*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTPRO (NDIM,POINT,NBFPRO,NOMFCT,TYPFCT 
     &                 ,NODONA,TYPRAS,MCASSO,IST,RST,CST
     &                 ,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 2002) 
* Derniere modification : D.Martin (1er Juillet 2003)
* 
* Calcul des fonctions propres de la methode des elements finis localises
* avec integration numerique en un point de coordonnees donnees quand 
* FCTPRO est appelee depuis CALKEF
*                                et
* calcul des coefficients spectraux pour le calcul d'un terme elements finis 
* localises quand FCTPRO est appelee dans CALCOP
*  
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeur(s):
*        POINT(I)= Ieme coordonnee du point (I=1,..,NDIM)
* NBFPRO nombre de fonctions propres du developpement
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA nom de la donnee 'Tableau' associee a la donnee 'Fonction'
* TYPRAS type de declaration de la donnee 'Tableau' associee a la 'Fonction' 
*        ('REEL','COMPLEXE',...)
* MCASSO adresse du tableau associe
*        dans le super-tableau du bon type (donne par TYPRAS)
* IST    super-tableau version entiere
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'        
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYPRAS
      INTEGER       NDIM,MCASSO,IST(*),NBFPRO,n0
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL          X,Y,ATANYX,NU_N,PI,H,K,M,TEMP,DH
      REAL          RAYON,SRAYPI,XC,YC,KR,BJ(0:12),DBJ(0:12)
      INTEGER       N,NINC
      CHARACTER ERCODE
*-----------------------------------------------------------------------
      PI= 4.*ATAN(1.)
      X=POINT(1)   
      Y=POINT(2)
      H=1.
      DH=H/(NBFPRO-1)
*
******************************
*      Fonctions propres     *
******************************
*
      IF (NOMFCT(1:5).EQ.'sinus')  THEN
         DO 12 N=1,NBFPRO
           RESULT(N) = SQRT(2./H)*SIN(N*PI*Y/H)
12       CONTINUE   

      ELSE IF (NOMFCT(1:7).EQ.'cosinus')  THEN
         RESULT(1) = SQRT(1./H)
         DO 13 N=1,NBFPRO-1
           RESULT(N+1) = SQRT(2./H)*COS(N*PI*Y/H)
13       CONTINUE

      ELSE IF (NOMFCT(1:2).EQ.'P0')  THEN
         DH=H/NBFPRO
         DO 14 N=1,NBFPRO
           RESULT(N) = 0.
14       CONTINUE
         n0=INT(Y/DH)
         IF(n0.LT.0) n0=0
         IF(n0.GT.NBFPRO-1) n0=NBFPRO-1
         RESULT(n0+1)=1.

      ELSE IF (NOMFCT(1:2).EQ.'P1')  THEN
         DO 15 N=1,NBFPRO
           RESULT(N) = 0.
15       CONTINUE
         n0=INT(Y/DH)
         IF(n0.LT.0) n0=0
         IF(n0.GT.NBFPRO-2) n0=NBFPRO-2
         RESULT(n0+1)=((n0+1)*DH-Y)/DH
         RESULT(n0+2)=(Y-n0*DH)/DH
      ENDIF
                                                                    END  !FctPro


