*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM (NDIM,POINT,NOMFCT,TYPFCT,NODONA,TYDONA
     &                 ,TYPRAS,MCASSO,IST,RST,CST,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Novembre 2002)
* Derniere modification : D.Martin (1er Juillet 2003)                                                                 
*
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeurs:
*        POINT(I)= Ieme coordonnee du point (I=1,..,NDIM);
*      ->si le point est sur un domaine de dimension NDIM-1, et que l'on
*        calcule un terme de type 'ELEMENTS FINIS', le tableau contient en outre
*        les composantes du vecteur normal au point sous la forme :
*        POINT(NDIM+1)  = norme du vecteur
*        POINT(NDIM+1+I)= I-eme composante du vecteur (I=1,..,NDIM)
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA nom de la donnee (constante ou tableau) associee a la fonction
*        (le cas echeant)
* TYDONA type de representation  de la donnee associee a la fonction 
*        ('CONSTANTE','TABLEAU') (le cas echeant) 
* TYPRAS type de declaration de la constante ou du tableau associe 
*        ('REEL','COMPLEXE',...) (le cas echeant)
* MCASSO adresse de la constante associee ou du tableau associe
*        dans le super-tableau du bon type (donne par TYPRAS) (le cas echeant)
* IST    super-tableau version entiere
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)  NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER        NDIM,IST(*),MCASSO
      REAL           RST(*),POINT(*),RESULT(*)
      COMPLEX        CST(*),CESULT(*)
*
      REAL   PI,X,Y
*-----------------------------------------------------------------------
      X=POINT(1)   
      Y=POINT(2)
      PI= 4.*ATAN(1.)
      RESULT(1)=0.
*
*     fonction source (f)
*     -------------------
      IF (NOMFCT(1:6).EQ.'source') THEN
*
        RESULT(1)=(4*PI*PI*Y*(Y-1)-2)*SIN(2*PI*X)
*
*     Solution exacte
*     ---------------
      ELSEIF (NOMFCT(1:6).EQ.'uexact') THEN
*
	RESULT(1)=Y*(Y-1)*SIN(2*PI*X)

      ENDIF
      END
