*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PROGRAM Laplace_Periodique
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
* Auteur : D.Martin (15 Juin 2003) 
* Derniere modification : D.Martin (1er Juillet 2003)
*
* Programme principal pour la resolution de l'equation de Laplace 2D
* avec condition de priodicit (multiplicateur spectral)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER  AST
      INTEGER    IST,MAXRST,MAXAST
      PARAMETER (MAXRST=20000000,MAXAST=80000)
      COMPLEX    CST
      REAL RST(1)
      COMMON/  /IST(MAXRST)    /STCHAR/AST(MAXAST)
*
      CHARACTER TYPE,CRAC,ERCODE
      INTEGER   KI,NINC,NIVEFL,NIVASS,NIVRES,NIVSOL,MCA,NIVIMP
      INTEGER   I,MCId
      REAL      H,KR,Yr,Yi,eps
      COMPLEX   KC,TEMP
      
      EQUIVALENCE (RST(1),IST(1))
*-----------------------------------------------------------------------
*     Initialisation de l'allocation dynamique
      CALL INITIE (MAXAST,MAXRST)
*     Lecture du maillage
      CALL LCGEOM
*     Lecture des directives : definition des calculs a effectuer
      CALL LCDIRE
      CALL LCDONN
*     Numerotation globale des noeuds et ...etc
      CALL NUMNEU
      CALL CPTDOM
      
      CALL PUTCST('-1','REEL',KI,-1.,KC,CRAC)
      CALL GETCST('NIVIMP',TYPE,KI,NIVIMP,KC,CRAC)

*     Calcul elements finis et elements finis localises sur tous les domaines
*     -----------------------------------------------------------------------
      CALL CALKEF
      CALL CALKSP

*     Assemblage mono-inconnue
*     ------------------------
      CALL DOASTR ('EFLNS-',1,'-1','CONSTANTE',0,'REEL')
      CALL ASMAKE ('EFLNS-',1,'EFL',1)
      CALL ASMAKE ('EFLNS+',1,'EFL',1)
      CALL ASMTRM ('EFL',1,10)
      CALL TRTERM ('EFL',1,'TEFL',1,NIVIMP)
      CALL PRTERM ('EFL',1,10,50)
      CALL PRTERM ('TEFL',1,10,50)

*     Assemblage multi-inconnues
*     ---------------------------
       CALL DSMAKE ('RIGID',1,'MATRIS',1)
       CALL DSMAKE ('EFL',1,'MATRIS',1)
       CALL DSMAKE ('TEFL',1,'MATRIS',1)
       CALL DSMTRM ('MATRIS',1,10)
       
       CALL MATVEC('MASSE',1,'SOURCE',1,'SECF',1,NIVIMP)
       CALL DSMAKE ('SECF',1,'SECMBR',1)
       CALL DSMAKE ('ZEROS',1,'SEMBR',1)
       CALL DSVTRM ('SECMBR',1,1)

*     Condition essentielle
*     ---------------------------
      CALL CDESSE ('DIRICH',1,'MATRIS',1,'SECMBR',1)
      CALL PRTERM ('MATRIS',1,10,50)

*     Resolution
*     ----------
      CALL FALU   ('MATRIS',1,' ','MATFAC',1,1)
      CALL FASV   ('MATFAC',1,'SECMBR',1,'SOLNUM',1,1)

*     Postprocessing
*     --------------
      CALL SDEKAM ('SOLNUM',1,'U','UCAL',1,NIVIMP)
      CALL T2TERM ('UCAL',1,'-','SOLEXA',1,'DIFF',1,NIVIMP)
      CALL DFTERM ('UCAL',1,'SOLEXA',1,1)

*     Traitement graphique :
      CALL GBEGIN ('sol','2D','unighn')
      CALL GHEADR ('sol','inc',' ')
      CALL GBODYR ('sol','UCAL',1,'OMEGA')
      CALL GBEGIN ('solexa','2D','unighn')
      CALL GHEADR ('solexa',' ',' ')
      CALL GBODYR ('solexa','SOLEXA',1,'OMEGA')
      CALL GBEGIN ('diff','2D','unighn')
      CALL GHEADR ('diff','tot',' ')
      CALL GBODYR ('diff','DIFF',1,'OMEGA')
      CALL GEND   () 
*
      CALL BYE    (' Game Over ')
      END
