*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                               PROGRAM HELMZ3
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Derniere modification (D.Martin) le 71 Juillembre 123456789
*  
*                  Resolution de HELMHOLTZ 3D 
*
*   TEST d'algorithmes de Gradient Biconjugue Preconditionne
*   TEST de formulation 'FOURIER' standard
*                       'FOURIER avec frontiere intermediaire' 
*           formulation 'DIRICHLET'
*  
*     Declarations globales - Taille des super-tableaux
      CHARACTER AST
      PARAMETER ( MOTMXR=4000000,NBCHMX=80000 ) 
      COMMON/     /RST(MOTMXR)      /STCHAR/AST(NBCHMX)
*  
      INCLUDE 'CONTEX'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPE,CARAC ,NOMMAI*80,LOCGLO*6
      COMPLEX   KC
      REAL      KR
      CALL PRFXMJ (1,'Helmz3d')
*  
*   Initialisation et valeurs par defaut - modification eventuelles  
*   de ces valeurs par directives.
      CALL INITIE (NBCHMX,MOTMXR)  
*   Lecture d'une geometrie  
      CALL LCGEOM 
*   Lecture des directives de definition des inconnues variationnelles
*   et de construction des termes elements-finis 
      CALL LCDIRE
*   Lecture des donnees  
      CALL LCDONN  
      CALL CHRONO   ('Lecture des directives',IMPPAL)
      CALL GETCST ('MAILLA',TYPE,IBID,KR,KC,NOMMAI)
      IF (NOMMAI(1:1).NE.' ') CALL ECGEOM (NOMMAI,'Titre')
*   Valeur des variables d'impression
      CALL GETCST ('IMPPRE',TYPE,NOIMPP,KR,KC,CARAC)
      CALL GETCST ('IMPFOU',TYPE,NOIMPF,KR,KC,CARAC)
      CALL GETCST ('IMPFRI',TYPE,NOIMPI,KR,KC,CARAC)
      CALL GETCST ('IMPDIR',TYPE,NOIMPD,KR,KC,CARAC)
      CALL GETCST ('IMPSOL',TYPE,NOIMPS,KR,KC,CARAC)
      CALL GETCST ('LOCGLO',TYPE,NOIMPS,KR,KC,LOCGLO)
*   Optimisation de la largeur de nbande
*     CALL RENUME (2,2,0)
*   Numerotations globales en noeuds pour toutes les interpolations  
       CALL NUMNEU
*   Calcul des termes elements-finis 
      CALL CPTDOM  
      CALL CALKEF
      CALL CHRONO ('Calcul sur les domaines',IMPPAL)
*
*   Second membre 'Elements Finis'
      CALL MATVEC ('PDELTA',1,'DPHIN',1,'NEUGAM',1,NOIMPP*3)
      CALL TBTUER ('DPHIN',1)
*  
*   Definition des constantes 1/4*pi et -1./4pi  
      CALL PUTCST ('1/4PI','REEL',IBID,.07957747,KC,CARAC) 
      CALL PUTCST ('-1/4PI','REEL',IBID,-.07957747,KC,CARAC)
*   Definition des constantes -K2 = -K * K et -iK = - i * K  
      CALL GETCST ('K',TYPE,IBID,KR,KC,CARAC)
      CALL PUTCST ('-K2','REEL',IBID,-KR*KR,KC,CARAC)
      CALL PUTCST ('-iK','COMPLEXE',IBID,KR,CMPLX(0.,-KR),CARAC)
*  
*   Assemblage de la matrice  Somme(Omega) gradu.gradv -k2 uv dx 
      CALL CLTERM ('RIGID',1,' ','MASSE',1,' ','ADEUV',1,NOIMPP*1)
*  
*   Assemblage de la matrice de preconditionnement
      CALL DOASTR ('GDELTA',1,'-iK','CONSTANTE',0,'COMPLEXE')
      CALL ASMTRM ('PRECON',0,NOIMPP*1)
      CALL CHRONO ('Assemblage E.F.',IMPPAL)
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*   Factorisation incomplete modifiee de la matrice de preconditionnement
      CALL FIMLU  ('PRECON',0,'S',0,'MILUPC',1,NOIMPP*1)
      CALL FASV   ('MILUPC',1,'NEUGAM',1,'MILUSO',1,NOIMPP*1)
      CALL T1TERM ('MILUSO',1,'=','MILUSO',2,0)
      CALL CHRONO ('Factor. L.U inc et Resolution : Solveur L.U'
     &,IMPPAL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Formulation FOURIER standard (sans frontiere intermediaire)  
*     Ici sont deja connus : ADEUV,1 - PDELTA,1 - GDELTA,1 
*  
      CALL PTITRE ('Formulation FOURIER standard')  
      IF (LOCGLO(1:3).EQ.'loc') THEN
*      Calcul des termes de Couplage 
*        (calcul local sur Sigma avec calcul des noyaux incorpore)
         CALL MKSDGN ('GDNOYS',1,'GDNOYD',1
     &               ,'Domaine_Sigma = SIGMA , Domaine_Gamma=GAMMA'
     &            //', Donnee1 = K , Type_Green =COMPLEXE'
     &            //', Donnee_Lambda=LAMBDA, Inconnue=PHI'
     &            //',Nom_Gdelta=Gdelta , Niveau_Gdelta=1')
         CALL COGDNO ('STANDARD','FOURIER','GDNOYS',1,'GDNOYD',1
     &               ,NOIMPF*1)
         CALL COGNOP ('GDNOYD',1,'PDELTA',1,'COUPLA',1,NOIMPF*1)
         CALL MATVEC ('GDNOYS',1,'NEUGAM',1,'COUPLS',1,NOIMPF*1)
      ELSE
*
*      Calcul des termes de Couplage 
*       (calcul global sur Sigma avec calcul prealable des noyaux)
         CALL CALNOY ('SIGMA','GAMMA',1,'FOURIER',1,'K','LAMBDA'  
     &               ,'NoyauS',1,'NoyauD',1)
         CALL MKSDGN ('GDNOYS',1,'GDNOYD',1
     &               ,'Domaine_Sigma = SIGMA,Domaine_Gamma=GAMMA'
     &            //',Inconnue=PHI,Nom_Gdelta=GDELTA,Niveau_Gdelta=1'
     &            //',Niveau_Noyau_Simple=1,Niveau_Noyau_Double=1')
         CALL COGDNO ('STANDARD','FOURIER','GDNOYS',1,'GDNOYD',1
     &               ,NOIMPF*1)
         CALL COGNOP ('GDNOYD',1,'PDELTA',1,'COUPLA',1,NOIMPF*1)
         CALL MATVEC ('GDNOYS',1,'NEUGAM',1,'COUPLS',1,NOIMPF*1)
      ENDIF
      CALL TBTUER ('GDNOYD',1)
      CALL CHRONO ('Termes de Couplage',IMPPAL)
*  
*   Assemblage des termes E.F. standard et des termes de Couplage
      CALL DOASTR ('GDELTA',1,'LAMBDA','CONSTANTE',0,'COMPLEXE')
      CALL DOASTR ('COUPLA',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASMTRM ('MATRIS',1,NOIMPF*5)
*   Assemblage des seconds membres E.F. standard et de Couplage  
      CALL DOASTR ('COUPLS',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASVTRM ('SECMBR',1,NOIMPF*5)  
      CALL TBTUER ('COUPLS',1)  
      CALL CHRONO ('Assemblage du systeme',IMPPAL)
*   Seuil d'arret des iterations de gradient et nb max d'iterations
      CALL GETCST('EPSILO',TYPE,IBID,EPSILO,KC,CARAC)
      CALL GETCST('MXITER',TYPE,MXITER,KR,KC,CARAC)
*
*----
      CALL PGAUSS ('MATRIS',1,'SECMBR',1,'GAMMA Union SIGMA'
     &            ,'Natris',1,'Necmbr',1,1)
      CALL GAUSMC ('Natris',1,'Necmbr',1,1,EPSILO,'P'
     &            ,'MILUSO',2,NOIMPF)
      CALL DFTERM ('MILUSO',2,'SOLEXA',1,1)
      CALL TBTUER ('MILUSO',2)
*----
*  
*  Resolution par Gradient conjugue squared preconditionne et FimLU
*     CALL GCS    ('MATRIS',1,'SECMBR',1,'MILUPC',1,EPSILO,MXITER 
*    &            ,'MILUSO',2,NOIMPF*5,*120)
*  Resolution par methode de Gauss
      CALL GAUSMC ('MATRIS',1,'SECMBR',1,1,EPSILO,'P'
     &            ,'MILUSO',2,NOIMPF)
      CALL DFTERM ('MILUSO',2,'SOLEXA',1,NOIMPF)
      CALL TBTUER ('MILUSO',2) 
      CALL CHRONO ('Resolution : FimLU + Gradient conjugue squared'
     &            ,IMPPAL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*     Formulation FOURIER avec relevement frontiere intermediaire  
*     Ici sont deja connus : ADEUV,1 - NEUGAM,1 - GDELTA,1 - COUPLA,1  
*  
      CALL PTITRE ('Formulation FOURIER ''Frontiere intermediaire'' ')  
      CALL RELFRI ('ADEUV',1,'GAMMA','PDELTA',2)
      CALL CHRONO ('Relevement frontiere intermediaire',IMPPAL)
*
*     Le terme GDNOYS,1 est deja calcule plus haut
      CALL COGNOP ('GDNOYS',1,'PDELTA',2,'COUPLI',2,NOIMPF*1)
      CALL TBTUER ('GDNOYS',1)
      CALL CHRONO('Termes de Couplage',IMPPAL)
*   Assemblage des termes E.F. standard et des termes de Couplage
      CALL DOASTR ('COUPLI',2,'-1/4PI','CONSTANTE',0,'REEL')
      CALL ASMTRM ('MATRIS',2,1*NOIMPI)
      CALL TBTUER ('COUPLA',1)  
      CALL TBTUER ('COUPLI',2)  
      CALL CHRONO ('Assemblage du systeme',IMPPAL) 
*   Resolution par Gradient biconjugue preconditionne
      CALL GCS    ('MATRIS',2,'NEUGAM',1,'MILUPC',1,EPSILO,MXITER 
     &            ,'SOLUTI',2,NOIMPI*1,*200)
      CALL DFTERM ('SOLUTI',2,'SOLEXA',1,1)
      CALL TBTUER ('MATRIS',2)  
      CALL CHRONO ('Resolution : FimLU + Gradient conjugue squared'
     &           ,IMPPAL)
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
**     Formulation DIRICHLET standard
** 
      CALL PTITRE ('Formulation couplage DIRICHLET standard')
      CALL RELDIR ('ADEUV',1,'SIGMA','GDELTA',3)
      CALL MKSDGN ('GDNOYS',3,'GDNOYD',3
     &            ,'Domaine_Sigma = SIGMA,Domaine_Gamma=GAMMA'
     &          //',Inconnue=PHI,Nom_Gdelta=GDELTA,Niveau_Gdelta=3'
     &          //',Niveau_Noyau_Simple=1,Niveau_Noyau_Double=1')
      CALL CALNOY ('SIGMA','GAMMA',1,'DIRICHLET',1,'K',' ' 
     &            ,'NoyauS',1,'NoyauD',1)
      CALL COGDNO ('STANDARD','DIRICHLET','GDNOYS',3,'GDNOYD',3
     &,NOIMPD*1)
      CALL COGNOP ('GDNOYD',3,'PDELTA',1,'COUPLA',3,NOIMPD*1)
      CALL MATVEC ('GDNOYS',3,'NEUGAM',1,'COUPLS',3,NOIMPD*1)
*
*     CALL COUMAT ('GDELTA',3,'NoyauD',1,1,'A MORT','PDELTA',1,'COUPLA'
*    &            ,3,1,NOIMPD)
*     CALL COUVEC ('GDELTA',3,'NoyauS',1,1,'A MORT','NEUGAM',1,'COUPLS'
*    &            ,3,NOIMPD)
      CALL DOASTR ('COUPLA',3,'-1/4PI','CONSTANTE',0,'REEL')
      CALL DOASTR ('COUPLS',3,'-1/4PI','CONSTANTE',0,'REEL')
      CALL ASMTRM ('MATRIS',3,NOIMPD*1)
      CALL TBTUER ('COUPLA',3)  
      CALL ASVTRM ('SECMBR',3,NOIMPD*1)
      CALL TBTUER ('COUPLS',3)  
*   Prise en compte de la  condition essentielle homogene 
      CALL CDESSE ('sigma',1,'MATRIS',3,'SECMBR',3)
      CALL FALU   ('MATRIS',3,' ','LUMATR',3,NOIMPD*1)
      CALL FASV   ('LUMATR',3,'SECMBR',3,'SOLUTI',3,NOIMPD*1)
      CALL TBTUER ('MATRIS',3)  
      CALL CHRONO ('Formulation Dirichlet',IMPPAL)
*  
*   Reconstitution sur 'Sigma'
      CALL MATVEC ('PDELTA',1,'SOLUTI',3,'PHIGAM',1,-1)  
      CALL REPINT ('SIGMA','NoyauD',1,1,'PHIGAM',1,'DOUBLE',1,0)
      CALL REPINT ('SIGMA','NoyauS',1,1,'NEUGAM',1,'SIMPLE',1,1)
      CALL TBTUER ('NoyauS',1)
      CALL TBTUER ('NoyauD',1)
      CALL DOASTR ('DOUBLE',1,'-1/4PI','CONSTANTE',0,'REEL')
      CALL DOASTR ('SIMPLE',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASMAKE ('SIMPLE',1,'SOLUTI',4)  
      CALL ASMAKE ('DOUBLE',1,'SOLUTI',4)  
      CALL ASMAKE ('SOLUTI',3,'SOLUTI',4)  
      CALL ASVTRM ('SOLUTI',4,-1)
*   Test des procedures CALRI1 ou CALRI2
      CALL ASMAKE ('SIMPLE',1,'REPINT',1)  
      CALL ASMAKE ('DOUBLE',1,'REPINT',1)
      CALL ASVTRM ('REPINT',1,-1)
      CALL CALRI2 ('&CORNE',9,'GAMMA','DIR',1,'K',' '
     &            ,'-1/4PI','PHIGAM',1
     &            ,'1/4PI','NEUGAM',1,'REPINT',4,1)
      CALL T1TERM ('SIMPLE',1,'=','REPINT',2,0)
      CALL T1TERM ('REPINT',4,'=VALEUR','REPINT',2,0)
*     CALL CALRI1 ('&CORNE',9,'GAMMA',1,'K','PHIGAM',1
*     &            ,'NEUGAM',1,'REPINT',4,1)
*     CALL T1TERM ('SIMPLE',1,'=','REPINT',2,0)
*     CALL T1TERM ('REPINT',4,'=VALEUR','REPINT',2,0)
*     CALL T1TERM ('REPINT',2,'*-1/4PI','REPINT',2,0)
      CALL DFTERM ('REPINT',1,'REPINT',2,10)
*   Fin de test de CALRI1 ou CALRI2
      CALL TBTUER ('SIMPLE',1)  
      CALL TBTUER ('DOUBLE',1)  
      CALL TBTUER ('SOLUTI',3) 
      CALL DFTERM ('SOLUTI',4,'SOLEXA',1,NOIMPS*1)
      CALL TBTUER ('SOLUTI',4)
      CALL STIMPR (9)
      CALL BYE(' Fin')
120   CALL BAISE ('Non-convergence Gradient conjugue pour (MATRIS,1)')
200   CALL BAISE ('Non-convergence Gradient conjugue pour (MATRIS,2)')

                                          END
