*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                               PROGRAM HELMZ3
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Derniere modification (D.Martin) le 71 Juillembre 123456789
*  
*                  Resolution de HELMHOLTZ 3D 
*
*   TEST d'algorithmes de Gradient Biconjugue Preconditionne
*   TEST d'algorithmes de Gradient Conjugue Squared Preconditionne
*   TEST de formulation 'FOURIER' standard
*                       'FOURIER avec frontiere intermediaire' 
*           formulation 'DIRICHLET'
*  
*     Declarations globales - Taille des super-tableaux
      CHARACTER AST
      PARAMETER ( MOTMXR=16000000,NBCHMX=80000 ) 
      COMMON/     /RST(MOTMXR)      /STCHAR/AST(NBCHMX)
*  
      INCLUDE 'CONTEX'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPE,CARAC*10,NOMMAI*80,FAPREC*6,RESOL*6
      COMPLEX   KC
      REAL      KR
      PREFIX(1)='Helmz3d'
*  
*   Initialisation et valeurs par defaut - modification eventuelles  
*   de ces valeurs par directives.
      CALL INITIE (NBCHMX,MOTMXR)  
*   Lecture d'une geometrie  
      CALL LCGEOM 
*   Lecture des directives de definition des inconnues variationnelles
*   et de construction des termes elements-finis 
      CALL LCDIRE  
*   Lecture des donnees  
      CALL LCDONN  
      CALL CHRONO   ('Lecture des directives',IMPPAL)
      CALL GETCST ('MAILLA',TYPE,IBID,KR,KC,NOMMAI)
      IF (NOMMAI(1:1).NE.' ') CALL ECGEOM (NOMMAI,'Titre')
*   Valeur des variables d'impression
      CALL GETCST ('IMPPRE',TYPE,NOIMPP,KR,KC,CARAC)
      CALL GETCST ('IMPFOU',TYPE,NOIMPF,KR,KC,CARAC)
      CALL GETCST ('IMPFRI',TYPE,NOIMPI,KR,KC,CARAC)
      CALL GETCST ('IMPDIR',TYPE,NOIMPD,KR,KC,CARAC)
      CALL GETCST ('IMPSOL',TYPE,NOIMPS,KR,KC,CARAC)
*   Numerotations globales en noeuds pour toutes les interpolations  
       CALL NUMNEU  
*   Calcul des termes elements-finis 
      CALL CPTDOM  
      CALL CALKEF  
      CALL CHRONO ('Calcul sur les domaines',IMPPAL)
*
*   Second membre 'Elements Finis'
      CALL MATVEC ('PDELTA',1,'DPHIN',1,'NEUGAM',1,NOIMPF*3)  
      CALL TBTUER ('DPHIN',1)
*  
*   Definition des constantes 1/4*pi et -1./4pi  
      CALL PUTCST ('1/4PI','REEL',IBID,.07957747,KC,CARAC) 
      CALL PUTCST ('-1/4PI','REEL',IBID,-.07957747,KC,CARAC)
*   Definition des constantes -K2 = -K * K et -iK = - i * K  
      CALL GETCST ('K',TYPE,IBID,KR,KC,CARAC)
      CALL PUTCST ('-K2','REEL',IBID,-KR*KR,KC,CARAC)
      CALL PUTCST ('-iK','COMPLEXE',IBID,KR,CMPLX(0.,-KR),CARAC)
*  
*   Assemblage de la matrice  Somme(Omega) gradu.gradv -k2 uv dx 
      CALL CLTERM ('RIGID',1,' ','MASSE',1,' ','ADEUV',1,NOIMPF*1)
*  
*   Assemblage de la matrice de preconditionnement
      CALL DOASTR ('GDELTA',1,'-iK','CONSTANTE',0,'COMPLEXE')
      CALL ASMTRM ('PRECON',0,NOIMPP*1)
      CALL CHRONO ('Assemblage E.F.',IMPPAL)
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CALL GETCST ('FAPREC',TYPE,IBID,KR,KC,FAPREC)
      IF (FAPREC(1:5).EQ.'FIMLU') THEN
*        Factorisation incomplete modifiee de la matrice de preconditionnement
         CALL FIMLU  ('PRECON',0,'S',0,'PREFAC',1,NOIMPP*1)
         CALL FASV   ('PREFAC',1,'NEUGAM',1,'SOLUTI',1,NOIMPP*1)
         CALL CHRONO ('Factor. L.U inc et Resolution : Solveur L.U'
     &               ,IMPPAL)
      ELSEIF (FAPREC(1:4).EQ.'FALU') THEN
*        Factorisation LU de la matrice de preconditionnement
         CALL FALU   ('PRECON',0,'S','PREFAC',1,NOIMPP*5) 
         CALL FASV   ('PREFAC',1,'NEUGAM',1,'SOLUTI',1,NOIMPP*1)
         CALL CHRONO ('Factor. L.U et Resolution : Solveur L.U'
     &               ,IMPPAL)
      ELSEIF (FAPREC(1:6).EQ.'FALDLT') THEN
*        Factorisation LDTL de la matrice de preconditionnement (test)
         CALL FALDLT ('PRECON',0,'PREFAC',1,NOIMPP*5)
         CALL FASV   ('PREFAC',1,'NEUGAM',1,'SOLUTI',1,NOIMPP*1)
         CALL CHRONO ('Factor. L.D.Lt et Resolution : Solveur L.D.Lt'
     &               ,IMPPAL)
      ENDIF
      CALL T1TERM ('SOLUTI',1,'=','SOLUTI',2,0)
*   Resolution par gradient bi-conjugue (test)
*      CALL GBCT   ('PRECON',0,'NEUGAM',1,' ',0,EPSILO,MXITER
*     *            ,'SOLUTI',23,NOIMPP*6,*10)
*10    CALL DFTERM ('SOLUTI',3,'SOLUTI',23,NOIMPS*1)
*      CALL CHRONO ('Resolution : Gradient Bi-conjugue',IMPPAL)
*   Resolution par gradient conjugue squared (test)
*      CALL GCS    ('PRECON',0,'NEUGAM',1,' ',0,EPSILO,MXITER
*     *            ,'SOLUTI',33,NOIMPP*6,*11)
*11    CALL DFTERM ('SOLUTI',3,'SOLUTI',33,NOIMPS*1)
*      CALL CHRONO ('Resolution : Gradient conjugue squared',IMPPAL)
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Formulation FOURIER standard (sans frontiere intermediaire)  
*     Ici sont deja connus : ADEUV,1 - PDELTA,1 - GDELTA,1 
*  
      CALL PTITRE ('Formulation FOURIER standard')  
*     Calcul des termes de Couplage
      CALL CALNOY ('SIGMA','GAMMA',1,'FOURIER',1,'K','LAMBDA'  
     *            ,'MATGRE',1,'MATGRN',1)
      CALL CHRONO ('Fonction de Green',IMPPAL)
      CALL COUMAT ('GDELTA',1,'MATGRN',1,1,'A MORT','PDELTA',1,'COUPLA'
     *            ,1,1,NOIMPF*1)
      CALL COUVEC ('GDELTA',1,'MATGRE',1,1,'A MORT','NEUGAM',1,'COUPLS'
     *            ,1,NOIMPF*1)
      CALL CHRONO ('Termes de Couplage',IMPPAL)
*  
*   Assemblage des termes E.F. standard et des termes de Couplage
      CALL DOASTR ('GDELTA',1,'LAMBDA','CONSTANTE',0,'COMPLEXE')
      CALL DOASTR ('COUPLA',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASMTRM ('MATRIS',1,NOIMPF*5)
*   Assemblage des seconds membres E.F. standard et de Couplage  
      CALL DOASTR ('COUPLS',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASVTRM ('SECMBR',1,NOIMPF*5)  
      CALL TBTUER ('COUPLS',1)  
      CALL CHRONO ('Assemblage du systeme',IMPPAL)
*  Sortie sur fichier du systeme
*      CALL MAT2NL ('MATRIS',1,'MATR',100)
*      CALL EXTERM ('SECMBR',1,'OMEGA',0,0,'SECM',100,-1)
*      CALL OPTERM ('MATR',100)
*      CALL ECMATR ('MATR',100)
*      CALL FETERM ('MATR',100)
*      CALL TBTUER ('MATR',100)
*      CALL OPTERM ('SECM',100)
*      CALL ECTERM ('SECM',100)
*      CALL FETERM ('SECM',100)
*      CALL TBTUER ('SECM',100)
*      CALL CHRONO ('Sortie matrice',IMPPAL)
*
*   Seuil d'arret des iterations de gradient et nb max d'iterations
      CALL GETCST('EPSILO',TYPE,IBID,EPSILO,KC,CARAC)
      CALL GETCST('MXITER',TYPE,MXITER,KR,KC,CARAC)
*
      CALL GETCST ('RESOL',TYPE,IBID,KR,KC,RESOL)
      IF (RESOL(1:4).EQ.'GBCT') THEN
*        Resolution par Gradient biconjugue preconditionne
         CALL  GBCT  ('MATRIS',1,'SECMBR',1,'PREFAC',1,EPSILO,MXITER 
     *               ,'SOLUTI',1,NOIMPF*5,*110)
 110     CALL DFTERM ('SOLUTI',1,'SOLEXA',1,NOIMPS*1)
         CALL CHRONO ('Resolution : Gradient Bi-conj.prec. t'
     *               ,IMPPAL)
      ELSEIF (RESOL(1:3).EQ.'GCS') THEN
*        Resolution par Gradient conjugue squared preconditionne
         CALL  GCS   ('MATRIS',1,'SECMBR',1,'PREFAC',1,EPSILO,MXITER 
     &               ,'SOLUTI',1,NOIMPF*5,*120)
120      CALL DFTERM ('SOLUTI',1,'SOLEXA',1,NOIMPS*1)
        CALL CHRONO ('Resolution : FimLU & Gradient conjugue squared'
     &              ,IMPPAL)
      ELSEIF (RESOL(1:3).EQ.'FALU') THEN
*
*        Factorisation LU et resolution
         CALL FALU   ('MATRIS',1,' ','MAFACT',1,NOIMPF*5)
         CALL FASV   ('MAFACT',1,'SECMBR',1,'SOLUTI',1,NOIMPF*5)
         CALL DFTERM ('SOLUTI',1,'SOLEXA',1,NOIMPS*1)
         CALL CHRONO ('Factorisation LU et Resolution : Solveur L.U'
     &            ,IMPPAL)
      ENDIF
      CALL TBTUER ('SOLUTI',1)
      CALL TBTUER ('MATRIS',1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*     Formulation FOURIER avec relevement frontiere intermediaire  
*     Ici sont deja connus : ADEUV,1 - NEUGAM,1 - GDELTA,1 - COUPLA,1  
*  
      CALL PTITRE ('Formulation FOURIER ''Frontiere intermediaire'' ')  
      CALL RELFRI ('ADEUV',1,'GAMMA','PDELTA',2)
      CALL CHRONO ('Relevement frontiere intermediaire',IMPPAL)
      CALL CALNOY ('SIGMA','GAMMA',1,'FOURIER',1,'K','LAMBDA'  
     *            ,'MATGRE',1,'MATGRN',1)
      CALL TBTUER ('MATGRN',1)  
      CALL COUMAT ('GDELTA',1,'MATGRE',1,1,'A MORT','PDELTA',2,'COUPLI'
     *            ,2,1,NOIMPI*1)
      CALL CHRONO('Termes de Couplage',IMPPAL)
*   Assemblage des termes E.F. standard et des termes de Couplage
      CALL DOASTR ('COUPLI',2,'-1/4PI','CONSTANTE',0,'REEL')   
      CALL ASMTRM ('MATRIS',2,NOIMPI*1)
      CALL TBTUER ('COUPLA',1)  
      CALL TBTUER ('COUPLI',2)  
      CALL CHRONO ('Assemblage du systeme',IMPPAL) 
*   Resolution par Gradient biconjugue preconditionne
      CALL  GCS   ('MATRIS',2,'NEUGAM',1,'PREFAC',1,EPSILO,MXITER 
     *            ,'SOLUTI',2,NOIMPI*1,*200)
200   CALL DFTERM ('SOLUTI',2,'SOLEXA',1,NOIMPI*1)
      CALL TBTUER ('MATRIS',2)  
      CALL CHRONO ('Resolution : Grad conj squared',IMPPAL)
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
**     Formulation DIRICHLET standard (sans frontiere intermediaire)
** 
      CALL PTITRE ('Formulation couplage DIRICHLET standard')
      CALL RELDIR ('ADEUV',1,'SIGMA','GDELTA',3)
      CALL CALNOY ('SIGMA','GAMMA',1,'DIRICHLET',1,'K',' ' 
     *            ,'MATGRE',1,'MATGRN',1)
      CALL COUMAT ('GDELTA',3,'MATGRN',1,1,'A MORT','PDELTA',1,'COUPLA'
     *            ,3,1,NOIMPD)
      CALL COUVEC ('GDELTA',3,'MATGRE',1,1,'A MORT','NEUGAM',1,'COUPLS'
     *            ,3,NOIMPD)
      CALL DOASTR ('COUPLA',3,'-1/4PI','CONSTANTE',0,'REEL')
      CALL DOASTR ('COUPLS',3,'-1/4PI','CONSTANTE',0,'REEL')
      CALL ASMAKE ('ADEUV',1,'MATRIS',3)
      CALL ASMAKE ('COUPLA',3,'MATRIS',3)  
      CALL ASMTRM ('MATRIS',3,NOIMPD*1)
      CALL TBTUER ('COUPLA',3)  
      CALL ASMAKE ('NEUGAM',1,'SECMBR',3)  
      CALL ASMAKE ('COUPLS',3,'SECMBR',3)  
      CALL ASVTRM ('SECMBR',3,NOIMPD*1)
      CALL TBTUER ('COUPLS',3)  
*   Prise en compte de la  condition essentielle homogene 
      CALL CDESSE ('sigma',1,'MATRIS',3,'SECMBR',3)
      CALL FALU   ('MATRIS',3,' ','LUMATR',3,NOIMPD*1)
      CALL TBTUER ('MATRIS',3)  
      CALL FASV   ('LUMATR',3,'SECMBR',3,'SOLUTI',3,NOIMPD*1)
      CALL TBTUER ('LUMATR',3)
      CALL TBTUER ('SECMBR',3) 
      CALL CHRONO ('Formulation Dirichlet',IMPPAL)
*  
*   Reconstitution sur 'Sigma'
      CALL CALNOY ('SIGMA','GAMMA',1,'DIRICHLET',1,'K',' ' 
     *            ,'MATGRE',1,'MATGRN',1)
      CALL MATVEC ('PDELTA',1,'SOLUTI',3,'PHIGAM',1,-1)  
      CALL REPINT ('SIGMA','MATGRE',1,1,'NEUGAM',1,'SIMPLE',1,0)
      CALL REPINT ('SIGMA','MATGRN',1,1,'PHIGAM',1,'DOUBLE',1,0)
      CALL TBTUER ('MATGRE',1)
      CALL TBTUER ('MATGRN',1)
      CALL TBTUER ('PDELTA',1)
      CALL TBTUER ('PHIGAM',1)
      CALL TBTUER ('NEUGAM',1)
      CALL DOASTR ('SIMPLE',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL DOASTR ('DOUBLE',1,'-1/4PI','CONSTANTE',0,'REEL')
      CALL ASMAKE ('SIMPLE',1,'SOLUTI',4)  
      CALL ASMAKE ('DOUBLE',1,'SOLUTI',4)  
      CALL ASMAKE ('SOLUTI',3,'SOLUTI',4)  
      CALL ASVTRM ('SOLUTI',4,-1)
      CALL TBTUER ('SIMPLE',1)  
      CALL TBTUER ('DOUBLE',1)  
      CALL TBTUER ('SOLUTI',3) 
      CALL DFTERM ('SOLUTI',4,'SOLEXA',1,NOIMPS*1)
      CALL TBTUER ('SOLUTI',4)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CALL STIMPR (9)
*  
      CALL BYE (' ')
                                          END
