*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                               PROGRAM HELMZ3
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Derniere modification : D.Martin (71 Juillembre 123456789)
*  
* Resolution de HELMHOLTZ 3D
*  
*     Declarations globales - Taille des super-tableaux
      IMPLICIT NONE
      CHARACTER AST
      INTEGER   MOTMXR,NBCHMX,IMPPAL
      REAL      RST
      PARAMETER ( MOTMXR=4000000, NBCHMX=80000, IMPPAL=6 )
      COMMON/     /RST(MOTMXR)      /STCHAR/AST(NBCHMX)
*
      CHARACTER TYPE,CARAC ,NOMMAI*80,LOCGLO*6
      INTEGER   EBID,MXITER,NOIMPP,NOIMPF,NOIMPI,NOIMPD,NOIMPS
      REAL      RBID,KR,EPSILO
      COMPLEX   CBID,KC
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'Helmz3d')
*  
*   Initialisation et valeurs par defaut - modification eventuelles  
*   de ces valeurs par directives.
      CALL INITIE (NBCHMX,MOTMXR)  
*   Lecture d'une geometrie  
      CALL LCGEOM 
*   Lecture des directives de definition des inconnues variationnelles
*   et de construction des termes elements-finis 
      CALL LCDIRE
*   Lecture des donnees  
      CALL LCDONN
*   Valeur des variables d'impression
      CALL GETCST ('IMPPRE',TYPE,NOIMPP,KR,KC,CARAC)
      CALL GETCST ('IMPFOU',TYPE,NOIMPF,KR,KC,CARAC)
      CALL GETCST ('IMPFRI',TYPE,NOIMPI,KR,KC,CARAC)
      CALL GETCST ('IMPDIR',TYPE,NOIMPD,KR,KC,CARAC)
      CALL GETCST ('IMPSOL',TYPE,NOIMPS,KR,KC,CARAC)
      CALL GETCST ('LOCGLO',TYPE,NOIMPS,KR,KC,LOCGLO)
*   Numerotations globales en noeuds pour toutes les interpolations  
       CALL NUMNEU
*   Calcul des termes elements-finis 
      CALL CPTDOM  
      CALL CALKEF
      CALL CHRONO ('Calcul sur les domaines',IMPPAL)
*   Second membre 'Elements Finis'
      CALL MATVEC ('PDELTA',1,'DPHIN',1,'NEUGAM',1,NOIMPP*1)
      CALL TBTUER ('DPHIN',1)
*  
*   Definition des constantes 1/4*pi et -1./4pi  
      CALL PUTCST ('1/4PI','REEL',EBID,.07957747,KC,CARAC) 
      CALL PUTCST ('-1/4PI','REEL',EBID,-.07957747,KC,CARAC)
*   Definition des constantes -K2 = -K * K et -iK = - i * K  
      CALL GETCST ('K',TYPE,EBID,KR,KC,CARAC)
      CALL PUTCST ('-K2','REEL',EBID,-KR*KR,KC,CARAC)
      CALL PUTCST ('-iK','COMPLEXE',EBID,KR,CMPLX(0.,-KR),CARAC)
*  
*   Assemblage de la matrice  Somme(Omega) gradu.gradv -k2 uv dx 
      CALL T2TERM ('RIGID',1,'CL','MASSE',1,'ADEUV',1,NOIMPP*1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*                        Preconditionnement
*
*   Assemblage de la matrice de preconditionnement
*
      CALL DOASTR ('GDELTA',1,'-iK','CONSTANTE',0,'COMPLEXE')
      CALL ASMTRM ('PRECON',0,NOIMPP*1)
      CALL CHRONO ('Assemblage E.F.',IMPPAL)
*
*   Factorisation incomplete modifiee de la matrice de preconditionnement
*
      CALL FIMLU  ('PRECON',0,'S',0,'MILUPC',1,NOIMPP*1)
      CALL FASV   ('MILUPC',1,'NEUGAM',1,'MILUSO',1,NOIMPP*1)
      CALL T1TERM ('MILUSO',1,'=','MILUSO',2,0)
      CALL CHRONO ('Factor. L.U inc et Resolution : Solveur L.U'
     &,IMPPAL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*                      Formulation FOURIER standard
*                     (sans frontiere intermediaire)
*     Ici sont deja connus : ADEUV,1 & PDELTA,1 & GDELTA,1
*  
      CALL PTITRE ('Formulation FOURIER standard')  
*   Calcul des termes de Couplage 
*   (calcul local sur Sigma avec calcul des noyaux incorpore)
      CALL MKSDGN ('GDNOYS',1,'GDNOYD',1
     &            ,'Domaine_Sigma = SIGMA , Domaine_Gamma=GAMMA'
     &         //', Donnee1 = K , Type_Green =COMPLEXE'
     &         //', Donnee_Lambda=LAMBDA, Inconnue=PHI'
     &         //',Nom_Gdelta=Gdelta')
      CALL COGDNO ('STANDARD','FOURIER','GDNOYS',1,'GDNOYD',1
     &            ,NOIMPF*1)
      CALL COGNOP ('GDNOYD',1,'PDELTA',1,'COUPLA',1,NOIMPF*1)
      CALL MATVEC ('GDNOYS',1,'NEUGAM',1,'COUPLS',1,NOIMPF*1)
*
      CALL TBTUER ('GDNOYD',1)
      CALL CHRONO ('Termes de Couplage',IMPPAL)
*  
*   Assemblage des matrices E.F. standard et des termes de Couplage
*
      CALL DOASTR ('GDELTA',1,'LAMBDA','CONSTANTE',0,'COMPLEXE')
      CALL DOASTR ('COUPLA',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASMTRM ('MATRIS',1,NOIMPF*5)
*
*   Assemblage des seconds membres E.F. standard et de Couplage 
* 
      CALL DOASTR ('COUPLS',1,'1/4PI','CONSTANTE',0,'REEL')
      CALL ASVTRM ('SECMBR',1,NOIMPF*5)  
      CALL TBTUER ('COUPLS',1)  
      CALL CHRONO ('Assemblage du systeme',IMPPAL)
*
*   Seuil d'arret des iterations de gradient et nb max d'iterations
*
      CALL GETCST('EPSILO',TYPE,EBID,EPSILO,KC,CARAC)
      CALL GETCST('MXITER',TYPE,MXITER,KR,KC,CARAC)
*  
*   Resolution par Gradient conjugue carre preconditionne
*
*     CALL GCS    ('MATRIS',1,'SECMBR',1,'MILUPC',1,EPSILO,MXITER 
*    &            ,'MILUSO',2,NOIMPF*5,*120)
*
      CALL CHRONO ('Resolution : FimLU + Gradient conjugue squared'
     &            ,IMPPAL)
      CALL BYE(' Fin')
120   CALL BAISE ('Non-convergence Gradient conjugue pour (MATRIS,1)')
                                          END
