*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM (NDIM,POINT,NOMFCT,TYPFCT 
     &                 ,NODONA,TYDONA,TYPRAS,MCASSO,IST,RST,CST
     &                 ,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2000)
* Derniere modification : D.Martin (20 Janvier 2000)
*  
* Calcul d'une fonction scalaire ou des composantes d'une fonction a valeurs
* vectorielles en un point de coordonnees donnees.
*  
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeurs:
*        POINT(I)= Ieme coordonnee du point (I=1,..,NDIM);
*      ->si le point est sur un domaine de dimension NDIM-1, et que l'on
*        calcule un terme de type 'ELEMENTS FINIS', le tableau contient en outre
*        les composantes du vecteur normal au point sous la forme :
*        POINT(NDIM+1)  = norme du vecteur
*        POINT(NDIM+1+I)= I-eme composante du vecteur (I=1,..,NDIM)
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA nom de la donnee (constante ou tableau) associee a la fonction
*        (le cas echeant)
* TYDONA type de representation  de la donnee associee a la fonction 
*        ('CONSTANTE','TABLEAU') (le cas echeant) 
* TYPRAS type de declaration de la constante ou du tableau associe 
*        ('REEL','COMPLEXE',...) (le cas echeant)
* MCASSO adresse de la constante associee ou du tableau associe
*        dans le super-tableau du bon type (donne par TYPRAS) (le cas echeant)
* IST    super-tableau version entiere
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,MCASSO,IST(*)
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL PI,X,Y,N1,N2,PIX,PIY
*-----------------------------------------------------------------------
      PI=4.*ATAN(1.D0)
      X=POINT(1)
      Y=POINT(2)
      PIX=PI*X
      PIY=PI*Y
         IF (NOMFCT(1:7).EQ.'uexacte') THEN
*
            RESULT(1)=COS(PIX)*SIN(PIY)
*
         ELSEIF (NOMFCT(1:7).EQ.'-deltau') THEN
*
            RESULT(1)=2*PI*PI*COS(PIX)*SIN(PIY)
*
         ELSEIF (NOMFCT(1:5).EQ.'gradu') THEN
*
            RESULT(1)=-PI*SIN(PIX)*SIN(PIY)
            RESULT(2)= PI*COS(PIX)*COS(PIY)
*
         ELSEIF (NOMFCT(1:4).EQ.'dudn') THEN
*
            RESULT(1)=-PI*SIN(PIX)*SIN(PIY)*POINT(NDIM+2)
     &                +PI*COS(PIX)*COS(PIY)*POINT(NDIM+3)
         ENDIF
                                                                    END !Fctrm
