*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PROGRAM DELTAU
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2000)
* Derniere modification : D.Martin (17 Janvier 2000)
*
* Resolution de \Delta U = F avec conditions de Dirichlet ou Neumann
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
*     Declarations globales des super-tableaux
*
      CHARACTER     AST
      INTEGER       MOTMXR,NBCHMX
      REAL          RST
*            | Intel-ifc-6  | AIX5.1-xlf  | GNUg77-2.9*  |
*            | GNUg77-3.*   | Intel-ifc-5 | SunOS-f77    |
*            |              | gfortran    |              |
*     MAXMOT | 536870911    | 268435455   | 134217727    |
      PARAMETER    (MOTMXR=268435455,NBCHMX=1000000)
      COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)
*
*     Variables locales
      INTEGER    EBID,DOMAIN,DOMAIX,IMPASS,IMPSYS,IMPRES,IMPSOL,IMPTES
     &          ,IDO,MXITER, KLGAMA
      REAL       RBID,EPSIL
      COMPLEX    CBID
      CHARACTER  ABID
      PARAMETER  (DOMAIX=4)
      CHARACTER  TYPE*1,SOLEXA*6,S2MEMB*11
      CHARACTER*3  CL(DOMAIX)
      CHARACTER*10 CONLIM(DOMAIX),RESOL*10
*
*-----------------------------------------------------------------------
*
*     Initialisation de l'allocation dynamique et
*     creation des structures de donnees.
      CALL INITIE (NBCHMX,MOTMXR)
*
*     Lecture du fichier de geometrie (maillage)
      CALL LCGEOM
*
*     Lecture des directives de definition des inconnues variationnelles
*     et de construction des termes elements-finis
      CALL LCDIRE
*
*     Lecture des donnees scalaires
      CALL LCDONN
      CALL CHRONO (' Lecture des donnees',6)
*
*     Numerotations globales en noeuds
      CALL NUMNEU
*
*     Distribution des coordonnees sur les domaines
      CALL CPTDOM
*
*     Calcul des termes elements-finis sur les domaines
      CALL CALKEF
      CALL CHRONO (' Calculs Elements Finis',6)
*
*     Constantes pour impression
      CALL GETCST ('Imp_ass',TYPE,IMPASS,RBID,CBID,ABID)
      CALL GETCST ('Imp_sys',TYPE,IMPSYS,RBID,CBID,ABID)
      CALL GETCST ('Imp_res',TYPE,IMPRES,RBID,CBID,ABID)
      CALL GETCST ('Imp_sol',TYPE,IMPSOL,RBID,CBID,ABID)
*     CALL GETCST ('Imp_tes',TYPE,IMPTES,RBID,CBID,ABID)
*
*     Nombre de bords du domaine et conditions aux limites
*
      CALL GETCST ('Domaines',TYPE,DOMAIN,RBID,CBID,ABID)
      IF (DOMAIN.GT.DOMAIX)
     &    CALL BAISE ('Nombre de domaines non prevu.')
      DO 1 IDO=1,DOMAIN
         CL(IDO)='CL'
         CALL ENCLER (IDO,CL(IDO)(3:3))
         CALL GETCST (CL(IDO),TYPE,EBID,RBID,CBID,CONLIM(IDO))
1     CONTINUE
*
*     Second Membre de l'equation
*
      CALL GETCST ('Calcul_2membre',TYPE,EBID,RBID,CBID,S2MEMB)
      IF (S2MEMB(1:6).EQ.'Interp')
     &   CALL MATVEC ('Masse',0,'Fval',0,'SecmbF',0,IMPASS)
      CALL ASMAKE ('SecmbF',0,'Secmbr',0)
*
*     Second Membre issu de conditions de Neuman
*
      DO 10 IDO=1,DOMAIN
         IF (CONLIM(IDO)(1:8).EQ.'NeumanNH') THEN
            IF (S2MEMB(1:6).EQ.'Interp')
     &      CALL MATVEC ('Masse',IDO,'dudn',IDO,'SecmbN',IDO,IMPASS)
            CALL ASMAKE ('SecmbN',IDO,'Secmbr',0)
         ENDIF
10    CONTINUE
*
*     Assemblage du second membre
      CALL ASVTRM ('Secmbr',0,IMPASS)
*
*     Conditions de Dirichlet
*
      DO 20 IDO=1,DOMAIN
         IF (CONLIM(IDO)(1:9).EQ.'Dirichlet') THEN
            CALL CDESSE ('Dirich',IDO,'Matris',0,'Secmbr',0)
         ENDIF
20    CONTINUE
*
      CALL CHRONO (' Constitution du Systeme',6)
*
*     Methode de resolution
*
      CALL GETCST ('Resolution',TYPE,EBID,RBID,CBID,RESOL)
      IF (RESOL(1:8).EQ.'Choleski') THEN
         CALL FALLT  ('Matris',0,'Matfac',0,IMPRES)
         CALL FASV   ('Matfac',0,'Secmbr',0,'Soluti',0,IMPRES)
      ELSEIF (RESOL(1:5).EQ.'Gauss') THEN
         CALL FALU   ('Matris',0,'S','Matfac',0,IMPRES)
         CALL FASV   ('Matfac',0,'Secmbr',0,'Soluti',0,IMPRES)
      ELSEIF (RESOL(1:7).EQ.'Gradient') THEN
         CALL GETCST ('Epsilon_GC',TYPE,EBID,EPSIL,CBID,ABID)
         CALL GETCST ('Max_Iter_GC',TYPE,MXITER,RBID,CBID,ABID)
         CALL GCJ    ('Matris',0,'Secmbr',0,' ',0,EPSIL,MXITER
     &               ,'Soluti',0,IMPRES,*99991)
      ELSE
         CALL BAISE  ('Methode de resolution non prevu.')
      ENDIF
      CALL TBTUER ('Matris',0)
      CALL TBTUER ('Secmbr',0)
      CALL CHRONO (' Resolution Systeme',6)
*
*     Comparaison avec une solution exacte
*
      CALL GETCST ('Solution_exacte',TYPE,EBID,RBID,CBID,SOLEXA)
      IF (SOLEXA(1:1).NE.' ')
     &   CALL DFTERM (SOLEXA,0,'Soluti',0,IMPSOL)
*
*     Calcul de la derivee normale sur Gamma1 (projection L2)
*
**      KLGAMA = 1
**      CALL MATVEC('UNV',KLGAMA,'Soluti',0,'SecDn',0,IMPTES)
**      CALL FALLT  ('Masse',KLGAMA,'Masfac',0,IMPTES)
**      CALL FASV   ('Masfac',0,'SecDn',0,'dudnca',0,IMPTES)
**      CALL DFTERM ('dudn',KLGAMA,'dudnca',0,IMPTES)
*
*     Calcul de la derivee normale sur Gamma1 par formule de Green
*
**      CALL ASMAKE ('SecmbF',0,'Secmbr',1)
*
*     Second Membre issu de conditions de Neuman
*
**      DO 110 IDO=1,DOMAIN
**         IF (IDO.NE.KLGAMA.AND.CONLIM(IDO)(1:8).EQ.'NeumanNH') THEN
**            IF (S2MEMB(1:6).EQ.'Interp')
**     &      CALL MATVEC ('Masse',IDO,'dudn',IDO,'SecmbN',IDO,IMPASS)
**            CALL ASMAKE ('SecmbN',IDO,'Secmbr',1)
**         ENDIF
**110    CONTINUE
*
*     Assemblage du second membre
**      CALL ASVTRM ('Secmbr',1,IMPASS)
*
*     Conditions de Dirichlet
*
**      DO 120 IDO=1,DOMAIN
**         IF (IDO.NE.KLGAMA.AND.CONLIM(IDO)(1:9).EQ.'Dirichlet') THEN
**            CALL CDESSE ('Dirich',IDO,'Matris',1,'Secmbr',1)
**         ENDIF
**120    CONTINUE
**      CALL MATVEC('Matris',1,'Soluti',0,'SecDn',1,IMPTES)
**      CALL T2TERM('SecDn',1,'-','Secmbr',1,'SecDn',2,IMPTES)
**      CALL FASV   ('Masfac',0,'SecDn',2,'dudnca',2,IMPTES)
**      CALL DFTERM ('dudn',KLGAMA,'dudnca',2,IMPTES)      

      CALL BYE (' That''s all Folks')
*
99991 CALL BAISE('Le Gradient Conjugue n''a pas converge')
      END

