*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM (NDIM,POINT,NOMFCT,TYPFCT 
     &                 ,NODONA,TYDONA,TYPRAS,MCASSO,IST,RST,CST
     &                 ,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 2001)
* Derniere modification : D.Martin (Decembre 2001)
*  
* Calcul d'une fonction scalaire ou des composantes d'une fonction a valeurs
* vectorielles en un point de coordonnees donnees.
*  
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeurs:
*        POINT(I)= Ieme coordonnee du point (I=1,..,NDIM);
*      ->si le point est sur un domaine de dimension NDIM-1, et que l'on
*        calcule un terme de type 'ELEMENTS FINIS', le tableau contient en outre
*        les composantes du vecteur normal au point sous la forme :
*        POINT(NDIM+1)  = norme du vecteur
*        POINT(NDIM+1+I)= I-eme composante du vecteur (I=1,..,NDIM)
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA nom de la donnee (constante ou tableau) associee a la fonction
*        (le cas echeant)
* TYDONA type de representation  de la donnee associee a la fonction 
*        ('CONSTANTE','TABLEAU') (le cas echeant) 
* TYPRAS type de declaration de la constante ou du tableau associe 
*        ('REEL','COMPLEXE',...) (le cas echeant)
* MCASSO adresse de la constante associee ou du tableau associe
*        dans le super-tableau du bon type (donne par TYPRAS) (le cas echeant)
* IST    super-tableau version entiere
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,MCASSO,IST(*)
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      REAL PI,X,Y,Z,N1,N2,N3,PIX,PIY,PIZ
*-----------------------------------------------------------------------
      PI=4.*ATAN(1.D0)
      X=POINT(1)
      Y=POINT(2)
      Z=POINT(3)
      SINPIX=SIN(PI*X)
      SINPIY=SIN(PI*Y)
      SINPIZ=SIN(PI*Z)
      COSPIX=COS(PI*X)
      COSPIY=COS(PI*Y)
      COSPIZ=COS(PI*Z)
      
         IF (NOMFCT(1:7).EQ.'uexacte') THEN
*
            RESULT(1)=COSPIX*COSPIY*COSPIZ
*
         ELSEIF (NOMFCT(1:7).EQ.'-deltau') THEN
*
            RESULT(1)=(3*PI*PI+1)*COSPIX*COSPIY*COSPIZ
*
         ELSEIF (NOMFCT(1:5).EQ.'gradu') THEN
*
            RESULT(1)=PI*SINPIX*COSPIY*COSPIZ
            RESULT(2)=PI*COSPIX*SINPIY*COSPIZ
            RESULT(3)=PI*COSPIX*COSPIY*SINPIZ
*
         ELSEIF (NOMFCT(1:4).EQ.'dudn') THEN
*
            N1=POINT(NDIM+2)/POINT(NDIM+1)
            N2=POINT(NDIM+3)/POINT(NDIM+1)
            N3=POINT(NDIM+4)/POINT(NDIM+1)
            RESULT(1)=-PI*SINPIX*COSPIY*COSPIZ*N1
     &                -PI*COSPIX*SINPIY*COSPIZ*N2
     &                -PI*COSPIX*COSPIY*SINPIZ*N3             
         ENDIF
                                                                    END !Fctrm
