*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            PROGRAM CE2D3C
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (fevrier/mars 1999)
* Derniere modification : D.Martin (3 mars 1999).
*
* Test de la condition essentielle E . Nu donnee
*                             ou   E ^ Nu donnee
*
* completee par l'une des conditions naturelles
*                                  Rot_{Beta}E^Nu = G
*                             ou   N Div_{Beta}E  = g
*
* pour l'operateur (inconnue a 3 composantes)
*
*   Rot_{-Beta}Rot_{Beta} E - Grad_{Beta}Div_{Beta} E + E = F 
*
* Voir fichier README
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Declarations des super-tableaux
      CHARACTER     AST
      INTEGER       MOTMXR,NBCHMX
      REAL          RST
      PARAMETER    (MOTMXR=10000000,NBCHMX=80000)
      COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)
*     Variables locales
      CHARACTER*10  TYPE*1,ABIDON*1,CLG(4)
      INTEGER       EBIDON,ORDGEO
      REAL          RBIDON,BETA
      COMPLEX       CBIDON
*-----------------------------------------------------------------------
*
*     Initialisation de l'allocation dynamique et
*     creation des structures de donnees.
      CALL INITIE (NBCHMX,MOTMXR)
*
*     Lecture du fichier de geometrie (maillage)
      CALL LCGEOM
*
*     Lecture des directives de definition des inconnues variationnelles
*     et de construction des termes elements-finis
      CALL LCDIRE
*
*     Lecture des donnees scalaires
      CALL LCDONN
*
*     Renumerotation pour minimiser la largeur de bande
      CALL GETCST ('ordregeom',TYPE,ORDGEO,BETA,CBIDON,ABIDON)
      CALL RENUME (ORDGEO,ORDGEO,0)
*
*     Numerotations globales en noeuds
      CALL NUMNEU
*
*     Distribution des coordonnees sur les domaines
      CALL CPTDOM
*
*     Calcul des termes elements-finis sur les domaines
      CALL CALKEF
      CALL CHRONO (' Calculs Elements Finis',6)
*
*     Assemblage de la matrice: 
*        Somme(Omega) RotB(u).RotB(v) + DivB(u).DivB(v) + u.v
*
      CALL GETCST ('BETA',TYPE,EBIDON,BETA,CBIDON,ABIDON)
      CALL PUTCST ('-BETA','REEL',EBIDON,-BETA,CBIDON,ABIDON)
      CALL PUTCST ('BETA2','REEL',EBIDON,BETA**2,CBIDON,ABIDON)
      CALL ASMTRM ('ADEUV',1,-1)
*
*     Chaines definissant les conditions aux limites
      CALL GETCST ('CLG1',TYPE,EBIDON,RBIDON,CBIDON,CLG(1))
      CALL GETCST ('CLG2',TYPE,EBIDON,RBIDON,CBIDON,CLG(2))
      CALL GETCST ('CLG3',TYPE,EBIDON,RBIDON,CBIDON,CLG(3))
      CALL GETCST ('CLG4',TYPE,EBIDON,RBIDON,CBIDON,CLG(4))
*
*     Calcul du second membre - Conditions naturelles sur Gamma.
      DO 10 NUGAMA=1,4
         IF (CLG(NUGAMA)(1:5).EQ.'CEF.N') THEN
*           Condition essentielle E.N = g, naturelle Rot_{Beta}E^N = G
            CALL MATVEC ('MASSEG',NUGAMA,'GG',NUGAMA,'MGG',NUGAMA,-1)
            CALL ASMAKE ('MGG',NUGAMA,'SCMEMB',1)
         ELSEIF (CLG(NUGAMA)(1:5).EQ.'CEF^N') THEN
*           Condition essentielle E^N = g, naturelle Div_{Beta}E N = g
            CALL MATVEC ('MASSEG',NUGAMA,'PG',NUGAMA,'MPG',NUGAMA,-1)
            CALL ASMAKE ('MPG',NUGAMA,'SCMEMB',1)
         ELSEIF (CLG(NUGAMA)(1:2).NE.'CE') THEN
*           Condition naturelles Rot_{Beta}E^N = G et Div_{Beta}E N = g
            CALL MATVEC ('MASSEG',NUGAMA,'GG',NUGAMA,'MGG',NUGAMA,-1)
            CALL MATVEC ('MASSEG',NUGAMA,'PG',NUGAMA,'MPG',NUGAMA,-1)
            CALL ASMAKE ('MGG',NUGAMA,'SCMEMB',1)
            CALL ASMAKE ('MPG',NUGAMA,'SCMEMB',1)
         ENDIF
10    CONTINUE
      CALL MATVEC ('masse',1,'F',1,'FV',1,-1)
      CALL ASMAKE ('FV',1,'SCMEMB',1)
      CALL ASVTRM ('SCMEMB',1,-1)
*
*     Bloquage des conditions essentielles
      DO 20 NUGAMA=1,4
         IF (CLG(NUGAMA)(1:5).EQ.'CEF.N') THEN
            CALL CDESSE ('EsN',NUGAMA,'ADEUV',1,'SCMEMB',1)
            WRITE (*,10000) 'RotE^N=G',NUGAMA
         ELSEIF (CLG(NUGAMA)(1:5).EQ.'CEF^N') THEN
            CALL CDESSE ('EvN',NUGAMA,'ADEUV',1,'SCMEMB',1)
            WRITE (*,10000) 'NdivE=g',NUGAMA
         ELSE
            WRITE (*,10000) 'NdivE=g et RotE^N=G',NUGAMA
         ENDIF
20    CONTINUE
*
      CALL CHRONO (' Assemblage',6)
*
*     Factorisation L.LT et resolution
      CALL FALLT  ('ADEUV',1,'APROF',1,0)
      CALL FASV   ('APROF',1,'SCMEMB',1,'SOLFA1',1,0)
      CALL DFTERM ('SOLEXA',1,'SOLFA1',1,0)
      CALL CHRONO (' Factorisation LLT et resolution',6)
*
*     Resolution par Gradient Conjugue.
      CALL GCJ    ('ADEUV',1,'SCMEMB',1,' ',0,1E-6,1000
     *            ,'SOLGCJ',1,0,*99)
      CALL DFTERM ('SOLEXA',1,'SOLGCJ',1,10)
      CALL CHRONO (' Resolution Gradient conjugue',6)
*
      CALL BYE('c''est fini')
99    CALL BAISE('Le Gradient Conjugue n''a pas converge')
10000 FORMAT (/T11,'Conditions naturelles ',A,' sur le domaine Gamma'
     &,I1)
      END

