*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            PROGRAM CE2D2C
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2001).
* Derniere modification : D.Martin (Janvier 2001).
*
* Test de la condition essentielle E^Nu ou E.Nu donne sur Gammai
* pour l'equation (inconnue a 2 composantes)
*               Rot rot E - S Grad Div E + K E = F
*                                      ( dp/dx2)           | E1 Nu1 |
* ou rot E=(dE2/dx1 - dE1/dx2), Rot p= (       ), E ^ Nu = |        |  
*                                      (-dp/dx1)           | E2 Nu2 |
* 
* avec les conditions naturelles au bord:
*                   Nu rot E = G et S Nu Div E = g
* ou des condition essentielles:
*                       E^Nu = G ou E.Nu = g
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Declarations globales des super-tableaux
      CHARACTER     AST
      INTEGER       MOTMXR,NBCHMX
      REAL          RST
      PARAMETER    (MOTMXR=10000000,NBCHMX=80000)
      COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)
*     Variables locales
      CHARACTER*10  TYPE*1,ABIDON*1,CLG(4),TYPES*4
      INTEGER       EBIDON,ORDGEO,MXITER
      REAL          RBIDON,EPSIL,S,K
      COMPLEX       CBIDON
*-----------------------------------------------------------------------
*
*     Initialisation de l'allocation dynamique et
*     creation des structures de donnees.
      CALL INITIE (NBCHMX,MOTMXR)
*
*     Lecture du fichier de geometrie (maillage)
      CALL LCGEOM
*
*     Lecture des directives de definition des inconnues variationnelles
*     et de construction des termes elements-finis
      CALL LCDIRE
*
*     Lecture des donnees scalaires
      CALL LCDONN
      CALL CHRONO (' Lecture des donnees',6)
*
      CALL GETTAB ('SetK',1,1,TYPES,EBIDON,S,CBIDON,ABIDON)
      CALL GETTAB ('SetK',1,2,TYPES,EBIDON,K,CBIDON,ABIDON)
      CALL PUTCST ('S',TYPES,EBIDON,S,CBIDON,ABIDON)
      CALL PUTCST ('K',TYPES,EBIDON,K,CBIDON,ABIDON)
      CALL PRTAB ('SetK',1,6)
*
*     Renumerotation pour minimiser la largeur de bande
      CALL GETCST ('ordregeom',TYPE,ORDGEO,BETA,CBIDON,ABIDON)
      CALL RENUME (ORDGEO,ORDGEO,0)
*
*     Numerotations globales en noeuds
      CALL NUMNEU
*
*     Distribution des coordonnees sur les domaines
      CALL CPTDOM
*
*     Calcul des termes elements-finis sur les domaines
      CALL CALKEF
      CALL CHRONO (' Calculs Elements Finis',6)
*
*     Assemblage de la matrice: 
*        Somme(Omega) Rot(u).Rot(v) + S Div(u).Div(v) + K u.v
*
      CALL ASMTRM ('ADEUV',1,0)
*
*     Calcul du second membre - Conditions naturelles sur Gamma.
*
      CALL GETCST ('CLG1',TYPE,EBIDON,RBIDON,CBIDON,CLG(1))
      CALL GETCST ('CLG2',TYPE,EBIDON,RBIDON,CBIDON,CLG(2))
      CALL GETCST ('CLG3',TYPE,EBIDON,RBIDON,CBIDON,CLG(3))
      CALL GETCST ('CLG4',TYPE,EBIDON,RBIDON,CBIDON,CLG(4))
*
      DO 10 NUGAMA=1,4
         IF (CLG(NUGAMA)(1:5).EQ.'CEF.N') THEN
*           Condition naturelle N Rot E = G
            CALL MATVEC ('UvV',NUGAMA,'GG',NUGAMA,'MGG',NUGAMA,-1)
            CALL ASMAKE ('MGG' ,NUGAMA,'SCMEMB',1)
         ELSE IF (CLG(NUGAMA)(1:5).EQ.'CEF^N') THEN
*           Condition naturelle N Div E = g
            CALL MATVEC ('UsV',NUGAMA,'PG',NUGAMA,'MPG',NUGAMA,-1)
            CALL DOASTR ('MPG',NUGAMA,'S','CONSTANTE',0,TYPES)
            CALL ASMAKE ('MPG',NUGAMA,'SCMEMB',1)
         ELSEIF (CLG(NUGAMA)(1:3).NE.'CEF') THEN
*           Condition naturelles N Rot E = G et N Div E = g
            CALL MATVEC ('UvV',NUGAMA,'GG',NUGAMA,'MGG',NUGAMA,-1)
            CALL MATVEC ('UsV',NUGAMA,'PG',NUGAMA,'MPG',NUGAMA,-1)
            CALL DOASTR ('MPG',NUGAMA,'S','CONSTANTE',0,TYPES)
            CALL ASMAKE ('MGG',NUGAMA,'SCMEMB',1)
            CALL ASMAKE ('MPG',NUGAMA,'SCMEMB',1)
         ENDIF
10    CONTINUE
*
      CALL MATVEC ('masse',1,'F',1,'FV',1,-1)
      CALL ASMAKE ('FV',1,'SCMEMB',1)
      CALL ASVTRM ('SCMEMB',1,0)
      CALL PRTERM ('ADEUV',1,10,8)
*
*     Prise en compte des conditions essentielles
      DO 20 NUGAMA=1,4
         IF (CLG(NUGAMA)(1:5).EQ.'CEF.N') THEN
*           Condition essentielle E.N = g
            CALL CDESSE ('EsN',NUGAMA,'ADEUV',1,'SCMEMB',1)
         ELSEIF (CLG(NUGAMA)(1:5).EQ.'CEF^N') THEN
*           Condition essentielle E^N = g
            CALL CDESSE ('EvN',NUGAMA,'ADEUV',1,'SCMEMB',1)
         ELSEIF (CLG(NUGAMA)(1:3).EQ.'CEF') THEN
            CALL CDESSE ('E1E2',NUGAMA,'ADEUV',1,'SCMEMB',1)
         ENDIF
20    CONTINUE
      CALL PRTERM ('ADEUV',1,10,8)
*
      CALL CHRONO (' Assemblage',6)
*
*     Resolutions
*
*     Factorisation de type Gauss ( L U )
*      CALL FALU   ('ADEUV',1,'S','APROF1',1,0)
*      CALL FASV   ('APROF1',1,'SCMEMB',1,'SOLFA1',1,0)
*      CALL DFTERM ('SOLEXA',1,'SOLFA1',1,10)
*      CALL CHRONO (' Factorisation LU et resolution',6)
*
*     Factorisation de type Choleski ( L Lt )
      CALL FALLT  ('ADEUV',1,'APROF2',1,0)
      CALL FASV   ('APROF2',1,'SCMEMB',1,'SOLFA2',1,0)
      CALL DFTERM ('SOLEXA',1,'SOLFA2',1,10)
*
*     Resolution par Gradient Conjugue.
      CALL GETCST ('EPSILON',TYPE,EBIDON,EPSIL,CBIDON,ABIDON)
      CALL GETCST ('MAXITER',TYPE,MXITER,RBIDON,CBIDON,ABIDON)
      CALL GCJ    ('ADEUV',1,'SCMEMB',1,' ',0,EPSIL,MXITER
     &            ,'SOLGCJ',1,0,*99)
      CALL DFTERM ('SOLEXA',1,'SOLGCJ',1,10)
      CALL CHRONO (' Resolution Gradient conjugue',6)
*
      CALL BYE('c''est fini')
99    CALL BAISE('Le Gradient Conjugue n''a pas converge')
      END

