*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FCTRM (NDIM,POINT,NOMFCT,TYPFCT
     &                 ,NODONA,TYDONA,TYPRAS,MCASSO,IST,RST,CST
     &                 ,RESULT,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)
* Derniere modification : D.Martin (9 Novembre 1999)
*  
* Calcul d'une fonction scalaire ou des composantes d'une fonction a valeurs
* vectorielles en un point de coordonnees donnees.
*  
*-- Arguments d'entree --
* NDIM   dimension d'espace
* POINT  tableau des coordonnees du point ou l'on calcule la ou les valeurs:
*        POINT(I)= Ieme coordonnee du point (I=1,..,NDIM);
*      ->si le point est sur un domaine de dimension NDIM-1, et que l'on
*        calcule un terme de type 'ELEMENTS FINIS', le tableau contient en outre
*        les composantes du vecteur normal au point sous la forme :
*        POINT(NDIM+1)  = norme du vecteur
*        POINT(NDIM+1+I)= I-eme composante du vecteur unitaire (I=1,..,NDIM)
* NOMFCT nom de la donnee FONCTION pour laquelle le calcul est effectue.
*        Cet argument permet de distinguer les differentes 'fonctions'
*        programmees dans cette procedure.
* TYPFCT type du resultat retourne par la fonction ('REEL' ou 'COMPLEXE') 
* NODONA nom de la donnee (constante ou tableau) associee a la fonction
*        (le cas echeant)
* TYDONA type de representation  de la donnee associee a la fonction 
*        ('CONSTANTE','TABLEAU') (le cas echeant) 
* TYPRAS type de declaration de la constante ou du tableau associe 
*        ('REEL','COMPLEXE',...) (le cas echeant)
* MCASSO adresse de la constante associee ou du tableau associe
*        dans le super-tableau du bon type (donne par TYPRAS) (le cas echeant)
* IST    super-tableau version entiere
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*-- Arguments de sortie --
* RESULT valeur ou tableau de valeurs de la fonction dans le cas TYPFCT='REEL'  
* CESULT idem dans le cas TYPFCT='COMPLEXE'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMFCT,TYPFCT,NODONA,TYDONA,TYPRAS
      INTEGER       NDIM,MCASSO,IST(*)
      REAL          POINT(*),RST(*),RESULT(*)
      COMPLEX       CST(*),CESULT(*)
*
      real x, y
      real a,b,c,d,t,theta
*-----------------------------------------------------------------------
      x=point(1)
      y=point(2)
      a=rst(mcasso)
      c=rst(mcasso+1)
      t=rst(mcasso+2)
      
      theta=(-2.0+a*c)/sqrt(2.0*a*c)
      
      if (nomfct(1:2).eq.'u0') then
       result(1)=0.5*(1.0+tanh(sqrt(2.0*a*c)*x/4.0))
      elseif (nomfct(1:2).eq.'v0') then
       result(1)=0.25*a*(1.0-tanh(sqrt(2.0*a*c)*x/4.0))**2
      elseif (nomfct(1:4).eq.'uexa') then
       result(1)=0.5*(1.0+tanh(sqrt(2.0*a*c)*(x-theta*t)/4.0))
      elseif (nomfct(1:4).eq.'vexa') then
       result(1)=0.25*a*(1.0-tanh(sqrt(2.0*a*c)*(x-theta*t)/4.0))**2
      endif
                                                                    END !Fctrm
