       program reactiondiffusion2d
          implicit none
          
          character ast
          integer motmxr, nbchmx
          integer klunit
          real rst
          parameter(motmxr=500000000,nbchmx=30000000)
          common/ /rst(motmxr) /stchar/ast(nbchmx)
          
          integer imptim, impsys, i, nbiter, imperr
          complex ctmp
          real dt, a, b, c, d, uern, vern
          character*4 dttype, atype, ctype, uerntype, verntype
          character*6 nbitertype
          character*20 str, stru, strv
          character*20 uofroot, vofroot, drawutype, drawvtype
          
          imptim=0
          impsys=0
          
          call initie(nbchmx,motmxr)
          call lcgeom
          call lcdire
          call lcdonn
          call numneu
          call cptdom
          
          call getcst('a',atype,0,a,ctmp,' ')
          call getcst('c',ctype,0,c,ctmp,' ')
          call getcst('Drawu',drawutype,0,0.0,ctmp,uofroot)
          call getcst('Drawv',drawvtype,0,0.0,ctmp,vofroot)
          b=2.0+5.0*a/3.0-a*c
          d=1.0/(3.0*c)
                    
          call putcst('b','REEL',0,b,ctmp,' ')
          call putcst('d','REEL',0,d,ctmp,' ')
          
          call puttab('param',1,1,'REEL',0,a,ctmp,' ')
          call puttab('param',1,2,'REEL',0,c,ctmp,' ')
          
          call getcst('dt',dttype,0,dt,ctmp,' ')
          
          call putcst('ddt','REEL',0,d*dt,ctmp,' ')
          call putcst('1+dt','REEL',0,1.0+dt,ctmp,' ')
          call putcst('1+adt','REEL',0,1.0+a*dt,ctmp,' ')
          call putcst('-dt','REEL',0,-dt,ctmp,' ')
          
          call getcst('nbiter',nbitertype,nbiter,0.0,ctmp,' ')
          
          call calkef
          
          write(str,'(i20)') 0
          stru=trim(adjustl(uofroot))//trim(adjustl(str))
          strv=trim(adjustl(vofroot))//trim(adjustl(str))
          
          call putcst('Drawu','CHARACTER*x',0,0.0,ctmp,stru)
          call gbegin('Drawu','2D','paraview')
          call gheadr('Drawu','u0',' ')
          call gbodyr('Drawu','Sun',1,'domain_3')
          call gend()
          
          call putcst('Drawv','CHARACTER*x',0,0.0,ctmp,strv)
          call gbegin('Drawv','2D','paraview')
          call gheadr('Drawv','v0',' ')
          call gbodyr('Drawv','Svn',1,'domain_3')
          call gend()
          
          call t1term('Sun',1,"=",'un',0,impsys)
          call t1term('Svn',1,"=",'vn',0,impsys)
          
          call clterm('un',0,' ','vn',0,'c','utmp1',0,impsys)
          call clterm('vn',0,' ','un',0,'b','vtmp1',0,impsys)
          call t2term('un',0,'.*','utmp1',0,'utmp2',0,impsys)
          call t2term('vn',0,'.*','vtmp1',0,'vtmp2',0,impsys)
          call clterm('un',0,'1+dt','utmp2',0,'-dt','Sun',1,impsys)
          call clterm('vn',0,'1+adt','vtmp2',0,'-dt','Svn',1,impsys)
          
          call matvec('Masse',0,'Sun',1,'Rhsu',0,impsys)
          call matvec('Masse',0,'Svn',1,'Rhsv',0,impsys)

          imperr=klunit()
          open (unit=imperr,file="erreur.txt")
          
          call clterm('Masse',0,' ','Rigid',0,'dt','Matu',0,impsys)
          call clterm('Masse',0,' ','Rigid',0,'ddt','Matv',0,impsys)
          call t1term('Matu',0,"=",'Musav',0,impsys)
          call t1term('Matv',0,"=",'Mvsav',0,impsys)
          
          call cdesse('Diricu',2,'Matu',0,'Rhsu',0)
          call cdesse('Diricv',2,'Matv',0,'Rhsv',0)
          
          call fallt('Matu',0,'Mfacu',0,impsys)
          call fallt('Matv',0,'Mfacv',0,impsys)
          
          do i=1,nbiter
            write(6,'(a,1x,i4)') 'Iteration',i
            
            call fasv('Mfacu',0,'Rhsu',0,'un',0,impsys)
            call fasv('Mfacv',0,'Rhsv',0,'vn',0,impsys)
            
            call clterm('un',0,' ','vn',0,'c','utmp1',0,impsys)
            call clterm('un',0,'b','vn',0,' ','vtmp1',0,impsys)
            call t2term('un',0,'.*','utmp1',0,'utmp2',0,impsys)
            call t2term('vn',0,'.*','vtmp1',0,'vtmp2',0,impsys)
            call clterm('un',0,'1+dt','utmp2',0,'-dt','Sun',1,impsys)
            call clterm('vn',0,'1+adt','vtmp2',0,'-dt','Svn',1,impsys)
          
            call matvec('Masse',0,'Sun',1,'Rhsu',0,impsys)
            call matvec('Masse',0,'Svn',1,'Rhsv',0,impsys)
            
            call puttab('param',1,3,'REEL',0,i*dt,ctmp,' ')
            call rkterm('ue',1,impsys)
            call rkterm('ve',1,impsys)
c             call rkterm('Rhsu',0,impsys)
c             call rkterm('Rhsv',0,impsys)
            
            call calkef
            
            call t1term('Musav',0,'=','Matu',0,impsys)
            call t1term('Mvsav',0,'=','Matv',0,impsys)
            call cdesse('Diricu',2,'Matu',0,'Rhsu',0)
            call cdesse('Diricv',2,'Matv',0,'Rhsv',0)
            
            write(str,'(i20)') i
            stru=trim(adjustl(uofroot))//trim(adjustl(str))
            call putcst('Drawu','CHARACTER*x',0,0.0,ctmp,stru)
            call gbegin('Drawu','2D','paraview')
            call gheadr('Drawu','u'//trim(adjustl(str)),' ')
            call gbodyr('Drawu','un',0,'domain_3')
            call gend()
            strv=trim(adjustl(vofroot))//trim(adjustl(str))
            call putcst('Drawv','CHARACTER*x',0,0.0,ctmp,strv)
            call gbegin('Drawv','2D','paraview')
            call gheadr('Drawv','v'//trim(adjustl(str)),' ')
            call gbodyr('Drawv','vn',0,'domain_3')
            call gend()
          
            call t2term('un',0,'-','ue',1,'uerr',1,impsys)
            call t2term('vn',0,'-','ve',1,'verr',1,impsys)
          
            call matvec('Masse',0,'uerr',1,'uer',1,impsys)
            call matvec('Masse',0,'verr',1,'ver',1,impsys)
          
            call xsterm('S','uerr',1,'uer',1,uerntype,uern,ctmp)
            call xsterm('S','verr',1,'ver',1,verntype,vern,ctmp)
          
            write(imperr,*) uern, vern
          end do
          close(imperr)
          call bye('Ce qui a commence doit finir !!!')
       end