*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                            PROGRAM VPLAP
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1999)
* Derniere modification : D.Martin (20 Janvier 2004)
*
* Calcul des plus petites valeurs propres du Laplacien par 
* la methode d'iterations de sous-espace
* ou
* Calcul de la plus petite valeur propre du Laplacien par 
* la methode d'iteration inverse
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
*     Declarations globales des super-tableaux
      INTEGER   MOTMXR,NBCHMX
      PARAMETER (MOTMXR=1000000,NBCHMX=80000)
      CHARACTER AST
      REAL RST
      COMMON/      /RST(MOTMXR)/STCHAR/AST(NBCHMX)
*     Variables locales
      CHARACTER TYPE,ABIDON,NUMERO
      INTEGER   DIMEST,NBVP,NBVPCA,I
      REAL      RBIDON,VALPRO
      COMPLEX   CBIDON
*-----------------------------------------------------------------------
*
*     Initialisation de l'allocation dynamique et
*     creation des structures de donnees.
      CALL INITIE (NBCHMX,MOTMXR)
*
*     Lecture du fichier de geometrie (maillage)
      CALL LCGEOM
*
*     Lecture des directives de definition des inconnues variationnelles
*     et des termes elements-finis
      CALL LCDIRE
*
*     Lecture des donnees scalaires
      CALL LCDONN
      CALL CHRONO (' Lecture des donnees',6)
*
*     Numerotations globales en noeuds
      CALL NUMNEU
*
*     Distribution des coordonnees sur les domaines
      CALL CPTDOM
*
*     Calcul des termes elements-finis sur les domaines
      CALL CALKEF
      CALL CHRONO (' Calculs Elements Finis',6)
*
      CALL CDESSE ('cdesse',1,'rigid',1,' ',1)
      CALL CDESSE ('cdesse',1,'masse',1,' ',1ls)
*
*     Plus petites valeurs propres Lambda et vecteurs propres V de
*                    rigid x  V = lambda masse x V
*
*     Factorisation LLT de rigid
*
      CALL FALLT  ('rigid',1,'rigidf',1,0)
*
      CALL GETCST ('NbValpro',TYPE,NBVP,RBIDON,CBIDON,ABIDON)
      CALL GETCST ('DimEst',TYPE,DIMEST,RBIDON,CBIDON,ABIDON)
*
*     Initialisation des tableaux valpro et vecpro
*
*     NBVPCA : Nombre de valeurs propres deja calculees
      NBVPCA=0
      CALL VPINIT ('rigid',1,'valpro',0,'vecpro',0,'espvp',0
     &            ,NBVP,NBVPCA,DIMEST,0)
*
*     Calcul des valeurs et vecteurs propres de Av = Lambda Bv
*     par la methode d'iteration de sous-espace
*
      CALL VPMISE ('L.LT(A)','rigidf',1,'masse',1,'valpro',0,'vecpro',0
     &            ,'espvp',0,NBVP,NBVPCA
     &            ,'Epsilon=Epsilon-vp,Maximum_Iterations=MaxIter-vp'
     &            //',Impression=Impression-vp')
*
*     Calcul des valeurs et vecteurs propres de Av = Lambda Bv
*     par la methode d'iterations inverses
*
**      NBVP=1
**      DIMEST=1
**      CALL VPINIT ('rigid',1,'valpro',0,'vecpro',0,' ',0
**     &            ,NBVP,NBVPCA,DIMEST,0)
**      CALL ITEINV ('rigid',1,'masse',1,VALPRO,'vecpro',0,0
**     &            ,'Impression=Impression-vp')

      CALL CHRONO (' Calculs des valeurs Propres',6)
*
*     Transformations du tableau des vecteurs propres en termes vectoriels
*     par extraction des colonnes
*
      DO 1 I=1,NBVP
         CALL ENCLER (I,NUMERO)
         CALL T1TERM ('vecpro',0,'colonne '//NUMERO,'vecpro',I,0)
1     CONTINUE
*
*     Fichier graphique pour dessiner le 1er vecteur propre
*
      CALL GBEGIN ('Dessin','2D','mesh&bb')
      CALL GHEADR ('Dessin','Vecteur propre #1','1')
      CALL GBODYR ('Dessin','vecpro',1,'Omega')
      CALL GEND ()

      CALL BYE('c''est fini')
      END

