      SUBROUTINE DECLIG (LIGNE,NBPTS,NBEL)

C- Fonction : Decoder la 4eme ligne du fichier de geometrie qui contient
C-            en format *libre* NBPTS et NBEL
C-
C- Entree :
C-    LIGNEN : Numero du message
C-
C- Sortie : 
C-    NBPTS : Nombre de points
C-    NBEL : Nombre d'elements
C-
C- Local :
C-    LONGCH : Fonction calculant la longueur reelle d'une chaine
C-   PUISS : puissances de 10
C-   I1,I2 : indices de debut/fin de sous-chaines
C-
C- Derniere modif : 11 AVR 2000

      CHARACTER*80 LIGNE
      CHARACTER C
      INTEGER NBPTS,NBEL,LONGCH,PUISS,I,I1,I2
     
C- On cherche la position des chaines 'NBPTS' et 'NBEL' pour verifier que
C- c'est bien la bonne ligne. On en deduit les positions des chaines contenant 
C- les nombres.
      I1=INDEX(LIGNE,'NBPTS')
      IF (I1.EQ.0) CALL BLEME (8)
      I2=INDEX(LIGNE,'NBEL')
      IF (I2.EQ.0) CALL BLEME (9)
 
C- Decodage de NBPTS. Compris entre I1+5 et I2-1
      NBPTS=0
      PUISS=1
      DO 10 I=I2-1,I1+5,-1
        C=LIGNE(I:I)
        IF (LGE(C,'0').AND.LLE(C,'9')) THEN
           NBPTS=NBPTS+(ICHAR(C)-48)*PUISS
           PUISS=PUISS*10
        ENDIF
10    CONTINUE
 
C- Decodage de NBEL. Compris entre I1=LONGCH(LIGNE) et I2+4
      NBEL=0
      PUISS=1
      I1=LONGCH(LIGNE)
      DO 20 I=I1,I2+4,-1
        C=LIGNE(I:I)
        IF (LGE(C,'0').AND.LLE(C,'9')) THEN
           NBEL=NBEL+(ICHAR(C)-48)*PUISS
           PUISS=PUISS*10
        ENDIF
20    CONTINUE

      END


