      SUBROUTINE DEFCHO (CLIC,NBCOL,NUMREP,MAILLA,ZMIN,ZMAX,PASCOL,
     &                   LARTRA,NBFEN,VALPRJ,AXES)

C- Fonction : Modifications lies au choix de la souris
C-
C- Entree :
C-    CLIC : Valeur du clic du mulot
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    
C- Sortie : -
C-    NUMREP : Type de representation
C-    MAILLA :  : Maillage ou non
C-    ZMIN,ZMAX : Min et max des Z
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    LARTRA : Largeur du trace en NUMREP=2
C-    NBFEN : Nombre de fenetres
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-    AXES : Traces ou non des axes
C-
C- Local :
C-    DELTAN : Variation des angles PHI et THETA
C-
C- Derniere modif : 29 NOV 2000

      INTEGER CLIC,NBCOL,NUMREP,LARTRA,NBFEN
      LOGICAL MAILLA,AXES
      REAL ZMIN,ZMAX,PASCOL,VALPRJ(*)

      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170,
     &      180,190,200,210,220,230,240,250) CLIC

C- Maillage
10    NUMREP=1
      RETURN

C- Iso.lignes
20    NUMREP=2
      RETURN

C- Iso.planes
30    NUMREP=3
      RETURN

C- Iso.en elevation
40    NUMREP=4
      RETURN

C- Maillage ou pas
50    MAILLA=.NOT.MAILLA
      RETURN

C- Mono/Multi-fenetrage
C- Choix possible si et ssi NBFICH=1 ou COMBIN
60    CALL PGSAVE ()
      IF (NBFEN.EQ.1) THEN
         NBFEN=4
         CALL PGSUBP (2,2)
      ELSE
         NBFEN=1
         NUMREP=1
         CALL PGSUBP (1,1)
         CALL PGUNSA ()
      ENDIF
      RETURN

C- Sortie fichier
70    RETURN

C- Quitter
80    RETURN

C- Changement du nombre de couleurs
90    NBCOL=32
      CALL INICOL (NBCOL)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

100   NBCOL=64
      CALL INICOL (NBCOL)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

110   NBCOL=128
      CALL INICOL (NBCOL)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

120   NBCOL=254
      CALL INICOL (NBCOL)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

C- Changement de ZMIN
130   CALL MENUZ (ZMIN,1)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

C- Changement de ZMAX
140   CALL MENUZ (ZMAX,2)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

C- Diminution de largeur du trait en NUMREP=2
150   LARTRA=LARTRA/2 
      IF (LARTRA.LT.1) LARTRA=1
      RETURN

C- Epaississement du trait en NUMREP=2
160   LARTRA=LARTRA*2
      IF (LARTRA.GT.10) LARTRA=10
      RETURN

C- VALPRJ(1) : angle de variation de RHO/PHI
170   VALPRJ(1)=VALPRJ(1)/2
      RETURN

C- Deltan +
180   VALPRJ(1)=2*VALPRJ(1)
      RETURN

C- RHO - : VALPRJ(2)
190   VALPRJ(2)=3*VALPRJ(2)/4
      RETURN

C- RHO + 
200   VALPRJ(2)=4*VALPRJ(2)/3
      RETURN

C- PHI - : VALPRJ(3)
210   VALPRJ(3)=VALPRJ(3)-VALPRJ(1)
      RETURN

C- PHI +
220   VALPRJ(3)=VALPRJ(3)+VALPRJ(1)
      RETURN

C- THETA - : VALPRJ(4)
230   VALPRJ(4)=VALPRJ(4)-VALPRJ(1)
      RETURN

C- THETA +
240   VALPRJ(4)=VALPRJ(4)+VALPRJ(1)
      RETURN

C- AXES (O/N)
250   AXES=.NOT.AXES

      END
