      SUBROUTINE DESSIN (NBFIMX,NBLMAX,NBFICH,COMBIN,NBFEN,NUMREP,
     &                   MAILLA,ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,
     &                   YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &                   LABEL,VALPRJ)


C- Fonction : Dessin du ou des NBFICH fichiers en fonction des differentes
C-            variables (NUMREP,NBFEN,...)
C-
C- Entree :
C-    NBFIMX : Nombre maximum de fichiers   
C-    NBLMAX : Nombre maximum d'elements
C-    NBFICH : Nombre de fichiers
C-    COMBIN : Combinaison des fichiers
C-    NBFEN  : Nombre de fenetres
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    LARTRA : Largeur du trace en NUMREP=2
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    XMIN,YMIN,ZMIN : Min des X,Y,Z
C-    XMAX,YMAX,ZMAX : Max des X,Y,Z
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-    AXES   : Traces ou non des axes
C-    LABEL  : Labels i.e commentaires des dessins
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Local :
C-    IFICH : Indice de fichiers
C-
C- Derniere modif : 29 NOV 2000

      INTEGER NBFIMX,NBLMAX,NBFICH,NBFEN,NUMREP,ARETES(*),LARTRA
      INTEGER N(NBFIMX,NBLMAX,*),NBEL(*),NBCOL,IFICH
      LOGICAL COMBIN,MAILLA,AXES
      REAL X(NBFIMX,*),Y(NBFIMX,*),Z(NBFIMX,*),XMIN,YMIN,ZMIN,XMAX,YMAX
      REAL ZMAX,PASCOL,TABCOL,VALPRJ(*)
      CHARACTER*80 LABEL(NBFIMX)

C- On "nettoie" la fenetre
      CALL PGPAGE ()

C- Si on a une seule fenetre, donc un seul fichier ou COMBIN
      IF (NBFEN.EQ.1) THEN
         IF (NBFICH.EQ.1) THEN
            CALL REPFIC (NBFIMX,NBLMAX,1,COMBIN,NUMREP,MAILLA,ARETES,
     &                   LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,N,
     &                   NBEL,NBCOL,PASCOL,TABCOL,AXES,LABEL,VALPRJ)
         ELSE 
            DO 10 IFICH=1,NBFICH
               CALL REPFIC (NBFIMX,NBLMAX,IFICH,COMBIN,NUMREP,MAILLA,
     &                      ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,
     &                      YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &                      LABEL,VALPRJ)
10          CONTINUE
         ENDIF

C- Si a on le multi-fenetrage, on represente les NBFICH a suivre 
C- dans le meme NUMREP
      ELSE
         IF (NBFICH.GT.1.AND..NOT.COMBIN) THEN
            DO 20 IFICH=1,NBFICH
               CALL REPFIC (NBFIMX,NBLMAX,IFICH,COMBIN,NUMREP,MAILLA,
     &                      ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,
     &                      YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &                      LABEL,VALPRJ)
C- On passe a la sous-fenetre suivante sauf le dernier sinon on passe a une 
C- autre fenetre. Capito ?
               IF (IFICH.LT.NBFICH) CALL PGPAGE()
20          CONTINUE

C- On represente dans des NUMREP differents si 1 fichier ou COMBIN
         ELSE
            DO 40 NUMREP=1,4
               IF (COMBIN) THEN
                  DO 30 IFICH=1,NBFICH
                     CALL REPFIC (NBFIMX,NBLMAX,IFICH,COMBIN,NUMREP,
     &                            MAILLA,ARETES,LARTRA,X,Y,Z,XMIN,YMIN,
     &                            ZMIN,XMAX,YMAX,ZMAX,N,NBEL,NBCOL,
     &                            PASCOL,TABCOL,AXES,LABEL,VALPRJ)
30                CONTINUE
               ELSE
                  CALL REPFIC (NBFIMX,NBLMAX,1,COMBIN,NUMREP,MAILLA,
     &                         ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,
     &                         YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,
     &                         AXES,LABEL,VALPRJ)
               ENDIF
               IF (NUMREP.LT.4) CALL PGPAGE ()
40          CONTINUE

         ENDIF    
      ENDIF

      END 
 
