      SUBROUTINE FICSOR (NBFIMX,NBLMAX,NBFICH,COMBIN,NBFEN,NUMREP,
     &                   MAILLA,ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,
     &                   YMAX,ZMAX,DELTAX,DELTAY,N,NBEL,NBCOL,PASCOL,
     &                   TABCOL,AXES,FICHRE,ENTREE,SORTIE,LABEL,VALPRJ)

C- Fonction : DESSIN dans un fichier de sortie GIF ou PostScript 
C-
C- Entree :
C-    NBFIMX : Nombre maximum de fichiers   
C-    NBLMAX : Nombre maximum d'elements
C-    NBFICH : Nombre de fichiers
C-    COMBIN : Combinaison des fichiers
C-    NBFEN  : Nombre de fenetres
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    LARTRA : Largeur du trace en NUMREP=2
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    XMIN,YMIN,ZMIN : Min des X,Y,Z
C-    XMAX,YMAX,ZMAX : Max des X,Y,Z
C-    DELTAX, DELTAY : Largeur (XMAX-XMIN) et hauteur (YMAX-YMIN) reels
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-    AXES   : Traces ou non des axes
C-    FICHRE : Nom du(es) fichier(s) de resultats
C-    ENTREE : Repertoire contenant les fichiers de donnees
C-    SORTIE : Repertoire contenant les fichiers de sorties
C-    LABEL  : Labels i.e commentaires des dessins
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Local :
C-    FENSOR : Unite PGPLOT associe au fichier de sortie
C-    PS     : Format du fichier de sortie (GIF ou PostScript) 
C-    NOMSOR : Nom du fichier de sortie
C-    IBIDON  : Variable bidon pour fonctions PGPLOT
C-
C- Derniere modif : 3 JUL 2001

      INTEGER NBFIMX,NBLMAX,NBFICH,NBFEN,NUMREP,ARETES(*),LARTRA
      INTEGER N(NBFIMX,NBLMAX,*),NBEL(*),NBCOL,FENSOR,PGOPEN,IBIDON
      LOGICAL COMBIN,MAILLA,AXES,PS
      REAL X(NBFIMX,*),Y(NBFIMX,*),Z(NBFIMX,*),XMIN,YMIN,ZMIN,XMAX,YMAX
      REAL ZMAX,DELTAX,DELTAY,PASCOL,TABCOL,VALPRJ(*)
      CHARACTER*80 FICHRE(NBFIMX),ENTREE,SORTIE,LABEL(NBFIMX),NOMSOR

C- Lecture du format et du nom du fichier de sortie
      CALL MENSOR (FICHRE,ENTREE,SORTIE,PS,NOMSOR)

      IF (PS) THEN
         FENSOR=PGOPEN(NOMSOR // '/cps')
         IF (FENSOR.LT.0) CALL BLEME (13)
      ELSE
         FENSOR=PGOPEN(NOMSOR // '/gif')
         IF (FENSOR.LT.0) CALL BLEME (13)
      ENDIF

      CALL PGENV (XMIN-0.01*DELTAX,XMAX+0.01*DELTAX+TABCOL,
     &            YMIN-0.01*DELTAY,YMAX+0.01*DELTAX,1,-2)

      CALL INICOL (NBCOL)

C- On inverse noir et blanc
      CALL PGSCRN (0,'White',IBIDON)
      CALL PGSCRN (NBCOL+1,'Black',IBIDON)

C- On retrouve grosso-modo la meme chose que dans grame.f
      IF (NBFEN.GT.1) CALL MULFEN (NBFEN)
      CALL  DESSIN (NBFIMX,NBLMAX,NBFICH,COMBIN,NBFEN,NUMREP,MAILLA,
     &              ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,N,
     &              NBEL,NBCOL,PASCOL,TABCOL,AXES,LABEL,VALPRJ)
      CALL PGASK (.FALSE.)
      CALL PGCLOS ()

C- On avertit quand c'est fini
      CALL BIP ()
      END


      
