      PROGRAM GRAME

C- Representation GRAphique de fichiers de sorties MElina
C-
C- Auteur : Pascal GENTIL
C-
C- Derniere modif : 3 JUL 2001
C-
C- Constantes
C-    NBBUTN Nombre de boutons du menu
      INTEGER NBBUTN
      PARAMETER (NBBUTN = 25)
C-    NBFIMX : Nombre maximum de fichiers           
      INTEGER NBFIMX
      PARAMETER (NBFIMX = 9)
C-    NBLMAX : Nombre maximum d'elements
      INTEGER NBLMAX 
      PARAMETER (NBLMAX = 100000)
C-
C- Variables
C-    ACTIFS : Choix actifs ou non
      LOGICAL ACTIFS(NBBUTN)
C-    ARETES : Tableau contenant le debut et la fin des aretes.
      INTEGER ARETES (NBLMAX)
C-    AXES : Traces ou non des axes
      LOGICAL AXES
C-    CHOSOU : Fonction renvoyant X et Y du mulot
      INTEGER CHOSOU
C-    CLIC : Valeur du clic du mulot
      INTEGER CLIC
C-    COMBIN : Combinaison des fichiers
      LOGICAL COMBIN
C-    DELTAX, DELTAY : LArgeur (XMAX-XMIN) et hauteur (YMAX-YMIN) reels
      REAL DELTAX,DELTAY
C-    ENTREE : Repertoire contenant les fichiers de donnees
      CHARACTER*80 ENTREE
C-    EXISTE : Existence de fichiers
      LOGICAL EXISTE
C-    FENDES : Unite PGPLOT associe a la fenetre de dessins
      INTEGER FENDES
C-    FENMEN : Unite PGPLOT associe a la fenetre de menu
      INTEGER FENMEN
C-    FICHGE : Nom du(es) fichier(s) de geometrie 
      CHARACTER*80 FICHGE(NBFIMX)
C-    FICHRE : Nom du(es) fichier(s) de resultats
      CHARACTER*80 FICHRE(NBFIMX)
C-    HAUMAX,LARMAX : Hauteur et largeur max d'une fenetre. Depend de l'ecran
      REAL HAUMAX,LARMAX
C-    IFICH : Indice de fichiers
      INTEGER IFICH
C-    LABEL : Labels i.e commentaires des dessins
      CHARACTER*80 LABEL(NBFIMX)
C-    LARTRA : Largeur du trace en NUMREP=2
      INTEGER LARTRA
C-    MAILLA : Maillage ou non
      LOGICAL MAILLA
C-    N : Tableau contenant les noeuds
      INTEGER N(NBFIMX,NBLMAX,3)
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
      INTEGER NBCOL
C-    NBEL : Nombre d'elements
      INTEGER NBEL(NBFIMX)
C-    NBFEN : Nombre de fenetres
      INTEGER NBFEN
C-    NBFICH : Nombre de fichiers
      INTEGER NBFICH
C-    NBPTS : Nombre de points
      INTEGER NBPTS(NBFIMX)
C-    NOMFIC : Nom du(es) fichier(s)
      CHARACTER*80 NOMFIC(NBFIMX)
C-    NUMREP : Type de representation
C-       1 : Maillage
C-       2 : Isovaleurs en lignes en couleurs moyennes 
C-       3 : Isovaleurs planes en couleurs reelles.
C-       4 : Isovaleurs en elevations
      INTEGER NUMREP
C-    PASCOL : DeltaZ correspondant a un changement de couleur
      REAL PASCOL
C-    PGOPEN : Fonction PGPLOT d'ouverture
      INTEGER PGOPEN  
C-    SORTIE : Repertoire contenant les fichiers de sorties
      CHARACTER*80 SORTIE
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
      REAL TABCOL
C-    TYPE : Type de maillage [P=Triangle, Q=Quadrangle, 1 ou 2]
      CHARACTER*8 TYPE(NBFIMX)
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
      REAL VALPRJ(7)
C-    X,Y,Z : Tableaux des coordonnees des noeuds 
      REAL X(NBFIMX,NBLMAX),Y(NBFIMX,NBLMAX),Z(NBFIMX,NBLMAX)
C-    XBUTON,YBUTON :  Coordonnees X et Y des boutons
      REAL XBUTON(NBBUTN),YBUTON(NBBUTN)
C-    XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y,Z
      REAL XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX

C- Initialisations 
      DATA AXES / .TRUE. /
      DATA COMBIN / .FALSE. /
      DATA LARMAX,HAUMAX / 11.0, 9.0 /
      DATA LARTRA / 1 /
      DATA MAILLA / .TRUE. /
      DATA NBCOL / 32 /
      DATA NUMREP / 1 /
      DATA XBUTON / 9*0.5,2.5,4.5,6.8,0.5,7.5,0.5,7.5,0.5,7.5,
     &              0.5,7.5,0.5,7.5,0.5,7.5,0.5 /
      DATA YBUTON / 22.0,21.0,20.0,19.0,16.0,15.0,14.0,13.0,
     &              10.0,10.0,10.0,10.0,9.0,9.0,8.0,8.0,5.0,
     &              5.0,4.0,4.0,3.0,3.0,2.0,2.0, 1.0 /
      DATA XMIN,YMIN,ZMIN / 3*1.E30 /
      DATA XMAX,YMAX,ZMAX / 3*-1.E30 /

C------------------------------------------------------------------------------

C- NB : TOUS les fichiers sont ouverts avec l'unite logique 21 puisque
C- il n'y en a jamais plus de 1 ouvert a la fois

C- Presentation
      CALL TITRE ()

C- ENTREE et SORTIE sont-ils biens definis ?
      INQUIRE (FILE='./grame.cfg', EXIST=EXISTE)
      IF (.NOT.EXISTE) THEN
         CALL BLEME (1)
         ENTREE='./'
         SORTIE='./'
      ELSE
         OPEN (21,FILE='./grame.cfg')
         READ (21,1001) ENTREE
         INQUIRE (FILE=ENTREE, EXIST=EXISTE)
         IF (.NOT.EXISTE) CALL BLEME (2)
         READ (21,1001) SORTIE
         INQUIRE (FILE=SORTIE, EXIST=EXISTE)
         IF (.NOT.EXISTE) CALL BLEME (3)
         CLOSE (21)
      ENDIF

C- Entree des donnees (nom des fichiers,couleurs,label et nombre de fenetres)
      CALL ENTDON (NBFIMX,NBFICH,FICHGE,FICHRE,NOMFIC,ENTREE,COMBIN,
     &             LABEL)

C- On lit le nombre de points, le nombre d'elements, les X,Y et les noeuds
C- dans le(s) fichier(s) de geometrie puis les Z dans le(s) fichier(s) de 
C- resultats
      DO 10 IFICH=1,NBFICH 
         OPEN (21,FILE=FICHGE(IFICH),STATUS='OLD')
         CALL LIRGEO (NBLMAX,NBFIMX,IFICH,TYPE,NBPTS,NBEL,X,Y,XMIN,XMAX,
     &                YMIN,YMAX,N)
         CLOSE (21) 
         OPEN (21,FILE=FICHRE(IFICH),STATUS='OLD')
         CALL LIRRES (NBFIMX,IFICH,NBPTS,Z,ZMIN,ZMAX)
         CLOSE (21)
10    CONTINUE

C- Ouverture de l'ecran, taille et forme de la fenetre ecran
      FENDES=PGOPEN('/xwin')
      IF (FENDES.LT.0) CALL BLEME (13)
      CALL PGASK (.FALSE.)
      CALL PGPAP (LARMAX,HAUMAX/LARMAX)
   
C- On pose la bande de couleur a droite du dessin
      DELTAX=XMAX-XMIN
      DELTAY=YMAX-YMIN

C- On augmente en X et en Y de 1/100 du deltaX/deltaY pour bien tracer 
C- les triangles qui sont sur la limite. On "elargit" de TABCOL
C- pour representer la barre de couleurs a droite
      TABCOL=(XMAX-XMIN)/10
      CALL PGENV (XMIN-0.01*DELTAX,XMAX+0.01*DELTAX+TABCOL,
     &            YMIN-0.01*DELTAY,YMAX+0.01*DELTAX,1,-2)

C- On charge le tableau de couleurs
      CALL INICOL (NBCOL)

C- On calcule le pas d'avance d'une couleur
      PASCOL=(ZMAX-ZMIN)/NBCOL

C- On prepare le multifenetrage eventuel
C- Par defaut, mono-fenetrage si un seul fichier ou COMBIN
C- sinon NBFEN=NBFICH
      IF (NBFICH.EQ.1.OR.COMBIN) THEN
         NBFEN=1
      ELSE
         NBFEN=NBFICH
         CALL MULFEN (NBFEN)
      ENDIF

C- Valeurs des variables de projection spherique
      CALL INIPRJ (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,VALPRJ)

C- Definition des boutons actifs 
      CALL DEFACT (NBBUTN,NUMREP,NBFICH,COMBIN,NBFEN,ACTIFS)

C- Ouverture de la fenetre de menu
      CALL INIMEN (FENMEN)
      CALL MENU (NBBUTN,YBUTON,NBFEN,NUMREP,ACTIFS,FENMEN,FENDES)

C- On choisit de representer a priori NUMREP=1
      NUMREP=1
      GOTO 30

C- Ya ka cliquer sur le mulot ((c) J.Ch)
20    CLIC=CHOSOU (NBBUTN,XBUTON,YBUTON,NUMREP,NBFICH,COMBIN,NBFEN,
     &             ACTIFS,NBCOL,FENMEN,FENDES)

C- Si sortie fichier
      IF (CLIC.EQ.7) THEN
         CALL FICSOR (NBFIMX,NBLMAX,NBFICH,COMBIN,NBFEN,NUMREP,MAILLA,
     &                ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,
     &                DELTAX,DELTAY,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &                FICHRE,ENTREE,SORTIE,LABEL,VALPRJ)
C- Si CLIC=8 on quitte
      ELSEIF (CLIC.EQ.8) THEN
         GOTO 999    
      ELSE
C- Sinon, on redefinit un certain nombre de variables en fonction du choix
         CALL DEFCHO (CLIC,NBCOL,NUMREP,MAILLA,ZMIN,ZMAX,PASCOL,LARTRA,
     &                NBFEN,VALPRJ,AXES)
      ENDIF

C- On recalcule les actifs et on regenere le menu
30    CALL DEFACT (NBBUTN,NUMREP,NBFICH,COMBIN,NBFEN,ACTIFS)
      CALL MENU (NBBUTN,YBUTON,NBFEN,NUMREP,ACTIFS,FENMEN,FENDES)

C- Enfin, on represente le tout
      CALL  DESSIN (NBFIMX,NBLMAX,NBFICH,COMBIN,NBFEN,NUMREP,MAILLA,
     &              ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,N,
     &              NBEL,NBCOL,PASCOL,TABCOL,AXES,LABEL,VALPRJ)

C- Et on repart pour un tour
      GOTO 20
  
C- Fin 
999   CALL PGCLOS ()

1001  FORMAT (A)
      END 
