      SUBROUTINE INIPRJ (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,VALPRJ)

C- Fonction : Calcul des parametres necessaires a la projection choisie
C-            Ici : Projection spherique
C-
C- Biblio :"Calcul des parties cachees", R.Dony, Masson, p18-20
C-
C- Entree :
C-    XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y
C-
C- Sortie :
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Local :
C-    XYZMIN : min(xmin,ymin,zmin)
C-    XYZMAX : max(xmax,ymax,zmax)
C-
C- Derniere modif : 20 JUN 2000

      REAL XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,VALPRJ(*),XYZMIN,XYZMAX

C- On pose :
C-   VALPRJ(1)=Valeur de depart des angles et de leur variation
C-             On initialise a 30 degres soit 0.52359 rad.
C-   VALPRJ(2)=RHO
C-   VALPRJ(3)=PHI 
C-   VALPRJ(4)=THETA : id
C-   VALPRJ(5)=distance de l'observateur
C-   VALPRJ(6) et VALPRJ(7) servent a centrer la projection.
C-   On ajoute la moitie de deltax et de deltay


      XYZMIN=MIN(XMIN,YMIN,ZMIN)
      XYZMAX=MAX(XMAX,YMAX,ZMAX)

      VALPRJ(1) = 0.52359
      VALPRJ(2) = 5*(XYZMAX-XYZMIN)
      VALPRJ(3) = VALPRJ(1)
      VALPRJ(4) = VALPRJ(1)
      VALPRJ(5) = 2*(XYZMAX-XYZMIN)
      VALPRJ(6)= (XMAX+XMIN)/2
      VALPRJ(7)= (YMAX+YMIN)/2

      END
