      SUBROUTINE LIRCHN (X,Y,CHAINE,LONCHN)
 
C- Fonction : Lire une chaine de caractere dans une fenetre graphique
C-
C- Entree :
C-    X,Y : Position de depart de l'ecriture de la chaine
C-
C- Sortie :
C-    CHAINE : Chaine de caractere ecrite dans la fenetre
C-    LONCHN : Longueur de la chaine
C-
C- Local :
C-    XCUR,YCUR : Position du curseur
C-    LONCHN    : Longueur reelle de la chaine 
C-    CHNMAX    : Longueur max de chaine
C-    NCH       : Code ASCII du caractere CH
C-    CH        : Caractere lu
C-
C- Derniere modif : 16 AVR 1999
C-
C- Notes :
C-   - On efface par Backspace ou Delete
C-   - On efface toute la ligne par Ctrl-U ou Ctrl-K
C-   - Cette routine est largement inspiree de PGRSTR
C-     fournie dans pgdemo14.f

      REAL X,Y,XCUR,YCUR
      CHARACTER*(*) CHAINE
      INTEGER LONCHN,BIDON,PGBAND,CHNMAX,NCH
      CHARACTER CH

      CHNMAX=LEN(CHAINE)
      LONCHN=0 
      CHAINE=' '

10    CONTINUE
C- Lecture d'un caractere
C-  PGBAND : lit la position du curseur en [X,Y] et le caractere
C-           tape [CH]
      IF (LONCHN.GT.0) CALL PGPTXT (X,Y,0.0,0.0,CHAINE(1:LONCHN))
      BIDON = PGBAND(0,1,XCUR,YCUR,XCUR,YCUR,CH)
      NCH=ICHAR(CH)

C- Effacement de l'ancien texte
      CALL PGSCI(0)
      IF (LONCHN.GT.0) CALL PGPTXT (X,Y,0.0,0.0,CHAINE(1:LONCHN))
      CALL PGSCI(1)

C--- Avoid problem with PGPLOT escape character [sic]
      IF (CH.EQ.CHAR(92)) CH = '*'

C- Backspace (ctrl H) ou  Delete efface le dernier caractere
      IF (NCH.EQ.8.OR.NCH.EQ.127) THEN
         IF (LONCHN.GT.0) THEN
            CHAINE(LONCHN:LONCHN) = ' '
            LONCHN = LONCHN-1
         ENDIF   
C- Ctrl K et Ctrl U efface tout le texte
      ELSEIF (NCH.EQ.11.OR.NCH.EQ.21) THEN
         CHAINE(1:LONCHN) = ' '
         LONCHN = 0
C- N'importe quel autre caractere ASCII < 32 termine l'entree
      ELSEIF (NCH.LT.32) THEN
         IF (LONCHN.GT.0) CALL PGPTXT(X,Y,0.0,0.0,CHAINE(1:LONCHN))
         RETURN
C- Sinon, on ajoute le caractere CH a CHAINE tant qu'il y as de la place
      ELSEIF (LONCHN.LT.CHNMAX) THEN
         LONCHN = LONCHN+1
         CHAINE(LONCHN:LONCHN) = CH
      END IF
      GOTO 10

      END
