      SUBROUTINE LIRGEO (NBLMAX,NBFIMX,IFICH,TYPE,NBPTS,NBEL,X,Y,XMIN,
     &                   XMAX,YMIN,YMAX,N)

C- Fonction : Lecture du fichier de geometrie FICHGE(IFICH) 
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    NBFIMX : Nombre maximum de fichiers  
C-    IFICH : Indice de fichiers
C-
C- Sortie :
C-    TYPE : Type de maillage [P=Triangle, Q=Quadrangle, 1 ou 2] 
C-    NBPTS : Nombre de points
C-    NBEL : Nombre d'elements
C-    X,Y : Sommets du maillage
C-    XMIN,XMAX,YMIN,YMAX : Min et max des X,Y
C-    N : Tableau contenant les noeuds
C-
C- Local :
C-    M1,M2  : Champs vides dans la lecture
C-    MULTEL : Mutilple du nombre de noeuds selon l'ordre
C-    NBNOEU : Nombre de noeuds
C-    NL     : Noeuds lus
C-    NORDRE : Est-on en [P/Q]1 ou 2 ou 3 ou ...
C-    TRIQUA : Est-on en triangle (P) ou quadrangle (Q)
C-
C-
C- Derniere modif : 14 AVR 2000

      INTEGER NBLMAX,NBFIMX,IFICH,NBPTS(*),NBEL(*),N(NBFIMX,NBLMAX,*)
      INTEGER I,J,K,NL(25),NORDRE,NBNOEU,MULTEL
      REAL X(NBFIMX,*),Y(NBFIMX,*),XMIN,XMAX,YMIN,YMAX
      CHARACTER*8 TYPE(*)
      LOGICAL TRIQUA
      CHARACTER*80 LIGNE

C- On saute les 2 premieres lignes
      DO 10 I=1,2
10    READ (21,1001)
C- 3eme ligne on lit le TYPE i.e 1(2)D et P(Q)1(2)
      READ (21,1001) TYPE(IFICH)
      I=INDEX(TYPE(IFICH),'D')
C- Triangle ou quadrangle, ordre 1, 2 ou 3
      IF (TYPE(IFICH)(I+3:I+3).EQ.'P') THEN
         TRIQUA = .TRUE.
      ELSEIF (TYPE(IFICH)(I+3:I+3).EQ.'Q') THEN
         TRIQUA = .FALSE.
      ELSE
         CALL BLEME (6)
      ENDIF
      NORDRE=ICHAR(TYPE(IFICH)(I+4:I+4))-48
      IF (NORDRE.LT.1.OR.NORDRE.GT.3) CALL BLEME (7)
C- 4eme ligne : NBPTS et NBEL
      READ (21,1001) LIGNE
      CALL DECLIG (LIGNE,NBPTS(IFICH),NBEL(IFICH))
      IF (NBEL(IFICH).GT.NBLMAX) CALL BLEME (10)
      READ (21,1001) 

C- On lit les X et Y et on calcule X et Y min et max pour *l'ensemble* 
C- des fichiers
      DO 20 I=1,NBPTS(IFICH)
         READ (21,*) X(IFICH,I), Y(IFICH,I)
         XMIN = MIN(XMIN,X(IFICH,I))
         XMAX = MAX(XMAX,X(IFICH,I))
         YMIN = MIN(YMIN,Y(IFICH,I))
         YMAX = MAX(YMAX,Y(IFICH,I))
20    CONTINUE

C- On saute la ligne NUMEL
      READ (21,1001)

C- On lit les noeuds
      IF (.NOT.TRIQUA) GOTO 500

C- Triangles
C- Nombre de noeuds
      NBNOEU=((NORDRE+1)*(NORDRE+2))/2
      MULTEL=NORDRE*NORDRE
      GOTO (30,50,70) NORDRE

C- Cas P1
30    DO 40 I=1,NBEL(IFICH)
40    READ (21,*) (N(IFICH,I,J),J=1,NBNOEU)
      K=NBEL(IFICH)
      GOTO 1000

C- Cas P2     
50    K=0
      DO 60 I=1,NBEL(IFICH)
         READ (21,*) (NL(J),J=1,NBNOEU)
         N(IFICH,K+1,1)=NL(1)
         N(IFICH,K+1,2)=NL(4)
         N(IFICH,K+1,3)=NL(6)
         N(IFICH,K+2,1)=NL(4)
         N(IFICH,K+2,2)=NL(2)
         N(IFICH,K+2,3)=NL(5)
         N(IFICH,K+3,1)=NL(4)
         N(IFICH,K+3,2)=NL(5)
         N(IFICH,K+3,3)=NL(6)
         N(IFICH,K+4,1)=NL(6)
         N(IFICH,K+4,2)=NL(5)
         N(IFICH,K+4,3)=NL(3)
         K=K+MULTEL
60    CONTINUE
      GOTO 1000

C- Cas P3
70    K=0
      DO 80 I=1,NBEL(IFICH)
         READ (21,*) (NL(J),J=1,NBNOEU)
         N(IFICH,K+1,1)=NL(1)
         N(IFICH,K+1,2)=NL(4)
         N(IFICH,K+1,3)=NL(9)
         N(IFICH,K+2,1)=NL(4)
         N(IFICH,K+2,2)=NL(7)
         N(IFICH,K+2,3)=NL(10)
         N(IFICH,K+3,1)=NL(7)
         N(IFICH,K+3,2)=NL(2)
         N(IFICH,K+3,3)=NL(5)
         N(IFICH,K+4,1)=NL(9)
         N(IFICH,K+4,2)=NL(4)
         N(IFICH,K+4,3)=NL(10)
         N(IFICH,K+5,1)=NL(10)
         N(IFICH,K+5,2)=NL(7)
         N(IFICH,K+5,3)=NL(5)
         N(IFICH,K+6,1)=NL(9)
         N(IFICH,K+6,2)=NL(10)
         N(IFICH,K+6,3)=NL(6)
         N(IFICH,K+7,1)=NL(10)
         N(IFICH,K+7,2)=NL(5)
         N(IFICH,K+7,3)=NL(8)
         N(IFICH,K+8,1)=NL(6)
         N(IFICH,K+8,2)=NL(10)
         N(IFICH,K+8,3)=NL(8)
         N(IFICH,K+9,1)=NL(6)
         N(IFICH,K+9,2)=NL(8)
         N(IFICH,K+9,3)=NL(3)
         K=K+MULTEL
80    CONTINUE
      GOTO 1000

C- On garde des etiquettes en vue de definir ordre 4,5,...

C- Quadrangles
500   NBNOEU=(NORDRE+1)*(NORDRE+1)
      MULTEL=2*NORDRE*NORDRE
      GOTO (510,530,550) NORDRE

C- Cas Q1
510   K=0
      DO 520 I=1,NBEL(IFICH)
         READ(21,*) (NL(J),J=1,NBNOEU)
         N(IFICH,K+1,1)=NL(1)
         N(IFICH,K+1,2)=NL(2)
         N(IFICH,K+1,3)=NL(3)
         N(IFICH,K+2,1)=NL(1)
         N(IFICH,K+2,2)=NL(3)
         N(IFICH,K+2,3)=NL(4)
         K=K+MULTEL
520   CONTINUE
      GOTO 1000

C- Cas Q2
530   K=0
      DO 540 I=1,NBEL(IFICH)
         READ(21,*) (NL(J),J=1,NBNOEU)
         N(IFICH,K+1,1)=NL(1)   
         N(IFICH,K+1,2)=NL(5)   
         N(IFICH,K+1,3)=NL(9)   
         N(IFICH,K+2,1)=NL(1)   
         N(IFICH,K+2,2)=NL(9)   
         N(IFICH,K+2,3)=NL(8)   
         N(IFICH,K+3,1)=NL(8)   
         N(IFICH,K+3,2)=NL(9)   
         N(IFICH,K+3,3)=NL(7)   
         N(IFICH,K+4,1)=NL(8)   
         N(IFICH,K+4,2)=NL(7)   
         N(IFICH,K+4,3)=NL(4)   
         N(IFICH,K+5,1)=NL(5)   
         N(IFICH,K+5,2)=NL(2)   
         N(IFICH,K+5,3)=NL(6)   
         N(IFICH,K+6,1)=NL(5)   
         N(IFICH,K+6,2)=NL(6)   
         N(IFICH,K+6,3)=NL(9)   
         N(IFICH,K+7,1)=NL(9)   
         N(IFICH,K+7,2)=NL(6)   
         N(IFICH,K+7,3)=NL(3)   
         N(IFICH,K+8,1)=NL(9)   
         N(IFICH,K+8,2)=NL(3)   
         N(IFICH,K+8,3)=NL(7)   
         K=K+MULTEL   
540   CONTINUE
      GOTO 1000

C- Cas Q3
550   K=0
      DO 560 I=1,NBEL(IFICH)
         READ(21,*) (NL(J),J=1,NBNOEU)
         N(IFICH,K+1,1)=NL(1)
         N(IFICH,K+1,2)=NL(5)
         N(IFICH,K+1,3)=NL(12)
         N(IFICH,K+2,1)=NL(5)
         N(IFICH,K+2,2)=NL(13)
         N(IFICH,K+2,3)=NL(12)
         N(IFICH,K+3,1)=NL(5)
         N(IFICH,K+3,2)=NL(9)
         N(IFICH,K+3,3)=NL(13)
         N(IFICH,K+4,1)=NL(9)
         N(IFICH,K+4,2)=NL(14)
         N(IFICH,K+4,3)=NL(13)
         N(IFICH,K+5,1)=NL(9)
         N(IFICH,K+5,2)=NL(2)
         N(IFICH,K+5,3)=NL(14)
         N(IFICH,K+6,1)=NL(2)
         N(IFICH,K+6,2)=NL(6)
         N(IFICH,K+6,3)=NL(14)
         N(IFICH,K+7,1)=NL(12)
         N(IFICH,K+7,2)=NL(13)
         N(IFICH,K+7,3)=NL(8)
         N(IFICH,K+8,1)=NL(13)
         N(IFICH,K+8,2)=NL(16)
         N(IFICH,K+8,3)=NL(8)
         N(IFICH,K+9,1)=NL(13)
         N(IFICH,K+9,2)=NL(14)
         N(IFICH,K+9,3)=NL(16)
         N(IFICH,K+10,1)=NL(14)
         N(IFICH,K+10,2)=NL(15)
         N(IFICH,K+10,3)=NL(16)
         N(IFICH,K+11,1)=NL(14)
         N(IFICH,K+11,2)=NL(6)
         N(IFICH,K+11,3)=NL(15)
         N(IFICH,K+12,1)=NL(6)
         N(IFICH,K+12,2)=NL(10)
         N(IFICH,K+12,3)=NL(15)
         N(IFICH,K+13,1)=NL(8)
         N(IFICH,K+13,2)=NL(16)
         N(IFICH,K+13,3)=NL(4)
         N(IFICH,K+14,1)=NL(16)
         N(IFICH,K+14,2)=NL(11)
         N(IFICH,K+14,3)=NL(4)
         N(IFICH,K+15,1)=NL(16)
         N(IFICH,K+15,2)=NL(15)
         N(IFICH,K+15,3)=NL(11)
         N(IFICH,K+16,1)=NL(15)
         N(IFICH,K+16,2)=NL(7)
         N(IFICH,K+16,3)=NL(11)
         N(IFICH,K+17,1)=NL(15)
         N(IFICH,K+17,2)=NL(10)
         N(IFICH,K+17,3)=NL(7)
         N(IFICH,K+18,1)=NL(10)
         N(IFICH,K+18,2)=NL(3)
         N(IFICH,K+18,3)=NL(7)
         K=K+MULTEL
560   CONTINUE


C- Dans *tous* les cas  
C- On a donc MULTEL fois + de triangles que NBEL
1000  IF (K.NE.MULTEL*NBEL(IFICH)) THEN
         CALL BLEME (11)
      ELSE
         NBEL(IFICH) = K
      ENDIF

1001  FORMAT (A)

      END
