*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELCRE (IMAGE,NOMBRE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 2000)
* Derniere modification : D.Martin (31 Mai 2000)
* Version  1.0.0
*  
* Reconnaissance de nombres reels sous forme de chaine de caracteres ASCII
* La chaine en entree est de la forme
*                          [+-]iii.ddd[E/D][+-]eee
* ou iii, ddd et eee sont des chaines representant des entiers
* (eventuellement vides)
*
*-- Arguments --
* IMAGE  chaine de caracteres a reconnaitre
* NOMBRE valeur du reel DOUBLE PRECISION reconnu en sortie
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER IMAGE*(*)
      DOUBLE PRECISION NOMBRE
*
      INTEGER   NRANMX,NRAN,NFIX,MFIX,NBCHIF,NBDECI,IEXP,NLU,MAXENT
      CHARACTER CHNEXT,SIGNE,SIGNEX
      DOUBLEPRECISION DP,EPSI,DIX
      DATA      EPSI/3.D-16/,DIX/1.D+01/,MAXENT/2147483647/
*-----------------------------------------------------------------------
      NOMBRE=0.D0
      NRANMX=LEN (IMAGE)
      DO 123 NRANMX=LEN(IMAGE),1,-1
         IF (IMAGE(NRANMX:NRANMX).NE.' ') GOTO 124
123   CONTINUE
124   NRAN=1
      CHNEXT=IMAGE(NRAN:NRAN)
      SIGNE =CHNEXT
      NFIX=0
*-    Nombre de chiffre de la mantisse : 
      NBCHIF=0 
*-    Nombre de chiffres decimaux de la mantisse (apres un . ou une ,) : 
      NBDECI=-1
*-    Valeur de l'exposant du nombre reel:
      IEXP=0
*--   Lecture de la mantisse
      IF (CHNEXT.NE.'-'.AND.CHNEXT.NE.'+') GOTO 3  
2     IF (NRAN+1.GT.NRANMX) GOTO 5
      NRAN =NRAN+1 
      CHNEXT=IMAGE(NRAN:NRAN)
3     NLU = 1
*
      IF (LGE(CHNEXT,'0').AND.LLE(CHNEXT,'9')) THEN
*        Le caractere est un chiffre de valeur NLU
         NLU=ICHAR (CHNEXT)-48
         NBCHIF=NBCHIF+1  
         IF (NBDECI.GE.0) NBDECI=NBDECI+1  
         IF (NBCHIF.LT.10) THEN
            NFIX=NLU+10*NFIX 
         ELSEIF (NBCHIF.EQ.10) THEN
            MFIX=NFIX
            NFIX=NLU 
         ELSE 
            IF (NBCHIF.LT.19) THEN
               NFIX=NLU+10*NFIX 
            ELSE 
               IF (NBDECI.LT.0) THEN
                  IEXP=IEXP+1  
               ELSE
                  NBDECI=NBDECI-1 
               ENDIF 
            ENDIF
         ENDIF
         GOTO 2
      ELSEIF (CHNEXT.EQ.'+'.OR.CHNEXT.EQ.'-') THEN
*        Le caractere est + ou -
         GOTO 12
      ELSEIF (CHNEXT.EQ.'.'.OR.CHNEXT.EQ.',') THEN
*        Le caractere est . ou ,
         IF (NBDECI.GE.0) RETURN
         NBDECI=0
         GOTO 2
      ELSEIF (CHNEXT.EQ.'D'.OR.CHNEXT.EQ.'E') THEN
         GOTO 12
      ENDIF
      RETURN 
5     IF (NBDECI.GE.0.OR.NBCHIF.GT.9) GOTO 12
* 
*--    On a lu un ENTIER 
*
      IF (SIGNE.EQ.'-') NFIX=-NFIX  
      NOMBRE=NFIX
      RETURN
*
*--    On a lu un REEL
*  
*     Prise en compte de la mantisse du reel
12    SIGNEX=' '  
      NOMBRE=NFIX
      NFIX=0
      IF (NBCHIF.GE.10) THEN
         DP=MFIX  
         IF (NBCHIF.GT.18) NBCHIF=18
         NOMBRE=NOMBRE+DP*DIX**(NBCHIF-9)
      ENDIF 
      NOMBRE=NOMBRE*(1.D0+EPSI)
*     Lecture de l'exposant 
      IF (NBDECI.LT.0) NBDECI=0 
      IEXP=IEXP-NBDECI 
      NLU = 1
      IF (CHNEXT.EQ.'+'.OR.CHNEXT.EQ.'-') THEN
         SIGNEX=CHNEXT
      ELSEIF (LGE(CHNEXT,'0').AND.LLE(CHNEXT,'9')) THEN
*        Le caractere est un chiffre de valeur NLU
         NLU=ICHAR (CHNEXT)-48
         GOTO 13
      ENDIF
13    IF (NRAN+1.LE.NRANMX) THEN
         NRAN =NRAN+1
         CHNEXT=IMAGE(NRAN:NRAN)
         NLU = 1
         IF (LGE(CHNEXT,'0').AND.LLE(CHNEXT,'9')) THEN
            NLU=ICHAR (CHNEXT)-48
            NFIX=NLU+10*NFIX 
            GOTO 13
         ELSEIF (CHNEXT.EQ.'+'.OR.CHNEXT.EQ.'-') THEN
            IF (SIGNEX.NE.' ') RETURN
            SIGNEX=CHNEXT
            GOTO 13
         ENDIF 
      ENDIF
19    IF (SIGNEX.EQ.'-') NFIX=-NFIX
      IEXP=IEXP+NFIX
      NOMBRE=NOMBRE*DIX**IEXP
*
*     Prise en compte du signe des reels
*
20    IF (NOMBRE.LT.0) THEN
          NOMBRE=-NOMBRE
          SIGNE='-'
      ENDIF
      IF (NOMBRE.GT.MAXENT*1.D0) THEN
          NFIX=MAXENT
      ELSE 
          NFIX=INT(NOMBRE)
      ENDIF
      IF (SIGNE.EQ.'-') THEN
         NOMBRE=-NOMBRE
         NFIX=-NFIX
      ENDIF
      END

