      SUBROUTINE REPCOL (YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,TABCOL)

C- Fonction : Representation des couleurs
C-
C- Entree :
C-    XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y,Z
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-
C- Sortie : -
C-
C- Local :
C-    XTABMN : X min du rectangle de couleurs
C-    XTABMX : X max du rectangle de couleurs
C-    TEXT   : Valeurs des couleurs en texte
C-    DELTAY : Ecart en Y entre les textes 
C-    DELTAZ : Ecart entre les couleurs texte
C-    LZMIN,LZMAX : Valeurs de ZMIN et ZMAX pour affichage
C-    EXPOS  : exposant servant a l'affichage des ZMAX et ZMIN
C-    CHAINE : Sert a ecrire les valeurs de Z et de EXPOS
C-
C- Derniere modif : 29 NOV 2000

      REAL YMIN,ZMIN,XMAX,YMAX,ZMAX,TABCOL
      REAL XTABMN,XTABMX,TEXT,DELTAY,DELTAZ
      INTEGER NBCOL,I
      CHARACTER*8 CHAINE

C- Rappel de l'ouverture
C- On a un vieport de XMAX,XMAX+TABCOL
      XTABMN=XMAX+0.45*TABCOL
      XTABMX=XMAX+1.05*TABCOL
      TEXT=XMAX+1.2*TABCOL
      DELTAY=(YMAX-YMIN)/ NBCOL
      CALL PGSFS (1)
      DO 10 I=1,NBCOL
         CALL PGSCI (I)
         CALL PGRECT (XTABMN,XTABMX,YMIN+DELTAY*(I-1),YMIN+DELTAY*I)
10    CONTINUE

C- Cadre entourant le tableau de couleurs
      CALL PGSLS (1)
      CALL PGSFS (2)
      CALL PGSCI (NBCOL+1)      
      CALL PGRECT (XTABMN,XTABMX,YMIN,YMAX)

C- Valeurs LZMIN a ZMAX avec 7 intermediaires
      DELTAZ=(ZMAX-ZMIN)/8.0
      DELTAY=(YMAX-YMIN)/8.0

C- On diminue un peu la taille des caracteres
      CALL PGSCH (5*DELTAY)

C- Pour faire plus joli on remonte un poil ZMIN et on redescend ZMAX
      CALL RL2CHN (ZMIN,CHAINE)
      CALL PGTEXT (TEXT,YMIN+DELTAY/16.0,CHAINE)
      CALL RL2CHN (ZMAX,CHAINE)      
      CALL PGTEXT (TEXT,YMAX-DELTAY/8.0,CHAINE)

C- Valeurs zintermediaires       
      DO 40 I=1,7
         CALL RL2CHN (ZMIN+I*DELTAZ,CHAINE)
         CALL PGTEXT (TEXT,YMIN+I*DELTAY,CHAINE)
40    CONTINUE

      END

