      SUBROUTINE REPFIC (NBFIMX,NBLMAX,IFICH,COMBIN,NUMREP,MAILLA,
     &                   ARETES,LARTRA,X,Y,Z,XMIN,YMIN,ZMIN,XMAX,YMAX,
     &                   ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,LABEL,
     &                   VALPRJ)

C- Fonction : Representation complete du fichier IFICH dans le type NUMREP
C-            plus le tableau couleur, le label et [eventuellment] les axes
C-
C- Entree :
C-    NBFIMX : Nombre maximum de fichiers   
C-    NBLMAX : Nombre maximum d'elements
C-    IFICH  : Indice de fichiers
C-    COMBIN : Combinaison des fichiers
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    LARTRA : Largeur du trace en NUMREP=2
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    XMIN,YMIN,ZMIN : Min des X,Y,Z
C-    XMAX,YMAX,ZMAX : Max des X,Y,Z
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-    AXES   : Traces ou non des axes
C-    LABEL  : Labels i.e commentaires des dessins
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Derniere modif : 29 NOV 2000
C-
      INTEGER NBFIMX,NBLMAX,IFICH,NUMREP,ARETES(*),LARTRA
      INTEGER N(NBFIMX,NBLMAX,*),NBEL(*),NBCOL
      REAL X(NBFIMX,*),Y(NBFIMX,*),Z(NBFIMX,*),XMIN,YMIN,ZMIN,XMAX,YMAX
      REAL ZMAX,PASCOL,TABCOL,VALPRJ(*)
      LOGICAL COMBIN,MAILLA,AXES
      CHARACTER*80 LABEL(NBFIMX)


C- Axes en 3D avant le dessin sinon c'est pas beau 
C- Une seule fois a tracer si COMBIN 
      IF (NUMREP.EQ.4.AND.AXES.AND.(IFICH.EQ.1.OR..NOT.COMBIN)) 
     &   CALL TRAXES (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,VALPRJ)

C- On dessine
      CALL DESFIC (NBFIMX,NBLMAX,IFICH,NUMREP,MAILLA,ARETES,LARTRA,X,Y,
     &             Z,ZMIN,N,NBEL,NBCOL,PASCOL,VALPRJ)

C- Tableau de couleurs
      IF (NUMREP.GT.1) CALL REPCOL (YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,
     &                              TABCOL)
     
C- Ecriture du label
C- NB : PGLAB n'est pas suffisant. On utilise PGMTXT
C- On n'ecrit que le premier si on a COMBIN
      IF (IFICH.EQ.1.OR..NOT.COMBIN) THEN
         CALL PGSCF (1)
         CALL PGSCH (1.0)
C- 2.0 : hauteur du texte au-dessus du viewport en unite hauteur de caractere
         CALL PGMTXT ('T',1.5,0.5,0.5,LABEL(IFICH))
      ENDIF

      END 
