      SUBROUTINE TRAXES (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,VALPRJ)

C- Fonction : Traces des axes en 3D
C-
C- Entree :
C-    XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Local :
C-   LONGAX : Longueur d'un axe. 1.25*delta([x,y,x]
C-   XAXES,YAXES : Coordonnees 2D des projections de X,Y,Z
C-
C- Derniere modif : 15 JUN 2000

      REAL XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,VALPRJ(*),XAXES(2),YAXES(2)
      REAL LONGAX
      INTEGER NBCOL
      
      CALL PGSCI (NBCOL+1)
C- Coordonnee de l'origine
      CALL PROJEC (0.0,0.0,0.0,VALPRJ,XAXES(1),YAXES(1)) 

      LONGAX=1.25*(XMAX-XMIN)
      CALL PROJEC (LONGAX,0.0,0.0,VALPRJ,XAXES(2),YAXES(2))
C- On "raccourcit" si ca depasse
      XAXES(2)=MIN(XAXES(2),XMAX)
      XAXES(2)=MAX(XAXES(2),XMIN)
      YAXES(2)=MIN(YAXES(2),YMAX)
      YAXES(2)=MAX(YAXES(2),YMIN)
      CALL PGMOVE (XAXES(1),YAXES(1))
      CALL PGDRAW (XAXES(2),YAXES(2))
      CALL PGTEXT (XAXES(2),YAXES(2),'X')

      LONGAX=1.25*(YMAX-YMIN)
      CALL PROJEC (0.0,LONGAX,0.0,VALPRJ,XAXES(2),YAXES(2))
      XAXES(2)=MIN(XAXES(2),XMAX)
      XAXES(2)=MAX(XAXES(2),XMIN)
      YAXES(2)=MIN(YAXES(2),YMAX)
      YAXES(2)=MAX(YAXES(2),YMIN)
      CALL PGMOVE (XAXES(1),YAXES(1))
      CALL PGDRAW (XAXES(2),YAXES(2))
      CALL PGTEXT (XAXES(2),YAXES(2),'Y')

      LONGAX=1.25*(ZMAX-ZMIN)
      CALL PROJEC (0.0,0.0,LONGAX,VALPRJ,XAXES(2),YAXES(2))
      XAXES(2)=MIN(XAXES(2),XMAX)
      XAXES(2)=MAX(XAXES(2),XMIN)
      YAXES(2)=MIN(YAXES(2),YMAX)
      YAXES(2)=MAX(YAXES(2),YMIN)
      CALL PGMOVE (XAXES(1),YAXES(1))
      CALL PGDRAW (XAXES(2),YAXES(2))
      CALL PGTEXT (XAXES(2),YAXES(2),'Z')

      END
