*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RECOPI (ITYP,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,IADRS,NWARTI
     &                  ,ATBNTB,ADSCTB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1988)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Recopie d'un tableau a la fin dans le super tableau concerne remplacement par
* un trou et mise a jour du rang, du nom et des indices de description 
*  
*-- Arguments --  
* ITYP   Type du super tableau concerne
* NBCAR,NBMOTS Nouvelle longueur du tableau (en caracteres ou mots)
* NBCEF,NBMO  le nombre d'individus a recopier effectivement : 
*             au dela le tableau est rempli de zero ou de blancs
* IRANG  Rang du tableau avant recopie 
* IADRS  Ancienne adresse  
* NWARTI Longueur nouvelle du tableau comptee en articles  
* ATBNTB  Adresse du tableau des noms de tableaux
* ADSCTB Adresse du tableau des indices de description des tableaux
*  
* REMARQUE : ATBNTB et ADSCTB sont fournis en argument afin de couvrir 
*            les cas ou ce sont les tableaux TBNMTB et TBDCTB qui 
*            sont recopies: dans ce dernier cas les valeurs a donner  
*            en entree sont celle qui sont justes apres la RECOPIe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITYP,NBCAR,NBCEF,NBMOTS,NBMO,IRANG,IADRS,NWARTI,ATBNTB
     &       ,ADSCTB
*
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8
      INTEGER NIP
*-----------------------------------------------------------------------
      NBTABL=TBDCST(4) 
      NXFRMO=TBDCST(7) 
      NBTRAS=TBDCST(8) 
      NXTADR=TBDCST(11)
      NBTRRS=TBDCST(12)
      IPRINT=TBDCST(16)
*  
      IF (ITYP.GT.10) THEN  
*        Recopie d'un tableau de caracteres
         DO 20 I=0,NBCEF-1 
20          AST(NXFRMO+I)=AST(IADRS+I) 
         DO 21 I=NXFRMO+NBCEF,NXFRMO+NBCAR-1
21          AST(I)=' ' 
         NIVTRO=NBTRAS+1
         IDSTRO=ADSCTB+NBPART*(IRANG-1)
         CALL GETATR (IST(IDSTRO),ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI)
         CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTR,NBCATR)
         TBDCST(6)=TBDCST(6)-NBCAR+NBCATR  
         TBDCST(7)=NXFRMO+NBCAR
         TBDCST(8)=NBTRAS+1
         NWADRS=NXFRMO 
      ELSEIF (ITYP.GE.1.AND.ITYP.LE.4) THEN
*        Recopie d'un tableau numerique
         IF(ITYP.GE.3.AND.MOD(NXTADR,2).EQ.0) THEN 
            NXTADR=NXTADR+1
            TBDCST(24)=TBDCST(24)+1
         ENDIF  
         DO 30 I=0,NBMO-1  
30          IST(NXTADR+I)=IST(IADRS+I) 
         DO 31 I=NXTADR+NBMO,NXTADR+NBMOTS-1
31          IST(I)=0
         NIVTRO=NBTRRS+1
         IDSTRO=ADSCTB+NBPART*(IRANG-1)
         CALL GETATR (IST(IDSTRO),ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI)
         CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTR,NBCATR)
         TBDCST(10)=TBDCST(10)-NBMOTS+NBMOTR
         TBDCST(11)=NXTADR+NBMOTS  
         TBDCST(12)=NBTRRS+1
         TBDCST(21)=TBDCST(21)+NBMOTS  
         TBDCST(23)=TBDCST(23)+NBMO
         NWADRS=NXTADR 
      ENDIF 
*
      II =ATBNTB+NBCHNT*(IRANG-1)-1 
      III=ATBNTB+NBCHNT*NBTABL-1
      DO 40 I=1,NBCHNT 
40       AST(III+I)=AST(II+I)  
      III=0
      CALL RIPCHN (AST(II+1),III,NBCHNT,'TROUMC')
      CALL PUTATR (ITYPTB,NIVTRO,IADRS,0,NBARTI,IST(IDSTRO))
*     Attention la longueur ne sera plus coherente avec le calculs des 
*     adresses en memoire secondaire. On se resigne a perdre la
*     sauvegarde precedente.
      IF (MSADRS.NE.0.AND.NWARTI.NE.NBARTI) MSADRS=0
      CALL PUTATR (ITYPTB,NIVETB,NWADRS,MSADRS,NWARTI
     &            ,IST(ADSCTB+NBPART*NBTABL))
      TBDCST(4)=NBTABL+1
      NBMO=NBMOTR  
      NBCEF=NBCATR
*-----------------------------------------------------------------------
      IF (IPRINT.GT.0) WRITE(IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1),ITYP
10001 FORMAT(A,A,'<Recopi',T39,', Recopie de type ',I5)
                                                                    END !Recopi
