*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SAUVTB (IND,NOMTB,IRANG,TBNMTB,TBDCTB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1988) 
* Derniere modification : D.Martin (4 Juillet 1997)
* Version 1.0.1
*  
* Placer un tableau en sauvegarde differee ou le sauvegarder  
* immediatement en le remplacant par un trou en memoire centrale  
*  
*-- Arguments d'entree -- 
* IND    indice de type de sauvegarde .EQ.0 : sauvegarde differee  
*                                     .NE.0              immediate 
* NOMTB  nom du tableau a sauvegarder 
* IRANG  son rang 
* TBNMTB tableau des noms de tableaux 
* TBDCTB tableau des indices de description de tableaux
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'   
*    
      CHARACTER TBNMTB(NBCHNT,*),NOMTB*(*)
      INTEGER   IND,IRANG,TBDCTB(*)
*
      CHARACTER NOMTAB*6,ISORTI*6,PRFXAS*8
      INTEGER NIP
*-----------------------------------------------------------------------
      NBTBMX=TBDCST(3) 
      NBTABL=TBDCST(4) 
      NBTRAS=TBDCST(8) 
      NBTRRS=TBDCST(12)
      ISEUIL=TBDCST(25)
      IPRINT=TBDCST(16)
      NOMTAB=NOMTB 
      IRG=NBPART*(IRANG-1)+1
      CALL GETATR (TBDCTB(IRG),ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI)
      IF (IND.EQ.0) THEN
*        Sauvegarde differee: l'adresse devient negative et c'est tout 
         TBDCTB(IRG+2)=-ABS(MCADRS)
*        IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
*    &                 ,NOMTAB(:NBCHNT),NIVETB,ITYPTB,NBARTI,'differee'
         RETURN
      ENDIF
      IF (IPRINT.GT.0) 
     &   WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                       ,NOMTAB(:NBCHNT),NIVETB,ITYPTB,NBARTI
      CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
      IF (NBMOTS.GT.ISEUIL) THEN
*        Sauvegarde par injection dans un fichier a acces direct
         ICOMPT=0  
*        Le fichier concerne sera ferme apres l'acces, si le tableau
*        est unique sous ce nom en memoire centrale
         IDEB=1
39       IOK=KELCHN (NOMTB,TBNMTB(1,IDEB),NBTABL-IDEB+1,NBCHNT)         !Utilite
         IF (IOK.NE.0) THEN 
            ICOMPT=ICOMPT+1
            IDEB=IOK+1 
            GO TO 39
         ENDIF
         IF (ICOMPT.EQ.1) THEN  
*           Sortie avec fermeture du fichier, plus d'unite logique 
*           affecte (MSBUF sera negatif au retour TBOPEN)  
            ISORTI='SRTFRM'
         ELSE  
*           Sortie simple - le fichier restera ouvert (MSBUF positif
*           au retour TBOPEN)  
            ISORTI='SORTIE'
         ENDIF 
         CALL TBOPEN (NOMTB,ITYPTB,NIVETB,ABS(MCADRS),MSADRS,NBARTI
     *               ,TBNMTB,TBDCTB,ISORTI)
      ELSE 
*        Sauvegarde par envoi dans un tableau tampon intermediaire 
*        avec le systeme de fichier acces direct-longueur variable.
         CALL TAMPON (NOMTB,ITYPTB,NIVETB,ABS(MCADRS),MSADRS,NBARTI
     *               ,TBNMTB,TBDCTB,'SORTIE')
      ENDIF
*  
*     Mise a jour de l'etat des tableaux
*  
*     On remplace par un trou en m.c., le tableau va au dernier rang
      IF (NBTABL.EQ.NBTBMX) THEN
         CALL ENCLER(NBTABL,ISORTI)                                     !Utilite
         CALL BAISE('Erreur ---> SAUVTB <--- ,Saturation du nombre '//
     *                                    ISORTI//' des tableaux crees')!Utilite
      ENDIF
      DO 100 ICAR=1,NBCHNT 
100      TBNMTB(ICAR,NBTABL+1)=TBNMTB(ICAR,IRANG)  
      CALL PUTATR (ITYPTB,NIVETB,0,MSADRS,NBARTI
     &            ,TBDCTB(NBPART*NBTABL+1))
      IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN 
         NIVTRO=NBTRRS+1
         TBDCST(10)=TBDCST(10)+NBMOTS  
         TBDCST(12)=NBTRRS+1
         TBDCST(22)=TBDCST(22)+NBMOTS  
      ELSEIF (ITYPTB.GT.10) THEN
         NIVTRO=NBTRAS+1
         TBDCST(6)=TBDCST(6)+NBCAR 
         TBDCST(8)=NBTRAS+1
      ENDIF
      IBIDON=0 
      CALL RIPCHN (TBNMTB(1,IRANG),IBIDON,NBCHNT,'TROUMC')              !Utilite
      CALL PUTATR (ITYPTB,NIVTRO,ABS(MCADRS),0,NBARTI,TBDCTB(IRG))
      TBDCST(4)=NBTABL+1
*  
      IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                ,NOMTAB(:NBCHNT),NIVETB,ITYPTB,NBARTI,'immediate'
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>SauvTb ',A,T32,'/',I6,T39,' Type',I3
     &,T48,', Lg',I12)
10001 FORMAT(A,A,'<SauvTb ',A,T32,'/',I6,T39,' Type',I3
     &,T48,', Lg',I12,T79,' -> sauvegarde ',A)
                                                                   END !Sauvtb
