*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE STINIT (NBCHMX,MOTMXR,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF
     &                  ,NBUTMX,NBUNIT,INTMAX,IPRINT,IMPERR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Mars 1988)
* Derniere modification : D.Martin (5 Novembre 2001)
* Version 1.0.3
*
* Initialisation des tables de description des tableaux
*
*-- Arguments d'entree --
* NBCHMX Dimension du super-tableau de caracteres
* MOTMXR Dimension du super-tableau numerique
* NBTBMX Nombre de tableaux initial maximum
* ISEUIL Seuil pour la taille d'un tableau au dessus duquel les sauvegardes
*        eventuelles sont injectives et non plus tamponnees.
* LGBUF  Longueur du tableau tampon: 'BFxxxx'
* NBENRX Taille d'un fichier du systeme "acces direct longueur variable"
*        en nombre d'enregistrements
* NBBUF  Nombre de tableaux tampons presents en memoire centrale
* NBUTMX Nombre maximum d'unites logiques ouvertes simultanement.
* NBUNIT Nombre effectif d'unites logiques ouvertes 
*        - sa valeur initiale est le numero du 1er fichier du systeme.
* INTMAX Plus grand entier de la machine
* IPRINT Unite logique d'impression des messages courants
* IMPERR Unite logique d'impression des messages d'erreurs (defaut : 6)
*
* En sortie, les memes en valeurs ou modifies par defaut
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBCHMX,MOTMXR,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF
     &       ,NBUTMX,NBUNIT,INTMAX,IPRINT,IMPERR
* 
      CHARACTER BUFFER*6,PRFXAS*8
      INTEGER IBIDON,NCHAR1,NCHAR2,NXTADR,MAXAGE,LONG
     &       ,NBFICH,MCBUF,NUBUF,ITPBUF,NBARTI,ICAR,I,NIP
*
      INCLUDE 'ALLOC'
*-----------------------------------------------------------------------
      IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
      IBIDON=0  
      TBDCST(1)=NBCHMX 
      TBDCST(2)=MOTMXR 
      IF (NBCHMX.GT.MOTMXR) THEN
         WRITE (*,*) 'Erreur ---> Stinit <--- ATTENTION, MOTMXR(',MOTMXR
     &   ,') doit etre > NBCHMX(',NBCHMX,') pour eviter des erreurs sur'
     &   ,' le calcul de l''AGE DES TAMPONS (??????)'
         CALL BAISE  ('Il faut lire la doc....')                        !utilite
      ENDIF
*     Nombre maximum initial de tableaux geres dans les tables 
      IF (NBTBMX.LE.4) NBTBMX=300
      TBDCST(3)=NBTBMX 
*     Nombre effectif de tableaux presents dans les tables (initialement 0)
      TBDCST(4)=0  
      TBDCST(5)=1  
*     NCPMMA : nombre de caracteres par mot-machine (Parameter dans ALLOC) 
      NCHAR1=((NBCHNT*NBTBMX-1)/NCPMMA+1)*NCPMMA
      NCHAR2=((NBCHDT*NBTBMX-1)/NCPMMA+1)*NCPMMA
      TBDCST(7)=NCHAR1+1
      TBDCST(6)=NBCHMX+1-TBDCST(7) 
      IF (TBDCST(6).LE.0) CALL BAISE
     &  ('Perdu d''avance, Super-tableau de caracteres deja sature')
      TBDCST(8)=0  
      NXTADR=NBIDSC+1  
      TBDCST(9)=NXTADR 
      TBDCST(10)=MOTMXR-NBIDSC-NBPART*NBTBMX
      TBDCST(11)=NBIDSC+NBPART*NBTBMX+1
      TBDCST(12)=0
      MAXAGE=INTMAX/MOTMXR
*     Le nombre d'unite logique est limite par les possibilites de 
*     codage de leur age
      NBUTMX=MIN (NBUTMX,MAXAGE)
      TBDCST(13)=NBUTMX
      TBDCST(14)=NBUNIT
      TBDCST(15)=1
      TBDCST(16)=IPRINT
      IF (IMPERR.EQ.0) IMPERR=6 
      TBDCST(17)=IMPERR
      TBDCST(35)=1+NCHAR1  
*  
*     Initialisation de 'TBDCST'
      CALL RIPCHN (AST(1),TBDCST(4),NBCHNT,'TBDCST')                    !utilite
      CALL PUTATR (1,1,1,0,NBIDSC,IST(NXTADR))
      NXTADR=NXTADR+NBPART 
*  
*     Initialisation de 'TBNMTB'
      CALL RIPCHN (AST(1),TBDCST(4),NBCHNT,'TBNMTB')                    !utilite
      CALL PUTATR (11,1,1,0,NBTBMX*NBCHNT,IST(NXTADR))            
      NXTADR=NXTADR+NBPART 
*  
*     Initialisation de 'TBDCTB'
      CALL RIPCHN (AST(1),TBDCST(4),NBCHNT,'TBDCTB')                    !utilite
      CALL PUTATR (1,1,NBIDSC+1,0,NBTBMX*NBPART,IST(NXTADR))
      NXTADR=NXTADR+NBPART 
*  
      TBDCST(18)=3
      TBDCST(35)=TBDCST(35)-NCHAR1-1
      TBDCST(19)=0
      TBDCST(20)=0
      TBDCST(21)=TBDCST(11)-1
      TBDCST(22)=0
      TBDCST(23)=0
      TBDCST(24)=0
      TBDCST(25)=ISEUIL
*
      IF (ISEUIL.GT.0) THEN
         TBDCST(26)=1
         TBDCST(27)=NBENRX
         TBDCST(28)=LGBUF
         IF (NBBUF.LT.2) NBBUF=2
         TBDCST(29)=NBBUF
         TBDCST(30)=1
         TBDCST(31)=INTMAX
         TBDCST(33)=0
         TBDCST(34)=0
         TBDCST(36)=1
         NBFICH=0
         MCBUF=TBDCST(11)
         DO 1 I=1,NBBUF
            NUBUF=(I-1)/NBENRX+1
            NBFICH=MAX(NBFICH,NUBUF)
            CALL ENCLER (NUBUF,BUFFER)                                  !utilite
            BUFFER(:2)='BF'
            DO 2 ICAR=3,6
               IF (BUFFER(ICAR:ICAR).EQ.' ') BUFFER(ICAR:ICAR)='0'
2           CONTINUE
*  
            CALL RIPCHN (AST(1),TBDCST(4),NBCHNT,BUFFER)                !utilite
            ITPBUF=1
            IF (I.EQ.NBBUF) ITPBUF=11
            IF (I.EQ.NBBUF) MCBUF =TBDCST(7)
            NBARTI=LGBUF
            IF (I.EQ.NBBUF) NBARTI=LGBUF*NCPMMA
            CALL PUTATR (ITPBUF,0,MCBUF,0,NBARTI,IST(NXTADR))
            IF (I.NE.NBBUF) MCBUF =MCBUF+LGBUF
            NXTADR=NXTADR+NBPART
1        CONTINUE
         TBDCST(6)=TBDCST(6)-LGBUF*NCPMMA
         IF (TBDCST(6).LE.0) CALL BAISE
     &   ('Perdu d''avance, buffer caractere sature le super-tableau')  !utilite
         TBDCST(7)=TBDCST(7)+LGBUF*NCPMMA
         TBDCST(10)=TBDCST(10)-LGBUF*(NBBUF-1)
         IF (TBDCST(10).LE.0) CALL BAISE
     &   ('Perdu d''avance, le super tableau numerique est deja sature')!utilite
         TBDCST(11)=TBDCST(11)+LGBUF*(NBBUF-1)
         TBDCST(18)=TBDCST(18)+NBBUF
         TBDCST(21)=TBDCST(21)+(NBBUF-1)*LGBUF
         TBDCST(32)=NBFICH
      ENDIF
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10002) (PRFXAS(NIP),NIP=1,0,-1)
*-----------------------------------------------------------------------
10001 FORMAT(A,A,'>Stinit')
10002 FORMAT(A,A,'<StInit Initialisation de l''allocation dynamique')
                                                                    END !Stinit
