*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TAMPON (NOMTB,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     &                  ,TBNMTB,TBDCTB,INOUT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.de Bayser (Mars 1988)
* Derniere modification : D.Martin (9 Novembre 2001)
* Version  1.0.2
*  
* Entrees/Sorties par tableaux tampons intermediaires
*  
* NOMTB  Nom du tableau 
* ITYPTB Son type
* NIVETB Son niveau 
* MCADRS Son adresse en memoire centrale
* MSADRS Son adresse en memoire secondaire  
* NBARTI Son nombre d'articles  
* TBNMTB Tableau des noms de tableaux
* TBDCTB tableau des indices de description de tableaux 
* INOUT  Indicateur d'entree ou de sortie
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC' 
*    
      CHARACTER TBNMTB(NBCHNT,*),NOMTB*(*),INOUT*(*)
      INTEGER   ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI,TBDCTB(*)
*
      CHARACTER NOMBUF*6,NOMTAB*6,ISORTI*6,NFIC*4,PRFXAS*8
      LOGICAL   PR1,PR2,PR3  
*-----------------------------------------------------------------------
      MOTMXR=TBDCST(2) 
      NBTABL=TBDCST(4) 
      IPRINT=TBDCST(16)
      NXADFI=TBDCST(26)
      NBENRX=TBDCST(27)
      LGBUF =TBDCST(28) 
      NBBUF =TBDCST(29) 
      INTMAX=TBDCST(31)
      NBFICH=TBDCST(32)
      IPREM =TBDCST(36)
      MAXAGE=INTMAX/MOTMXR
*
*     Messages anciennement affiches dans Stinit
      IF (MAXAGE.LE.2) THEN
         WRITE (*,*) ' Age maximum (!!!) :       MAXAGE=',MAXAGE
         WRITE (*,*) ' Longueur du super-tableau MOTMXR=',MOTMXR
         WRITE (*,*) ' Plus grand entier         INTMAX=',INTMAX
         CALL BAISE ('Super-tableau TROP GRAND'
     &//' (cas non prevu par l''allocation dynamique !!!!!!!!)')
      ENDIF
*
      IF (NBBUF.GT.MAXAGE) THEN
         WRITE (*,*) ' Nombre de Buffers :       NBBUF =',NBBUF
         WRITE (*,*) ' Age maximum (!!!) :       MAXAGE=',MAXAGE
         WRITE (*,*) ' Longueur du super-tableau MOTMXR=',MOTMXR
         WRITE (*,*) ' Plus grand entier         INTMAX=',INTMAX
         CALL BAISE  ('Les possibilites de coder l''age des tampons'
     &     //'sont satures d''emblee; reduire NBBUF !')                 !utilite
      ENDIF
*  
      NBMOTS=NBARTI
      IF (ITYPTB.EQ.3.OR.ITYPTB.EQ.4) THEN
         NBMOTS=2*NBARTI
      ELSEIF (ITYPTB.GT.10) THEN
         NBMOTS=((NBARTI*(ITYPTB-10)-1)/NCPMMA+1)  
      ENDIF
*     Sauvegarde par envoi dans un tableau tampon intermediaire
*     avec le systeme de fichier acces direct-longueur variable.
*     Ce systeme est compose d'un nombre (indefini) de fichiers
*     a acces direct de taille fixe et consideres comme bout a bout.
*     Les noms de ces fichiers commencent par les caracteres BF suivis 
*     du rang (dans la suite des fichiers ...)code sur 4 caracteres.
*     Tout ces fichiers sont consideres comme de la meme taille: NBENRX
*     enregistrements maximum. 
*     Il y a virtuellement autant de tableaux tampons que  
*     d'enregistrements dans ce systeme .  
*     Mais en realite le nombre de tableaux tampon simultanement en
*     memoire centrale est fixe (egal a NBBUF). La correspondance  
*     est assuree par les niveaux de ces derniers: ils sont egaux  
*     aux numeros absolus des enregistrements du systeme de fichier,
*     qu'ils contiennent. Les tableaux tampons sont crees dans STINIT. 
*     MSADRS represente l'adresse absolue dans le systeme de fichiers.  
      IF (MSADRS.LE.0) THEN 
         IF (INOUT(1:6).EQ.'ENTREE')
     &      CALL ERTBAL (10,'*Tampon*',NOMTB,NIVETB)
*        ATTENTION: il n'y a pas de controle sur un eventuel maximum
*        de la taille du systeme de fichiers
         MSADRS=NXADFI 
         TBDCST(26)=NXADFI+NBMOTS  
      ENDIF
      IREK=(MSADRS-1)/LGBUF+1  
*     L'adresse relative IOFSET dans l'enregistrement IREK est compte  
*     en mots  
      IOFSET=MSADRS-(IREK-1)*LGBUF 
*     Description des transferts a effectuer: le 1er a LGDEB mots, 
*     puis NLGEBF a LGBUF mots, enfin le dernier a LGEND mots  
      NTRSFR=1 
      NLGEBF=0 
      LGDEB=LGBUF-IOFSET+1 
      LGDEB=MIN(LGDEB,NBMOTS)  
      LGREST=NBMOTS-LGDEB  
      IF (LGREST.GT.0) THEN 
         NLGEBF=LGREST/LGBUF
         NTRSFR=NTRSFR+NLGEBF  
         LGEND=LGREST-NLGEBF*LGBUF 
         IF (LGEND.GT.0) NTRSFR=NTRSFR+1
      ENDIF
*
*     Boucle d'execution des transferts
      DO 80 ITRSFR=1,NTRSFR
         IGMIN=MAXAGE+1
         IAGBUF=TBDCST(30) 
         NBUF=0
*        variables logiques pour le sens des transferts
         PR1=ITRSFR.EQ.1.AND.  
     &       (IOFSET.NE.1.OR.(NBMOTS.LT.LGBUF.AND.MSADRS.NE.NXADFI))
         PR2=ITRSFR.EQ.NTRSFR.AND.NTRSFR.NE.1.AND.MSADRS.NE.NXADFI 
         PR3=PR1.OR.PR2
         PR1=INOUT(1:6).EQ.'ENTREE'
         PR2=INOUT(1:6).EQ.'SORTIE'.OR.INOUT(1:6).EQ.'SRTFRM'
         PR3=PR3.AND.PR2
         DO 35 ITABL=1,NBTABL  
*           Recherche du tampon contenant IREK ou a defaut, du tampon  
*           le plus agee
            DO 13 ICAR=1,NBCHNT
13             NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITABL)
            ITT=NBPART*(ITABL-1)
            IF (NOMTAB(1:2).EQ.'BF') THEN
               ITPBUF=TBDCTB(1+ITT)
               NIVBUF=TBDCTB(2+ITT)
               MCCBUF=TBDCTB(3+ITT)
               NBUF=NBUF+1 
               IF (IREK.EQ.NIVBUF) THEN 
*                 L'enregistrement vise est dans un des tampons
*                 Test de securite 
                  IF (((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.ITPBUF.EQ.1) 
     *             .OR.(ITYPTB.GT.10.AND.ITPBUF.EQ.11)) THEN
                     IRB=ITT
                     ICBUF=ABS(MCCBUF) 
                     IG=(ICBUF-1)/MOTMXR
                     ICBUF=ICBUF-IG*MOTMXR 
                     MCBUF=SIGN(ICBUF,MCCBUF)  
*                    On court directement a l'execution du transfert ...
                     GOTO 50
                  ELSE 
                     CALL ENCLER (ITPBUF,NOMBUF)                        !utilite
                     CALL ENCLER (ITYPTB,NOMTAB)                        !utilite
                     CALL BAISE  (' *Tampon* Erreur,l''enregistrement ' !utilite
     *             //'vise est retrouve, mais pas avec le bon type, '
     *             //'type du tampon:'//NOMBUF//'; type voulu:'//NOMTAB)
                  ENDIF
               ELSE
*                 Recherche du rang du tampon le plus age avec le type 
*                 Convenable
*                 Remarque: l'age est compte avec MOTMXR quel que soit 
*                           le type du tampon. donc on doit avoir: 
*                           MOTMXR.ge.NBCHMX   en valeur.  
                  ICBUF=ABS(MCCBUF)
                  IG=(ICBUF-1)/MOTMXR  
                  IF (IG.LE.IGMIN.AND.
     *             (((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.ITPBUF.EQ.1).
     *            OR.(ITYPTB.GT.10.AND.ITPBUF.EQ.11))) THEN
                     IGMIN=IG
                     IRBUF=ITABL
                     NOMBUF=NOMTAB 
                     NVBUF=NIVBUF  
                     ICBUF=ICBUF-IG*MOTMXR 
                     MCBUF=SIGN(ICBUF,MCCBUF)  
                  ENDIF
               ENDIF
            ENDIF  
*           Economie de la fin de la boucle sur les tableaux
            IF (NBUF.GE.NBBUF) GOTO 37  
35       CONTINUE  
         IF (NBUF.EQ.0) CALL ERTBAL (20,'*Tampon*','Buffer',0)
*        L'enregistrement vise n'est pas dans les tableaux tampons 
*        on utilise le tampon le plus age IRBUF
37       IF (IGMIN.GT.MAXAGE) THEN
            CALL BAISE  (' *Tampon* Erreur, Etrange ..,Il n''y a pas de'!utilite
     &                //' tampon senile avec le type convenable')
         ENDIF 
         IRB=NBPART*(IRBUF-1)  
         IF (MCBUF.LE.0) THEN
*           il faut sauvegarder le contenu du tampon IRBUF au prealable
            ITPBUF=TBDCTB(1+IRB)
*           N[ d'enregistrement relatif dans le fichier du systeme 
            IQUOTI=(NVBUF-1)/NBENRX
            NIVBUF=NVBUF-IQUOTI*NBENRX 
            ICOMPT=0
            NBUF=0 
*           Le fichier concerne sera ferme apres l'acces, si le tampon 
*           est unique sous ce nom en memoire centrale 
            DO 39 ITABL=1,NBTABL
               DO 38 ICAR=1,NBCHNT 
38                NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITABL) 
               IF (NOMTAB(1:2).EQ.'BF') THEN
                  NBUF=NBUF+1  
                  IF (NOMTAB.EQ.NOMBUF) ICOMPT=ICOMPT+1 
               ENDIF
*              Economie de la fin de la boucle sur les tableaux
               IF (NBUF.GE.NBBUF) GOTO 40
39          CONTINUE
40          IF (ICOMPT.LE.0) THEN
              CALL BAISE  (' *Tampon* Erreur, Bizarre le tableau'//     !utilite
     &        NOMBUF//' a subitement disparu des tables de description')
            ELSEIF (ICOMPT.EQ.1) THEN  
*              Sortie avec fermeture du fichier, plus d'unite logique  
*              affecte (MSBUF sera negatif au retour TBOPEN)
               ISORTI='SRTFRM' 
            ELSE
*              Sortie simple - le fichier restera ouvert (MSBUF positif
*              au retour TBOPEN)
               ISORTI='SORTIE' 
            ENDIF  
            MSBUF=TBDCTB(4+IRB)
*           write(*,*) ' ->Tampon ',NOMTB
            CALL TBOPEN (NOMBUF,ITPBUF,NIVBUF,ABS(MCBUF),MSBUF,LGBUF
     &                  ,TBNMTB,TBDCTB,ISORTI)
         ENDIF 
*        En cas de transferts memoire centrale vers tampon (INOUT='SORTIE')
*        on fait au prealable, rentrer l'enregistrement vise dans le tampon
*        simplement pour le 1er et pour le dernier transfert,eventuellement;
*        en effet, ce sont des transferts incomplets, et il ne faut pas
*        perdre la partie complementaire.  
*        Dans le cas inverse (INOUT='ENTREE') on fait rentrer l'enregistrement 
*        vise pour tout les transferts.
*        Calcul du nom du tampon
*        Mise a jour du nombre de fichiers dans le systeme acces direct
*        longueur variable 
         NUFICH=(IREK-1)/NBENRX+1  
         IF (NUFICH.GT.NBFICH) TBDCST(32)=NUFICH
         CALL ENCLER (NUFICH,NFIC)                                      !utilite
         DO 41 ICAR=1,4
41          IF (NFIC(ICAR:ICAR).EQ.' ') NFIC(ICAR:ICAR)='0' 
         NOMBUF='BF'//NFIC 
*        L'adresse en memoire secondaire est celle des tampons portant 
*        le meme nom. Si il n'y en a pas (le nouvel etat du tampon 
*        n'est pas encore enregistre par son nom) c'est que le fichier 
*        vise est ferme sans unite logique affectee (MSBUF=0). 
         MSBUF=0
         NBUF=0
         DO 44 ITABL=1,NBTABL  
            DO 42 ICAR=1,NBCHNT
42             NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITABL)
            IF (NOMTAB.EQ.NOMBUF) THEN  
               MSBUF=TBDCTB(4+NBPART*(ITABL-1))
               NBUF=NBUF+1 
            ENDIF  
*           Economie de la fin de la boucle sur les tableaux
            IF (NBUF.GE.NBBUF) GOTO 45  
44       CONTINUE  
45       DO 46 ICAR=1,NBCHNT
46          TBNMTB(ICAR,IRBUF)=NOMBUF(ICAR:ICAR)
         IF (PR1.OR.PR3) THEN
*           No d'enregistrement relatif dans le fichier NOMBUF du systeme  
            IREKRL=IREK-(NUFICH-1)*NBENRX  
            CALL TBOPEN (NOMBUF,ITPBUF,IREKRL,ABS(MCBUF),MSBUF,LGBUF
     *                  ,TBNMTB,TBDCTB,'ENTREE')
         ENDIF 
         TBDCTB(4+IRB)=MSBUF
50       IF (ITRSFR.EQ.1) THEN  
            LG=LGDEB
            IF (PR1) THEN
               JDEB=ABS(MCBUF)+IOFSET-2
               IDEB=MCADRS-1
            ELSEIF (PR2) THEN  
               IDEB=ABS(MCBUF)+IOFSET-2
               JDEB=MCADRS-1
            ENDIF  
         ELSE  
            LG=LGBUF
            IF (ITRSFR.EQ.NTRSFR) LG=LGEND  
            IF (PR1) THEN
               JDEB=ABS(MCBUF)-1
               IDEB=MCADRS-1+LGDEB+(ITRSFR-2)*LGBUF
            ELSEIF (PR2) THEN  
               IDEB=ABS(MCBUF)-1
               JDEB=MCADRS-1+LGDEB+(ITRSFR-2)*LGBUF
            ENDIF  
         ENDIF 
*        Transfert proprement dit  
         IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN  
            DO 70 IT=1,LG  
70             RST(IDEB+IT)=RST(JDEB+IT)
            IF (PR1) THEN
               TBDCST(33)=TBDCST(33)+1 
            ELSEIF (PR2) THEN  
               TBDCST(34)=TBDCST(34)+1 
            ENDIF  
         ELSEIF (ITYPTB.GT.10) THEN
            IIDEB=IDEB 
            JJDEB=JDEB 
            DO 72 IT=1,LG  
               DO 71 ICAR=1,NCPMMA 
71                AST(IIDEB+ICAR)=AST(JJDEB+ICAR)  
               IIDEB=IIDEB+NCPMMA  
               JJDEB=JJDEB+NCPMMA  
72          CONTINUE
         ELSE  
            CALL BAISE  (' *Tampon* Erreur ITYPTB non reconnu')         !utilite
         ENDIF 
         TBDCTB(2+IRB)=IREK
         IREK=IREK+1
         MCCBUF=ABS(MCBUF)+MOTMXR*IAGBUF
         IF (PR1) THEN  
            TBDCTB(3+IRB)=SIGN(MCCBUF,MCBUF)
         ELSE  
*           Dans ce cas il faudra surement a l'avenir sauvegarder le tampon
*           avant de le reutiliser 
            TBDCTB(3+IRB)=-MCCBUF  
         ENDIF 
         IF (IAGBUF+1.GE.MAXAGE) THEN
*           La prochaine fois, on va depasser les possibilites de codage
*           de l'age des buffer comme multiple de MOTMXR.
*           Donc on rajeunit les buffers, ensembles, en redefinissant IAGBUF.
            NBUF=0
            IGMIN=MAXAGE
            DO 74 ITABL=1,NBTABL  
*              1ere passe: Recherche de l'age IGMIN le plus ancien des tampons
               DO 73 ICAR=1,NBCHNT
73                NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITABL)
               ITT=NBPART*(ITABL-1)
               IF (NOMTAB(1:2).EQ.'BF') THEN
                  ITPBUF=TBDCTB(1+ITT)
                  MCCBUF=TBDCTB(3+ITT)
                  IF (((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.ITPBUF.EQ.1) 
     *             .OR.(ITYPTB.GT.10.AND.ITPBUF.EQ.11)) THEN
                     ICBUF =ABS (MCCBUF)
                     IGMIN =MIN ((ICBUF-1)/MOTMXR,IGMIN)
                     NBUF=NBUF+1 
*                    Economie de la fin de la boucle sur les tableaux
                     IF (NBUF.GE.NBBUF) GOTO 75
                  ENDIF
               ENDIF
74          CONTINUE
75          NBUF=0
*           remarque IPREM est le premier age possible d'un buffer.
*           Il a ete pose a 1 dans stinit par l'instruction TBDCST(36)=1
            DO 77 ITABL=1,NBTABL  
*              2ieme passe: Rajeunissement des tampons
               DO 76 ICAR=1,NBCHNT
76                NOMTAB(ICAR:ICAR)=TBNMTB(ICAR,ITABL)
               ITT=NBPART*(ITABL-1)
               IF (NOMTAB(1:2).EQ.'BF') THEN
                  ITPBUF=TBDCTB(1+ITT)
                  MCCBUF=TBDCTB(3+ITT)
                  IF (((ITYPTB.GE.1.AND.ITYPTB.LE.4).AND.ITPBUF.EQ.1)  
     *              .OR.(ITYPTB.GT.10.AND.ITPBUF.EQ.11)) THEN
                     ICBUF =ABS(MCCBUF)
                     ICBUF =ICBUF+(IPREM-IGMIN)*MOTMXR
                     TBDCTB(3+ITT)=SIGN(ICBUF,MCCBUF)
                     NBUF=NBUF+1 
*                    Economie de la fin de la boucle sur les tableaux
                     IF (NBUF.GE.NBBUF) GOTO 78
                  ENDIF
               ENDIF
77          CONTINUE
78          IAGBUF=IAGBUF-IGMIN+IPREM
         ENDIF
         TBDCST(30)=IAGBUF+1
*        La description du nouvel etat du tampon est a jour dans
*        les tables
80    CONTINUE 
*  
      IF (IPRINT.GT.0) THEN 
         IF (INOUT(1:6).EQ.'ENTREE') THEN
            WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &            ,NOMTB(1:NBCHNT),NIVETB,' Retour d''un tableau tampon'
         ELSEIF (INOUT(1:6).EQ.'SORTIE') THEN
            WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &           ,NOMTB(1:NBCHNT),NIVETB,' Envoi dans un tableau tampon'
         ENDIF
      ENDIF
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'<Tampon ',A,T32,'/',I6,A)
      END
