*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBCREE (NOMTB,NIVETB,ITYPTB,NBARTI,COMENT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juillet 1988)
* Derniere modification : D.Martin (30 Aout 2000)
* Version 1.0.3
*  
* Creation en memoire centrale du tableau NOMTB  
*  
*-- Arguments --  
* NOMTB  nom du tableau
* NIVETB niveau du tableau
* ITYPTB type du tableau
*        1 - entie,  2 - reel,  3 - reel double precision, 4 - complexe
*        11- character*(1), 12 - character*2, ...
* NBARTI longueur en articles du tableau
* COMENT commentaire sur le contenu du tableau
*  
* Remarque : TBDCST(3) nombre maximum actuel de tableaux  
*            TBDCST(4) nombre effectif de tableaux
*            TBDCST(5) adresse de TBNMTB dans AST 
*            TBDCST(9) adresse de TBDCTB dans IST 
*            TBDCST(18) nombre de tableaux crees  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTB,COMENT
*
      CHARACTER PRFXAS*8,CODEOU
      INTEGER   IPRINT,IEME,ITBID,MCBID,NBBID,NBMOTS,NBCAR,MCADRS,MSADRS
     &         ,NIP
      INTEGER       NIVETB,ITYPTB,NBARTI
*  
      INCLUDE 'ALLOC'
*-----------------------------------------------------------------------
      IPRINT=TBDCST(16)
*
*     Un tableau de memes nom/niveau existe-t-il ?
*
      CALL TBRANG (NOMTB,NIVETB,AST(TBDCST(5)),IST(TBDCST(9)),IEME
     &            ,ITBID,MCBID,MSADRS,NBBID)
      IF (IEME.GT.0) THEN
         IF (ITBID.EQ.ITYPTB) THEN  
*           Le tableau existe deja avec le meme type
*           S'il a la meme longueur on le restaure
            IF (NBARTI.LE.NBBID) THEN
               IF (MCBID.LE.0)
     &            CALL TBRECH (NOMTB,NIVETB,NBBID,CODEOU,' ')
               IF (NBARTI.LT.NBBID) CALL TBAJST (NOMTB,NIVETB,NBARTI)
               RETURN
            ELSE
               CALL TBTUER (NOMTB,NIVETB)  
            ENDIF  
         ELSE  
*           Le tableau existe deja sans le meme type: erreur ???
            CALL TBTUER (NOMTB,NIVETB)
*            CALL ERTBAL (6,'*TbCree*',NOMTB,NIVETB)
         ENDIF 
      ENDIF
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                                     ,NOMTB,NIVETB,ITYPTB,NBARTI
      IF (NBARTI.LT.0) THEN
         WRITE (*,*) 'Tableau de type ',ITYPTB
     &             ,' de longueur negative : ',NBARTI
         CALL ERTBAL(10,'*TbCree*',NOMTB,NIVETB)
      ENDIF
*  
*     Agrandissement eventuel de TBDCST(3), donc deplacer TBNMTB et TBDCTB
*
      IF (TBDCST(4).EQ.TBDCST(3)-1) CALL DEPLAC
*
*     Longueur en mots du tableau, et eventuellement en caracteres
*
      CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
*  
*     Assurance sur la place disponible dans les super tableaux
*
      CALL ASSURC (ITYPTB,NBCAR,NBMOTS,*99991) 
*  
      MCADRS=0 
      MSADRS=0 
      IEME=0
      CALL MISEAJ (IEME,AST(TBDCST(5)),IST(TBDCST(9)),NOMTB,ITYPTB
     &            ,NIVETB,MCADRS,MSADRS,NBARTI,NBMOTS,NBCAR,0)
      TBDCST(18)=TBDCST(18)+1
*
      IF (IPRINT.GT.0) WRITE (IPRINT,10001) (PRFXAS(NIP),NIP=1,0,-1)
     &                                  ,NOMTB,NIVETB,ITYPTB,NBARTI,IEME
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'>TbCree ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12,T79,' -> cree')
10001 FORMAT(A,A,'<TbCree ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12,', Rg',I5)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL ERTBAL (7,'*TbCree*',NOMTB,NIVETB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (20 avril 2007)
* - ajout erreur en cas de tableau de longueur negative
* Version 1 : D.Martin (30 Aout 2000)
* Version 0 : O.DeBayser (Juillet 1988)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !TbCree
