*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBCRSU (NOMTB,NIVETB,ITYPTB,NBARTI,NWARTI,COMENT)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Mars 1990)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version # 1.0.1
*  
* Creation en memoire centrale du tableau NOMTB de niveau NIVETB 
* avec le maximum de memoire disponible inferieure ou egale a NBARTI 
*  
*-- Arguments --  
* NOMTB   nom du tableau
* NIVETB  niveau du tableau
* ITYPTB  type du tableau  
*         entier                : ITYPTB = 1
*         reel                  :   "    = 2
*         reel double precision :   "    = 3
*         complexe              :   "    = 4
*         character*(ITYPTB-10) :   "    = 11 et plus ...  
* NBARTI  longueur demandee en articles du tableau en entree
* NWARTI  longueur reelle en articles du tableau en sortie 
* COMENT  commentaire sur le contenu du tableau
*-- Remarque : TBDCST(3) nombre maximum actuel de tableaux  
*              TBDCST(4) nombre effectif de tableaux
*              TBDCST(5) adresse de TBNMTB dans AST 
*              TBDCST(9) adresse de TBDCTB dans IST 
*              TBDCST(18) nombre de tableaux crees  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTB,COMENT
      INTEGER       NIVETB,ITYPTB,NBARTI,NWARTI
*  
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8
      INTEGER IPRINT,IMPERR,NBCAR,NBMOTS,NIP
*-----------------------------------------------------------------------
*     Longueur en mots du tableau a creer, et eventuellement en caracteres 
      CALL TBLONG (NCPMMA,ITYPTB,NBARTI,NBMOTS,NBCAR)
*  
*     Assurance sur la place disponible dans les super tableaux
      CALL ASSURC (ITYPTB,NBCAR,NBMOTS,*10)
*  
*     Il y a la place necessaire pour creer le tableau 
      NWARTI=NBARTI
      CALL TBCREE (NOMTB,NIVETB,ITYPTB,NBARTI,COMENT)
      RETURN
*  
*     Il n'y a pas ce qu'il faut pour loger NBARTI 
*     On utilise le maximum de place disponible
10    CALL TBGONL (NCPMMA,ITYPTB,TBDCST(10),TBDCST(6),NWARTI)
      CALL TBCREE (NOMTB,NIVETB,ITYPTB,NWARTI,COMENT)
      IPRINT=TBDCST(16)
      IF (IPRINT.GT.0) WRITE (IPRINT,10000) (PRFXAS(NIP),NIP=1,0,-1)
     &                        ,NOMTB,NIVETB ,ITYPTB,NWARTI,NWARTI,NBARTI
      IMPERR=TBDCST(17)
      IF (IMPERR.GT.0) WRITE (IMPERR,10002) (PRFXAS(NIP),NIP=1,0,-1)
     &                                ,NOMTB,NIVETB,ITYPTB,NWARTI,NBARTI
*-----------------------------------------------------------------------
10000 FORMAT(A,A,'<Tbcrsu ',A,T32,'/',I6,T39,', Type',I3
     &,T48,', Lg',I12/T11,'Creation de ',I12,' articles pour '
     &,I12,' articles demandes')
10002 FORMAT(A,A,'>Tbcrsu ',A,T32,'/',I6,T39,', Type',I3
     &/T11,'Creation avec ',I12,' articles au lieu de ',I12
     & ,' articles demandes')
      END                                                               !Tbcrsu
