*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBOPEN (NOMTB,ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI
     &                  ,TBNMTB,TBDCTB,INOUT)  
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (1988)
* Derniere modification : D.Martin (7 janvier 2004)
* Version 1.1
*  
* Reouverture eventuelle d'un tableau en memoire secondaire et execution 
* des entrees/sorties a acces direct
*  
* NOMTB   nom du tableau a reouvrir  
* ITYPTB  son type
* NIVETB  son niveau 
* MCADRS  son adresse en memoire centrale
* MSADRS  son adresse en memoire secondaire ;  c'est a dire :
*         (unite logique) + MOTMXR*(age de l'unite logique)  
* NBARTI  son nombre d'articles  
* TBNMTB  tableau des noms de tableaux
* TBDCTB  tableau des indices de description de tableaux 
* INOUT   indice d'entree, de sortie, ou de sortie avec fermeture
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     TBNMTB(*),NOMTB*(*),INOUT*(*),CODE1,CODE2 
      INTEGER       ITYPTB,NIVETB,MCADRS,MSADRS,NBARTI,TBDCTB(*)
*
      INCLUDE 'ALLOC'
*  
      CHARACTER*8   PRFXAS
      LOGICAL       VEX,VOP  
      INTEGER       TY,MOTMXR,NBTABL,NBUTMX,NBUNIT,IPRINT,IMPERR,ISEUIL
     &             ,NBENRX,IUNIT,LRECL,IOERR,ITB,ITABL,NI,MCADR,MSADR
     &             ,LR,IAGE,IAMS,ITAB,ITABR,IG,MCFICH,IRET
     &             ,NBMOTS,NBCAR,I,NIP
      CHARACTER     NOMTBR*6,NOMTAB*6,PARASI*25,ACCES*10,FORMAT*11
*
      INTEGER       NXTNIV,NXTNUF,LASNUF
      COMMON/BORDEL/NXTNIV,NXTNUF,LASNUF
      CHARACTER OSARCH*32,NAMEMA*32,F77CMP*16,AUTODP*3
      COMMON/OS   /OSARCH,NAMEMA,F77CMP,AUTODP
*-----------------------------------------------------------------------
      MOTMXR=TBDCST(2) 
      NBTABL=TBDCST(4) 
      NBUTMX=TBDCST(13)
      NBUNIT=TBDCST(14)
      IPRINT=TBDCST(16)
      IMPERR=TBDCST(17)
      ISEUIL=TBDCST(25)
      NBENRX=TBDCST(27)

*     Inquisition par le nom
      IF (NOMTB(1:2).EQ.'BF') THEN
*        On se debrouille pour qu'il n'y ait pas 6 caracteres dans 
*        les noms de fichier, buffer pour l'instant ....
*
         PARASI(1:3)='BUF' 
         PARASI(4:7)=NOMTB(3:6)
         INQUIRE (FILE=PARASI(1:7),EXIST=VEX,OPENED=VOP,NUMBER=IUNIT
     &           ,RECL=LRECL,ERR=979,IOSTAT=IOERR)
      ELSE 
         INQUIRE (FILE=NOMTB(1:NBCHNT),EXIST=VEX,OPENED=VOP,NUMBER=IUNIT
     &           ,RECL=LRECL,ERR=979,IOSTAT=IOERR)
      ENDIF
      IF ((.NOT.VEX).AND.(INOUT(1:NBCHNT).EQ.'ENTREE')) THEN
         CALL BAISE(' *TbOpen* C''est curieux, on me demande de lire'//
     &  ' dans le tableau'//NOMTB(1:NBCHNT)// 
     &                               ' qui n''existe sous aucun niveau')
      ENDIF
      
      IF ((.NOT.VEX).OR.(VEX.AND..NOT.VOP)) THEN
*        N'existe pas    ou    existe et non ouvert
*        Quelle taille d'enregistrement ? - On prend la taille maximum 
*        parmi les tableaux de meme nom  - le calcul est en mots
         LRECL=1
         ITB=1 
         DO 8 ITABL=1,NBTABL
            CALL GETCHN(TBNMTB,NBCHNT,ITABL,NOMTAB)
            CALL GETATR(TBDCTB(ITB),TY,NI,MCADR,MSADR,LR)  
            IF(NOMTAB.EQ.NOMTB(1:NBCHNT).AND.TY.EQ.ITYPTB) 
     &                                             LRECL =MAX(LRECL,LR)
8           ITB=ITB+NBPART 
         IF(ITYPTB.EQ.3.OR.ITYPTB.EQ.4) LRECL=2*LRECL  
         IF(ITYPTB.GT.10) LRECL=(LRECL*(ITYPTB-10)-1)/NCPMMA+1 
*        Quelle unite logique ?
9        IF(MSADRS.EQ.0) THEN  
*           Aucune unite logique affectee  
            PARASI=' ' 
            NOMTBR=' ' 
            IF(NBUNIT.GT.NBUTMX) THEN  
*              Les unitees logiques sont a priori toutes attribuees
*              il faut en retrouver une disponible 
               IAGE=0  
               IAMS=4  
               DO 10 ITAB=1,NBTABL 
                  CALL GETCHN(TBNMTB,NBCHNT,ITABR,NOMTAB)  
                  MSADR=TBDCTB(IAMS)
*                 Parmi les tableaux correspondant directement a un fichier
*                 et parmi les unites logiques recuperables, on prend la plus  
*                 agee; remarque: l'age est compte avec MOTMXR 
                  IG=(ABS(MSADR)-1)/MOTMXR 
                  IF((NOMTAB(1:2).EQ.'BF'.OR.LRECL.GT.ISEUIL).AND  
     &                                  .MSADR.LT.0.AND.IG.GE.IAGE) THEN
                     IUNIT=ABS(MSADR)-IG*MOTMXR
                     IAGE=IG
                     ITABR=ITAB
                  ENDIF
10             IAMS=IAMS+NBPART
               IF(IAGE.EQ.0) THEN  
*                 Saturation des unitees logiques, aucune n'est recuperable
                  CALL ENCLER(NBUNIT,PARASI(1:8))  
                  CALL BAISE(' *TbOpen* SATURATION DES unites logiques'
     &                       //' : '//PARASI(1:8)//' unites attribuees')
               ENDIF
*              Les tableaux de ce nom n'auront plus d'adresse M.S. 
               CALL GETCHN(TBNMTB,NBCHNT,ITABR,NOMTBR) 
            ELSE
*              on attribue une unite logique de plus
               CODE2=' '
               CALL TBADRS('#Unite',0,MCFICH,CODE1,CODE2)  
               IF(CODE1.NE.' ') CALL BAISE 
     &         ('*TBOPEN* #Unite a des problemes (CODE='//CODE1//')') 
               IRET=0 
*              recherche du prochain numero de fichier non affecte
11             IF(AST(MCFICH-1+NXTNUF).NE.'%') GO TO 12  
               IF(IRET.EQ.1) THEN
                  INQUIRE(UNIT=NXTNUF,OPENED=VOP) 
                  IF(.NOT.VOP) GO TO 12
               END IF
               NXTNUF=NXTNUF+1  
               IF(NXTNUF.GT.LASNUF) THEN
                  IF(IRET.GE.2) CALL BAISE
     &            ('*TBOPEN* Plus d''unite logique disponible')
*                 On refait un tour a partir de la premiere unite possible 
                  NXTNUF=10
*                 (Cf SDEXPLO/KLUNIT pour concordance sur "10")
                  IRET=IRET+1
                  GO TO 11
               ENDIF
               GO TO 11
12             IUNIT=NXTNUF
               AST(MCFICH-1+NXTNUF)='%' 
            ENDIF  
*           L'age des unitees logique est compte a partir de la valeur 
*           initiale de NBUNIT
*           (NBUNIT=nbr d'unites logiques ouvertes, different de NXTNUF) 
            MSADRS=-(IUNIT+MOTMXR*NBUNIT)  
            TBDCST(14)=NBUNIT+1
*           Inquisition par l'unite logique pour verification  
            INQUIRE(UNIT=IUNIT,EXIST=VEX,OPENED=VOP,NAME=PARASI,ACCESS=
     &                           ACCES,FORM=FORMAT,ERR=978,IOSTAT=IOERR)
            IF(VOP) THEN
               IF(PARASI.EQ.NOMTBR(1:NBCHNT)) THEN 
                  CALL ENCLER(IUNIT,NOMTAB(1:6))
                  CALL BAISE(' *TbOpen* Erreur unite logique '//
     &               NOMTAB(1:6)//' ouverte sur le fichier: '//PARASI//
     &                 ' a acces'//ACCES//' '//FORMAT//', alors que '//
     &                 'l''adresse en memoire secondaire est negative')
               ENDIF
*              L'unite logique est ouverte sur quelqu'un ...!!!!
               WRITE(IMPERR,95) PRFXAS (0),IUNIT,PARASI,ACCES,FORMAT
*              On la ferme pour la recuperer
*              CLOSE(UNIT=IUNIT,STATUS='KEEP',ERR=977,IOSTAT=IOERR)
               GO TO 9 
            ENDIF  
            IF(NOMTBR(1:1).NE.' ') THEN
*              Mise a jour des differends niveaux du tableau qui vient 
*              d'etre ferme, ou qui l'etait deja et dont l'unite logique
*              vient d'etre recuperee  
               ITB=4
               DO 25 ITABL=1,NBTABL
                  CALL GETCHN(TBNMTB,NBCHNT,ITABL,NOMTAB)  
                  IF(NOMTAB.EQ.PARASI(1:NBCHNT).AND.NOMTAB.EQ.NOMTBR)  
     &               CALL BAISE(' * TbOpen* Erreur, une unite logique'  
     &                          //' concerne deux tableaux de noms'
     &                          //' differents, a la fois')
                  IF(NOMTAB.EQ.NOMTBR) TBDCTB(ITB)=0
25                ITB=ITB+NBPART
            ENDIF  
         ELSE IF(MSADRS.LT.0) THEN 
*           il y a une unite logique affecte, elle est recuperee
            IG=(ABS(MSADRS)-1)/MOTMXR  
            IUNIT=ABS(MSADRS)-IG*MOTMXR
         ELSE  
            CALL ENCLER (MSADRS,PARASI(1:8))
            CALL BAISE  (' *TbOpen* Erreur : contradiction entre '//
     &            'l''etat du tableau'//NOMTB(1:NBCHNT)//' et le signe '
     &               //' de son adresse en M.S. : MSADRS='//PARASI(1:8))
         ENDIF
*        Seules les ouvertures de fichiers tampons sont realisees avec des 
*        ordre OPEN dependant de l4OS
         IF(NOMTB(1:2).EQ.'BF') THEN
*           On se debrouille pour qu'il n'y ait pas 6 caracteres dans  
*           les noms de fichier, buffer pour l'instant ....
*           sinon baise au ccsa ...
            PARASI(1:3)='BUF'  
            PARASI(4:7)=NOMTB(3:6) 
            CALL OSIOPN (OSARCH,IUNIT,PARASI(1:7),'UNKNOWN'
     &                  ,'DIRECT',LRECL,IMPERR)
         ELSE  
            CALL OSIOPN (OSARCH,IUNIT,NOMTB(1:NBCHNT),'UNKNOWN'
     &                  ,'DIRECT',LRECL,IMPERR)
         ENDIF 
         MSADRS=ABS(MSADRS)
*        Mise a jour des differends niveaux du tableau re-ouvert
         ITB=4 
         DO 35 ITABL=1,NBTABL  
            CALL GETCHN(TBNMTB,NBCHNT,ITABL,NOMTAB)
            IF(NOMTAB.EQ.NOMTB(1:NBCHNT)) TBDCTB(ITB)=MSADRS
35          ITB=ITB+NBPART 
      ELSE 
*        Existe et ouvert  
*        Verification sur l'unite logique (ici MSADRS doit etre positif)
         IAGE=(MSADRS-1)/MOTMXR
         MSADR=MSADRS-IAGE*MOTMXR  
         IF(IUNIT.NE.MSADR) THEN
*           Conflit entre l'unite logique retrouvee et celle figurant  
*           dans la table de description
            CALL ENCLER(IUNIT,PARASI(1:4)) 
            CALL ENCLER(MSADR,PARASI(5:12))
            CALL ENCLER(IAGE,PARASI(13:20))
            CALL BAISE(' *TbOpen* Erreur : conflit d''unite logique,'//
     &         ' inquisition: IUNIT='//PARASI(1:4)//', en memoire'//
     &         ': MSADRS='//PARASI(5:12)//' (AGE:'//PARASI(13:20)//')')
         ENDIF 
      ENDIF

      NBMOTS=NBARTI
      NBCAR=0  
      IF (ITYPTB.GE.3.AND.ITYPTB.LE.4) NBMOTS=2*NBARTI  
      IF (ITYPTB.GT.10) THEN
         NBMOTS=((ITYPTB-10)*NBARTI-1)/NCPMMA+1
         NBCAR=NBMOTS*NCPMMA
      ENDIF
      IF (INOUT(1:NBCHNT).EQ.'ENTREE') THEN 
         IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN  
            READ (IUNIT,REC=NIVETB,ERR=999,IOSTAT=IOERR)
     &           (RST(MCADRS-1+I),I=1,NBMOTS)
            TBDCST(19)=TBDCST(19)+1
         ELSEIF (ITYPTB.GT.10) THEN
            READ (IUNIT,REC=NIVETB,ERR=998,IOSTAT=IOERR)
     &           (AST(MCADRS-1+I),I=1,NBCAR)
         ENDIF 
      ELSEIF ((INOUT(1:NBCHNT).EQ.'SORTIE').OR.
     &         (INOUT(1:NBCHNT).EQ.'SRTFRM')) THEN
         IF (ITYPTB.GE.1.AND.ITYPTB.LE.4) THEN  
            WRITE (IUNIT,REC=NIVETB,ERR=989,IOSTAT=IOERR)
     &            (RST(MCADRS-1+I),I=1,NBMOTS)
            TBDCST(20)=TBDCST(20)+1
         ELSEIF (ITYPTB.GT.10) THEN
            WRITE (IUNIT,REC=NIVETB,ERR=988,IOSTAT=IOERR)
     &            (AST(MCADRS-1+I),I=1,NBCAR)
         ENDIF 
      ELSE 
*        Operation demandee non reconnue
         CALL ENCLER(NIVETB,PARASI(1:4))
         CALL BAISE  (' *TbOpen* Erreur : '//INOUT(1:NBCHNT)// 
     &             ', type d''operation non reconnue pour le tableau '//
     &                      NOMTB(1:NBCHNT)//' de niveau '//PARASI(1:4))
      ENDIF
      IF (INOUT(1:NBCHNT).EQ.'SRTFRM') THEN 
*        Sortie avec fermeture du fichier  
         CLOSE (UNIT=IUNIT,STATUS='KEEP',ERR=987,IOSTAT=IOERR)  
*        Mise a jour des differends niveaux du tableau ferme
         ITB=0 
         DO 50 ITABL=1,NBTABL  
            CALL GETCHN(TBNMTB,NBCHNT,ITABL,NOMTAB)
            IF (NOMTAB.EQ.NOMTB(1:NBCHNT)) THEN 
               MSADRS=-MSADRS  
               TBDCTB(ITB+4)=MSADRS
            ENDIF  
            ITB=ITB+NBPART 
50       CONTINUE  
      ENDIF
      IF (IPRINT.GT.0) THEN 
         IF (INOUT(1:NBCHNT).EQ.'ENTREE') THEN
            WRITE(IPRINT,140) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                      ,'Lecture'
         ELSEIF (INOUT(1:NBCHNT).EQ.'SORTIE') THEN
            WRITE(IPRINT,140) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                       ,'Ecriture'
         ELSEIF (INOUT(1:NBCHNT).EQ.'SRTFRM') THEN
            WRITE(IPRINT,140) (PRFXAS(NIP),NIP=1,0,-1),NOMTB,NIVETB
     &                       ,'Ecriture et fermeture'
         ENDIF
      ENDIF
      RETURN
*-----------------------------------------------------------------------
140   FORMAT(A,A,'<TbOpen ',A,T32,'/',I6,T39
     &,'Ouverture du buffer pour ',A)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
999   PARASI='READ-RST'
      GO TO 1000
998   PARASI='READ-AST'
      GO TO 1000
989   PARASI='WRITE-RST'
      GO TO 1000
988   PARASI='WRITE-AST'
      GO TO 1000
987   PARASI='CLOSE2-KEEP'
      GO TO 1000
979   PARASI='INQUIRE-FILE'
      GO TO 1000
978   PARASI='INQUIRE-UNIT'
      GO TO 1000
*977  PARASI='CLOSE1-KEEP'
1000  CALL STIMPR(IMPERR)
      CALL BAISE(' *TbOpen* Erreur '//PARASI)
95    FORMAT(A,T10,' Unite logique ',I5,' ouverte sur le fichier: ',A,  
     &     ' a acces ',A,' ',A/'  on la ferme pour la recuperer')
                                                                   END  
