*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE  GHELMS (TYNOYO,K,CORM,CORP,E,D1EM,D1EP,D2EMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1996)
* Derniere modification : D.Martin (28 Novembre 1997)
* Version 1.0.1
*  
* Solution Elementaire au point 'CORM' de l'Equation de Helmholtz dans R2
* avec symetrie par rapport au plan x=0
*  
*-- Arguments d'entree -- 
* TYNOYO: type du noyau de Green a calculer
* K     : constante K de J0(K*R)+iY0(K*R)  
* CORM  : coordonnees du point source  
* CORP  : coordonnees du point image
*-- Arguments de sortie --
* E     : J0(K*R)+iY0(K*R) 
* D1EM  : derivees de E par rapport aux coordonnees de M
* D1EP  : derivees de E par rapport aux coordonnees de P
* D2EMP : derivees secondes croisees dans l'ordre suivant  
*         d2E/dxmdxp, d2E/dxmdyp, d2E/dymdxp, d2E/dymdyp
*  
*--  Remarques: La multiplication par i/4 n'est pas effectuee dans ce S-P 
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      REAL    K,CORP(*),CORM(*)
      COMPLEX E,D1EP(*),D1EM(*),D2EMP(*)
*
      REAL    CORFM(2)
      COMPLEX F,D1FP(2),D1FM(2),D2FMP(4)
*-----------------------------------------------------------------------
      CALL  GHLMZ2 (TYNOYO,K,CORM ,CORP,E,D1EM,D1EP,D2EMP)
      CORFM(1)= CORM(1)
      CORFM(2)=-CORM(2)
      CALL  GHLMZ2 (TYNOYO,K,CORFM,CORP,F,D1FM,D1FP,D2FMP)
      E=E+F
      D1EP(1)=D1EP(1)+D1FP(1)
      D1EP(2)=D1EP(2)+D1FP(2)
*     On prend le gradient en M et non au point symetrique M'(xM,-yM)
      D1EM(1)=D1EM(1)+D1FM(1)
      D1EM(2)=D1EM(2)-D1FM(2)
      D2EMP(1)=D2EMP(1)+D2FMP(1)
      D2EMP(2)=D2EMP(2)+D2FMP(2)
      D2EMP(3)=D2EMP(3)-D2FMP(3)
      D2EMP(4)=D2EMP(4)-D2FMP(4)
      RETURN
                                                                    END !Ghelms
