*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE GHLOIN (TYNOYO,K,CORM,CORP,E,D1EM,D1EP,D2EMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1991)  
* Derniere modification : D.Martin (7 Mai 2002)
* Version 1.0.1
*   
* Champ lointain au point 'CORM' pour l'acoustique dans R2  
*   
*-- Arguments d'entree -- 
* TYNOYO: type du noyau de Green a calculer 
* K     : constante K de J0(K*R)+iY0(K*R)   
* CORM  : coordonnees du point source   
* CORP  : coordonnees du point image
*-- Arguments de sortie -- 
* E     : EXP ( I*K*(OM.OP)/norme de OM 
* D1EM  : derivees de E par rapport aux coordonnees de M
* D1EP  : derivees de E par rapport aux coordonnees de P
* D2EMP : derivees de E par rapport aux coordonnees de M puis P 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO  
      REAL    K,CORP(*),CORM(*)
      COMPLEX E,D1EP(*),D1EM(*),D2EMP(*)
*
      INTEGER IRANG2,I,J
      REAL    X,ROM2,ROMOP,ROM
      COMPLEX IKR
*-----------------------------------------------------------------------
      ROM2 =0.  
      ROMOP=0.  
      DO 10 I=1,2
         X=CORM(I)  
         ROM2 =ROM2 +X*X
         ROMOP=ROMOP+X*CORP(I)
10    CONTINUE
      IF (ROM2.LT.1.E-06) GO TO 999  
      ROM=SQRT(ROM2)
      IKR=(0.,-1.)*K*ROMOP/ROM  
*   
*     Champ lointain
      E=EXP(IKR)
      DO 15 I=1,2
         D1EM(I) = (0.,1.)*K*CORM(I)*E/ROM  
         D1EP(I) = -D1EM(I)
15    CONTINUE 
*   
      IF (TYNOYO(:3).EQ.'FOU'.OR.TYNOYO(:3).EQ.'NEU') THEN   
         IKR=K*K*E/ROM2 
         IRANG2=1   
         DO 21 I=1,2 
            DO 20 J=1,2  
               D2EMP(IRANG2)=IKR*CORM(I)*CORM(J)
               IRANG2=IRANG2+1
20       CONTINUE
21    CONTINUE
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
999   WRITE (*,1000) (CORP(I),I=1,2),(CORM(I),I=1,2) 
      CALL BAISE  ('Erreur dans le maillage ?')
1000  FORMAT('*Ghloin* On essaie de calculer la fonction de Green pour'
     &,' une distance < 10**-6'/T11,'XP=',E12.4,' YP=',E12.4,
     &                        '      XM=',E12.4,' YM=',E12.4/) 
                                                                    END !Ghloin
