*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION SXHL2D (K,COR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1990)
* Derniere modification : D.Martin (7 Mai 2002)
* Version 1.0.1
*
* Champ de pression diffracte, d'une onde plane incidente PHIW= EXP(i*K*x),
* par un cylindre circulaire infini rigide de rayon unite
* et pour une condition d'impedance de type Dirichlet:
* Representation sous forme d'une serie de fonctions de BESSEL
*
* Bibliographie : ABRAMOVITZ et STEGUN - Handbook of Math. Functions
*                 (Bessel fonctions of integer order , pp.358-436)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL    K,COR(*)
      COMPLEX SXHL2D
*
      INTEGER NDIM,NMAX
      PARAMETER ( NDIM = 2 , NMAX = 50 )
      LOGICAL LASTCL
      REAL    KKEEP,KRKEEP   
      COMPLEX CIN,H1PRIM,COEFAN,HNZERO
      REAL    AJYN(NMAX+1) 
      COMMON/KEEPD/COEFAN(NMAX),HNZERO(NMAX+1),KKEEP,KRKEEP,NBTRMH
      DATA EPSIL/1.E-10/
*-----------------------------------------------------------------------
      R2=0. 
      DO 1 IDIM=1,NDIM  
         R2=R2+COR(IDIM)*COR(IDIM)
1     CONTINUE  
      R=SQRT(R2)
      COSTET=COR(1)/R   
      SINTET=COR(2)/R   
      IF (ABS(K-KKEEP).GT.1.E-10) THEN   
*   
*        Calcul des coefficients AN du developpement en serie   
*   
         CALL BEYN   (K,NMAX,AJYN)
         DO 2 I=1,NMAX+1
            HNZERO(I)=CMPLX (0.,AJYN(I))
2        CONTINUE 
         CALL BEJN   (K,NMAX,AJYN)
         DO 3 I=1,NMAX+1
            HNZERO(I)=HNZERO(I)+AJYN(I)
3        CONTINUE
         COEFAN(1)=-REAL (HNZERO(1))/HNZERO(1)   
         CIN=(0.,1.)
         LASTCL=.FALSE. 
         DO 4 I=2,NMAX  
            H1PRIM=HNZERO(I)   
            COEFAN(I)=-2.*CIN*REAL (H1PRIM)/H1PRIM  
            CIN=(0.,1.)*CIN
            IF (LASTCL) GOTO 5 
            IF (ABS(COEFAN(I)).LE.EPSIL) LASTCL=.TRUE.  
4        CONTINUE   
         CALL BAISE
     &   ('*Sxhl2d Convergence non atteinte : augmenter NMAX ?')
5        NBTRMH=I-1 
         WRITE (*,*) 'Sxhl2d K,NMAX,COEFAN :'
     &              ,K,NMAX,(COEFAN(III),III=1,I)   
      ENDIF
*   
      R=K*R 
      IF (ABS(K-KKEEP).GT.EPSIL.OR.ABS(R-KRKEEP).GT.EPSIL) THEN
         CALL BEYN   (R,NBTRMH,AJYN)
         DO 6 I=1,NBTRMH+1  
            HNZERO(I)=CMPLX (0.,AJYN(I))
6        CONTINUE
         CALL BEJN   (R,NBTRMH,AJYN)
         DO 7 I=1,NBTRMH+1  
            HNZERO(I)=(HNZERO(I)+AJYN(I))*COEFAN(I)
7        CONTINUE
      ENDIF
      KKEEP=K   
      KRKEEP=R  
*   
*    Calcul du Cosinus et de la serie : 
*   
      SXHL2D=HNZERO(1)
      COSNTE=COSTET 
      SINNTE=SINTET 
      DO 8 I=2,NBTRMH   
         SXHL2D=SXHL2D+COSNTE*HNZERO(I)
         COSSAR=COSNTE  
         COSNTE=COSTET*COSNTE-SINTET*SINNTE 
         SINNTE=SINNTE*COSTET+SINTET*COSSAR
8     CONTINUE
*
*     IF(ABS(HNZERO(NBTRMH+1)).GT.1.E-8)
*    *WRITE (*,20) NBTRMH+1,HNZERO(NBTRMH+1),COEFAN(NBTRMH+1),R 
*20   FORMAT(' IMAX=',I3,' Terme neglige:',2E11.4,' Coef:',2E11.4,' KR='
*    *,E11.4)   
                                                                    END !Sxhl2d
