*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION CEXPE1 (INTPA,Z)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1980)
* Derniere modification (D.Martin) le 23 janvier 1997
*  
* Calcul de CEXPE1 =
*  E1(Z)*EXP(Z)                                           si ABS(INTPA).EQ.1
*  --> Retrait de la singularite logarithmique  ||Z|| petit :
*  E1(Z)*EXP(Z)+CLOG(Z)+EULER                             si ABS(INTPA).EQ.2
*  --> Retrait du developpement asymptotique ||Z|| grand
*  E1(Z)*EXP(Z)-SOMME(1,INTPA-2) ((-1)*((N-1)!/(-Z)**N))  si ABS(INTPA).GT.2
* De plus si INTPA.<0   CEXPE1=CEXPE1+I*PI*EXP(Z)  
*  
*  ou E1 est la fonction integrale exponentielle complexe  
*  et CEULER la constante Gamma d'Euler : .5772156649  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER INTPA
      COMPLEX CEXPE1,Z
*
      INTEGER IN,I
      REAL    CEULER,PI
      COMPLEX CU,CV,CW,CUNSRZ,CE1
      PARAMETER ( CEULER = .57721566 , PI = 3.1415926 )
*-----------------------------------------------------------------------
      CEXPE1=CE1(Z)
*  
      IN=ABS(INTPA)
      IF(IN.EQ.2) THEN 
*  
*        Retrait de la singularite logarithmique
*  
         CEXPE1=CEXPE1+LOG(Z)+CEULER
      ELSEIF (IN.GT.2) THEN
*  
*        Developpement asymptotique d'ordre ABS(INTPA-2) de EXP(Z)*E1(Z)
*  
         CUNSRZ=-1./Z  
         CU=CUNSRZ  
         CW=CU*CU 
         CV=CW
         DO 1 I=1,IN-3 
            CU=CU+CW  
            CW=(I+1)*CUNSRZ*CW
            CV=CV+CW
1        CONTINUE  
         CEXPE1=CEXPE1+CMPLX(REAL(CU),AIMAG(CV)) 
*  
      ENDIF
      IF (INTPA.LE.0) CEXPE1=CEXPE1+CMPLX(0.,PI)*EXP(Z)
                                                                    END !Cexpe1
