*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GD23 (INTPA,NP,AR,AZ,EXPAZ,G3,G2,D3,D2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & A.Clement
* Derniere modification (D.Martin) le 12 Avril 1996
*- 
*-Calcul des integrales suivantes :
*-  
*1) Si INTPA est positif et inferieur ou egal a 99  
* G2+G3=4/Pi*Somme(0,Pi/2) Re(EXP(q)*E1(q)) dt  
* D2+D3=-4/Pi*Somme(0,Pi/2) Im(EXP(q)*E1(q)-1./q)*cos t dt  
*2) Si INTPA est negatif
* G2+G3=4/Pi*Somme(0,Pi/2) Re(EXP(q)*E1(q)+i*Pi*EXP(q)) dt  
* D2+D3=-4/Pi*Somme(0,Pi/2) Im(EXP(q)*E1(q)(q)-1/q+i*Pi*EXP(q)*cos t dt 
*                ou q = AZ+i*AR*cos t
*3) Sinon
* G2+G3= -2*EXP(AZ)*Somme(0,-AZ) EXP(T) (T**2+AR**2)(**-1/2) dt 
* D2+D3=2*EXP(AZ)*R*Somme(0.-AZ) EXP(T) (T**2+AR**2)(**-3/2) dt 
*  en outre le calcul de l'integrale depend de la valeur exacte de INTPA
*-  
*N.B. On trouvera la definition des termes G2,G3,D2,D3 dans le rapport  
*     d'Alain CLEMENT (Rapport ENSTA no 165 (Aout 1982) 
*  
*-- Arguments d'entree -- 
* INTPA entier relatif indiquant la formule a utiliser
* NP    nombre de pas d'integration de la formule de quadrature  
* AR    AN*R     (R:distance horizontale entre deux points)  
* AZ    AN*(Z+C)  (Z+C:somme des cotes des deux points)  
*  ou AN=Omega*Omega/G est le nombre d'onde 
*            (Omega est la pulsation, G la cste de gravite) 
* EXPAZ  EXP(AZ) ( calcule prealablement a l'appel de ce sous-programme )
*-- Arguments de sortie --
* G2 partie reelle de l'integrale
* D2 partie imaginaire de l'integrale
* G3 partie reelle du complement (le cas echeant)
* D3 partie imaginaire du complement
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER INTPA,NP
      REAL    AR,AZ,EXPAZ,G3,G2,D3,D2
*
      INTEGER I,IN,INM3,IP,J,JJ1,JJN,JPN,NN,NBINPP
     &       ,POLYQ(45)
      DATA POLYQ/-1,-3,3,-6,15,-15,-10,45,-105,105,-15,105,-420,945,-945
     &,-21,210,-1260,4725,-10395,10935,-28,378,-3150,17325,-62370,135135
     &,-135135,-36,630,-6930,51975,-270270,945945,-2027025,2027025, -45
     &,990,-13860,135135,-945945,4729725,-16216200,34459425,-34459425/
      REAL    AR2,ARD2,AZAT,AZAT3,CEF1,CEF2,D4,H,PR,T,R0,PN,SURR,SURPR
     &       ,TEG,TEGI
      COMPLEX ANUQ,CEXPE1,X,Y,QOQOL,TEGRAX,AFINT(3)
      DOUBLE PRECISION HCOS,HSIN,PNP1,COSAT,SINAT,EX
     &                ,G41,G42,D41,D42,DJ2P1,DJ2M1,DICOEF,SURPR2,SURR2
     &                ,POLYP(62) 
      DATA POLYP/  
     2.2D+1,-.1D+1,
     3-.6D+1,.9D+1,
     4.24D+2,-.72D+2,.9D+1,
     5-.12D+3,.6D+3,-.225D+3,  
     6.72D+3,-.54D+4,.405D+4,-.225D+3, 
     7-.504D+4,.5292D+5,-.6615D+5,.11025D+5,
     8.4032D+5,-.56448D+6,.10584D+7,-.3528D+6,.11025D+5,
     9-.36288D+6,.653184D+7,-.1714608D+8,.95256D+7,-.893025D+6,
     O.36288D+7,-.81648D+8,.285768D+9,-.23814D+9,.4465125D+8,-.893025D+6
     1,-.399168D+8,.1097712D+10,-.4939704D+10,.5762988D+10,-.180093375D
     &+10,.108056025D+9,
     2.4790016D+9,-.158070528D+11,.88914672D+11,-.138311712D+12,.6483361
     &5D+11,-.77800338D+10,.1080856025D+9, 
     3-.62270208D+10,.2428538112D+12,-.1669619952D+13,.3339239904D+13, 
     &-.2191376187D+13,.4382752374D+12,-.18261468225D+11,  
     4.871782912D+11,-.39666122496D+13,.327245510592D+14,  
     &-.81811377648D+14,.71584955442D+14,-.214754866326D+14,
     &.178962388605D+13,-.18261468225D+11/ 
*     5-.1307674368D+13,.6865290432D+14,-.66936581712D+15, 
*     &.20452844412D+16,-.230094499635D+16,.966396898467D+15,  
*     &-.13422179145375D+15,.4108839350625D+13/
*-----------------------------------------------------------------------
      G3=0.
      G2=0.
      D3=0.
      D2=0.
      IF (AZ.GE.-1.E-07) RETURN 
      IN=ABS (INTPA)
      TEGRAX=(0.,0.)
      H=0. 
      PR=SQRT (AR*AR+AZ*AZ) 

      IF (IN.GE.100) GOTO 100  
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Formulations 1 A 3.  
*     Integration de la formule 'Near-Field' (exponentielle integrale) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
*     Partie commune aux trois formulations
*  
      IF (AR.LT.1.E-06.OR.NP.EQ.0) THEN 
         ANUQ=CMPLX (AZ,.7071067*AR)
         QOQOL=CEXPE1 (INTPA,ANUQ)
         G2=REAL (QOQOL)
         G2=G2+G2  
         D2=-1.273239545*AIMAG(QOQOL)  
      ELSEIF (NP.GT.0) THEN
*       Calcul de l'integrale par le regle de Simpson des 3 8iemes 
         EX=.52359877559830D0/NP
         HCOS=COS (EX)  
         HSIN=SIN (EX)  
         ANUQ=CMPLX (AZ,AR) 
         TEGRAX=CEXPE1 (INTPA,ANUQ)
         COSAT=HCOS
         SINAT=HSIN
         DO 2 I=1,NP
            DO 1 J=1,3 
               T=ABS (COSAT)
               ANUQ=CMPLX (AZ,AR*T) 
               QOQOL=CEXPE1 (INTPA,ANUQ)
               AFINT(J)=CMPLX (REAL (QOQOL),(AIMAG (QOQOL)*T))
               EX=COSAT
               COSAT=COSAT*HCOS-HSIN*SINAT 
               SINAT=SINAT*HCOS+HSIN*EX
1           CONTINUE
            X=AFINT(1)+AFINT(2)
            Y=AFINT(3) 
            TEGRAX=TEGRAX+X+X+X+Y+Y
2        CONTINUE
         TEGRAX=.25*(TEGRAX-Y)/NP  
         G2= REAL (TEGRAX)  
         D2=-AIMAG (TEGRAX) 
      ENDIF
*  
*     Calcul de la partie integree analytiquement de la derivee (D3)  
*  
      R0=1./PR 
      D3=AR*R0/(PR-AZ) 
      D3=-(D3+D3)  
*  
*     Calculs complementaires diffencies selon la valeur de INTPA  
*  
      D4=0.
      IF (IN.EQ.2) THEN 
*  
*       IN=2 ... Formulation no 2  
*       On rajoute separement le singularite logarithmique de E1
*       que l'on a evite de calculer dans la fonction CEXPE1
*  
         D3=D3*(1.+PR)+4.  
         G3=LOG (DBLE (PR-AZ))-.11593151565841245D0  
*  
      ELSEIF (IN.GT.2) THEN
*  
*       IN>2 ... Formulation no 3  
*       Calcul de la somme de la serie par les IN-2 1ers polynomes Pn  
         HCOS=AZ/AR
         HSIN=HCOS*HCOS
         ARD2=AR*R0*R0 
         G3=R0 
         R0=ARD2*R0
         D4=R0 
         INM3=IN-3 
         PN=-HCOS  
         JJN=0 
         IP=1  
         DO 4 NN=1,INM3
            G3=R0*PN+G3
            JJ1=JJN+1  
            JJN=JJ1+(NN+1)/2
            PNP1=POLYP(JJ1)
            JJ1=JJ1+1  
*           Calcul des Pn+1 (Algorithme de Horner) 
            DO 3 JPN=JJ1,JJN
               PNP1=PNP1*HSIN+POLYP(JPN)
3           CONTINUE
            IF (IP.EQ.-1) PNP1=HCOS*PNP1
            IP=-IP 
            R0=R0*ARD2 
            PN=PN+PN*SNGL (HSIN)
            D4=D4+R0*((NN+1)*PN+SNGL (HCOS*PNP1))
            PN=PNP1
4        CONTINUE
      ENDIF
      G3=-(G3+G3)  
      D3=D3+D4+D4  
      RETURN
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Formulation no 4 (Integrale d'exponentielles simples)
*     Integration directe de la formule d'Haskind modifiee (In=100)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
100   NBINPP=IN-100
      IF (AZ.GT.-1.E-06.OR.(NBINPP.LE.0.AND.NP.LE.0)) THEN  
         D2=1./(AR*AR+(AZ*AZ)/4.)  
         T=SQRT (D2)
         G2=-AZ*EXP (AZ/2.) 
         D2=(AR+AR)*T*D2*G2
         G2=-(T+T)*G2  
         NP=0  
      ELSEIF (NBINPP.LE.0) THEN
         T=0.  
         H=-AZ/(NP+NP+NP)  
         CEF1=.75*EXPAZ
         HCOS=1.D0 
         EX=EXP (DBLE (H))
         IF (AR.LE.1.) THEN 
*           Changement de variable pour R petit
            H=H/AR 
            CEF1=CEF1*H
            CEF2=CEF1/AR
            AR2=1. 
            TEGRAX=(1.,1.) 
         ELSE  
            AR2=AR*AR  
            CEF1=H*CEF1
            CEF2=CEF1*AR
            TEGRAX=CMPLX (1./AR,1./(AR2*AR))
         ENDIF
*        Calcul de l'integrale par le regle de Simpson des 3 8emes 
         DO 102 I=1,NP 
            DO 101 J=1,3
               T=T+H
               HCOS=HCOS*EX
               AZAT=1./(T*T+AR2)
               AZAT3=HCOS*SQRT (AZAT)
               AFINT(J)=CMPLX (AZAT3,AZAT3*AZAT)
101         CONTINUE
            X=AFINT(1)+AFINT(2)
            Y=AFINT(3) 
            TEGRAX=TEGRAX+X+X+X+Y+Y
102      CONTINUE
         TEGRAX=TEGRAX-Y
         G2=-CEF1*REAL (TEGRAX) 
         D2=CEF2*AIMAG (TEGRAX) 
      ELSE 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*     Formulation no 5 (Integrale d'exponentielles simples)
*     Integration de la formule d'Haskind modifiee (In>100)
*     apres IN-100 integrations par parties (polynomes Qn) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
         AR2=AR*AR 
         SURPR=1./PR
         SURPR2=SURPR*SURPR
         TEG=-SURPR/EXPAZ  
         TEGI=TEG*AR*SNGL (SURPR2)  
         SURR=1./AR
         SURR2=SURR*SURR
         G3=TEG+SURR
         D3=TEGI+SNGL (SURR2)
         IF (NBINPP.EQ.1) THEN  
*  
*           Une seule integration par parties (INTPA=101)  
*  
            IF (NP.GT.0) THEN
               H=-AZ/(NP+NP+NP)
               T=0.
               EX=EXP (DBLE (H)) 
               HCOS=1.D0
*              Calcul de l'integrale
               DO 104 I=1,NP
                  DO 103 J=1,3 
                     T=T+H 
                     HCOS=HCOS*EX  
                     AZAT=1./(T*T+AR2) 
                     AZAT3=SQRT (AZAT)*AZAT*T*HCOS  
                     AFINT(J)=CMPLX (AZAT3,AZAT3*AZAT)
103               CONTINUE  
                  X=AFINT(1)+AFINT(2)  
                  Y=AFINT(3)
                  TEGRAX=TEGRAX-(X+X+X+Y+Y)
104            CONTINUE
               TEGRAX=.75*H*EXPAZ*(TEGRAX+Y)
               G2=REAL (TEGRAX) 
               D2=-(AR+AR+AR)*AIMAG (TEGRAX)
            ENDIF 
         ELSE  
*  
*           Plus d'une integration par parties (IN > 101)  
*  
            DICOEF=1.D0
            G41= TEG
            G42= SURR  
            D41= TEGI  
            D42= SURR2 
            DJ2M1=-1.D0
            HSIN=-AZ
            JJN=0  
*           Calcul de la somme du developpement
            DO 106 J=1,NBINPP-1
               DJ2M1=DJ2M1+2.D0
               DJ2P1=DJ2M1+2.D0
               DICOEF=DICOEF*DJ2M1 
               PNP1=1.D0
               JJ1=JJN 
               JJN=JJN+J
               JJ1=JJ1+1
*              Calcul des Qn+1 (Algorithme de HORNER)  
               DO 105 JPN=JJ1,JJN  
                  PNP1=PNP1*HSIN+POLYQ(JPN)
105            CONTINUE
               G41=G41*SURPR2  
               G42=G42*SURR2
               D41=D41*SURPR2  
               D42=D42*SURR2
               G3=G3+SNGL(DICOEF*(G41*PNP1+G42*POLYQ(JJN)))
               D3=D3+SNGL(DICOEF*DJ2P1*(D41*PNP1+D42*POLYQ(JJN)))  
106         CONTINUE
            IF (NP.GT.0) THEN
               H=-AZ/(NP+NP+NP)
               HSIN=0.D0
               T=0.
               EX=EXP (DBLE (H)) 
               HCOS=1.D0
*              Calcul de l'integrale
               DO 109 I=1,NP
                  DO 108 J=1,3 
                     T=T+H 
                     HCOS=HCOS*EX  
                     AZAT=1./(T*T+AR2) 
                     AZAT3=SQRT(AZAT)*AZAT*T*HCOS  
                     AFINT(J)=CMPLX(AZAT3,AZAT3*AZAT)  
                     PNP1=1.D0 
                     HSIN=HSIN+H
                     DO 107 JPN=JJ1,JJN
                        PNP1=POLYQ(JPN)+PNP1*HSIN  
                        AFINT(J)=AFINT(J)*AZAT
107                  CONTINUE 
                     AFINT(J)=AFINT(J)*SNGL(PNP1)  
108               CONTINUE
                  X=AFINT(1)+AFINT(2)  
                  Y=AFINT(3)
                  TEGRAX=TEGRAX-(X+X+X+Y+Y)
109            CONTINUE
               TEGRAX=.75*H*EXPAZ*SNGL (DICOEF*DJ2P1)*(TEGRAX+Y)
               G2=REAL (TEGRAX) 
               D2=-SNGL (DJ2P1+2.D0)*AR*AIMAG (TEGRAX)
            ENDIF 
         ENDIF
         CEF1=EXPAZ+EXPAZ  
         G3=CEF1*G3
         D3=-CEF1*D3
      ENDIF
                                                                    END !Gd23
