*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GD4 (INTPA,R,G4,D4)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1981)
* Derniere modification (D.Martin) le 12 Avril 1996
*  
* Calcul de :  
*  G4 =-2.*i*J0(R) et D4 =2.*i*J1(R)                              si INTPA.LE.0 
*  G4 =2.*H0(R)-2*i*J0(R) et D4 =-2.*(H1(R)-2/PI)+2*i*J1(R)  si 0 < INTPA < 100  
*  G4 =H0(R)+Y0(R)-2*i*J0(R) et D4=-(H1(R)-2/PI+Y1(R))+2*i*J1(R) si 100 < INTPA  
*
*  ou J0  (resp.J1) est la fonction de Bessel de 1ere espece d'ordre 0 (resp. 1)
*     Y0  (resp.Y1) est la fonction de Bessel de 2eme espece d'ordre 0 (resp. 1)
*     H0  (resp.H1) est la fonction de Struve d'ordre 0 (resp. 1)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER INTPA
      REAL    R
      COMPLEX G4,D4
*
      REAL    AH0,AH1,AJ0,AJ1,AY0,AY1
*-----------------------------------------------------------------------
      AH0=0.
      AH1=0.
      AY0=0.
      AY1=0.
      IF (R.LE.8.)  THEN
*  
*        Calcul de J0 et J1 et de Y0 et Y1 si ABS(INTPA) >99
         CALL BEJY01 (R,AJ0,AJ1,AY0,AY1,ABS(INTPA).GE.100)              !SpecFct
         IF (INTPA.GT.0) THEN
*           Calcul de H0 et H1-2/PI
            CALL STRH01 (R,AH0,AH1)                                     !SpecFct
            AH1=AH1-.6366197723675 
         ENDIF
      ELSE 
*        Calcul de J0 et J1 et de Y0 et Y1 si INTPA > 0
         CALL BEJY01 (R,AJ0,AJ1,AY0,AY1,INTPA.GT.0)                     !SpecFct
         IF (INTPA.GT.0) THEN
*           Calcul de H0-Y0 et H1-Y1 puis de H0 et H1-2/PI
            CALL STRH01 (R,AH0,AH1)                                     !SpecFct
            AH0=AH0+AY0
            AH1=AH1+AY1-.6366197723675 
         ENDIF
      ENDIF
      G4=-CMPLX (0.,AJ0+AJ0)
      D4= CMPLX (0.,AJ1+AJ1)
      IF (INTPA.GT.0) THEN  
         IF (INTPA.LT.100) THEN 
            AH0=AH0+AH0
            AH1=AH1+AH1
         ELSE  
            AH0=AH0+AY0
            AH1=AH1+AY1
         ENDIF
      ENDIF
      G4=G4+AH0
      D4=D4-AH1
                                                                    END !Gd4
