*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  GMAXS1 (TYNOYO,KK,SS,CORP,CORM
     *                   ,G,OMGOM,GOMP,GOMM,GNAP,GNAM,NAGNA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (novembre 1992)
* Derniere modification (O.DeBayser) le 4 Novembre 1996
*
*     Solution Elementaire au point 'CORP' de l'Operateur:
*     Rot(Rot(u)) - s*Grad(Div(u) - k**2(u) = 0 dans R3 avec s=1.
*     l'origine se trouvant en 'CORM'.  
*
*** Arguments d'entree *** 
* TYNOYO: type du noyau de Green a calculer
* KK    : constante K de EXP(I*K*R)/R
* SS    : constante S de modification de l'operateur  
* CORP  : coordonnees du point source  
* CORM  : coordonnees du point image
*** Arguments de sortie ***
* G     : tenseur de Green ((G)t)   matrice  3x3
* OMGOM : Roty((Rotx(G))t)          matrice  3x3
* GOMP  : -(Rotx(G))t               matrice  3x3
* GOMM  : Roty((G)t)                matrice  3x3
* GNAP  : (Divx(G))t                vecteur  1x3
* GNAM  : Divy((G)t)                vecteur  1x3
* NAGNA : Divy((Divx(G))t)          scalaire 1x1
*  
*** Remarque : La multiplication par 1./4*PI n'est pas effectuee dans ce S-P
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      REAL          CORP(*),CORM(*)
      COMPLEX       KK,SS
      COMPLEX       G(*),OMGOM(*),GOMP(*),GOMM(*),GNAP(*),GNAM(*),NAGNA
*
      REAL          XM(3),UNSUR,UNSUR2
      REAL          K,S,K2,SURK2,SRK2R2
      COMPLEX       IKR,H,IKRM1,SIKRH
      COMPLEX       ALPHA2,ALPHA3,ALPHA4
*
      IF(AIMAG(KK).GT.1E-08.OR.AIMAG(SS).GT.1E-08) THEN
         CALL BAISE('*gmaxs1* Atention K et S sont complexes'
     &           //' et devraient avoir des parties imaginaires nulles')!Utilite
      ENDIF
      K=REAL(KK)
      S=REAL(SS)
      IF(S.NE.1.) THEN
         CALL BAISE('*gmaxs1* S est differend de UN;'
     &            //' Utilisez le s.p. Gmaxwl dans Green ...!')         !Utilite
      ENDIF
*
      R=0.
      DO 5 I=1,3
         X=CORM(I)-CORP(I)
         R=R+X*X
5        XM(I)=X
      IF(R.LT.1.E-06)  GO TO 999
      UNSUR2=1./R
      R=SQRT(R) 
      UNSUR =1./R
*
      K2    =K*K
      SURK2 =1./K2 
      SRK2R2=SURK2*UNSUR2
      IKR   =CMPLX(0.,1.)*K*R  
      H     =EXP(IKR)*UNSUR  
*            ===
      IKRM1 =IKR-1.
*
      IKS   = 0.
      IKSM1 = 0.
      SIKRH = SRK2R2*IKRM1*H
      ALPHA2= K2*(H+SIKRH)
      ALPHA3=-K2*(3.*SIKRH+H)*UNSUR2
      ALPHA4= K2*SIKRH
*
*     Parties diagonales des tenseurs
      IND=1
      DO 10 I=1,3
         XI =XM(I)
         XI2=XI*XI
         G    (IND)= H
         OMGOM(IND)= ALPHA2+ALPHA3*XI2
         GOMP (IND)= 0.
         GOMM (IND)= 0.
         GNAP   (I)= 0.
         GNAM   (I)= 0.
         IND=IND+4
10    CONTINUE
*
*     Le vecteur: (Divx(G))t
      DO 11 I=1,3
         GNAP(I)   = -ALPHA4*XM(I)
         GNAM(I)   = -GNAP(I)
11    CONTINUE
*
*     Les tenseurs de Green: ((G)t), Roty((Rotx(G))t)
      XI2=XM(2)*XM(1)
      G(2)    = 0.
      G(4)    = 0.
      OMGOM(2)= ALPHA3*XI2
      OMGOM(4)= OMGOM(2)
*
      XI2=XM(3)*XM(1)
      G(3)    = 0.
      G(7)    = 0.
      OMGOM(3)= ALPHA3*XI2
      OMGOM(7)= OMGOM(3)
*
      XI2=XM(3)*XM(2)
      G(6)    = 0.
      G(8)    = 0.
      OMGOM(6)= ALPHA3*XI2
      OMGOM(8)= OMGOM(6)
*
*     Tenseur de Green: Rotx(G)
      GOMP(2)=-ALPHA4*XM(3)
      GOMP(4)=-GOMP(2)
      GOMP(3)=+ALPHA4*XM(2)
      GOMP(7)=-GOMP(3)
      GOMP(6)=-ALPHA4*XM(1)
      GOMP(8)=-GOMP(6)
*
*     Tenseur de Green: Roty((G)t)
      GOMM(2)=-GOMP(2)
      GOMM(4)=-GOMP(4)
      GOMM(3)=-GOMP(3)
      GOMM(7)=-GOMP(7)
      GOMM(6)=-GOMP(6)
      GOMM(8)=-GOMP(8)
*
*     Scalaire: Divy((Divx(G))t)
      NAGNA=-K2*H
*
      RETURN
*
999   PRINT 1000,(CORP(I),I=1,3),(CORM(I),I=1,3)
      STOP
1000  FORMAT(3X,'RIGOLO on essaie de calculer la fonction de Green pour'
     *                              ,' une distance inferieure a 10**-6'
     *                       /10X,'XP=',E12.4,' YP=',E12.4,' ZP=',E12.4
     *                       ,10X,'XM=',E12.4,' YM=',E12.4,' ZM=',E12.4)
                                                                 END    *Gmaxs1*
