*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  GMAXWL (TYNOYO,KK,SS,CORP,CORM
     *                   ,G,OMGOM,GOMP,GOMM,GNAP,GNAM,NAGNA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (novembre 1992)
* Derniere modification (O.DeBayser) le 4 Novembre 1996
*
*     Solution Elementaire au point 'CORP' de l'Operateur:
*     Rot(Rot(u)) - s*Grad(Div(u) - k**2(u) = 0 dans R3
*     l'origine se trouvant en 'CORM'.  
*
*** Arguments d'entree *** 
* TYNOYO: type du noyau de Green a calculer
* KK    : constante K de EXP(I*K*R)/R
* SS    : constante S de modification de l'operateur  
* CORP  : coordonnees du point source  
* CORM  : coordonnees du point image
*** Arguments de sortie ***
* G     : tenseur de Green ((G)t)   matrice  3x3
* OMGOM : Roty((Rotx(G))t)          matrice  3x3
* GOMP  : -(Rotx(G))t               matrice  3x3
* GOMM  : Roty((G)t)                matrice  3x3
* GNAP  : (Divx(G))t                vecteur  1x3
* GNAM  : Divy((G)t)                vecteur  1x3
* NAGNA : Divy((Divx(G))t)          scalaire 1x1
*  
*** Remarque : La multiplication par 1./4*PI n'est pas effectuee dans ce S-P
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      REAL          CORP(*),CORM(*)
      COMPLEX       KK,SS
      COMPLEX       G(*),OMGOM(*),GOMP(*),GOMM(*),GNAP(*),GNAM(*),NAGNA
*
      REAL          XM(3),UNSUR,UNSUR2
      REAL          K,S,KS,K2,KS2,SURK2,SRK2R2
      COMPLEX       IKR,IKS,H,HS,IKRM1,IKSM1,SIKRH,SIKSRH
      COMPLEX       ALPHA0,ALPHA1,ALPHA2,ALPHA3,ALPHA4,ALPHA5,ALPHA7
*     COMPLEX       GRADI(9),CC                                         !
*
      IF(AIMAG(KK).GT.1E-08.OR.AIMAG(SS).GT.1E-08) THEN
         CALL BAISE('*gmaxs1* Atention K et S sont complexes'
     &           //' et devraient avoir des parties imaginaires nulles')!Utilite
      ENDIF
      K=REAL(KK)
      S=REAL(SS)
*
*     On a: Gradx(r)=(P-M)/r et Grady(r)=(M-P)/r.
      R=0.
      DO 5 I=1,3
         X=CORM(I)-CORP(I)
         R=R+X*X
5        XM(I)=X
      IF(R.LT.1.E-06)  GO TO 999
      UNSUR2=1./R
      R=SQRT(R) 
      UNSUR =1./R
*
      K2    =K*K
      SURK2 =1./K2 
      SRK2R2=SURK2*UNSUR2
      IKR   =CMPLX(0.,1.)*K*R  
      H     =EXP(IKR)*UNSUR  
*            ===
      IKRM1 =IKR-1.
*
      IKS   = 0.
      IKSM1 = 0.
      SIKRH = SRK2R2*IKRM1*H
      ALPHA0= H+SIKRH
      ALPHA1=-(3.*SIKRH+H)*UNSUR2
      ALPHA2= K2*ALPHA0
      ALPHA3= K2*ALPHA1
      ALPHA4= K2*SIKRH
      IF(S.GT.1E-08) THEN
         KS2   = K2/S
         KS    = SQRT(KS2)
         IKS   = CMPLX(0.,1.)*KS*R
         HS    = EXP(IKS)*UNSUR
*                ===
         IKSM1 = IKS-1.
         SIKSRH= SRK2R2*IKSM1*HS
         ALPHA0= ALPHA0-SIKSRH
         ALPHA7= (3.*SIKSRH+HS/S)*UNSUR2
         ALPHA1= ALPHA1+ALPHA7
         ALPHA5= KS2*SIKSRH                                             !
         ALPHA7=-KS2*ALPHA7                                             !
      ENDIF
*
*     Parties diagonales des tenseurs
      IND=1
      DO 10 I=1,3
         XI =XM(I)
         XI2=XI*XI
         G    (IND)= ALPHA0+ALPHA1*XI2
         OMGOM(IND)= ALPHA2+ALPHA3*XI2
         GOMP (IND)= 0.
         GOMM (IND)= 0.
         GNAP   (I)= 0.
         GNAM   (I)= 0.
*        GRADI(IND)= 0.                                                 !
10       IND=IND+4
*
*     Les vecteurs de Green: (Divx(G))t et Divy((G)t)
      IF(S.GT.1E-08) THEN
         IND=1
         DO 11 I=1,3
            GNAP(I)   = -ALPHA5*XM(I)
            GNAM(I)   = -GNAP(I)
*           XI =XM(I)
*           XI2=XI*XI
*           GRADI(IND)= ALPHA5+ALPHA7*XI2                               !
11          IND=IND+4
      ENDIF
*
*     Les tenseurs de Green: ((G)t), Roty((Rotx(G))t)
      XI2=XM(2)*XM(1)
      G(2)    = ALPHA1*XI2
      G(4)    = G(2)
      OMGOM(2)= ALPHA3*XI2
      OMGOM(4)= OMGOM(2)
*     IF(S.GT.1E-08) THEN                                               !
*        GRADI(2)= ALPHA7*XI2                                           !
*        GRADI(4)= GRADI(2)                                             !
*     ENDIF                                                             !
*
      XI2=XM(3)*XM(1)
      G(3)    = ALPHA1*XI2
      G(7)    = G(3)
      OMGOM(3)= ALPHA3*XI2
      OMGOM(7)= OMGOM(3)
*     IF(S.GT.1E-08) THEN                                               !
*        GRADI(3)= ALPHA7*XI2                                           !
*        GRADI(7)= GRADI(3)                                             !
*     ENDIF                                                             !
*
      XI2=XM(3)*XM(2)
      G(6)    = ALPHA1*XI2
      G(8)    = G(6)
      OMGOM(6)= ALPHA3*XI2
      OMGOM(8)= OMGOM(6)
*     IF(S.GT.1E-08) THEN                                               !
*        GRADI(6)= ALPHA7*XI2                                           ! 
*        GRADI(8)= GRADI(6)                                             !
*     ENDIF                                                             !
*
*     Tenseur de Green: Rotx(G)
      GOMP(2)=-ALPHA4*XM(3)
      GOMP(4)=-GOMP(2)
      GOMP(3)=+ALPHA4*XM(2)
      GOMP(7)=-GOMP(3)
      GOMP(6)=-ALPHA4*XM(1)
      GOMP(8)=-GOMP(6)
*
*     Tenseur de Green: Roty((G)t)
      GOMM(2)=-GOMP(2)
      GOMM(4)=-GOMP(4)
      GOMM(3)=-GOMP(3) 
      GOMM(7)=-GOMP(7)
      GOMM(6)=-GOMP(6)
      GOMM(8)=-GOMP(8)
*
*     Scalaire: Divy((Divx(G))t)
      NAGNA=CMPLX(0.,0.)
      IF(S.GT.1E-08) NAGNA=-KS2*HS/S
*
*     Verification Rot(Rot(G))-s*Grad(div(G))-K2*G=0.                   !
*     DO I=1,9                                                          !
*        CC=OMGOM(I)-S*GRADI(I)-K2*G(I)                                 !
*        PRINT*,'gmaxwl CC=',I,OMGOM(I),S,GRADI(I),K2,G(I),CC           !
*        IF(REAL(CC).GT.5E-06.OR.AIMAG(CC).GT.5E-06)                    !
*    *   PRINT*,'gmaxwl Rot(Rot(G))-s*Grad(div(G))-K2*G non nul: =',CC  !
*     ENDDO                                                             !
*
      RETURN
*
999   PRINT 1000,(CORP(I),I=1,3),(CORM(I),I=1,3)
      STOP
1000  FORMAT(3X,'RIGOLO on essaie de calculer la fonction de Green pour'
     *                              ,' une distance inferieure a 10**-6'
     *                       /10X,'XP=',E12.4,' YP=',E12.4,' ZP=',E12.4
     *                       ,10X,'XM=',E12.4,' YM=',E12.4,' ZM=',E12.4)
                                                                 END    !Gmaxwl*
