*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  G M L O I N (TYNOYO,KK,SS,CORP,CORM
     *                        ,G,OMGOM,GOMP,GOMM,GNAP,GNAM,NAGNA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mai 1995)
* Derniere modification (O.DeBayser) le 29 fevrier 1996
*
*     Champ lointain pour l'Operateur:
*     Rot(Rot(u)) - s*Grad(Div(u) - k**2(u) = 0 dans R3
*     l'origine se trouvant en 'CORM'.  
*
*** Arguments d'entree *** 
* TYNOYO: type du noyau de Green a calculer
* KK    : constante K de EXP(I*K*R)/R
* SS    : constante S de modification de l'operateur  
* CORP  : coordonnees du point source  
* CORM  : coordonnees du point image
*** Arguments de sortie ***
* G     : tenseur de Green ((G)t)   matrice  3x3
* OMGOM : Roty((Rotx(G))t)          matrice  3x3 (inutilise ici)
* GOMP  : -(Rotx(G))t               matrice  3x3
* GOMM  : Roty((G)t)                matrice  3x3
* GNAP  : (Divx(G))t                vecteur  1x3
* GNAM  : Divy((G)t)                vecteur  1x3
* NAGNA : Divy((Divx(G))t)          scalaire 1x1 (inutilise ici)
*  
*** Remarque : La multiplication par 1./4*PI * Exp(ikr)/r
*              n'est pas effectuee dans ce S-P.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO 
      REAL          CORP(*),CORM(*)
      COMPLEX       KK,SS
      COMPLEX       G(*),OMGOM(*),GOMP(*),GOMM(*),GNAP(*),GNAM(*),NAGNA
*
      REAL          XM(3),UNSUR,UNSUR2
      REAL          K,S,KS,K2,KS2
      COMPLEX       IKR,IKS,H,HS
      COMPLEX       ALPHA0,ALPHA1,ALPHA2,ALPHA4,ALPHA5
      COMPLEX       CBETA,CBETAS
*
      IF(AIMAG(KK).GT.1E-08.OR.AIMAG(SS).GT.1E-08) THEN
         CALL BAISE('*gmloin* ATENTION K et S sont complexes')          !Utilite
      ENDIF
      K=REAL(KK)
      S=REAL(SS)
*
      R =0.
      RP=0.
      DO 5 I=1,3
         X =CORM(I)
         R =R +X*X
         RP=RP+X*CORP(I)
5        XM(I)=X
*
      UNSUR2=1./R
      R=SQRT(R) 
*     UNSUR =1./R
      CBETA =CMPLX(0.,-1.)*K*RP/R
      CBETA =EXP(CBETA)
      IKR   =CMPLX(0.,1.)*K*R  
      H     =EXP(IKR)
*     H     =EXP(IKR)*UNSUR  
*            ===
      IKS   = 0.
      ALPHA0= CBETA
      ALPHA2= CBETA*UNSUR2
      ALPHA1=-ALPHA2
      ALPHA4= ALPHA2*IKR
      IF(S.GT.1E-08) THEN
         K2    = K*K
         KS2   = K2/S
         KS    = SQRT(KS2)
         CBETAS= CMPLX(0.,-1.)*KS*RP/R
         CBETAS= EXP(CBETAS)
         IKS   = CMPLX(0.,1.)*KS*R
         HS    = EXP(IKS)
*        HS    = EXP(IKS)*UNSUR
*                ===
         ALPHA2= (CBETAS*UNSUR2*HS)/(H*S)
         ALPHA1= ALPHA1+ALPHA2
         ALPHA5= ALPHA2*IKS
      ENDIF
*
*     Parties diagonales des tenseurs
      IND=1
      DO 10 I=1,3
         XI =XM(I)
         XI2=XI*XI
         G    (IND)= ALPHA0+ALPHA1*XI2
         GOMP (IND)= 0.
         GOMM (IND)= 0.
         GNAP   (I)= 0.
         GNAM   (I)= 0.
10       IND=IND+4
*
*     Le vecteur: (Divx(G))t et Divy((G)t)
      IF(S.GT.1E-08) THEN
         DO 11 I=1,3
            GNAP(I)   = -ALPHA5*XM(I)
            GNAM(I)   = -GNAP(I)
11       CONTINUE
      ENDIF
*
*     Tenseur de Green: ((G)t)
      XI2=XM(2)*XM(1)
      G(2)    = ALPHA1*XI2
      G(4)    = G(2)
*
      XI2=XM(3)*XM(1)
      G(3)    = ALPHA1*XI2
      G(7)    = G(3)
*
      XI2=XM(3)*XM(2)
      G(6)    = ALPHA1*XI2
      G(8)    = G(6)
*
*     Tenseur de Green: Rotx(G)
      GOMP(2)=-ALPHA4*XM(3)
      GOMP(4)=-GOMP(2)
      GOMP(3)=+ALPHA4*XM(2)
      GOMP(7)=-GOMP(3)
      GOMP(6)=-ALPHA4*XM(1)
      GOMP(8)=-GOMP(6)
*
*     Tenseur de Green: Roty((G)t)
      GOMM(2)=-GOMP(2)
      GOMM(4)=-GOMP(4)
      GOMM(3)=-GOMP(3)
      GOMM(7)=-GOMP(7)
      GOMM(6)=-GOMP(6)
      GOMM(8)=-GOMP(8)
                                                                 END    *Gmloin*
