*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  PTTEVN (K,COR,GAMMA,A1,A2,A3,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 93)  
* Derniere modification (O.DeBayser) le 10 Avril 96
*
*   Valeur sur la sphere du  
*   champ total diffracte par une sphere rigide de rayon GAMMA,
*   d'une onde plane incidente: PHIW= (A1,A2,A3) EXP(i*K*z). 
*   Conditions: E^n=0 sur la sphere, et divE=0 en volume.
*   Representation sous forme d'une serie de fonctions de BESSEL spheriques
*   et de Polynomes de LEGENDRE .  
*   Bibliographie : ABRAMOVITZ et STEGUN - Handbook of Math. Functions
*                   (Bessel fonctions of fractional order , pp.437,439)  
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL          K,COR(*),GAMMA,A1,A2,A3
      COMPLEX       CESULT(*) 
*  
      PARAMETER   ( NMAX = 50 ) 
      LOGICAL       LASTCL 
      REAL          KKEEP,KRKEEP,AJYN(NMAX+1),A,R,KR,X2LP1 
      COMPLEX       CIN,COEFAN,COEFBN,HNZERO,CR,CTETA,CPHI
      COMMON/KEEPK/ COEFAN(NMAX),COEFBN(NMAX),HNZERO(NMAX+1)
     *             ,KKEEP,KRKEEP,NBTRMH
      DATA EPSIL   /1.E-16/
*
      R2=COR(1)*COR(1)+COR(2)*COR(2)
      A =SQRT(R2)
      R2=R2+COR(3)*COR(3)
      R =SQRT(R2)
      SINTET=A/R
      COSTET=COR(3)/R 
      IF(A.GT.1.E-6) THEN
         SINPHI=COR(2)/A 
         COSPHI=COR(1)/A
      ELSE
         SINPHI=0. 
         COSPHI=1.
      ENDIF
*
*     Calcul des coefficients dependant de GAMMA  
      KR=K*GAMMA  
      CALL BESFYN(KR,NMAX,AJYN)                                         !SpecFct
      DO 2 I=1,NMAX+1  
2        HNZERO(I)=CMPLX(0.,AJYN(I))  
      CALL BESFJN(KR,NMAX,AJYN)                                         !SpecFct
      DO 3 I=1,NMAX+1  
3        HNZERO(I)=HNZERO(I)+AJYN(I)
      COEFAN(1)=1./CMPLX(0.,KR)*HNZERO(1) 
      LASTCL=.FALSE.
      DO 4 I=2,NMAX
         CIN=KR*HNZERO(I-1)-REAL(I-1)*HNZERO(I)
         COEFAN(I)=1./CIN
         IF(LASTCL) GO TO 5
         IF(ABS(COEFAN(I)).LE.EPSIL) LASTCL=.TRUE.
4     CONTINUE 
      STOP ' *PTTEVN Convergence non atteinte : augmenter NMAX ?'  
5     NBTRMH=I-1
*  
*     Calcul des polynomes de LEGENDRE et de la serie : 
      KR   =KR*KR
      CIN  =CMPLX(0.,1.)
      CR   =CMPLX(0.,0.)
      CTETA=CMPLX(0.,0.)
      CPHI =CMPLX(0.,0.)
      X2LP1=3.
      P10=0.
      P11=SINTET
      DOSTET=COSTET+COSTET
      CSTETA=COSTET 
      DO 8 I=2,NBTRMH
         CSTETA=CSTETA+DOSTET 
         P12   =(CSTETA*P11 - I   *P10 )/(I-1)
         CR    =CR+CIN*X2LP1*(COEFAN(I)/KR)*P11*COSPHI
         CIN   =CIN*CMPLX(0.,1.)
         X2LP1 =X2LP1+2.
         P10=P11
         P11=P12
8     CONTINUE
      CESULT(1)=SINTET*COSPHI*CR+COSTET*COSPHI*CTETA-SINPHI*CPHI
      CESULT(2)=SINTET*SINPHI*CR+COSTET*SINPHI*CTETA+COSPHI*CPHI
      CESULT(3)=COSTET       *CR-SINTET       *CTETA
*
*     IF(ABS(P1*HNZERO(NBTRMH+1)).GT.1.E-8)
*    *PRINT 20,NBTRMH+1,P1*HNZERO(NBTRMH+1),COEFAN(NBTRMH+1),R
*20   FORMAT(' IMAX=',I3,' Terme neglige:',2E11.4,' Coef:',2E11.4,' KR='
*    *,E11.4) 
                                                                    END !Pttevn*
