*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  SLDEVN (K,COR,GAMMA,A1,A2,A3,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 93)  
* Derniere modification (O.DeBayser) le 10 Juin 1993
*
*   Calcul du ROTATIONNEL du champ diffracte par une sphere rigide de rayon GAMA,
*   d'une onde plane incidente: PHIW= (A1,A2,A3) EXP(i*K*z). 
*   Conditions: E^n=0 sur la sphere, et divE=0 en volume.
*   Representation sous forme d'une serie de fonctions de BESSEL spheriques
*   et de Polynomes de LEGENDRE .  
*   Bibliographie : ABRAMOVITZ et STEGUN - Handbook of Math. Functions
*                   (Bessel fonctions of fractional order , pp.437,439)  
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL          K,COR(*),GAMMA,A1,A2,A3
      COMPLEX       CESULT(*) 
*  
      PARAMETER   ( NMAX = 50 ) 
      LOGICAL       LASTCL 
      REAL          KKEEP,KRKEEP,AJYN(NMAX+1),A,R,KR 
      COMPLEX       CI,CIN,COEFAN,COEFBN,HNZERO,X,H,U,CR,CTETA,CPHI
      COMMON/KEEPK/ COEFAN(NMAX),COEFBN(NMAX),HNZERO(NMAX+1)
     *             ,KKEEP,KRKEEP,NBTRMH
      DATA EPSIL   /1.E-16/
*
      CI=CMPLX(0.,1.)
      R2=COR(1)*COR(1)+COR(2)*COR(2)
      A =SQRT(R2)
      R2=R2+COR(3)*COR(3)
      R =SQRT(R2)
      SINTET=A/R
      COSTET=COR(3)/R 
      IF(A.GT.1.E-6) THEN
         SINPHI=COR(2)/A
         COSPHI=COR(1)/A
      ELSE
         SINPHI=0.
         COSPHI=1.
      ENDIF
*
*      IF(ABS(K-KKEEP).GT.1.E-10) THEN  
*  
*        Calcul des coefficients dependant de GAMMA  
*
         KR=K*GAMMA  
         CALL BESFYN(KR,NMAX,AJYN)                                      !SpecFct
         DO 2 I=1,NMAX+1  
2            HNZERO(I)=CMPLX(0.,AJYN(I))  
         CALL BESFJN(KR,NMAX,AJYN)                                      !SpecFct
         DO 3 I=1,NMAX+1  
3           HNZERO(I)=HNZERO(I)+AJYN(I)
         CIN=HNZERO(1)
         COEFAN(1)=CI*AIMAG(CIN)/CIN 
         COEFBN(1)=REAL(CIN)/CIN 
         LASTCL=.FALSE.
         DO 4 I=2,NMAX
            CIN=KR*HNZERO(I-1)-REAL(I-1)*HNZERO(I)
            COEFAN(I)=REAL(CIN)/CIN
            CIN=HNZERO(I)
            COEFBN(I)=REAL(CIN)/CIN  
            IF(LASTCL) GO TO 5
            IF(ABS(COEFAN(I)).LE.EPSIL.AND.ABS(COEFBN(I)).LE.EPSIL) 
     *                                                    LASTCL=.TRUE.
4        CONTINUE 
         STOP ' *SLDEVN Convergence non atteinte : augmenter NMAX ?'
5        NBTRMH=I-1
*      END IF
*
      KR=K*R
*      IF(ABS(K-KKEEP).GT.1.E-10.OR.ABS(R-KRKEEP).GT.1.E-10) THEN
         CALL BESFYN(KR,NBTRMH,AJYN)                                    !SpecFct
         DO 6 I=1,NBTRMH
6           HNZERO(I)=CMPLX(0.,AJYN(I))  
         CALL BESFJN(KR,NBTRMH,AJYN)                                    !SpecFct
         DO 7 I=1,NBTRMH
7           HNZERO(I)=HNZERO(I)+AJYN(I)  
*      END IF
*      KKEEP=K  
*      KRKEEP=KR 
*  
*     Calcul des polynomes de LEGENDRE et de la serie : 
*
      CIN  =CMPLX(1.,0.)
      CR   =CMPLX(0.,0.)
      CTETA=CMPLX(0.,0.)
      CPHI =CMPLX(0.,0.)
      X2LP1=3.
      XLLP1=2.
      P00=1.
      P01=COSTET
      P10=0.
      P11=SINTET
      P00P=0.
      P01P=1.
      DOSTET=COSTET+COSTET
      CSTETA=COSTET 
      DO 8 I=2,NBTRMH
         CSTETA=CSTETA+DOSTET 
         P02P  =(CSTETA*P01P- I   *P00P)/(I-1)
         P02   =(CSTETA*P01 -(I-1)*P00 )/ I
         P12   =(CSTETA*P11 - I   *P10 )/(I-1)
         DP12  =-COSTET*P01P+XLLP1*P01
         H=HNZERO(I)
         U=KR*HNZERO(I-1)-REAL(I-1)*H
         X=CIN*(X2LP1/XLLP1)
         CR   =CR   -X*SINPHI*XLLP1*CI*(COEFBN(I)/R)*H*P11
         CTETA=CTETA+X*SINPHI*
     &                 ((COEFAN(I)*K)*H*P01P-CI*(COEFBN(I)/R)*U*DP12)
         CPHI =CPHI +X*COSPHI*
     &                 ((COEFAN(I)*K)*H*DP12-CI*(COEFBN(I)/R)*U*P01P)
         CIN=CIN*CI
         X2LP1=X2LP1+2.
         XLLP1=XLLP1+2.*I
         P00=P01
         P01=P02
         P10=P11
         P11=P12
         P00P=P01P
         P01P=P02P
8     CONTINUE
      CESULT(1)=SINTET*COSPHI*CR+COSTET*COSPHI*CTETA-SINPHI*CPHI
      CESULT(2)=SINTET*SINPHI*CR+COSTET*SINPHI*CTETA+COSPHI*CPHI
      CESULT(3)=COSTET       *CR-SINTET       *CTETA
*-----------------------------------------------------------------------
*     IF(ABS(P1*HNZERO(NBTRMH+1)).GT.1.E-8)
*    *PRINT 20,NBTRMH+1,P1*HNZERO(NBTRMH+1),COEFAN(NBTRMH+1),R
*20   FORMAT(' IMAX=',I3,' Terme neglige:',2E11.4,' Coef:',2E11.4,' KR='
*    *,E11.4) 
                                                                    END *Sldevn*
