*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  SLXEVN (K,COR,GAMMA,CESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 93)  
* Derniere modification (O.DeBayser) le 10 Avril 1996
*  
*   Champ de perturbation diffracte par une sphere rigide de rayon GAMMA,
*   d'une onde plane incidente: PHIW= (A1,A2,A3) EXP(i*K*z). 
*   Conditions: E^n=0 sur la sphere, et divE=0 en volume.
*   Representation sous forme d'une serie de fonctions de BESSEL spheriques
*   et de Polynomes de LEGENDRE .  
*   Bibliographie : ABRAMOVITZ et STEGUN - Handbook of Math. Functions
*                   (Bessel fonctions of fractional order , pp.437,439)  
*  
* (Routine identique a SLTEVN au retrait du potentiel incident a la fin)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL    K,COR(*),GAMMA,A1,A2,A3
      COMPLEX CESULT(*) 
*  
      PARAMETER (NMAX = 50 ) 
      LOGICAL   LASTCL 
      REAL      KKEEP,KRKEEP,AJYN(NMAX+1),A,RHO,KR
     &         ,PCNM1,PCNM,PCNP1,PSNM1,PSNM,PSNP1,P0NM1,P0NM,P0NP1 
      COMPLEX   CI,CIN,COEFAN,COEFBN,HNZERO,X,H,U,CR,CTETA,CPHI
      COMMON/KEEPK/COEFAN(NMAX),COEFBN(NMAX),HNZERO(NMAX+1)
     &            ,KKEEP,KRKEEP,NBTRMH
      DATA EPSIL /1.E-16/
*------------------------------------------------------------------------
      R2 = COR(1)*COR(1)+COR(2)*COR(2)
      RHO = SQRT(R2+COR(3)*COR(3))
      A = SQRT(R2)
      SINTET=A/RHO
      COSTET=COR(3)/RHO 
      IF (A.GT.1.E-8) THEN
         SINPHI=COR(2)/A
         COSPHI=COR(1)/A
      ELSE
         SINPHI=0.
         COSPHI=1.
      ENDIF
      CI=CMPLX(0.,1.)
*
*     IF (ABS(K-KKEEP).GT.1.E-10) THEN
*        Calcul des coefficients dependant de GAMMA  
*
         KR=K*GAMMA  
         CALL BESFYN (KR,NMAX,AJYN)                                     !SpecFct
         DO 2 I=1,NMAX+1  
             HNZERO(I)=CMPLX(0.,AJYN(I))
2        CONTINUE  
         CALL BESFJN (KR,NMAX,AJYN)                                     !SpecFct
         DO 3 I=1,NMAX+1  
            HNZERO(I)=HNZERO(I)+AJYN(I)
3        CONTINUE
         H=HNZERO(1)
         COEFAN(1)=CI*AIMAG(H)/H 
         COEFBN(1)=REAL(H)/H 
         LASTCL=.FALSE.
         DO 4 I=2,NMAX
            H = HNZERO(I)
            U = KR * HNZERO(I-1) - REAL(I-1) * H
            COEFAN(I)=REAL(U)/U
            COEFBN(I)=REAL(H)/H
            IF(LASTCL) GO TO 5
            IF(ABS(COEFAN(I)).LE.EPSIL.AND.ABS(COEFBN(I)).LE.EPSIL) 
     *                                                    LASTCL=.TRUE.
4        CONTINUE 
         STOP ' *SLXEVN Convergence non atteinte : augmenter NMAX ?'
5        NBTRMH=I-1
*     ENDIF
*
      KR=K*RHO
*     IF (ABS(K-KKEEP).GT.1.E-10.OR.ABS(RHO-KRKEEP).GT.1.E-10) THEN
         CALL BESFYN (KR,NBTRMH,AJYN)                                   !SpecFct
         DO 6 I=1,NBTRMH
            HNZERO(I)=CMPLX(0.,AJYN(I))
6        CONTINUE  
         CALL BESFJN (KR,NBTRMH,AJYN)                                   !SpecFct
         DO 7 I=1,NBTRMH
            HNZERO(I)=HNZERO(I)+AJYN(I)
7        CONTINUE  
*     ENDIF
*     KKEEP=K  
*     KRKEEP=KR 
*  
*     Calcul des polynomes de LEGENDRE et de la serie : 
*
      CIN  = CMPLX(1.,0.)
      CR   = CMPLX(0.,0.)
      CTETA= CMPLX(0.,0.)
      CPHI = CMPLX(0.,0.)
      DOSTET= COSTET+COSTET
      X2LP1 = 3.
      XLLP1 = 2.
      PCNM1 = 1.
      PCN   = COSTET
      PSNM1 = 0.
      PSN   = SINTET
      P0NM1 = 0.
      P0N   = 1.
      CSTETA=COSTET 
      DO 8 I = 2, NBTRMH
         CSTETA = CSTETA+DOSTET 
         D0N  = -COSTET*P0N+XLLP1*PCN
         H = HNZERO(I)
*        THIS IS NOT A BESSEL FUNCTION DERIVATIVE
         U = KR * HNZERO(I-1) - REAL(I-1) * H
         X = CIN*X2LP1
*
         CR   = CR - X*COSPHI*(COEFAN(I)/KR)*H*PSN
         X = X/XLLP1
         CTETA= CTETA-X*COSPHI*((COEFAN(I)/KR)*U*D0N+CI*COEFBN(I)*H*P0N)
         CPHI = CPHI +X*SINPHI*((COEFAN(I)/KR)*U*P0N+CI*COEFBN(I)*H*D0N)
*
         CIN = CIN*CI
         X2LP1 = X2LP1+2.
         XLLP1 = XLLP1+2.*I
*        Recurrence polynomes de Legendre
         PCNP1 = (CSTETA*PCN-(I-1)*PCNM1)/I
         PCNM1= PCN
         PCN  = PCNP1
         PSNP1 = (CSTETA*PSN- I   *PSNM1)/(I-1)
         PSNM1= PSN
         PSN  = PSNP1
         P0NP1 = (CSTETA*P0N- I   *P0NM1)/(I-1)
         P0NM1= P0N
         P0N  = P0NP1
8     CONTINUE
      CESULT(1)=SINTET*COSPHI *CR + COSTET*COSPHI *CTETA - SINPHI *CPHI
      CESULT(2)=SINTET*SINPHI *CR + COSTET*SINPHI *CTETA + COSPHI *CPHI
      CESULT(3)=COSTET        *CR - SINTET        *CTETA
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1 : D.Martin (15 juin 2011)
* - cosmetic changes (notations)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Slxevn
*      REAL COR(3)
*      COMPLEX CES(3)
*      COR(1)=1.
*      COR(2)=0.
*      COR(3)=0.
*      CALL SLXEVN(1.,COR,1.,CES)
*      WRITE(*,*) COR(1),COR(2),COR(3),CES(1),CES(2),CES(3)
*      COR(1)=0.
*      COR(2)=1.
*      CALL SLXEVN(1.,COR,1.,CES)
*      WRITE(*,*) COR(1),COR(2),COR(3),CES(1),CES(2),CES(3)
*      COR(2)=0.
*      COR(3)=1.
*      CALL SLXEVN(1.,COR,1.,CES)
*      WRITE(*,*) COR(1),COR(2),COR(3),CES(1),CES(2),CES(3)
*      COR(1)=1.
*      DO I = 1,2
*         COR(2)=1.
*         DO J = 1,3
*           COR(3)=1.
*           DO K = 1, 6
*             CALL SLXEVN(1.,COR,1.,CES)
*             WRITE(*,*) COR(1),COR(2),COR(3),CES(1),CES(2),CES(3)
*             COR(3)=COR(3)+0.2
*           ENDDO
*           COR(2)=COR(2)+0.2
*        ENDDO
*        COR(1)=COR(1)+0.2
*      ENDDO
*      END
