*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  N O Y D I T (NDIM,NORMAP,FGREEN,G,GNP,NIVIMP,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Dec 87)
* Derniere modification (O.DeBayser) le 12 Fev. 90  
*   
*   Calcul du noyau de Green pour un couple de point (M,P) dans le cas  
*   du couplage Dirichlet et pour une fonction de Green complexe
*   
*** Arguments d'entree ***  
* NDIM   dimension d'espace 
* NORMAP normale en P a la premiere surface (de representation integrale)   
* FGREEN valeurs de la fct. de green et de ses derivees pour un couple (p,m)
*** Arguments de sortie *** 
* G      =  G au point (M,P)
* GNP    = dG/dnp au point (M,P)
*   
*** Notation : M point sur la frontiere de couplage sigma   
*              P point sur la frontiere portant la representation integrale 
*** Remarque importante : Rangement du tableau FGREEN   
* (1)          : valeur de la fonction de Green 
* (2) a (1+NDIM)            : derivees par rapport a M : dG/dxm,dG/dym,(dG/dzm) 
* (2+NDIM) a (1+2*NDIM)     : derivees par rapport a P : dG/dxp,dG/dyp,(dG/dzp) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      real G,GNP,FGREEN  
      REAL NORMAP   
      DIMENSION FGREEN(*),NORMAP(*) 
*   
***   Calcul de d/dnp(g(M,P))   
*   
      INDER=2
      DO 1 IDIM=1,NDIM  
         GNP=GNP+FGREEN(INDER)*NORMAP(IDIM) 
1        INDER=INDER+1  

*   
***   Calcul de g(M,P)  
*   
      G=G+FGREEN(1)   
*   
*      IF(NIVIMP.GT.2)WRITE(IMPFCH,1000) G,GNP   
*   
1000  FORMAT(5X,'*NoyDit*  G = ',E9.3,' Gn= ',SS,E9.3 )
                                                                    END *NoyDit*
