*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE S Y M G R T (NDIM,TABCSG,POINTP,POINTM,PPRIME  
     *                  ,NS,FGRE,EGRE,TABASS,MCTABG,numreg,nbpass,ETA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Oct.89)&P.Vezolle 
* Derniere modification (P.Vezolle) le 13 Fev. 90
*  
* Calcul de la fonction de Green pour un couple de points (POINTP,POINTM)  
* y compris la prise en compte des symetries eventuelles du probleme par
* rapport aux plans de coordonnees.
*  
*** Arguments ***  
*
* NDIM  : dimension d'espace
* TABCSG: tableau contenant les constantes necessaires pour le calcul  
* POINTP: point sur la frontiere de calcul de representation integrale 
* POINTM: point numero 2 (en general sur la frontiere de couplage) 
* PPRIME: tab. de dim. 3 (independament de NDIM) : points symetriques de POINTP
* NS    : tableau de dim. 3 (independament de NDIM) contenant les indices  
*         de symetrie du probleme par rapport aux plans de coordonnees :
*          NS(i) = 1 pas de symetrie en la i-eme variable d'espace 
*          NS(i) = 2  symetrie en la i-eme variable d'espace
*          NS(i) =-2  antisymetrie en la i-eme variable d'espace
*          Remarques : Si NDIM =1 ce tableau doit necessairement contenir  
*                      les valeurs 1 en 2 et 3-ieme positions  
*                      Si NDIM =2 ce tableau doit necessairement contenir  
*                      la valeur 1 en 3-ieme positions 
* FGRE   : tableau contenant les valeurs de la fonction de Green et de ses 
*          derivees, cumulant les valeurs pour les symetries
* EGRE  : idem mais pour un seul couple de points (tableau de travail) 
* TABASS : Tableau de travail pour Green
* MCTABG : adresse dans RST du tableau TABGEN contenant les tables
*          d'interpolation
* numreg : numero de la region pour l'interpolation de green
* nbpass : nombre de passages dans la fonction de green
*
* Remarque importante : Rangement des tableaux FGRE et EGRE
* FGRE(1)          : valeur de la fonction de Green
* FGRE(2) a FGRE(1+NDIM)      :derivees par rapport a M :dG/dxm,dG/dym,(dG/dzm)
* FGRE(2+NDIM) a FGRE(1+2*NDIM):derivees par rapport a P:dG/dxp,dG/dyp,(dG/dzp)
* FGRE(2+2*NDIM) a la fin du tableau : derivees secondes croisees dans l'ordre 
*                                            d2G/dxmdxp,d2G/dxmdyp,(d2G/dxmdzp)
*                                            d2G/dymdxp,d2G/dymdyp,(d2G/dymdzp)
*                                           (d2G/dzmdxp,d2G/dzmdyp,(d2G/dzmdzp))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      COMPLEX TABASS
      real TABCSG
      real FGRE,EGRE
      DIMENSION TABCSG(*),FGRE(*),EGRE(*),TABASS(*)
      DIMENSION POINTP(*),POINTM(*),PPRIME(3),coo(3)
      DIMENSION NS(3)

      NDIM2=1+NDIM
      nbpass = 0
      PPRIME(3)=POINTP(3)  
      ISZ=1
      LASZ=0
      DO 10 IZ=1,ABS(NS(3))
         PPRIME(2)=POINTP(2)
         ISY=1 
         IS=ISZ
         LASY=0
         DO 9 IY=1,ABS(NS(2))  
            PPRIME(1)=POINTP(1)
            ISX=1  
            LASX=0 
            IS=IS*ISY  
            DO 8 IX=1,ABS(NS(1))
               IS=IS*ISX
               DO 6 I=1,NDIM2  
6                 EGRE(I)=0.
*    calcul de la region du couple (M,P) pour la fonction de green
                  coo(1) = pointm(1) - pprime(1)
                  coo(2) = pointm(2) - pprime(2)
                  coo(3) = pointm(3) + pprime(3)
*
		if (coo(3).ge.0) then
		call baise('Corps non immerge : '//          
     *			'Augmentez la profondeur')
		endif

                  numre1 = numr(coo,tabcsg)
               if (numre1.eq.numreg) then
                CALL GREEN(TABCSG,PPRIME,POINTM,EGRE,numre1, 
     *                                TABASS,MCTABG,eta) 
                nbpass = nbpass + 1
               endif
               if (numre1.eq.4) then
                if (numreg.eq.1) then  
                CALL GREEN(TABCSG,PPRIME,POINTM,EGRE,numre1, 
     *                                TABASS,MCTABG,eta)    
                nbpass = nbpass + 1
                endif
               endif
*                   -----  
               DO 1 I=2,LASX,NDIM 
1                 EGRE(I)=-EGRE(I) 
               DO 2 I=3,LASY,NDIM 
2                 EGRE(I)=-EGRE(I) 
               DO 3 I=4,LASZ,NDIM 
3                 EGRE(I)=-EGRE(I) 
               IF(IS.GT.0) THEN
                  DO 4 I=1,NDIM2
4                    FGRE(I)=FGRE(I)+EGRE(I)
               ELSE
                  DO 5 I=1,NDIM2
5                    FGRE(I)=FGRE(I)-EGRE(I)
               END IF  
               PPRIME(1)=-POINTP(1)
               ISX=SIGN(1,NS(1))
8              LASX=NDIM2  
            PPRIME(2)=-POINTP(2)
            ISY=SIGN(1,NS(2))  
9           LASY=NDIM2 
         PPRIME(3)=-POINTP(3)  
         ISZ=SIGN(1,NS(3)) 
10       LASZ=NDIM2
                                                                    END *Csymgr*
