*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMATR (NMTRMR,NVTRMR,TYTRMR,NVASMB,NCPINC,NVNURC
     &                  ,NBNERC,NCPINL,NVNURL,NBNERL,NVSTOR,ITYSYR
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1992)  
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.3
*  
* Assemblage du terme NMTRMR de niveau NVTRMR   
*  
*-- Arguments d'entree -- 
* NMTRMR nom du terme resultat de l'assemblage 
* NVTRMR son niveau
* TYTRMR type (reel ou complexe) du terme resultat de l'assemblage
* NVASMB niveau de la structure d'assemblage
* NCPINC nombre de composantes pour l'inconnue en colonne (cas vectoriel)
* NVNURC niveau du tableau #GNEDO de numerotation des noeuds en colonne
* NBNERC nombre de colonnes du terme assemble
* NCPINL nombre de composantes pour l'inconnue en ligne (cas vectoriel)
* NVNURL niveau du tableau #GNEDO de numerotation des noeuds en ligne 
* NBNERL nombre de lignes du terme assemble 
* NVSTOR niveau du tableau de stockage du terme resultat
* ITYSYR indicateur de symetrie du terme assemble resultat
* NIVIMP niveau d'impression
* IMPFCH unite d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER       NVTRMR,NVASMB,NCPINC,NVNURC,NBNERC,NCPINL,NVNURL
     &             ,NBNERL,NVSTOR,ITYSYR,NIVIMP,IMPFCH
      CHARACTER*(*) NMTRMR,TYTRMR
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDSTO,INTDON,INTTYP
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NVTRMB,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYB,IPTDIR
     &             ,NUINCC,NVDUBC,NBNEBC,NVNUBC,NUINCL,NVDUBL,NBNEBL
     &             ,NVNUBL,INDSTB,NVSTOB,NVCORC,IATRDO,NIVIMA,LGTRMB
     &             ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &             ,MCCSTE,MCDONN,ITYDON,NIVDON,ITYPDO,INCSTE
     &             ,NVNCAV,NVNLAV,NVSTAV,MCTRMB,LGTRMR,MCTRMR,MCSTOB
      CHARACTER     SYMIND*14,TYPINT*4
      CHARACTER     READRE,OPERAT,CRWORK
      CHARACTER     TYPCST*4,TYTRMB*4,CHCSTE*6,NMSTOK*6
      CHARACTER     ERCODE*120,NMTRMB*16
      COMMON/FORMAH/ERCODE
      EQUIVALENCE (ERCODE(89:89),NMTRMB)
     &           ,(ERCODE(105:105),CHCSTE),(ERCODE(113:113),NMSTOK)
     &           ,(ERCODE(119:119),CRWORK),(ERCODE(120:120),OPERAT)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsMatr*')
*
      CALL TBRR1  (ERCODE,NMTRMR,NVTRMR,LGTRMR)
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                   ,'#OMTRM',1,MCMTRM)                     
      READRE='N'
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
      CRWORK='N'
      NVNCAV=NDFNUM
      NVNLAV=NDFNUM
      NVSTAV=NDFSTO
*
      DO 1 NUTRAS=1,NBTRAC
         IF (READRE.EQ.'Y') THEN
            CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                         ,'#OMTRM',1,MCMTRM)
            READRE='N'
         ENDIF
*
*        Recherche des caracteristiques du terme courant a assembler
*
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &               ,NVTRMB,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYB,IPTDIR
     &               ,NUINCC,NVDUBC,NBNEBC,NVNUBC,NUINCL,NVDUBL,NBNEBL
     &               ,NVNUBL,INDSTB,NVSTOB,NVCORC,IATRDO,NIVIMA)        !sdexplo
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NMTRMB(1:NCHTRM))       !utilite
         TYTRMB=TYPINT (ITYPTR)                                         !utilite
*
         CALL TBRR1  (ERCODE,NMTRMB(:NCHTRM),NVTRMB,LGTRMB)
         READRE='Y'
*
*        Le cas echeant recherche de la constante associee au terme courant
*
         MCCSTE=0
         CHCSTE=' '
         NIVDON=0
         OPERAT='+'
         TYPCST='REEL'
*
         IF (NUDONN.GT.0) THEN
            CALL TBAR1 (ERCODE,'$DONNE',1,MCDONN)
            CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)       !utilite
            TYPCST=TYPINT (ITYPDO)                                      !utilite
            IF (ITYDON.EQ.INTDON ('CONSTANTE').AND.NIVDON.GT.0) THEN    !utilite
               OPERAT='*'
               IF (TYPCST(1:2).EQ.'RE') THEN
                  CHCSTE='$RCSTE'
               ELSEIF (TYPCST(1:2).EQ.'CO') THEN
                  CHCSTE='$CCSTE'
               ELSEIF (TYPCST(1:2).EQ.'EN') THEN
                  CHCSTE='$ECSTE'
                  CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
                  INCSTE=IST(MCCSTE+NIVDON)
                  IF (INCSTE.EQ.1)  OPERAT='+'
                  IF (INCSTE.EQ.-1) OPERAT='-'
               ENDIF
            ENDIF
         ENDIF
*
         IF (INDSTB.EQ.INDSTO ('PLEIN-L').OR.
     &       INDSTB.EQ.INDSTO ('PLEIN-C')    ) THEN                     !utilite
*
*           La matrice courante est stockee pleine
*
            CALL ASMOPL (OPERAT,TYPCST,CHCSTE,NIVDON
     &                  ,NMTRMB(1:NCHTRM),NVTRMB,TYTRMB
     &                  ,NVNUBC,NBNEBC,NVNUBL,NBNEBL
     &                  ,NMTRMR,NVTRMR,TYTRMR,ITYSYR,NMSTOK,NVSTOR
     &                  ,NVNURC,NBNERC,NVNURL,NBNERL
     &                  ,NCPINC,NCPINL,LGTRMB,NVNCAV,NVNLAV
     &                  ,READRE,CRWORK,NIVIMP,IMPFCH)                   !assembl
*
            NVSTAV=NDFSTO
*
         ELSE
*
            IF (NVSTOB.EQ.NVSTOR) THEN
*
*              La matrice courante a le meme stockage que la matrice resultat
*              On assemble les coefficients par combinaison lineaire
*                               R(I)=R(I) + c. B(I)
*
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOB,MCSTOB)
*
               CALL ASIDMO (OPERAT,TYPCST,CHCSTE,NIVDON
     &                     ,NMTRMB(1:NCHTRM),NVTRMB,TYTRMB,ITYSYB
     &                     ,NMSTOK,NVSTOB,NMTRMR,NVTRMR,TYTRMR,ITYSYR
     &                     ,NCPINC,NCPINL)                              !assembl
*
               CALL TBSAVE (NMSTOK,NVSTOB)
*
            ELSE
*
*              Assemblage selon des tableaux de stockage differents
*
               CALL ASMOMO (OPERAT,TYPCST,CHCSTE,NIVDON
     &                     ,NMTRMB(1:NCHTRM),NVTRMB,TYTRMB,ITYSYB
     &                     ,NMSTOK,NVSTOB,NVNUBC,NBNEBC,NVNUBL,NBNEBL
     &                     ,NMTRMR,NVTRMR,TYTRMR,ITYSYR,NVSTOR
     &                     ,NVNURC,NBNERC,NVNURL,NBNERL
     &                     ,NCPINC,NCPINL,LGTRMB,NVSTAV
     &                     ,READRE,CRWORK,NIVIMP,IMPFCH)                !assembl
*
               NVSTAV=NVSTOB
*
            ENDIF
*
            NVNLAV=NDFNUM
            NVNCAV=NDFNUM
         ENDIF
         CALL TBSAVE (NMTRMB(1:NCHTRM),NVTRMB)
1     CONTINUE
      IF (CRWORK.EQ.'Y') THEN
         CALL TBTUER ('$WORK$',0)
         CALL TBSAVE ( NMSTOK ,NVSTOR)
         CALL TBSAVE ('#GNEDO',NVNURC)
         IF (NVNURC.NE.NVNURL) CALL TBSAVE ('#GNEDO',NVNURL)
      ENDIF
      CALL PRFXMJ (-1,'*AsMatr*')  
                                                                    END !AsMatr
