*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMNIV (NMTERM,NVTERM,NUTERA,NVASMB,ITYPTA,NUINCR
     &                  ,NVDUCR,NBCOLX,NVNUCR,NCPINC,NUINLR,NVDULR
     &                  ,NBLIGX,NVNULR,NCPINL,ITYSYR,INDSTR,NVSTOR
     &                  ,NVCOOR,IADRDO,NVNUC1,NVNUL1,NVSTO1
     &                  ,IDMSTK,IDMBMS,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.4
*
* Modifications anterieures
* D.Martin (4 octobre 2002) correction d'un bug d'impression (99993)
* D.Martin (18 juin 2002)
* 
* Determination des niveaux des tableaux de numerotations du tableau 
* resultat de l'assemblage et de l'ordre de parcours de la structure 
*  
*-- Arguments d'entree --
* NMTERM nom du terme a assemble
* NVTERM niveau du terme a assemble
* NUTERA numero du terme resultat
* NVASMB niveau de la structure d'assemblage
*-- Arguments de sortie -- (indices de description du terme asssemble) 
* ITYPTA Type du terme assemble (reel,complexe, ... )
* NUINCR numero de l'inconnue en colonne
* NVNUCR niveau du tableau de numerotation globale des noeuds en colonne
* NBCOLX surestimation du nombre de d.l. en colonne du terme resultat
* NCPINC nombre de composantes de l'inconnue en colonne
* NUINLR numero de l'inconnue en ligne 
* NVNULR niveau du tableau de numerotation globale des noeuds en ligne 
* NBLIGX surestimation du nombre de d.l. en ligne du terme resultat  
* NCPINL nombre de composantes de l'inconnue en ligne
* ITYSYR indicateur de symetrie du resultat
* INDSTR indice de type de stockage du terme resultat 
* NVSTOR niveau du tableau de stockage matriciel du resultat
* NVCOOR niveau du tableau de coordonnees des noeuds en colonne
* IADRDO adresse relative dans la structure #TERDO
* NVNUC1 niveau de la numerotation globale des noeuds en colonne du 1er terme
* NVNUL1 niveau de la numerotation globale des noeuds en ligne du 1er terme
* NVSTO1 niveau du tableau de stockage du 1er terme
* IDMSTK indicateur de type de stockage identique pour tous les termes
* IDMBMS indicateur de stockage bi-morse
* IRCODE indicateur d'erreur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      CHARACTER IDMSTK,IDMBMS
      INTEGER   NVTERM,NUTERA,NVASMB,ITYPTA,NUINCR,NVDUCR,NBCOLX
     &         ,NVNUCR,NCPINC,NUINLR,NVDULR,NBLIGX,NVNULR,NCPINL
     &         ,ITYSYR,INDSTR,NVSTOR,NVCOOR,IADRDO
     &         ,NVNUC1,NVNUL1,NVSTO1,IRCODE
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      INTEGER       INDSTO,INTTYP
      INTEGER       MCCONU,MCDONN,MCMTRM,MCASMB,ADASMB,MCDTRM
      INTEGER       ITYSY0,ITYSY1,INDSBI,INDSML,INDSMC,INDSPL,INDSPC
     &             ,ITYCMP,IGTNCO,IGTNLI,NGTNCO,NGTNLI,LG
     &             ,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &             ,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NUTER1,NIVTR1,NUDON1
     &             ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVASMM
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &             ,NVNUML,INDSTK,NVSTOK,NVCORC,IATRDO,NIVITR
     &             ,ITYPT1,INDST1,INTRPC,NBTNEC,INTRPL,NBTNEL
     &             ,NCATR1,NCATR2,NCATR3,ITYDON,NIVDON,ITYPDO,IAUX
      CHARACTER     STOCHN*6,STOIND*7
      CHARACTER     ERCODE*120,IDMSYM,MEMNUC,MEMNUL
      CHARACTER     NMTRMB*16,CHCSTE*6,NMSTOK*6,CRWORK,READRE
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(89:89),NMTRMB)
     &            ,(ERCODE(105:105),CHCSTE),(ERCODE(113:113),NMSTOK)
     &            ,(ERCODE(119:119),CRWORK)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsmNiv*')
      ITYSY0=ITYSYR
*
      INDSBI=INDSTO ('BIMORSE')                                         !utilite
      INDSML=INDSTO ('MORSE-L')                                         !utilite
      INDSMC=INDSTO ('MORSE-C')                                         !utilite
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
      INDSPC=INDSTO ('PLEIN-C')                                         !utilite
      ITYCMP=INTTYP ('COMPLEXE')                                        !utilite
*
*     Adresses des structures de description des Termes ($SDTRM),
*     des donnees ($DONNE) et de la structure d'assemblage.
*
      CALL TBAR3  (ERCODE,'$ASMBL',NVASMB,MCASMB,'$SDTRM',1,MCDTRM
     &                   ,'$DONNE',1,MCDONN)                     
      READRE='N'
*
*     Caracteristiques de la structure de description des termes
*
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Caracteristiques de la structure d'assemblage
*
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
*
*--   Reperage du 1er terme stocke Morse (Bimorse, Morse-L ou Morse-C).
*--   Le cas echeant, on le place en premier dans la liste.
*
*     adresse contenant le numero du premier terme a assembler
      ADASMB=MCASMB+LGETRA
*     adresse des caracteristiques du 1er terme de la structure $ASMBL
*     dans la structure des termes ($SDTRM)
      NUTER1=IST(ADASMB)
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTER1-1)),NIVTR1 
     &            ,ITYPTA,ITYCAL,NUKALE,NUDONN,ITYSYR,NVASMM
     &            ,NUINCR,NVDUCR,NBCOLX,NVNUC1
     &            ,NUINLR,NVDULR,NBLIGX,NVNUL1
     &            ,INDST1,NVSTO1,NVCOOR,IADRDO,NIVITR)                  !sdexplo
*
      INDSTR = INDSBI
      IF (NUINCR.GT.NUINLR) THEN
         INDSTR = INDSMC
      ELSEIF (NUINCR.LT.NUINLR) THEN
         INDSTR = INDSML
      ENDIF
      NMSTOK=STOCHN (INDSTR)
      NVNUCR = NVNUC1
      NVNULR = NVNUL1
      NGTNCO = NBCOLX
      NGTNLI = NBLIGX
*
      IF (INDST1.EQ.INDSBI.OR.INDST1.EQ.INDSML.OR.INDST1.EQ.INDSMC) THEN
*
*        Le 1er terme est stocke 'Morse', on ne modifie pas la structure
*        (pour le moment)
*
         NVSTOR = NVSTO1
*
      ELSE
*
         DO 1 NUTRAS=2,NBTRAC
            ADASMB=ADASMB+INCTRA
*           numero du prochain terme dans la structure d'assemblage $ASMBL
            NUTERM=IST(ADASMB)
*           caracteristiques du prochain terme a assembler
            CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVTRM 
     &                  ,ITYPT1,ITYCAL,NUKALE,NUDON1,ITYSY1,NVASMM
     &                  ,NUINCR,NVDUCR,NGTNCO,NVNUC1
     &                  ,NUINLR,NVDULR,NGTNLI,NVNUL1
     &                  ,INDST1,NVSTO1,NVCOOR,IADRDO,NIVITR)            !sdexplo
            IF (INDST1.EQ.INDSBI
     &      .OR.INDST1.EQ.INDSML.OR.INDST1.EQ.INDSMC) GOTO 2
 1       CONTINUE
*
*        Aucun des termes de l'assemblage n'est stocke 'Morse'
*        (Il sont tous pleins, la-dedans !).
*        On ne modifie pas la structure et on creera une structure 'Morse'
*        (Bimorse, Morse-L ou Morse-C selon le cas)
*
         NVNUC1 = NVNUCR
         NVNUL1 = NVNULR
         NGTNCO = NBCOLX
         NGTNLI = NBLIGX
         NVSTOR = NDFSTO
         GOTO 3
*
*        Le terme assemble herite des caracteristiques du 'nouveau' 1er terme
*        ('Morse') de la structure
*
 2       NVNUCR = NVNUC1
         NVNULR = NVNUL1
         NVSTOR = NVSTO1
         ITYPTA = ITYPT1
         ITYSYR = ITYSY1
         NBCOLX = NGTNCO
         NBLIGX = NGTNLI
         NUDONN = NUDON1
*
*        On place le terme trouve en premier
*
         IAUX=IST(ADASMB)
         IST(ADASMB)=IST(MCASMB+LGETRA)
         IST(MCASMB+LGETRA)=IAUX
*
      ENDIF
*
*     Le terme assemble herite du type du 'nouveau' 1er terme
*
 3    IF (ITYPTA.NE.ITYCMP.AND.NUDONN.GT.0) THEN
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYPDO.EQ.ITYCMP) ITYPTA=ITYCMP
      ENDIF
*
*--    Prise en compte des attributs des autres termes de l'assemblage
*--
*
      IDMBMS='Y'
      IDMSYM='Y'
      IDMSTK='Y'
      MEMNUC='Y'
      MEMNUL='Y'
      IGTNCO=1
      IGTNLI=1
      DO 11 NUTRAS=2,NBTRAC
         IF (READRE.EQ.'Y') THEN
            CALL TBAR3  (ERCODE,'$ASMBL',NVASMB,MCASMB
     &                         ,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN)
            READRE='N'
         ENDIF
         ADASMB=MCASMB+LGETRA+INCTRA*(NUTRAS-1)
         NUTERM=IST(ADASMB)
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVTRM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVASMM
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVITR)               !sdexplo
*
*        Type de symetrie du terme
         IF (ITYSYM.NE.ITYSYR) IDMSYM='N'
*  
*        Compatibilite des inconnues en colonne et ligne
         IF (NUINCR.NE.NUINCC) GOTO 99991
         IF (NUINLR.NE.NUINCL) GOTO 99992
*
*        Identite ou non des numerotations
         IF (NVNUMC.NE.NVNUCR) MEMNUC='N'
         IF (NVNUML.NE.NVNULR) MEMNUL='N'
*
*        Compatibilite des types de stockage
         IF (INDSTK.NE.INDST1) THEN
*           Si les compactages sont differents:
*           Indstk doit etre PLEIN-L si INDST1 est BIMORSE ou MORSE-L,
*           Indstk doit etre PLEIN-C si INDST1 est MORSE-C.
            IF ( (INDSTK.EQ.INDSPL.AND.INDST1.NE.INDSMC).OR.
     &           (INDSTK.EQ.INDSPC.AND.INDST1.EQ.INDSMC)) THEN
               IDMSTK='N'
            ELSE
               GOTO 99993
            ENDIF
         ENDIF
*        Compatibilite de symetrie du compactage bimorse
*        (une matrice compactee bimorse mais non symetrique peut avoir
*         des zeros structurels sur sa diagonale, devant etre
*         introduit dans le compactage du resultat)
         IF (ITYSYM.EQ.NDFSYM.AND.INDSTK.EQ.INDSBI) IDMBMS='N'
*
*        Type (REEL ou COMPLEXE) du terme resultat
         IF (ITYPTA.NE.ITYCMP) THEN
            IF (ITYPTR.EQ.ITYCMP) ITYPTA=ITYCMP
            IF (NUDONN.GT.0) THEN
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
               IF (ITYPDO.EQ.ITYCMP) ITYPTA=ITYCMP
            ENDIF
         ENDIF
*  
*        Surestimation des nombres max de d.l. en colonne et ligne
         NBCOLX=NBCOLX+NBCOLO
         NBLIGX=NBLIGX+NBLIGN
*  
*        Recherche du terme de la structure d'assemblage ayant les plus
*        grosses numerotations en colonne et ligne
         IF ((NBCOLO.GT.NGTNCO.AND.NBLIGN.GT.NGTNLI)
     &   .OR.(IGTNCO.NE.IGTNLI
     &      .AND.(NBCOLO.GE.NGTNCO.AND.NBLIGN.GE.NGTNLI))) THEN
            IGTNCO=NUTRAS
            NGTNCO=NBCOLO
            NVDUCR=NVDUMC
            NVNUCR=NVNUMC
            IGTNLI=NUTRAS
            NGTNLI=NBLIGN
            NVDULR=NVDUML
            NVNULR=NVNUML
            IF (NVSTOK.NE.NDFSTO) NVSTOR=NVSTOK  
            NVCOOR=NVCORC
            IADRDO=IATRDO
         ENDIF
*        Recherche de la plus grosse numerotation en colonne
         IF (NBCOLO.GT.NGTNCO) THEN 
            IGTNCO=NUTRAS
            NGTNCO=NBCOLO
            NVDUCR=NVDUMC
            NVNUCR=NVNUMC
            NVCOOR=NVCORC
         ENDIF
*        Recherche de la plus grosse numerotation en ligne 
         IF (NBLIGN.GT.NGTNLI) THEN
            IGTNLI=NUTRAS
            NGTNLI=NBLIGN
            NVDULR=NVDUML
            NVNULR=NVNUML
         ENDIF
*
11    CONTINUE
*  
*     Reordonnement des termes de la structure :
*     On place en premier dans la structure d'assemblage le terme dont la  
*     numerotation en ligne contient les numerotations des autres
*
      IF (IGTNLI.GT.1) THEN
         ADASMB=MCASMB+LGETRA+INCTRA*(IGTNLI-1)
         IAUX=IST(ADASMB)
         IST(ADASMB)=IST(MCASMB+LGETRA)  
         IST(MCASMB+LGETRA)=IAUX
      ELSEIF (IGTNCO.GT.1) THEN
         ADASMB=MCASMB+LGETRA+INCTRA*(IGTNCO-1)
         IAUX=IST(ADASMB)
         IST(ADASMB)=IST(MCASMB+LGETRA)  
         IST(MCASMB+LGETRA)=IAUX
      ENDIF
*
      CALL TBAR1  (ERCODE,'#NCONU',1,MCCONU)                     
      CALL SDEXCO (NUINCR,IST(MCCONU),NCPINC,INTRPC,NBTNEC)             !utilite
      CALL SDEXCO (NUINLR,IST(MCCONU),NCPINL,INTRPL,NBTNEL)             !utilite
*
*     Les plus gros tableaux de numerotations sont rapatries en M.C.
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUCR,LG)
      IF (NVNULR.NE.NVNUCR) CALL TBRR1  (ERCODE,'#GNEDO',NVNULR,LG)
      ERCODE(1:1)='!'
      CALL TBRR1  (ERCODE,NMSTOK,NVSTOR,LG)
*
      IF (IDMSTK.EQ.'N'.OR.MEMNUC.EQ.'N'.OR.
     &    MEMNUL.EQ.'N'.OR.IDMBMS.EQ.'N') THEN
*        Recherche d'un domaine total pour numerotation en ligne ou colonne
         IF (NGTNCO.LT.NBTNEC) THEN 
            NVNUCR = NDFNUM
            NVDUCR = NDFDUM
            NVCOOR = NDFCOR
         ENDIF
         IF (NGTNLI.LT.NBTNEL) THEN 
            NVNULR = NDFNUM
            NVDULR = NDFDUM
         ENDIF
*        Il faut fabriquer le compactage car un des terme est "PLEIN" 
*        ou "BIMORSE" et non symetrique
         NVSTOR = NDFSTO
      ENDIF
      IF (NVNUCR.NE.NDFNUM) NBCOLX = NGTNCO
      IF (NVNULR.NE.NDFNUM) NBLIGX = NGTNLI
*
      IF (IDMSYM.EQ.'N') ITYSYR=NDFSYM
*
*     Si le type de symetrie  declare de la matrice ne correspond pas
*     au type prevu par le programme
*
      IF (ITYSY0.NE.NDFSYM) THEN
         IF (ITYSY0.NE.ITYSYR) IRCODE=-1
         ITYSYR=ITYSY0
      ENDIF
      CALL PRFXMJ (-1,'*AsmNiv*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL TBAR1  (ERCODE,'#OMTRM',1,MCMTRM)                     
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(1:NCHTRM))
      CALL ERTERS (9,NMTERM,NVTERM,ERCODE(1:NCHTRM),NIVTRM)
*
99992 CALL TBAR1  (ERCODE,'#OMTRM',1,MCMTRM)                     
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(1:NCHTRM))
      CALL ERTERS (10,NMTERM,NVTERM,ERCODE(1:NCHTRM),NIVTRM)
*
99993 CALL TBAR1  (ERCODE,'#OMTRM',1,MCMTRM)                     
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTER1,ERCODE(1:NCHTRM))
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(NCHTRM+1:2*NCHTRM))
      CALL PRNTRM (NMTERM,NVTERM,ERCODE(2*NCHTRM+1:),NCATR1)
      CALL PRNTRM (ERCODE(1:NCHTRM),NIVTR1
     &            ,ERCODE(2*NCHTRM+NCATR1+1:),NCATR2)
      CALL PRNTRM (ERCODE(NCHTRM+1:2*NCHTRM),NIVTRM
     &            ,ERCODE(2*NCHTRM+NCATR1+NCATR2+1:),NCATR3)
      IAUX=2*NCHTRM+NCATR1+NCATR2+NCATR3
      ERCODE(IAUX+1:IAUX+7)=STOIND (INDSTK)                             !utilite
      ERCODE(IAUX+8:IAUX+14)=STOIND (INDST1)                            !utilite
      CALL BAISE  (' Assemblage du terme '
     &//ERCODE(2*NCHTRM+1:2*NCHTRM+NCATR1)
     &//', incompatibilite entre le type de stockage du terme '
     &//ERCODE(IAUX-NCATR3+1:IAUX)
     &//' ('//ERCODE(IAUX+1:IAUX+7)
     &//') et le type de stockage du 1er terme '
     &//ERCODE(2*NCHTRM+NCATR1+1:2*NCHTRM+NCATR1+NCATR2)
     & //' ('//ERCODE(IAUX+8:IAUX+14)//').')
                                                                    END !AsmNiv
