*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMOMO (OPERAT,TYPCST,CHCSTE,NUMCST
     &                  ,NMTRMB,NVTRMB,TYTRMB,ITYSYB,NMSTOK,NVSTOB
     &                  ,NVNUBC,NBNEBC,NVNUBL,NBNEBL
     &                  ,NMTRMR,NVTRMR,TYTRMR,ITYSYR,NVSTOR
     &                  ,NVNURC,NBNERC,NVNURL,NBNERL
     &                  ,NCPINC,NCPINL,LGTRMB,NVSTAV
     &                  ,READRE,CRWORK,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)  
* Derniere modification : D.Martin (11 decembre 2002)
* Version 1.0.1
*  
* Assemblage d'une matrice stockee Bi-Morse, Morse-Ligne ou Morse-Colonne (B)
* dans une matrice (R) stockee selon des structures differentes.
*  
*-- Arguments d'entree --
* OPERAT operateur de combinaison lineaire ('*', '+' ou '-')
* TYPCST type (entier, reel ou complexe) de la constante si OPERAT='*'
* CHCSTE le cas echeant, nom du tableau des constantes du type ad'hoc
* NUMCST son numero dans la liste des constantes du type adequat
* NMTRMB nom du terme a combiner (B)
* NVTRMB son niveau
* TYTRMB type (reel ou complexe) du terme (B)
* ITYSYB indicateur de symetrie du terme (B)
* NMSTOK nom du tableau de stockage du terme (B)
* NVSTOB niveau du tableau de stockage du terme (B)
* NVNUBC niveau du tableau #GNEDO de numerotation des noeuds en colonne de (B)
* NBNEBC nombre de colonnes du terme 
* NVNUBL niveau du tableau #GNEDO de numerotation des noeuds en ligne de (B)
* NBNEBL nombre de lignes du terme (B)
* NMTRMR nom du terme Morse resultat (R)
* NVTRMR son niveau
* TYTRMR type (reel ou complexe) du terme resultat (R)
* ITYSYR indicateur de symetrie du terme resultat (R)
* NVSTOR niveau du tableau de stockage du terme resultat (R)
* NVNURC niveau du tableau #GNEDO de numerotation des noeuds en colonne de (R)
* NBNERC nombre de colonnes du terme resultat 
* NVNURL niveau du tableau #GNEDO de numerotation des noeuds en ligne de (R)
* NBNERL nombre de lignes du terme resultat (R)
* NCPINC nombre de composante de l'inconnue (vectorielle) en colonne
* NCPINL nombre de composante de l'inconnue (vectorielle) en ligne
* LGTRMB longueur du terme operande (B)
* NVSTAV valeur de NVSTOB du terme assemble precedent
* READRE indicateur de recalcul necessaire d'adresses en MC
* CRWORK indicateur de creation d'un tableau de travail
* NIVIMP niveau d'impression pour les pointeurs
* IMPFCH unite d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) OPERAT,TYPCST,CHCSTE,NMTRMB,TYTRMB,NMSTOK
     &             ,NMTRMR,TYTRMR,READRE,CRWORK
      INTEGER       NUMCST,NVTRMB,ITYSYB,NVNUBC,NBNEBC,NVNUBL,NBNEBL
     &             ,NVSTOB,NVTRMR,ITYSYR,NVNURC,NBNERC,NVNURL,NBNERL
     &             ,NVSTOR,NCPINC,NCPINL,LGTRMB,NVSTAV,NIVIMP,IMPFCH
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*
      INTEGER       INDSYM
      INTEGER       ADTRMU,ITYSNO,ITYSYM,NCFSSD
     &             ,MCSTOB,NBL,NBPL,MCPLAG,MCPLIG,LGLB
     &             ,NBC,NBPC,MCPLAU,MCPLIU,LGUB,LGDB,NBPTRL,NBPTRU
     &             ,MCNEBC,MCNEBL,LGPTRS,MCPTRS,MCSTOR,MCNERC,MCNERL
     &             ,IDBPTR,IDBPTU,MCPLAR,MCPLIR,LGLS,MCPARU,MCPIRU,LGUS
     &             ,LGLSV,LGLBV,MCCSTE,MCTRMB,MCPTRB,I
      CHARACTER     SYMIND*14
      CHARACTER     TYPSYM*14,ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Asmomo*')
*
      ITYSNO=NDFSYM
      ITYSYM=INDSYM ('SYMETRIQUE')                                      !utilite
*
      NCFSSD=MAX(NCPINL,NCPINC)
      IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
*
      IF (NVSTOB.EQ.NVSTAV) THEN
*
*        Les tableaux de pointeurs existent (pour l'operande precedent)
*
         CALL TBRR1  (ERCODE,NMSTOK,NVSTOB,MCSTOB)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOB,MCSTOB)
*
         IF (NMSTOK.EQ.'&BMORS') THEN
            CALL EXBMOR (MCSTOB,IST(MCSTOB),NBL,NBPL,MCPLAG,MCPLIG,LGLB 
     &                                     ,NBC,NBPC,MCPLAU,MCPLIU,LGUB)!sdexplo
            LGDB=MIN (NBC*NCPINC,NBL*NCPINL)
            LGLB=LGLB*NCPINC*NCPINL+MIN(NBL,NBC)*NCFSSD
            NBPTRL=LGDB+LGLB
            NBPTRU=LGUB*NCPINC*NCPINL+MIN(NBL,NBC)*NCFSSD
         ELSEIF (NMSTOK.EQ.'&PLAGE') THEN
            CALL EXMORS (MCSTOB,IST(MCSTOB)
     &                  ,NBL,NBC,NBPL,MCPLAG,MCPLIG,LGLB)               !sdexplo
            NBPTRL=LGLB*NCPINC*NCPINL
*           En fait on doit avoir ici NBPTRL=LGTRMB
         ELSEIF (NMSTOK.EQ.'&EGALP') THEN
            CALL EXMORS (MCSTOB,IST(MCSTOB)
     &                  ,NBC,NBL,NBPC,MCPLAG,MCPLIG,LGLB)               !sdexplo
            NBPTRL=LGLB*NCPINC*NCPINL
*           En fait on doit avoir ici NBPTRL=LGTRMB
         ELSE
            CALL ERTERM (18,NMTRMB,NVTRMB)                              !utilite
         ENDIF
*
      ELSE
*
*        Calcul du tableau des pointeurs d'assemblage de sorte que
*        l'assemblage se reduise a l'operation :
*                       R(PTR(I))=R(PTR(I)) + c. B(I)
*
         CALL TBRR2  (ERCODE,NMSTOK,NVSTOB,MCSTOB
     &                      ,'#GNEDO',NVNUBC,MCNEBC)
         IF (NVNUBL.NE.NVNUBC)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNUBL,MCNEBL)
*
         LGPTRS=LGTRMB
*
*        Cas d'une matrice B symetrique mais pas R
*
         IF (ITYSYB.EQ.ITYSYM.AND.ITYSYR.EQ.ITYSNO)
     &      LGPTRS=2*LGTRMB-MIN (NBNEBL*NCPINL,NBNEBC*NCPINC)
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,'$WORK$',0,MCPTRS)
         IF (ERCODE(1:1).EQ.'C') THEN
            CRWORK='Y'
            CALL TBCREE ('$WORK$',0,1,LGPTRS,'c')
            CALL TBRR2  (ERCODE, NMSTOK ,NVSTOR,MCSTOR
     &                         ,'#GNEDO',NVNURC,MCNERC)
            IF (NVNURC.NE.NVNURL)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNURL,MCNERL)
         ELSE
            CALL TBAJST ('$WORK$',0,LGPTRS)
         ENDIF
         READRE='Y'
         CALL TBAR7  (ERCODE,NMSTOK,NVSTOB,MCSTOB,NMSTOK,NVSTOR,MCSTOR
     &                  ,'#GNEDO',NVNUBC,MCNEBC,'#GNEDO',NVNURC,MCNERC
     &                  ,'#GNEDO',NVNUBL,MCNEBL,'#GNEDO',NVNURL,MCNERL
     &                  ,'$WORK$',0,MCPTRS)
         NBPTRL=0
         IDBPTR=0
         IF (NMSTOK.EQ.'&BMORS') THEN
*           Assemblage de matrices Bi-Morse
            CALL EXBMOR (MCSTOB,IST(MCSTOB),NBL,NBPL,MCPLAG,MCPLIG,LGLB
     &                                     ,NBC,NBPC,MCPLAU,MCPLIU,LGUB)!sdexplo
            CALL EXBMOR (MCSTOR,IST(MCSTOR),NBL,NBPL,MCPLAR,MCPLIR,LGLS
     &                                     ,NBC,NBPC,MCPARU,MCPIRU,LGUS)!sdexplo
            LGDB=MIN (NBNEBL,NBNEBC)
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
               IDBPTR=MIN(NBNERL,NBNERC)
               IDBPTU=IDBPTR+LGLS
*              Pointeurs d'assemblage de la partie diagonale de B
               CALL ASMPTD (NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPARU),IST(MCPIRU),IDBPTU,IST(MCPTRS)) !assembl
               NBPTRL=LGDB
*              Pointeurs d'assemb. de la partie triang. inf. de B
               CALL ASMPTM (1,NBNEBL,IST(MCNEBL+2),IST(MCNEBC+2)
     &                     ,IST(MCPLAG),IST(MCPLIG),NBPTRL
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPARU),IST(MCPIRU),IDBPTU,IST(MCPTRS)) !assembl
               NBPTRU=NBPTRL
               IF (MCPARU.NE.MCPLAR.OR.MCPLAU.NE.MCPLAG) THEN
*                 Si la matrice assemblee est non symetrique en structure
*                 pointeurs d'assemblage de la partie triangulaire sup. de B
                  CALL ASMPTM (1,NBNEBC,IST(MCNEBC+2),IST(MCNEBL+2)
     &                        ,IST(MCPLAU),IST(MCPLIU),NBPTRU
     &                        ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                       ,IST(MCPARU),IST(MCPIRU),IDBPTU,IST(MCPLAR)
     &                        ,IST(MCPLIR),IDBPTR,IST(MCPTRS))          !assembl
                  NBPTRU=NBPTRU-NBPTRL
               ELSEIF (ITYSYR.EQ.ITYSNO) THEN
*                 Si la matrice est symetrique en structure mais
*                 ni (anti)symetrique ni (anti)adjointe, les pointeurs
*                 de la partie sup. se deduisent de ceux de la partie inf.
                  MCPTRB=MCPTRS+LGDB
                  DO 10 I=MCPTRB,MCPTRB+LGLB-1
10                   IST(LGLB+I)=IST(I)+LGLS
                  NBPTRU=LGLB
               ENDIF
               IF (NIVIMP.GT.10)
     &         CALL PRPTBM (IST(MCSTOB),ITYSYB,1,1
     &                     ,MCPTRS,IST,NIVIMP,IMPFCH)                   !prsd
            ELSE
*--            Cas d'inconnues vectorielles
               IDBPTR=MIN(NBNERL*NCPINL,NBNERC*NCPINC)
               LGLSV=LGLS*NCPINC*NCPINL+MIN(NBNERL*NCFSSD,NBNERC*NCFSSD)
               IDBPTU=IDBPTR+LGLSV
               CALL ASMPVD (NCPINL,NCPINC
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2) 
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPARU),IST(MCPIRU),IDBPTU,IST(MCPTRS)) !assembl
               LGDB=MIN(NBNEBL*NCPINL,NBNEBC*NCPINC)
               NBPTRL=LGDB
               CALL ASMPVM (1,NCPINL,NCPINC,NBNEBL,IST(MCNEBL+2),NBNEBC 
     &                     ,IST(MCNEBC+2),IST(MCPLAG),IST(MCPLIG)
     &                 ,NBPTRL,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPARU),IST(MCPIRU),IDBPTU,IST(MCPTRS)) !assembl
               NBPTRU=NBPTRL
               IF (MCPARU.NE.MCPLAR.OR.MCPLAU.NE.MCPLAG) THEN
                  CALL ASMPVM (1,NCPINC,NCPINL,NBNEBC,IST(MCNEBC+2)      
     &                     ,NBNEBL,IST(MCNEBL+2),IST(MCPLAU),IST(MCPLIU)
     &                 ,NBPTRU,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                     ,IST(MCPARU),IST(MCPIRU),IDBPTU
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR,IST(MCPTRS)) !assembl
                  NBPTRU=NBPTRU-NBPTRL
               ELSEIF (ITYSYR.EQ.ITYSNO) THEN
                  MCPTRB=MCPTRS+LGDB
                  LGLBV=LGLB*NCPINC*NCPINL+MIN(NBNEBL,NBNEBC)*NCFSSD
                  DO 11 I=MCPTRB,MCPTRB+LGLBV-1
11                   IST(LGLBV+I)=IST(I)+LGLSV
                  NBPTRU=LGLBV
               ENDIF
               IF (NIVIMP.GT.10)
     &         CALL PRPTBM (IST(MCSTOB),ITYSYB,NCPINC,NCPINL
     &                     ,MCPTRS,IST,NIVIMP,IMPFCH)                   !prsd
            ENDIF
*
         ELSEIF (NMSTOK.EQ.'&PLAGE') THEN
*
            CALL EXMORS (MCSTOB,IST(MCSTOB),NBL,NBC,NBPL,MCPLAG,MCPLIG
     &                  ,LGLB)
            CALL EXMORS (MCSTOR,IST(MCSTOR),NBL,NBC,NBPL,MCPLAR,MCPLIR
     &                  ,LGLS)
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
               CALL ASMPTM (0,NBNEBL,IST(MCNEBL+2),IST(MCNEBC+2)         
     &                     ,IST(MCPLAG),IST(MCPLIG),NBPTRL
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR,IST(MCPTRS)) !assembl
            ELSE
*--            Cas d'inconnues vectorielles
               CALL ASMPVM (0,NCPINL,NCPINC,NBNEBL,IST(MCNEBL+2),NBNEBC  
     &                     ,IST(MCNEBC+2),IST(MCPLAG),IST(MCPLIG),NBPTRL
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR,IST(MCPTRS)) !assembl
            ENDIF
         ELSEIF (NMSTOK.EQ.'&EGALP') THEN
*
            CALL EXMORS (MCSTOB,IST(MCSTOB),NBC,NBL,NBPC,MCPLAG,MCPLIG
     &                  ,LGLB)
            CALL EXMORS (MCSTOR,IST(MCSTOR),NBC,NBL,NBPC,MCPLAR,MCPLIR
     &                  ,LGLS)
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
               CALL ASMPTM (0,NBNEBC,IST(MCNEBC+2),IST(MCNEBL+2)         
     &                     ,IST(MCPLAG),IST(MCPLIG),NBPTRL
     &                     ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR,IST(MCPTRS)) !assembl
            ELSE
*--            Cas d'inconnues vectorielles
               CALL ASMPVM (0,NCPINC,NCPINL,NBNEBC,IST(MCNEBC+2),NBNEBL  
     &                     ,IST(MCNEBL+2),IST(MCPLAG),IST(MCPLIG),NBPTRL
     &                     ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR
     &                     ,IST(MCPLAR),IST(MCPLIR),IDBPTR,IST(MCPTRS)) !assembl
            ENDIF
         ENDIF
*
         IF (NVNUBC.NE.NVNURC.AND.NVNUBC.NE.NVNURL)
     &   CALL TBSAVE ('#GNEDO',NVNUBC)
         IF (NVNUBL.NE.NVNURL.AND.NVNUBL.NE.NVNURC.AND.
     &   NVNUBL.NE.NVNUBC) CALL TBSAVE ('#GNEDO',NVNUBL)
*
      ENDIF
      CALL TBSAVE (NMSTOK,NVSTOB)
*
*--   Assemblage proprement dit : R(PTR(I))=R(PTR(I)) + c. B(I)
*
      ADTRMU=0
      CALL ASMCPT (OPERAT,CHCSTE,TYPCST,NUMCST,NMTRMB,NVTRMB,TYTRMB     
     &            ,NBPTRL,ADTRMU,ADTRMU,NMTRMR,NVTRMR,TYTRMR
     &            ,IST,RST,CST)                                         !assembl
*
      IF (ITYSYR.EQ.ITYSNO.AND.NMSTOK.EQ.'&BMORS') THEN
*
*        Assemblage de la partie triangulaire superieure (cas BiMorse)
*
         IF (OPERAT(1:1).EQ.'*') CALL TBAR1  (ERCODE,CHCSTE,1,MCCSTE)
         CALL TBAR1  (ERCODE,NMTRMB,NVTRMB,MCTRMB)
         TYPSYM=SYMIND (ITYSYB)                                         !utilite
*
         IF (ITYSYB.EQ.ITYSYR) THEN
*           Matrice (B) ni sym., ni antisym., ni autoadj., ni antiadj.
            ADTRMU=NBPTRL
         ELSE
            ADTRMU=LGDB
*           Matrice (B) autoadjointe ou antiadjointe
            IF (TYPSYM(5:12).EQ.'ADJOINTE') 
     &         CALL TCDANT (LGLB,TYTRMB,MCTRMB,RST,CST
     &                          ,TYTRMB,MCTRMB,RST,CST)                 !utilite
*           Matrice (B) antisymetrique ou antiadjointe
            IF (TYPSYM(1:4).EQ.'ANTI')
     &         CALL ASMNSY (OPERAT,TYPCST,MCCSTE+NUMCST,IST,RST,CST)    !assembl
         ENDIF
*
         CALL ASMCPT (OPERAT,CHCSTE,TYPCST,NUMCST,NMTRMB,NVTRMB,TYTRMB
     &               ,NBPTRU,ADTRMU,NBPTRL,NMTRMR,NVTRMR,TYTRMR
     &               ,IST,RST,CST)                                      !assembl
*
         IF (ITYSYB.NE.ITYSYR) THEN
            IF (TYPSYM(5:12).EQ.'ADJOINTE')
     &         CALL TCDANT (LGLB,TYTRMB,MCTRMB,RST,CST 
     &                          ,TYTRMB,MCTRMB,RST,CST)                 !utilite
            IF (TYPSYM(1:4).EQ.'ANTI')
     &         CALL ASMNSY (OPERAT,TYPCST,MCCSTE+NUMCST,IST,RST,CST)    !assembl
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*Asmomo*')  
                                                                    END !Asmomo
