*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMOPL (OPERAT,TYPCST,CHCSTE,NUMCST
     &                  ,NMTRMB,NVTRMB,TYTRMB
     &                  ,NVNUBC,NBNEBC,NVNUBL,NBNEBL
     &                  ,NMTRMR,NVTRMR,TYTRMR,ITYSYR,NMSTOK,NVSTOR
     &                  ,NVNURC,NBNERC,NVNURL,NBNERL
     &                  ,NCPINC,NCPINL,LGTRMB,NVNCAV,NVNLAV
     &                  ,READRE,CRWORK,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)  
* Derniere modification : D.Martin (8 Septembre 2006)
* Version 1.2
*  
* Assemblage d'une matrice stockee Pleine (B) rangee ligne apres ligne
* dans une matrice Bi-Morse, Morse-Ligne ou Morse-Colonne (R) :
*                              'R = R + c.B'
*  
*-- Arguments d'entree --
* OPERAT operateur de combinaison lineaire ('*', '+' ou '-')
* TYPCST type (entier, reel ou complexe) de la constante si OPERAT='*'
* CHCSTE le cas echeant, nom du tableau des constantes du type ad'hoc
* NUMCST son numero dans la liste des constantes du type ad'hoc
* NMTRMB nom du terme Plein a combiner (B)
* NVTRMB son niveau
* TYTRMB type (reel ou complexe) du terme Plein (B)
* NVNUBC niveau du tableau #GNEDO de numerotation des noeuds en colonne de (B)
* NBNEBC nombre de colonnes du terme Plein 
* NVNUBL niveau du tableau #GNEDO de numerotation des noeuds en ligne de (B)
* NBNEBL nombre de lignes du terme Plein (B)
* NMTRMR nom du terme Morse resultat (R)
* NVTRMR son niveau
* TYTRMR type (reel ou complexe) du terme resultat (R)
* NVNURC niveau du tableau #GNEDO de numerotation des noeuds en colonne de (R)
* NBNERC nombre de colonnes du terme resultat 
* NVNURL niveau du tableau #GNEDO de numerotation des noeuds en ligne de (R)
* NBNERL nombre de lignes du terme resultat (R)
* ITYSYR indicateur de symetrie du terme resultat (R)
* NVSTOR niveau du tableau de stockage du terme resultat (R)
* NCPINC nombre de composante de l'inconnue (vectorielle) en colonne
* NCPINL nombre de composante de l'inconnue (vectorielle) en ligne
* LGTRMB longueur du terme operande (B)
* NVNCAV valeur precedente de NVNUBC si le terme precedent est stockee Plein
* NVNLAV valeur precedente de NVNUBL si le terme precedent est stockee Plein
* READRE indicateur de recalcul necessaire d'adresses en MC
* CRWORK indicateur de creation d'un tableau de travail
* NIVIMP niveau d'impression pour les pointeurs
* IMPFCH unite d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) OPERAT,TYPCST,CHCSTE,NMTRMB,TYTRMB,NMSTOK
     &             ,NMTRMR,TYTRMR,READRE,CRWORK
      INTEGER NUMCST,NVTRMB,NVNUBC,NBNEBC,NVNUBL,NBNEBL,NVTRMR,NVNURC
     &       ,NBNERC,NVNURL,NBNERL,ITYSYR,NVSTOR,NCPINC,NCPINL,LGTRMB
     &       ,NVNCAV,NVNLAV,NIVIMP,IMPFCH
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*
      INTEGER     ADTRMU,MCNEBC,MCNEBL,LGPTRS,MCPTRS
     &           ,MCSTOR,MCNERC,MCNERL,NBPTRB,IDBPTR,IAPTRO,IAPTRN
     &           ,NBL,NBPL,MCPLAR,MCPLIR,LGL,NBC,NBPC,MCPARU,MCPIRU,LGU
     &           ,NCFSSD,LGLV,I,J,IADOLD,IADNEW
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsMoPl*')
*
      IF (NVNCAV.NE.NVNUBC.OR.NVNLAV.NE.NVNUBL) THEN
*        Calcul du tableau des pointeurs d'assemblage de sorte que 
*        l'assemblage se reduise a l'operation : 
*                       R(PTR(I))=R(PTR(I)) + c. B(I)
*
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUBC,MCNEBC)
         IF (NVNUBL.NE.NVNUBC) 
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNUBL,MCNEBL)
*
         LGPTRS=LGTRMB
         ERCODE(1:1)='!'
         CALL TBAR1  (ERCODE,'$WORK$',0,MCPTRS)
         IF (ERCODE(1:1).EQ.'C') THEN
            CRWORK='Y'
            CALL TBCREE ('$WORK$',0,1,LGPTRS,'c')
            CALL TBRR2  (ERCODE, NMSTOK ,NVSTOR,MCSTOR
     &                         ,'#GNEDO',NVNURC,MCNERC)
            IF (NVNURC.NE.NVNURL)
     &         CALL TBRR1  (ERCODE,'#GNEDO',NVNURL,MCNERL)
         ELSE
            CALL TBAJST ('$WORK$',0,LGPTRS)
         ENDIF
         READRE='Y'
*
         CALL TBAR6  (ERCODE,'$WORK$',0,MCPTRS,NMSTOK,NVSTOR,MCSTOR
     &                  ,'#GNEDO',NVNUBC,MCNEBC,'#GNEDO',NVNURC,MCNERC
     &                  ,'#GNEDO',NVNUBL,MCNEBL,'#GNEDO',NVNURL,MCNERL)
         NBPTRB=0
         IDBPTR=0
*
         IF (NMSTOK.EQ.'&BMORS') THEN
*
*           Assemblage dans une matrice Bi-Morse
*
            CALL EXBMOR (MCSTOR,IST(MCSTOR),NBL,NBPL,MCPLAR,MCPLIR,LGL
     &                                     ,NBC,NBPC,MCPARU,MCPIRU,LGU) !sdexplo
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
*              Pointeurs d'assemblage dans la partie diagonale de B
               CALL ASMPTG (NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,NBPTRB,IST(MCPTRS))                         !assembl
*              Pointeurs d'assemblage dans la partie triang. inf. de B
               IDBPTR=MIN (NBNERL,NBNERC)
               CALL ASMPTP (1,NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
               IF (MCPARU.NE.MCPLAR) THEN
*                 Pointeurs d'assemblage dans la partie triang. sup. de B
                  IDBPTR=IDBPTR+LGL
                  CALL ASMPTP (1,1,NBNEBC
     &                        ,NBNEBC,IST(MCNEBC+2),NBNEBL,IST(MCNEBL+2)
     &                        ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                        ,IST(MCPARU),IST(MCPIRU)
     &                        ,NBPTRB,IDBPTR,IST(MCPTRS))               !assembl
               ELSEIF (ITYSYR.EQ.NDFSYM) THEN
*                 Si la matrice est symetrique en structure mais
*                 ni (anti)symetrique ni (anti)adjointe, les pointeurs
*                 de la partie sup. se deduisent de ceux de la partie inf.
                  IAPTRO=MCPTRS
                  IAPTRN=MCPTRS
                  DO 11 I=1,NBNEBL
                     IADOLD=IAPTRO
                     IADNEW=IAPTRN
                     DO 10 J=1,I-1
                        IST(IADNEW)=IST(IADOLD)+LGL
                        IADOLD=IADOLD+NBNEBL
                        IADNEW=IADNEW+NBNEBC
10                   CONTINUE
                     IAPTRO=IAPTRO+NBNEBC
                     IAPTRN=IAPTRN+NBNEBL
11                CONTINUE
               ENDIF
               IF (NIVIMP.GT.5) 
     &         CALL PRPTPL (NBNEBL,NBNEBC,NCPINC,NCPINL
     &                     ,NBNEBC*NCPINC,1,MCPTRS,IST,NIVIMP,IMPFCH)   !sdexplo
            ELSE
*--            Cas d'inconnues vectorielles
               CALL ASMPVG (NCPINL,NCPINC,NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2)       ,IST(MCNERC+2)
     &                     ,NBPTRB,IST(MCPTRS))                         !assembl
               IDBPTR=MIN(NCPINL*NBNERL,NCPINC*NBNERC)
               CALL ASMPVP (1,NCPINL,NCPINC,NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
               NCFSSD=((NCPINC-1)*NCPINC)/2
               LGLV=LGL*NCPINC*NCPINL+NCFSSD*MIN (NBNERL,NBNERC)
               IF (MCPARU.NE.MCPLAR) THEN
*                 Pointeurs d'assemblage dans la partie triang. sup.
                  IDBPTR=IDBPTR+LGLV
                  CALL ASMPVP (1,NCPINC,NCPINL,1,NBNEBC
     &                       ,NBNEBC,IST(MCNEBC+2),NBNEBL,IST(MCNEBL+2)
     &                       ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                       ,IST(MCPARU),IST(MCPIRU)
     &                       ,NBPTRB,IDBPTR,IST(MCPTRS))                !assembl
               ELSEIF (ITYSYR.EQ.NDFSYM) THEN
*                 Si la matrice est symetrique en structure mais
*                 ni (anti)symetrique ni (anti)adjointe, les pointeurs
*                 de la partie sup. se deduisent de ceux de la partie inf.
                  IAPTRO=MCPTRS
                  IAPTRN=MCPTRS
                  DO 21 I=1,NBNEBL*NCPINL
                     IADOLD=IAPTRO
                     IADNEW=IAPTRN
                     DO 20 J=1,I-1
                        IST(IADNEW)=IST(IADOLD)+LGLV
                        IADOLD=IADOLD+NBNEBL*NCPINL
                        IADNEW=IADNEW+NBNEBC*NCPINC
20                   CONTINUE
                     IAPTRO=IAPTRO+NBNEBC*NCPINC
                     IAPTRN=IAPTRN+NBNEBL*NCPINL
21                CONTINUE
               ENDIF
               IF (NIVIMP.GT.5) 
     &         CALL PRPTPL (NBNEBL,NBNEBC,NCPINC,NCPINL
     &                     ,NBNEBC*NCPINC,1,MCPTRS,IST,NIVIMP,IMPFCH)   !sdexplo
            ENDIF
*
         ELSEIF (NMSTOK.EQ.'&PLAGE') THEN
*
*           Assemblage dans une matrice Morse-Ligne
*
            CALL EXMORS (MCSTOR,IST(MCSTOR),NBL,NBC,NBPL,MCPLAR,MCPLIR
     &                  ,LGL)                                           !sdexplo
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
               CALL ASMPTP (0,NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
            ELSE
*--            Cas d'inconnues vectorielles
               CALL ASMPVP (0,NCPINL,NCPINC,NBNEBC,1
     &                     ,NBNEBL,IST(MCNEBL+2),NBNEBC,IST(MCNEBC+2)
     &                     ,NBNERL,IST(MCNERL+2),NBNERC,IST(MCNERC+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
            ENDIF
*
         ELSEIF (NMSTOK.EQ.'&EGALP') THEN
*
*           Assemblage dans une matrice Morse-Colonne
*
            CALL EXMORS (MCSTOR,IST(MCSTOR),NBC,NBL,NBPC,MCPLAR,MCPLIR
     &                  ,LGU)                                           !sdexplo
            IF (NCPINC*NCPINL.EQ.1) THEN
*--            Cas d'inconnues scalaires
*!!            CALL ASMPTP (0,1,NBNEBL
               CALL ASMPTP (0,NBNEBL,1
     &                     ,NBNEBC,IST(MCNEBC+2),NBNEBL,IST(MCNEBL+2)
     &                     ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
            ELSE
*--            Cas d'inconnues vectorielles
*
*!!            CALL ASMPVP (0,NCPINC,NCPINL,1,NBNEBL
               CALL ASMPVP (0,NCPINL,NCPINC,NBNEBL,1                   
     &                     ,NBNEBC,IST(MCNEBC+2),NBNEBL,IST(MCNEBL+2)
     &                     ,NBNERC,IST(MCNERC+2),NBNERL,IST(MCNERL+2)
     &                     ,IST(MCPLAR),IST(MCPLIR)
     &                     ,NBPTRB,IDBPTR,IST(MCPTRS))                  !assembl
            ENDIF
*
         ENDIF           
*
         IF (NVNUBC.NE.NVNURC.AND.NVNUBC.NE.NVNURL) 
     &     CALL TBSAVE ('#GNEDO',NVNUBC)
         IF (NVNUBL.NE.NVNURL.AND.NVNUBL.NE.NVNURC.AND.
     &      NVNUBL.NE.NVNUBC) CALL TBSAVE ('#GNEDO',NVNUBL)
         NVNLAV=NVNUBL
         NVNCAV=NVNUBC
      ELSE
*        Le tableau des pointeurs d'assemblage existe deja
         NBPTRB=LGTRMB
      ENDIF
*
*     Assemblage proprement dit : R(PTR(I))=R(PTR(I)) + c. B(I)
*
      ADTRMU=0
      CALL ASMCPT (OPERAT,CHCSTE,TYPCST,NUMCST,NMTRMB,NVTRMB,TYTRMB
     &            ,NBPTRB,ADTRMU,ADTRMU,NMTRMR,NVTRMR,TYTRMR
     &            ,IST,RST,CST)                                         !assembl
*
      CALL PRFXMJ (-1,'*AsMoPl*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 1.2 : D.Martin (8 Septembre 2006)
*   Echange des arguments 2 et 3 de APMPTP pour le cas Morse-Colonne
* Version 1.1 : D.Martin (24 Avril 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !AsMoPl
