*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPTD (NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIS,NGNLIS,NBNCOS,NGNCOS
     &                  ,NULAPL,IPLAGL,IDBPTL,NULAPU
     &                  ,IPLAGU,IDBPTU,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : O.DeBayser (3 Avril 1996)
* Version 1.0.0
*  
* Recherche dichotomique ou non du tableau de pointeurs pour l'assemblage
* d'une vecteur dans un autre
*
*-- Arguments --
* NBNLIB nombre de lignes du terme a assembler (B)
* NGNLIB numerotation du terme a assembler (B)
* NBNCOB nombre de colonnes du terme a assembler (B)
* NGNCOB numerotation  en colonne du terme a assembler (B)
* NBNLIS nombre de lignes du terme vectoriel resultat (S)
* NGNLIS numerotation du terme vectoriel resultat (S)
* NBNCOS nombre de colonnes du terme resultat (S)
* NGNCOS numerotation  en colonne du terme resultat (S)
* NULAPL tableau des numeros de derniere plage des lignes de (S)
* IPLAGL tableau de stockage Morse-Ligne de la matrice (S)
* IDBPTL adresse relative des pointeurs dans le triangle inf. de (S)
* NULAPU tableau des numeros de derniere plage des colonnes de (S)
* IPLAGU tableau de stockage Morse-Colonne de la matrice (S)
* IDBPTU adresse relative des pointeurs dans le triangle sup. de (S)
*-- Argument de sortie --
* PTRB2S tableau de pointeurs d'assemblage d'un vecteur dans un autre.
*        Sa taille est celle du vecteur (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
      INTEGER NBNLIS,NGNLIS(*),NBNCOS,NGNCOS(*),PTRB2S(*)
      INTEGER NULAPL(*),IPLAGL(2,*),NULAPU(*),IPLAGU(2,*)
*
      INTEGER MOOUBM,MOOUB1,NEXTLS,NEXTKS,LIGNEB,LS,KS
     &       ,NUPRUS,LGCUUS,NUDRUS,LGCUVU,IDBPTU,NUPLU,IDBPTL
*-----------------------------------------------------------------------
      MOOUBM=1 
      MOOUB1=MOOUBM+1
      NEXTLS=1
      NEXTKS=1
      DO 100 LIGNEB=1,MIN (NBNLIB,NBNCOB)
*        Recherche dichotomique dans S de la ligne de B
         CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LIGNEB),LS,*1175)     !utilite
         NEXTLS=LS+1
*        On cherche la position dans S de la diagonale de B
         CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(LIGNEB),KS,*1176)     !utilite
         NEXTKS=KS+1
         IF (KS.EQ.LS) THEN
*           On est sur la diagonale de S
            PTRB2S(LIGNEB)=KS
         ELSEIF (KS.GT.LS) THEN
*           On est dans le triangle superieur de S
            NUPRUS=1
            IF (KS.GT.MOOUB1) NUPRUS=1+NULAPU(KS-MOOUB1)
            LGCUUS=0
            IF (NUPRUS.GT.1) LGCUUS=IPLAGU(2,NUPRUS-1)
            NUDRUS=0
            IF (KS.GT.MOOUBM) NUDRUS=NULAPU(KS-MOOUBM)
            LGCUVU=IDBPTU+LGCUUS
            CALL DIKLPL (LS,NUPRUS,NUDRUS,LGCUUS,IPLAGU,NUPLU,*1178)    !morse
            IF (NUPLU.GT.NUPRUS) THEN
*              Changement de plage sur la Colonne KS de S
               LGCUVU=LGCUVU+IPLAGU(2,NUPLU-1)-LGCUUS
            ENDIF
            PTRB2S(LIGNEB)=LGCUVU+LS-IPLAGU(1,NUPLU)+1
         ELSEIF (KS.LT.LS) THEN
*           On est dans le triangle inferieur de S
            NUPRUS=1
            IF (LS.GT.MOOUB1) NUPRUS=1+NULAPL(LS-MOOUB1)
            LGCUUS=0
            IF (NUPRUS.GT.1) LGCUUS=IPLAGL(2,NUPRUS-1)
            NUDRUS=0
            IF (LS.GT.MOOUBM) NUDRUS=NULAPL(LS-MOOUBM)
            LGCUVU=IDBPTL+LGCUUS
            CALL DIKLPL (KS,NUPRUS,NUDRUS,LGCUUS,IPLAGL,NUPLU,*1177)    !morse
            IF (NUPLU.GT.NUPRUS) THEN
*              Changement de plage sur la ligne LS de S
               LGCUVU=LGCUVU+IPLAGL(2,NUPLU-1)-LGCUUS
            ENDIF
            PTRB2S(LIGNEB)=LGCUVU+KS-IPLAGL(1,NUPLU)+1
         ENDIF
100   CONTINUE
*
      RETURN
*-----------------------------------------------------------------------
1175  CALL BAISE('*Asmptd* On ne retrouve pas la ligne   de B dans '
     &//'celles de S')
1176  CALL BAISE('*Asmptd* On ne retrouve pas la colonne de B dans '
     &//'celles de S')
1177  CALL BAISE('*Asmptd* L Cette situation ne doit pas se produire')
1178  CALL BAISE('*Asmptd* U Cette situation ne doit pas se produire')
                                                                    END !Asmptd
