*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPTM (MOOUBM,NBNLIB,NGNLIB,NGNCOB,NULAPB,IPLAGB
     &                  ,NMBPTR,NBNLIS,NGNLIS,NBNCOS,NGNCOS,NULAPS
     &                  ,IPLAGS,IDBPTR,NULAPU,IPLAGU,IDBPTU,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1992)
* Derniere modification : O.DeBayser (3 Avril 1996)
* Version 1.0.0
*
* Recherche dichotomique du tableau de pointeurs pour l'assemblage
* d'une matrice Morse-Ligne ou  Morse-Colonne dans une autre ou dans
* la partie triangulaire inferieure ou superieure d'une matrice BiMorse
*
*-- Arguments d'entree --
* MOOUBM =0 pour le cas Morse-Ligne ou Morse-Colonne,
*        =1 pour le cas BiMorse
* NBNLIB nombre de lignes du terme matriciel a assembler (B)
* NGNLIB numerotation en ligne du terme matriciel a assembler (B)
* NGNCOB numerotation en colonne du terme matriciel a assembler (B)
* NULAPB tableau des numeros de derniere plage des lignes de (B)
* IPLAGB tableau de stockage Morse-Ligne de la matrice (B)
* NBNLIS nombre de lignes du terme matriciel resultat (S)
* NGNLIS numerotation en ligne du terme matriciel resultat (S)
* NBNCOS nombre de lignes du terme matriciel resultat (S)
* NGNCOS numerotation en colonne du terme matriciel resultat (S)
* NULAPS tableau des numeros de derniere plage des lignes de (S)
* IPLAGS tableau de stockage Morse-Ligne de la matrice (S)
* IDBPTR adresse relative des pointeurs dans (S)
*-- Arguments de sortie --
* NMBPTR nombre de coefficients de (B) a assembler dans (S)
* PRTB2S tableau de pointeurs d'assemblage d'une matrice dans une autre.
*        Sa taille est celle de la matrice (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NMBPTR,NBNLIS,NGNLIS(*),NBNCOS,NGNCOS(*)
      INTEGER NULAPS(*),IPLAGS(2,*),NULAPU(*),IPLAGU(2,*)
      INTEGER NBNLIB,NGNLIB(*),NGNCOB(*),NULAPB(*),IPLAGB(2,*),PTRB2S(*)
*
      INTEGER MOOUB1,NUPRPB,NUDRPB,LGCUAB,LGCUMB,NEXTLS,NEXTKS,LS,KS
     &       ,NUPRPS,NUDRPS,NUPRUS,NUDRUS,LGCUAS,LGCUUS,NUPLB,LB,KB
     &       ,KOLDEB,KOLFIN,NUPLS,LGCUVS,LGCUVU,IDBPTR,IDBPTU,NUPLU
     &       ,LGCUMS
*-----------------------------------------------------------------------
      MOOUB1=1+MOOUBM
      NUDRPB=0
      LGCUAB=0
      LGCUMB=0
      NEXTLS=1
      NUDRPS=0
      NUDRUS=0
      LGCUAS=0
      LGCUUS=0
*
*     Parcours des lignes LB de la matrice B a assembler dans S
      DO 10 LB=MOOUB1,NBNLIB
*        Premiere et derniere plage de la ligne courante LB de B
         NUPRPB=NUDRPB+1
         NUDRPB=NULAPB(LB-MOOUBM)
*        Recherche de la ligne LS de S 'contenant' la ligne LB de B
         CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*1175)         !utilite
         NEXTLS=LS+1
*        Premiere, derniere plage de la ligne LS correspondant dans S
         NUPRPS=NUDRPS+1
         IF (LS.GT.MOOUB1) NUPRPS=1+NULAPS(LS-MOOUB1)
         IF (NUPRPS.GT.1)  LGCUAS=IPLAGS(2,NUPRPS-1)
         IF (LS.GT.MOOUBM) NUDRPS=NULAPS(LS-MOOUBM)
         LGCUVS=IDBPTR+LGCUAS
*        Parcours des plages et des colonnes KB de la ligne LB de B
         NEXTKS=1
         DO 8 NUPLB=NUPRPB,NUDRPB
            KOLDEB=IPLAGB(1,NUPLB)
            LGCUMB=IPLAGB(2,NUPLB)
            KOLFIN=KOLDEB+LGCUMB-LGCUAB-1
            LGCUAB=LGCUMB
            DO 6 KB=KOLDEB,KOLFIN
*              Recherche de la colonne KS de la ligne IS de S contenant
*              la colonne KB de B
               CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*1176)   !utilite
               NEXTKS=KS+1
*              Recherche de la plage de la ligne de S contenant
*              la colonne KS
               CALL DIKLPL(KS,NUPRPS,NUDRPS,LGCUAS,IPLAGS,NUPLS,*177)   !morse
               IF (NUPLS.GT.NUPRPS) THEN
*                 Changement de plage sur la ligne LS de S
                  LGCUMS=IPLAGS(2,NUPLS-1)
                  LGCUVS=LGCUVS+LGCUMS-LGCUAS
                  LGCUAS=LGCUMS
                  NUPRPS=NUPLS
               ENDIF
*              Pointeur du coefficient courant de B dans le tableau S
               NMBPTR=NMBPTR+1
               PTRB2S(NMBPTR)=LGCUVS+KS-IPLAGS(1,NUPLS)+1
               GOTO 6
*              On est dans le triangle sup. de S
177            NUPRUS=1
               IF (KS.GT.MOOUB1) NUPRUS=1+NULAPU(KS-MOOUB1)
               IF (NUPRUS.GT.1)  LGCUUS=IPLAGU(2,NUPRUS-1)
               IF (KS.GT.MOOUBM) NUDRUS=NULAPU(KS-MOOUBM)
               LGCUVU=IDBPTU+LGCUUS
               CALL DIKLPL(LS,NUPRUS,NUDRUS,LGCUUS,IPLAGU,NUPLU,*187)   !morse
               IF (NUPLU.GT.NUPRUS) THEN
*                 Changement de plage sur la Colonne KS de S
                  LGCUMS=IPLAGU(2,NUPLU-1)
                  LGCUVU=LGCUVU+LGCUMS-LGCUUS
                  LGCUUS=LGCUMS
                  NUPRUS=NUPLU
               ENDIF
               NMBPTR=NMBPTR+1
               PTRB2S(NMBPTR)=LGCUVU+LS-IPLAGU(1,NUPLU)+1
               GOTO 6
*              On est sur la diagonale de S (on doit avoir KS=LS)
187            NMBPTR=NMBPTR+1
               PTRB2S(NMBPTR)=LS
6           CONTINUE
8        CONTINUE
10    CONTINUE
*
      RETURN
*-----------------------------------------------------------------------
1175  CALL BAISE ('*Asmptm* On ne retrouve pas la ligne   de B dans '
     &          //'celles de S')
1176  CALL BAISE('*Asmptm* On ne retrouve pas la colonne de B dans '
     &          //'celles de S')
                                                                    END !Asmptm
