*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPVD (NCPINL,NCPINC
     &                  ,NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIS,NGNLIS,NBNCOS,NGNCOS 
     &                  ,NULAPL,IPLAGL,IDBPTL,NULAPU,IPLAGU
     &                  ,IDBPTU,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : D.Martin (3 Avril 1996)
* Version 1.0.1
*  
* Recherche dichotomique du tableau de pointeurs pour l'assemblage de la
* diagonale d'une matrice BiMorse dans le cas d'inconnues vectorielles
*
*-- Arguments --
* NCPINL nombre de composante de l'inconnue en ligne
* NCPINC nombre de composante de l'inconnue en colonne
* NBNLIB nombre de lignes du terme a assembler (B)
* NGNLIB numerotation du terme a assembler (B)
* NBNCOB nombre de colonnes du terme a assembler (B)
* NGNCOB numerotation  en colonne du terme a assembler (B)
* NBNLIS nombre de lignes du terme vectoriel resultat (S)
* NGNLIS numerotation du terme vectoriel resultat (S)
* NBNCOS nombre de colonnes du terme resultat (S)
* NGNCOS numerotation  en colonne du terme resultat (S)
* NULAPL tableau des numeros de derniere plage des lignes de (S)
* IPLAGL tableau de stockage Morse-Ligne de la matrice (S)
* IDBPTL adresse relative des pointeurs dans le triangle inf. de (S)
* NULAPU tableau des numeros de derniere plage des colonnes de (S)
* IPLAGU tableau de stockage Morse-Colonne de la matrice (S)
* IDBPTU adresse relative des pointeurs dans le triangle sup. de (S)
*-- Argument de sortie --
* PTRB2S tableau de pointeurs d'assemblage d'un vecteur dans un autre.
*        Sa taille est celle du vecteur (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NCPINL,NCPINC
      INTEGER NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
      INTEGER NBNLIS,NGNLIS(*),NBNCOS,NGNCOS(*),PTRB2S(*)
      INTEGER NULAPL(*),IPLAGL(2,*),IDBPTL,NULAPU(*),IPLAGU(2,*),IDBPTU
*
      INTEGER NCOMPO,NCFSSD,NSNEMI,MOOUBM,MOOUB1,LIGNEB,LIGNBV,LIGNSV
     &       ,NEXTLS,LS,LB,NEXTKS,KS,NUPRUS,NUDRUS,LGCUMS,LGCUUS,LGCOGS
     &       ,LGCUVU,NUPLU,IDLL
*-----------------------------------------------------------------------
      NCOMPO=MAX(NCPINL,NCPINC)
      NCFSSD=NCOMPO
      IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
      NSNEMI=MIN(NBNLIS,NBNCOS)
* 
      MOOUBM=1 
      MOOUB1=MOOUBM+1
      LIGNBV=0
      NEXTLS=1
      NEXTKS=1
      DO 100 LIGNEB=1,MIN (NBNLIB,NBNCOB)
*        Recherche dichotomique dans S de la ligne de B
         CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LIGNEB),LS,*1175)     !utilite
         NEXTLS=LS+1
*        On cherche la position dans S de la diagonale de B
         CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(LIGNEB),KS,*1176)     !utilite
         NEXTKS=KS+1
         IF (KS.EQ.LS) THEN
*           On est sur la diagonale de S
            LIGNSV=1+NCOMPO*(KS-1)
            DO 10 LB=LIGNBV+1,LIGNBV+NCOMPO
               PTRB2S(LB)=LIGNSV
               LIGNSV=LIGNSV+1
10          CONTINUE
         ELSEIF (KS.GT.LS) THEN
*           On est dans le triangle superieur de S
            NUPRUS=1
            IF (KS.GT.MOOUB1) NUPRUS=1+NULAPU(KS-MOOUB1)
            LGCUUS=0
            IF (NUPRUS.GT.1) LGCUUS=IPLAGU(2,NUPRUS-1)
            NUDRUS=NULAPU(KS-MOOUBM)
            LGCOGS=IPLAGU(2,NUDRUS)-LGCUUS
            LGCUVU=IDBPTU+LGCUUS*NCPINC*NCPINL
     &                   +NCFSSD*MIN(KS-1,NSNEMI)
            CALL DIKLPL (LS,NUPRUS,NUDRUS,LGCUUS,IPLAGU,NUPLU,*1178)    !morse
            IF (NUPLU.GT.NUPRUS) THEN
*              Changement de plage sur la Colonne KS de S
               LGCUMS=IPLAGU(2,NUPLU-1)
               LGCUVU=LGCUVU+(LGCUMS-LGCUUS)*NCPINL
            ENDIF
            LGCUVU=LGCUVU+(LS-IPLAGU(1,NUPLU)    )*NCPINL
            DO 20 IDLL=1,NCOMPO
               PTRB2S(LIGNBV+IDLL)=LGCUVU+IDLL
               LGCUVU=LGCUVU+LGCOGS*NCPINL
               IF (KS.LE.NSNEMI) LGCUVU=LGCUVU+IDLL-1
20          CONTINUE
         ELSEIF (KS.LT.LS) THEN
*           On est dans le triangle inferieur de S
            NUPRUS=1
            IF (LS.GT.MOOUB1) NUPRUS=1+NULAPL(LS-MOOUB1)
            LGCUUS=0
            IF (NUPRUS.GT.1) LGCUUS=IPLAGL(2,NUPRUS-1)
            NUDRUS=NULAPL(LS-MOOUBM)
            LGCOGS=IPLAGL(2,NUDRUS)-LGCUUS
            LGCUVU=IDBPTL+LGCUUS*NCPINC*NCPINL
     &                   +NCFSSD*MIN(LS-1,NSNEMI)
            CALL DIKLPL (KS,NUPRUS,NUDRUS,LGCUUS,IPLAGL,NUPLU,*1177)    !morse
            IF (NUPLU.GT.NUPRUS) THEN
*              Changement de plage sur la ligne LS de S
               LGCUMS=IPLAGL(2,NUPLU-1)
               LGCUVU=LGCUVU+(LGCUMS-LGCUUS)*NCPINC
            ENDIF
            LGCUVU=LGCUVU+(KS-IPLAGL(1,NUPLU))*NCPINC
            DO 30 IDLL=1,NCOMPO
               PTRB2S(LIGNBV+IDLL)=LGCUVU+IDLL
               LGCUVU=LGCUVU+LGCOGS*NCPINC
               IF (LS.LE.NSNEMI) LGCUVU=LGCUVU+IDLL-1
30          CONTINUE
         ENDIF
         LIGNBV=LIGNBV+NCOMPO
100   CONTINUE
*
      RETURN
*-----------------------------------------------------------------------
1175  CALL BAISE('*Asmpvd* On ne retrouve pas la ligne   de B dans '
     &//'celles de S')
1176  CALL BAISE('*Asmpvd* On ne retrouve pas la colonne de B dans '
     &//'celles de S')
1177  CALL BAISE('*Asmpvd* L Cette situation ne doit pas se produire')
1178  CALL BAISE('*Asmpvd* U Cette situation ne doit pas se produire')
                                                                    END !Asmpvd
