*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPVG (NCPINL,NCPINC,INCREL,INCREC
     &                  ,NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIS,NGNLIS,NGNCOS,NBPTRB,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1992)
* Derniere modification : O.DeBayser (3 Avril 1996)
* Version 1.0.0
*  
* Recherche dichotomique ou non du tableau de pointeurs pour l'assemblage
* de la diagonale d'un terme stocke 'Plein' (B) dans un terme stocke
* 'Bi-Morse' (S) dans le cas d'inconnues vectorielles
*
*-- Arguments --
* NCPINL nombre de composantes de l'inconnue en ligne
* NCPINC nombre de composantes de l'inconnue en colonne
* INCREL increment dans les pointeurs lors du changement de ligne dans (B)
* INCREL increment dans les pointeurs lors du changement de colonne dans (B)
* NBNLIB nombre de lignes du terme a assembler (B)
* NGNLIB numerotation en ligne du terme a assembler (B)
* NBNCOB nombre de colonnes du terme a assembler (B)
* NGNCOB numerotation  en colonne du terme a assembler (B)
* NBNLIS nombre de lignes du terme resultat (S)
* NGNLIS numerotation en ligne du terme resultat (S)
* NGNCOS numerotation  en colonne du terme resultat (S)
*-- Argument de sortie --
* NBPTRB nombre de coefficients de la diagonale de (B)
* PTRB2S tableau de pointeurs d'assemblage d'un vecteur dans un autre.
*        Sa taille est celle du vecteur (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPINL,NCPINC,INCREL,INCREC
     &       ,NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
     &       ,NBNLIS,NGNLIS(*),NGNCOS(*),NBPTRB,PTRB2S(*)
*
      INTEGER INCRDL,INCRDC,INCREM,NCOMPO,LIGNES,NXPTRB,NEXTL,NEXTC
     &       ,LIGNEB,KOLDIA,LIGNSV,IDLC
*-----------------------------------------------------------------------
      INCRDL=1
      IF (INCREL.GT.1) INCRDL=INCREL*NCPINC
      INCRDC=1
      IF (INCREC.GT.1) INCRDC=INCREC*NCPINL
      INCREM=MAX (INCRDL,INCRDC)
      NCOMPO=MAX (NCPINL,NCPINC)
*
      CALL DICOTO (1,NBNLIS,NGNLIS,NGNLIB(1),LIGNES,*98)                !utilite
      IF (NGNCOB(NBNCOB).LT.NGNCOS(LIGNES)) RETURN
      CALL DICOTO (1,NBNLIS,NGNLIS,NGNLIB(NBNLIB),LIGNES,*98)           !utilite
      IF (NGNCOB(1).GT.NGNCOS(LIGNES)) RETURN
*
      LIGNES=0
      NXPTRB=0
      NEXTL=1
      NEXTC=1
      DO 10 LIGNEB=1,NBNLIB
         CALL DICOTO (NEXTL,NBNLIS,NGNLIS,NGNLIB(LIGNEB),LIGNES,*98)    !utilite
         NEXTL=LIGNES+1
*        On cherche la position dans B de la diagonale de S
         CALL DICOTO (NEXTC,NBNCOB,NGNCOB,NGNCOS(LIGNES),KOLDIA,*10)    !utilite
         NEXTC=KOLDIA+1
         LIGNSV=1+NCOMPO*(LIGNES-1)
         NXPTRB=(LIGNEB-1)*NCPINL*INCRDL+(KOLDIA-1)*NCPINC*INCRDC
         DO 5 IDLC=1,NCOMPO
            PTRB2S(NXPTRB+IDLC)=LIGNSV
            LIGNSV=LIGNSV+1
            NXPTRB=NXPTRB+INCREM
            NBPTRB=NBPTRB+1
5        CONTINUE
10    CONTINUE
*
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
98    CALL BAISE('*asmpvg* numero de ligne de B non retrouve dans S')
                                                                    END !AsMPvG
