*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMPVP (MOOUBM,NCPINL,NCPINC,INCREL,INCREC
     &                  ,NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIS,NGNLIS,NBNCOS,NGNCOS
     &                  ,NULAPS,IPLAGS,NMBPTR,IDBPTR,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1992)
* Derniere modification : D.Martin (5 novembre 2008)
* Version 2
*  
* Recherche dichotomique du tableau de pointeurs pour l'assemblage
* d'une matrice Pleine (B) dans le cas d'inconnues vectorielles
*  
*-- Arguments d'entree --
* MOOUBM =0 pour le cas Morse-Ligne ou Morse-Colonne,
*        =1 pour le cas BiMorse
* NCPINL nombre de composantes de l'inconnue en ligne
* NCPINC nombre de composantes de l'inconnue en colonne
*        =NCPINL dans le cas Bimorse
* INCREL increment de changement de ligne dans les pointeurs
* INCREC increment de changement de colonne dans les pointeurs
* NBNLIB nombre de lignes du terme matriciel a assembler (B)
* NGNLIB numerotation en ligne du terme matriciel a assembler (B)
* NBNCOB nombre de colonnes du terme matriciel a assembler (B)
* NGNCOB numerotation en colonne du terme matriciel a assembler (B)
* NBNLIS nombre de lignes du terme matriciel resultat (S)
* NGNLIS numerotation en ligne du terme matriciel resultat (S)
* NBNCOS nombre de lignes du terme matriciel resultat (S)
* NGNCOS numerotation en colonne du terme matriciel resultat (S)
* NULAPS tableau des numeros de derniere plage des lignes de (S)
* IPLAGS tableau de stockage Morse-Ligne de la matrice (S)
* IDBPTR adresse relative des pointeurs dans (S)
*-- Arguments de sortie --
* NMBPTR nombre de coefficients de (B) a assembler dans (S)
* PRTB2S tableau de pointeurs d'assemblage d'une matrice dans une autre.
*        Sa taille est celle de la matrice (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NCPINL,NCPINC,INCREL,INCREC
     &       ,NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
     &       ,NBNLIS,NGNLIS(*),NBNCOS,NGNCOS(*),NULAPS(*),IPLAGS(2,*)
     &       ,NMBPTR,IDBPTR,PTRB2S(*)
*
      INTEGER NCFSSD,MOOUB1,LS,NEXTLS,KS,NEXTKS,INCRDL,INCRDC,NAVPTR
     &       ,NUPRPS,NUDRPS,NUPLS,LGCUAS,LGCUMS,LGLIGS,LGCUVS,NXTPTR
     &       ,LGCUSV,LGCUNS,LGCUWS,NEXTLB,LB,KB,IDLL,IDLC
*-----------------------------------------------------------------------
*     Nombre de CoeFficients SouS-Diagonaux d'un bloc diagonal
*     cree pour les inconnues vectorielles. Cas Bimorse seulement
      NCFSSD=0
      IF (MOOUBM.EQ.1) NCFSSD=((NCPINC-1)*NCPINC)/2
*
      INCRDL=1
      IF (INCREL.GT.1) INCRDL=INCREL*NCPINC
      INCRDC=1
      IF (INCREC.GT.1) INCRDC=INCREC*NCPINL
*
      MOOUB1=1+MOOUBM
      NEXTLS=1
      NEXTLB=1
*
      IF (MOOUBM.EQ.1) THEN
*        Recherche de la colonne KS de la ligne LS de S contenant
*        la premiere colonne de B
         CALL DICOTO (1,NBNCOS,NGNCOS,NGNCOB(1),KS,*9)                 !utilite
*        Recherche de la premiere ligne de B contenant une partie
*        sous-diagonale non vide par rapport a S
         DO 8 LB=1,NBNLIB
*           Recherche de la ligne LS de S 'contenant' la ligne LB 
*           de B 
            CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*8)        !utilite
            IF (LS.GE.KS) THEN
*              On est sur la diagonale ou dans le triangle inferieur de S
               NEXTLB=LB
               GOTO 10
            ENDIF
            NEXTLS=LS+1
8        CONTINUE
*        B n'est pas dans le triangle inferieur de S
9        RETURN
      ENDIF
*
10    LGCUAS=0
      LGCUMS=0
      NUPRPS=1
      NUDRPS=0
*     Parcours des lignes LB de la matrice B a assembler dans S
      DO 50 LB=NEXTLB,NBNLIB
*        Recherche de la ligne LS de S 'contenant' la ligne LB de B
         CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*1175)         !utilite
         NEXTLS=LS+1
*        Premiere, derniere plage de la ligne LS correspondant dans S
         IF (LS.GT.MOOUB1) NUPRPS=1+NULAPS(LS-MOOUB1)
         IF (NUPRPS.GT.1) LGCUAS=IPLAGS(2,NUPRPS-1)
         IF (LS.GT.MOOUBM) NUDRPS=NULAPS(LS-MOOUBM)
         IF (NUDRPS.GT.0)  LGCUMS=IPLAGS(2,NUDRPS)
         LGLIGS=LGCUMS-LGCUAS
         LGCUVS=IDBPTR+LGCUAS*NCPINC*NCPINL+NCFSSD*(LS-1)
         LGCUSV=LGCUVS
*        Parcours des plages et des colonnes KB de la ligne LB de B
         LGCUMS=LGCUAS
         NEXTKS=1
         NAVPTR=(LB-1)*INCRDL*NCPINL 
         DO 25 KB=1,NBNCOB
*           Recherche de la colonne KS de la ligne LS de S contenant
*           la colonne KB de B
            CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*1176)      !utilite
            NEXTKS=KS+1
*           Recherche de la plage de la ligne de S contenant 
*           la colonne KS
            CALL DIKLPL (KS,NUPRPS,NUDRPS,LGCUMS,IPLAGS,NUPLS,*16)      !morse
            IF (NUPLS.GT.NUPRPS) THEN
*              Changement de plage sur la plage de la ligne LS de S
               NUPRPS=NUPLS
               LGCUNS=IPLAGS(2,NUPLS-1)
               LGCUSV=LGCUSV+(LGCUNS-LGCUMS)*NCPINC
               LGCUMS=LGCUNS
            ENDIF
*
            LGCUWS=LGCUSV+(KS-IPLAGS(1,NUPLS))*NCPINC
            NXTPTR=NAVPTR
            DO 14 IDLL=1,NCPINL
               DO 12 IDLC=1,NCPINC
                  PTRB2S(NXTPTR+(IDLC-1)*INCRDC+1)=LGCUWS+IDLC
                  NMBPTR=NMBPTR+1
12             CONTINUE
               NXTPTR=NXTPTR+INCRDL
               LGCUWS=LGCUWS+LGLIGS*NCPINC+(IDLL-1)*MOOUBM
14          CONTINUE
            NAVPTR=NAVPTR+NCPINC*INCRDC
16          CONTINUE
*           Bloc diagonaux de la matrice (S)
            IF (KS.EQ.LS.AND.MOOUBM.EQ.1) THEN
*              Cas de coefficients sous-diagonaux d'un bloc diagonal
*              d'une matrice (S) BiMorse
               LGCUVS=LGCUVS+LGLIGS*NCPINC
               NXTPTR=NAVPTR
               DO 19 IDLL=2,NCPINC
                  NXTPTR=NXTPTR+INCRDL
                  LGCUVS=LGCUVS+LGLIGS*NCPINC+IDLL-2
                  DO 18 IDLC=1,IDLL-1
                     PTRB2S(NXTPTR+(IDLC-1)*INCRDC+1)=LGCUVS+IDLC
                     NMBPTR=NMBPTR+1
18                CONTINUE
19             CONTINUE
            ENDIF
25       CONTINUE
50    CONTINUE
*
      RETURN
*-----------------------------------------------------------------------
1175  CALL BAISE('*Asmpvp* On ne retrouve pas la ligne   de B dans '
     &//'celles de S')
1176  CALL BAISE('*Asmpvp* On ne retrouve pas la colonne de B dans '
     &//'celles de S')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (5 novembre 2008)
*  Bug dans le cas non BiMorse ( NCFSSD = 0 dans ce cas )
* Version 1 : O.DeBayser (3 Avril 1996)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !AsMPvP
