*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMSML (MOOUBM
     &                  ,NBNLIB,NGNLIB,NBNCOB,NGNCOB,NULAPB,IPLAGB
     &                  ,NULAPU,IPLAGU
     &                  ,NBNLIS,NGNLIS,NBNCOS,NGNCOS,NULAPS,IPLAGS
     &                  ,NBPLAX,NBPLAS,IMPFCH,IRCODL,IRCODC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*
* Concatenation des tables de stockage 'Morse-Ligne' ou 'Morse-Colonne'
* ou des tables de stockage Bi-Morse inferieur ou superieur  de 2 matrices
* S et B pour creer la table de la matrice S '+' B,
* Le resultat est place dans le tableau de stockage de S.
*  
*-- Arguments d'entree --
* MOOUBM =0 pour Morse-Ligne ou Morse-Colonne, =1 pour Bi-Morse
* NBNLIB nombre de ligne/colonnes de la matrice B
* NGNLIB numerotation globale des lignes/colonnes de la matrice B
* NBNCOB nombre de colonnes/lignes de la matrice B
* NGNCOB numerotation globale des colonnes/lignes de la matrice B
* NULAPB numero de derniere plage de chaque ligne/colonne de B (lig)
* IPLAGB numeros de debut de plage et de longueurs cumulees des plages de B
* NULAPU numero de derniere plage de chaque ligne/colonne de B (col)
* IPLAGU numeros de debut de plage et de longueurs cumulees des plages de B
* NBNLIS nombre de lignes/colonnes de la matrice S receptrice
* NGNLIS numerotation globale des lignes/colonnes de la matrice receptrice S
* NBNCOS nombre de colonnes/lignes de la matrice receptrice S
* NGNCOS numerotation globale des colonnes/lignes de la matrice receptrice S
* NBPLAX nombre maximum de plages pour le compactage resultat
* IMPFCH numero d'unite logique du fichier d'impression
*-- Arguments modifies --
* NBPLAS nombre de plages de la matrice S
* NULAPS numero de derniere plage de chaque ligne/colonne de S
* IPLAGS numeros de debut de plage et de longueurs cumulees des plages de S
* IRCODL code d'erreur detectee sur une ligne
* IRCODC code d'erreur detectee sur une colonne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*),NULAPB(*)
     &       ,IPLAGB(2,*),NULAPU(*),IPLAGU(2,*),NBNLIS,NGNLIS(*),NBNCOS
     &       ,NGNCOS(*),NULAPS(*),IPLAGS(2,*)
     &       ,NBPLAX,NBPLAS,IMPFCH,IRCODL,IRCODC
*
      INTEGER NUPRPB,NUDRPB,NUMPLA,LGCUBV,NEXTLS,LS,NEXTKS,KS,MOOUB1
     &       ,KOLDEB,LGPL,NUPRUB,NUDRUB,NUPLU,LGCUUB,LB,KB
*------------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsmSMl*')
      NUPRPB=1 
      NUDRPB=0
      LGCUBV=0 
      NEXTLS=1
      IRCODL=0
      IRCODC=0
      MOOUB1=MOOUBM+1  
      DO 9 LB=1,NBNLIB
*        Recherche du rang de la ligne de B dans la numerotation
*        en ligne de S 
         CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*90001)        !utilite
         NEXTLS=LS+1
         IF (LB.GT.MOOUBM) NUDRPB=NULAPB(LB-MOOUBM)
         NEXTKS=1 
         DO 2 NUMPLA=NUPRPB,NUDRPB 
            KOLDEB=IPLAGB(1,NUMPLA)
            LGPL  =IPLAGB(2,NUMPLA)-LGCUBV
            DO 1 KB=KOLDEB,KOLDEB-1+LGPL  
*              Recherche du rang de la colonne par rapport a la 
*              numerotation en colonne de S
               CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*90002)  !utilite
               NEXTKS=KS+1
*              Si la matrice B (cas Bimorse) est non symetrique, 
*              le coefficient ne fait eventuellement pas partie du 
*              triangle inf. de S
               IF (KS.LT.LS.OR.MOOUBM.EQ.0) THEN
                  CALL CMPLGN (LS,KS,NBNLIS
     &                        ,NBPLAS,NULAPS,IPLAGS,NBPLAX,IRCODL)      !morse
                  IF (IRCODL.NE.0) GOTO 90000
               ENDIF
1           CONTINUE  
            LGCUBV=LGCUBV+LGPL
2        CONTINUE
         NUPRPB=NUDRPB+1
         IF (MOOUBM.EQ.1.AND.LB.LE.MIN (NBNLIB,NBNCOB)) THEN
            CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(LB),KS,*90003)     !utilite
            NEXTKS=KS+1
*           Si la matrice B est non symetrique, il se peut que 
*           le coefficient de sa diagonale se situe dans le triangle
*           inferieure de S
            IF (KS.LT.LS) THEN
               CALL CMPLGN (LS,KS,NBNLIS,NBPLAS
     &                     ,NULAPS,IPLAGS,NBPLAX,IRCODL)                !morse
               IF (IRCODL.NE.0) GOTO 90000
            ENDIF
*           Si la matrice B est non symetrique, il se peut que
*           des coefficients de son triangle superieur fassent partie
*           du triangle inferieure de S
            DO 3 KB=LB+1,NBNCOB
               NUPRUB=1
               IF (KB.GT.MOOUB1) NUPRUB=1+NULAPU(KB-MOOUB1)
               LGCUUB=0
               IF (NUPRUB.GT.1) LGCUUB=IPLAGU(2,NUPRUB-1)
               NUDRUB=NULAPU(KB-MOOUBM)
               CALL DIKLPL (LB,NUPRUB,NUDRUB,LGCUUB,IPLAGU,NUPLU,*3)    !morse
               CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*90002)  !utilite
               NEXTKS=KS+1
               IF (KS.LT.LS) THEN
                  CALL CMPLGN (LS,KS,NBNLIS
     &                        ,NBPLAS,NULAPS,IPLAGS,NBPLAX,IRCODL)      !morse
                  IF (IRCODL.NE.0) GOTO 90000
               ELSE
                  GOTO 9
               ENDIF
3           CONTINUE
         ENDIF
9     CONTINUE 
      CALL PRFXMJ (-1,'*AsmSMl*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 IRCODL=-1
      IRCODC=-1
      RETURN
90001 IRCODL=LB
      RETURN
90002 IRCODL=LB
      IRCODC=KB
      RETURN
90003 IRCODL=LB
      IRCODC=LB
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Correction d'un bug lorsque qu'un terme vide n'est pas un bloc diagonal
* Version 1.0.2 : D.Martin (12 octobre 2002)
* Modifications anterieures
* D.Martin (1er mars 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !AsmSMl
