*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMSPL (MOOUBM,NBNLIB,NGNLIB,NBNCOB,NGNCOB
     &                  ,NBNLIS,NGNLIS,NBNCOS,NGNCOS,NULAPS,IPLAGS
     &                  ,NBPLAX,NBPLAS,IMPFCH,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : D.Martin (15 mars 2008)
* Version 2
*  
* Modification de la table de stockage 'Morse-Ligne'ou 'Morse-Colonne'
* ou de la table de stockage Bi-Morse inferieure ou superieure de la matrice
* S pour creer la table de la matrice S '+' B,  B etant une matrice pleine,
* le resultat etant place dans le tableau de stockage de S.
*  
*-- Arguments d'entree -- 
* MOOUBM =0 pour Morse-Colonne ou Morse-Ligne, =1 pour BiMorse
* NBNLIB nombre de ligne/colonnes de la matrice B
* NGNLIB numerotation globale des lignes/colonnes de la matrice B
* NBNCOB nombre de colonnes/lignes de la matrice B
* NGNCOB numerotation globale des colonnes/lignes de la matrice B
* NBNLIS nombre de lignes/colonnes de la matrice S receptrice
* NGNLIS numerotation globale des lignes/colonnes de la matrice receptrice S
* NBNCOS nombre de colonnes/lignes de la matrice receptrice S
* NGNCOS numerotation globale des colonnes/lignes de la matrice receptrice S
* NBPLAX nombre maximum de plages pour le compactage resultat
* IMPFCH quincaillerie habituelle
* IRCODE code d'erreur detectee
*-- Arguments modifiables --
* NBPLAS nombre de plages de la matrice S
* NULAPS numero de derniere plage de chaque ligne/colonne de S
* IPLAGS numeros de debut de plage et de longueurs cumulees des plages de S
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NBNLIB,NGNLIB(*),NBNCOB,NGNCOB(*)
     &       ,NBNLIS,NGNLIS(*),NBNCOS,NGNCOS(*),NULAPS(*),IPLAGS(2,*)
     &       ,NBPLAX,NBPLAS,IMPFCH,IRCODE
*
      INTEGER NEXTLS,LS,KS,NEXTKS,LB,KB
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsmSPl*')
*  
      NEXTLS=1
      IF (MOOUBM.EQ.1) THEN
         DO 3 LB=1,NBNLIB
*           Recherche du rang de la ligne de B dans la numerotation 
*           en ligne de S 
            CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*3)         !utilite
            NEXTLS=LS+1
            NEXTKS=1 
            DO 1 KB=1,NBNCOB
*              Recherche du rang du numero de colonne par rapport a la 
*              nouvelle numerotation en colonne de S
               CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*1)      !utilite
               NEXTKS=KS+1
               IF (KS.LT.LS) THEN
                  CALL CMPLGN (LS,KS,NBNLIS,NBPLAS,NULAPS
     &                        ,IPLAGS,NBPLAX,IRCODE)                    !morse
                  IF (IRCODE.NE.0) GOTO 90001
               ENDIF
1           CONTINUE
3        CONTINUE
      ELSE
         DO 13 LB=1,NBNLIB
            CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LB),LS,*13)        !utilite
            NEXTLS=LS+1
            NEXTKS=1  
            DO 11 KB=1,NBNCOB
*              Recherche du rang du numero de colonne par rapport a la 
*              nouvelle numerotation en colonne de S
               CALL DICOTO (NEXTKS,NBNCOS,NGNCOS,NGNCOB(KB),KS,*11)     !utilite
               NEXTKS=KS+1
               CALL CMPLGN (LS,KS,NBNLIS,NBPLAS,NULAPS
     &                     ,IPLAGS,NBPLAX,IRCODE)                       !morse
               IF (IRCODE.NE.0) GOTO 90001
11          CONTINUE  
13       CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*AsmSPl*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 IRCODE=-1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Correction d'un bug lorsque qu'un terme vide n'est pas un bloc diagonal
* Version 1.0.2 : D.Martin (25 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !AsmSPl
