*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMSTB (NVASMB,NBPLAX,ITYSYR,NVLICO,NBLICO,NVCOLI
     &                  ,NBCOLI,NMSTOK,NVSTOK,LGSTOK,LONTRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.4
*  
* Creation des tableaux de stockage Bi-Morse d'un terme assemble
*  
*-- Arguments d'entree -- 
* NVASMB niveau de la structure d'assemblage
* NBPLAX nombre maximum de plages
* ITYSYR indicateur de symetrie du terme
* NVCOLI niveau de la structure #GNEDO pour l'inconnue en colonne/ligne  
* NBCOLI nombre de noeuds en colonne/ligne du terme assemble 
* NVLICO niveau de la structure #GNEDO pour l'inconnue en ligne/colonne
* NBLICO nombre de noeuds en ligne/colonne du terme assemble
* NVSTOK niveau de la structure BiMorse inf./sup. pour le terme assemble  
* LGSTOK longueur utile du tableau de stockage Bi-Morse 
* LONTRM longueur du terme assemble
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NVASMB,NBPLAX,ITYSYR,NVLICO,NBLICO,NVCOLI,NBCOLI
     &         ,NVSTOK,LGSTOK,LONTRM
      CHARACTER NMSTOK*6
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*  
      CHARACTER READRE,ERCODE*120,PRFXAS*8
      INTEGER   INDSTO
      INTEGER   IRCODL,IRCODC,INDSPL,NVNUAC,NVNUAL,NVSTAV,NBPARR
     &         ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &         ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &         ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYB,IPTDIR
     &         ,NUINCC,NVDUMC,NBCOLB,NVNBCO,NUINCL,NVDUML,NBLIGB
     &         ,NVNBLI,INSTOB,NVSTOB,NVCORC,IATRDO,NIVITR
     &         ,MCNBCO,MCCOLI,MCNBLI,MCLICO
     &         ,MCSTOK,MCPARL,MCPIRL,MCPARU,MCPIRU
     &         ,MCSTOB,NBL,NBPABL,MCPABL,MCPIBL,LGL,NBC,NBPABU
     &         ,MCPABU,MCPIBU,LGU,LASTPL,L
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsmStB*')
      INDSPL=INDSTO ('PLEIN-L')                                           !utilite
      IRCODL=0
      IRCODC=0
*
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                                     , NMSTOK ,NVSTOK,MCSTOK)
      READRE='N'
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
*
*--   Creation des pointeurs de la partie Bi-Morse superieure
*
      IST(MCSTOK)=2
      CALL TAZERO (NBLICO,'ENTIER',MCSTOK+1,AST,IST,RST,CST)            !utilite
      NVNUAC=NDFNUM
      NVNUAL=NDFNUM
      NVSTAV=NDFSTO
      NBPARR=0
*
      DO 2 NUTRAS=1,NBTRAC
         IF (READRE.EQ.'Y')
     &   CALL TBAR2 (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB)
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &               ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYB,IPTDIR
     &               ,NUINCC,NVDUMC,NBCOLB,NVNBCO,NUINCL,NVDUML,NBLIGB
     &               ,NVNBLI,INSTOB,NVSTOB,NVCORC,IATRDO,NIVITR)        !sdexplo
         READRE='N'
         IF (INSTOB.EQ.INDSPL) THEN
            IF (NVNBCO.EQ.NVNUAC.AND.NVNBLI.EQ.NVNUAL) GOTO 2
            READRE='Y'
*           Cas d'un terme stocke PLEIN
            CALL TBRR1 (ERCODE,'#GNEDO',NVNBCO,MCNBCO)            
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR3  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
            MCPARL=MCSTOK+2
            MCPIRL=MCPARL+NBLICO-1
            IST(MCPARL-1)=0
            CALL ASMSPL (1,IST(MCNBLI+1),IST(MCNBLI+2),IST(MCNBCO+1)
     &                  ,IST(MCNBCO+2),NBLICO,IST(MCLICO+2),NBCOLI
     &                  ,IST(MCCOLI+2),IST(MCPARL-1),IST(MCPIRL)
     &                  ,NBPLAX,NBPARR,IMPSDR,IRCODL)                   !assembl
            IF (IRCODL.EQ.-1) GOTO 99900
            NVNUAC=NVNBCO
            NVNUAL=NVNBLI
*
         ELSE
            IF (NVSTOB.EQ.NVSTAV) GOTO 2
            READRE='Y'
            CALL TBRR2  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         , NMSTOK ,NVSTOB,MCSTOB)
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR4  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         , NMSTOK ,NVSTOB,MCSTOB
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
            CALL EXBMOR (MCSTOB,IST(MCSTOB),NBL,NBPABL,MCPABL,MCPIBL,LGL
     &                                    ,NBC,NBPABU,MCPABU,MCPIBU,LGU)!utilite
            MCPARL=MCSTOK+2
            MCPIRL=MCPARL+NBLICO-1
            IST(MCPARL-1)=0
            CALL ASMSML (1,IST(MCNBLI+1),IST(MCNBLI+2),IST(MCNBCO+1)
     &                  ,IST(MCNBCO+2),IST(MCPABL),IST(MCPIBL)
     &                  ,IST(MCPABU),IST(MCPIBU),NBLICO,IST(MCLICO+2)
     &                  ,NBCOLI,IST(MCCOLI+2),IST(MCPARL-1),IST(MCPIRL)
     &                  ,NBPLAX,NBPARR,IMPSDR,IRCODL,IRCODC)            !assembl
            IF (IRCODL.NE.0) THEN
               IF (IRCODL.EQ.-1.AND.IRCODC.EQ.-1) GOTO 99900
               IF (IRCODC.EQ.0) THEN
                   WRITE(IMPPAL,99901) PRFXAS(0) ,IRCODL
     &                                ,IST(MCNBLI+1+IRCODL),NBLICO
               ELSE
                   WRITE(IMPPAL,99902) PRFXAS(0),IRCODL
     &                                ,IST(MCNBLI+1+IRCODL),IRCODC
     &                                ,IST(MCNBCO+1+IRCODC),NBCOLI
               ENDIF
               CALL BAISE  ('bug interne ?')
            ENDIF
            CALL TBSAVE( NMSTOK ,NVSTOB)
            NVSTAV=NVSTOB
         ENDIF
*        Prise en compte des lignes sous-diagonales vides
         LASTPL=0
         DO 1 L=MCPARL,MCPIRL-1
            IF (IST(L).LE.0) THEN
               IST(L)=LASTPL
            ELSE
               LASTPL=IST(L)
            ENDIF
1        CONTINUE
*
         IF (NVNBCO.NE.NVCOLI.AND.NVNBCO.NE.NVLICO)
     &   CALL TBSAVE( '#GNEDO',NVNBCO)
         IF (NVNBLI.NE.NVNBCO.AND.NVNBLI.NE.NVCOLI.AND.NVNBLI.NE.NVLICO)
     &   CALL TBSAVE ('#GNEDO',NVNBLI)
2     CONTINUE
*
      LGSTOK=1+NBLICO+2*NBPARR
      LONTRM=MIN(NBLICO,NBCOLI)+IST(MCSTOK+LGSTOK-1)
      IST(MCSTOK+1)=NBLICO
      IF (ITYSYR.EQ.NDFSYM) THEN
*
*--      Creation des pointeurs de la partie Bi-Morse superieure
*
         IST(MCSTOK)=1+LGSTOK
         CALL TAZERO (NBCOLI,'ENTIER',MCSTOK+LGSTOK,AST,IST,RST,CST)    !utilite
         NVNUAC=NDFNUM
         NVNUAL=NDFNUM
         NVSTAV=NDFSTO
         NBPLAX=NBPLAX-NBPARR
         NBPARR=0
         READRE='Y'
*
         DO 12 NUTRAS=1,NBTRAC
         IF (READRE.EQ.'Y')
     &   CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB)
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &               ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYB,IPTDIR
     &               ,NUINCC,NVDUMC,NBCOLB,NVNBCO,NUINCL,NVDUML,NBLIGB
     &               ,NVNBLI,INSTOB,NVSTOB,NVCORC,IATRDO,NIVITR)        !sdexplo
         READRE='N'
         IF (INSTOB.EQ.INDSPL) THEN
            IF (NVNBCO.EQ.NVNUAC.AND.NVNBLI.EQ.NVNUAL) GOTO 12
            READRE='Y'
*           Cas d'un terme stocke PLEIN
            CALL TBRR1  (ERCODE,'#GNEDO',NVNBCO,MCNBCO)
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR3  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL  TBAR1 (ERCODE,'#GNEDO',NVLICO,MCLICO)
            MCPARU=MCSTOK+1+LGSTOK
            MCPIRU=MCPARU+NBCOLI-1
            IST(MCPARU-1)=0
            CALL ASMSPL (1,IST(MCNBCO+1),IST(MCNBCO+2),IST(MCNBLI+1)
     &                  ,IST(MCNBLI+2),NBCOLI,IST(MCCOLI+2),NBLICO
     &                  ,IST(MCLICO+2),IST(MCPARU-1),IST(MCPIRU)
     &                  ,NBPLAX,NBPARR,IMPSDR,IRCODC)                   !assembl
            IF (IRCODC.EQ.-1) GOTO 99910
            NVNUAC=NVNBCO
            NVNUAL=NVNBLI
*
         ELSE
            IF (NVSTOB.EQ.NVSTAV) GOTO 12
            READRE='Y'
            CALL TBRR2  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         , NMSTOK ,NVSTOB,MCSTOB)
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR4  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         , NMSTOK ,NVSTOB,MCSTOB
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
            CALL EXBMOR (MCSTOB,IST(MCSTOB),NBL,NBPABL,MCPABL,MCPIBL,LGL
     &                                    ,NBC,NBPABU,MCPABU,MCPIBU,LGU)!utilite
            MCPARU=MCSTOK+1+LGSTOK
            MCPIRU=MCPARU+NBCOLI-1
            IST(MCPARU-1)=0
            CALL ASMSML (1,IST(MCNBCO+1),IST(MCNBCO+2),IST(MCNBLI+1)
     &                  ,IST(MCNBLI+2),IST(MCPABU),IST(MCPIBU)
     &                  ,IST(MCPABL),IST(MCPIBL),NBCOLI,IST(MCCOLI+2)
     &                  ,NBLICO,IST(MCLICO+2),IST(MCPARU-1),IST(MCPIRU)
     &                  ,NBPLAX,NBPARR,IMPSDR,IRCODC,IRCODL)            !assembl
            IF (IRCODC.NE.0) THEN
               IF (IRCODC.EQ.-1.AND.IRCODL.EQ.-1) GOTO 99910
               IF (IRCODL.EQ.0) THEN
                   WRITE(IMPPAL,99911) PRFXAS(0),IRCODC
     &                                ,IST(MCNBCO+1+IRCODC),NBCOLI
               ELSE
                   WRITE(IMPPAL,99912) PRFXAS(0),IRCODC
     &                                ,IST(MCNBCO+1+IRCODC),IRCODL
     &                                ,IST(MCNBLI+1+IRCODL),NBLICO
               ENDIF
               CALL BAISE ('bug interne ?')
            ENDIF
            CALL TBSAVE ( NMSTOK ,NVSTOB)
            NVSTAV=NVSTOB
         ENDIF
*
*        Prise en compte des colonnes sur-diagonales vides
         LASTPL=0
         DO 11 L=MCPARU,MCPIRU-1
            IF (IST(L).LE.0) THEN
               IST(L)=LASTPL
            ELSE
               LASTPL=IST(L)
            ENDIF
11       CONTINUE
*
         IF (NVNBCO.NE.NVCOLI.AND.NVNBCO.NE.NVLICO)
     &      CALL TBSAVE ('#GNEDO',NVNBCO)
         IF (NVNBLI.NE.NVCOLI.AND.NVNBLI.NE.NVLICO.AND.NVNBLI.NE.NVNBCO)
     &      CALL TBSAVE ('#GNEDO',NVNBLI)
12       CONTINUE
*
         IST(MCSTOK+LGSTOK)=NBCOLI
         LGSTOK=LGSTOK+NBCOLI+2*NBPARR
         LONTRM=LONTRM+IST(MCSTOK+LGSTOK-1)
      ENDIF
*
      CALL PRFXMJ (-1,'*AsmStB*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99900 CALL ENCLER (NVASMB,ERCODE(1:4))
      CALL ENCLER (NBPLAX,ERCODE(5:10))
      CALL BAISE (' Taille ('//ERCODE(5:10)
     &//') sous estimee pour le tableau de stockage '
     &//'inferieur pour la structure d''assemblage de niveau '
     &//ERCODE(1:4))
99901 FORMAT(/A,' -> STOP : Ligne ',I4,' de B (numero',I6,
     &') non retrouvee dans les ',I6,' lignes de S :'/(10I6))
99902 FORMAT(/A,' -> STOP : sur la ligne ',I4,' de B (numero',I6,
     &'), colonne ',I4,' de B (numero',I6,') non retrouvee'
     &,' dans les ',I6,' colonnes de S :'/(10I6))
99910 CALL ENCLER (NVASMB,ERCODE(1:4))
      CALL ENCLER (NBPLAX,ERCODE(5:10))
      CALL BAISE (' Taille ('//ERCODE(5:10)
     &//') sous estimee pour le tableau de stockage '
     &//'superieur pour la structure d''assemblage de niveau '
     &//ERCODE(1:4))
99911 FORMAT(/A,' -> STOP : Colonne ',I4,' de B (numero',I6,') non
     &retrouvee dans les ',I6,' colonness de S :'/(10I6))
99912 FORMAT(/A,' -> STOP : sur la colonne ',I4,' de B (numero',I6,
     &'), la ligne ',I4,' de B (numero',I6,') n''est pas retrouvee dan
     &s les ',I6,' lignes de S :'/(10I6))
                                                                    END !AsmStB
