*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMSTM (NVASMB,NBPLAX,NVLICO,NBLICO,NVCOLI,NBCOLI
     &                  ,NMSTOK,NVSTOK,LGSTOK,LONTRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.3
*  
* Creation des tableaux de stockage Morse-Ligne/Colonne d'un terme assemble
*  
*-- Arguments d'entree -- 
* NVASMB niveau de la structure d'assemblage
* NVSTOK niveau de la structure Morse-Ligne/Colonne pour le terme assemble  
* NBPLAX nombre maximum de plages
* NVCOLI niveau de la structure #GNEDO pour l'inconnue en colonne/ligne  
* NBCOLI nombre de noeuds en colonne/ligne du terme assemble 
* NVLICO niveau de la structure #GNEDO pour l'inconnue en ligne/colonne
* NBLICO nombre de noeuds en ligne/colonne du terme assemble
* LONTRM longueur du terme assemble
* LGSTOK longueur utile du tableau de stockage Morse-Ligne/Colonne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NVASMB,NBPLAX,NVLICO,NBLICO,NVCOLI,NBCOLI
     &         ,NVSTOK,LGSTOK,LONTRM
      CHARACTER NMSTOK*6
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*  
      CHARACTER READRE,ERCODE*120,PRFXAS*8
      INTEGER   INDSTO
      INTEGER   IRCODL,IRCODC,INDSPL,INDSPC,NVNUAC,NVNUAL,NVSTAV
     &         ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &         ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &         ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &         ,NUINCC,NVDUMC,NBNEBC,NVNUMC,NUINCL,NVDUML,NBNEBL
     &         ,NVNUML,INDSTK,NVSTOB,NVCORC,IATRDO,NIVITR
     &         ,NVNBCO,MCNBCO,MCCOLI,NVNBLI,MCNBLI,MCLICO
     &         ,MCSTOK,NBL,NBC,NBPLAS,MCPLAR,MCPLIR,LG
     &         ,MCSTOB,NBPLAB,MCPLAB,MCPLIB,LASTPL,L
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsmStM*')
*
      IRCODL=0
      IRCODC=0
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
      INDSPC=INDSTO ('PLEIN-C')                                         !utilite
* 
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                   , NMSTOK ,NVSTOK,MCSTOK)
      READRE='N'
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
*
      CALL TAZERO (NBLICO+4,'ENTIER',MCSTOK,AST,IST,RST,CST)            !utilite
      IST(MCSTOK)  =NBLICO
      IST(MCSTOK+1)=NBCOLI
*
      NVNUAC=NDFNUM
      NVNUAL=NDFNUM
      NVSTAV=NDFSTO
      DO 2 NUTRAS=1,NBTRAC
         IF (READRE.EQ.'Y')
     &   CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB)
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &               ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &               ,NUINCC,NVDUMC,NBNEBC,NVNUMC,NUINCL,NVDUML,NBNEBL
     &               ,NVNUML,INDSTK,NVSTOB,NVCORC,IATRDO,NIVITR)        !sdexplo
         READRE='N'
         IF (NMSTOK.EQ.'&PLAGE')      THEN
            NVNBLI=NVNUML
            NVNBCO=NVNUMC
         ELSEIF (NMSTOK.EQ.'&EGALP') THEN
            NVNBLI=NVNUMC
            NVNBCO=NVNUML
         ENDIF
         IF (INDSTK.EQ.INDSPL.OR.INDSTK.EQ.INDSPC) THEN
*
*           Cas d'un terme stocke PLEIN
*
            IF (NVNUMC.EQ.NVNUAC.AND.NVNUAL.EQ.NVNUML) GOTO 2
            READRE='Y'
            CALL TBRR1  (ERCODE,'#GNEDO',NVNBCO,MCNBCO)
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR3  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
            CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAS,MCPLAR
     &                  ,MCPLIR,LG)                                     !sdexplo
            CALL ASMSPL (0,IST(MCNBLI+1),IST(MCNBLI+2),IST(MCNBCO+1)
     &                  ,IST(MCNBCO+2),NBLICO,IST(MCLICO+2),NBCOLI
     &                  ,IST(MCCOLI+2),IST(MCPLAR),IST(MCPLIR),NBPLAX
     &                  ,IST(MCSTOK+2),IMPSDR,IRCODL)                   !assembl
            IF (IRCODL.EQ.-1) GOTO 99900
            NVNUAC=NVNUMC
            NVNUAL=NVNUML
*
         ELSE
*
*           Cas d'un terme stocke Bimorse, Morse-L ou Morse-C
*
            IF (NVSTOB.EQ.NVSTAV) GOTO 2
            READRE='Y'
            CALL TBRR2  ( ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                          , NMSTOK ,NVSTOB,MCSTOB)
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBRR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            CALL TBAR4  (ERCODE,'#GNEDO',NVNBCO,MCNBCO
     &                         , NMSTOK ,NVSTOB,MCSTOB
     &                         ,'#GNEDO',NVCOLI,MCCOLI
     &                         , NMSTOK ,NVSTOK,MCSTOK)
            MCNBLI=MCNBCO
            IF (NVNBCO.NE.NVNBLI)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNBLI,MCNBLI)
            MCLICO=MCCOLI
            IF (NVCOLI.NE.NVLICO)
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
            CALL EXMORS (MCSTOB,IST(MCSTOB),NBL,NBC,NBPLAB,MCPLAB
     &                  ,MCPLIB,LG)                                     !sdexplo
            CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAS,MCPLAR
     &                  ,MCPLIR,LG)                                     !sdexplo
            CALL ASMSML (0,IST(MCNBLI+1),IST(MCNBLI+2),IST(MCNBCO+1)
     &                  ,IST(MCNBCO+2),IST(MCPLAB),IST(MCPLIB)
     &                  ,IST(MCPLAB),IST(MCPLIB),NBLICO,IST(MCLICO+2)
     &                  ,NBCOLI,IST(MCCOLI+2),IST(MCPLAR),IST(MCPLIR)
     &                  ,NBPLAX,IST(MCSTOK+2),IMPSDR,IRCODL,IRCODC)     !assembl
            IF (IRCODL.NE.0) THEN
               IF (IRCODL.EQ.-1.AND.IRCODC.EQ.-1) GOTO 99900
               IF (IRCODC.EQ.0) THEN
                   WRITE(IMPPAL,99901) PRFXAS(0),IRCODL
     &                                ,IST(MCNBLI+1+IRCODL),NBLICO
               ELSE
                   WRITE(IMPPAL,99902) PRFXAS(0),IRCODL
     &                                ,IST(MCNBLI+1+IRCODL),IRCODC
     &                                ,IST(MCNBCO+1+IRCODC),NBCOLI
               ENDIF
            ENDIF
            CALL TBSAVE (NMSTOK,NVSTOB)
            NVSTAV=NVSTOB
         ENDIF
*        Prise en compte des lignes vides
         LASTPL=0
         DO 1 L=MCPLAR,MCPLIR-1
            IF (IST(L).LE.0) THEN
               IST(L)=LASTPL
            ELSE
               LASTPL=IST(L)
            ENDIF
1        CONTINUE
*
         IF (NVNBCO.NE.NVCOLI.AND.NVNBCO.NE.NVLICO)
     &   CALL TBSAVE ('#GNEDO',NVNBCO)
         IF (NVNBLI.NE.NVNBCO.AND.NVNBLI.NE.NVCOLI.AND.NVNBLI.NE.NVLICO)
     &   CALL TBSAVE ('#GNEDO',NVNBLI)
2     CONTINUE
*
      CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      LGSTOK       =4+NBLICO+2*IST(MCSTOK+2)
      LONTRM       =IST(MCSTOK+LGSTOK-1)
      IST(MCSTOK+3)=LONTRM
      CALL PRFXMJ (-1,'*AsmStM*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99900 CALL ENCLER (NVASMB,ERCODE(1:4))
      CALL ENCLER (NBPLAX,ERCODE(5:10))
      CALL BAISE (' Taille ('//ERCODE(5:10)
     &//') sous estimee pour le tableau de stockage '
     &//'inferieur pour la structure d''assemblage de niveau '
     &//ERCODE(1:4))
99901 FORMAT(/A,'-> STOP : Ligne ',I4,' de B (numero',I6,') non
     &retrouvee dans les ',I6,' lignes de S :'/(10I6))
99902 FORMAT(/A,' -> STOP : sur la ligne ',I4,' de B (numero',I6,
     &'), la colonne ',I4,' de B (numero',I6,') n''est pas retrouvee dan
     &s les ',I6,' colonnes de S :'/(10I6))
                                                                    END !AsmStM
