*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASVECT (NMTERM,NVTERM,TYTERM,NVASMB,NCPINL,NVNURL
     &                  ,NBLIGR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.2
*  
* Assemblage uni-inconnue d'un vecteur
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme a assembler 
* NVTERM son niveau
* TYTERM type (reel ou complexe) du terme a assembler
* NVASMB niveau de la structure d'assemblage = numero du terme assemble
* NCPINL nombre de composante de l'inconnue
* NVNURL niveau du tableau #GNEDO de numerotation des noeuds en ligne du terme
* NBLIGR nombre de noeuds pour l'interpolation en ligne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM ,TYTERM
      INTEGER       NVTERM,NVASMB,NCPINL,NVNURL,NBLIGR
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*
      INTEGER  INTDON,INTTYP
      INTEGER  MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM,LGTERM
     &        ,NVTRMB,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDDDD
     &        ,NUINCL,NVDUBL,NBNEBL,NVNUBL,NUINCC,NVDUBC,NBNEBC,NVNUBC
     &        ,INSTOK,NVSTOK,NVCORC,IATRDO,NIVIMP,LGTRMB,MCTRMB,MCTERM
     &        ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &        ,MCDONN,ITYDON,NIVDON,ITYPDO,INCSTE,MCCSTE
     &        ,INTENT,INTREL,INTCOM,NVNUAV
     &        ,MCNUBL,MCPTRS,MCNURL
      CHARACTER     TYPINT*4
      CHARACTER     ERCODE*120
      CHARACTER     READRE,CRWORK,OPERAT
      CHARACTER     NMTRMB*16,CHCSTE*6,NMSTOK*6
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(89:89),NMTRMB)
     &            ,(ERCODE(105:105),CHCSTE),(ERCODE(113:113),NMSTOK)
     &            ,(ERCODE(119:119),CRWORK),(ERCODE(120:120),OPERAT)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsVect*')
*
      INTENT= INTTYP ('ENTIER')                                         !utilite
      INTREL= INTTYP ('REEL')                                           !utilite
      INTCOM= INTTYP ('COMPLEXE')                                       !utilite
*
      CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                   ,'#OMTRM',1,MCMTRM)                     
      READRE='N'
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !sdexplo
      CRWORK='N'
*
      NVNUAV=NDFNUM
*
      DO 1 NUTRAS=1,NBTRAC
         IF (READRE.EQ.'Y') THEN
            CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM
     &                         ,'$ASMBL',NVASMB,MCASMB)
            READRE='N'
         ENDIF
*
*        Recherche des caracteristiques du terme courant a assembler
*
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1))
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTRMB
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDDDD
     &               ,NUINCC,NVDUBC,NBNEBC,NVNUBC
     &               ,NUINCL,NVDUBL,NBNEBL,NVNUBL
     &               ,INSTOK,NVSTOK,NVCORC,IATRDO,NIVIMP)               !sdexplo
         IF (NUINCL.EQ.NDFINC) THEN
            NUINCL=NUINCC
            NVDUBL=NVDUBC
            NBNEBL=NBNEBC
            NVNUBL=NVNUBC
         ENDIF
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NMTRMB(1:NCHTRM))       !utilite
*
         CALL TBRR1  (ERCODE,NMTRMB(:NCHTRM),NVTRMB,LGTRMB)
         READRE='Y'
*
*        Le cas echeant recherche de la constante associee au terme courant

         MCCSTE=0
         CHCSTE=' '
         NIVDON=0
         OPERAT='+'
         ITYPDO=INTREL
         IF (NUDONN.GT.0) THEN
            CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
            CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)       !sdexplo
            IF (ITYDON.EQ.INTDON ('CONSTANTE').AND.NIVDON.GT.0) THEN    !utilite
               OPERAT='*'
               IF (ITYPDO.EQ.INTREL) THEN
                  CHCSTE='$RCSTE'
               ELSEIF (ITYPDO.EQ.INTCOM) THEN
                  CHCSTE='$CCSTE'
               ELSEIF (ITYPDO.EQ.INTENT) THEN
                  CHCSTE='$ECSTE'
                  CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
                  INCSTE=IST(MCCSTE+NIVDON)
                  IF (INCSTE.EQ.1)  OPERAT='+'
                  IF (INCSTE.EQ.-1) OPERAT='-'
               ENDIF
            ENDIF
         ENDIF
*
         IF (NVNUBL.EQ.NVNURL) THEN
*
*           Le terme courant a la meme numerotation que le terme assemble,
*           on assemble les coefficients par combinaison lineaire:
*                      S(I)=S(I) + c. B(I)
*
            CALL TBAR2  (ERCODE,NMTERM          ,NVTERM,MCTERM
     &                         ,NMTRMB(1:NCHTRM),NVTRMB,MCTRMB)
            CALL ASMCLI (OPERAT,CHCSTE,TYPINT(ITYPDO),NIVDON
     &                  ,TYPINT(ITYPTR),MCTRMB,LGTRMB,TYTERM,MCTERM
     &                  ,IST,RST,CST)                                   !assembl
         ELSE
            IF (NVNUBL.NE.NVNUAV) THEN
*              Calcul du tableau des pointeurs d'assemblage de sorte que
*              l'assemblage se reduit a l'operation :
*                      S(PTR(I))=S(PTR(I)) + c. B(I)
*
               CALL TBRR1  (ERCODE,'#GNEDO',NVNUBL,MCNUBL)
               READRE='Y'
               ERCODE(1:1)='!'
               CALL TBAR1  (ERCODE,'$WORK$',0,MCPTRS)
               IF (ERCODE(1:1).EQ.'C') THEN
                  CRWORK='Y'
                  CALL TBCREE ('$WORK$',0,1,LGTERM,'c')
                  CALL TBRR1  (ERCODE,'#GNEDO',NVNURL,MCNURL)
                  CALL TBAR3  (ERCODE,'$WORK$',0,MCPTRS
     &                               ,'#GNEDO',NVNUBL,MCNUBL
     &                               ,'#GNEDO',NVNURL,MCNURL)
               ELSE
                  CALL TBAR2  (ERCODE,'#GNEDO',NVNUBL,MCNUBL
     &                               ,'#GNEDO',NVNURL,MCNURL)
               ENDIF
               CALL ASVEPT (NCPINL,NBNEBL,IST(MCNUBL+2)
     &                     ,NBLIGR,IST(MCNURL+2),IST(MCPTRS))           !assembl
               CALL TBSAVE ('#GNEDO',NVNUBL)                     
               NVNUAV=NVNUBL
            ENDIF
*
*           Assemblage proprement dit : S(PTR(I))=S(PTR(I)) + c. B(I)
*
            CALL ASMCPT (OPERAT,CHCSTE,TYPINT(ITYPDO),NIVDON             
     &                  ,NMTRMB(:NCHTRM),NVTRMB,TYPINT(ITYPTR),LGTRMB
     &                  ,0,0,NMTERM,NVTERM,TYTERM,IST,RST,CST)          !assembl
         ENDIF
*
         CALL TBSAVE (NMTRMB(1:NCHTRM),NVTRMB)
*
1     CONTINUE
*
      IF (CRWORK.EQ.'Y') THEN
         CALL TBTUER ('$WORK$',0)
         CALL TBSAVE ('#GNEDO',NVNURL)
      ENDIF
      CALL PRFXMJ (-1,'*AsVect*')   
                                                                    END !Asvect
