*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASVEPT (NCPINL,NBNLIB,NGNLIB,NBNLIS,NGNLIS,PTRB2S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)
* Derniere modification : D.Martin (31 Janvier 1995)
* Version 1.0.0
*  
* Recherche dichotomique ou non du tableau de pointeurs pour l'assemblage
* d'une vecteur dans un autre
*
*-- Arguments --
* NCPINL nombre de composante de l'inconnue en ligne
* NBNLIB nombre de lignes du terme vectoriel a assembler (B)
* NGNLIB numerotation du terme vectoriel a assembler (B)
* NBNLIS nombre de lignes du terme vectoriel resultat (S)
* NGNLIS numerotation du terme vectoriel resultat (S)
*-- Argument de sortie --
* PRTB2S tableau de pointeurs d'assemblage d'un vecteur dans un autre.
*        Sa taille est celle du vecteur (B) a assembler dans (S)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPINL,NBNLIB,NGNLIB(*),NBNLIS,NGNLIS(*),PTRB2S(*)
*
      INTEGER LIGNES,LIGNBV,LIGNSV,NEXTLS,LIGNE,LIGNEB,NGS,NGB
     &       ,LIGNSS
*-----------------------------------------------------------------------
      IF (NBNLIS.GT.2*NBNLIB) THEN
*        Recherche dichotomique
         LIGNES=0
         LIGNBV=1
         NEXTLS=1
         DO 11 LIGNEB=1,NBNLIB
            CALL DICOTO (NEXTLS,NBNLIS,NGNLIS,NGNLIB(LIGNEB),LIGNES,*11)!Utilite
            NEXTLS=LIGNES+1
            LIGNSV=1+NCPINL*(LIGNES-1)
            DO 10 LIGNE=LIGNBV,LIGNBV+NCPINL-1
               PTRB2S(LIGNE)=LIGNSV
               LIGNSV=LIGNSV+1
10           CONTINUE
            LIGNBV=LIGNBV+NCPINL
11       CONTINUE
      ELSE
*        Recherche selon les adresses croissantes
         LIGNSV=1
         LIGNEB=1
         LIGNBV=1
         DO 21 LIGNES=1,NBNLIS
            NGS=NGNLIS(LIGNES)
            NGB=NGNLIB(LIGNEB)
            IF (NGS.EQ.NGB) THEN
               LIGNSS=LIGNSV
               DO 20 LIGNE=LIGNBV,LIGNBV+NCPINL-1
                  PTRB2S(LIGNE)=LIGNSS
                  LIGNSS=LIGNSS+1
20             CONTINUE
               LIGNEB=LIGNEB+1
               IF (LIGNEB.GT.NBNLIB) RETURN
               LIGNBV=LIGNBV+NCPINL
            ELSEIF (NGS.GT.NGB) THEN
               RETURN
            ENDIF
            LIGNSV=LIGNSV+NCPINL
21       CONTINUE
      ENDIF
                                                                    END !Asvept
