*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASVNIV (NMTERM,NVTERM,NVASMB
     &                  ,ITTRMR,NVALNE,NUINRL,NVDULR,NBLIGX
     &                  ,NVNULR,NCPINL,NVCOOR,IADRDO,NVNU1L)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (15 Juin 2002)
* Version 1.0.3
*  
* Determination du niveau de tableau de numerotation du tableau  
* resultat de l'assemblage et de l'ordre de parcours de la structure 
* pour l'assemblage d'un terme vectoriel uninconnue
*  
*-- Arguments d'entree --
* NMTERM nom du terme resultat de l'assemblage
* NVTERM niveau du terme resultat de l'assemblage 
* NVASMB niveau de la structure d'assemblage
*-- Arguments de sortie -- (indices de description du terme asssemble) 
* ITTRMR type du terme assemble (reel,complexe, ... )
* NVALNE nombre de valeurs par noeuds des termes 
* NUINRL numero de l'inconnue
* NVDULR niveau du tableau de numerotation globale des d.l.
* NBLIGX surestimation du nombre de noeuds du terme resultat    
* NVNULR niveau du tableau de numerotation globale des noeuds  
* NCPINL nombre de composantes de l'inconnue
* NVCOOR niveau du tableau de coordonnees des noeuds
* IADRDO adresse relative dans la structure #TERDO
* NVNU1L niveau de la numerotation globale des noeuds du 1er terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER NVTERM,NVASMB,ITTRMR,NUINRL,NVDULR,NBLIGX,NVNULR
     &       ,NCPINL,NVCOOR,IADRDO,NVNU1L
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      INTEGER INTTYP
      INTEGER MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM,IADTRM,IGTNLI
     &       ,NIVTRM,ITYCAL,NUKALE,NUDONN,NVALN1,NVDDDD,NIVITR
     &       ,NUIN1L,NVDU1L,NGTNEL,NUIN1C,NVDU1C,NGTNEC,NVNU1C
     &       ,ITYPTR,NVALNE,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &       ,NUINCL,NVDUML,NBNEUL,NVNUML,INSTOK,NVSTOK,NVCORC,IATRDO
     &       ,MCDONN,ITYDON,NIVDON,ITYPDO,MCCONU,INTRPL,NBTNEL
     &       ,MCASMB,LGETRA,NBTRAC,INCTRA,NBTRAL,NUTRAS
     &       ,MCDAUX,IAUX,LG,MCMTRM,ITCOMP
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsvNiv*')
      ITCOMP=INTTYP ('COMPLEXE')                                        !utilite
*
      CALL TBAR4  (ERCODE,'$ASMBL',NVASMB,MCASMB,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',  1   ,MCCONU,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)             !utilite
*  
*     Report des attributs du 1er terme dans le terme assemble
*
      IGTNLI=1 
      IADTRM=MCDTRM+LGETRM+INCTRM*(IST(MCASMB+LGETRA)-1)
      CALL GETTRM (IST(IADTRM),NIVTRM,ITTRMR,ITYCAL,NUKALE,NUDONN 
     &            ,NVALNE,NVDDDD
     &            ,NUIN1C,NVDU1C,NGTNEC,NVNU1C
     &            ,NUIN1L,NVDU1L,NGTNEL,NVNU1L
     &            ,INSTOK,NVSTOK,NVCOOR,IADRDO,NIVITR)                  !sdexplo
      IF (NUIN1L.NE.NDFINC) THEN
         NUINRL=NUIN1L
         NVDULR=NVDU1L
         NVNULR=NVNU1L
         NBLIGX=NGTNEL
      ELSE
         NUINRL=NUIN1C
         NVDULR=NVDU1C
         NVNULR=NVNU1C
         NBLIGX=NGTNEC
         NVNU1L=NVNU1C
      ENDIF
      NVALN1=NVALNE
      IF (ITTRMR.NE.ITCOMP.AND.NUDONN.GT.0) THEN
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYPDO.EQ.ITCOMP) ITTRMR=ITYPDO
      ENDIF
*  
*     Prise en compte des attributs des autres termes de l'assemblage 
*
      DO 1 NUTRAS=2,NBTRAC
         NUTERM=IST(MCASMB+LGETRA+INCTRA*(NUTRAS-1)) 
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM),NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN 
     &               ,NVALNE,NVDDDD
     &               ,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &               ,NUINCL,NVDUML,NBNEUL,NVNUML
     &               ,INSTOK,NVSTOK,NVCORC,IATRDO,NIVITR)               !sdexplo
         IF (NUINCL.EQ.NDFINC) THEN
            NUINCL=NUINCC
            NVDUML=NVDUMC
            NBNEUL=NBNEUC
            NVNUML=NVNUMC
         ENDIF
*
*        Compatibilite de l'inconnue
         IF (NUINRL.NE.NUINCL) GOTO 99990
         IF (NVALN1.NE.NVALNE) GOTO 99991
*
*        Type (REEL ou COMPLEXE) du terme resultat
         IF (ITTRMR.NE.ITCOMP) THEN
            IF (ITYPTR.EQ.ITCOMP) ITTRMR=ITCOMP
            IF (NUDONN.GT.0) THEN 
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
               IF (ITYPDO.EQ.ITCOMP) ITTRMR=ITCOMP
            ENDIF
         ENDIF
*  
*        Evaluation surestimee des nbr. max de d.l. en ligne
         NBLIGX=NBLIGX+NBNEUL
*
*        Recherche de la plus grosse numerotation en ligne 
         IF (NBNEUL.GT.NGTNEL) THEN 
            IGTNLI=NUTRAS  
            NGTNEL=NBNEUL  
            NVDULR=NVDUML
            NVNULR=NVNUML   
            NVCOOR=NVCORC 
            IADRDO=IATRDO   
         ENDIF
1     CONTINUE 
*  
*     Reordonnement des termes de la structure :
*     On place en premier dans la structure d'assemblage le terme dont la  
*     numerotation en ligne contient les numerotations des autres
      IF (IGTNLI.GT.1) THEN 
         MCDAUX=MCASMB+LGETRA+INCTRA*(IGTNLI-1)
         IAUX=IST(MCDAUX)
         IST(MCDAUX)=IST(MCASMB+LGETRA)  
         IST(MCASMB+LGETRA)=IAUX
      ENDIF
*  
      CALL SDEXCO (NUINRL,IST(MCCONU),NCPINL,INTRPL,NBTNEL)             !utilite
*
*     Le plus gros tableau de numerotation est rapatrie en M.C.
      CALL TBRR1  (ERCODE,'#GNEDO',NVNULR,LG)
*  
*     Recherche d'un domaine total pour la numerotation
      IF (NGTNEL.LT.NBTNEL) THEN 
         IADRDO=0
         NVDULR=NDFDUM
         NVNULR=NDFNUM
      ENDIF
      IF (NVNULR.NE.NDFNUM) NBLIGX=NGTNEL 
      CALL PRFXMJ (-1,'*AsvNiv*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL TBAR1  (ERCODE,'#OMTRM',1     ,MCMTRM)
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(105:))
      CALL ERTERS (10,NMTERM,NVTERM,ERCODE(105:),NIVTRM)
99991 CALL TBAR1  (ERCODE,'#OMTRM',1     ,MCMTRM)
      CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,ERCODE(105:))
      CALL ERTERS (13,NMTERM,NVTERM,ERCODE(105:),NIVTRM)
                                                                    END !AsvNiv
