*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASVTRM (NMTERM,NVTERM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (19 Septembre 2003)
* Version 1.4
*  
* Assemblage uni-inconnue du terme vectoriel NMTERM de niveau NVTERM 
* selon sa structure d'assemblage $ASMBL
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme resultat de l'assemblage
* NVTERM niveau du terme resultat de l'assemblage 
* NIVIMP niveau d'impression du terme
*        si l'assemblage a ete declaree par directive, le niveau d'impression
*        est celui declare par directive, ou sa valeur par defaut 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INTYKL,INDASS,INDSTO,KLNIVE,KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVASMB
     &             ,NUINRL,NVDURL,NBNERL,NVNURL,NUINRC,NVDURC,NBNERC
     &             ,NVNURC,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR,NIVREL
     &             ,MCASMB,LGCREE,MCNEDR,MCTRMR,LGTERM
     &             ,MCINCO,NCPINL,INTRPL,NBTNEL
     &             ,NVNUL1,NCATR1,NCATR2,IRCODE
      CHARACTER     PRFXAS*8,TYPINT*9
*>>>> Attention dans toute cette procedure et celles qu'elle appelle
*>>>> on utilise la common FORMAH pour transporter des info
      CHARACTER     ERCODE*120,THETR1*16,THETR2*16,CHCSTE*6,NMSTOK*6
      CHARACTER     CHANGD,CRWORK,OPERAT
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(73:73),THETR2)  , (ERCODE(89:89),THETR1)
     &            ,(ERCODE(105:105),CHCSTE),(ERCODE(113:113),NMSTOK)
     &            ,(ERCODE(119:119),CRWORK),(ERCODE(120:120),OPERAT)
*>>>>
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsVtrm*')
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVASMB
     &            ,NUINRC,NVDURC,NBNERC,NVNURC
     &            ,NUINRL,NVDURL,NBNERL,NVNURL
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR)                  !sdexplo
*
*     Le niveau d'impression par directive est prioritaire s'il est non nul
      NIVREL=NIVIMP
      IF (NIVTMR.NE.0) NIVREL=NIVTMR
*
      IF (ITYCAL.NE.INTYKL('ASSEMB').OR.ABS(NUKALE).NE.INDASS(' '))     !utilite
     &   CALL ERTERM (12,NMTERM,NVTERM)                                 !utilite
      CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,MCASMB)
*
      IF (NIVREL.GT.0.AND.IMPSDR.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         WRITE (IMPSDR,10000) PRFXAS(0),THETR1(1:NCATR1)
      ENDIF
*
      IF (NUKALE.LT.0) THEN
*
*        Si la structure d'assemblage n'a pas ete remise a jour,
*        on passe directement a l'assemblage proprement dit
*
         CALL TBAR1  (ERCODE,'#NCONU',1,MCINCO)
         CALL SDEXCO (NUINRL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)          !sdexplo
      ELSE
         NIVEAU=0
*
*        Determination de l'ordre de parcours de la structure et des
*        niveaux des tableaux de numerotation du terme resultat
*
         CALL ASVNIV (NMTERM,NVTERM,NVASMB
     &               ,ITYPTR,NVALNE,NUINRL,NVDURL,NBNERL,NVNURL,NCPINL
     &               ,NVCOOR,IATRDO,NVNUL1)                             !assembl
         IF (NIVREL.GT.0) CALL PRSDAS (NVASMB,NUTERM,NIVREL,IMPSDR)     !prsd
*
*        Numerotation des noeuds du terme
         CHANGD='N'
         IF (NVNURL.EQ.NDFNUM) THEN
            CHANGD='Y'
            IF (NIVEAU.EQ.0) NIVEAU=KLNIVE ()                           !sdexplo
            NVNURL=NIVEAU
            CALL TBCRSU ('#GNEDO',NVNURL,1,2+NBNERL,LGCREE,'c')
            NBNERL=LGCREE-2
            CALL ASNUME (NVASMB,'Ligne',NVNURL,NBNERL,CHANGD,IRCODE)    !assembl
            IF (IRCODE.EQ.1) GOTO 99991
            IF (CHANGD.EQ.'Y') THEN
               IF (NIVREL.GE.3) THEN
                  CALL TBAR1  (ERCODE,'#GNEDO',NVNURL,MCNEDR)
                  CALL PRNEDO ('*Asnume*','Ligne',IST(MCNEDR),IMPSDR)   !prsd
               ENDIF
            ENDIF
            CALL TBAJST ('#GNEDO',NVNURL,2+NBNERL)
         ENDIF
      ENDIF
*
*     Assemblage  proprement dit du terme
*
      IF (NVALNE.NE.NCPINL) CALL ERTERM (36,NMTERM,NVTERM)
      LGTERM=NCPINL*NBNERL
      CALL TBCREE (NMTERM,NVTERM,ITYPTR,LGTERM,'c')
*
*     Mise a zero du terme avant assemblage
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTRMR)
      CALL TAZERO (LGTERM,TYPINT(ITYPTR),MCTRMR,AST,IST,RST,CST)        !utilite
*  
      CALL ASVECT (NMTERM,NVTERM,TYPINT(ITYPTR),NVASMB,NCPINL,NVNURL    
     &            ,NBNERL)                                              !assembl
*
*     Mise a jour des attributs du terme assemble dans $SDTRM
*
      ITYCAL= INTYKL ('ASSEMB')
      NUKALE=-INDASS (' ')
      INSTOK= INDSTO ('PLEIN-L')
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTERM 
     &            ,ITYPTR,ITYCAL,NUKALE,NDFDON,NVALNE,NVASMB
     &            ,NDFINC,NDFDUM,1,NDFNUM,NUINRL,NVDURL,NBNERL,NVNURL
     &            ,INSTOK,NDFSTO,NDFCOR,IATRDO,NIVREL)                  !sdexplo
*  
      IF (NIVREL.GT.0) CALL PRTERM (NMTERM,NVTERM,NIVREL,IMPSDR)        !prsd
      CALL TBSAVE ( NMTERM ,NVTERM)
      CALL TBSAVE ('$ASMBL',NVASMB)
*
      IF (NIVREL.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                       ,TYPINT(ITYPTR)
      ENDIF
*  
      CALL PRFXMJ (-1,'*AsVtrm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Assemblage du terme ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL ENCLER (NBNERL,ERCODE(1:6))
      CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
      CALL PRNTRM ('#GNEDO',NVNURL,THETR2,NCATR2)
      CALL BAISE  ('Taille sous-estimee ('//ERCODE(1:6)
     &//') pour le tableau de numerotation '//THETR2 (1:NCATR2)
     &//' lors de l''assemblage du terme '//THETR1 (1:NCATR1))
                                                                    END !AsVtrm
