*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COTERM (COMP,NMTRM1,NVTRM1,NOMDOM,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1999)
* Derniere modification : D.Martin (9 Avril 2002)
* Version 1.0.2
*  
* Creation d'un terme composante normale ou tangentielle d'un terme a inconnue
* vectorielle sur un domaine (2D seulement pour la composante tangentielle)
*  
*-- Arguments d'entree --
* COMP 'n' (pour composante normale), 't' (pour composante tangentielle 2D)
* NMTRM1,NVTRM1 Nom et niveau du terme d'entree vectoriel
* NOMDOM nom du domaine geometrique ou l'on calcule le terme
* NMTRM2,NVTRM2 Nom et niveau du terme resultat scalaire
* NIVIMP Niveau d'impression du terme resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) COMP,NMTRM1,NOMDOM,NMTRM2
      INTEGER       NVTRM1,NVTRM2,NIVIMP
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       INDSTO,KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE
     &             ,NVDSMB,NUINCC,NVDUMC,NBNEUC,NVNUMC,NUINCL,NVDUML
     &             ,NBNEUL,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR
     &             ,MCMDOM,MCTRDO,LGERDO,NBDOMK,INCRDO,NCHDOM,NUDOMG
     &             ,NUDOMK,IGEOME,INDMIX,NUSCHQ,INDEXC,IDLHRC,INTRPC
     &             ,NBNECX,NBNEXC,NBDLXC,NBNFXC,NBDFXC
     &             ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEXL,NBDLXL,NBNFXL
     &             ,NBDFXL,NVNORM,INUTIL,NBTRDO,NIVIMS
     &             ,MCMINC,MCINCO,LGEINC,NBINCO,INCINC,NCHINC
     &             ,NCPINC,INTERP,NBTNE1
     &             ,LASCAR,LGTRM1,MCNORM,MCTRM1,MCTRM2,IAD,ICOMP,NCATR1
      CHARACTER     LOWERC*1
      INTEGER       ADNORM,ADTRM2
      LOGICAL       CRETRM
      REAL          RCN
      COMPLEX       CCN
      CHARACTER     ERCODE*120,UCOMP*1,TYPINT*4,TYTRM1*4
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoTerm*')
*
      UCOMP=LOWERC (COMP)                                               !utilite
      CALL TBAR6  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO
     &                   ,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !utilite
      CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)             !utilite
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Numero du domaine geometrique de nom NOMDOM
*  
      CALL KLDOMN (NOMDOM,0,-1,IST(MCTRDO),AST(MCMDOM),NBDOMG
     &            ,NUDOMG,IATRDO)                                       !sdexplo
      IATRDO=MCTRDO+IATRDO 
      CALL GETDOM (IST(IATRDO)  ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,INDEXC,IDLHRC,INTRPC
     &            ,NBNECX,NBNEXC,NBDLXC,NBNFXC,NBDFXC,NVNUMC
     &            ,INDEXL,IDLHRL,INTRPL
     &            ,NBNELX,NBNEXL,NBDLXL,NBNFXL,NBDFXL,NVNUML
     &            ,NVNORM,INUTIL,NBTRDO,NIVIMS)                         !sdexplo
      IF (NUDOMG.LE.0) CALL ERDOMA (1,NOMDOM)                           !utilite
*  
*     Recherche des caracteristiques du 1er terme
*
      NUTERM=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEUC,NVNUMC 
     &            ,NUINCL,NVDUML,NBNEUL,NVNUML
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR)                  !sdexplo
      IF (NUINCL.EQ.NDFINC) THEN
         NUINCL=NUINCC
         NBNEUL=NBNEUC
         NVNUML=NVNUMC
      ENDIF
*
*     Nom de l'inconnue affectee au terme et attributs
*
      CALL SDEXCO (NUINCL,IST(MCINCO),NCPINC,INTERP,NBTNE1)             !utilite
      IF (NCPINC.LE.1) CALL ERINCO (3,ERCODE(119-NCHINC:118))           !utilite
      IF (INTERP.NE.INTRPC) GOTO 99991
      IF (NVALNE.LE.1) CALL ERTERM (32,NMTRM1,NVTRM1)                   !utilite
*
      TYTRM1=TYPINT (ITYPTR)                                            !utilite
      ERCODE(1:1)='!'
      CALL TBRR2  (ERCODE,NMTRM1,NVTRM1,LGTRM1,'&NORMA',NVNORM,MCNORM)
      IF (ERCODE(2:2).EQ.'C') CALL ERDOMA (4,NOMDOM)                    !utilite
*  
*     Creation (si necessaire) du 2eme terme
*
      CRETRM=.FALSE.
      INSTOK=INDSTO ('PLEIN-L')
      NVALNE=1
      CALL CRTERM (NMTRM2,NVTRM2,LGTRM1/NCPINC,ITYPTR,ITYCAL,NUKALE
     &            ,NDFDON,NVALNE,NVDSMB,NDFINC,NDFDUM,1     ,NDFNUM
     &            ,NUINCL,NDFDUM,NBNEUL,NVNUML,INSTOK,NDFSTO,NVCOOR
     &            ,IATRDO,NIVIMP,.FALSE.,CRETRM)                        !sdexplo
*
      CALL TBAR3  (ERCODE,NMTRM1,NVTRM1,MCTRM1,NMTRM2,NVTRM2,MCTRM2
     &                   ,'&NORMA',NVNORM,MCNORM)
      ADTRM2 = MCTRM2
      ADNORM = MCNORM
*
      IF (UCOMP.EQ.'n') THEN
*
*        Report des valeurs du produit scalaire
*
         IF (TYTRM1.EQ.'REEL') THEN
            DO 122 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               RCN=0.
               DO 121 ICOMP=0,NDIM-1
                  RCN=RCN+RST(IAD+ICOMP)*RST(ADNORM)
                  ADNORM = ADNORM+1
121            CONTINUE
               RST(ADTRM2)=RCN
               ADTRM2 = ADTRM2+1
122         CONTINUE
         ELSEIF (TYTRM1(1:4).EQ.'COMP') THEN
            DO 144 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               CCN=0.
               DO 141 ICOMP=0,NDIM-1
                  CCN=CCN+CST(IAD+ICOMP)*RST(ADNORM)
                  ADNORM = ADNORM+1
141             CONTINUE
               CST(ADTRM2)=CCN
               ADTRM2 = ADTRM2+1
144         CONTINUE
         ENDIF
*
      ELSEIF (COMP.EQ.'t') THEN
*
*        Report des valeurs du produit exterieur
*
         IF (NDIM.EQ.2) THEN
         IF (TYTRM1.EQ.'REEL') THEN
            DO 222 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               RST(ADTRM2)=RST(IAD)*RST(ADNORM+1)-RST(IAD+1)*RST(ADNORM)
               ADNORM = ADNORM+2
               ADTRM2 = ADTRM2+1
222         CONTINUE
         ELSEIF (TYTRM1(1:4).EQ.'COMP') THEN
            DO 244 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               CST(ADTRM2)=CST(IAD)*RST(ADNORM+1)-CST(IAD+1)*RST(ADNORM)
               ADNORM = ADNORM+2
               ADTRM2 = ADTRM2+1
244         CONTINUE
         ENDIF
         ELSE
          CALL BAISE  ('*CoTerm* Composante tangentielle '
     &                 //' reserve a la dimension 2.')
         ENDIF
*
      ELSEIF (COMP.EQ.'1'.OR.COMP.EQ.'2'.OR.COMP.EQ.'3') THEN
*
         CALL BAISE ('Remplacer COTERM par T1TERM en supprimant le 1er'
     &//' argument et en ajoutant comme 3eme argument la chaine'
     &//' COMPOSANTE '//UCOMP//'.')
      ELSE
         GOTO 99992
      ENDIF
*
      CALL TBSAVE ( NMTRM2 ,NVTRM2)
      CALL TBSAVE ( NMTRM1 ,NVTRM1)
      CALL TBSAVE ('&NORMA',NVNORM)
      CALL PRFXMJ (-1,'*CoTerm*')
      RETURN  
*-----------------------------------------------------------------------
99991 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE(1:16),NCATR1)
      ERCODE(NCATR1+1:NCATR1+NCHDOM)=NOMDOM
      CALL BAISE  ('Incoherence entre l''interpolation de l''inconnue'
     &//ERCODE(119-LASCAR:118)//' associee au terme '//ERCODE(1:NCATR1)
     &//' et l''interpolation en colonne des normales sur le domaine '
     &//ERCODE(NCATR1+1:NCATR1+NCHDOM)//'.')
99992 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE(1:16),NCATR1)
      CALL BAISE  ('Calcul de la composante '//UCOMP
     &//' non prevue pour le terme '//ERCODE(1:NCATR1)//'.')
                                                                    END !CoTerm
