*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DIAMAT (NMDIAG,NVDIAG,NMMATR,NVMATR
     &                  ,NMPROD,NVPROD,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 2008)
* Derniere modification : D.Martin (13 Juin 2008)
* Version 0
*
* Multiplication D * M : Matrice Diagonale x Matrice "quelconque"
* (Voir aussi MATDIA)
*
*-- Arguments d'entree --
* NMDIAG nom du terme vecteur contenant la matrice diagonale
* NVDIAG niveau du terme vecteur contenant la matrice diagonale
* NMMATR nom du terme matriciel operande
* NVMATR niveau 
* NMPROD nom du terme matriciel resultat
* NVPROD niveau du terme resultat
* NIVIMP niveau d'impression du terme resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMDIAG,NMMATR,NMPROD
      INTEGER       NVDIAG,NVMATR,NVPROD
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER INDASS,INDSTO,INDSYM,INTYKL,INTTYP,KLTERM
      INTEGER MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM,ADTERM
     &       ,ITYPTD,ITYCAD,NUKALD,NUDOND,NVALND,NVDSMD,NUINCD,NVDUCD
     &       ,NBNECD,NVNUCD,NUINLD,NVDULD,NBNELD,NVNULD,INDSTD,NVSTOD
     &       ,NVCOOR,IATRDD,ITYPTR,LGPROD,MCPROD,MCSTOK
     &       ,ITYPTM,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMM,NUINCM,NVDUCM
     &       ,NBCOLO,NVNUCM,NUINLM,NVDULM,NBLIGN,NVNULM,INDSTK,NVSTOK
     &       ,IATRDO,NIVIMR,NIVEAU,NCATR1,NCATR2,NCATR3
     &       ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCML,MCMU
     &       ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU,MCPL,MCPU,NIVIMP
     &       ,LGMATR,MCMATR,LGDIAG,MCDIAG,DIAGLG
      LOGICAL IDMTRM, CRETRM 
      CHARACTER PRFXAS*8,TYPINT*8, MULTIV,MULTIM
      CHARACTER*8 TYDIAG,TYMATR,TYPROD
      CHARACTER STOCHN*6,NMSTOK*6,ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DiaMat*')
      CRETRM=.TRUE.
      IDMTRM=.FALSE.
*
      IF (NIVIMP.GE.0.AND.IMPSDR.GT.0) THEN
         CALL PRNTRM (NMPROD,NVPROD,ERCODE,NCATR1)
         CALL PRNTRM (NMDIAG,NVDIAG,ERCODE(NCATR1+1:),NCATR2)
         CALL PRNTRM (NMMATR,NVMATR,ERCODE(NCATR1+NCATR2+1:),NCATR3)
         WRITE (IMPSDR,10000) PRFXAS (0),ERCODE(1:NCATR1)
     &         ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &         ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCATR3)
      ENDIF
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Caracteristiques de vecteur (matrice diagonale, operande a gauche)
*
      NUTERM=KLTERM (NMDIAG,NVDIAG,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMDIAG,NVDIAG)                    !utilite
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(ADTERM)  ,NIVEAU,ITYPTD,ITYCAD,NUKALD,NUDOND
     &            ,NVALND,NVDSMD,NUINCD,NVDUCD,NBNECD,NVNUCD,NUINLD
     &            ,NVDULD,NBNELD,NVNULD,INDSTD,NVSTOD,NVCOOR,IATRDD
     &            ,NIVIMR)                                              !sdexpl
*     Le terme diagonal est a priori un vecteur colonne, mais ...
      IF (NUINCD.NE.NDFINC) THEN
         NUINLD=NUINCD
         NVDULD=NVDUCD
         NBNELD=NBNECD
         NVNULD=NVNUCD
      ENDIF
      MULTIV='N'
      IF (NVDSMD.NE.NDFDSM.AND.NUINLD.EQ.NDFINC) MULTIV='Y'
      TYDIAG=TYPINT (ITYPTD)
*
*     Caracteristiques de la matrice operande a droite
*
      NUTERM=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATR,NVMATR)                    !utilite
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(ADTERM)  ,NIVEAU,ITYPTM,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,NVDSMM,NUINCM,NVDUCM,NBCOLO,NVNUCM,NUINLM
     &            ,NVDULM,NBLIGN,NVNULM,INDSTK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMR)                                              !sdexplo
      TYMATR=TYPINT (ITYPTM)
      MULTIM='N'
      IF (NVDSMM.NE.NDFDSM.AND.NUINCM.EQ.NDFINC.AND.NUINLM.EQ.NDFINC) 
     &   MULTIM='Y'
*
      NMSTOK=STOCHN (INDSTK)                                            !utilite
      CALL TBRR2  (ERCODE,NMDIAG,NVDIAG,LGDIAG,NMMATR,NVMATR,LGMATR)
      IF (NMSTOK(1:2).NE.'PL') CALL TBRR1 (ERCODE,NMSTOK,NVSTOK,MCSTOK)      
      ITYCAL= INTYKL ('ASSEMB')                                         !utilite
      NUKALE=-INDASS (' ')                                              !utilite
*
*     Type, longueur de la matrice resultat
*
      IF (MULTIM.EQ.'Y'.OR.MULTIV.EQ.'Y') GOTO 99991
      IF (NBLIGN.NE.LGDIAG) CALL ERTERS (7,NMDIAG,NVDIAG,NMMATR,NVMATR) !utilite
      DIAGLG=MIN(NBLIGN,NBCOLO)
      TYPROD=TYDIAG
      IF (TYMATR(1:2).EQ.'CO') TYPROD=TYMATR
      ITYPTR= INTTYP (TYPROD)                                           !utilite
      IF ( ITYSYM.EQ.NDFSYM ) THEN
          LGPROD = LGMATR
      ELSE
          LGPROD = DIAGLG + 2*(LGMATR-DIAGLG)
      ENDIF
      CALL CRTERM (NMPROD,NVPROD,LGPROD,ITYPTR,ITYCAL,NUKALE,NDFDON
     &            ,NDFSYM,NVDSMD
     &            ,NUINCM,NVDUCM,NBCOLO,NVNUCM
     &            ,NUINLD,NVDULM,NBLIGN,NVNULM,INDSTK,NVSTOK,NVCOOR
     &            ,IATRDO,NIVIMP,IDMTRM,CRETRM)                         !sdexplo
*
*--   Adresse des operandes et du tableau de pointeurs de la matrice
*
      CALL TBAR3  (ERCODE,NMDIAG,NVDIAG,MCDIAG,NMMATR,NVMATR,MCMATR
     &                   ,NMPROD,NVPROD,MCPROD)
      IF (NMSTOK(1:2).NE.'PL') CALL TBAR1 (ERCODE,NMSTOK,NVSTOK,MCSTOK)
*
*     Multiplication Diag(V) * M
*
      IF (NMSTOK.EQ.'&BMORS') THEN
*        Matrice stockee Bimorse
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)                  !sdexplo
         MCML = MCMATR + DIAGLG
         MCMU = MCML
         MCPL = MCPROD + DIAGLG         
         MCPU = MCPL + LGL
         IF (ITYSYM.EQ.INDSYM('SYMETRIQUE')) THEN
            CALL TDANST (LGL,TYMATR,MCMU,IST,RST,CST
     &                      ,TYPROD,MCPU,IST,RST,CST)
         ELSEIF (ITYSYM.EQ.INDSYM('ANTISYMETRIQUE')) THEN
            CALL TMDANT (LGL,TYMATR,MCMU,IST,RST,CST
     &                      ,TYPROD,MCPU,IST,RST,CST)
         ELSEIF (ITYSYM.EQ.INDSYM('AUTOADJOINTE')) THEN
            CALL TCDANT (LGL,TYMATR,MCMU,IST,RST,CST
     &                      ,TYPROD,MCPU,IST,RST,CST)
         ELSEIF (ITYSYM.EQ.INDSYM('ANTIADJOINTE')) THEN
            CALL TCDANT (LGL,TYMATR,MCMU,IST,RST,CST
     &                      ,TYPROD,MCPU,IST,RST,CST)
            CALL TMDANT (LGL,TYMATR,MCPU,IST,RST,CST
     &                      ,TYMATR,MCPU,IST,RST,CST)
         ELSE
            CALL TDANST (LGMATR,TYMATR,MCMATR,IST,RST,CST
     &                         ,TYPROD,MCPROD,IST,RST,CST)
            MCMU = MCML + LGL
         ENDIF
*        Calcul des coefficients diagonaux
         CALL TAZERO (NBLIGN,TYPROD,MCPROD,AST,IST,RST,CST)             !utilite
         CALL TCOCOT (NBLIGN,TYDIAG,MCDIAG,RST,CST,TYMATR,MCMATR,RST,CST
     &               ,TYPROD,MCPROD,RST,CST)                            !utilite
*        Calcul des coefficients de la partie triangulaire inferieure
         CALL DXML   (1,TYDIAG,MCDIAG,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &               ,TYMATR,MCML  ,MCPL  ,RST,CST)                     !multmat
*        Calcul des coefficients de la partie triangulaire superieure
         CALL DXMU   (1,TYDIAG,MCDIAG,NBCOLO,IST(MCPLAU),IST(MCPLIU)
     &               ,TYMATR,MCPU  ,MCPU  ,RST,CST)                     !multmat
         CALL TBSAVE (NMSTOK,NVSTOK)
*
      ELSEIF (NMSTOK.EQ.'&PLAGE') THEN
*        Matrice stockee Morse-L
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAL,MCPLAL,MCPLIL
     &               ,LGL)                                              !sdexplo
         CALL DXML   (0,TYDIAG,MCDIAG,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &               ,TYMATR,MCMATR,MCPROD,RST,CST)                     !multmat
      ELSEIF (NMSTOK.EQ.'&EGALP') THEN
*        Matrice stockee Morse-C
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAL,MCPLAU,MCPLIU
     &               ,LGU)                                              !sdexplo
         CALL DXMU   (0,TYDIAG,MCDIAG,NBCOLO,IST(MCPLAU),IST(MCPLIU)
     &               ,TYMATR,MCMATR,MCPROD,RST,CST)                     !multmat
      ELSEIF (NMSTOK(1:5).EQ.'PLEIN-L') THEN
*        Matrice stockee Plein-L
         CALL TDANST (LGMATR,TYMATR,MCMATR,IST,RST,CST
     &                      ,TYPROD,MCPROD,IST,RST,CST)
         NBLIGN = LGDIAG
         NBCOLO = LGDIAG
         CALL DXPL  (TYDIAG,MCDIAG,NBLIGN,NBCOLO,TYMATR,NMSTOK,MCMATR
     &              ,MCPROD,RST,CST)                                    !multmat
*
      ELSE
*
         GOTO 99992
*
      ENDIF
      
      IF (NIVIMP.GT.0) CALL PRTERM (NMPROD,NVPROD,NIVIMP,IMPSDR)        !prsd
*
      CALL TBSAVE (NMDIAG,NVDIAG)
      CALL TBSAVE (NMMATR,NVMATR)
      CALL TBSAVE (NMPROD,NVPROD)
      CALL PRFXMJ (-1,'*DiaMat*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Produit matrice diag x matrice ',A:
     &/T11,'matrice diag',A,' et matrice ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL BAISE  (' Multiplication matrice diagonale x matrice non '
     &//'prevue pour le stockage '//NMSTOK(1:6)//' en d.l. vectoriels'
     &//': matrice '//ERCODE(1:NCATR1)//'.')
99992 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL BAISE  (' Multiplication matrice diagonale x matrice non '
     &//'prevue pour le stockage '//NMSTOK(1:6)
     &//': matrice '//ERCODE(1:NCATR1)//'.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (13 juin 2008)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DiaMat
