*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMAJO (NVDSMB,IRCODE,NUCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin, O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (30 octobre 2008)
* Version 2
*
* Calculs des majorants pour dimensionner les tableaux de numerotations
* et de compactages de la structure $DSMBL de niveau NVDSMB.
*
*-- Arguments --
* NVDSMB niveau de la structure $DSMBL
* IRCODE code d'erreur
*        5 incompatibilite du stockage / ordre inconnues
*        6 type de stockage non prevu
*        7 terme PLEIN-L non prevu
*        8 terme PLEIN-C non prevu
* NUCODE numero du terme provoquant l'erreur
*-- Remarque --
* Le tableau de travail &WORK$/1 est structure comme suit:
* (1) nombre total de d.l. en ligne du resultat    (DsNume)
* (2) nombre total de d.l. en colonnes du resultat (DsNume)
* (3) nombre max. de coefficients dans la partie triangulaire inferieure
* (4) nombre max. de coefficients dans la partie triangulaire superieure
* (5) nombre max. de plages dans la partie triangulaire inferieure
* (6) nombre max. de plages dans la partie triangulaire superieure
* (7) indicateur de presence de d.l. vectoriel si .gt.1
* (+ADWRKL=8)        majorants du nb. de lignes par inconnue
* (+ADWRKC=8+NBSTRU) majorants du nb. de colonnes par inconnue
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER    NVDSMB,IRCODE,NUCODE
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER STOCHN*6
      INTEGER   INDSTO
      INTEGER   MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERA,ADTERA
     &         ,MCDSMB,LGEDSM,NBLOCC,INCDSM,NBLOCL,NULOCC,NULOCL
     &         ,NVTERA,ITYMAT,ITYCAL,NUKALE,NUDONN,ITSYMA,NVDSSS,NUINCM
     &         ,NVDUMC,NBNECO,NVNUMC,NUINLM,NVDUML,NBNELI,NVNUML,INSTOK
     &         ,NVSTOK,NVCOOR,IATRDO,NIVIMA
     &         ,MCCONU,NCPINC,NCPINL,INTERP,NBT,NCFSSD,LGS
     &         ,MCPLAG,NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &         ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU
     &         ,LGEWRK,INCWRK,NBSTRU,MCWOR1,ADWRKC,ADWRKL,LRIPIN
      CHARACTER ERCODE*120,NMSTOK*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsMajo*')
*
*     Mise en place du tableau de travail &WORK$/1
*
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$DSMBL',NVDSMB,MCDSMB)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)             !utilite
      LGEWRK=7
      INCWRK=10
      NBSTRU=MAX (NBLOCC,NBLOCL)
      CALL TBCREE ('&WORK$',1,1,LGEWRK+INCWRK*NBSTRU,'c')
      CALL TBAR1  (ERCODE,'&WORK$',1,MCWOR1)                     
      CALL TAZERO (LGEWRK+INCWRK*NBSTRU,'ENTIER',MCWOR1,AST,IST,RST,CST)!utilite
*
      LRIPIN=LGEDSM
      ADWRKC=LGEWRK+NBSTRU
      DO 2 NULOCC=1,NBLOCC
         ADWRKL=LGEWRK
         DO 1 NULOCL=1,NBLOCL
            CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$DSMBL',NVDSMB,MCDSMB
     &                         ,'#NCONU',1,MCCONU)
            NUTERA=IST(MCDSMB+LRIPIN)
            IF (NUTERA.GT.0) THEN
               ADTERA=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
               CALL GETTRM (IST(ADTERA),NVTERA,ITYMAT,ITYCAL,NUKALE
     &                     ,NUDONN,ITSYMA,NVDSSS,NUINCM,NVDUMC,NBNECO
     &                     ,NVNUMC,NUINLM,NVDUML,NBNELI,NVNUML,INSTOK
     &                     ,NVSTOK,NVCOOR,IATRDO,NIVIMA)                !sdexplo
               CALL SDEXCO (NUINCM,IST(MCCONU),NCPINC,INTERP,NBT)       !utilite
               CALL SDEXCO (NUINLM,IST(MCCONU),NCPINL,INTERP,NBT)       !utilite
               LGS=0
               NBL=NBNELI
               NBC=NBNECO
*              Forgotten, added on 30.oct.2008
               LGL=0
               LGU=0
               NBPLAL=0
               NBPLAU=0
*
               NMSTOK = STOCHN (INSTOK)
               IF (NMSTOK.EQ.'&BMORS') THEN
*
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL EXBMOR (MCPLAG,IST(MCPLAG)
     &                           ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                           ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)         !sdexplo
                     LGL=LGL*NCPINC
                     LGU=LGU*NCPINL
                     NCFSSD=MAX(NCPINL,NCPINC)
                     IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
                     LGS=NCFSSD*MIN(NBL,NBC)
                     CALL TBSAVE (NMSTOK,NVSTOK)
*
               ELSEIF (NMSTOK.EQ.'&PLAGE') THEN
*
                  IF (NULOCC.GT.NULOCL) GOTO 99995
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                           ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)     !sdexplo
                     LGL=LGL*NCPINC
                     CALL TBSAVE (NMSTOK,NVSTOK)
*
               ELSEIF (NMSTOK.EQ.'&EGALP') THEN
*
                  IF (NULOCL.GT.NULOCC) GOTO 99996
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                           ,NBC,NBL,NBPLAU,MCPLAL,MCPLIL,LGU)     !sdexplo
                     LGU =LGU*NCPINL
                     CALL TBSAVE (NMSTOK,NVSTOK)
*
               ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-L')) THEN
*
                  IF (NULOCC.GT.NULOCL) GOTO 99995
                  NBPLAL=NBL
                  LGL=NBL*NBC*NCPINC
               ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-C')) THEN
*
                  IF (NULOCL.GT.NULOCC) GOTO 99995
                  NBPLAU=NBC
                  LGU=NBL*NBC*NCPINL
               ELSE
                  GOTO 99995
               ENDIF
               CALL TBAR1  (ERCODE,'&WORK$',1,MCWOR1)
               IST(MCWOR1  )=IST(MCWOR1  )+NBL*NCPINL
               IST(MCWOR1+1)=IST(MCWOR1+1)+NBC*NCPINC
               IST(MCWOR1+2)=IST(MCWOR1+2)+LGL*NCPINL+LGS
               IST(MCWOR1+3)=IST(MCWOR1+3)+LGU*NCPINC+LGS
               IST(MCWOR1+4)=IST(MCWOR1+4)+NBPLAL*NCPINL
               IST(MCWOR1+5)=IST(MCWOR1+5)+NBPLAU*NCPINC
*              IF (NCFSSD.GT.1) IST(MCWOR1+6)=MAX(IST(MCWOR1+6),NCFSSD)
               IST(MCWOR1+ADWRKL)=IST(MCWOR1+ADWRKL)+NBL*NCPINL
               IST(MCWOR1+ADWRKC)=IST(MCWOR1+ADWRKC)+NBC*NCPINC
            ENDIF
            ADWRKL=ADWRKL+1
            LRIPIN=LRIPIN+INCDSM
1        CONTINUE
         ADWRKC=ADWRKC+1
2     CONTINUE
      CALL PRFXMJ (-1,'*DsMajo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99995 IRCODE=5
      NUCODE=NUTERA
      RETURN
99996 IRCODE=6
      NUCODE=NUTERA
      RETURN
99997 IRCODE=7
      NUCODE=NUTERA
      RETURN
99998 IRCODE=8
      NUCODE=NUTERA
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (30 octobre 2008)
*  Changement de nom des structures en DL : ne travailler qu'avec les structures
*  en noeuds ...
* * Version 1.0.1 : D.Martin (1er Fevrier 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END
