*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMAMO (NMTERM,NVTERM,ITTERM,NVDSMB,NMSTOR,NVSTOR
     &                  ,COLLIG,NBLIGN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1992)
* Derniere modification : D.Martin (6 novembre 2008)
* Version 3
*  
* Report des termes de la structure d'assemblage de niveau NVDSMB 
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme assemble resultat
* NVTERM son niveau
* ITTERM son type de declaration
* NVDSMB niveau de la structure d'assemblage $DSMBL
* NMSTOR nom du tableau de stockage du terme assemble resultat
* NVSTOR niveau du tableau de stockage du terme assemble resultat
* COLLIG indicateur d'assemblage par ligne ou colonne : 'L' ou 'C'
* NBLIGN pointeur sur le numero des lignes
*-- Remarque --
* Le tableau de travail &WORK$,1 est structure comme suit:
*    "  (1         )=NXLIGN tableau des numeros de 1ere colonne a parcourir
*    "  (1+  NBSTRU)=NUDRPL tableau des numeros de derniere plage de la ligne
*    "  (1+2*NBSTRU)=LGCUAV longueur cumule avant la ligne en cours
*    "  (1+3*NBSTRU)=MCNELI adresse de la numerotation en ligne du terme
*    "  (1+4*NBSTRU)=MCPLAL adresse du tableau de derniere plage de la ligne
*    "  (1+5*NBSTRU)=MCPLIL adresse du tableau de debut et longueur de plage
*    "  (1+6*NBSTRU)=MCTERA adresse du terme
*    "  (1+7*NBSTRU)=ITYPTR type du terme
*    "  (1+8*NBSTRU)=MCASSO adresse de la donnee associee
*    "  (1+9*NBSTRU)=ITYPDO type de la donnee associee
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NVTERM,ITTERM,NVDSMB,NVSTOR,NBLIGN
      CHARACTER*(*) NMTERM,COLLIG,NMSTOR
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      CHARACTER STODLN*6
      INTEGER   INDSTO,INTDON,INTTYP
      INTEGER   INTENT,INTREL,INTCOM,INDSBI,INDSML,INDSMC,INDSPL,INDSPC
     &         ,MCDSMB,LGEDSM,NBLOCC,INCDSM,NBLOCL,INCRIN,INCREX,NBBOEX
     &         ,LRIPEX,LRIPIN,NBSTRU,NUBOEX,NBBOIN,NUBOIN
     &         ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERA,IADTRM
     &         ,NVTERA,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS,NUINCC
     &         ,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &         ,NVSTOC,NVCOOR,IATRDO,NIVITR,NVNURC,NVNURL,MCLIGN,NVSTOK
     &         ,NWNUML,MCNELI,NWNUMC,MCTERA,MCPLAG,MCWOR1,MWNXLI,MWNELI
     &         ,MWNXLK ,MCCONU,NCPINL,INTRP,NBT,NCPINC,MCTERM,MCRESU
     &         ,MCROLD,MCDONN,ITYDON,NIVDON,ITYPDO,MCCSTE
     &         ,MCPLAR,ADTRIA,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,NBC,NBPLAU
     &         ,MCPLAU,MCPLIU,LGU,LGD,INRESU, INDSKK
      CHARACTER     ERCODE*120,CHAINE*16,NMSTOK*6
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(105:105),CHAINE)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Dsmamo*')
*
      INTENT=INTTYP ('ENTIER')                                          !utilite
      INTREL=INTTYP ('REEL')                                            !utilite
      INTCOM=INTTYP ('COMPLEXE')                                        !utilite
      INDSBI=INDSTO ('BIMORSE')                                         !utilite
      INDSML=INDSTO ('MORSE-L')                                         !utilite
      INDSMC=INDSTO ('MORSE-C')                                         !utilite
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
      INDSPC=INDSTO ('PLEIN-C')                                         !utilite
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$DSMBL',NVDSMB,MCDSMB
     &                                     , NMSTOR ,NVSTOR,MCPLAR)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)             !utilite
      CALL EXBMOR (MCPLAR,IST(MCPLAR),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)     !sdexplo
*     ADTRIA adresse relative de la partie triangulaire concernee
      ADTRIA=MIN(NBL,NBC)
      IF (COLLIG(1:1).EQ.'L') THEN
*        Structure Bimorse pour la partie triangulaire inferieure
         INCRIN=INCDSM*NBLOCL
         INCREX=INCDSM
         NBBOEX=NBLOCL
         NBBOEY=NBLOCC
      ELSEIF (COLLIG(1:1).EQ.'C') THEN
*        Structure Bimorse pour la partie triangulaire superieure
         INCRIN=INCDSM
         INCREX=INCDSM*NBLOCL
         NBBOEX=NBLOCC
         NBBOEY=NBLOCL
         ADTRIA=ADTRIA+LGL
      ENDIF
      NBSTRU=MAX (NBLOCC,NBLOCL)
      INRESU=0
      NBLIGN=0
*
      LRIPEX=LGEDSM
      DO 120 NUBOEX=1,NBBOEX
*
*        Recherche des tableaux utiles pour la boucle suivante
         LRIPIN=LRIPEX
         NBBOIN=MIN(NUBOEX,NBBOEY)
         DO 105 NUBOIN=1,NBBOIN
            CALL TBAR4(ERCODE,'$SDTRM',  1   ,MCDTRM,'#OMTRM',1,MCMTRM
     &                       ,'$DSMBL',NVDSMB,MCDSMB,'#NCONU',1,MCCONU)
*           Numero du terme (bloc) courant
            NUTERA=IST(MCDSMB+LRIPEX)
*           NUTERA = 0 ==> le bloc est vide (non occupe par un terme)
            IF (NUTERA.GT.0) THEN
*              Niveau du tableau #GNEDO en colonne/ligne du bloc courant
               NVNURC=IST(MCDSMB+LRIPEX+3)
*              Niveau du tableau #GNEDO en ligne/colonne du bloc courant
               NVNURL=IST(MCDSMB+LRIPEX+4)
*              Niveau du tableau de stockage du bloc
               NVSTOK=IST(MCDSMB+LRIPEX+5)
               IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
               CALL GETTRM (IST(IADTRM),NVTERA,ITYPTR,ITYCAL,NUKALE
     &                     ,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC,NBNECO
     &                     ,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &                     ,NVSTOC,NVCOOR,IATRDO,NIVITR)                !sdexplo
               CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)        !utilite
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !utilite
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,CHAINE)           !utilite
               CALL TBRR1  (ERCODE,CHAINE(:NCHTRM),NVTERA,MCTERA)
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
               IF (COLLIG(1:1).EQ.'C') THEN
                  NWNUML=NWNUMC
                  NVNURL=NVNURC
               ENDIF
*              Nom du tableau de stockage
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
               NMSTOK = STODLN (INDSKK,NCPINC,NCPINL)                   !utilite
               CALL TBRR3  (ERCODE,'#GNEDO',NWNUML,MCNELI 
     &                            ,'#GNEDO',NVNURL,MCLIGN
     &                            ,NMSTOK,NVSTOK,MCPLAG)
            ENDIF
            LRIPEX=LRIPEX+INCRIN
 105     CONTINUE
*
*        Collecte d'information sur chaque inconnue en colonne pour la
*        boucle suivante
         CALL TBAR5  (ERCODE,'$SDTRM',   1  ,MCDTRM,'#OMTRM',1,MCMTRM
     &                      ,'$DSMBL',NVDSMB,MCDSMB,'&WORK$',1,MCWOR1
     &                      ,'#NCONU',1,MCCONU)
*        Mise a 1 de NXLIGN(*)
         MWNXLI=MCWOR1
         MWNELI=MWNXLI+3*NBSTRU
*
         LRIPEX=LRIPIN
         DO 110 NUBOIN=1,NBBOIN
*           Recherches des tableaux pour l'inconnue en ligne
            NUTERA=IST(MCDSMB+LRIPEX)
            NVNURC=IST(MCDSMB+LRIPEX+3)
            NVNURL=IST(MCDSMB+LRIPEX+4)
            NVSTOK=IST(MCDSMB+LRIPEX+5)
            IF (NUTERA.GT.0) THEN
               IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
               CALL GETTRM (IST(IADTRM),NVTERA,ITYPTR,ITYCAL,NUKALE
     &                     ,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC,NBNECO
     &                     ,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &                     ,NVSTOC,NVCOOR,IATRDO,NIVITR)                !sdexplo
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,CHAINE)           !utilite
               CALL TBAR1  (ERCODE,CHAINE(:NCHTRM),NVTERA,MCTERA)
               LGD=0
               CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)        !sdexplo
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !sdexplo
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
               IF (COLLIG(1:1).EQ.'C') THEN
                  NWNUML=NWNUMC
                  NVNURL=NVNURC
               ENDIF
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
               NMSTOK = STODLN (INDSKK,NCPINC,NCPINL)                   !utilite
               CALL TBAR3  (ERCODE,'#GNEDO',NWNUML,MCNELI
     &                            ,'#GNEDO',NVNURL,MCLIGN
     &                            ,NMSTOK,NVSTOK,MCPLAG)
               IF (NMSTOK(1:4).EQ.'&BMO') THEN
                  CALL EXBMOR (MCPLAG,IST(MCPLAG)
     &                        ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                        ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)            !sdexplo
                  LGD=MIN(NBL,NBC)
                  IF (COLLIG(1:1).EQ.'C') THEN
                     IF (ITYSYM.EQ.NDFSYM) LGD=LGD+LGL
                     MCPLAL=MCPLAU
                     MCPLIL=MCPLIU
                  ENDIF
               ELSEIF (NMSTOK(1:4).EQ.'&PLA') THEN
                  CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                        ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)        !sdexplo
               ELSEIF (NMSTOK(1:4).EQ.'&EGA') THEN
                  CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                        ,NBC,NBL,NBPLAU,MCPLAL,MCPLIL,LGU)        !sdexplo
               ENDIF
*
               IST(MWNXLI)=1
               IF (NUBOIN.EQ.NBBOIN) IST(MWNXLI)=2
               MWNXLK     =MWNXLI+NBSTRU
               IST(MWNXLK)=0
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=0
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=MCNELI+2
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=MCPLAL
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=MCPLIL
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=MCTERA+LGD
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK)=ITYPTR
               MWNXLK     =MWNXLK+NBSTRU
               IST(MWNXLK       )=0
               IST(MWNXLK+NBSTRU)=0
               IF (NUDONN.GT.0) THEN
                  CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
                  CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO) !sdexplo
                  IF (ITYDON.EQ.INTDON ('CONSTANTE')
     &               .AND.NIVDON.GT.0)              THEN
                     IF (ITYPDO.EQ.INTREL) THEN
                        CALL TBAR1  (ERCODE,'$RCSTE',1,MCCSTE)
                     ELSEIF (ITYPDO.EQ.INTCOM) THEN
                        CALL TBAR1  (ERCODE,'$CCSTE',1,MCCSTE)
                     ELSEIF (ITYPDO.EQ.INTENT) THEN
                        CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
                     ENDIF
                     IST(MWNXLK       )=MCCSTE+NIVDON
                     IST(MWNXLK+NBSTRU)=ITYPDO
                  ENDIF
               ENDIF
            ELSE
               IST(MWNELI)=-9999
            ENDIF
            LRIPEX=LRIPEX+INCRIN
            MWNXLI=MWNXLI+1
            MWNELI=MWNELI+1
 110     CONTINUE
*
         CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*        Remarque NBLIGN est compte en d.l. puisque vient de
*        la numerotation en ligne de la structure
         NBLIGN=NBLIGN+IST(MCLIGN+1)
         MCRESU=MCTERM+ADTRIA+INRESU
         MCROLD=MCRESU
*
*        Fusion des matrices des inconnue en colonne pour l'inconnue en ligne
*
         MWNXLI=MCWOR1
         CALL DSMALI (MCRESU,ITTERM,MCLIGN+2,NBBOIN
     &               ,IST(MWNXLI)         ,IST(MWNXLI+  NBSTRU)
     &               ,IST(MWNXLI+2*NBSTRU),IST(MWNXLI+3*NBSTRU)
     &               ,IST(MWNXLI+4*NBSTRU),IST(MWNXLI+5*NBSTRU)
     &               ,IST(MWNXLI+6*NBSTRU),IST(MWNXLI+7*NBSTRU)
     &               ,IST(MWNXLI+8*NBSTRU),IST(MWNXLI+9*NBSTRU)
     &               ,IST,RST,CST)                                      !assembl
*        Increment d'adresse dans le parcours dans la partie triangulaire
*        inferieure (par ligne) ou superieure (par colonne)
         INRESU=INRESU+MCRESU-MCROLD
*
*        Sauvegarde des tableaux devenus inutiles
*        (on choisit ne pas tuer systematiquement ces tables pour
*         le cas ou l'assemblage intervient une boucle)
         LRIPEX=LRIPIN
         DO 115 NUBOIN=1,NBBOIN
            NUTERA=IST(MCDSMB+LRIPEX)
            NVNURC=IST(MCDSMB+LRIPEX+3)
            NVNURL=IST(MCDSMB+LRIPEX+4)
            NVSTOK=IST(MCDSMB+LRIPEX+5)
            IF (NUTERA.GT.0) THEN
               IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
               CALL GETTRM (IST(IADTRM),NVTERA,ITYPTR,ITYCAL,NUKALE
     &                     ,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC,NBNECO
     &                     ,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &                     ,NVSTOC,NVCOOR,IATRDO,NIVITR)                !sdexplo
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,CHAINE)           !utilite
               CALL TBSAVE (CHAINE(:NCHTRM),NVTERA)
               CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)        !sdexplo
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !sdexplo
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
               IF (COLLIG(1:1).EQ.'C') THEN
                  NWNUML=NWNUMC
                  NVNURL=NVNURC
               ENDIF
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
               NMSTOK = STODLN (INDSKK,NCPINC,NCPINL)                   !utilite
               IF (INSTOK.EQ.INDSPL.OR.INSTOK.EQ.INDSPC) THEN
*                 Le compactage temporaire pour l'assemblage des termes
*                 PLEIN-L/C en D.L. est detruit
                  CALL TBTUER (NMSTOK,NVSTOK)
               ELSE
                  CALL TBSAVE (NMSTOK,NVSTOK)
               ENDIF
               CALL TBSAVE ('#GNEDO',NWNUML)                     
               CALL TBSAVE ('#GNEDO',NVNURL)                     
               CALL TBAR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
            ENDIF
            LRIPEX=LRIPEX+INCRIN
 115     CONTINUE
*
         LRIPEX=LRIPIN+INCREX
 120  CONTINUE
*
      CALL PRFXMJ (-1,'*Dsmamo*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (6 novembre 2008)
*  Suppression : destruction des structure de stockage en D.L. 
* Version 2 : D.Martin (30 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
*  Rajout : destruction des structure de stockage en D.L.
* Version 1.0.3 : D.Martin (17 octobre 2002)
* Modifications anterieures
* Version 1.0.2 : D.Martin (21 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END
