*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMCMO (NMTERM,NVTERM,NVDSMB,COLLIG
     &                  ,LGMORL,NMSTOR,NVSTOR,NBPLAX,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (30 octobre 2008)
* Version 2
*
* Creation d'une table de compactage BIMORSE inferieur ou superieur pour
* l'assemblage d'un terme multi-inconnue
*  
*-- Arguments d'entree --- 
* NMTERM nom du terme a assembler
* NVTERM son niveau
* NVDSMB niveau de la structure $DSMBL
* COLLIG indice de transposition: chaine dont l'initiale contient 'C' ou 'L' 
* LGMORL adresse relative du compactage en ligne ou en colonne
* NMSTOR nom du tableau de stockage BIMORSE du terme resultat
* NVSTOR niveau du tableau de stockage BIMORSE du terme resultat
* NBPLAX nombre maximum de plages possibles
* IRCODE code de retour en cas de depassement du nombre de plage max.
*-- Remarque --
* Le tableau de travail &WORK$/1 est structure comme suit:
* (1)=NBLITO nombre de lignes de la matrice assemblee
* (2)=NBCOTO nombre de colonnes de la matrice assemblee
* (3)=LGINF  nombre max. de coefficients dans le triangle inferieur
* (4)=LGSUP  nombre max. de coefficients dans le triangle superieur
* (5)=NBPLAX nombre max. de plages dans le triangle inferieur
* (6)=NBPUAX nombre max. de plages dans le triangle superieur
* (7)=IADUDL Indicateur de presence de d.l. vectoriels si .gt.1
* puis:
* (8         )=NXLIGN tableau des numeros de 1ere col./lig. a parcourir
* (8+  NBSTRU)=NUDRPL "       numeros de derniere plage de la lig./col.
* (8+2*NBSTRU)=LGCUAV longueur cumule avant la lig./col. en cours
* (8+3*NBSTRU)=MCNELI adresse de la numerotation en lig./col. du terme
* (8+4*NBSTRU)=MCNECO adresse de la numerotation en col./lig. du terme
* (8+5*NBSTRU)=MCPLAL adresse du tableau de derniere plage de la lig./col.
* (8+6*NBSTRU)=MCPLIL adresse du tableau de debut et longueur de plage
* (8+7*NBSTRU)=MCCOLO adresse de la numerotation en col./lig. du bloc
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM,COLLIG,NMSTOR 
      INTEGER       NVTERM,NVDSMB,LGMORL,NBPLAX,IRCODE
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      CHARACTER STOCHN*6, STODLN*6
      INTEGER INDSTO
      INTEGER INDSBI,INDSML,INDSMC,INDSPL,INDSPC,KLNIVE
     &       ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &       ,MCDSMB,LGEDSM,NBLOCC,INCDSM,NBLOCL,NBBOEX,NBBEOY,INCRIN
     &       ,INCREX,NUBOEX,LRIPEX,NBBOIN,NUBOIN,LRIPIN,NBSTRU,NBLIGN,NUTERA
     &       ,NVTERA,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS,NUINCC
     &       ,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &       ,INDSKK,NVSTOK,NVCOOR,IATRDO,NIVITR,NCATR1
     &       ,MCCONU,NCPINC,INTRP,NBT,NCPINL,ADLICO,ADCOLI
     &       ,MCWOR1,LGEWRK,MWNXLI,MWNXLK,NBLIAV,LPLAGS,LGCUSV
     &       ,NVNURC,NVCOLI,MCCOLI,NVNURL,NVLICO,MCLICO,NWNUMC,MCNECO
     &       ,NWNUML,MCNELI,NVSTOR,NBPLAR,MCPLAG,NVSTOC,MCPLAR,MCPLIR
     &       ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU
      CHARACTER     ERCODE*120,NMTERA*16,NMSTOK*6
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Dsmcmo*')
*
      INDSBI=INDSTO ('BIMORSE')                                         !utilite
      INDSML=INDSTO ('MORSE-L')                                         !utilite
      INDSMC=INDSTO ('MORSE-C')                                         !utilite
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
      INDSPC=INDSTO ('PLEIN-C')                                         !utilite
      CALL TBAR3 (ERCODE,'$SDTRM',1,MCDTRM,'$DSMBL',NVDSMB,MCDSMB
     &                  ,'&WORK$',1,MCWOR1)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)             !utilite
      LGEWRK=7
      NBSTRU=MAX (NBLOCC,NBLOCL)
*
      IF (COLLIG(1:1).EQ.'L') THEN
*
*        Structure Bimorse pour la partie triangulaire inferieure
         NBBOEX=NBLOCL
         NBBOEY=NBLOCC
         INCRIN=INCDSM*NBLOCL
         INCREX=INCDSM
         NBLIGN=IST(MCWOR1)
         ADCOLI=3
         ADLICO=4
*
      ELSEIF (COLLIG(1:1).EQ.'C') THEN
*
*        Structure Bimorse pour la partie triangulaire superieure
         NBBOEX=NBLOCC
         NBBOEY=NBLOCL
         INCRIN=INCDSM
         INCREX=INCDSM*NBLOCL
         NBLIGN=IST(MCWOR1+1)
         ADCOLI=4
         ADLICO=3
*
      ENDIF
      LPLAGS=0
      LGCUSV=0
      NBPLAR=0
      NBLIAV=0
*
*     Adresse relative des informations du 1er bloc dans la structure '$DSMBL'
      LRIPEX=LGEDSM
      DO 120 NUBOEX=1,NBBOEX
*        Adresse relative des informations du bloc courant dans la structure '$DSMBL'
         LRIPIN=LRIPEX
*
*        Recherche des tableaux utiles pour la boucle suivante
*        et restauration en Memoire Centrale
*
         NBBOIN=MIN (NUBOEX,NBBOEY)
         DO 105 NUBOIN=1,NBBOIN
            CALL TBAR4  (ERCODE,'$SDTRM',1,MCDTRM,'#NCONU',1,MCCONU
     &                        ,'$DSMBL',NVDSMB,MCDSMB,'#OMTRM',1,MCMTRM)
*           Numero du terme (bloc) courant
            NUTERA=IST(MCDSMB+LRIPEX)
*           Niveau du tableau #GNEDO en colonne/ligne du bloc courant
            NVCOLI=IST(MCDSMB+LRIPEX+ADCOLI)
*           Niveau du tableau #GNEDO en ligne/colonne du bloc courant
            NVLICO=IST(MCDSMB+LRIPEX+ADLICO)
*
            IF (NUTERA.GT.0) THEN
*              Renseignements concernant le terme du bloc courant
               CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,NMTERA(1:NCHTRM)) !utilite
               CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NVTERA
     &                     ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &                     ,NUINCC,NVDUMC,NBNECO,NVNUMC
     &                     ,NUINCL,NVDUML,NBNELI,NVNUML
     &                     ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVITR)         !sdexplo
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !utilite
               NCPINL=NCPINC
               IF (NUINCL.NE.NUINCC) THEN
                  CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)     !utilite
               ELSE
                  IF (INSTOK.NE.INDSBI) GOTO 99993
               ENDIF
*              Niveau du tableau #GNEDO en colonne du terme courant
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
*              Niveau du tableau #GNEDO en ligne du terme courant
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               CALL TBRR2  (ERCODE,'#GNEDO',NVCOLI,MCCOLI
     &                            ,'#GNEDO',NWNUMC,MCNECO)
               IF (NWNUML.NE.NWNUMC)
     &            CALL TBRR1  (ERCODE,'#GNEDO',NWNUML,MCNELI)
*
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
               NMSTOK = STOCHN(INDSKK)
               IF (NCPINL*NCPINC.LE.1) THEN
*                 Cas d'inconnues scalaires
                  IF (INSTOK.EQ.INDSBI) THEN
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                  ELSEIF (INSTOK.EQ.INDSML) THEN
                     IF (COLLIG(1:1).NE.'L') GOTO 99991
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                  ELSEIF (INSTOK.EQ.INDSMC) THEN
                     IF (COLLIG(1:1).NE.'C') GOTO 99992
                     CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                  ELSEIF (INSTOK.EQ.INDSPL) THEN
                     IF (COLLIG(1:1).NE.'L') GOTO 99991
                     NVSTOK=KLNIVE ()                                   !sdexplo
*                    Creation d'un compactage Morse-L pour l'assemblage
                     CALL TBCREE (NMSTOK,NVSTOK,1,4+3*NBNELI,'c')
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL PL2MOL (NBNELI,NBNECO,IST(MCPLAG))            !morse
                  ELSEIF (INSTOK.EQ.INDSPC) THEN
                     IF (COLLIG(1:1).NE.'C') GOTO 99992
                     NVSTOK=KLNIVE ()                                   !sdexplo
*                    Creation d'un compactage Morse-C pour l'assemblage
                     CALL TBCREE (NMSTOK,NVSTOK,1,4+3*NBNECO,'c')
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL PL2MOL (NBNECO,NBNELI,IST(MCPLAG))            !morse
                  ENDIF
               ELSE
*                 Cas d'une inconnue vectorielle en ligne ou colonne
                  IF (INSTOK.EQ.INDSBI) THEN
                     CALL BMO2DL (NVSTOK,NCPINL,NCPINC,ITYSYM
     &                           ,NMTERA(1:NCHTRM),NVTERA,NIVITR)       !sdexplo
                  ELSEIF (INSTOK.EQ.INDSML) THEN
                     IF (COLLIG(1:1).NE.'L') GOTO 99991
                     CALL MOL2DL (NVSTOK,NCPINL,NCPINC
     &                           ,NMTERA(1:NCHTRM),NVTERA,NIVITR)       !sdexplo
                  ELSEIF (INSTOK.EQ.INDSMC) THEN
                     IF (COLLIG(1:1).NE.'C') GOTO 99992
                     CALL MOC2DL (NVSTOK,NCPINL,NCPINC
     &                           ,NMTERA(1:NCHTRM),NVTERA,NIVITR)       !sdexplo
                  ELSEIF (INSTOK.EQ.INDSPL) THEN
                     IF (COLLIG(1:1).NE.'L') GOTO 99991
                     NVSTOK=KLNIVE ()                                   !sdexplo
*                    Creation d'un compactage Morse-L pour l'assemblage
                     CALL TBCREE (NMSTOK,NVSTOK,1,4+3*NBNELI,'c')
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL PL2MOL (NBNELI,NBNECO,IST(MCPLAG))            !morse
                     CALL MOL2DL (NVSTOK,NCPINL,NCPINC,NMTERA(1:NCHTRM)
     &                           ,NVTERA,NIVITR)                        !sdexplo
                  ELSEIF (INSTOK.EQ.INDSPC) THEN
                     IF (COLLIG(1:1).NE.'C') GOTO 99992
                     NVSTOK=KLNIVE ()                                   !sdexplo
*                    Creation d'un compactage Morse-C pour l'assemblage
                     CALL TBCREE (NMSTOK,NVSTOK,1,4+3*NBNECO,'c')
                     CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
                     CALL PL2MOL (NBNECO,NBNELI,IST(MCPLAG))            !morse
                     CALL MOC2DL (NVSTOK,NCPINL,NCPINC,NMTERA(1:NCHTRM)
     &                           ,NVTERA,NIVITR)                        !sdexplo
                  ENDIF
               ENDIF
               IST(MCDSMB+LRIPEX+5)=NVSTOK
            ENDIF
            LRIPEX=LRIPEX+INCRIN
*           Tableau #GNEDO de numerotation en colonne/ligne du bloc (NUBOEX,NUBOIN)
            CALL TBRR1  (ERCODE,'#GNEDO',NVCOLI,MCCOLI) 
105      CONTINUE
*        Tableau #GNEDO de numerotation en ligne/colonne des blocs NUBOEX
         CALL TBRR1  (ERCODE,'#GNEDO',NVLICO,MCLICO) 
         CALL TBAR1  (ERCODE,'#GNEDO',NVLICO,MCLICO)
*
*        Collecte d''information sur chaque inconnue en colonne 
*
         CALL TBAR4  (ERCODE,'&WORK$',1,MCWOR1,'$DSMBL',NVDSMB,MCDSMB
     &                      ,'$SDTRM',1,MCDTRM,'#NCONU',1,MCCONU)
         MWNXLI=MCWOR1+LGEWRK
*
         LRIPEX=LRIPIN
         DO 110 NUBOIN=1,NBBOIN
*           Numero du terme constituant du bloc courant
*           NUTERA = 0 ==> le bloc est vide (non occupe par un terme)
            NUTERA=IST(MCDSMB+LRIPEX)
*           Niveau du tableau #GNEDO en colonne/ligne du bloc courant
            NVCOLI=IST(MCDSMB+LRIPEX+ADCOLI)
            CALL TBAR1  (ERCODE,'#GNEDO',NVCOLI,MCCOLI)
            IST(MWNXLI+7*NBSTRU)=MCCOLI

            IF (NUTERA.LE.0) THEN
*              Absence de Terme : Bloc (NUBOEX, NUBOIN)
*              Mise a -1 des adresses MCNELI, MCNECO
               IST(MWNXLI+3*NBSTRU)=-1
               IST(MWNXLI+4*NBSTRU)=-1
            ELSE
*              Niveau du tableau de stockage du bloc
               NVSTOK=IST(MCDSMB+LRIPEX+5)
*              Renseignements concernant le terme du bloc courant
               CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NVTERA
     &                     ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &                     ,NUINCC,NVDUMC,NBNECO,NVNUMC
     &                     ,NUINCL,NVDUML,NBNELI,NVNUML
     &                     ,INSTOK,NVSTOC,NVCOOR,IATRDO,NIVITR)         !sdexplo
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !utilite
               NCPINL=NCPINC
               IF (NUINCL.NE.NUINCC)
     &            CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)     !utilite
*              Niveau du tableau #GNEDO en colonne du terme courant
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
               CALL TBAR1  (ERCODE,'#GNEDO',NWNUMC,MCNECO)
*              Niveau du tableau #GNEDO en ligne du terme courant
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               MCNELI=MCNECO
               IF (NWNUML.NE.NWNUMC)
     &            CALL TBAR1  (ERCODE,'#GNEDO',NWNUML,MCNELI)
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
*
*              Tableau de stockage du terme occupant le bloc courant
               NMSTOK = STODLN (INDSKK,NCPINC,NCPINL)                  !utilite
               CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCPLAG)
               IF (NMSTOK(1:4).EQ.'&BMO') THEN
                  CALL EXBMOR (MCPLAG,IST(MCPLAG)
     &                        ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                        ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)            !sdexplo
               ELSEIF (NMSTOK(1:4).EQ.'&PLA') THEN
                  CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                        ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)        !sdexplo
               ELSEIF (NMSTOK(1:4).EQ.'&EGA') THEN
                  CALL EXMORS (MCPLAG,IST(MCPLAG)
     &                        ,NBC,NBL,NBPLAU,MCPLAU,MCPLIU,LGU)        !sdexplo
               ENDIF
               IST(MWNXLI)=1
               MWNXLK     =MWNXLI+NBSTRU
*              Tableau des numeros de derniere plage de la lig./col.
*              (initialise ici et remplit dans Dsmcdi)
               IST(MWNXLK)=0
               MWNXLK     =MWNXLK+NBSTRU
*              Tableau des longueurs cumulees avant la lig./col. en cours
*              (initialise ici et remplit dans Dsmcdi)
               IST(MWNXLK)=0
               MWNXLK     =MWNXLK+NBSTRU
               IF (COLLIG(1:1).EQ.'L') THEN
*                 Tableau des adresses de la numerotation en ligne des termes
                  IST(MWNXLK)=MCNELI
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses de la numerotation en colonne des termes
                  IST(MWNXLK)=MCNECO
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses des tableaux de derniere plage de la ligne
                  IST(MWNXLK)=MCPLAL
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses des tableaux de debut de plage et de longueur
                  IST(MWNXLK)=MCPLIL
               ELSEIF (COLLIG(1:1).EQ.'C') THEN
*                 Tableau des adresses de la numerotation en colonne des termes
                  IST(MWNXLK)=MCNECO
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses de la numerotation en ligne des termes
                  IST(MWNXLK)=MCNELI
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses des tableaux de derniere plage de la colonne
                  IST(MWNXLK)=MCPLAU
                  MWNXLK     =MWNXLK+NBSTRU
*                 Tableau des adresses des tableaux de debut de plage et de longueur
                  IST(MWNXLK)=MCPLIU
               ENDIF
            ENDIF
            MWNXLI=MWNXLI+1
            LRIPEX=LRIPEX+INCRIN
110      CONTINUE
*
         CALL TBAR1  (ERCODE,NMSTOR,NVSTOR,MCPLAR)
         IST(MCPLAR)=LGMORL+1
         MWNXLI=MCWOR1+LGEWRK
         MCPLAR=MCPLAR+LGMORL
         MCPLIR=MCPLAR+NBLIGN
*
*        Fusion des tableaux de stockage de chaque inconnue en colonne
*        pour l'inconnue en ligne
         IRCODE=0
         CALL DSMCDI (MCPLAR,MCPLIR,MCLICO,NBPLAX,LPLAGS,LGCUSV
     &               ,NBPLAR,NBLIAV,NUBOEX,IST(MWNXLI)
     &               ,IST(MWNXLI+  NBSTRU),IST(MWNXLI+2*NBSTRU)
     &               ,IST(MWNXLI+3*NBSTRU),IST(MWNXLI+4*NBSTRU)
     &               ,IST(MWNXLI+5*NBSTRU),IST(MWNXLI+6*NBSTRU)
     &               ,IST(MWNXLI+7*NBSTRU),IRCODE,IST)                  !assembl
         IF (IRCODE.GT.0) GOTO 99990
*
*        Boucle de sauvegarde des tableaux
         LRIPEX=LRIPIN
         DO 115 NUBOIN=1,NBBOIN
            NUTERA=IST(MCDSMB+LRIPEX)
            NVCOLI=IST(MCDSMB+LRIPEX+ADCOLI)
            IF (NUTERA.GT.0) THEN
               NVSTOK=IST(MCDSMB+LRIPEX+5)
               CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NVTERA
     &                     ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &                     ,NUINCC,NVDUMC,NBNECO,NVNUMC
     &                     ,NUINCL,NVDUML,NBNELI,NVNUML
     &                     ,INSTOK,NVSTOC,NVCOOR,IATRDO,NIVITR)         !sdexplo
               CALL SDEXCO (NUINCC,IST(MCCONU),NCPINC,INTRP,NBT)        !utilite
               NCPINL=NCPINC
               IF (NUINCL.NE.NUINCC)
     &            CALL SDEXCO (NUINCL,IST(MCCONU),NCPINL,INTRP,NBT)     !utilite
               NWNUMC=NVNUMC
               IF (NCPINC.GT.1) NWNUMC=NVDUMC
               CALL TBSAVE ('#GNEDO',NWNUMC)                     
               NWNUML=NVNUML
               IF (NCPINL.GT.1) NWNUML=NVDUML
               IF (NWNUML.NE.NWNUMC) CALL TBSAVE ('#GNEDO',NWNUML)
               INDSKK = INSTOK
               IF (INSTOK.EQ.INDSPL) THEN
                  INDSKK = INDSML
               ELSEIF (INSTOK.EQ.INDSPC) THEN
                  INDSKK = INDSMC
               ENDIF
               NMSTOK = STODLN (INDSKK,NCPINC,NCPINL)                   !utilite
               CALL TBSAVE (NMSTOK,NVSTOK)
            ENDIF
            CALL TBSAVE ('#GNEDO',NVCOLI)
            LRIPEX=LRIPEX+INCRIN
115      CONTINUE
         CALL TBSAVE ('#GNEDO',NVLICO)
         LRIPEX=LRIPIN+INCREX
120   CONTINUE
      LGMORL=LGMORL+NBLIAV+2*NBPLAR
*
      IST(MCPLAR)=NBLIAV
      IF (NBLIAV.NE.NBLIGN) GOTO 99994
*  
      CALL PRFXMJ (-1,'*Dsmcmo*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL ENCLER (NUBOEX,ERCODE(NCATR1+1:NCATR1+3))
      CALL ENCLER (IRCODE,ERCODE(NCATR1+4:NCATR1+6))
      CALL ENCLER (NBPLAX,ERCODE(NCATR1+7:NCATR1+12))
      CALL WARNNG  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1) //'. Taille (Nombre de plages max ='
     &//ERCODE(NCATR1+7:NCATR1+12)
     &//') sous estimee pour le tableau Bimorse (bloc en cours '
     &//ERCODE(NCATR1+1:NCATR1+3)//'x'//ERCODE(NCATR1+4:NCATR1+6)//').')
      NIVESP=NIVESP-1
      RETURN
99991 NMSTOK=STOCHN (INDTSK)
      CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRM (NMTERA(1:NCHTRM),NVTERA,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. La matrice '//NMSTOK//' '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' doit aller dans la partie triangulaire inferieure.')
99992 NMSTOK=STOCHN (INDTSK)
      CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRM (NMTERA(1:NCHTRM),NVTERA,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. La matrice '//NMSTOK//' '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' doit aller dans la partie triangulaire superieure.')
99993 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRM (NMTERA(1:NCHTRM),NVTERA,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. La matrice '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' posee  sur la diagonale, est necessairement BiMorse.')
99994 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL ENCLER (NBLIGN,ERCODE(NCATR1+1:NCATR1+6))
      CALL ENCLER (NBLIAV,ERCODE(NCATR1+7:NCATR1+12))
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)
     &//'. Incoherence sur le nombre de lignes, nombre de lignes prevu '
     &//ERCODE(NCATR1+1:NCATR1+6)//', nombre de lignes trouve '
     &//ERCODE(NCATR1+7:NCATR1+12)//'.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (30 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 2 : D.Martin (16 mars 2008)
*  Correction d'un bug lorsque qu'un terme vide n'est pas un bloc diagonal
* Version 1.4 : D.Martin (9 septembre 2006)
*  Amelioration des Warnings
* Version 1.3 : D.Martin (17 octobre 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END
