*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMRUC (NMTERM,NVTERM,NVASMB,ITYPTA,NIVIMP
     &                  ,IRCODE,NUCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1992)
* Derniere modification : D.Martin (26 mai 2004)
* Version 1.1
*  
* Creation de la structure $DSMBL d'assemblage multi-inconnues 
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme a assembler
* NVTERM niveau
* NVASMB niveau des structures $ASMBL et $DSMBL
* ITYPTA type de declaration du resultat
* NIVIMP niveau d'impression
* IRCODE code d'erreur
* NUCODE numero du terme provoquant l'erreur
*-- Structure $DSMBL
* $DSMBL(1)=LGEDSM (=4)
*       (2)=NBLOCC nombre de termes en colonne
*       (3)=INCDSM (=6) nb. caracteristiques par terme de la structure
*       (4)=NBLOCL nombre de termes en ligne
* puis pour chaque terme de la structure (. = LGEDSM+INCDSM*(NUTRAS-1) )
*       (.  ) NUTERA numero du terme
*       (.+1) numero de l'inconnue en colonne du terme
*       (.+2) numero de l'inconnue en ligne du terme
*       (.+3) niveau de la numerotation en colonne du terme
*       (.+4) niveau de la numerotation en ligne du terme
*       (.+5) case de travail
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NVASMB,ITYPTA,NIVIMP,IRCODE,NUCODE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INTTYP
      INTEGER       INCMIC,INCMAC,INCMIL,INCMAL,NBTDSM
     &             ,LGASMB,MCASMB,LGEASM,NBTRAS,INCASM,NBLOCL,NBLOCC
     &             ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCWRK0,ADWRK0
     &             ,NVDSMB,LGDSMB,LGEDSM,INCDSM,MCDSMB,ADDSMB,INTCOM
     &             ,NUTERA,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM
     &             ,NVDSSS,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML
     &             ,NBNELI,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR
     &             ,MCDONN,ITYDON,NIVDON,ITYPDO,NUTRAS,NUTERB,K,NCATR1
     &             ,NCATR2
      CHARACTER     PRFXAS*8
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsmRuc*')
      INTCOM=INTTYP ('COMPLEXE')                                        !utilite
*
      CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,LGASMB)
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'$ASMBL',NVASMB,MCASMB
     &                   ,'$DONNE',1,MCDONN)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCASMB),LGEASM,NBTRAS,INCASM,NBLOCL)             !utilite
*
*     Estimation de la taille de la structure
*
      INCMIC = INTMAX
      INCMAC = INTMIN
      INCMIL = INCMIC
      INCMAL = INCMAC
      MCASMB=MCASMB+LGEASM
      DO 1 NUTRAS=1,NBTRAS
         NUTERA=IST(MCASMB)
         MCASMB=MCASMB+INCASM
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU,ITYPTR
     &               ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC
     &               ,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &               ,NVSTOK,NVCOOR,IATRDO,NIVTMR)                      !sdexplo
*
*        Pas de terme multi-inconnues dans un assemblage multi-inconnues
*
         IF (NVDSSS.NE.NDFDSM.AND.NUINCC.EQ.NDFINC.AND.NUINCL.EQ.NDFINC)
     &      GOTO 99991
*
*        Type (REEL ou COMPLEXE) du resultat
*
         IF (ITYPTA.NE.INTCOM) THEN
            IF (ITYPTR.EQ.INTCOM) ITYPTA=INTCOM
            IF (NUDONN.NE.NDFDON) THEN
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
               IF (ITYPDO.EQ.INTCOM) ITYPTA=INTCOM
            ENDIF
         ENDIF
         INCMIC = MIN (NUINCC,INCMIC)
         INCMAC = MAX (NUINCC,INCMAC)
         INCMIL = MIN (NUINCL,INCMIL)
         INCMAL = MAX (NUINCL,INCMAL)
1     CONTINUE
*
*     Nombre maximum de blocs de la structure $DSMBL
*
      NBTDSM = (INCMAC-INCMIC+1)*(INCMAL-INCMIL+1)
*
*     Creation d'une structure $DSMBL' destinee a recevoir
*     les attributs de la matrice assemblee "multi-inconnues".
*
      NVDSMB=NVASMB
      ERCODE(1:1)='!'
      CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,LGDSMB)
      IF (ERCODE(1:1).EQ.'C') THEN
*
*        Creation de la structure $DSMBL de niveau NVDSMB
*
         LGEDSM=4
         INCDSM=6
         LGDSMB=LGEDSM+NBTDSM*INCDSM
         CALL TBCREE ('$DSMBL',NVDSMB,1,LGDSMB,'c')
         IF (NIVIMP.GE.1) THEN
            CALL PRNTRM ('$DSMBL',NVDSMB,ERCODE,NCATR1)                 !utilite
            CALL PRNTRM (NMTERM,NVTERM,ERCODE(NCATR1+1:),NCATR2)        !utilite
            WRITE (IMPSDR,10000) PRFXAS (1),ERCODE(1:NCATR1)
     &                          ,ERCODE(NCATR1+1:NCATR1+NCATR2)
         ENDIF
      ELSE
*
*        Agrandissement eventuel de la structure $DSMBL
*
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
         CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)          !utilite
         CALL SDAJST ('$DSMBL',NVDSMB,LGDSMB,LGEDSM,INCDSM,NBLOCC*NBLOCL
     &               ,NBTDSM-MAX(NBLOCC*NBLOCL,0))                      !sdexplo
      ENDIF
      CALL TBCREE ('&WORK$',0,1,MAX (INCDSM,5*NBTRAS),'c')
*
*     Initialisation / Remplissage de la structure $DSMBL
*
      CALL TBAR4  (ERCODE,'$DSMBL',NVDSMB,MCDSMB,'$ASMBL',NVASMB,MCASMB
     &                   ,'$SDTRM',1,MCDTRM,'&WORK$',0,MCWRK0)
*
*     Utilisation de la seconde moitie de '&WORK$'/0 pour stockage
*     des valeurs d'initialisation d'un bloc de sstructure '$DSMBL'
*
      ADWRK0=MCWRK0
      IST(ADWRK0  )=0
      IST(ADWRK0+1)=NDFINC
      IST(ADWRK0+2)=NDFINC
      IST(ADWRK0+3)=NDFNUM
      IST(ADWRK0+4)=NDFNUM
      IST(ADWRK0+5)=NDFSTO
      ADDSMB=MCDSMB+LGEDSM
      DO 3 NUTRAS=MCDSMB,MCDSMB+LGEDSM-1
         IST(NUTRAS)=0
3     CONTINUE
      DO 5 NUTRAS=1,NBTDSM
         DO 4 K=0,INCDSM-1
            IST(ADDSMB+K)=IST(ADWRK0+K)
4        CONTINUE
         ADDSMB=ADDSMB+INCDSM
5     CONTINUE
*
      MCASMB=MCASMB+LGEASM
      DO 10 NUTRAS=1,NBTRAS
         NUTERA=IST(MCASMB)
         MCASMB=MCASMB+INCASM
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU,ITYPTR
     &               ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC
     &               ,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &               ,NVSTOK,NVCOOR,IATRDO,NIVTMR)                      !sdexplo
*
         ADWRK0=MCWRK0
         DO 9 NUTERB=1,NUTRAS-1
*           Deux termes a assembler ont des couples d'inconnues differents
            IF (NUINCC.EQ.IST(ADWRK0+NBTRAS)
     &     .AND.NUINCL.EQ.IST(ADWRK0+2*NBTRAS)) GOTO 99992
            ADWRK0=ADWRK0+1
9        CONTINUE
*
*        Mise a jour de la structure $DSMBL provisoire pour le terme
         IST(ADWRK0         )=NUTERA
         IST(ADWRK0+  NBTRAS)=NUINCC
         IST(ADWRK0+2*NBTRAS)=NUINCL
         IST(ADWRK0+3*NBTRAS)=NUINCC
         IST(ADWRK0+4*NBTRAS)=NUINCL
10    CONTINUE
*
*     Tri de la structure '$DSMBL' pour l'ordonner en 'carre'
*     selon les numeros d'inconnues en ligne puis en colonne
*
      CALL DSMTRI (NBTRAS,INCDSM,IST(MCDSMB+LGEDSM),IST(MCWRK0)         !assembl
     &            ,NBLOCC,NBLOCL,IRCODE)                                !assembl
      IF (IRCODE.NE.0) RETURN
      CALL SDMKDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)             !utilite
      CALL TBTUER ('&WORK$',0)
*
      CALL DSMAJO (NVDSMB,IRCODE,NUCODE)                                !assembl
      IF (IRCODE.NE.0) RETURN
*
      CALL TBSAVE ('$ASMBL',NVASMB)
*
      CALL PRFXMJ (-1,'*DsmRuc*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT (T2,A,'>*Dsmruc* Creation de la structure ',A
     &,' pour l''assemblage de la matrice ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 IRCODE=1
      NUCODE=NUTERA
      RETURN
99992 IRCODE=2
      NUCODE=NUTERA
      RETURN
                                                                    END !DsMruc
