*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMTRI (NBTRAS,INCDSM,SDSMBL,SORTIN,NBLOCC,NBLOCL
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1999)
* Derniere modification : D.Martin (26 Aout 2000)
* Version 1.0.4
*
* Tri de la structure SDSMBL.
* En sortie SDSMBL est d'un tableau carre a double entree (ligne/colonne)
*
*-- Arguments --
* NBTRAS nombre d'items de cette structure
* INCDSM nombre de mots par item de cette structure
* SDSMBL structure a trier
* SORTIN tableau de travail pour trier les inconnues
* NBLOCC nombre de blocs (termes) en colonne en sortie
* NBLOCL nombre de blocs (termes) en ligne en sortie
* IRCODE code d'erreur en sortie
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NBTRAS,INCDSM,SDSMBL(*),SORTIN(NBTRAS,*),NBLOCC,NBLOCL
     &         ,IRCODE
*
      INTEGER   NUTRAS,ADDRES,NUINCC,NUINCL,NULOCC,NULOCL,ADDRE1,ADDREL
*-----------------------------------------------------------------------
*     Tri des inconnues par ordre croissant en colonne / ligne
*
      CALL TRI1TB (NBTRAS,1,SORTIN(1,4))                                !utilite
      CALL TRI1TB (NBTRAS,1,SORTIN(1,5))                                !utilite
*
*     Nombre de blocs en colonne et ligne
*
      NBLOCC=1
      NBLOCL=1
      DO 2 NUTRAS=2,NBTRAS
         IF (SORTIN(NUTRAS,4).GT.SORTIN(NUTRAS-1,4)) THEN
            NBLOCC=NBLOCC+1
            SORTIN(NBLOCC,4)=SORTIN(NUTRAS,4)
         ENDIF
         IF (SORTIN(NUTRAS,5).GT.SORTIN(NUTRAS-1,5)) THEN
            NBLOCL=NBLOCL+1
            SORTIN(NBLOCL,5)=SORTIN(NUTRAS,5)
         ENDIF
2     CONTINUE
*
*     Reperage des termes et inconnues bloc par bloc
*
      DO 10 NUTRAS=1,NBTRAS
         NUINCC=SORTIN(NUTRAS,2)
         NUINCL=SORTIN(NUTRAS,3)
         ADDRES=1-INCDSM
         DO 9 NULOCC=1,NBLOCC
            DO 8 NULOCL=1,NBLOCL
               ADDRES=ADDRES+INCDSM
               IF (NUINCC.EQ.SORTIN(NULOCC,4)
     &        .AND.NUINCL.EQ.SORTIN(NULOCL,5)) THEN
*                  Caracteristiques du terme correspondant
*                  au bloc (NULOCC,NULOCL) dans le structure
*
*                  Numero du terme
                   SDSMBL(ADDRES  )=SORTIN(NUTRAS,1)
*                  Inconnues en colonne/ligne du terme
                   SDSMBL(ADDRES+1)=NUINCC
                   SDSMBL(ADDRES+2)=NUINCL
                   GOTO 10
               ENDIF
8           CONTINUE
9        CONTINUE
10    CONTINUE
*
*     Mise a jour des numeros d'inconnue en colonne pour tous les termes
*
      ADDRES=1-INCDSM
      DO 19 NULOCC=1,NBLOCC
         ADDRE1=ADDRES
         DO 15 NULOCL=1,NBLOCL
            ADDRES=ADDRES+INCDSM
            NUINCC=SDSMBL(ADDRES+1)
            IF (NUINCC.GT.0) GOTO 16
15       CONTINUE
         IRCODE=3
         RETURN
16       ADDRES=ADDRE1
         DO 17 NULOCL=1,NBLOCL
            ADDRES=ADDRES+INCDSM
            SDSMBL(ADDRES+1)=NUINCC
17       CONTINUE
19    CONTINUE
*
*     Mise a jour des numeros d'inconnue en ligne pour tous les termes
*
*     ADDREL=1-INCDSM corrige en (26 Aout 2000)
      ADDREL=1-INCDSM*NBLOCC
      DO 29 NULOCL=1,NBLOCL
         ADDRE1=ADDREL
         ADDRES=ADDRE1
         DO 25 NULOCC=1,NBLOCC
            ADDRES=ADDRES+INCDSM*NBLOCC
            NUINCL=SDSMBL(ADDRES+2)
            IF (NUINCL.GT.0) GOTO 26
25       CONTINUE
         IRCODE=4
         RETURN
26       ADDRES=ADDRE1
         DO 27 NULOCC=1,NBLOCC
            ADDRES=ADDRES+INCDSM*NBLOCC
            SDSMBL(ADDRES+2)=NUINCL
27       CONTINUE
         ADDREL=ADDREL+INCDSM
29    CONTINUE
                                                                    END !Dsmtri

