*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSMTRM (NMTERM,NVTERM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (9 septembre 2006)
* Version 1.5
*  
* Assemblage multi-inconnue du terme matriciel NMTERM de niveau NVTERM  
* selon ses structures d'assemblage $ASMBL (puis $DSMBL)
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme resultat de l'assemblage
* NVTERM niveau du terme resultat de l'assemblage 
* NIVIMP niveau d'impression du terme
*        si l'assemblage a ete declaree par directive, le niveau d'impression
*        est celui declare par directive, ou sa valeur par defaut
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM 
      INTEGER       NVTERM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     TYPINT*9,STOCHN*6,STOIND*7,SYMIND*14
      CHARACTER     ERCODE*120,PRFXAS*8,THETR1*16,NMSTOK*6,CHAINE*16
      INTEGER       INDASS,INDSTO,INTYKL,KLNIVE,KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &             ,NUINRC,NVDURC,NBNERC,NVNURC,NUINRL,NVDURL,NBNERL
     &             ,NVNURL,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR,NIVREL
     &             ,NBCOTO,NBLITO,LGBMOR,LGCREE,LGMORL,LGTERM,MCTERM
     &             ,MCSTOK,NBPLAX,NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &             ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU
     &             ,MCDSMB,LGEDSM,NBLOCC,INCDSM,NBLOCL,MCCONU
     &             ,MCWOR1,NBAJBM,NCATR1,NCATR2,IRCODE,NUCODE
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(105:105),CHAINE)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsmTrm*')
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU,ITYPTR
     &            ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB,NUINRC,NVDURC
     &            ,NBNERC,NVNURC,NUINRL,NVDURL,NBNERL,NVNURL,INSTOK
     &            ,NVSTOK,NVCOOR,IATRDO,NIVTMR)                         !sdexplo
*
      NIVREL=NIVIMP
*     Le niveau d'impression par directive est prioritaire s'il est non nul
      IF (NIVTMR.NE.0) NIVREL=NIVTMR
*
      IF (NVDSMB.EQ.NDFDSM) CALL ERTERM (13,NMTERM,NVTERM)              !utilite
*
      IF (NIVREL.GT.0.AND.IMPSDR.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         WRITE (IMPSDR,10000) PRFXAS(0),THETR1(1:NCATR1),SYMIND(ITYSYM)
      ENDIF
*
*     Si la structure d'assemblage n'a pas ete remise a jour, on passe 
*     directement a l'assemblage des termes proprement dit
*
      IF (NUKALE.GE.0) THEN
*
*        Creation de la structure '$DSMBL'
*
         IRCODE=0
         CALL DSMRUC (NMTERM,NVTERM,NVDSMB,ITYPTR,NIVIMP,IRCODE,NUCODE) !assembl
         GOTO (99991,99992,99993,99993,99995,99996,99997,99998) IRCODE
*        IF (NIVREL.GT.0)
*    &      CALL PRSDDS (NVDSMB,NMTERM,NVTERM,NIVREL,IMPSDR)            !prsd
*
*        Calcul des numerotations pour chaque couple d'inconnues
*
         CALL DSNUME (NMTERM,NVTERM,NVDSMB,NIVREL)                      !assembl
         IF (NIVREL.GT.0)
     &      CALL PRSDDS (NVDSMB,NMTERM,NVTERM,NIVREL,IMPSDR)            !prsd
*
*        Calcul du compactage total
*
         NBAJBM=0
         NVSTOK=KLNIVE ()                                               !sdexplo
*
*        Estimation 1 de la taille de la table BiMorse du resultat
         CALL TBAR1  (ERCODE,'&WORK$',1,MCWOR1)
         NBLITO=IST(MCWOR1)
         NBCOTO=IST(MCWOR1+1)
         LGBMOR=1+2*NBLITO+2*IST(MCWOR1+4)
         IF (ITYSYM.EQ.NDFSYM) LGBMOR=LGBMOR+2*NBCOTO+2*IST(MCWOR1+5)
*
         NMSTOK='&BMORS'
         CALL TBCRSU (NMSTOK,NVSTOK,1,LGBMOR,LGCREE,'c')
*
*        Tables Bimorse de la partie triangulaire inferieure du resultat
*
1        LGMORL=1
         NBPLAX=(LGCREE-LGMORL-NBLITO)/2
         CALL DSMCMO (NMTERM,NVTERM,NVDSMB,'Lig',LGMORL
     &               ,NMSTOK,NVSTOK,NBPLAX,IRCODE)                      !assembl
         IF (IRCODE.GT.0) THEN
            IF (NBAJBM.GT.2) GOTO 99981
*           Taille insuffisante detectee pour NMSTOK,NVSTOK
*           multiplication par 2 (pour les parties inferieure et superieure)
               CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
               CALL WARNNG ('Assemblage de '//THETR1(1:NCATR1)
     &            //'. Estimation taille structure Bimorse Inf a revoir'
     &            //'. Prevenir Daniel.Martin@univ-rennes1.fr')         !utilite
            LGCREE=2*LGBMOR
            CALL TBAJST (NMSTOK,NVSTOK,LGCREE)
            NBAJBM=NBAJBM+1
            GOTO 1
         ENDIF
*
         IF (ITYSYM.EQ.NDFSYM) THEN
*
*           Tables Bimorse de la partie triangulaire superieure
*
2           NBPLAX=(LGCREE-LGMORL-NBCOTO)/2
            CALL DSMCMO (NMTERM,NVTERM,NVDSMB,'Col',LGMORL
     &                  ,NMSTOK,NVSTOK,NBPLAX,IRCODE)                   !assembl
            IF (IRCODE.GT.0) THEN
               IF (NBAJBM.GT.4) GOTO 99982
*              Taille insuffisante detectee pour NMSTOK,NVSTOK
*              multiplication par 3/2 pour la partie superieure
               CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
               CALL WARNNG ('Assemblage de '//THETR1(1:NCATR1)
     &            //'. Estimation taille structure Bimorse Sup a revoir'
     &            //'. Prevenir Daniel.Martin@univ-rennes1.fr')         !utilite
               LGCREE=3*LGBMOR/2
               CALL TBAJST (NMSTOK,NVSTOK,LGCREE)
               NBAJBM=NBAJBM+1
               GOTO 2
            ENDIF
         ENDIF
         CALL TBAJST (NMSTOK,NVSTOK,LGMORL)
         IF (NIVREL.GE.5) THEN
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
            CALL PRBMOR (IST(MCSTOK),' Terme',NMTERM,NVTERM
     &                  ,NIVREL,IMPSDR)                                 !prsd
         ENDIF
*
      ELSE
*
         NMSTOK=STOCHN (INSTOK)                                         !utilite
         CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
         IF (NIVREL.GT.0)
     &      CALL PRSDDS (NVDSMB,NMTERM,NVTERM,NIVREL,IMPSDR)            !prsd
         CALL TBAR2  (ERCODE,'$DSMBL',NVDSMB,MCDSMB,'#NCONU',1,MCCONU)
         CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCC,INCDSM,NBLOCL)          !utilite
         CALL TBCREE ('&WORK$',1,1,10*MAX (NBLOCC,NBLOCL),'c')
      ENDIF
*
*     Creation du terme resultat 
*
      CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)     !sdexplo
      LGTERM=MIN (NBC,NBL)+LGL
      IF (ITYSYM.EQ.NDFSYM) LGTERM=LGTERM+LGU
*
      CALL TBCREE (NMTERM,NVTERM,ITYPTR,LGTERM,'c')
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
      CALL TAZERO (LGTERM,TYPINT(ITYPTR),MCTERM,AST,IST,RST,CST)        !utilite
*
*     Assemblage proprement dit de la partie triangulaire inferieure
*
      CALL DSMAMO (NMTERM,NVTERM,ITYPTR,NVDSMB,NMSTOK,NVSTOK
     &            ,'Ligne'  ,NBNERL)                                    !assembl
      NBNERC=NBNERL
*
*     Assemblage proprement dit de la partie triangulaire superieure
*
      IF (ITYSYM.EQ.NDFSYM) THEN
        CALL DSMAMO (NMTERM,NVTERM,ITYPTR,NVDSMB,NMSTOK,NVSTOK
     &               ,'Colonne',NBNERC)                                 !assembl
      ENDIF
*
*     Assemblage proprement dit de la diagonale
*
      CALL DSMADI (NMTERM,NVTERM,ITYPTR,NVDSMB)                         !assembl
      CALL TBTUER ('&WORK$',1)                                          !assembl
*  
*     Mise a jour des attributs du terme dans la structure $SDTRM  
*     Remarque: NBNERL,NBNERC sont comptes en d.l. puisque viennent
*               des numerotations en ligne de la structure. Ils sont
*               egaux aux nombres de lignes ou colonnes effectives
* 
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      ITYCAL= INTYKL ('ASSEMB')                                         !utilite
      NUKALE=-INDASS ('MULTI-INCONNUE')                                 !utilite
      INSTOK= INDSTO ('BIMORSE')                                        !utilite
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTERM,ITYPTR
     &            ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB,NUINRC,NVDURC
     &            ,NBNERC,NVNURC,NUINRL,NVDURL,NBNERL,NVNURL
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVREL)                  !sdexplo
*  
      IF (NIVREL.GT.0) CALL PRTERM (NMTERM,NVTERM,NIVREL,IMPSDR)        !prsd
*  
      CALL TBSAVE ( NMTERM ,NVTERM)
      CALL TBSAVE ( NMSTOK ,NVSTOK)
      CALL TBSAVE ('$DSMBL',NVDSMB)
*
      IF (NIVREL.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         IF (ITYSYM.EQ.0) THEN
            WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                          ,TYPINT(ITYPTR),STOIND(INSTOK)
         ELSE
            WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                          ,TYPINT(ITYPTR),STOIND(INSTOK)
     &                          ,SYMIND(ITYSYM)
         ENDIF
      ENDIF
*  
      CALL PRFXMJ (-1,'*DsmTrm*') 
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT (/T2,A8,' Assemblage multi-inconnue du terme ',A,:
     &,', ',A,', ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99981 CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
      CALL BAISE  ('Assemblage de '//THETR1(1:NCATR1)
     &//'. Estimation taille structure Bimorse Inf a revoir.'
     &//' Prevenir rapidement Daniel.Martin@univ-rennes1.fr')
99982 CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
      CALL BAISE  ('Assemblage de '//THETR1(1:NCATR1)
     &//'. Estimation taille structure Bimorse Sup a revoir.'
     &//' Prevenir rapidement Daniel.Martin@univ-rennes1.fr')
*     Erreurs detectees dans DSMRUC
99991 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Le terme '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' est un terme  multi-inconnue. Cas non prevu.')
99992 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Deux termes dont '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' ont le meme couple d''inconnues. Effectuer prealablement'
     &//' un assemblage uni-inconnue pour ces termes.')
99993 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL ERTERM (IRCODE+26,NMTERM,NVTERM)
99995 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Incompatibilite du stockage '
     &//' du terme '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' et l''ordre des inconnues.')
99996 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)
     &//' .Type de stockage non prevu du terme '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)//'.')
99997 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Cas d''une matrice PLEIN-L non prevu'
     &//' (il faudrait creer un compactage bi-morse).')
99998 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Cas d''une matrice PLEIN-C non prevu'
     &//' (il faudrait creer un compactage bi-morse).')
      END                                                               !Dsmtrm
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1.5 : D.Martin (9 septembre 2006)
*  Amelioration des Warnings
* Version 1.4 : D.Martin (8 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

