*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSVECT (NMTERM,NVTERM,TYTERM,NVDSMB,NBLIGN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : O.deBayser & D.Martin (Juin 1992)
* Derniere modification : D.Martin (21 Mars 2002)
* Version 1.0.1
*
* Report des vecteurs de la structure d'assemblage de niveau NVDSMB  
* dans le vecteur resultat multi-inconnue NMTERM,NVTERM
*
*-- Arguments d'entree --
* NMTERM nom du terme a assembler
* NVTERM son niveau
* TYTERM type (reel ou complexe) du terme a assembler
* NVDSMB niveau de la structure d'assemblage = numero du terme assemble
* NBLIGN nombre de coefficients du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM,TYTERM
      INTEGER       NVTERM,NVDSMB,NBLIGN
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      INTEGER    INTDON,INTTYP
      INTEGER    LGRIPP,INTENT,INTREL,INTCOM
     &          ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &          ,MCDSMB,LGETRD,NBLOCC,INCTRD,NBTRAS,NUTRAS,NUTERA,ADTERA
     &          ,NVTERA,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSSS
     &          ,NUINCC,NVDUMC,NBNEUC,NVNUMC,NUINCL,NVDUML,NBNEUL,NVNUML
     &          ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVITR
     &          ,MCDONN,ITYDON,NIVDON,ITYPDO,MCCSTE
     &          ,NVNUMR,MCNUMR,MCTERA,NBCOEF,MCTERM
      CHARACTER  ERCODE*120,NMTERA*16,TYPINT*4
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(105:105),NMTERA)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsVect*')
*
      INTENT= INTTYP ('ENTIER')                                         !utilite
      INTREL= INTTYP ('REEL')                                           !utilite
      INTCOM= INTTYP ('COMPLEXE')                                       !utilite
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM
     &                   ,'$DSMBL',NVDSMB,MCDSMB)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDSMB),LGETRD,NBLOCC,INCTRD,NBTRAS)             !sdexplo
*
      NBLIGN=0
      LGRIPP=LGETRD
      DO 10 NUTRAS=1,NBTRAS
         NUTERA=IST(MCDSMB+LGRIPP)
         NVNUMR=IST(MCDSMB+LGRIPP+4)
         ADTERA=MCDTRM+LGETRM+INCTRM*(NUTERA-1)
         CALL GETTRM (IST(ADTERA),NVTERA,ITYPTR,ITYCAL,NUKALE
     &               ,NUDONN,NVALNE,NVDSSS
     &               ,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &               ,NUINCL,NVDUML,NBNEUL,NVNUML
     &               ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVITR)               !sdexplo
*
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERA,NMTERA(1:NCHTRM))       !utilite
         CALL TBRR2  (ERCODE,'#GNEDO',NVNUMR,MCNUMR
     &                      , NMTERA(1:NCHTRM),NVTERA,MCTERA)
         CALL TBAR4  (ERCODE,'$DSMBL',NVDSMB,MCDSMB
     &                      , NMTERM ,NVTERM,MCTERM
     &                      ,'#GNEDO',NVNUMR,MCNUMR
     &                      , NMTERA(:NCHTRM),NVTERA,MCTERA)
         NBCOEF=IST(MCNUMR+1)
         MCCSTE=0
         IF (NUDONN.NE.NDFDON) THEN
            CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
            CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)       !sdexplo
            IF (ITYDON.EQ.INTDON ('CONSTANTE').AND.NIVDON.GT.0) THEN    !utilite
               IF (ITYPDO.EQ.INTREL) THEN
                  CALL TBAR1  (ERCODE,'$RCSTE',1,MCCSTE)
               ELSEIF (ITYPDO.EQ.INTCOM) THEN
                  CALL TBAR1  (ERCODE,'$CCSTE',1,MCCSTE)
               ELSEIF (ITYPDO.EQ.INTENT) THEN
                  CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
               ENDIF
               MCCSTE=MCCSTE+NIVDON
            ENDIF
         ENDIF
*
*        Remarque NBLIGN est compte en d.l. puisque vient de la numerotation
*        en ligne de la structure
         MCTERM=MCTERM+NBLIGN
         NBLIGN=NBLIGN+NBCOEF
         IF (MCCSTE.NE.0) THEN
            CALL TEQAT  (NBCOEF,TYPINT(ITYPTR),MCTERA    ,RST,CST
     &                         ,TYPINT(ITYPDO),MCCSTE,IST,RST,CST
     &                         ,TYTERM        ,MCTERM    ,RST,CST)      !utilite
         ELSE
            CALL TDANST (NBCOEF,TYPINT(ITYPTR),MCTERA,IST,RST,CST
     &                         ,TYTERM        ,MCTERM,IST,RST,CST)      !utilite
         ENDIF
         CALL TBSAVE  (NMTERA(:NCHTRM),NVTERA)
         IF (NUTRAS.LE.NBTRAS)
     &      CALL TBAR3(ERCODE,'$SDTRM',  1   ,MCDTRM,'#OMTRM',1,MCMTRM
     &                       ,'$DSMBL',NVDSMB,MCDSMB)
         
         LGRIPP=LGRIPP+INCTRD
10    CONTINUE
      CALL PRFXMJ (-1,'*DsVect*')
                                                                    END !DsVect
