*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSVRUC (NMTERM,NVTERM,NVASMB,ITYPTA,LGTRMR
     &                  ,IRCODE,NUCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1992)
* Derniere modification : D.Martin (1er Fevrier 2002)
* Version 1.0.2
*  
* Creation de la structure $DSMBL d'assemblage multi-inconnues d'un vecteur 
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme a assembler
* NVTERM niveau
* NVASMB niveau des structures $ASMBL et $DSMBL ou numero du terme assemble
* ITYPTA type de declaration du resultat
* LGTRMR majorant de la longueur du resultat
* IRCODE code d'erreur
* NUCODE numero du terme provoquant l'erreur
*-- Structure $DSMBL
* $DSMBL(1)=LGEDSM (=4) longueur de l'entete
*       (2)=1      nombre de termes en colonne
*       (3)=INCDSM (=5) nb. caracteristiques par terme de la structure
*       (4)=NBLOCL nombre de termes en ligne
* puis pour chaque terme de la structure . = LGEDSM+INCDSM*(NUTRAS-1)
*       (.) NUTERA numero du terme
*       (.+2) numero de l'inconnue en ligne du terme
*       (.+4) niveau de la numerotation en ligne du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NVASMB,ITYPTA,LGTRMR,IRCODE,NUCODE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INTTYP,KLNIVE
      INTEGER       LGASMB,MCDSAS,LGEASM,NBTRAS,INCASM,NBLOCL,NBLOCC
     &             ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCWOR0
     &             ,NVDSMB,LGDSMB,LGEDSM,INCDSM,MCSDDS,ADSDDS,INTCOM
     &             ,NUTERA,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM
     &             ,NVDSSS,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML
     &             ,NBNELI,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR
     &             ,MCDONN,ITYDON,NIVDON,ITYPDO,NUTRAS,NUTERB,K,INTERP
     &             ,MCCONU,NCPINC,NBCOEF,MCDUME,MCNUME,ADSDD2
     &             ,NUINCO,NVDUME,NBNOEU,NVNUME
      CHARACTER     ERCODE*120,LIOUCO*1
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsvRuc*')
      INTCOM=INTTYP ('COMPLEXE')                                        !utilite
*
      CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,LGASMB)
      CALL TBAR2  (ERCODE,'$ASMBL',NVASMB,MCDSAS,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDSAS),LGEASM,NBTRAS,INCASM,NBLOCL)             !utilite
*
*     Creation d'une structure $DSMBL' destinee a recevoir les attributs
*     du resultat "multi-inconnues".
*
      NVDSMB=NVASMB
      LGEDSM=4
      INCDSM=6
      CALL TBCREE ('&WORK$',0,1,INCDSM,'c')
      ERCODE(1:1)='!'  
      CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,LGDSMB)
      IF (ERCODE(1:1).EQ.'C') THEN  
*        Creation de la structure $DSMBL de niveau NVDSMB
         LGDSMB=LGEDSM+NBTRAS*INCDSM
         CALL TBCREE ('$DSMBL',NVDSMB,1,LGDSMB,'c')
      ELSE
*        Agrandissement eventuel de la structure $DSMBL
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMB,MCSDDS)
         CALL SDEXDB (IST(MCSDDS),LGEDSM,NBLOCC,INCDSM,NBLOCL)          !utilite
         CALL SDAJST ('$DSMBL',NVDSMB,LGDSMB,LGEDSM,INCDSM,NBLOCL
     &               ,NBTRAS-MAX (NBLOCL,0))                            !sdexplo
      ENDIF
*
*     Initialisation / Remplissage de la structure $DSMBL 
*     Type et longueur du terme multi-inconnues resultat
*
      LGTRMR=0
      CALL TBAR6  (ERCODE,'$DSMBL',NVDSMB,MCSDDS,'$ASMBL',NVASMB,MCDSAS
     &                   ,'$SDTRM',1,MCDTRM,'#NCONU',1,MCCONU
     &                   ,'$DONNE',1,MCDONN,'&WORK$',0,MCWOR0)
      CALL TAZERO (LGEDSM,'ENTIER',MCSDDS,AST,IST,RST,CST)              !utilite
*     Utilisation de la seconde moitie de '&WORK$'/0 pour stockage
*     des valeurs d'initialisation d'un bloc de structure '$DSMBL'
      IST(MCWOR0  )=0
      IST(MCWOR0+1)=NDFINC
      IST(MCWOR0+2)=NDFINC
      IST(MCWOR0+3)=NDFNUM
      IST(MCWOR0+4)=NDFNUM
      IST(MCWOR0+5)=0
      ADSDDS=MCSDDS+LGEDSM
      DO 5 NUTRAS=1,NBTRAS
         DO 3 K=0,INCDSM-1
            IST(ADSDDS+K)=IST(MCWOR0+K)
3        CONTINUE
         ADSDDS=ADSDDS+INCDSM
5     CONTINUE
*
      MCDSAS=MCDSAS+LGEASM
      ADSDDS=LGEDSM
      DO 10 NUTRAS=1,NBTRAS
         NUTERA=IST(MCDSAS)
         MCDSAS=MCDSAS+INCASM
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU,ITYPTR
     &               ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS,NUINCC,NVDUMC
     &               ,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML,INSTOK
     &               ,NVSTOK,NVCOOR,IATRDO,NIVTMR)                      !sdexplo
*
         NUINCO=NUINCL
         NVDUME=NVDUML
         NBNOEU=NBNELI
         NVNUME=NVNUML
         LIOUCO='L'
         IF (NUINCL.EQ.NDFINC) THEN
            NUINCO=NUINCC
            NVDUME=NVDUMC
            NBNOEU=NBNECO
            NVNUME=NVNUMC
            LIOUCO='C'
         ENDIF
         IF (NVDSSS.EQ.NDFDSM.AND.NUINCO.EQ.NDFINC) GOTO 99991
         ADSDD2=MCSDDS+LGEDSM
         DO 9 NUTERB=1,NUTRAS-1
*           Deux termes de la structure ne peuvent avoir la meme inconnue
            IF (NUINCO.EQ.IST(ADSDD2+2)) GOTO 99992
            ADSDD2=ADSDD2+INCDSM
9        CONTINUE
*
         IF (ITYPTA.NE.INTCOM) THEN
            IF (ITYPTR.EQ.INTCOM) ITYPTA=INTCOM
            IF (NUDONN.NE.NDFDON) THEN
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
               IF (ITYPDO.EQ.INTCOM) ITYPTA=INTCOM
            ENDIF
         ENDIF
*
         CALL SDEXCO (NUINCO,IST(MCCONU),NCPINC,INTERP,NBCOEF)          !utilite
         NBCOEF=NCPINC*NBNOEU
         IF (NCPINC.GT.1) THEN
*           Cas d'une inconnue vectorielle
            IF (NVDUME.EQ.NDFDUM) THEN
               NVDUME=KLNIVE ()                                         !sdexplo
               IF (LIOUCO.EQ.'L') THEN
                  NVDUML=NVDUME
               ELSE
                  NVDUMC=NVDUME
               ENDIF
               CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU
     &                     ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &                     ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML
     &                     ,NBNELI,NVNUML,INSTOK,NVSTOK,NVCOOR
     &                     ,IATRDO,NIVTMR)                              !sdexplo
            ENDIF
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,'#GNEDO',NVDUME,MCDUME)
            IF (ERCODE(1:1).NE.' ') THEN
               CALL TBCREE ('#GNEDO',NVDUME,1,2+NBCOEF,'c')
               CALL TBRR1  (ERCODE,'#GNEDO',NVNUME,MCNUME)
               CALL TBAR2  (ERCODE,'#GNEDO',NVNUME,MCNUME
     &                            ,'#GNEDO',NVDUME,MCDUME)
               CALL N2DLNU (NCPINC,IST(MCNUME+1),IST(MCNUME+2)
     &                            ,IST(MCDUME+1),IST(MCDUME+2))         !sdexplo
               IST(MCDUME)=IST(MCNUME)
               CALL TBSAVE ('#GNEDO',NVNUME)                     
            ENDIF
            CALL TBSAVE ('#GNEDO',NVDUME)
            NVNUME=NVDUME
         ENDIF
         LGTRMR=LGTRMR+NBCOEF
*
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMB,MCSDDS)
         ADSDD2=MCSDDS+ADSDDS
         IST(ADSDD2  )=NUTERA
         IST(ADSDD2+2)=NUINCO
         IST(ADSDD2+4)=NVNUME
         ADSDDS=ADSDDS+INCDSM
10    CONTINUE
*
*     Tri de la structure '$DSMBL' par numeros d'inconnues croissant
*
      CALL DSVTRI (IST(MCSDDS+LGEDSM),INCDSM,NBTRAS,IST(MCWOR0))        !assembl
      CALL SDMKDB (IST(MCSDDS),LGEDSM,1,INCDSM,NBTRAS)                  !utilite
      CALL TBTUER ('&WORK$',0)
*
      CALL TBSAVE ('$ASMBL',NVASMB)
*
      CALL PRFXMJ (-1,'*DsVruc*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 IRCODE=1
      NUCODE=NUTERA
      RETURN
99992 IRCODE=2
      NUCODE=NUTERA
      RETURN
                                                                    END !DsVruc
