*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSVTRM (NMTERM,NVTERM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (juin 1992)
* Derniere modification : D.Martin (19 mai 2005)
* Version 1.5
*  
* Assemblage multi-inconnue du terme vectoriel NMTERM de niveau NVTERM  
* selon ses structures d'assemblage $ASMBL (puis $DSMBL)
*  
*-- Arguments d'entree -- 
* NMTERM nom du vecteur resultat de l'assemblage
* NVTERM niveau du terme resultat de l'assemblage 
* NIVIMP niveau d'impression du terme
*        si l'assemblage a ete declaree par directive, le niveau d'impression
*        est celui declare par directive, ou sa valeur par defaut 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NIVIMP 
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER PRFXAS*8,TYPINT*9
      INTEGER   INDASS,INDSTO,INTYKL,KLTERM
      INTEGER   MCMTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM,IRCODE,NUCODE
     &         ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB,NUINRC
     &         ,NVDURC,NBNERC,NVNURC,NUINRL,NVDURL,NBNERL,NVNURL
     &         ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR
     &         ,NIVREL,LGTERM,MCTERM,MCDSMB,MCDTRM,NCATR1,NCATR2
      CHARACTER     ERCODE*120,THETR1*16
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DsVtrm*')
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINRC,NVDURC,NBNERC,NVNURC
     &            ,NUINRL,NVDURL,NBNERL,NVNURL
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVTMR)                  !sdexplo
*
*     Le niveau d'impression par directive est prioritaire s'il est non nul
      NIVREL=NIVIMP
      IF (NIVTMR.NE.0) NIVREL=NIVTMR
*
      IF (NVDSMB.EQ.NDFDSM) CALL ERTERM (13,NMTERM,NVTERM)              !utilite
*
      IF (NIVREL.GT.0.AND.IMPSDR.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         WRITE (IMPSDR,10000) PRFXAS(0),THETR1(1:NCATR1)
      ENDIF
*
*     Si la structure d'assemblage n'a pas ete remise a jour, on passe 
*     directement a l'assemblage des termes proprement dit
*
      IF (NUKALE.GE.0) THEN
         IRCODE=0
         CALL DSVRUC (NMTERM,NVTERM,NVDSMB,ITYPTR,LGTERM,IRCODE,NUCODE) !assembl
         GOTO (99991,99992) IRCODE
      ELSE
         CALL TBRR2  (ERCODE,'$DSMBL',NVDSMB,MCDSMB
     &                        ,NMTERM,NVTERM,LGTERM)
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
      ENDIF
*
*     Creation et remplissage du terme resultat 
*
      IF (NIVREL.GT.0)
     &   CALL PRSDDS (NVDSMB,NMTERM,NVTERM,NIVREL,IMPSDR)               !prsd
      CALL TBCREE (NMTERM,NVTERM,ITYPTR,LGTERM,'c')
*
*     Mise a zero du terme avant assemblage
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
      CALL TAZERO (LGTERM,TYPINT(ITYPTR),MCTERM,AST,IST,RST,CST)        !utilite
*
      CALL DSVECT (NMTERM,NVTERM,TYPINT(ITYPTR),NVDSMB,NBNERL)          !assembl
*  
*     Mise a jour des attributs du terme dans la structure $SDTRM 
*     Remarque: NBNERL est compte en d.l. puisque vient de la numerotation 
*               en ligne de la structure.Il egale le nombre de lignes effectif
*  
      ITYCAL= INTYKL ('ASSEMB')
      NUKALE=-INDASS ('MULTI-INCONNUE')
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &            ,NVTERM,ITYPTR,ITYCAL,NUKALE,NDFDON,NDFSYM,NVDSMB
     &            ,NDFINC,NDFDUM,1,NDFNUM,NUINRL,NVDURL,NBNERL,NVNURL
     &            ,INDSTO ('PLEIN-L'),NDFSTO,NDFCOR,IATRDO,NIVREL)      !sdexplo
*  
      IF (NIVREL.GT.0) CALL PRTERM (NMTERM,NVTERM,NIVREL,IMPSDR)        !prsd
      CALL TBSAVE ( NMTERM ,NVTERM)
      CALL TBSAVE ('$DSMBL',NVDSMB)
*
      IF (NIVREL.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
         WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                       ,TYPINT(ITYPTR)
      ENDIF
*  
      CALL PRFXMJ (-1,'*DsVtrm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Assemblage multi-inconnue du terme ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Le terme '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' n''existe pas ou est un terme multi-inconnue.')
99992 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL PRNTRN (NUCODE,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Assemblage multi-inconnue du terme '
     &//ERCODE(1:NCATR1)//'. Deux termes dont '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)//' ont la meme inconnue.')
                                                                    END !DsVtrm
