*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INTERM (NMTERM,NVTERM,KLADRS,NMDONN)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1995) 
* Derniere modification : D.Martin (15 Octobre 2001)
* Version 1.0.1
*  
* Introduction de la valeur d'une donnee dans un terme a une adresse
* relative donnee
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme
* NVTERM niveau du terme
* KLADRS adresse contenant le coefficient a modifier
* NMDONN nom de la donnee constante
*
* Remarque : -- Le terme a initialiser doit exister car on ne peut creer
*               ses attributs a partir de rien
*            -- Aucune coherence entre les types du terme et la constante
*               n'est verifiee, par exemple si la constante est complexe
*               et le terme reel, il sera initialiser par la partie reelle
*               de la constante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NVTERM,KLADRS
      CHARACTER*(*) NMTERM,NMDONN 
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       INTDON,KELCHN,KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,LGTERM,ITTERM,MCTERM
     &             ,MCMDON,MCDONN,LGEDON,NBDONN,INCDON,NCHDON,NUDONN
     &             ,ITYDON,NIVDON,ITYPDO,MCCSTE
      CHARACTER*4   TYPINT,TYTERM,TYDONN
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(113:113),TYTERM),(ERCODE(105:105),TYDONN) 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*InTerm*')
*  
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*     Recherche des caracteristiques du terme
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
      CALL TBTYPE (NMTERM,NVTERM,ITTERM)
      TYTERM=TYPINT (ITTERM)                                            !utilite
*
      CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
*     Recherche du numero  et des caracteristiques de la constante
*
      NUDONN=NDFDON
      IF (NMDONN(1:1).NE.' ')  THEN
         NUDONN=KELCHN (NMDONN,AST(MCMDON),NBDONN,NCHDON)               !sdexplo
         IF (NUDONN.LE.0) CALL ERDONN (1,NMDONN)                        !utilite
      ENDIF
      TYDONN=' '
      IF (NUDONN.NE.NDFDON) THEN
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !sdexplo
         IF (ITYDON.NE.INTDON ('CONSTANTE')) CALL ERDONN (2,NMDONN)     !utilite
         TYDONN=TYPINT (ITYPDO)                                         !utilite
      ENDIF
*
*     Initialisation effective du terme
*
      IF (TYDONN(1:1).EQ.'R') THEN
         CALL TBAR2  (ERCODE,'$RCSTE',1,MCCSTE,NMTERM,NVTERM,MCTERM)
      ELSEIF (TYDONN(1:1).EQ.'C') THEN 
         CALL TBAR2  (ERCODE,'$CCSTE',1,MCCSTE,NMTERM,NVTERM,MCTERM)
      ELSEIF (TYDONN(1:1).EQ.'E') THEN
         CALL TBAR2  (ERCODE,'$ECSTE',1,MCCSTE,NMTERM,NVTERM,MCTERM)
      ENDIF
*
      IF (KLADRS.LE.0.OR.KLADRS.GT.LGTERM) GOTO 99990
      IF (NUDONN.NE.NDFDON) THEN
         CALL TINPUT (KLADRS,IST(MCCSTE+NIVDON),RST(MCCSTE+NIVDON)
     &                  ,CST(MCCSTE+NIVDON),TYTERM,MCTERM,IST,RST,CST)  !utilite
      ELSE
         CALL TINPUT (KLADRS,0,0.,(0.,0.),TYTERM,MCTERM,IST,RST,CST)    !utilite
      ENDIF
*
      CALL TBSAVE (NMTERM,NVTERM)
      CALL PRFXMJ (-1,'*InTerm*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 WRITE (IMPPAL,*) ' Adresse relative :',KLADRS,' pour un terme de '
     &,'longueur ',LGTERM
      CALL ERTERM (7,NMTERM,NVTERM)
                                                                    END !InTerm
