*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PJTERM (COMP,NMTRM1,NVTRM1,NOMDOM,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin, O.DeBayser (Mai 1995)
* Derniere modification : D.Martin (9 Avril 2002)
* Version 1.0.1
*  
* Creation d'un terme projection normale ou tangentielle d'un terme a inconnue
* vectorielle sur un domaine : (T.n)n ou n^(T^n)=T-(T.n).n
*  
*-- Arguments d'entree --
* COMP 'n' (pour projection normale), 't' (pour projection tangentielle 2D)
* NMTRM1,NVTRM1 Nom et niveau du terme d'entree vectoriel
* NOMDOM nom du domaine geometrique ou l'on calcule le terme
* NMTRM2,NVTRM2 Nom et niveau du terme resultat scalaire
* NIVIMP Niveau d'impression du terme resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) COMP,NMTRM1,NOMDOM,NMTRM2
      INTEGER       NVTRM1,NVTRM2,NIVIMP
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER    INDSTO,KLTERM
      CHARACTER  TYPINT*4,LOWERC*1
      INTEGER    MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM,NIVEAU
     &          ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB,NUINCC,NVDUMC
     &          ,NBNEUC,NVNUMC,NUINCL,NVDUML,NBNEUL,NVNUML
     &          ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR
     &          ,MCMDOM,MCTRDO,LGERDO,NBDOMK,INCRDO,NCHDOM
     &          ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ,INDEXC,IDLHRC,INTRPC
     &          ,NBNECX,NBNEXC,NBDLXC,NBNFXC,NBDFXC,INDEXL,IDLHRL
     &          ,INTRPL,NBNELX,NBNEXL,NBDLXL,NBNFXL,NBDFXL,NVNORM
     &          ,INUTIL,NBTRDO,NIVIMS,MCNORM,ADNORM,ADTRM2
     &          ,MCMINC,MCINCO,LGEINC,NBINCO,INCINC,NCHINC
     &          ,NCPINC,INTERP,NBTNE1,NCATR1,LGTRM1,MCTRM1,MCTRM2,IAD
      LOGICAL    CRETRM
      REAL       KR1
      COMPLEX    KC1
      CHARACTER  ERCODE*120,UCOMP*1,TYTRM1*4
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PjTerm*')
*
      UCOMP=LOWERC (COMP)                                               !utilite
      CALL TBAR6  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDOM',1,MCMDOM,'$TERDO',1,MCTRDO
     &                   ,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !utilite
      CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)             !utilite
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Numero du domaine geometrique de nom NOMDOM
*
      CALL KLDOMN (NOMDOM,0,-1,IST(MCTRDO),AST(MCMDOM),NBDOMG
     &            ,NUDOMG,IATRDO)                                       !sdexplo
      IATRDO=MCTRDO+IATRDO
      CALL GETDOM (IST(IATRDO)  ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,INDEXC,IDLHRC,INTRPC
     &            ,NBNECX,NBNEXC,NBDLXC,NBNFXC,NBDFXC,NVNUMC
     &            ,INDEXL,IDLHRL,INTRPL
     &            ,NBNELX,NBNEXL,NBDLXL,NBNFXL,NBDFXL,NVNUML
     &            ,NVNORM,INUTIL,NBTRDO,NIVIMS)                         !sdexplo
      IF (NUDOMG.LE.0) CALL ERDOMA (1,NOMDOM)                           !utilite
*
*     Recherche des caracteristiques du 1er terme
*
      NUTERM=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &            ,NUINCL,NVDUML,NBNEUL,NVNUML
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR)                  !sdexplo
      IF (NUINCL.EQ.NDFINC) THEN
         NUINCL=NUINCC
         NBNEUL=NBNEUC
         NVNUML=NVNUMC
      ENDIF
*
*     Nom de l'inconnue affectee au terme et attributs
*
      CALL SDEXCO (NUINCL,IST(MCINCO),NCPINC,INTERP,NBTNE1)             !utilite
      IF (NCPINC.LE.1) CALL ERINCO (3,ERCODE(119-NCHINC:118))           !utilite
      IF (INTERP.NE.INTRPC) GOTO 99991
      IF (NVALNE.LE.1) CALL ERTERM (32,NMTRM1,NVTRM1)                   !utilite
*
      TYTRM1=TYPINT (ITYPTR)                                            !utilite
      ERCODE(1:1)='!'
      CALL TBRR2  (ERCODE,NMTRM1,NVTRM1,LGTRM1,'&NORMA',NVNORM,MCNORM)
      IF (ERCODE(2:2).EQ.'C') CALL ERDOMA (4,NOMDOM)                    !utilite
*
*     Creation (si necessaire) du 2eme terme
*
      CRETRM=.FALSE.
      INSTOK=INDSTO ('PLEIN-L')
      NVALNE=NCPINC
      CALL CRTERM (NMTRM2,NVTRM2,LGTRM1       ,ITYPTR,ITYCAL,NUKALE
     &            ,NDFDON,NVALNE,NVDSMB,NDFINC,NDFDUM,1     ,NDFNUM
     &            ,NUINCL,NDFDUM,NBNEUL,NVNUML,INSTOK,NDFSTO,NVCOOR
     &            ,IATRDO,NIVIMP,.FALSE.,CRETRM)                        !sdexplo
*
      CALL TBAR3  (ERCODE, NMTRM1 ,NVTRM1,MCTRM1,NMTRM2,NVTRM2,MCTRM2
     &                   ,'&NORMA',NVNORM,MCNORM)
      ADTRM2 = MCTRM2
      ADNORM = MCNORM
*
*     Calcul de la projection normale (T.n)n
*
      IF (TYTRM1.EQ.'REEL') THEN
         DO 122 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
            KR1=    RST(IAD)  *RST(ADNORM)
            KR1=KR1+RST(IAD+1)*RST(ADNORM+1)
            IF (NDIM.GT.2) KR1=KR1+RST(IAD+2)*RST(ADNORM+2)
            RST(ADTRM2)  =KR1*RST(ADNORM)
            RST(ADTRM2+1)=KR1*RST(ADNORM+1)
            IF (NCPINC.GT.2) RST(ADTRM2+2)=KR1*RST(ADNORM+2)
            ADNORM = ADNORM+NDIM
            ADTRM2 = ADTRM2+NCPINC
122      CONTINUE
      ELSEIF (TYTRM1(1:4).EQ.'COMP') THEN
         DO 144 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
            KC1=    CST(IAD)  *RST(ADNORM)
            KC1=KC1+CST(IAD+1)*RST(ADNORM+1)
            IF (NDIM.GT.2) KC1=KC1+CST(IAD+2)*RST(ADNORM+2)
            CST(ADTRM2)  =KC1*RST(ADNORM)
            CST(ADTRM2+1)=KC1*RST(ADNORM+1)
            IF (NCPINC.GT.2) CST(ADTRM2+2)=KC1*RST(ADNORM+2)
            ADNORM = ADNORM+NDIM
            ADTRM2 = ADTRM2+NCPINC
144      CONTINUE
      ENDIF
*
      IF (UCOMP.EQ.'t') THEN
*
*        Calcul de la projection tangentielle  T-(T.n)n
*
         ADTRM2 = MCTRM2
         IF (TYTRM1.EQ.'REEL') THEN
            DO 222 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               RST(ADTRM2)=RST(IAD)-RST(ADTRM2)
               RST(ADTRM2+1)=RST(IAD+1)-RST(ADTRM2+1)
               IF (NCPINC.GT.2) RST(ADTRM2+2)=RST(IAD+2)-RST(ADTRM2+2)
               ADTRM2 = ADTRM2+NCPINC
222         CONTINUE
         ELSEIF (TYTRM1(1:4).EQ.'COMP') THEN
            DO 244 IAD = MCTRM1,MCTRM1+LGTRM1-1,NCPINC
               CST(ADTRM2)=CST(IAD)-CST(ADTRM2)
               CST(ADTRM2+1)=CST(IAD+1)-CST(ADTRM2+1)
               IF (NCPINC.GT.2) CST(ADTRM2+2)=CST(IAD+2)-CST(ADTRM2+2)
               ADTRM2 = ADTRM2+NCPINC
244         CONTINUE
         ENDIF

      ENDIF
*
      CALL TBSAVE ( NMTRM2 ,NVTRM2)
      CALL TBSAVE ( NMTRM1 ,NVTRM1)
      CALL TBSAVE ('&NORMA',NVNORM)
      CALL PRFXMJ (-1,'*PjTerm*')
      RETURN  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE(1:16),NCATR1)
      ERCODE(NCATR1+1:NCATR1+NCHDOM)=NOMDOM
      CALL BAISE ('Incoherence entre l''interpolation de l''inconnue'
     &//ERCODE(119-NCHINC:118)//' associee au terme '//ERCODE(1:NCATR1)
     &//' et l''interpolation en colonne des normales sur le domaine '
     &//ERCODE(NCATR1+1:NCATR1+NCHDOM)//'.')
                                                                    END !PjTerm
