*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRTERM (NMTRM1,NVTRM1,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1993)
* Derniere modification : D.Martin (6 Juin 2000)
* Version 1.0.1
*
* Calcul de la transposee d'une matrice
*
* La matrice est actuellement necessairement stockee sous forme 'BiMorse',
* 'Morse-L', Morse-C', 'Plein-L' ou Plein-C'.
*
*-- Arguments d'entree --
* NMTRM1 nom de la matrice dont on calcule la transposee
* NVTRM1 son niveau
* NMTRM2 nom de la matrice transposee
* NVTRM2 son niveau
* NIVIMP son niveau d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTRM1,NMTRM2
      INTEGER       NVTRM1,NVTRM2,NIVIMP
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'
*
      INTEGER       INDSTO,INDSYM,INTYKL,KLNIVE,KLTERM
      CHARACTER     TYPINT*4
      INTEGER       INDSML,INDSMC,INDSPL,INDSPC,LGMTRM,MCMTRM
     &             ,LGDTRM,MCDTRM,MCINCO,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NUTERM,IADTRM,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &             ,ITYSYM,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM
     &             ,NVDULM,NBNELM,NVNULM,INDSTA,NVSTOA,NVCOMA,IATRDO
     &             ,NIVIMA,INSTOK,NVSTOK,LGTRM1,LGSTOK,MCSTOK,NBL,NBPLAL
     &             ,MCPLAL,MCPLIL,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU
     &             ,MCWTOK,MCWTOU,MCTRM1,MCTRM2,LGDIAG,NWHTRM
     &             ,NCATR1,NCATR2
      CHARACTER     ERCODE*120,TYPTRM*4,NMSTOA*6,NMSTOK*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*TrTerm*')
*
      INDSML=INDSTO ('MORSE-L')                                         !utilite
      INDSMC=INDSTO ('MORSE-C')                                         !utilite
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
      INDSPC=INDSTO ('PLEIN-C')                                         !utilite
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      IF (NMTRM2.EQ.NMTRM1.AND.NVTRM2.EQ.NVTRM1)
     &   CALL ERTERM (9,NMTRM1,NVTRM1)                                  !utilite
*
*--   Recherche des caracteristiques de la matrice
*
      NUTERM=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM
     &            ,NVDULM,NBNELM,NVNULM,INDSTA,NVSTOA
     &            ,NVCOMA,IATRDO,NIVIMA)                                !sdexplo
      TYPTRM=TYPINT (ITYPTR)                                            !utilite
      IF (NUINCM.LE.0.OR.NUINLM.LE.0) CALL ERTERM (10,NMTRM1,NVTRM1)    !utilite
      INSTOK=INDSTA
      NVSTOK=NVSTOA
      IF (INDSTA.EQ.INDSTO ('BIMORSE'))     THEN
         NMSTOA='&BMORS'
         NMSTOK='&BMORS'
      ELSEIF (INDSTA.EQ.INDSPL) THEN
         INSTOK=INDSPC
         NMSTOA='PLEINL'
         NVSTOK=0
      ELSEIF (INDSTA.EQ.INDSPC) THEN
         INSTOK=INDSPL
         NMSTOA='PLEINC'
         NVSTOK=0
      ELSEIF (INDSTA.EQ.INDSML) THEN
         INSTOK=INDSMC
         NMSTOA='&PLAGE'
         NMSTOK='&EGALP'
      ELSEIF (INDSTA.EQ.INDSMC) THEN
         INSTOK=INDSML
         NMSTOA='&EGALP'
         NMSTOK='&PLAGE'
      ELSE
         CALL ERTERM (18,NMTRM1,NVTRM1)                                 !utilite
      ENDIF
      CALL TBRR1  (ERCODE,NMTRM1,NVTRM1,LGTRM1)
*
*     Creation de la matrice transposee
      CALL TBCREE (NMTRM2,NVTRM2,ITYPTR,LGTRM1,'c')
*
      IF (NMSTOA(1:4).EQ.'&BMO') THEN
*
         IF (ITYSYM.EQ.INDSYM (' ')) THEN                               !utilite
            CALL TBRR1  (ERCODE,NMSTOA,NVSTOA,LGSTOK)
            CALL TBAR1  (ERCODE,NMSTOA,NVSTOA,MCSTOK)
            CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                   ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU) !sdexplo
            MCWTOK=MCSTOK
            IF (IST(MCSTOK).NE.2) THEN
*
*              Matrice non symetrique en structure :
*              transposition de la structure de pointeurs BiMorse
*
               NVSTOK=KLNIVE ()                                         !sdexplo
               CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
               CALL TBAR4  (ERCODE,NMTRM1,NVTRM1,MCTRM1
     &                            ,NMTRM2,NVTRM2,MCTRM2
     &                            ,NMSTOA,NVSTOA,MCSTOK
     &                            ,NMSTOK,NVSTOK,MCWTOK)
               IST(MCWTOK+1)=NBC
               CALL TDANST (NBC+2*NBPLAU,'E',MCPLAU  ,IST,RST,CST
     &                                  ,'E',MCWTOK+2,IST,RST,CST)      !utilite
               MCWTOU=MCWTOK+1+NBC+2*NBPLAU
               IST(MCWTOK)=MCWTOU
               IST(MCWTOU)=NBL
               CALL TDANST (NBL+2*NBPLAL,'E',MCPLAL  ,IST,RST,CST
     &                                  ,'E',MCWTOU+1,IST,RST,CST)      !utilite
               CALL TBSAVE (NMSTOK,NVSTOK)
            ENDIF
            IF (NVSTOK.NE.NVSTOA) CALL TBSAVE (NMSTOA,NVSTOA)
*
*           Calcul de la transposee
*
            LGDIAG=MIN (NBL,NBC)
            CALL TDANST (LGDIAG,TYPTRM,MCTRM1,IST,RST,CST
     &                         ,TYPTRM,MCTRM2,IST,RST,CST)              !utilite
            CALL TDANST (LGU,TYPTRM,MCTRM1+LGDIAG+LGL,IST,RST,CST
     &                      ,TYPTRM,MCTRM2+LGDIAG    ,IST,RST,CST)      !utilite
            CALL TDANST (LGL,TYPTRM,MCTRM1+LGDIAG    ,IST,RST,CST
     &                      ,TYPTRM,MCTRM2+LGDIAG+LGU,IST,RST,CST)      !utilite
*
         ELSE
*           Matrice symetrique en structure possedant une propriete
*           de symetrie, antisymetrie, autoadjointe ou antiadjointe
            CALL TBAR2  (ERCODE,NMTRM1,NVTRM1,MCTRM1
     &                         ,NMTRM2,NVTRM2,MCTRM2)
            CALL TDANST (LGTRM1,TYPTRM,MCTRM1,IST,RST,CST
     &                         ,TYPTRM,MCTRM2,IST,RST,CST)              !utilite
*
         ENDIF
      ELSEIF (NMSTOA(1:4).EQ.'&PLA'.OR.NMSTOA(1:4).EQ.'&EGA') THEN
*
*        La matrice compactee en ligne est equivalente a sa transposee
*        en colonne et lycee de Versailles.
         CALL TBRR1  (ERCODE,NMSTOA,NVSTOA,LGSTOK)
         NVSTOK=KLNIVE ()                                               !sdexplo
         CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
         CALL TBAR4  (ERCODE,NMTRM1,NVTRM1,MCTRM1,NMTRM2,NVTRM2,MCTRM2
     &                      ,NMSTOA,NVSTOA,MCSTOK,NMSTOK,NVSTOK,MCWTOK)
         CALL TDANST (LGSTOK,'E',MCSTOK,IST,RST,CST
     &                      ,'E',MCWTOK,IST,RST,CST)                    !utilite
         CALL TDANST (LGTRM1,TYPTRM,MCTRM1,IST,RST,CST
     &                      ,TYPTRM,MCTRM2,IST,RST,CST)                 !utilite
         CALL TBSAVE (NMSTOK,NVSTOK)
         CALL TBSAVE (NMSTOA,NVSTOA)
      ELSEIF (NMSTOA(1:5).EQ.'PLEIN') THEN
*
*        La matrice pleine en ligne est equivalente a sa transposee
*        en colonne et lycee de Versailles.
         CALL TBAR2  (ERCODE,NMTRM1,NVTRM1,MCTRM1,NMTRM2,NVTRM2,MCTRM2)
         CALL TDANST (LGTRM1,TYPTRM,MCTRM1,IST,RST,CST
     &                      ,TYPTRM,MCTRM2,IST,RST,CST)                 !utilite
      ENDIF
*
*     Mise a jour des structures de description pour la matrice resultat
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      NUTERM=KLTERM (NMTRM2,NVTRM2,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN
         CALL ALFANU (NBCHNT,NMTRM2)                                    !utilite
         NWHTRM=MAX (NCHTRM,LEN (NMTRM2))
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTRM2)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERM=NBTERM
      ENDIF
      ITYCAL=INTYKL ('ASSEMB')                                          !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL PUTTRM (IST(IADTRM)  ,NVTRM2,ITYPTR,ITYCAL,NUKALE,NDFDON
     &            ,ITYSYM,NDFDSM,NUINLM,NVDULM,NBNELM,NVNULM,NUINCM
     &            ,NVDUCM,NBNECM,NVNUCM,INSTOK,NVSTOK,NDFCOR,0,NIVIMP)  !sdexplo
      CALL TBSAVE (NMTRM1,NVTRM1)
      CALL TBSAVE (NMTRM2,NVTRM2)
*--
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTRM2,NVTRM2,ERCODE,NCATR1)
         CALL PRNTRM (NMTRM1,NVTRM1,ERCODE(NCATR1+1:),NCATR2)
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &                       ,ERCODE(NCATR1+1:NCATR1+NCATR2)
      ENDIF
      CALL PRFXMJ (-1,'*TrTerm*')  
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*TrTerm* Calcul du terme ',A,' transpose de ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (10 novembre 2009)
* bug NMSTOA(1:5).EQ.'PLEIN-L' -> NMSTOA(1:5).EQ.'PLEIN'
* Version 1.0.1 : D.Martin (6 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !TrTerm
