*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASNORM (ISGDET,NDIM,NBNEF,RGNOEU,NORMAL,NORMAD)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1989)
* Derniere modification : D.Martin (12 Novembre 1999)
* Version 1.0.0
*  
* Assemblage des vecteurs normaux en tous les noeuds d'un domaine  
*  
*-- Arguments --  
* ISGDET signe du determinant jacobien dans l'element courant 
* NDIM   dimension d'espace
* NBNEF  nombre de noeuds de la face ou arete en cours
* RGNOEU tableau des rangs des noeuds de la face dans le domaine  
* NORMAL tableau des normales sur la face ou arete
* NORMAD tableau des normales assemblees sur le domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER ISGDET,NDIM,NBNEF,RGNOEU(*)
      REAL    NORMAL(NDIM,*),NORMAD(NDIM,*)
*
      INTEGER NEEL,NOEUD,IDIM
*------------------------------------------------------------------------
      IF (ISGDET.GT.0) THEN
*        L'element est oriente dans le sens direct 
         DO 2 NEEL=1,NBNEF
            NOEUD=RGNOEU(NEEL)
            DO 1 IDIM=1,NDIM
               NORMAD(IDIM,NOEUD)=NORMAD(IDIM,NOEUD)+NORMAL(IDIM,NEEL)
1           CONTINUE
2        CONTINUE
      ELSE
*        L'element est oriente dans le sens retrograde
         DO 4 NEEL=1,NBNEF
            NOEUD=RGNOEU(NEEL)
            DO 3 IDIM=1,NDIM
               NORMAD(IDIM,NOEUD)=NORMAD(IDIM,NOEUD)-NORMAL(IDIM,NEEL)
3           CONTINUE
4        CONTINUE
      ENDIF
                                                                    END !Asnorm
