*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CALNOR (NDMDOM,NDMDOE,NUDOG ,NUDOK ,NCHDOM,NBELDO
     &                  ,NXLIST,IRPLOC,LIOUCO,INTERP,NBNEFX,NBNEUG
     &                  ,NVNORM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (Novembre 1988)  
* Derniere modification : D.Martin (13 Juillet 1997)
* Version 1.0.0
*  
* Calculs des normales aux noeuds sur un domaine pour un interpolation donnee 
*  
*-- Arguments --  
* NDMDOM dimension du domaine  
* NUDOG  numero du domaine geometrique 
* NUDOK  numero du domaine de calcul
* NCHDOM nombre de caracteres par nom de domaine
* NBELDO nombre d'elements du domaine  
* NXLIST pointeur dans #ISTEL pour le 1er element 
* IRPLOC indicateur de calcul des normales sur le domaine 
* LIOUCO chaine de caracteres indiquant 'Ligne' ou 'Colonne' 
* INTERP niveau de l'interpolation en ligne ou colonne selon LIOUCO 
* NBNEFX nombre maximum de noeuds pour l'interpolation sur une face
*         de dimension NDMDOM d'un element du domaine
* NBNEUG nombre de noeuds sur le domaine selon l'interpolation INTERP
* NVNORM niveau du tableau &NORMA construit sur le domaine  
* NIVIMP niveau d'impression du domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIOUCO
      INTEGER       NDMDOM,NDMDOE,NUDOG,NUDOK,NCHDOM,NBELDO,NXLIST
     &             ,IRPLOC,INTERP,NBNEFX,NBNEUG,NVNORM,NIVIMP
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      CHARACTER     PRFXAF*8
      INTEGER       MCNORM,MCGOCO,MCCORL,MCREPR,MCDLCG,MCDFCG,MCBLOK
     &             ,MCMDOM,MCLIST,MCCORP,MCWORK,MCRPLC,MCNONO
     &             ,LISRAN,NUTGAV,NUFAAV,NIVAMP,ELEMEN,LAG,KCL
     &             ,NUTGEO,NUELEM,NUTYFG,NBNEEC,NBDLEC,NUFACE,NUTYFC
     &             ,NBNEFC,NBDLFC,NUTELC,NBNEEG,NBDLEG,NBNEFG,NBDLFG
     &             ,NUTYLG,NUTEAV,NBNEUL,NIVBMP
      REAL          NORME
      CHARACTER     ERCODE*120 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CalNor*')
*
      CALL ENCLER (NUDOK,ERCODE(1:2))                                   !Utilite
      ERCODE(1:1)='!'
      CALL TBRR1  (ERCODE,'&NORMA',NVNORM,MCNORM)
      IF (ERCODE(1:1).EQ.'C'.OR.MCNORM.LT.NDIM*NBNEUG)
     &   CALL TBCREE ('&NORMA',NVNORM,2,NDIM*NBNEUG,'c')
*
      CALL TBRR1  (ERCODE,'#RGNDO',NUDOK ,MCGOCO)
*
*     Calcul des adresses relatives des tableaux de calcul des normales
*
*     Tableau des coordonnees locales (Elt.Ref) long. NDMDOM*NBNEFX
      MCCORL=0
*     Tableau des reperes locaux aux noeuds long. IRPLOC*NDIM*NBNEFX
      MCRPLC=MCCORL+NDMDOM*NBNEFX
*     Repere local en un noeud (tableau de travail) long. NDIM*NDIM
      MCREPR=MCRPLC+IRPLOC*NDIM*NBNEFX
*     Tableau pour NUNEFA,NUDLFA long. MAX(NBNEFX,NBPTFX)
      MCDLCG=MCREPR+NDIM*NDIM
*     Tableau des derivees des fonction de base long. NDMDOM*NBPTFX
      MCDFCG=MCDLCG+MAX(NBNEFX,NBPTFX)
*  
      CALL TBCREE ('$WORK$',0,2,MCDFCG+NDMDOM*NBPTFX,'c')
*
      MCBLOK=1
      IF (NBBBLK.GE.2) CALL TBAR1  (ERCODE,'#LOKEL',1,MCBLOK)
      CALL TBAR6  (ERCODE,'#OMDOM',  1   ,MCMDOM,'#RGNDO',NUDOK ,MCGOCO 
     &                   ,'#ISTEL',NUDOG ,MCLIST,'#ORPTL',NUDOK ,MCCORP
     &                   ,'$WORK$',  0   ,MCWORK,'&NORMA',NVNORM,MCNORM)
      CALL TAZERO (NDIM*NBNEUG,'R',MCNORM,AST,IST,RST,CST)              !Utilite
      IF (LIOUCO(1:1).NE.'C') THEN
         MCGOCO=MCGOCO+IST(MCGOCO)-1
      ELSE
         MCGOCO=MCGOCO+1
      ENDIF
      MCCORL=MCWORK+MCCORL 
      MCRPLC=MCWORK+MCRPLC 
      MCREPR=MCWORK+MCREPR 
      MCDLCG=MCWORK+MCDLCG 
      MCDFCG=MCWORK+MCDFCG 
      LISRAN=0 
      NUTGAV=0
      NUTEAV=0 
      NUFAAV=0 
      NIVAMP=NIVIMP
*
      DO 100 ELEMEN=1,NBELDO
         NBNEUL=IST(MCGOCO)
         NIVIMP=0  
         IF (ELEMEN.EQ.1.OR.ELEMEN.EQ.NBELDO) NIVIMP=NIVAMP
         NIVBMP=NIVIMP
         IF (INTERP.NE.INTRPG) NIVBMP=0
         IF (NIVIMP.GT.0) WRITE (IMPSDR,10000) PRFXAF( ),ELEMEN
*  
*        Exploitation de la structure #ISTEL et recherche des donnees  
*        geometriques et pour l'interpolation
*
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,IST(MCLIST+NXLIST)
     &               ,IST(MCBLOK),NUTGEO,INTRPG,NUELEM,NUTGAV,NUTYLG
     &               ,LAG,KCL,NBNEEG,NBDLEG,NUFACE,NUFAAV,NUTYFG
     &               ,NBNEFG,NBDLFG,IST(MCDLCG),IST(MCDLCG)
     &               ,NIVBMP,IMPSDR)                                    !Sdexplo
         IF (INTERP.EQ.INTRPG) THEN 
            NUTYFC=NUTYFG
            NBNEFC=NBNEFG
         ELSE
            CALL EXSTEW (NDMDOM,INTERP,NUTGEO,NUELEM,NUTEAV,NUTELC
     &                  ,LAG,KCL,NBNEEC,NBDLEC,NUFACE,NUFAAV,NUTYFC
     &                  ,NBNEFC,NBDLFC,IST(MCDLCG),IST(MCDLCG)
     &                  ,NIVIMP,IMPSDR)                                 !Sdexplo
         ENDIF
*
*        Coordonnees des noeuds de l'element de reference pour l'interpolation
*
         CALL ELEMCO (NUTYFC,NDMDOM,RST(MCCORL))                        !Ef?d
*
*        Calcul des normales sur le domaine aux noeuds
*
         CALL REPLOC (NDIM,NUTYFG,NBDLFG,RST(MCCORP+2)   
     &               ,NBNEFC,RST(MCCORL),RST(MCDFCG),IRPLOC
     &               ,RST(MCRPLC),RST(MCREPR),NIVIMP,IMPSDR)            !Calelem
*
*        Assemblage des normales
*
         CALL ASNORM (IST(MCCORP+1),NDIM,NBNEUL,IST(MCGOCO+1)
     &               ,RST(MCRPLC),RST(MCNORM))                          !Calgeo
*
         NUTGAV=NUTGEO 
         NUTEAV=NUTELC
         NUFAAV=NUFACE
         MCCORP=MCCORP+2+IST(MCCORP)*NDIM  
         MCGOCO=MCGOCO+NBNEUL+1
100   CONTINUE
*
*     Normalisation des vecteurs normaux assembles sur le domaine
*
      MCNONO=MCNORM
      DO 200 NBNEUL=1,NBNEUG
         CALL NORMIZ (NDIM,RST(MCNONO),NORME)                           !Utilite
         MCNONO=MCNONO+NDIM
200   CONTINUE
*
*     Impression et sauvegarde du tableau des normales
*
      IF (NIVIMP.GT.0) THEN
         MCMDOM=MCMDOM+NCHDOM*(NUDOG-1)
         WRITE (IMPSDR,10003) PRFXAF()
     &                       ,(AST(KCL),KCL=MCMDOM,MCMDOM+NCHDOM-1)
         CALL PRCOOR (NDIM,NBNEUG,RST(MCNORM),' Normal',NIVIMP,IMPSDR)  !PrSd
      ENDIF
      IF (NIVIMP.GE.0) WRITE (IMPPAL,10001) PRFXAF(),NVNORM 

*
      CALL TBSAVE ('&NORMA',NVNORM)
      CALL TBTUER ('$WORK$',0)
      CALL PRFXMJ (-1,'*CalNor*') 
*----------------------------------------------------------------------- 
10000 FORMAT(/T2,A8,T30,'Calculs geometriques dans l''element',I6 
     &/T30,36('-')) 
10001 FORMAT(T5,A8,' Normales assemblees, tableau &NORMA de niveau'
     &,I4) 
10003 FORMAT(/T2,A8,' Vecteurs normaux normalises sur le domaine : '
     &,50A1)
                                                                    END !CalNor
