*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUDLDO (NDMDOM,NDMDOE,NBELDO,INDEX,INTERP,BLOKEL
     &                  ,LISTEL,NBNEEX,NGNEEL,NUNEFA,NUDLFA,NEDUDL
     &                  ,IRGDLN,NDLINN,NBNELC,NGNELC,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988)
* Derniere modification : D.Martin (1 Decembre 1999)
*  
* Prise en compte des d.l. Hermite de la numerotation globale en colonne 
* ou en ligne des noeuds d'un domaine.
*  
*-- Arguments d'entree -- 
* NDMDOM dimension (des constituants) du domaine geometrique
* NDMDOE dimension des elements supports des constituants du domaine geometrique
* NBELDO nombre d'elements ou de couples (element,face ou arete) du domaine
* INDEX  indice d'extension d'une des numerotations en colonne ou ligne
* INTERP indice de l'interpolation en colonne (resp. ligne)
* BLOKEL tableau des numeros de type des elements du maillage par blocs
* LISTEL tableau des numeros d'elements du domaine si NDIM=NDMDOM , sinon
*          tableau des couples (No d'element,No de face ou d'arete) du domaine
* NBNEEX nombre maximum de noeuds des elements pour l'interpolation
* NGNEEL numerotation globale des noeuds du maillage par element
* NIVIMP,IMPFCH quincaillerie habituelle
*
*-- Arguments de sortie --
* NGNELC tableau contenant la numerotation des noeuds du domaine  
*         et le numero dans le domaine du premier d.l. de chaque noeud
*
*-- Tableaux de travail -- (inutilises pour leur contenu a l'exterieur)
* NUNEFA correspondance entre la numerotation locale sur la face ou l'arete
*          et la numerotation locale dans l'element pour les noeuds
* NUDLFA idem pour les d.l. l'element geometrique 
* NEDUDL numero du noeud supportant un d.l.
* IRGDLN indice de rang local de d.l. (d.l. Hermite)
* NDLINN nombre de d.l. (internes) portes par le noeud
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDMDOM,NDMDOE,NBELDO,INDEX,INTERP,NBNEEX,NBNELC
     &             ,NIVIMP,IMPFCH
      INTEGER       BLOKEL(*),LISTEL(*),NUNEFA(*),NUDLFA(*)
     &             ,NEDUDL(*),IRGDLN(*),NDLINN(*)  
     &             ,NGNEEL(NBNEEX,*),NGNELC(*) 
*
      INTEGER       ELEMEN,NUELEM,NUTEAV,NUFAAV,LISRAN,NUTGEO,NUTELT
     &             ,NUFACE,NUTYFA,NBNEEL,NBDLEL,NBNEFA,NBDLFA,LAGHER
     &             ,KCLASS,NOEUEL,NOELOC,NBNOEU,NOGLOB,NBDLLC,NB
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Nudldo*')
*
      NUTEAV=0 
      NUFAAV=0 
      LISRAN=0 
      DO 2 ELEMEN=1,NBELDO  
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,LISTEL,BLOKEL,NUTGEO,INTERP
     &               ,NUELEM,NUTEAV,NUTELT,LAGHER,KCLASS,NBNEEL,NBDLEL
     &               ,NUFACE,NUFAAV,NUTYFA,NBNEFA,NBDLFA,NUNEFA,NUDLFA
     &               ,NIVIMP,IMPFCH)                                    !SDexplo
         NBNOEU=NBNEFA
         IF (INDEX.GE.1) THEN
            NUTYFA=NUTELT  
            NBNOEU=NBNEEL  
            NUFACE=0  
         ENDIF
         CALL ELEMDL (NUTYFA,NEDUDL,IRGDLN,NDLINN)                      !Ef?d
         DO 1 NOELOC=1,NBNOEU 
            NOEUEL=NOELOC 
            IF (INDEX.EQ.0.AND.NUFACE.NE.0) NOEUEL=NUNEFA(NOELOC) 
            NOGLOB=NGNEEL(NOEUEL,NUELEM) 
*           Tout d'abord NGNELC(NBNELC+.) est le nb. de d.l. intra-element
            NGNELC(NBNELC+NOGLOB+1)=NDLINN(NOEUEL)
1        CONTINUE
         NUTEAV=NUTELT
         NUFAAV=NUFACE
2     CONTINUE 
*     Ensuite NGNELC(NBNELC+1+NOELOC) est le No du 1er d.l.intra-elementaire  
      NBDLLC=NGNELC(NBNELC+2)  
      NGNELC(NBNELC+2)=1
      DO 3 NOELOC=NBNELC+3,2*NBNELC+1 
         NB=NGNELC(NOELOC)
         NGNELC(NOELOC)=NBDLLC+1  
         NBDLLC=NBDLLC+NB 
3     CONTINUE 
      NGNELC(NBNELC+1)=NBDLLC  
      CALL PRFXMJ (-1,'*Nudldo*')  
                                                                    END !Nudldo
