*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUMNIV (NXDODO,NXDOD1,INCRDO,NUDOK,INTRPC,INDEXC,INTRPL
     &                  ,INDEXL,NVNUMC,NVNUML,NUCC,NUCL,NULC,NULL
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1997)
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*  
* Recherche des niveaux des tableaux de numerotation (#GNEDO) pour des
* domaines geometriques portant plusieurs domaines de calcul.
* (Il s'agit de ne pas creer de numerotation identique sous des numeros
* differents.)
*  
*-- Arguments d'entree --  
* NXDODO adresse relative dans $TERDO du domaine de calcul courant
* NXDOD1 adresse relative dans $TERDO du premier domaine de calcul porte par
*        le domaine de calcul courant
* INCRDO increment de parcours de la structure #TERDO
* INTRPC numero de type de l'interpolation en colonne du domaine courant
* INDEXC indice d'extension du domaine courant pour l'interpolation en colonne
* INTRPL numero de type de l'interpolation en ligne du domaine courant
* INDEXL indice d'extension du domaine courant pour l'interpolation en ligne
*-- Arguments de sortie --
* NVNUMC niveau de la structure de numerotation #GNEDO pour l'interpolation
*        en colonne pour le domaine de calcul courant
* NVNUML niveau de la structure de numerotation #GNEDO pour l'interpolation
*        en ligne pour le domaine de calcul courant
* NUCC   numero du domaine de calcul dont la numerotation en colonne est la meme
*        que la numerotation en colonne du domaine courant (=0 sinon)
* NUCL   numero du domaine de calcul dont la numerotation en ligne est la meme
*        que la numerotation en colonne du domaine courant (=0 sinon)
* NULC   numero du domaine de calcul dont la numerotation en colonne est la meme
*        que la numerotation en ligne du domaine courant (=0 sinon)
* NULL   numero du domaine de calcul dont la numerotation en ligne est la meme
*        que la numerotation en ligne du domaine courant (=0 sinon)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NXDODO,NXDOD1,INCRDO,NUDOK
     &             ,INTRPC,INDEXC,INTRPL,INDEXL,NIVIMP,IMPFCH
     &             ,NVNUMC,NVNUML,NUCC,NUCL,NULC,NULL
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
      INTEGER       MCTRDO,MCTRD1,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &             ,JNDEXC,IDLHRC,JNTRPC,NBNECX,NBNEXC,NBDLXC,NBNFXC
     &             ,NBDFXC,JVNUMC,JNDEXL,IDLHRL,JNTRPL,NBNELX,NBNEXL
     &             ,NBDLXL,NBNFXL,NBDFXL,JVNUML,INUTI1,INUTI2,NBTRDO
     &             ,NIVDOM
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*NumNiv*')
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)              
      MCTRD1=MCTRDO+NXDOD1
      MCTRDO=MCTRDO+NXDODO
      NUCC=0
      NUCL=0
      NULC=0
      NULL=0
*
1     CALL GETDOM (IST(MCTRD1)  ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,JNDEXC,IDLHRC,JNTRPC,NBNECX,NBNEXC,NBDLXC
     &            ,NBNFXC,NBDFXC,JVNUMC
     &            ,JNDEXL,IDLHRL,JNTRPL,NBNELX,NBNEXL,NBDLXL
     &            ,NBNFXL,NBDFXL,JVNUML
     &            ,INUTI1,INUTI2,NBTRDO,NIVDOM)                         !sdexplo
      IF (NVNUMC.EQ.NDFNUM) THEN
         IF (INTRPC.EQ.JNTRPC.AND.INDEXC.EQ.JNDEXC) THEN
            NVNUMC=JVNUMC
            NUCC=NUDOMK
         ELSEIF (INTRPC.EQ.JNTRPL.AND.INDEXC.EQ.JNDEXL) THEN
            NVNUMC=JVNUML
            NUCL=NUDOMK
         ENDIF
      ENDIF
      IF (NVNUML.EQ.NDFNUM) THEN
         IF (INTRPL.EQ.JNTRPL.AND.INDEXL.EQ.JNDEXL) THEN
            NVNUML=JVNUML
            NULL=NUDOMK
         ELSEIF (INTRPL.EQ.JNTRPC.AND.INDEXL.EQ.JNDEXC) THEN
            NVNUML=JVNUMC
            NULC=NUDOMK
         ENDIF
      ENDIF
      MCTRD1=MCTRD1+INCRDO+NBTRDO
      IF (MCTRD1.GE.MCTRDO.OR.
     &   (NVNUMC.NE.NDFNUM.AND.NVNUML.NE.NDFNUM)) THEN
         IF (IMPFCH.GT.0.AND.NIVIMP.GT.0) THEN
            WRITE (IMPFCH,10000) NUDOK,NVNUMC,NVNUML
            IF (NUCC.GT.0) WRITE (IMPFCH,10001) 'colonne','colonne',NUCC
            IF (NUCL.GT.0) WRITE (IMPFCH,10001) 'colonne','ligne  ',NUCL
            IF (NULC.GT.0) WRITE (IMPFCH,10001) 'ligne  ','colonne',NULC
            IF (NULL.GT.0) WRITE (IMPFCH,10001) 'ligne  ','ligne  ',NULL
         ENDIF
      ELSE
         GOTO 1
      ENDIF
      CALL PRFXMJ (-1,'*NumNiv*')
*-----------------------------------------------------------------------
10000 FORMAT (T2,'<NumNiv> '
     &,'Numerotations des noeuds du domaine de calcul ',I3
     &, ' : en colonne =',I6,', en ligne =',I6 )
10001 FORMAT (T11,'Numerotation en ',A7,' identique a celle en ',A7
     &,' du domaine ',I3)
                                                                    END !NumNiv
