*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUNEDO (NUDOK,NDMDOM,NDMDOE,NBELDO,INDEX,INTERP,BLOKEL
     &                  ,LISTEL,NBNEEX,NGNEEL,MAXNGN,NUNEFA,NUDLFA
     &                  ,NBNELC,NGNELC,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (1 Decembre 1999)
*  
* Creation de la numerotation globale en colonne ou en ligne des noeuds  
* d'un domaine.  
*  
*-- Arguments d'entree -- 
* NUDOK  numero du domaine de calcul  
* NDMDOM dimension (des constituants) du domaine geometrique
* NDMDOE dimension des elements supports des constituants du domaine geometrique
* NBELDO nombre d'elements ou de couples (element,face ou arete) du domaine
* INDEX  indice d'extension d'une des numerotations en colonne ou ligne
* INTERP indice de l'interpolation en colonne (resp. ligne)
* BLOKEL tableau des numeros de type des elements du maillage par blocs . 
* LISTEL tableau des numeros d'elements du domaine si NDIM=NDMDOM , sinon 
*          tableau des couples (No d'element,No de face ou d'arete) du domaine 
* NBNEEX nombre maximum de noeuds des elements pour l'interpolation
* NGNEEL numerotation globale des noeuds du maillage par element .
* MAXNGN taille declaree du tableau de numerotation globale du domaine .  
* IMPFCH numero d'unite logique du fichier d'impression
*-- Arguments de sortie --
* NBNELC nombre de noeuds en colonne (resp. en ligne) 
* NGNELC tableau contenant la numerotation des noeuds du domaine  
*          et le numero dans le domaine du premier d.l. de chaque noeud
*-- Tableaux de travail -- (inutilises pour leur contenu a l'exterieur)
* NUNEFA correspondance entre la numerotation locale sur la face ou l'arete
*          et la numerotation locale dans l'element pour les noeuds
* NUDLFA idem pour les d.l. l'element geometrique 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUDOK,NDMDOM,NDMDOE,NBELDO,INDEX,INTERP,NBNEEX,MAXNGN
     &       ,NBNELC,NIVIMP,IMPFCH
      INTEGER BLOKEL(*),LISTEL(*),NUNEFA(*),NUDLFA(*)
     &       ,NGNEEL(NBNEEX,*),NGNELC(*)
*
      INTEGER ELEMEN,NUTEAV,NUFAAV,LISRAN,NUTGEO,NUELEM,NUTELT,NBNOEU
     &       ,LAGHER,KCLASS,NBNEEL,NBDLEL,NUFACE,NUTYFA,NBNEFA,NBDLFA
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Nunedo*')
*  
*     Creation de la numerotation globale des noeuds du domaine en lignes  
*     ou en colonnes (Tableau NGNELC)  
*  
      NUTEAV=0 
      NUFAAV=0 
      LISRAN=0 
*  
      DO 1 ELEMEN=1,NBELDO  
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,LISTEL,BLOKEL,NUTGEO,INTERP
     &               ,NUELEM,NUTEAV,NUTELT,LAGHER,KCLASS,NBNEEL,NBDLEL
     &               ,NUFACE,NUFAAV,NUTYFA,NBNEFA,NBDLFA,NUNEFA,NUDLFA
     &               ,NIVIMP,IMPFCH)                                    !Sdexplo
         NBNOEU=NBNEFA
         IF (INDEX.GE.1) THEN
*           On etend sur tout l'element ...
            NBNOEU=NBNEEL
            NUFACE=0
         ENDIF
         CALL LISUNI (NBNELC,NGNELC,NBNOEU,NGNEEL(1,NUELEM)
     &               ,INDEX.EQ.0.AND.NUFACE.NE.0,NUNEFA,.FALSE.
     &               ,MAXNGN,*9999)                                     !Utilite
         NUTEAV=NUTELT
         NUFAAV=NUFACE
1     CONTINUE
* 
      CALL PRFXMJ (-1,'*Nunedo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
9999  WRITE(*,10000) MAXNGN,NUDOK,ELEMEN
10000 FORMAT(/' *Nunedo*  Taille maximum ',I9,' atteinte pour le tableau
     & #GNEDO, niveau',I4,/,T13,'dans l''element numero',I4) 
      CALL BAISE  (' En rentrant de LisUni .....')                      !Utilite
                                                                    END !Nunedo
