*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRNOMD (NOMDOM,NCHDOM,NUDOK,NDMDOM,NBELDO,NBTRDO
     &                  ,IGEOME,NUSCHQ,INTRPG,INTRPC,INTRPL
     &                  ,NIVDOM,IMPPAL,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)  
* Derniere modification : D.Martin (4 Octobre 2001)
* Version 1.0.4
*  
* Impression d'un nom et des caracteristiques d'un domaine de calcul  
*  
*-- Arguments --  
* NOMDOM nom du domaine
* NCHDOM nombre de caracteres par nom de domaine  
* NUDOK  numero du domaine de calcul
* NDMDOM dimension du domaine  
* NBELDO nombre de constituants du domaine 
* NBTRDO nombre de termes sur le domaine
* INTRPG numero de l'interpolation geometrique 
* INTRPC numero de l'interpolation en colonne sur le domaine
* INTRPL numero de l'interpolation en ligne sur le domaine
* NUSCHQ numero de la formule de quadrature pour les calculs 'EF' sur le domaine
* NIVDOM niveau d'impression sur le domaine
* SPNAME nom du sous-programme appele
* IMPPAL numero d'unite logique du fichier d'impression principal  
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      CHARACTER NOMDOM(*)
      INTEGER   NCHDOM,NUDOK,NDMDOM,NBELDO,NBTRDO,IGEOME,NUSCHQ,INTRPG
     &         ,INTRPC,INTRPL,NIVDOM,IMPPAL,IMPFCH
*
      INTEGER   DEGQUA,I,J,DEGQUX
      CHARACTER PRFXAS*8
*-----------------------------------------------------------------------
      IF (NBTRDO.LE.0.AND.IGEOME.LE.0) RETURN
*
      CALL PRFXMJ (1,'*PrNomd*')
*
      DO 1 J=NCHDOM,1,-1
         IF (NOMDOM(J).NE.' ') GOTO 2
1     CONTINUE
2     WRITE (IMPPAL,10010) PRFXAS(1),NUDOK,(NOMDOM(I),I=1,J)
      IF (NUSCHQ.NE.-99999.AND.NBTRDO.GT.0) THEN
         DEGQUX=DEGQUA (NUSCHQ,1000*NDMDOM)
         WRITE (IMPPAL,10011) NUSCHQ,DEGQUX
      ENDIF
*
      IF (NIVDOM.GT.0) THEN
*  
         WRITE (IMPFCH,*)
         WRITE (IMPFCH,10000) PRFXAS(1),NUDOK,(NOMDOM(I),I=1,J)
         IF (NUSCHQ.NE.-99999) WRITE (IMPFCH,10011) NUSCHQ,DEGQUX
         WRITE (IMPFCH,10001) ('=',I=0,J+1) 
         WRITE (IMPFCH,10002) NDMDOM,NBELDO,NBTRDO  
         IF (INTRPC.EQ.INTRPL.AND.NDMDOM.GT.0) THEN 
            IF (INTRPC.EQ.INTRPG) THEN  
              WRITE (IMPFCH,10003) 'isoparametrique en colonne et ligne'
            ELSE
              WRITE (IMPFCH,10003) 'en colonne et ligne',INTRPC
            ENDIF 
         ELSEIF (NDMDOM.GT.0) THEN
            WRITE (IMPFCH,10003) 'en colonne',INTRPC,'en ligne',INTRPL  
         ENDIF
*
      ENDIF
      CALL PRFXMJ (-1,'*PrNomd*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'* ',A8,' ',98('*'),/T2,'Domaine de calcul #',I3
     &,', Domaine geometrique : ',50A1)
10010 FORMAT(/T2,A8,' Domaine de calcul #',I3
     &,', Domaine geometrique : ',50A1)
10011 FORMAT(T10,'(Formule de quadrature numero',I3,', degre',I3,')')
10001 FORMAT(T2,60('='),50A1)  
10002 FORMAT(/' Dimension du domaine (NDMDOM) ',I2
     &,' - Nombre d''elements :',I5,' - Nombre de termes :',I3)  
10003 FORMAT(' Interpolation ',2(A:,' :',I3:,'   '))  
                                                                    END !PrNomd
