*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RGNEDO (NUDOK ,NDMDOM,NDMDOE,NBELDO,INDEX ,INTERP
     &                  ,BLOKEL,LISTEL,NBNEEX,NGNEEL,NUNEFA,NUDLFA
     &                  ,NBNELC,NGNELC,IRGNLC,LGINGO,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (1 Decembre 1999)
*  
* Creer la correspondance entre les noeuds locaux et la numerotation 
* globale des noeuds d'un domaine : Rangs des noeuds dans un domaine 
*  
*-- Arguments d'entree -- 
* NUDOK  numero du domaine de calcul 
* NDMDOM dimension (des constituants) du domaine geometrique
* NDMDOE dimension des elements supports des constituants du domaine geometrique
* NBELDO nombre d'elements ou de couples (element,face ou arete) du domaine
* INDEX  indice d'extension d'une des numerotations en colonne ou ligne
* INTERP indice de l'interpolation en colonne (resp. ligne)
* BLOKEL tableau des numeros de type des elements du maillage par blocs . 
* LISTEL tableau des numeros d'elements du domaine si NDIM=NDMDOM , sinon 
*        tableau des couples (No d'element,No de face ou d'arete) du domaine 
* NBNEEX nombre maximum de noeuds des elements pour l'interpolation
* NGNEEL numerotation globale des noeuds du maillage par element .
* NBNELC nombre de noeuds en colonne (resp. en ligne) 
* NGNELC tableau contenant la numerotation des noeuds du domaine  
* NIVIMP,IMPFCH : quincaillerie habituelle
*
*-- Arguments de sortie --
* IRGNLC tableau des indices d'occurrence des noeuds du domaine . 
* LGINGO longueur du tableau IRGNLC
*  
*-- Tableaux de travail -- (inutilises pour leur contenu a l'exterieur)
* NUNEFA correspondance entre la numerotation locale sur la face ou l'arete
*          et la numerotation locale dans l'element pour les noeuds
* NUDLFA idem pour les d.l. l'element geometrique 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NUDOK ,NDMDOM,NDMDOE,NBELDO,INDEX ,INTERP,NBNEEX
     &             ,NBNELC,LGINGO,NIVIMP,IMPFCH
      INTEGER       BLOKEL(*),LISTEL(*),NUNEFA(*),NUDLFA(*)
     &             ,NGNEEL(NBNEEX,*),NGNELC(*),IRGNLC(*)
*
      INTEGER       ELEMEN,NUTEAV,NUFAAV,LISRAN,LGINGX,NUTGEO,NUTELT
     &             ,NUFACE,NUTYFA,NBNEFA,NBDLFA,NBNEEL,NBDLEL,NBNOEU
     &             ,LAGHER,KCLASS,NUELEM,NOEUEL,NOELOC,NEGLOB,RANGNE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Rgnedo*')
*  
      NUTEAV=0 
      NUFAAV=0 
      LISRAN=0 
      LGINGX=LGINGO
      LGINGO=1 
      DO 1 ELEMEN=1,NBELDO  
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,LISTEL,BLOKEL,NUTGEO,INTERP
     &               ,NUELEM,NUTEAV,NUTELT,LAGHER,KCLASS,NBNEEL,NBDLEL
     &               ,NUFACE,NUFAAV,NUTYFA,NBNEFA,NBDLFA,NUNEFA,NUDLFA
     &               ,NIVIMP,IMPFCH)                                    !Sdexplo
         NBNOEU=NBNEFA
         IF (INDEX.GE.1) THEN
*           On etend sur tout l'element ...
            NBNOEU=NBNEEL  
            NUFACE=0  
         ENDIF
         IF (LGINGX.LT.LGINGO+NBNOEU+1) GOTO 9999
         IRGNLC(LGINGO)=NBNOEU
         DO 2 NOELOC=1,NBNOEU 
            NOEUEL=NOELOC 
            IF (INDEX.EQ.0.AND.NUFACE.NE.0) NOEUEL=NUNEFA(NOELOC) 
            NEGLOB=NGNEEL(NOEUEL,NUELEM) 
*  
*           Recherche dichotomique du rang du noeud NOELOC dans la numerotation
*           des noeuds du domaine (tableau NGNELC) .
*  
            CALL DICOTO (1,NBNELC,NGNELC,NEGLOB,RANGNE,*9998)           !Utilite
            IRGNLC(LGINGO+NOELOC)=RANGNE 
2        CONTINUE 
         LGINGO=LGINGO+NBNOEU+1
         NUTEAV=NUTELT
         NUFAAV=NUFACE
1     CONTINUE
      CALL PRFXMJ (-1,'*Rgnedo*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
9998  CALL BAISE  (' La recherche par dichotomie a echoue')             !Utilite
9999  WRITE(*,10000) LGINGX,NUDOK,ELEMEN
10000 FORMAT(/' *RgNeDo* Taille maximum',I9,' atteinte pour le tableau 
     *#RGNDO, niveau',I4/T13,'dans l''element',I5) 
      CALL BAISE  ('?????????????????????????????????????????????????') !Utilite
                                                                    END !RgNedo
