*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CALCOP (NDIM,NBTRDO,INDTRD,POIN,NBFPRO
     &                  ,MCMATR,MCMATC,NUTRDO,NUDONN,NCHDON,NOMDON
     &                  ,NODONA,NOMFCT,IST,RST,CST,COFVAR,COFVAC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 2002)
* Derniere modification : D.Martin (10 novembre 2002)
* Version 1.0.0
*
* Calcul d'un coefficent variable dans une integrale Elements Finis Localises
* par integration numerique
*
*-- Arguments (voir aussi Calinb) --
* NDIM   dimension d'espace
* NBTRDO nombre de termes a calculer sur le domaine (pour parcourir INDTRD)
* INDTRD structure locale de description des termes du domaine
*   Contenu du tableau INDTRD pour le terme numero NUTRDO
*   (NUTRDO)           niveau, puis adresse absolue du terme dans RST,CST
*   (NUTRDO+ 2*NBTRDO) adresses relatives des tableaux locaux de valeurs  
*                      nodales dans le tableau des matrices elementaires
*   (NUTRDO+16*NBTRDO) adresse du tableau associe au terme ou
*                      de la constante ou du tableau associe a la fonction
*   (NUTRDO+17*NBTRDO) type (CONSTANTE ou TABLEAU) associe a la fonction
*   (NUTRDO+18*NBTRDO) type du resultat (REEL, COMPLEXE) associe a la fonction
*   (NUTRDO+19*NBTRDO) nombre de composantes par noeud pour une donnee
*                      associee de type TABLEAU
* POIN   tableau de travail contenant les coordonnees de l'image du point
*        de quadrature dans l'element courant, suivi le cas echeant de la norme
*        et des composantes du vecteur normal (NON UNITAIRE)
* NBFPRO nombre de fonctions dans le developpement de l'inconnue spectrale
* MCMATR adresse du tableau des matrices elementaires reelles
* MCMATC adresse du tableau des matirces elementaires complexes
* NUTRDO numero du terme sur le domaine de calcul courant(pour parcourir INDTRD)
* NUDONN numero de donnee affectee au terme courant
* NCHDON nombre de caracteres par nom de donnee
* NOMDON tableau #OMDON des noms de donnees
* NODONA chaine de caractere receptrice d'un nom de donnee
* NOMFCT chaine de caractere receptrice d'un nom de fonction
* IST    super-tableau entier 
* RST    super-tableau reel
* CST    super-tableau complexe
* COFVAR tableau recepteur du coefficient variable dans le cas REEL
* COFVAC tableau recepteur du coefficient variable dans le cas COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NODONA,NOMFCT 
      CHARACTER     NOMDON(*)
      INTEGER NDIM,NBTRDO,INDTRD(*),NBFPRO,MCMATR,MCMATC
     &       ,NUTRDO,NUDONN,NCHDON,IMPFCH,IST(*)
      REAL    POIN(*),RST(*),COFVAR(*)
      COMPLEX CST(*),COFVAC(*)
*
      CHARACTER DONINT*9,TYPINT*12
      INTEGER   INTDON,ITYDON,NIVDON,ITYPDO,ITYRAS,ITYASS,MCASSO,NVALNE
     &         ,MCATAB,I
*-----------------------------------------------------------------------
*     Renseignements pour la donnee de type 'Fonction' affectee
*      
*     Type de donnee
      ITYDON=INDTRD(NUTRDO+13*NBTRDO)
      IF (ITYDON.NE.INTDON ('FONCTION')) CALL ERINTG (101,1)
*
*     Numero de donnee associee
      NIVDON=INDTRD(NUTRDO+14*NBTRDO)
*
*     Type de declaration de la donnee
      ITYPDO=INDTRD(NUTRDO+15*NBTRDO)
*
*     Nom et attributs de la donnee fonction affectee
      CALL GETCHN (NOMDON,NCHDON,NUDONN,NOMFCT)                         !utilite
*
*     Donnee TABLEAU associee a la donnee fonction ?
*     Nom de la donnee associee
      CALL GETCHN (NOMDON,NCHDON,NIVDON,NODONA)                         !utilite
*
*     Adresse de la donnee 'Tableau' associee a la donnee 'Fonction'
      MCASSO=INDTRD(NUTRDO+16*NBTRDO)
*
*     Type ('Tableau') de la donnee associee
      ITYRAS=INDTRD(NUTRDO+17*NBTRDO)
      IF (ITYRAS.LE.INTDON ('FONCTION')) CALL ERINTG (102,1)
*
*     Type de declaration de de la donnee associee
      ITYASS=INDTRD(NUTRDO+18*NBTRDO)
*
*     Calcul des fonctions propres au point de quadrature
*
      CALL FCTPRO  (NDIM,POIN,NBFPRO,NOMFCT,TYPINT(ITYPDO),NODONA 
     &             ,TYPINT(ITYASS),MCASSO,IST,RST,CST,COFVAR,COFVAC)
*
                                                                    END !CalCop
