*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CALCOV (NDIM,NBTRDO,INDTRD,POIN,NBC,WC,MCMATR,MCMATC
     &                  ,NUTRDO,TYPE,NUDONN,NCHDON,NOMDON,NODONA              
     &                  ,NOMFCT,IST,RST,CST,COFVAR,COFVAC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 2002)
* Derniere modification : D.Martin (10 novembre 2002)
* Version 1.0.0
*
* Calcul d'un coefficent variable dans une integrale Elements Finis
*
*-- Arguments (voir aussi Calin*) --
* NDIM   dimension d'espace
* NBTRDO nombre de termes a calculer sur le domaine (pour parcourir INDTRD)
* INDTRD structure locale de description des termes du domaine
*   Contenu du tableau INDTRD pour le terme numero NUTRDO
*   (NUTRDO)           niveau, puis adresse absolue du terme dans RST,CST
*   (NUTRDO+ 2*NBTRDO) adresses relatives des tableaux locaux de valeurs  
*                      nodales dans le tableau des matrices elementaires
*   (NUTRDO+16*NBTRDO) adresse du tableau associe au terme ou
*                      de la constante ou du tableau associe a la fonction
*   (NUTRDO+17*NBTRDO) type (CONSTANTE ou TABLEAU) associe a la fonction
*   (NUTRDO+18*NBTRDO) type du resultat (REEL, COMPLEXE) associe a la fonction
*   (NUTRDO+19*NBTRDO) nombre de composantes par noeud pour une donnee
*                      associee de type TABLEAU
* POIN   tableau de travail contenant les coordonnees de l'image du point
*        de quadrature dans l'element courant, suivi le cas echeant de la norme
*        et des composantes du vecteur normal (NON UNITAIRE)
* NBC nombre de d.l. (de la face ou arete) de l'element en colonne
* WC  valeurs des fonctions de base pour l'interpolation en colonne
* MCMATR adresse du tableau des matrices elementaires reelles
* MCMATC adresse du tableau des matirces elementaires complexes
* NUTRDO numero du terme sur le domaine de calcul courant(pour parcourir INDTRD)
* TYPE   type REEL ou COMPLEXE du terme courant
* NUDONN numero de donnee affectee au terme courant
* NCHDON nombre de caracteres par nom de donnee
* NOMDON tableau #OMDON des noms de donnees
* NODONA chaine de caractere receptrice d'un nom de donnee
* NOMFCT chaine de caractere receptrice d'un nom de fonction
* IST    super-tableau entier 
* RST    super-tableau reel
* CST    super-tableau complexe
* COFVAR tableau recepteur du coefficient variable dans le cas REEL
* COFVAC tableau recepteur du coefficient variable dans le cas COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NODONA,NOMFCT,TYPE  
      CHARACTER     NOMDON(*)
      INTEGER NDIM,NBTRDO,INDTRD(*),NBC,MCMATR,MCMATC
     &       ,NUTRDO,NUDONN,NCHDON,IMPFCH,IST(*)
      REAL    POIN(*),WC(*),RST(*),COFVAR(*)
      COMPLEX CST(*),COFVAC(*)
*
      CHARACTER DONINT*9,TYPINT*12
      INTEGER   INTDON,ITYDON,NIVDON,ITYPDO,ITYRAS,ITYASS,MCASSO,NVALNE
     &         ,MCATAB,I
*-----------------------------------------------------------------------
*     Renseignements pour la donnee affectee au terme courant
*
*     Type de donnee ('Fonction' ou 'Tableau')
      ITYDON=INDTRD(NUTRDO+13*NBTRDO)
*     Numero de donnee associee pour une donnee de type 'Fonction'
*     Niveau du tableau pour une donnee de type 'Tableau'
      NIVDON=INDTRD(NUTRDO+14*NBTRDO)
*     Type de declaration de la donnee affectee
      ITYPDO=INDTRD(NUTRDO+15*NBTRDO)

      IF (ITYDON.EQ.INTDON ('FONCTION')) THEN
*
*        Nom et attributs de la donnee fonction affectee
*
         CALL GETCHN (NOMDON,NCHDON,NUDONN,NODONA)                      !utilite
         ITYRAS=0
         ITYASS=1
         MCASSO=1
         NOMFCT=NODONA
*        Coefficient variable donne par sous-programme (FCTRM)
*        Y-a-t'il une donnee associee a la donnee fonction ?
         IF (NIVDON.GT.0) THEN
*           Nom de la donnee associee
            CALL GETCHN (NOMDON,NCHDON,NIVDON,NODONA)                   !utilite
*           Adresse de la donnee associee a la donnee fonction
            MCASSO=INDTRD(NUTRDO+16*NBTRDO)
*           Type ('Constante' ou 'Tableau') de la donnee associee
            ITYRAS=INDTRD(NUTRDO+17*NBTRDO)
*           Type de declaration de de la donnee associee
            ITYASS=INDTRD(NUTRDO+18*NBTRDO)
         ENDIF
*
*        Calcul du coefficient variable pour l'integrand
*
         CALL FCTRM  (NDIM,POIN,NOMFCT,TYPINT(ITYPDO),NODONA 
     &               ,DONINT(ITYRAS),TYPINT(ITYASS),MCASSO
     &               ,IST,RST,CST,COFVAR,COFVAC)
*
      ELSEIF (ITYDON.EQ.INTDON ('TABLEAU')) THEN  
*
*        Coefficients variables donnes aux noeuds (interpolation)
*        Le tableau local des valeurs nodales est rempli dans EfVnlo
*
         MCATAB=INDTRD(NUTRDO+ 2*NBTRDO)
         NVALNE=INDTRD(NUTRDO+19*NBTRDO)
			   	
         DO 101 I=1,NVALNE
            CALL TSCALT (NBC,'R',1,WC,CST(1),TYPINT(ITYPDO),MCATAB
     &                  ,RST(MCMATR),CST(MCMATC),COFVAC(I))             !utilite
            MCATAB=MCATAB+NBC
101      CONTINUE
         IF (TYPE(1:1).EQ.'R') THEN
             DO 102 I=1,NVALNE
                COFVAR(I)=REAL (COFVAC(I))
102          CONTINUE
         ENDIF
      ENDIF
                                                                    END !CalCov
