*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CALELD (ELEMEN,NUFACE,NDIM  ,NDMDOM,NBTRDO,INDTRD
     &                  ,NCHDON,NOMDON,EPSMAC,NUTGAV,NUTGFV,NUFAAV
     &                  ,ISGDET,CORDLG,NBPTQX,NUSCHQ,NBPTQD,POIDQ,COORQ
     &                  ,NUTYFC,NBDLFC
     &                  ,NUTYLC,NBDLEC,KELFCC,FCTBC,DFCTBC,DWC
     &                  ,NUTYFL,NBDLFL
     &                  ,NUTYLL,NBDLEL,KELFCL,FCTBL,DFCTBL,DWL
     &                  ,NUTYFG,NBDLFG
     &                  ,NUTYLG,NBDLEG,KELFCG,FCTBG,DFCTBG
     &                  ,NUDLFG,CORDLF,POIDQD,COORQD
     &                  ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1988)
* Derniere modification : D.Martin (23 juin 2005)
* Version 4
*  
* Calcul des integrales elementaires sur un domaine de bord necessitant
* une extension (integrales avec derivees non tangentielles)
* --> Toute la geometrie de l'element est prise en compte et les calculs
*     sont effectues sur la face/arete de l'element de reference associe.
*  
*-- Arguments --
* ELEMEN numero de l'element en cours
* NUFACE numero de la face ou de l'arete d'integration  
* NDIM   dimension d'espace
* NDMDOM dimension du domaine d'integration
* NBTRDO nombre de termes a calculer sur le domaine
* INDTRD structure locale de description des termes EF sur le domaine
* INDTRD tableau de gestion des adresses pour le calcul des termes
*     Contenu du tableau INDTRD
*     (NUINT          ) niveau (plus tard adresse absolue du terme)
*     (NUINT+   NBTRDO) adresses relatives des matrices elementaires
*                       dans le tableau des matrices elementaires du bon type
*     (NUINT+ 2*NBTRDO) adresses relatives des tableaux de valeurs
*                       nodales dans le tableau des matrices elementaires
*     (NUINT+ 3*NBTRDO) type REEL ou COMPLEXE du terme
*     (NUINT+ 4*NBTRDO) indice de type de calcul
*     (NUINT+ 5*NBTRDO) numero d'integrand
*     (NUINT+ 6*NBTRDO) nombre de composantes de l'inconnue en colonne
*     (NUINT+ 9*NBTRDO) nombre de composantes de l'inconnue en ligne
*     (NUINT+12*NBTRDO) numero de donnee associee si FONCTION ou TABLEAU
*     (NUINT+13*NBTRDO) type de la donnee associee (FONCTION,TABLEAU)
*     (NUINT+14*NBTRDO) niveau ou numero de la donnee associee
*     (NUINT+15*NBTRDO) type du declaration de la fonction ou du tableau
*     (NUINT+16*NBTRDO) adresse de la donnee TABLEAU associee
*                       ou adresse de la CONSTANTE ou du TABLEAU associe
*                       dans le cas d'une donnee FONCTION 
* NCHDON nombre de caracteres par nom de donne
* NOMDON tableau #OMDON des noms de donnees
* NUTGAV numero de type geometrique de l'element lors de l'appel precedent  
* NUTGFV numero de type geometrique de la face lors de l'appel precedent
* NUFAAV numero de face lors de l'appel precedent
* ISGDET signe indiquant l'orientation de l'element (pour la normale exterieure)
* CORDLG coordonnees des points de l'element
* NBPTQX nombre maximum de points de quadrature
* NUSCHQ numero du schema de quadrature 
* NBPTQD nombre de points de la formule de quadrature
* POIDQ  poids de quadrature sur l'element de reference associe a la face/arete
* COORQ  coordonnees des points de la formule de quadrature --
* NUTYFC numero de type d'interpolation en colonne de la face NUFACE
* NBDLFC nombre de d.l. sur une face ou arete pour l'interpolation en colonne
* NUTYLC numero de type d'interpolation en ligne de l'element
* NBDLEC nombre de d.l. de l'element pour l'interpolation en colonne 
* KELFCC indice de calcul des fonctions de base pour l'interpolation en colonne
*       (1:1)='Y' ==> calcul des fonctions de base
*       (2:2)='Y' ==> calcul des derivees des fonctions de base
*       (3:3)='Y' ==> calcul des derivees secondes des fonctions de base
*       (4:4)='C' ==> calculs selon l'interpolation en 'colonne'
*             'G' ==> calculs selon l'interpolation geometrique
*       (5:5)='Y' ==> on conserve les calculs en tous les points
*                     de quadrature pour l'element suivant
*       (6:6)='Y' ==> indique le calcul des derivees des fonctions de base
*                     dans tout l'element
* FCTBC  valeurs des fonctions de base dans l'element de reference
*        pour l'interpolation en colonne (en tous les pts de quadrature)
* DFCTBC derivees des fonctions de base dans l'element de reference
*        pour l'interpolation en colonne (en tous les pts de quadrature)
* DWC    derivees des fonctions de base dans l'element courant
*        pour l'interpolation en colonne (en un point de quadrature)
* NUTYFL numero de type d'interpolation en ligne de la face NUFACE  
* NBDLFL nombre de d.l. sur une face ou arete pour l'interpolation en ligne
* NUTYLL numero de type d'interpolation en colonne de l'element
* NBDLEL nombre de d.l. de l'element pour l'interpolation en ligne
* KELFCL indice de calcul des fonctions de base pour l'interp. en ligne
* FCTBL  valeurs des fonctions de base dans l'element de reference
*        pour l'interpolation en ligne (en tous les pts de quadrature)
* DFCTBL derivees des fonctions de base dans l'element de reference
*        pour l'interpolation en ligne (en tous les pts de quadrature)
* DWL    derivees des fonctions de base dans l'element courant
*        pour l'interpolation en ligne (en un point de quadrature)
* NUTYLG numero de type geometrique de l'element
* NUTYFG numero de type geometrique de la face NUFACE
* NBDLFG nombre de points sur la face de l'element geometrique
* NBDLEG nombre de points de l'element (geometrique)
* NUDLFG numerotation locale des points (d.l.) de la face NUFACE  
* KELFCG indice de calcul des fonctions de base geometriques
* FCTBG  valeurs des fonctions de base pour les calcul geometriques sur le bord 
* DFCTBG derivees des fct. de base pour les calculs geometriques sur le bord  
* CORDLF coordonnees des points de la face ou arete
* POIDQD poids de quadrature sur la face/arete de l'element de reference
* COORQD coordonnees des points de la formule de quadrature -- 
* MCMATR adresse du tableau des matirces elementaires reelles 
* MCMATC adresse du tableau des matirces elementaires complexes
* IST    super-tableau entier 
* RST    super-tableau reel
* CST    super-tableau complexe
* NODONA chaine de caractere receptrice d'un nom de donnee (cf. CalinD)
* NOMTRA chaine de caractere receptrice d'un nom de fonction (cf. CalinD)
* NIVIMP niveau d'impression  
* IMPFCH numero de l'unite logique des impressions  (pas d'impression si =0)
*
* Remarques: L'argument NUTGAV permet d'eviter de rappeler la procedure de 
*        calcul de la formule de quadrature et surtout de refaire les calculs 
*        des fonctions de base si la place necessaire pour leur conservation 
*        est disponible en M.C.
*        (test sur la valeur de KELFCx(5:5))
*            Les 6 tableaux FCTBC,FCTBL,FCTBG,DFCTBC,DFCTBL,DFCTBG peuvent 
*        contenir les valeurs des fonctions de base et derivees pour 1 ou 
*        tous les points de quadrature selon la place en M.C.
*        (test sur KELFCx(5:5))
*        De plus 2 ou 3 des tableaux FCTBx ou DFCTBx peuvent coincider
*        (adresses d'entree egales) lorsque les interpolations correspondantes
*        sont les memes (Test sur KELFCx(4:4))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NODONA,NOMTRA,KELFCC,KELFCL,KELFCG
      CHARACTER*1   NOMDON(*)
      INTEGER       ELEMEN,NUFACE,NDIM,NDMDOM,NBTRDO,NCHDON,NUTGAV
     &             ,NUTGFV,ISGDET,NBPTQX,NUSCHQ,NBPTQD,MCMATR,MCMATC
     &             ,NUFAAV,INDTRD(*),NUDLFG(*),NIVIMP,IMPFCH
     &             ,NUTYFG,NBDLFG,NUTYLG,NBDLEG
     &             ,NUTYFC,NBDLFC,NUTYLC,NBDLEC
     &             ,NUTYFL,NBDLFL,NUTYLL,NBDLEL
     &             ,IST(*)
      REAL          EPSMAC,CORDLG(NDIM,*),POIDQ(*),COORQ(NDMDOM,*)
     &             ,CORDLF(NDIM,*),POIDQD(*),COORQD(NDIM,*)
     &             ,FCTBG(*),DFCTBG(NDIM,*)
     &             ,FCTBC(*),DFCTBC(NDIM,*),DWC(NDIM,*)
     &             ,FCTBL(*),DFCTBL(NDIM,*),DWL(NDIM,*)
     &             ,RST(*)
      COMPLEX       CST(*) 
*
* Variables locales
      CHARACTER LEYTUN*5,FORMAN*120
      INTEGER   IMPINT,IMPFCT,IMP,NUINT,MIXTE,IDIM,NUPTQD,IDLF,IDLL
     &         ,IAFCG,IADFCG,IAFCC,IADFCC,IAFCL,IADFCL,I
     &         ,DIMPTX,DIMJAX,INUTIL
* POIN   tableau de travail pour recevoir les coordonnees d'un point
*        la norme du vecteur normal et ses composantes
* JACOBF tableau pour le calcul de la matrice jacobienne
* JACOBM tableau pour le calcul de la matrice jacobienne inverse
      PARAMETER ( DIMPTX=7 , DIMJAX=9 )
      REAL      POIN(DIMPTX),JACOBF(DIMJAX),JACOBM(DIMJAX)
     &         ,DETDF,DETDFA,ELTDIF,PAUTIL
      LOGICAL   KLAGEL,KLAGEF,KLAGEN
*
      COMMON/ONSEPA/FORMAN
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CalelD*')
      IMP=IMPFCH
      IF (NIVIMP.LE.0) IMP=0
*
*     Variables impliquant le necessaire recalcul des fonctions de base
      KLAGEL=NUTYLG.NE.NUTGAV  
      KLAGEF=NUTYFG.NE.NUTGFV 
      KLAGEN=KLAGEF.OR.KLAGEL.OR.NUFACE.NE.NUFAAV
*  
*     Formule de quadrature de l'element de reference de la face/arete
*     ----------------------------------------------------------------
      IF (KLAGEF) THEN
         CALL ELEMQD (NUTYFG,NDMDOM,NUSCHQ,NBPTQD,POIDQ,COORQ,IMP)      !Ef3d
         IF (NBPTQD.GT.NBPTQX) GOTO 99995  
      ENDIF
*
*     Transport de la formule sur la face/arete de l'element de reference
*     -------------------------------------------------------------------
      IF (KLAGEN)
     &CALL ELEMQF (NDMDOM,NUTYLG,NUFACE,NBPTQD,POIDQ,COORQ
     &            ,POIDQD,COORQD,IMP)                                   !Ef3d
*
*     Transport des coordonnees de l'element sur la face/arete
*     --------------------------------------------------------
      DO 2 IDLF=1,NBDLFG
         IDLL=NUDLFG(IDLF)
         DO 1 IDIM=1,NDIM  
            CORDLF(IDIM,IDLF)=CORDLG(IDIM,IDLL) 
1        CONTINUE
2     CONTINUE
*
      DETDFA=0.
*
*     Indices pour impression de resultats partiels
      IMPINT=0
      IMPFCT=0
      IF (NIVIMP.GT.0) THEN
         IF (NIVIMP.GE.5) THEN
            IMPINT=IMPFCH
            IMPFCT=IMPFCH
            WRITE (IMP,10000) ELEMEN,NUFACE,NUTYFC,NUTYFG,1,NBPTQD
         ELSE
            WRITE (IMP,10001) ELEMEN,NUFACE,NUTYFC,NUTYFG,NBPTQD
         ENDIF
         IF (.NOT.KLAGEN) IMPFCT=0
         DO 10 NUINT=1,NBTRDO
            IF (INDTRD(NUINT+5*NBTRDO).GT.0)
     &         WRITE (IMP,10002) INDTRD(NUINT+5*NBTRDO)
     &        ,ABS(INDTRD(NUINT+12*NBTRDO)),INDTRD(NUINT+NBTRDO)
10       CONTINUE
      ENDIF
*     Pour annuler les composantes du vecteur normal
      DO 11 I=NDIM+2,DIMPTX
         POIN(I)=0.
11    CONTINUE
*-------------------------------------------------------------------------------
* Plan :
*  I--> Calculs geometriques (matrice jacobienne, normale, element de surface)
*    a) Derivees des fonctions de base definissant la transformation geometrique
*    b) Matrice jacobienne de la transformation geometrique
*    c) Calcul des vecteurs tangents et de l'element de surface
*    d) Determinant jacobien et matrice inverse
*    e) Le cas echeant, calcul de l'image par la transformation geometrique
*       du point de quadrature dans l'element
*    g) Le cas echeant (interpolation isoparametrique)
*       calcul des derivees de fontions de base dans l'element courant
*       (Rappel : Les calculs geometriques (jacobien et element differentiel)
*        utilisent l'element geometrique (NUTYLG), les calculs d'integrands
*        utilisent les fonctions de base de l'element pour l'interpolation
*        en colonne (NUTYFC/NUTYLC) et ligne (NUTYFL/NUTYLL)).
*
* II--> Calcul des fonctions de base et/ou des derivees intervenant dans
*       dans le calcul des integrands dans le cas non isoparametrique ou mixte
*       Inutile dans le cas isoparametrique on utilise les fonctions de base
*       deja calculees pour la geometrie
*    f) calcul des fonctions et derivees de fontions de base dans l'element
*       de reference (cas d'une interpolation non isoparametrique)
*    g) calcul des derivees de fontions de base dans l'element courant
*
* III--> Calcul des matrices elementaires en un point de quadrature
*
* ATTENTION : Les fonctions de base sont calculees pour les d.l. du bord
*             pour des points de quadrature en dimension du bord
*             (cf. ELEMQF & tableaux POIDQD, COORQD)
*             Les derivees des fonctions sont calculees pour les d.l. de tout
*             l'element pour des points de quadrature en dimension d'espace
*             (cf. ELEMQD & tableaux POIDQ, COORQ)
*-------------------------------------------------------------------------------
      DO 111 NUPTQD=1,NBPTQD
* --I) Calculs geometriques
*     a) Derivees des fonctions de base pour les d.l. dans tout l'element
         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLG
     &               ,NBDLFG,NBDLEG,'NY'//KELFCG(3:6)
     &               ,PAUTIL,DFCTBG,INUTIL,IADFCG,IMPFCT)
*
*     b) Matrice jacobienne dans tout l'element
         CALL DELAFO (NDIM,NDIM,NBDLEG,CORDLG,DFCTBG(1,IADFCG)
     &               ,IMPINT,JACOBF)
*
*     c) Calcul des vecteurs tangents a partir de la matrice jacobienne
*        (JACOBM est utilise ici comme tableau de travail intermediaire)
         CALL ELEMTF (NDIM,NDMDOM,NUTYLG,NUFACE,JACOBF,JACOBM,IMPINT) !ef3d
*
*        Calcul de l'element de surface et de la normale unitaire
         CALL ELDIFF (NDIM,NDMDOM,JACOBM,ISGDET,ELTDIF,POIN(NDIM+2)   !calelem
     &               ,IMPINT)
*        Norme du vecteur normal = Element de surface ou de longueur
         POIN(NDIM+1)=ELTDIF
*
*     d) Determinant et Inverse de la matrice jacobienne
*        (OFALED retourne l'inverse de la matrice jacobienne)
         CALL OFALED (NDIM,JACOBF,DETDF,JACOBM,EPSMAC,IMPINT)
*        Tests sur la nullite ou le changement de signe du determinant
         IF (ABS(DETDF).LE.EPSMAC) GOTO 99990
         IF (DETDF*DETDFA.LT.0) GOTO 99992
         DETDFA=DETDF
*     e) Fonctions de base sur le bord de l'element
*        Calcul de l'image du point de quadrature dans l'element courant
*        (cas des integrands a coefficient variable)
*
         IF (KELFCG(1:1).NE.'N')
     &   CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFG
     &               ,NBDLFG,NBDLEG,'YN'//KELFCG(3:6)
     &               ,FCTBG,PAUTIL,IAFCG,INUTIL,IMPFCT)
         IF (KELFCG(6:6).EQ.'Y')
     &   CALL TRANSF(NDIM,NBDLFG,CORDLF,FCTBG(IAFCG),POIN)
*
*        Calculs differencies selon les interpolations en colonne et ligne
*        -----------------------------------------------------------------
         IF (KELFCC(4:4).EQ.'G') THEN
*
            IF (KELFCL(4:4).EQ.'G') THEN
*  
*        f)    Interpolation isoparametrique en colonne et en ligne
*
*        g)    Calcul des derivees de fontions de base dans l'element courant
               IF (KELFCG(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEG,DFCTBG(1,IADFCG),JACOBM
     &                     ,DWC,IMPFCT)
* III)
               MIXTE=0
               CALL CALIND (MIXTE,NDIM,NBTRDO,INDTRD,NCHDON,NOMDON
     &                     ,POIDQD(NUPTQD),ELTDIF,POIN
     &                     ,NBDLFG,NBDLEG,FCTBG(IAFCG),DWC
     &                     ,NBDLFG,NBDLEG,FCTBG(IAFCG),DWC
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,IMPINT)
*
            ELSEIF (KELFCL(4:4).EQ.'L') THEN
*  
*              Interpolation isoparametrique en colonne et non en ligne
*
* -II)  f)     Fonctions de base pour l'interpolation en ligne
*              pour les d.l. du bord
               IF (KELFCL(1:1).NE.'N')
     &         CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFL
     &                     ,NBDLFL,NBDLEL,'YN'//KELFCL(3:6)
     &                     ,FCTBL,PAUTIL,IAFCL,INUTIL,IMPFCT)
*              Derivees des fonctions de base pour l'interpolation en ligne
*              pour tous les d.l. de l'element
               IF (KELFCL(2:2).NE.'N')
     &         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLL
     &                     ,NBDLFL,NBDLEL,'NY'//KELFCL(3:6)
     &                     ,PAUTIL,DFCTBL,INUTIL,IADFCL,IMPFCT)
*       g)
               IF (KELFCG(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEG,DFCTBG(1,IADFCG),JACOBM
     &                     ,DWC,IMPFCT)
               IF (KELFCL(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEL,DFCTBL(1,IADFCL),JACOBM
     &                     ,DWL,IMPFCT)
* III)
               MIXTE=NUTYLC-NUTYLL
               CALL CALIND (MIXTE,NDIM,NBTRDO,INDTRD,NCHDON,NOMDON
     &                     ,POIDQD(NUPTQD),ELTDIF,POIN
     &                     ,NBDLFG,NBDLEG,FCTBG(IAFCG),DWC
     &                     ,NBDLFL,NBDLEL,FCTBL(IAFCL),DWL
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,IMPINT)
*
            ENDIF
*
         ELSEIF (KELFCC(4:4).EQ.'C') THEN
*
            IF (KELFCL(4:4).EQ.'C') THEN
*  
*           Interpolation non-isoparametrique identique en colonne et ligne
*
* -II)  f)     Fonctions de base pour l'interpolation en colonne
               IF (KELFCC(1:1).NE.'N')
     &         CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFC
     &                     ,NBDLFC,NBDLEC,'YN'//KELFCC(3:6)
     &                     ,FCTBC,PAUTIL,IAFCC,INUTIL,IMPFCT)
*              Derivees des fonctions de base pour l'interpolation en colonne
*              pour tous les d.l. de l'element
               IF (KELFCC(2:2).NE.'N')
     &         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLC
     &                     ,NBDLFC,NBDLEC,'NY'//KELFCC(3:6)
     &                     ,PAUTIL,DFCTBC,INUTIL,IADFCC,IMPFCT)
*       g)
               IF (KELFCC(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEC,DFCTBC(1,IADFCC),JACOBM
     &                     ,DWC,IMPFCT)
* III)
               MIXTE=0
               CALL CALIND (MIXTE,NDIM,NBTRDO,INDTRD,NCHDON,NOMDON
     &                     ,POIDQD(NUPTQD),ELTDIF,POIN
     &                     ,NBDLFC,NBDLEC,FCTBC(IAFCC),DWC
     &                     ,NBDLFC,NBDLEC,FCTBC(IAFCC),DWC
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,IMPINT)
*
            ELSEIF (KELFCL(4:4).EQ.'G') THEN
*  
*              Interpolation non-iso. en colonne, isoparametrique en ligne
*
* -II)  f)     Fonctions de base pour l'interpolation en colonne
               IF (KELFCC(1:1).NE.'N')
     &         CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFC
     &                     ,NBDLFC,NBDLEC,'YN'//KELFCC(3:6)
     &                     ,FCTBC,PAUTIL,IAFCC,INUTIL,IMPFCT)
*              Derivees des fonctions de base pour l'interpolation en colonne
*              pour tous les d.l. de l'element
               IF (KELFCC(2:2).NE.'N')
     &         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLC
     &                     ,NBDLFC,NBDLEC,'NY'//KELFCC(3:6)
     &                     ,PAUTIL,DFCTBC,INUTIL,IADFCC,IMPFCT)
*       g)
               IF (KELFCC(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEC,DFCTBC(1,IADFCC),JACOBM
     &                     ,DWC,IMPFCT)
               IF (KELFCG(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEG,DFCTBG(1,IADFCG),JACOBM
     &                     ,DWL,IMPFCT)
* III)
               MIXTE=NUTYLC-NUTYLL
               CALL CALIND (MIXTE,NDIM,NBTRDO,INDTRD,NCHDON,NOMDON
     &                     ,POIDQD(NUPTQD),ELTDIF,POIN
     &                     ,NBDLFC,NBDLEC,FCTBC(IAFCC),DWC
     &                     ,NBDLFG,NBDLEG,FCTBG(IAFCG),DWL
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,IMPINT)
*
            ELSEIF (KELFCL(4:4).EQ.'L') THEN
*  
*              Interpolation non-isoparam. differentes en colonne et ligne
*
* -II)  f)     Fonctions de base pour l'interpolation en colonne
               IF (KELFCC(1:1).NE.'N')
     &         CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFC
     &                     ,NBDLFC,NBDLEC,'YN'//KELFCC(3:6)
     &                     ,FCTBC,PAUTIL,IAFCC,INUTIL,IMPFCT)
*              Derivees des fonctions de base pour l'interpolation en colonne
*              pour tous les d.l. de l'element
               IF (KELFCC(2:2).NE.'N')
     &         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLC
     &                     ,NBDLFC,NBDLEC,'NY'//KELFCC(3:6)
     &                     ,PAUTIL,DFCTBC,INUTIL,IADFCC,IMPFCT)
*              Fonctions de base pour l'interpolation en colonne
               IF (KELFCL(1:1).NE.'N')
     &         CALL ECOBAS (KLAGEF,NUPTQD,COORQ(1,NUPTQD),NDIM,NUTYFL
     &                     ,NBDLFL,NBDLEL,'YN'//KELFCL(3:6)
     &                     ,FCTBL,PAUTIL,IAFCL,INUTIL,IMPFCT)
*              Derivees des fonctions de base pour l'interpolation en ligne
*              pour tous les d.l. de l'element
               IF (KELFCL(2:2).NE.'N')
     &         CALL ECOBAS (KLAGEN,NUPTQD,COORQD(1,NUPTQD),NDIM,NUTYLL
     &                     ,NBDLFL,NBDLEL,'NY'//KELFCL(3:6)
     &                     ,PAUTIL,DFCTBL,INUTIL,IADFCL,IMPFCT)
*        g)
               IF (KELFCC(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEC,DFCTBC(1,IADFCC),JACOBM
     &                     ,DWC,IMPFCT)
               IF (KELFCL(2:2).EQ.'Y')
     &         CALL DWIDXK (NDIM,NBDLEL,DFCTBL(1,IADFCL),JACOBM
     &                     ,DWL,IMPFCT)
* III)
               MIXTE=NUTYLC-NUTYLL
               CALL CALIND (MIXTE,NDIM,NBTRDO,INDTRD,NCHDON,NOMDON
     &                     ,POIDQD(NUPTQD),ELTDIF,POIN
     &                     ,NBDLFC,NBDLEC,FCTBC(IAFCC),DWC
     &                     ,NBDLFL,NBDLEL,FCTBL(IAFCL),DWL
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,IMPINT)
*
            ENDIF
         ENDIF
*
*        Pour les impressions au dernier point de quadrature
*
         IMPINT = 0
         IMPFCT = 0
         IF (NIVIMP.GT.0.AND.NUPTQD.EQ.NBPTQD-1) THEN
            IMPINT = IMPFCH
            IMPFCT = IMPFCH
         ENDIF
111   CONTINUE
      CALL PRFXMJ (-1,'*CalelD*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/' *CalelD*  Element #',I5,' Face ',I1,' : Type ',I5,  
     &' ,  type geometrique ',I5,', aux points de quadrature #'
     &,5(I3:,', '))
10001 FORMAT(/' *CalelD*  Element #',I5,' Face ',I1,' : Type ',I5,
     &' ,  type geometrique ',I5,', au dernier point de quadrature #'
     &,(I3:,', '))
10002 FORMAT(T13,'Integrand #',I4,' Donnee associee # ',I3,' Adr.rel. :'
     &,I9)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*    Impression en cas de nullite ou changement de signe du determinant
*  
99990 WRITE (IMPFCH,99991) DETDF,NUFACE,ELEMEN,LEYTUN (NUTYFG),NUPTQD
      CALL BAISE  (' Determinant nul, probleme de maillage?')
99991 FORMAT(/' *CalelD* --> STOP'/'  Determinant nul'
     &/T20,' DETDF =',E12.4/'  sur la face no',I2,' de l''element no'
     &,I5,' de type ',A,', au point de quadrature no',I4)
99992 WRITE (IMPFCH,99993) DETDF,DETDFA,NUFACE,ELEMEN,LEYTUN (NUTYFG)
     &,NUPTQD
      CALL BAISE  ('Changement de signe du determinant,'
     &// 'Probleme de maillage ?')
99993 FORMAT(/' *CalelD* --> STOP'/
     &'  Changement de signe du determinant jacobien'
     &/T20,' DETDF =',E12.4,' DETDFav =',E12.4/'  sur la face no',I2
     &,' de l''element no',I5,' de type ',A
     &,', au point de quadrature no',I4)
*
99995 CALL ENCLER (NBPTQX,FORMAN(1:3))
      CALL ENCLER (NBPTQD,FORMAN(4:6))
      CALL BAISE  ('Nombre maximum ('//FORMAN(1:3)//
     &') de points de quadrature depasse : NBPTQD='//FORMAN(4:6))
                                                                    END !CalelD
