*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CORNEL (NDIM,NDMDOM,NUTGEO,NBPTEL,CORPTL,NBNEEL,CORLOC
     &                  ,FCTBAS,COORNL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*  
* Calcul des coordonnees des noeuds d'un element 
*  
*-- Arguments --
* NDIM   dimension d'espace
* NDMDOM dimension d'espace pour l'element de reference
* NUTGEO numero de type de l'element geometrique (ou face ou arete)
* NBPTEL nombre de points sur la face ou l'arete  
* CORPTL tableaux de coordonnees des points de l'element 
* NBNEEL nombre de noeuds de l'element  
* CORLOC tableau des coordonnees des noeuds sur l'element de reference
* FCTBAS tableau recepteur des fonctions de base
* COORNL tableau des coordonnees des noeuds dans l'element
* NIVIMP,IMPFCH quincaillerie habituelle
*-- Procedures utilisees --
* ELEMFB fournit les fonctions de base
* TRANSF fourmit l'image d'un noeud de l'elt. de reference dans l'elt. courant
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDIM,NDMDOM,NUTGEO,NBPTEL,NBNEEL,NIVIMP
     &             ,IMPFCH
      REAL          CORLOC(NDMDOM,*),FCTBAS(*),COORNL(NDIM,*)
     &             ,CORPTL(NDIM,*)
*
      CHARACTER     WCH,FORMA*119,PRFXAF*8
      INTEGER       I,J,IDM,NUNEEL
      REAL          PAUTIL
      COMMON/FORMAH/FORMA,WCH
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Cornel*')
*  
*     Boucle sur les noeuds de l'element (ou face/arete de l'element)
*  
      DO 1 NUNEEL=1,NBNEEL
*  
*        Calcul des fonctions de base geometriques au noeud de l'element
*        de reference associe au noeud
*
         CALL ELEMFB (NUTGEO,'YNN',CORLOC(1,NUNEEL),FCTBAS
     &               ,PAUTIL,PAUTIL,0)                                  !ef3d
*
*        Calcul du noeud image du noeud de l'element de reference
*
         CALL TRANSF (NDIM,NBPTEL,CORPTL,FCTBAS,COORNL(1,NUNEEL))       !calelem
*
1     CONTINUE 
      CALL PRFXMJ (-1,'*Cornel*')
      IF (NIVIMP.EQ.0) RETURN 
*-----------------------------------------------------------------------
*     Impressions (particulierement elegantes !)
      WCH=CHAR(NDIM+48)  
      WRITE (IMPFCH,10000) PRFXAF( )
10000 FORMAT(T2,A8,' > *Cornel*')
      FORMA=
     &     '(1(TR5,''i '','//WCH//'('' Cornel(i,'',I1,'') ''),'' '',:))'
      NUNEEL=NDIM+(-1)**NDIM
      FORMA(2:2)=CHAR(NUNEEL+49)
      WRITE (IMPFCH,FORMA) ((IDM,IDM=1,NDIM),J=0,MIN(NUNEEL,NBNEEL-1))
      I=0  
      FORMA=
     &     '('//CHAR(NUNEEL+49)//'(I6,TR1,'//'('//WCH//'E13.5,'' '':)))'
*-----------------------------------------------------------------------
11    I=I+1
      IF (I.GT.NBNEEL) RETURN
      NUNEEL=MIN(NUNEEL,NBNEEL-I)
      WRITE (IMPFCH,FORMA) (I+J,(COORNL(IDM,I+J),IDM=1,NDIM),J=0,NUNEEL) 
      I=I+NUNEEL
      GOTO 11 
                                                                    END !Cornel
