*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DELAFO (NDIM,NDMDOM,NBDLG,CORDLG,DFCTBA,IMPFCH,JACOB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (8 mars 1994)
* Version 1.0.0
*  
* Calcul de la matrice jacobienne de la transformation qui envoie l'element  
* de reference sur l'element courant en un point (en general de quadrature)  
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace .
* NDMDOM dimension de domaine calcul ( inferieur ou egal a NDIM ) .
* NBDLG  nombre de points (d.l. geometriques) de l'element . 
* CORDLG tableau des coordonnees des 'points' de l'element geometrique . 
* DFCTBA derivees des fonctions de base de l'element geometrique.
* IMPFCH numero du fichier d'impression si non nul . 
*  
*-- Argument en sortie -- 
* JACOB  tableau contenant les NDMDOM colonnes de la matrice jacobienne .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NDIM,NDMDOM,NBDLG,IMPFCH
      REAL    CORDLG(NDIM,*),DFCTBA(NDMDOM,*),JACOB(NDIM,*)  
*
      INTEGER K,KK,IDL
      DOUBLE PRECISION A
*------------------------------------------------------------------------
      DO 3 K=1,NDIM
         DO 2 KK=1,NDMDOM  
            A=0.
            DO 1 IDL=1,NBDLG
               A=A+CORDLG(K,IDL)*DFCTBA(KK,IDL)
1           CONTINUE
            JACOB(K,KK)=A
2         CONTINUE
3     CONTINUE
*  
      IF (IMPFCH.LE.0) RETURN
*------------------------------------------------------------------------
      WRITE (IMPFCH,10000) (JACOB(1,KK),KK=1,NDMDOM)
      DO 10 K=2,NDIM
         WRITE (IMPFCH,10001) (JACOB(K,KK),KK=1,NDMDOM)
10    CONTINUE
*      write (impfch,10002) ((cordlg(K,IDL),K=1,2),IDL=1,NBDLG)
10000 FORMAT(T6,'*Delafo*  Matrice Jacobienne :',T45,3E12.4)
10001 FORMAT(T45,3E12.4)
10002 FORMAT('Coord :',4E12.4)
                                                                    END !Delafo
