*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DWIDXK (NDIM,NBDL,DFBASE,JACOBM,DWDX,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 2000)
* Derniere modification : D.Martin (5 Juillet 2000)
* Version 1.0.0
*
* Calcul des valeurs des derivees des fonctions de base dans l'element courant
* a partir des derivees des fonctions de base dans l'element de reference
* et de la matrice jacobienne de la transformation F elt de ref --> elt courant
*
*                     dw_i/dx_k = d^w_i/d^x_k . [DF^{-1}]_k
*
* ou [DF^{-1}]_k est le k-ieme vecteur colonne de la matrice jacobienne inverse
* et d^w_i/d^x_k la k-ieme derivee partielle de la i-ieme fonction de base
*              dans l'element de reference
*
*-- Arguments d'entree --
* NDIM   dimension d'espace
* NBDL   nombre de degre de liberte de l'element
* DFBASE derivees des fonctions de base dans l'element de reference
*        DFBASE(K,I) = d^w_i/d^x_k
* JACOBM inverse de la matrice jacobienne
*
* Argument de sortie --
* DWDX   derivees des fonctions de base dans l'element courant
*        DWDX  (K,I) = dw_i/dx_k
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NBDL,IMPFCH
      REAL    DFBASE(NDIM,*),JACOBM(NDIM,*),DWDX(NDIM,*)
*
      INTEGER K,IDL,ID
      DOUBLE PRECISION DWIDK
*-----------------------------------------------------------------------
      DO 10 K=1,NDIM
        DO 5 IDL=1,NBDL
           DWIDK=0.
           DO 1 ID=1,NDIM
              DWIDK=DWIDK+DFBASE(ID,IDL)*JACOBM(ID,K)
1          CONTINUE
           DWDX(K,IDL)=DWIDK
5       CONTINUE
10    CONTINUE
*-----------------------------------------------------------------------
      IF (IMPFCH.LE.0) RETURN
      WRITE (IMPFCH,1001)
      DO 1003 K=1,NDIM
         WRITE (IMPFCH,1002)
     &         'Derivees/X'//CHAR(K+48),(DWDX(K,IDL),IDL=1,NBDL)
1003  CONTINUE
1001  FORMAT(/T6,'*dWidxk* Derivees des fonctions de base '
     &,' (element courant)')
1002  FORMAT(T7,A,(T19,':',10E11.4))
                                                                    END !dWidxk
