*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELDIFF (NDIM,NDMDOM,TANGTS,ISGDET,ELTDIF,NORMAL,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (23 juin 2005)
* Version 2
*
* Calcul de l'element differentiel pour les integrales elementaires de bord
*
*-- Arguments d'entree --
* NDIM   dimension d'espace
* NDMDOM dimension du domaine d'integration
* TANGTS vecteur(s) tangent(s) sur la face
* ISGDET orientation de l'element pour le calcul de la normale exterieure
*-- Arguments de sortie --
* ELTDIF element differentiel
* NORMAL composantes du vecteur normal exterieur unitaire, si defini
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NDIM,NDMDOM,ISGDET,IMPFCH
      REAL     TANGTS(NDIM,*),ELTDIF,NORMAL(*)
*
      INTEGER I
*-----------------------------------------------------------------------
      IF (NDIM-NDMDOM.EQ.2) THEN
*
*        Cas des integrales d'aretes en dimension 3
*
         ELTDIF=0.
         DO 10 I=1,NDIM
            ELTDIF=ELTDIF+TANGTS(I,1)*TANGTS(I,1)
10       CONTINUE
         ELTDIF=SQRT (ELTDIF)
*
         IF (IMPFCH.GT.0) WRITE(IMPFCH,10001) ELTDIF,NDIM,NDMDOM
      ELSE
*
*        Integrales de surface en dimension 3 ou de ligne en dimension 2
*
         CALL PROEXT (NDIM,TANGTS,NORMAL)                               !utilite
         ELTDIF=0.
         DO 20 I=1,NDIM
            ELTDIF=ELTDIF+NORMAL(I)*NORMAL(I)
20       CONTINUE
         ELTDIF=SQRT (ELTDIF)
*
*        Calcul de la normale unitaire
*
         DO 21 I=1,NDIM
            NORMAL(I) = NORMAL(I)/ELTDIF
21       CONTINUE
*
*        Prise en compte de l'orientation de l'element
*
         IF (ISGDET.LT.0) THEN
            DO 30 I=1,NDIM
               NORMAL(I)=-NORMAL(I)
30          CONTINUE
         ENDIF
*
         IF(IMPFCH.GT.0) THEN
            WRITE (IMPFCH,10000) (NORMAL(I),I=1,NDIM)
            WRITE (IMPFCH,10001) ELTDIF,NDIM,NDMDOM
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T6,'*Eldiff*  Vecteur normal exterieur :',T45,3E12.4)
10001 FORMAT(T6,'*Eldiff*  EltDif=',E11.4,' Ndim=',I1,' Ndmdom=',I1)
                                                                    END !ElDiff
