*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OFALED (NBLIGN,MAT,DET,MATINV,EPSIL,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1988)
* Derniere modification : D.Martin (23 juin 2005)
* Version 3
*  
* Calcul le determinant et l'inverse d'une matrice 1x1 (!), 2x2 ou 3x3
* (Procedure utilisee pour le calcul de la matrice jacobienne inverse
*  dans les calculs elementaires des matrices elements finis)
*  
*-- Arguments --  
* NBLIGN dimension de la matrice
* MAT    matrice a inverser
* DET    le determinant de la matrice d'entree  
* MATINV inverse de la matrice d'entree 
* EPSIL  seuil en deca duquel la division par le determinant n'est pas faite
* IMPFCH unite logique d'impression (pas d'impression si IMPFCH = 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLIGN,IMPFCH
      REAL    DET,MAT(NBLIGN,*),MATINV(NBLIGN,*),EPSIL,DETINV
*
      INTEGER I,J
*-----------------------------------------------------------------------
      IF (NBLIGN.EQ.3) THEN
*
*        Calculs des mineurs des coefficients de la premiere ligne 
         MATINV(1,1)=MAT(2,2)*MAT(3,3)-MAT(2,3)*MAT(3,2)
         MATINV(2,1)=MAT(2,3)*MAT(3,1)-MAT(2,1)*MAT(3,3)
         MATINV(3,1)=MAT(2,1)*MAT(3,2)-MAT(2,2)*MAT(3,1)
*        Calcul du determinant (developpement / la 1ere ligne)
         DET=MAT(1,1)*MATINV(1,1)+MAT(1,2)*MATINV(2,1)
     &        +MAT(1,3)*MATINV(3,1)
         IF (ABS(DET).LE.EPSIL) RETURN
         DETINV=1./DET
         MATINV(1,1)=MATINV(1,1)*DETINV
         MATINV(2,1)=MATINV(2,1)*DETINV
         MATINV(3,1)=MATINV(3,1)*DETINV
*        Calculs des mineurs des coefficients de la deuxieme ligne 
         MATINV(1,2)=(MAT(1,3)*MAT(3,2)-MAT(1,2)*MAT(3,3))*DETINV
         MATINV(2,2)=(MAT(1,1)*MAT(3,3)-MAT(1,3)*MAT(3,1))*DETINV
         MATINV(3,2)=(MAT(1,2)*MAT(3,1)-MAT(1,1)*MAT(3,2))*DETINV
*        Calculs des mineurs des coefficients de la troisieme ligne
         MATINV(1,3)=(MAT(1,2)*MAT(2,3)-MAT(1,3)*MAT(2,2))*DETINV
         MATINV(2,3)=(MAT(1,3)*MAT(2,1)-MAT(1,1)*MAT(2,3))*DETINV
         MATINV(3,3)=(MAT(1,1)*MAT(2,2)-MAT(1,2)*MAT(2,1))*DETINV
*
      ELSEIF (NBLIGN.EQ.2) THEN
*
         DET=MAT(1,1)*MAT(2,2)-MAT(1,2)*MAT(2,1)
         IF (ABS(DET).LE.EPSIL) RETURN
         DETINV=1./DET
         MATINV(1,1)= MAT(2,2)*DETINV
         MATINV(2,2)= MAT(1,1)*DETINV
         MATINV(1,2)=-MAT(1,2)*DETINV
         MATINV(2,1)=-MAT(2,1)*DETINV
*
      ELSEIF (NBLIGN.EQ.1) THEN
*
         DET=MAT(1,1) 
         IF (ABS(DET).LE.EPSIL) RETURN
         MATINV(1,1)=1./DET
*
      ENDIF
*-----------------------------------------------------------------------
      IF (IMPFCH.LE.0) RETURN
      WRITE(IMPFCH,10000) DET,(MATINV(1,J),J=1,NBLIGN)
      DO 10 I=2,NBLIGN
         WRITE(IMPFCH,10001) (MATINV(I,J),J=1,NBLIGN)
10    CONTINUE
10000 FORMAT(T6,'*Ofaled*',T16,'Determinant Jacobien DET :',T45,E12.4,
     &/T16,'Matrice Jacobienne Inverse :',T45,3E12.4)
10001 FORMAT(T45,3E12.4)
                                                                    END !Ofaled
