*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRANSF (NDIM,NBPOIN,CORPTL,FCTBAS,POINT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1989)
* Derniere modification : D.Martin (8 Mars 1994)
* Version 1.0.0
*  
* Calcul de la transformation qui envoie un point de l'element de reference sur
* un point de l'element courant :
*
*                      x = F(^x) = \sum_{i=1,nbpoin} a_i ^w_i(^x)
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* NBPOIN nombre de points de l'element
* CORPTL tableau des coordonnees des points de l'element courant
* FCTBAS fonctions de base de l'element de l'element de reference au point ^x
*        FCTBAS(I) = ^w_i(^x)
*  
*-- Argument en sortie -- 
* POINT  coordonnees du point de l'element courant calcule (x)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NBPOIN
      REAL    CORPTL(NDIM,*),FCTBAS(*),POINT(*)
*
      INTEGER K,IDL
      DOUBLE PRECISION A
*-----------------------------------------------------------------------
      DO 2 K=1,NDIM
         A=0.
         DO 1 IDL=1,NBPOIN
            A=A+CORPTL(K,IDL)*FCTBAS(IDL)
1        CONTINUE
         POINT(K)=A
2     CONTINUE
                                                                    END !Transf
