*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSKBMO (NCHDOM,NUDOG ,NUDOK ,NBELDO,NBNECO,NBNELI
     &                  ,NVSTKB,ITYSYD,DIMOBL,DIMOBU,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1992) 
* Derniere modification : D.Martin (16 Mars 2008)
* Version 2
*  
* Creation des tableaux de stockage 'BiMorse' des termes sur un domaine
*  
*-- Arguments d'entree -- 
* NCHDOM nombre de caracteres par nom de domaine  
* NUDOG  numero du domaine geometrique
* NUDOK  numero du domaine de calcul  
* NBELDO nombre d'elements (de couples element-face) du domaine
* NBNECO nombre de noeuds pour l'interpolation en colonne
* NBNELI nombre de noeuds pour l'interpolation en ligne
* NVSTKB niveau du tableau de stockage 'Bi-Morse'
* ITYSYD indicateur de stockage 'BiMorse' symetrique sur le domaine
* DIMOBL taille de la partie triangulaire inferieure du stockage 'BiMorse'
* DIMOBU taille de la partie triangulaire superieure du stockage 'BiMorse'
* NIVIMP numero de niveau d'impression
* IMPFCH numero d'unite logique d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NCHDOM,NUDOG ,NUDOK ,NBELDO,NBNECO,NBNELI,NVSTKB,ITYSYD
     &        ,DIMOBL,DIMOBU,NIVIMP,IMPFCH
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      INTEGER LGSTMO,IRCODE
      INTEGER MCPLAG,NL,NBPLAL,MCPLAL,MCPLIL,NC,NBPLAU,MCPLAU,MCPLIU
     &       ,LGBMOR,MCGOCO,LGREEL,MCGNDO,MCGOLI,NBPLAX,LASTPL,LGL,LGU
     &       ,MCMDOM,IGLO,JGLO,L,IDL,JDL
      CHARACTER     ERCODE*120 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DskBmo*')
*  
      ERCODE(1:1)='!'  
      CALL TBRR1  (ERCODE,'&BMORS',NVSTKB,MCPLAG)
*
      IF (ERCODE(1:1).EQ.' ') THEN
*        Le tableau de stockage BiMorse existe : ses attributs
         CALL TBAR1  (ERCODE,'&BMORS',NVSTKB,MCPLAG)
         CALL EXBMOR (MCPLAG,IST(MCPLAG),NL,NBPLAL,MCPLAL,MCPLIL,DIMOBL
     &                                  ,NC,NBPLAU,MCPLAU,MCPLIU,DIMOBU)!utilite
*
      ELSE
*
*        Surestimation de la taille du tableau de stockage 'Bi-Morse'
         LGBMOR=LGSTMO ('B',NBNELI,NBNECO,ITYSYD)                       !utilite
*
*        Creation du tableau de stockage des matrices Bimorse
         CALL TBRR1  (ERCODE,'#RGNDO',NUDOK ,MCGOCO)
         CALL TBCRSU ('&BMORS',NVSTKB,1,LGBMOR,LGREEL,'c')
*        Nombre maximum de plages du tableau de stockage 'Bi-Morse' inf
         NBPLAX=(LGREEL-NBNELI-1)/2
*
         CALL TBAR2  (ERCODE,'#RGNDO',NUDOK,MCGNDO
     &                      ,'&BMORS',NVSTKB,MCPLAG)
*
*--      Remplissage du tableau de stockage Bi-Morse inferieur
*
*        Mise a zero du sous-tableau NULAPL du tableau &BMORS
         MCPLAL=MCPLAG+2
         MCPLIL=MCPLAG+1+NBNELI
*        Remarque : NULAPL translate d'une adresse a gauche (MCPLAL-1)
         DO 10 L=MCPLAL-1,MCPLIL-1
            IST(L)=0
10       CONTINUE
         NBPLAL=0
         MCGOLI=MCGNDO+IST(MCGNDO)-1
         MCGOCO=MCGNDO+1
*
         DO 11 L=1,NBELDO
*           Boucle sur les noeuds de l'element en ligne
            DO 111 IDL=1,IST(MCGOLI)
               IGLO=IST(MCGOLI+IDL)
*              Boucle sur les noeuds de l'element en colonne
               DO 112 JDL=1,IST(MCGOCO)
                  JGLO=IST(MCGOCO+JDL)
                  IF (IGLO.GT.JGLO) THEN
                     CALL CMPLGN (IGLO,JGLO,NBNELI,NBPLAL,IST(MCPLAL-1)
     &                           ,IST(MCPLIL),NBPLAX,IRCODE)            !morse
                     IF (IRCODE.NE.0) GOTO 99991
                  ENDIF
112            CONTINUE
111         CONTINUE
            MCGOCO=MCGOCO+IST(MCGOCO)+1
            MCGOLI=MCGOLI+IST(MCGOLI)+1
11       CONTINUE
         IST(MCPLAL-1)=NBNELI
*
*        Prise en compte des lignes sous-diagonales vides
         LASTPL=0
         DO 12 L=MCPLAL,MCPLIL-1
            IF (IST(L).LE.0) THEN
               IST(L)=LASTPL
            ELSE
               LASTPL=IST(L)
            ENDIF
12       CONTINUE
         LGBMOR       =1+NBNELI+2*NBPLAL
         IST(MCPLAG)  =2
         IST(MCPLAG+1)=NBNELI
         CALL EXBMOR (MCPLAG,IST(MCPLAG),NL,NBPLAL,MCPLAL,MCPLIL,DIMOBL
     &                                  ,NC,NBPLAU,MCPLAU,MCPLIU,DIMOBU)!utilite
*
         IF (ITYSYD.EQ.0) THEN
*
*--         Remplissage du tableau de stockage Bi-Morse superieur
*
            IST(MCPLAG)=MCPLIL+2*NBPLAL
            IST(IST(MCPLAG))=NBNECO
            CALL EXBMOR (MCPLAG,IST(MCPLAG),NL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                     ,NC,NBPLAU,MCPLAU,MCPLIU,LGU)!utilite
*           Nombre maximum de plages du tableau de stockage 'Bi-Morse' sup
            NBPLAX=(LGREEL-1-NBNELI-NBNECO-2*NBPLAL)/2
*           Mise a zero du sous-tableau NULAPU du tableau &BMORS
            DO 20 L=MCPLAU-1,MCPLIU-1
               IST(L)=0
20          CONTINUE
            NBPLAU=0
            MCGOLI=MCGNDO+IST(MCGNDO)-1
            MCGOCO=MCGNDO+1
*
            DO 21 L=1,NBELDO
*              Boucle sur les noeuds de l'element en colonne
               DO 121 JDL=1,IST(MCGOCO)
                  JGLO=IST(MCGOCO+JDL)
*                 Boucle sur les noeuds de l'element en ligne
                  DO 122 IDL=1,IST(MCGOLI)
                     IGLO=IST(MCGOLI+IDL)
                     IF (JGLO.GT.IGLO) THEN
                        CALL CMPLGN (JGLO,IGLO,NBNECO,NBPLAU
     &                              ,IST(MCPLAU-1),IST(MCPLIU),NBPLAX
     &                              ,IRCODE)                            !morse
                        IF (IRCODE.NE.0) GOTO 99992
                     ENDIF
122               CONTINUE
121            CONTINUE
               MCGOCO=MCGOCO+IST(MCGOCO)+1
               MCGOLI=MCGOLI+IST(MCGOLI)+1
21          CONTINUE
            IST(MCPLAU-1)=NBNECO
*
*           Prise en compte des colonnes sur-diagonales vides
            LASTPL=0
            DO 22 L=MCPLAU,MCPLIU-1
               IF (IST(L).LE.0) THEN
                  IST(L)=LASTPL
               ELSE
                  LASTPL=IST(L)
               ENDIF
22          CONTINUE
            IST(IST(MCPLAG))=NBNECO
            LGBMOR          =LGBMOR+NBNECO+2*NBPLAU
            CALL EXBMOR (MCPLAG,IST(MCPLAG),NL,NBPLAL,MCPLAL,MCPLIL
     &                  ,DIMOBL,NC,NBPLAU,MCPLAU,MCPLIU,DIMOBU)         !utilite
         ENDIF
*
         CALL TBAJST ('&BMORS',NVSTKB,LGBMOR)
         IF (IMPFCH.GT.0.AND.NIVIMP.GT.0) THEN
            CALL TBAR2 (ERCODE,'#OMDOM',1,MCMDOM,'&BMORS',NVSTKB,MCPLAG)
            MCMDOM=MCMDOM+NCHDOM*(NUDOG-1)-1
            DO 30 L=1,NCHDOM
               MCMDOM=MCMDOM+1
30             ERCODE(L:L)=AST(MCMDOM)
            CALL PRBMOR(IST(MCPLAG),' Stockage Bi-Morse,domaine'
     &                  ,ERCODE(1:NCHDOM),NUDOK,NIVIMP,IMPFCH)          !prsd
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*DskBmo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL TBAR1 (ERCODE,'#OMDOM',1,MCMDOM)
      MCMDOM=MCMDOM+NCHDOM*(NUDOG-1)-1
      DO 99981 NL=1,NCHDOM
         MCMDOM=MCMDOM+1
         ERCODE(NL:NL)=AST(MCMDOM)
99981 CONTINUE
      CALL ENCLER (IGLO,ERCODE(NCHDOM+1:NCHDOM+6))
      CALL ENCLER (L,ERCODE(NCHDOM+6:NCHDOM+11))
      CALL BAISE  ('Nombre de plages sous-estime dans la creation de la'
     &//' partie inferieure de la structure BiMorse sur le domaine '
     &//ERCODE(1:NCHDOM)
     &//' . Maximum atteint sur la ligne '//ERCODE(NCHDOM+1:NCHDOM+6)
     &//' dans l''element '//ERCODE(NCHDOM+6:NCHDOM+11)//'.')
99992 CALL TBAR1 (ERCODE,'#OMDOM',1,MCMDOM)
      MCMDOM=MCMDOM+NCHDOM*(NUDOG-1)-1
      DO 99982 L=1,NCHDOM
         MCMDOM=MCMDOM+1
         ERCODE(L:L)=AST(MCMDOM)
99982 CONTINUE
      CALL ENCLER (JGLO,ERCODE(NCHDOM+1:NCHDOM+6))
      CALL ENCLER (L,ERCODE(NCHDOM+6:NCHDOM+11))
      CALL BAISE  ('Nombre de plages sous-estime dans la creation de la'
     &//' partie superieure de la structure BiMorse sur le domaine '
     &//ERCODE(1:NCHDOM)
     &//' . Maximum atteint sur la colonne '//ERCODE(NCHDOM+1:NCHDOM+6)
     &//' dans l''element '//ERCODE(NCHDOM+6:NCHDOM+11)//'.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Correction d'un bug lorsque qu'un terme vide n'est pas un bloc diagonal
* Version 1.0.4 : D.Martin (25 Mars 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DskBmo
