*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSKMLH (NCHDOM,NUDOG  
     &                  ,NBNECO,NVNUMC,NBDLCO,NBNELI,NVNUML,NBDLLI
     &                  ,NVSTKM,MATDIM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (10 Avril 1996)
* Version 1.0.0
*  
* Transformation des tableaux de stockage 'Morse ligne' pour prendre
* en compte les d.l. d'Hermite
*  
*-- Arguments d'entree --
* NCHDOM nombre de caracteres par nom de domaine
* NBNECO nombre de noeuds pour l'interpolation en colonne
* NVNUMC niveau du tableau de numerotation en colonne
* NBDLCO nombre de d.l. en colonne
* NBNELI nombre de noeuds pour l'interpolation en ligne
* NVNUML niveau du tableau de numerotation en ligne
* NBDLLI nombre de d.l. en ligne
* NVSTKM niveau du tableau de stockage 'Morse' ('Morse-ligne')
* NIVIMP numero de niveau d'impression
* IMPFCH numero d'unite logique d'impression
*-- Arguments en sortie --
* MATDIM: Nombre de coefficients non nuls des matrices 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCHDOM,NUDOG,NBNECO,NVNUMC,NBDLCO,NBNELI,NVNUML,NBDLLI
     &       ,NVSTKM,MATDIM,NIVIMP,IMPFCH
*
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX'
*
      INTEGER MCNECO,MCNELI,MCPLAG,NBPLAG,MCMDOM,L,NUDOK
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL TBRR1 (ERCODE,'#GNEDO',NVNUMC,MCNECO)
      IF (NVNUML.NE.NVNUMC) CALL TBRR1 (ERCODE,'#GNEDO',NVNUML,MCNELI)
      CALL TBAR1 (ERCODE,'#GNEDO',NVNUMC,MCNECO)
      MCNELI=MCNECO  
      IF (NVNUML.NE.NVNUMC) CALL TBAR1 (ERCODE,'#GNEDO',NVNUML,MCNELI)
      CALL TBAR1 (ERCODE,'&PLAGE',NVSTKM,MCPLAG)
*
      CALL CMPHRM (NBNELI,IST(MCNELI+NBNELI+2),IST(MCNECO+NBNECO+2)     !morse
     &            ,IST(MCPLAG+3),IST(MCPLAG+4),IST(MCPLAG+4+NBNELI))
*
      IST(MCPLAG+1)=NBDLLI
      NBPLAG=IST(MCPLAG+3+NBNELI)
      IST(MCPLAG+2)=NBPLAG
      MATDIM=IST(MCPLAG+3+NBNELI+2*NBPLAG)
      IST(MCPLAG+3)=MATDIM
*
      IF (IMPFCH.GT.0.AND.NIVIMP.GT.0) THEN
         CALL TBAR1 (ERCODE,'#OMDOM',1,MCMDOM)
            MCMDOM=MCMDOM+NCHDOM*(NUDOG-1)-1
            DO 30 L=1,NCHDOM
               MCMDOM=MCMDOM+1
30             ERCODE(L:L)=AST(MCMDOM)
            CALL PRMORS (IST(MCPLAG),'L','Stockage Morse-L, domaine'
     &                  ,ERCODE(1:NCHDOM),NUDOK,NIVIMP,IMPFCH)          !prsd
      ENDIF
                                                                    END !DskMlh
