*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DSKNIV (NBTRDO,ITERDO,INCTRM,ISDTRM,NIVALL
     &                  ,NVSTKB,NVSTKL,NVSTKC,ITYSYD)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)
* Derniere modification : D.Martin (25 Mars 2002)
* Version 1.0.1
*  
* Recherche des niveaux des tableaux de stockage BiMorse, Morse-Ligne,
* Morse-Colonne et de l'indicateur de symetrie des termes du domaine
*  
*-- Arguments d'entree --  
* NBTRDO: nombre de choses a faire sur le domaine (vachement clair)
*         En fait NBTRDO est la somme des nombres de matrices E.F.,
*         de conditions essentielles, de conditions de transmission, etc...
* ITERDO: structure #TERDO a l'adresse du 1er terme du domaine 
* INCTRM: increment de parcours sequentiel de la structure $SDTRM  
* ISDTRM: structure $SDTRM a l'adresse du premier terme
* NIVALL: niveau commun des structures du domaine
*-- Arguments de sortie --
* NVSTKB: niveau de la structure de compactage Bi-Morse pour le domaine
* NVSTKL: niveau de la structure de compactage Morse (ligne) pour le domaine 
* NVSTKB: niveau de la structure de compactage Morse-Colonne pour le domaine
* ITYSYD: indicateur de symetrie des termes du domaine 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBTRDO,ITERDO(*),INCTRM,ISDTRM(*),NIVALL,NVSTKB
     &             ,NVSTKL,NVSTKC,ITYSYD
*
      INTEGER       INDSTO,INTYKL,KLNIVE
      INTEGER       INDSTB,INDSTL,INDSTC,INTYEF,INTFOR,ITERM ,NUTERM
     &             ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &             ,NVNUML,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP
     &             ,KC,IC,KL,IL,INSYME
*-----------------------------------------------------------------------
      INDSTB=INDSTO ('BIMORSE')                                         !utilite
      INDSTL=INDSTO ('MORSE-L')                                         !utilite
      INDSTC=INDSTO ('MORSE-C')                                         !utilite
      INTYEF=INTYKL ('ELFINI')                                          !utilite
      INTFOR=INTYKL ('FORMLI')                                          !utilite
      DO 1 ITERM=1,NBTRDO  
         NUTERM=ITERDO(ITERM)  
         IF (NUTERM.GT.0) THEN
            CALL GETTRM (ISDTRM(1+INCTRM*(NUTERM-1)),NIVTRM,ITYPTR
     &                  ,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR,NUINCC
     &                  ,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &                  ,NVNUML,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP)     !sdexplo
*           Si on n'a pas redemande le calcul, on passe au suivant !
            IF (NUKALE.LE.0) GOTO 1
            IF (ITYCAL.EQ.INTYEF) THEN
*              Si le terme ne correspond pas a une matrice E.F.
               CALL INTATR (NUKALE,KC,IC,KL,IL,INSYME)                  !integra
*              Pour les termes unicolonne, pas de compactage !
               IF (KC.GE.0) THEN
                  IF (NVSTOK.GT.0) THEN
*                    Le terme a un niveau de type de stockage
                     IF (INDSTK.EQ.INDSTB)      THEN
                        NVSTKB=-NIVALL
                     ELSEIF (INDSTK.EQ.INDSTL) THEN
                        NVSTKL=-NIVALL
                     ELSEIF (INDSTK.EQ.INDSTC) THEN
                        NVSTKC=-NIVALL
                     ENDIF
                  ELSE
                     IF (NIVALL.LE.0) NIVALL=KLNIVE()                   !sdexplo
                     IF (NUINCC.EQ.NUINCL)     THEN
*                       Inconnues identiques en ligne et colonne 
*                       ==> Stockage BiMorse
                        NVSTKB=NIVALL
                        IF (INSYME.EQ.0) ITYSYD=0
                     ELSEIF (NUINCC.LT.NUINCL) THEN
*                       ==> Stockage Morse-Ligne
                        NVSTKL=NIVALL
                     ELSE
*                       ==> Stockage Morse-Colonne
                        NVSTKC=NIVALL
                     ENDIF
                  ENDIF
               ENDIF
            ELSEIF (ITYCAL.EQ.INTFOR) THEN
*              Le terme est une forme lineaire ponctuelle ???
               IF (NVSTOK.GT.0) THEN
*                 Le terme a un niveau de type de stockage
                  IF (INDSTK.EQ.INDSTB)     THEN
                     NVSTKB=-NIVALL
                  ELSEIF (INDSTK.EQ.INDSTL) THEN
                     NVSTKL=-NIVALL
                  ELSEIF (INDSTK.EQ.INDSTC) THEN
                     NVSTKC=-NIVALL
                  ENDIF
               ELSE
                  IF (NIVALL.LE.0) NIVALL=KLNIVE()                      !sdexplo
                  IF (NUINCC.EQ.NUINCL)     THEN
*                    Inconnues identiques en ligne et colonne 
*                    ==> Stockage BiMorse
                     NVSTKB=NIVALL
                     IF (INSYME.EQ.0) ITYSYD=0
                  ELSEIF (NUINCC.LT.NUINCL) THEN
*                    ==> Stockage Morse-Ligne
                     NVSTKL=NIVALL
                  ELSE
*                    ==> Stockage Morse-Colonne
                     NVSTKC=NIVALL
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
1     CONTINUE  
                                                                    END !DskNiv
