*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFADFB (LGMAX,LGFBAS,LGDBAS,NBPTQ,KELFCT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)
* Derniere modification : D.Martin (10 mars 1994)
* Version 1.0.0
*  
* Calcul des longueurs des tableaux pour le stockage des fonctions de base 
* et de leurs derivees en tous les points de quadrature, lorsque la place  
* en memoire centrale est suffisante.
*  
*-- Arguments --
* LGMAX  longueur disponible en memoire centrale
* LGFBAS en entree longueur du tableau de fonctions de base en 1 point
* LGDBAS en entree longueur du tableau de derivees des fct. de base en 1 point
*        en sortie les memes mais pour tous les points si possible
* NBPTQ : nombre de points de quadrature
*-- Arguments de sortie --
* KELFCT ='Y' implique place suffisante pour conserver les calculs en M.C.
*        pour les fonctions de base et derivees de l'interpolation
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER KELFCT
      INTEGER   LGMAX,LGFBAS,LGDBAS,NBPTQ
*-----------------------------------------------------------------------
      IF (LGMAX.LT.(LGFBAS+LGDBAS)*(NBPTQ-1)) RETURN
      KELFCT='Y'
      LGFBAS=NBPTQ*LGFBAS
      LGDBAS=NBPTQ*LGDBAS
      LGMAX=LGMAX-LGFBAS-LGDBAS 
                                                                    END !EFAdfb
