*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFADRS (NBTRDO,ITERDO,NOMTRM,NCHTRM,NOMDON,NCHDON
     &                  ,IDONNE,INDTRD,MCESTE,MCRSTE,MCCSTE,TABASS
     &                  ,TYPDON,NODOAA,NODONA,NOMTRA
     &                  ,AST,IST,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)  
* Derniere modification : D.Martin (10 novembre 2002)
* Version 1.0.3
*  
* Reperage des adresses des termes elements finis et des tableaux associes 
*  
*-- Arguments --  
* NBTRDO nombre de 'choses' sur le domaine en cours
* ITERDO tableau #TERDO pour le domaine de calcul en cours
* NOMTRM tableau des noms de terme
* NCHTRM nombre de caracteres par nom de terme
* NOMDON tableau des noms de donnees  
* NCHDON nombre de caracteres par nom de donnee
* INDTRD structure locale de description des termes du domaine
*   Contenu du tableau INDTRD pour le terme numero NUINT
*     (NUINT)           niveau, puis adresse absolue du terme dans RST,CST
*     (NUINT+   NBTRDO) adresses relatives des matrices elementaires  
*                       dans le tableau des matrices elementaires du bon type
*     (NUINT+ 2*NBTRDO) adresses relatives des tableaux locaux de valeurs  
*                       nodales dans le tableau des matrices elementaires
*     (NUINT+ 3*NBTRDO) indice de type de declaration REEL ou COMPLEXE du terme
*     (NUINT+ 4*NBTRDO) indice de type de calcul (ITYCAL)
*     (NUINT+ 5*NBTRDO) numero d'integrand (NUKALE)
*     (NUINT+ 6*NBTRDO) nombre de composantes de l'inconnue en colonne
*     (NUINT+ 7*NBTRDO) type d'interplation de l'inconnue en colonne
*     (NUINT+ 8*NBTRDO) nombre de noeuds de l'inconnue en colonne
*                       ou nombre de fonctions propres (inconnue spectrale)
*     (NUINT+ 9*NBTRDO) nombre de composantes de l'inconnue en ligne
*     (NUINT+10*NBTRDO) type d'interplation de l'inconnue en ligne
*     (NUINT+11*NBTRDO) nombre de noeuds de l'inconnue en ligne
*                       ou nombre de fonctions propres (inconnue spectrale)
*     (NUINT+12*NBTRDO) numero de donnee affectee si cette donnee est de type
*                       FONCTION ou TABLEAU
*     (NUINT+13*NBTRDO) type de la donnee associee (CONSTANTE,FONCTION,TABLEAU) 
*     (NUINT+14*NBTRDO) niveau ou numero de la donnee affectee au terme (NIVDON)  
*     (NUINT+15*NBTRDO) type du resultat de la donnnee associee (REEL,COMPLEXE) 
*     (NUINT+20*NBTRDO) niveau d'impression du terme
*   de plus si la donnee affectee au terme est un tableau ou une fonction
*     (NUINT+16*NBTRDO) adresse du tableau associe au terme ou
*                       de la constante ou du tableau associe a la fonction
*     (NUINT+17*NBTRDO) type (CONSTANTE ou TABLEAU) associe a la fonction
*     (NUINT+18*NBTRDO) type du resultat (REEL, COMPLEXE) associe a la fonction
*     (NUINT+19*NBTRDO) nombre de composantes par noeud pour une donnee
*                       associee de type TABLEAU
* MCESTE adresse du tableau des constantes entieres
* MCRSTE adresse du tableau des constantes reelles
* MCCSTE adresse du tableau des constantes complexes  
* TABASS indicateur de presence d'un vecteur nodale elementaire
* TYPDON chaine de caractere receptrice du type d'une donnee
* NODOAA chaine de caractere receptrice d'un nom de donnee associee
* NODONA chaine de caractere receptrice d'un nom de donnee
* NOMTRA chaine de caractere receptrice d'un nom de terme 
* NIVIMP niveau d'impression pour le domaine  
* IMPFCH numero d'unite logique d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER     AST(*),TABASS,NOMTRM(*),NOMDON(*)
      CHARACTER*(*) TYPDON,NODOAA,NODONA,NOMTRA
      INTEGER       NBTRDO,NCHTRM,NCHDON,MCESTE,MCRSTE,MCCSTE
     &             ,NIVIMP,IMPFCH
     &             ,IST(*),ITERDO(*),IDONNE(*),INDTRD(*)
      REAL          RST(*)
      COMPLEX       CST(*)

      CHARACTER     ERCODE*120,DONINT*9,TYPINT*9
      INTEGER       INTDON,INTDCO,INTDFO,INTDTA,NUINT,NUTERM,NIVTRM
     &             ,ITYPTR,NUKALE,NUDONN,ITYDON,NIVDON,ITYPDO,MCTERM
     &             ,LGTERM,ITYRAS,ITYASS,MCASSO,NIVASS
      COMMON/FORMAH/ERCODE   
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EFAdrs*')
*
      IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) WRITE (IMPFCH,10000)
*
      INTDCO=INTDON ('CONSTANTE')                                       !utilite
      INTDFO=INTDON ('FONCTION')                                        !utilite
      INTDTA=INTDON ('TABLEAU')                                         !utilite
      TABASS='N'
*
      DO 10 NUINT=1,NBTRDO
         NUTERM=ITERDO(NUINT)
         NIVTRM=INDTRD(NUINT)
         ITYPTR=INDTRD(NUINT+3*NBTRDO)
         NUKALE=INDTRD(NUINT+5*NBTRDO)
         NUDONN=ABS (INDTRD(NUINT+12*NBTRDO))
         ITYDON=INDTRD(NUINT+13*NBTRDO)
         NIVDON=INDTRD(NUINT+14*NBTRDO)
         ITYPDO=INDTRD(NUINT+15*NBTRDO)
*
         IF (NUKALE.GT.0) THEN
*
*           Nom du terme courant
            CALL GETCHN (NOMTRM,NCHTRM,NUTERM,NOMTRA)                   !utilite
*           Longueur du terme courant
            CALL TBARTI (NOMTRA(1:NCHTRM),NIVTRM,LGTERM)
*           Adresse du terme courant
            CALL TBAR1  (ERCODE,NOMTRA(1:NCHTRM),NIVTRM,MCTERM)
*           Mise a zero du terme courant
            CALL TAZERO (LGTERM,TYPINT(ITYPTR),MCTERM,AST,IST,RST,CST)  !utilite
*           En cas de defaut de donnee affectee au terme
            ITYRAS=ITYDON
            ITYASS=ITYPDO
            MCASSO=1
*
            IF (NUDONN.GT.0) THEN
*
*              Recherche des caracteristiques de la donnee affectee au terme
*
               NODONA=' '
*              Nom de la donnee associee
               CALL GETCHN (NOMDON,NCHDON,NUDONN,NODONA)                !utilite
*              Type de la donnee associee
               TYPDON=DONINT (ITYDON)                                   !utilite
*
               IF (TYPDON(1:4).EQ.'TABL') THEN
*
*                 Adresse absolue du tableau affecte au terme (MCASSO)
*
                  CALL TBAR1  (ERCODE,NODONA(1:NCHDON),NIVDON,MCASSO)
                  ITYRAS=ITYDON
                  ITYASS=ITYPDO
                  TABASS='Y'
*
               ELSEIF (ITYDON.EQ.INTDFO) THEN
*
                  IF (NIVDON.GT.0) THEN
*
*                    Caracteristiques de la donnee associee a la donnee
*                    fonction affectee au terme courant
*
                     CALL GETCHN (NOMDON,NCHDON,NIVDON,NODOAA)          !utilite
                     CALL SDEXCO (NIVDON,IDONNE,ITYRAS,NIVASS,ITYASS)   !utilite
                     TYPDON=DONINT (ITYRAS)                             !utilite
*
                     IF (TYPDON(1:4).EQ.'TABL') THEN
*                       Adresse du tableau associe a la donnee
*                       fonction affectee au terme courant
                        CALL TBAR1  (ERCODE,NODOAA(1:NCHDON),NIVASS
     &                              ,MCASSO)                     
                     ELSEIF (ITYRAS.EQ.INTDCO) THEN
                        TYPDON=TYPINT (ITYASS)                          !utilite
*                       Adresse de la constante associee a la donne
*                       fonction affectee au terme courant, selon son type
                        IF (TYPDON(1:2).EQ.'RE') THEN
                           MCASSO=MCRSTE+NIVASS
                        ELSEIF (TYPDON(1:2).EQ.'CO') THEN
                           MCASSO=MCCSTE+NIVASS
                        ELSEIF (TYPDON(1:2).EQ.'EN') THEN
                           MCASSO=MCESTE+NIVASS
                        ENDIF
                     ENDIF
                  ENDIF
*
               ENDIF
            ENDIF
*
*           On remplace le niveau du terme NIVTRM par son adresse.
*
            INDTRD(NUINT)          =MCTERM
            INDTRD(NUINT+16*NBTRDO)=MCASSO
            INDTRD(NUINT+17*NBTRDO)=ITYRAS
            INDTRD(NUINT+18*NBTRDO)=ITYASS
*
            IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
               WRITE (IMPFCH,10001) NOMTRA(:NCHTRM),NIVTRM
     &                             ,TYPINT(ITYPTR)                      !utilite
               IF (NUDONN.GT.0) WRITE (IMPFCH,10002) DONINT(ITYDON)
     &                         ,TYPINT(ITYPDO),NIVDON,NODONA(:NCHDON)   !utilite
               WRITE (IMPFCH,10003) INDTRD(NUINT),INDTRD(NUINT+NBTRDO) 
               IF (ITYDON.EQ.INTDFO) WRITE (IMPFCH,10004) MCASSO,ITYRAS
               IF (ITYDON.EQ.INTDTA) WRITE (IMPFCH,10004) MCASSO
            ENDIF
         ENDIF
10    CONTINUE
      CALL PRFXMJ (-1,'*EFAdrs*')
*-----------------------------------------------------------------------
10000 FORMAT(/' *EFAdrs* Adresses des termes, des matrices elementaires'
     &,', et des eventuels tableaux associes')
10001 FORMAT(T9,'Terme  : ',A,' , de niveau :',I6,', de type ',A)
10002 FORMAT(T9,'Donnee : ',A,' de type ',A,' , de niveau ',I6,' : ',A)
10003 FORMAT(T9,'Adresse absolue du terme     ',I12 
     &,', Adresse relative de la matrice elementaire',I6)
10004 FORMAT(T9,'Adresse de la donnee associee',I12,:
     &,', Type de la donnee associee                ',I6)
                                                                    END !EFAdrs
