*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFATRI (NDIM,NDMDOM,NBTRDO,ITERDO,NOMTRM,ISDTRM
     &                  ,INCONU,NOMDON,NCHDON,IDONNE,INDTRD,LGTABB
     &                  ,INTRPC,NBDLXC,NBDFXC,KELFCC
     &                  ,INTRPL,NBDLXL,NBDFXL,KELFCL
     &                  ,INTRPG,NBDLXG,NBDFXG,KELFCG,NODONA,NOMTRA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 1988)
* Derniere modification : D.Martin & C.Chambeyron (15 novembre 2002)
* Version 1.0.5
*  
* Calcul de la longueur max. pour le domaine de calcul des matrices elementaires
*     des longueurs des tableaux de valeurs nodales associees,
*     de la longueur des tableaux pour les fonctions de base et leurs derivees
*  et des indices de calcul des fonctions de base .  
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* NDMDOM dimension du domaine geometrique
* NBTRDO nombre de termes sur le domaine de calcul
* ITERDO tableau #TERDO a l'adresse du numero du 1er terme du domaine
* NOMTRM tableau des noms de termes
* ISDTRM tableau $SDTRM des caracteristiques des termes
* NOMDON tableau des noms de donnees
* NCHDON nombre de caracteres par nom de donnee
* INCONU structure #NCONU a l'adresse 1
* IDONNE tableau $DONNE a l'adresse 1
* INDTRD structure locale de description des termes du domaine
*   Contenu du tableau INDTRD pour le terme numero NUINT
*     (NUINT)           niveau, puis adresse absolue du terme dans RST,CST
*     (NUINT+   NBTRDO) adresses relatives des matrices elementaires  
*                       dans le tableau des matrices elementaires du bon type
*     (NUINT+ 2*NBTRDO) adresses relatives des tableaux locaux de valeurs  
*                       nodales dans le tableau des matrices elementaires
*     (NUINT+ 3*NBTRDO) indice de type de declaration REEL ou COMPLEXE du terme
*     (NUINT+ 4*NBTRDO) indice de type de calcul (ITYCAL)
*     (NUINT+ 5*NBTRDO) numero d'integrand (NUKALE)
*     (NUINT+ 6*NBTRDO) nombre de composantes de l'inconnue en colonne
*     (NUINT+ 7*NBTRDO) type d'interplation de l'inconnue en colonne
*     (NUINT+ 8*NBTRDO) nombre de noeuds de l'inconnue en colonne
*                       ou nombre de fonctions propres (inconnue spectrale)
*     (NUINT+ 9*NBTRDO) nombre de composantes de l'inconnue en ligne
*     (NUINT+10*NBTRDO) type d'interplation de l'inconnue en ligne
*     (NUINT+11*NBTRDO) nombre de noeuds de l'inconnue en ligne
*                       ou nombre de fonctions propres (inconnue spectrale)
*     (NUINT+12*NBTRDO) numero de donnee affectee si cette donnee est de type
*                       FONCTION ou TABLEAU
*     (NUINT+13*NBTRDO) type de la donnee associee (CONSTANTE,FONCTION,TABLEAU) 
*     (NUINT+14*NBTRDO) niveau ou numero de la donnee affectee au terme (NIVDON)  
*     (NUINT+15*NBTRDO) type du resultat de la donnnee associee (REEL,COMPLEXE) 
*     (NUINT+20*NBTRDO) niveau d'impression du terme
*   de plus si la donnee affectee au terme est un tableau ou une fonction
*     (NUINT+16*NBTRDO) adresse du tableau associe au terme ou
*                       de la constante ou du tableau associe a la fonction
*     (NUINT+17*NBTRDO) type (CONSTANTE ou TABLEAU) associe a la fonction
*     (NUINT+18*NBTRDO) type du resultat (REEL, COMPLEXE) associe a la fonction
*     (NUINT+19*NBTRDO) nombre de composantes par noeud pour une donnee
*                       associee de type TABLEAU
* LGTABB tableau de travail
*     Contenu du tableau LGTABB
*     ( 1) longueur cumulee des matrices elementaires reelles
*     ( 2) longueur cumulee des matrices elementaires complexes 
*     ( 3) LGJACO, longueur de la matrice jacobienne
*     ( 4) LGJAJA, longueur de la matrice jacobienne inverse x par sa transposee
*     ( 5) LGFCTC, longueur du tab. des fcts. de base pour l'inter. en colonne
*     ( 6) LGFCTL, idem pour l'interpolation en ligne
*     ( 7) LGFCTG, idem pour l'interpolation geometrique
*     ( 8) LGDFCC, longueur du tab. des derivees des fcts de base pour l'interp.
*                  en colonne
*     ( 9) LGDFCL, idem pour l'interpolation en ligne
*     (10) LGDFCG, idem pour l'interpolation geometrique
* INTRPC indice de l'interpolation en colonne sur le domaine de calcul
* NBDLXC nombre max. de d.l. en colonne par element 'volumique' du domaine
* NBDFXC nombre max. de d.l. en colonne par face d'element du domaine
* KECFCC indice de calcul des fonctions de base pour l'interp. en colonne
*     (1:1)='Y' ==> calcul des fonctions de base
*     (2:2)='Y' ==> calcul des derivees des fonctions de base
*     (3:3)='Y' ==> calcul des derivees secondes des fct. de base
*     (4:4)='C' ==> calculs selon l'interpolation en 'colonne'
*           'G' ==> calculs selon l'interpolation geometrique
*     (5:5)='Y' ==> on conserve les calculs en tous les points
*                   de quadrature pour l'element suivant
*     (6:6)='Y' ==> implique le calcul de la matrice jacobienne dans
*                   tout l'element(integrands contenant une derivee)
*                   inutilise pour les calculs en dimension d'espace
* INTRPL indice de l'interpolation en ligne sur le domaine de calcul
* NBDLXL nombre max. de d.l. en ligne par element 'volumique' du domaine  
* NBDFXL nombre max. de d.l. en ligne par face d'element du domaine 
* KELFCL indice de calcul des fonctions de base pour l'interp. en ligne
* INTRPG indice de l'interpolation geometrique
* NBDLXG nombre max. de points par element 'volumique' du domaine 
* NBDFXG nombre max. de points par face d'element du domaine
* KELFCG indice de calcul des fonctions de base geometriques  
*     (i:i) , i=1,2,3 ==> cf. KELFCC 
*     (4:4) inutilise
*     (5:5) ==> cf. KELFCC ou KELFCL 
*     (6:6) ==> impose le calcul effectif des fonctions de base de l'interpol.
*               geometrique (e.g. dans le cas d'un integrand a coeff. variable)
* NODONA chaine de caractere receptrice d'un nom de donnee
* NODONA chaine de caractere receptrice d'un nom de term
*-----------
* Remarques: Si les interpolations en colonne et ligne coincident,on ne retient
*           que les parametres de l'interpolation en colonne.
*            De meme si l'une des interpolations en colonne ou en ligne coincide
*           avec l'interpolation geometrique,on ne retient que les parametres
*           de l'interpolation geometrique.
*            Ceci est une sordide histoire de calcul des longueurs des tableaux
*           recepteurs des fonctions de base et de leurs derivees (cf.ECOBAS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER     NOMTRM(*),NOMDON(*)
      CHARACTER*(*) KELFCC,KELFCL,KELFCG,NODONA,NOMTRA
      INTEGER       NDIM,NDMDOM,NBTRDO,NCHDON
     &             ,INTRPC,NBDLXC,NBDFXC,INTRPL,NBDLXL,NBDFXL
     &             ,INTRPG,NBDLXG,NBDFXG
     &             ,ITERDO(*),INDTRD(*),IDONNE(*),LGTABB(*)
     &             ,ISDTRM(*),INCONU(*)
*     Variables locales
      INTEGER       INTDON,INTTYP,INTYKL,KLTERM
      INTEGER       LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,INTFON,IB,NDOM,INTTAB,INTCOM,INTYEL,INTYQU,INTYME
     &             ,NUINT,NUTERM,NIVTRM,ITYPTR,ITYCAL,KINTEG,NUDONN
     &             ,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &             ,NVDUML,NBLIGN,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO
     &             ,NIVIMP,NTABAS,TAYINT
     &             ,NCPINC,INTINC,NBTNEC,NCPINL,INTINL,NBTNEL
     &             ,ITYDON,NIVDON,ITYPDO,NVALNE,NUDONA
      CHARACTER     ERCODE*1
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EfAtri*')
*  
*     Longueurs pour les matrices elementaires et la matrice jacobienne
      LGTABB(1)=1  
      LGTABB(2)=1  
      LGTABB(3)=0
      LGTABB(4)=0
*     Initialisation des parametres pour les fonctions de base en colonne
*     (longueur effective calculee dans INTTAY)
      KELFCC='NNNCNN'
      LGTABB( 5)=0
      LGTABB( 8)=0
*     Initialisation des parametres pour les fonctions de base en ligne
*     (longueur effective calculee dans INTTAY)
      KELFCL='NNNLNN'
      LGTABB( 6)=0
      LGTABB( 9)=0
*     Initialisation des parametres pour les fonctions de base geometriques :  
*     On a toujours besoin des derivees
*     (longueur effective calculee dans INTTAY)
      KELFCG='NYNGNN'
      LGTABB( 7)=0
*     Dimension des derivees des fonctions de bases (=NDIM ou NDMDOM)
*     (valeur effective calculee dans INTTAY)
      NDOM=NDMDOM
      LGTABB(10)=NBDFXG
*  
*     Boucle sur les integrands sur le domaine de calcul pour determiner
*     les indices de calculs des fonctions de base et derivees et les  
*     longueurs des tableaux recepteurs (FCTB? et DFCTB?)  
*     Dans un premier temps ces calculs sont effectues comme si toutes 
*     les interpolations (en colonne, en ligne et geometrique) sont 
*     distinctes . 
      INTTAB=INTDON ('TABLEAU')                                         !utilite
      INTFON=INTDON ('FONCTION')                                        !utilite
      INTCOM=INTTYP ('COMPLEXE')                                        !utilite
      INTYEL=INTYKL ('ELFINI')                                          !utilite
      INTYME=INTYKL ('MATELM')                                          !utilite
      INTYQU=INTYKL ('ELFLQU')                                          !utilite 
* 
      CALL SDEXDB (ISDTRM,LGETRM,NBTERM,INCTRM,NCHTRM)                  !sdexplo
* 
      DO 1 NUINT=1,NBTRDO 
         NUTERM=ITERDO(NUINT)  
         CALL GETTRM (ISDTRM(LGETRM+INCTRM*(NUTERM-1)+1),NIVTRM
     &               ,ITYPTR,ITYCAL,KINTEG,NUDONN,ITYSYM,IPTDIR
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INDSTK,NVNUMS,NVCORC,IATRDO,NIVIMP)               !sdexplo
*
         NTABAS=0  
         TAYINT=0
         IF ((ITYCAL.EQ.INTYEL.OR.ITYCAL.EQ.INTYME.OR.ITYCAL.EQ.INTYQU)
     &    .AND.KINTEG.GT.0)  THEN
*
            CALL INTTAY (KINTEG,NDIM,NDMDOM,NBDLXC,NBDFXC,NBDLXL,NBDFXL 
     &                  ,NBDLXG,NBDFXG,NDOM,LGTABB,KELFCC,KELFCL,TAYINT)!integra
*         
            NCPINC=1
            IF (NUINCC.GT.0)
     &         CALL SDEXCO (NUINCC,INCONU,NCPINC,INTINC,NBTNEC)         !sdexplo
            NCPINL=1
            IF (NUINCL.GT.0)
     &         CALL SDEXCO (NUINCL,INCONU,NCPINL,INTINL,NBTNEL)         !sdexplo
*
*           Taille occupee par l'integrale elementaire
*
            TAYINT=NCPINC*NCPINL*TAYINT
*           Pour les E.F.Localises calcules par quadrature ...
            IF (ITYCAL.EQ.INTYQU) THEN
               IF (INTINC.EQ.-1) TAYINT=TAYINT*NBTNEC
               IF (INTINL.EQ.-1) TAYINT=TAYINT*NBTNEL
            ENDIF
*
            INDTRD(NUINT)          =NIVTRM
            INDTRD(NUINT+ 3*NBTRDO)=ITYPTR
            INDTRD(NUINT+ 4*NBTRDO)=ITYCAL
            INDTRD(NUINT+ 5*NBTRDO)=KINTEG
            INDTRD(NUINT+ 6*NBTRDO)=NCPINC
            INDTRD(NUINT+ 7*NBTRDO)=INTINC
            INDTRD(NUINT+ 8*NBTRDO)=NBTNEC
            INDTRD(NUINT+ 9*NBTRDO)=NCPINL
            INDTRD(NUINT+10*NBTRDO)=INTINL
            INDTRD(NUINT+11*NBTRDO)=NBTNEL
            INDTRD(NUINT+20*NBTRDO)=NIVIMP
*
            IF (NUDONN.GT.0) THEN
*  
*              Integrales a coeff. variable interpole ou donne par fonction 
*
               NVALNE=1
               ITYDON=0
               NIVDON=0
               ITYPDO=0
*  
               CALL SDEXCO (NUDONN,IDONNE,ITYDON,NIVDON,ITYPDO)         !sdexplo 
*
               IF (ITYDON.EQ.INTTAB) THEN
*                 L'integrand contient un coefficient variable interpole
*                 fourni par une donnee associee de type 'TABLEAU'
*                 qui est necessairement un Terme 'Valeurs Nodales'.
*                 L'indice d'interpolation est celui de l'inconnue en colonne
*
*                 Nom de la donnee Tableau affectee, son niveau est NIVDON
*                 On utilisera un tableau de valeurs nodales local (elementaire)
*                 pour transporter ces valeurs dans les calculs elementaires
*                 voir EfVnlo & CalInt
*                 Recherche du nombre de Valeurs par noeud : NVALNE
                  CALL GETCHN (NOMDON,NCHDON,NUDONN,NODONA)             !utilite
                  NOMTRA(1:NCHTRM)=NODONA(1:NCHDON)
                  NUTERM=KLTERM (NOMTRA(1:NCHTRM),NIVDON,NOMTRM,ISDTRM) !sdexplo
                  IF (NUTERM.LE.0) 
     &               CALL ERTERM (1,NOMTRA(1:NCHTRM),NIVDON)            !utilite
                  CALL GETTRM (ISDTRM(LGETRM+INCTRM*(NUTERM-1)+1),NIVTRM
     &                        ,ITYPTR,ITYCAL,KINTEG,NUDONA,NVALNE,IPTDIR
     &                        ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &                        ,NUINCL,NVDUML,NBLIGN,NVNUML
     &                        ,INDSTK,NVNUMS,NVCORC,IATRDO,NIVIMP)      !sdexplo
*
                  LGTABB( 5)=NBDFXC
                  KELFCC(1:1)='Y'
*                 Longueur du tableau de 'valeurs nodales' local
                  NTABAS=NBDFXC*NVALNE
                  IF (ITYPTR.EQ.INTCOM) THEN
                     INDTRD(NUINT+2*NBTRDO)=LGTABB(2)+TAYINT
                  ELSE
                     INDTRD(NUINT+2*NBTRDO)=LGTABB(1)+TAYINT
                  ENDIF
               ELSEIF (ITYDON.EQ.INTFON) THEN
*                 L'integrand contient un coefficient variable fourni
*                 par un donnee associee de type 'FONCTION' :
*                 on a besoin de la transformation
*                     Element de Reference --> Element courant
*                 pour transporter les points de quadrature
                  LGTABB( 7)=NBDFXG
                  KELFCG(1:1)='Y'
                  KELFCG(6:6)='Y'
               ELSE
                  NUDONN=-NUDONN
               ENDIF
               INDTRD(NUINT+12*NBTRDO)=NUDONN
               INDTRD(NUINT+13*NBTRDO)=ITYDON 
               INDTRD(NUINT+14*NBTRDO)=NIVDON 
               INDTRD(NUINT+15*NBTRDO)=ITYPDO
               INDTRD(NUINT+19*NBTRDO)=NVALNE
            ENDIF
*
*           Adresses relatives des integrales elementaires et
*           tailles des tableaux reel ou complexe les contenant
*
            IF (ITYPTR.EQ.INTCOM) THEN 
               INDTRD(NUINT+NBTRDO)=LGTABB(2) 
               LGTABB(2)=LGTABB(2)+TAYINT+NTABAS  
            ELSE  
               INDTRD(NUINT+NBTRDO)=LGTABB(1) 
               LGTABB(1)=LGTABB(1)+TAYINT+NTABAS
            ENDIF
         ENDIF
1     CONTINUE
      LGTABB( 8)=NDOM*LGTABB( 8)
      LGTABB( 9)=NDOM*LGTABB( 9)
      LGTABB(10)=NDOM*LGTABB(10)
      LGTABB(1)=LGTABB(1)-1
      LGTABB(2)=LGTABB(2)-1
*  
*     Cas ou les indices d'interpolation en ligne et colonne coincident  
*     (Elements finis non mixtes) ==> Les fonctions de base des interpolations 
*     en colonne et ligne occcupent les memes tableaux (cf. Eftbad, Efadfb)
*
      IF (INTRPL.EQ.INTRPC) CALL EFRPFB
     & (KELFCC,LGTABB( 5),LGTABB( 8),KELFCL,LGTABB( 6),LGTABB( 9))      !caltrm
*  
*     Si l'un des indices d'interpolations en colonne ou en ligne coincide
*     avec celui de l'interpolation geometrique, ses fonctions de base 
*     occupent les memes tableaux que celles de l'interpolation geometriques.
*
      IF (INTRPC.EQ.INTRPG) CALL EFRPFB
     & (KELFCG,LGTABB( 7),LGTABB(10),KELFCC,LGTABB( 5),LGTABB( 8))      !caltrm
      IF (INTRPL.EQ.INTRPG) CALL EFRPFB
     & (KELFCG,LGTABB( 7),LGTABB(10),KELFCL,LGTABB( 6),LGTABB( 9))      !caltrm
*
      CALL PRFXMJ (-1,'*EfAtri*')  
                                                                    END !EfAtri
