*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFQLTR (NDMDOM,NDMDOE,NBELDO,NXLIST,INCRDO,NXDODO
     &                  ,NBTRDO,NBPTQX,NBDLXG,NBDFXG,NVNUMC,NVNUML
     &                  ,NVSTKB,NVSTKL,NVSTKC,KALTEF,KALTME,KALTQU
     &                  ,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1988)
* Derniere modification : D.Martin & C.Chambeyron (11 novembre 2002) 
* Version 1.0.5
*
* Calculs des termes elements finis sur un domaine  
*  
*-- Arguments --  
* NDMDOM dimension (des constituants) du domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NBELDO nombre d'elements (de dimension NDMDOM) du domaine
* NXLIST adresse relative des numeros d'elements dans le tableau #ISTEL
*        pour le domaine en cours
* INCRDO nombre d'attributs d'un domaine de calcul
* NXDODO adressse relative dans #TERDO des caracteristiques du domaine en cours
* NBTRDO nombre de 'termes' a calculer sur le domaine
* NBPTQX nombre maximum de points de quadrature sur un element du domaine
* NBDLXG nombre max. de points (d.l. geometriques) sur un element du domaine
* NBDFXG idem mais pour une face de dimension NDMDOM  
* NVNUMC niveau du tableau #GNEDO de numerotation des noeuds en colonne
* NVNUML niveau du tableau #GNEDO de numerotation des noeuds en ligne
* NVSTKB niveau du tab. &BMORS de stockage BiMorse des termes du domaine 
* NVSTKL niveau du tab. &PLAGE de stockage Morse-Ligne des termes du domaine
* NVSTKC niveau du tab. &EGALP de stockage Morse-Colonne des termes du domaine
* KALTEF indicateur de calcul de matrices elementaires 'ElFini'
* KALTME indicateur de calcul de matrices elementaires 'MatElm'
* KALTQU indicateur de calcul de matrices elementaires 'ElFLQu'
* IMPFCH unite d'impression des messages
*  
* ATTENTION : Dans ce sous-programme et tous ceux qu'il appelle, 
*             on utilise de maniere totalement illicite le COMMON/FORMAH/
*             pour transporter KELFCC,KELFCL,KELFCG
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER  KALTEF,KALTME,KALTQU
      INTEGER    NDMDOM,NDMDOE,NBELDO,NXLIST,INCRDO,NXDODO,NBTRDO,NBPTQX
     &          ,NBDLXG,NBDFXG,NVNUMC,NVNUML,NVSTKB,NVSTKL,NVSTKC,IMPFCH
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*     Variables locales
      INTEGER    LGWORK,MCWORK,LGWOR0,MCWOR0,MCDTAB
     &          ,MCTRDO,IDTRDO,NUDOG,NUDOK,IGEOME,INDMIX,NUSCHQ
     &          ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEXC,NBDLXC,NBNFXC,NBDFXC
     &          ,KVNUMC,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEXL,NBDLXL,NBNFXL
     &          ,NBDFXL,KVNUML,NVCORC,INUTIL,NIVDOM
     &          ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &          ,MCMDON,MCDONN,LGEDON,NBDONN,INCDON,NCHDON
     &          ,MCESTE,MCRSTE,MCCSTE,MCCORP
     &          ,MCBLOK,MCLIST,LISRAN
     &          ,MCINCO,MCPOIQ,MCCORQ,MCPOID,MCCORD,MCCORF,MCPTBL,MCPTBC
     &          ,MCPTBM,MCPBMO,MCPTML,MCPTMC,LGMATR,MCMATR,LGMATC,MCMATC
     &          ,MCINGC,MCNECC,MCDLNC,MCNDIC,MCNUFC,MCDLFC,MCFCTC,MCDFCC
     &          ,MCDWDC,NBNECC,KCLC,LAGC,NUTYLC,NBNEEC,NBDLEC,NBNEFC
     &          ,NBDLFC,NUTYFC,NBNEUC
     &          ,MCINGL,MCNELL,MCDLNL,MCNDIL,MCNUFL,MCDLFL,MCFCTL,MCDFCL
     &          ,MCDWDL,NBNELL,KCLL,LAGL,NUTYLL,NBNEEL,NBDLEL,NBNEFL
     &          ,NBDLFL,NUTYFL,NBNEUL
     &          ,MCNUFG,MCDLFG,MCFCTG,MCDFCG,LAGG,KCLG
     &          ,NBNEEG,NBDLEG,NUTYFG,NBNEFG,NBDLFG,NUTYLG,NUTGEO
     &          ,MCMORB,NBC,NBPL,MCPLAL,MCPLIL,LGLB
     &                 ,NBL,NBPU,MCPLAU,MCPLIU,LGUB
     &          ,MCMORL,MCPLAG,MCPLIG,LGL,MCMORC,MCGALP,MCGILP,LGC
     &          ,NUEL,NUTGAV,NUTCAV,NUTLAV,NUTGFV,NUFFAV,NIVIMP,NIVAMP
      INTEGER    NBCART,NBCARG,ELEMEN,FACE,FACEAV,ELEMEP,ELEMEV
*
      PARAMETER (NBCART=21,NBCARG=10)
      CHARACTER  KELFCC*6,KELFCL*6,KELFCG*6,TABASS*1
      CHARACTER  NODOAA*16,NODONA*16,NOMTRA*16,TYPDON*4,ERCODE*120 
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(41:41),TYPDON),(ERCODE(49:49),NODOAA) 
     &            ,(ERCODE(65:65),KELFCC),(ERCODE(73:73),KELFCL)  
     &            ,(ERCODE(81:81),KELFCG),(ERCODE(88:88),TABASS)
     &            ,(ERCODE(89:89),NODONA),(ERCODE(105:105),NOMTRA)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EFqltr*')
*
*     Structure temporaire de description des termes du domaine
*
      LGWOR0=NBCART*NBTRDO+NBCARG
      CALL TBCREE ('$WORK$',0,1,LGWOR0,'c')
      CALL TBAR1  (ERCODE,'$WORK$',0,MCWOR0)                     
      CALL TAZERO (LGWOR0,'ENTIER',MCWOR0,AST,IST,RST,CST)              !utilite
*
      CALL TBAR7  (ERCODE,'#TERDO',1,MCTRDO,'$WORK$',0,MCWOR0
     &                                     ,'#NCONU',1,MCINCO
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !sdexplo
*
*     Attributs du domaine de calcul
*
      IDTRDO=MCTRDO+NXDODO
      CALL GETDOM (IST(IDTRDO),NUDOG,NUDOK,IGEOME,INDMIX,NUSCHQ
     &            ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEXC,NBDLXC,NBNFXC
     &            ,NBDFXC,KVNUMC
     &            ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEXL,NBDLXL,NBNFXL
     &            ,NBDFXL,KVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM)           !sdexplo
      MCDTAB=MCWOR0+NBCART*NBTRDO
      IDTRDO=IDTRDO+INCRDO
*  
*     Calcul des longueurs des matrices elementaires, de tableau de stockage
*     des fonctions de base, matrice jacobienne, ...
*  
      CALL EFATRI (NDIM,NDMDOM,NBTRDO,IST(IDTRDO),AST(MCMTRM)
     &            ,IST(MCDTRM),IST(MCINCO),AST(MCMDON),NCHDON
     &            ,IST(MCDONN),IST(MCWOR0),IST(MCDTAB)
     &            ,INTRPC,NBDLXC,NBDFXC,KELFCC
     &            ,INTRPL,NBDLXL,NBDFXL,KELFCL
     &            ,INTRPG,NBDLXG,NBDFXG,KELFCG,NODONA,NOMTRA)           !caltrm
      LGMATR=IST(MCDTAB)
      LGMATC=IST(MCDTAB+1)
	  
*
*     Adresses des matrices elementaires
*
      IF (LGMATR.GT.0) CALL TBCREE ('&MATLR',NUDOK,2,LGMATR,'c')
      IF (LGMATC.GT.0) CALL TBCREE ('&MATLC',NUDOK,4,LGMATC,'c')
*  
*     Creation du tableau de travail &WRKEF et calculs des adresses
*     relatives dans ce tableau des divers tableaux de preparation 
*
      CALL TBAR1 (ERCODE,'$WORK$',0,MCWOR0)
      MCDTAB=MCWOR0+NBCART*NBTRDO
*
      CALL EFTBAD (NDIM,NDMDOM,NBPTQX
     &            ,MCPOIQ,MCCORQ,MCPOID,MCCORD,MCCORF,IST(MCDTAB)
     &            ,NVSTKB,MCPTBM,NVSTKL,MCPTML,NVSTKC,MCPTMC
     &            ,INDEXC,IDLHRC,INTRPC,NBNFXC,NBDFXC,NBNECX,KELFCC
     &            ,MCNDIC,MCNUFC,MCDLFC,MCFCTC,MCDFCC,MCDWDC
     &            ,INDEXL,IDLHRL,INTRPL,NBNFXL,NBDFXL,NBNELX,KELFCL
     &            ,MCNDIL,MCNUFL,MCDLFL,MCFCTL,MCDFCL,MCDWDL
     &            ,INTRPG,NBDFXG,NBDFXG,KELFCG,MCNUFG,MCDLFG
     &            ,MCFCTG,MCDFCG,TBDCST(10),LGWORK,NIVDOM,IMPFCH)       !caltrm
*
      CALL TBCREE('$WORK$',NUDOK,2,LGWORK,'c')
*
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUML,MCNELL)
      IF (NVNUMC.NE.NDFNUM.AND.NVNUMC.NE.NVNUML) 
     &   CALL TBRR1 (ERCODE,'#GNEDO',NVNUMC,MCNECC)
      CALL TBAR15 (ERCODE,'#NCONU',  1  ,MCINCO,'#TERDO',  1  ,MCTRDO
     &                   ,'$SDTRM',  1  ,MCDTRM,'$DONNE',  1  ,MCDONN
     &                   ,'#OMDON',  1  ,MCMDON,'#OMTRM',  1  ,MCMTRM
     &                   ,'$ECSTE',  1  ,MCESTE,'$RCSTE',  1  ,MCRSTE
     &                   ,'$CCSTE',  1  ,MCCSTE,'$WORK$',  0  ,MCWOR0
     &                   ,'#ISTEL',NUDOG,MCLIST
     &                   ,'#ORPTL',NUDOK,MCCORP,'#RGNDO',NUDOK,MCINGC
     &                   ,'$WORK$',NUDOK,MCWORK,'#GNEDO',NVNUML,MCNELL)
      IDTRDO=MCTRDO+NXDODO+INCRDO 
      MCDTRM=MCDTRM+LGETRM
      MCBLOK=MCWOR0
      IF (NBBBLK.GE.2) CALL TBAR1  (ERCODE,'#LOKEL',1,MCBLOK)
      MCNECC=MCNELL
      IF (NVNUMC.NE.NDFNUM.AND.NVNUMC.NE.NVNUML) 
     &   CALL TBAR1 (ERCODE,'#GNEDO',NVNUMC,MCNECC)
*  
*     Adresses des sous-tableaux des numerotations en colonne et ligne 
*     et des tableaux de stockage des fonctions de base
*     Nombre et adresses des numerotations en noeuds et d.l. en colonne 
      NBNECC=IST(MCNECC+1) 
      MCNECC=MCNECC+2  
      MCDLNC=MCNECC+NBNECC 
*     Nombre et adresses des numerotations en noeuds et d.l. en ligne
      NBNELL=IST(MCNELL+1) 
      MCNELL=MCNELL+2  
      MCDLNL=MCNELL+NBNELL
*     Adresses des tableaux des rangs des noeuds dans la numerotation
*     des noeuds en ligne et colonne
      MCINGL=MCINGC+IST(MCINGC)-1  
      MCINGC=MCINGC+1 
*     Adresses des tableaux des poids et points de quadrature
      IF (NDMDOM.NE.NDIM.AND.MAX(INDEXC,INDEXL).GT.0) THEN
*        Adresses pour la formule de quadrature projetee sur la face/arete
         MCPOID=MCWORK+MCPOID
         MCCORD=MCWORK+MCCORD
*        Adresse du tab. des coordonnees des points sur la face /arete
         MCCORF=MCWORK+MCCORF
      ENDIF
      MCPOIQ=MCWORK+MCPOIQ
      MCCORQ=MCWORK+MCCORQ
*     Adresses des tableaux des pointeurs d'assemblage
      MCPTBM=MCWORK+MCPTBM
      MCPTML=MCWORK+MCPTML
      MCPTMC=MCWORK+MCPTMC
*     Adresses des tableaux de numerotations locales
      MCNDIC=MCWORK+MCNDIC
      MCNDIL=MCWORK+MCNDIL
      MCNUFG=MCWORK+MCNUFG
      MCDLFG=MCWORK+MCDLFG
      MCNUFC=MCWORK+MCNUFC 
      MCNUFL=MCWORK+MCNUFL 
      MCDLFC=MCWORK+MCDLFC 
      MCDLFL=MCWORK+MCDLFL
*     Adresses pour les tableaux des fonctions de base et derivees
      MCFCTG=MCWORK+MCFCTG
      MCFCTC=MCWORK+MCFCTC
      MCFCTL=MCWORK+MCFCTL
      MCDFCG=MCWORK+MCDFCG
      MCDFCC=MCWORK+MCDFCC
      MCDWDC=MCWORK+MCDWDC
      MCDFCL=MCWORK+MCDFCL
      MCDWDL=MCWORK+MCDWDL
*
      IF (KALTEF.EQ.'Y') THEN
*
*        Caracteristiques des tableaux de stockage des termes
*
         LGLB=0
         LGUB=0
         IF (NVSTKB.GT.0) THEN
            CALL TBAR1  (ERCODE,'&BMORS',NVSTKB,MCMORB)
            CALL EXBMOR (MCMORB,IST(MCMORB),NBC,NBPL,MCPLAL,MCPLIL,LGLB 
     &                  ,NBL,NBPU,MCPLAU,MCPLIU,LGUB)                   !sdexplo
         ENDIF
         LGL=0
         IF (NVSTKL.GT.0) THEN
            CALL TBAR1  (ERCODE,'&PLAGE',NVSTKL,MCMORL)
            CALL EXMORS (MCMORL,IST(MCMORL),NBC,NBL,NBPL,MCPLAG,MCPLIG
     &                  ,LGL)                                           !sdexplo
         ENDIF
         LGC=0
         IF (NVSTKC.GT.0) THEN
            CALL TBAR1  (ERCODE,'&EGALP',NVSTKC,MCMORC)
            CALL EXMORS (MCMORC,IST(MCMORC),NBL,NBC,NBPL,MCGALP,MCGILP
     &                  ,LGC)                                           !sdexplo
         ENDIF
*
      ENDIF
*
*     Adresses des matrices elementaires
*
      IF (LGMATR.GT.0) CALL TBAR1 (ERCODE,'&MATLR',NUDOK ,MCMATR)
      IF (LGMATC.GT.0) CALL TBAR1 (ERCODE,'&MATLC',NUDOK ,MCMATC)
        
*  
*     Adresses de chaque terme E.F. et des eventuels tableaux associes
*     et stockage dans le tableau de travail '$WORK$',0 
*
      CALL EFADRS (NBTRDO,IST(IDTRDO),AST(MCMTRM),NCHTRM,AST(MCMDON)
     &            ,NCHDON,IST(MCDONN),IST(MCWOR0),MCESTE,MCRSTE,MCCSTE
     &            ,TABASS,TYPDON,NODOAA,NODONA,NOMTRA,AST,IST,RST,CST
     &            ,NIVDOM,IMPFCH)                                       !caltrm
*  
*     Boucle sur les elements du domaine
*
      LISRAN=0 
      NUTGAV=0
      NUTCAV=0
      NUTLAV=0
      NUTGFV=0 
      FACEAV=0 
      NIVIMP=NIVDOM
      ELEMEP=1
      ELEMEV=NBELDO-1
      IF (NIVIMP.GT.10) ELEMEV=MAX (1,NBELDO/(NIVIMP-9))
*
      DO 100 ELEMEN=1,NBELDO
         NIVDOM=0
         IF (NIVIMP.GT.0) THEN
            IF (ELEMEN.EQ.ELEMEP) THEN
                NIVDOM=NIVIMP
                ELEMEP=MIN(ELEMEP+ELEMEV,NBELDO)
            ENDIF
         ENDIF
*
*        Mise a zero du tableau des matrices elementaires. 
         IF (LGMATR.GT.0) 
     &   CALL TAZERO (LGMATR,'RE',MCMATR,AST,IST,RST,CST)               !utilite
         IF (LGMATC.GT.0) 
     &   CALL TAZERO (LGMATC,'CO',MCMATC,AST,IST,RST,CST)               !utilite
*  
         IF (NIVDOM.GT.0) WRITE(IMPFCH,10000) ELEMEN 
*  
*        Exploitation de la structure #ISTEL et recherche des caracteristiques 
*        de l'element ou la face FACE adequat de l'element
         NIVAMP=NIVDOM
         IF (INTRPC.NE.INTRPG.OR.INTRPL.NE.INTRPG) NIVAMP=0
*  
*        Parametres geometriques de l'element :
*  
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,IST(MCLIST+NXLIST)
     &               ,IST(MCBLOK),NUTYLG,INTRPG,NUEL,NUTGAV,NUTGEO
     &               ,LAGG,KCLG,NBNEEG,NBDLEG,FACE,NUFFAV,NUTYFG
     &               ,NBNEFG,NBDLFG,IST(MCNUFG),IST(MCDLFG)
     &               ,NIVAMP,IMPFCH)                                    !sdexplo
*
*        Parametres de l'element pour l'interpolation en colonne
*  
         IF (INTRPC.EQ.INTRPG) THEN 
            KCLC=KCLG
            NUTYLC=NUTYLG  
            NBNEEC=NBNEEG  
            NBDLEC=NBDLEG  
            NUTYFC=NUTYFG  
            NBNEFC=NBNEFG  
            NBDLFC=NBDLFG  
         ELSE
            CALL EXSTEW (NDMDOM,INTRPC,NUTYLG,NUEL,NUTCAV,NUTYLC
     &                  ,LAGC,KCLC,NBNEEC,NBDLEC,FACE,FACEAV,NUTYFC
     &                  ,NBNEFC,NBDLFC,IST(MCNUFC),IST(MCDLFC)
     &                  ,NIVDOM,IMPFCH)                                 !sdexplo
         ENDIF
*  
*        Parametres de l'element pour l'interpolation en ligne
*  
         IF (INTRPL.EQ.INTRPG) THEN 
            KCLL=KCLG
            NUTYLL=NUTYLG  
            NBNEEL=NBNEEG  
            NBDLEL=NBDLEG  
            NUTYFL=NUTYFG  
            NBNEFL=NBNEFG  
            NBDLFL=NBDLFG  
         ELSEIF (INTRPL.EQ.INTRPC) THEN
            KCLL=KCLC
            NUTYLL=NUTYLC  
            NBNEEL=NBNEEC  
            NBDLEL=NBDLEC  
            NUTYFL=NUTYFC  
            NBNEFL=NBNEFC  
            NBDLFL=NBDLFC  
         ELSE
            CALL EXSTEW (NDMDOM,INTRPL,NUTYLG,NUEL,NUTLAV,NUTYLL
     &                  ,LAGL,KCLL,NBNEEL,NBDLEL,FACE,FACEAV,NUTYFL
     &                  ,NBNEFL,NBDLFL,IST(MCNUFL),IST(MCDLFL)
     &                  ,NIVDOM,IMPFCH)                                 !sdexplo
         ENDIF
*  
         IF (TABASS.EQ.'Y') THEN
*           Remplissage des tableaux locaux de valeurs nodales
*           a partir des tableau de valeurs nodales associes aux termes.
            CALL EFVNLO (NBTRDO,IST(MCWOR0),INDEXC,NBNEFC,IST(MCNUFC)
     &                  ,IST(MCINGC+1),MCMATR,MCMATC,RST,CST)           !caltrm
         ENDIF
*
*        Nombre de points de l'element
         NBDLEG=IST(MCCORP)
*
         IF (NDMDOM.EQ.NDMDOE) THEN
*  
*--         Calculs d'integrales en dimension d'espace
*           
            CALL CALELM (ELEMEN,NDIM,NBTRDO,IST(MCWOR0),NCHDON
     &                  ,AST(MCMDON),EPSMAC,NUTGAV
     &                  ,RST(MCCORP+2),NBPTQX
     &                  ,NUSCHQ,IST(MCWORK),RST(MCPOIQ),RST(MCCORQ)
     &                  ,NUTYLC,NBDLEC
     &                  ,KELFCC,RST(MCFCTC),RST(MCDFCC),RST(MCDWDC)
     &                  ,NUTYLL,NBDLEL
     &                  ,KELFCL,RST(MCFCTL),RST(MCDFCL),RST(MCDWDL)
     &                  ,NUTYLG,NBDLEG,KELFCG,RST(MCFCTG),RST(MCDFCG)
     &                  ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                  ,NIVDOM,IMPFCH)                                 !calelem
*  
         ELSE
            IF (MAX (INDEXC,INDEXL).LE.0) THEN
*  
*--            Calculs d'integrales sur les faces ou aretes de l'element
*
               CALL CALELB (ELEMEN,FACE,NDIM,NDMDOM,NBTRDO,IST(MCWOR0)
     &                     ,NCHDON,AST(MCMDON),NUTGFV
     &                     ,IST(MCCORP+1),RST(MCCORP+2),NBPTQX
     &                     ,NUSCHQ,IST(MCWORK),RST(MCPOIQ),RST(MCCORQ)
     &                     ,NUTYFC,NBDLFC
     &                     ,KELFCC,RST(MCFCTC),RST(MCDFCC)
     &                     ,NUTYFL,NBDLFL
     &                     ,KELFCL,RST(MCFCTL),RST(MCDFCL)
     &                     ,NUTYFG,NBDLFG,KELFCG,RST(MCFCTG),RST(MCDFCG)
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,NIVDOM,IMPFCH)                              !calelem
*
            ELSE
*  
*--            Calculs d'integrales sur les faces ou aretes de l'element
*              pour un domaine etendu (integrand avec derivees)
*
               CALL CALELD (ELEMEN,FACE,NDIM,NDMDOM,NBTRDO,IST(MCWOR0)
     &                     ,NCHDON,AST(MCMDON),EPSMAC,NUTGAV,NUTGFV
     &                     ,FACEAV,IST(MCCORP+1),RST(MCCORP+2),NBPTQX
     &                     ,NUSCHQ,IST(MCWORK),RST(MCPOIQ),RST(MCCORQ)
     &                     ,NUTYFC,NBDLFC,NUTYLC,NBDLEC
     &                     ,KELFCC,RST(MCFCTC),RST(MCDFCC),RST(MCDWDC)
     &                     ,NUTYFL,NBDLFL,NUTYLL,NBDLEL
     &                     ,KELFCL,RST(MCFCTL),RST(MCDFCL),RST(MCDWDL)
     &                     ,NUTYFG,NBDLFG,NUTYLG,NBDLEG
     &                     ,KELFCG,RST(MCFCTG),RST(MCDFCG),IST(MCDLFG)
     &                     ,RST(MCCORF),RST(MCPOID),RST(MCCORD)
     &                     ,MCMATR,MCMATC,IST,RST,CST,NODONA,NOMTRA
     &                     ,NIVDOM,IMPFCH)                              !calelem
            ENDIF
            NUTGFV=NUTYFG 
            FACEAV=FACE
         ENDIF
*
*        Nombre de noeuds pour les interpolations en colonne et ligne
         NBNEUC=IST(MCINGC)
         NBNEUL=IST(MCINGL)
*
*        Pre-assemblage des termes elements finis standard
*
         IF (KALTEF.EQ.'Y') THEN
*
*           Numerotations locales supplementaires dans le cas HERMITE
            IF (IDLHRL.GT.0)
     &      CALL ELEMDL (NUTYFL,IST(MCNUFL),IST(MCDLFL),IST(MCNDIL))    !ef3d
            IF (IDLHRC.GT.0)
     &      CALL ELEMDL (NUTYFC,IST(MCNUFC),IST(MCDLFC),IST(MCNDIC))    !ef3d
*
*--         Pre-assemblage des termes du domaine
*
            MCPTBL=MCPTBM
            MCPTBC=MCPTBM+2*NBNEUL
            MCPBMO=MCPTBM+2*(NBNEUC+NBNEUL)
*
*           Calcul des pointeurs d'assemblage des matrices elementaires
            IF (NVSTKB.GT.0) THEN
               CALL PTRBMS (NBNEUL,IST(MCINGL+1),NBNEUC,IST(MCINGC+1)
     &                     ,IST(MCPLAL),IST(MCPLIL),MCPLAU.EQ.MCPLAL
     &                     ,IST(MCPTBL),IST(MCPTBL+NBNEUL)
     &                      ,IST(MCPTBC+NBNEUC),IST(MCPBMO))            !morse
               IF (MCPLAU.NE.MCPLAL) THEN
                  CALL PTRBMU (NBNEUL,IST(MCINGL+1),NBNEUC,IST(MCINGC+1)
     &                        ,IST(MCPLAU),IST(MCPLIU),IST(MCPTBC)
     &                        ,IST(MCPTBC+NBNEUC),IST(MCPBMO))          !morse
*
                  IF (NIVDOM.GT.5)  
     &            CALL PRPTRB (' ',NBNEUL,NBNEUC,IST(MCPTBL)
     &                        ,IST(MCPTBC),IST(MCPBMO),NIVDOM,IMPFCH)   !morse
               ELSE
                  IF (NIVDOM.GT.5)
     &            CALL PRPTRB ('INFERIEUR',NBNEUL,NBNEUC,IST(MCPTBL)
     &                        ,IST(MCPTBL),IST(MCPBMO),NIVDOM,IMPFCH)   !morse
               ENDIF
            ENDIF
            IF (NVSTKL.GT.0) THEN
               CALL PTRMLI (NBNEUL,IST(MCINGL+1),NBNEUC,IST(MCINGC+1)
     &                     ,IST(MCPLAG),IST(MCPLIG),IST(MCPTML)
     &                     ,IST(MCPTML+NBNEUL),IST(MCPTML+2*NBNEUL))    !morse
*
               IF (NIVDOM.GT.5)
     &         CALL PRPTRM ('L',NBNEUL,NBNEUC,IST(MCPTML)
     &                     ,IST(MCPTML+2*NBNEUL),NIVDOM,IMPFCH)         !morse
            ENDIF
            IF (NVSTKC.GT.0) THEN
               CALL PTRMCO (NBNEUL,IST(MCINGL+1),NBNEUC,IST(MCINGC+1)
     &                     ,IST(MCGALP),IST(MCGILP),IST(MCPTMC)
     &                     ,IST(MCPTMC+NBNEUC),IST(MCPTMC+2*NBNEUC))    !morse
*
               IF (NIVDOM.GT.5) 
     &         CALL PRPTRM ('C',NBNEUL,NBNEUC,IST(MCPTMC)
     &                     ,IST(MCPTMC+2*NBNEUC),NIVDOM,IMPFCH)         !morse
            ENDIF 
*
*           Pre-assemblage proprement dit
*
            CALL PASTDO (NBTRDO,IST(IDTRDO),INCTRM,IST(MCDTRM),NCHTRM
     &                  ,AST(MCMTRM),IST(MCINCO),IST(MCWOR0),LGLB
     &                  ,IST(MCPTBL),IST(MCPTBL+NBNEUL)
     &                  ,IST(MCPTBC),IST(MCPTBC+NBNEUC),IST(MCPBMO)
     &              ,IST(MCPTML),IST(MCPTML+NBNEUL),IST(MCPTML+2*NBNEUL)
     &              ,IST(MCPTMC),IST(MCPTMC+NBNEUC),IST(MCPTMC+2*NBNEUC) 
     &                  ,NBNELL,IST(MCINGL+1),KCLL,NBNEUL,NBNEEL,NBNEFL
     &                  ,IST(MCNUFL),IDLHRL,IST(MCDLNL),IST(MCDLFL)
     &                  ,IST(MCNDIL),NBNECC,IST(MCINGC+1),KCLC,NBNEUC
     &                  ,NBNEEC,NBNEFC,IST(MCNUFC),IDLHRC,IST(MCDLNC) 
     &                  ,IST(MCDLFC),IST(MCNDIC),MCMATR,MCMATC,RST,CST
     &                  ,ELEMEN,NOMTRA,IMPFCH)                          !caltrm
         ENDIF
*
*        Pre-assemblage des termes elements finis localises calcules 
*        par quadrature
*
         IF (KALTQU.EQ.'Y') THEN      
            CALL PASTIS (NBTRDO,IST(IDTRDO),INCTRM,IST(MCDTRM),NCHTRM
     &                  ,AST(MCMTRM),IST(MCINCO),IST(MCWOR0)
     &                  ,NBNELL,IST(MCINGL+1),KCLL,NBNEUL,NBNEEL,NBNEFL
     &                  ,IST(MCNUFL),NBNECC,IST(MCINGC+1),KCLC,NBNEUC
     &                  ,NBNEEC,NBNEFC,IST(MCNUFC)
     &                  ,MCMATR,MCMATC,RST,CST,ELEMEN,NOMTRA,IMPFCH)     !caltrm      
         ENDIF
*
*        Non-Assemblage des termes des elements finis 'Matrice Elementaire'
*
         IF (KALTME.EQ.'Y') THEN
            CALL NASTDO (NBTRDO,IST(IDTRDO),INCTRM,IST(MCDTRM),NCHTRM
     &                  ,AST(MCMTRM),IST(MCINCO),IST(MCWOR0)
     &                  ,NBNEUL,NBNEUC,MCMATR,MCMATC,RST,CST
     &                  ,NOMTRA,IMPFCH)                                 !caltrm
*
         ENDIF
*
         NUTGAV=NUTYLG
         NUTCAV=NUTYLC
         NUTLAV=NUTYLL
         MCCORP=MCCORP+2+NDIM*IST(MCCORP)  
         MCINGC=MCINGC+NBNEUC+1
         MCINGL=MCINGL+NBNEUL+1
*
100   CONTINUE
*
      CALL TBTUER ('$WORK$',NUDOK)
      CALL TBTUER ('$WORK$',0)
      IF (NVSTKB.GT.0) CALL TBSAVE ('&BMORS',NVSTKB)
      IF (NVSTKL.GT.0) CALL TBSAVE ('&PLAGE',NVSTKL)
      IF (NVSTKC.GT.0) CALL TBSAVE ('&EGALP',NVSTKC)
      IF (LGMATR.GT.0) CALL TBTUER ('&MATLR',NUDOK)
      IF (LGMATC.GT.0) CALL TBTUER ('&MATLC',NUDOK) 
      CALL PRFXMJ (-1,'*EFqltr*')
*-----------------------------------------------------------------------
10000 FORMAT(/T30,'Calculs dans l''element ',I5/T30,30('-'))  
                                                                    END !EFqltr
