*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFVNLO (NBTRDO,INDTRD,INDEXC,NBNEFC,NUNEFC,IRGNDO
     &                  ,MCMATR,MCMATC,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.DeBayser (Avril 1990)
* Derniere modification : D.Martin (10 novembre 2002
* Verion 1.0.2
*  
* Remplissage des tableaux locaux de valeurs nodales a partir d'un 
* tableau associe a un terme element fini.
*  
*-- Arguments --  
* NBTRDO nombre de termes sur le domaine
* INDTRD structure locale pour le domaine
*   (NUINT+ 2*NBTRDO) adresse relative du tableau elementaire local de
*                     valeurs nodales dans le tableau des matrices elementaires
*   (NUINT+ 6*NBTRDO) nombre de composantes de l'inconnue en colonne
*   (NUINT+ 9*NBTRDO) nombre de composantes de l'inconnue en ligne
*   (NUINT+13*NBTRDO) type de la donnee (CONSTANTE,TABLEAU,FONCTION)
*   (NUINT+15*NBTRDO) type du declaration du tableau associe
*   (NUINT+16*NBTRDO) adresse absolue du tableau associe
*   (NUINT+19*NBTRDO) nombre de valeurs par noeuds du tableau associe
* INDEXC indice d'extension en colonne
* NBNEFC nombre de noeuds elementaires en colonne  
* NUNEFC tableau des noeuds elementaires en colonne
* IRGNDO tableau des indices d'occurrence des noeuds du domaine
* MCMATR adresse reelle des tableaux elementaires  
* MCMATC adresse complexe des tableaux elementaires
* RST,CST super-tableaux reel ou complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NBTRDO,INDEXC,NCPINC,NBNEFC,MCMATR,MCMATC
     &        ,NUNEFC(*),INDTRD(*),IRGNDO(*)  
      REAL     RST(*) 
      COMPLEX  CST(*)
*     Variables locales
      INTEGER  INTTYP,INTDON
      INTEGER  INTREL,INTTAB,NUINT,ITYDON,ITYTAB,NVALNE,MCNEGL,INEU
     &        ,INEUL,MCATAB,MCATA1,MCASSO,ADASSO,ADASS1
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EfVnlo*')
*  
      INTREL=INTTYP ('REEL')                                            !utilite
      INTTAB=INTDON ('TABLEAU')                                         !utilite
*
      DO 100 NUINT=1,NBTRDO
         ITYDON=INDTRD(NUINT+13*NBTRDO)
         IF (ITYDON.EQ.INTTAB) THEN
            MCATAB=INDTRD(NUINT+2*NBTRDO)
            ITYTAB=INDTRD(NUINT+15*NBTRDO)
            MCASSO=INDTRD(NUINT+16*NBTRDO)
            NVALNE=INDTRD(NUINT+19*NBTRDO)
*
            IF (ITYTAB.EQ.INTREL) THEN
               MCATAB=MCMATR+MCATAB-1
               DO 22 INEU=1,NBNEFC
                  INEUL=INEU
                  IF (INDEXC.GE.1) INEUL=NUNEFC(INEU)
*                 Adresse du 1er coefficient nodal (tableau associe)
                  ADASSO=MCASSO+NVALNE*(IRGNDO(INEUL)-1)
*
                  MCATA1=MCATAB
                  DO 21 ADASS1=ADASSO,ADASSO-1+NVALNE
                     RST(MCATA1)=RST(ADASS1)
                     MCATA1=MCATA1+NBNEFC
21                CONTINUE
                  MCATAB=MCATAB+1
22             CONTINUE
            ELSE
               MCATAB=MCMATC+MCATAB-1
               DO 42 INEU=1,NBNEFC
                  INEUL=INEU
                  IF (INDEXC.GE.1) INEUL=NUNEFC(INEU)
                  ADASSO=MCASSO+NVALNE*(IRGNDO(INEUL)-1)
                  MCATA1=MCATAB
                  DO 41 ADASS1=ADASSO,ADASSO-1+NVALNE
                     CST(MCATA1)=CST(ADASS1)
                     MCATA1=MCATA1+NBNEFC
41                CONTINUE
                  MCATAB=MCATAB+1
42             CONTINUE
            ENDIF
         ENDIF
100   CONTINUE 
      CALL PRFXMJ (-1,'*EfVnlo*')
                                                                    END !EFvnlo
