*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NASTDO (NBTRDO,ITERDO,INCTRM,ISDTRM,NCHTRM,NOMTRM
     &                  ,INCONU,INDTRD,NBNEEL,NBNEEC,MCMATR,MCMATC
     &                  ,RST ,CST   ,NOMTRA,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1995)  
* Derniere modification : D.Martin (11 Decembre 1999)
* Version 1.0.0
*  
* Non-assemblage a l'aide des tableaux de pointeurs des termes 'MatElm'
*  
*-- Arguments --
* NBTRDO nombre de termes sur le domaine
* ITERDO tableau des numeros des termes sur le domaine = structure #TERDO
*        a l'adresse du numero du 1er terme sur le domaine
* INCTRM increment de la structure $SDTRM de description des termes
* ISDTRM structure $SDTRM a l'adresse du 1er terme
* NCHTRM nombre de caracteres par nom de terme
* NOMTRM tableau #OMTRM des noms de termes
* INCONU structure #NCONU a son adresse initiale
* INDTRD tableau des adresses absolues des termes et des adresses relatives
*        des matrices elementaires
* NBNEEL nombre de noeuds de l'element pour l'interpolation en ligne
* NBNEEC nombre de noeuds de l'element pour l'interpolation en colonne
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* RST,CST super-tableau version REELLE et COMPLEXE
* NOMTRA chaine de caractere receptrice d'un nom de terme 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTRM(*),NOMTRA
      INTEGER       NBTRDO,ITERDO(*),INCTRM,ISDTRM(*),NCHTRM,INCONU(*)
     &             ,INDTRD(*),NBNEEL,NBNEEC,MCMATR,MCMATC,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       INTYKL,INTYME,NUTERM,LETERM,MCTERM,MCTELM
     &             ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &             ,NVNUML,INDSTK,KVNUMS,NVCORC,IATRDO,NIVIMP
     &             ,KDERIC,KNDEXC,KDERIL,KNDEXL,INSYME
     &             ,NCPINC,NCPINL,IST,IB
      CHARACTER     ERCODE*120,TYPINT*1,TYPTRM*1
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*NasTdo*')
      INTYME=INTYKL ('MATELM')                                          !utilite
*
      DO 1 LETERM=1,NBTRDO
         NUTERM=ITERDO(LETERM)
*        Terme deja calcule ou terme non 'MATELM', on saute
         IF (NUTERM.LE.0.OR.INDTRD(LETERM+5*NBTRDO).LE.0) GOTO 1
*
         CALL GETTRM (ISDTRM(1+INCTRM*(NUTERM-1)) ,NIVTRM,ITYPTR,ITYCAL
     &               ,NUKALE,NUDONN,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBCOLO
     &               ,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INDSTK,KVNUMS
     &               ,NVCORC,IATRDO,NIVIMP)                             !sdexplo
         IF (ITYCAL.NE.INTYME) GOTO 1
         TYPTRM=TYPINT (ITYPTR)                                         !utilite
*
*        Nom et niveau du terme a assembler
         CALL GETCHN (NOMTRM,NCHTRM,NUTERM,NOMTRA)                      !utilite
         CALL INTATR (NUKALE,KDERIC,KNDEXC,KDERIL,KNDEXL,INSYME)        !integra
*
*        Adresse absolue du terme et relative de la matrice elementaire
         MCTERM=INDTRD(LETERM)
         MCTELM=INDTRD(LETERM+NBTRDO)
         IF (KDERIC.LE.-1) THEN
*
*           Assemblage des termes unicolonnes
*
*           Nombre de composantes de l'inconnue en ligne
            CALL SDEXCO (NUINCL,INCONU,NCPINL,IB,IB)                    !sdexplo
            CALL TDANST (NBNEEL*NCPINL,TYPTRM,MCTELM
     &                  ,IST,RST(MCMATR),CST(MCMATC)
     &                  ,TYPTRM,1,IST,RST(MCTERM),CST(MCTERM))          !utilite
            INDTRD(LETERM)=MCTERM+NBNEEL*NCPINL
         ELSE
*
*           Assemblage des termes matriciels
*
*           Nombre de composantes des inconnues en ligne et colonne
            CALL SDEXCO (NUINCL,INCONU,NCPINL,IB,IB)                    !sdexplo
            CALL SDEXCO (NUINCC,INCONU,NCPINC,IB,IB)                    !sdexplo
*
            CALL TDANST (NBNEEC*NCPINC*NBNEEL*NCPINL,TYPTRM,MCTELM
     &                  ,IST,RST(MCMATR),CST(MCMATC)
     &                  ,TYPTRM,1,IST,RST(MCTERM),CST(MCTERM))          !utilite
            INDTRD(LETERM)=MCTERM+NBNEEC*NCPINC*NBNEEL*NCPINL
         ENDIF
1     CONTINUE
      CALL PRFXMJ (-1,'*NasTdo*')
                                                                    END !NasTdo
