*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASLBM (NBNEUL,NNEITL,NUNEFL,RGNELI
     &                  ,NBNEUC,NNEITC,NUNEFC,RGNECO
     &                  ,MCMATR,MCMATC,MCTELM,TYPTRM,MCDIAG,MCTRIL
     &                  ,PTRDEB,PTRBMO,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Mars 1992) 
* Derniere modification : D.Martin (25 Mars 2002)
* Version 1.0.1
*  
* Assemblage d'une matrice elementaire dans la diagonale et la partie
* triangulaire inferieure de la matrice d'un terme stocke 'Bi-Morse'
* pour des inconnues scalaires en ligne et colonne
*  
*-- Arguments d'entree --
* NBNEUL nombre de noeuds dans l'element pour l'interpolation en ligne
* NNEITL nombre de lignes de la matrice elementaire comptees en noeuds
* NUNEFL correspondance noeud de face - noeud dans l'element en ligne
* RGNELI RGNELI(ne) est la ligne de la matrice assemblee associee au noeud ne
*
* NBNEUC nombre de noeuds dans l'element pour l'interpolation en colonne
* NNEITC nombre de colonnes de la matrice elementaire comptees en noeuds  
* NUNEFC correspondance noeud de face - noeud dans l'element en colonne
* RGNECO RGNECO(ne) est la colonne de la matrice assemblee associee au noeud ne
*
*
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* MCTELM adresse relative de la matrice elementaire 
* TYPTRM type REEL ou COMPLEXE du terme
* MCDIAG adresse abs. de la diagonale du terme Bi-Morse assemble
* MCTRIL adresse abs. de la partie triangulaire inf. du terme Bi-Morse assemble
* PTRDEB tableau des adresses de debut des lignes de la matrice compactee
*
* PTRBMO tableau des adresses a partir du debut de la ligne, dans la partie
*        triangulaire inferieure de la matrice 'Bi-Morse', des coefficients
*        d'une matrice elementaire
* RST,CST super-tableau version reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*),RGNELI(*)
     &             ,NBNEUC,NNEITC,NUNEFC(*),RGNECO(*)
     &             ,MCMATR,MCMATC,MCTELM,MCDIAG,MCTRIL
     &             ,PTRDEB(*),PTRBMO(NBNEUL,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCDOEF,MCCOEF,MCPRDL,MCDBLI,INCREL,INCREC
     &             ,INEL,NELI,NGNELI,INEC,NECO,NGNECO
*-----------------------------------------------------------------------
      INCREL=NNEITL
      INCREC=1
*
      IF (TYPTRM(1:1).EQ.'R') THEN
*
*        Cas d'une matrice reelle
*
         MCDOEF=MCMATR-1+MCTELM
*        Boucle sur les noeuds en ligne de l'element
         DO 201 INEL=1,NNEITL
            NELI=INEL
            IF (NNEITL.NE.NBNEUL) NELI=NUNEFL(INEL)
            NGNELI=RGNELI(NELI)
            MCCOEF=MCDOEF
*           Adresse de debut de ligne -1
            MCDBLI=MCTRIL-2+PTRDEB(NELI)
            DO 200 INEC=1,NNEITC
               NECO=INEC
               IF (NNEITC.NE.NBNEUC) NECO=NUNEFC(INEC)
               NGNECO=RGNECO(NECO)
               IF (NGNELI.EQ.NGNECO) THEN
*                 Diagonale
                  MCPRDL=MCDIAG+NGNELI-1
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
               ELSEIF (NGNELI.GT.NGNECO) THEN
*                 Partie triangulaire inferieure
                  MCPRDL=MCDBLI+PTRBMO(NELI,NECO)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
               ENDIF
               MCCOEF=MCCOEF+INCREL
200         CONTINUE
            MCDOEF=MCDOEF+INCREC
201      CONTINUE
*
      ELSE
*
*        Cas d'une matrice complexe
*
         MCDOEF=MCMATC-1+MCTELM
         DO 401 INEL=1,NNEITL
            NELI=INEL
            IF (NNEITL.NE.NBNEUL) NELI=NUNEFL(INEL)
            NGNELI=RGNELI(NELI)
            MCCOEF=MCDOEF
            MCDBLI=MCTRIL-2+PTRDEB(NELI)
            DO 400 INEC=1,NNEITC
               NECO=INEC
               IF (NNEITC.NE.NBNEUC) NECO=NUNEFC(INEC)
               NGNECO=RGNECO(NECO)
               IF (NGNELI.EQ.NGNECO) THEN
                  MCPRDL=MCDIAG+NGNELI-1
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)
               ELSEIF (NGNELI.GT.NGNECO) THEN
                  MCPRDL=MCDBLI+PTRBMO(NELI,NECO)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)
               ENDIF
               MCCOEF=MCCOEF+INCREL
400         CONTINUE
            MCDOEF=MCDOEF+INCREC
401      CONTINUE
      ENDIF
                                                                    END !PasLbm
