*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASMCO (NBNEUL,NNEITL,NUNEFL
     &                  ,NBNEUC,NNEITC,NUNEFC
     &                  ,MCMATR,MCMATC,MCTELM,TYPTRM,MCTERM
     &                  ,PTRDMO,PTRMOR,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Septembre 1988) 
* Derniere modification : D.Martin (22 Novembre 1999)
* Version 1.0.0
*  
* Assemblage d'une matrice elementaire dans la matrice d'un terme stocke
* Morse-Colonne avec inconnues scalaires en ligne et colonne
*  
*-- Arguments d'entree --
* NBNEUL nombre des noeuds en ligne dans l'element
* NNEITL nombre de lignes de la matrice elementaire comptees en noeuds
* NUNEFL correspondance noeud de face - noeud dans l'element en ligne
*
*
* NBNEUC nombre de noeuds en colonne dans l'element
* NNEITC nombre de colonnes de la matrice elementaire comptees en noeuds  
* NUNEFC correspondance noeud de face - noeud dans l'element en colonne
*
*
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* MCTELM adresse relative de la matrice elementaire 
* TYPTRM type REEL ou COMPLEXE du terme
* MCTERM adresse absolue du terme vectoriel assemble
* PTRDMO tableau des adresses de debut des lignes de la matrice compactee
* PTRMOR tableau des adresses a partir du debut de la ligne dans la matrice
*        stockee Morse des coefficients d'une matrice elementaire
* RST,CST super-tableau version reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*),NUNEFC(*),NBNEUC,NNEITC
     &             ,MCMATR,MCMATC,MCTELM,MCTERM
     &             ,PTRDMO(*),PTRMOR(NBNEUL,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCDOEF,MCCOEF,MCPRDL,MCDBKO,INCREL,INCREC
     &             ,INEL,LINOEU,INEC,KONOEU
*-----------------------------------------------------------------------
      INCREL=NNEITL
      INCREC=1
*
      IF (TYPTRM(1:1).EQ.'R') THEN
*
*        Cas d'une matrice reelle
*
         MCDOEF=MCMATR-1+MCTELM
         IF (NNEITC.EQ.NBNEUC.AND.NNEITL.EQ.NBNEUL) THEN
            DO 201 INEC=1,NBNEUC
               MCCOEF=MCDOEF
*              Adresse de debut de ligne -1
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 200 INEL=1,NBNEUL
                  MCPRDL=MCDBKO+PTRMOR(INEL,INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
                  MCCOEF=MCCOEF+INCREC
200            CONTINUE
               MCDOEF=MCDOEF+INCREL
201         CONTINUE
         ELSEIF (NNEITC.EQ.NBNEUC) THEN
            DO 203 INEC=1,NBNEUC
               MCCOEF=MCDOEF
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 202 LINOEU=1,NNEITL
                  MCPRDL=MCDBKO+PTRMOR(NUNEFL(LINOEU),INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
                  MCCOEF=MCCOEF+INCREC
202            CONTINUE
               MCDOEF=MCDOEF+INCREL
203        CONTINUE
         ELSEIF (NNEITL.EQ.NBNEUL) THEN
            DO 205 KONOEU=1,NNEITC
               MCCOEF=MCDOEF
               INEC=NUNEFC(KONOEU)
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 204 INEL=1,NBNEUL
                  MCPRDL=MCDBKO+PTRMOR(INEL,INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
                  MCCOEF=MCCOEF+INCREC
204            CONTINUE
               MCDOEF=MCDOEF+INCREL
205         CONTINUE
         ELSE
            DO 207 KONOEU=1,NNEITC
               MCCOEF=MCDOEF
               INEC=NUNEFC(KONOEU)
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 206 LINOEU=1,NNEITL
                  MCPRDL=MCDBKO+PTRMOR(NUNEFL(LINOEU),INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREC
206            CONTINUE
               MCDOEF=MCDOEF+INCREL
207         CONTINUE
         ENDIF
*
      ELSE
*
*        Cas d'une matrice complexe
*
         MCDOEF=MCMATC-1+MCTELM
         IF (NNEITC.EQ.NBNEUC.AND.NNEITL.EQ.NBNEUL) THEN
            DO 401 INEC=1,NBNEUC
               MCCOEF=MCDOEF
*              Adresse de debut de ligne -1
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 400 INEL=1,NBNEUL
                  MCPRDL=MCDBKO+PTRMOR(INEL,INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREC
400            CONTINUE
               MCDOEF=MCDOEF+INCREL
401         CONTINUE
         ELSEIF (NNEITC.EQ.NBNEUC) THEN
            DO 403 INEC=1,NBNEUC
               MCCOEF=MCDOEF
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 402 LINOEU=1,NNEITL
                  MCPRDL=MCDBKO+PTRMOR(NUNEFL(LINOEU),INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREC
402            CONTINUE
               MCDOEF=MCDOEF+INCREL
403        CONTINUE
         ELSEIF (NNEITL.EQ.NBNEUL) THEN
            DO 405 KONOEU=1,NNEITC
               MCCOEF=MCDOEF
               INEC=NUNEFC(KONOEU)
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 404 INEL=1,NBNEUL
                  MCPRDL=MCDBKO+PTRMOR(INEL,INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREC
404            CONTINUE
               MCDOEF=MCDOEF+INCREL
405         CONTINUE
         ELSE
            DO 407 KONOEU=1,NNEITC
               MCCOEF=MCDOEF
               INEC=NUNEFC(KONOEU)
               MCDBKO=MCTERM-2+PTRDMO(INEC)
               DO 406 LINOEU=1,NNEITL
                  MCPRDL=MCDBKO+PTRMOR(NUNEFL(LINOEU),INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREC
406            CONTINUE
               MCDOEF=MCDOEF+INCREL
407         CONTINUE
         ENDIF
      ENDIF
                                                                    END !PasMco
