*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASMLH (NBNEUL,NNEITL,NUNEFL,IDLHRL,NDLINL,NCPINC
     &                  ,NBNEUC,NNEITC,NUNEFC,IDLHRC,NDLINC,NCPINL
     &                  ,MCMATR,MCMATC,MCTELM,TYPTRM,MCTERM,LGLIGN
     &                  ,PTRMOL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Septembre 1988) 
* Derniere modification : D.Martin (10 Avril 96)
* Version 1.0.0
*  
* Assemblage ligne apres ligne dans la matrice compactee de la
* matrice elementaire
*  
*-- Arguments d'entree --
* NBNEUC nombre de noeuds en colonne sur la ligne .
* NNEITC nombre de colonnes comptees en noeuds de la matrice elementaire  
* NUNEFC correspondance noeud de face , noeud dans l'element en colonne
* IDLHRC indice de presence de d.l. d'Hermite en colonne  
* NDLINC nombre de d.l. par noeud dans l'element en colonne
* NBNEUL nombre des noeuds en ligne dans l'element
* NNEITL nombre de lignes comptees en noeuds de la matrice elementaire
* NUNEFL correspondance noeud de face , noeud dans l'element en ligne 
* IDLHRL indice de presence de d.l. d'Hermite en ligne
* NDLINL nombre de d.l. par noeud dans l'element en ligne
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* MCTELM adresse relative de la matrice elementaire 
* NCPINC nombre de composantes de l'inconnue en colonne
* NCPINL nombre de composantes de l'inconnue en ligne 
* NIVTRM niveau du (tableau contenant le) terme
* NCHTRM nombre de caracteres par nom de terme
* TYPTRM type REEL ou COMPLEXE du terme
* MCTERM adresse absolue du terme vectoriel assemble
* LGLIGN tableau des longueurs des lignes de la matrice compactee 
* PTRMOL tableau des adresses dans la matrice Morse des coefficients
*        d'une matrice de l'element en cours
* RST,CST super-tableau version reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*),IDLHRL,NDLINL(*),NCPINC
     &             ,NBNEUC,NNEITC,NUNEFC(*),IDLHRC,NDLINC(*),NCPINL
     &             ,MCMATR,MCMATC,MCTELM,MCTERM,LGLIGN(*)
     &             ,PTRMOL(NBNEUL,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       IACCOF,IAPTRM,IAPTRR,INEL,INEUL,IADBTR,IDLL
     &             ,INEC,INEUC,IDEB,NBDLIC,IDLC,NBDLIL
*-----------------------------------------------------------------------
*  
      IF (TYPTRM(1:1).EQ.'R') THEN
         IACCOF=MCMATR-1+MCTELM
         IAPTRM=0
         DO 24 INEL=1,NNEITL
*
            INEUL=INEL
            IF (NNEITL.NE.NBNEUL) INEUL=NUNEFL(INEL)
*  
            IADBTR=0  
            NBDLIL=NDLINL(INEUL)  
            DO 23 IDLL=1,NBDLIL*NCPINL 
               IAPTRR=IAPTRM
               DO 22 INEC=1,NNEITC
                  IAPTRR=IAPTRR+1 
                  INEUC=INEC  
                  IF (NNEITC.NE.NBNEUC) INEUC=NUNEFC(INEC)
                  IDEB=MCTERM-1+PTRMOL(INEUL,INEUC)+IADBTR 
                  NBDLIC=NDLINC(INEUC)
                  DO 22 IDLC=IDEB,IDEB+NBDLIC*NCPINC-1 
                     RST(IDLC)=RST(IDLC)+RST(IACCOF)  
22                IACCOF=IACCOF+1  
23             IADBTR=IADBTR+LGLIGN(INEUL)
            IAPTRM=IAPTRR
24       CONTINUE
      ELSE
      ENDIF
                                                                    END !PasMoH
