*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASMLI (NBNEUL,NNEITL,NUNEFL
     &                  ,NBNEUC,NNEITC,NUNEFC
     &                  ,MCMATR,MCMATC,MCTELM,TYPTRM,MCTERM
     &                  ,PTRDMO,PTRMOR,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Septembre 1988) 
* Derniere modification : D.Martin (27 Septembre 2000)
* Version 1.0.1
*  
* Assemblage d'une matrice elementaire dans la matrice d'un terme stocke
* 'Morse-Ligne' avec inconnues scalaires en ligne et colonne
*  
*  
*-- Arguments d'entree --
* NBNEUL nombre des noeuds en ligne dans l'element
* NNEITL nombre de lignes comptees en noeuds de la matrice elementaire
* NUNEFL correspondance noeud de face , noeud dans l'element en ligne
*
*
* NBNEUC nombre de noeuds en colonne sur la ligne .
* NNEITC nombre de colonnes comptees en noeuds de la matrice elementaire  
* NUNEFC correspondance noeud de face , noeud dans l'element en colonne
*
*
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* MCTELM adresse relative de la matrice elementaire 
* TYPTRM type REEL ou COMPLEXE du terme
* MCTERM adresse absolue du terme 'Bi-Morse' assemble
*
* PTRDMO tableau des adresses de debut des lignes de la matrice compactee
* PTRMOR tableau des adresses a partir du debut de la ligne dans la matrice
*        assemblee 'Morse-Ligne' des coefficients d'une matrice elementaire
* RST,CST super-tableau version reelle et complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*)
     &             ,NBNEUC,NNEITC,NUNEFC(*)
     &             ,MCMATR,MCMATC,MCTELM,MCTERM
     &             ,PTRDMO(*),PTRMOR(NBNEUL,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER      MCDOEF,MCCOEF,MCPRDL,MCDBLI,INCREL,INCREC
     &            ,INEL,LINOEU,INEC,KONOEU
*-----------------------------------------------------------------------
      INCREL=NNEITL
      INCREC=1
*
      IF (TYPTRM(1:1).EQ.'R') THEN
*
*        Cas d'une matrice reelle
*
         MCDOEF=MCMATR-1+MCTELM
         IF (NNEITL.EQ.NBNEUL.AND.NNEITC.EQ.NBNEUC) THEN
            DO 201 INEL=1,NBNEUL
*              Adresse de debut de ligne -1
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               MCCOEF=MCDOEF
               DO 200 INEC=1,NBNEUC
                  MCPRDL=MCDBLI+PTRMOR(INEL,INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
                  MCCOEF=MCCOEF+INCREL
200            CONTINUE
               MCDOEF=MCDOEF+INCREC
201         CONTINUE
         ELSEIF (NNEITL.EQ.NBNEUL) THEN
            DO 203 INEL=1,NBNEUL
               MCCOEF=MCDOEF
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 202 KONOEU=1,NNEITC
                  MCPRDL=MCDBLI+PTRMOR(INEL,NUNEFC(KONOEU))
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
202           CONTINUE
              MCDOEF=MCDOEF+INCREC
203        CONTINUE
         ELSEIF (NNEITC.EQ.NBNEUC) THEN
            DO 205 LINOEU=1,NNEITL
               MCCOEF=MCDOEF
               INEL=NUNEFL(LINOEU)
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 204 INEC=1,NBNEUC
                  MCPRDL=MCDBLI+PTRMOR(INEL,INEC)
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
204            CONTINUE
              MCDOEF=MCDOEF+INCREC
205         CONTINUE
         ELSE
            DO 207 LINOEU=1,NNEITL
               MCCOEF=MCDOEF
               INEL=NUNEFL(LINOEU)
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 206 KONOEU=1,NNEITC
                  MCPRDL=MCDBLI+PTRMOR(INEL,NUNEFC(KONOEU))
                  RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
206            CONTINUE
              MCDOEF=MCDOEF+INCREC
207         CONTINUE
         ENDIF
*
      ELSE
*
*        Cas d'une matrice complexe
*
         MCDOEF=MCMATC-1+MCTELM
         IF (NNEITL.EQ.NBNEUL.AND.NNEITC.EQ.NBNEUC) THEN
            DO 401 INEL=1,NBNEUL
               MCCOEF=MCDOEF
*              Adresse de debut de ligne -1
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 400 INEC=1,NBNEUC
                  MCPRDL=MCDBLI+PTRMOR(INEL,INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+1
400            CONTINUE
              MCDOEF=MCDOEF+INCREC
401         CONTINUE
         ELSEIF (NNEITL.EQ.NBNEUL) THEN
            DO 403 INEL=1,NBNEUL
               MCCOEF=MCDOEF
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 402 KONOEU=1,NNEITC
                  MCPRDL=MCDBLI+PTRMOR(INEL,NUNEFC(KONOEU))
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
402           CONTINUE
              MCDOEF=MCDOEF+INCREC
403        CONTINUE
         ELSEIF (NNEITC.EQ.NBNEUC) THEN
            DO 405 LINOEU=1,NNEITL
               MCCOEF=MCDOEF
               INEL=NUNEFL(LINOEU)
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 404 INEC=1,NBNEUC
                  MCPRDL=MCDBLI+PTRMOR(INEL,INEC)
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
404            CONTINUE
              MCDOEF=MCDOEF+INCREC
405         CONTINUE
         ELSE
            DO 407 LINOEU=1,NNEITL
               MCCOEF=MCDOEF
               INEL=NUNEFL(LINOEU)
               MCDBLI=MCTERM-2+PTRDMO(INEL)
               DO 406 KONOEU=1,NNEITC
                  MCPRDL=MCDBLI+PTRMOR(INEL,NUNEFC(KONOEU))
                  CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)  
                  MCCOEF=MCCOEF+INCREL
406            CONTINUE
              MCDOEF=MCDOEF+INCREC
407         CONTINUE
         ENDIF
      ENDIF
                                                                    END !PasMli
