*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASTDO (NBTRDO,ITERDO,INCTRM,ISDTRM,NCHTRM,NOMTRM
     &                  ,INCONU,INDTRD,LGTRIL
     &                  ,PTRDBL,LGLIBM,PTRDBC,LGCOBM,PTRBMO
     &                  ,PTRDML,LGLIMO,PTRMOL,PTRDMC,LGCOMO,PTRMOC
     &                  ,NBNELI,RGNELI,KCLL,NBNEUL,NBNEEL,NBNEFL,NUNEFL
     &                  ,IDLHRL,NUDLNL,NUDLFL,NDLINL
     &                  ,NBNECO,RGNECO,KCLC,NBNEUC,NBNEEC,NBNEFC,NUNEFC
     &                  ,IDLHRC,NUDLNC,NUDLFC,NDLINC
     &                  ,MCMATR,MCMATC,RST ,CST ,ELEMEN,NOMTRA,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)
* Derniere modification : D.Martin (10 novembre 2002)
* Version 1.0.2
*
* Pre-assemblage a l'aide des tableaux de pointeurs des termes 'Elements Finis'
*
*-- Arguments --
* NBTRDO nombre de termes sur le domaine
* ITERDO tableau des numeros des termes sur le domaine = structure #TERDO
*        a l'adresse du numero du 1er terme sur le domaine
* INCTRM increment de la structure $SDTRM de description des termes
* ISDTRM structure $SDTRM a l'adresse du 1er terme
* NCHTRM nombre de caracteres par nom de terme
* NOMTRM tableau #OMTRM des noms de termes
* INCONU structure #NCONU a son adresse initiale
* INDTRD tableau des adresses absolues des termes et des adresses relatives
*        des matrices elementaires
* LGTRIL longueur de la partie triang. inf. d'un stockage BiMorse
* PTRDBL pointeurs des coefficients de debut de ligne dans la partie triang.
*        inferieure de structure BiMorse
* LGLIBM tableau des longueurs des lignes de la partie triang. inferieure
*        de la structure BiMorse
* PTRDBC pointeurs des coefficients de debut de colonne dans la partie triang.
*        superieure de structure BiMorse
* LGCOBM tableau des longueurs des colonnes de la partie triang. superieure
*        de la structure BiMorse
* PTRBMO tableau des pointeurs Bi-Morse des coeff. d'une matrice elementaire
*        dans la matrice assemblee
* PTRDML pointeurs des coefficients de debut de ligne de la structure Morse-L
* LGLIMO tableau des longueurs des lignes de la structure Morse-Ligne
* PRTMOL tableau des pointeurs Morse-Ligne des coeff. d'une matrice
*        elementaire dans la matrice assemblee
* PTRDMC pointeurs des coefficients de debut de colonne de la structure Morse-C
* LGCOMO tableau des longueurs des lignes de la structure Morse-Colonne
* PRTMOC tableau des pointeurs Morse-Colonne des coeff. d'une matrice 
*        elementaire dans la matrice assemblee
* NBNELI nombre de noeuds du domaine pour l'interpolation en ligne
* RGNELI tableau des rangs des noeuds de l'element dans la numerotation
*        en ligne du domaine (pour l'assemblage des vecteurs)
* KCLL   classe de l'element pour l'interpolation en ligne
* NBNEUL nbr de noeuds par elt. pour l'interp. en ligne compte tenu de INDEXL
* NBNEEL nombre de noeuds de l'element pour l'interp. en ligne
* NBNEFL nombre de noeuds de la face de l'element pour l'interp. en ligne
* NUNEFL tableau de corresp. numero de noeud de face -> numero dans l'element
* NBNECO nombre de noeuds du domaine pour l'interpolation en colonne
* RGNECO tableau des rangs des noeuds de l'element dans la numerotation
*        en ligne du domaine (pour l'assemblage des vecteurs)
* KCLC   classe de l'element pour l'interpolation en colonne
* NBNEUC nbr de noeuds par elt. pour l'interp. en colonne compte tenu de INDEXC
* NBNEEC nombre de noeuds de l'element pour l'interp. en colonne
* NBNEFC nombre de noeuds de la face de l'element pour l'interp. en colonne
* NUNEFC tableau de corresp. numero de noeud de face -> numero dans l'element
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* RST,CST super-tableau version REELLE et COMPLEXE
* NOMTRA chaine de caractere receptrice d'un nom de terme
* ELEMEN numero de l'element en cours (impression)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTRM(*),NOMTRA
      INTEGER NBTRDO,ITERDO(*),INCTRM,ISDTRM(*),NCHTRM,INCONU(*)
     &       ,INDTRD(*),LGTRIL,PTRDBL(*),LGLIBM(*),PTRDBC(*)
     &       ,LGCOBM(*),PTRBMO(*),PTRDML(*),LGLIMO(*),PTRMOL(*)
     &       ,PTRDMC(*),LGCOMO(*),PTRMOC(*)
     &       ,NBNELI,RGNELI(*),KCLL,NBNEUL,NBNEEL,NBNEFL,NUNEFL(*)
     &       ,IDLHRL,NUDLNL(*),NUDLFL(*),NDLINL(*)
     &       ,NBNECO,RGNECO(*),KCLC,NBNEUC,NBNEEC,NBNEFC,NUNEFC(*)
     &       ,IDLHRC,NUDLNC(*),NUDLFC(*),NDLINC(*)
     &       ,MCMATR,MCMATC,ELEMEN,IMPFCH
      REAL    RST(*)
      COMPLEX CST(*)
*
      INTEGER INDSTO,INTYKL
      INTEGER INTYEF,INDSTB,INDSML,INDSMC,LETERM,NUTERM
     &       ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &       ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVNUML,NBLIGN,NVDUML
     &       ,INDSTK,KVNUMS,NVCORC,IATRDO,NIVIMP
     &       ,MCTERM,ADRELM,NNEITL,NCPINL,NNEITC,NCPINC,IB
     &       ,MCTRIA,NBNEMI,NCFSSD
     &       ,KDERIC,KNDEXC,KDERIL,KNDEXL,INSYME
      CHARACTER     ERCODE*120,TYPINT*1
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PasTdo*')
      INTYEF=INTYKL ('ELFINI')                                          !utilite
      INDSTB=INDSTO ('BIMORSE')                                         !utilite
      INDSML=INDSTO ('MORSE-L')                                         !utilite
      INDSMC=INDSTO ('MORSE-C')                                         !utilite
*
      DO 1 LETERM=1,NBTRDO
         NUTERM=ITERDO(LETERM)
*        Terme deja calcule ou terme non 'ELFINI', on saute
         IF (NUTERM.LE.0.OR.INDTRD(LETERM+5*NBTRDO).LE.0) GOTO 1
*
*        Recherche des caracteristiques du terme
         CALL GETTRM (ISDTRM(1+INCTRM*(NUTERM-1)) ,NIVTRM,ITYPTR,ITYCAL
     &               ,NUKALE,NUDONN,ITYSYM,IPTDIR,NUINCC,NVDUMC,NBCOLO
     &               ,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INDSTK,KVNUMS
     &               ,NVCORC,IATRDO,NIVIMP)                             !sdexplo
         IF (ITYCAL.NE.INTYEF) GOTO 1
*
*        Nom et niveau du terme a assembler
         CALL GETCHN (NOMTRM,NCHTRM,NUTERM,NOMTRA)                      !utilite
*        Recherche des attributs de l'integrand
         CALL INTATR (NUKALE,KDERIC,KNDEXC,KDERIL,KNDEXL,INSYME)        !integra
*
*        Adresse absolue du terme et relative de la matrice elementaire
         MCTERM=INDTRD(LETERM)
         ADRELM=INDTRD(LETERM+NBTRDO)
         IF (KDERIC.LE.-1) THEN
*
*           Assemblage des termes unicolonnes
*
            NNEITL=NBNEFL
*           Cas ou le terme ne necessite pas l'extension du domaine
*           bien que le domaine soit etendu.
*           Dans ce cas, le vecteur elementaire est en NBNEFL,
*                        mais le tableau RGNELI est en NBNEEL
            IF (KDERIL.GT.KCLL.AND.KNDEXL.EQ.1) NNEITL=NBNEEL
*
*           Rappel: NBNEUL=NBNEEL  si domaine:    NDIM
*                                  ou si domaine: NDMDOM + extension,
*                   NBNEUL=NBNEFL  si domaine:    NDMDOM sans extension.
*
*           Nombre de composantes de l'inconnue en ligne
            CALL SDEXCO (NUINCL,INCONU,NCPINL,IB,IB)                    !utilite
            IF (NCPINL.EQ.1) THEN
*              Inconnue scalaire
               IF (IDLHRL.GT.0) THEN
                  GOTO 99991
*                  CALL PASVEH (NBNEUL,NNEITL,NUNEFL,RGNELI,NDLINL,NUDLNL
*     &                        ,MCMATR,MCMATC,ADRELM,NCPINL
*     &                        ,TYPINT(ITYPTR),MCTERM,RST,CST)          !caltrm
               ELSE
                  CALL PASVEC (NBNEUL,NNEITL,NUNEFL,RGNELI,MCMATR,MCMATC
     &                        ,ADRELM,TYPINT(ITYPTR),MCTERM,RST,CST)    !caltrm
               ENDIF
            ELSE
*              Inconnue vectorielle
               IF (IDLHRL.GT.0) THEN
                  GOTO 99991
*                  CALL PASVEH (NBNEUL,NNEITL,NUNEFL,RGNELI,NDLINL,NUDLNL
*     &                        ,MCMATR,MCMATC,ADRELM,NCPINL
*     &                        ,TYPINT(ITYPTR),MCTERM,RST,CST)          !caltrm
               ELSE
                  CALL PAVVEC (NBNEUL,NNEITL,NUNEFL,RGNELI,MCMATR,MCMATC
     &                        ,ADRELM,NCPINL
     &                        ,TYPINT(ITYPTR),MCTERM,RST,CST)           !caltrm
               ENDIF
            ENDIF
*
         ELSE
*
*           Assemblage des termes matriciels
*
            NNEITL=NBNEFL 
            IF (KDERIL.GT.KCLL.AND.KNDEXL.EQ.1) NNEITL=NBNEEL 
            NNEITC=NBNEFC 
            IF (KDERIC.GT.KCLC.AND.KNDEXC.EQ.1) NNEITC=NBNEEC
*           Nombre de composantes des inconnues en ligne et colonne
            CALL SDEXCO (NUINCL,INCONU,NCPINL,IB,IB)                    !utilite
            CALL SDEXCO (NUINCC,INCONU,NCPINC,IB,IB)                    !utilite
*
            IF (INDSTK.EQ.INDSTB) THEN
*
*               Stockage Bi-Morse
*
               IF (NCPINC.EQ.1.AND.NCPINL.EQ.1) THEN
*                 Inconnues scalaires en ligne et colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
                  ELSE
                     MCTRIA=MCTERM+MIN (NBNECO,NBNELI)
                     CALL PASLBM (NBNEUL,NNEITL,NUNEFL,RGNELI           
     &                           ,NBNEUC,NNEITC,NUNEFC,RGNECO
     &                           ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                           ,MCTERM,MCTRIA,PTRDBL,PTRBMO,RST,CST)  !caltrm
                     IF (ITYSYM.EQ.0) THEN
                        MCTRIA=MCTRIA+LGTRIL
                        CALL PASUBM (NBNEUL,NNEITL,NUNEFL,RGNELI        
     &                              ,NBNEUC,NNEITC,NUNEFC,RGNECO
     &                              ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                              ,MCTRIA,PTRDBC,PTRBMO,RST,CST)      !caltrm
                     ENDIF
                  ENDIF
               ELSE
*                 Inconnues vectorielles en ligne ou colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
                  ELSE
                     NBNEMI=MIN (NBNECO,NBNELI)
                     MCTRIA=MCTERM+MIN (NCPINC*NBNECO,NCPINL*NBNELI)
                     CALL PAVLBM (NBNEUL,NNEITL,NUNEFL,RGNELI,NCPINL    
     &                           ,NBNEUC,NNEITC,NUNEFC,RGNECO,NCPINC
     &                           ,NBNEMI,MCMATR,MCMATC
     &                           ,ADRELM,TYPINT(ITYPTR),MCTERM,MCTRIA
     &                           ,PTRDBL,LGLIBM,PTRBMO,RST,CST)         !caltrm
                     IF (ITYSYM.EQ.0) THEN
                        NCFSSD=NCPINC
                        IF (NCPINC.LT.3) NCFSSD=NCPINC-1
                        MCTRIA=MCTRIA+NCPINC*NCPINL*LGTRIL+NCFSSD*NBNEMI
                        CALL PAVUBM (NBNEUL,NNEITL,NUNEFL,RGNELI,NCPINL 
     &                              ,NBNEUC,NNEITC,NUNEFC,RGNECO,NCPINC
     &                              ,NBNEMI,MCMATR,MCMATC
     &                              ,ADRELM,TYPINT(ITYPTR),MCTRIA,PTRDBC
     &                              ,LGCOBM,PTRBMO,RST,CST)             !caltrm
                     ENDIF
                  ENDIF
               ENDIF
*
            ELSEIF (INDSTK.EQ.INDSML) THEN
*
*               Stockage Morse-Ligne
*
               IF (NCPINC.EQ.1.AND.NCPINL.EQ.1) THEN
*                 Inconnues scalaires en ligne et colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
*                    CALL PASMLH (NBNEUL,NNEITL,NUNEFL,IDLHRL,NDLINL
*     &                          ,NCPINL,NBNEUC,NNEITC,NUNEFC,IDLHRC
*     &                          ,NDLINC,NCPINC,MCMATR,MCMATC
*     &                          ,ADRELM,TYPINT(ITYPTR),MCTERM,PTRDML
*     &                          ,LGLIGN,PTRMOL,RST,CST)                !caltrm
                  ELSE
                     CALL PASMLI (NBNEUL,NNEITL,NUNEFL                   
     &                           ,NBNEUC,NNEITC,NUNEFC
     &                           ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                           ,MCTERM,PTRDML,PTRMOL,RST,CST)         !caltrm
                  ENDIF
               ELSE
*                 Inconnues vectorielles en ligne ou colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
                  ELSE
                     CALL PAVMLI (NBNEUL,NNEITL,NUNEFL,NCPINL                 
     &                           ,NBNEUC,NNEITC,NUNEFC,NCPINC
     &                           ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                           ,MCTERM,PTRDML,PTRMOL,LGLIMO,RST,CST)  !caltrm

                  ENDIF
               ENDIF
*
            ELSEIF (INDSTK.EQ.INDSMC) THEN
*
*               Stockage Morse-Colonne
*
               IF (NCPINC.EQ.1.AND.NCPINL.EQ.1) THEN
*                 Inconnues scalaires en ligne et colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
*                     CALL PASMCH (NBNEUL,NNEITL,NUNEFL,IDLHRL,NDLINL
*     &                           ,NCPINC,NBNEUC,NNEITC,NUNEFC,IDLHRC
*     &                           ,NDLINC,NCPINL,MCMATR,MCMATC,ADRELM
*     &                           ,TYPINT(ITYPTR),MCTERM,PTRDMC,PTRMOC
*     &                           ,RST,CST)                             !caltrm
                  ELSE
                     CALL PASMCO (NBNEUL,NNEITL,NUNEFL                   
     &                           ,NBNEUC,NNEITC,NUNEFC
     &                           ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                           ,MCTERM,PTRDMC,PTRMOC,RST,CST)         !caltrm
                  ENDIF
               ELSE
*                 Inconnues vectorielles en ligne ou colonne
                  IF (IDLHRL.GT.0.OR.IDLHRC.GT.0) THEN
                     GOTO 99991
                  ELSE
                     CALL PAVMCO (NBNEUL,NNEITL,NUNEFL,NCPINL            
     &                           ,NBNEUC,NNEITC,NUNEFC,NCPINC
     &                           ,MCMATR,MCMATC,ADRELM,TYPINT(ITYPTR)
     &                           ,MCTERM,PTRDMC,PTRMOC,LGCOMO,RST,CST)  !caltrm
                  ENDIF
               ENDIF
            ENDIF
*
         ENDIF
1     CONTINUE
      CALL PRFXMJ (-1,'*PasTdo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('Interpolation Hermite non active.')
                                                                    END !PasTdo
