*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASTEC (TYTERM,MCTERM,MCELMR,MCELMC
     &                  ,NBTNEL,NBNELI,RGNELI,NCPINL,INTINL
     &                  ,NBNEFL,NBNEUL,NUNEFL
     &                  ,NBTNEC,NBNECO,RGNECO,NCPINC,INTINC
     &                  ,NBNEFC,NBNEUC,NUNEFC,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : C.Chambeyron (Novembre 2002)
* Derniere modification : D.Martin & C.Chambeyron (17 novembre 2009) 
* Version 2
*
* Pre-ASsemblage d'un Terme Elflqu pour un stockage PLEIN-C
*
*-- Arguments --
* TYTERM type (reel ou complexe) du terme
* MCTERM adresse absolue du terme
* MCELMR adresse de la matrice elementaire, cas reel
* MCELMC adresse de la matrice elementaire cas complexe
* NBTNEL nombre de dl de l'inconnue en ligne si elle est variationnelle
*        nombre de fonctions propres si l'inconnue en ligne est spectrale
* NBNELI nombre de noeuds sur le domaine pour l'interpolation en ligne
* RGNELI rangs des noeuds du domaine dans la numerotation globale en noeuds
*        pour l'interpolation en ligne
* NCPINL nombre de composantes de l'inconnue en ligne
* INTINL type d'interpolation de l'inconnue en ligne
* NBNEFL nombre de noeuds d'interpolation en ligne sur une face d'un element 
* NBNEUL nombre de noeuds d'interpolation en ligne sur un element 
*        = NBNEFL dans le cas du bord sans extension 
* NUNEFL correspondance noeud de face <--> noeud dans l'element en ligne
* NBTNEC nombre de dl de l'inconnue en colonne si elle est variationnelle
*        nombre de fonctions propres si l'inconnue en colonne est spectrale
* NBNECO nombre de dl sur le domaine pour l'interpolation en colonne
* RGNECO rangs des noeuds dans la numerotation globale en noeuds
*        pour l'interpolation en colonne
* NCPINC nombre de composantes de l'inconnue en colonne
* INTINC type d'interpolation de l'inconnue en colonne
* NBNEFC nombre de noeuds d'interpolation en colonne sur une face d'un element 
* NBNEUC nombre de noeuds d'interpolation en ligne sur un element 
*        = NBNEFC dans le cas du bord sans extension 
* NUNEFC correspondance noeud de face <--> noeud dans l'element en colonne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER TYTERM
      INTEGER MCTERM,MCELMR,MCELMC
     &       ,NBTNEL,NBNELI,RGNELI(*),NCPINL,INTINL,NBNEFL,NBNEUL
     &       ,NUNEFL(*)  
     &       ,NBTNEC,NBNECO,RGNECO(*),NCPINC,INTINC,NBNEFC,NBNEUC
     &       ,NUNEFC(*)    
      COMPLEX CST(*)
      REAL    RST(*)
*    
      INTEGER MCELEM,MCCOTR,MCCOTL,NOEULI,NSPECT,NEUNUM,NOEUCO,III
      CHARACTER     ERCODE*120,TYPINT*1
      COMMON/FORMAH/ERCODE
*------------------------------------------------------------------------ 
      IF (INTINC.EQ.-1) THEN
*
*        Inconnue Spectrale en colonne, 
*        Inconnue scalaire ou vectorielle de type 'Valeurs Nodales' en ligne
*
         IF (TYTERM.EQ.'R') THEN
*           Terme/matrice reelle   
            MCELEM=MCELMR
            DO 22 NOEUCO = 1,NBTNEC
               MCCOTL=MCTERM+(NOEUCO-1)*NBNELI*NCPINL
               DO 21 NOEULI = 1,NBNEUL
                  NEUNUM=NOEULI
                  IF (NBNEUL.NE.NBNEFL) NEUNUM=NUNEFL(NOEULI) 
                  MCCOTR=MCCOTL+(RGNELI(NEUNUM)-1)*NCPINL
                  DO 20 III = 1,NCPINL
                     RST(MCCOTR)=RST(MCCOTR)+RST(MCELEM) 
                     MCCOTR=MCCOTR+1
                     MCELEM=MCELEM+1
 20               CONTINUE
 21            CONTINUE
 22         CONTINUE
         ELSE
            MCELEM=MCELMC
            DO 42 NOEUCO = 1,NBTNEC
               MCCOTL=MCTERM+(NOEUCO-1)*NBNELI*NCPINL
               DO 41 NOEULI = 1,NBNEUL
                  NEUNUM=NOEULI 
                  IF (NBNEUL.NE.NBNEFL) NEUNUM=NUNEFL(NOEULI) 
                  MCCOTR=MCCOTL+(RGNELI(NEUNUM)-1)*NCPINL
                  DO 40 III = 1,NCPINL
                     CST(MCCOTR)=CST(MCCOTR)+CST(MCELEM)
                     MCCOTR=MCCOTR+1
                     MCELEM=MCELEM+1
 40               CONTINUE
 41            CONTINUE
 42         CONTINUE
         ENDIF
*
      ELSEIF (INTINL.EQ.-1) THEN
*
*        Inconnue Spectrale en ligne
*        Inconnue scalaire de type 'Valeurs Nodales' en colonne
*
         IF (TYTERM.EQ.'R') THEN
            DO 25 NOEUCO = 1,NBNEUC
               NEUNUM=NOEUCO    
               IF (NBNEUC.NE.NBNEFC) NEUNUM=NUNEFC(NOEUCO) 
               MCELEM=MCELMC+(NOEUCO-1)
               MCCOTL=MCTERM+(RGNECO(NOEUCO)-1)*NBTNEL
               DO 24 NOEULI = 1,NBTNEL                     
                  MCCOTR=MCCOTL+NOEULI-1                              
                  RST(MCCOTR)=RST(MCCOTR)+RST(MCELEM)
                  MCELEM=MCELEM+NBNEUC              
 24            CONTINUE
 25         CONTINUE
         ELSE     
            DO 45 NOEUCO = 1,NBNEUC
               NEUNUM=NOEUCO    
               IF (NBNEUC.NE.NBNEFC) NEUNUM=NUNEFC(NOEUCO) 
               MCELEM=MCELMC+(NOEUCO-1)
               MCCOTL=MCTERM+(RGNECO(NOEUCO)-1)*NBTNEL
               DO 44 NOEULI = 1,NBTNEL                     
                  MCCOTR=MCCOTL+NOEULI-1                              
                  CST(MCCOTR)=CST(MCCOTR)+CST(MCELEM)
                  MCELEM=MCELEM+NBNEUC              
 44            CONTINUE
 45         CONTINUE
         ENDIF
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 2 : D.Martin & C.Chambeyron (17 novembre 2009)
* - cas d'une inconnue vectorielle en ligne
* Version 1 : C.Chambeyron (27 janvier 2003) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !PasTeC
                       
  
