*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE PASTIS (NBTRDO,ITERDO,INCTRM,ISDTRM,NCHTRM,NOMTRM
     &                   ,INCONU,INDTRD
     &                   ,NBNELI,RGNELI,KCLL,NBNEUL,NBNEEL,NBNEFL,NUNEFL
     &                   ,NBNECO,RGNECO,KCLC,NBNEUC,NBNEEC,NBNEFC,NUNEFC
     &                   ,MCMATR,MCMATC,RST,CST,ELEMEN,NOMTRA,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : C.Chambeyron (novembre 2002)
* Derniere modification : D.Martin (16 octobre 2006) 
* Version 2
*
* Pre-ASsemblage des Terme Elements Finis localISes
* -   -              -                         -- 
* calcules par integration numerique
*
*--  Arguments --
* NBTRDO nombre de termes sur le domaine
* ITERDO tableau des numeros des termes sur le domaine = structure #TERDO
*        a l'adresse du numero du 1er terme sur le domaine
* INCTRM increment de la structure $SDTRM de description des termes
* ISDTRM structure $SDTRM a l'adresse du 1er terme
* NCHTRM nombre de caracteres par nom de terme
* NOMTRM tableau #OMTRM des noms de termes
* INCONU structure #NCONU a son adresse initiale
* INDTRD tableau des adresses absolues des termes et des adresses relatives
*        des matrices elementaires 
* NBNELI nombre de noeuds du domaine pour l'interpolation en ligne
* RGNELI tableau des rangs des noeuds de l'element dans la numerotation
*        en ligne du domaine (pour l'assemblage des vecteurs)
* KCLL   classe de l'element pour l'interpolation en ligne
* NBNEUL nbr de noeuds par elt. pour l'interp. en ligne compte tenu de INDEXL
* NBNEEL nombre de noeuds de l'element pour l'interp. en ligne
* NBNEFL nombre de noeuds de la face de l'element pour l'interp. en ligne
* NUNEFL tableau de corresp. numero de noeud de face -> numero dans l'element
* NBNECO nombre de noeuds du domaine pour l'interpolation en colonne
* RGNECO tableau des rangs des noeuds de l'element dans la numerotation
*        en ligne du domaine (pour l'assemblage des vecteurs)
* KCLC   classe de l'element pour l'interpolation en colonne
* NBNEUC nbr de noeuds par elt. pour l'interp. en colonne compte tenu de INDEXC
* NBNEEC nombre de noeuds de l'element pour l'interp. en colonne
* NBNEFC nombre de noeuds de la face de l'element pour l'interp. en colonne
* NUNEFC tableau de corresp. numero de noeud de face -> numero dans l'element
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* RST,CST super-tableau version REELLE et COMPLEXE
* NOMTRA chaine de caractere receptrice d'un nom de terme
* ELEMEN numero de l'element en cours (impression)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER NOMTRM(*),NOMTRA
*
      INTEGER NBTRDO,ITERDO(*),INCTRM,ISDTRM(*),NCHTRM,INCONU(*)
     &       ,INDTRD(*)
     &       ,NBNELI,RGNELI(*),KCLL,NBNEUL,NBNEEL,NBNEFL,NUNEFL(*)
     &       ,NBNECO,RGNECO(*),KCLC,NBNEUC,NBNEEC,NBNEFC,NUNEFC(*)    
     &       ,MCMATR,MCMATC,ELEMEN,IMPFCH,M,N
      REAL    RST(*)
      COMPLEX CST(*)
*
      INTEGER INDSTO,INTYKL
      INTEGER INTYQU,LETERM,NUTERM,ADRELM
     &       ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSBM
     &       ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML
     &       ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP,MCTERM,MCELMC,MCELMR
     &       ,NCPINC,INTINC,NBTNEC,NCPINL,INTINL,NBTNEL
*
      CHARACTER     ERCODE*120,STOIND*7,TYPINT*2,STKIND*7
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PasTis*')
      INTYQU=INTYKL ('ELFLQU')                                          !utilite
*
      DO 1 LETERM=1,NBTRDO
         NUTERM=ITERDO(LETERM)
*        Terme deja calcule, on saute
         IF (NUTERM.LE.0.OR.INDTRD(LETERM+5*NBTRDO).LE.0) GOTO 1
*
*        Recherche des caracteristiques du terme
         CALL GETTRM (ISDTRM(1+INCTRM*(NUTERM-1)),NIVTRM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSBM
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP)               !sdexplo
*
*        On ne travaille que pour le termes Elements Finis LOcalises
         IF (ITYCAL.NE.INTYQU) GOTO 1
* 
*        Nom et niveau du terme a assembler
         CALL GETCHN (NOMTRM,NCHTRM,NUTERM,NOMTRA)                      !utilite
*    
*        Adresse absolue du terme et relative de la matrice elementaire
*
         MCTERM=INDTRD(LETERM)
         ADRELM=INDTRD(LETERM+NBTRDO) 
         MCELMC=MCMATC+ADRELM-1
         MCELMR=MCMATR+ADRELM-1
*   
*        Recherche des caracteristiques des inconnues
*
         NCPINC=1
         INTINC=0
         IF (NUINCC.NE.0)
     &        CALL SDEXCO (NUINCC,INCONU,NCPINC,INTINC,NBTNEC)          !utilite
         NCPINL=1
         INTINL=0
         IF (NUINCL.NE.0) 
     &        CALL SDEXCO (NUINCL,INCONU,NCPINL,INTINL,NBTNEL)          !utilite
*
         STKIND=STOIND (INDSTK)                                         !utilite
         IF (INTINL.EQ.-1.AND.INTINC.EQ.-1) THEN
*            Matrice Spectrale x Spectrale :
*            Stockage BIMORSE, PLEIN-L ou PLEIN-C selon les rangs relatifs
*            des inconnues dans le tableau des inconnues
             CALL PASTSS (TYPINT(ITYPTR),STKIND,MCTERM,MCELMR,MCELMC
     &                   ,NBTNEL,NCPINL,NBTNEC,NCPINC,RST,CST)          !caltrm
*
         ELSEIF (STKIND.EQ.'PLEIN-L') THEN
*
*           Stockage PLEIN-Ligne
            CALL PASTEL (TYPINT(ITYPTR),MCTERM,MCELMR,MCELMC
     &                  ,NBTNEL,NBNELI,RGNELI,NCPINL,INTINL
     &                  ,NBNEFL,NBNEUL,NUNEFL
     &                  ,NBTNEC,NBNECO,RGNECO,NCPINC,INTINC
     &                  ,NBNEFC,NBNEUC,NUNEFC,RST,CST)                  !caltrm
*
         ELSEIF (STKIND.EQ.'PLEIN-C') THEN
*
*           Stockage PLEIN-Colonne
            CALL PASTEC (TYPINT(ITYPTR),MCTERM,MCELMR,MCELMC
     &                  ,NBTNEL,NBNELI,RGNELI,NCPINL,INTINL
     &                  ,NBNEFL,NBNEUL,NUNEFL
     &                  ,NBTNEC,NBNECO,RGNECO,NCPINC,INTINC
     &                  ,NBNEFC,NBNEUC,NUNEFC,RST,CST)                  !caltrm
*
         ENDIF
*
 1    CONTINUE
      CALL PRFXMJ (-1,'*PasTis*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 2 : D.Martin (16 octobre 2006)
*  - rangement BIMORSE, PLEIN-L ou PLEIN-C des termes selon les inconnues
*    pour les termes a couple d'inconnues spectrales
*  - suppression des 10 (!) arguments inutilises a l'appel de PASTSS
* Version 1.1 : C.Chambeyron (25 juillet 2006)
*  - rajout des termes Spectral x Spectral : appel de PASTSS
* Version 1 : C.Chambeyron (27 janvier 2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Pastis  

