*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASTSS (TYTERM,STOIND,MCTERM,MCELMR,MCELMC
     &                  ,NBTNEL,NCPINL,NBTNEC,NCPINC,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : C.Chambeyron (Juin 2006)
* Derniere modification : D.Martin (12 octobre 2006) 
* Version 2
*
* Pre-ASsemblage d'un Terme ELFLQU Spectral x Spectral
*
* Remarque : La matrice elementaire est stockee pleine, colonne apres colonne
*            La matrice assemblee est stockee BIMORSE ou PLEIN-L/C
*
*-- Arguments --
* TYTERM type (reel ou complexe) du terme
* STKIND type de stockage (BIMORSE, PLEIN-L, PLEIN-C) du terme
* MCTERM adresse absolue du terme
* MCELMR adresse de la matrice elementaire, cas reel
* MCELMC adresse de la matrice elementaire, cas complexe
* NBTNEL nombre de fonctions propres si l'inconnue en ligne est spectrale
* NCPINL nombre de composantes de l'inconnue en ligne
* NBTNEC nombre de fonctions propres si l'inconnue en colonne est spectrale
* NCPINC nombre de composantes de l'inconnue en colonne
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYTERM,STOIND
      INTEGER MCTERM,MCELMR,MCELMC,NBTNEL,NCPINL,NBTNEC,NCPINC   
      COMPLEX CST(*)
      REAL    RST(*)
*
      INTEGER MCELEM
*------------------------------------------------------------------------     
*
      MCELEM=MCELMR
      IF (TYTERM(1:1).EQ.'C') MCELEM=MCELMC
*
      IF (STOIND(1:7).EQ.'BIMORSE') THEN
*
*        Stockage BiMorse du terme assemble (matrice carree pleine)
*
          CALL MPL2BM (TYTERM,NBTNEL,NBTNEC,'PLEIN-C',MCELEM
     &                ,MCTERM,RST,CST)                                   !morse
*
       ELSEIF (STOIND(1:7).EQ.'PLEIN-C') THEN
*
*         Stockage PLEIN-C du terme assemble (matrice carree pleine)
*
          CALL TPLUST (NBTNEL*NBTNEC,TYTERM,MCTERM,RST,CST
     &                ,TYTERM,MCELEM,RST,CST,TYTERM,MCTERM,RST,CST)      !utiliter
*
       ENDIF
*
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 2 : D.Martin (12 octobre 2006)
* - ajout de l'assemblage Bimorse de la matrice pleine
* - suppression des 10 (!) arguments inutilises
* Version 1 : C.Chambeyron (27 septembre 2006)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                     END !PasTSS

