*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASVEC (NBNEUL,NNEITL,NUNEFL,RGNELI,MCMATR,MCMATC
     &                  ,MCTELM,TYPTRM,MCTERM,RST   ,CST   )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Avril 1989) 
* Derniere modification : D.Martin (10 Avril 1996)
* Version 1.0.0
*  
* Pre-Assemblage d'un vecteur (terme unicolonne) pour une inconnue scalaire
* (cas d'un second membre par exemple)
*  
*-- Arguments d'entree --
* NBNEUL nombre des noeuds en ligne dans (la face de) l'element
* NNEITL nombre de lignes comptees en noeuds du vecteur elementaire
* NUNEFL correspondance noeud de face <--> noeud dans l'element en ligne
* RGNELI tableau des rangs des noeuds en ligne de l'element
* MCTELM tableau contenant le vecteur elementaire dans l'element en cours
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* TYPTRM type REEL ou COMPLEXE du terme
* MCTERM adresse absolue du terme vectoriel assemble
* RST,CST super-tableau version reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*),RGNELI(*)
     &             ,MCMATR,MCMATC,MCTELM,MCTERM
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCCOEF,NOEULI,MCPRDL
*-----------------------------------------------------------------------
      IF (TYPTRM(1:1).EQ.'R') THEN
*
*        Cas d'un vecteur reel
*
         MCCOEF=MCMATR-1+MCTELM
*
         IF (NNEITL.EQ.NBNEUL) THEN
            DO 21 NOEULI=1,NNEITL
               MCPRDL=MCTERM+RGNELI(NOEULI)-1
               RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
               MCCOEF=MCCOEF+1
21          CONTINUE
         ELSE
            DO 23 NOEULI=1,NNEITL
               MCPRDL=MCTERM+RGNELI(NUNEFL(NOEULI))-1
               RST(MCPRDL)=RST(MCPRDL)+RST(MCCOEF)
               MCCOEF=MCCOEF+1
23          CONTINUE
         ENDIF
*
      ELSEIF (TYPTRM(1:1).EQ.'C') THEN
*
*        Cas d'une vecteur complexe
*
         MCCOEF=MCMATC-1+MCTELM
*
         IF (NNEITL.EQ.NBNEUL) THEN
            DO 41 NOEULI=1,NNEITL
               MCPRDL=MCTERM+RGNELI(NOEULI)-1
               CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)
               MCCOEF=MCCOEF+1
41          CONTINUE
         ELSE
            DO 43 NOEULI=1,NNEITL
               MCPRDL=MCTERM+RGNELI(NUNEFL(NOEULI))-1
               CST(MCPRDL)=CST(MCPRDL)+CST(MCCOEF)
               MCCOEF=MCCOEF+1
43          CONTINUE
         ENDIF
      ENDIF
                                                                    END !PasVec
