*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PASVEH (NBNEUL,NNEITL,NUNEFL,RGNELI,NDLINL,NULINE
     &                  ,MCMATR,MCMATC,MCTELM,NCPINL,TYPTRM,MCTERM
     &                  ,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1989) 
* Derniere modification : D.Martin (10 Avril 1996)
* Version 1.0.0
*  
* Pre-Assemblage d'un terme vectoriel dans le cas Hermite
*  
*-- Arguments d'entree --
* NBNEUL nombre des noeuds en ligne dans l'element
* NNEITL nombre de lignes comptees en noeuds du vecteur elementaire
* NUNEFL correspondance noeud de face <--> noeud dans l'element en ligne
* RGNELI tableau des rangs des noeuds en ligne de l'element
* NDLINL nombre de d.l. par noeud dans l'element en ligne
* NULINE tableau des numeros des premiers d.l. de chaque noeud en ligne
* MCTELM tableau contenant le vecteur elementaire dans l'element en cours
* MCMATR adresse absolue du tableau des matrices elementaires reelles
* MCMATC adresse absolue du tableau des matrices elementaires complexes
* NCPINL nombre de composantes de l'inconnue du terme vectoriel 
* TYPTRM type REEL ou COMPLEXE du terme
* MCTERM adresse absolue du terme vectoriel assemble
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPTRM
      INTEGER       NBNEUL,NNEITL,NUNEFL(*),RGNELI(*),NDLINL(*)
     &             ,NULINE(*),MCMATR,MCMATC,MCTELM,NCPINL,MCTERM
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCCOEF,INEUL,INEL,MCPRDL,MCAUDL
*-----------------------------------------------------------------------
      IF (TYPTRM(1:1).EQ.'R') THEN
*
*        Cas d'un vecteur reel
* 
         MCCOEF=MCMATR-1+MCTELM
         IF (NNEITL.EQ.NBNEUL) THEN
            DO 22 INEUL=1,NBNEUL
               MCPRDL=MCTERM+NCPINL*(NULINE(RGNELI(INEUL))-1)
               DO 21 MCAUDL=MCPRDL,MCPRDL+NCPINL*NDLINL(INEUL)-1
                  RST(MCAUDL)=RST(MCAUDL)+RST(MCCOEF)    
21                MCCOEF=MCCOEF+1
22          CONTINUE
         ELSE
            DO 24 INEL=1,NNEITL
               INEUL=NUNEFL(INEL)
               MCPRDL=MCTERM+NCPINL*(NULINE(RGNELI(INEUL))-1)
               DO 23 MCAUDL=MCPRDL,MCPRDL+NCPINL*NDLINL(INEUL)-1
                  RST(MCAUDL)=RST(MCAUDL)+RST(MCCOEF)    
23                MCCOEF=MCCOEF+1
24          CONTINUE
         ENDIF
*
      ELSEIF (TYPTRM(1:1).EQ.'C') THEN
*
*        Cas d'un vecteur complexe
*
         MCCOEF=MCMATC-1+MCTELM
         IF (NNEITL.EQ.NBNEUL) THEN
            DO 42 INEUL=1,NBNEUL
               MCPRDL=MCTERM+NCPINL*(NULINE(RGNELI(INEUL))-1)
               DO 41 MCAUDL=MCPRDL,MCPRDL+NCPINL*NDLINL(INEUL)-1
                  CST(MCAUDL)=CST(MCAUDL)+CST(MCCOEF)    
41                MCCOEF=MCCOEF+1
42          CONTINUE
         ELSE
            DO 44 INEL=1,NNEITL
               INEUL=NUNEFL(INEL)
               MCPRDL=MCTERM+NCPINL*(NULINE(RGNELI(INEUL))-1)
               DO 43 MCAUDL=MCPRDL,MCPRDL+NCPINL*NDLINL(INEUL)-1
                  CST(MCAUDL)=CST(MCAUDL)+CST(MCCOEF)    
43                MCCOEF=MCCOEF+1
44          CONTINUE
         ENDIF
      ENDIF
                                                                    END !PasVeH
