*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VNATRI (NDIM,NBTRDO,ITERDO,ISDTRM,INCTRM,INCONU,IDONNE
     &                  ,INTDRV,NBTRVN,INCREM,KORNOE,INORMA
     &                  ,IECSTE,IRCSTE,ICCSTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1992)  
* Derniere modification : D.Martin (10 novembre 2002)
* Version 1.0.1
*  
* Recherche des attributs des termes 'Valeurs Nodales' et donnee de
* 'Condition Essentielle  (Dirichlet ou Transmission) Non Homogene' 
* sur un domaine de calcul
*  
*-- Arguments --
* NDIM   dimension d'espace  
* NBTRDO nombre de termes sur le domaine  
* ITERDO tableau #TERDO a l'adresse du numero du 1er terme du domaine
* ISDTRM tableau $SDTRM a l'adresse du 1er terme
* INCTRM increment de parcours de la structure $SDTRM
* INCONU structure #NCONU a l'adresse 1
* IDONNE structure $DONNE a l'adresse 1
* INTDRV structure locale de description des termes du domaine
*     Contenu du tableau INTDRV
*     (IATERM   ) numero du terme 
*     (IATERM+1 ) niveau
*     (IATERM+2 ) type reel ou complexe du terme
*     (IATERM+3 ) numero de type de calcul
*     (IATERM+4 ) numero de type de valeur nodale
*     (IATERM+5 ) numero de donnee
*     (IATERM+6 ) niveau d'impression
*     (IATERM+7 ) type de la donnee (FONCTION,TABLEAU)
*     (IATERM+8 ) numero de donnee associee si FONCTION ou TABLEAU
*     (IATERM+9 ) type de la donnee (REEL ou COMPLEXE)
*     (IATERM+10) type de la donnee associee (FONCTION,TABLEAU)
*     (IATERM+11) niveau ou numero de la donnee associee
*     (IATERM+12) type de la donnee associee (REEL ou COMPLEXE)
*     (IATERM+13) nombre de composantes de l'inconnue
*     (IATERM+14) nombre de valeurs par noeud du terme
* NBTRVN nombre de termes 'Valeurs Nodales' ou 'Condition Essentielle'
* INCREM increment pour le terme suivant dans le tableau INTDRV
* KORNOE indique que les coordonnees des noeuds sont necessaires ou non
* INORMA indique que les normales aux noeuds sont necessaires ou non
* IECSTE indique que les constantes entieres sont necessaires ou non
* IRCSTE indique que les constantes reelles sont necessaires ou non
* ICCSTE indique que les constantes complexes sont necessaires ou non
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDIM,NBTRDO,INCTRM,NBTRVN,INCREM,KORNOE,INORMA
     &             ,IECSTE,IRCSTE,ICCSTE
      INTEGER       ITERDO(*),ISDTRM(*),INCONU(*),IDONNE(*),INTDRV(*)
*
      INTEGER       INTYKL,INTDON,INTTYP,INVANO                         !utilite
     &             ,INTYVN,INTYCE,INTYCT,INTDCO,INTDFO,INTDTA
     &             ,ITYENT,ITYREL,ITYCOM,ITYCAR,INVANF,IATERM,NUTERM
     &             ,NIVTRM,ITYPTR,ITYCAL,NUVALE,NUDONN,NCOMNE,NVDSMB
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &             ,NVNUML,INDSTK,NVNUMS,NVCORC,IATRDO,NIVIMP
     &             ,ITYDON,NIVDON,ITYPDO,ITYASS,NIVASS,ITYRAS
     &             ,NCPINC,INTRPC,NBTNEC,IT
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*VnAtri*')
*
      INTYVN=INTYKL ('VALNOD')                                          !utilite
      INTYCE=INTYKL ('C.ESSE')                                          !utilite
      INTYCT=INTYKL ('C.TRAN')                                          !utilite
*
      INTDCO=INTDON ('CONSTANTE')                                       !utilite
      INTDFO=INTDON ('FONCTION')                                        !utilite
      INTDTA=INTDON ('TABLEAU')                                         !utilite
*
      ITYENT=INTTYP ('ENTIER')                                          !utilite
      ITYREL=INTTYP ('REEL')                                            !utilite
      ITYCOM=INTTYP ('COMPLEXE')                                        !utilite
      ITYCAR=INTTYP ('CARACTERE')                                       !utilite
*
      INVANF=INVANO ('F')                                               !utilite
*
      NBTRVN=0
      IATERM=1
*
      DO 1 IT=1,NBTRDO
         NUTERM=ITERDO(IT)  
         CALL GETTRM (ISDTRM((NUTERM-1)*INCTRM+1),NIVTRM,ITYPTR,ITYCAL
     &               ,NUVALE,NUDONN,NCOMNE,NVDSMB,NUINCC,NVDUMC,NBCOLO
     &               ,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INDSTK,NVNUMS
     &               ,NVCORC,IATRDO,NIVIMP)                             !sdexplo
*
*        Si le terme a deja ete calcule et que son calcul n'a pas ete
*        redemande, ou bien s'il n'y a pas de donnee associee, on saute ...
         IF (NUVALE.GT.0.AND.NUDONN.GT.0) THEN
*           On ne calcul que les termes de type Valeurs Nodales,
*           Condition de Dirichlet ou Condition de Transmission,
*           pour lesquelles la donnee n'est pas de type CARACTERE
            IF (ITYPTR.LT.ITYCAR.AND.(ITYCAL.EQ.INTYVN
     &         .OR.ITYCAL.EQ.INTYCE.OR.ITYCAL.EQ.INTYCT)) THEN
               IF (ITYCAL.EQ.INTYCE.OR.ITYCAL.EQ.INTYCT)
     &         NUVALE=INVANF
*              Caracteristiques de la donnee associee au terme
               CALL SDEXCO (NUDONN,IDONNE,ITYDON,NIVDON,ITYPDO)         !sdexplo
               NBTRVN=NBTRVN+1
               INTDRV(IATERM   )=NUTERM
               INTDRV(IATERM+1 )=NIVTRM
               INTDRV(IATERM+2 )=ITYPTR
               INTDRV(IATERM+3 )=ITYCAL
               INTDRV(IATERM+4 )=NUVALE
               INTDRV(IATERM+5 )=NUDONN
               INTDRV(IATERM+6 )=NIVIMP
               INTDRV(IATERM+7 )=ITYDON
               INTDRV(IATERM+8 )=NIVDON
               INTDRV(IATERM+9 )=ITYPDO
               IF (ITYDON.EQ.INTDCO) THEN
*                 Pour une donnee associee CONSTANTE, on a besoin du
*                 tableau des valeurs des CONSTANTE du type ad hoc
                  IF (ITYPDO.EQ.ITYENT) THEN
                     IECSTE=1
                  ELSEIF (ITYPDO.EQ.ITYREL) THEN
                     IRCSTE=1
                  ELSEIF (ITYPDO.EQ.ITYCOM) THEN
                     ICCSTE=1
                  ENDIF
               ELSEIF (ITYDON.EQ.INTDFO) THEN
*                 Pour une donnee associee FONCTION, on a besoin du
*                 tableau des coordonnees des noeuds
                  KORNOE=1
                  IF (NIVDON.GT.0) THEN
*                    Attributs d'une donnee associee a la donnee FONCTION
                     CALL SDEXCO (NIVDON,IDONNE,ITYASS,NIVASS,ITYRAS)   !sdexplo
                     INTDRV(IATERM+10)=ITYASS
                     INTDRV(IATERM+11)=NIVASS
                     INTDRV(IATERM+12)=ITYRAS
                     IF (ITYASS.EQ.INTDCO) THEN
                        IF (ITYRAS.EQ.ITYENT) THEN
                           IECSTE=1
                        ELSEIF (ITYRAS.EQ.ITYREL) THEN
                           IRCSTE=1
                        ELSEIF (ITYRAS.EQ.ITYCOM) THEN
                           ICCSTE=1
                        ENDIF
                     ENDIF
                  ENDIF
               ELSEIF (ITYDON.EQ.INTDTA) THEN 
*                 Si la donnee associee est un TABLEAU,
*                 le terme est donne par un tableau 
                  INTDRV(IATERM+10)=ITYDON
                  INTDRV(IATERM+11)=NIVDON
                  INTDRV(IATERM+12)=ITYPDO
               ENDIF
*
*              Attributs de l'inconnue associee au terme
               CALL SDEXCO (NUINCC,INCONU,NCPINC,INTRPC,NBTNEC)
               INTDRV(IATERM+13)=NCPINC
*
*              Nombre de valeurs par noeud du terme calcule dans TrmDom
*              ou par lecture des directives
               INTDRV(IATERM+14)=NCOMNE
*
               IF (NUVALE.NE.INVANO('TABF')) THEN
*                 Indicateur pour l'utilisation du tableau des coordonnees
                  KORNOE=1
                  IF (NUVALE.NE.INVANF) THEN
*                    Indicateur pour l'utilisation du tableau des normales
                     INORMA=1
                  ENDIF
               ENDIF
*
               IATERM=IATERM+INCREM
            ENDIF
         ENDIF
1     CONTINUE
      CALL PRFXMJ (-1,'*VnAtri*')
                                                                    END !VnAtri
