*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VNQLTR (NBTRDO,NXTRDO,INTRPC,NBNECO,NVNUME,NVNORM
     &                  ,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1989)  
* Derniere modification : D.Martin (15 septembre 2006)
* Version 4
*  
* Calcul des termes 'Valeurs Nodales' et 'Condition Essentielle Non Homogene'
* sur un domaine de calcul
*  
*-- Arguments -- 
* NBTRDO nombre de termes sur le domaine  
* NXTRDO adresse relative du numero du premier terme du domaine dans #TERDO
* INTRPC numero de l'interpolation en colonne pour le domaine
* NBNECO nombre de noeuds sur le domaine de calcul
* NVNUME niveau du tableau #GNEDO pour l'interpolation en colonne
* IMPFCH numero d'unite logique d'impression
* NVNORM niveau du tableaux des normales pour le domaine
*
*-- Procedures utilisees (autres que Lib-Utiliter & Lib-Sdexplo) --
* VNATRI, VNCALC 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER       NBTRDO,NXTRDO,INTRPC,NBNECO,NVNUME,NVNORM,IMPFCH
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*  
      CHARACTER     YKLINT*6,DONINT*9,TYPINT*9                          !utilite
      CHARACTER     ERCODE*120,NODONA*16,NOMDON*16,NOMTRM*16,THETR1*16
      CHARACTER     TYPASS*9,TYPRAS*9,TYPWRK*9
      LOGICAL       READRE
      INTEGER       INTDON
      INTEGER       INCREM,LGWOR0,LGETRM,NBTERM,INCTRM,NCHTRM,LGEDON
     &             ,NBDONN,INCDON,NCHDON
     &             ,MCTRDO,MCDONN,MCDTRM,MCINCO,MCWOR0,MCCORN,MCNORM
     &             ,MCESTE,MCRSTE,MCCSTE,MCMTRM,MCMDON,MCTERM
     &             ,IDTRDO,NBTRVN,IAWOR0,IAWORI,MCASSO,LGASSO
     &             ,NUTERM,NIVTRM,ITYPTR,ITYCAL,NUVALE
     &             ,NUDONN,NIVIMP,ITYDON,NIVDON,ITYRDO,ITYASS,NIVASS
     &             ,ITYRAS,NCPINC,NVALNE,ITERM,MCNUME,NCATR1,NCATR2
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(25:25),TYPASS)
     &            ,(ERCODE(41:41),TYPRAS),(ERCODE(57:57),TYPWRK)
     &            ,(ERCODE(73:73),NODONA),(ERCODE(89:89),NOMDON)
     &            ,(ERCODE(105:105),NOMTRM)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*VnQltr*')
*
      INCREM=15
      LGWOR0=INCREM*NBTRDO
      CALL TBCREE ('$WORK$',0,1,LGWOR0,'c') 
      ERCODE='!'
      CALL TBAR5  (ERCODE,'#TERDO',1,MCTRDO,'$DONNE',1,MCDONN
     &                   ,'$SDTRM',1,MCDTRM,'#NCONU',1,MCINCO
     &                   ,'$WORK$',0,MCWOR0)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !sdexplo
      CALL TAZERO (LGWOR0,'ENTIER',MCWOR0,AST,IST,RST,CST)              !utilite
      IDTRDO=MCTRDO+NXTRDO
      MCDTRM=MCDTRM+LGETRM
*  
*     Preparation pour tous les termes du domaine
*
      MCCORN=-1
      MCNORM=-1
      MCESTE=-1
      MCRSTE=-1
      MCCSTE=-1
      CALL VNATRI (NDIM,NBTRDO,IST(IDTRDO),IST(MCDTRM),INCTRM
     &            ,IST(MCINCO),IST(MCDONN),IST(MCWOR0),NBTRVN,INCREM
     &            ,MCCORN,MCNORM,MCESTE,MCRSTE,MCCSTE)                  !caltrm
*
*     Pour les termes dont le calcul necessite le tableau des coordonnees
*     des noeuds pour l'interpolation en colonne sur le domaine
      IF (MCCORN.GT.0) THEN
         CALL TBRR2  (ERCODE,'#ORNOE',INTRPC,MCCORN
     &                      ,'#GNEDO',NVNUME,MCNUME)
      ENDIF
*     Pour les termes dont le calcul necessite le tableau des composantes
*     de la normale aux noeuds pour l'interpolation en colonne sur le domaine
      IF (MCNORM.GT.0) THEN
         CALL TBRR1  (ERCODE,'&NORMA',NVNORM,MCNORM)
      ENDIF
*
      READRE=.TRUE.
      IAWORI=0
      DO 1 ITERM=1,NBTRVN
         IF (READRE) THEN
*           Les adresses sont susceptibles d'avoir changees par 
*           restauration d'un tableau en M.C. lors de l'iteration precedente
            CALL TBAR3  (ERCODE,'$WORK$',0,MCWOR0 
     &                         ,'#OMTRM',1,MCMTRM,'#OMDON',1,MCMDON)
            READRE=.FALSE.
         ENDIF
         IAWOR0=MCWOR0+IAWORI
         NUTERM=IST(IAWOR0  )
         NIVTRM=IST(IAWOR0+1)
*        type du terme
         ITYPTR=IST(IAWOR0+2)
*        type de calcul ('Valeur Nodale')
         ITYCAL=IST(IAWOR0+3)
*        numero de type de calcul d'un terme 'Valeur Nodale'
         NUVALE=IST(IAWOR0+4)
*        numero de la donnee affectee au terme
         NUDONN=IST(IAWOR0+5)
         NIVIMP=IST(IAWOR0+6)
         ITYDON=IST(IAWOR0+7)
         NIVDON=IST(IAWOR0+8)
         ITYRDO=IST(IAWOR0+9)
*        nombre de composantes par noeuds de l'inconnue
         NCPINC=IST(IAWOR0+13)
*        nombre de composantes par noeuds du terme
         NVALNE=IST(IAWOR0+14)
         NODONA=' '
         TYPRAS=' '
         TYPASS=' '
         ITYASS=-1
         NIVASS=-1
         MCASSO=-1
*        Nom du terme courant  
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NOMTRM)                 !utilite
*        Nom de la donnee affectee au terme
         CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NOMDON)                 !utilite
*
         IF (ITYDON.EQ.INTDON ('CONSTANTE')) THEN                       !utilite
*
            CALL TBAR1  (ERCODE,NOMTRM(1:NCHTRM),NIVTRM,MCTERM)
            TYPRAS=TYPINT (ITYRDO)
            IF (NIVDON.GT.0) THEN
*              Adresse de la constante affectee
               IF (TYPRAS(1:1).EQ.'R') THEN 
                  CALL TBAR1  (ERCODE,'$RCSTE',1,MCASSO) 
               ELSEIF (TYPRAS(1:1).EQ.'C') THEN
                  CALL TBAR1  (ERCODE,'$CCSTE',1,MCASSO)
               ELSE
                  CALL TBAR1  (ERCODE,'$ECSTE',1,MCASSO)
               ENDIF
               CALL TINIT  (TYPRAS,NIVDON+1,AST,IST(MCASSO),RST(MCASSO)
     &                     ,CST(MCASSO),NBNECO*NVALNE,TYPINT(ITYPTR)
     &                     ,MCTERM,AST,IST,RST,CST)                     !utilite
*
               IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
                  CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)  !utilite
                  WRITE (IMPFCH,10000) THETR1(1:NCATR1),YKLINT (ITYCAL)
     &            ,'Constante affectee',NOMDON(1:NCHDON),TYPINT (ITYRDO)
               ENDIF
            ELSE
               CALL TAZERO (NBNECO*NVALNE,TYPRAS
     &                     ,MCTERM,AST,IST,RST,CST)                     !utilite
*
               IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
                  CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)
                  WRITE (IMPFCH,10001) THETR1(1:NCATR1),YKLINT (ITYCAL)
               ENDIF
            ENDIF
*
         ELSEIF (ITYDON.EQ.INTDON ('FONCTION')) THEN
*
            IF (NIVDON.GT.0) THEN
*
*              Nom et attributs d'une donnee associee a la donnee FONCTION
*
               CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NODONA)           !utilite
               ITYASS=IST(IAWOR0+10)
               NIVASS=IST(IAWOR0+11)
               ITYRAS=IST(IAWOR0+12)
               TYPASS=DONINT(ITYASS)  
               TYPRAS=TYPINT(ITYRAS)
               IF (TYPASS(1:9).EQ.'CONSTANTE') THEN 
*                 Adresse de la constante associee a la donnee FONCTION
                  IF (TYPRAS(1:1).EQ.'R') THEN 
                     CALL TBAR1  (ERCODE,'$RCSTE',1,MCASSO) 
                  ELSEIF (TYPRAS(1:1).EQ.'C') THEN 
                     CALL TBAR1  (ERCODE,'$CCSTE',1,MCASSO)
                  ELSE
                     CALL TBAR1  (ERCODE,'$ECSTE',1,MCASSO)
                  ENDIF
                  MCASSO=MCASSO+NIVASS
*
                  IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
                    CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)!utilite
                    WRITE (IMPFCH,10000) THETR1(1:NCATR1),YKLINT(ITYCAL)
     &             ,'Fonction affectee',NOMDON(1:NCHDON),TYPINT (ITYRDO)
     &             ,'Constante associee a la fonction',NODONA(1:NCHDON)
     &             ,TYPRAS
                  ENDIF
               ELSEIF (TYPASS(1:7).EQ.'TABLEAU') THEN  
*                 Adresse du tableau associe a la donnee FONCTION
                  CALL TBRR1  (ERCODE,NODONA(1:NCHDON),NIVASS,LGASSO)
                  READRE=.TRUE.
                  CALL TBAR1  (ERCODE,NODONA(1:NCHDON),NIVASS,MCASSO)
*
                  IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
                    CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)!utilite
                    WRITE (IMPFCH,10000)THETR1(1:NCATR1),YKLINT (ITYCAL)
     &             ,'Fonction affectee',NOMDON(1:NCHDON),TYPINT (ITYRDO)
     &             ,'Tableau associe a la fonction',NODONA(1:NCHDON)
     &             ,TYPRAS
                  ENDIF
               ENDIF 
            ELSE
*
               IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
                  CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)  !utilite
                  WRITE (IMPFCH,10000) THETR1(1:NCATR1),YKLINT(ITYCAL)
     &              ,'Fonction affectee',NOMDON(:NCHDON),TYPINT(ITYRDO)
               ENDIF
            ENDIF
*
*           Calcul effectif du terme pour une donnee affectee FONCTION
*
            CALL TBAR1  (ERCODE,NOMTRM(1:NCHTRM),NIVTRM,MCTERM)
            IF (MCCORN.GT.0) THEN
                CALL TBAR2  (ERCODE,'#ORNOE',INTRPC,MCCORN
     &                             ,'#GNEDO',NVNUME,MCNUME)
            ENDIF
            IF (MCNORM.GT.0) THEN
               CALL TBAR1  (ERCODE,'&NORMA',NVNORM,MCNORM)
            ENDIF
            CALL VNCALC (NOMTRM(1:NCHTRM),NIVTRM,NUVALE,NCPINC,NVALNE
     &                  ,MCTERM,TYPINT(ITYPTR),NOMDON,TYPINT(ITYRDO)
     &                  ,NODONA,NIVASS,TYPASS,TYPRAS,MCASSO,NDIM
     &                  ,NBNECO,IST(MCNUME+2),RST(MCCORN),RST(MCNORM)
     &                  ,IST,RST,CST)                                   !caltrm
*
         ELSEIF (ITYDON.EQ.INTDON ('TABLEAU')) THEN                     !utilite
*
*           Cas d'un terme valeur nodale donne par TABLEAU
*
            NIVASS=NIVDON  
            TYPASS=DONINT (ITYDON)  
            TYPRAS=TYPINT (ITYRDO)  
            CALL TBRR1  (ERCODE,NOMDON(1:NCHDON),NIVASS,LGASSO)
            IF (ERCODE(1:1).NE.' ')      GOTO 99991
            IF (LGASSO.NE.NBNECO*NVALNE) GOTO 99992
            READRE=.TRUE.
            CALL TBAR2  (ERCODE,NOMDON(1:NCHDON),NIVASS,MCASSO
     &                         ,NOMTRM(1:NCHTRM),NIVTRM,MCTERM)
            CALL TDANST (LGASSO,TYPRAS,MCASSO,IST,RST,CST
     &                  ,TYPINT(ITYPTR),MCTERM,IST,RST,CST)             !utilite
*
            IF (NIVIMP.GT.0.AND.IMPFCH.GT.0) THEN
               CALL PRNTRM (NOMTRM (1:NCHTRM),NIVTRM,THETR1,NCATR1)
               WRITE (IMPFCH,10000) THETR1(1:NCATR1),YKLINT(ITYCAL)
     &                ,'Tableau affecte',NOMDON(:NCHDON),TYPINT(ITYRDO)
            ENDIF
*
         ENDIF
1     IAWORI=IAWORI+INCREM
* 
      CALL TBTUER ('$WORK$',0)
      IF (MCCORN.GT.0) THEN
         CALL TBSAVE ('#ORNOE',INTRPC)
         CALL TBSAVE ('#GNEDO',NVNUME)
      ENDIF
      IF (MCNORM.GT.0) THEN
         CALL TBSAVE ('&NORMA',NVNORM)
      ENDIF
      CALL PRFXMJ (-1,'*VnQltr*')
      RETURN 
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*VnQltr* Calcul du terme ',A,' de type ',A
     &,2(/T11,A,' : ',A,' de type ',A,:))
10001 FORMAT(/T2,'*VnQltr* Calcul du terme ',A,' de type ',A
     &,' sans donnee affectee.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NOMTRM(:NCHTRM),NIVTRM,ERCODE,NCATR1)
      CALL BAISE  ('Pas de tableau affecte pour le terme VALeur NODale'
     &//' de type TABF '//ERCODE(1:NCATR1)//'!')
99992 CALL PRNTRM (NOMTRM(1:NCHTRM),NIVTRM,ERCODE,NCATR1)
      CALL PRNTRM (NOMDON(1:NCHDON),NIVDON,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Incoherence de longueur entre la donnee tableau '
     &//ERCODE(NCATR1+1:NCATR2+NCATR2)//' et le terme '
     &//ERCODE(1:NCATR1)//'.')
                                                                    END !VnQltr
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 4 : D.Martin (15 septembre 2006)
* - suppression de la sauvegarde d'un tableau affecte au terme
* Version 3 : D.Martin (9 decembre 2005)
* - suppression de la sauvegarde d'un tableau associe a un fonction affectee
*   au terme
* Version 2 : D.Martin (18 juin 2004)
* Version 1 : D.Martin (1er Mars 1999)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
