*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NOYDIR (NDIM,NORMAP,FGREEN,G,GNP,NIVIMP,IMPFCH) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1987)
* Derniere modification (D.Martin) le 30 Mai 1996
*  
* Calcul du noyau de Green pour un couple de point (M,P) dans le cas 
* du couplage Dirichlet et pour une fonction de Green complexe
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* NORMAP normale en P a la premiere surface (de representation integrale)  
* FGREEN valeurs de la fct. de green et de ses derivees pour un couple (p,m)
*-- Arguments de sortie --
* G      =  G     au point (M,P)
* GNP    = dG/dnp au point (M,P)
*  
*-- Notation : M point sur la frontiere de couplage sigma  
*              P point sur la frontiere portant la representation integrale
*-- Remarque importante : Rangement du tableau FGREEN  
* (1)                   : valeur de la fonction de Green
* (2) a (1+NDIM)        : derivees par rapport a M : dG/dxm,dG/dym,(dG/dzm)
* (2+NDIM) a (1+2*NDIM) : derivees par rapport a P : dG/dxp,dG/dyp,(dG/dzp)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NIVIMP,IMPFCH
      REAL    NORMAP(*)
      COMPLEX G,GNP,FGREEN(*)
*
      INTEGER INDER,IDIM
*----------------------------------------------------------------------
*  
*--   Calcul de d/dnp(g(M,P))  
*  
      INDER=2+NDIM 
      GNP=0.
      DO 1 IDIM=1,NDIM 
         GNP=GNP+FGREEN(INDER)*NORMAP(IDIM)
         INDER=INDER+1
1     CONTINUE 
*  
*--   Calcul de g(M,P) 
*  
      G=FGREEN(1)  
*  
      IF (NIVIMP.LE.2) RETURN
*----------------------------------------------------------------------
      WRITE (IMPFCH,1000) G,GNP  
1000  FORMAT(T6,'<NoyDir>  G = ',SS,E9.3,SP,E9.3,'*i , Gn= '
     &,SS,E9.3,SP,E9.3,'*i')
                                                                    END !NoyDir
