*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CDMODL (IDNUME,NBNELI,NGNELI,NBNECO,NGNECO,NULAPL
     &                  ,IPLAGE,TYMATR,MCMATR,TYSCMB,MCSCMB,NBNEES
     &                  ,NGNEES,TYESSE,MCESSE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1989)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version 1.0.0
*  
* Modification d'un terme matrice 'MORSE' par annulation des coefficients
* non diagonaux des lignes Dirichlet
* et dans le cas d'une condition essentielle non homogene du vecteur
* second-membre par report de Aii*Ui dans la ligne i du second membre 
*  
*-- Arguments --
* IDNUME Donnee logique indiquant l'identite des numerotations en ligne
*        et colonne du terme sur lequel porte l'elimination
* NBNELI Nombre de noeuds en ligne du terme
* NGNELI Numerotation des noeuds en ligne pour l'interpolation en ligne
* NBNECO Nombre de noeuds en colonne du terme  
* NGNECO Numerotation des noeuds en ligne pour l'interpolation en colonne  
* NULAPL Numeros de derniere plage de chaque ligne 
* IPLAGE Numeros de colonne de debut de plage et longueurs cumulees
* TYMATR Type du terme matriciel
* MCMATR Adresse en M.C. du terme  
* TYSCMB Type du terme second membre
* MCSCMB Adresse en M.C. du second membre  
* NBNEES Nombre de noeuds 'Dirichlet'  
* NGNEES Numerotation des noeuds 'Dirichlet'
* TYESSE Type du tableau de la donnee de Dirichlet 
* MCESSE Adresse en M.C. du second membre  
* RST,CST Super-tableau numerique, version reelle et complexe  
*        (n'est necesaire qu'en cas de condition non homogene) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL       IDNUME 
      CHARACTER*(*) TYMATR,TYSCMB,TYESSE 
      INTEGER       NBNELI,NGNELI(*),NBNECO,NGNECO(*),NULAPL(*)
     &             ,IPLAGE(2,*),MCMATR,MCSCMB,NBNEES,NGNEES(*),MCESSE
      REAL          RST(*),ROFDIA  
      COMPLEX       CST(*),COFDIA  
      EQUIVALENCE  (COFDIA,ROFDIA) 
*
      CHARACTER     AST
      INTEGER       IST
      INTEGER       NUPRPL,NUDRPL,LGCUAV,LGCUAP,NXLIGN,NXCOLO,NUNEDI
     &             ,LIGNEI,KOLDIA,MCDIAG,NUPDIA
*-----------------------------------------------------------------------  
      CALL PRFXMJ (1,'*CdMoDl*')
*  
      NUPRPL=1 
      LGCUAV=0 
      NXLIGN=1 
      NXCOLO=1 
*  
      DO 20 NUNEDI=1,NBNEES
*        Recherche des lignes de la matrice correspondant a une relation
*        de la condition essentielle
         CALL DICOTO (NXLIGN,NBNELI,NGNELI,NGNEES(NUNEDI),LIGNEI,*20)   !utilite
         NXLIGN=LIGNEI+1
*  
         IF (LIGNEI.GT.1) THEN
            NUPRPL=NULAPL(LIGNEI-1)+1  
            LGCUAV=IPLAGE(2,NUPRPL-1)  
         ENDIF
         NUDRPL=NULAPL(LIGNEI) 
         LGCUAP=IPLAGE(2,NUDRPL)
*  
*        Recherche de la colonne contenant le coeff. diagonal de la matrice
         KOLDIA=LIGNEI 
         MCDIAG=MCMATR+LGCUAV  
         COFDIA=0. 
         IF (.NOT.IDNUME) THEN
            CALL DICOTO (NXCOLO,NBNECO,NGNECO,NGNEES(NUNEDI),KOLDIA,*10)!utilite
            NXCOLO=KOLDIA+1
         ENDIF
*        Recherche de la plage qui contient le coeff. 'diagonal'
         CALL DIKLPL (KOLDIA,NUPRPL,NUDRPL,LGCUAV,IPLAGE,NUPDIA,*10)    !morse
*  
*        Adresse du coeff. diagonal dans la matrice compactee  
         MCDIAG=0  
         IF (NUPDIA.GT.1) MCDIAG=IPLAGE(2,NUPDIA-1)
         MCDIAG=MCMATR+MCDIAG+KOLDIA-IPLAGE(1,NUPDIA)  
*  
         IF (MCESSE.GT.0)  THEN
*           On reporte Aii x Ui dans le second membre 
            CALL CDSCDI (TYMATR,MCDIAG,TYSCMB,MCSCMB-1+LIGNEI
     &                  ,TYESSE,MCESSE-1+NUNEDI,RST,CST)                !cdesse
         ELSEIF (TYSCMB(1:1).EQ.'R') THEN
*           On pose 0. dans la ligne i du second membre
            RST(MCSCMB-1+LIGNEI)=0.
         ELSE
            CST(MCSCMB-1+LIGNEI)=0.
         ENDIF
*  
         CALL TDANST (1,TYMATR,MCDIAG,IST,RST   ,CST
     &                 ,TYMATR,  1   ,IST,ROFDIA,COFDIA)                !utilite
*  
*        Mise a zero de la ligne excepte pour le coefficient diagonal  
10       CALL TAZERO (LGCUAP-LGCUAV,TYMATR,LGCUAV+1,AST,IST
     &               ,RST(MCMATR),CST(MCMATR))                          !utilite
         CALL TDANST (1,TYMATR,  1   ,IST,ROFDIA,COFDIA
     &                 ,TYMATR,MCDIAG,IST,RST   ,CST   )                !utilite
20    CONTINUE 
      CALL PRFXMJ (-1,'*CdMoDl*')  
                                                                    END !CdMoDl
