*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CDMOVC (NUKAES,NCPNES,NBNELI,NGNELI,NBNECO,NGNECO
     &                  ,NULAPL,IPLAGE,TYMATR,MCMATR,TYSCMB,MCSCMB
     &                  ,NBNEES,NGNEES,TYESSE,MCESSE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (Avril 1989)
* Derniere modification : D.Martin (4 Juillet 1997)
* Version 1.0.0
*  
* Modification d'un terme matrice 'MORSE' par annulation des colonnes
* de noeuds Dirichlet sur les lignes de noeuds non Dirichlet
* et, dans le cas d'une condition essentielle non homogene, d'un terme
* vecteur second-membre par report de l'elimination.
*  
*-- Arguments --
* NUKAES numero de type de condition essebtielle
* NCPNES nombre de composantes de l'inconnue vectorielle
* NBNELI Nombre de noeuds en ligne du terme
* NGNELI Numerotation globale en ligne du terme,
* NBNECO Nombre de noeuds en colonne du terme  
* NGNECO Numerotation globale en colonne du terme, 
* NULAPL Numeros de derniere plage de chaque ligne 
* IPLAGE Numeros de colonne de debut de plage et longueurs cumulees
* TYMATR Type du terme matriciel
* MCMATR Adresse en M.C. du terme matriciel
* TYSCMB Type du second membre eventuel
* MCSCMB Adresse en M.C. du second membre eventuel 
* NBNEES Nombre de noeuds 'Dirichlet'  
* NGNEES Numeros de noeuds des noeuds 'Dirichlet'  
* TYESSE Type de la donnee de Dirichlet
* MCESSE Adresse en M.C. de cette donnee
* RST,CST Super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYSCMB,TYESSE 
      INTEGER       NUKAES,NCPNES,NBNELI,NGNELI(*),NBNECO,NGNECO(*)
     &             ,NULAPL(*),IPLAGE(2,*),MCMATR,MCSCMB
     &             ,NBNEES,NGNEES(*),MCESSE
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPLA,LGCUAP,LGCUAV,LGCUAW,LGLIGL
     &             ,LGCUDL,KOLDEB,KOLFIN,IADRES
     &             ,KOLONJ,LIGNEI,NULINE,NXNEDI,IDIRLI,KOLDIR,NXCODI
     &             ,MCSCM1,IAMATL,IAESSE,I,J
*-----------------------------------------------------------------------  
      CALL PRFXMJ (1,'*CdMovc*')
*  
      NUPRPL=1 
      LGCUAV=0 
      NXNEDI=1 
      MCSCM1=MCSCMB-NCPNES  
*  
      DO 100 LIGNEI=1,NBNELI
         MCSCM1=MCSCM1+NCPNES
         NULINE=NGNELI(LIGNEI) 
         NUDRPL=NULAPL(LIGNEI) 
         LGCUAP=IPLAGE(2,NUDRPL)
         LGCUAW=LGCUAV
         LGCUAV=LGCUAP 
*        Recherche des lignes de la matrice ne correspondant pas a un
*        noeud portant la condition essentielle 
         CALL DICOTO (NXNEDI,NBNEES,NGNEES,NULINE,IDIRLI,*1)            !utilite
         NXNEDI=IDIRLI+1
         GOTO 100
*  
1        NXCODI=1 
*        Cas d'une inconnue vectorielle exprimee dans le repere
*        local (n,t1,t2)
         LGLIGL=(LGCUAP-LGCUAW)*NCPNES
         LGCUDL=LGCUAW*NCPNES*NCPNES
         IF (TYMATR(1:1).EQ.'R') THEN
            DO 12 NUMPLA=NUPRPL,NUDRPL 
               KOLDEB=IPLAGE(1,NUMPLA) 
               LGCUAP=IPLAGE(2,NUMPLA) 
               KOLFIN=KOLDEB-1+LGCUAP-LGCUAV
               IF (NGNECO(KOLFIN).LT.NGNEES(NXCODI)) GOTO 12
               IADRES=LGCUDL
               DO 11 KOLONJ=KOLDEB,KOLFIN  
*                 Colonnes correspondant a des D.L. Dirichlet
                  CALL DICOTO (NXCODI,NBNEES,NGNEES,NGNECO(KOLONJ)
     &                        ,KOLDIR,*11)                              !utilite
                  NXCODI=KOLDIR+1
                  IAMATL=MCMATR+IADRES
                  IAESSE=MCESSE+(KOLDIR-1)*NCPNES
                  IF (NUKAES.EQ.1) THEN
*                    Condition de type u=0 toutes les composantes
*                    sont eliminees
                     DO 4 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                      CALL CDSCND (NCPNES,TYMATR,IAMATL,TYESSE
     &                                  ,IAESSE,TYSCMB,MCSCM1-1+J
     &                                  ,RST,CST)                       !cdesse
*                       Annulation des coefficients Aij
                        DO 3 I=1,NCPNES
3                          RST(IAMATL-1+I)=0.
4                    IAMATL=IAMATL+LGLIGL
                  ELSEIF (NUKAES.EQ.2) THEN
*                    Condition de type u.n=0 la composante normale 
*                    est eliminee
                     DO 5 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                     CALL CDSCND (1,TYMATR,IAMATL,TYESSE
     &                                 ,IAESSE,TYSCMB,MCSCM1-1+J
     &                                 ,RST,CST)                        !cdesse
*                       Annulation des coefficients Aij
                        RST(IAMATL)=0.
5                       IAMATL=IAMATL+LGLIGL
                  ELSEIF (NUKAES.EQ.3) THEN
*                    Condition de type u^n=0 les composantes
*                    tangentielles sont eliminees
                     DO 7 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                     CALL CDSCND (NCPNES-1,TYMATR,IAMATL+1,TYESSE
     &                                 ,IAESSE+1,TYSCMB,MCSCM1-1+J
     &                                 ,RST,CST)!cdesse
*                       Annulation des coefficients Aij
                        DO 8 I=1,NCPNES-1
8                         RST(IAMATL+I)=0.
7                   IAMATL=IAMATL+LGLIGL
                  ELSE   
                     CALL BAISE  ('vous etes tombe dans un trou')       !utilite
                  ENDIF
11                IADRES=IADRES+NCPNES  
               IF (NXCODI.GT.NBNEES) GOTO 100
12             LGCUAW=LGCUAP
         ELSEIF (TYMATR(1:1).EQ.'C') THEN
            DO 22 NUMPLA=NUPRPL,NUDRPL 
               KOLDEB=IPLAGE(1,NUMPLA) 
               LGCUAP=IPLAGE(2,NUMPLA) 
               KOLFIN=KOLDEB-1+LGCUAP-LGCUAV
               IF (NGNECO(KOLFIN).LT.NGNEES(NXCODI)) GOTO 22
               IADRES=LGCUDL
               DO 21 KOLONJ=KOLDEB,KOLFIN  
                  CALL DICOTO (NXCODI,NBNEES,NGNEES,NGNECO(KOLONJ)
     &                        ,KOLDIR,*21)                              !utilite
                  NXCODI=KOLDIR+1
                  IAMATL=MCMATR+IADRES
                  IAESSE=MCESSE+(KOLDIR-1)*NCPNES
                  IF (NUKAES.EQ.1) THEN
*                    Condition de type u=0 toutes les composantes
*                    sont eliminees
                     DO 14 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                     CALL CDSCND (NCPNES,TYMATR,IAMATL,TYESSE
     &                                 ,IAESSE,TYSCMB,MCSCM1-1+J
     &                                 ,RST,CST)                        !cdesse
*                       Annulation des coefficients Aij
                        DO 13 I=1,NCPNES
13                         RST(IAMATL-1+I)=0.
14                   IAMATL=IAMATL+LGLIGL
                  ELSEIF (NUKAES.EQ.2) THEN
*                    Condition de type u.n=0 la composante normale 
*                    est eliminee
                     DO 15 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                     CALL CDSCND (1,TYMATR,IAMATL,TYESSE
     &                                 ,IAESSE,TYSCMB,MCSCM1-1+J
     &                                 ,RST,CST)                        !cdesse
*                       Annulation des coefficients Aij
                        RST(IAMATL)=0.
15                      IAMATL=IAMATL+LGLIGL
                  ELSEIF (NUKAES.EQ.3) THEN
*                    Condition de type u^n=0 les composantes
*                    tangentielles sont eliminees
                     DO 17 J=1,NCPNES
*                       Report des -Aij x Uj dans le second membre
                        IF (MCESSE.GT.0)
     &                     CALL CDSCND (NCPNES-1,TYMATR,IAMATL+1,TYESSE
     &                                 ,IAESSE+1,TYSCMB,MCSCM1-1+J
     &                                 ,RST,CST)                        !cdesse
*                       Annulation des coefficients Aij
                        DO 18 I=1,NCPNES-1
18                         RST(IAMATL+I)=0.
17                   IAMATL=IAMATL+LGLIGL
                  ELSE   
                     CALL BAISE  ('vous etes tombe dans un trou')       !utilite
                  ENDIF
21                IADRES=IADRES+NCPNES  
               IF (NXCODI.GT.NBNEES) GOTO 100
22             LGCUAW=LGCUAP
         ENDIF
*  
100   NUPRPL=NUDRPL+1  
      CALL PRFXMJ (-1,'*CdMovc*')  
                                                                    END !CdMovc
