*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CDSCDI (TYMATR,MCMATL,TYSCMB,MCSCMB
     &                  ,TYESSE,MCESSE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1989)  
* Derniere modification : O.DeBayser (10 Avril 1996)
* Version 1.0.0
*  
* Mise a jour du second membre pour une condition essentielle
* sur une ligne 'Dirichlet'
*
* -> On pose Aii*Ui dans le coefficient i du second membre
*  
*-- Arguments --
* TYMATR type de la matrice
* MCMATL adresse absolue en M.C. du coefficient Aii 
* TYSCMB type du second membre 
* MCSCMB adresse en M.C. du coefficient de la ligne i du second membre
* TYESSE type du tableau des valeurs de blocage 'Dirichlet'
* MCESSE adresse en M.C. du coefficient Ui valeur de blocage
* RST,CST super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYSCMB,TYESSE
      INTEGER       MCMATL,MCSCMB,MCESSE 
      REAL          RST(*) 
      COMPLEX       CST(*) 
*-----------------------------------------------------------------------
      IF (TYSCMB(1:1).EQ.'R') THEN
*
*        Si le second membre est REEL alors necessairement
*        la matrice et les valeurs de blocage sont REELLES (voir cdesse)
*
         RST(MCSCMB)=RST(MCMATL)*RST(MCESSE)
      ELSE
*
*        Le second membre est COMPLEXE mais la matrice et les valeurs 
*        de blocage sont de type quelconque
*
         IF (TYMATR(1:1).EQ.'C') THEN
*           Matrice complexe
            IF (TYESSE(1:1).EQ.'C') THEN
                  CST(MCSCMB)=CST(MCMATL)*CST(MCESSE)
            ELSE
                  CST(MCSCMB)=CST(MCMATL)*RST(MCESSE)
            ENDIF
         ELSE
*           Matrice reelle
            IF (TYESSE(1:1).EQ.'R') THEN
                  CST(MCSCMB)=RST(MCMATL)*RST(MCESSE)
            ELSE
                  CST(MCSCMB)=RST(MCMATL)*CST(MCESSE)
            ENDIF
         ENDIF
      ENDIF
                                                                    END !CdScDi
