*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CDSCND (NBCOEF,TYMATR,MCMATR,TYSCMB,MCSCMB
     &                  ,TYESSE,MCESSE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1989)  
* Derniere modification : D.Martin (22 Janvier 1996)
* Version 1.0.0
*  
* Mise a jour du second membre pour une condition essentielle
* sur des lignes non 'Dirichlet' de numeros i consecutifs :
*
* -> On ajoute  - Aij*Uj dans le coeff. i du second membre a "j" fixe
*  
* (adapte a la partie triangulaire superieure de la matrice)
*
*-- Arguments --
* NBCOEF nombre de colonnes sur laquelle on effectue le report 
* TYMATR type de la matrice
* MCMATR adresse absolue en M.C. du coefficient Aij 
* TYSCMB type du second membre 
* MCSCMB adresse du coefficient de la 1ere ligne concernee du second membre
* TYESSE type du tableau des valeurs de blocage 'Dirichlet'
* MCESSE adresse en M.C. du coefficient Uj valeur de blocage
* RST,CST super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYSCMB,TYESSE
      INTEGER       NBCOEF,MCMATR,MCSCMB,MCESSE 
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      INTEGER       MCMAT1,MCSMB1
      REAL          SR
      COMPLEX       SC
*-----------------------------------------------------------------------
      MCMAT1=MCMATR
      IF (TYSCMB(1:1).EQ.'R') THEN
*
*        Si le second membre est REEL alors necessairement
*        la matrice et les valeurs de blocage sont REELLES (voir CDEsse)
*
         SR = RST(MCESSE)
         DO 222 MCSMB1=MCSCMB,MCSCMB-1+NBCOEF
            RST(MCSMB1)=RST(MCSMB1)-RST(MCMAT1)*SR
            MCMAT1=MCMAT1+1
222      CONTINUE
      ELSE
*
*        Le second membre est COMPLEXE mais la matrice et les valeurs 
*        de blocage sont de type quelconque
*
         IF (TYMATR(1:1).EQ.'C') THEN
*           Matrice complexe
            IF (TYESSE(1:1).EQ.'C') THEN
               SC = CST(MCESSE)
               DO 444 MCSMB1=MCSCMB,MCSCMB-1+NBCOEF
                  CST(MCSMB1)=CST(MCSMB1)-CST(MCMAT1)*SC
                  MCMAT1=MCMAT1+1
444            CONTINUE
            ELSE
               SR = RST(MCESSE)
               DO 442 MCSMB1=MCSCMB,MCSCMB-1+NBCOEF
                  CST(MCSMB1)=CST(MCSMB1)-CST(MCMAT1)*SR
                  MCMAT1=MCMAT1+1
442            CONTINUE
            ENDIF
         ELSE
*           Matrice reelle
            IF (TYESSE(1:1).EQ.'R') THEN
               SR = RST(MCESSE)
               DO 242 MCSMB1=MCSCMB,MCSCMB-1+NBCOEF
                  CST(MCSMB1)=CST(MCSMB1)-RST(MCMAT1)*SR
                  MCMAT1=MCMAT1+1
242            CONTINUE
            ELSE
               SC = CST(MCESSE)
               DO 244 MCSMB1=MCSCMB,MCSCMB-1+NBCOEF
                  CST(MCSMB1)=CST(MCSMB1)-RST(MCMAT1)*SC
                  MCMAT1=MCMAT1+1
244            CONTINUE
            ENDIF
         ENDIF
      ENDIF
                                                                    END !CdScND
