*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CDTRAN (NMESSE,NVESSE,NMMATR,NVMATR,NMVECT,NVVECT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1994, refonte en Avril 1998)
* Derniere modification : D.Martin (12 Decembre 2001)
* Version 1.0.9
*
* 'Blocage des d.l.' d'une condition essentielle de transmission
*  dans une matrice A et, le cas echeant, un vecteur V.
* 
* Il peut s'agir d'un systeme lineaire A x = V
*                d'un probleme de valeurs propres A V = Lambda V
*
*-- Arguments d'entree -- 
* NMESSE nom de la condition de transmission
* NVESSE niveau de ce terme
* NMMATR nom de la matrice (A)
* NVMATR niveau de ce terme
* NMVECT nom du vecteur (V), le cas echeant (NMVECT=' ' si pas de vecteur)
*        Il s'agit par exemple du 2nd membre du systeme lineaire
*        ou de vecteurs propres.
* NVVECT niveau de ce terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMESSE,NMMATR,NMVECT
      INTEGER       NVESSE,NVMATR,NVVECT
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDSYM,INTDON,INTTYP,KLNIVE,KLTERM                  !utilite
      CHARACTER     PRFXAS*8,STOCHN*6,TYPINT*12,SYMIND*14,CESSIN*2      !utilite
      LOGICAL       HOMOGN,PARDL
      INTEGER       NBDOAX,NBDOAS,NVVAUX
     &             ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCMTRM
     &             ,MCINCO,LGEINC,NBINCO,INCINC,NCHINC
     &             ,MCTRDO,LGERDO,NBDOMK,INCRDO,NCHDOM,MCMDOM,NUDOMG
     &             ,MCDSMA,NVDSMA
     &             ,NUESSE,ADTRCE,ITESSE,ITYCCE,NUKACE,NUDOCE,NVALNE
     &             ,NUINCD,NVDUCE,NBNECE,NVNUCE,NUINCG,NVDUCG,INTECE
     &             ,NBNECG,NVNUCG,NVCOCE,IATRCE,NIVICE
     &             ,NUMATR,ADTERM,ITMATR,ITYCAL,NUKALE,NUDOMA,ITYSYM
     &             ,NUINMC,NVDUMC,NBNEMC,NVNUMC,NCPINC,INTEMC
     &             ,NUINML,NVDUML,NBNEML,NVNUML,NCPINL,INTEML
     &             ,NVCORC,IATRDO,NIVIMA,INDSTK,NVSTOK,NBTNEU,NVINUT
     &             ,NUINCC,NCPICE,NUINCL
     &             ,NUVECT,NVDSMV,NBVECT,NIVISC,NBLIGN,NBCOLO
     &             ,NUINC1,NUINC2,IRCODE,LGVECT,LGMATR,LGSTOK
     &             ,NCATR1,NCATR2,I,NCAINC,NCCAAA
      INTEGER       NVNEC1,NEAVC1,NVNEC2,NEAVC2,ITYSYF,LGWRK2,STRSYM
     &             ,NVNEL1,NEAVL1,NVNEL2,NEAVL2
     &             ,NFOUND,LGCHMA,MCSTOK,MCNECE,MCSTOS,NVSTOS
      PARAMETER    (NBDOAX=3)
      INTEGER       ITYDAS(NBDOAX),NVDOAS(NBDOAX),NVANAS(NBDOAX)
     &             ,NBSUNE(NBDOAX),SKIPNE(NBDOAX),MCDOAS(NBDOAX)
*
      CHARACTER     TYMATR*8,TYVECT*8,TYCHMA*8,TYSCMW*8
     &             ,NMSTOK*6,NMVAUX*6,THEINC*20
      CHARACTER     ERCODE*120,MULTIM,YADLVC,YADLVL,YADLVV,YADLVE
     &             ,ROTONS,ROTACE,NMDOAS*6,TYDOAS*12,KEEP,THECES*4
      DIMENSION     NMDOAS(NBDOAX),TYDOAS(NBDOAX)
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (NMSTOK,ERCODE(73:73))
     &            ,(TYMATR,ERCODE(89:89)),(TYVECT,ERCODE(105:105))
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CdTran*')
      IRCODE=0
*
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc 1 commun a CdEsse et CdTran
*     Tableau des caracteristiques des termes, des noms de termes,
*     des caracteristiques des inconnues, des domaines de calcul
      CALL TBAR4  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM
     &                   ,'#NCONU',1,MCINCO,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)             !utilite
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !utilite
*
*--   Caracteristiques de la condition essentielle
*
      NUESSE=KLTERM (NMESSE,NVESSE,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUESSE.LE.0) CALL ERTERM (1,NMESSE,NVESSE)                    !utilite
      ADTRCE=LGETRM+(NUESSE-1)*INCTRM
      CALL GETTRM (IST(MCDTRM+ADTRCE)  ,NVINUT,ITESSE,ITYCCE,NUKACE
     &            ,NUDOCE,NVALNE,NVDSMA,NUINCD,NVDUCE,NBNECE,NVNUCE
     &            ,NUINCG,NVDUCG,NBNECG,NVNUCG,INDSTK,NVSTOK
     &            ,NVCOCE,IATRCE,NIVICE)                                !sdexplo
*
      IF (NUKACE.GT.0) GOTO 90001
*     Numero et nom du domaine geometrique sur lequel porte la condition
      NUDOMG=IST(MCTRDO+IATRCE-1)
*
*     Caracteristiques de l'inconnue pour la condition essentielle
      CALL SDEXCO (NUINCD,IST(MCINCO),NCPICE,INTECE,NBTNEU)             !utilite
*
*--   Caracteristiques de la matrice
*
      NUMATR=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUMATR.LE.0) CALL ERTERM (1,NMMATR,NVMATR)                    !utilite
      ADTERM=LGETRM+(NUMATR-1)*INCTRM
      CALL GETTRM (IST(MCDTRM+ADTERM)  ,NVINUT,ITMATR,ITYCAL,NUKALE
     &            ,NUDOMA,ITYSYM,NVDSMA,NUINMC,NVDUMC,NBNEMC,NVNUMC
     &            ,NUINML,NVDUML,NBNEML,NVNUML,INDSTK,NVSTOK
     &            ,NVCORC,IATRDO,NIVIMA)                                !sdexplo
*
*--   Impression d'un titre
*
      IF (NIVICE.GE.0.OR.NIVIMA.GT.0) THEN
         NCCAAA=2
         THECES=CESSIN (ABS(NUKACE))
         IF (THECES(1:1).EQ.' ') NCCAAA=0
         THECES(NCCAAA+1:NCCAAA+2)='=G'
         CALL PRNINC (NUINCD,THECES(1:NCCAAA+2),THEINC,NCAINC)          !sdexplo
         CALL TBAR1  (ERCODE,'#OMDOM',1,MCMDOM)
         MCMDOM=MCMDOM+(NUDOMG-1)*NCHDOM
         CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
         IF (IMPPAL.GT.0) WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &        ,THEINC(1:NCAINC),(AST(I),I=MCMDOM,MCMDOM-1+NCHDOM)
         IF ((NIVICE.GT.0.OR.NIVIMA.GT.0).AND.IMPSDR.GT.0) THEN
            WRITE (IMPSDR,10010) PRFXAS (0)
            WRITE (IMPSDR,10000) ERCODE(1:NCATR1)
         ENDIF
      ENDIF
*
*--   Detection du caractere multi-inconnue de la matrice
*
      NCPINC=1
      NCPINL=1
      MULTIM='N'
      IF (NVDSMA.NE.NDFDSM.AND.NUINMC.EQ.NDFINC.AND.NUINML.EQ.NDFINC)
     &   MULTIM='Y'
*
*--   Type de stockage/structure de la matrice et nombre de lignes/colonnes
*
      NMSTOK=STOCHN (INDSTK)                                            !utilite
*
      YADLVE='N'
      YADLVC='N'
      YADLVL='N'
      NUINCC=NUINMC
      NUINCL=NUINML
*
      IF (MULTIM.EQ.'Y') THEN
*        Condition essentielle sur une matrice "multi-inconnue"
*
         IF (NMSTOK.NE.'&BMORS') CALL ERTERM (18,NMMATR,NVMATR)         !utilite
         NBCOLO=NBNEMC
         NBLIGN=NBNEML
*
         NVINUT=1
         CALL FONUDL (NCPICE,1,NVNUCE,NVNUCE,0,0,0,0
     &               ,NVDUCE,NVINUT,YADLVE,YADLVV)                      !sdexplo
         IF (YADLVE.NE.'N')
     &      CALL PUTTRM (IST(MCDTRM+ADTRCE)  ,NVESSE,ITESSE,ITYCCE
     &                  ,NUKACE,NUDOCE,NVALNE,NDFDSM,NUINCD,NVDUCE
     &                  ,NBNECE,NVNUCE,NUINCG,NVDUCG,NBNECG,NVNUCG
     &                  ,0     ,NDFSTO,NVCOCE,IATRCE,NIVICE)            !sdexplo
         CALL TBRR1  (ERCODE,'$DSMBL',NVDSMA,MCDSMA)
* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Fin du Bloc 1 commun a CdEsse et CdTran
      ELSE
         CALL ERTERM (13,NMMATR,NVMATR)                                 !utilite
      ENDIF
*
*     Numerotation supplementaire pour inconnue vectorielle de la cond.
      IF (YADLVE.EQ.'C')
     &   CALL NUM2DL (NCPICE,NVNUCE,NVDUCE,NBNECE*NCPICE,NIVICE)        !sdexplo
*
      TYMATR=TYPINT (ITMATR)                                            !utilite
*
*     Proprietes de la condition essentielle
*
      NUINC1=NUINCD
      NUINC2=NUINCG
      IF (NUINCD.GT.NUINCG) THEN
         NUINC2=NUINCD
         NUINC1=NUINCG
      ENDIF
*
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc 2 commun a CdEsse et CdTran
      NUKACE=ABS (NUKACE)
      NBDOAS=NBDOAX
      CALL CECADO (NMESSE,NVESSE,TYPINT(ITESSE),ITYCCE,NUKACE,NUDOCE
     &            ,NVALNE,NCPICE,NBNECE,NUINCD,NUINCG,NBDOAS
     &            ,NMDOAS,ITYDAS,NVDOAS,TYDOAS,NVANAS,NBSUNE,SKIPNE
     &            ,TYCHMA,HOMOGN,PARDL ,ROTONS,ROTACE,IRCODE)
      IF (IRCODE.EQ.1) GOTO 90011
*
*     Quelques cas non encore prevu
*
      IF (TYMATR(1:4).EQ.'REEL'.AND.TYCHMA(1:8).EQ.'COMPLEXE')
     &   CALL BAISE
     &   ('Matrice reelle, changement de base complexe. A(u) revoir.')
      IF (.NOT.PARDL)
     & CALL BAISE  ('Donnees matricielles prevues pour la prochaine !')
*
      NUVECT=0
      NBVECT=1
      TYVECT='REEL'
      IF (NMVECT(1:1).NE.' ') THEN
*        Preparation du second membre avec extension eventuelle
*        selon la numerotation en ligne de la matrice
         NIVISC=NIVICE
         TYSCMW='REEL'
         IF (TYMATR(1:2).EQ.'CO'.OR.TYCHMA(1:2).EQ.'CO'
     &   .OR.TYDOAS(NBDOAS)(1:2).EQ.'CO') TYSCMW='COMPLEXE'
         KEEP='n'
         CALL VCPREP (NMVECT,NVVECT,KEEP.EQ.'y',TYSCMW,'Ligne'
     &               ,NMMATR,NVMATR,MULTIM,NVDSMA
     &               ,NUINCL,NCPINL,NVDUML,NBLIGN,NVNUML,'$WORK$',1
     &               ,NUVECT,NVDSMV,NBVECT,NMVAUX,NVVAUX,TYVECT,NIVISC) !sdexplo
*
*        Correction de la structure 'multi-inconnue' du second membre pour
*        y faire exister les blocs apparaissant avec la condition essentielle
         IF (MULTIM.EQ.'Y') CALL CESCMJ (ITYCCE,NUINC1,NUINC2,NUESSE
     &                                  ,HOMOGN,NVDSMA,NVDSMV,IRCODE)   !cdesse
         IF (IRCODE.EQ.1) THEN
            CALL PRSDDS (NVDSMA,NMMATR,NVMATR,1,IMPPAL)
            CALL PRSDDS (NVDSMV,NMVECT,NVVECT,1,IMPPAL)
            CALL ERTERS (5,NMMATR,NVMATR,NMVECT,NVVECT)                 !utilite
         ENDIF
         IF (NIVISC.GT.5.AND.IMPSDR.GT.0) THEN
            CALL PRTERM (NMVECT,NVVECT,NIVISC,IMPSDR)                   !prsd
            CALL TBRR1  (ERCODE,NMVECT,NVVECT,LGVECT)
         ENDIF
      ENDIF
*
*     Restauration en M.C. de la matrice et du tableau de stockage
*
      CALL TBRR2  (ERCODE,NMMATR,NVMATR,LGMATR,NMSTOK,NVSTOK,LGSTOK)
*
* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Fin du Bloc 2 commun a CdEsse et CdTran
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc particulier a CdTran
*
*     La structure de stockage de la matrice est-elle symetrique ?
*
      CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      STRSYM=0
      IF (IST(MCSTOK).EQ.2) STRSYM=1
*     En general la matrice modifiee en sortie n'a aucune propriete
*     de symetrie (sauf dans le cas ou k1=k2, a tester ????)
      ITYSYF=INDSYM (' ')
*
*     Tableaux pour les matrices pour les changement d'inconnues
*
      LGCHMA=NCPICE+NCPICE+(SKIPNE(1)+SKIPNE(2))*(NBNECE-1)
      LGCHMA=LGCHMA+NCPICE+MAX(SKIPNE(1),SKIPNE(2))*(NBNECE-1)
      CALL TBCREE ('$WRKT$',1,INTTYP(TYCHMA),LGCHMA,'c')
*     Tableau de travail utilise dans CTMOST, CTCHVA,
*     pour le reperage des numeros des colonnes/lignes de la matrice
*     correspondant aux d.l. des inconnues de la condition transmission
      LGWRK2=2*NBNECE
      IF (STRSYM.EQ.0) LGWRK2=2*LGWRK2
      CALL TBCREE ('$WRKT$',2,1,LGWRK2,'c')
*
*     Remarques:
*     1) dans CTINVO, l'inconnue au premier membre de la condition
*        correspond a l'inconnue de numero le plus petit
*     2) apres changement de variable, c'est l'inconnue de numero
*        le plus petit qui subit les rotations et les eliminations.
*     Invocation de la structure $DSMBL de niveau NVDSMA pour connaitre
*     les caracteristiques des blocs a 'droite' et a 'gauche'
      CALL CTINVO (NVDSMA,NUINCD,NVNEC1,NEAVC1,NVNEL1,NEAVL1
     &                   ,NUINCG,NVNEC2,NEAVC2,NVNEL2,NEAVL2)           !cdesse
*
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUCE,MCNECE)
      CALL CTRGDL ('Ligne',NCPICE,NVNUCE,NVNEL1,NEAVL1
     &            ,NVNEL2,NEAVL2,'$WRKT$',2,NIVICE,IMPSDR)              !cdesse
      IF (STRSYM.EQ.0) THEN
         CALL CTRGDL ('Colon',NCPICE,NVNUCE,NVNEC1,NEAVC1
     &               ,NVNEC2,NEAVC2,'$WRKT$',2,NIVICE,IMPSDR)           !cdesse
      ENDIF
*
*     Modification du stockage de la matrice pour les coefficients
*     qui coupleront les inconnues de la condition de transmission
*
*     Le tableau de stockage est-il partage par d'autres termes ?
*
      CALL CNTSTK (INDSTK,NVSTOK,NUMATR,NFOUND)
*
      IF (NFOUND.GT.0) THEN
*        Si le tableau de stockage de stockage de la matrice est partage
*        par un autre terme, on cree un nouveau tableau de stockage
         NVSTOS=NVSTOK
         NVSTOK=KLNIVE ( )
         CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
         CALL TBAR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK,NMSTOK,NVSTOS,MCSTOS)
         CALL TDANST (LGSTOK,'E',MCSTOS,IST,RST,CST
     &                      ,'E',MCSTOK,IST,RST,CST)                    !utilite
         CALL TBSAVE (NMSTOK,NVSTOS)
      ENDIF
*
*     Modification de la structure de stockage de la matrice
*
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
      CALL PUTTRM (IST(MCDTRM+ADTERM)  ,NVMATR,ITMATR,ITYCAL
     &            ,NUKALE,NUDOMA,ITYSYF,NVDSMA,NUINMC,NVDUMC
     &            ,NBCOLO,NVNUMC,NUINML,NVDUML,NBLIGN,NVNUML
     &            ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMA)                  !sdexplo
*
      CALL CTMOST (NMMATR,NVMATR,ITYSYM,ITYSYF,TYMATR,NBCOLO
     &            ,NBLIGN,NMSTOK,NVSTOK,LGSTOK,NCPICE,NBNECE
     &            ,'$WRKT$',2,'$WRKT$',3,STRSYM,NIVIMA)                 !cdesse
*
*     Changement de variables pour ramener les conditions de transmission
*     a des conditions essentielles.
*
*     Adresses des donnees associees a une condition essentielle
      CALL CEADDO (NBDOAS,NMDOAS,ITYDAS,NVDOAS,TYDOAS,MCDOAS)
*
      CALL CTCHVA (1,'$WRKT$',1,TYCHMA,SKIPNE,NBDOAS,TYDOAS,NVANAS
     &            ,NBSUNE,MCDOAS,'$WRKT$',2,NCPICE,NBNECE,HOMOGN
     &            ,NMMATR,NVMATR,ITYSYF,TYMATR,STRSYM
     &            ,NMVECT,NVVECT,TYVECT,NBVECT
     &            ,NBCOLO,NBLIGN,NMSTOK,NVSTOK,NIVICE)                  !cdesse
*
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc 3 commun a CdEsse et CdTran
*
*     Passage si necessaire dans le repere local (n , t1 [,t2])
*     et elimination, puis retour au repere cartesien (e1, e2 [,e3])
*
      CALL CERELR (NMESSE,NVESSE,NMMATR,NVMATR,NMVECT,NVVECT
     &            ,ROTONS,ROTACE,NUKACE,NUINC1,NVDUCE,NBNECE
     &            ,NVNUCE,NCPICE,NVCOCE,NUDOMG,NCHDOM,NIVICE
     &            ,NMDOAS(NBDOAS),NVDOAS(NBDOAS),TYDOAS(NBDOAS)
     &            ,NVANAS(NBDOAS),HOMOGN,MULTIM,NVDSMA
     &            ,NBCOLO,NUINCC,NVNUMC,NBNEMC,NCPINC
     &            ,NBLIGN,NUINCL,NVNUML,NBNEML,NCPINL
     &            ,NMSTOK,NVSTOK,INDSTK,ITYSYF,TYMATR,NBVECT,TYVECT
     &            ,IRCODE)                                              !cdesse
      IF (IRCODE.EQ.1) GOTO 90000
*
* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Fin du Bloc 3 commun a CdEsse et CdTran
*
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc particulier a CdTran
*     Changement de variables pour retour aux inconnues initiales.
*
      CALL CEADDO (NBDOAS,NMDOAS,ITYDAS,NVDOAS,TYDOAS,MCDOAS)
      CALL CTCHVA (-1,'$WRKT$',1,TYCHMA,SKIPNE,NBDOAS,TYDOAS,NVANAS
     &            ,NBSUNE,MCDOAS,'$WRKT$',2,NCPICE,NBNECE,HOMOGN
     &            ,NMMATR,NVMATR,ITYSYF,TYMATR,STRSYM
     &            ,NMVECT,NVVECT,TYVECT,NBVECT
     &            ,NBCOLO,NBLIGN,NMSTOK,NVSTOK,NIVICE)                  !cdesse
*
      CALL TBTUER ('$WRKT$',1)
      CALL TBTUER ('$WRKT$',2)
*
* >>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> Bloc 4 commun a CdEsse et CdTran
*--   --   Sauvegarde des tableaux
*
      DO 100 I=1,NBDOAS-1
         IF (ITYDAS(I).EQ.INTDON('TABLEAU')) 
     &       CALL TBSAVE (NMDOAS(I),NVDOAS(I))
100   CONTINUE
      IF (.NOT.HOMOGN) CALL TBSAVE (NMDOAS(NBDOAS),NVDOAS(NBDOAS))
*
      IF (MULTIM.EQ.'Y'.AND.NCPICE.GT.1) CALL TBSAVE ('#GNEDO',NVDUCE)
      CALL TBSAVE ('#GNEDO',NVNUCE)
      CALL TBSAVE ( NMSTOK ,NVSTOK)
      CALL TBSAVE ('#GNEDO',NVNUMC)
      IF (NVNUML.NE.NVNUMC) CALL TBSAVE ('#GNEDO',NVNUML)
*
      IF (NIVIMA.GT.0) CALL PRTERM (NMMATR,NVMATR,NIVIMA,IMPSDR)        !prsd
      IF (MULTIM.EQ.'Y') CALL TBSAVE ('$DSMBL',NVDSMA)
      CALL TBSAVE (NMMATR,NVMATR)
      IF (NUVECT.GT.0) THEN
         IF (MULTIM.EQ.'Y') CALL TBSAVE ('$DSMBL',NVDSMV)
         IF (NIVISC.GT.0) CALL PRTERM (NMVECT,NVVECT,NIVISC,IMPSDR)     !prsd
         CALL TBSAVE (NMVECT,NVVECT)
      ENDIF
*__   __    Impression en sortie
      IF (NIVICE.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
         IF (NUVECT.GT.0) THEN
            CALL PRNTRM (NMVECT,NVVECT,ERCODE(NCATR1+1:),NCATR2)
            WRITE (IMPPAL,10001) ERCODE(1:NCATR1)
     &                          ,ERCODE(NCATR1+1:NCATR1+NCATR2)
         ELSE
            WRITE (IMPPAL,10001) ERCODE(1:NCATR1)
         ENDIF
      ENDIF
* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<< Fin du Bloc 4 commun a CdEsse et CdTran
*
      CALL PRFXMJ (-1,'*CdTran*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/' *CdTran* Condition de transmission ',A,:
     &,' de type ',A,', sur le domaine ',50A1)
10001 FORMAT(T11,'portant sur la matrice ',A,:,' et le vecteur ',A)
10010 FORMAT(/T2,'* ',A8,' ',98('*'))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      CALL PRNTRM (NMMATR,NVMATR,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Condition de transmission '//ERCODE(1:NCATR1)
     &//' : Le terme matriciel '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' est '//SYMIND(ITYSYM)//'. Cas non prevu.')
90001 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      CALL BAISE  ('Les attributs de la condition de transmission'
     &//ERCODE(1:NCATR1)
     &//' n''ont pas ete determines. Repasser par CalkEF.')
90011 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      CALL ENCLER (NBDOAS,ERCODE(NCATR1+1:NCATR1+1))
      CALL BAISE  ('Le nombre de donnees associees, limite a '
     &//ERCODE(NCATR1+1:NCATR1+1)
     &//', est depasse pour la condition de transmission '
     &//ERCODE(1:NCATR1)//'.')
                                                                    END !CdTran
