*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEADDO (NBDOAS,NMDOAS,ITYDAS,NVDOAS,TYDOAS,MCDOAS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (31 Mai 1998)
* Version 1.0.0
*  
* Adresses des donnees associees a une condition essentielle
*  
*-- Arguments d'entree --
* NBDOAS nombre de donnees associees a la condition essentielle
* NMDOAS noms des donnees associees a la condition essentielle
* ITYDAS types ('CONSTANTE', 'TABLEAU') de ces donnees
* NVDOAS numeros de constante des donnees de type 'CONSTANTE' ou
*        niveaux des donnees de type 'TABLEAU'
* TYDOAS types ('REEL', 'COMPLEXE') de ces donnees
*-- Arguments de sortie
* MCDOAS adresse en memoire centrale de ces donnees
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBDOAS,ITYDAS(*),NVDOAS(*),MCDOAS(*)
      CHARACTER*(*) NMDOAS(*),TYDOAS(*)
*
      INCLUDE 'ALLOC'
*
      INTEGER       INTDON
      INTEGER       MCCSTE,I,INTCON,INTTAB
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ceaddo*')
*
      INTCON=INTDON ('CONSTANTE')                                       !utilite
      INTTAB=INTDON ('TABLEAU')                                         !utilite
*
      DO 10 I=1,NBDOAS
         MCDOAS(I)=0
         IF (NMDOAS(I).NE.' ') THEN
            IF (ITYDAS(I).EQ.INTCON) THEN
               IF (TYDOAS(I)(1:1).EQ.'E') THEN
                  CALL TBAR1  (ERCODE,'$ECSTE',1,MCCSTE)
               ELSEIF (TYDOAS(I)(1:1).EQ.'R') THEN
                  CALL TBAR1  (ERCODE,'$RCSTE',1,MCCSTE)
               ELSEIF (TYDOAS(I)(1:2).EQ.'CO') THEN
                  CALL TBAR1  (ERCODE,'$CCSTE',1,MCCSTE)
               ENDIF
               MCDOAS(I)=MCCSTE+NVDOAS(I)
            ELSEIF (ITYDAS(I).EQ.INTTAB) THEN
               CALL TBAR1  (ERCODE,NMDOAS(I),NVDOAS(I),MCDOAS(I))
            ENDIF
         ENDIF
10    CONTINUE
*
      CALL PRFXMJ (-1,'*Ceaddo*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Ceaddo
