*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CECADO (NMESSE,NVESSE,TYESSE,ITYCCE,NUKACE,NUDOCE
     &                  ,NVALNE,NCPICE,NBNECE,NUINC1,NUINC2,NBDOAS
     &                  ,NMDOAS,ITYDAS,NVDOAS,TYDOAS,NVANAS,NBSUNE
     &                  ,SKIPNE,TYCHMA,HOMOGN,PARDL ,ROTONS,ROTACE
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (30 Mars 2004)
* Version 1.1
*  
* Caracteristiques des donnees (k_1, k_2, g) d'une condition essentielle
*
* du type   k_1 u_1 =  [ g ] pour une condition de Dirichlet
*
* du type   k_1 u_1 = k_2 u_2 [ + g ] pour une condition de transmission
*
*  k_i est un scalaire ou une matrice donnee en chaque noeud; 
*      si k_i est un vecteur, k_i est considere comme une matrice diagonale
*  k_i peut etre un scalaire constant ou une matrice constante
*      (i.e. independant du noeud)
*  
*-- Arguments d'entree --
* NMESSE nom de la condition essentielle
* NVESSE son niveau
* TYESSE type (REEL, COMPLEXE ou CARACTERE) de la donnee associee a
*        la condition essentielle
* ITYCCE type de calcul de la condition essentielle (Dirichlet ou Transmission)
* NUKACE numero de type de la condition essentielle
* NUDOCE numero de la donnee associee a la condition essentielle
* NVALNE nombre de composantes par noeud du terme 'donnee non homogene' g
* NCPICE nombre de composantes par noeud de l'inconnue ou des inconnues
*        affectees a la cond. essentielle
* NCNECE nombre de noeuds portant la condition essentielle
* NBDOAS nombre de donnees associees a la condition essentielle
*        = 2 si condition de Dirichlet (k_1 et g)
*        = 3 si condition de Transmission (k_1, k_2 et g)
*-- Arguments de sortie --
* NMDOAS noms des NBDOAS donnees associees a la condition essentielle
*        (chaque nom peut etre ' ')
* ITYDAS types ('CONSTANTE', 'TABLEAU') de ces donnees
* NVDOAS numeros de constante des donnees de type 'CONSTANTE' ou
*        niveaux des donnees de type 'TABLEAU'
* TYDOAS types ('REEL', 'COMPLEXE') pour chacune de ces donnees
* NVANAS tableau des nombres de valeurs par noeud pour chacune de ces donnees
* NBSUNE increment de passage d'un noeud au suivant pour chacune de ces donnees
* SKIPNE passage d'un noeud au suivant pour chacune de ces donnees
*        (0 si matrice constante, NCPICE si diagonale, NCPICE*NCPICE sinon)
* PARDL  indicateur de changement de repere par d.l.
*        (.TRUE. lorsque les tableaux associes ne sont pas matriciels par noeud)
* ROTONS indicateur de rotation dans la matrice
* ROTACE indicateur de rotation dans la donnee de condition essentielle
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMESSE,TYESSE,NMDOAS(*),TYDOAS(*),TYCHMA
     &             ,ROTONS,ROTACE
      INTEGER       NVESSE,ITYCCE,NUKACE,NUDOCE,NVALNE,NCPICE,NBNECE
     &             ,NBDOAS,NUINC1,NUINC2,ITYDAS(*),NVDOAS(*)
     &             ,NVANAS(*),NBSUNE(*),SKIPNE(*),IRCODE
      LOGICAL       HOMOGN,PARDL
*
      INCLUDE 'ALLOC'
*
      INTEGER       INTDON,INTTYP,INTYKL,KELCHN,KLTERM
      INTEGER       MCMDON,MCDONN,LGEDON,NBDONN,INCDON,NCHDON,ITYDON
     &             ,NVTDON,ITYPDO,ITDOAS,LGTDON,MCTDON,MCDTRM,MCMTRM
     &             ,NUDOAS,NBCHAS,NCATR1,J,JJ,INTCON,INTTAB,LG
     &             ,LGETRM,NBTERM,INCTRM,NCHTRM,NWTRM
     &             ,ITYCAL,NUKALE,NUDONN,NVDSMA,NUINCC,NVDUMC,NUINCL
     &             ,NBNUMC,NVNUMC,NVDUML,NBNUML,NVNUML,INDSTK,NVSTOK
     &             ,NVCOOR,IATRDO,NIVIMP
      CHARACTER     TYPINT*12
      CHARACTER     ERCODE*120,NMTDON*16
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Cecado*')
*
      INTCON=INTDON ('CONSTANTE')                                       !utilite
      INTTAB=INTDON ('TABLEAU')                                         !utilite
      TYCHMA='REEL'
*
*     Les valeurs par defaut correspondent  une donnee constante reelle
*
      DO 1 J=1,NBDOAS
         NMDOAS(J)=' '
         NVDOAS(J)=0
         ITYDAS(J)=INTCON
         TYDOAS(J)='REEL'
         NVANAS(J)=1
         SKIPNE(J)=0
         NBSUNE(J)=0
1     CONTINUE
      PARDL =.TRUE.
*
      IF (TYESSE(1:2).EQ.'CA') THEN
*
*        Le tableau affecte a la condition essentielle est de type CARACTERE,
*        il peut y avoir plusieurs donnees associees (k_i, g)
*
*        NBCHAS : Nombre de caracteres par item du tableau affecte
*
         NBCHAS=INTTYP (TYESSE)-INTTYP ('CARACTERE*1')+1
         CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
         CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
*
*        On s'assure que le tableau affecte est bien .. un tableau
*
         CALL SDEXCO (NUDOCE,IST(MCDONN),ITYDON,NVTDON,ITYPDO)          !utilite
         CALL GETCHN (AST(MCMDON),NCHDON,NUDOCE,NMTDON)                 !utilite
         IF (ITYDON.EQ.INTTAB) THEN
*
*           Cas d'un tableau de type 'CARACTERE*' associe :
*           Il contient des noms de donnees pour la condition essentielle
*           qui sont soit des constantes, soit des tableaux
            CALL TBRR1  (ERCODE,NMTDON,NVTDON,LGTDON)
            CALL TBAR5  (ERCODE, NMTDON ,NVTDON,MCTDON
     &                         ,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM
     &                         ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
            CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !utilite
*
            IF (NBDOAS.LT.LGTDON) GOTO 90001
*
*           Boucle sur les donnees figurant dans le tableau affecte
*
            DO 2 J=1,LGTDON
               JJ=J
               IF (J.LE.NBDOAS-1.AND.NUINC1.GT.NUINC2) JJ=NBDOAS-J
*
*              Nom, numero, type de declaration, ..., de chaque donnee
*              decrite dans le tableau
*
               CALL GETCHN (AST(MCTDON),NBCHAS,JJ,NMDOAS(JJ))           !utilite
               NUDOAS=KELCHN (NMDOAS(JJ),AST(MCMDON),NBDONN,NCHDON)     !utilite
               IF (NUDOAS.LE.0) GOTO 99992
               CALL SDEXCO (NUDOAS,IST(MCDONN)
     &                     ,ITYDAS(JJ),NVDOAS(JJ),ITDOAS)               !utilite
               TYDOAS(JJ)=TYPINT (ITDOAS)                               !utilite
*              Lorsque l'un des tableaux k_i est COMPLEXE,
*              la matrice de changement d'inconnue sera COMPLEXE
               IF (J.LE.NBDOAS-1.AND.TYDOAS(JJ).EQ.'COMPLEXE')
     &            TYCHMA='COMPLEXE'
*
*              Si la donnee JJ est un terme (Valeurs Nodales)
*
               NUDOAS=KLTERM (NMDOAS(JJ),NVDOAS(JJ)
     &                       ,AST(MCMTRM),IST(MCDTRM))                  !sdexplo
*
*              Son nombre de valeurs par noeud est donne par NVANAS(JJ)
*
               IF (NUDOAS.GT.0)
     &         CALL GETTRM (IST(MCDTRM+LGETRM+(NUDOAS-1)*INCTRM) 
     &                     ,NWTRM,ITDOAS,ITYCAL,NUKALE,NUDONN,NVANAS(JJ)
     &                     ,NVDSMA,NUINCC,NVDUMC,NBNUMC,NVNUMC,NUINCL
     &                     ,NVDUML,NBNUML,NVNUML,INDSTK,NVSTOK,NVCOOR
     &                     ,IATRDO,NIVIMP)                              !sdexplo
2           CONTINUE
*
*           On n'aura plus besoin du tableau affecte  la C.E.
*
            CALL TBSAVE (NMTDON,NVTDON)
*
*           Si la donnee g n'est pas mentionnee dans le tableau affecte
*           la condition est homogene
*
            HOMOGN=(ITYCCE.EQ.INTYKL ('C.ESSE').AND.LGTDON.EQ.1).OR.
     &             (ITYCCE.EQ.INTYKL ('C.TRAN').AND.LGTDON.EQ.2)
*
*           Si la condition est homogene (g non mentionnee)
*           la derniere donnee porte le nom de la condition essentielle
*
            IF (HOMOGN) THEN
               NMDOAS(NBDOAS)=NMESSE
               NVDOAS(NBDOAS)=NVESSE
               TYDOAS(NBDOAS)='REEL'
               ITYDAS(NBDOAS)=INTCON
            ENDIF
         ELSE
            GOTO 99991
         ENDIF
*
      ELSE
*
*        Si le tableau affectee a la condition essentielle est de type
*        REEL ou COMPLEXE il n'y a qu'une donnee associee
*        (le second membre g)
*
         LGTDON=0
*
*        Si la condition essentielle n'a pas de donnee affectee, 
*        la condition est homogene
         HOMOGN=NUDOCE.LE.0
*        la (derniere) donnee porte le nom de la condition essentielle
         NMDOAS(NBDOAS)=NMESSE
         NVDOAS(NBDOAS)=NVESSE
*        le nombre de valeur par noeud est celui de la donnee de la c.e.
         NVANAS(NBDOAS)=NVALNE
         TYDOAS(NBDOAS)=TYESSE
         ITYDAS(NBDOAS)=INTCON
         IF (.NOT.HOMOGN) ITYDAS(NBDOAS)=INTTAB
      ENDIF 
*
*     Restauration en M.C. des donnees de type tableau
*     et calcul du nombre de valeurs par noeud et 
*     de l'increment pour le passage d'un noeud au suivant
*
      DO 10 J=1,NBDOAS
         IF (ITYDAS(J).EQ.INTTAB) THEN
            CALL TBRR1  (ERCODE,NMDOAS(J),NVDOAS(J),LG)
            IF (NVANAS(J).GT.0) THEN
*              Terme valeurs nodales (a priori non constant par noeud)
               NBSUNE(J)=NVANAS(J)
               SKIPNE(J)=MAX (NCPICE,NVANAS(J))
            ELSE
*              Tableau donne en tous les noeuds
*              (matriciel, vectoriel ou scalaire en chaque noeud)
               NVANAS(J)=LG
               IF (LG.EQ.NBNECE*NCPICE*NCPICE) THEN
*                 Tableau matriciel donne noeud par noeud
                  NVANAS(J)=NCPICE*NCPICE
                  NBSUNE(J)=NCPICE*NCPICE
                  SKIPNE(J)=NCPICE*NCPICE
               ELSEIF (LG.EQ.NBNECE*NCPICE) THEN
*                 Tableau vectoriel (i.e. diagonal) donne noeud par noeud
                  NVANAS(J)=NCPICE
                  NBSUNE(J)=NCPICE
                  SKIPNE(J)=NCPICE
               ELSEIF (LG.EQ.NBNECE) THEN
*                 Tableau diagonal a diagonale constante donnee noeud par noeud
                  NVANAS(J)=1
                  NBSUNE(J)=1
                  SKIPNE(J)=NCPICE
               ENDIF
            ENDIF
         ELSEIF (ITYDAS(J).NE.INTCON) THEN
            GOTO 99993
         ENDIF
         IF (NVANAS(J).GT.NCPICE) PARDL=.FALSE.
10    CONTINUE
*
*     Passage au repere local dans la matrice et le second membre ?
*
      ROTONS(1:1)='N'
*     pour des conditions a inconnues vectorielles du type u.n ou u^n
      IF (NCPICE.GT.1.AND.(NUKACE.EQ.2.OR.NUKACE.EQ.3)) ROTONS(1:1)='Y'
*
*     Passage au repere local dans la donnee de la condition essentielle ?
*
      ROTACE(1:1)='N'
      IF (.NOT.HOMOGN.AND.NVALNE.GT.1.AND.NUKACE.EQ.3)  ROTACE(1:1)='Y'
*
      CALL PRFXMJ (-1,'*Cecado*')
      RETURN
90001 IRCODE=1
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      ERCODE(NCATR1+1:NCATR1+11)=TYESSE
      CALL BAISE  ('La donnee '//NMTDON(1:NCHDON)
     &//' de type '//ERCODE(NCATR1+1:NCATR1+11)
     &//', pour la condition essentielle '//ERCODE(1:NCATR1)
     &//', est obligatoirement un tableau.')
99992 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      CALL ENCLER (J,ERCODE(NCATR1+1:NCATR1+1))
      ERCODE(NCATR1+2:)=NMDOAS(J)
      CALL BAISE  ('La donnee '//ERCODE(NCATR1+2:NCATR1+1+NCHDON)
     &//', numero '//ERCODE(NCATR1+1:NCATR1+1)
     &//' pour la condition essentielle '//ERCODE(1:NCATR1)
     &//', n''a pas ete definie (en tant que donnee).')
99993 CALL PRNTRM (NMESSE,NVESSE,ERCODE,NCATR1)
      ERCODE(NCATR1+1:)=NMDOAS(J)
      CALL BAISE  ('La donnee '//NMTDON(1:NCHDON)
     &//', pour la condition essentielle '//ERCODE(1:NCATR1)
     &//', ne peut contenir le nom de la donnee de type FONCTION '
     &//ERCODE(NCATR1+1:NCATR1+NCHDON)//'.')
                                                                    END !Cecado
