*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEEBC (NBNECO,NGNECO,NBCOAV,NBNELI,NGNELI,NBLIAV
     &                 ,NBNTLI,IDNUME
     &                 ,NULAPL,IPLAGE,TYMATR,MCMATR,TYVECT,MCVECT
     &                 ,NBESSE,NGESSE,TYESSE,MCESSE,RST,CST
     &                 ,LIGCOL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1989)
* Derniere modification : D.Martin (30 Septembre 2001)
* Version 1.0.2
*  
* 1) Modification de la partie triangulaire inferieure d'un terme matriciel 
* BiMorse par mise a zero des coefficients sous-diagonaux des colonnes Dirichlet
* et, dans le cas d'un condition non homogene, 
* modification du vecteur second membre par report de -Aij x Uj dans le
* coefficient i du second membre
*                                 ou
* 2) Modification de la partie triangulaire superieure d'un terme matriciel 
* BiMorse par mise a zero des coefficients sur-diagonaux des lignes Dirichlet.
*
*   (dans ce cas echanger le role des lignes et des colonnes ci-dessus
*    et les suffixes CO par LI et reciproquement dans le source)
*
*-- Arguments --  
* NBNECO 1) nombre de colonnes du terme du terme matriciel
* NGNECO 1) numerotation des d.l. en colonne du terme matriciel
* NBCOAV 1) nb. de colonnes des blocs prec. dans le cas "multi-inconnue"
* NBNELI 1) nombre de lignes du terme du terme matriciel
* NGNELI 1) numerotation des d.l. en ligne du terme matriciel
* NBLIAV 1) nb. de lignes des blocs prec. dans le cas "multi-inconnue"
* IDNUME donnee logique indiquant l'identite des numerotations en ligne
*        et colonne du terme matriciel sur lequel porte l'elimination
* NULAPL numeros de derniere plage de chaque 1) colonne / 2) ligne
* IPLAGE numeros de 1)ligne / 2)colonne de debut de plage et longueurs cumulees
* TYMATR type (REEL ou COMPLEXE) du terme matriciel
* NBNTLI nombre total de 1)lignes / 2) colonnes
* MCMATR adresse en M.C. de la partie triangulaire 1)inf / 2)sup du terme
* TYVECT type (REEL ou COMPLEXE) du terme de second membre
* MCVECT 1) adresse en M.C. du second membre eventuel
*        2) = 0
* NBESSE nombre de d.l. de la 'Condition Essentielle'  
* NGESSE numerotation des d.l. de la 'Condition Essentielle'
* TYESSE type (REEL ou COMPLEXE) de la donnee de la 'Condition Essentielle'
* MCESSE 1) adresse de la donnee de la 'Condition Essentielle'
*        2) = 0
* RST,CST super-tableau numerique, version reelle et complexe
* LIGCOL 'Ligne' ou 'Colonne'
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYMATR,TYVECT,TYESSE,LIGCOL
      INTEGER       NBNECO,NGNECO(*),NBCOAV,NBNELI,NGNELI(*),NBLIAV
     &             ,NBNTLI,NULAPL(*),IPLAGE(2,*)
     &             ,MCMATR,MCVECT,NBESSE,NGESSE(*),MCESSE,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
      LOGICAL       IDNUME 
*
      INTEGER       NXCOLO,NXLIGN,NUESSE,LIGIM1,KOLONJ,LIGNEI
     &             ,NUPRPL,NUDRPL,PLAGE,LGCUAV,MCMAT1
     &             ,ADMATR,ADVECT,ADESSE
      REAL          RVESSE
      COMPLEX       CVESSE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeEbc *')
*
      IF (NIVIMP.GT.2.AND.IMPFCH.GT.0) THEN
        IF (LIGCOL(1:1).EQ.'L') THEN
           WRITE (IMPFCH,10000) 'Ligne','Colonne'
        ELSE
           WRITE (IMPFCH,10000) 'Colonne','Ligne'
        ENDIF
      ENDIF
      NXCOLO=1 
      NXLIGN=1 
*
      IF (MCESSE.GT.0.AND.MCVECT.GT.0) THEN
*
*        1) Ne concerne que de la partie triangulaire inferieure
*           et le cas d'une condition de Dirichlet non homogene
*
         RVESSE=0.
         CVESSE=0.
         ADESSE=MCESSE-1
         DO 4500 NUESSE=1,NBESSE
            IF (NGESSE(NUESSE).LE.0) GOTO 4500
*           NBCOEF=0
            ADESSE=ADESSE+1
            IF (TYESSE(1:1).EQ.'R') THEN
               RVESSE=RST(ADESSE)
               CVESSE=RVESSE
            ELSEIF (TYESSE(1:1).EQ.'C') THEN
               CVESSE=CST(ADESSE)
            ENDIF
*
*           Recherche des colonnes de la matrice correspondant a un noeud
*           portant la condition essentielle
*
            CALL DICOTO (NXCOLO,NBNECO,NGNECO,NGESSE(NUESSE)
     &                  ,KOLONJ,*4500)                                  !utilite
            NXCOLO=KOLONJ+1
            LIGNEI=KOLONJ
            IF (.NOT.IDNUME) THEN
               CALL DICOTO (NXLIGN,NBNELI,NGNELI,NGESSE(NUESSE)
     &                     ,LIGNEI,*4500)                               !utilite
               NXLIGN=LIGNEI+1
            ENDIF
            KOLONJ=KOLONJ+NBCOAV
            LIGNEI=LIGNEI+NBLIAV
*        
            NUDRPL=0
            IF (LIGNEI.GT.1) NUDRPL=NULAPL(LIGNEI-1)
            LGCUAV=0
            IF (NUDRPL.GT.0) LGCUAV=IPLAGE(2,NUDRPL)
*
            IF (TYVECT(1:1).EQ.'R') THEN
*
*              Si le second membre est REEL alors necessairement
*              la matrice et les valeurs de blocage sont REELLES (voir CdEsse)
*
               DO 2223 LIGIM1=LIGNEI,NBNTLI-1
                  NUPRPL=NUDRPL+1  
                  NUDRPL=NULAPL(LIGIM1)  
                  CALL DIKLPL (KOLONJ,NUPRPL,NUDRPL,LGCUAV,IPLAGE
     &                        ,PLAGE,*2221)                             !morse 
                  IF (PLAGE.GT.1) LGCUAV=IPLAGE(2,PLAGE-1)
                  MCMAT1=MCMATR+LGCUAV+KOLONJ-IPLAGE(1,PLAGE)
*                 Report de -Aij x Uj dans le second membre
                  ADVECT=MCVECT+LIGIM1
                  RST(ADVECT)=RST(ADVECT)-RST(MCMAT1)*RVESSE
                  RST(MCMAT1)=0.
*                 NBCOEF=NBCOEF+1
2221              LGCUAV=IPLAGE(2,NUDRPL)
2223           CONTINUE
*
            ELSEIF (TYVECT(1:1).EQ.'C') THEN
*
               IF (TYMATR(1:1).EQ.'C') THEN
*
                  DO 4443 LIGIM1=LIGNEI,NBNTLI-1
                     NUPRPL=NUDRPL+1  
                     NUDRPL=NULAPL(LIGIM1)  
                     CALL DIKLPL (KOLONJ,NUPRPL,NUDRPL,LGCUAV,IPLAGE
     &                           ,PLAGE,*4441)                          !morse 
                     IF (PLAGE.GT.1) LGCUAV=IPLAGE(2,PLAGE-1)
                     MCMAT1=MCMATR+LGCUAV+KOLONJ-IPLAGE(1,PLAGE)
                     ADVECT=MCVECT+LIGIM1
                     CST(ADVECT)=CST(ADVECT)-CST(MCMAT1)*CVESSE
                     CST(MCMAT1)=0.
*                    NBCOEF=NBCOEF+1
4441                 LGCUAV=IPLAGE(2,NUDRPL)
4443              CONTINUE
*
               ELSEIF (TYMATR(1:1).EQ.'R') THEN
*
                  DO 2443 LIGIM1=LIGNEI,NBNTLI-1
                     NUPRPL=NUDRPL+1  
                     NUDRPL=NULAPL(LIGIM1)  
                     CALL DIKLPL (KOLONJ,NUPRPL,NUDRPL,LGCUAV,IPLAGE
     &                           ,PLAGE,*2441)                          !morse 
                     IF (PLAGE.GT.1) LGCUAV=IPLAGE(2,PLAGE-1)
                     MCMAT1=MCMATR+LGCUAV+KOLONJ-IPLAGE(1,PLAGE)
                     ADVECT=MCVECT+LIGIM1
                     CST(ADVECT)=CST(ADVECT)-RST(MCMAT1)*CVESSE
                     RST(MCMAT1)=0.
*                    NBCOEF=NBCOEF+1
2441                 LGCUAV=IPLAGE(2,NUDRPL)
2443               CONTINUE
               ENDIF
            ENDIF
4500     CONTINUE
*
      ELSE
*
*        1) Annulation des coefficients sous-diagonaux des colonnes Dirichlet
*        dans la partie triangulaire inferieure (cas homogene)
*        ou
*        2) Annulation des coefficients sur-diagonaux des lignes Dirichlet
*        dans la partie triangulaire superieure (cas homogene ou non)
*
         DO 4100 NUESSE=1,NBESSE
*           NBCOEF=0
*
*           Recherche des colonnes/lignes de la matrice correspondant
*           a un noeud portant la condition essentielle
            CALL DICOTO (NXCOLO,NBNECO,NGNECO,NGESSE(NUESSE)
     &                  ,KOLONJ,*4100)                                  !utilite
            NXCOLO=KOLONJ+1
            LIGNEI=KOLONJ
            IF (.NOT.IDNUME) THEN
               CALL DICOTO (NXLIGN,NBNELI,NGNELI,NGESSE(NUESSE)
     &                     ,LIGNEI,*4100)                               !utilite
               NXLIGN=LIGNEI+1
            ENDIF
            KOLONJ=KOLONJ+NBCOAV
            LIGNEI=LIGNEI+NBLIAV
            NUDRPL=0
            IF (LIGNEI.GT.1) NUDRPL=NULAPL(LIGNEI-1)
            LGCUAV=0
            IF (NUDRPL.GT.0) LGCUAV=IPLAGE(2,NUDRPL)
*
*           Recherche des lignes/colonnes pour la colonne/ligne a annuler
*
            IF (TYMATR(1:1).EQ.'R') THEN
               DO 2003 LIGIM1=LIGNEI,NBNTLI-1
                  NUPRPL=NUDRPL+1
                  NUDRPL=NULAPL(LIGIM1)
                  CALL DIKLPL (KOLONJ,NUPRPL,NUDRPL,LGCUAV,IPLAGE
     &                        ,PLAGE,*2001)                             !morse
                  IF (PLAGE.GT.1) LGCUAV=IPLAGE(2,PLAGE-1)
                  MCMAT1=MCMATR+LGCUAV+KOLONJ-IPLAGE(1,PLAGE)
                  RST(MCMAT1)=0.
                  IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &               WRITE (IMPFCH,10001) NUESSE,KOLONJ,LIGIM1+1
     &                                   ,MCMAT1-MCMATR+1
*                 NBCOEF=NBCOEF+1
2001              LGCUAV=IPLAGE(2,NUDRPL)
2003           CONTINUE
            ELSEIF (TYMATR(1:1).EQ.'C') THEN
               DO 4003 LIGIM1=LIGNEI,NBNTLI-1
                  NUPRPL=NUDRPL+1
                  NUDRPL=NULAPL(LIGIM1)
                  CALL DIKLPL (KOLONJ,NUPRPL,NUDRPL,LGCUAV,IPLAGE
     &                        ,PLAGE,*4001)                             !morse
                  IF (PLAGE.GT.1) LGCUAV=IPLAGE(2,PLAGE-1)
                  MCMAT1=MCMATR+LGCUAV+KOLONJ-IPLAGE(1,PLAGE)
                  CST(MCMAT1)=0.
                  IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &               WRITE (IMPFCH,10001) NUESSE,KOLONJ,LIGIM1+1
     &                                   ,MCMAT1-MCMATR+1
*                 NBCOEF=NBCOEF+1
4001              LGCUAV=IPLAGE(2,NUDRPL)
4003           CONTINUE
            ENDIF
4100     CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*CeEbc *')
*-----------------------------------------------------------------------
10000 FORMAT (T40,' #  ',A7,' ',A7,'  Adresse')
10001 FORMAT (T40,I3,I8,I8,I8)

                                                                    END !CeEbc
