*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEEBCV (NCPINC,NUELI1,NUELI2,NBNECO,NGNECO,NBCOAV
     &                  ,NBNELI,NGNELI,NBLIAV,NBLINE,IDNUME
     &                  ,NULAPL,IPLAGL,TYMATR,MCMATR,NCFSSD
     &                  ,TYVECT,MCVECT,NBVECT,NLVECT
     &                  ,NBESSE,NGESSE,TYESSE,NCESSE,MCESSE,NDESSE
     &                  ,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : O.DeBayser & D.Martin (Decembre 1994)
* Derniere modification : D.Martin (25 Novembre 1999)
* Version 1.0.0
*  
* 1) Modification de la partie triangulaire inferieure d'un terme matriciel 
* BiMorse par annulation des coefficients des colonnes j Dirichlet
* precede dans le cas d'un condition non homogene, de la modification du vecteur
* par report de -Aij x Uj dans le coefficient i du vecteur
*                                ou
* 2) Modification de la partie triangulaire superieure d'un terme matriciel 
* BiMorse par annulation des coefficients des lignes Dirichlet
*
*    Cas d'une inconnue vectorielle et d'un systeme uni-inconnue
*  
*-- Arguments --
* NCPINC nombre de composantes de l'inconnue vectorielle
* NUELI1 1ere composante du noeud a eliminer
* NUELI2 derniere composante du noeud a eliminer
* NBNECO nombre de noeuds en colonne de la matrice
* NGNECO numerotation des noeuds en ligne pour l'interpolation en colonne
* NBCOAV nombre de colonnes des blocs precedents, cas "multi-inconnue"
* NBNELI nombre de noeuds en ligne de la matrice
* NGNELI numerotation des noeuds en ligne pour l'interpolation en ligne
* NBLIAV nombre de noeuds av. la 1ere ligne dans le cas "multi-inconnue"
* NBLINE nombre de noeuds en colonne total
* IDNUME donnee logique indiquant l'identite des numerotations en ligne
*        et colonne du terme sur lequel porte l'elimination
* NULAPL numeros de derniere plage de chaque colonne
* IPLAGL numeros de ligne de debut de plage et longueurs cumulees
* TYMATR type du terme matriciel
* MCMATR adresse en M.C. de la partie triangulaire superieure du terme
* NCFSSD nombre de coefficients d'un bloc sous-diagonal
* TYVECT type du terme vecteur
* MCVECT adresse du terme vecteur
* NBVECT nombre de (colonnes de) vecteur(s)
* NLVECT nombre de lignes du vecteur
* NBESSE nombre de noeuds 'Condition Essentielle'  
* NGESSE numerotation des noeuds 'Condition Essentielle'
* TYESSE type de la donnee de Dirichlet
* NCESSE nombre de composantes par noeud de la donnee de `Condition Essentielle'
* MCESSE adresse en M.C. de cette donnee
* NDESSE numero de la 1ere composante par noeud utile dans la donnee de la 
*        condition essentielle
* RST,CST super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL       IDNUME 
      CHARACTER*(*) TYMATR,TYVECT,TYESSE
      INTEGER       NCPINC,NUELI1,NUELI2,NBNECO,NGNECO(*)
     &             ,NBCOAV,NBNELI,NGNELI(*),NBLIAV,NBLINE
     &             ,NULAPL(*),IPLAGL(2,*),NCFSSD
     &             ,MCMATR,MCVECT,NBVECT,NLVECT
     &             ,NBESSE,NGESSE(*),NCESSE,MCESSE,NDESSE
      REAL          RST(*)  
      COMPLEX       CST(*)  
*
      CHARACTER     AST
      INTEGER       IST
      INTEGER       NUESSE,KOLDIR,NXCOLO,LGCUAV,LGCUMU,LGCUDA
     &             ,NUPRPL,NUDRPL,PLAGE
     &             ,ADMATR,ADMAT1,ADESSE,ADVECT,ADVEC1,NUVECT
     &             ,LIGIM1,LGLIGL,LIGDIA,NXLIGN
     &             ,NBELIM,MOELI1,NBELI1,NBELII,J
      COMPLEX       CC
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeEbcv*')
*
*     Nombre de lignes a eliminer par noeud
      NBELIM=NUELI2-NUELI1+1
*     Nombre de coefficients du bloc diagonal d'un noeud  annuler
      MOELI1=NUELI1*(NUELI1+1)/2
      ADESSE=MCESSE+NDESSE-1-NCESSE
*
      NXCOLO=1 
      NXLIGN=1
      DO 4500 NUESSE=1,NBESSE
*        Adresse absolue de la 1re valeur de blocage Dirichlet du noeud
         ADESSE=ADESSE+NCESSE
*        Recherche de la colonne de la matrice correspondant au 1er d.l.
*        du prochain noeud portant la condition essentielle
         CALL DICOTO (NXCOLO,NBNECO,NGNECO,NGESSE(NUESSE)
     &               ,KOLDIR,*4500)                                     !utilite
         NXCOLO=KOLDIR+1
         LIGDIA=KOLDIR 
         IF (.NOT.IDNUME) THEN  
            CALL DICOTO (NXLIGN,NBNELI,NGNELI,NGESSE(NUESSE)
     &                  ,LIGDIA,*4500)                                  !utilite
            NXLIGN=LIGDIA+1
         ENDIF
         KOLDIR=KOLDIR+NBCOAV
         LIGDIA=LIGDIA+NBLIAV
*        
         NUPRPL=0
         IF (LIGDIA.GT.2) NUPRPL=NULAPL(LIGDIA-2)
         LGCUAV=0
         IF (NUPRPL.GT.0) LGCUAV=IPLAGL(2,NUPRPL)
         NUPRPL=NUPRPL+1
         NUDRPL=0
         IF (LIGDIA.GT.1) NUDRPL=NULAPL(LIGDIA-1)
         LGCUMU=0
         IF (NUDRPL.GT.0) LGCUMU=IPLAGL(2,NUDRPL)
*        Nombre de coefficients precedant la 1ere ligne du noeud
         LGCUDA=NCPINC*NCPINC*LGCUAV+NCFSSD*(LIGDIA-1)
*        Nombre de coefficients de la 1ere ligne du noeud
         LGLIGL=(LGCUMU-LGCUAV)*NCPINC
*
         IF (MCESSE.GT.0.AND.MCVECT.GT.0) THEN
*
*           Elimination sur les lignes des d.l. suivants du noeud
*           Adresse dans le vecteur du premier noeud suivant :
            ADVECT=MCVECT+(LIGDIA-1)*NCPINC+NUELI1
*           Adresse dans la matrice de la colonne du 1er d.l. Dirichlet
*           sur la ligne suivante :
            ADMATR=MCMATR+LGCUDA+(NUELI1+1)*LGLIGL+MOELI1-1
            LGLIGL=LGLIGL+NUELI1
            NBELI1=1
            DO 2221 J=NUELI1+1,NCPINC
               NBELII=MIN (NBELI1,NBELIM)
               ADVEC1=ADVECT
               IF (TYVECT(1:1).EQ.'R') THEN
                  DO 2220 NUVECT=1,NBVECT
                     CALL TSCALT (NBELII,TYMATR,ADMATR,RST,CST
     &                                  ,TYESSE,ADESSE,RST,CST,CC)
                     RST(ADVEC1)=RST(ADVEC1)-REAL(CC)
                     ADVEC1=ADVEC1+NLVECT
2220              CONTINUE
               ELSEIF (TYVECT(1:1).EQ.'C') THEN
                  DO 2240 NUVECT=1,NBVECT
                     CALL TSCALT (NBELII,TYMATR,ADMATR,RST,CST
     &                                  ,TYESSE,ADESSE,RST,CST,CC)
                     CST(ADVEC1)=CST(ADVEC1)-CC
                     ADVEC1=ADVEC1+NLVECT
2240              CONTINUE
               ENDIF
               CALL TAZERO (NBELII,TYMATR,ADMATR,AST,IST,RST,CST)       !utilite
               NBELI1=NBELI1+1
               ADVECT=ADVECT+1
               ADMATR=ADMATR+LGLIGL
               LGLIGL=LGLIGL+1
2221        CONTINUE
            LGCUAV=LGCUMU
*
*           Recherche dans les lignes des noeuds suivants des coefficients
*           de la colonne KOLDIR (a annuler)
            DO 2229 LIGIM1=LIGDIA,NBLINE-1
               NUPRPL=NUDRPL+1  
               NUDRPL=NULAPL(LIGIM1)
               IF (NUDRPL.GT.0) LGCUMU=IPLAGL(2,NUDRPL)  
               LGCUDA=NCPINC*NCPINC*LGCUAV+NCFSSD*LIGIM1
               LGLIGL=(LGCUMU-LGCUAV)*NCPINC
               CALL DIKLPL (KOLDIR,NUPRPL,NUDRPL,LGCUAV,IPLAGL
     &                     ,PLAGE,*2228)                                !morse 
               IF (PLAGE.GT.NUPRPL) 
     &         LGCUDA=LGCUDA+(IPLAGL(2,PLAGE-1)-LGCUAV)*NCPINC
               ADMATR=MCMATR+LGCUDA+(KOLDIR-IPLAGL(1,PLAGE))*NCPINC
     &               +NUELI1-1
               ADVECT=MCVECT+LIGIM1*NCPINC
               DO 2227 J=1,NCPINC
                  ADVEC1=ADVECT
                  IF (TYVECT(1:1).EQ.'R') THEN
                     DO 2225 NUVECT=1,NBVECT
                        CALL TSCALT (NBELIM,TYMATR,ADMATR,RST,CST
     &                                     ,TYESSE,ADESSE,RST,CST,CC)
                        RST(ADVEC1)=RST(ADVEC1)-REAL(CC)
                        ADVEC1=ADVEC1+NLVECT
2225                 CONTINUE
                  ELSEIF (TYVECT(1:1).EQ.'C') THEN
                     DO 2245 NUVECT=1,NBVECT
                        CALL TSCALT (NBELIM,TYMATR,ADMATR,RST,CST
     &                                     ,TYESSE,ADESSE,RST,CST,CC)
                        CST(ADVEC1)=CST(ADVEC1)-CC
                        ADVEC1=ADVEC1+NLVECT
2245                 CONTINUE
                  ENDIF
                  CALL TAZERO (NBELIM,TYMATR,ADMATR,AST,IST,RST,CST)    !utilite
                  ADVECT=ADVECT+1
                  ADMATR=ADMATR+LGLIGL
                  LGLIGL=LGLIGL+1
2227           CONTINUE
2228           LGCUAV=LGCUMU
2229        CONTINUE
*
         ELSE
*
*           Elimination sur les lignes des d.l. suivants du noeud
*           Adresse dans la matrice de la colonne du 1er d.l. Dirichlet
*           sur la ligne suivante :
            ADMATR=MCMATR+LGCUDA+(NUELI1+1)*LGLIGL+MOELI1-1
            LGLIGL=LGLIGL+NUELI1
            NBELI1=1
            IF (TYMATR(1:1).EQ.'R') THEN
               DO 2201 J=NUELI1+1,NCPINC
                  DO 2200 ADMAT1=ADMATR,ADMATR-1+MIN (NBELI1,NBELIM)
                     RST(ADMAT1)=0.
2200              CONTINUE
                  NBELI1=NBELI1+1
                  ADMATR=ADMATR+LGLIGL
                  LGLIGL=LGLIGL+1
2201           CONTINUE
               LGCUAV=LGCUMU
*              Recherche dans les lignes suivantes des coefficients 
*              de la colonne KOLDIR (a annuler)
               DO 2215 LIGIM1=LIGDIA,NBLINE-1
                  NUPRPL=NUDRPL+1  
                  NUDRPL=NULAPL(LIGIM1)
                  IF (NUDRPL.GT.0) LGCUMU=IPLAGL(2,NUDRPL)
*                 Nombre de coefficients de la matrice precedant la ligne
                  LGCUDA=NCPINC*NCPINC*LGCUAV+NCFSSD*LIGIM1
*                 Nombre de coefficients de la ligne
                  LGLIGL=(LGCUMU-LGCUAV)*NCPINC
                  CALL DIKLPL (KOLDIR,NUPRPL,NUDRPL,LGCUAV,IPLAGL
     &                        ,PLAGE,*2213)                             !morse 
                  IF (PLAGE.GT.NUPRPL) 
     &            LGCUDA=LGCUDA+(IPLAGL(2,PLAGE-1)-LGCUAV)*NCPINC
                  ADMATR=MCMATR+LGCUDA+(KOLDIR-IPLAGL(1,PLAGE))*NCPINC
     &                  +NUELI1-1
                  DO 2211 J=1,NCPINC
                     DO 2210 ADMAT1=ADMATR,ADMATR-1+NBELIM
                        RST(ADMAT1)=0.
2210                 CONTINUE
                     ADMATR=ADMATR+LGLIGL
                     LGLIGL=LGLIGL+1
2211              CONTINUE
2213              LGCUAV=LGCUMU
2215           CONTINUE
            ELSE
               DO 2401 J=NUELI1+1,NCPINC
                  DO 2400 ADMAT1=ADMATR,ADMATR-1+MIN (NBELI1,NBELIM)
                     CST(ADMAT1)=0.
2400              CONTINUE
                  NBELI1=NBELI1+1
                  ADMATR=ADMATR+LGLIGL
                  LGLIGL=LGLIGL+1
2401           CONTINUE
               LGCUAV=LGCUMU
               DO 2415 LIGIM1=LIGDIA,NBLINE-1
                  NUPRPL=NUDRPL+1  
                  NUDRPL=NULAPL(LIGIM1)
                  IF (NUDRPL.GT.0) LGCUMU=IPLAGL(2,NUDRPL)  
                  LGCUDA=NCPINC*NCPINC*LGCUAV+NCFSSD*LIGIM1
                  LGLIGL=(LGCUMU-LGCUAV)*NCPINC
                  CALL DIKLPL (KOLDIR,NUPRPL,NUDRPL,LGCUAV,IPLAGL
     &                        ,PLAGE,*2413)                             !morse 
                  IF (PLAGE.GT.NUPRPL) 
     &            LGCUDA=LGCUDA+(IPLAGL(2,PLAGE-1)-LGCUAV)*NCPINC
                  ADMATR=MCMATR+LGCUDA+(KOLDIR-IPLAGL(1,PLAGE))*NCPINC
     &                  +NUELI1-1
                  DO 2411 J=1,NCPINC
                     DO 2410 ADMAT1=ADMATR,ADMATR-1+NBELIM
                        CST(ADMAT1)=0.
2410                 CONTINUE
                     ADMATR=ADMATR+LGLIGL
                     LGLIGL=LGLIGL+1
2411              CONTINUE
2413              LGCUAV=LGCUMU
2415           CONTINUE
            ENDIF
*
         ENDIF
4500  CONTINUE
      CALL PRFXMJ (-1,'*CeEbcv*')
                                                                    END !CeEbcv
