*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEEBL (NBNOEU,NGNOEU,NBLIAV
     &                 ,NULAPL,IPLAGE,TYMATR,MCMATR,TYVECT,MCVECT
     &                 ,NBESSE,NGESSE,TYESSE,MCESSE,RST,CST
     &                 ,LIGCOL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Mai 1989)
* Derniere modification : D.Martin (30 Septembre 2001)
* Version 1.0.2
*
* 1) Modification de la partie triangulaire inferieure d'un terme matriciel 
* BiMorse par annulation des coefficients sous-diagonaux des lignes Dirichlet
*                                 ou
* 2) Modification de la partie triangulaire superieure d'un terme matriciel 
* BiMorse par annulation des coefficients sur-diagonaux des colonnes Dirichlet 
* et, dans le cas d'un condition non homogene, 
* modification du vecteur second membre par report de -Aij x Uj dans le
* coefficient i du second membre
*
*            Cas d'une inconnue scalaire ou multi-inconnue
*  
*-- Arguments --
* NBNOEU 1) nombre de lignes du terme matriciel
*        2) nombre de colonnes du terme matriciel 
* NGNOEU 1) numerotation des d.l. des lignes du terme matriciel
*        2) numerotation des d.l. des colonnes du terme matriciel
* NBLIAV 1) nombre de lignes des blocs precedents pour le cas "multi-inconnue"
*        2) nombre de colonnes des blocs precedents pour le cas "multi-inconnue"
* NULAPL numeros de derniere plage de chaque 1)ligne / 2)colonne
* IPLAGE numeros de 1)colonne / 2)ligne de debut de plage et longueurs cumulees
* TYMATR type (REEL ou COMPLEXE) du terme matriciel
* MCMATR adresse de la partie triangulaire 1)inf / 2)sup. du terme matriciel
* TYVECT type (REEL ou COMPLEXE) du terme de second membre
* MCVECT 1) = 0
*        2) adresse du terme vecteur (second membre)
* NBESSE nombre de d.l. de la 'Condition Essentielle'  
* NGESSE numerotation des d.l. de la 'Condition Essentielle'  
* TYESSE type (REEL ou COMPLEXE) de la donnee de la 'Condition Essentielle'
* MCESSE 1) = 0
*        2) adresse de la donnee de la 'Condition Essentielle'
* RST,CST super-tableau numerique, version reelle et complexe
* LIGCOL 'Ligne' ou 'Colonne'
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYMATR,TYVECT,TYESSE,LIGCOL
      INTEGER       NBNOEU,NGNOEU(*),NULAPL(*),IPLAGE(2,*),NBLIAV
     &             ,MCMATR,MCVECT,NBESSE,NGESSE(*),MCESSE,NIVIMP,IMPFCH
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      INTEGER       NUESSE,LIOUCO,NXNOEU,LGCUAV,LGCUMU,LGCUAW,LIGDEB
     &             ,NUPRPL,NUDRPL,PLAGE,ADESSE,ADVECT,MCMAT1,MCVEC1
      REAL          RVESSE
      COMPLEX       CVESSE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeEbl *')
*
      IF (NIVIMP.GT.2.AND.IMPFCH.GT.0) WRITE (IMPFCH,10000) LIGCOL
      NXNOEU=1
      LIOUCO=0
      RVESSE=0.
      CVESSE=0.
      ADESSE=MCESSE-1
      DO 4500 NUESSE=1,NBESSE
         IF (NGESSE(NUESSE).LE.0) GOTO 4500
         IF (MCESSE.GT.0.AND.MCVECT.GT.0) THEN
            ADESSE=ADESSE+1
            IF (TYESSE(1:1).EQ.'R') THEN
               RVESSE=RST(ADESSE)
               CVESSE=RVESSE
            ELSEIF (TYESSE(1:1).EQ.'C') THEN
               CVESSE=CST(ADESSE)
            ENDIF
         ENDIF
*        Recherche de la prochaine colonne de la matrice correspondant 
*        a un noeud portant la condition essentielle
         CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &               ,LIOUCO,*4500)                                     !utilite
         NXNOEU=LIOUCO+1
         LIOUCO=LIOUCO+NBLIAV
         IF (LIOUCO.LE.1) GOTO 4500
         NUPRPL=0
         IF (LIOUCO.GT.2) NUPRPL=NULAPL(LIOUCO-2)
         LGCUAV=0
         IF (NUPRPL.GT.0) LGCUAV=IPLAGE(2,NUPRPL)
         NUPRPL=NUPRPL+1
         NUDRPL=NULAPL(LIOUCO-1)
         IF (NUDRPL.LT.NUPRPL) GOTO 4500
         LGCUMU=IPLAGE(2,NUDRPL)
         LGCUAW=LGCUAV
*
         IF (MCESSE.GT.0.AND.MCVECT.GT.0) THEN
*
*           Report de -Aij x Uj au second membre pour tous les noeuds
*
            IF (TYVECT(1:1).EQ.'R') THEN
*
*              Si le second membre est REEL alors necessairement
*              la matrice et les valeurs de blocage sont REELLES (voir CdEsse)
*
               DO 2223 PLAGE=NUPRPL,NUDRPL
                  LIGDEB=IPLAGE(1,PLAGE)
                  LGCUMU=IPLAGE(2,PLAGE)
                  MCMAT1=MCMATR+LGCUAW
                  ADVECT=MCVECT-1+LIGDEB
                  DO 2221 MCVEC1=ADVECT,ADVECT-1+LGCUMU-LGCUAW
                     RST(MCVEC1)=RST(MCVEC1)-RST(MCMAT1)*RVESSE
                     MCMAT1=MCMAT1+1
2221              CONTINUE
                  LGCUAW=LGCUMU   
2223           CONTINUE
*
            ELSEIF (TYVECT(1:1).EQ.'C') THEN
*
               IF (TYMATR(1:1).EQ.'C') THEN
*
                  DO 4443 PLAGE=NUPRPL,NUDRPL
                     LIGDEB=IPLAGE(1,PLAGE)
                     LGCUMU=IPLAGE(2,PLAGE)
                     MCMAT1=MCMATR+LGCUAW
                     ADVECT=MCVECT-1+LIGDEB
                     DO 4441 MCVEC1=ADVECT,ADVECT-1+LGCUMU-LGCUAW
                        CST(MCVEC1)=CST(MCVEC1)-CST(MCMAT1)*CVESSE
                        MCMAT1=MCMAT1+1
4441                 CONTINUE
                     LGCUAW=LGCUMU   
4443              CONTINUE
*
               ELSEIF (TYMATR(1:1).EQ.'R') THEN
*
                  DO 2443 PLAGE=NUPRPL,NUDRPL
                     LIGDEB=IPLAGE(1,PLAGE)
                     LGCUMU=IPLAGE(2,PLAGE)
                     MCMAT1=MCMATR+LGCUAW
                     ADVECT=MCVECT-1+LIGDEB
                     DO 2441 MCVEC1=ADVECT,ADVECT-1+LGCUMU-LGCUAW
                        CST(MCVEC1)=CST(MCVEC1)-RST(MCMAT1)*CVESSE
                        MCMAT1=MCMAT1+1
2441                 CONTINUE
                     LGCUAW=LGCUMU   
2443              CONTINUE
               ENDIF
            ENDIF
         ENDIF
*
*        Annulation de tous les coefficients de la ligne/colonne
         IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &      WRITE (IMPFCH,10001) NUESSE,LIOUCO,LGCUMU-LGCUAV
     &                          ,LGCUAV+1,LGCUMU
         IF (TYMATR(1:1).EQ.'R') THEN
            DO 2011 MCMAT1=MCMATR+LGCUAV,MCMATR+LGCUMU-1
               RST(MCMAT1)=0.
2011        CONTINUE
         ELSE
            DO 4011 MCMAT1=MCMATR+LGCUAV,MCMATR+LGCUMU-1
               CST(MCMAT1)=0.
4011        CONTINUE
         ENDIF
4500  CONTINUE
      CALL PRFXMJ (-1,'*CeEbl *')
*-----------------------------------------------------------------------
10000 FORMAT (T40,' #  ',A7,'  Nombre / adresses des coeff. annules')
10001 FORMAT (T35,I8,I8,I8,'/',I8,' a ',I8)
                                                                    END !CeEbl
