*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEEBLV (NCPINC,NUELI1,NUELI2,NBNOEU,NGNOEU,NBLIAV
     &                  ,NULAPL,IPLAGE,TYMATR,MCMATR,NCFSSD
     &                  ,TYVECT,MCVECT,NBVECT,NLVECT
     &                  ,NBESSE,NGESSE,TYESSE,NCESSE,MCESSE,NDESSE
     &                  ,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : O.DeBayser & D.Martin (Decembre 1994)
* Derniere modification : D.Martin (25 Novembre 1999)
* Version 1.0.0
*
* 2) Modification de la partie triangulaire superieure d'un terme matriciel 
* BiMorse par annulation des coefficients sur-diagonaux des colonnes Dirichlet
* et dans le cas d'un condition non homogene, modification du vecteur
* par report de -Aij x Uj dans le coeff. i du vecteur
*                                ou
* 1) Modification de la partie triangulaire inferieure d'un terme matriciel 
* BiMorse par annulation des coefficients sous-diagonaux des lignes Dirichlet
*
*    Cas d'une inconnue vectorielle et d'un systeme uni-inconnue
*  
*-- Arguments --
* NCPINC nombre de composantes de l'inconnue vectorielle
* NUELI1 1ere composante du noeud a eliminer
* NUELI2 derniere composante du noeud a eliminer
* NBNOEU 1) nombre de noeuds en colonne du terme matriciel
*        2) nombre de noeuds en ligne du terme matriciel  
* NGNOEU 1) numerotation des noeuds en colonne du terme matriciel
*        2) numerotation des noeuds en ligne du terme matriciel
* NBLIAV 1) nombre de colonnes des blocs precedents, cas "multi-inconnue"
*        2) nombre de lignes des blocs precedents, cas "multi-inconnue"
* NULAPL numeros de derniere plage de chaque 1)colonne /2)ligne
* IPLAGE numeros de 1)ligne /2)colonne de debut de plage et longueurs cumulees
* TYMATR type (REEL ou COMPLEXE) du terme matriciel
* MCMATR adresse de la partie triangulaire 1)sup. /2)inf. du terme matriciel
* NCFSSD nombre de coefficients d'un bloc sur/sous-diagonal pour un noeud
* TYVECT type (REEL ou COMPLEXE) du vecteur
* MCVECT adresse du terme vectoriel
* NBVECT nombre de (colonnes de) vecteur(s)
* NLVECT nombre de lignes du vecte
* NBESSE nombre de noeuds de la 'Condition Essentielle'  
* NGESSE numerotation des noeuds de la 'Condition Essentielle'  
* TYESSE type (REEL ou COMPLEXE) de la donnee de la 'Condition Essentielle'
* NCESSE nombre de composantes par noeud de la donnee de `Condition Essentielle'
* MCESSE adresse de la donnee de la 'Condition Essentielle'
* NDESSE numero de la 1ere composante par noeud utile dans la donnee de la 
*        condition essentielle
* RST,CST super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYVECT,TYESSE
      INTEGER       NCPINC,NUELI1,NUELI2,NBNOEU,NGNOEU(*)
     &             ,NULAPL(*),IPLAGE(2,*),NCFSSD,NBLIAV
     &             ,MCMATR,MCVECT,NBVECT,NLVECT
     &             ,NBESSE,NGESSE(*),NCESSE,MCESSE,NDESSE
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      CHARACTER*6   BUG(3)
      INTEGER       NUESSE,LIOUCO,NXNOEU,LGCUAV,LGCUMU,LGCUAW,LIGDEB
     &             ,NUPRPL,NUDRPL,PLAGE,LGCUDW,LGCUDA,LGCOGL
     &             ,ADMATR,ADMAT1,ADESSE,ADESS1,ADVECT,ADVEC1,ADVEC2
     &             ,NUVECT,ADRIPP,LGELIM,NBELIM,MOELII,MOELIM
     &             ,J,NBANUL,NBZERO
      REAL          RVESSE
      COMPLEX       CVESSE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeEblv*')
*
*     Nombre de lignes a eliminer par noeud
      NBELIM=NUELI2-NUELI1+1
*     Nombre de coefficients du bloc diagonal d'un noeud a annuler
      MOELII=(NUELI1-1)*(NUELI1-2)/2
      MOELIM=NUELI2*(NUELI2-1)/2-MOELII
      ADESSE=MCESSE+NDESSE-1-NCESSE
*
      NXNOEU=1
      LIOUCO=0
      DO 4500 NUESSE=1,NBESSE
*        Adresse absolue de la 1re valeur de blocage Dirichlet du noeud
         ADESSE=ADESSE+NCESSE
*        Recherche de la colonne de la matrice correspondant au 1er d.l.
*        du prochain noeud portant la condition essentielle
         CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &               ,LIOUCO,*4500)                                     !utilite
         NXNOEU=LIOUCO+1
         LIOUCO=LIOUCO+NBLIAV
*        Reperage de la colonne du 1er d.l. du noeud
*        (1ere et derniere plage, adresse du dernier coeff. precedent)
         NUPRPL=0
         IF (LIOUCO.GT.2) NUPRPL=NULAPL(LIOUCO-2)
         LGCUAV=0
         IF (NUPRPL.GT.0) LGCUAV=IPLAGE(2,NUPRPL)
         NUPRPL=NUPRPL+1
         NUDRPL=0
         IF (LIOUCO.GT.1) NUDRPL=NULAPL(LIOUCO-1)
         LGCUMU=0
         IF (NUDRPL.GT.0) LGCUMU=IPLAGE(2,NUDRPL)
*        Nombre de coefficients precedant la 1ere ligne du noeud Dirichlet
*        = Adresse relative du dernier coeff. de la ligne precedente
         LGCUDA=LGCUAV*NCPINC*NCPINC+NCFSSD*(LIOUCO-1)
*        Nombre de coefficients de la ligne du 1er d.l. du noeud Dirichlet
         LGCOGL=(LGCUMU-LGCUAV)*NCPINC
*
         IF (MCESSE.GT.0.AND.MCVECT.GT.0) THEN
            NBANUL=0
*           Report de -Aij x Uj au second membre pour toutes les lignes j
*           des d.l. des noeuds precedant le 1er d.l. du noeud Dirichlet
            LGCUAW=LGCUAV
            LGCUDW=LGCUDA
            IF (TYVECT(1:1).EQ.'R') THEN
*              On ne parcourt que les LGCOGL 1ers coeff. des colonnes
*              des d.l. du noeud (et non le bloc sous-diagonal du noeud)
               DO 2223 PLAGE=NUPRPL,NUDRPL
                  LIGDEB=IPLAGE(1,PLAGE)
                  LGCUMU=IPLAGE(2,PLAGE)
                  LGELIM=(LGCUMU-LGCUAW)*NCPINC
*                 Adresse du 1er coeff. de la plage de la colonne
*                 du 1er d.l. Dirichlet du noeud
                  ADRIPP=NUELI1-1
                  ADMATR=MCMATR+LGCUDW+(NUELI1-1)*LGCOGL
*                 Adresse a laquelle on soustraire Aij x Uj dans le vecteur
                  ADVECT=MCVECT+(LIGDEB-1)*NCPINC
                  ADESS1=ADESSE
*                 Boucle sur les d.l. Dirichlet du noeud
*                 (NUELI1=1, NUELI2=NCPINC pour une condition u = g,
*                  NUELI1=1, NUELI2=1      pour u.n = g
*                  NUELI1=2, NUELI2=NCPINC pour u^n = g)
                  DO 2222 J=NUELI1,NUELI2
                     RVESSE=RST(ADESS1)
                     ADMAT1=ADMATR
                     DO 2221 ADVEC1=ADVECT,ADVECT-1+LGELIM
                        ADVEC2=ADVEC1
                        DO 2220 NUVECT=1,NBVECT
                           RST(ADVEC2)=RST(ADVEC2)-RST(ADMAT1)*RVESSE
                           ADVEC2=ADVEC2+NLVECT
2220                    CONTINUE
                        NBANUL=NBANUL+1
                        ADMAT1=ADMAT1+1
2221                 CONTINUE
                     ADESS1=ADESS1+1
*                    Augmentation de 1 de la longueur de la colonne
*                    lors du passage au d.l. suivant
                     ADMATR=ADMATR+LGCOGL+ADRIPP
                     ADRIPP=ADRIPP+1
2222              CONTINUE
                  LGCUAW=LGCUMU
                  LGCUDW=LGCUDW+LGELIM  
2223           CONTINUE
*              Report de -Aij x Uj au second membre pour les lignes
*              des autres d.l. du noeud (bloc diagonal du noeud)
               ADRIPP=NUELI1-1
               ADMATR=MCMATR+LGCUDA+NUELI1*LGCOGL+MOELII+ADRIPP-1
               ADVECT=MCVECT+(LIOUCO-1)*NCPINC
               ADESS1=ADESSE
*              Parcours des 1eres colonnes non Dirichlet du noeud 
*              (les coeff. des dernieres colonnes non Dirichlet du noeud
*               sont dans la partie triangulaire inferieure)
               DO 2227 J=NUELI1,NUELI2
                  RVESSE=RST(ADESS1)
                  ADMAT1=ADMATR
                  DO 2226 ADVEC1=ADVECT,ADVECT+J-2
                     ADVEC2=ADVEC1
                     DO 2225 NUVECT=1,NBVECT
                        RST(ADVEC2)=RST(ADVEC2)-RST(ADMAT1)*RVESSE
                        ADVEC2=ADVEC2+NLVECT
2225                 CONTINUE
                     NBANUL=NBANUL+1
                     ADMAT1=ADMAT1+1
2226              CONTINUE
                  ADESS1=ADESS1+1
*                 Augmentation de 1 de la longueur de la colonne
*                 lors du passage au d.l. suivant
                  ADMATR=ADMATR+LGCOGL+ADRIPP
                  ADRIPP=ADRIPP+1
2227           CONTINUE
            ELSEIF (TYVECT(1:1).EQ.'C') THEN
               IF (TYMATR(1:1).EQ.'C') THEN
                  DO 4433 PLAGE=NUPRPL,NUDRPL
                     LIGDEB=IPLAGE(1,PLAGE)
                     LGCUMU=IPLAGE(2,PLAGE)
                     LGELIM=(LGCUMU-LGCUAW)*NCPINC
                     ADRIPP=NUELI1-1
                     ADMATR=MCMATR+LGCUDW+(NUELI1-1)*LGCOGL
                     ADVECT=MCVECT+(LIGDEB-1)*NCPINC
                     ADESS1=ADESSE
                     DO 4432 J=NUELI1,NUELI2
                        IF (TYESSE(1:1).EQ.'C') THEN
                           CVESSE=CST(ADESS1)
                        ELSE
                           CVESSE=CMPLX(RST(ADESS1),0.)
                        ENDIF
                        ADMAT1=ADMATR
                        DO 4431 ADVEC1=ADVECT,ADVECT-1+LGELIM
                           ADVEC2=ADVEC1
                           DO 4430 NUVECT=1,NBVECT
                              CST(ADVEC2)=CST(ADVEC2)-CST(ADMAT1)*CVESSE
                              ADVEC2=ADVEC2+NLVECT
4430                       CONTINUE
                           NBANUL=NBANUL+1
                           ADMAT1=ADMAT1+1
4431                    CONTINUE
                        ADESS1=ADESS1+1
                        ADMATR=ADMATR+LGCOGL+ADRIPP
                        ADRIPP=ADRIPP+1
4432                 CONTINUE
                     LGCUAW=LGCUMU
                     LGCUDW=LGCUDW+LGELIM  
4433              CONTINUE
                  ADRIPP=NUELI1-1
                  ADMATR=MCMATR+LGCUDA+NUELI1*LGCOGL+MOELII*ADRIPP-1
                  ADVECT=MCVECT+(LIOUCO-1)*NCPINC
                  ADESS1=ADESSE
                  DO 4437 J=NUELI1,NUELI2
                     IF (TYESSE(1:1).EQ.'C') THEN
                        CVESSE=CST(ADESS1)
                     ELSE
                        CVESSE=CMPLX(RST(ADESS1),0.)
                     ENDIF
                     ADMAT1=ADMATR
                     DO 4436 ADVEC1=ADVECT,ADVECT+J-2
                        ADVEC2=ADVEC1
                        DO 4435 NUVECT=1,NBVECT
                           CST(ADVEC2)=CST(ADVEC2)-CST(ADMAT1)*CVESSE
                           ADVEC2=ADVEC2+NLVECT
4435                    CONTINUE
                        NBANUL=NBANUL+1
                        ADMAT1=ADMAT1+1
4436                 CONTINUE
                     ADESS1=ADESS1+1
                     ADMATR=ADMATR+LGCOGL+ADRIPP
                     ADRIPP=ADRIPP+1
4437              CONTINUE
               ELSE
                 DO 2433 PLAGE=NUPRPL,NUDRPL
                     LIGDEB=IPLAGE(1,PLAGE)
                     LGCUMU=IPLAGE(2,PLAGE)
                     LGELIM=(LGCUMU-LGCUAW)*NCPINC
                     ADRIPP=NUELI1-1
                     ADMATR=MCMATR+LGCUDW+(NUELI1-1)*LGCOGL
                     ADVECT=MCVECT+(LIGDEB-1)*NCPINC
                     ADESS1=ADESSE
                     DO 2432 J=NUELI1,NUELI2
                        IF (TYESSE(1:1).EQ.'C') THEN
                           CVESSE=CST(ADESS1)
                        ELSE
                           CVESSE=CMPLX(RST(ADESS1),0.)
                        ENDIF
                        ADMAT1=ADMATR
                        DO 2431 ADVEC1=ADVECT,ADVECT-1+LGELIM
                           ADVEC2=ADVEC1
                           DO 2430 NUVECT=1,NBVECT
                              CST(ADVEC2)=CST(ADVEC2)-RST(ADMAT1)*CVESSE
                              ADVEC2=ADVEC2+NLVECT
2430                       CONTINUE
                           NBANUL=NBANUL+1
                           ADMAT1=ADMAT1+1
2431                    CONTINUE
                        ADESS1=ADESS1+1
                        ADMATR=ADMATR+LGCOGL+ADRIPP
                        ADRIPP=ADRIPP+1
2432                 CONTINUE
                     LGCUAW=LGCUMU
                     LGCUDW=LGCUDW+LGELIM  
2433              CONTINUE
                  ADRIPP=NUELI1-1
                  ADMATR=MCMATR+LGCUDA+NUELI1*LGCOGL+MOELII*ADRIPP-1
                  ADVECT=MCVECT+(LIOUCO-1)*NCPINC
                  ADESS1=ADESSE
                  DO 2437 J=NUELI1,NUELI2
                     IF (TYESSE(1:1).EQ.'C') THEN
                        CVESSE=CST(ADESS1)
                     ELSE
                        CVESSE=CMPLX(RST(ADESS1),0.)
                     ENDIF
                     ADMAT1=ADMATR
                     DO 2436 ADVEC1=ADVECT,ADVECT+J-2
                        ADVEC2=ADVEC1
                        DO 2435 NUVECT=1,NBVECT
                           CST(ADVEC2)=CST(ADVEC2)-RST(ADMAT1)*CVESSE
                           ADVEC2=ADVEC2+NLVECT
2435                    CONTINUE
                        NBANUL=NBANUL+1
                        ADMAT1=ADMAT1+1
2436                 CONTINUE
                     ADESS1=ADESS1+1
                     ADMATR=ADMATR+LGCOGL+ADRIPP
                     ADRIPP=ADRIPP+1
2437              CONTINUE
               ENDIF
            ENDIF
            NBZERO=NBELIM*LGCOGL+MOELIM
            IF (NBANUL.NE.NBZERO) THEN
               CALL ENCLER (NGESSE(NUESSE),BUG(1))
               CALL ENCLER (NBANUL,BUG(2))
               CALL ENCLER (NBZERO,BUG(3))
               CALL WARNNG ('*CeEblv* Bug interne. Nombre de reports '
     &                    //' dans le vecteur ('//BUG(2)
     &                    //') different du nombre de coeff. annules ('
     &                    //BUG(3)//'), pour le noeud' //BUG(1))
            ENDIF
         ENDIF
*
*        Annulation de tous les coefficients des lignes/colonnes du noeud
         ADMATR=MCMATR+LGCUDA+(NUELI1-1)*LGCOGL
         NBZERO=NBELIM*LGCOGL+MOELIM
         IF (TYMATR(1:1).EQ.'R') THEN
            DO 2011 ADMAT1=ADMATR,ADMATR+NBZERO-1
               RST(ADMAT1)=0.
2011        CONTINUE
         ELSE
            DO 4011 ADMAT1=ADMATR,ADMATR+NBZERO-1
               CST(ADMAT1)=0.
4011        CONTINUE
         ENDIF
4500  CONTINUE
      CALL PRFXMJ (-1,'*CeEblv*')
                                                                    END !CeEblv
