*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEEBV  (NCPINC,NUELI1,NUELI2,NBNOEU,NGNOEU,NBLIAV
     &                  ,TYMATR,MCMATR,TYVECT,MCVECT,NBVECT,NLVECT
     &                  ,NBESSE,NGESSE,TYESSE,NCESSE,MCESSE,NDESSE
     &                  ,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : O.DeBayser & D.Martin (Decembre 1994)
* Derniere modification : D.Martin (30 Septembre 2001)
* Version 1.0.2
*  
* Prise en compte dans le vecteur, d'une condition essentielle affectee
* a un couple (matrice A, vecteur V) -- cas d'une inconnue vectorielle
* - non homogene: on pose Aii x Ei dans Vi sur les lignes i Dirichlet
* - homogene:     on pose 0.       dans Vi sur les lignes i Dirichlet
* (Ne doit etre appele que si MCVECT.GT.0)
*  
*-- Arguments --
* NCPINC nombre de composantes de l'inconnue vectorielle
* NUELI1 1ere ligne de chaque noeud a eliminer
* NUELI2 derniere ligne de chaque noeud a eliminer
* NBNOEU nombre de noeuds en ligne du terme matriciel A
* NGNOEU numerotation des noeuds en ligne du terme matriciel A
* NBLIAV nombre de noeuds des blocs precedents pour le cas "multi-inconnue"
* TYMATR type (REEL ou COMPLEXE) du terme matriciel A
* MCMATR adresse de la diagonale du terme matriciel A
* TYVECT type du terme vecteur V
* MCVECT adresse du terme vecteur V
* NBVECT nombre de (colonnes de) vecteur(s) V
* NLVECT nombre de lignes du vecteur V
* NBESSE nombre de noeuds de la 'Condition Essentielle' 
* NGESSE numerotation des noeuds de la 'Condition Essentielle'
* TYESSE type (REEL ou COMPLEXE) de la donnee de la `Condition Essentielle'
* NCESSE nombre de valeurs par noeud de la donnee de `Condition Essentielle'
* MCESSE adresse de la donnee de la `Condition Essentielle' E
* NDESSE numero de la 1ere composante par noeud utile dans la donnee de la 
*        condition essentielle
* RST,CST super-tableau numerique, version reelle et complexe  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYMATR,TYVECT,TYESSE 
      INTEGER       NCPINC,NUELI1,NUELI2,NBNOEU,NGNOEU(*),NBLIAV
     &             ,MCMATR,MCVECT,NBVECT,NLVECT
     &             ,NBESSE,NGESSE(*),NCESSE,MCESSE,NDESSE
      REAL          RST(*)  
      COMPLEX       CST(*)  
*
      INTEGER       NUESSE,LIGDIR,NXNOEU,NUVECT
     &             ,ADMATR,ADMAT1,ADESSE,ADESS1,ADVECT,ADVEC1,ADVEC2
     &             ,ADRIPP,NBELIM
      REAL          RCOEFF
      COMPLEX       CCOEFF
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeEbv*')
*
*     Nombre de composantes par noeud a modifier
      NBELIM=NUELI2-NUELI1+1
*     Adresse de depart dans le vecteur
      ADVECT = MCVECT+NCPINC*(NBLIAV-1)
      NXNOEU = 1
*
      IF (MCESSE.LE.0) THEN
*
*        Conditions essentielles homogenes
*        On pose 0. dans les lignes idoines du vecteur V
*
         IF (TYVECT(1:1).EQ.'R') THEN
            DO 2003 NUESSE=1,NBESSE
               CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                     ,LIGDIR,*2003)                               !utilite
               NXNOEU = LIGDIR+1
               ADRIPP = LIGDIR*NCPINC+NUELI1-1
               DO 2001 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                  RST(ADVEC1) = 0.
2001           CONTINUE
2003        CONTINUE
         ELSEIF (TYVECT(1:1).EQ.'C') THEN
            DO 4003 NUESSE=1,NBESSE
               CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                     ,LIGDIR,*4003)                               !utilite
               NXNOEU = LIGDIR+1
               ADRIPP = LIGDIR*NCPINC+NUELI1-1
               DO 4001 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                  CST(ADVEC1) = 0.
4001           CONTINUE
4003        CONTINUE
         ENDIF
*
      ELSE
*
*        Conditions essentielles non homogenes
*        On pose Aii x Ei dans les lignes idoines du vecteur V
*
         ADMATR = MCMATR+NCPINC*(NBLIAV-1)
         ADESSE = MCESSE+NDESSE-1-NCESSE
         IF (TYVECT(1:1).EQ.'R') THEN
*
*           Si le second membre est REEL alors necessairement
*           la matrice et les valeurs de blocage sont REELLES (voir CdEsse)
*
            DO 2223 NUESSE=1,NBESSE
               IF (NGESSE(NUESSE).LE.0) GOTO 2223
               ADESSE = ADESSE+NCESSE
               CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                     ,LIGDIR,*2223)                               !utilite
               NXNOEU = LIGDIR+1
               ADESS1 = ADESSE
               ADRIPP = LIGDIR*NCPINC+NUELI1-1
               ADMAT1 = ADMATR+ADRIPP
               DO 2221 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                  RCOEFF = RST(ADMAT1)*RST(ADESS1)
                  ADMAT1 = ADMAT1+1
                  ADESS1 = ADESS1+1
                  ADVEC2=ADVEC1
                  DO 2220 NUVECT=1,NBVECT
                     RST(ADVEC2) = RCOEFF
                     ADVEC2=ADVEC2+NLVECT
2220              CONTINUE
2221           CONTINUE
2223        CONTINUE
         ELSEIF (TYVECT(1:1).EQ.'C') THEN
            IF (TYMATR(1:1).EQ.'C') THEN
               IF (TYESSE(1:1).EQ.'C') THEN
                  DO 4443 NUESSE=1,NBESSE
                     IF (NGESSE(NUESSE).LE.0) GOTO 4443
                     ADESSE = ADESSE+NCESSE
                     CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                           ,LIGDIR,*4443)                         !utilite
                     NXNOEU = LIGDIR+1
                     ADESS1 = ADESSE
                     ADRIPP = LIGDIR*NCPINC+NUELI1-1
                     ADMAT1 = ADMATR+ADRIPP
                     DO 4441 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                        CCOEFF = CST(ADMAT1)*CST(ADESS1)
                        ADMAT1 = ADMAT1+1
                        ADESS1 = ADESS1+1
                        ADVEC2=ADVEC1
                        DO 4440 NUVECT=1,NBVECT
                           CST(ADVEC2) = CCOEFF
                           ADVEC2=ADVEC2+NLVECT
4440                    CONTINUE
4441                 CONTINUE
4443              CONTINUE
               ELSE
                  DO 4423 NUESSE=1,NBESSE
                     IF (NGESSE(NUESSE).LE.0) GOTO 4423
                     ADESSE = ADESSE+NCESSE
                     CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                           ,LIGDIR,*4423)                         !utilite
                     NXNOEU = LIGDIR+1
                     ADESS1 = ADESSE
                     ADRIPP = LIGDIR*NCPINC+NUELI1-1
                     ADMAT1 = ADMATR+ADRIPP
                     DO 4421 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                        CCOEFF = CST(ADMAT1)*RST(ADESS1)
                        ADMAT1 = ADMAT1+1
                        ADESS1 = ADESS1+1
                        ADVEC2=ADVEC1
                        DO 4420 NUVECT=1,NBVECT
                           CST(ADVEC2) = CCOEFF
                           ADVEC2=ADVEC2+NLVECT
4420                    CONTINUE
4421                 CONTINUE
4423              CONTINUE
               ENDIF
            ELSEIF (TYMATR(1:1).EQ.'R') THEN
               IF (TYESSE(1:1).EQ.'R') THEN
                  DO 4223 NUESSE=1,NBESSE
                     IF (NGESSE(NUESSE).LE.0) GOTO 4223
                     ADESSE = ADESSE+NCESSE
                     CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                           ,LIGDIR,*4223)                         !utilite
                     NXNOEU = LIGDIR+1
                     ADESS1 = ADESSE
                     ADRIPP = LIGDIR*NCPINC+NUELI1-1
                     ADMAT1 = ADMATR+ADRIPP
                     DO 4221 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                        RCOEFF = RST(ADMAT1)*RST(ADESS1)
                        ADMAT1 = ADMAT1+1
                        ADESS1 = ADESS1+1
                        ADVEC2=ADVEC1
                        DO 4220 NUVECT=1,NBVECT
                           CST(ADVEC2) = RCOEFF
                           ADVEC2=ADVEC2+NLVECT
4220                    CONTINUE
4221                 CONTINUE
4223              CONTINUE
               ELSE
                  DO 4243 NUESSE=1,NBESSE
                     IF (NGESSE(NUESSE).LE.0) GOTO 4243
                     ADESSE = ADESSE+NCESSE
                     CALL DICOTO (NXNOEU,NBNOEU,NGNOEU,NGESSE(NUESSE)
     &                           ,LIGDIR,*4243)                         !utilite
                     NXNOEU = LIGDIR+1
                     ADESS1 = ADESSE
                     ADRIPP = LIGDIR*NCPINC+NUELI1-1
                     ADMAT1 = ADMATR+ADRIPP
                     DO 4241 ADVEC1=ADVECT+ADRIPP,ADVECT+ADRIPP+NBELIM-1
                        CCOEFF = RST(ADMAT1)*CST(ADESS1)
                        ADMAT1 = ADMAT1+1
                        ADESS1 = ADESS1+1
                        ADVEC2=ADVEC1
                        DO 4240 NUVECT=1,NBVECT
                           CST(ADVEC2) = CCOEFF
                           ADVEC2=ADVEC2+NLVECT
4240                    CONTINUE
4241                 CONTINUE
4243              CONTINUE
               ENDIF
            ENDIF
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*CeEbv*')
                                                                    END !CeEbv
