*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEPLOC (NMPLOC,NVPLOC,NDIM,NCPICE,NBNECE,NVNUCE,NVNORM
     &                  ,NUDOMG,NCHDOM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1997)
* Derniere modification : D.Martin (26 Aout 2000)
* Version 1.0.1
*  
* Creation du tableau des reperes locaux a partir d'un tableau des normales
* pour changement de repere local dans les conditions essentielles
* pour inconnue vectorielle
*
*-- Arguments d'entree -- 
* NMPLOC nom du tableau recepteur des reperes locaux
* NVPLOC niveau des reperes locaux
* NDIM   dimension d'espace
* NCPICE nombre de composantes de l'inconnue vectorielle
* NBNECE nombre de noeuds
* NVNUCE niveau de numerotation en noeuds
* NVNORM niveau des tableaux de normales
* NUDOMG numero du domaine geometrique 
* NCHDOM nombre de caractere par nom de domaine
* NIVIMP niveau d'impression
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NMPLOC*(*)
      INTEGER   NVPLOC,NDIM,NCPICE,NBNECE,NVNUCE,NVNORM,NUDOMG
     &         ,NCHDOM,NIVIMP,IMPFCH
*  
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8
      INTEGER   MCLIST,MCNUME,MCNORM,MCPLOC,MCMDOM,I
     &         ,NXLIST,NDMDOM,NDMDOE,NBELDO,NBNEEX,NBDLEX,NBNEFX,NBDLFX
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ceploc*')
*
      CALL TBRR2  (ERCODE,'#ISTEL',NUDOMG,MCLIST,'&NORMA',NVPLOC,MCNORM)
      CALL TBAR4  (ERCODE,'#ISTEL',NUDOMG,MCLIST,'#GNEDO',NVNUCE,MCNUME
     &                   ,'&NORMA',NVNORM,MCNORM,NMPLOC,NVPLOC,MCPLOC)
      CALL EXLIST (IST(MCLIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &            ,NBNEEX,NBDLEX,NBNEFX,NBDLFX)                         !sdexplo
*
      CALL RPLOCA (NDIM,NDMDOM,NCPICE,NBNECE,RST(MCNORM),RST(MCPLOC))   !sdexplo
*
      IF (IMPFCH.GT.0.AND.NIVIMP.GT.5) THEN
         CALL TBAR1 (ERCODE,'#OMDOM',1,MCMDOM)
         MCMDOM=MCMDOM+(NUDOMG-1)*NCHDOM
         WRITE (IMPFCH,10001) (PRFXAS(I),I=2,1,-1),NVPLOC
     &                       ,(AST(I),I=MCMDOM,MCMDOM-1+NCHDOM)
         CALL PRREPL (NCPICE,NBNECE,RST(MCPLOC),' Rp.loc',IMPFCH)       !prsd
      ENDIF
      CALL TBSAVE ('&NORMA',NVNORM)
      CALL TBSAVE ('#ISTEL',NUDOMG)
*
      CALL PRFXMJ (-1,'*Ceploc*')  
*-----------------------------------------------------------------------
10001 FORMAT(T2,A,'>',A,'>*Ceploc* Reperes locaux (tableau &RPLOC/',I4
     &,') sur le domaine : ',50A1)
                                                                    END !Ceploc
