*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CERODI (NPAS,NDPLOC,MOOUBM,NCPICE,LGLIGN,LGCOLO
     &                  ,MCMATP,NUENLI,ADPRLI,MCCDDV,MCCDLV,MCCDUV
     &                  ,TYMATR,MCMATD,MCMATL,MCMATU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1997) 
* Derniere modification : D.Martin (25 Janvier 2001)
* Version 1.0.2
*  
* Changement de repere dans un bloc diagonal d'une matrice
*  
*-- Arguments --
* NPAS   pas de parcours du tableau des changements de repere
*        1:naturel, NDPLOC:transpose
* NDPLOC dimension d'espace
* MOOUBM indice de matrice Bimorse (1) ou Morse (0) 
* NCPICE nombre de composantes de l'inconnue vectorielle de la cond. esse.
* LGLIGN longueur de la ligne de la matrice des noeuds du bloc
* LGCOLO longueur de la colonne de la matrice relative des noeuds du bloc
* NUENLI numero de ligne du 1er d.l. du noeud courant
* MCMATP adresse du tableau des matrices de changement de base en chaque noeud
* ADPRLI adresse relative du 1er noeud du bloc de lignes
* MCCDDV adresse absolue du coeff. diagonal de la matrice pour le noeud courant
* MCCDLV adresse absolue des coeff. de la ligne du noeud courant dans la
*        partie triangulaire inferieure de la matrice
* MCCDUV adresse absolue des coeff. de la colonne du noeud courant dans la
*        partie triangulaire superieure de la matrice
* MCMATD adresse absolue de la matrice (1er coeff. diagonal) (pour impression)
* MCMATL adresse absolue de la partie triangulaire inferieure de la matrice
*       (1er coeff. non nul a partir de la ligne 2)
* MCMATU adresse absolue de la partie triangulaire superieure de la matrice
*       (1er coeff. non nul a partir de la colonne 2)
* TYMATR type REEL ou COMPLEXE de la matrice
* RST,CST super tableaux habituels ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      CHARACTER TYMATR*(*)
      INTEGER   NPAS,NDPLOC,MOOUBM,NCPICE,LGLIGN,LGCOLO,MCMATP,NUENLI
     &         ,ADPRLI,MCCDDV,MCCDLV,MCCDUV,MCMATD,MCMATL,MCMATU
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER NDPLO2,NDPLOP,IPTU,IPTD,IPTL,IPT,ADMATP,ADPMA1,I,J,K
      INTEGER ADS(3,3)
      REAL    RAUX,RAUX1(3),RAUX2(3,3)
      COMPLEX CAUX,CAUX1(3),CAUX2(3,3)
*----------------------------------------------------------------------
      NDPLO2=NDPLOC*NDPLOC
      NDPLOP=NCPICE*NPAS
*
*     Pointeurs pour ramener le calcul a des matrices NCPICExNCPICE
*     recherche des adresses des coefficients du bloc diagonal
*     correspondant aux inconnues du noeud NUENLI,
*     dans les parties triangualaires sup et inf et sur la diagonale
*
      IPTU=MCCDUV+LGCOLO-1
      IPTD=MCCDDV
      IPTL=MCCDLV+LGLIGN-2
      DO 85 J=1,NCPICE
         IPT=IPTU
         IPTU=IPTU+LGCOLO+1
         DO 81 I=1,J-1
            ADS(I,J)=IPT
            IPT=IPT+1
81       CONTINUE
         ADS(J,J)=IPTD
         IPTD=IPTD+1
         IPTL=IPTL+LGLIGN+2
         IPT=IPTL
         DO 82 I=J+1,NCPICE
            ADS(I,J)=IPT
            IPT=IPT+LGLIGN+I-1
82       CONTINUE
85    CONTINUE
*
      IF (TYMATR(1:1).EQ.'R') THEN
*
*        Changement de repere en ligne : P**-1 x Aij
*
         DO 23 J=1,NCPICE
            DO 20 I=1,NCPICE
               RAUX1(I)=RST(ADS(I,J))
20          CONTINUE
            ADMATP=MCMATP+ADPRLI
            DO 22 I=1,NCPICE
               RAUX=0.
               K=1
               DO 21 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                  RAUX=RAUX+RST(ADPMA1)*RAUX1(K)
                  K=K+1
21             CONTINUE
               ADMATP=ADMATP+NDPLOC+1-NPAS
               RAUX2(I,J)=RAUX
22          CONTINUE
23       CONTINUE
*
*        Changement de repere en colonne : Aij x P
*
         DO 27 I=1,NCPICE
            DO 24 J=1,NCPICE
               RAUX1(J)=RAUX2(I,J)
24          CONTINUE
            ADMATP=MCMATP+ADPRLI
            DO 26 J=1,NCPICE
               RAUX=0.
               K=1
               DO 25 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                  RAUX=RAUX+RST(ADPMA1)*RAUX1(K)
                  K=K+1
25             CONTINUE
               ADMATP=ADMATP+NDPLOC+1-NPAS
               RAUX2(I,J)=RAUX
26          CONTINUE
27       CONTINUE
*
*        Recopie dans la matrice
*
         DO 29 J=1,NCPICE
            DO 28 I=1,NCPICE
               RST(ADS(I,J))=RAUX2(I,J)
28          CONTINUE
29       CONTINUE
*
      ELSEIF (TYMATR(1:1).EQ.'C') THEN
         DO 43 J=1,NCPICE
            DO 40 I=1,NCPICE
               CAUX1(I)=CST(ADS(I,J))
40          CONTINUE
            ADMATP=MCMATP+ADPRLI
            DO 42 I=1,NCPICE
               CAUX=0.
               K=1
               DO 41 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                  CAUX=CAUX+RST(ADPMA1)*CAUX1(K)
                  K=K+1
41             CONTINUE
               ADMATP=ADMATP+NDPLOC+1-NPAS
               CAUX2(I,J)=CAUX
42          CONTINUE
43       CONTINUE
         DO 47 I=1,NCPICE
            DO 44 J=1,NCPICE
               CAUX1(J)=CAUX2(I,J)
44          CONTINUE
            ADMATP=MCMATP+ADPRLI
            DO 46 J=1,NCPICE
               CAUX=0.
               K=1
               DO 45 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                  CAUX=CAUX+RST(ADPMA1)*CAUX1(K)
                  K=K+1
45             CONTINUE
               ADMATP=ADMATP+NDPLOC+1-NPAS
               CAUX2(I,J)=CAUX
46          CONTINUE
47       CONTINUE
         DO 49 J=1,NCPICE
            DO 48 I=1,NCPICE
               CST(ADS(I,J))=CAUX2(I,J)
48          CONTINUE
49       CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10001 FORMAT (T10,A,I5,':',3(I6,' ',A,' ',E11.5,' > ',E11.5))
10002 FORMAT (T2,A,A,I3,2E12.4,2I6,4E12.4)
                                                                    END !CeroDi
