*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CERODM (NPAS,NDPLOC,MOOUBM,NCPICE,MULTIM,NBENLI,RGESLI
     &                  ,NULAPL,IPLAGL,NULAPU,IPLAGU
     &                  ,TYMATR,MCMATD,MCMATL,MCMATU,MCMATP,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1997)
* Derniere modification : D.Martin (25 Janvier 2001)
* Version 1.0.2
*  
* Changement de repere (repere local) sur la diagonale (par bloc)
* d'une matrice stockee Bimorse
*  
*-- Arguments --
* NPAS   pas de parcours du tableau des changements de repere
*        1:naturel, NDPLOC:transpose
* NDPLOC dimension d'espace ou egal a NCPICE
* MOOUBM indice de matrice BIMORSE(1) ou MORSE (0)
* NCPICE nombre de composantes de l'inconnue vectorielle de la cond. esse.
* MULTIM indicateur du caractere multi-inconnue ou non du systeme
* NBENLI nombre de noeuds ou d.l. en ligne de la matrice
* RGESLI rangs des noeuds de la cond. esse. dans les lignes de la matrice
* NULAPL table des plages de la matrice triangle inf.
* IPLAGL table des debut et longueur de plages de la matrice tri. inf.
* NULAPU table des plages de la matrice triangle sup.
* IPLAGU table des debut et longueur de plages de la matrice tri. sup.
* TYMATR type de la matrice
* MCMATD adresse absolue des coeff. diagonaux de la matrice
* MCMATL adresse absolue des coeff. de la partie triangulaire inferieure
* MCMATU adresse absolue des coeff. de la partie triangulaire superieure
* MCMATP adresse du tableau des matrices de changement de base en chaque noeud
* RST,CST super tableaux habituels ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      CHARACTER MULTIM*(*),TYMATR*(*)
      INTEGER   NPAS,NDPLOC,MOOUBM,NCPICE,NBENLI,RGESLI(*),NULAPL(*)
     &         ,IPLAGL(2,*),NULAPU(*),IPLAGU(2,*),MCMATD,MCMATL,MCMATU
     &         ,MCMATP
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER LGLIGN,LGCOLO,LGCDAV,LGCLAV,LGCUAV,NUPRPL,NUDRPL,ADPRLI
     &       ,NUENLI,NUESLI,MCCDDV,MCCDLV,MCCDUV,NCFSSD,LGPLUS,ADNULA
     &       ,NDPLO2,UNOUMU
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeRodM*')
      LGCDAV=0
      LGCLAV=0
      LGCUAV=0
      LGLIGN=0
      LGCOLO=0
      NDPLO2=NDPLOC*NDPLOC
*
      IF (MULTIM(1:1).EQ.'Y') THEN
         UNOUMU=NCPICE
*
*        Boucle sur les lignes de la matrice comptees en d.l.
*        pour les premiers d.l. de chaque noeud
*
         ADNULA=NCPICE-MOOUBM
         DO 100 NUENLI=1,NBENLI,UNOUMU
            MCCDDV=MCMATD+LGCDAV
            LGCDAV=LGCDAV+NCPICE
            MCCDLV=MCMATL+LGCLAV
            MCCDUV=MCMATU+LGCUAV
*
            NUESLI=RGESLI(NUENLI)
            IF (NUESLI.GT.0) THEN
*
*              Adresse relative dans la matrice de changement de base
*
               ADPRLI=NDPLO2*((NUESLI-1)/UNOUMU)
*
               CALL CERODI (NPAS,NDPLOC,MOOUBM,NCPICE
     &                     ,LGLIGN,LGCOLO
     &                     ,MCMATP,NUENLI,ADPRLI,MCCDDV,MCCDLV,MCCDUV
     &                     ,TYMATR,MCMATD,MCMATL,MCMATU,RST,CST)        !cdesse
            ENDIF
*
*           Plages de debut et de fin, adresse de debut de ligne
*           et longueur de la ligne suivante
            NUPRPL=NULAPL(ADNULA)
            LGCLAV=IPLAGL(2,NUPRPL)   
            NUDRPL=NULAPL(ADNULA+1)
            IF (NUDRPL.GT.0) LGLIGN=IPLAGL(2,NUDRPL)-LGCLAV
            NUPRPL=NULAPU(ADNULA)
            LGCUAV=IPLAGU(2,NUPRPL)
            NUDRPL=NULAPU(ADNULA+1)
            IF (NUDRPL.GT.0) LGCOLO=IPLAGU(2,NUDRPL)-LGCUAV
            ADNULA=ADNULA+NCPICE
100      CONTINUE
*
      ELSE
         NCFSSD=NCPICE
         IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
         NCFSSD=NCFSSD*MOOUBM
         LGPLUS=0
         UNOUMU=1
*
*        Boucle sur les lignes de la matrice, comptees en noeuds
*
         ADNULA=1-MOOUBM
         DO 200 NUENLI=1,NBENLI,UNOUMU
            MCCDDV=MCMATD+LGCDAV
            LGCDAV=LGCDAV+NCPICE
            MCCDLV=MCMATL+LGCLAV*NDPLO2+LGPLUS
            LGCLAV=LGCLAV+LGLIGN
            MCCDUV=MCMATU+LGCUAV*NDPLO2+LGPLUS
            LGCUAV=LGCUAV+LGCOLO
            LGPLUS=LGPLUS+NCFSSD
*
            NUESLI=RGESLI(NUENLI)
            IF (NUESLI.GT.0) THEN
*
*              Adresse relative dans la matrice de changement de base
*
               ADPRLI=NDPLO2*((NUESLI-1)/UNOUMU)
*
               CALL CERODI (NPAS,NDPLOC,MOOUBM,NCPICE
     &                     ,LGLIGN*NCPICE,LGCOLO*NCPICE
     &                     ,MCMATP,NUENLI,ADPRLI,MCCDDV,MCCDLV,MCCDUV
     &                     ,TYMATR,MCMATD,MCMATL,MCMATU,RST,CST)        !cdesse
            ENDIF
*
*           Plages de debut et de fin, adresse de debut de ligne
*           et longueur de la ligne suivante
            ADNULA=ADNULA+1
            NUDRPL=NULAPL(ADNULA)
            IF (NUDRPL.GE.1) LGLIGN=IPLAGL(2,NUDRPL)-LGCLAV
            NUDRPL=NULAPU(ADNULA)
            IF (NUDRPL.GE.1) LGCOLO=IPLAGU(2,NUDRPL)-LGCUAV
200      CONTINUE
*
      ENDIF
      CALL PRFXMJ (-1,'*CeRodM*')
                                                                    END !CeRodM
