*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEROMA (NPAS,NDPLOC,MOOUBM,UNOUMU,NCPICE,RGESCO
     &                  ,NUESLI,MCMATP,NUENLI,ADRPLI
     &                  ,LGLIGN,NUPRPL,NUDRPL,PLAGEL,LGCUAV
     &                  ,MCCDLV,TYMATR,MCMATR,INFSUP,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1997) 
* Derniere modification : D.Martin (26 Aout 2000)
* Version 1.0.2
*
* Changement de repere un bloc rectangulaire ligne x colonnes de la partie
* triangulaire inferieure ou superieure d'une matrice
*
*-- Arguments --
* NPAS   pas de parcours du tableau des changements de repere
*        1:naturel, NDPLOC:transpose
* NDPLOC dimension d'espace
* MOOUBM indice de matrice Bimorse (1) ou Morse (0)
* UNOUMU indicateur de matrice uni- ou multi-inconnues 
* NCPICE nombre de composantes de l'inconnue vectorielle de la cond. esse.
* RGESCO rangs des noeuds de la cond. esse. dans les colonnes de la matrice
* NUESLI rang du noeud courant de la cond. esse. dans les lignes de la matrice
* MCMATP adresse du tableau des matrices de changement de base en chaque noeud
* NUENLI numero de ligne du 1er d.l. du noeud courant
* ADPRLI adresse relative du 1er noeud du bloc de lignes
* LGLIGN longueur de la ligne de la matrice relative au 1er noeud du bloc
* NUPRPL numero de la premiere plage relative au 1er noeud du bloc
* NUDRPL numero de la derniere plage relative au 1er noeud du bloc
* PLAGEL table des debut et longueur de plages de la partie tri. inf. ou sup.
* LGCUAV
* MCCDLV adresse absolue des coeff. de la ligne du noeud courant dans la
*        partie triangulaire inferieure de la matrice
* TYMATR Type REEL ou COMPLEXE de la matrice
* MCMATR adresse absolue de la partie triangulaire inferieure ou superieure
* INFSUP 'Inf' ou 'Sup'
* RST,CST super tableaux habituels ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      CHARACTER TYMATR*(*),INFSUP*(*)
      INTEGER   NPAS,NDPLOC,MOOUBM,UNOUMU,NCPICE,RGESCO(*),NUESLI,MCMATP
     &         ,NUENLI,ADRPLI,LGLIGN,NUPRPL,NUDRPL,PLAGEL(2,*),LGCUAV
     &         ,MCCDLV,MCMATR
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER   NDPLO2,NDPLOP,NUPLAG,KOLDEB,KOLFIN,LGCUML
     &         ,NUENCO,NUESCO,ADRPCO,ADPMA1,ADMATP,MCCUWL,MUOUBM
     &         ,I,J,K,MCT,kijkij
      INTEGER   ADS(3)
      REAL      RAUX,RAUX1(3)
      COMPLEX   CAUX,CAUX1(3)
*-----------------------------------------------------------------------
      NDPLO2=NDPLOC*NDPLOC
      NDPLOP=NCPICE*NPAS
*
*     Boucle sur les plages et les noeuds en colonne
*
      DO 90 NUPLAG=NUPRPL,NUDRPL
         KOLDEB=PLAGEL(1,NUPLAG)
         LGCUML=PLAGEL(2,NUPLAG)
         KOLFIN=KOLDEB+LGCUML-LGCUAV-1
         LGCUAV=LGCUML
         DO 80 NUENCO=KOLDEB,KOLFIN,UNOUMU
            NUESCO=RGESCO(NUENCO)
*
            IF (TYMATR(1:1).EQ.'R') THEN
*
               IF (NUESCO.GT.0) THEN
                  MCCUWL=MCCDLV
                  MUOUBM=0
                  ADRPCO=MCMATP+((NUESCO-1)/UNOUMU)*NDPLO2
*
                  DO 25 J=1,NCPICE
*                    Adresses des coeff. matriciels sur lesquels operer
                     MCT=MCCUWL
                     DO 20 I=1,NCPICE
                        ADS(I)=MCT
                        MCT=MCT+1
20                   CONTINUE
*
*                    Changement de repere en colonne : Aij x P -> Aij
*
                     ADMATP=ADRPCO
                     DO 23 I=1,NCPICE
                        K=1
                        RAUX=0.
                        DO 22 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                           RAUX=RAUX+RST(ADPMA1)*RST(ADS(K))
                           K=K+1
22                      CONTINUE
                        RAUX1(I)=RAUX
                        ADMATP=ADMATP+NDPLOC+1-NPAS
23                   CONTINUE
                     DO 24 I=1,NCPICE
                        RST(ADS(I))=RAUX1(I)
24                   CONTINUE
*
                     MCCUWL=MCCUWL+LGLIGN+MUOUBM
                     MUOUBM=MUOUBM+MOOUBM
25                CONTINUE
               ENDIF
*
               IF (NUESLI.GT.0) THEN
                  MCCUWL=MCCDLV
*
                  DO 35 J=1,NCPICE
*                    Adresses des coeff. matriciels sur lesquels operer
                     MCT=MCCUWL
                     MUOUBM=0
                     DO 30 I=1,NCPICE
                        ADS(I)=MCT
                        MCT=MCT+LGLIGN+MUOUBM
                        MUOUBM=MUOUBM+MOOUBM
30                   CONTINUE
*
*                    Changement de repere en ligne : P**-1 x Aij -> Aij
*
                     ADMATP=MCMATP+ADRPLI
                     DO 33 I=1,NCPICE
                        K=1
                        RAUX=0.
                        DO 32 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                           RAUX=RAUX+RST(ADPMA1)*RST(ADS(K))
                           K=K+1
32                      CONTINUE
                        RAUX1(I)=RAUX
                        ADMATP=ADMATP+NDPLOC+1-NPAS
33                   CONTINUE
                     DO 34 I=1,NCPICE
                        RST(ADS(I))=RAUX1(I)
34                   CONTINUE
*
                     MCCUWL=MCCUWL+1
35                CONTINUE
               ENDIF
*
            ELSEIF (TYMATR(1:1).EQ.'C') THEN
*
               IF (NUESCO.GT.0) THEN
                  MCCUWL=MCCDLV
                  MUOUBM=0
                  ADRPCO=MCMATP+((NUESCO-1)/UNOUMU)*NDPLO2
*
                  DO 45 J=1,NCPICE
*
                     MCT=MCCUWL
                     DO 40 I=1,NCPICE
                        ADS(I)=MCT
                        MCT=MCT+1
40                   CONTINUE
*
                     ADMATP=ADRPCO
                     DO 43 I=1,NCPICE
                        K=1
                        CAUX=0.
                        DO 42 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                           CAUX=CAUX+RST(ADPMA1)*CST(ADS(K))
                           K=K+1
42                      CONTINUE
                        CAUX1(I)=CAUX
                        ADMATP=ADMATP+NDPLOC+1-NPAS
43                   CONTINUE
                     DO 44 I=1,NCPICE
                        CST(ADS(I))=CAUX1(I)
44                   CONTINUE
*
                     MCCUWL=MCCUWL+LGLIGN+MUOUBM
                     MUOUBM=MUOUBM+MOOUBM
45                CONTINUE
               ENDIF
*
               IF (NUESLI.GT.0) THEN
                  MCCUWL=MCCDLV
*
                  DO 55 J=1,NCPICE
*
                     MCT=MCCUWL
                     MUOUBM=0
                     DO 50 I=1,NCPICE
                        ADS(I)=MCT
                        MCT=MCT+LGLIGN+MUOUBM
                        MUOUBM=MUOUBM+MOOUBM
50                   CONTINUE
*
                     ADMATP=MCMATP+ADRPLI
                     DO 53 I=1,NCPICE
                        K=1
                        CAUX=0.
                        DO 52 ADPMA1=ADMATP,ADMATP-1+NDPLOP,NPAS
                           CAUX=CAUX+RST(ADPMA1)*CST(ADS(K))
                           K=K+1
52                      CONTINUE
                        CAUX1(I)=CAUX
                        ADMATP=ADMATP+NDPLOC+1-NPAS
53                   CONTINUE
                     DO 54 I=1,NCPICE
                        CST(ADS(I))=CAUX1(I)
54                   CONTINUE
*
                     MCCUWL=MCCUWL+1
55                CONTINUE
               ENDIF
*
            ENDIF
            MCCDLV=MCCDLV+NCPICE
80       CONTINUE
90    CONTINUE
*-----------------------------------------------------------------------
10001 FORMAT (T10,A,I5,':',3(I6,' ',A,' ',E11.5,' > ',E11.5))
10002 FORMAT (T2,A,A,I3,2E12.4,2I6,4E12.4)
                                                                    END !CeroMa
