*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEROMM (NPAS,NDPLOC,MOOUBM,NCPICE,MULTIM
     &                  ,NBENLI,RGESLI,RGESCO,NULAPL,PLAGEL
     &                  ,TYMATR,MCMATL,MCMATP,INFSUP,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1995) 
* Derniere modification : D.Martin (26 Aout 2000)
* Version 1.0.1
*  
* Changement de repere (repere local) dans une des partie triangulaires
* d'une matrice stockee Bimorse ou dans une matrice Morse-L ou Morse-C 
*  
*-- Arguments --
* NPAS   pas de parcours du tableau des changements de repere
*        1:naturel, NDPLOC:transpose
* NDPLOC dimension d'espace ou egal a NCPICE
* MOOUBM indice de matrice Bimorse (1) ou Morse (0)
* NCPICE nombre de composantes de l'inconnue vectorielle de la cond. esse.
* MULTIM indicateur du caractere multi-inconnue ou non du systeme
* NBENLI nombre de noeuds ou d.l. en ligne de la matrice
* RGESLI rang des noeuds de la cond. esse. dans les lignes de la matrice
* RGESCO rang des noeuds de la cond. esse. dans les colonnes de la matrice
* NULAPL table des plages de la matrice
* PLAGEL table des debut et longueur de plages de la matrice
* TYMATR type de la matrice
* MCMATL adresse absolue de la partie triangulaire inferieure ou superieure
* MCMATP adresse du tableau des matrices de changement de base en chaque noeud
* INFSUP 'Inf' ou 'Sup'
* RST,CST super tableaux habituels ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT  NONE
      CHARACTER MULTIM*(*),TYMATR*(*),INFSUP*(*)
      INTEGER   NPAS,NDPLOC,MOOUBM,NCPICE,NBENLI,RGESLI(*),RGESCO(*)
     &         ,NULAPL(*),PLAGEL(2,*),MCMATL,MCMATP
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER   NDPLO2,NCPIC2,LGLIGN,LGCUAV,NUPRPL,NUDRPL,ADPRLI,NEXTLI
     &         ,NUENLI,NUESLI,MCCDLV,NCFSSD,UNOUMU
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeRomM*')
      LGLIGN=0
      LGCUAV=0
      NUPRPL=1
      NUDRPL=0
      NDPLO2=NDPLOC*NDPLOC
      NCPIC2=NCPICE*NCPICE
*
      IF (MULTIM(1:1).EQ.'Y') THEN
         UNOUMU=NCPICE
         NEXTLI=1+MOOUBM*UNOUMU
*
*        Boucle sur les noeuds en ligne
*
         DO 100 NUENLI=NEXTLI,NBENLI,UNOUMU
*           Plages de debut et de fin, adresse de debut de ligne
*           et longueur de la ligne courante
            IF (NUENLI.GT.1) THEN
               NUPRPL=NULAPL(NUENLI-MOOUBM-1)
               LGCUAV=PLAGEL(2,NUPRPL)
               NUPRPL=NUPRPL+1
            ENDIF
            NUDRPL=NULAPL(NUENLI-MOOUBM)
            MCCDLV=MCMATL+LGCUAV
            IF (NUDRPL.GE.1) LGLIGN=PLAGEL(2,NUDRPL)-LGCUAV
*
*           Adresse relative dans la matrice de changement de base
*
            NUESLI=RGESLI(NUENLI)
            ADPRLI=NDPLO2*((NUESLI-1)/UNOUMU)
*
            CALL CEROMA (NPAS  ,NDPLOC,MOOUBM,UNOUMU,NCPICE,RGESCO
     &                  ,NUESLI,MCMATP,NUENLI,ADPRLI
     &                  ,LGLIGN,NUPRPL,NUDRPL,PLAGEL,LGCUAV
     &                  ,MCCDLV,TYMATR,MCMATL,INFSUP,RST,CST)
100      CONTINUE
*
      ELSE
         NCFSSD=NCPICE
         IF (NCFSSD.LT.3) NCFSSD=NCPICE-1
         NCFSSD=MOOUBM*NCFSSD
         UNOUMU=1
         NEXTLI=1+MOOUBM*UNOUMU
*
*        Boucle sur les lignes de la matrice, comptees en noeuds
*
         DO 200 NUENLI=NEXTLI,NBENLI,UNOUMU
*           Plages de debut et de fin, adresse de debut de ligne
*           et longueur de la ligne courante
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(NUENLI-MOOUBM)
            MCCDLV=MCMATL+LGCUAV*NCPIC2+NCFSSD*(NUENLI-1)
            IF (NUDRPL.GE.1) LGLIGN=NCPICE*(PLAGEL(2,NUDRPL)-LGCUAV)
*
*           Adresse relative dans la matrice de changement de base
            NUESLI=RGESLI(NUENLI)
            ADPRLI=NDPLO2*((NUESLI-1)/UNOUMU)
*
            CALL CEROMA (NPAS  ,NDPLOC,MOOUBM,UNOUMU,NCPICE,RGESCO
     &                  ,NUESLI,MCMATP,NUENLI,ADPRLI
     &                  ,LGLIGN,NUPRPL,NUDRPL,PLAGEL,LGCUAV
     &                  ,MCCDLV,TYMATR,MCMATL,INFSUP,RST,CST)
200      CONTINUE
*
      ENDIF
      CALL PRFXMJ (-1,'*CeRomM*')
                                                                    END !CeRomM
