*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CEROTV (NPAS  ,NDIM  ,NCPICE,NEOUDL,RGESSE
     &                  ,TYVECT,LGVECT,MCVECT,MCMATP,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1997) 
* Derniere modification : D.Martin (3 Avril 1998)
* Version 1.0.0
*  
* Rotation dans un vecteur valeur nodale associe a un inconnue vectorielle
*  
*-- Arguments --
* NPAS   pas de parcours des tableaux des rotations
*        si NPAS=1 ordre naturel, si NPAS=NDIM ordre transpose
* NDIM   dimension d'espace
* NCPICE nombre de composantes de l'inconnue de la cond. essentielle
* NEOUDL indique une numerotation en noeuds ou en d.l. vectoriels
* RGESSE rangs des noeuds de la condition essentielle dans le second membre
* TYVECT type (REEL ou COMPLEXE) du second membre
* LGVECT longueur du vecteur
* MCVECT adresse des coefficients du second membre
* MCMATP adresse du tableau des matrices de changement de base en chaque noeud
* RST,CST super-tableaux habituels
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYVECT*(*)
      INTEGER   NDIM,NCPICE,NPAS,NEOUDL,RGESSE(*),LGVECT,MCVECT,MCMATP
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER   MCPMAT,ADPMA1,ADPMAT,NDIM2,NDIMP,MCVECW,NEVECT,I,K
      REAL      RAUX,RAUX1(3)
      COMPLEX   CAUX,CAUX1(3)
*-----------------------------------------------------------------------
      MCPMAT=MCMATP
      NDIM2 =NDIM*NDIM
      NDIMP =NCPICE*NPAS
      MCVECW=MCVECT
*
      IF (TYVECT(1:1).EQ.'R') THEN
*
*        Boucle sur les noeuds du vecteur
*
         DO 25 NEVECT=1,LGVECT,NEOUDL
            IF (RGESSE(NEVECT).GT.0) THEN
               DO 21 I=1,NCPICE
                  RAUX1(I)=RST(MCVECW-1+I)
21             CONTINUE
               ADPMAT=MCPMAT
*              Rotation proprement dite
               DO 23 I=1,NCPICE
                  RAUX=0.
                  K=1
                  DO 22 ADPMA1=ADPMAT,ADPMAT-1+NDIMP,NPAS
                     RAUX=RAUX+RST(ADPMA1)*RAUX1(K)
                     K=K+1
22                CONTINUE
                  ADPMAT=ADPMAT+NDIM+1-NPAS
                  RST(MCVECW)=RAUX
                  MCVECW=MCVECW+1
23             CONTINUE
               MCPMAT=MCPMAT+NDIM2
            ELSE
               MCVECW=MCVECW+NCPICE
            ENDIF
25       CONTINUE
      ELSE
         DO 45 NEVECT=1,LGVECT,NEOUDL
            IF (RGESSE(NEVECT).GT.0) THEN
               DO 41 I=1,NCPICE
                  CAUX1(I)=CST(MCVECW-1+I)
41             CONTINUE
               ADPMAT=MCPMAT
               DO 43 I=1,NCPICE
                  CAUX=0.
                  K=1
                  DO 42 ADPMA1=ADPMAT,ADPMAT-1+NDIMP,NPAS
                     CAUX=CAUX+RST(ADPMA1)*CAUX1(K)
                     K=K+1
42                CONTINUE
                  ADPMAT=ADPMAT+NDIM+1-NPAS
                  CST(MCVECW)=CAUX
                  MCVECW=MCVECW+1
43             CONTINUE
               MCPMAT=MCPMAT+NDIM2
            ELSE
               MCVECW=MCVECW+NCPICE
            ENDIF
45       CONTINUE
      ENDIF
                                                                    END !CeRotV
