*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CESCMJ (ITYCCE,NUINCE,NUINTR,NUESSE,HOMOGN
     &                  ,NVDSMA,NVDSMB,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Avril 1995)
* Modifications : D.Martin (30 Mars 2005) (30 Decembre 1999)
* Version 2
*  
* Mise a jour de la structure $DSMBL du second membre pour y introduire
* les blocs eventuellement manquant qui apparaissent du fait des
* conditions aux limites essentielles.
* Le numero de terme rajoute est celui de donnee de la condition essentielle.
*  
*-- Arguments d'entree --
* ITYCCE indice de nature de la condition essentielle 
* NUINCE inconnue portant la condition essentielle de Dirichlet
*        ou premiere inconnue de la condition de transmission
* NUINTR ignoree (pour une condition essentielle de Dirichlet)
*        ou seconde inconnue de la condition de transmission
* NUESSE numero de terme de la condition essentielle ou de transmission
* HOMOGN indicateur logique de donnee homogene ou non
* NVDSMA niveau de la structure d'assemblage '$DSMBL' de la matrice
* NVDSMB niveau de la structure d'assemblage '$DSMBL' du second membre
* IRCODE code d'erreur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL HOMOGN
      INTEGER ITYCCE,NUINCE,NUINTR,NUESSE,NVDSMA,NVDSMB,IRCODE
*
      INCLUDE 'ALLOC'
*
      INTEGER INTYKL
      INTEGER MCDSMA,LGEDSM,NBLOCA,INCTRA,NBLOLA,MCDSMB,NBLOCB,INCTRB
     &       ,NBLOLB,LRIPEM,LRIPIM,NULOCA,NULOLA,NUINCO,NUTERM
     &       ,NUTERE,LRIPIE,NUTERT,LRIPIT,MC
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeScmj*')
*
      IRCODE=0
      CALL TBAR2  (ERCODE,'$DSMBL',NVDSMA,MCDSMA,'$DSMBL',NVDSMB,MCDSMB)
      CALL SDEXDB (IST(MCDSMA),LGEDSM,NBLOCA,INCTRA,NBLOLA)             !utilite
      CALL SDEXDB (IST(MCDSMB),LGEDSM,NBLOCB,INCTRB,NBLOLB)             !utilite
      IF (NBLOLA.NE.NBLOLB) THEN
         IRCODE=1
         CALL PRFXMJ (-1,'*CeScmj*')
         RETURN
      ENDIF
* 
*     Introduction dans la structure "multi-inconnues" du second membre
*     des blocs qui apparaissent par elimination de Dirichlet non-homogene.
      IF (.NOT.HOMOGN) THEN
         LRIPEM=LGEDSM
         DO 10 NULOCA=1,NBLOCA
            NUINCO=IST(MCDSMA+LRIPEM+1)
            IF (NUINCO.EQ.NUINCE) THEN
               LRIPIM=LRIPEM
               DO 8 NULOLA=1,NBLOLA
                  NUTERM=IST(MCDSMA+LRIPIM)
                  IF (NUTERM.GT.0) THEN
*                    Le bloc de la matrice "multi-inconnues" existe.
*                    Si la condition essentielle n'est pas homogene,
*                    il faut faire exister le bloc correspondant
*                    dans le second membre
                     MC=MCDSMB+LRIPIM-LRIPEM+LGEDSM
*                    DM : 30 mars 2005, 1 ligne modifiee
*                    IF (IST(MC).LE.0) IST(MC)=NUESSE
                     IF (IST(MC).LE.0) IST(MC)=-1
                  ENDIF
                  LRIPIM=LRIPIM+INCTRA
8              CONTINUE
            ENDIF
            LRIPEM=LRIPEM+NBLOLA*INCTRA
10       CONTINUE
      ENDIF
*
      IF (ITYCCE.EQ.INTYKL ('C.TRAN')) THEN
*
*        Introduction dans la structure "multi-inconnues" du second membre 
*        des blocs qui apparaissent du fait d'une condition de transmission.
         LRIPEM=LGEDSM
         NUTERE=-1
         NUTERT=-1
         DO 20 NULOLA=1,NBLOLB
            NUINCO=IST(MCDSMB+LRIPEM+2)
            IF (NUINCO.EQ.NUINCE) THEN
               NUTERE=IST(MCDSMB+LRIPEM)
               LRIPIE=LRIPEM
            ENDIF
            IF (NUINCO.EQ.NUINTR) THEN
               NUTERT=IST(MCDSMB+LRIPEM)
               LRIPIT=LRIPEM
            ENDIF
            LRIPEM=LRIPEM+INCTRB
20       CONTINUE
*        Les deux blocs concernes du second membre doivent exister 
*        tous les deux des que l'un d'entre eux existe.
*        DM : 30 mars 2005, 2 lignes modifiees
*         IF (NUTERE.EQ.0.AND.NUTERT.GT.0) IST(MCDSMB+LRIPIE)=NUESSE
*         IF (NUTERT.EQ.0.AND.NUTERE.GT.0) IST(MCDSMB+LRIPIT)=NUESSE
         IF (NUTERE.EQ.0.AND.NUTERT.GT.0) IST(MCDSMB+LRIPIE)=-1
         IF (NUTERT.EQ.0.AND.NUTERE.GT.0) IST(MCDSMB+LRIPIT)=-1
      ENDIF
*
      CALL PRFXMJ (-1,'*CeScmj*') 
*-----------------------------------------------------------------------
                                                                    END !Cescmj
