*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CESLCT (NCPICE,NVDUCE,NUKACE,BONDLS,BONNLS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Mars 1995)
* Derniere modification : D.Martin (29 Mai 1998)
* Version 1.0.0
*  
* Creation de la numerotation en d.l. de la condition essentielle avec 
* retrait (mise au signe negatif) des d.l. non-utiles
*
*-- Arguments d'entree --
* NCPICE nombre de composantes de l'inconnue
* NVDUCE niveau de numerotation
* NUKACE numero de type de condition essentielle
* BONDLS nom du tableau de travail contenant la numerotation en d.l.
* BONNLS son niveau
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) BONDLS
      INTEGER       NCPICE,NVDUCE,NUKACE,BONNLS
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCDUCE,NBDUCE,LAWORK,MCWORK,ADWORK
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CeSlct*')
*
      CALL TBAR2  (ERCODE,'#GNEDO',NVDUCE,MCDUCE,BONDLS,BONNLS,MCWORK)
      NBDUCE       =IST(MCDUCE+1)
      IST(MCWORK)  =IST(MCDUCE)
      IST(MCWORK+1)=NBDUCE
      MCDUCE       =MCDUCE+2
      MCWORK       =MCWORK+2
      LAWORK       =MCWORK+1+NBDUCE
*
      IF (NUKACE.EQ.2) THEN
*
*        Cas d'une condition du type: u.n=g
*        le premier d.l. (composante normale) du repere local est concerne
*
         DO 21 ADWORK=MCWORK,LAWORK
            IST(ADWORK)=-IST(MCDUCE)
            MCDUCE     = MCDUCE+1
21       CONTINUE
*        On ne retient que le 1ere composante de chaque noeud
         DO 22 ADWORK=MCWORK,LAWORK,NCPICE
            IST(ADWORK)=-IST(ADWORK)
22       CONTINUE
*
      ELSEIF (NUKACE.EQ.3) THEN
*
*        Cas d'une condition du type: u^n=g 
*        les derniers d.l. (composantes tangentielles) sont concernes
*
         DO 31 ADWORK=MCWORK,LAWORK
            IST(ADWORK)= IST(MCDUCE)
            MCDUCE     = MCDUCE+1
31       CONTINUE
*        On ne retient que les dernieres composantes de chaque noeud
         DO 32 ADWORK=MCWORK,LAWORK,NCPICE
            IST(ADWORK)=-IST(ADWORK)
32       CONTINUE
      ENDIF
*
      CALL PRFXMJ (-1,'*CeSlct*')  
                                                                    END !CeSlct
