*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTCHBL (SENSCH,NCPICE,NBNECE,RANG1,RANG2
     &                  ,NBLIGN,NULAPL,PLAGEL,TYMATR,MCMATR,MCMATL
     &                  ,TYCHMA,MCCHM1,MCCHM2,SKIPN1,SKIPN2,RST,CST
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (23 Aout 2000)
* Version 1.0.1
*
* Changement de variable X = Px dans la partie triangulaire inferieure
* d'un matrice BiMorse pour une condition de transmission.
*  
*-- Arguments --
* SENSCH 1 - multiplication A x P^{-1} ou P x A
*       -1 - multiplication P^{-1} x A ou A x P
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds portant la condition de transmission
* RANG1  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 1 
* RANG2  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 2
* NBLIGN nombre de lignes de la matrice
* NULAPL numeros de derniere plage de chaque ligne
* PLAGEL numeros de colonne de debut de plage et longueurs cumulees
* TYMATR type de declaration de la matrice
* MCMATR adresse de la diagonale de la matrice
* MCMATL adresse du triangle inferieur de la matrice
* TYCHMA type des coefficients caracteristiques du chgmt. de variable 
* MCCHM1 adresse des coefficients caracteristiques du chgmt. de variable inc. 1
* MCCHM2 idem pour l'incoonue 2
* SKIPN1 passage d'un noeud au suivant dans le tableau ci-dessus
*        (0 si matrice constante, NCPICE sinon) pour l'inconnue 1
* SKIPN2 idem pour l'inconnue 2
* RST,CST super-tableau habituels
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYCHMA
      INTEGER       SENSCH,NCPICE,NBNECE,RANG1(*),RANG2(*)
     &             ,NBLIGN,NULAPL(*),PLAGEL(2,*),MCMATR,MCMATL
     &             ,MCCHM1,MCCHM2,SKIPN1,SKIPN2,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       COLON1,MCMAI1,MCK1,MCK1N,PLAGE1,LGCUA1
     &             ,COLON2,MCMAI2,MCK2,MCK2N,PLAGE2
     &             ,MCMATD,NUNECE,IC,LIGNM1,NUPPL2,NUDPL2,LGCUAV
      REAL          RCOEI1,RCOEI2,RP(2,2)
      COMPLEX       CCOEI1,CCOEI2,CP(2,2)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ctchbl*')
*
      IF (NIVIMP.GT.2.AND.IMPFCH.GT.0) WRITE (IMPFCH,10000)
      MCMATD=MCMATR-1
      MCK1=MCCHM1
      MCK2=MCCHM2
*
      IF (TYMATR(1:1).EQ.'R') THEN
         DO 2251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 2250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(1,2)= SENSCH*RST(MCK2N)
               RP(2,1)=-SENSCH*RST(MCK2N)
               LGCUAV=0
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPL(COLON2-2)+1
               NUDPL2=NULAPL(COLON2-1)
               IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*
*              Adresse de a_{l,l}
               MCMAI2=MCMATD+COLON2
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                     ,PLAGE1,*2235)
*              Adresse de a_{l,k}
               LGCUA1=0
               IF (PLAGE1.GT.1) LGCUA1=PLAGEL(2,PLAGE1-1)              
               MCMAI1=MCMATL+LGCUA1+COLON1-PLAGEL(1,PLAGE1)
               RCOEI1=RST(MCMAI1)
               RCOEI2=RST(MCMAI2)
               RST(MCMAI1)=RCOEI1*RP(1,1)+RCOEI2*RP(2,1)
               RST(MCMAI2)=RCOEI1*RP(1,2)+RCOEI2*RP(2,2)
2235           CONTINUE
*
               DO 2236 LIGNM1=COLON2,NBLIGN-1
*                 Plages de la ligne
                  NUPPL2=NUDPL2+1
                  NUDPL2=NULAPL(LIGNM1)
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*                 Plage de la ligne contenant la colonne k
                  CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE1,*2236)
*                 Adresse de a_{ligne,k}              
                  NUPPL2=PLAGE1
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
                  MCMAI1=MCMATL+LGCUAV+COLON1-PLAGEL(1,PLAGE1)
*                 Plage de la ligne contenant la colonne l
                  CALL DIKLPL (COLON2,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE2,*2236)
*                 Adresse de a_{ligne,l}
                  IF (PLAGE2.GT.1) LGCUAV=PLAGEL(2,PLAGE2-1)              
                  MCMAI2=MCMATL+LGCUAV+COLON2-PLAGEL(1,PLAGE2)
                  RCOEI1=RST(MCMAI1)
                  RCOEI2=RST(MCMAI2)
                  RST(MCMAI1)=RCOEI1*RP(1,1)+RCOEI2*RP(2,1)
                  RST(MCMAI2)=RCOEI1*RP(1,2)+RCOEI2*RP(2,2)
2236           CONTINUE
               IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &            WRITE (IMPFCH,10001) NUNECE,IC,COLON1,COLON2
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
2250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
2251     CONTINUE
      ELSEIF (TYCHMA(1:1).EQ.'R') THEN
         DO 4251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(1,2)= SENSCH*RST(MCK2N)
               RP(2,1)=-SENSCH*RST(MCK2N)
               LGCUAV=0
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPL(COLON2-2)+1
               NUDPL2=NULAPL(COLON2-1)
               IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*
*              Adresse de a_{l,l}
               MCMAI2=MCMATD+COLON2
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                     ,PLAGE1,*4235)
*              Adresse de a_{l,k}
               LGCUA1=0
               IF (PLAGE1.GT.1) LGCUA1=PLAGEL(2,PLAGE1-1)              
               MCMAI1=MCMATL+LGCUA1+COLON1-PLAGEL(1,PLAGE1)
               CCOEI1=CST(MCMAI1)
               CCOEI2=CST(MCMAI2)
               CST(MCMAI1)=CCOEI1*RP(1,1)+CCOEI2*RP(2,1)
               CST(MCMAI2)=CCOEI1*RP(1,2)+CCOEI2*RP(2,2)
4235           CONTINUE
*
               DO 4236 LIGNM1=COLON2,NBLIGN-1
*                 Plages de la ligne
                  NUPPL2=NUDPL2+1
                  NUDPL2=NULAPL(LIGNM1)
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*                 Plage de la ligne contenant la colonne k
                  CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE1,*4236)
*                 Adresse de a_{ligne,k}
                  NUPPL2=PLAGE1
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)              
                  MCMAI1=MCMATL+LGCUAV+COLON1-PLAGEL(1,PLAGE1)
*                 Plage de la ligne contenant la colonne l
                  CALL DIKLPL (COLON2,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE2,*4236)
*                 Adresse de a_{ligne,l}
                  IF (PLAGE2.GT.1) LGCUAV=PLAGEL(2,PLAGE2-1)              
                  MCMAI2=MCMATL+LGCUAV+COLON2-PLAGEL(1,PLAGE2)
                  CCOEI1=CST(MCMAI1)
                  CCOEI2=CST(MCMAI2)
                  CST(MCMAI1)=CCOEI1*RP(1,1)+CCOEI2*RP(2,1)
                  CST(MCMAI2)=CCOEI1*RP(1,2)+CCOEI2*RP(2,2)
4236           CONTINUE
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4251     CONTINUE
      ELSE
         DO 4451  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4450 IC=1,NCPICE
               CP(1,1)= CST(MCK1N)
               CP(2,2)= CST(MCK1N)
               CP(1,2)= SENSCH*CST(MCK2N)
               CP(2,1)=-SENSCH*CST(MCK2N)
               LGCUAV=0
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPL(COLON2-2)+1
               NUDPL2=NULAPL(COLON2-1)
               IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*
*              Adresse de a_{l,l}
               MCMAI2=MCMATD+COLON2
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                     ,PLAGE1,*4435)
*              Adresse de a_{l,k}
               LGCUA1=0
               IF (PLAGE1.GT.1) LGCUA1=PLAGEL(2,PLAGE1-1)              
               MCMAI1=MCMATL+LGCUA1+COLON1-PLAGEL(1,PLAGE1)
               CCOEI1=CST(MCMAI1)
               CCOEI2=CST(MCMAI2)
               CST(MCMAI1)=CCOEI1*CP(1,1)+CCOEI2*CP(2,1)
               CST(MCMAI2)=CCOEI1*CP(1,2)+CCOEI2*CP(2,2)
4435           CONTINUE
*
               DO 4436 LIGNM1=COLON2,NBLIGN-1
*                 Plages de la ligne
                  NUPPL2=NUDPL2+1
                  NUDPL2=NULAPL(LIGNM1)
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)
*                 Plage de la ligne contenant la colonne k
                  CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE1,*4436)
*                 Adresse de a_{ligne,k}
                  NUPPL2=PLAGE1
                  IF (NUPPL2.GT.1) LGCUAV=PLAGEL(2,NUPPL2-1)            
                  MCMAI1=MCMATL+LGCUAV+COLON1-PLAGEL(1,PLAGE1)
*                 Plage de la ligne contenant la colonne l
                  CALL DIKLPL (COLON2,NUPPL2,NUDPL2,LGCUAV,PLAGEL
     &                        ,PLAGE2,*4436)
*                 Adresse de a_{ligne,l}
                  IF (PLAGE2.GT.1) LGCUAV=PLAGEL(2,PLAGE2-1)              
                  MCMAI2=MCMATL+LGCUAV+COLON2-PLAGEL(1,PLAGE2)
                  CCOEI1=CST(MCMAI1)
                  CCOEI2=CST(MCMAI2)
                  CST(MCMAI1)=CCOEI1*CP(1,1)+CCOEI2*CP(2,1)
                  CST(MCMAI2)=CCOEI1*CP(1,2)+CCOEI2*CP(2,2)
4436           CONTINUE
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4450        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4451     CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*Ctchbl*')
*-----------------------------------------------------------------------
10000 FORMAT (T40,' Noeud D.L. D.L.Inc.1 D.L.Inc.2')
10001 FORMAT (T40,I6,I5,2I10)
      END
