*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTCHBM (SENSCH,NCPICE,NBNECE,RANG1,RANG2,NULAPL
     &                  ,PLAGEL,NULAPU,PLAGEU,TYMATR,MCMATL,MCMATU
     &                  ,TYCHMA,MCCHM1,MCCHM2,SKIPN1,SKIPN2
     &                  ,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (23 Aout 2000)
* Version 1.0.1
*
* Changement de variable simultane dans les parties triangulaires inferieure
* et superieure d'une matrice BiMorse pour une condition de transmission
*  
*-- Arguments --
* SENSCH 1 : multiplication A x P^{-1} ou P x A = (A^t x P^t)^t
*       -1 : multiplication A x P ou P^{-1} x A
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds portant la condition de transmission
* RANG1  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 1 
* RANG2  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 2
* NULAPL numeros de derniere plage de chaque ligne
* PLAGEL numeros de colonne de debut de plage et longueurs cumulees
* NULAPU numeros de derniere plage de chaque colonne
* PLAGEU numeros de ligne de debut de plage et longueurs cumulees
* TYMATR type de declaration de la matrice
* MCMATL Adresse du triangle inferieur de la matrice
* MCMATU Adresse du triangle superieur de la matrice
* TYCHMA type des coefficients caracteristiques du chgmt. de variable
* MCCHM1 adresse des coefficients caracteristiques du chgmt. de variable inc. 1
* MCCHM2 idem pour l'inconnue 2
* SKIPN1 passage d'un noeud au suivant dans le tableau ci-dessus
*        (0 si matrice constante, NCPICE sinon) pour l'inconnue 1
* SKIPN2 idem pour l'inconnue 2
* RST,CST Super-tableau habituels
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYCHMA 
      INTEGER       SENSCH,NCPICE,NBNECE,RANG1(*),RANG2(*)
     &             ,NULAPL(*),PLAGEL(2,*),NULAPU(*),PLAGEU(2,*)
     &             ,MCMATL,MCMATU,MCCHM1,MCCHM2,SKIPN1,SKIPN2
     &             ,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       COLON1,MCMAI1,MCK1,MCK1N,PLAGE1
     &             ,COLON2,MCMAI2,MCK2,MCK2N,PLAGE2,NUPPC2,NUDPC2,LGCUC2
     &             ,NUNECE,IC,LIGNE,LIGNE1,NUPPLI,NUDPLI,LGCUCI,LGPLI
      REAL          RCOEI1,RCOEI2,RP(2,2)
      COMPLEX       CCOEI1,CCOEI2,CP(2,2)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ctchbm*')
*
      IF (NIVIMP.GT.2.AND.IMPFCH.GT.0) WRITE (IMPFCH,10000)
      MCK1=MCCHM1
      MCK2=MCCHM2
*
      IF (TYMATR(1:1).EQ.'R') THEN
         DO 2251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 2250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(1,2)= SENSCH*RST(MCK2N)
               RP(2,1)=-SENSCH*RST(MCK2N)
*              Plages de la colonne l (partie triang. sup.)
*              (ici, on a COLON2 > COLON1 >= 1)
               NUPPC2=NULAPU(COLON2-2)+1
               NUDPC2=NULAPU(COLON2-1)
               LGCUC2=0
               IF (NUPPC2.GT.1) LGCUC2=PLAGEU(2,NUPPC2-1)
*              Adresse du premier coeff. de la colonne l (partie triang. sup.)
               MCMAI2=MCMATU+LGCUC2
               DO 2233 PLAGE2=NUPPC2,NUDPC2
*                 Ligne du premier coeff de la colonne l (partie triang. sup.)
                  LIGNE1=PLAGEU(1,PLAGE2)
*                 Nombre de coeffs de la plage de la colonne l 
                  LGPLI =PLAGEU(2,PLAGE2)-LGCUC2
                  DO 2231 LIGNE=LIGNE1,LIGNE1-1+LGPLI
*                    Plages de la ligne (partie triang. inf.)
                     NUPPLI=1
                     IF (LIGNE.GT.2) NUPPLI=NULAPL(LIGNE-2)+1
                     NUDPLI=0
                     IF (LIGNE.GT.1) NUDPLI=NULAPL(LIGNE-1)
                     LGCUCI=0
                     IF (NUPPLI.GT.1) LGCUCI=PLAGEL(2,NUPPLI-1)
                     CALL DIKLPL (COLON1,NUPPLI,NUDPLI,LGCUCI,PLAGEL
     &                           ,PLAGE1,*2230)
                     IF (PLAGE1.GT.1) LGCUCI=PLAGEL(2,PLAGE1-1)
*                    Adresse de a_{i,k} (partie triang. inf.)
                     MCMAI1=MCMATL+LGCUCI+COLON1-PLAGEL(1,PLAGE1)
*
                     RCOEI1=RST(MCMAI1)
                     RCOEI2=RST(MCMAI2)
                     RST(MCMAI1)=RCOEI1*RP(1,1)+RCOEI2*RP(2,1)
                     RST(MCMAI2)=RCOEI1*RP(1,2)+RCOEI2*RP(2,2)
2230                 MCMAI2=MCMAI2+1
2231              CONTINUE
                  LGCUC2=LGCUC2+LGPLI
2233           CONTINUE
               IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &            WRITE (IMPFCH,10001) NUNECE,IC,COLON1,COLON2
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
2250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
2251     CONTINUE
      ELSEIF (TYCHMA(1:1).EQ.'R') THEN
         DO 4251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK2N)
               RP(1,2)= SENSCH*RST(MCK1N)
               RP(2,1)=-SENSCH*RST(MCK2N)
*              Plages de la colonne l (partie triang. sup.)
*              (ici, on a COLON2 > COLON1 >= 1)
               NUPPC2=NULAPU(COLON2-2)+1
               NUDPC2=NULAPU(COLON2-1)
               LGCUC2=0
               IF (NUPPC2.GT.1) LGCUC2=PLAGEU(2,NUPPC2-1)
*              Adresse du premier coeff. de la colonne l (partie triang. sup.)
               MCMAI2=MCMATU+LGCUC2
               DO 4233 PLAGE2=NUPPC2,NUDPC2
*                 Ligne du premier coeff de la colonne l (partie triang. sup.)
                  LIGNE1=PLAGEU(1,PLAGE2)
*                 Nombre de coeffs de la plage de la colonne l 
                  LGPLI =PLAGEU(2,PLAGE2)-LGCUC2
                  DO 4231 LIGNE=LIGNE1,LIGNE1-1+LGPLI
*                    Plages de la ligne (partie triang. inf.)
                     NUPPLI=1
                     IF (LIGNE.GT.2) NUPPLI=NULAPL(LIGNE-2)+1
                     NUDPLI=0
                     IF (LIGNE.GT.1) NUDPLI=NULAPL(LIGNE-1)
                     LGCUCI=0
                     IF (NUPPLI.GT.1) LGCUCI=PLAGEL(2,NUPPLI-1)
                     CALL DIKLPL (COLON1,NUPPLI,NUDPLI,LGCUCI,PLAGEL
     &                           ,PLAGE1,*4230)
                     IF (PLAGE1.GT.1) LGCUCI=PLAGEL(2,PLAGE1-1)
*                    Adresse de a_{i,k} (partie triang. inf.)
                     MCMAI1=MCMATL+LGCUCI+COLON1-PLAGEL(1,PLAGE1)
*
                     CCOEI1=CST(MCMAI1)
                     CCOEI2=CST(MCMAI2)
                     CST(MCMAI1)=CCOEI1*RP(1,1)+CCOEI2*RP(2,1)
                     CST(MCMAI2)=CCOEI1*RP(1,2)+CCOEI2*RP(2,2)
4230                 MCMAI2=MCMAI2+1
4231              CONTINUE
                  LGCUC2=LGCUC2+LGPLI
4233           CONTINUE
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4251     CONTINUE
      ELSE
         DO 4451  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4450 IC=1,NCPICE
               CP(1,1)= CST(MCK1N)
               CP(2,2)= CST(MCK2N)
               CP(1,2)= SENSCH*CST(MCK1N)
               CP(2,1)=-SENSCH*CST(MCK2N)
*              Plages de la colonne l (partie triang. sup.)
*              (ici, on a COLON2 > COLON1 >= 1)
               NUPPC2=NULAPU(COLON2-2)+1
               NUDPC2=NULAPU(COLON2-1)
               LGCUC2=0
               IF (NUPPC2.GT.1) LGCUC2=PLAGEU(2,NUPPC2-1)
*              Adresse du premier coeff. de la colonne l (partie triang. sup.)
               MCMAI2=MCMATU+LGCUC2
               DO 4433 PLAGE2=NUPPC2,NUDPC2
*                 Ligne du premier coeff de la colonne l (partie triang. sup.)
                  LIGNE1=PLAGEU(1,PLAGE2)
*                 Nombre de coeffs de la plage de la colonne l 
                  LGPLI =PLAGEU(2,PLAGE2)-LGCUC2
                  DO 4431 LIGNE=LIGNE1,LIGNE1-1+LGPLI
*                    Plages de la ligne (partie triang. inf.)
                     NUPPLI=1
                     IF (LIGNE.GT.2) NUPPLI=NULAPL(LIGNE-2)+1
                     NUDPLI=0
                     IF (LIGNE.GT.1) NUDPLI=NULAPL(LIGNE-1)
                     LGCUCI=0
                     IF (NUPPLI.GT.1) LGCUCI=PLAGEL(2,NUPPLI-1)
                     CALL DIKLPL (COLON1,NUPPLI,NUDPLI,LGCUCI,PLAGEL
     &                           ,PLAGE1,*4430)
                     IF (PLAGE1.GT.1) LGCUCI=PLAGEL(2,PLAGE1-1)
*                    Adresse de a_{i,k} (partie triang. inf.)
                     MCMAI1=MCMATL+LGCUCI+COLON1-PLAGEL(1,PLAGE1)
*
                     CCOEI1=CST(MCMAI1)
                     CCOEI2=CST(MCMAI2)
                     CST(MCMAI1)=CCOEI1*CP(1,1)+CCOEI2*CP(2,1)
                     CST(MCMAI2)=CCOEI1*CP(1,2)+CCOEI2*CP(2,2)
4430                 MCMAI2=MCMAI2+1
4431              CONTINUE
                  LGCUC2=LGCUC2+LGPLI
4433           CONTINUE
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4450        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4451     CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*Ctchbm*')
*-----------------------------------------------------------------------
10000 FORMAT (T40,' Noeud D.L. D.L.Inc.1 D.L.Inc.2')
10001 FORMAT (T40,I6,I5,2I10)
      END
