*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTCHBU (SENSCH,NCPICE,NBNECE,RANG1,RANG2
     &                  ,NULAPU,PLAGEU,TYMATR,MCMATR,MCMATU
     &                  ,TYCHMA,MCCHM1,MCCHM2,SKIPN1,SKIPN2,RST,CST
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (23 Aout 2000)
* Version 1.0.1
*
* Changement de variable U = Pu dans la partie triangulaire superieure 
* d'un terme matriciel BiMorse pour une condition de transmission
*  
*-- Arguments --
* SENSCH 1 - multiplication A x P^{-1} ou P x A
*       -1 - multiplication P^{-1} x A ou A x P
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds portant la condition de transmission
* RANG1  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 1 
* RANG2  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 2
* NULAPU numeros de derniere plage de chaque colonne
* PLAGEU numeros de ligne de debut de plage et longueurs cumulees
* TYMATR type de declaration de la matrice
* MCMATR adresse de la diagonale de la matrice
* MCMATU adresse du triangle superieur de la matrice
* TYCHMA type des coefficients caracteristiques du chgmt. de variable
* MCCHM1 adresse des coefficients caracteristiques du chgmt. de variable inc. 1
* MCCHM2 idem pour l'incoonue 2
* SKIPN1 passage d'un noeud au suivant dans le tableau ci-dessus
*        (0 si matrice constante, NCPICE sinon) pour l'inconnue 1
* SKIPN2 idem pour l'inconnue 2
* RST,CST super-tableau habituels
* NIVIMP niveau d'impression du terme condition essentielle
* IMPFCH numero du fichier pour impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYCHMA
      INTEGER       SENSCH,NCPICE,NBNECE,RANG1(*),RANG2(*)
     &             ,NULAPU(*),PLAGEU(2,*),MCMATR,MCMATU
     &             ,MCCHM1,MCCHM2,SKIPN1,SKIPN2,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       COLON1,MCMAI1,MCK1,MCK1N,NUPPL1,NUDPL1,PLAGE1,LGCUA1
     &             ,COLON2,MCMAI2,MCK2,MCK2N,NUPPL2,NUDPL2,PLAGE2,LGCUA2
     &             ,MCMATD,NUNECE,IC,LIGNE,LIGNE1,LGPLL
      REAL          RCOEI1,RCOEI2,RP(2,2)
      COMPLEX       CCOEI1,CCOEI2,CP(2,2)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ctchbu*')
*
      IF (NIVIMP.GT.2.AND.IMPFCH.GT.0) WRITE (IMPFCH,10000)
      MCMATD=MCMATR-1
      MCK1=MCCHM1
      MCK2=MCCHM2
*
      NUPPL1=1
      IF (TYMATR(1:1).EQ.'R') THEN
         DO 2251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 2250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(1,2)= SENSCH*RST(MCK2N)
               RP(2,1)=-SENSCH*RST(MCK2N)
*              plages de la colonne l dans la partie triangulaire superieure
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPU(COLON2-2)+1
               NUDPL2=NULAPU(COLON2-1)
               LGCUA2=0
               IF (NUPPL2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*              plages de la colonne k dans la partie triangulaire superieure
               IF (COLON1.GT.2) NUPPL1=NULAPU(COLON1-2)+1
               NUDPL1=0
               IF (COLON1.GT.1) NUDPL1=NULAPU(COLON1-1)
               LGCUA1=0
               IF (NUPPL1.GT.1) LGCUA1=PLAGEU(2,NUPPL1-1)
*              adresse du 1er coeff. de la colonne k
               MCMAI1=MCMATU+LGCUA1
*              boucle sur les plages de la colonne k
               DO 2233 PLAGE1=NUPPL1,NUDPL1
*                 numero de ligne du 1er coeff. de la plage de la colonne k
                  LIGNE1=PLAGEU(1,PLAGE1)
*                 nombre de coefficients de la plage de la colonne k
                  LGPLL =PLAGEU(2,PLAGE1)-LGCUA1
*                 recherche de la ligne LIGNE1 dans la colonne l
                  CALL DIKLPL (LIGNE1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                        ,PLAGE2,*2233)
                  NUPPL2=PLAGE2
                  IF (PLAGE2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*                 adresse de a_{ligne,l}
                  MCMAI2=MCMATU+LGCUA2+LIGNE1-PLAGEU(1,PLAGE2)
                  DO 2231 LIGNE=LIGNE1,LIGNE1-1+LGPLL
                     RCOEI1=RST(MCMAI1)
                     RCOEI2=RST(MCMAI2)
                     RST(MCMAI1)=RCOEI1*RP(1,1)+RCOEI2*RP(2,1)
                     RST(MCMAI2)=RCOEI1*RP(1,2)+RCOEI2*RP(2,2)
                     MCMAI1=MCMAI1+1
                     MCMAI2=MCMAI2+1
2231              CONTINUE  
                  LGCUA1=LGCUA1+LGPLL
2233           CONTINUE
*
*              adresse de a_{k,k}
               MCMAI1=MCMATD+COLON1
*              recherche de la ligne k dans la colonne l
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                     ,PLAGE2,*2234)
               IF (PLAGE2.GT.1) LGCUA2=PLAGEU(2,PLAGE2-1)
*              adresse de a_{k,l}
               MCMAI2=MCMATU+LGCUA2+COLON1-PLAGEU(1,PLAGE2)
               RCOEI1=RST(MCMAI1)
               RCOEI2=RST(MCMAI2)
               RST(MCMAI1)=RCOEI1*RP(1,1)+RCOEI2*RP(2,1)
               RST(MCMAI2)=RCOEI1*RP(1,2)+RCOEI2*RP(2,2)
2234           CONTINUE
*
               IF (NIVIMP.GT.2.AND.IMPFCH.GT.0)
     &            WRITE (IMPFCH,10001) NUNECE,IC,COLON1,COLON2
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
2250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
2251     CONTINUE
      ELSEIF (TYCHMA(1:1).EQ.'R') THEN
         DO 4251  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4250 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(1,2)= SENSCH*RST(MCK2N)
               RP(2,1)=-SENSCH*RST(MCK2N)
*              plages de la colonne l dans la partie triangulaire superieure
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPU(COLON2-2)+1
               NUDPL2=NULAPU(COLON2-1)
               LGCUA2=0
               IF (NUPPL2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*              plages de la colonne k dans la partie triangulaire superieure
               IF (COLON1.GT.2) NUPPL1=NULAPU(COLON1-2)+1
               NUDPL1=0
               IF (COLON1.GT.1) NUDPL1=NULAPU(COLON1-1)
               LGCUA1=0
               IF (NUPPL1.GT.1) LGCUA1=PLAGEU(2,NUPPL1-1)
*              adresse du 1er coeff. de la colonne k
               MCMAI1=MCMATU+LGCUA1
*              boucle sur les plages de la colonne k
               DO 4233 PLAGE1=NUPPL1,NUDPL1
*                 numero de ligne du 1er coeff. de la plage de la colonne k
                  LIGNE1=PLAGEU(1,PLAGE1)
*                 nombre de coefficients de la plage de la colonne k
                  LGPLL =PLAGEU(2,PLAGE1)-LGCUA1
*                 recherche de la ligne ligne dans la colonne l
                  CALL DIKLPL (LIGNE1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                        ,PLAGE2,*4233)
                  NUPPL2=PLAGE2
                  IF (NUPPL2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*                 adresse de a_{ligne1,l}
                  MCMAI2=MCMATU+LGCUA2+LIGNE1-PLAGEU(1,PLAGE2)
                  DO 4231 LIGNE=LIGNE1,LIGNE1-1+LGPLL
                     CCOEI1=CST(MCMAI1)
                     CCOEI2=CST(MCMAI2)
                     CST(MCMAI1)=CCOEI1*RP(1,1)+CCOEI2*RP(2,1)
                     CST(MCMAI2)=CCOEI1*RP(1,2)+CCOEI2*RP(2,2)
                     MCMAI1=MCMAI1+1
                     MCMAI2=MCMAI2+1
4231              CONTINUE  
                  LGCUA1=LGCUA1+LGPLL
4233           CONTINUE
*
*              adresse de a_{k,k}
               MCMAI1=MCMATD+COLON1
*              recherche de la ligne k dans la colonne l
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                     ,PLAGE2,*4234)
               IF (PLAGE2.GT.1) LGCUA2=PLAGEU(2,PLAGE2-1)
*              adresse de a_{k,l}
               MCMAI2=MCMATU+LGCUA2+COLON1-PLAGEU(1,PLAGE2)
               CCOEI1=CST(MCMAI1)
               CCOEI2=CST(MCMAI2)
               CST(MCMAI1)=CCOEI1*RP(1,1)+CCOEI2*RP(2,1)
               CST(MCMAI2)=CCOEI1*RP(1,2)+CCOEI2*RP(2,2)
4234           CONTINUE
*
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4250        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4251     CONTINUE
      ELSE
         DO 4451  NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            COLON1=RANG1(NUNECE)
            COLON2=RANG2(NUNECE)
            DO 4450 IC=1,NCPICE
               CP(1,1)= CST(MCK1N)
               CP(2,2)= CST(MCK1N)
               CP(1,2)= SENSCH*CST(MCK2N)
               CP(2,1)=-SENSCH*CST(MCK2N)
*              plages de la colonne l dans la partie triangulaire superieure
*              (ici, on a COLON2 > 2 > COLON1 >= 1)
               NUPPL2=NULAPU(COLON2-2)+1
               NUDPL2=NULAPU(COLON2-1)
               LGCUA2=0
               IF (NUPPL2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*              plages de la colonne k dans la partie triangulaire superieure
               IF (COLON1.GT.2) NUPPL1=NULAPU(COLON1-2)+1
               NUDPL1=0
               IF (COLON1.GT.1) NUDPL1=NULAPU(COLON1-1)
               LGCUA1=0
               IF (NUPPL1.GT.1) LGCUA1=PLAGEU(2,NUPPL1-1)
*              adresse du 1er coeff. de la colonne k
               MCMAI1=MCMATU+LGCUA1
*              boucle sur les plages de la colonne k
               DO 4433 PLAGE1=NUPPL1,NUDPL1
*                 numero de ligne du 1er coeff. de la plage de la colonne k
                  LIGNE1=PLAGEU(1,PLAGE1)
*                 nombre de coefficients de la plage de la colonne k
                  LGPLL =PLAGEU(2,PLAGE1)-LGCUA1
*                 recherche de la ligne ligne dans la colonne l
                  CALL DIKLPL (LIGNE1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                        ,PLAGE2,*4433)
                  NUPPL2=PLAGE2
                  IF (NUPPL2.GT.1) LGCUA2=PLAGEU(2,NUPPL2-1)
*                 adresse de a_{ligne1,l}
                  MCMAI2=MCMATU+LGCUA2+LIGNE1-PLAGEU(1,PLAGE2)
                  DO 4431 LIGNE=LIGNE1,LIGNE1-1+LGPLL
                     CCOEI1=CST(MCMAI1)
                     CCOEI2=CST(MCMAI2)
                     CST(MCMAI1)=CCOEI1*CP(1,1)+CCOEI2*CP(2,1)
                     CST(MCMAI2)=CCOEI1*CP(1,2)+CCOEI2*CP(2,2)
                     MCMAI1=MCMAI1+1
                     MCMAI2=MCMAI2+1
4431              CONTINUE  
                  LGCUA1=LGCUA1+LGPLL
4433           CONTINUE
*              remplace ctchbd
*              adresse de a_{k,k}
               MCMAI1=MCMATD+COLON1
*              recherche de la ligne k dans la colonne l
               CALL DIKLPL (COLON1,NUPPL2,NUDPL2,LGCUA2,PLAGEU
     &                     ,PLAGE2,*4434)
               IF (PLAGE2.GT.1) LGCUA2=PLAGEU(2,PLAGE2-1)
*              adresse de a_{k,l}
               MCMAI2=MCMATU+LGCUA2+COLON1-PLAGEU(1,PLAGE2)
               CCOEI1=CST(MCMAI1)
               CCOEI2=CST(MCMAI2)
               CST(MCMAI1)=CCOEI1*CP(1,1)+CCOEI2*CP(2,1)
               CST(MCMAI2)=CCOEI1*CP(1,2)+CCOEI2*CP(2,2)
4434           CONTINUE
*
               COLON1=COLON1+1
               COLON2=COLON2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4450        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4451     CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*Ctchbu*')
*-----------------------------------------------------------------------
10000 FORMAT (T40,' Noeud D.L. D.L.Inc.1 D.L.Inc.2')
10001 FORMAT (T40,I6,I5,2I10)
      END
