*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTCHDO (SENSCH,NCPICE,NBNECE,NBDOAS,TYDONG,NBVANG
     &                  ,MCDONG,TYCHMA,MCCHM3,SKIPNE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 2000)
* Derniere modification : D.Martin (30 Mars 2004)
* Version 1.3
*
* Mise a jour de la donnee g d'une condition de transmission de la forme
*                        k_1 u_1 = k_2 u_2 + g
* pour prendre en compte le changement de variable U = P.u (par noeud)
*
*           ( (k_1^2+k_2^2)^{-1/2)*k_1   -(k_1^2+k_2^2)^{-1/2}*k_2 )
* avec  P = (                                                      ) = P^t^{-1}
*           ( (k_1^2+k_2^2)^{-1/2)*k_2    (k_1^2+k_2^2)^{-1/2}*k_1 )
*
* La donnee g devient g/sqrt(k_1^2+k_2^2) en chaque noeud pour SENSCH=1
* Elle retrouve ses valeurs initiales si SENSCH=-1
*
*-- Arguments d'entree --
* SENSCH +1 si changement de variables        (calcul de P A x P^{-1})
*        -1 si retour aux variables initiales (calcul de P^{-1} A' x P)
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de la condition de transmission
* NBDOAS nombre de donnees affectees a la condition de transmission (ici 3)
* TYDONG type, reel ou complexe, de la donnee affectee g
* NBVANG nombres de valeurs par noeud pour la donnee g
* MCDONG adresse de la donnee g
* TYCHMA type, reel ou complexe, des matrices P de changement de variable
*        resulte des type de declaration de k_1 et k_2
* MCCHM3 adresse du tableau de travail contenant les modules de normalisation
*        des coefficients des matrices de changement de base
* SKIPNE passage d'un noeud au suivant dans les tableaux ci-dessus
*        (0 si matrice constante, NCPICE si diagonale, NCPICE*NCPICE sinon)
* RST,CST super-tableaux version reelle ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYCHMA,TYDONG
      INTEGER       SENSCH,NCPICE,NBNECE,NBDOAS,NBVANG,MCDONG
     &             ,SKIPNE(*),MCCHM3
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCG,MCGN,MC3,MC3N,NBNECH,NUDOAS,SKIPPP
     &             ,MMCK,INCK,INCIN,I,J
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ctchdo*')
*
*     Adresse contenant la donnee g de la condition aux limites
*
      MCG=MCDONG
      MC3=MCCHM3
*     Incrment de parcours dans le tableau de normalisation
*     c-a-d contenant les valeurs (k_1^2+k_2^2)^{-1/2)
      SKIPPP=MAX (SKIPNE(1),SKIPNE(2))
*
*     NBNECH nombre noeuds portant les valeurs de la donnee g
*     (1 s'il s'agit d'une constante, 
*      nombre de noeuds portant la Condition Essentielle sinon)
*
      NBNECH=NBNECE
      IF (SKIPNE(NBDOAS).EQ.0) NBNECH=1
*
      IF (SENSCH.EQ.1) THEN
*
*        Transformation des valeurs de la donnee g due au changement de variables
*
         IF (TYCHMA(1:1).EQ.'R') THEN
            IF (TYDONG(1:1).EQ.'R') THEN
               DO 1221 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 1220 J=1,NBVANG
                     RST(MCGN)=RST(MCGN)*RST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
1220              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
1221           CONTINUE
            ELSEIF (TYDONG(1:1).EQ.'C') THEN
               DO 1241 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 1240 J=1,NBVANG
                     CST(MCGN)=CST(MCGN)*RST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
1240              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
1241           CONTINUE
            ENDIF
         ELSEIF (TYCHMA(1:1).EQ.'C') THEN
            IF (TYDONG(1:1).EQ.'R') THEN
               DO 1421 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 1420 J=1,NBVANG
                     RST(MCGN)=RST(MCGN)*CST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
1420              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
1421           CONTINUE
            ELSEIF (TYDONG(1:1).EQ.'C') THEN
               DO 1441 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 1440 J=1,NBVANG
                     CST(MCGN)=CST(MCGN)*CST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
1440              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
1441           CONTINUE
            ENDIF
         ENDIF
*
      ELSE
*
*        Retour aux valeurs initiales de la donnee g
*
         IF (TYCHMA(1:1).EQ.'R') THEN
            IF (TYDONG(1:1).EQ.'R') THEN
               DO 3221 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 3220 J=1,NBVANG
                     RST(MCGN)=RST(MCGN)/RST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
3220              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
3221           CONTINUE
            ELSEIF (TYDONG(1:1).EQ.'C') THEN
               DO 3241 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 3240 J=1,NBVANG
                     CST(MCGN)=CST(MCGN)/RST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
3240              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
3241           CONTINUE
            ENDIF
         ELSEIF (TYCHMA(1:1).EQ.'C') THEN
            IF (TYDONG(1:1).EQ.'R') THEN
               DO 3421 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 3420 J=1,NBVANG
                     RST(MCGN)=RST(MCGN)/CST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
3420              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
3421           CONTINUE
            ELSEIF (TYDONG(1:1).EQ.'C') THEN
               DO 3441 I=1,NBNECH
                  MC3N=MC3
                  MCGN=MCG
                  DO 3440 J=1,NBVANG
                     CST(MCGN)=CST(MCGN)/CST(MC3N)
                     MC3N=MC3N+1
                     MCGN=MCGN+1
3440              CONTINUE
                  MC3=MC3+SKIPPP
                  MCG=MCG+NBVANG
3441           CONTINUE
            ENDIF
         ENDIF
      ENDIF
*
      CALL PRFXMJ (-1,'*Ctchdo*')
      END
