*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTCHSC (SENSCH,NCPICE,NBNECE,RANG1,RANG2
     &                  ,TYVECT,MCVECT,NBVECT,LGVECT
     &                  ,TYCHMA,MCCHM1,MCCHM2,SKIPN1,SKIPN2,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1998)
* Derniere modification : D.Martin (6 Mai 1999)
* Version 1.0.1
*
* Changement de variable dans le vecteur (second membre) pour une condition
* de transmission
*  
*-- Arguments --
* SENSCH 1 - multiplication P x B
*       -1 - multiplication P^{-1} x B 
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds portant la condition de transmission
* RANG1  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 1 
* RANG2  rangs en colonne/ligne des d.l. de transmission pour l'inconnue 2
* TYVECT type de declaration du second membre
* MCVECT adresse du vecteur multi-colonnes
* NBVECT nombre de colonnes du vecteur multi-colonnes
* LGVECT nombre de lignes du vecteur multi-colonnes
* TYCHMA type des coefficients caracteristiques du chgmt. de variable
* MCCHM1 adresse des coefficients caracteristiques du chgmt. de variable inc. 1
* MCCHM2 idem pour l'inconnue 2
* SKIPN1 passage d'un noeud au suivant dans le tableau ci-dessus
*        (0 si matrice constante, NCPICE sinon) pour l'inconnue 1
* SKIPN2 idem pour l'inconnue 2
* RST,CST Super-tableau habituels
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYVECT,TYCHMA
      INTEGER       SENSCH,NCPICE,NBNECE,RANG1(*),RANG2(*)
     &             ,MCVECT,NBVECT,LGVECT
     &             ,MCCHM1,MCCHM2,SKIPN1,SKIPN2
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCVEC1,ADVEC1,MCK1,MCK1N,MCVEC2,ADVEC2,MCK2,MCK2N
     &             ,MCVECM,NUNECE,IC,NUVECT
      REAL          RCOEF1,RCOEF2,RP(2,2)
      COMPLEX       CCOEF1,CCOEF2,CP(2,2)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ctchsc*')
*
      MCK1=MCCHM1
      MCK2=MCCHM2
      MCVECM=MCVECT-1
      IF (TYVECT(1:1).EQ.'R') THEN
         DO 2202 NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
*           Lignes du second membre correspondant 
*           a des noeuds lies par la condition de transmission
            MCVEC1=MCVECM+RANG1(NUNECE)
            MCVEC2=MCVECM+RANG2(NUNECE)
            DO 2201 IC=1,NCPICE
*                        ( k1 -k2)                   ( k_1 k_2)
*              RP = P =  |       |  ou   RP = P^{-1}=|        |
*                        ( k2  k1)                   (-k_2 k_1)
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(2,1)= SENSCH*RST(MCK2N)
               RP(1,2)=-SENSCH*RST(MCK2N)
               ADVEC1=MCVEC1
               ADVEC2=MCVEC2
               DO 2200 NUVECT=1,NBVECT
                  RCOEF1=RST(ADVEC1)
                  RCOEF2=RST(ADVEC2)
                  RST(ADVEC1)=RP(1,1)*RCOEF1+RP(1,2)*RCOEF2
                  RST(ADVEC2)=RP(2,1)*RCOEF1+RP(2,2)*RCOEF2
                  ADVEC1=ADVEC1+LGVECT
                  ADVEC2=ADVEC2+LGVECT
2200           CONTINUE
               MCVEC1=MCVEC1+1
               MCVEC2=MCVEC2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
2201        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
2202     CONTINUE
      ELSEIF (TYCHMA(1:1).EQ.'R') THEN
         DO 4202 NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            MCVEC1=MCVECM+RANG1(NUNECE)
            MCVEC2=MCVECM+RANG2(NUNECE)
            DO 4201 IC=1,NCPICE
               RP(1,1)= RST(MCK1N)
               RP(2,2)= RST(MCK1N)
               RP(2,1)= SENSCH*RST(MCK2N)
               RP(1,2)=-SENSCH*RST(MCK2N)
               ADVEC1=MCVEC1
               ADVEC2=MCVEC2
               DO 4200 NUVECT=1,NBVECT
                  CCOEF1=CST(ADVEC1)
                  CCOEF2=CST(ADVEC2)
                  CST(ADVEC1)=RP(1,1)*CCOEF1+RP(1,2)*CCOEF2
                  CST(ADVEC2)=RP(2,1)*CCOEF1+RP(2,2)*CCOEF2
                  ADVEC1=ADVEC1+LGVECT
                  ADVEC2=ADVEC2+LGVECT
4200           CONTINUE
               MCVEC1=MCVEC1+1
               MCVEC2=MCVEC2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4201        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4202     CONTINUE
      ELSE
         DO 4402 NUNECE=1,NBNECE
            MCK1N=MCK1
            MCK2N=MCK2
            MCVEC1=MCVECM+RANG1(NUNECE)
            MCVEC2=MCVECM+RANG2(NUNECE)
            DO 4401 IC=1,NCPICE
               CP(1,1)= CST(MCK1N)
               CP(2,2)= CST(MCK1N)
               CP(2,1)= SENSCH*CST(MCK2N)
               CP(1,2)=-SENSCH*CST(MCK2N)
               ADVEC1=MCVEC1
               ADVEC2=MCVEC2
               DO 4400 NUVECT=1,NBVECT
                  CCOEF1=CST(ADVEC1)
                  CCOEF2=CST(ADVEC2)
                  CST(ADVEC1)=CP(1,1)*CCOEF1+CP(1,2)*CCOEF2
                  CST(ADVEC2)=CP(2,1)*CCOEF1+CP(2,2)*CCOEF2
                  ADVEC1=ADVEC1+LGVECT
                  ADVEC2=ADVEC2+LGVECT
4400           CONTINUE
               MCVEC1=MCVEC1+1
               MCVEC2=MCVEC2+1
               MCK1N=MCK1N+1
               MCK2N=MCK2N+1
4401        CONTINUE
            MCK1=MCK1+SKIPN1
            MCK2=MCK2+SKIPN2
4402     CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*Ctchsc*') 
      END
