*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTINVO (NVDSMA
     &                  ,NUINC1,NVNEC1,NEAVC1,NVNEL1,NEAVL1
     &                  ,NUINC2,NVNEC2,NEAVC2,NVNEL2,NEAVL2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Novembre 1994)
* Derniere modification : D.Martin (31 Mai 1998)
* Version 1.0.0
*  
* Caracteristiques en ligne et colonne des blocs d'une matrice
* correspondant aux deux inconnues liees par une condition de transmission
*  
*-- Arguments d'entree --
* NVDSMA niveau de la structure $DSMBL
* NUINC1 numero de l'inconnue de transmission numero 1
* NVNEC1 niveau de la numerotation en colonne pour l'inconnue 1
* NEAVC1 nombre de colonnes avant la premiere colonne pour l'inconnue 1
* NVNEL1 niveau de la numerotation en ligne  pour l'inconnue 1
* NEAVL1 nombre de lignes avant la premiere ligne pour l'inconnue 1
* NUINC2 numero de l'inconnue de transmission numero 2
* NVNEC2 niveau de la numerotation en colonne pour l'inconnue 2
* NEAVC2 nombre de colonnes avant la premiere colonne pour l'inconnue 2
* NVNEL2 niveau de la numerotation en ligne pour l'inconnue 2
* NEAVL2 nombre de lignes avant la premiere ligne pour l'inconnue 2
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NVDSMA,NUINC1,NVNEC1,NVNEL1
     &         ,NEAVC1,NEAVL1,NUINC2,NVNEC2,NVNEL2,NEAVC2,NEAVL2
*
      INCLUDE 'ALLOC'
*
      INTEGER   MCNUME,MCDSMA,LGEDSM,NBLOCC,INCDSM,NBLOCL
     &         ,IBLOC1,IBLOL1,IBLOC2,IBLOL2,LGRIPP,NULOCC,NULOCL
     &         ,NUINCC,NUINCL,NVNUMC,NVNUML,NBNUMC,NBNUML
     &         ,IAUX,NBCOLO,NBLIGN
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CtInvo*')
* 
      CALL TBAR1  (ERCODE,'$DSMBL',NVDSMA,MCDSMA)
      CALL SDEXDB (IST(MCDSMA),LGEDSM,NBLOCC,INCDSM,NBLOCL)             !sdexplo
*
*     Boucle de recherche des blocs correspondant aux inconnues 
*     de numero le plus petit (suffixe D) et le plus grand (suffixe G) 
*     en ligne (L) et en colonne (C)
*
      NVNEC1=0
      IBLOC1=0
      NEAVC1=0
      NVNEL1=0
      IBLOL1=0
      NEAVL1=0
      NVNEC2=0
      IBLOC2=0
      NEAVC2=0
      NVNEL2=0
      IBLOL2=0
      NEAVL2=0
*
      LGRIPP=LGEDSM
      NBCOLO=0
      DO 11 NULOCC=1,NBLOCC
         NBLIGN=0
         DO 10 NULOCL=1,NBLOCL
            CALL TBAR1  (ERCODE,'$DSMBL',NVDSMA,MCDSMA)
            NUINCC=IST(MCDSMA+LGRIPP+1)
            NUINCL=IST(MCDSMA+LGRIPP+2)
            NVNUMC=IST(MCDSMA+LGRIPP+3)
            NVNUML=IST(MCDSMA+LGRIPP+4)
            LGRIPP=LGRIPP+INCDSM
            IF (NUINCC.EQ.NUINC1) THEN
               NVNEC1=NVNUMC
               IBLOC1=NULOCC
               NEAVC1=NBCOLO
            ENDIF
            IF (NUINCC.EQ.NUINC2) THEN
               NVNEC2=NVNUMC
               IBLOC2=NULOCC
               NEAVC2=NBCOLO
            ENDIF
            IF (NUINCL.EQ.NUINC1) THEN
               NVNEL1=NVNUML
               IBLOL1=NULOCL
               NEAVL1=NBLIGN
            ENDIF
            IF (NUINCL.EQ.NUINC2) THEN
               NVNEL2=NVNUML
               IBLOL2=NULOCL
               NEAVL2=NBLIGN
            ENDIF
            IF (IST(MCDSMA+LGRIPP+1).EQ.0) IST(MCDSMA+LGRIPP+1)=-1
*
            CALL TBRR1  (ERCODE,'#GNEDO',NVNUML,MCNUME)
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUME)
            NBNUML=IST(MCNUME+1)
            CALL TBSAVE ('#GNEDO',NVNUML)
            IF (NVNUMC.NE.NVNUML) THEN
               CALL TBRR1  (ERCODE,'#GNEDO',NVNUMC,MCNUME)
               CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNUME)
               NBNUMC=IST(MCNUME+1)
               CALL TBSAVE ('#GNEDO',NVNUMC)                     
            ELSE
               NBNUMC=NBNUML
            ENDIF
            NBLIGN=NBLIGN+NBNUML
10       CONTINUE
         NBCOLO=NBCOLO+NBNUMC
11    CONTINUE
*
*     Dans la matrice les rangs des dl correspondant a l'inconnue de plus petit 
*     numero sont plus petits que ceux de l'inconnue de plus grand numero.
*
      IF (IBLOC1.GT.IBLOC2) THEN
         IAUX=NVNEC1
         NVNEC1=NVNEC2
         NVNEC2=IAUX
         IAUX=IBLOC1
         IBLOC1=IBLOC2
         IBLOC2=IAUX
         IAUX=NEAVC1
         NEAVC1=NEAVC2
         NEAVC2=IAUX
         IAUX=NVNEL1
         NVNEL1=NVNEL2
         NVNEL2=IAUX
         IAUX=IBLOL1
         IBLOL1=IBLOL2
         IBLOL2=IAUX
         IAUX=NEAVL1
         NEAVL1=NEAVL2
         NEAVL2=IAUX
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF (IBLOC1.NE.IBLOL1.AND.IBLOC1.NE.0.AND.IBLOL1.NE.0)
     &   CALL BAISE  ('Incoherence pour le bloc de rang le plus petit?')
      IF (IBLOC2.NE.IBLOL2.AND.IBLOC2.NE.0.AND.IBLOL2.NE.0)
     &   CALL BAISE  ('Incoherence pour le bloc de rang le plus grand?')
      CALL PRFXMJ (-1,'*CtInvo*')  
                                                                    END !Ctinvo
