*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTMOBD (NBCOLO,NBLIGN,NCPICE,NBNECE
     &                  ,RANGC1,RANGC2,STRSYM
     &                  ,NULAPL,PLAGEL,NULASL,PLAGSL,NBPLAL,NXPLAL
     &                  ,NULAPU,PLAGEU,NULASU,PLAGSU,NBPLAU,NXPLAU
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1994)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*
* Modification du compactage dans les parties triangulaires inf. et sup.
* d'un terme matriciel BiMorse en vue d'une condition de transmission
*
*-- Arguments --
* NBCOLO nombre de colonnes de la matrice
* NBLIGN nombre de lignes   de la matrice
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de transmission
* RANGC1 rang en colonne dans la matrice des noeuds de transmission "a droite"
* RANGC2 rang en colonne dans la matrice des noeuds de transmission "a gauche"
* STRSYM indice de symetrie structurelle de la matrice
* NULAPL numeros de derniere plage de chaque colonne
* PLAGEL numeros de colonne de debut de plage et longueurs cumulees
* NULASL numeros modifie de derniere plage de chaque colonne
* PLAGSL numeros modifie de colonne de debut de plage et longueurs cumulees
* NBPLAL nombre de plages (modifie en sortie)
* NXPLAL nombre de plages maximum a ne pas depasser
* NULAPU numeros de derniere plage de chaque colonne
* PLAGEU numeros de ligne de debut de plage et longueurs cumulees
* NULASU numeros modifie de derniere plage de chaque colonne
* PLAGSU numeros modifie de ligne de debut de plage et longueurs cumulees
* NBPLAU nombre de plages (modifie en sortie)
* NXPLAU nombre de plages maximum a ne pas depasser
* IRCODE code de retour en cas de nombre de plages depasse
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IRCODE,NBCOLO,NBLIGN,NCPICE,NBNECE
     &       ,RANGC1(*),RANGC2(*),STRSYM
     &       ,NULAPL(*),PLAGEL(2,*),NULASL(*),PLAGSL(2,*),NBPLAL,NXPLAL
     &       ,NULAPU(*),PLAGEU(2,*),NULASU(*),PLAGSU(2,*),NBPLAU,NXPLAU
*
      INTEGER NUNECE,IC,COLONK,COLONL
*-----------------------------------------------------------------------
      IRCODE=0
      DO 1001 NUNECE=1,NBNECE
         COLONK=RANGC1(NUNECE)
         COLONL=RANGC2(NUNECE)
         DO 1002 IC=1,NCPICE
*
*           Croisement "k","l" dans le triangle inferieur
*	
            CALL CMPLGN (COLONL,COLONK,NBLIGN,NBPLAL,NULASL,PLAGSL
     &                  ,NXPLAL,IRCODE)                                 !morse
            IF (IRCODE.NE.0) GOTO 99999
*
*           Croisement "k","l" dans le triangle superieur
*           en cas de structure non symetrique
*
            IF (STRSYM.EQ.0) THEN
               CALL CMPLGN (COLONL,COLONK,NBCOLO,NBPLAU,NULASU,PLAGSU
     &                     ,NXPLAU,IRCODE)                              !morse
               IF (IRCODE.NE.0) GOTO 99998
            ENDIF
            COLONK=COLONK+1
            COLONL=COLONL+1
1002     CONTINUE
1001  CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99998 IRCODE=1
      RETURN
99999 IRCODE=2
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
*  dans l'appel de CMPLGN
* Version 1 : D.Martin (27 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Ctmobd
