*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTMOBL (NBCOLI,NCPICE,NBNECE,RANGC1,RANGC2
     &                  ,NULAPL,PLAGEL,NULASL,PLAGSL,NBPLAL,NXPLAL
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1994)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*
* Modification du compactage de la partie triangulaire inferieure ou superieure
* d'un terme matriciel BiMorse en vue d'une condition de transmission
*
*-- Arguments --
* NBCOLI nombre de ligne/colonnes de la matrice
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de transmission
* RANGC1 rang en ligne/colonne des d.l. de transmission pour l'inconnue 1
* RANGC2 rang en ligne/colonne des d.l. de transmission pour l'inconnue 2
* NULAPL numeros de derniere plage de chaque ligne
* PLAGEL numeros de colonne de debut de plage et longueurs cumulees
* NULASL numeros modifie de derniere plage de chaque ligne
* PLAGSL numeros modifie de colonne de debut de plage et longueurs cumulees
* NBPLAL nombre de plages modifie
* NXPLAL nombre de plages maximum a ne pas depasser
* IRCODE code de retour en cas de nombre de plages depasse
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IRCODE,NBCOLI,NCPICE,NBNECE,RANGC1(*),RANGC2(*)
     &       ,NULAPL(*),PLAGEL(2,*),NULASL(*),PLAGSL(2,*),NBPLAL,NXPLAL
*
      INTEGER COLONK,COLONL,NUPRPL,NUDRPL,LGCUAV,NUNECE,IC,LIGNE,NUPLAG
*------------------------------------------------------------------------
      IRCODE=0
      DO 1002 NUNECE=1,NBNECE
         COLONK=RANGC1(NUNECE)
         COLONL=RANGC2(NUNECE)
         DO 1001 IC=1,NCPICE
*
            NUPRPL=1
            NUDRPL=0
            LGCUAV=0
            DO 41 LIGNE=1,NBCOLI
               IF (NUPRPL.GT.1) LGCUAV=PLAGEL(2,NUPRPL-1)
               CALL DIKLPL (COLONK,NUPRPL,NUDRPL,LGCUAV,PLAGEL
     &                     ,NUPLAG,*40)                                 !morse
*              Le coefficient LIGNE, COLONK a un correspondant dans
*              la colonne COLONL qu'on incorpore au triangle inferieur.
               IF (LIGNE.GT.COLONL) THEN
                  CALL CMPLGN (LIGNE,COLONL,NBCOLI,NBPLAL,NULASL,PLAGSL
     &                        ,NXPLAL,IRCODE)                           !morse
                  IF (IRCODE.NE.0) GOTO 99998
               ENDIF
40             NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
41          CONTINUE
*
            NUPRPL=1
            NUDRPL=0
            LGCUAV=0
            DO 43 LIGNE=1,NBCOLI
               IF (NUPRPL.GT.1) LGCUAV=PLAGEL(2,NUPRPL-1)
               CALL DIKLPL (COLONL,NUPRPL,NUDRPL,LGCUAV,PLAGEL
     &                  ,NUPLAG,*42)                                    !morse
*              Le coefficient LIGNE, COLONL a un correspondant dans
*              la colonne COLONK qu'on incorpore au triangle inferieur.
               CALL CMPLGN (LIGNE,COLONK,NBCOLI,NBPLAL,NULASL,PLAGSL
     &                     ,NXPLAL,IRCODE)                              !morse
               IF (IRCODE.NE.0) GOTO 99998
42             NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
43          CONTINUE
*
            COLONK=COLONK+1
            COLONL=COLONL+1
1001     CONTINUE
1002  CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99998 IRCODE=1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
*  dans l'appel de CMPLGN
* Version 1 : D.Martin (23 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Ctmobl
