*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTMOBM (NBCOLO,NBLIGN,NCPICE,NBNECE
     &                  ,RANGC1,RANGC2,STRSYM
     &                  ,NULAPL,PLAGEL,NULASL,PLAGSL,NBPLAL,NXPLAL
     &                  ,NULAPU,PLAGEU,NULASU,PLAGSU,NBPLAU,NXPLAU
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1994)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*
* Modification du compactage dans les parties triangulaires inf. et sup.
* d'un terme matriciel BiMorse en vue d'une condition de transmission
*
*-- Arguments --
* NBCOLO nombre de colonnes de la matrice
* NBLIGN nombre de lignes   de la matrice
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de transmission
* RANGC1 rang en colonne dans la matrice des noeuds de transmission "a droite"
* RANGC2 rang en colonne dans la matrice des noeuds de transmission "a gauche"
* STRSYM indicateur de matrice a structure symetrique
*        =1 structure symetrique, 0 sinon
* NULAPL numeros de derniere plage de chaque colonne
* PLAGEL numeros de colonne de debut de plage et longueurs cumulees
* NULASL numeros modifie de derniere plage de chaque colonne
* PLAGSL numeros modifie de colonne de debut de plage et longueurs cumulees
* NBPLAL nombre de plages modifie
* NXPLAL nombre de plages maximum a ne pas depasser
* NULAPU numeros de derniere plage de chaque colonne
* PLAGEU numeros de ligne de debut de plage et longueurs cumulees
* NULASU numeros modifie de derniere plage de chaque colonne
* PLAGSU numeros modifie de ligne de debut de plage et longueurs cumulees
* NBPLAU nombre de plages modifie
* NXPLAU nombre de plages maximum a ne pas depasser
* IRCODE code de retour en cas de nombre de plages depasse
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IRCODE,NBCOLO,NBLIGN,NCPICE,NBNECE
     &       ,RANGC1(*),RANGC2(*),STRSYM
     &       ,NULAPL(*),PLAGEL(2,*),NULASL(*),PLAGSL(2,*),NBPLAL,NXPLAL
     &       ,NULAPU(*),PLAGEU(2,*),NULASU(*),PLAGSU(2,*),NBPLAU,NXPLAU
*
      INTEGER COLONK,LGCUAK,COLONL,LGCUAL,LGCUNL
     &       ,NUPRPL,NUDRPL,NUNECE,IC,LIGNE,NUPLAG,LIGDEB
*-----------------------------------------------------------------------
      IRCODE=0
      LGCUAL=0
      DO 1002 NUNECE=1,NBNECE
         COLONK=RANGC1(NUNECE)
         COLONL=RANGC2(NUNECE)
*
         DO 1001 IC=1,NCPICE
*
            NUPRPL=1
            NUDRPL=0
            LGCUAK=0
*
*           Boucle sur les plages de la ligne L
*
            DO 31 LIGNE=1,NBLIGN
               IF (NUPRPL.GT.1) LGCUAK=PLAGEL(2,NUPRPL-1)
               CALL DIKLPL (COLONK,NUPRPL,NUDRPL,LGCUAK,PLAGEL
     &                     ,NUPLAG,*30)                                 !morse
*              Le coefficient LIGNE, COLONK a un correspondant dans
*              la colonne COLONL qu'on incorpore au triangle superieur.
               IF (LIGNE.LT.COLONL) THEN
                  CALL CMPLGN (COLONL,LIGNE,NBCOLO,NBPLAU
     &                        ,NULASU,PLAGSU,NXPLAU,IRCODE)             !morse
                  IF (IRCODE.NE.0) GOTO 99998
               ENDIF
30             NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
31          CONTINUE
*
            NUDRPL=NULAPU(COLONL-1)
            NUPRPL=NULAPU(COLONL-2)+1
            IF (NUPRPL.GT.1) LGCUAL=PLAGEU(2,NUPRPL-1)
*
*           Boucle sur les plages de la colonne L
*
            DO 33 NUPLAG=NUPRPL,NUDRPL
*              Numero de ligne du 1er coeff. de la plage de la colonne L
               LIGDEB=PLAGEU(1,NUPLAG)
               LGCUNL=PLAGEU(2,NUPLAG)
*              Boucles sur les lignes de la colonne L
               DO 32 LIGNE=LIGDEB,LIGDEB-1+LGCUNL-LGCUAL
*                 Le coefficient LIGNE, COLONL a un correspondant dans
*                 la colonne COLONK qu'on incorpore au triangle inferieur.
                  IF (LIGNE.GT.COLONK) THEN
                     CALL CMPLGN (LIGNE,COLONK,NBLIGN,NBPLAL
     &                            ,NULASL,PLAGSL,NXPLAL,IRCODE)          !morse
                     IF (IRCODE.NE.0) GOTO 99999
                  ENDIF
32             CONTINUE
               LGCUAL=LGCUNL
33          CONTINUE
*
            COLONK=COLONK+1
            COLONL=COLONL+1
*
1001     CONTINUE
1002  CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99998 IRCODE=1
      RETURN
99999 IRCODE=2
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
*  dans l'appel de CMPLGN
* Version 1 : D.Martin (27 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Ctmobm
