*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTMOBU (NBCOLI,NCPICE,NBNECE,RANGC1,RANGC2
     &                  ,NULAPU,PLAGEU,NULASU,PLAGSU,NBPLAU,NXPLAU
     &                  ,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Novembre 1994)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*
* Modification du compactage de la partie triangulaire superieure ou superieure
* d'un terme matriciel BiMorse en vue d'une condition de transmission
*
*-- Arguments --
* NBCOLI nombre de colonnes/lignes de la matrice
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de transmission
* RANGC1 rangs en colonne/ligne des d.l. de transmission pour l'inconnue 1
* RANGC2 rangs en colonne/ligne des d.l. de transmission pour l'inconnue 2
* NULAPU numeros de derniere plage de chaque colonne
* PLAGEU numeros de ligne de debut de plage et longueurs cumulees
* NULASU numeros modifies de derniere plage de chaque colonne
* PLAGSU numeros modifies de ligne de debut de plage et longueurs cumulees
* NBPLAU nombre de plages modifie
* NXPLAU nombre de plages a ne pas depasser
* IRCODE code de retour en cas de nombre de plages depasse
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IRCODE,NBCOLI,NCPICE,NBNECE,RANGC1(*),RANGC2(*)
     &       ,NULAPU(*),PLAGEU(2,*),NULASU(*),PLAGSU(2,*),NBPLAU,NXPLAU
*
      INTEGER COLONK,NUPRPK,NUDRPK,LGCUAK,LGCUNK
     &       ,COLONL,NUPRPL,NUDRPL,LGCUAL,LGCUNL
     &       ,NUPLAG,LIGDEB,NUNECE,IC,LIGNE
*-----------------------------------------------------------------------
      IRCODE=0
*
      NUPRPK=1
      NUDRPK=0
      LGCUAK=0
      LGCUAL=0
      DO 1002 NUNECE=1,NBNECE
         COLONK=RANGC1(NUNECE)
         COLONL=RANGC2(NUNECE)
         DO 1001 IC=1,NCPICE
*
*           Plages de la colonne K dans le triangle superieur (K > 0)
            IF (COLONK.GT.2) NUPRPK=NULAPU(COLONK-2)+1
            IF (COLONK.GT.1) NUDRPK=NULAPU(COLONK-1)
            IF (NUPRPK.GT.1) LGCUAK=PLAGEU(2,NUPRPK-1)
*
*           Boucle sur les plages de la colonne K
            DO 21 NUPLAG=NUPRPK,NUDRPK
*              Numero de ligne du 1er coeff. de la plage de la colonne K
               LIGDEB=PLAGEU(1,NUPLAG)
               LGCUNK=PLAGEU(2,NUPLAG)
*              Boucles sur les lignes de la colonne K
               DO 20 LIGNE=LIGDEB,LIGDEB+LGCUNK-LGCUAK-1
                  CALL CMPLGN (COLONL,LIGNE,NBCOLI,NBPLAU,NULASU,PLAGSU
     &                        ,NXPLAU,IRCODE)                           !morse
                  IF (IRCODE.NE.0) GOTO 99999
20             CONTINUE
               LGCUAK=LGCUNK
21          CONTINUE
*
*           Plages de la colonne L dans le triangle superieur (L > K > 0)
            NUDRPL=NULAPU(COLONL-1)
            NUPRPL=NULAPU(COLONL-2)+1
            IF (NUPRPL.GT.1) LGCUAL=PLAGEU(2,NUPRPL-1)
*
*           Boucle sur les plages de la colonne L
            DO 23 NUPLAG=NUPRPL,NUDRPL
*              Numero de ligne du 1er coeff. de la plage de la colonne L
               LIGDEB=PLAGEU(1,NUPLAG)
               LGCUNL=PLAGEU(2,NUPLAG)
*              Boucles sur les lignes de la colonne L
               DO 22 LIGNE=LIGDEB,LIGDEB-1+LGCUNL-LGCUAL
                  IF (LIGNE.LT.COLONK) THEN
                     CALL CMPLGN (COLONK,LIGNE,NBCOLI,NBPLAU,NULASU
     &                           ,PLAGSU,NXPLAU,IRCODE)                 !morse
                     IF (IRCODE.NE.0) GOTO 99999
                  ENDIF
22             CONTINUE  
               LGCUAL=LGCUNL
23          CONTINUE
*
            COLONK=COLONK+1
            COLONL=COLONL+1
1001     CONTINUE
1002  CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 IRCODE=1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
*  dans l'appel de CMPLGN
* Version 1 : D.Martin (27 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Ctmobu
