*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CTMOST (NMMATR,NVMATR,ITYSYM,ITYSYF,TYMATR,NBCOLO
     &                  ,NBLIGN,NMSTOK,NVSTOK,LGSTOK,NCPICE,NBNECE
     &                  ,NMRGDL,NVRGDL,NMSTOW,NVSTOW,STRSYM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Mars 1995)
* Derniere modification : D.Martin & L.Landure (11 Septembre 2000)
* Version 1.0.6
*  
* Modification du compactage d'une matrice pour la prise en compte
* d'une condition de transmission 
*  
*-- Arguments d'entree --
* NMMATR nom de la matrice dont il faut modifier le compactage
* NVMATR son niveau du terme
* ITYSYM indicateur de symetrie de la matrice initiale
* ITYSYF indicateur de symetrie de la matrice finale
* TYMATR type de declaration de la matrice
* NBCOLO nombre de colonnes de la matrice
* NBLIGN nombre de lignes   de la matrice
* NMSTOK nom du tableau de stockage de la matrice
* NVSTOK niveau du tableau de stockage de la matrice
* LGSTOK longueur initiale du tableau de stockage de la matrice
* NCPICE nombre de composantes des inconnues de la condition de transmission
* NBNECE nombre de noeuds de transmission
* NMRGDL tableau des rangs des d.l. portant la condition de transmission
*        dans les lignes/colonnes de la matrice
* NVRGDL son niveau
* NMSTOW tableau pour creer un nouveau tableau de pointeurs de stockage
* NVSTOW son niveau
* STRSYM indicateur de structure matricielle symetrique
* NIVIMP niveau d'impression pour la matrice
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMMATR,TYMATR,NMSTOK,NMRGDL,NMSTOW
      INTEGER NVMATR,ITYSYM,ITYSYF,NBCOLO,NBLIGN,NVSTOK,LGSTOK,NCPICE
     &       ,NBNECE,NVRGDL,NVSTOW,STRSYM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER INDSYM,LGSTMO
      INTEGER ITYSNO,LGSTOW,MCSTOW,MCSTOK,MCMATR,LGMATR,LGDIAG
     &       ,MCRGDL,MCRGC1,MCRGC2,MCRGL1,MCRGL2,IRCODE,NCATR1
     &       ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCMATL,LWMATL,LGBINF
     &       ,NXPLAL,NWPLAL,MWPLAL,MWPLIL,MWMATL,LWMATR
     &       ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU,MCMATU,LWMATU,LGBSUP
     &       ,NXPLAU,NWPLAU,MWPLAU,MWPLIU,MWMATU
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CtmoSt*')
      ITYSNO=INDSYM (' ')                                               !utilite
*
      LGDIAG=MIN (NBCOLO,NBLIGN)
*
*     Tableau de travail surdimensionne (?) du nouveau tableau de stockage
*
      LGSTOW=MIN(2*LGSTOK,LGSTMO('B',NBLIGN,NBCOLO,1))
      CALL TBCREE (NMSTOW,NVSTOW,1,(2-STRSYM)*LGSTOW,'c')
*
      CALL TBAR3  (ERCODE, NMSTOK ,NVSTOK,MCSTOK, NMSTOW ,NVSTOW,MCSTOW
     &                   , NMRGDL ,NVRGDL,MCRGDL)
      CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)     !sdexplo
      MCRGL1=MCRGDL
      MCRGL2=MCRGDL+NBNECE
      MCRGC1=MCRGDL
      MCRGC2=MCRGDL+NBNECE
*
*     Les stockages 'inf' et 'sup' sont determines separement, et seront
*     recolles apres, car on ne connait pas a priori leur taille
*
*     Pointeurs pour la partie triangulaire inferieure
      LGBINF=NBL+2*NBPLAL
      LGBSUP=LGBINF
      CALL TDANST (LGBINF+1,'E',MCSTOK,IST,RST,CST
     &                     ,'E',MCSTOW,IST,RST,CST)                     !utilite
      MWPLAL=MCSTOW+1
      IST(MWPLAL)=0
      NXPLAL=(LGSTOW-1-NBL)/2
      NWPLAL=NBPLAL
      MWPLIL=MWPLAL+NBL
*     Pointeurs pour la partie triangulaire superieure
      MWPLAU=MCSTOW+1
      NXPLAU=NXPLAL
      NWPLAU=NWPLAL
      MWPLIU=MWPLIL
      IF (STRSYM.EQ.0) THEN
         MCRGC1=MCRGDL+2*NBNECE
         MCRGC2=MCRGDL+3*NBNECE
         LGBSUP=NBC+2*NBPLAU
         CALL TDANST (LGBSUP,'E',MCSTOK+LGBINF+1,IST,RST,CST
     &                      ,'E',MCSTOW+LGSTOW,IST,RST,CST)             !utilite
         MWPLAU=MCSTOW+LGSTOW
         IST(MWPLAU)=0
         NXPLAU=(LGSTOW-1-NBC)/2
         NWPLAU=NBPLAU
         MWPLIU=MWPLAU+NBC
      ENDIF

*
*     Modification du compactage dans les colonnes correspondant aux
*     noeuds support de la condition pour les inconnues 1 et 2
*     pour les lignes de la matrice autres
*     (ne correspondant pas aux noeuds support des inconnues 1 et 2)
*
*     Modifications dans le partie triangulaire inferieure de la matrice
      CALL CTMOBU (NBL,NCPICE,NBNECE,IST(MCRGL1),IST(MCRGL2)
     &            ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &            ,NWPLAL,NXPLAL,IRCODE)                                !cdesse
      IF (IRCODE.EQ.1) GOTO 99992
*
      IF (STRSYM.EQ.0) THEN
*        Modifications dans le partie triangulaire superieur de la matrice
         CALL CTMOBU (NBC,NCPICE,NBNECE,IST(MCRGC1),IST(MCRGC2)
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MWPLAU),IST(MWPLIU)
     &               ,NWPLAU,NXPLAU,IRCODE)                             !cdesse
         IF (IRCODE.EQ.1) GOTO 99991
      ENDIF
*
*     Modification simultanement dans les parties triangulaires inf. et sup.
      IF (STRSYM.NE.0) THEN
         CALL CTMOBM (NBL,NBC,NCPICE,NBNECE,IST(MCRGL1),IST(MCRGL2)
     &               ,STRSYM
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &               ,NWPLAL,NXPLAL
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &               ,NWPLAL,NXPLAL,IRCODE)                             !cdesse
      ELSE
         CALL CTMOBM (NBL,NBC,NCPICE,NBNECE,IST(MCRGL1),IST(MCRGL2)
     &               ,STRSYM
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MWPLAU),IST(MWPLIU)
     &               ,NWPLAU,NXPLAU
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &               ,NWPLAL,NXPLAL,IRCODE)                             !cdesse
         IF (IRCODE.EQ.2) GOTO 99995
         IF (IRCODE.EQ.1) GOTO 99996
         CALL CTMOBM (NBC,NBL,NCPICE,NBNECE,IST(MCRGC1),IST(MCRGC2)
     &               ,STRSYM
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &               ,NWPLAL,NXPLAL
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MWPLAU),IST(MWPLIU)
     &               ,NWPLAU,NXPLAU,IRCODE)                             !cdesse
         IF (IRCODE.EQ.1) GOTO 99995
         IF (IRCODE.EQ.2) GOTO 99996
      ENDIF
*
*     Modification dans le partie triangulaire inferieure de la matrice
      CALL CTMOBL (NBC,NCPICE,NBNECE,IST(MCRGC1),IST(MCRGC2)
     &            ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &            ,NWPLAL,NXPLAL,IRCODE)                                !cdesse
      IF (IRCODE.NE.0) GOTO 99993
*
      IF (STRSYM.EQ.0) THEN
*        Modification dans le partie triangulaire superieure de la matrice
         CALL CTMOBL (NBL,NCPICE,NBNECE,IST(MCRGL1),IST(MCRGL2)
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MWPLAU),IST(MWPLIU)
     &               ,NWPLAU,NXPLAU,IRCODE)                             !cdesse
         IF (IRCODE.NE.0) GOTO 99994
      ELSE
         NWPLAU=NWPLAL
      ENDIF
*     Modification du compactage au deux croisements anti-diagonaux
*     des lignes et colonnes.
*
      CALL CTMOBD (NBC,NBL,NCPICE,NBNECE,IST(MCRGC1),IST(MCRGC2)
     &            ,STRSYM
     &            ,IST(MCPLAL),IST(MCPLIL),IST(MWPLAL),IST(MWPLIL)
     &            ,NWPLAL,NXPLAL
     &            ,IST(MCPLAU),IST(MCPLIU),IST(MWPLAU),IST(MWPLIU)
     &            ,NWPLAU,NXPLAU,IRCODE)                                !cdesse
      IF (IRCODE.EQ.1) GOTO 99997
      IF (IRCODE.EQ.2) GOTO 99998
      IF (STRSYM.NE.0) NWPLAU=NWPLAL
*
*     Transfert de la modification dans la matrice
*
      LGBSUP=0
      LGBINF=NBL+2*NWPLAL
      IF (STRSYM.EQ.0) LGBSUP=NBC+2*NWPLAU
*      IF (LGBINF+LGBSUP+1.GT.(2-STRSYM)*LGSTOW)
      IF (LGBINF+LGBSUP+1.GT.LGSTOK)
     &   CALL TBAJST (NMSTOK,NVSTOK,LGBINF+LGBSUP+1)
*
      LWMATU=0
*     Longueur de la partie triangulaire inferieure
      LWMATL=IST(MWPLIL+2*NWPLAL-1)
*     Longueur de la partie triangulaire superieure
      IF (ITYSYF.EQ.ITYSNO) LWMATU=IST(MWPLIU+2*NWPLAU-1)
*     Nouvelle longueur de la matrice
      LWMATR=LGDIAG+LWMATL+LWMATU
      CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGMATR)
      CALL TBAJST (NMMATR,NVMATR,LWMATR)
      CALL TBAR3  (ERCODE,NMSTOK,NVSTOK,MCSTOK,NMSTOW,NVSTOW,MCSTOW
     &                   ,NMMATR,NVMATR,MCMATR)
      CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)     !sdexplo
*
*     Re-arrangement de la matrice selon les nouveaux pointeurs de stockage
      MWPLAL=MCSTOW+1
      MWPLIL=MWPLAL+NBL
      MWPLAU=MWPLAL
      IF (STRSYM.EQ.0) MWPLAU=MCSTOW+LGSTOW
      MWPLIU=MWPLAU+NBC
*     Adresses dans la matrice initiale
      MCMATL=MCMATR+LGDIAG
      MCMATU=MCMATL
      IF (ITYSYM.EQ.ITYSNO) MCMATU=MCMATL+LGL
*     Adresses dans la matrice finale
      MWMATL=MCMATL
      IF (ITYSYF.EQ.ITYSNO) MWMATU=MWMATL+LWMATL
*
      CALL TAZERO (LWMATR-LGMATR,TYMATR,MCMATR+LGMATR,AST,IST,RST,CST)  !utilite
*
*     Report de la partie triangulaire superieure
*     (si la matrice est symetrique elle coincide avec la partie triang. inf.)
*
      CALL BM2BMG (TYMATR,NBC,IST(MCPLAU),IST(MCPLIU),MCMATR
     &            ,MCMATU,IST(MWPLAU+1),IST(MWPLIU),MCMATR,MWMATU
     &            ,IRCODE,RST,CST)                                      !morse
      IF (IRCODE.EQ.-1) CALL ERTERM (6,NMMATR,NVMATR)
      IF (IRCODE.EQ.1) GOTO 99981
      IF (IRCODE.NE.0) GOTO 99983

*
*     Report de la partie triangulaire inferieure
*
      IF (ITYSYF.EQ.ITYSNO) THEN
         CALL BM2BMG (TYMATR,NBL,IST(MCPLAL),IST(MCPLIL),MCMATR
     &               ,MCMATL,IST(MWPLAL+1),IST(MWPLIL),MCMATR,MWMATL
     &               ,IRCODE,RST,CST)                                   !morse
         IF (IRCODE.EQ.-1) CALL ERTERM (6,NMMATR,NVMATR)
         IF (IRCODE.EQ.1) GOTO 99982
         IF (IRCODE.NE.0) GOTO 99984
      ENDIF
*
*     Transfert du nouveau tableau de pointeurs de stockage de la matrice
*
*     Partie triangulaire inferieure
      IST(MCSTOK)=2
      IST(MWPLAL)=NBL
      CALL TDANST (LGBINF,'E',MWPLAL,IST,RST,CST
     &                   ,'E',MCSTOK+1,IST,RST,CST)                     !utilite
*
      IF (STRSYM.EQ.0) THEN
*        Partie triangulaire sup. (matrice non structurellement symetrique)
         IST(MCSTOK)=2+LGBINF
         IST(MWPLAU)=NBC
         CALL TDANST (LGBSUP,'E',MWPLAU,IST,RST,CST
     &                      ,'E',MCSTOK+LGBINF+1,IST,RST,CST)           !utilite
      ENDIF
*
      IF (NIVIMP.GT.5) THEN
         CALL PRBMOR (IST(MCSTOK),'Tables BiMorse modifiees'
     &               ,NMMATR,NVMATR,NIVIMP,IMPSDR)                      !prsd
         CALL PRTERM (NMMATR,NVMATR,NIVIMP,IMPSDR)                      !prsd
         CALL TBRR2  (ERCODE,NMMATR,NVMATR,LGMATR,NMSTOK,NVSTOK,MCSTOK)
      ENDIF
*
      CALL TBTUER (NMSTOW,NVSTOW)
      CALL PRFXMJ (-1,'*CtmoSt*')
      RETURN
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (NXPLAU,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobu* Nombre maximum (NXPLAU='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse superieur'
     &//' pour la matrice '//ERCODE(1:NCATR1))
99992 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (NXPLAL,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobu* Nombre maximum (NXPLAL='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse inferieur'
     &//' pour la matrice '//ERCODE(1:NCATR1))
99993 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (NXPLAL,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobl* Nombre maximum (NXPLAU='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse inferieur'
     &//' pour la matrice '//ERCODE(1:NCATR1))
99994 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (NXPLAU,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobl* Nombre maximum (NXPLAL='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse superieur'
     &//' pour la matrice '//ERCODE(1:NCATR1))
99995 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (NXPLAU,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobm* Nombre maximum (NXPLAU='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse superieur'
     &//' de la matrice '//ERCODE(1:NCATR1))
99996 CALL ENCLER (NXPLAL,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobm* Nombre maximum (NXPLAL='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse inferieur'
     &//' de la matrice '//ERCODE(1:NCATR1))
99997 CALL ENCLER (NXPLAU,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobd* Nombre maximum (NXPLAU='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse superieur'
     &//' de la matrice '//ERCODE(1:NCATR1))
99998 CALL ENCLER (NXPLAL,ERCODE(NCATR1+1:NCATR1+9))
      CALL BAISE  ('*CtmoSt < CtMobd* Nombre maximum (NXPLAL='
     &//ERCODE(NCATR1+1:NCATR1+9)//') de plages depasse'
     &//'; Taille sous estimee pour le stockage bimorse inferieur'
     &//' de la matrice '//ERCODE(1:NCATR1))
99981 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL BAISE  ('*CtmoSt < Bm2bmg* Bug de programmation,'
     &//' lors du report de la partie triangulaire superieure de '
     &//ERCODE(1:NCATR1)
     &//'. Contactez votre service clientele immediatement.')
99982 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL BAISE  ('*CtmoSt < Bm2bmg* Bug de programmation,'
     &//' lors du report de la partie triangulaire inferieure de '
     &//ERCODE(1:NCATR1)
     &//'. Contactez votre service clientele immediatement.')
99983 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (IRCODE,ERCODE(NCATR1+1:NCATR1+6))
      CALL BAISE  ('*CtmoSt < Bm2Bmg* Bug interne: '
     &//'Colonne non retrouvee sur la ligne '
     &//ERCODE(NCATR1+1:NCATR1+6)
     &//' de la matrice '//ERCODE(1:NCATR1))
99984 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL ENCLER (IRCODE,ERCODE(NCATR1+1:NCATR1+6))
      CALL BAISE  ('*CtmoSt < Bm2Bmg* Bug interne : '
     &//'Ligne non retrouvee sur la colonne '
     &//ERCODE(NCATR1+1:NCATR1+6)
     &//' de la matrice '//ERCODE(1:NCATR1))
                                                                    END !CtmoSt
