*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CODOFA (NDIM,NDMDOM,NBELDO,NBCNVE,VARIAB,BLOKEL,LISTEL  
     &                  ,NBPTEX,ISGDET,CORPTG,ICORPL,CORPTL,LGCORL
     &                  ,NUNEFA,NUDLFA,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.deBayser (Mai 1988)  
* Derniere modification : D.Martin (28 Mai 1999)
*  
* Redistribuer par domaine les coordonnees des points  
* Cas des domaines de bord ne necessitant pas d'extension  
*  
*-- Arguments d'entree --   
* NDIM   dimension d'espace
* NDMDOM dimension du domaine 
* NBELDO nombre d'elements (ou de couple element-face) du domaine 
* NBCNVE nombre de caracteres par nom de variable d'espace
* VARIAB noms des variables d'espace (tableau CHARACTER*1 de longueur NBCNVE) 
* BLOKEL tableau des caracteristiques des blocs d'elements du maillage
*        consecutifs de meme type
* LISTEL tableau descriptif des liste d'elements par domaine  
* NBPTEX nombre max. de point dans un element du maillage
* ISDGET orientation de l'element en cours
* CORPTG coordonnees globales des points par element pour tout le maillage
* ICORPL memoires du tableau CORPTL utilisees par le stockage du nombre
*        de points de chaque 'element' du domaine de calcul .
* CORPTL coordonnees des points du maillage par 'element' du domaine  
* LGCORL longueur des tableaux CORPTL et ICORPL (en sortie)
* NUNEFA tableau de la numerotation locale des noeuds de la face de l'element 
* NUDLFA tableau de la numerotation locale des d.l. de la face de l'element
* NIVIMP niveau d'impression (pas d'impression si nul)
* IMPFCH numero d'unite d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) VARIAB(*)
      INTEGER       NDIM,NDMDOM,NBELDO,NBCNVE,NBPTEX,LGCORL,NIVIMP
     &             ,IMPFCH
      INTEGER       BLOKEL(*),LISTEL(*),ICORPL(*),ISGDET(*),NUNEFA(*)  
     &             ,NUDLFA(*)  
      REAL          CORPTG(*),CORPTL(*)
*
      INTEGER       LISRAN,NUTYAV,NUFAAV,LEMENT,NUEL,NUF,NUTGEO,NTYA
     &             ,NBNE,NBDLEL,ICORPT,NIVIMO
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoDoFa*')
*  
      LGCORL=1 
      LISRAN=0 
      NUTYAV=0 
      NUFAAV=0
      DO 1 LEMENT=1,NBELDO
         NIVIMO=0
         IF (NIVIMP.GT.10.OR.LEMENT.LE.10*NIVIMP) NIVIMO=NIVIMP
         LISRAN=LISRAN+1
         NUEL=LISTEL(LISRAN)
         LISRAN=LISRAN+1
         NUF=LISTEL(LISRAN)
*        Numero de type geometrique de l'element
         CALL EXBLOK (NUEL,BLOKEL,NUTGEO)                               !sdexplo
*        Attributs de la face de dimension NDMDOM  
         IF (NUTYAV.NE.NUTGEO.OR.NUFAAV.NE.NUF)
     &   CALL ELEMFA (NUTGEO,NDMDOM,NUF,NTYA,NBNE,NUNEFA,NBDLEL,NUDLFA) !ef?d
         NUTYAV=NUTGEO 
         NUFAAV=NUF
         ICORPT=2+(NUEL-1)*(1+NDIM*NBPTEX) 
         ICORPL(LGCORL)=NBDLEL 
         ICORPL(LGCORL+1)=ISGDET(ICORPT-1) 
         IF (NIVIMO.GT.0) THEN
            IF(NDMDOM.EQ.2) WRITE (IMPFCH,1000) 'a face ',NUF,NUEL
     &                                        ,LEMENT,ICORPL(LGCORL+1)
            IF(NDMDOM.EQ.1) WRITE (IMPFCH,1000) '''arete',NUF,NUEL
     &                                        ,LEMENT,ICORPL(LGCORL+1)
            IF(NDMDOM.LE.0) WRITE (IMPFCH,1000) 'e point',NUF,NUEL
     &                                        ,LEMENT,ICORPL(LGCORL+1)
         ENDIF
         LGCORL=LGCORL+2
         CALL SACHA (NDIM,NBCNVE,VARIAB,CORPTG(ICORPT),NBDLEL           !cordom
     &              ,CORPTL(LGCORL),1,NUDLFA,NIVIMO,IMPFCH)
         LGCORL=LGCORL+NDIM*NBDLEL
1     CONTINUE
      LGCORL=LGCORL-1
      CALL PRFXMJ (-1,'*CoDoFa*') 
*----------------------------------------------------------------------- 
1000  FORMAT(T5,'*CoDoFa Coordonnees sur l',A,I2,' de l''element No',I5
     &,' de rang',I5,' (orientation:',SP,I2,')')
                                                                    END !CoDoFa
