*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CODOVO (NDIM,NDMDOM,NDMDOE,NBELDO,NBCNVE,VARIAB,BLOKEL
     &                  ,LISTEL,NBPTEX,ISGDET,CORPTG,ICORPL,CORPTL
     &                  ,LGCORL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.deBayser (Mai 1988)  
* Derniere modification : D.Martin (30 Novembre 1999)
*  
* Redistribution par domaine des coordonnees des points
* Cas des domaines de dimension NDIM  (domaines ''volumiques'')
* ou des domaines necessitant une extension en ligne ou en colonne 
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* NDMDOM dimension des constituants domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NBELDO nombre d'elements (ou de couple element-face/arete) du domaine
* NBCNVE nombre de caracteres par nom de variable d'espace
* VARIAB noms des variables d'espace (tableau CHARACTER*1 de longueur NBCNVE) 
* BLOKEL tableau des caracteristiques des blocs d'elements du maillage
*          consecutifs de meme type
* LISTEL tableau descriptif des listes d'elements par domaine
* ISDGET indicateur de l'orientation de l'element 
* NBPTEX nombre max. de point dans un element du maillage 
* CORPTG coordonnees globales des points par element pour tout le maillage
* ICORPL memoires du tableau CORPTL utilisees par le stockage du nombre
*        de points de chaque 'element' du domaine de calcul .
* CORPTL coordonnees des points du maillage par 'element' du domaine  
* LGCORL longueur des tableaux CORPTL et ICORPL (en sortie)  
* NIVIMP niveau d'impression (pas d'impression si nul)
* IMPFCH numero d'unite d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) VARIAB(*)
      INTEGER       NDIM,NDMDOM,NDMDOE,NBELDO,NBCNVE,NBPTEX,LGCORL
     &             ,NIVIMP,IMPFCH
      INTEGER       BLOKEL(*),LISTEL(*),ICORPL(*),ISGDET(*)
      REAL          CORPTG(*),CORPTL(*)
*
      INTEGER       LISRAN,NUTYAV,LEMENT,NUEL,NUTGEO,LAG,KCL,NBSOMT
     &             ,NBARET,NBFACE,NBPT,NBDLEL,NBNF,NBPTSF,NBNA,NBPTSA
     &             ,ICORPT,IBID,NIVIMO
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoDoVo*')
*  
      LGCORL=1 
      LISRAN=0 
      NUTYAV=0 
      DO 1 LEMENT=1,NBELDO
         NIVIMO=0
         IF (NIVIMP.GT.10.OR.LEMENT.LE.10*NIVIMP) NIVIMO=NIVIMP
         LISRAN=LISRAN+1
         NUEL=LISTEL(LISRAN)
         IF (NDMDOM.LT.NDMDOE) LISRAN=LISRAN+1
*        Numero de type geometrique et nombre de points de l'element
         CALL EXBLOK (NUEL,BLOKEL,NUTGEO)                               !sdexplo
         IF (NUTYAV.NE.NUTGEO) 
     &      CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE            !ef3d
     &                  ,NBPT,NBDLEL,NBNA,NBPTSA,NBNF,NBPTSF)
         NUTYAV=NUTGEO 
         ICORPT=2+(NUEL-1)*(1+NDIM*NBPTEX) 
         ICORPL(LGCORL)=NBDLEL 
         ICORPL(LGCORL+1)=ISGDET(ICORPT-1) 
         IF (NIVIMO.GT.0)
     &      WRITE(IMPFCH,1000) NUEL,LEMENT,ICORPL(LGCORL+1)
         LGCORL=LGCORL+2
         CALL SACHA  (NDIM,NBCNVE,VARIAB,CORPTG(ICORPT),NBDLEL          !cordom
     &               ,CORPTL(LGCORL),0,IBID,NIVIMO,IMPFCH)
         LGCORL=LGCORL+NDIM*NBDLEL
1     CONTINUE 
      LGCORL=LGCORL-1
      CALL PRFXMJ (-1,'*CoDoVo*')
*----------------------------------------------------------------------- 
1000  FORMAT(T5,'*CoDoVo* Coordonnees dans l''element No',I5,' de rang'  
     &,I5,' (orientation:',SP,I2,')') 
                                                                    END !CoDoVo
