*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COCOGR (NBCSTG,NUCSTG,NMWRKC,NVWRKC
     &                  ,NMTBAS,NVTBAS,TYTBAS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1995)
* Derniere modification D.Martin (11 Juillet 1997)
*
* Constantes ou tableau pour les calculs de fonctions de Green
*
*-- Arguments --
* NBCSTG nombre de donnees associees de la fonction de Green
* NUCSTG tableau des numeros de ces donnees
* NMWRKC nom du tableau de travail pour les constantes associees (COMPLEXE) 
* NVWRKC son niveau
* NMTBAS nom du tableau associe a la fonction de Green
* NVTBAS son niveau
* TYTBAS son type (ENTIER, REEL ou COMPLEXE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMWRKC,NMTBAS,TYTBAS
      INTEGER       NBCSTG,NUCSTG(*),NVWRKC,NVTBAS
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER*4   TYPINT                                              !Utilite
      INTEGER       INTDON                                              !Utilite
      INTEGER       MCMDON,MCDONN,MCESTE,MCRSTE,MCCSTE,NBTBAS
     &             ,LGEDON,NBDONN,INCDON,NCHDON,MCWRKC,ITTBAS
     &             ,ITYDON,NIVDON,ITDONN,INTDOC,I
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoCoGr*')
*
      INTDOC=INTDON ('CONSTANTE')                                       !Utilite
*  
*     Recherche de la valeur des constantes associees a la fonction de Green
*  
      NBTBAS=0
      IF (NBCSTG.GE.1) THEN
         CALL TBAR5  (ERCODE, NMWRKC ,NVWRKC,MCWRKC
     &                      ,'$DONNE',1,MCDONN,'$ECSTE',1,MCESTE
     &                      ,'$RCSTE',1,MCRSTE,'$CCSTE',1,MCCSTE)
         CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)          !Sdexplo
         DO 12 I=1,NBCSTG
            CALL SDEXCO (NUCSTG(I),IST(MCDONN),ITYDON,NIVDON,ITDONN)    !Sdexplo
            CST(MCWRKC)=(0.,0.)
            IF (ITYDON.EQ.INTDOC) THEN
               CALL OUTCST (NIVDON,ITDONN,IST(2*MCWRKC-1)
     &                     ,RST(2*MCWRKC-1),CST(MCWRKC),ERCODE)         !Sdexplo
            ELSEIF (ITYDON.EQ.INTDON ('TABLEAU')) THEN                  !Utilite
               CALL TBAR1  (ERCODE,'#OMDON',1,MCMDON)
               CALL GETCHN (AST(MCMDON),NCHDON,NUCSTG(I),NMTBAS)
               NVTBAS = NIVDON
               ITTBAS = ITDONN
               NBTBAS = NBTBAS +1
            ENDIF
            MCWRKC = MCWRKC+1
12       CONTINUE
      ENDIF
*
*     Cas d'un tableau associe au calcul de la fonction
*
      IF (NBTBAS.EQ.1) THEN
         CALL TBRR1  (ERCODE,NMTBAS,NVTBAS,MCWRKC)
         TYTBAS=TYPINT(ITTBAS)                                          !Utilite
      ELSEIF (NBTBAS.GT.1) THEN
         CALL ENCLER (NMTBAS,ERCODE(1:3))                               !Utilite
         CALL BAISE  ('Un tableau AU PLUS peut etre associe au calcul '
     &              //'de la fonction de Green. On en a trouve '
     &              //ERCODE(1:3))                                      !Utilite
      ENDIF
      CALL PRFXMJ (-1,'*CoCoGr*')
*-----------------------------------------------------------------------
                                                                    END !CoCoGr
