*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COGNOP (NMGDNO,NVGDNO,NMPDEL,NVPDEL
     &                  ,NMCOUP,NVCOUP,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995)
* Derniere modification : D.Martin (13 Fevrier 1998)
*  
* Calcul d'une matrice de couplage par produit d'une matrice (Gdelta*Noyau)
* (calculee par CoGdNo) et d'une matrice Pdelta.
*  
*-- Arguments d'entree -- 
* NMGDNO/NVGDNO nom/niveau du terme contenant le produit Gdelta * Noyau
* NMPDEL/NVPDEL nom/niveau de la matrice Pdelta 
* NMCOUP/NVCOUP nom/niveau du terme contenant la matrice de couplage resultat
* NIVIMP niveau d'impression de la matrice de couplage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMGDNO,NMPDEL,NMCOUP
      INTEGER       NVGDNO,NVPDEL,NVCOUP,NIVIMP
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      CHARACTER TYPINT*4                                                !utilite
      CHARACTER ERCODE*120,NMINCO*16,TYCOUP*4
      INTEGER   INDSTO,KLTERM,INTTYP,INTYKL                             !utilite
      INTEGER   MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &         ,MCMINC,LGEINC,NBINCO,INCINC,NCHINC,MCCONU,NUTERM
     &         ,NIVEAU,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR,INDSTK,NVSTOK
     &         ,NVCOOR,IATRDO,ITGDNO,ITPDEL,ITYSYP,INSTOP,NVSTOP,NVCOPD
     &         ,INCOGC,NVDUCG,KOGDNO,NVNUCG,INCOGL,NVDULG,LIGDEL,NVNULG
     &         ,INCOPC,NVDUCP,KOPDEL,NVNUCP,INCOPL,NVDULP,LIPDEL,NVNULP
     &         ,ITCOUP
      LOGICAL   CRETRM
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoGnoP*')
*
*--   Tableaux de gestion des Termes et Inconnues
*
      CALL TBAR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMINC',1,MCMINC,'#NCONU',1,MCCONU)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCCONU),LGEINC,NBINCO,INCINC,NCHINC)             !sdexplo
*
*--   Attributs du terme Gdelta*Noyau
*
      NUTERM=KLTERM (NMGDNO,NVGDNO,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMGDNO,NVGDNO)                    !utilite  
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &            ,NIVEAU,ITGDNO,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &            ,INCOGC,NVDUCG,KOGDNO,NVNUCG,INCOGL,NVDULG,LIGDEL
     &            ,NVNULG,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVIMQ)           !sdexplo
*  
*--   Attributs du terme NMPDEL,NVPDEL (Pdelta) defini sur la frontiere
*     de calcul de la representation integrale Gamma
*
      NUTERM=KLTERM (NMPDEL,NVPDEL,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMPDEL,NVPDEL)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
     &            ,NIVEAU,ITPDEL,ITYCAL,NUKALE,NUDONN,ITYSYP,IPTDIR
     &            ,INCOPC,NVDUCP,KOPDEL,NVNUCP,INCOPL,NVDULP,LIPDEL
     &            ,NVNULP,INSTOP,NVSTOP,NVCOPD,IATRDO,NIVIMQ)           !sdexplo
*
      CALL GETCHN (AST(MCMINC),NBINCO,INCOPC,NMINCO(1:NCHINC))          !utilite
      CALL SDEXCO (INCOPC,IST(MCCONU),NCPIPC,INTIPC,NBTNEU)             !sdexplo
      IF (NCPIPC.GT.1) CALL ERINCO (2,NMINCO(1:NCHINC))                 !utilite
      IF (INTIPC.LE.0) CALL ERINCO (4,NMINCO(1:NCHINC))                 !utilite
      CALL GETCHN (AST(MCMINC),NBINCO,INCOPL,NMINCO(1:NCHINC))          !utilite
      CALL SDEXCO (INCOPL,IST(MCCONU),NCPIPL,INTIPL,NBTNEU)             !sdexplo
      IF (NCPIPL.GT.1) CALL ERINCO (2,NMINCO(1:NCHINC))                 !utilite
      IF (INTIPL.LE.0) CALL ERINCO (4,NMINCO(1:NCHINC))                 !utilite
      IF (INCOGC.NE.INCOPL) GOTO 99991
      IF (KOGDNO.NE.LIPDEL) GOTO 99992
*
      ITCOUP=ITGDNO 
      IF (ITPDEL.EQ.INTTYP('COMPLEXE')) ITCOUP=ITPDEL
      TYCOUP=TYPINT (ITCOUP)                                            !utilite
*
*     Type de stockage de la matrice de couplage
      IF (INCOGL.GE.INCOPC) THEN
*        Stockage du terme sous forme Plein-Ligne
         INDSTK=INDSTO ('PLEIN-L')                                      !utilite
*        Increment lors d'un changement dans la ligne/colonne
         INCREL=KOPDEL
         INCREC=1
      ELSE
*        Stockage du terme sous forme Plein-Colonne
         INDSTK=INDSTO ('PLEIN-C')                                      !utilite
*        Increment lors d'un changement dans la ligne/colonne 
         INCREL=1
         INCREC=LIGDEL
      ENDIF
*  
*--   Calcul de la matrice de couplage (Gdelta)*(Noyau) * (Pdelta)
*
      ITYCAL = INTYKL('COUPLA')                                         !utilite
      NUKALE = 1
      CALL CRTERM (NMCOUP,NVCOUP,LIGDEL*KOPDEL,ITCOUP,ITYCAL,NUKALE
     &            ,NDFDON,NDFSYM,NDFDSM,INCOPC,NDFDUM,KOPDEL,NVNUCP
     &            ,INCOGL,NDFDUM,LIGDEL,NVNULG,INDSTK,NDFSTO,NVCOPD
     &            ,NDFNDF,NIVIMP,.FALSE.,CRETRM)                        !sdexplo
      CALL TBAR1  (ERCODE,NMCOUP,NVCOUP,MCCOUP)
      CALL TAZERO (LIGDEL*KOPDEL,TYCOUP,MCCOUP,AST,IST,RST,CST)         !utilite
*
      CALL COMOPL ('PLMO',NMPDEL,NVPDEL,ITPDEL,ITYSYP,INSTOP,NVSTOP
     &            ,1,KOPDEL,NMGDNO,NVGDNO,ITGDNO,1,LIPDEL,1,LIGDEL
     &            ,NMCOUP,NVCOUP,ITCOUP,INCREL,INCREC,NCHTRM,NIVIMP)    !couplag
*
      IF (NIVIMP.GT.0) CALL PRTERM (NMCOUP,NVCOUP,NIVIMP,IMPSDR)        !prsd
      CALL TBSAVE (NMCOUP,NVCOUP)
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMCOUP,NVCOUP,ERCODE,NCATR1)
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
      ENDIF
      CALL PRFXMJ (-1,'*CoGnoP*') 
      RETURN 
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*CoGnoP* Calcul de la matrice de couplage ',A)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMGDNO,NVGDNO,ERCODE,NCATR1)
      CALL PRNTRM (NMPDEL,NVPDEL,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  ('Incoherence entre les inconnues en colonne de '
     &//ERCODE(1:NCATR1)//' et en ligne de la matrice '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2))
99992 CALL PRNTRM (NMPDEL,NVPDEL,ERCODE,NCATR1)
      CALL BAISE  ('Incoherence entre le nombre de noeuds sur Gamma'
     &//' et le nombre de colonnes de la matrice '//ERCODE(1:NCATR1))
                                                                    END !CoGnoP
