*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COGNRG (SIMPLE,DOUBLE,NBNSIL,IRGNSL,TYGDNO
     &                  ,TBGDNS,TBGDND,COLONS,MCGDNS,MCGDND,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995)
* Derniere modification : D.Martin (9 Decembre 1997)
*
* Rangement des contributions de l'element en cours pour les matrices
*       Gdelta_{i,l} * G(P_k,M_l)        (noyau de simple couche)
* et    Gdelta_{i,l} * dG/dn_P(P_k,M_l)   (noyau de double couche)
* (construites en numerotation dans l'element de Sigma en cours)
* dans les matrices globales (en numerotation globale sur Sigma)
*
*-- Arguments --
* DOUBLE indicateur de calcul des noyaux de double couche
* SIMPLE indicateur de calcul des noyaux de simple couche
* NBNSIL nombre de noeuds en ligne pour la matrice Gdelta
* IRGNSL numero des noeuds de l'element de Sigma en cours
* TYGDNO type (REEL ou COMPLEXE) des matrices noyaux 
* TBGDNS matrice locale Gdelta_{i,l} * G(P_k,M_l) COMPLEXE
* TBGDND matrice locale Gdelta_{i,l} * dG/dn_P(P_k,M_l) COMPLEXE
* COLONS nombre de colonnes des termes resultats
* MCGDNS adresse de la matrice globale Gdelta_{i,l} * G(P_k,M_l)
* MCGDND adresse de la matrice globale Gdelta_{i,l} * dG/dn_P(P_k,M_l)
* RST    super-tableau version reelle
* CST    super-tableau version complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL       SIMPLE,DOUBLE
      CHARACTER*(*) TYGDNO
      INTEGER       COLONS,NBNSIL,IRGNSL(*),MCGDNS,MCGDND
      REAL          RST(*)
      COMPLEX       TBGDND(NBNSIL,*),TBGDNS(NBNSIL,*),CST(*)
*
      INTEGER       ADRS,ISIG,KGAM,MCGS,MCGD
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoGnRg*')
*
      IF (SIMPLE.AND.DOUBLE) THEN
         IF (TYGDNO(1:1).EQ.'C') THEN
            DO 3441 ISIG=1,NBNSIL
               ADRS = COLONS*(IRGNSL(ISIG)-1)
               MCGD = MCGDND+ADRS
               MCGS = MCGDNS+ADRS
               DO 3440 KGAM=1,COLONS
                  CST(MCGD) = CST(MCGD)+TBGDND(ISIG,KGAM)
                  MCGD      = MCGD+1
                  CST(MCGS) = CST(MCGS)+TBGDNS(ISIG,KGAM)
                  MCGS      = MCGS+1
3440           CONTINUE
3441        CONTINUE
         ELSE
            DO 3241 ISIG=1,NBNSIL
               ADRS = COLONS*(IRGNSL(ISIG)-1)
               MCGD = MCGDND+ADRS
               MCGS = MCGDNS+ADRS
               DO 3240 KGAM=1,COLONS
                  RST(MCGD) = RST(MCGD)+REAL(TBGDND(ISIG,KGAM))
                  MCGD      = MCGD+1 
                  RST(MCGS) = RST(MCGS)+REAL(TBGDNS(ISIG,KGAM))
                  MCGS      = MCGS+1
3240           CONTINUE
3241        CONTINUE
         ENDIF
      ELSEIF (SIMPLE) THEN
         IF (TYGDNO(1:1).EQ.'C') THEN
            DO 1441 ISIG=1,NBNSIL
               MCGS = MCGDNS+COLONS*(IRGNSL(ISIG)-1)
               DO 1440 KGAM=1,COLONS
                  CST(MCGS) = CST(MCGS)+TBGDNS(ISIG,KGAM)
                  MCGS      = MCGS+1
1440           CONTINUE
1441        CONTINUE
         ELSE
            DO 1241 ISIG=1,NBNSIL
               MCGS = MCGDNS+COLONS*(IRGNSL(ISIG)-1)
                  DO 1240 KGAM=1,COLONS
                  RST(MCGS) = RST(MCGS)+REAL(TBGDNS(ISIG,KGAM))
                  MCGS      = MCGS+1
1240           CONTINUE
1241        CONTINUE
         ENDIF
      ELSEIF (DOUBLE) THEN
         IF (TYGDNO(1:1).EQ.'C') THEN
            DO 2441 ISIG=1,NBNSIL
               MCGD = MCGDND+COLONS*(IRGNSL(ISIG)-1)
               DO 2440 KGAM=1,COLONS
                  CST(MCGD) = CST(MCGD)+TBGDND(ISIG,KGAM)
                  MCGD      = MCGD+1 
2440           CONTINUE
2441        CONTINUE
         ELSE
            DO 2241 ISIG=1,NBNSIL
               MCGD = MCGDND+COLONS*(IRGNSL(ISIG)-1)
                  DO 2240 KGAM=1,COLONS
                  RST(MCGD) = RST(MCGD)+REAL(TBGDND(ISIG,KGAM))
                  MCGD      = MCGD+1 
2240           CONTINUE
2241        CONTINUE
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*CoGnRg*')
                                                                    END !CoGnRg
