*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COMOPL (SBMOPL,NMMORS,NVMORS,ITMORS,ITYMOR,INDMOR
     &                  ,NVSTOK,IPRMOR,IDRMOR,NMPLEI,NVPLEI,ITPLEI
     &                  ,IPRCOL,IDRCOL,IPRLIG,IDRLIG,NMRESU,NVRESU
     &                  ,ITRESU,INCREL,INCREC,NCHTRM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1995)
* Derniere modification : D.Martin (13 Fevrier 1998)
*  
* 1) Multiplication d'une matrice (Bi)Morse (Gdelta) et d'une matrice pleine 
*   (Noyau) 
* 2) Multiplication d'une matrice pleine (Gdelta*Noyau) et d'une matrice 
*    (Bi)Morse(Pdelta) 
* pour le calcul des termes de couplage  Elements Finis/Rep.Integrale
*  
*-- Arguments d'entree -- 
* SBMOPL chaine de caractere 'MOPL' (cas 1) ou 'PLMO' (cas 2)
* NMMORS nom de la matrice Morse (Pdelta ou Gdelta) 
* NVMORS son niveau
* ITMORS son numero de type ('REEL' ou 'COMPLEXE')
* ITYMOR son numero de type de symetrie
* INDMOR son numero de type de stockage
* NVSTOK le numero de son tableau de pointeurs de stockage
* IPRMOR premiere colonne de la matrice Morse
* IDRMOR derniere colonne de la matrice Morse
* NMPLEI nom de la matrice pleine (Noyau ou 'Gdelta*Noyau')
* NVPLEI son niveau
* ITPLEI son numero de type ('REEL' ou 'COMPLEXE')
* IPRCOL premiere colonne de la matrice pleine
* IDRCOL derniere colonne de la matrice pleine
* IPRLIG premiere ligne de la matrice pleine
* IDRLIG derniere ligne de la matrice pleine
* NMRESU nom de la matrice resultat (Gdelta*Noyau ou matrice de couplage)
* NVRESU niveau de la matrice resultat
* ITRESU son type ('REEL' ou 'COMPLEXE')
* INCREL 
* INCREC 
* NIVIMP niveau d'impression des termes de couplage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) SBMOPL,NMMORS,NMPLEI,NMRESU
      INTEGER       NVMORS,ITMORS,ITYMOR,INDMOR,NVSTOK,IPRMOR,IDRMOR
     &             ,NVPLEI,ITPLEI,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &             ,NVRESU,ITRESU,INCREL,INCREC,NCHTRM,NIVIMP
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      CHARACTER SYMIND*14,TYPINT*4                                      !utilite
      CHARACTER ERCODE*120,TYMORS*4,TYPLEI*4,TYRESU*4
      INTEGER   INDSTO,INDSYM                                           !utilite
      INTEGER   INDSYY,MCMORS,MCSTOK
     &         ,MCPLEI,MCRESU,NBLIGN,NBCOLO,NBPLAL,MCPLAL,MCPLIL
     &         ,LGMORL,NBPLAU,MCPLAU,MCPLIU,LGMORU
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoMoPl*')
*
      INDSYY = INDSYM ('SYMETRIQUE')                                    !utilite
      TYMORS = TYPINT (ITMORS)                                          !utilite
      TYPLEI = TYPINT (ITPLEI)                                          !utilite
      TYRESU = TYPINT (ITRESU)                                          !utilite
*
      CALL TBRR2  (ERCODE,NMMORS,NVMORS,MCMORS,NMPLEI,NVPLEI,MCPLEI)
*
      IF (INDMOR.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         CALL TBRR1  (ERCODE,'&BMORS',NVSTOK,MCSTOK)
         CALL TBAR4  (ERCODE,NMMORS,NVMORS,MCMORS,NMPLEI,NVPLEI,MCPLEI
     &                     ,NMRESU,NVRESU,MCRESU,'&BMORS',NVSTOK,MCSTOK)
*
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBLIGN,NBPLAL,MCPLAL,MCPLIL 
     &               ,LGMORL,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGMORU)        !sdexplo
         CALL DPL    (IPRMOR,IDRMOR,TYMORS,MCMORS,IPRCOL,IDRCOL
     &               ,IPRLIG,IDRLIG,TYPLEI,MCPLEI,INCREL,INCREC
     &               ,TYRESU,MCRESU,RST,CST)                            !multmat
         MCMORS=MCMORS+MIN(NBLIGN,NBCOLO)
*
         IF (SBMOPL(1:4).EQ.'MOPL') THEN
*
            IF (ITYMOR.EQ.INDSYY) THEN
               CALL BMUPL  (IPRMOR,IDRMOR,IST(MCPLAL),IST(MCPLIL),TYMORS
     &                     ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG,TYPLEI
     &                     ,MCPLEI,INCREL,INCREC,TYRESU,MCRESU,RST,CST) !multmat
            ELSEIF (ITYMOR.EQ.NDFSYM) THEN
               CALL BMUPL  (IPRMOR,IDRMOR,IST(MCPLAU),IST(MCPLIU),TYMORS
     &                     ,MCMORS+LGMORL,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &                     ,TYPLEI,MCPLEI,INCREL,INCREC
     &                     ,TYRESU,MCRESU,RST,CST)                      !multmat
            ELSE
               GOTO 99991
            ENDIF
*
            CALL BMLPL (IPRMOR,IDRMOR,IST(MCPLAL),IST(MCPLIL),TYMORS
     &                 ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &                 ,TYPLEI,MCPLEI,INCREL,INCREC
     &                 ,TYRESU,MCRESU,RST,CST)                          !multmat
*
         ELSEIF (SBMOPL(1:4).EQ.'PLMO') THEN
*
            IF (ITYMOR.EQ.INDSYY) THEN
               CALL BMLPL  (IPRMOR,IDRMOR,IST(MCPLAL),IST(MCPLIL),TYMORS
     &                     ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &                     ,TYPLEI,MCPLEI,INCREL,INCREC
     &                     ,TYRESU,MCRESU,RST,CST)                      !multmat
            ELSEIF (ITYMOR.EQ.NDFSYM) THEN
               CALL BMLPL  (IPRMOR,IDRMOR,IST(MCPLAU),IST(MCPLIU),TYMORS
     &                     ,MCMORS+LGMORL,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &                     ,TYPLEI,MCPLEI,INCREL,INCREC
     &                     ,TYRESU,MCRESU,RST,CST)                      !multmat
            ELSE
               GOTO 99991
            ENDIF
*
            CALL BMUPL (IPRMOR,IDRMOR,IST(MCPLAL),IST(MCPLIL),TYMORS
     &                 ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &                 ,TYPLEI,MCPLEI,INCREL,INCREC
     &                 ,TYRESU,MCRESU,RST,CST)                          !multmat
         ENDIF
         CALL TBSAVE ('&BMORS',NVSTOK)
*
      ELSEIF (INDMOR.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
*
         CALL TBRR1  (ERCODE,'&PLAGE',NVSTOK,MCSTOK)
         CALL TBAR4  (ERCODE,NMMORS,NVMORS,MCMORS,NMPLEI,NVPLEI,MCPLEI
     &                    ,NMRESU,NVRESU,MCRESU,'&PLAGE',NVSTOK,MCSTOK)
*
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBLIGN,NBCOLO,NBPLAL
     &               ,MCPLAL,MCPLIL,LGMORL)                             !sdexplo
         CALL MOPL   (IPRMOR,IDRMOR,IST(MCPLAL),IST(MCPLIL),TYMORS
     &               ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &               ,TYPLEI,MCPLEI,INCREL,INCREC
     &               ,TYRESU,MCRESU,RST,CST)                            !multmat
         CALL TBSAVE ('&PLAGE',NVSTOK)
*
      ELSEIF (INDMOR.EQ.INDSTO ('MORSE-C')) THEN
*
         CALL TBRR1  (ERCODE,'&EGALP',NVSTOK,MCSTOK)
         CALL TBAR4  (ERCODE,NMMORS,NVMORS,MCMORS,NMPLEI,NVPLEI,MCPLEI
     &                    ,NMRESU,NVRESU,MCRESU,'&EGALP',NVSTOK,MCSTOK)
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBCOLO,NBLIGN,NBPLAU
     &               ,MCPLAU,MCPLIU,LGMORL)                             !sdexplo
*
         CALL MOPL   (IPRMOR,IDRMOR,IST(MCPLAU),IST(MCPLIU),TYMORS
     &               ,MCMORS,IPRCOL,IDRCOL,IPRLIG,IDRLIG
     &               ,TYPLEI,MCPLEI,INCREL,INCREC
     &               ,TYRESU,MCRESU,RST,CST)                            !multmat
         CALL TBSAVE ('&EGALP',NVSTOK)
*
      ELSE
         CALL ERTERM (18,NMMORS,NVMORS)                                 !utilite
      ENDIF
*
      CALL TBSAVE (NMMORS,NVMORS)
      CALL TBSAVE (NMPLEI,NVPLEI)
      CALL PRFXMJ (-1,'*CoMoPl*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMMORS,NVMORS,ERCODE,NCATR1)
      CALL BAISE  ('La matrice '//ERCODE(1:NCATR1)
     &//' ne peut etre '//SYMIND(ITYMOR))
                                                                    END !CoMoPl
