*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COSLDN (SIMPLE,DOUBLE,LIPDEL,ELTSIG,NBNSIC,NBNSIL
     &                  ,TYGDEL,MCGDEL,TYNOYO,MCNOYS,MCNOYD
     &                  ,TYGDNO,GDNOYS,GDNOYD,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995)
* Derniere modification D.Martin (13 Juillet 1997)
*
* Contribution d'une face de Sigma au calcul des produits de la matrice Gdelta
* et des noyaux de Simple et Doucble couche :
*     Gdelta_{i,l} * G(P_k,M_l) et Gdelta_{i,l} * dG/dn_P(P_k,M_l)
*
*-- Arguments --
* SIMPLE indicateur de calcul des noyaux de simple couche
* DOUBLE indicateur de calcul des noyaux de double couche
* LIPDEL nombre de d.l. sur Gamma = nombre de colonnes des termes de couplage
* ELTSIG numero de l'element de Sigma en cours
* NBNSIC nombre de noeuds en colonne pour la matrice Gdelta
* NBNSIL nombre de noeuds en ligne pour la matrice Gdelta
* TYGDEL type de la matrice elementaire Gdelta sur la face de Sigma en cours
* MCGDEL adresse de la matrice elementaire Gdelta sur la face de Sigma en cours
* TYNOYO type (REEL ou COMPLEXE) des noyaux de Green
* MCNOYS adresse de la matrice noyau de simple couche locale G(P_k,M_l)
* MCNOYD adresse de la matrice noyau de double couche locale dG/dn_P(P_k,M_l)
* GDNOYS matrice locale Gdelta_{i,l} * G(P_k,M_l) COMPLEXE
* GDNOYD matrice locale Gdelta_{i,l} * dG/dn(P_k,M_l) COMPLEXE
* RST    super-tableau version reelle
* CST    super-tableau version complexe
* NIVIMP niveau d'impression  
* IMPFCH numero de l'unite logique des impressions
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL       DOUBLE,SIMPLE
      CHARACTER*(*) TYGDEL,TYNOYO,TYGDNO
      INTEGER       LIPDEL,ELTSIG,NBNSIC,NBNSIL,MCGDEL
     &             ,MCNOYS,MCNOYD,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       GDNOYD(NBNSIL,*),GDNOYS(NBNSIL,*),CST(*)
*
      INTEGER ISIG,LSIG,KGAM,MCGDE1,MCGDE2,ADNOYS,ADNOYD
      REAL    RGDEL
      COMPLEX CGDEL
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoSlDn*')
*
      IF (NIVIMP.GT.3) WRITE (IMPFCH,90000) ELTSIG
      MCGDE1 = MCGDEL
      ADNOYS = MCNOYS
      ADNOYD = MCNOYD
*
      IF (DOUBLE.AND.SIMPLE) THEN
*
         IF (TYGDEL(1:1).EQ.'R') THEN
*
*--         Cas d'une matrice Gdelta reelle
*
            DO 3425 LSIG = 1,NBNSIC
               DO 3423 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 3421 ISIG = 1,NBNSIL
                     RGDEL  = RST(MCGDE2)
                     GDNOYD(ISIG,KGAM) 
     &                      = GDNOYD(ISIG,KGAM)+RGDEL*CST(ADNOYD)
                     GDNOYS(ISIG,KGAM) 
     &                      = GDNOYS(ISIG,KGAM)+RGDEL*CST(ADNOYS)
                     MCGDE2 = MCGDE2 +1
3421              CONTINUE
                  ADNOYD = ADNOYD+1
                  ADNOYS = ADNOYS+1
3423           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
3425        CONTINUE
*
         ELSE
*
*--         Cas d'une matrice Gdelta complexe
*
            DO 3445 LSIG = 1,NBNSIC
               DO 3443 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 3441 ISIG = 1,NBNSIL
                     CGDEL  = CST(MCGDE2)
                     GDNOYD(ISIG,KGAM) 
     &                      = GDNOYD(ISIG,KGAM)+CGDEL*CST(ADNOYD)
                     GDNOYS(ISIG,KGAM) 
     &                      = GDNOYS(ISIG,KGAM)+CGDEL*CST(ADNOYS)
                     MCGDE2 = MCGDE2 +1
3441              CONTINUE
                  ADNOYD = ADNOYD+1
                  ADNOYS = ADNOYS+1
3443           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
3445        CONTINUE
*
         ENDIF
      ELSEIF (SIMPLE) THEN
         IF (TYGDEL(1:1).EQ.'R') THEN
            DO 1425 LSIG = 1,NBNSIC
               DO 1423 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 1421 ISIG = 1,NBNSIL
                     GDNOYS(ISIG,KGAM) 
     &                      = GDNOYS(ISIG,KGAM)+RST(MCGDE2)*CST(ADNOYS)
                     MCGDE2 = MCGDE2 +1
1421              CONTINUE
                  ADNOYS = ADNOYS+1
1423           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
1425        CONTINUE
         ELSE
            DO 1445 LSIG = 1,NBNSIC
               DO 1443 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 1441 ISIG = 1,NBNSIL
                     GDNOYS(ISIG,KGAM) 
     &                      = GDNOYS(ISIG,KGAM)+CST(MCGDE2)*CST(ADNOYS)
                     MCGDE2 = MCGDE2 +1
1441              CONTINUE
                  ADNOYS = ADNOYS+1
1443           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
1445        CONTINUE
        ENDIF
      ELSEIF (DOUBLE) THEN
*
         IF (TYGDEL(1:1).EQ.'R') THEN
            DO 2425 LSIG = 1,NBNSIC
               DO 2423 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 2421 ISIG = 1,NBNSIL
                     GDNOYD(ISIG,KGAM) 
     &                      = GDNOYD(ISIG,KGAM)+RST(MCGDE2)*CST(ADNOYD)
                     MCGDE2 = MCGDE2 +1
2421              CONTINUE
                  ADNOYD = ADNOYD+1
2423           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
2425        CONTINUE
         ELSE
            DO 2445 LSIG = 1,NBNSIC
               DO 2443 KGAM = 1,LIPDEL
                  MCGDE2 = MCGDE1
                  DO 2441 ISIG = 1,NBNSIL
                     GDNOYD(ISIG,KGAM) 
     &                     = GDNOYD(ISIG,KGAM)+CST(MCGDE2)*CST(ADNOYD)
                     MCGDE2 = MCGDE2 +1
2441              CONTINUE
                  ADNOYD = ADNOYD+1
2443           CONTINUE
               MCGDE1 = MCGDE1+NBNSIL
2445        CONTINUE
         ENDIF
      ENDIF
*
      MCGDEL = MCGDE1
      CALL PRFXMJ (-1,'*CoSlDn*')
*-----------------------------------------------------------------------
90000 FORMAT (/T2,'*CoSLDN   Produits elementaires Gdelta*Noyau sur ',
     &'l''element No ',I6)
                                                                    END !CoSLDN
