*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COSLGN (KPERSO,INTRGL,NVNLGA,NVNOGA,LIPDEL,INTRSC
     &                  ,NVNCSI,LIGDEL,NMGDEL,NVGDEL,ITGDEL,IATRSI
     &                  ,ITNOYO,KLNOYO,TYFGRE,LAMBDC,NMTBAS,NVTBAS
     &                  ,TYTBAS,ITGDNO,NMGDNS,NVGDNS,NMGDND,NVGDND
     &                  ,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995)
* Derniere modification D.Martin (9 Decembre 1997)
*  
* Calcul des produits Gdelta * Noyau pour les termes de COuplage elements finis
* representation integrale pour un domaine de couplage (Sigma) definie 
* eLement par element et un domaine de representation integrale (Gamma)
* definie Globalement.
*
*-- Arguments --
* KPERSO ='STANDARD' formulation standard
*        ="Autre chose" indique que les calculs Gdelta *  Noyau sont effectues 
*        a l'aide d'une routine PRSOGN fournie par l'utilisateur
* INTRGL numero de l'interpolation en ligne sur Gamma
* NVNLGA niveau du tableau #GNEDO en ligne sur Gamma
* NVNOGA niveau du tableau des normales aux noeuds sur Gamma (le cas echeant)
* LIPDEL nombre de lignes de Pdelta = nombre de d.l. sur Gamma
*        = nombre de colonnes des matrices noyaux
* INTRSC numero de l'interpolation en colonne sur Gamma
* NVNCSI niveau du tableau #GNEDO en colonne sur Sigma
* LIGDEL nombre de lignes de Gdelta = nombre de d.l. sur Sigma
*        = nombre de lignes des matrices noyaux
* NMGDEL nom de la matrice Gdelta definie sur Sigma (' ' si n'existe pas) 
* NVGDEL son niveau (si NMGDEL <> ' ')
* ITGDEL son numero de type (REEL ou COMPLEXE) si definie
* IATRSI adresse dans #TERDO du domaine Sigma
* ITNOYO numero de type (REEL ou COMPLEXE) des noyaux de Green
* KLNOYO type de couplage ('DIRICHLET', 'FOURIER', 'NEUMAN')
* TYFGRE type  (REEL ou COMPLEXE) de la fonction de Green
* LAMBDC valeur COMPLEXE de la constante de couplage dans le cas 'FOURIER'
* NMTBAS nom du tableau REEL ou COMPLEXE associe a la fonction de Green
* NVTBAS son niveau
* TYTBAS son type (REEL ou COMPLEXE)
* ITGDNO numero de type des matrices 'Gdelta*Noyau'
* NMGDNS nom du produit Gdelta * Noyau pour le potentiel de simple couche :
*                     = Gdelta_{i,l} * G (P_k,M_l)
*        (peut etre la chaine blanche ' ')
* NVGDNS son niveau
* NMGDND nom du produit Gdelta * Noyau pour le potentiel de douche couche :
*                     = Gdelta_{i,l} * dG/dnP (P_k,M_l)
*        (peut etre la chaine blanche ' ')
* NVGDND son niveau
* NIVIMP niveau d'impression des calculs
*
*-- Tableaux de travail utilises --
* $WORK$ / 2 tableau COMPLEXE des valeurs des constantes associees 
*            a la fonction de Green 
* $WORK$ / 4 calcul fonction Green pour un couple (REEL ou COMPLEXE)
* $WORK$ / 5 coordonnees et reperes locaux        (REEL)
* $WORK$ / 6 noyaux de Green globaux              (REEL ou COMPLEXE)
* $WORK$ / 7 noyaux de Green locaux               (REEL ou COMPLEXE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KPERSO,NMGDEL,KLNOYO,TYFGRE,NMTBAS,TYTBAS
     &             ,NMGDNS,NMGDND
      INTEGER       INTRGL,NVNLGA,NVNOGA,LIPDEL,INTRSC,NVNCSI,LIGDEL
     &             ,NVGDEL,ITGDEL,IATRSI,ITNOYO,NVTBAS,ITGDNO
     &             ,NVGDNS,NVGDND,NIVIMP
      COMPLEX       LAMBDC
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     TYPINT*4                                            !utilite
      CHARACTER     ERCODE*120,TYNOYO*4,TYGDEL*4,TYGDNO*4
      INTEGER       INTTYP                                              !utilite
      INTEGER       ELTSIG,NBELSI,IB,IDLF,IADCOP,IADCOF,IADDLL
      COMMON/FORMAH/ERCODE
*
*     Tableaux pour les symetries dans le calcul de la fonction de Green
*     de dimension 3 quelle que soit la dimension d'espace
      INTEGER       TSYMGR(3)
      REAL          PSYMGR(3)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoSLGn*')
*
      ITREEL = INTTYP ('REEL')                                          !utilite
      ITCOMP = INTTYP ('COMPLEXE')                                      !utilite
      TYGDEL = TYPINT (ITGDEL)                                          !utilite
      TYGDNO = TYPINT (ITGDNO)                                          !utilite
      TYNOYO = TYPINT (ITNOYO)                                          !utilite
*
*     Decodage de ISYMGR (Symetries pour la fonction de Green)
*
      IF (ISYMGR.GT.0) CALL KLSYME (NDIM,ISYMGR,TSYMGR)                 !sdexplo
*
*--   Creation des tableaux locaux des coordonnees et normales 
*     (element par element) $WORK$,5
*
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)                     
      CALL GETDOM (IST(MCTRDO+IATRSI),NUDGSI,NUDKSI,IGEOME,INDMIX,NUSCHQ
     &            ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEXC,NBDLXC,NBNFXC
     &            ,NBDFXC,NVNSIC
     &            ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEXL,NBDLXL,NBNFXL
     &            ,NBDFXL,NVNSIL
     &            ,NVCOOR,INUTIL,NBTRDO,NIVDOM)                         !sdexplo
      CALL TBRR3  (ERCODE,'#ISTEL',NUDGSI,MCLISI,'#ORPTL',NUDKSI,MCCORP
     &                   ,'#RGNDO',NUDKSI,MCGNSI)
      CALL TBAR1  (ERCODE,'#ISTEL',NUDGSI,MCLISI)
*
*     Exploitation de la structure de donnees #ISTEL (1ere partie) 
*     (Renseignements globaux sur les elements constituant le domaine)
*
      CALL EXLIST (IST(MCLISI),NXLISI,NDMDOM,NDMDOE,NBELSI
     &            ,NBNEXG,NBDLXG,NBNFXG,NBDFXG)                         !sdexplo
*
      LGCORS = 0
      LGCORG = 0
      IF (KPERSO(1:8).NE.'STANDARD') THEN
*        Stockage des coordonnees des noeuds par element sur Sigma
         LGCORS = NDIM*NBNFXC
*        Stockage des coordonnees des noeuds sur Gamma (pour l'utilisateur)
         LGCORG = NDIM*LIPDEL
      ENDIF
      LGGEON = 0
      IF (MAX (INDEXC,INDEXL).GE.1) LGGEON = NDIM*NBDFXG
*     Longueur pour le calcul des normales aux noeuds de Sigma par element
*                       + normales    + coor. loc.    + rep.loc.
*                       + derivees fct de base geometriques
      IF (KLNOYO(1:3).NE.'DIR'.AND.NDMDOM.EQ.NDIM-1)
     &   LGGEON =LGGEON + NDIM*NBNFXC + NDMDOM*NBNFXC + NDIM*NDIM
     &                  + NBDFXG*NDMDOM
      LGGEON = LGCORS + LGCORG + LGGEON
*
*     Tableau $WORK$,4 pour les coefficients de la fonction de Green
*
*     ITFGRE = INTTYP (TYFGRE)                                          !utilite
      ITFGRE = INTTYP ('COMPLEXE')                                      !utilite
      LGFGRE = 1+NDIM+NDIM
      IF (KLNOYO(1:3).NE.'DIR') LGFGRE = LGFGRE+NDIM*NDIM
      LGWRKG=LGFGRE
      IF (ISYMGR.GT.0) LGWRKG=LGWRKG+LGWRKG
*
*     Tableaux de calculs intermediaires Noyaux de Green par element
*                                     et Gdelta * Noyau  par element
      LGNOES = 1
      LGGNES = 0
      INNOYS = 0
      IF (NMGDNS.NE.' ') THEN
         LGNOES = LIPDEL*NBDFXC
         LGGNES = LIPDEL*NBDFXL
         INNOYS = 1
      ENDIF
      LGNOED = 1
      LGGNED = 0
      INNOYD = 0
      IF (NMGDND.NE.' ') THEN
         LGNOED = LIPDEL*NBDFXC
         LGGNED = LIPDEL*NBDFXL
         INNOYD = 1
      ENDIF
      LGWOR6=LGNOES+LGNOED
      LGWOR7=LGGNES+LGGNED
*
      CALL TBCREE ('$WORK$',4,ITFGRE,LGWRKG,'c')
      CALL TBCREE ('$WORK$',5,ITREEL,LGGEON,'c')
      CALL TBCREE ('$WORK$',6,ITNOYO,LGWOR6,'c')
      CALL TBCREE ('$WORK$',7,ITCOMP,LGWOR7,'c')
*
      CALL TBAR12 (ERCODE,'#ORNOE',INTRGL,MCCOGA,'#GNEDO',NVNLGA,MCNLGA
     &                   ,'#ORNOE',INTRSC,MCCOSI,'#GNEDO',NVNCSI,MCNCSI
     &                   ,'#ISTEL',NUDGSI,MCLISI,'#ORPTL',NUDKSI,MCCORP
     &                   ,'#RGNDO',NUDKSI,MCINGC
     &                   ,'$WORK$',2,MCCST2
     &                   ,'$WORK$',4,MCFGR4,'$WORK$',5,MCGEO5
     &                   ,'$WORK$',6,MCNOYS,'$WORK$',7,MCSGDS)
      MCGDNS=1
      IF (NMGDNS.NE.' ') THEN
         CALL TBAR1  (ERCODE,NMGDNS,NVGDNS,MCGDNS)
         CALL TAZERO (LIPDEL*LIGDEL,TYGDNO,MCGDNS,AST,IST,RST,CST)      !utilite
      ENDIF
      MCGDND=1 
      IF (NMGDND.NE.' ') THEN
         CALL TBAR1  (ERCODE,NMGDND,NVGDND,MCGDND)
         CALL TAZERO (LIPDEL*LIGDEL,TYGDNO,MCGDND,AST,IST,RST,CST)      !utilite
      ENDIF
      MCNOGA=MCCOGA
      NDNOGA=0
      IF (NVNOGA.GT.0) THEN
         CALL TBAR1  (ERCODE,'&NORMA',NVNOGA,MCNOGA)
         NDNOGA=NDIM
      ENDIF
      MCTBAS=1
      IF (NMTBAS.NE.' ') CALL TBAR1  (ERCODE,NMTBAS,NVTBAS,MCTBAS)
      MCBLOK=1
      IF (NBBBLK.GE.2)   CALL TBAR1  (ERCODE,'#LOKEL',1,MCBLOK)
      MCGDEL=1
      IF (NMGDEL.NE.' ') CALL TBAR1  (ERCODE,NMGDEL,NVGDEL,MCGDEL)
*
*     Adresse pour les pointeurs de numerotation (#RGNDO)
      MCINGL = MCINGC+IST(MCINGC)-1
      MCINGC = MCINGC+1
*     Adresses pour les tableaux de coordonnees des noeuds
      MCCRSI = MCGEO5
      MCCRGA = MCGEO5 + LGCORS
      MCCRFS = MCCRGA + LGCORG
*     Adresses des tableaux de calcul geometriques locaux :
*     normales (MCNOSI), coord. locales des points (MCCORL),
*     repere(MCREPR), derivees fct. base geom.(MCDFCG)
*     numerotation locale de face (MCDLFG)
      MCNOSI = MCCRFS
      IF (MAX (INDEXC,INDEXL).GE.1) MCNOSI = MCCRFS + NDIM*NBDFXG
      NDNOSI = NDIM
      MCCORL = MCNOSI + NDIM*NBNFXC
      MCREPR = MCCORL + NDMDOM*NBNFXC
      MCDFCG = MCREPR + NDIM*NDIM
      MCDLFG = MCDFCG + NBDFXG*NDMDOM
*
      IF (.NOT.(KLNOYO(1:3).NE.'DIR'.AND.NDMDOM.EQ.NDIM-1)) THEN
         MCNOSI=MCCOSI
         NDNOSI=0
      ENDIF
      MCNOYD=MCNOYS + LGNOES
      MCSGDD=MCSGDS + LGGNES
*
      IF (LGCORG.GT.0) THEN
*
*        Transport des coordonnees des noeuds de l'interpolation sur Gamma 
*        (coordonnees pour l'interpolation en ligne)
*
         IADCOF=MCCRGA
         DO 6 IDLF=1,LIPDEL
            IADCOP=MCCOGA+NDIM*(IST(MCNLGA+1+IDLF)-1)-1
            DO 5 IB=IADCOP+1,IADCOP+NDIM
               RST(IADCOF)=RST(IB)
               IADCOF=IADCOF+1
5           CONTINUE
6        CONTINUE
      ENDIF
*
      MCLISI = MCLISI+NXLISI
      LISRAN = 0 
      NUTGAV = 0 
      NUTGFV = -99999 
      NUFAAV = 0
      NUTYFV = -99999
*
      DO 100 ELTSIG = 1,NBELSI
*        Nombre de noeuds en colonne/ligne dans l'element de Sigma en cours
         NBNSIC=IST(MCINGC)
         NBNSIL=IST(MCINGL)
*
         NIVAMP =-1
         IF (ELTSIG.EQ.1.OR.ELTSIG.EQ.NBELSI) NIVAMP = NIVIMP
         NIVBMP=NIVIMP
         IF (INTRPC.NE.INTRPG) NIVBMP=0
         IF (NIVAMP.GT.0) WRITE (IMPSDR,10000) ELTSIG 
*  
*        Exploitation de la structure #ISTEL et recherche des donnees  
*        geometriques et pour l'interpolation en colonne pour la face
*
         CALL EXSTEL (NDMDOM,NDMDOE,LISRAN,IST(MCLISI),IST(MCBLOK)
     &               ,NUTGEO,INTRPG,NUEL  ,NUTGAV,NUTYLG,LAG,KCL
     &               ,NBNEEG,NBDLEG,NUFACE,NUFAAV,NUTYFG,NBNEFG,NBDLFG
     &               ,IST(MCDLFG),IST(MCDLFG),NIVBMP,IMPSDR)            !sdexplo
         IF (INTRPC.EQ.INTRPG) THEN 
            NUTYFC=NUTYFG
            NBNEFC=NBNEFG 
         ELSE  
            CALL EXSTEW (NDMDOM,INTRPC,NUTGEO,NUEL,NUTGAV,NUTYLC,LAG,KCL
     &                  ,NBNEEC,NBDLEC,NUFACE,NUFAAV,NUTYFC,NBNEFC
     &                  ,NBDLFC,IST(MCDFCG),IST(MCDFCG),NIVAMP,IMPSDR)  !sdexplo
         ENDIF
         NUTGAV = NUTGEO 
         NUTGFV = NUTYFG 
         NUFAAV = NUFACE
*
         IF (KLNOYO(1:3).NE.'DIR'.AND.NDMDOM.EQ.NDIM-1) THEN
*
*           Adresse de tableau des coordonnees des POINTS sur la face
            MCCORF = MCCORP+2
            IF (MAX (INDEXC,INDEXL).GE.1) THEN  
               MCCORF = MCCRFS
*              Transfert des coordonnees de points sur la face dans 
*              un tableau indice par la numerotation de la face
               IADDLL = MCDLFG  
               IADCOF = MCCORF  
               DO 10 IDLF = 1,NBDLFG
                  IADCOP = MCCORP+1+NDIM*(IST(IADDLL)-1)
                  DO 9 IB = IADCOP+1,IADCOP+NDIM
                     RST(IADCOF) = RST(IB)  
                     IADCOF = IADCOF+1  
9                 CONTINUE 
                  IADDLL = IADDLL+1 
10             CONTINUE
            ENDIF
*
            IF (NUTYFC.NE.NUTYFV) THEN
*
*              Coordonnees des noeuds dans l'element de reference
*
               CALL ELEMCO (NUTYFC,NDMDOM,RST(MCCORL))                  !ef3d
               NUTYFV=NUTYFC
            ENDIF
*
*           Vecteurs normaux sur l'element pour l'interp. en colonne.
*
            CALL REPLOC (NDIM,NUTYFG,NBDLFG,RST(MCCORF)
     &                  ,NBNEFC,RST(MCCORL),RST(MCDFCG),1,RST(MCNOSI)
     &                  ,RST(MCREPR),NIVAMP,IMPSDR)                     !calelem
         ENDIF
*
         NIVIMG=NIVAMP
         CALL TAZERO (LGWOR7,'COMP',MCSGDS,AST,IST,RST,CST)             !utilite
*
         IF (KPERSO(1:8).EQ.'STANDARD') THEN
*
*           Calcul des noyaux de Green G_{j,k} pour les d.l. j de l'element 
*           de Sigma (interp. en colonne) en cours et tous les d.l. k de Gamma
*
            IF (NIVIMG.LT.10) NIVIMG=-1
            CALL COSLNO (NDIM,KLNOYO,LAMBDC,CST(MCCST2),TYTBAS,MCTBAS
     &                  ,ISYMGR,TSYMGR,PSYMGR
     &                  ,LIPDEL,IST(MCNLGA+2),RST(MCCOGA)
     &                  ,NDNOGA,RST(MCNOGA),ELTSIG
     &                  ,NUTYFC,NBNSIC,IST(MCINGC+1),IST(MCNCSI+2)
     &                  ,RST(MCCOSI),NDNOSI,RST(MCNOSI)
     &                  ,TYNOYO,MCFGR4,LGFGRE
     &                  ,MCNOYS,INNOYS,MCNOYD,INNOYD
     &                  ,RST,CST,NIVIMG,IMPSDR)                         !couplag
*
*           Calcul des Gdelta_{i,j} * G_{j,k} pour i,j sur l'element de Sigma
*           (i parcourt les lignes de Gdelta i=1,NBNSIL ,
*            j parcourt les colonnes j=1,NBNSIC,
*            k parcourt Gamma        k=1,LIPDEL
*
            CALL COSLDN (NMGDNS.NE.' ',NMGDND.NE.' ',LIPDEL,ELTSIG
     &                  ,NBNSIC,NBNSIL,TYGDEL,MCGDEL
     &                  ,TYNOYO,MCNOYS,MCNOYD
     &                  ,TYGDNO,CST(MCSGDS),CST(MCSGDD)
     &                  ,RST,CST,NIVIMG,IMPSDR)                         !couplag
*
         ELSE
*           Cas d'une procedure utilisateur pour les calculs des matrice
*           locales Gdelta * Noyau
*
*           Transport des coordonnees des noeuds de Sigma sur la face 
*           (coordonnees pour l'interpolation en colonne)
*
            IADCOF=MCCRSI
            DO 20 IDLF=1,NBNSIC
               IADCOP=MCCOSI+NDIM*(IST(MCNCSI+1+IST(MCINGC+IDLF))-1)-1
               DO 19 IB=IADCOP+1,IADCOP+NDIM
                  RST(IADCOF)=RST(IB)
                  IADCOF=IADCOF+1
19             CONTINUE
20          CONTINUE
*
            CALL PRSOGN (KPERSO,NDIM,KLNOYO,LAMBDC,CST(MCCST2),TYTBAS
     &                  ,MCTBAS,ISYMGR,TSYMGR,PSYMGR
     &                  ,LIPDEL,RST(MCCRGA),NDNOGA,RST(MCNOGA)
     &                  ,ELTSIG,NUTYFG,NBDLFG,RST(MCCORF)
     &                  ,NUTYFC,NBNSIC,RST(MCCRSI),NDNOSI,RST(MCNOSI)
     &                  ,NUTYFL,NBNSIL,TYNOYO,MCNOYS,MCNOYD
     &                  ,TYGDNO,CST(MCSGDS),CST(MCSGDD)
     &                  ,RST,CST,PREFIX,NIVESP,NIVIMG,IMPSDR)           !couplag
         ENDIF
*
*        Rangement des matrices Gdelta*Noyau locales
*        dans les matrices globales
*
         CALL COGNRG (NMGDNS.NE.' ',NMGDND.NE.' ',NBNSIL,IST(MCINGL+1)
     &               ,TYGDNO,CST(MCSGDS),CST(MCSGDD),LIPDEL
     &               ,MCGDNS,MCGDND,RST,CST)                            !couplag
*
         MCCORP = MCCORP + 2 + IST(MCCORP) * NDIM
         MCINGC = MCINGC + 1 + NBNSIC
         MCINGL = MCINGL + 1 + NBNSIL
100   CONTINUE
      CALL TBTUER ('$WORK$',4)
      CALL TBTUER ('$WORK$',5)
      CALL TBTUER ('$WORK$',6)
      CALL TBTUER ('$WORK$',7)
      CALL TBSAVE ('#ISTEL',NUDGSI)
      CALL TBSAVE ('#ORPTL',NUDKSI)
      CALL TBSAVE ('#RGNDO',NUDKSI)
      CALL PRFXMJ (-1,'*CoSLGn*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*CoSLGn*',T30,'Calculs alodynentaires dans l''element'
     &,I5/T30, 43('-'))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !CoSLGn
