*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COSLNO (NDIM  ,KLNOYO,LAMBDC,CONGRE,TYTBAS,MCTBAS
     &                  ,ISYMGR,TSYMGR,PSYMGR
     &                  ,NDLGAM,NGNEGA,ORNOGA,NDNOGA,NORGAM
     &                  ,ELTSIG,NUTSIC,NBNSIC,IRGNSI,NGNESI
     &                  ,ORNOSI,NDNOSI,NORSIC,TYNOYO,MCFGRE,LGFGRE
     &                  ,MCNOYS,INNOYS,MCNOYD,INNOYD
     &                  ,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995)
* Derniere modification : D.Martin (13 Juillet 1997)
*
* Contribution d'une face de Sigma au calcul des noyaux de simple couche
* g(l,k) et double couche gn(l,k),
*
* ou g (l,k) = G(P_k,M_l)                       ('Dirichlet')
*              (d/dnM) G(P_k,M_l)               ('Neuman')
*              (d/dnM + Lambda) G(P_k,M_l)      ('Fourier')
*
* et gn(l,k) = dG/dnP(P_k,M_l)                  ('Dirichlet')
*              (d/dnM) dG/dnP(P_k,M_l)          ('Neuman')
*              (d/dnM + Lambda) dG/dnP(P_k,M_l) ('Fourier')
*
*-- Arguments --
* NDIM   dimension d'espace
* KLNOYO type de noyau ('DIRICHLET', 'NEUMAN' ou 'FOURIER')
*        ou AUTRE pour le cas d'une procedure programme par l'utilisateur
* LAMBDC le cas echeant, valeur COMPLEXE de la constante de couplage
* CONGRE le tableau COMPLEXE contenant leurs valeurs des constantes associees
*        au calcul de la fonction de Green
* TYTBAS type (ENTIER, REEL ou COMPLEXE) de l'eventuel tableau associe au calcul
*        de la fonction de Green
* MCTBAS son adresse absolue
* ISYMGR indicateur de symetrie pour la fonction de Green
* TSYMGR tableau ENTIER pour la definition des (anti-)symetries
* PSYMGR tableau REEL pour les coordonnees d'un point symetrique
* NDLGAM nombre de d.l. sur Gamma
* NGNEGA numerotation globale (#GNEDO) pour l'interp. en ligne de Gamma
* ORNOGA coord. des noeuds (#ORNOE) correspondant a l'interp. en ligne Gamma
* NDNOGA = NDIM le tableau des normales sur Gamma existe, =0 sinon
* NORGAM tableau des normales aux noeuds assemblees sur Gamma
* ELTSIG numero de l'element de Sigma en cours
* NUTSIC numero de type de l'element en cours de Sigma interp. en colonne
* NBNSIC nombre de noeuds en colonne pour la matrice elementaire Gdelta
* IRGNSI tableau des rangs des noeuds (#RGNDO) en colonne de l'elt dans Sigma
* NGNESI numerotation globale (#GNEDO) pour l'interp. en colonne de Sigma
* ORNOSI coord. des noeuds (#ORNOE) correspondant a l'interp. en colonne Sigma
* NDNOSI = NDIM le tableau des normales sur Sigma existe, =0 sinon
* NORSIC composantes des normales elementaires sur la face de Sigma en cours
* TYNOYO type (REEL ou COMPLEXE) des noyaux de Green
* MCFGRE adresse absolue du tableau pour le calcul de la fonction de Green et
*        de ses derivees pour un couple (P_k,M_l)
* LGFGRE nombre de valeurs de fonction de Green et derivees calculees
* MCNOYS adresse du tableau pour les noyaux de Green g (l,k) pour tous les 
*        d.l. P_j de Gamma et les d.l. M_k de la face de Sigma en cours
* INNOYS indicateur de calcul des noyaux de simple couche g (l,k)
* MCNOYD adresse du tableau pour les noyaux de Green gn(l,k) ....
* INNOYD indicateur de calcul des noyaux de double couche gn(l,k)
* RST    super-tableau version reelle
* CST    super-tableau version complexe
* NIVIMP niveau d'impression  
* IMPFCH numero de l'unite logique des impressions
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYNOYO,KLNOYO,TYTBAS
      INTEGER       NDIM  ,MCTBAS,ISYMGR,TSYMGR(*),NDLGAM,NGNEGA(*)
     &             ,NDNOGA,ELTSIG,NUTSIC,NBNSIC,IRGNSI(*),NGNESI(*)
     &             ,NDNOSI,MCFGRE,LGFGRE
     &             ,MCNOYS,INNOYS,MCNOYD,INNOYD,NIVIMP,IMPFCH
      REAL          PSYMGR(*),ORNOGA(NDIM,*),NORGAM(*)
     &             ,ORNOSI(NDIM,*),NORSIC(*),RST(*)
      COMPLEX       LAMBDC,CONGRE(*),CST(*)
*
      CHARACTER     AST
      INTEGER       LSIG,LSIGGL,KGAM,KGAMGL,ADNOYS,ADNOYD,ADNOGA,ADNOSI
     &             ,IST
      COMPLEX       CG,CGN
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CoSlNo*')
*
      IF (NIVIMP.GT.2) WRITE (IMPFCH,90000) ELTSIG
      ADNOYS=MCNOYS
      ADNOYD=MCNOYD
      ADNOSI=1
      IF (ISYMGR.GT.0) THEN
*
*--      Cas de symetries ou d'antisymetries pour la fonction de Green
*
         IF (TYNOYO(1:1).EQ.'C') THEN
            IF (KLNOYO(1:3).EQ.'FOU') THEN
*              Couplage 'Fourier' 
               DO 401 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 400 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL SYMGRE (KLNOYO,NDIM,CONGRE,ORNOGA(1,KGAMGL)
     &                           ,ORNOSI(1,LSIGGL),PSYMGR,TSYMGR,LGFGRE
     &                           ,CST(MCFGRE),CST(MCFGRE+LGFGRE)
     &                           ,CST(MCTBAS))                          !Calgre
                     CALL NOYFOU (NDIM,NORGAM(ADNOGA),NORSIC(ADNOSI)
     &                           ,LAMBDC,CST(MCFGRE),CG,CGN
     &                           ,NIVIMP,IMPFCH)                        !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
400               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
401            CONTINUE
            ELSEIF (KLNOYO(1:3).EQ.'NEU') THEN
*              Couplage 'Neumann' 
               DO 403 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 402 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL SYMGRE (KLNOYO,NDIM,CONGRE,ORNOGA(1,KGAMGL)
     &                           ,ORNOSI(1,LSIGGL),PSYMGR,TSYMGR,LGFGRE
     &                           ,CST(MCFGRE),CST(MCFGRE+LGFGRE)     
     &                           ,CST(MCTBAS))                          !Calgre
                     CALL NOYNEU (NDIM,NORGAM(ADNOGA),NORSIC(ADNOSI)
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
402               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
403            CONTINUE             
            ELSEIF (KLNOYO(1:3).EQ.'DIR') THEN
*              Couplage 'Dirichlet' 
               DO 405 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 404 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL SYMGRE (KLNOYO,NDIM,CONGRE,ORNOGA(1,KGAMGL)
     &                           ,ORNOSI(1,LSIGGL),PSYMGR,TSYMGR,LGFGRE
     &                           ,CST(MCFGRE),CST(MCFGRE+LGFGRE)     
     &                           ,CST(MCTBAS))                          !Calgre
                     CALL NOYDIR (NDIM,NORGAM(ADNOGA)
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
404               CONTINUE
405            CONTINUE
            ELSE
*              Calcul procedure utilisateur
               DO 407 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 406 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL PRSONO (KLNOYO,NDIM,LAMBDC,CONGRE,CST(MCTBAS)
     &                           ,ORNOGA(1,KGAMGL),NDNOGA,NORGAM(ADNOGA)
     &                           ,ORNOSI(1,LSIGGL),NDNOSI,NORSIC(ADNOSI)
     &                           ,ISYMGR,TSYMGR,PSYMGR,LGFGRE
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Modeles
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
406               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
407            CONTINUE
            ENDIF
         ELSE
             CALL BAISE  ('Fonction de Green reelle non implementee')
         ENDIF
      ELSE
*
*--      Pas de symetrie
*
         IF (TYNOYO(1:1).EQ.'C') THEN
            IF (KLNOYO(1:3).EQ.'FOU') THEN
               DO 421 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 420 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL GREEN (KLNOYO,CONGRE,ORNOGA(1,KGAMGL)
     &                          ,ORNOSI(1,LSIGGL),CST(MCFGRE)
     &                          ,CST(MCTBAS))                           !Calgre
                     CALL NOYFOU (NDIM,NORGAM(ADNOGA),NORSIC(ADNOSI)
     &                           ,LAMBDC,CST(MCFGRE),CG,CGN
     &                           ,NIVIMP,IMPFCH)                        !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
420               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
421            CONTINUE
            ELSEIF (KLNOYO(1:3).EQ.'NEU') THEN
               DO 423 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 422 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL GREEN (KLNOYO,CONGRE,ORNOGA(1,KGAMGL)
     &                          ,ORNOSI(1,LSIGGL),CST(MCFGRE)
     &                          ,CST(MCTBAS))                           !Calgre
                     CALL NOYNEU (NDIM,NORGAM(ADNOGA),NORSIC(ADNOSI)
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
422               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
423            CONTINUE
            ELSEIF (KLNOYO(1:3).EQ.'DIR') THEN
               DO 425 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 424 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL GREEN (KLNOYO,CONGRE,ORNOGA(1,KGAMGL)
     &                          ,ORNOSI(1,LSIGGL),CST(MCFGRE)
     &                          ,CST(MCTBAS))                           !Calgre
                     CALL NOYDIR (NDIM,NORGAM(ADNOGA)
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Calgre
                     ADNOGA      = ADNOGA + NDNOGA
                     CST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     CST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
424               CONTINUE
425            CONTINUE
*           Calcul procedure utilisateur
               DO 427 LSIG=1,NBNSIC
                  LSIGGL=NGNESI(IRGNSI(LSIG))
                  ADNOGA=1
                  DO 426 KGAM=1,NDLGAM
                     KGAMGL=NGNEGA(KGAM)
                     CALL TAZERO (LGFGRE,TYNOYO,MCFGRE,AST,IST,RST,CST) !Utilite
                     CALL PRSONO (KLNOYO,NDIM,LAMBDC,CONGRE,CST(MCTBAS)
     &                           ,ORNOGA(1,KGAMGL),NDNOGA,NORGAM(ADNOGA)
     &                           ,ORNOSI(1,LSIGGL),NDNOSI,NORSIC(ADNOSI)
     &                           ,ISYMGR,TSYMGR,PSYMGR,LGFGRE
     &                           ,CST(MCFGRE),CG,CGN,NIVIMP,IMPFCH)     !Modeles
                     ADNOGA      = ADNOGA + NDNOGA
                     RST(ADNOYS) = CG
                     ADNOYS      = ADNOYS+INNOYS
                     RST(ADNOYD) = CGN
                     ADNOYD      = ADNOYD+INNOYD
426               CONTINUE
                  ADNOSI    = ADNOSI + NDNOSI
427            CONTINUE
            ENDIF
         ELSE
             CALL BAISE  ('Fonction de Green reelle non implementee')
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*CoSlNo*')
*-----------------------------------------------------------------------
90000 FORMAT (/T2,'*CoSlNo* Noyaux de Green, Element de Sigma No',I6)
                                                                    END !CoSlNo
