*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE COUVEC (NMGDEL,NVGDEL,NMGREN,NVGREN,NBGREN,SAVGRE
     &                  ,NMVECT,NVVECT,NMCOUP,NVCOUP,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Juin 1989) 
* Derniere modification : D.Martin (2 Avril 2002)
* Version 1.0.1
*  
* Calcul d'un vecteur de couplage Elements Finis/Representation Integrale
*  
*-- Arguments d'entree --
* NMGDEL/NVGDEL nom/niveau de la matrice GDELTA 'Bi-Morse' ou 'Morse-Ligne'
* NMGREN nom des (tableaux contenant les) sous-matrices Noyaux de Green
* NVGREN niveau du premier de tels sous-tableaux
*        les tableaux ont des niveaux consecutifs  
* NBGREN leur nombre
* NMVECT/NVVECT nom/niveau du (tableau contenant le) vecteur operande
* NMCOUP/NVCOUP nom/niveau du (tableau contenant le) vecteur resultat
* NIVIMP niveau d'impression du vecteur resultat  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMGDEL,NMGREN,SAVGRE,NMVECT,NMCOUP
      INTEGER       NVGDEL,NVGREN,NBGREN,NVVECT,NVCOUP,NIVIMP
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      CHARACTER  ERCODE*120,TYPINT*4                                    !utilite
      CHARACTER*4 TYGDEL,TYVECT,TYGREE,TYWORK,TYCOUP,NMSTOG*6
      INTEGER    INDSTO,INTYKL,KLTERM                                   !utilite
      INTEGER    ITGREE,ITWORK,ITCOUP,MCWORK,IPRLIG,IDRLIG,NCATR1
     &          ,LGMTRM,MCMTRM
     &          ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &          ,NIVEAU,ITGDEL,ITYCAL,NUKALE,NUDONN,ITYSYG,IPTDIR
     &          ,NUINCG,NVDUCG,NBCOGD,NVNUCG,NUINLG,NVDULG,NBLIGD,NVNULG
     &          ,INDSTG,NVSTOG,NVCORC,IATRSI,NIVIGD,ITVECT,NVALNE
     &          ,NUINCV,NVDUCV,NBNECV,NVNUCV,NUINLV,NVDULV,NBNELV,NVNULV
     &          ,INSTOK,NVSTOK,NVCOOO,IATRGA,NIVIVC,NBCOGR,NBLIGR,NWGREN
     &          ,NUGREN,MCGREN,MCVECT,MCGDEL,MCLGDE,MCCOUP,MCSTOG
     &          ,NBL,NBPL,MCPLAL,MCPLIL,LGMORL,NBC,NBPU,MCPLAU,MCPLIU
     &          ,LGMORU,LGM
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(65:65),TYGDEL),(ERCODE(73:73),TYVECT)
     &            ,(ERCODE(81:81),TYGREE),(ERCODE(89:89),TYWORK)
     &            ,(ERCODE(97:97),TYCOUP),(ERCODE(105:105),NMSTOG)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Couvec*')
*  
*--   Type (REEL ou COMPLEXE des noyaux de Green)  
*
      CALL TBTYPE (NMGREN,NVGREN,ITGREE)
      TYGREE=TYPINT(ITGREE)                                             !utilite
      ITWORK=ITGREE
      ITCOUP=ITGREE
*  
*--   Agrandissement prealable des structures $SDTRM et #OMTRM 
*  
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)            !sdexplo
      CALL SDAJST ('#OMTRM',1,LGMTRM,0,NCHTRM,NBTERM,1)                 !sdexplo
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
*  
*--   Recherche des attributs du terme NMGDEL
*  
      NUTERM=KLTERM (NMGDEL,NVGDEL,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMGDEL,NVGDEL)                    !utilite  
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU 
     &            ,ITGDEL,ITYCAL,NUKALE,NUDONN,ITYSYG,IPTDIR
     &            ,NUINCG,NVDUCG,NBCOGD,NVNUCG
     &            ,NUINLG,NVDULG,NBLIGD,NVNULG
     &            ,INDSTG,NVSTOG,NVCORC,IATRSI,NIVIGD)                  !sdexplo
      TYGDEL=TYPINT (ITGDEL)                                            !utilite
*  
*--   Recherche des attributs du terme NMVECT
*  
      NUTERM=KLTERM (NMVECT,NVVECT,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMVECT,NVVECT)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVEAU
     &            ,ITVECT,ITYCAL,NUKALE,NUDONN,NVALNE,IPTDIR
     &            ,NUINCV,NVDUCV,NBNECV,NVNUCV
     &            ,NUINLV,NVDULV,NBNELV,NVNULV
     &            ,INSTOK,NVSTOK,NVCOOO,IATRGA,NIVIVC)                  !sdexplo
      IF (NUINLV.EQ.NDFINC) NBNELV=NBNECV
*
      IF (TYGDEL.EQ.'COMP') ITCOUP=ITGDEL
      TYVECT=TYPINT (ITVECT)                                            !utilite
      IF (TYVECT.EQ.'COMP') THEN
         ITWORK=ITVECT 
         ITCOUP=ITVECT 
      ENDIF
      NMSTOG='&BMORS'
      IF (INDSTG.EQ.INDSTO ('MORSE-L')) NMSTOG='&PLAGE'                 !utilite
      TYWORK=TYPINT (ITWORK)                                            !utilite
      TYCOUP=TYPINT (ITCOUP)                                            !utilite
*  
*     Nombre de colonnes d'un morceau de noyau (colonnes completes)
      NBCOGR=(NBNELV-1)/NBGREN+1
*     Taille d'une colonne
      NBLIGR=NBCOGD
*  
*     Creation d'un vecteur de travail intermediaire
      CALL TBCREE ('$WORK$',1,ITWORK,NBLIGR,'c')
      CALL TBAR1  (ERCODE,'$WORK$',1,MCWORK)                     
      CALL TAZERO (NBLIGR,TYWORK,MCWORK,AST,IST,RST,CST)                !utilite
*  
*     Multiplication NOYAU*NMVECT dans $WORK$
      CALL TBRR1  (ERCODE,NMVECT,NVVECT,MCVECT)
      IDRLIG=0
      NWGREN=NVGREN-1  
      DO 9 NUGREN=1,NBGREN 
         NWGREN=NWGREN+1
         IPRLIG=IDRLIG+1
         IDRLIG=MIN (IDRLIG+NBCOGR,NBNELV)  
         CALL TBRR1  (ERCODE,NMGREN,NWGREN,MCGREN)
         CALL TBAR3  (ERCODE,NMGREN,NWGREN,MCGREN,NMVECT,NVVECT,MCVECT
     &                      ,'$WORK$',1,MCWORK)
*  
         CALL PPLVC  (1,NBLIGR,TYGREE,MCGREN,1,NBLIGR,IPRLIG,IDRLIG
     &               ,TYVECT,MCVECT,TYWORK,MCWORK,RST,CST)              !multmat
         IF (SAVGRE(:6).EQ.'A MORT') THEN
            CALL TBTUER (NMGREN,NWGREN)
         ELSE
            CALL TBSAVE (NMGREN,NWGREN)
         ENDIF
9     CONTINUE  
*  
*     Sauvegarde du vecteur multiplicatif  
      CALL TBSAVE (NMVECT,NVVECT)
*  
*     Creation du Vecteur resultat 
      CALL TBCREE (NMCOUP,NVCOUP,ITCOUP,NBLIGD,'c')
*  
*     Introduction du terme de couplage dans les structures #OMTRM et $SDTRM
*  
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM) 
      NUTERM=KLTERM (NMCOUP,NVCOUP,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
         CALL ALFANU (NBCHNT,NMCOUP)                                    !utilite
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMCOUP)                 !utilite
         NUTERM=NBTERM 
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
      ENDIF
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVCOUP
     &            ,ITCOUP,INTYKL('COUPLA'),1,NDFDON,1,NDFDSM
     &            ,NDFINC,NDFDUM,1     ,NDFNUM
     &            ,NUINLG,NVDULG,NBLIGD,NVNULG
     &            ,INDSTO('PLEIN-L'),NDFSTO,NVCORC,0     ,NIVIMP)         !sdexplo
* 
*     Calcul proprement dit du vecteur de couplage
*
      CALL TBRR2 (ERCODE,NMGDEL,NVGDEL,MCGDEL,NMSTOG,NVSTOG,MCSTOG)
      CALL TBAR4 (ERCODE,NMGDEL,NVGDEL,MCGDEL,NMSTOG,NVSTOG,MCSTOG
     &                  ,NMCOUP,NVCOUP,MCCOUP,'$WORK$',1,MCWORK)
      CALL TAZERO (NBLIGD,TYCOUP,MCCOUP,AST,IST,RST,CST)                !utilite
*
*     Multiplication GDELTA*$WORK$ dans NMCOUP
*
      IF (INDSTG.EQ.INDSTO ('BIMORSE')) THEN
         CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPL,MCPLAL,MCPLIL,LGMORL
     &                                  ,NBC,NBPU,MCPLAU,MCPLIU,LGMORU) !sdexplo
         MCLGDE=MCGDEL+MIN (NBL,NBC)
         CALL BMVC   (NBLIGD,IST(MCPLAL),IST(MCPLIL)                      
     &               ,NBCOGD,IST(MCPLAU),IST(MCPLIU),ITYSYG,TYGDEL
     &               ,MCGDEL,MCLGDE,MCLGDE+LGMORL,TYWORK,MCWORK
     &               ,TYCOUP,MCCOUP,RST,CST)                            !multmat
      ELSEIF (INDSTG.EQ.INDSTO ('MORSE-L')) THEN
         CALL EXMORS (MCSTOG,IST(MCSTOG),NBL,NBC,NBPL,MCPLAL,MCPLIL,LGM)!sdexplo
         CALL MOVC   (NBLIGD,NBCOGD,IST(MCPLAL),IST(MCPLIL)
     &               ,TYGDEL,MCGDEL,TYWORK,MCWORK,TYCOUP,MCCOUP,RST,CST)!multmat
      ENDIF
      CALL TBSAVE (NMSTOG,NVSTOG)
      CALL TBTUER ('$WORK$',1)
*
*     Sauvegarde de GDELTA 
      CALL TBSAVE (NMGDEL,NVGDEL)
*
      IF (NIVIMP.GT.0) CALL PRTERM (NMCOUP,NVCOUP,NIVIMP,IMPSDR)        !prsd
      CALL TBSAVE (NMCOUP,NVCOUP)
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMCOUP,NVCOUP,ERCODE,NCATR1)
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
      ENDIF
      CALL PRFXMJ (-1,'*Couvec*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/' *CouVec* Calcul du vecteur de couplage ',A)
                                                                    END !Couvec
