*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NOYTVC (GAMMA,NMGREE,NVGREE,NMVEC1,NVVEC1
     &                  ,NMVEC3,NVVEC3,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (15 decembre 2006) 
* Derniere modification : D.Martin (15 decembre 2006)
* Version 0
*  
* Calcul d'un produit Noyau de Green transpose par un vecteur:
*
*              V3(p) = NG(M,p)^t.V1(M) (M sur SIGMA, p sur Gamma)
*
* ou NG(M,p) est le noyau de Green 
* Calcul du produit noyau de green transpos (GAMMAxSIGMA) par un vecteur (sur SIGMA):
*
*-- Arguments d'entree -- 
* GAMMA  nom du domaine geometrique
* NMGREE nom du tableau contenant le noyau de Green
* NVGREE le niveau du 1er de ces tableaux
* NMVEC1 nom du terme contenant le vecteur operande (V1)
* NVVEC1 son niveau
* NMVEC3 nom du terme contenant le vecteur resultat (V3)
* NVVEC3 son niveau
* NIVIMP niveau d'impression du vecteur resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) GAMMA,NMGREE,NMVEC1,NMVEC3
      INTEGER       NVGREE,NBGREE,NVVEC1,NVVEC3,NIVIMP
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*  
      CHARACTER  ERCODE*120,TYPINT*4
      CHARACTER*4 TYGREE,TYVEC1,TYVEC3
      INTEGER    INDSTO,INTYKL,KLTERM
      INTEGER    ITGREE,ITVEC3,IPRLIG,IDRLIG,NWHTRM
     &          ,LGMTRM,MCMTRM,MCMDOM,MCTRDO,IATRGA
     &          ,NUDGGA,NUDOGA,IGEOME,INDMIX,INDEXC,IDLHRC,NVNUGA
     &          ,INDEXL,IDLHRL,NVNUSL,NVCOGA,INUTIL,NBTRDO,NIVIGA
     &          ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &          ,ITYVEC,ITYCAL,NUKALE,NUDONN,NVALNE,IPTDIR 
     &          ,NUINCV,NUDUCV,NBNECV,NVNUCV
     &          ,NUINLV,NVDULV,NBNOSI,NVNULV
     &          ,INSTOK,NVSTOK,NVCOOO,IATRSI,NIVIVC,NIVEAU
     &          ,NVVOLD,ITYOLD,NUKOLD,NVSOLD,NCOOLD,IATOLD,NIVOLD
     &          ,NUCOLD,NDCOLD,NBCOLD,NVCOLD,NULOLD,NDLOLD,NBLOLD,NVLOLD     
     &          ,MCNUGA,NBNOGA,NUTRVC,NWGREE,MCGREE,NUGREN
     &          ,MCVEC3,MCVEC1,I
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (ERCODE(97:97),TYGREE),(ERCODE(105:105),TYVEC1)
     &           ,(ERCODE(113:113),TYVEC3)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Noytvc*')
*  
*     Type (REEL ou COMPLEXE des noyaux de Green)  
*
      CALL TBTYPE (NMGREE,NVGREE,ITGREE)
      TYGREE=TYPINT (ITGREE)                                            !utilite
      ITVEC3=ITGREE
*  
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
*     Caracteristiques du domaine de representation integrale en colonne
*     pour decrire les caracteristiques en ligne de la matrice NOYAU
*  
      CALL KLDOMN (GAMMA,0,-1,IST(MCTRDO),AST(MCMDOM),NBDOMG
     &            ,NUDOGA,IATRGA)                                       !sdexplo
      IATRGA=MCTRDO+IATRGA 
      CALL GETDOR (IST(IATRGA),NUDGGA,NUDOGA,IGEOME,INDMIX 
     &            ,INDEXC,IDLHRC,NVNUGA,INDEXL,IDLHRL,NVNUSL
     &            ,NVCOGA,INUTIL,NBTRDO,NIVIGA)                         !sdexplo
*  
*     Recherche des attributs du terme NMVEC1  
*  
      NUTRVC=KLTERM (NMVEC1,NVVEC1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTRVC.LE.0) CALL ERTERM (1,NMVEC1,NVVEC1)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTRVC-1)),NIVEAU
     &            ,ITYVEC,INSTOK,NUKALE,NUDONN,NVALNE,IPTDIR 
     &            ,NUINCV,NUDUCV,NBNECV,NVNUCV
     &            ,NUINLV,NVDULV,NBNOSI,NVNULV
     &            ,INSTOK,NVSTOK,NVCOOO,IATRSI,NIVIVC)                  !sdexplo
      TYVEC1=TYPINT (ITYVEC)                                            !utilite
      IF (TYVEC1.EQ.'COMP') ITVEC3=ITYVEC
  
      TYVEC3=TYPINT (ITVEC3)                                            !utilite
*  
*--   Creation du Vecteur resultat 
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUGA,MCNUGA)
      CALL TBAR1  (ERCODE,'#GNEDO',NVNUGA,MCNUGA)
      NBNOGA=IST(MCNUGA+1)
*
*     Introduction du resultat dans les structures #OMTRM et $SDTRM
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
      NUTERM=KLTERM (NMVEC3,NVVEC3,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
         CALL ALFANU (NBCHNT,NMVEC3)                                    !utilite
         NWHTRM=MAX (NCHTRM,LEN(NMVEC3))
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMVEC3)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
         NUTERM=NBTERM 
         IATOLD=0  
         NVSOLD=0  
         NUDONN=0
      ELSE 
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVOLD
     &               ,ITYOLD,ITYCAL,NUKOLD,NUDONN,NVALNE,IPTDIR
     &               ,NUCOLD,NDCOLD,NBCOLD,NVCOLD
     &               ,NULOLD,NDLOLD,NBLOLD,NVLOLD
     &               ,INSTOK,NVSOLD,NCOOLD,IATOLD,NIVOLD)               !sdexplo
      ENDIF
*  
      ITYCAL=INTYKL ('ASSEMB')                                          !utilite
      INSTOK=INDSTO ('PLEIN-L')                                         !utilite
      IF (NVCOGA.LE.0) NVCOGA=NCOOLD
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVEC3
     &            ,ITVEC3,ITYCAL,1,NUDONN,NVALNE,NDFDSM
     &            ,NDFINC,NDFDUM,1     ,NDFNUM
     &            ,NUINLV,NDFDUM,NBNOGA,NVNUGA
     &            ,INSTOK,NDFSTO,NVCOGA,IATOLD,NIVIMP)                  !sdexplo
*  
      CALL TBCREE (NMVEC3,NVVEC3,ITVEC3,NBNOGA,'c')
      CALL TBAR1  (ERCODE,NMVEC3,NVVEC3,MCVEC3)
      CALL TAZERO (NBNOGA,TYVEC3,MCVEC3,AST,IST,RST,CST)                !utilite
*  
*--   Multiplication NOYAU*NMVEC1 dans NMVEC3
         CALL TBRR2  (ERCODE,NMGREE,NVGREE,MCGREE,NMVEC1,NVVEC1,MCVEC1)
         CALL TBAR3  (ERCODE,NMGREE,NVGREE,MCGREE,NMVEC1,NVVEC1,MCVEC1
     &                      ,NMVEC3,NVVEC3,MCVEC3)
*
*         CALL PLVC   (NBNOGA,NBNOSI,TYGREE,MCGREE        
*     &               ,TYVEC1,MCVEC1,TYVEC3,MCVEC3,RST,CST)              !multmat
         CALL PLXPL (TYGREE,NBNOSI,NBNOGA,'PLEIN-C',MCGREE,TYVEC1,
     &               1,'PLEIN-L',MCVEC1,'PLEIN-L',MCVEC3,RST,CST)	 
	 CALL TBSAVE (NMGREE,NVGREE)
*  
*     Sauvegarde du vecteur multiplicatif  
      CALL TBSAVE (NMVEC1,NVVEC1)
*     Impression et sauvegarde du vecteur resultat 
      IF (NIVIMP.GE.0) CALL PRTERM (NMVEC3,NVVEC3,NIVIMP,IMPSDR)         !prsd
      CALL TBSAVE (NMVEC3,NVVEC3)
      CALL PRFXMJ (-1,'*Noytvc*')  
                                                                    END !RepInt
