*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELBMO (NBLIGN,NBCOLO,NBDLLI,NVNUML,NBDLCO,NVNUMC
     &                  ,NMSTOG,NVSTOG,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOP,NVSTOP
     &                  ,LGLR,LGUR)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (13 juillet 1997)
* Derniere modification : D.Martin (18 septembre 2006)
* Version 1.1
*
* Calcul des tables de stockage BIMORSE du terme releve
*
* NBLIGN nombre de lignes du terme releve (= NBDLLI ou NWDLLI)
* NBCOLO nombre de colonnes du terme releve (=NWDLCO)
* NBDLLI nombre de lignes du terme original
* NVNUML niveau de la numerotation en ligne du terme original
* NBDLCO nombre de colonnes du terme original
* NVNUMC niveau de la numerotation en colonne du terme original
* NMSTOG/NVSTOG nom/niveau du tableau de stockage du terme original
* LGSTOG sa longueur (sert a calculer la longueur du stocakge du resultat)
* NWDLLI nombre de lignes du terme releve
* NWNUML niveau de la numerotation en ligne du terme releve
* NWDLCO nombre de colonnes du terme releve
* NWNUMC niveau de la numerotation en colonne du terme releve
* NMSTOP/NVSTOP nom/niveau du tableau de stockage du terme releve
* LGLR   longueur de la partie triangulaire inferieure du terme releve
* LGUR   longueur de la partie triangulaire superieure du terme releve
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMSTOG,NMSTOP,NMPTIT
      INTEGER       NBLIGN,NBCOLO,NBDLLI,NVNUML,NBDLCO,NVNUMC,NVSTOG
     &             ,LGSTOG,NVPTIT,NWDLLI,NWNUML,NWDLCO,NWNUMC,NVSTOP
     &             ,LGLR,LGUR
*
      INCLUDE 'ALLOC'  
*
      CHARACTER ERCODE*120
      INTEGER   IRCODE,NBAJST,LGCREA,LGCREE,NBPLAX,MCNUMC,MCNUML,MWNUMC
     &         ,MWNUML,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCSTOG
     &         ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU,MCSTOP,MCPLIR
     &         ,LGSTOP,MCPUAR,MCPUIR
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RelBmo*')
*
      IRCODE=0
      NBAJST=0 
      LGCREA=MIN (2*LGSTOG,1+(NBLIGN+1)*(NBCOLO+1))
      CALL TBCRSU (NMSTOP,NVSTOP,1,LGCREA,LGCREE,'c')
1     NBPLAX=(LGCREE-1-NBLIGN)/2
      CALL TBAR6  (ERCODE
     &            ,'#GNEDO',NVNUMC,MCNUMC,'#GNEDO',NVNUML,MCNUML
     &            ,'#GNEDO',NWNUMC,MWNUMC,'#GNEDO',NWNUML,MWNUML 
     &            , NMSTOP ,NVSTOP,MCSTOP, NMSTOG ,NVSTOG,MCSTOG)
      CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)     !sdexplo
      MCSTOP=MCSTOP+2
      MCPLIR=MCSTOP+NWDLLI-1
*
*     Calcul du stockage BIMORSE inferieur du terme releve
      CALL RLBMOR (NBDLCO,IST(MCNUMC+2),NBDLLI,IST(MCNUML+2)
     &            ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &            ,NWDLLI,IST(MWNUML+2),NWDLCO,IST(MWNUMC+2)
     &            ,NBPLAX,IST(MCSTOP),IST(MCPLIR),IRCODE)               !couplag
      IF (IRCODE.GT.0) THEN
*        Un noeud de la numerotation (NWNUML) de la frontiere
*        n'est pas retrouve dans la numerotation (NVNUML) en ligne du terme
         CALL ENCLER (IRCODE,ERCODE(1:6))
         CALL ENCLER (IST(MWNUML+1+IRCODE),ERCODE(7:12))
         CALL ENCLER (NBDLLI,ERCODE(13:18))
         CALL BAISE  (' >Rlbmor Le noeud # '//ERCODE(1:6)
     &          //' de la frontiere de numero global '//ERCODE(7:12)
     &          //' n''est pas retrouve parmi les '//ERCODE(13:18)
     &          //' noeuds de la numerotation en ligne du terme.')      !utilite
      ELSEIF (IRCODE.LT.0) THEN
*        Taille insuffisante detectee pour NMSTOP,NVSTOP
*        multiplication par 2 (pour les parties inferieure et superieure)
         CALL WARNNG ('Estimation taille Inf structure Bimorse a revoir'
     &            //'. Prevenir Daniel.Martin@univ-rennes1.fr')         !utilite
         IF (NBAJST.GT.2) GOTO 99991
         LGCREE=4*LGCREE
         CALL TBAJST (NMSTOP,NVSTOP,LGCREE)
         NBAJST=NBAJST+1
         GOTO 1
      ENDIF
*
      IST(MCSTOP-1)=NWDLLI
      LGSTOP=1+NWDLLI+2*IST(MCPLIR-1)
      LGLR=IST(MCSTOP-3+LGSTOP)
      MCPUAR=MCSTOP+LGSTOP-1
      MCPUIR=MCPUAR+NWDLCO-1
      IST(MCSTOP-2)=LGSTOP
*
*     Calcul du stockage BIMORSE superieur
2     NBPLAX=(LGCREE-LGSTOP-NBCOLO)/2
      CALL RLBMOR (NBDLLI,IST(MCNUML+2),NBDLCO,IST(MCNUMC+2)
     &            ,IST(MCPLAU),IST(MCPLIU),IST(MCPLAL),IST(MCPLIL)
     &            ,NWDLCO,IST(MWNUMC+2),NWDLLI,IST(MWNUML+2)
     &            ,NBPLAX,IST(MCPUAR),IST(MCPUIR),IRCODE)               !couplag
      IF (IRCODE.GT.0) THEN
*        Un noeud de la numerotation (NWNUMC) de la frontiere
*        n'est pas retrouve dans la numerotation (NVNUMC) en colonne du terme
         CALL ENCLER (IRCODE,ERCODE(1:6))
         CALL ENCLER (IST(MWNUMC+1+IRCODE),ERCODE(7:12))
         CALL ENCLER (NBDLCO,ERCODE(13:18))
         CALL BAISE  (' >Rlbmor Le noeud # '//ERCODE(1:6)
     &          //' de la frontiere de numero global '//ERCODE(7:12)
     &          //' n''est pas retrouve parmi les '//ERCODE(13:18)
     &          //' noeuds de la numerotation en colonne du terme.')    !utilite
      ELSEIF (IRCODE.LT.0) THEN
*        Taille insuffisante detectee pour NMSTOR,NVSTOR
*        multiplication par 2 pour la partie superieure
         CALL WARNNG ('Estimation taille Sup structure Bimorse a revoir'
     &            //'. Prevenir Daniel.Martin@univ-rennes1.fr')         !utilite
         IF (NBAJST.GT.4) GOTO 99992
         LGCREE=3*LGCREE/2
         CALL TBAJST (NMSTOP,NVSTOP,LGCREE)
         NBAJST=NBAJST+1
         GOTO 1
      ENDIF
      IST(MCPUAR-1)=NWDLCO
      LGSTOP=LGSTOP+NWDLCO+2*IST(MCPUIR-1)
      LGUR=IST(MCSTOP-3+LGSTOP)
      CALL TBAJST (NMSTOP,NVSTOP,LGSTOP)
*
      CALL PRFXMJ (-1,'*RelBmo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMPTIT,NVPTIT,ERCODE,NCATR1)
      CALL BAISE  ('Estimation taille Inf structure Bimorse a revoir'
     &//' pour le terme '//ERCODE(1:NCATR1)
     &//'. Prevenir rapidement Daniel.Martin@univ-rennes1.fr')
99992 CALL PRNTRM (NMPTIT,NVPTIT,ERCODE,NCATR1)
      CALL BAISE  ('Estimation taille Sup structure Bimorse a revoir'
     &//' pour le terme '//ERCODE(1:NCATR1)
     &//'. Prevenir rapidement Daniel.Martin@univ-rennes1.fr')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1.1 : D.Martin (18 septembre 2006)
* - modification des messages d'erreur en sortie de Rlbmor
* Version 1.0 : D.Martin (13 fevrier 1998)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END                                                               !RelBmo
