*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELCNU (FRONTI,MOOUBM,NBNECO,NGNECO,NBNELI,NGNELI
     &                  ,NULAPL,IPLAGE,NBNEFR,NGNEFR,NBNERE,NGNERE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1989)
* Derniere modification (O.DeBayser) le 20 janvier 1995
*  
* Creation de la numerotation globale en ligne d'un domaine de relevement
* a partir des numerotations globales d'un terme "de volume",
* de son compactage en colonne MORSE ou BIMORSE (triangle superieur),
* et de la numerotation en colonne d'une frontiere.
* (ex: cas de la formulation dite de relevement 'DIRICHLET') 
*  
*-- Arguments d'entrees --
* FRONTI .TRUE. indique que les numeros globaux de la frontiere font partie
*        du domaine de relevement,   .FALSE. autrement
* MOOUBM vaut: 1 dans le cas BIMORSE, 0 sinon
* NBNECO nombre de noeuds en colonne du terme de volume
* NGNECO numerotation des noeuds en colonne du terme de volume
* NBNELI nombre de noeuds en ligne du terme de volume
* NGNELI numerotation des noeuds en ligne du terme de volume
* NULAPL tableau des numeros de derniere plage des colonnes du terme de volume
* IPLAGE tableau des numeros de debut de plage et des longueurs cumulees
*        du compactage 'MORSE' ou 'BIMORSE' du terme de volume
* NBNEFR nombre de noeuds de la frontiere de relevement
* NGNEFR numerotation des noeuds de la frontiere de relevement
*-- Arguments de sortie --
* NBNERE nombre de noeuds du terme releve 
* NGNERE numerotation des noeuds du terme releve
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL FRONTI
      INTEGER MOOUBM,NBNECO,NGNECO(*),NBNELI,NGNELI(*)
     &       ,NBNEFR,NGNEFR(*),NBNERE,NGNERE(*),NULAPL(*),IPLAGE(2,*) 
*----------------------------------------------------------------------
      LGCUAV=0 
      NDEBPL=1 
      NEFROL=1 
* 
      IF(MOOUBM.GT.0) THEN
*        Cas d'une matrice bimorse
         INELI=1
         IF (FRONTI.OR.NGNELI(INELI).NE.NGNEFR(NEFROL)) THEN  
            CALL DICOTO (1,NBNEFR,NGNEFR,NGNECO(INELI),NEFROC,*2)       !Utilite
*           Fait partie du domaine de relevement en ligne  
*           le numero global de la premiere ligne si le numero
*           global de la 1ere colonne fait partie de la frontiere
            CALL LISUNI (NBNERE,NGNERE,1,NGNELI(INELI),.FALSE.
     &                                 ,NGNELI(INELI),.TRUE.,NBNELI,*2) !Utilite
2           CONTINUE
         ELSE  
            NEFROL=NEFROL+1
         ENDIF
      ENDIF 
*
      DO 10 INELI=1+MOOUBM,NBNELI  
         NFINPL=NULAPL(INELI-MOOUBM)  
         IF (NFINPL.GT.0) LGCUMU=IPLAGE(2,NFINPL)
         IF (FRONTI.OR.NGNELI(INELI).NE.NGNEFR(NEFROL)) THEN  
            DO 5 NUMPLA=NDEBPL,NFINPL  
               LGPLAG=IPLAGE(2,NUMPLA)-LGCUAV  
               LGCUAV=LGCUAV+LGPLAG
               KOLDEB=IPLAGE(1,NUMPLA) 
               DO 4 NUCOL=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (1,NBNEFR,NGNEFR,NGNECO(NUCOL),NEFROC,*4) !Utilite
*                 Seuls font partie du domaine de relevement en ligne  
*                 les numeros globaux des lignes dont au moins un numero
*                 global en colonne fait partie de la frontiere
                  CALL LISUNI (NBNERE,NGNERE,1,NGNELI(INELI),.FALSE.
     &                        ,NGNELI(INELI),.TRUE.,NBNELI,*4)          !Utilite
                  GOTO 6
4              CONTINUE
5           CONTINUE
6           CONTINUE
         ELSE  
            NEFROL=NEFROL+1
         ENDIF 
         LGCUAV=LGCUMU 
         NDEBPL=NFINPL+1
10    CONTINUE        
                                                                    END !Relcnu
