*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELDIR (NMGROT,NVGROT,FRONTR,NMPTIT,NVPTIT)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Decembre 1989)
* Derniere modification : D.Martin (13 Fevrier 1998)
* Version 1.0.0
*  
* Calcul d'un terme de relevement issu d'une condition essentielle
*  
*-- Arguments d'entree -- 
* NMGROT som du terme dont il faut extraire le terme de relevement 
* NVGROT son niveau
* FRONTR som du domaine frontiere par rapport auquel on releve 
* NMPTIT som du terme de relevement en sortie  
* NVPTIT son niveau
*-- Remarque --
* Le terme releve a des numerotations qui correspondent :  
*    - en colonne aux noeuds de la frontiere 
*    - en ligne aux noeuds des elements qui touchent cette frontiere 
*        par au moins un noeud, exception faite des noeuds de la frontiere 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMGROT,FRONTR,NMPTIT
      INTEGER       NVGROT,NVPTIT
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      CHARACTER     ERCODE*120,NMSTOK*6,SYMIND*14
      INTEGER       INDSTO 
      LOGICAL       IADEJA 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RelDir*')
*
      CALL RELPRE (NMGROT,NVGROT,ITYPTR,ITYSYG
     &            ,NUINCC,NVNUMC,NBDLCO,NUINCL,NVNUML,NBDLLI
     &            ,INDSTG,NMSTOK,NVSTOG,LGSTOG,NCPINC,NCPINL,FRONTR
     &            ,NVNUFR,NVDUFR,NBNEFR,NBDLFR,ITYCAL,NUDONN,NVNURL
     &            ,NVDURL,NBNERL,NBDLRL,NVSTOP,NVCORP,NCHDOM,NBTERM
     &            ,NCHTRM,NMPTIT,NVPTIT,NURELV,'*RelDir*'
     &            ,IADEJA,NIVIMP)                                       !couplag
*     Numerotation en colonne (celle de la frontiere)
      NWNECO=NBNEFR
      NWDLCO=NBDLFR
      NWNUMC=NVNUFR
      IF (NCPINC.GT.1) NWNUMC=NVDUFR
*     .... en ligne (celle du domaine de relevement)
      NWNELI=NBNERL
      NWDLLI=NBDLRL
      NWNUML=NVNURL
      IF (NCPINL.GT.1) NWNUML=NVDURL
*
      IF (INDSTG.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en ligne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            LGCREE=1+(NBDLLI+1)*(IST(MCNUML)+1)  
            CALL TBCREE ('#GNEDO',NWNUML,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPLAL,MCPLAL,MCPLIL
     &                  ,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)              !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML
     &                         ,'#GNEDO',NWNUMC,MWNUMC)
            MCNUML=MCNUMC
            IF (NVNUML.NE.NVNUMC)
     &         CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            NWDLLI=0
            CALL RELCNU (.FALSE.,1,NBDLCO,IST(MCNUMC+2),NBDLLI
     &                  ,IST(MCNUML+2),IST(MCPLAL),IST(MCPLIL),NWDLCO
     &                  ,IST(MWNUMC+2),NWDLLI,IST(MWNUML+2))            !couplag
            CALL RELLNU (.FALSE.,1,NBDLLI,IST(MCNUML+2),NBDLCO
     &                  ,IST(MCNUMC+2),IST(MCPLAU),IST(MCPLIU),NWDLCO
     &                  ,IST(MWNUMC+2),NWDLLI,IST(MWNUML+2))            !couplag
            IST(MWNUML)  =IST(MCNUML)  
            IST(MWNUML+1)=NWDLLI 
            IF (NIVIMP.GT.3) 
     &         CALL PRNEDO ('*RelDir*','Ligne  ',IST(MWNUML),IMPSDR)    !prsd
            CALL TBAJST ('#GNEDO',NWNUML,1+(NWDLLI+1)*(IST(MWNUML)+1))
*
*           Calcul des tables de stockage BIMORSE du terme releve
            CALL RELBMO (NBDLLI,NWDLCO,NBDLLI,NVNUML,NBDLCO,NVNUMC
     &                  ,NMSTOK,NVSTOG,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOK,NVSTOP
     &                  ,LGLR,LGUR)
            IF (NIVIMP.GT.4) THEN
               CALL TBAR1  (ERCODE,NMSTOK,NVSTOP,MCSTOP)
               CALL PRBMOR (IST(MCSTOP),' Terme releve '
     &                     ,NMPTIT,NVPTIT,NIVIMP,IMPSDR)                !prsd
            ENDIF
            LGCREE=MIN (NWDLCO,NWDLLI)+LGLR+LGUR
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
            CALL TBSAVE (NMSTOK,NVSTOP)
         ELSE
            CALL TBRR4  (ERCODE, NMPTIT ,NVPTIT,MCPTIT
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML
     &                         , NMSTOK ,NVSTOP,MCSTOP)
*           Recherche de LGLR
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOP,MCSTOP)
            CALL EXBMOR (MCSTOP,IST(MCSTOP)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGLR
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU )                 !sdexplo
            CALL TBSAVE (NMSTOK,NVSTOP)
         ENDIF
         CALL TBAR6  (ERCODE
     &               ,'#GNEDO',NWNUMC,MWNUMC,'#GNEDO',NVNUMC,MCNUMC
     &               ,'#GNEDO',NWNUML,MWNUML, NMSTOK ,NVSTOG,MCSTOG
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
         MCNUML=MCNUMC
         IF (NVNUML.NE.NVNUMC) 
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
         CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !sdexplo
         CALL RLDGTR (NBDLCO,IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),ITYSYG  
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &               ,ITYPTR,MCGROT,NWDLCO,IST(MWNUMC+2)
     &               ,NWDLLI,IST(MWNUML+2),MCPTIT,RST,CST)              !couplag
         MCPTIT=MCPTIT+MIN(NWDLCO,NWDLLI)
         CALL RLBMTR (NBDLCO,IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),ITYSYG 
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &               ,ITYPTR,MCGROT,NWDLLI,IST(MWNUML+2)
     &               ,NWDLCO,IST(MWNUMC+2),MCPTIT,RST,CST)              !couplag
         MCPTIT=MCPTIT+LGLR
         CALL RLBMTR (NBDLLI,IST(MCNUML+2),NBDLCO,IST(MCNUMC+2),ITYSYG
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MCPLAL),IST(MCPLIL)
     &               ,ITYPTR,MCGROT,NWDLCO,IST(MWNUMC+2)
     &               ,NWDLLI,IST(MWNUML+2),MCPTIT,RST,CST)              !couplag
*
      ELSEIF (INDSTG.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
         IF (ITYSYG.NE.NDFSYM) GOTO 99999
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en ligne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            LGCREE=1+(NBDLLI+1)*(IST(MCNUML)+1)  
            CALL TBCREE ('#GNEDO',NWNUML,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXMORS (MCSTOG,IST(MCSTOG)
     &                  ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)              !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML
     &                         ,'#GNEDO',NWNUMC,MWNUMC)
            MCNUML=MCNUMC
            IF (NVNUML.NE.NVNUMC)
     &         CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
*           Calcul de la numerotation en colonne du terme releve
            NWDLLI=0
            CALL RELCNU (.FALSE.,0,NBDLCO,IST(MCNUMC+2),NBDLLI
     &                  ,IST(MCNUML+2),IST(MCPLAL),IST(MCPLIL),NWDLCO
     &                  ,IST(MWNUMC+2),NWDLLI,IST(MWNUML+2))            !couplag
            IST(MWNUML)  =IST(MCNUML)  
            IST(MWNUML+1)=NWDLLI 
            IF (NIVIMP.GT.2) 
     &         CALL PRNEDO ('*RelDir*','Ligne  ',IST(MWNUML),IMPSDR)    !prsd
            CALL TBAJST ('#GNEDO',NWNUML,1+(NWDLLI+1)*(IST(MWNUML)+1))
*
*           Calcul des tableaux de stockage MORSE-Ligne du terme releve
            CALL RELMOR (NBDLLI,NBDLLI,NVNUML,NVNUMC,NMSTOK,NVSTOG
     &                  ,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOK,NVSTOP)
            IF (NIVIMP.GT.4) THEN
               CALL TBAR2  (ERCODE,'#OMTRM',1     ,MCMTRM
     &                            , NMSTOK ,NVSTOP,MCSTOP)
               CALL PRPLAG (IST(MCSTOP),NCHTRM,' Terme releve '
     &                     ,AST(MCMTRM+NCHTRM*(NURELV-1))
     &                     ,'en noeuds',NIVIMP,IMPSDR)                  !prsd
            ENDIF
*  
*           Calcul du terme releve compacte Morse-Ligne
            LGCREE=IST(MCSTOP+3)
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
            CALL TBSAVE (NMSTOK,NVSTOP)
         ELSE
            CALL TBRR3  (ERCODE, NMPTIT ,NVPTIT,MCPTIT
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
         ENDIF
         CALL TBAR6  (ERCODE 
     &               ,'#GNEDO',NWNUML,MWNUML,'#GNEDO',NWNUMC,MWNUMC
     &               ,'#GNEDO',NVNUML,MCNUML, NMSTOK ,NVSTOG,MCSTOG 
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
         MCNUMC=MCNUML
         IF (NVNUML.NE.NVNUMC) CALL TBAR1(ERCODE,'#GNEDO',NVNUMC,MCNUMC)
         CALL EXMORS (MCSTOG,IST(MCSTOG)
     &               ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)                 !sdexplo
         CALL RLDLTR (IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),IST(MCPLAL)
     &               ,IST(MCPLIL),ITYPTR,MCGROT,NWDLCO,IST(MWNUMC+2)
     &               ,NWDLLI,IST(MWNUML+2),MCPTIT,RST,CST)              !couplag
*
      ELSEIF (INDSTG.EQ.INDSTO ('MORSE-C')) THEN                        !utilite
         IF (ITYSYG.NE.NDFSYM) GOTO 99999
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en ligne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            LGCREE=1+(NBDLLI+1)*(IST(MCNUML)+1)
            CALL TBCREE ('#GNEDO',NWNUML,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXMORS (MCSTOG,IST(MCSTOG)
     &                  ,NBC,NBL,NBPLAL,MCPLAL,MCPLIL,LGU)              !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC                  
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
            MCNUML=MCNUMC 
            IF (NVNUML.NE.NVNUMC)
     &         CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            NWDLLI=0
            CALL RELLNU (.FALSE.,0,NBDLLI,IST(MCNUML+2),NBDLCO
     &                  ,IST(MCNUMC+2),IST(MCPLAL),IST(MCPLIL),NWDLCO
     &                  ,IST(MWNUMC+2),NWDLLI,IST(MWNUML+2))            !couplag
            IST(MWNUML)  =IST(MCNUML)  
            IST(MWNUML+1)=NWDLLI 
            IF (NIVIMP.GT.2)
     &         CALL PRNEDO ('*RelDir*','Ligne  ',IST(MWNUML),IMPSDR)    !prsd
            CALL TBAJST ('#GNEDO',NWNUML,1+(NWDLLI+1)*(IST(MWNUML)+1))
*
*           Calcul des tables de stockage MORSE-Colonne du terme releve
            CALL RELMOR (NBDLCO,NBDLCO,NVNUMC,NVNUML,NMSTOK,NVSTOG
     &                  ,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLCO,NWNUMC,NWDLLI,NWNUML,NMSTOK,NVSTOP)
            IF (NIVIMP.GT.4) THEN
               CALL TBAR2  (ERCODE,'#OMTRM',  1   ,MCMTRM
     &                            , NMSTOK ,NVSTOP,MCSTOP)
               CALL PRPLAG (IST(MCSTOP),NCHTRM,' Terme releve '
     &                     ,AST(MCMTRM+NCHTRM*(NURELV-1))
     &                     ,'en noeuds',NIVIMP,IMPSDR)                  !prsd
            ENDIF
*  
*-          Calcul du terme releve compacte Morse-Colonne
            LGCREE=IST(MCSTOP+3)
            CALL TBSAVE (NMSTOK,NVSTOP)
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
         ELSE
            CALL TBRR3  (ERCODE, NMPTIT ,NVPTIT,MCPTIT 
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
         ENDIF
         CALL TBAR6  (ERCODE
     &               ,'#GNEDO',NVNUMC,MCNUMC,'#GNEDO',NWNUML,MWNUML
     &               ,'#GNEDO',NWNUMC,MWNUMC, NMSTOK ,NVSTOG,MCSTOG
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
         MCNUML=MCNUMC
         IF (NVNUML.NE.NVNUMC) 
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
         CALL EXMORS (MCSTOG,IST(MCSTOG)
     &               ,NBC,NBL,NBPLAL,MCPLAL,MCPLIL,LGU)                 !sdexplo
         CALL RLDLTR (IST(MCNUML+2),NBDLCO,IST(MCNUMC+2),IST(MCPLAL)
     &               ,IST(MCPLIL),ITYPTR,MCGROT,NWDLLI,IST(MWNUML+2)
     &               ,NWDLCO,IST(MWNUMC+2),MCPTIT,RST,CST)              !couplag
*
      ENDIF
*
*     Sauvegarde du gros terme et de ses numerotations
      CALL TBSAVE ( NMGROT ,NVGROT)
      CALL TBSAVE ( NMSTOK ,NVSTOG)
      CALL TBSAVE ('#GNEDO',NWNUMC)
      CALL TBSAVE ('#GNEDO',NWNUML)
      CALL TBSAVE ('#GNEDO',NVNUMC)
      IF (NVNUML.NE.NVNUMC) CALL TBSAVE ('#GNEDO',NVNUML)
*
*     Numerotation en noeuds (le cas echeant) pour le relevement
      NWNELI=NWDLLI
      IF (NCPINL.GT.1) NWNELI=NWNELI/NCPINL
      IF (.NOT.IADEJA.AND.NCPINL.GT.1) THEN
*        Dans le cas d'un terme en d.l.: NWNUML a le sens
*        d'une numerotation en d.l. Il faut la numerotation en noeuds.
         CALL TBCREE ('#GNEDO',NVNURL,1,2+NWNELI,'c')
         CALL TBRR1  (ERCODE,'#GNEDO',NVDURL,MCDURL)
         CALL TBAR2  (ERCODE,'#GNEDO',NVNURL,MCNURL
     &                      ,'#GNEDO',NVDURL,MCDURL)
         CALL DL2NNU (NCPINL,IST(MCDURL+1),IST(MCDURL+2)
     &                      ,IST(MCNURL+1),IST(MCNURL+2))               !sdexplo
         IST(MCNURL)=IST(MCDURL)
         CALL TBSAVE ('#GNEDO',NVNURL)
         CALL TBSAVE ('#GNEDO',NVDURL)
      ENDIF
*
*     Mise a jour des attributs du terme
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      IADTRM=MCDTRM+LGETRM+INCTRM*(NURELV-1)
      CALL PUTTRM (IST(IADTRM),  NVPTIT,ITYPTR,ITYCAL,-1    ,NUDONN
     &            ,NDFSYM,NDFDSM,NUINCC,NVDUFR,NWNECO,NVNUFR,NUINCL
     &            ,NVDURL,NWNELI,NVNURL,INDSTG,NVSTOP,NVCORP,0,NIVIMP)  !sdexplo
      IF (NIVIMP.GT.0) CALL PRTERM (NMPTIT,NVPTIT,NIVIMP,IMPSDR)        !prsd
      CALL TBSAVE (NMPTIT,NVPTIT)
*
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMPTIT,NVPTIT,ERCODE,NCATR1)
         CALL PRNTRM (NMGROT,NVGROT,ERCODE(NCATR1+1:),NCATR2)
         ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCHDOM)=FRONTR
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &                       ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &                    ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCHDOM)
      ENDIF
      CALL PRFXMJ (-1,'*RelDir*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/,' *RelDir* Calcul du terme de relevement ',A
     &/,T11,'a partir du terme ',A,' et de la frontiere ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 CALL PRNTRM (NMGROT,NVGROT,ERCODE,NCATR1)
      CALL BAISE  (' Le terme '//ERCODE(1:NCATR1)
     &//' ne peut etre stocke '//SYMIND (ITYSYG))
      END
