*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELFRI (NMGROT,NVGROT,FRONTR,NMPTIT,NVPTIT)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1989)
* Derniere modification : D.Martin (23 Avril 2001)
* Version 1.0.1
*  
* Calcul d'un terme de relevement issus de l'application de la
* formule de Green (Operation 'Relevement de frontiere intermediaire')
*  
*-- Arguments d'entree -- 
* NMGROT nom du terme dont il faut extraire le terme de relevement 
* NVGROT son niveau
* FRONTR nom du domaine frontiere par rapport auquel on releve 
* NMPTIT nom du terme de relevement en sortie  
* NVPTIT son niveau
*-- Remarque --
* Le terme releve a des numerotations qui correspondent :
*    - en colonne aux noeuds des elts dont un noeud appartient a cette frontiere
*    - en ligne aux noeuds de la frontiere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMGROT,FRONTR,NMPTIT
      INTEGER       NVGROT,NVPTIT
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
* 
      CHARACTER     ERCODE*120,NMSTOK*6,SYMIND*14
      INTEGER       INDSTO
      LOGICAL       IADEJA 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RelFri*')
*
*     Recherche des Numerotations en noeuds ou en d.l. et des tables 
*     de stockages pour le gros terme et la frontiere par rapport
*     a laquelle on releve
*
      CALL RELPRE (NMGROT,NVGROT,ITYPTR,ITYSYG
     &            ,NUINCC,NVNUMC,NBDLCO,NUINCL,NVNUML,NBDLLI
     &            ,INDSTG,NMSTOK,NVSTOG,LGSTOG,NCPINC,NCPINL,FRONTR
     &            ,NVNUFR,NVDUFR,NBNEFR,NBDLFR,ITYCAL,NUDONN,NVNURL
     &            ,NVDURL,NBNERL,NBDLRL,NVSTOP,NVCORP,NCHDOM,NBTERM
     &            ,NCHTRM,NMPTIT,NVPTIT,NURELV,'*RelFri*'
     &            ,IADEJA,NIVIMP)                                       !couplag
*     Numerotation en colonne (celle du domaine de relevement)
      NWNECO=NBNERL
      NWDLCO=NBDLRL
      NWNUMC=NVNURL 
      IF (NCPINC.GT.1) NWNUMC=NVDURL
*     .... en ligne (celle de la frontiere)
      NWNELI=NBNEFR
      NWDLLI=NBDLFR
      NWNUML=NVNUFR
      IF (NCPINL.GT.1) NWNUML=NVDUFR
*
      IF (INDSTG.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en colonne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNUMC)
            LGCREE=1+(NBDLCO+1)*(IST(MCNUMC)+1)  
            CALL TBCREE ('#GNEDO',NWNUMC,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPLAL,MCPLAL,MCPLIL 
     &                  ,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)              !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
            MCNUML=MCNUMC
            IF (NVNUML.NE.NVNUMC) 
     &         CALL TBAR1 (ERCODE,'#GNEDO',NVNUML,MCNUML)
            NWDLCO=0 
            CALL RELLNU (.TRUE.,1,NBDLCO,IST(MCNUMC+2),NBDLLI
     &                  ,IST(MCNUML+2),IST(MCPLAL),IST(MCPLIL),NWDLLI
     &                  ,IST(MWNUML+2),NWDLCO,IST(MWNUMC+2))            !couplag
            CALL RELCNU (.TRUE.,1,NBDLLI,IST(MCNUML+2),NBDLCO 
     &                  ,IST(MCNUMC+2),IST(MCPLAU),IST(MCPLIU),NWDLLI
     &                  ,IST(MWNUML+2),NWDLCO,IST(MWNUMC+2))            !couplag
            IST(MWNUMC)  =IST(MCNUMC)  
            IST(MWNUMC+1)=NWDLCO 
            IF (NIVIMP.GT.3)
     &         CALL PRNEDO ('*RelFri*','Colonne',IST(MWNUMC),IMPSDR)    !prsd
            CALL TBAJST ('#GNEDO',NWNUMC,1+(NWDLCO+1)*(IST(MWNUMC)+1))
*
*           Calcul des tables de stockage BIMORSE du terme releve
*
            CALL RELBMO (NWDLLI,NWDLCO,NBDLLI,NVNUML,NBDLCO,NVNUMC
     &                  ,NMSTOK,NVSTOG,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOK,NVSTOP
     &                  ,LGLR,LGUR)
            IF (NIVIMP.GT.4) THEN
               CALL TBAR1  (ERCODE,NMSTOK,NVSTOP,MCSTOP)
               CALL PRBMOR (IST(MCSTOP),' Terme releve '
     &                     ,NMPTIT,NVPTIT,NIVIMP,IMPSDR)                !prsd
            ENDIF
            LGCREE=MIN (NWDLCO,NWDLLI)+LGLR+LGUR
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
            CALL TBSAVE (NMSTOK,NVSTOP)
         ELSE
            CALL TBRR4  (ERCODE, NMPTIT ,NVPTIT,MCPTIT
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML
     &                         , NMSTOK ,NVSTOP,MCSTOP)
*           Recherche de LGLR
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOP,MCSTOP)
            CALL EXBMOR (MCSTOP,IST(MCSTOP)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGLR 
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU )                 !sdexplo
            CALL TBSAVE (NMSTOK,NVSTOP)
         ENDIF
         CALL TBAR6  (ERCODE
     &               ,'#GNEDO',NWNUMC,MWNUMC,'#GNEDO',NVNUMC,MCNUMC 
     &               ,'#GNEDO',NWNUML,MWNUML, NMSTOK ,NVSTOG,MCSTOG 
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
         MCNUML=MCNUMC
         IF (NVNUML.NE.NVNUMC) 
     &      CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
         CALL EXBMOR (MCSTOG,IST(MCSTOG),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !sdexplo
         CALL RLDGTR (NBDLCO,IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),ITYSYG
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &               ,ITYPTR,MCGROT,NWDLLI,IST(MWNUML+2)
     &               ,NWDLCO,IST(MWNUMC+2),MCPTIT,RST,CST)              !couplag
         MCPTIT=MCPTIT+MIN(NWDLCO,NWDLLI)
         CALL RLBMTR (NBDLCO,IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),ITYSYG
     &               ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &               ,ITYPTR,MCGROT,NWDLLI,IST(MWNUML+2)
     &               ,NWDLCO,IST(MWNUMC+2),MCPTIT,RST,CST)              !couplag
         MCPTIT=MCPTIT+LGLR
         CALL RLBMTR (NBDLLI,IST(MCNUML+2),NBDLCO,IST(MCNUMC+2),ITYSYG
     &               ,IST(MCPLAU),IST(MCPLIU),IST(MCPLAL),IST(MCPLIL)
     &               ,ITYPTR,MCGROT,NWDLCO,IST(MWNUMC+2)
     &               ,NWDLLI,IST(MWNUML+2),MCPTIT,RST,CST)              !couplag
*
      ELSEIF (INDSTG.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
         IF (ITYSYG.NE.NDFSYM) GOTO 99999
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en ligne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNUMC)
            LGCREE=1+(NBDLCO+1)*(IST(MCNUMC)+1)  
            CALL TBCREE ('#GNEDO',NWNUMC,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXMORS (MCSTOG,IST(MCSTOG)
     &                               ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL) !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
            MCNUML=MCNUMC
            IF (NVNUML.NE.NVNUMC)
     &         CALL TBAR1 (ERCODE,'#GNEDO',NVNUML,MCNUML)
*           Calcul de la numerotation en colonne du terme releve
            NWDLCO=0 
            CALL RELLNU (.TRUE.,0,NBDLCO,IST(MCNUMC+2),NBDLLI
     &                  ,IST(MCNUML+2),IST(MCPLAL),IST(MCPLIL),NWDLLI
     &                  ,IST(MWNUML+2),NWDLCO,IST(MWNUMC+2))            !couplag
            IST(MWNUMC)  =IST(MCNUMC)  
            IST(MWNUMC+1)=NWDLCO 
            IF (NIVIMP.GT.2) 
     &         CALL PRNEDO ('*RelFri*','Colonne',IST(MWNUMC),IMPSDR)    !sdexplo
            CALL TBAJST ('#GNEDO',NWNUMC,1+(NWDLCO+1)*(IST(MWNUMC)+1))
*
*           Calcul des tables de stockage MORSE-Ligne du terme releve
            CALL RELMOR (NWDLLI,NBDLLI,NVNUML,NVNUMC,NMSTOK,NVSTOG
     &                  ,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOK,NVSTOP)  
            IF (NIVIMP.GT.4) THEN
               CALL TBAR2  (ERCODE,'#OMTRM',  1   ,MCMTRM
     &                            , NMSTOK ,NVSTOP,MCSTOP)
               CALL PRPLAG (IST(MCSTOP),NCHTRM,' Terme releve' 
     &                     ,AST(MCMTRM+NCHTRM*(NURELV-1))
     &                     ,'en noeuds',NIVIMP,IMPSDR)                  !sdexplo
            ENDIF
*  
*           Calcul du terme releve compacte Morse-Ligne
            LGCREE=IST(MCSTOP+3)
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
            CALL TBSAVE (NMSTOK,NVSTOP)
         ELSE
            CALL TBRR3  (ERCODE, NMPTIT ,NVPTIT,MCPTIT
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
         ENDIF
         CALL TBAR5  (ERCODE
     &               ,'#GNEDO',NWNUML,MWNUML
     &               ,'#GNEDO',NVNUML,MCNUML, NMSTOK ,NVSTOG,MCSTOG
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
*
*
         CALL EXMORS (MCSTOG,IST(MCSTOG)
     &               ,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL)                 !sdexplo
         CALL RLFLTR (NBDLLI,IST(MCNUML+2),IST(MCPLAL)      
     &               ,IST(MCPLIL),ITYPTR,MCGROT
     &               ,NWDLLI,IST(MWNUML+2),MCPTIT,RST,CST)              !couplag
*
      ELSEIF (INDSTG.EQ.INDSTO ('MORSE-C')) THEN                        !utilite
         IF (ITYSYG.NE.NDFSYM) GOTO 99999
         IF (.NOT.IADEJA) THEN
*
*           Calcul de la numerotation en colonne du terme releve
            CALL TBAR1  (ERCODE,'#GNEDO',NVNUMC,MCNUMC)
            LGCREE=1+(NBDLCO+1)*(IST(MCNUMC)+1)
            CALL TBCREE ('#GNEDO',NWNUMC,1,LGCREE,'c')
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOG,MCSTOG)
            CALL EXMORS (MCSTOG,IST(MCSTOG)
     &                  ,NBC,NBL,NBPLAU,MCPLAU,MCPLIU,LGU)              !sdexplo
            CALL TBAR3  (ERCODE,'#GNEDO',NVNUMC,MCNUMC
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
            MCNUML=MCNUMC
            IF (NVNUML.NE.NVNUMC) 
     &         CALL TBAR1  (ERCODE,'#GNEDO',NVNUML,MCNUML)
            NWDLCO=0 
            CALL RELCNU (.TRUE.,0,NBDLLI,IST(MCNUML+2),NBDLCO 
     &                  ,IST(MCNUMC+2),IST(MCPLAU),IST(MCPLIU),NWDLLI
     &                  ,IST(MWNUML+2),NWDLCO,IST(MWNUMC+2))            !couplag
            IST(MWNUMC)  =IST(MCNUMC)  
            IST(MWNUMC+1)=NWDLCO 
            IF (NIVIMP.GT.2) 
     &         CALL PRNEDO ('*RelFri*','Colonne',IST(MWNUMC),IMPSDR)    !prsd
            CALL TBAJST ('#GNEDO',NWNUMC,1+(NWDLCO+1)*(IST(MWNUMC)+1))
*
*           Calcul des tables de stockage MORSE-Colonne du terme releve
            CALL RELMOR (NWDLCO,NBDLCO,NVNUMC,NVNUML,NMSTOK,NVSTOG
     &                  ,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLCO,NWNUMC,NWDLLI,NWNUML,NMSTOK,NVSTOP)
            IF (NIVIMP.GT.4) THEN
               CALL TBAR2  (ERCODE,'#OMTRM',  1   ,MCMTRM
     &                            , NMSTOK ,NVSTOP,MCSTOP)
               CALL PRPLAG (IST(MCSTOP),NCHTRM,' Terme releve '
     &                     ,AST(MCMTRM+NCHTRM*(NURELV-1))
     &                     ,'en noeuds',NIVIMP,IMPSDR)                  !prsd
            ENDIF
*  
*-          Calcul du terme releve compacte Morse-Colonne
            LGCREE=IST(MCSTOP+3)
            CALL TBSAVE (NMSTOK,NVSTOP)
            CALL TBCREE (NMPTIT,NVPTIT,ITYPTR,LGCREE,'c')
         ELSE
            CALL TBRR3  (ERCODE, NMPTIT ,NVPTIT,MCPTIT 
     &                         ,'#GNEDO',NWNUMC,MWNUMC
     &                         ,'#GNEDO',NWNUML,MWNUML)
         ENDIF
         CALL TBAR6  (ERCODE
     &               ,'#GNEDO',NVNUMC,MCNUMC,'#GNEDO',NWNUML,MWNUML
     &               ,'#GNEDO',NWNUMC,MWNUMC, NMSTOK ,NVSTOG,MCSTOG 
     &               , NMGROT ,NVGROT,MCGROT, NMPTIT ,NVPTIT,MCPTIT)
         MCNUML=MCNUMC
         IF (NVNUML.NE.NVNUMC) 
     &      CALL TBAR1 (ERCODE,'#GNEDO',NVNUML,MCNUML)
         CALL EXMORS (MCSTOG,IST(MCSTOG)
     &               ,NBC,NBL,NBPLAU,MCPLAU,MCPLIU,LGU)                 !sdexplo
         CALL RLDLTR (IST(MCNUML+2),NBDLCO,IST(MCNUMC+2),IST(MCPLAU)
     &               ,IST(MCPLIU),ITYPTR,MCGROT,NWDLLI,IST(MWNUML+2)
     &               ,NWDLCO,IST(MWNUMC+2),MCPTIT,RST,CST)              !couplag
*
      ENDIF
*
*     Sauvegarde du gros terme et de ses numerotations
      CALL TBSAVE ( NMGROT ,NVGROT)
      CALL TBSAVE ( NMSTOK ,NVSTOG)
      CALL TBSAVE ('#GNEDO',NWNUMC)
      CALL TBSAVE ('#GNEDO',NWNUML)
      CALL TBSAVE ('#GNEDO',NVNUMC)
      IF (NVNUML.NE.NVNUMC) CALL TBSAVE ('#GNEDO',NVNUML)
*
*     Numerotation en noeuds (le cas echeant) pour le relevement
      NWNECO=NWDLCO
      IF (NCPINC.GT.1) NWNECO=NWNECO/NCPINC
      IF (.NOT.IADEJA.AND.NCPINC.GT.1) THEN
*        Dans le cas d'un terme en d.l.: NVNUML a le sens
*        d'une numerotation en d.l. Il faut la numerotation en noeuds.
         CALL TBCREE ('#GNEDO',NVNURL,1,2+NWNECO,'c')
         CALL TBRR1  (ERCODE,'#GNEDO',NVDURL,MCDURL)
         CALL TBAR2  (ERCODE,'#GNEDO',NVNURL,MCNURL
     &                      ,'#GNEDO',NVDURL,MCDURL)
         CALL DL2NNU (NCPINC,IST(MCDURL+1),IST(MCDURL+2)
     &                      ,IST(MCNURL+1),IST(MCNURL+2))               !sdexplo
         IST(MCNURL)=IST(MCDURL)
         CALL TBSAVE ('#GNEDO',NVNURL)
         CALL TBSAVE ('#GNEDO',NVDURL)
      ENDIF
*
*     Mise a jour des attributs du terme
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      IADTRM=MCDTRM+LGETRM+INCTRM*(NURELV-1)
      CALL PUTTRM (IST(IADTRM),  NVPTIT,ITYPTR,ITYCAL,-1    ,NUDONN
     &            ,NDFSYM,NDFDSM,NUINCC,NVDURL,NWNECO,NVNURL,NUINCL
     &            ,NVDUFR,NWNELI,NVNUFR,INDSTG,NVSTOP,NVCORP,0,NIVIMP)  !sdexplo
      IF (NIVIMP.GT.0) CALL PRTERM (NMPTIT,NVPTIT,NIVIMP,IMPSDR)        !sdexplo
      CALL TBSAVE (NMPTIT,NVPTIT)
*
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMPTIT,NVPTIT,ERCODE,NCATR1)
         CALL PRNTRM (NMGROT,NVGROT,ERCODE(NCATR1+1:),NCATR2)
         ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCHDOM)=FRONTR
         WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &                       ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &                    ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCHDOM)
      ENDIF
      CALL PRFXMJ (-1,'*RelFri*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/,' *RelFri* Calcul du terme de relevement ',A,
     &/,T11,'a partir du terme ',A,' et de la frontiere ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 CALL PRNTRM (NMGROT,NVGROT,ERCODE,NCATR1)
      CALL BAISE  (' Le terme '//ERCODE(1:NCATR1)
     &//' ne peut etre stocke '//SYMIND (ITYSYG))
      END
