*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELLNU (FRONTI,MOOUBM,NBNECO,NGNECO,NBNELI,NGNELI
     &                  ,NULAPL,IPLAGE,NBNEFR,NGNEFR,NBNERE,NGNERE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1989)
* Derniere modification (D.Martin) le 21 juin 1994
*  
* Creation de la numerotation globale en colonne d'un domaine de relevement
* a partir des numerotations globales d'un terme "de volume", de
* son compactage "en ligne" MORSE ou BIMORSE (triangle inferieur),
* et de la numerotation en ligne d'une frontiere.
* (ex: cas de la formulation couplage 'frontiere intermediaire,...)
*  
*-- Arguments d'entree -- 
* FRONTI .TRUE. indique que les numeros globaux de la frontiere font partie
*        du domaine de relevement,   .FALSE. autrement
* MOOUBM vaut: 1 dans le cas BIMORSE, 0 sinon
* NBNECO nombre de noeuds en colonne du terme de volume
* NGNECO numerotation en colonne du terme de volume
* NBNELI nombre de noeuds en ligne du terme de volume  
* NGNELI numerotation en ligne du terme de volume  
* NULAPL tableau des numeros de derniere plage des lignes du terme de volume
* IPLAGE tableau des numeros de debut de plage et des longueurs cumulees
*        du compactage 'MORSE' ou 'BIMORSE' du terme de volume  
* NBNEFR nombre de noeuds de la frontiere de relevement 
* NGNEFR numerotation globale des noeuds de la frontiere de relevement
*-- Arguments de sortie --
* NBNERE nombre de noeuds du terme releve
* NGNERE numerotation des noeuds du terme releve
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      LOGICAL FRONTI
      INTEGER MOOUBM,NBNECO,NGNECO(*),NBNELI,NGNELI(*)
     &       ,NBNEFR,NGNEFR(*),NBNERE,NGNERE(*),NULAPL(*),IPLAGE(2,*)
*-----------------------------------------------------------------------
      LGCUAV=0 
      NDEBPL=1 
      NXNEFR=1 
*
      DO 5 INELI=1+MOOUBM,NBNELI  
         NFINPL=NULAPL(INELI-MOOUBM)  
         CALL DICOTO (NXNEFR,NBNEFR,NGNEFR,NGNELI(INELI),NUNEFR,*4)     !Utilite
         NXNEFR=NUNEFR+1
         NXENFR=1
         DO 3 NUMPLA=NDEBPL,NFINPL 
*           Puisque le no. global de la ligne fait partie de la
*           frontiere a relever, tous les no. globaux en colonne
*           de cette ligne doivent faire partie de la numerotation 
*           en colonne du domaine de relevement.
            LGPLAG=IPLAGE(2,NUMPLA)-LGCUAV 
            LGCUAV=LGCUAV+LGPLAG
            KOLDEB=IPLAGE(1,NUMPLA)
            IF (FRONTI) THEN
               CALL LISUNI (NBNERE,NGNERE,LGPLAG,NGNECO(KOLDEB),.FALSE.
     &                     ,NGNECO(KOLDEB),.TRUE.,NBNECO,*3)            !Utilite
            ELSE
               DO 2 NUCOL=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (NXENFR,NBNEFR,NGNEFR,NGNECO(NUCOL)
     &                        ,NEFROC,*1)                               !Utilite
                  NXENFR=NEFROC+1
                  GOTO 2
1                 CALL LISUNI (NBNERE,NGNERE,1,NGNECO(NUCOL),.FALSE.
     &                        ,NGNECO(NUCOL),.TRUE.,NBNECO,*2)          !Utilite
2              CONTINUE
            ENDIF
3        CONTINUE  
4        IF (NFINPL.GT.0) LGCUAV=IPLAGE(2,NFINPL)
         NDEBPL=NFINPL+1
5        CONTINUE
                                                                    END !Rellnu
