*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELMOR (NBLIGN,NBDLLI,NVNUML,NVNUMC
     &                  ,NMSTOG,NVSTOG,LGSTOG,NMPTIT,NVPTIT
     &                  ,NWDLLI,NWNUML,NWDLCO,NWNUMC,NMSTOP,NVSTOP)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (13 Juillet 1997)
* Derniere modification : D.Martin (13 Fevrier 1998)
*
* Calcul des tableaux de stockage MORSE-Ligne/Colonne d'un terme releve
*
* NBLIGN nombre de lignes du terme releve (= NBDLLI ou NWDLLI)
* NBDLLI nombre de lignes du terme original
* NVNUML niveau de la numerotation en ligne du terme original
* NVNUMC niveau de la numerotation en colonne du terme original
* NMSTOG/NVSTOG nom/niveau du tableau de stockage du terme original
* LGSTOG sa longueur (sert a calculer la longueur du stocakge du resultat)
* NWDLLI nombre de lignes du terme releve
* NWNUML niveau de la numerotation en ligne du terme releve
* NWDLCO nombre de colonnes du terme releve
* NWNUMC niveau de la numerotation en colonne du terme releve
* NMSTOP/NVSTOP nom/niveau du tableau de stockage du terme releve
* LGLR   longueur de la partie triangulaire inferieure du terme releve
* LGUR   longueur de la partie triangulaire superieure du terme releve
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMSTOG,NMSTOP,NMPTIT
      INTEGER       NBLIGN,NBDLLI,NVNUML,NVNUMC,NVSTOG,LGSTOG
     &             ,NVPTIT,NWDLLI,NWNUML,NWDLCO,NWNUMC,NVSTOP
*
      INCLUDE 'ALLOC'  
*
      CHARACTER     ERCODE*120
      INTEGER IRCODE,NBAJST,LGCREA,LGCREE,NBPLAX,MCNUMC,MCNUML,MWNUMC
     &       ,MWNUML,NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL,MCSTOG,MCSTOP
     &       ,LGSTOP
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RelMor*')
*
      IRCODE=0
      NBAJST=0
      LGCREA=LGSTOG
      CALL TBCRSU (NMSTOP,NVSTOP,1,LGCREA,LGCREE,'c')
1     NBPLAX=(LGCREE-4-NBLIGN)/2
      CALL TBAR6  (ERCODE
     &            ,'#GNEDO',NVNUMC,MCNUMC,'#GNEDO',NVNUML,MCNUML
     &            ,'#GNEDO',NWNUML,MWNUML,'#GNEDO',NWNUMC,MWNUMC 
     &            , NMSTOP ,NVSTOP,MCSTOP, NMSTOG ,NVSTOG,MCSTOG)
      CALL EXMORS (MCSTOG,IST(MCSTOG),NBL,NBC,NBPLAL,MCPLAL,MCPLIL,LGL) !sdexplo            
      IST(MCSTOP)  =NWDLLI
      IST(MCSTOP+1)=NWDLCO 
      CALL RLMORS (IST(MCNUMC+2),NBDLLI,IST(MCNUML+2),IST(MCPLAL) 
     &            ,IST(MCPLIL),NWDLLI,IST(MWNUML+2),NWDLCO
     &            ,IST(MWNUMC+2),NBPLAX,IST(MCSTOP+4)
     &            ,IST(MCSTOP+4+NWDLLI),IRCODE)                         !couplag
      IF (IRCODE.GT.0) THEN
*        Taille insuffisante detectee pour NMSTOP,NVSTOP
*        multiplication par 2 (pour les parties inferieure et superieure)
         CALL WARNNG ('Estimation taille structure Morse a revoir'
     &            //'. Prevenir Daniel.Martin@univ-rennes1.fr')         !Utilite
         IF (NBAJST.GT.2) GOTO 99991
         LGCREE=4*LGCREE
         CALL TBAJST (NMSTOP,NVSTOP,LGCREE)
         NBAJST=NBAJST+1
         GOTO 1
      ENDIF
      LGSTOP=4+NWDLLI+2*NBPLAX 
      IST(MCSTOP+2)=NBPLAX 
      IST(MCSTOP+3)=IST(MCSTOP-1+LGSTOP)
      CALL TBAJST (NMSTOP,NVSTOP,LGSTOP)
*
      CALL PRFXMJ (-1,'*RelMor*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMPTIT,NVPTIT,ERCODE,NCATR1)
      CALL BAISE  ('Estimation taille structure Morse a revoir, pour'
     &//' le terme '//ERCODE(1:NCATR1)
     &//'. Prevenir rapidement Daniel.Martin@univ-rennes1.fr')
      END
