*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELPRE (NMTRM1,NVTRM1,ITTRM1,ITYSY1
     &                  ,NUINC1,NVNUC1,NBDLC1,NUINL1,NVNUL1,NBDLL1
     &                  ,INDST1,NMSTO1,NVSTO1,LGSTO1,NCPIC1,NCPIL1
     &                  ,FRONTR,NVNUFR,NVDUFR,NBNEFR,NBDLFR,ITYCAL
     &                  ,NUDONN,NVNURL,NVDURL,NBNERL,NBDLRL,NVSTO2
     &                  ,NVCOR2,NCHDOM,NBTERM,NCHTRM
     &                  ,NMTRM2,NVTRM2,NUTRM2,TYPREL,DEJAFE,NIVIMP)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Decembre 1989)
* Derniere modification : D.Martin (30 Octobre 2008)
* Version 2
*  
*-- Arguments d'entree -- 
* NMTRM1 nom du terme dont il faut extraire le terme de relevement 
* NVTRM1 son niveau
* FRONTR nom du domaine frontiere par rapport auquel on releve
* NMTRM2 nom du terme de relevement en sortie  
* NVTRM2 son niveau
* TYPREL signalisation d la procedure appelant
*-- Arguments de sortie --
* ITTRM1 type du terme dont il faut extraire le terme de relevement  
* ITYSY1 son indice de symetrie 
* NUINC1 numero de l'inconnue en colonne
* NVNUC1 numero de son tableau de numeotation globale en colonne
* NBDLC1 nombre de d.l. en colonne
* NUINL1 numero de l'inconnue en ligne 
* NVNUL1 numero de son tableau de numeotation globale en ligne 
* NBDLL1 nombre de d.l. en ligne
* INDST1 type de compactage 
* NMSTO1 nom de son tableau de compactage
* NVSTO1 niveau de son tableau de compactage
* LGSTO1 longueur du tableau de stockage (pour estimation)
* NCPIC1 nombre de composantes de l'inconnue en colonne
* NCPIL1 nombre de composantes de l'inconnue en ligne
*  
* NVNUFR niveau du tableau de numerotation de la frontiere
* NBDLFR nombre de noeuds de la frontiere
* ITYCAL type du terme de relevement ('assembl')
* NUDONN numero de donnee associee
* NVNURL niveau du tableau de numerotation du relevement
* NVDURL niveau du tableau de numerotation du relevement en d.l.
* NBNERL
* NVSTO2 niveau de son tableau de compactage
* NVCOR2 niveau de son tableau de coordonnees
* NCHDOM nombre de caracteres par nom de domaine
* NBTERM nombre de termes (rang du terme releve en cas de nouveau terme)
*
* NUTRM2 numero du terme resultat si terme pre-existant (0 sinon)
* DEJAFE indice de preexistance du terme
* NIVIMP niveau d'impression du terme  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTRM1,FRONTR,NMTRM2,TYPREL,NMSTO1
      INTEGER       NVTRM1,ITTRM1,ITYSY1,NUINC1,NVNUC1,NUINL1,NVNUL1
     &             ,INDST1,NVSTO1,LGSTO1,NCPIC1,NCPIL1,NVNUFR,NVDUFR
     &             ,ITYCAL,NUDONN,NVNURL,NVDURL,NBNERL,NVSTO2,NVCOR2
     &             ,NCHDOM,NBTERM,NCHTRM,NVTRM2,NUTRM2,NIVIMP
      LOGICAL       DEJAFE  
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER     STODLN*6, ERCODE*120
      CHARACTER     YADLC1,YADLL1,YADLFR
      INTEGER       KLTERM,KLNIVE,INTYKL,INDSTO                         !utilite
      INTEGER       NVDUC1,NBNEC1,NVDUL1,NBNEL1,MCDTRM,LGETRM,INCTRM
     &             ,MCMTRM,MCTRDO,MCINCO,MCMDOM,LGERDO,NBDOMK,INCRDO
     &             ,NUTRM1,IADTRM,NIVEAU,IPTDIR,INTRPL,INUTIL
     &             ,NUDFRO,JGEOME,JNDMIX,JNDEXC,JDLHRC,JNDEXL
     &             ,JDLHRL,JVNUML,NBTRDO,JIVDOM,NBTNEU,NUKALE,IATRDO
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RelPre*')
*  
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR5  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM 
     &           ,'#NCONU',1,MCINCO,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !sdexplo
*  
      NUTRM2=KLTERM (NMTRM2,NVTRM2,AST(MCMTRM),IST(MCDTRM))             !sdexplo
*  
*     Recherche des caracteristiques du gros terme dont il faut extraire
*     le terme de relevement
*
      NUTRM1=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTRM1.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTRM1-1)
      CALL GETTRM (IST(IADTRM),NIVEAU,ITTRM1,ITYCAL,NUKALE,NUDONN
     &            ,ITYSY1,IPTDIR,NUINC1,NVDUC1,NBNEC1,NVNUC1,NUINL1
     &            ,NVDUL1,NBNEL1,NVNUL1,INDST1,NVSTO1,NVCOR2
     &            ,IATRDO,NIVIMP)                                       !sdexplo
      CALL SDEXCO (NUINC1,IST(MCINCO),NCPIC1,INTRPL,NBTNEU)             !sdexplo
      NCPIL1=NCPIC1
      IF (NUINL1.NE.NUINC1) 
     &   CALL SDEXCO (NUINL1,IST(MCINCO),NCPIL1,INTRPL,NBTNEU)          !sdexplo
*
      CALL FONUDL (NCPIC1,NCPIL1,NVNUC1,NVNUL1,0,0,0,0
     &            ,NVDUC1,NVDUL1,YADLC1,YADLL1)                         !sdexplo
      IF (.NOT.(YADLC1.EQ.'N'.AND.YADLL1.EQ.'N'))
     &   CALL PUTTRM (IST(IADTRM),NVTRM1,ITTRM1,ITYCAL,NUKALE,NUDONN
     &               ,ITYSY1,IPTDIR,NUINC1,NVDUC1,NBNEC1,NVNUC1,NUINL1
     &               ,NVDUL1,NBNEL1,NVNUL1,INDST1,NVSTO1,NVCOR2
     &               ,IATRDO,NIVIMP)                                    !sdexplo
*  
*     Recherche des caracteristiques du domaine frontiere  
      CALL KLDOMN (FRONTR,0,0,IST(MCTRDO),AST(MCMDOM),NBDOMG
     &            ,NUKFRO,IATRDO)                                       !sdexplo
      CALL GETDOR (IST(MCTRDO+IATRDO),NUDFRO,NUKFRO,JGEOME,JNDMIX
     &            ,JNDEXC,JDLHRC,NVNUFR,JNDEXL,JDLHRL,JVNUML,NVCOR2
     &            ,INUTIL,NBTRDO,JIVDOM)                                !sdexplo
      NVDUFR=NDFDUM
      YADLFR='N'
      IF (NCPIC1.GT.1) THEN 
         NVDUFR=KLNIVE ()                                               !sdexplo
         YADLFR='Y'
      ENDIF
*     Recherche des attributs du terme de relevement
      DEJAFE=.FALSE.  
      IF (NUTRM2.LE.0) THEN 
*        Il  n'existe pas, on le met dans $SDTRM et #OMTRM  
         CALL ALFANU (NBCHNT,NMTRM2)                                    !utilite
         NWHTRM=MAX (NCHTRM,LEN (NMTRM2))
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTRM2)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
         NUTRM2=NBTERM
         ITYCAL=INTYKL ('ASSEMB')                                       !utilite
         NUDONN=NDFDON
         ITYSYM=NDFSYM
         NVDURL=NDFDUM
         NVNURL=KLNIVE ()                                               !sdexplo
         NVSTO2=NVNURL
         NBNERL=0
         NBDLRL=0
         IF (TYPREL(1:8).EQ.'*RelDir*'.AND.NCPIL1.GT.1) NVDURL=KLNIVE ()!sdexplo
         IF (TYPREL(1:8).EQ.'*RelFri*') THEN
            IF (NCPIC1.GT.1) NVDURL=KLNIVE ()                           !sdexplo
            NVCOR2=NDFCOR
         ENDIF 
      ELSE
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTRM2-1)
         CALL GETTRM (IST(IADTRM)  ,NIVEAU,ITTRM2,ITYCAL,NUKALE,NUDONN
     &               ,ITYSYM,IPTDIR,NUINC2,NVDUC2,NBNEC2,NVNUC2,NUINL2
     &               ,NVDUL2,NBNEL2,NVNUL2,INDST2,NVSTO2,NVCOR2,IATRDO
     &               ,NIVIMP)                                           !sdexplo
         IF (NVNUC2.NE.NDFNUM.AND.NVNUL2.NE.NDFNUM.AND.NVSTO2.NE.NDFSTO) 
     &      DEJAFE=.TRUE.
         CALL SDEXCO (NUINC2,IST(MCINCO),NCPIC2,INTRPL,NBTNEU)          !sdexplo
         CALL SDEXCO (NUINL2,IST(MCINCO),NCPIL2,INTRPL,NBTNEU)          !sdexplo
         IF (TYPREL(1:8).EQ.'*RelFri*')  THEN
            NVCOR2=NDFCOR
            NVNURL=NVNUC2
            NBNERL=NBNEC2
            NBDLRL=NBNEC2*NCPIC2
            NVDURL=NVDUC2
         ELSEIF (TYPREL(1:8).EQ.'*RelDir*') THEN
            NVNURL=NVNUL2
            NBNERL=NBNEL2
            NBDLRL=NBNEL2*NCPIL2
            NVDURL=NVDUL2
         ENDIF
         IF (ITTRM2.NE.ITTRM1) GOTO 99991
         IF (INDST2.NE.INDST1) GOTO 99992
         IF (NCPIC2.NE.NCPIC1.OR.NCPIL2.NE.NCPIL1) GOTO 99993
      ENDIF
*
*     Cas d'inconnue vectorielle, numerotation de la frontiere
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUFR,MCNFRO)
      CALL TBAR1  (ERCODE,'#GNEDO',NVNUFR,MCNFRO)
      NBNEFR=IST(MCNFRO+1)
      NBDLFR=NBNEFR
      IF (YADLFR.EQ.'Y') THEN
         IF (TYPREL(1:8).EQ.'*RelFri*') THEN
            NBDLFR=NBDLFR*NCPIL1
         ELSEIF (TYPREL(1:8).EQ.'*RelDir*') THEN
            NBDLFR=NBDLFR*NCPIC1
         ENDIF
         CALL NUM2DL (NCPIC1,NVNUFR,NVDUFR,NBDLFR,NIVIMP)               !sdexplo
         NVNUFR=NVDUFR
      ENDIF
*
*     Cas d'inconnue(s) vectorielle(s), numerotations de la matrice en DL
      NBDLL1=NBNEL1
      IF (YADLL1.EQ.'Y') THEN
         NBDLL1=NBNEL1*NCPIL1
         CALL NUM2DL (NCPIL1,NVNUL1,NVDUL1,NBDLL1,NIVIMP)               !sdexplo
         NVNUL1=NVDUL1
      ENDIF
      NBDLC1=NBNEC1
      IF (YADLC1.EQ.'Y') THEN
         NBDLC1=NBNEC1*NCPIC1
         CALL NUM2DL (NCPIC1,NVNUC1,NVDUC1,NBDLC1,NIVIMP)               !sdexplo
         NVNUC1=NVDUC1
      ENDIF
*
      NMSTO1 = STODLN (INDST1,NCPIC1,NCPIL1)                            !utilite
      IF (NCPIL1*NCPIC1.GT.1) THEN
*        Cas d'inconnue vectorielle, compactage de la matrice en DL
         IF (INDST1.EQ.INDSTO ('BIMORSE')) THEN                         !utilite
            CALL BMO2DL (NVSTO1,NCPIL1,NCPIC1,ITYSY1,NMTRM1,NVTRM1
     &                  ,NIVIMP)                                        !sdexplo
         ELSEIF (INDST1.EQ.INDSTO ('MORSE-L')) THEN                     !utilite
            CALL MOL2DL (NVSTO1,NCPIL1,NCPIC1,NMTRM1,NVTRM1,NIVIMP)     !sdexplo
         ELSEIF (INDST1.EQ.INDSTO ('MORSE-C')) THEN                     !utilite
            CALL MOC2DL (NVSTO1,NCPIL1,NCPIC1,NMTRM1,NVTRM1,NIVIMP)     !sdexplo
         ENDIF
      ENDIF
*
*     Recherche des Numerotations et des tables de compactages pour le 
*     gros terme et la frontiere par rapport a laquelle on releve
*
      CALL TBRR4  (ERCODE,'#GNEDO',NVNUC1,LGNUC1,'#GNEDO',NVNUFR,LGNFRO
     &                   , NMSTO1 ,NVSTO1,LGSTO1, NMTRM1 ,NVTRM1,LGTRM1)
      IF (NVNUL1.NE.NVNUC1) CALL TBRR1  (ERCODE,'#GNEDO',NVNUL1,LGNUL1)
*
      CALL PRFXMJ (-1,'*RelPre*')
      RETURN
*-----------------------------------------------------------------------
99990 CALL ENCLER (INDST1,ERCODE(119:120))
      CALL BAISE  (' Relevement avec d.l. vectoriels non prevus pour'
     &//' le type de compactage '//ERCODE(119:120)//' pour l''instant')
99991 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE,NCATR1)
      CALL PRNTRM (NMTRM2,NVTRM2,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  (' Incoherence de declaration entre '
     &//ERCODE(1:NCATR1)//' et '//ERCODE(NCATR1+1:NCATR1+NCATR2))
99992 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE,NCATR1)
      CALL PRNTRM (NMTRM2,NVTRM2,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  (' Incoherence de compactage entre '
     &//ERCODE(1:NCATR1)//' et '//ERCODE(NCATR1+1:NCATR1+NCATR2))
99993 CALL PRNTRM (NMTRM1,NVTRM1,ERCODE,NCATR1)
      CALL PRNTRM (NMTRM2,NVTRM2,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE  (' Incoherence entre les inconnues de'
     &//ERCODE(1:NCATR1)//' et '//ERCODE(NCATR1+1:NCATR1+NCATR2))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (30 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (28 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !RelPre
