*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLBMOR (NBNECO,NGNECO,NBNELI,NGNELI,NULAPL,IPLAGL
     &                  ,NULAPU,IPLAGU,NBNEFR,NGNEFR,NBNERE,NGNERE
     &                  ,NBPLAR,NULAPR,IPLAGR,CODERR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1992)
* Derniere modification : D.Martin (18 septembre 2006)
* Version 1.1
*  
* Creation des tables de compactage BIMORSE d'un terme de relevement
* a partir de celles d'un terme de 'volume'
*  
*-- Arguments d'entree -- 
* NBNECO nombre de noeuds en colonne du terme de volume
* NGNECO numerotation des noeuds en colonne du terme de volume
* NBNELI nombre de noeuds en ligne du terme de volume
* NGNELI numerotation des noeuds en ligne du terme de volume 
* NULAPL,IPLAGL tables de compactage inferieures du terme de volume  
* NULAPU,IPLAGU tables de compactage superieures du terme de volume  
* NBNEFR nombre de noeuds en ligne de la frontiere
* NGNEFR numerotation des noeuds en ligne de la frontiere
* NBNERE nombre de noeuds en colonne du domaine releve
* NGNERE numerotation des noeuds en colonne du domaine releve
*-- Arguments de sortie --
* NBPLAR nombre de plages du terme releve  
* NULAPR,IPLAGR tables de compactage du terme releve
* CODERR code de retour en cas de depassement du nombre max. de plages  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBNECO,NGNECO(*),NBNELI,NGNELI(*),NULAPL(*),IPLAGL(2,*)
     &       ,NULAPU(*),IPLAGU(2,*),NBNEFR,NGNEFR(*),NBNERE,NGNERE(*)
     &       ,NULAPR(*),IPLAGR(2,*),CODERR
*-----------------------------------------------------------------------
      LGCUAV=0 
      NDEBPL=1 
      LGCURV=0 
      NBPLAX=NBPLAR
      NBPLAR=0 
      NXNELI=1
* 
      DO 10 NEFRON=2,NBNEFR
*        Dans le terme releve seules sont retenues les lignes correspondant
*        a des noeuds du domaine relevant
         CALL DICOTO (NXNELI,NBNELI,NGNELI,NGNEFR(NEFRON),INELI,*99999) !Utilite
         NXNELI=INELI+1
*        Report de toutes les positions des coeff. de la ligne correspondant
*        a des noeuds de la numerotation en colonne du domaine releve.
         NUCSAV=1 
         NUCOAV=-1
*
*        Dans le triangle inferieur du terme de volume  
         NDEBPL=1
         LGCUAV=0
         IF (INELI .GT.2) NDEBPL=NULAPL(INELI-2)+1
         IF (NDEBPL.GT.1) LGCUAV=IPLAGL(2,NDEBPL-1)
         NFINPL=NULAPL(INELI-1)
         DO 3 NUMPLA=NDEBPL,NFINPL
            LGPLAG=IPLAGL(2,NUMPLA)-LGCUAV
            KOLDEB=IPLAGL(1,NUMPLA)
            DO 2 KOLON=KOLDEB,KOLDEB-1+LGPLAG
               CALL DICOTO (NUCSAV,NBNERE,NGNERE,NGNECO(KOLON),NUCS,*2) !Utilite
               IF (NUCS.GE.NEFRON) GOTO 10
               NUCSAV=NUCS+1
               IF (NUCS.GT.NUCOAV+1) THEN  
*                 Changement de ligne ou de plage dans la somme
                  NBPLAR=NBPLAR+1
                  IF (NBPLAR.GT.NBPLAX) GOTO 9999 
                  IPLAGR(1,NBPLAR)=NUCS
               ENDIF
               LGCURV=LGCURV+1
               IPLAGR(2,NBPLAR)=LGCURV 
               NUCOAV=NUCS
2              LGCUAV=LGCUAV+1
3         CONTINUE
*
*        Pour la diagonale du terme de volume 
         CALL DICOTO (NUCSAV,NBNERE,NGNERE,NGNECO(INELI),NUCS,*4)       !Utilite
         IF (NUCS.GE.NEFRON) GOTO 10
         NUCSAV=NUCS+1
         IF (NUCS.GT.NUCOAV+1) THEN  
*           Changement de ligne ou de plage dans la somme
            NBPLAR=NBPLAR+1
            IF (NBPLAR.GT.NBPLAX) GOTO 9999 
            IPLAGR(1,NBPLAR)=NUCS
         ENDIF
         LGCURV=LGCURV+1
         IPLAGR(2,NBPLAR)=LGCURV 
         NUCOAV=NUCS
*
*        Dans le triangle superieur du terme de volume
4        DO 5 KOLON=INELI+1,NBNECO
            CALL DICOTO (NUCSAV,NBNERE,NGNERE,NGNECO(KOLON),NUCS,*5)    !Utilite
            IF (NUCS.GE.NEFRON) GOTO 10 
            NUCSAV=NUCS+1
            NUDRPU=NULAPU(KOLON-2)  
            NUPRPU=NUDRPU+1
            LGCUAU=0
            IF (NUDRPU.GT.0) LGCUAU=IPLAGU(2,NUDRPU)
            NUDRPU=NULAPU(KOLON-1)
            CALL DIKLPL (INELI,NUPRPU,NUDRPU,LGCUAU,IPLAGU,NUPLIG,*5)   !Morse
            IF (NUCS.GT.NUCOAV+1) THEN  
*              Changement de ligne ou de plage dans la somme
               NBPLAR=NBPLAR+1
               IF (NBPLAR.GT.NBPLAX) GOTO 9999 
               IPLAGR(1,NBPLAR)=NUCS
            ENDIF
            LGCURV=LGCURV+1
            IPLAGR(2,NBPLAR)=LGCURV 
            NUCOAV=NUCS
5        CONTINUE
*
10    NULAPR(NEFRON-1)=NBPLAR
      RETURN
9999  CODERR=-NEFRON
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 WRITE (*,*)
      WRITE (*,*) '* Bug dans Rlbmor '
     &//'**************************************************************'
      WRITE (*,*) ' -> NEFRON=',NEFRON,' NGNEFR(NEFRON)=',NGNEFR(NEFRON)
      CODERR = NEFRON
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1.1 : D.Martin (18 septembre 2006)
* - modification des messages (report dans RelBmo)
* Version 1.0 : D.Martin (13 juillet 1997)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END                                                               !Rlbmor
