*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RLBMTR (NBNECO,NGNECO,NBNELI,NGNELI,ITYSYG
     &                  ,NULAPL,IPLAGL,NULAPU,IPLAGU,ITYPTR,MCTERM
     &                  ,NBNEFR,NGNEFR,NBNERE,NGNERE,MCTREL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Jan. 92)
* Derniere modification (D.Martin) le 20 septembre 1994
*  
* Constitution d'un terme de relevement compacte MORSE ou BIMORSE
* cas du domaine de relevement en ligne
*  
*-- Arguments d'entree --
* NBNECO nombre de colonnes du terme dont on extrait le relevement
* NGNECO numeros globaux des noeuds pour l'interpolation en colonne
* NBNELI nombre de lignes du terme dont on extrait le relevement
* NGNELI numeros globaux des noeuds pour l'interpol. en ligne 
* ITYSYG indice de symetrie du terme dont on extrait le relevement
* NULAPL,IPLAGL tableaux de compactage Bimorse inf
* NULAPU,IPLAGU tableaux de compactage Bimorse sup 
* ITYPTR Indice de type (REEL ou COMPLEXE) du terme
* MCTERM adresse du terme en m.c. du terme dont on extrait le relevement
* NBNEFR nombre de noeuds de la front. de relevement
* NGNEFR numeros globaux des noeuds de la front. de relevement
* NBNERE nombre de noeuds du terme releve
* NGNERE numeros globaux des noeuds du terme releve
* MCTREL adresse du terme releve en m.c.
* RST,CST, quolifichets habituels  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBNECO,NGNECO(*),NBNELI,NGNELI(*),ITYSYG
     &             ,NULAPL(*),IPLAGL(2,*),NULAPU(*),IPLAGU(2,*),ITYPTR
     &             ,MCTERM,NBNEFR,NGNEFR(*),NBNERE,NGNERE(*),MCTREL 
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER       INDSYM,INTTYP
*-----------------------------------------------------------------------
      NXNELI=1  
      LGCURV=MCTREL
      LGMORL=0
      IF (ITYSYG.EQ. INDSYM (' ')) THEN                                 !Utilite
         NUDRPL=NULAPL(NBNELI-1)
         LGMORL=IPLAGL(2,NUDRPL)
      ENDIF
      IADREL=MCTERM+MIN (NBNELI,NBNECO)
      IADREC=IADREL+LGMORL
*
      IF (ITYPTR.EQ.INTTYP ('REEL')) THEN                               !Utilite
         DO 10 NEFRON=2,NBNEFR
            CALL DICOTO (NXNELI,NBNELI,NGNELI,NGNEFR(NEFRON),INELI,*51) !Utilite
            NXNELI=INELI+1
*
*           Dans le triangle inferieur du terme de volume
            NXNUCS=1
            NDEBPL=1
            LGCUAV=0
            IF (INELI .GT.2) NDEBPL=NULAPL(INELI-2)+1
            IF (NDEBPL.GT.1) LGCUAV=IPLAGL(2,NDEBPL-1)
            NFINPL=NULAPL(INELI-1)
            DO 2 NUMPLA=NDEBPL,NFINPL
               LGPLAG=IPLAGL(2,NUMPLA)-LGCUAV
               KOLDEB=IPLAGL(1,NUMPLA)
               DO 2 KOL=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(KOL),NUCS,*2)!Utilite
                  IF (NUCS.GE.NEFRON) GOTO 10 
                  NXNUCS=NUCS+1
                  IADRES=IADREL+LGCUAV
                  RST(LGCURV)=RST(IADRES)
                  LGCURV=LGCURV+1
2                 LGCUAV=LGCUAV+1
*
*           Pour la diagonale du terme de volume 
            CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(INELI),NUCS,*3)    !Utilite
            IF (NUCS.GE.NEFRON) GOTO 10
            NXNUCS=NUCS+1
            RST(LGCURV)=RST(MCTERM-1+INELI)
            LGCURV=LGCURV+1
*
*           Dans le triangle superieur du terme de volume
3           DO 5 KOL=INELI+1,NBNECO
               CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(KOL),NUCS,*5)   !Utilite
               IF (NUCS.GE.NEFRON) GOTO 10
               NXNUCS=NUCS+1
               NFINPL=NULAPU(KOL-2)  
               NDEBPL=NFINPL+1
               LGCUAV=0
               IF (NFINPL.GT.0) LGCUAV=IPLAGU(2,NFINPL)
               NFINPL=NULAPU(KOL-1)
               CALL DIKLPL (INELI,NDEBPL,NFINPL,LGCUAV,IPLAGU,NUPLIG,*5)!Morse
               LGCUAV=0
               IF (NUPLIG.GT.1) LGCUAV=IPLAGU(2,NUPLIG-1)
               KOLDEB=IPLAGU(1,NUPLIG)
               IADRES=IADREC+LGCUAV+INELI-KOLDEB
               RST(LGCURV)=RST(IADRES)
               LGCURV=LGCURV+1
5           CONTINUE
10       CONTINUE
      ELSE
         DO 20 NEFRON=2,NBNEFR
            CALL DICOTO (NXNELI,NBNELI,NGNELI,NGNEFR(NEFRON),INELI,*51) !Utilite
            NXNELI=INELI+1
*
*           dans le triangle inferieur du terme de volume
            NXNUCS=1
            NDEBPL=1
            LGCUAV=0
            IF (INELI .GT.2)NDEBPL=NULAPL(INELI-2)+1
            IF (NDEBPL.GT.1)LGCUAV=IPLAGL(2,NDEBPL-1)
            NFINPL=NULAPL(INELI-1)
            DO 12 NUMPLA=NDEBPL,NFINPL
               LGPLAG=IPLAGL(2,NUMPLA)-LGCUAV
               KOLDEB=IPLAGL(1,NUMPLA) 
               DO 12 KOL=KOLDEB,KOLDEB-1+LGPLAG
                  CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(KOL),NUCS
     &                                                            ,*12) !Utilite
                  IF (NUCS.GE.NEFRON) GOTO 20 
                  NXNUCS=NUCS+1
                  IADRES=IADREL+LGCUAV
                  CST(LGCURV)=CST(IADRES)
                  LGCURV=LGCURV+1
12                LGCUAV=LGCUAV+1
*
*           Pour la diagonale du terme de volume 
            CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(INELI),NUCS,*13)   !Utilite
            IF (NUCS.GE.NEFRON) GOTO 20
            NXNUCS=NUCS+1
            CST(LGCURV)=CST(MCTERM-1+INELI)
            LGCURV=LGCURV+1
*
*           Dans le triangle superieur du terme de volume
13          DO 15 KOL=INELI+1,NBNECO
               CALL DICOTO (NXNUCS,NBNERE,NGNERE,NGNECO(KOL),NUCS,*15)  !Utilite
               IF (NUCS.GE.NEFRON) GOTO 20
               NXNUCS=NUCS+1
               NFINPL=NULAPU(KOL-2)  
               NDEBPL=NFINPL+1
               LGCUAV=0
               IF (NFINPL.GT.0) LGCUAV=IPLAGU(2,NFINPL)
               NFINPL=NULAPU(KOL-1)
               CALL DIKLPL(INELI,NDEBPL,NFINPL,LGCUAV,IPLAGU,NUPLIG,*15)!Morse
               LGCUAV=0
               IF (NUPLIG.GT.1) LGCUAV=IPLAGU(2,NUPLIG-1)
               KOLDEB=IPLAGU(1,NUPLIG)
               IADRES=IADREC+LGCUAV+INELI-KOLDEB
               CST(LGCURV)=CST(IADRES)
               LGCURV=LGCURV+1
15          CONTINUE
20       CONTINUE 
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
51    CALL BAISE  (' Le numero global NGNEFR(NEFRON) doit se trouver dan 
     &s la numerotation en ligne ')                                     !Utilite
                                                                    END !Rlbmtr
