*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CHKQUA (NUSCHQ,NDMDOM,INTRPC,INTRPL,IMPPAL,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Novembre 2002) 
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2
*
* Test du degre d'exactitude de la formule de quadrature sur le domaine
*
*-- Arguments --
* NUSCHQ numero de la formule de quadrature
* NDMDOM dimension du domaine ou on utilise la formule
* INTRPC interpolation en colonne
* INTRPC interpolation en ligne
* IMPPAL numero d'unite logique du fichier d'impression principal
* IMPMES numero d'unite logique du fichier d'impression des messages
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUSCHQ,NDMDOM,INTRPC,INTRPL,IMPPAL,IMPMES
*
      CHARACTER PRFXAS*8
      INTEGER INTDEG,DEGQUA,NTYPFO
      INTEGER JNTRPC,JNTRPL,DEGREF,DEGINC,DEGINL
      PARAMETER (NTYPFO = 1000)
*-----------------------------------------------------------------------
      IF (INTRPC.LT.0.AND.INTRPL.LT.0) RETURN
      JNTRPC=INTRPC
      JNTRPL=INTRPL
*
*     Cas d'elements finis non Standard (ef localises ...)
*
      IF (JNTRPC.LT.0) THEN
         JNTRPC=JNTRPL
      ELSEIF (JNTRPC.LT.0) THEN
         JNTRPL=JNTRPC
      ENDIF
*
*     Degre d'exactitude de la formule actuelle
*
      DEGREF=DEGQUA (NUSCHQ,10*NTYPFO*NDMDOM)                           !ef3d
*
      IF (JNTRPL.EQ.JNTRPC) THEN
*        Degre des polynomes correspondant a l'interpolation en colonne
         DEGINC=INTDEG (JNTRPC)                                         !utilite
*
         IF (DEGREF.LT.2*DEGINC-1) THEN
            CALL BIP ()
            WRITE (IMPMES,10010) PRFXAS(0),NUSCHQ,DEGREF,JNTRPC,DEGINC
            WRITE (IMPPAL,10010) NUSCHQ,DEGREF,JNTRPC,DEGINC
            WRITE (IMPMES,10012) 2*DEGINC-1
            CALL WARNNG ('Utiliser la directive QUADRATURE.')
         ENDIF
      ELSE
*        Degre des polynomes correspondant a l'interpolation en colonne
         DEGINC=INTDEG (JNTRPC)                                         !utilite
*        Degre des polynomes correspondant a l'interpolation en ligne
         DEGINL=INTDEG (JNTRPL)                                         !utilite
*
         IF (DEGREF.LT.DEGINC+DEGINL-1) THEN
            CALL BIP ()
            WRITE (IMPMES,10011) PRFXAS(0),NUSCHQ,DEGREF
     &                          ,JNTRPC,DEGINC,JNTRPL,DEGINL
            WRITE (IMPPAL,10011) NUSCHQ,DEGREF
     &                          ,JNTRPC,DEGINC,JNTRPL,DEGINL
            WRITE (IMPMES,10012) DEGINC+DEGINL-1
         CALL WARNNG ('Utiliser la directive QUADRATURE.')
         ENDIF
*
      ENDIF
*-----------------------------------------------------------------------
10010 FORMAT(' ',A8,' :>( La formule de quadrature numero ',I3
     &,' de degre ',I3,' peut etre insuffisante '
     &/T11,':>(  pour l''interpolation numero',I2,', de degre ',I2,'.')
10012 FORMAT(T11,':>( Utiliser une formule de degre au moins egal a '
     &,I3,' (?).')
10011 FORMAT(' ',A8,' :>( La formule de quadrature numero ',I3
     &,' de degre ',I3,' peut etre insuffisante',
     &/T11,':>( pour les interpolations numero ',I2,', de degre ',I2
     &,'et numero ',I2,', de degre ',I2,'.')
                                                                    END !ChkQua


