*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION DEGQUA (K,T)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 2000)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Degre d'exactitude de la formule de quadrature de numero K pour l'element
* de type TYPE
*
*-- Argument d'entree --
* K code entier definissant la formule de quadrature
* T numero de type de l'element
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER K,T,DEGQUA
*
      INTEGER DIM,TYP,SHP, LAGDMX, NTYPFO
      PARAMETER (LAGDMX = 100, NTYPFO = 1000)
      CHARACTER ERR*4,ERRD*1
*-----------------------------------------------------------------------
      DEGQUA=0
      DIM=T/(10*NTYPFO)
*
      IF (K.GT.0) THEN
         DEGQUA=K
         IF (K.GT.LAGDMX) DEGQUA=K-LAGDMX
      ELSEIF (K.EQ.-1) THEN
         DEGQUA=1
      ELSEIF (K.EQ.-2) THEN
         DEGQUA=3
         TYP=T-10*NTYPFO*DIM
*        Formules nodales des triangles, prismes et tetraedres d'ordre 2
         IF (TYP.GT.0) DEGQUA=2
      ELSEIF (K.EQ.-3) THEN
         IF (DIM.EQ.2) DEGQUA=3
      ELSEIF (K.EQ.-4) THEN
         IF (DIM.EQ.1) DEGQUA=5
      ENDIF
*
      IF (DEGQUA.EQ.0) THEN
         CALL ENCLER (K,ERR)
         CALL ENCLER (T,ERRD)
         CALL BAISE ('<DegQua> Formule de numero non prevu :'
     &              //ERR//' en dimension '//ERRD//'.')
      ENDIF
                                                                    END !DegQua



