*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EL000C (FORM,NDIM,CORLOC) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1994)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Cordonnees locales du point central dans les elements de reference d'ordre 0
*
*-- Arguments d'entree --
* FORM 0 hexaedres, quadrangles ou segments
*      1 prismes, triangles
*      2 tetraedres, triangles
* NDIM dimension d'espace
*-- Arguments en sortie --
* CORLOC Tableau des coordonnees du point central
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER FORM,NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER I
      REAL    TIERS
*-----------------------------------------------------------------------
      IF (FORM.EQ.0) THEN
*
*        Hexaedres, quadrangles ou segments
         DO 1 I=1,NDIM
            CORLOC(I,1)=.5
1        CONTINUE
*
      ELSEIF (FORM.EQ.1) THEN
*
*        Prismes, triangles
         TIERS=1./3.
         DO 2 I=1,2
            CORLOC(I,1)=TIERS
2        CONTINUE
         IF (NDIM.EQ.3) CORLOC(3,1)=.5
*
      ELSEIF (FORM.EQ.2) THEN
*
*        Tetraedres, triangles
         TIERS=1./3.
         DO 3 I=1,NDIM
            CORLOC(I,1)=TIERS
3        CONTINUE
*
      ENDIF
                                                                    END !El000C
