*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMCO (NUTYPE,NDIM,CORLOC) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1988)
* Derniere modification : D.Martin (22 mars 2007)
* Version 2.1
* (-> Penser a supprimer l'argument NDIM qui peut etre incoherent avec NUTYPE)
*
* Coordonnees des points dans l'element de reference 1d, 2d ou 3d
*
*-- Variable d'entree --
* NUTYPE NUmero de TYpe d'ELement
*    (1) Convention pour la forme geometrique de l'element
*        0 pour les Hexaedres en dimension 3
*               les Quadrangles en dimension 2
*               les Segments en dimension 1
*     1000 pour les Prismes en dimension 3
*               les Triangles en dimension 2
*     2000 pour les Tetraedres en dimension 3
*     3000 pour les Pyramides en dimension 3
*    (2) Convention pour une forme d'element donnee
*             k < 100 Lagrange d'ordre k
*       100 < k < 200 Lagrange d'ordre k aux points de Gauss-Lobatto
*             k = 200 Hermite d'ordre 3 (triangles, segments)
*             k = 201 Lagrange d'ordre 1 Non Conforme (triangles)
*             k = 202 Serendipity d'ordre 2 (quadrangles, prismes, hexaedres)
*             k = 203 P1 + bulle P3 (triangles)
*
*         -->   NUTYPE = Somme de 10000*dim & de (1) & de (2)
* NDIM   dimension d'espace de l'element de reference (dimension de CORLOC)
*-- Variables en sortie --  
* CORLOC tableau des coordonnees des noeuds dans l'element de reference
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUTYPE,NDIM
      REAL    CORLOC(NDIM,*) 
*
      CHARACTER FORMA*12
      INTEGER LAGDMX,DIML,TYPE,FORM
      PARAMETER ( LAGDMX = 100 )
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
      IF (DIML.NE.NDIM) GOTO 10001                                      !03-2007
*
      IF (TYPE.EQ.0) THEN
*
*        Elements d'ordre 0 en dimension quelconque
         IF (DIML.LE.0.OR.DIML.GE.4) CALL ERELEM (2,'*ElemCo*',NUTYPE)
         CALL EL000C (FORM,DIML,CORLOC)
         RETURN
*
      ENDIF
*
      IF (DIML.EQ.3) THEN
*
         IF (FORM.EQ.0) THEN
            IF (TYPE.LT.2*LAGDMX) THEN
               CALL HELKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.202) THEN
               CALL HE202C (DIML,CORLOC)
            ELSE
               CALL HEXXCO(TYPE,DIML,CORLOC)
            ENDIF
         ELSEIF (FORM.EQ.1) THEN
            IF (TYPE.LE.2) THEN
               CALL PRLKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.202) THEN
               CALL PR202C (DIML,CORLOC)
            ELSE
               CALL PRXXCO (TYPE,DIML,CORLOC)
            ENDIF 
         ELSEIF (FORM.EQ.2) THEN
            IF (TYPE.LE.2) THEN
               CALL TELKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.202) THEN
               CALL TELKCO (2,DIML,CORLOC)
            ELSE
               CALL TEXXCO (TYPE,DIML,CORLOC)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemCo*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
         IF (FORM.EQ.0) THEN
            IF (TYPE.LT.2*LAGDMX) THEN
               CALL QULKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.202) THEN
               CALL QU202C (DIML,CORLOC)
            ELSE
               CALL QUXXCO (TYPE,DIML,CORLOC)
            ENDIF 
         ELSEIF (FORM.EQ.1) THEN
            IF (TYPE.LE.LAGDMX) THEN
               CALL TRLKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.200) THEN
               CALL TR200C (DIML,CORLOC)
            ELSEIF (TYPE.EQ.201) THEN
               CALL TR201C (DIML,CORLOC)
            ELSEIF (TYPE.EQ.202) THEN
               CALL TRLKCO (2,DIML,CORLOC)
            ELSEIF (TYPE.EQ.203) THEN                                   !06/2004
               CALL TR200C (DIML,CORLOC)                                !06/2004
            ELSE
               CALL TRXXCO (TYPE,DIML,CORLOC)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemCo*',NUTYPE)
         ENDIF
* 
      ELSEIF (DIML.EQ.1) THEN
*
         IF (FORM.EQ.0) THEN
            IF (TYPE.LT.2*LAGDMX) THEN
               CALL SELKCO (TYPE,DIML,CORLOC)
            ELSEIF (TYPE.EQ.200) THEN
               CORLOC(1,1)=1.
               CORLOC(1,2)=0.
            ELSEIF (TYPE.EQ.201) THEN
               CORLOC(1,1)=0.5
            ELSEIF (TYPE.EQ.202) THEN
               CALL SELKCO (2,DIML,CORLOC)
            ELSE
               CALL SEXXCO (TYPE,DIML,CORLOC)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemCo*',NUTYPE)
         ENDIF
      ELSE
         CALL ERELEM (2,'*ElemCo*',NUTYPE)
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10001 CALL ENCLER (NUTYPE,FORMA(:6))                                    !Utilite
      CALL ENCLER (NDIM,FORMA(7:12))                                    !Utilite
      CALL BAISE  (' *ElemCo*(Ef3d) Conflit entre numero de type '
     &//' d''element ('//FORMA(:6)//') et dimension de CORLOC ('
     &//FORMA(7:12)//')')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2.1 D.Martin (22 mars 2007)
* - ajout d'un message d'erreur en cas d'incoherence NUTYPE / NDIM
* Version 2 D.Martin (04 juillet 2005)
                                                                    END !Elemco
