*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMDL (NUTYPE,NEDUDL,IRGDLN,NDLINN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Description des D.L. des elements d'Hermite
* Ce sous-programme ne doit pas etre appele pour les elements de Lagrange
*  
*-- Variable d'entree --
* NUTYPE numero de type de l'element
*  
*-- Variables en sortie --  
* NEDUDL(idl) numero du noeud supportant le d.l. idl 
* IRGDLN(idl) rang du d.l. idl dans l'ensemble des d.l. du noeud le portant  
* NDLINN(ine) nombre de d.l.(internes) portes par le noeud ine
*  
*  Remarque : Les d.l. portes par un noeud sont ranges consecutivement 
*             dans l'ordre de la numerotation des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER     NUTYPE,NEDUDL(*),IRGDLN(*),NDLINN(*)
*  
      INTEGER     DIML,FORM,TYPE
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*  
      IF (DIML.EQ.3) THEN
*  
*        Elements en dimension 3 
         IF (FORM.EQ.0) THEN
*           Elements hexaedriques
            CALL HEXXDL (TYPE,NEDUDL,IRGDLN,NDLINN)
         ELSEIF (FORM.EQ.1) THEN
*           Elements prismatiques
            CALL PRXXDL (TYPE,NEDUDL,IRGDLN,NDLINN) 
         ELSEIF (FORM.EQ.2) THEN
*           Elements tetraedriques
            CALL TEXXDL (TYPE,NEDUDL,IRGDLN,NDLINN) 
         ELSE
            CALL ERELEM (3,'*ElemDl*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*  
         IF (FORM.EQ.0) THEN
*           Elements quadrangulaires
            CALL QUXXDL (TYPE,NEDUDL,IRGDLN,NDLINN) 
         ELSEIF (FORM.EQ.1) THEN
*           Elements triangulaires
            IF (TYPE.EQ.200) THEN
               CALL TR200D (NEDUDL,IRGDLN,NDLINN)
            ELSE
               CALL TRXXDL (TYPE,NEDUDL,IRGDLN,NDLINN)
            ENDIF 
         ELSE
            CALL ERELEM (3,'*ElemDl*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.1) THEN
*
         IF (FORM.EQ.0) THEN
*           Elements en dimension 1 
            IF (TYPE.EQ.200) THEN
               CALL SE200D (NEDUDL,IRGDLN,NDLINN)
            ELSE
               CALL SEXXDL (TYPE,NEDUDL,IRGDLN,NDLINN)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemDl*',NUTYPE)
         ENDIF
      ELSE
         CALL ERELEM (2,'*ElemDl*',NUTYPE)
      ENDIF
                                                                    END !ElemDl
