*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMFA (NUTYPE,NDMDOM,NUFACE
     &                  ,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Constitution des renseignements (numerotations locales des noeuds, d.l., ...)
* sur une face (NDMDOM=2) ou une arete (NDMDOM=1) d'un element de reference. 
*  
*-- Variables d'entree -- 
* NUTYPE numero de type de l'element
* NDMDOM dimension de la face ou arete
* NUFACE numero de la face ou arete de l'element 
*  
*-- Variables en sortie --
* NUTYFA numero de type de face ou d'arete
* NBNEFA nombre de noeuds sur la face ou arete NUFACE de l'element  
* NUNEFA(inef) numero local du noeud inef de la face ou arete  
* NBDLFA nombre de d.l. de la face ou arete NUFACE de l'element
* NUDLFA(idlf) numero local du d.l. idlf de la face ou arete
*  
* --> Remarque : En dimension 2, la numerotation locale sur les faces est telle
*                que la normale exterieure est directement orthogonale au vecteur
*                'NUNEFA(2)-NUNEFA(1)'
*                En dimension 3, la numerotation locale sur les faces est telle
*                que la normale exterieure est donnee par le produit exterieur
*                'NUNEFA(2)-NUNEFA(1)'^ 'NUNEFA(3)-NUNEFA(2)'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUTYPE,NDMDOM,NUFACE,NUTYFA,NBNEFA,NBDLFA
     &       ,NUNEFA(*),NUDLFA(*)
*
      INTEGER     DIML,FORM,TYPE,LAGDMX,NTYPFO
      PARAMETER ( LAGDMX = 100, NTYPFO = 1000)
*-----------------------------------------------------------------------
      IF (NUFACE.LE.0) RETURN
*
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
* 
      IF (NDMDOM.EQ.0) THEN
*        Pour les points quelque soit l'element
         NBNEFA=1
         NUTYFA=0
         NBDLFA=NBNEFA
         NUNEFA(1)=NUFACE
*
      ELSEIF (DIML.EQ.1) THEN
*
*        En Dimension 1 !
         CALL ERELEM (3,'*ElemFa*',NUTYPE)
*
      ELSEIF (DIML.EQ.3) THEN
* 
         IF (NDMDOM.EQ.2) THEN
*           Faces de dimension 2
            IF (TYPE.EQ.0) THEN
*              Hexaedres, Prismes, Tetraedres d'ordre 0
               NBNEFA=1
               NUTYFA=20*NTYPFO
               NBDLFA=NBNEFA
               NUNEFA(1)=1
               IF (FORM.EQ.1.AND.(NUFACE.EQ.1.OR.NUFACE.EQ.5)
     &         .OR.FORM.EQ.2) NUTYFA=21*NTYPFO
*  
            ELSEIF (FORM.EQ.0) THEN
*              Hexaedres
               IF (TYPE.LT.2*LAGDMX.OR.TYPE.EQ.202) THEN
*                 ... de Lagrange d'ordre k (k=1,2)
                  CALL HELKFA (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL HEXXFA
     &           (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA)
               ENDIF
            ELSEIF (FORM.EQ.1) THEN
*              Prismes
               IF (TYPE.LE.2) THEN
*                 ... de Lagrange d'ordre k
                  CALL PRLKFA (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL PR202F (NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL PRXXFA
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA)
               ENDIF
            ELSEIF (FORM.EQ.2) THEN
*              Tetraedres
               IF (TYPE.LE.2) THEN
*                 ... de Lagrange d'ordre k (k=1,2)
                  CALL TELKFA (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL TELKFA (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL TEXXFA
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA)
               ENDIF
            ELSE
               CALL ERELEM (3,'*ElemFa*',NUTYPE)
            ENDIF
*
         ELSEIF (NDMDOM.EQ.1) THEN
*
            IF (TYPE.EQ.0) THEN
*              Aretes de tous les elements d'ordre 0
	            NBNEFA=1
               NUTYFA=10*NTYPFO
               NUNEFA(1)=1
               NBDLFA=NBNEFA
*
            ELSEIF (FORM.EQ.0) THEN
*              Hexaedres 
               IF (TYPE.LT.2*LAGDMX) THEN
*                 ... de Lagrange d'ordre k
                  CALL HELKAR (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL HELKAR (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL HEXXAR
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA) 
               ENDIF
            ELSEIF (FORM.EQ.1) THEN
*              Prismes
               IF (TYPE.LE.2) THEN
*                 ... de Lagrange d'ordre k
                  CALL PRLKAR (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL PRLKAR (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL PRXXAR
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA) 
               ENDIF
            ELSEIF (FORM.EQ.2) THEN
*              Tetraedres
               IF (TYPE.LE.2) THEN
*                 ... de Lagrange d'ordre k
                  CALL TELKAR (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL TELKAR (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL TEXXAR
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA) 
               ENDIF
            ELSE
               CALL ERELEM (3,'*ElemFa*',NUTYPE)
            ENDIF
*
         ELSE
            CALL ERELEM (4,'*ElemFa*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
* 
         IF (NDMDOM.EQ.1) THEN
            IF (TYPE.EQ.0) THEN
*              Aretes de tous les elements d'ordre 0
	           NBNEFA=1
               NUTYFA=10*NTYPFO
               NUNEFA(1)=1
               NBDLFA=NBNEFA
*
            ELSEIF (FORM.EQ.0) THEN
*              Quadrangles
               IF (TYPE.LT.2*LAGDMX) THEN
*                 ... de Lagrange
                  CALL QULKAR (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL QULKAR (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSE
                  CALL QUXXAR
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA) 
               ENDIF
            ELSEIF (FORM.EQ.1) THEN
*              Triangles
               IF (TYPE.LE.LAGDMX) THEN
*                 ... de Lagrange
                  CALL TRLKAR (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.200) THEN
*                 ... de Hermite P3
                  CALL TR200A
     &            (NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA)
               ELSEIF (TYPE.EQ.201) THEN
*                 ... de Lagrange non conforme d'ordre 1
                  NBNEFA=1
                  NUTYFA=10*NTYPFO
                  NUNEFA(1)=1
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.202) THEN
*                 ... de Lagrange Serendipity d'ordre 2
                  CALL TRLKAR (2,NUFACE,NUTYFA,NBNEFA,NUNEFA)
                  NBDLFA=NBNEFA
               ELSEIF (TYPE.EQ.203) THEN                                !06/2004
*                 ... de Lagrange P1 + bulle P3                         !06/2004
                  CALL TRLKAR (1,NUFACE,NUTYFA,NBNEFA,NUNEFA)           !06/2004
                  NBDLFA=NBNEFA                                         !06/2004
               ELSE
                  CALL TRXXAR
     &            (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA,NBDLFA,NUDLFA) 
               ENDIF
            ELSE
              CALL ERELEM (3,'*ElemFa*',NUTYPE)
            ENDIF
         ELSE
            CALL ERELEM (4,'*ElemFa*',NUTYPE)
         ENDIF
      ENDIF
                                                                    END !ElemFa
