*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMFB (NUTYPE,KELFCT,COR,P,DP,DDP,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (30 septembre 2005)
* Version 3
*
* Calcul des fonctions de base et/ou derivees dans l'element de reference
*
*-- Variables d'entree --
* NUTYPE numero de type de l'element
* KELFCT variable CHARACTER indiquant
*         si KELFCT(1:1).NE.'N' Calcul des fonctions de base  
*         si KELFCT(2:2).NE.'N' Calcul des derivees 1eres
*         si KELFCT(3:3).NE.'N' Calcul des derivees 2ndes
* COR    coordonnees du point ou on demande le calcul
* IMPFCH impression sur unite IMPFCH si >0
*-- Variables en sortie --  
* P      valeurs des fonctions de base 
*        P(I) I=1,..., nombre de D.L. de l'element
* DP     valeurs des derivees premieres de fonctions de base
*        DP(J,I) J=1,..Diml, I=1,..., nombre de D.L. de l'element de reference
* DDP    valeurs des derivees secondes de fonctions de base
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   NUTYPE,IMPFCH
      CHARACTER KELFCT*(*) 
      REAL      COR(*),P(*),DP(*),DDP(*)
*
      INTEGER   LAGDMX
      PARAMETER ( LAGDMX = 100 )
      INTEGER   DIML,FORM,TYPE,LA,CL,SO,AR,FA,NE,NBDLEL,NAX,NDX,NFX,NGX
     &         ,I,J
      REAL      TOTAL
      CHARACTER LEYTUN*5
*-----------------------------------------------------------------------  
      IF (KELFCT(1:2).EQ.'NN') RETURN
*
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      IF (TYPE.LE.0) THEN
*        Elements d'ordre 0, dimension quelconque
         CALL EL000B(KELFCT,DIML,P,DP)
*
      ELSEIF (DIML.EQ.3) THEN
*
         IF (FORM.EQ.0) THEN
            IF (TYPE.LT.2*LAGDMX) THEN
               CALL HELKFB (TYPE,KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSEIF (TYPE.EQ.202) THEN
               CALL HE202B (KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSE
               CALL HEXXFB (TYPE,KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ENDIF 
         ELSEIF (FORM.EQ.1) THEN  
            IF (TYPE.EQ.1) THEN
               CALL PR001B (KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSEIF (TYPE.EQ.2) THEN
               CALL PR002B (KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSEIF (TYPE.EQ.202) THEN
               CALL PR202B (KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSE
               CALL PRXXFB (TYPE,KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ENDIF
         ELSEIF (FORM.EQ.2) THEN
            IF (TYPE.EQ.1) THEN
               CALL TE001B (KELFCT,COR(1),COR(2),COR(3),P,DP)
            ELSEIF (TYPE.EQ.2.OR.TYPE.EQ.202) THEN
               CALL TE002B (KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ELSE
               CALL TEXXFB (TYPE,KELFCT,COR(1),COR(2),COR(3),P,DP,DDP)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemFb*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN 
*
         IF (FORM.EQ.0) THEN
*           Elements quadrangulaires
            IF (TYPE.LT.2*LAGDMX) THEN
               CALL QULKFB (TYPE,KELFCT,COR(1),COR(2),P,DP,DDP)
            ELSEIF (TYPE.EQ.202) THEN
               CALL QU202B (KELFCT,COR(1),COR(2),P,DP,DDP)
            ELSE
               CALL QUXXFB(TYPE,KELFCT,COR(1),COR(2),P,DP,DDP)
            ENDIF 
         ELSEIF (FORM.EQ.1) THEN
*           Elements triangulaires
            IF (TYPE.EQ.1) THEN
               CALL TR001B (KELFCT,COR(1),COR(2),P,DP)
            ELSEIF (TYPE.EQ.2.OR.TYPE.EQ.202) THEN
               CALL TR002B (KELFCT,COR(1),COR(2),P,DP,DDP)
            ELSEIF (TYPE.EQ.3) THEN
               CALL TR003B (KELFCT,COR(1),COR(2),P,DP,DDP)
            ELSEIF (TYPE.EQ.4) THEN                                     !09/2005
               CALL TR004B (KELFCT,COR(1),COR(2),P,DP,DDP)              !09/2005
            ELSEIF (TYPE.EQ.5) THEN                                     !09/2005
               CALL TR005B (KELFCT,COR(1),COR(2),P,DP,DDP)              !09/2005
            ELSEIF (TYPE.EQ.6) THEN                                     !09/2005
               CALL TR006B (KELFCT,COR(1),COR(2),P,DP,DDP)              !09/2005
            ELSEIF (TYPE.EQ.200) THEN
               CALL TR200B (KELFCT,COR(1),COR(2),P,DP,DDP)
            ELSEIF (TYPE.EQ.201) THEN
               CALL TR201B (KELFCT,COR(1),COR(2),P,DP)
            ELSEIF (TYPE.EQ.203) THEN                                   !06/2004
               CALL TR203B (KELFCT,COR(1),COR(2),P,DP)                  !06/2004
            ELSE
               CALL TRXXFB (TYPE,KELFCT,COR(1),COR(2),P,DP,DDP)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemFb*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.1) THEN 
*
         IF (FORM.EQ.0) THEN
*           Elements de dimension 1 
            IF (TYPE.LE.LAGDMX) THEN
               CALL SELKFB (TYPE,KELFCT,COR(1),P,DP,DDP)
            ELSEIF (TYPE.LT.2*LAGDMX) THEN
               CALL SEGLKB (TYPE-LAGDMX,KELFCT,COR(1),P,DP,DDP)
            ELSEIF (TYPE.EQ.200) THEN
               CALL SE200B (KELFCT,COR(1),P,DP,DDP)
            ELSEIF (TYPE.EQ.201) THEN
               CALL EL000B (KELFCT,1,P,DP)
            ELSEIF (TYPE.EQ.202) THEN
               CALL SELKFB (2,KELFCT,COR(1),P,DP,DDP)
            ELSE
               CALL SEXXFB (TYPE,KELFCT,COR(1),P,DP,DDP)
            ENDIF
         ELSE
            CALL ERELEM (3,'*ElemFb*',NUTYPE) 
         ENDIF
      ELSE
         CALL ERELEM (2,'*ElemFb*',NUTYPE)
      ENDIF
*-----------------------------------------------------------------------
*   Impressions eventuelles :  
*  
      IF (IMPFCH.LE.0) RETURN
      WRITE (IMPFCH,1001) LEYTUN(NUTYPE),(COR(I),I=1,DIML)
      CALL ELEMNB (NUTYPE,LA,CL,SO,AR,FA,NE,NBDLEL,NAX,NDX,NFX,NGX) 
      IF (KELFCT(1:1).NE.'N') THEN
         TOTAL=0.
         DO 90 I=1,NBDLEL
            TOTAL=TOTAL+P(I)
 90      CONTINUE
         WRITE (IMPFCH,1002) 'Valeurs',(P(I),I=1,NBDLEL),TOTAL
      ENDIF
      IF (KELFCT(2:2).NE.'N') THEN  
         DO 1003 J=1,DIML
            TOTAL=0.
            DO 91 I=1,NBDLEL
               TOTAL=TOTAL+DP(J+DIML*(I-1))
 91         CONTINUE
            WRITE (IMPFCH,1002)
     &           'Derivees/X'//CHAR(J+48),(DP(J+DIML*(I-1)),I=1,NBDLEL)
     &           ,TOTAL
 1003    CONTINUE
      ENDIF
 1001 FORMAT(/T6,'*Elemfb*  Fonctions de base pour l''element ',A, 
     &' au point : ',3E11.4)
 1002 FORMAT(T7,A,(T19,':',10E11.4))
                                                                    END !Elemfb
