*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMNB (NUTYPE,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE  
     &                  ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (15 Octobre 2001)
* Version 1.0.2
*
* Nombres caracteristiques d'un element fini
*  
*-- Variable d'entree --
* NUTYPE numero de type de l'element
*  
*-- Variables de sortie --  
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* CLASSE classe de l'element (Element de classe C^0, C^1,...etc)
* NBSOMT nombre de sommets
* NBARET nombre d'aretes (2D ou 3D) ou de sommets (1D)
* NBFACE nombre de faces (3D) ou d'aretes (2D) ou de sommets (1D)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBNEAX nombre maximum de noeuds sur une arete (=NBNEEL si dim < 2)
* NBDLAX nombre maximum de d.l. sur une arete   (=NBDLEL si dim < 2)
* NBNEFX nombre maximum de noeuds sur une face  (=NBNEAX si dim < 3)
* NBDLFX nombre maximum de d.l. sur une face    (=NBDLAX si dim < 3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   NUTYPE,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE,NBNEEL,NBDLEL
     &         ,NBNEAX,NBDLAX,NBNEFX,NBDLFX
*
      INTEGER   DIML,FORM,TYPE
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*  
      IF (DIML.EQ.3) THEN
*
*        Elements en dimension 3 : hexaedre, prisme, tetraedre
*
         IF (FORM.EQ.0) THEN
            CALL HEXA   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                  ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
            NBSOMT=8
            NBARET=12
            NBFACE=6 
         ELSEIF (FORM.EQ.1) THEN
            CALL PRIS   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                  ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
            NBSOMT=6
            NBARET=9
            NBFACE=5
         ELSEIF (FORM.EQ.2) THEN
            CALL TETR   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                  ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
            NBSOMT=4
            NBARET=6
            NBFACE=4
*
         ELSE
            CALL ERELEM (3,'*ElemNb*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
*        Elements en dimension 2 : quadrangle, triangle
* 
         IF (FORM.EQ.0) THEN
            CALL QUAD   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
            NBSOMT=4
            NBARET=4
         ELSEIF (FORM.EQ.1) THEN
            CALL TRIA   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
            NBSOMT=3
            NBARET=3 
         ELSE
            CALL ERELEM (3,'*ElemNb*',NUTYPE)
         ENDIF
         NBFACE=NBARET
         NBNEFX=NBNEAX
         NBDLFX=NBDLAX
*
      ELSEIF (DIML.EQ.1) THEN
*
*        Elements en dimension 1  : segment
* 
         IF (FORM.EQ.0) THEN
            CALL SEGM   (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBDLAX) 
            NBSOMT=2
            NBARET=NBSOMT
         ELSE
            CALL ERELEM (3,'*ElemNb*',NUTYPE)
         ENDIF
         NBNEAX=1
         NBFACE=NBARET   
         NBNEFX=1 
         NBDLFX=NBDLAX
      ELSE
          CALL ERELEM (2,'*ElemNb*',NUTYPE)
      ENDIF
                                                                    END !ElemNb
