*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMNE (NUTYPE,NESOME,NEARET,NEFACE,NEINTE) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (15 Octobre 2001)
* Version 1.0.1
*  
*-- Variable d'entree --
* NUTYPE numero de type de l'element (cf. Definition dans le s-p NuTYEL)
*  
*-- Variables de sortie --  
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEFACE nombre de noeuds sur les faces non situes sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NUTYPE,NESOME,NEARET,NEFACE,NEINTE
*
      INTEGER   DIML,FORM,TYPE
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*  
      IF (DIML.EQ.3) THEN
*
*        Elements en dimension 3 : hexaedre, prisme, tetraedre
*
         IF (FORM.EQ.0) THEN
            CALL HEXANE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
         ELSEIF (FORM.EQ.1) THEN
            CALL PRISNE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
         ELSEIF (FORM.EQ.2) THEN
            CALL TETRNE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
         ELSE
            CALL ERELEM (3,'*ElemNe*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
*        Elements en dimension 2 : quadrangle, triangle
* 
         IF (FORM.EQ.0) THEN
            CALL QUADNE (TYPE,NESOME,NEARET,NEINTE)
         ELSEIF (FORM.EQ.1) THEN
            CALL TRIANE (TYPE,NESOME,NEARET,NEINTE)
         ELSE
            CALL ERELEM (3,'*ElemNe*',NUTYPE)
         ENDIF
         NEFACE=0
*
      ELSEIF (DIML.EQ.1) THEN
*
*        Elements en dimension 1  : segment
* 
         IF (FORM.EQ.0) THEN
            CALL SEGMNE (TYPE,NESOME,NEINTE) 
         ELSE
            CALL ERELEM (3,'*ElemNe*',NUTYPE)
         ENDIF
         NEFACE=0
         NEARET=0
      ELSE
          CALL ERELEM (2,'*ElemNe*',NUTYPE)
      ENDIF
                                                                    END !ElemNe

