*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMP1 (NUTYPE,NBLMP1,NUPOP1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (15 Octobre 2001)
* Derniere modification : D.Martin (26 mai 2009)
* Version 2
*
* Construction des tableaux de correspondance des numerotations locales
* entre elements Pk ou Qk et elements P1 pour le decoupage d'un element
* en elements P1 (triangles ou tetraedres).
*
*-- Argument d'entree --
* NUTYPE numero de type de l'element
*-- Arguments de sortie --
* NBLMP1 nombre d'elements P1 crees par le decoupage
* NUPOP1 tableau de correspondance entre element P1 et element Pk ou Qk
*        NUPOP1 (s,t) = numero dans l'element du sommet s de l'element (P1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUTYPE,NBLMP1,NUPOP1(*)
*
      INTEGER   DIML,FORM,TYPE,TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100 )
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*  
      IF (DIML.EQ.3) THEN
*
*        Elements en dimension 3 : hexaedre, prisme, tetraedre
*
         IF (FORM.EQ.0) THEN
*
*           Elements hexaedriques
*
            CALL ERELEM (1,'*ElemP1*',NUTYPE)
	 ELSEIF (FORM.EQ.1) THEN
*
*           Elements prismatiques
*
            CALL PRLKP1 (TYPE,NBLMP1,NUPOP1)
         ELSEIF (FORM.EQ.2) THEN
*
*           Elements tetrahedriques
*
            CALL TELKP1 (TYPE,NBLMP1,NUPOP1)
         ELSE
*
            CALL ERELEM (1,'*ElemP1*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
*        Elements en dimension 2 : quadrangle, triangle
* 
         IF (FORM.EQ.0) THEN
*
*           Elements quadrangulaires
*
            IF (TYPNEW.LE.LAGDMX) THEN
               CALL QULKP1 (TYPNEW,NBLMP1,NUPOP1)
            ELSE
               CALL ERELEM (11,'*ElemP1*',NUTYPE)
            ENDIF
*
         ELSEIF (FORM.EQ.1) THEN
*
*           Elements triangulaires
*
            IF (TYPE.LE.LAGDMX) THEN
               CALL TRLKP1 (TYPE,NBLMP1,NUPOP1)
            ELSEIF (TYPE.EQ.203) THEN
               CALL TR203P (NBLMP1,NUPOP1)
            ELSE
               CALL ERELEM (12,'*ElemP1*',NUTYPE)
            ENDIF 
         ELSE
            CALL ERELEM (3,'*ElemP1*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.1) THEN
*
*        Elements en dimension 1  : segment
*
         IF (TYPE.GT.1) CALL ERELEM (2,'*ElemP1*',NUTYPE)
*
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (26 mai 2009)
* - ajout du cas des prismes
* Version 1.0.4 : D.Martin (9 juin 2004)
* Version 1 : D.Martin (15 Octobre 2001)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !ElemP1


