*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMQD (NUTYPE,NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,IMPFCH) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
* 
* Formules de quadrature pour les elements de reference en dimension 1,2 ou 3
*
*-- Variables d'entree --
* NUTYPE numero de type de l'element
* NDMDOM dimension d'espace du domaine d'integration (dimension de COORQ)
* NUSCHQ numero de la formule de quadrature
* IMPFCH impression sur unite IMPFCH si >0
*-- Variables en sortie --
* NBPTQ  nombre de points de la formule de quadrature
* POIDQ  tableau des poids de la formule de quadrature
* COORQ  tableau des coordonnees des points de quadrature
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUTYPE,NDMDOM,NUSCHQ,NBPTQ,IMPFCH
      REAL    COORQ(NDMDOM,*),POIDQ(*)
*  
      CHARACTER LEYTUN*5,FORMA*50
      INTEGER   DIML,FORM,TYPE,I,J,DEXACT
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      IF (DIML.NE.NDMDOM) GOTO 10001
*  
      IF (DIML.EQ.3) THEN
*  
         IF (FORM.EQ.0) THEN
            CALL HEXAQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,DEXACT)
         ELSEIF (FORM.EQ.1) THEN
            CALL PRISQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,DEXACT)
         ELSEIF (FORM.EQ.2) THEN
            CALL TETRQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,DEXACT)
         ELSE
            CALL ERELEM (3,'*ElemQd*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*  
         IF (FORM.EQ.0) THEN
            CALL QUADQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,DEXACT)
         ELSEIF (FORM.EQ.1) THEN
            CALL TRIAQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,DEXACT)
         ELSE
            CALL ERELEM (3,'*ElemQd*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.1) THEN
* 
         TYPE=0
         IF (FORM.EQ.0) THEN
            CALL SEGMQD (NDMDOM,NUSCHQ,NBPTQ,POIDQ,COORQ,TYPE,DEXACT)
         ELSE
            CALL ERELEM (3,'*ElemQd*',NUTYPE)
         ENDIF
      ELSE
         CALL ERELEM (2,'*ElemQd*',NUTYPE)
      ENDIF
*-----------------------------------------------------------------------
*   Impressions eventuelles en Format variable :
*  
      IF (IMPFCH.LE.0) RETURN
      WRITE (IMPFCH,1001) NUSCHQ,LEYTUN(NUTYPE),DEXACT
      FORMA='('//CHAR(53-NDMDOM)//'(TR14,''Poids '','//CHAR(NDMDOM+48)
     &//'(''   Coord('',I1,'')''),'' '',:))'
      WRITE (IMPFCH,FORMA) ((J,J=1,NDMDOM),I=1,MIN(5-NDMDOM,NBPTQ)) 
      FORMA(4:)='TR6,I4,E11.4,'//CHAR(NDMDOM+48)//'E11.4))' 
      WRITE (IMPFCH,FORMA)(I,POIDQ(I),(COORQ(J,I),J=1,NDMDOM),I=1,NBPTQ)
      RETURN
 1001 FORMAT(/T6,'*Elemqd*  Formule de quadrature No ',I2
     &,' pour l''element ',A,', exacte pour le degre ',I2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10001 CALL ENCLER (NUTYPE,FORMA(:6))                                    !Utilite
      CALL ENCLER (NDMDOM,FORMA(7:12))                                  !Utilite
      CALL BAISE  (' *ElemQd*(Ef3d) Conflit entre numero de type '
     &//' d''element ('//FORMA(:6)//') et dimension d''espace ('
     &//FORMA(7:12)//')')
                                                                    END !Elemqd
