*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMQF (NDMDOM,NUTYPE,NUFACE,NBPTQ,POIDQ,COORQ
     &                  ,POIDQS,COORQS,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Formule de quadrature sur une face ou arete d'element de reference 
* construite a partir d'une formule de quadrature en dimension NDMDOM
*
*-- Arguments d'entree --
* NDMDOM dimension de la formule de quadrature initiale (1 -> arete, 2 -> face)
* NUTYPE numero de type de l'element
* NUFACE numero de la face/arete de l'element
* NBPTQ  nombre de points de la formule de quadrature 2d/1d
* POIDQ  poids de la formule de quadrature 2d/1d
* COORQ  coordonnees des points de la formule de quadrature 2d/1d
* POIDQS poids de la formule de quadrature sur la face de l'element 3d/2d
* COORQS coordonnees des points de la formule de quadrature sur la face/arete
* IMPFCH impression sur unite IMPFCH si >0
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   NDMDOM,NUTYPE,NUFACE,NBPTQ,IMPFCH
      REAL      POIDQ(*),COORQ(*),POIDQS(*),COORQS(*)
*
      INTEGER   DIML,TYPE,FORM,I,J
      CHARACTER LEYTUN*5,FORMA*50
*----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      IF (DIML.EQ.3) THEN
         IF (NDMDOM.EQ.2) THEN
            IF (FORM.EQ.0) THEN
               CALL HEXAQF (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSEIF (FORM.EQ.1) THEN
               CALL PRISQF (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSEIF (FORM.EQ.2) THEN
               CALL TETRQF (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSE
               CALL ERELEM (3,'*ElemQf*',NUTYPE)
            ENDIF
         ELSEIF (NDMDOM.EQ.1) THEN
            IF (FORM.EQ.0) THEN
               CALL HEXAQA (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSEIF (FORM.EQ.1) THEN
               CALL PRISQA (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSEIF (FORM.EQ.2) THEN
               CALL TETRQA (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSE
               CALL ERELEM (3,'*ElemQf*',NUTYPE)
            ENDIF
         ELSE
            CALL ERELEM (2,'*ElemQf*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
         IF (NDMDOM.EQ.1) THEN
            IF (FORM.EQ.0) THEN
               CALL QUADQA (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSEIF (FORM.EQ.1) THEN
               CALL TRIAQA (NUFACE,NBPTQ,POIDQ,COORQ,POIDQS,COORQS)
            ELSE
               CALL ERELEM (2,'*ElemQf*',NUTYPE)
            ENDIF
         ELSE
            CALL ERELEM (2,'*ElemQf*',NUTYPE)
         ENDIF
*
      ENDIF
*----------------------------------------------------------------------
*   Impressions eventuelles en Format variable :
*  
      IF (IMPFCH.LE.0) RETURN
      IF (DIML.EQ.3) THEN
         WRITE (IMPFCH,1003) NUFACE,LEYTUN (NUTYPE)
      ELSE
         WRITE (IMPFCH,1002) NUFACE,LEYTUN (NUTYPE)
      ENDIF
      FORMA='('//CHAR(53-DIML)//'(TR14,''Poids '','//CHAR(DIML+48)
     &//'(''   Coord('',I1,'')''),'' '',:))'
      WRITE (IMPFCH,FORMA)((J,J=1,DIML),I=1,MIN(5-DIML,NBPTQ)) 
      FORMA(4:)='TR6,I4,E11.4,'//CHAR(DIML+48)//'E11.4))' 
      WRITE (IMPFCH,FORMA)
     &(I,POIDQS(I),(COORQS((I-1)*DIML+J),J=1,DIML),I=1,NBPTQ)
      RETURN
1002  FORMAT(/T6,'*ElemQf*  Formule de quadrature sur l''arete ',I2
     &,' de l''element ',A)
1003  FORMAT(/T6,'*ElemQf*  Formule de quadrature sur la face ',I2
     &,' de l''element ',A)
                                                                    END !ElemQf

