*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELEMTF (NDIM,NDMDOM,NUTYPE,NUFACE,JACOBF,JACOBT,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (15 Octobre 2001)
* Version 1.0.2
*
* Projection des vecteurs tangents sur une face ou arete d'un element
* a partir de la matrice jacobienne sur l'element
*
*-- Arguments d'entree --
* NDIM   dimension d'espace (dimension de JACOBF)
* NDMDOM dimension de la face ou arete (1 -> arete, 2 -> face)
* NUTYPE numero de type de l'element
* NUFACE numero de la face ou arete de l'element
* JACOBF matrice jacobienne
* JACOBT vecteurs tangents sur la face courante
* IMPFCH impression sur unite IMPFCH si >0
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NDIM,NDMDOM,NUTYPE,NUFACE,IMPFCH
      REAL     JACOBF(NDIM,*),JACOBT(NDIM,*)
*
      INTEGER  DIML,FORM,TYPE,K,KK
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      IF (DIML.EQ.3) THEN
*
         IF (NDMDOM.EQ.2) THEN
*
            IF (FORM.EQ.0) THEN
               CALL HEXATF (NUFACE,JACOBF,JACOBT)
            ELSEIF (FORM.EQ.1) THEN
               CALL PRISTF (NUFACE,JACOBF,JACOBT)
            ELSEIF (FORM.EQ.2) THEN
               CALL TETRTF (NUFACE,JACOBF,JACOBT)
            ELSE
               CALL ERELEM (3,'*ElemTf*',NUTYPE)
            ENDIF
*
         ELSEIF (NDMDOM.EQ.1) THEN
*
            IF (FORM.EQ.0) THEN
               CALL HEXATA (NUFACE,JACOBF,JACOBT)
            ELSEIF (FORM.EQ.1) THEN
               CALL PRISTA (NUFACE,JACOBF,JACOBT)
            ELSEIF (FORM.EQ.2) THEN
               CALL TETRTA (NUFACE,JACOBF,JACOBT)
            ELSE
               CALL ERELEM (3,'*ElemTf*',NUTYPE)
            ENDIF
*
         ELSE
            CALL ERELEM (2,'*ElemTf*',NUTYPE)
         ENDIF
*
      ELSEIF (DIML.EQ.2) THEN
*
         IF (NDMDOM.EQ.1) THEN
*
            IF (FORM.EQ.0) THEN
               CALL QUADTA (NUFACE,JACOBF,JACOBT)
            ELSEIF (FORM.EQ.1) THEN
               CALL TRIATA (NUFACE,JACOBF,JACOBT)
            ELSE
               CALL ERELEM (3,'*ElemTf*',NUTYPE)
            ENDIF
         ELSE
            CALL ERELEM (2,'*ElemTf*',NUTYPE)
         ENDIF
      ENDIF
      IF(IMPFCH.LE.0) RETURN
*-----------------------------------------------------------------------
      IF (NDIM.EQ.3) THEN
         WRITE (IMPFCH,1003) (JACOBT(1,KK),KK=1,NDMDOM)
         DO 10 K=2,NDIM
            WRITE (IMPFCH,1004) (JACOBT(K,KK),KK=1,NDMDOM)
10       CONTINUE
      ELSEIF (NDIM.EQ.2) THEN
         WRITE (IMPFCH,1002) (JACOBT(KK,1),KK=1,NDIM)
      ENDIF
      RETURN
1002  FORMAT(T6,'*Elemtf*  Vecteur Tangent :',T45,2E12.4)
1003  FORMAT(T6,'*Elemtf*  Vecteurs Tangents :',T45,3E12.4)
1004  FORMAT(T45,3E12.4)
                                                                    END !ElemTf

