*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HELKCO (K,NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (09 Decembre 2001)
* Version 1.1.1
*  
* Coordonnees des noeuds de l'element de reference pour l'hexaedre de 
* Lagrange d'ordre k a (k+1)^3 noeuds construites par produit tensoriel 
* a partir des coordonnees de l'element 1D
*                    (../../doc_html/ef/numloche.html)
*
*-- Variables d'entree --
* K      pour hexaedre de Lagrange de type k
* NDIM   dimension d'espace
*  
*-- Variables en sortie --
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER LAGDMX,NBNEX
      PARAMETER ( LAGDMX = 100 , NBNEX = (LAGDMX+1)**3 )
      INTEGER NUX3SE(3,NBNEX),KNEW,NOEUDS,I,J
      REAL    CORLO1 (LAGDMX+1)
*-----------------------------------------------------------------------
*
      KNEW=K
      IF (KNEW.GT.LAGDMX) KNEW=KNEW-LAGDMX
*
*     Coordonnees de noeuds dans le segments d'ordre k
*
      CALL SELKCO (K,1,CORLO1)
*
*     Tableau de correspondance entre les noeuds du segment d'ordre k
*     et l'hexaedre d'ordre k
*
      NOEUDS=0
      CALL SEX3SE (KNEW,NDIM,NOEUDS,NUX3SE)
*
*     Coordonnees des noeuds dans l'hexaedre d'ordre k
*
      DO 2 I=1,NOEUDS
         DO 1 J=1,NDIM
            CORLOC(J,I) = CORLO1(NUX3SE(J,I))
1        CONTINUE
2     CONTINUE
                                                                    END !Helkco
