*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HELKFA (TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988), Refonte complete (21 juin 2002)
* Derniere modification : D.Martin (21 juin 2002)
* Version 2.0.1
*  
* Numerotation locale des noeuds d'une face de l'element de reference 
* 'Hexaedre de Lagrange (ordre k) a (k+1)^3 noeuds', construite
* a partir de la numerotation locale des noeuds sur les aretes
* et de la numerotation locale des aretes sur les faces
*
*-- Arguments --
* TYPE   =K pour hexaedre de Lagrange de type k
* NUFACE numero de la face
* NUTYFA numero de type de la face (numero de type de l'element 2d associe)
* NBNEFA nombre de noeuds de la face
* NUNEFA tableau des numeros locaux des noeuds de la face
*
*  Numerotations des sommets, aretes et faces
*
*                         Arete s1 s2 equation |  Face  s1  s2  s3  s4  eq.
*       8------IX-----7     1    2  6 x=1 y=1  |    1    2   6   5   1  x=1
*      /|            /|     2    7  6 y=1 z=1  |    2    7   6   2   3  y=1
*    XI |          II |     3    5  6 z=1 x=1  |    3    5   6   7   8  z=1
*   /   IV        /   X     4    8  4 x=0 y=0  |    4    3   4   8   7  x=0
*  5------III----6    |     5    1  4 x=0 y=0  |    5    8   4   1   5  y=0
*  |    |        |    |     6    3  4 x=0 y=0  |    6    1   4   3   2  z=0
*  |    4-----VI-|----3     7    1  5 y=1 z=0  |---------------------------
* VII  /        1|   /      8    2  3 z=1 x=0  |  Face  a1  a2  a3  a4
*  |  V          | VIII     9    7  8 x=1 y=0  |    1    1  -3  -7  12
*  |/            |/        10    3  7 y=0 z=1  |    2    2  -1   8  10
*  1-----XII-----2         11    5  8 z=0 x=1  |    3    3  -2   9 -11
*                          12    1  2 x=0 y=1  |    4    6  -4  -9 -10
*                                              |    5    4  -5   7  11
*                                              |    6    5  -6  -8 -12
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,NUFACE,NUTYFA,NBNEFA,NUNEFA(*)
*
      INTEGER LAGDMX,NTYPFO
      PARAMETER ( LAGDMX = 100, NTYPFO = 1000 )
      INTEGER TYPNEW,NEA,NEF,NEL,NUARET,NUARFF,NUARFA(4)
     &       ,NUTYAR,NBNEAR,NUNEAR(LAGDMX+1)
*---------------------------------------------------------------------
*
      TYPNEW=TYPE
      IF (TYPNEW.EQ.202) TYPNEW=2
      IF (TYPNEW.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      CALL HEARFA (NUFACE,NUARFA)
*
*     Numerotation locale des noeuds des aretes de la face construite
*     a partir de la numerotation locale des neouds sur les aretes
*     et de la numerotation locale des aretes sur les faces
*
      DO 4 NUARFF=1,4
         NEF = NUARFF
         NUARET = NUARFA(NUARFF)
*
         CALL HELKAR (TYPE,ABS(NUARET),NUTYAR,NBNEAR,NUNEAR)
*
         IF (NUARET.GE.0) THEN
*
            NUNEFA(NEF) = NUNEAR(1)
            DO 1 NEA=3,NBNEAR
              NEF = NEF + 4
              NUNEFA(NEF) = NUNEAR(NEA)
1           CONTINUE
*
         ELSE
*
            NUNEFA(NEF) = NUNEAR(2)
            DO 2 NEA=NBNEAR,3,-1
              NEF = NEF + 4
              NUNEFA(NEF) = NUNEAR(NEA)
2           CONTINUE
*
         ENDIF
*
4     CONTINUE
*
      
      IF (TYPNEW.GE.2.AND.TYPE.NE.22) THEN
*
*           Noeuds internes de la face (non situes sur une arete)
*
            NEL=8 + (12 + (NUFACE-1)*(TYPNEW-1)) * (TYPNEW-1)
            DO 5 NEA=1,(TYPNEW-1)*(TYPNEW-1)
               NEL=NEL+1
               NEF=NEF+1
               NUNEFA(NEF)=NEL
5           CONTINUE
      ENDIF
*
      NUTYFA=20*NTYPFO+TYPE
      NBNEFA=(TYPNEW+1)*(TYPNEW+1)
                                                                    END !Helkfa
