*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HELKFB (K,KELFCT,X1,X2,X3,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Reecriture complete D.Martin (November 2001)
* Derniere modification : D.Martin (07 Decembre 2001)
* Version 1.1.0
*  
* Fonctions de base et derivees - Quadrangle de Lagrange d'ordre k
* construites par produit tensoriel a partir des fonctions de base 1D
*
*-- Arguments d'entree --
* K      ordre de l'element de Lagrange
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees 1eres des fonctions de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees 2ndes des fonctions de base
* X1,X2 coordonnees du point ou on demande le calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      INTEGER K
      REAL X1,X2,X3,P(*),DP(3,*),DDP(6,*)
*
      INTEGER LAGDMX,NBNEX,DIM
      PARAMETER ( LAGDMX = 100 , NBNEX = (LAGDMX+1)**3 , DIM = 3 )
      REAL P1(LAGDMX+1),DP1(LAGDMX+1),DDP1
      REAL P2(LAGDMX+1),DP2(LAGDMX+1),DDP2
      REAL P3(LAGDMX+1),DP3(LAGDMX+1),DDP3
      INTEGER NUX3SE(DIM,NBNEX),KNEW,NOEUDS,J,I1,I2,I3
*-----------------------------------------------------------------------
      KNEW=K
      IF (KNEW.GT.LAGDMX) KNEW=KNEW-LAGDMX
*
*     Fonctions de l'element 1D
*
      IF (KELFCT(1:2).EQ.'YN') THEN
        CALL SELKFB (K,'YNN',X1,P1,DP1,DDP1)
        CALL SELKFB (K,'YNN',X2,P2,DP2,DDP2)
        CALL SELKFB (K,'YNN',X3,P3,DP3,DDP3)
      ELSE
        CALL SELKFB (K,'YYN',X1,P1,DP1,DDP1)
        CALL SELKFB (K,'YYN',X2,P2,DP2,DDP2)
        CALL SELKFB (K,'YYN',X3,P3,DP3,DDP3)
      ENDIF
*
*     Tableau de correspondance entre les noeuds du segment d'ordre k
*     et l'hexaedre d'ordre k
*
      NOEUDS=0
      CALL SEX3SE (KNEW,DIM,NOEUDS,NUX3SE)
*
*     Fonctions de base
*
      IF (KELFCT(1:1).NE.'N') THEN
         DO 10 J=1,NOEUDS
            I1=NUX3SE(1,J)
            I2=NUX3SE(2,J)
            I3=NUX3SE(3,J)
            P(J)=P1(I1) * P2(I2) * P3(I3)
10       CONTINUE
      ENDIF
*
*     Derivees premieres
*
      IF (KELFCT(2:2).NE.'N') THEN
         DO 11 J=1,NOEUDS
            I1=NUX3SE(1,J)
            I2=NUX3SE(2,J)
            I3=NUX3SE(3,J)
            DP(1,J)=DP1(I1) * P2(I2)  * P3(I3)
            DP(2,J)= P1(I1) * DP2(I2) * P3(I3)
            DP(3,J)= P1(I1) * P2(I2)  * DP3(I3)
11       CONTINUE
      ENDIF
                                                                    END !Helkfb
