*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXA (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &                ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (17 Novembre 2001)
* Version 1.1.0
*  
*-- Variable d'entree --
* TYPE numero de type de l'element
*   k=  0 a  99 --> Hexaedre de Lagrange Qk a (k+1)^3 noeuds treillis regulier
*   k=100 a 199 --> Hexaedre de Lagrange Qk a (k+1)^2 noeuds de Gauss-Lobatto
*   k=202       --> Hexaedre de Lagrange Serendipity Q2' a 20 noeuds
*  
*-- Variable en sortie --
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* CLASSE classe de l'element (Element de classe C^0, C^1,...etc)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBNEAX nombre de noeuds sur une arete
* NBDLAX nombre de d.l. sur une arete
* NBNEFX nombre de noeuds sur une face
* NBDLFX nombre de d.l. sur une face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &       ,NBNEAX,NBDLAX,NBNEFX,NBDLFX
*
      INTEGER TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      LAGHER=0
      CLASSE=0
*
      IF (TYPNEW.LE.LAGDMX) THEN
         NBNEAX=TYPNEW+1
         NBDLAX=NBNEAX
         NBNEFX=NBNEAX*NBNEAX
         NBDLFX=NBNEFX
         NBNEEL=NBNEAX*NBNEFX
         NBDLEL=NBNEEL
      ELSEIF (TYPE.EQ.202) THEN
         NBNEAX=3
         NBDLAX=NBNEAX
         NBNEFX=8
         NBDLFX=NBNEFX
         NBNEEL=20
         NBDLEL=NBNEEL
      ELSE
         CALL HEXAXX (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL
     &               ,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
      ENDIF
                                                                    END !Hexa
