*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXANE (TYPE,NESOME,NEARET,NEFACE,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995)
* Derniere modification : D.Martin (17 Novembre 2001)
* Version 1.1.0
*  
*-- Variable d'entree --
* TYPE numero de type de l'element
*   k < 11 --> Hexaedre de Lagrange Qk a (k+1)^3 noeuds treillis regulier
*   k = 22 --> Hexaedre de Lagrange Serendipity Q2' a 20 noeuds
*  
*-- Variables en sortie --
* NESOME nombre de noeuds sommets
* NEARET nombre de noeuds non sommets sur les aretes
* NEFACE nombre de noeuds sur les faces non situes sur les aretes
* NEINTE nombre de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,NESOME,NEARET,NEFACE,NEINTE
*
      INTEGER TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      NESOME=8
      NEARET=0
      NEFACE=0
      NEINTE=0
*
      IF (TYPE.EQ.0) THEN
         NESOME=0
         NEINTE=1
      ELSEIF (TYPNEW.EQ.1) THEN
         RETURN
      ELSEIF (TYPNEW.LT.LAGDMX) THEN
         NEARET=(TYPNEW-1)
         NEFACE=NEARET*NEARET
         NEINTE=NEARET*NEFACE
         NEARET=12*NEARET
         NEFACE=6*NEFACE
      ELSEIF (TYPE.EQ.202) THEN
         NEARET=12
      ELSE
         CALL ERELEM (13,'*Hexane*',TYPE)
      ENDIF
                                                                    END !HexaNe
