*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXAQF (NUFACE,NBPTQ,POIDQ2,COORQ2,POIDQ3,COORQ3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (03 Decembre 2001)
* Version 1.1.0
*
* Formule de quadrature sur une face de l'hexaedre de reference construite 
* a partir d'une formule de quadrature sur le carre.
*
*-- Arguments d'entree ---
* NUFACE numero de la face de l'element
* NBPTQ  nombre de points de la formule de quadrature du carre
* POIDQ2 poids de la formule de quadrature sur le carre
* COORQ2 coordonnees des points de la formule de quadrature sur le carre
* POIDQ3 poids de la formule de quadrature sur la face de l'hexaedre
* COORQ3 coordonnees des points de la formule de quadrature sur la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE,NBPTQ
      REAL    POIDQ2(*),COORQ2(2,*),POIDQ3(*),COORQ3(3,*)
*
      INTEGER I
*-----------------------------------------------------------------------
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x1=1.
         DO 1 I=1,NBPTQ
            COORQ3(1,I) = 1.
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = COORQ2(1,I)
            POIDQ3(I)   = POIDQ2(I)
1        CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x2=1.
         DO 2 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = 1.
            COORQ3(3,I) = COORQ2(2,I)
            POIDQ3(I)   = POIDQ2(I)
2        CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 3 : plan x3=1.
         DO 3 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 1.
            POIDQ3(I)   = POIDQ2(I)
3        CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x1=0.
         DO 4 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = COORQ2(1,I)
            POIDQ3(I)   = POIDQ2(I)
4        CONTINUE
      ELSEIF (NUFACE.EQ.5) THEN
*        Face 5 : plan x2=0.
         DO 5 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = 0.
            COORQ3(3,I) = COORQ2(2,I)
            POIDQ3(I)   = POIDQ2(I)
5        CONTINUE
      ELSEIF (NUFACE.EQ.6) THEN
*        Face 6 : plan x3=0.
         DO 6 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ2(I)
6        CONTINUE
      ELSE
         CALL ERELEM (6,'HexaQf',NUFACE)                                !Utilite
      ENDIF
                                                                    END !HexaQf
