*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXATA (NUARET,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.1.0
*
* Projection du vecteur tangent sur une arete d'un hexaedre
*
*-- Arguments d'entree --
* NUARET numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteur tangent sur l'arete courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUARET
      REAL    JACOBF(3,*),JACOBT(3)
*
      INTEGER I,DIM
*-----------------------------------------------------------------------
      DIM=3
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1=1.,x2=1.
         DO 1 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
1        CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x2=1.,x3=1.
         DO 2 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
2        CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x1=1.,x3=1.
         DO 3 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
3        CONTINUE
      ELSEIF (NUARET.EQ.4) THEN
*        Arete 4 : droite x1=0.,x2=0.
         DO 4 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
4        CONTINUE
      ELSEIF (NUARET.EQ.5) THEN
*        Arete 5 : droite x2=0.,x3=0.
         DO 5 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
5        CONTINUE
      ELSEIF (NUARET.EQ.6) THEN
*        Arete 6 : droite x1=0.,x3=0.
         DO 6 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
6        CONTINUE
      ELSEIF (NUARET.EQ.7) THEN
*        Arete 7 : droite x1=1.,x2=0.
         DO 7 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
7        CONTINUE
      ELSEIF (NUARET.EQ.8) THEN
*        Arete 8 : droite x2=1.,x3=0.
         DO 8 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
8     CONTINUE
      ELSEIF (NUARET.EQ.9) THEN
*        Arete 9 : droite x1=0.,x3=1.
         DO 9 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
9        CONTINUE
      ELSEIF (NUARET.EQ.10) THEN
*        Arete 10 : droite x1=0.,x2=1.
         DO 10 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
10       CONTINUE
      ELSEIF (NUARET.EQ.11) THEN
*        Arete 11 : droite x2=0.,x3=1.
         DO 11 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
11       CONTINUE
      ELSEIF (NUARET.EQ.12) THEN
*        Arete 1 : droite x1=1.,x3=0.
         DO 12 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
12     CONTINUE

      ELSE
         CALL ERELEM (5,'HexaTa',NUARET)                                !Utilite
      ENDIF
                                                                    END !HexaTa
