*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE HEXATF (NUFACE,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (03 Decembre 2001)
* Version 1.1.0
*
* Projection des vecteurs tangents sur une face d'un hexaaedre
*
*-- Arguments d'entree --
* NUFACE numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteurs tangents sur la face courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE
      REAL    JACOBF(3,*),JACOBT(3,*)
*
      INTEGER I,DIM
*-----------------------------------------------------------------------
      DIM=3
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x1=1.
         DO 1 I=1,DIM
            JACOBT(I,1)=JACOBF(I,2)
            JACOBT(I,2)=JACOBF(I,3)
1        CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x2=1.
         DO 2 I=1,DIM
            JACOBT(I,1)=JACOBF(I,3)
            JACOBT(I,2)=JACOBF(I,1)
2        CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 3 : plan x3=1.
         DO 3006 I=1,DIM
            JACOBT(I,1)=JACOBF(I,1)
            JACOBT(I,2)=JACOBF(I,2)
3006     CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x1=0.
         DO 4 I=1,DIM
            JACOBT(I,1)=JACOBF(I,3)
            JACOBT(I,2)=JACOBF(I,2)
4        CONTINUE
      ELSEIF (NUFACE.EQ.5) THEN
*        Face 5 : plan x2=0.
         DO 5 I=1,DIM
            JACOBT(I,1)=JACOBF(I,1)
            JACOBT(I,2)=JACOBF(I,3)
5        CONTINUE
      ELSEIF (NUFACE.EQ.6) THEN
*        Face 6 : plan x3=0.
         DO 6 I=1,DIM
            JACOBT(I,1)=JACOBF(I,2)
            JACOBT(I,2)=JACOBF(I,1)
6        CONTINUE
      ELSE
         CALL ERELEM (6,'HexaTf',NUFACE)                                !Utilite
      ENDIF
                                                                    END !HexaTf
