*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION LEYTUN (NUTYPE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Correspondance entre numero de type d'element et nom de code
* (Fonction reciproque de NUTYEL)
*
*-- Argument --
* NUTYPE NUmero de TYpe d'ELement
*
* (1) Convention pour la forme geometrique de l'element
*      0 pour les Hexaedres en dimension 3,
*        les Quadrangles en dimension 2,
*        les Segments en dimension 1
*   1000 pour les Prismes en dimension 3 
*        les Triangles en dimension 2
*   2000 pour les Tetraedres en dimension 3
*   3000 pour les Pyramides en dimension 3
* (2) Convention pour une forme d'element donnee
*         k < 100 Lagrange standard d'ordre k
*   102 < k < 200 Lagrange d'ordre k aux points de Gauss-Lobatto (quadrangles)
*         k = 200 Hermite d'ordre 3 (triangles, segments)
*         k = 201 Lagrange d'ordre 1 Non Conforme (triangles)
*         k = 202 Serendipity d'ordre 2 (quadrangles, prismes, hexaedres)
*
*         -->   NUTYEL = Somme de 10000*dim & de (1) & de (2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*5 LEYTUN
      INTEGER     NUTYPE
*
      INTEGER DIML,FORM,TYPE
      CHARACTER*2 FORMEL(7)
      DATA FORMEL/'HE','PR','TE','PY','QU','TR','SE'/
*-----------------------------------------------------------------------
      CALL NUSPLT (NUTYPE,DIML,FORM,TYPE)
*
      FORM=FORM+1  
      IF (DIML.EQ.2) FORM=FORM+4  
      IF (DIML.EQ.1) FORM=7 
      CALL ENCLER (TYPE,LEYTUN(3:5))                                    !Utilite
      IF (LEYTUN(3:3).EQ.' ') LEYTUN(3:3)='0'
      IF (LEYTUN(4:4).EQ.' ') LEYTUN(4:4)='0'
      LEYTUN(1:2)=FORMEL(FORM)
                                                                    END !Leytun
