*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUSPLT (NUTYPE,DIML,FORM,TYPE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (15 Octobre 2001)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
*-- Argument d'entree --
* NUTYPE numero de type de l'element
*-- Arguments de sortie --
* DIML   dimension de l'element
* FORM   forme de l'element
*      0 pour les Hexaedres en 3d, les Quadrangles en 2d, les Segments en 1d
*      1 pour les Prismes en dimension 3, les Triangles en dimension 2
*      2 pour les Tetraedres en dimension 3
*      3 pour les Pyramides en dimension 3
* TYPE   numero (conventionnel) d'interpolation de l'element
*         k < 100 Lagrange standard d'ordre k
*   102 < k < 200 Lagrange d'ordre k aux points de Gauss-Lobatto (quadrangles)
*         k = 200 Hermite d'ordre 3 (triangles, segments)
*         k = 201 Lagrange d'ordre 1 Non Conforme (triangles)
*         k = 202 Serendipity d'ordre 2 (quadrangles, prismes, hexaedres)
*
*
*  -->   NUTYEL = 10000 * DIML + 1000 * FORM + TYPE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUTYPE,DIML,FORM,TYPE
*
      INTEGER NTYPFO
      PARAMETER (NTYPFO = 1000)
*-----------------------------------------------------------------------
      DIML=NUTYPE/(10*NTYPFO)
      TYPE=NUTYPE-10*NTYPFO*DIML 
      FORM=TYPE/NTYPFO
      TYPE=TYPE-NTYPFO*FORM
                                                                    END !NuSplt
