*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION NUTYEL (ENTREE)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Correspondance entre un nom d'element et son numero de type
*
*-- Variable d'entree --
* ENTREE symbole affecte au type de l'element (cf. Tableaux ELT/NUFORM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Definition du NUmero de TYpe d'ELement
*
* (1) Convention pour la forme geometrique de l'element
*      0 pour les Hexaedres en dimension 3
*        les Quadrangles en dimension 2,
*        les Segments en dimension 1
*    100 pour les Prismes en dimension 3 
*        les Triangles en dimension 2
*    200 pour les Tetraedres en dimension 3
*    300 pour les Pyramides en dimension 3
* (2) Convention pour une forme d'element donnee
*         k < 100 Lagrange standard d'ordre k
*   102 < k < 200 Lagrange d'ordre k aux points de Gauss-Lobatto (quadrangles)
*         k = 200 Hermite d'ordre 3 (triangles, segments)
*         k = 201 Lagrange d'ordre 1 Non Conforme (triangles)
*         k = 202 Serendipity d'ordre 2 (quadrangles, prismes, hexaedres)
*
*         -->   NUTYEL = Somme de 1000*dim & de (1) & de (2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NUTYEL
      CHARACTER*(*) ENTREE 
*
      INTEGER       MAXELT,IELT,KELCHN,NOMBRE,NTYPFO
      PARAMETER    (MAXELT=7, NTYPFO = 1000)
      CHARACTER*2   ELT(MAXELT)
      INTEGER       NUFORM(MAXELT) 
      DATA ELT     /'HE','PR','TE','PY','QU','TR','SE'/
     &    ,NUFORM  /30  ,31  ,32  ,33  ,20  ,21  ,10  /
*-----------------------------------------------------------------------
      IELT=KELCHN (ENTREE(1:2),ELT,MAXELT,2)                            !utilite
      IF (IELT.EQ.0) CALL BAISE                                         
     &   (' *Nutyel*(Ef3d) Type d''element non reconnu : '//ENTREE(1:5))!utilite
      CALL RELCNE (ENTREE(3:5),NOMBRE)                                  !utilite
      NUTYEL=NTYPFO*NUFORM(IELT)+NOMBRE
                                                                    END !Nutyel
