*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PR001B (KELFCT,X1,X2,X3,P,DP,DDP)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees pour le prisme de Lagrange a 6 noeuds  
*  
*-- Arguments d'entree -- cf. ElemFb
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT
      REAL          X1,X2,X3,P(*),DP(3,*),DDP(6,*)
*
      REAL          X6,X7  
*-----------------------------------------------------------------------
      X7=1.-X1-X2  
      X6=1.-X3 
*  
*   Fonctions de base  
*
      IF (KELFCT(1:1).NE.'N') THEN
         P(1)=X1*X6
         P(2)=X2*X6
         P(3)=X6-(P(1)+P(2))
         P(4)=X1-P(1)  
         P(5)=X2-P(2)  
         P(6)=X7-P(3)  
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN
         DP(1,1)=X6
         DP(1,2)=0.
         DP(1,3)=-X6
         DP(1,4)=X3
         DP(1,5)=0.
         DP(1,6)=-X3
         DP(2,1)=0.
         DP(2,2)=X6
         DP(2,3)=-X6
         DP(2,4)=0.
         DP(2,5)=X3
         DP(2,6)=-X3
         DP(3,1)=-X1
         DP(3,2)=-X2
         DP(3,3)=-X7
         DP(3,4)=X1
         DP(3,5)=X2
         DP(3,6)=X7
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy 
*      IF (KELFCT(3:3).NE.'N') THEN
*         DO 1 I=1,6
*         DO 1 J=1,6
*1           DDP(J,I)=0.
*         DDP(4,1)=0.  
*         DDP(4,2)=-1. 
*         DDP(4,3)=1.  
*         DDP(4,4)=0.  
*         DDP(4,5)=1.  
*         DDP(4,6)=-1. 
*         DDP(5,1)=-1. 
*         DDP(5,2)=0.  
*         DDP(5,3)=1.  
*         DDP(5,4)=1.  
*         DDP(5,5)=0.  
*         DDP(5,6)=-1. 
*      ENDIF  
                                                                    END !Pr01FB
