*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PR002B (KELFCT,X1,X2,X3,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees pour le prisme de Lagrange a 18 noeuds 
*  
*-- Arguments d'entree -- cf. ElemFb
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT 
      REAL          X1,X2,X3,P(*),DP(3,*),DDP(6,*) 
*
      INTEGER       I
      REAL          X6,X7,DX1M1,DX2M1,DX3M1,DX6M1,DX7M1,X1DX1,X2DX2
     &             ,X3DX3,X6DX6,X7DX7,QX1X2,QX1X7,QX2X7,QX3X6,A
*-----------------------------------------------------------------------
      X7=1.-X1-X2  
      X6=1.-X3 
      DX1M1=X1+X1-1.
      DX2M1=X2+X2-1.
      DX3M1=X3-X6  
      DX7M1=X7+X7-1.
      DX6M1=-DX3M1 
      QX1X2=4.*X1*X2 
      QX1X7=4.*X1*X7 
      QX2X7=4.*X2*X7  
      QX3X6=4.*X3*X6  
      X1DX1=X1*DX1M1
      X2DX2=X2*DX2M1
      X3DX3=X3*DX3M1
      X6DX6=X6*DX6M1
      X7DX7=X7*DX7M1
*  
*   Fonctions de base  
* 
      IF (KELFCT(1:1).EQ.'Y') THEN  
         P(1)=X1DX1
         P(2)=X2DX2
         P(3)=X7DX7
         P(7)=QX1X2
         P(8)=QX2X7
         P(9)=QX1X7
         DO 1 I=1,3
           A=P(I)  
           P(I+12)=QX3X6*A 
           P(I+3)=A*X3DX3  
           P(I)=A*X6DX6
           A=P(I+6)
           P(I+15)=QX3X6*A 
           P(I+9)=X3DX3*A  
1          P(I+6)=X6DX6*A  
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).EQ.'Y') THEN  
         DP(1,1)=DX1M1+DX1M1+1.
         DP(1,2)=0.
         DP(1,3)=-(1.+DX7M1+DX7M1) 
         DP(1,4)=X3DX3*DP(1,1) 
         DP(1,5)=0.
         DP(1,6)=X3DX3*DP(1,3) 
         DP(1,7)=DX2M1+DX2M1+2.
         DP(1,10)=DP(1,7)*X3DX3
         DP(1,11)=-DP(1,10)
         DP(1,12)=-DP(1,4)-DP(1,6) 
         DP(1,13)=QX3X6*DP(1,1)
         DP(1,14)=0.
         DP(1,15)=QX3X6*DP(1,3)
         DP(1,16)=DP(1,7)*QX3X6
         DP(2,2)=DP(1,7)-1.
         DP(1,7)=X6DX6*DP(1,7) 
         DP(1,8)=-DP(1,7)  
         DP(1,17)=-DP(1,16)
         DP(1,18)=-(DP(1,13)+DP(1,15)) 
         DP(2,1)=0.
         DP(2,4)=0.
         DP(2,5)=DP(2,2)*X3DX3 
         DP(2,6)=DP(1,6)
         DP(2,7)=DP(1,1)+1.
         DP(2,10)=DP(2,7)*X3DX3
         DP(2,11)=-(DP(2,5)+DP(2,6))
         DP(2,12)=-DP(2,10)
         DP(2,13)=0.
         DP(2,14)=QX3X6*DP(2,2)
         DP(2,15)=DP(1,15) 
         DP(2,16)=DP(2,7)*QX3X6
         DP(2,7)=DP(2,7)*X6DX6 
         DP(2,9)=-DP(2,7)  
         DP(2,17)=-(DP(2,14)+DP(2,15)) 
         DP(2,18)=-DP(2,16)
         DP(2,2)=X6DX6*DP(2,2) 
         DP(1,1)=X6DX6*DP(1,1) 
         DP(1,3)=X6DX6*DP(1,3) 
         DP(1,9)=-(DP(1,3)+DP(1,1))
         DP(2,3)=DP(1,3)
         DP(2,8)=-(DP(2,3)+DP(2,2))
*  
         DP(3,4)=DX3M1+DX3M1+1.
         DP(3,1)=DP(3,4)-2.
         DP(3,2)=X2DX2*DP(3,1) 
         DP(3,3)=X7DX7*DP(3,1) 
         DP(3,5)=X2DX2*DP(3,4) 
         DP(3,6)=X7DX7*DP(3,4) 
         DP(3,7)=QX1X2*DP(3,1) 
         DP(3,8)=QX2X7*DP(3,1) 
         DP(3,9)=QX1X7*DP(3,1) 
         DP(3,10)=DP(3,7)+(QX1X2+QX1X2)
         DP(3,11)=DP(3,8)+(QX2X7+QX2X7)
         DP(3,12)=DP(3,9)+(QX1X7+QX1X7)
         DP(3,4)=X1DX1*DP(3,4) 
         DP(3,1)=DP(3,4)-(X1DX1+X1DX1) 
         DP(3,13)=-(DP(3,1)+DP(3,4))
         DP(3,14)=-(DP(3,2)+DP(3,5))
         DP(3,15)=-(DP(3,3)+DP(3,6))
         DP(3,16)=-(DP(3,7)+DP(3,10))  
         DP(3,17)=-(DP(3,8)+DP(3,11))  
         DP(3,18)=-(DP(3,9)+DP(3,12))  
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy 
      IF (KELFCT(3:3).EQ.'Y') THEN  
         CALL BAISE  
     &      (' Pas de derivees secondes pour le prisme a 18 noeuds')
      ENDIF
                                                                    END !Pr02FB
