*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PR202B (KELFCT,X1,X2,X3,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees - Prisme de Lagrange Serendip a 15 noeuds  
*  
*-- Arguments d'entree -- cf. ElemFb
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT 
      REAL          X1,X2,X3,P(*),DP(3,*),DDP(6,*)
*
      INTEGER       I
      REAL          A,X6,X7,DX1,DX2,DX7,DX3P1,DX3M3,QX1X2,QX1X7,QX2X7
     &             ,QX3X6,X1X3,X1X6,X2X3,X2X6,X3X6,X3X7,X6X7,QX1,QX2,QX7
*-----------------------------------------------------------------------
      X7=1.-X1-X2  
      X6=1.-X3 
      X1X3=X1*X3
      X1X6=X1-X1X3 
      X2X3=X2*X3
      X2X6=X2-X2X3 
      X3X6=X3*X6
      X3X7=X3-(X1X3+X2X3)  
      X6X7=X7-X3X7 
      DX3P1=X3+X3+1.
      DX3M3=DX3P1-4.
      DX1=X1+X1
      DX2=X2+X2
      DX7=X7+X7
      QX1X2=4.*X1*X2  
      QX2X7=4.*X2*X7  
      QX1X7=4.*X1*X7  
      QX3X6=4.*X3X6  
*  
*   Fonctions de base  
*
      IF (KELFCT(1:1).NE.'N') THEN  
         P(7)=DX1*X2X6 
         P(8)=DX7*X2X6 
         P(9)=DX7*X1X6 
         P(10)=DX1*X2X3
         P(11)=DX7*X2X3
         P(12)=DX7*X1X3
         P(13)=DX1*X3X6
         P(14)=2.*X3*X2X6  
         P(15)=DX7*X3X6
         P(1)=X1X6-(P(13)+P(9)+P(7))
         P(2)=X2X6-(P(14)+P(7)+P(8))
         P(3)=X6X7-(P(15)+P(9)+P(8))
         P(4)=X1X3-(P(13)+P(10)+P(12)) 
         P(5)=X2X3-(P(14)+P(10)+P(11)) 
         P(6)=X3X7-(P(15)+P(11)+P(12)) 
         DO 1 I=7,15
1          P(I)=P(I)+P(I)  
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
         QX1=DX1+DX1
         QX2=DX2+DX2
         QX7=QX1+QX2-4.
         A=X2X6+X2X6
         DP(1,7)=A+A
         DP(1,8)=-DP(1,7)  
         DP(1,10)=QX2+DP(1,8)  
         DP(1,11)=-DP(1,10)
         DP(1,13)=QX3X6
         DP(1,15)=-DP(1,13)
         DP(1,2)=0.
         DP(1,5)=0.
         DP(1,14)=0.
         DP(1,1)=X6*(QX1-DX3P1)
         DP(1,3)=X6*(QX7+DX3P1)
         DP(1,4)=X3*(QX1+DX3M3)
         DP(1,6)=X3*(QX7-DX3M3)
         DP(1,9)=-(DP(1,1)+DP(1,3))
         DP(1,12)=-(DP(1,4)+DP(1,6))
*  
         DP(2,1)=0.
         DP(2,2)=X6*(QX2-DX3P1)
         DP(2,3)=X6*(QX7+DX3P1)
         DP(2,4)=0.
         DP(2,5)=X3*(QX2+DX3M3)
         DP(2,6)=DP(1,6)
         A=X1X6+X1X6
         DP(2,7)=A+A
         DP(2,8)=-(DP(2,2)+DP(2,3))
         DP(2,9)=-DP(2,7)  
         DP(2,10)=QX1+DP(2,9)  
         DP(2,11)=-(DP(2,6)+DP(2,5))
         DP(2,12)=-DP(2,10)
         DP(2,13)=0.
         DP(2,14)=QX3X6
         DP(2,15)=-QX3X6
*  
         DX3P1=DX3P1+DX3P1-3.  
         DP(3,1)=X1*(DX3P1-DX1)
         DP(3,2)=X2*(DX3P1-DX2)
         DP(3,3)=X7*(DX3P1-DX7)
         DX3P1=DX3P1-2.
         DP(3,4)=X1*(DX3P1+DX1)
         DP(3,5)=X2*(DX3P1+DX2)
         DP(3,6)=X7*(DX3P1+DX7)
         DP(3,10)=QX1X2
         DP(3,11)=QX2X7
         DP(3,12)=QX1X7
         DP(3,7)=-DP(3,10) 
         DP(3,8)=-DP(3,11) 
         DP(3,9)=-DP(3,12) 
         DP(3,13)=-(DP(3,1)+DP(3,4))
         DP(3,14)=-(DP(3,2)+DP(3,5))
         DP(3,15)=-(DP(3,3)+DP(3,6))
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy 
      IF (KELFCT(3:3).NE.'N') THEN  
      CALL BAISE
     &   (' Pas de derivees secondes pour le prisme a 15 noeuds')
      ENDIF
                                                                    END !Pr22fb
