*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISQA (NUARET,NBPTQ,POIDQ1,COORQ1,POIDQ3,COORQ3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (29 Octobre 1999)
* Version 1.0.0
*
* Formule de quadrature sur une arete du prisme de reference 
* construite a partir d'une formule de quadrature sur le segment.
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUARET numero de l'arete de l'element
* NBPTQ  nombre de points de la formule de quadrature du segment
* POIDQ1 poids de la formule de quadrature sur le segment
* COORQ1 coordonnees des points de la formule de quadrature sur le segment
* POIDQ3 poids de la formule de quadrature sur l'arete du prisme
* COORQ3 coordonnees des points de la formule de quadrature sur l'arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUARET,NBPTQ
      REAL    POIDQ1(*),COORQ1(*),POIDQ3(*),COORQ3(3,*)
*
      INTEGER I
      REAL    SQRT2
*-----------------------------------------------------------------------
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1+x2=1.,x3=0.
         SQRT2 =  SQRT(2.)
         DO 3001 I=1,NBPTQ
            COORQ3(1,I) = COORQ1(I)
            COORQ3(2,I) = 1.-COORQ1(I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = SQRT2*POIDQ1(I)
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x1=0.,x3=0.
         DO 3002 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = COORQ1(I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ1(I)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x2=0.,x3=0.
         DO 3003 I=1,NBPTQ
            COORQ3(1,I) = COORQ1(I)
            COORQ3(2,I) = 0.
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ1(I)
3003     CONTINUE
      ELSEIF (NUARET.EQ.4) THEN
*        Arete 4 : droite x1=1.,x2=0.
         DO 3004 I=1,NBPTQ
            COORQ3(1,I) = 1.
            COORQ3(2,I) = 0.
            COORQ3(3,I) = COORQ1(I)
            POIDQ3(I)   = POIDQ1(I)
3004     CONTINUE
      ELSEIF (NUARET.EQ.5) THEN
*        Arete 5 : droite x1=1.,x2=1.
         DO 3005 I=1,NBPTQ
            COORQ3(1,I) = 1.
            COORQ3(2,I) = 1.
            COORQ3(3,I) = COORQ1(I)
            POIDQ3(I)   = POIDQ1(I)
3005     CONTINUE
      ELSEIF (NUARET.EQ.6) THEN
*        Arete 6 : droite x1=0.,x2=0.
         DO 3006 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = 0.
            COORQ3(3,I) = COORQ1(I)
            POIDQ3(I)   = POIDQ1(I)
3006     CONTINUE
      ELSEIF (NUARET.EQ.7) THEN
*        Arete 7 : droite x1+x2=1.,x3=1.
         SQRT2 =  SQRT(2.)
         DO 3007 I=1,NBPTQ
            COORQ3(1,I) = COORQ1(I)
            COORQ3(2,I) = 1.-COORQ1(I)
            COORQ3(3,I) = 1.
            POIDQ3(I)   = SQRT2*POIDQ1(I)
3007     CONTINUE
      ELSEIF (NUARET.EQ.8) THEN
*        Arete 8 : droite x1=0.,x3=1.
         DO 3008 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = COORQ1(I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ1(I)
3008     CONTINUE
      ELSEIF (NUARET.EQ.9) THEN
*        Arete 9 : droite x2=0.,x3=1.
         DO 3009 I=1,NBPTQ
            COORQ3(1,I) = COORQ1(I)
            COORQ3(2,I) = 0.
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ1(I)
3009     CONTINUE
      ELSE
         CALL ERELEM (5,'PrisQa',NUARET)                                !Utilite
      ENDIF
                                                                    END !PrisQa
