*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISQF (NUFACE,NBPTQ,POIDQ2,COORQ2,POIDQ3,COORQ3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.0.1
*
* Formule de quadrature sur une face du prisme de reference 
* construite a partir d'une formule de quadrature sur le carre ou le triangle.
*
*-- Arguments d'entree --
* NUFACE numero de la face de l'element
* NBPTQ  nombre de points de la formule de quadrature 2d
* POIDQ2 poids de la formule de quadrature 2d
* COORQ2 coordonnees des points de la formule de quadrature 2d
* POIDQ3 poids de la formule de quadrature sur la face du prisme
* COORQ3 coordonnees des points de la formule de quadrature sur la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE,NBPTQ
      REAL    POIDQ2(*),COORQ2(2,*),POIDQ3(*),COORQ3(3,*)
*
      INTEGER I
      REAL    SQRT2
*-----------------------------------------------------------------------
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x3=0.
         DO 3101 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ2(I)
3101     CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x1+x2=1.
         SQRT2 = SQRT (2.)
         DO 3102 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = 1.-COORQ2(1,I)
            COORQ3(3,I) = COORQ2(2,I)
            POIDQ3(I)   = SQRT2*POIDQ2(I)
3102     CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 4 : plan x1=0.
         DO 3103 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = COORQ2(1,I)
            POIDQ3(I)   = POIDQ2(I)
3103     CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x2=0.
         DO 3104 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = 0.
            COORQ3(3,I) = COORQ2(2,I)
            POIDQ3(I)   = POIDQ2(I)
3104     CONTINUE
      ELSEIF (NUFACE.EQ.5) THEN
*        Face 5 : plan x3=1.
         DO 3105 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 1.
            POIDQ3(I)   = POIDQ2(I)
3105     CONTINUE
      ELSE
         CALL ERELEM (6,'PrisQf',NUFACE)                                !Utilite
      ENDIF
                                                                    END !PrisQf
