*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISTA (NUARET,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.0.1
*
* Projection du vecteur tangent sur une arete d'un hexaedre
*
*-- Arguments d'entree --
* NUARET numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteur tangent sur l'arete courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUARET
      REAL    JACOBF(3,*),JACOBT(3)
*
      INTEGER I,DIM
      REAL    USQRT2
*-----------------------------------------------------------------------
      DIM=3
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1+x2=1.,x3=0.
         USQRT2 = SQRT (2.)/2.
         DO 3001 I=1,DIM
            JACOBT(I)= USQRT2*(JACOBF(I,2)-JACOBF(I,1))
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x1=0.,x3=0.
         DO 3002 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x2=0.,x3=0.
         DO 3003 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
3003     CONTINUE
      ELSEIF (NUARET.LE.6) THEN
*        Aretes 4,5,6 : droites x1=1.,x2=0.;x1=0.,x2=1.;x1=0.,x2=0.
         DO 3004 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
3004     CONTINUE
      ELSEIF (NUARET.EQ.7) THEN
*        Arete 7 : droite x1+x2=1.,x3=1.
         USQRT2 = SQRT (2.)/2.
         DO 3007 I=1,DIM
            JACOBT(I)= USQRT2*(JACOBF(I,2)-JACOBF(I,1))
3007     CONTINUE
      ELSEIF (NUARET.EQ.8) THEN
*        Arete 8 : droite x1=0.,x3=1.
         DO 3008 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
3008     CONTINUE
      ELSEIF (NUARET.EQ.9) THEN
*        Arete 9 : droite x2=0.,x3=1.
         DO 3009 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
3009     CONTINUE
      ELSE
         CALL ERELEM (5,'PrisTa',NUARET)                                !Utilite
      ENDIF
                                                                    END !PrisTa
