*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRISTF (NUFACE,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.0.1
*
* Projection des vecteurs tangents sur une face d'un prisme
*
*-- Arguments d'entree --
* NUFACE numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteurs tangents sur la face courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE
      REAL    JACOBF(3,*),JACOBT(3,*)
*
      INTEGER I,DIM
      REAL    USQRT2
*-----------------------------------------------------------------------
      DIM=3
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x3=0.
         DO 3001 I=1,DIM
            JACOBT(I,1)=JACOBF(I,2)
            JACOBT(I,2)=JACOBF(I,1)
3001     CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x1+x2=1.
         USQRT2 = SQRT (2.)/2.
         DO 3002 I=1,DIM
            JACOBT(I,1)= USQRT2*(JACOBF(I,2)-JACOBF(I,1))
            JACOBT(I,2)=JACOBF(I,3)
3002     CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 3 : plan x1=0.
         DO 3003 I=1,DIM
            JACOBT(I,1)=JACOBF(I,3)
            JACOBT(I,2)=JACOBF(I,2)
3003     CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x2=0.
         DO 3004 I=1,DIM
            JACOBT(I,1)=JACOBF(I,1)
            JACOBT(I,2)=JACOBF(I,3)
3004     CONTINUE
      ELSEIF (NUFACE.EQ.5) THEN
*        Face 5 : plan x3=1.
         DO 3005 I=1,DIM
            JACOBT(I,1)=JACOBF(I,1)
            JACOBT(I,2)=JACOBF(I,2)
3005     CONTINUE
      ELSE
         CALL ERELEM (6,'PrisTf',NUFACE)                                !Utilite
      ENDIF
                                                                    END !PrisTf
