*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLKAR (K,NUARET,NUTYAR,NBNEAR,NUNEAR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (13 Decembre 2000)
* Version 1.0.2
*  
* Numerotation locale des noeuds d'une arete de l'element de reference 
* Prisme de Lagrange d'ordre k
*
*-- Arguments --
* K      pour hexaedre de type k
* NUARET numero de l'arete
* NUTYAR numero de type de l'arete (numero de type de l'elt 1d associe)
* NBNEAR nombre de noeuds de l'arete
* NUNEAR tableau des numeros locaux des noeuds de l'arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  K,NUARET,NUTYAR,NBNEAR,NUNEAR(*),NTYPFO
      PARAMETER ( NTYPFO = 1000 )
*-----------------------------------------------------------------------
      IF (NUARET.LE.3) THEN
*
*        Aretes 1 a 3 (Face 1 , Z=0)
         NUNEAR(1)=NUARET 
         NUNEAR(2)=NUARET+1
         IF (NUARET.EQ.3) NUNEAR(2)=1
         IF (K.EQ.2) THEN
            NUNEAR(3)=NUARET+6
         ENDIF
*
      ELSEIF (NUARET.LE.6) THEN
*
*        Aretes 4 a 6 (Verticales)
         NUNEAR(1)=NUARET-3
         NUNEAR(2)=NUARET
         IF (K.EQ.2) THEN
            NUNEAR(3)=NUARET+9
         ENDIF
*
      ELSEIF (NUARET.LE.9) THEN
*
*        Aretes 7 a 9 (Face 6 , Z=1)
         NUNEAR(1)=NUARET-3
         NUNEAR(2)=NUARET-2
         IF (NUARET.EQ.9) NUNEAR(2)=4
         IF (K.EQ.2) THEN
            NUNEAR(3)=NUARET+3
         ENDIF
*
      ENDIF
      NUTYAR=10*NTYPFO+K
      NBNEAR=K+1
*  
                                                                    END !Prlkar
