*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLKP1 (K,NBLMP1,NUPOP1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : Rania Rais (Mai 2009)
* Derniere modification : Rania Rais (26 mai 2009)
* Version 1
*
* Construction des tableaux de correspondance des numerotations locales
* entre elements prismiques Pk et elements tetraedriques P1.
* Le prisme P1 est decoupe en 3 tetraedres P1
* Le prisme P2 est decoupe en 8 prismes P1 et chaque prisme est decoupe
* en 3 tetraedres  
*
*-- Argument d'entree --
* K      pour un prisme de degre k
*-- Arguments de sortie --
* NBLMP1 nombre de tetraedres P1
* NUPOP1 tableau de correspondance entre tetraedres P1 et prisme Pk
*        NUPOP1 (s,t) = numero dans le prisme Pk du sommet s du tetraedre t
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,NBLMP1,NUPOP1(4,*)
*
      INTEGER NK
*-----------------------------------------------------------------------
      NBLMP1=0
      NK=K
*
*decoupage dun prisme en 3 tetraedres
      IF (NK.EQ.1) THEN 
*
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1 
         NUPOP1(2,NBLMP1) = 2 
         NUPOP1(3,NBLMP1) = 3 
         NUPOP1(4,NBLMP1) = 5 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 3 
         NUPOP1(2,NBLMP1) = 4 
         NUPOP1(3,NBLMP1) = 5 
         NUPOP1(4,NBLMP1) = 6
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1 
         NUPOP1(2,NBLMP1) = 3
         NUPOP1(3,NBLMP1) = 4 
         NUPOP1(4,NBLMP1) = 5   
*
      ELSEIF (NK.EQ.2) THEN       
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1 
         NUPOP1(2,NBLMP1) = 7 
         NUPOP1(3,NBLMP1) = 9 
         NUPOP1(4,NBLMP1) = 16 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9
         NUPOP1(2,NBLMP1) = 13 
         NUPOP1(3,NBLMP1) = 16 
         NUPOP1(4,NBLMP1) = 18
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1 
         NUPOP1(2,NBLMP1) = 9 
         NUPOP1(3,NBLMP1) = 13 
         NUPOP1(4,NBLMP1) = 16
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 7 
         NUPOP1(2,NBLMP1) = 2 
         NUPOP1(3,NBLMP1) = 8 
         NUPOP1(4,NBLMP1) = 14 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 8 
         NUPOP1(2,NBLMP1) = 16 
         NUPOP1(3,NBLMP1) = 14 
         NUPOP1(4,NBLMP1) = 17
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 7 
         NUPOP1(2,NBLMP1) = 8 
         NUPOP1(3,NBLMP1) = 16 
         NUPOP1(4,NBLMP1) = 14
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 13 
         NUPOP1(2,NBLMP1) = 16 
         NUPOP1(3,NBLMP1) = 18 
         NUPOP1(4,NBLMP1) = 10 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 18 
         NUPOP1(2,NBLMP1) = 4 
         NUPOP1(3,NBLMP1) = 10 
         NUPOP1(4,NBLMP1) = 12
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 13 
         NUPOP1(2,NBLMP1) = 18 
         NUPOP1(3,NBLMP1) = 4 
         NUPOP1(4,NBLMP1) = 10 
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 16 
         NUPOP1(2,NBLMP1) = 14 
         NUPOP1(3,NBLMP1) = 17 
         NUPOP1(4,NBLMP1) = 5 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 17 
         NUPOP1(2,NBLMP1) = 10 
         NUPOP1(3,NBLMP1) = 5 
         NUPOP1(4,NBLMP1) = 11
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 16 
         NUPOP1(2,NBLMP1) = 17 
         NUPOP1(3,NBLMP1) = 10 
         NUPOP1(4,NBLMP1) = 5
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9 
         NUPOP1(2,NBLMP1) = 8 
         NUPOP1(3,NBLMP1) = 3 
         NUPOP1(4,NBLMP1) = 17 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 3 
         NUPOP1(2,NBLMP1) = 18 
         NUPOP1(3,NBLMP1) = 17 
         NUPOP1(4,NBLMP1) = 15
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9 
         NUPOP1(2,NBLMP1) = 3 
         NUPOP1(3,NBLMP1) = 18 
         NUPOP1(4,NBLMP1) = 17
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 18 
         NUPOP1(2,NBLMP1) = 17 
         NUPOP1(3,NBLMP1) = 15 
         NUPOP1(4,NBLMP1) = 11 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 15 
         NUPOP1(2,NBLMP1) = 12 
         NUPOP1(3,NBLMP1) = 11 
         NUPOP1(4,NBLMP1) = 6
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 18 
         NUPOP1(2,NBLMP1) = 15 
         NUPOP1(3,NBLMP1) = 12 
         NUPOP1(4,NBLMP1) = 11

         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 8 
         NUPOP1(2,NBLMP1) = 9 
         NUPOP1(3,NBLMP1) = 7 
         NUPOP1(4,NBLMP1) = 18 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 7
         NUPOP1(2,NBLMP1) = 17 
         NUPOP1(3,NBLMP1) = 18
         NUPOP1(4,NBLMP1) = 16
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 8 
         NUPOP1(2,NBLMP1) = 7 
         NUPOP1(3,NBLMP1) = 17 
         NUPOP1(4,NBLMP1) = 18
         
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 17 
         NUPOP1(2,NBLMP1) = 18 
         NUPOP1(3,NBLMP1) = 16 
         NUPOP1(4,NBLMP1) = 12 
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 16 
         NUPOP1(2,NBLMP1) = 11 
         NUPOP1(3,NBLMP1) = 12 
         NUPOP1(4,NBLMP1) = 10
	 NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 17 
         NUPOP1(2,NBLMP1) = 16 
         NUPOP1(3,NBLMP1) = 11 
         NUPOP1(4,NBLMP1) = 12   
    
      ELSE
        CALL ERELEM (15,'*Prlkp1*',K) 
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : R.Rais (26 mai 2009)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END
