*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QU202B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Fonctions de base et derivees - Quadrangle de Lagrange Serendip a 20 noeuds
*
*-- Arguments --
* KELFCT variable CHARACTER indiquant
*         si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*         si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*         si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP      -       -            -     -  derivees premieres  
* DDP     -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)  
*
      REAL          X1X2,X1X4,X2X3,X3,X4,X3X4,DX1,DX2,QX1,QX2,QX3
     &             ,DX1M1,DX2M1,Q1MD2,Q1MD4,Q2MD1,Q4MD1
*-----------------------------------------------------------------------
      X3=1.-X1 
      X4=1.-X2 
*
*   Fonctions de base
*
      IF (KELFCT(1:1).NE.'N') THEN  
         X1X2=X1*X2
         X2X3=X2-X1X2  
         X1X4=X1-X1X2  
         X3X4=1.-X2-X1X4
         P(1)=X1X4*(X1-X2) 
         P(1)=P(1)+P(1)-X1X4
         P(2)=X1X2*(X2-X3) 
         P(2)=P(2)+P(2)-X1X2
         P(3)=X2X3*(X3-X4) 
         P(3)=P(3)+P(3)-X2X3
         P(4)=X3X4*(X4-X1) 
         P(4)=P(4)+P(4)-X3X4
         QX3=X3+X3 
         QX3=QX3+QX3
         QX2=X2+X2 
         QX2=QX2+QX2
         P(8)=X1X4*QX3 
         P(5)=X1X4*QX2 
         P(6)=X1X2*QX3 
         P(7)=X3X4*QX2 
      ENDIF
*
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN
         DX1=X1+X1
         DX2=X2+X2
         DX1M1=DX1-1.
         DX2M1=DX2-1.
         QX1=DX1+DX1
         QX2=DX2+DX2
         Q1MD2=QX1-DX2-1.
         Q1MD4=QX1+DX2-3.
         Q2MD1=QX2-DX1-1.
         Q4MD1=-3.+QX2+DX1 
         DP(1,1)=X4*Q1MD2
         DP(1,2)=X2*Q1MD4
         DP(1,3)=Q1MD2-DP(1,1) 
         DP(1,4)=Q1MD4-DP(1,2) 
         DP(1,8)=(QX2-4.)*DX1M1
         DP(1,5)=X4*QX2
         DP(1,6)=-QX2*DX1M1
         DP(1,7)=-DP(1,5)
         DP(2,1)=X1*Q2MD1 
         DP(2,2)=X1*Q4MD1
         DP(2,3)=Q2MD1-DP(2,1) 
         DP(2,4)=Q4MD1-DP(2,2) 
         DP(2,8)=-QX1*X3
         DP(2,5)=-QX1*DX2M1
         DP(2,6)=-DP(2,8)  
         DP(2,7)=(QX1-4.)*DX2M1
      ENDIF
*
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy 
*      IF (KELFCT(3:3).NE.'N') THEN 
*         DX1=X1+X1
*         DX1=DX1+DX1  
*         DX2=X2+X2
*         DX2=DX2+DX2  
*         DX3=4.-DX1
*         DX4=4.-DX2
*         DDP(1,1)=DX4 
*         DDP(1,2)=DX2 
*         DDP(1,3)=DX2 
*         DDP(1,4)=DX4 
*         DDP(2,1)=DX1 
*         DDP(2,2)=DX1 
*         DDP(2,3)=DX3 
*         DDP(2,4)=DX3 
*         DDP(3,1)=DX2-DX1-1.  
*         DDP(3,2)=DX1-DX4+1.  
*         DDP(3,3)=DX4-DX3-1.  
*         DDP(3,4)=DX3-DX2+1.  
*         DX1=DX1+DX1  
*         DX2=DX2+DX2  
*         DX3=DX3+DX3  
*         DX4=DX4+DX4  
*         DDP(1,8)=-DX4
*         DDP(1,5)=0.  
*         DDP(1,6)=-DX2
*         DDP(1,7)=0.  
*         DDP(2,8)=0.  
*         DDP(2,5)=-DX1
*         DDP(2,6)=0.  
*         DDP(2,7)=-DX3
*         DDP(3,8)=DX1-4.  
*         DDP(3,5)=DX4-4.  
*         DDP(3,6)=-DDP(3,8)
*         DDP(3,7)=-DDP(3,5)
*      ENDIF  
                                                                    END !Qu22Fb
