*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QUAD (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
*-- Variable d'entree --
* TYPE numero de type de l'element   
*   k= 0 a 19 --> Quadrangle de Lagrange Qk a (k+1)^2 noeuds treillis regulier
*   k=30 a 49 --> Quadrangle de Lagrange Qk a (k+1)^2 noeuds de Gauss-Lobatto
*   k=22      --> Quadrangle de Lagrange Q2 Serendipity a 8 noeuds
*  
*-- Variables en sortie --
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* CLASSE classe de l'element (Element de classe C^0, C^1,...etc)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBNEAX nombre de noeuds sur une arete
* NBDLAX nombre de d.l. sur une arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX
*
      INTEGER TYPNEW,LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPE.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
      LAGHER=0
      CLASSE=0
*
      IF (TYPNEW.LE.LAGDMX) THEN
         NBNEAX=TYPNEW+1
         NBDLAX=NBNEAX
         NBNEEL=NBNEAX*NBNEAX
         NBDLEL=NBNEEL
      ELSEIF (TYPE.EQ.202) THEN
         NBNEAX=3
         NBDLAX=NBNEAX
         NBNEEL=8
         NBDLEL=NBNEEL
      ELSE
         CALL QUADXX (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
      ENDIF
                                                                    END !Quad
