*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QUADTA (NUARET,JACOBF,TANGNT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (28 Decembre 2000)
* Version 1.0.1
*
* Calcul d'un vecteur tangent sur une arete d'un quadrangle
* a partir de la matrice jacobienne sur l'element
*
*-- Arguments d'entree --
* NUARET numero de la face de l'element
* JACOBF matrice jacobienne
* TANGNT vecteur tangent sur l'arete courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NUARET
      REAL     JACOBF(2,*),TANGNT(*)
*
      INTEGER I
*-----------------------------------------------------------------------
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1=1.
         DO 3001 I=1,2
            TANGNT(I)= JACOBF(I,2)
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x2=1.
         DO 3002 I=1,2
            TANGNT(I)=-JACOBF(I,1)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x1=0.
         DO 3003 I=1,2
            TANGNT(I)=-JACOBF(I,2)
3003     CONTINUE
      ELSEIF (NUARET.EQ.4) THEN
*        Arete 4 : droite x2=0.
         DO 3004 I=1,2
            TANGNT(I)=+JACOBF(I,1)
3004     CONTINUE
      ELSE
         CALL ERELEM (5,'QuadTa',NUARET)                                !Utilite
      ENDIF
                                                                    END !QuadTa
