*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QULKAR (TYPE,NUARET,NUTYAR,NBNEAR,NUNEAR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2000)
* Derniere modification : D.Martin (6 Septembre 2001)
* Version 1.1.0
*
* Numerotation locale des noeuds d'une arete de l'element de reference
* Quadrangle de Lagrange d'ordre k a (k+1)^2 noeuds
*
*-- Arguments --
* TYPE   =K pour quadrangle de Lagrange de type k
* NUARET numero de l'arete
* NUTYAR numero de type de l'arete (numero de type de l'element 1d associe)
* NBNEAR nombre de noeuds de l'arete
* NUNEAR tableau des numeros locaux des noeuds de l'arete
* --> Remarque : La numerotation locale sur les aretes est telle que la base
*                constituee de la normale exterieure et du vecteur
*                'NUNEFA(1)-NUNEFA(2)' est directe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE,NUARET,NUTYAR,NBNEAR,NUNEAR(*)
*
      INTEGER TYPNEW,NBARET,I,MORE,LAGDMX, NTYPFO
      PARAMETER ( LAGDMX = 100, NTYPFO = 1000)

*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPNEW.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
*  Segments
*  Numerotations locales des noeuds
*  2----1  2---3---1  2---4---3---1  2---5---4---3---1  2---6---5---4---3---1
*
*  Quadrangles
*  Numerotations des aretes
*  3-----II----2
*  |           |
*  |           |
* III          I
*  |           |
*  |           |
*  4-----IV----1
*  Numerotations des noeuds   
*  3----2  3---6---2  3--10---6---2  3--14--10---6---2  3--18--14--10---6---2
*  |    |  |       |  |           |  |               |  |                   |
*  4----1  7   9   5  7  15  14   9  7  19  22  18  13  7  23  30  26  22  17
*   k=1    |       |  |           |  |               |  |                   |
*          4---8---1 11  16  13   5  11 23  25  21   9 11  27  35  34  29  13
*             k=2     |           |  |               |  |                   |
*                     4---8--12---1 15  20  24  17   5 15  31  36  33  25   9
*                          k=3       |               |  |                   |
*                                    4---8--12--16---1 19  24  28  32  21   5
*                                            k=4        |                   |
*                                                       4---8--12--16--20---1
*                                                                k=5
      NBARET=4
      NUTYAR=10*NTYPFO+TYPE
      NBNEAR=TYPNEW+1
      NUNEAR(1)=NUARET+1
      NUNEAR(2)=NUARET
      IF (NUARET.EQ.NBARET) NUNEAR(1)=1
      MORE=NBARET
      DO 1 I=NBNEAR,3,-1
        NUNEAR(I)=NUARET+MORE
        MORE=MORE+NBARET
 1    CONTINUE
                                                                    END !Qulkar
