*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE QULKCO (K,NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Janvier 2000)
* Refonte complete pour les elements de Lagrange aux abscisses quelconques
* (en particulier de Gauss-Lobatto) : D.Martin (30 Aout 2001)
* Derniere modification : D.Martin (09 Decembre 2001)
* Version 1.1.1
*
* Coordonnees des noeuds de l'element de reference pour le quadrangle de
* Lagrange (ordre k) a (k+1)^2 noeuds * construites par produit tensoriel 
* a partir des coordonnees de l'element 1D
*                    (../../doc_html/ef/numlocqu.html)
*
*-- Arguments --
* K      pour quadangle de type k
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER LAGDMX,NBNEX
      PARAMETER ( LAGDMX = 100 , NBNEX = (LAGDMX+1)**2 )
      INTEGER NUX2SE(2,NBNEX),KNEW,NE,I,J
*     &       ,Q,NK,IQQ1,IQQ2,IQQ3,I33,IQQ4,I44
      REAL    CORLO1 (LAGDMX+1)
*-----------------------------------------------------------------------
*
*  Numerotations locales
*  Segments
*  2----1  2---3---1  2---4---3---1  2---5---4---3---1  2---6---5---4---3---1
*
*  Quadrangles
*  3----2  3---6---2  3--10---6---2  3--14--10---6---2  3--18--14--10---6---2
*  |    |  |       |  |           |  |               |  |                   |
*  4----1  7   9   5  7  15  14   9  7  19  22  18  13  7  23  30  26  22  17
*   k=1    |       |  |           |  |               |  |                   |
*          4---8---1 11  16  13   5  11 23  25  21   9 11  27  35  34  29  13
*             k=2     |           |  |               |  |                   |
*                     4---8--12---1 15  20  24  17   5 15  31  36  33  25   9
*                          k=3       |               |  |                   |
*                                    4---8--12--16---1 19  24  28  32  21   5
*                                            k=4        |                   |
*                                                       4---8--12--16--20---1
*                                                                k=5
      KNEW=K
      IF (KNEW.GT.LAGDMX) KNEW=KNEW-LAGDMX
*
      CALL SELKCO (K,1,CORLO1)
*
*     Tableau de correspondance entre les noeuds du segment d'ordre k
*     et le quadrangle d'ordre k
*
      NE=0
      CALL SEX2SE (KNEW,NDIM,NE,1,2,3,KNEW+1,1,2,1,NUX2SE)
*
*     Coordonnees des noeuds dans l'hexaedre d'ordre k
*
      DO 2 I=1,NE
         DO 1 J=1,NDIM
            CORLOC(J,I)=CORLO1(NUX2SE(J,I))
1        CONTINUE
2     CONTINUE
                                                                    END !QulkCo
