*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE010B (KELFCT,XSP,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Vial (Septembre 2000)
* Derniere modification : D.Martin & G.Vial (05 juillet 2005)
* Version 2
*
* Fonctions de base et derivees sur le segment de Lagrange d'ordre 10
*
*-- Arguments d'entree --
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou l'on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X
* DP        -       -            -     -  derivees premieres
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL    XSP,P(*),DP(*)
*
      DOUBLE PRECISION X,XM1,DXM1,CXM1,CXM2,CXM3,CXM4,KXM1,KXM3,KXM5
     &                ,KXM7,KXM9,KXM1M1,KXM3M4,KXM7M8,KXM9X1,YYY
*-----------------------------------------------------------------------
      X = DBLE(XSP)
      XM1 = X-1.
      KXM1= 10*X-1.
      YYY=1D0/4536.
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N') THEN
         DXM1=2*X-1
         KXM3=KXM1-2
         KXM7=KXM1-6
         KXM9=KXM1-8
         CXM1=5*X-1
         CXM2=CXM1-1
         CXM3=CXM1-2
         CXM4=CXM1-3
         KXM1M1=KXM1*CXM1
         KXM3M4=KXM3*CXM2
         KXM7M8=KXM7*CXM4
         KXM9X1=KXM9*XM1

         P(2) =      YYY  *KXM1M1*KXM3M4*DXM1*CXM3*KXM7M8*KXM9X1
         P(1) =      YYY*X*KXM1M1*KXM3M4*DXM1*CXM3*KXM7M8*KXM9
         P(11)= -100*YYY*X  *CXM1*KXM3M4*DXM1*CXM3*KXM7M8*KXM9X1
         P(10)=  225*YYY*X*KXM1  *KXM3M4*DXM1*CXM3*KXM7M8*KXM9X1
         P(9) =-1200*YYY*X*KXM1M1  *CXM2*DXM1*CXM3*KXM7M8*KXM9X1
         P(8) = 1050*YYY*X*KXM1M1*KXM3  *DXM1*CXM3*KXM7M8*KXM9X1
         P(7) = -504*YYY*X*KXM1M1*KXM3M4     *CXM3*KXM7M8*KXM9X1
         P(6) = 1050*YYY*X*KXM1M1*KXM3M4*DXM1     *KXM7M8*KXM9X1
         P(5) =-1200*YYY*X*KXM1M1*KXM3M4*DXM1*CXM3  *CXM4*KXM9X1
         P(4) =  225*YYY*X*KXM1M1*KXM3M4*DXM1*CXM3*KXM7  *KXM9X1
         P(3) = -100*YYY*X*KXM1M1*KXM3M4*DXM1*CXM3*KXM7M8   *XM1
      ENDIF
*     Derivees premieres
      IF (KELFCT(2:2).NE.'N') THEN
         DP(2)=YYY*(20*X-11)*(12078+(-267894+(2379795+(-112046D2
     &         +(30881125+(-51425D3+(50875D3+(-275D5+625D4
     &         *X)*X)*X)*X)*X)*X)*X)*X)
         DP(1)=YYY*(20*X-9)*(504+(-27396+(427745+(-30699D2
     &         +(11881125+(-26325D3+(33375D3+(-225D5+625D4
     &         *X)*X)*X)*X)*X)*X)*X)*X)
         DP(11)=100+(-24305D1/63+(1997825D0/42+(-16598525D1/567
     &         +(18878125D0/18+(-20965625D0/9+(293125D2/9
     &         +(-5275D5/189+(9375D3/7-15625D4/567
     &         *X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(10)=-225+(153025D0/14+(-8694225D0/56+(6619175D1/63
     &         +(-289909375D0/72+(56396875D0/6+(-122828125D0/9
     &         +(75875D4/63+(-4140625D1/7+78125D3/63
     &         *X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(9)=400+(-13082D2/63+(2002895D1/63+(-433739D3/189
     &         +(8343125D1/9+(-677375D2/3+(305375D3/9+(-194D7/63
     &         +(325D6/21-625D6/189*X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(8)=-525+(168775D0/6+(-1792225D0/4+(91073375D0/27
     &        +(-510353125D0/36+(107321875D0/3+(-49896875D1/9
     &        +(155D6/3+(-26562500+15625D4/27*X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(7)=-1D0/9*(2*X-1)*(4536+(-238500+(3562875+(-24148750
     &        +(87074375+(-1775D5+(205D6+(-125D6+3125D4
     &        *X)*X)*X)*X)*X)*X)*X)*X)
         DP(6)=-350+(174025D0/9+(-11544725D0/36+(6835775D1/27
     &        +(-403334375D0/36+(89384375D0/3+(-43728125D1/9
     &        +(475D5+(-765625D2/3+15625D4/27*X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(5)=12D2/7+(-2006D2/21+(112195D1/7+(-242639D3/189
     &        +(5200625D1/9+(-15662500+(234625D3/9
     &        +(-164D7/63+(1D8/7-625D6/189*X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(4)=-225D0/4+(88325D0/28+(-2990025D0/56+(54486625D0/126
     &        +(-142028125D0/72+(32584375D0/6+(-82796875D0/9+(59D7/63
     &        +(-3671875D1/7+78125D3/63*X)*X)*X)*X)*X)*X)*X)*X)*X
         DP(3)=1D2/9+(-1315D1/21+(4033825D0/378+(-4943525D1/567
     &        +(21709375D0/54+(-10090625D0/9+(520625D2/27+(-3775D5/189
     &        +(71875D3/63-15625D4/567*X)*X)*X)*X)*X)*X)*X)*X)*X
      ENDIF
      END
