*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SE200B (KELFCT,X,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees sur le segment de Hermite a 4 d.l. d'ordre 3  
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X      coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT
      REAL          X,P(*),DP(*),DDP(*)
*
      REAL          X2,X3  
*-----------------------------------------------------------------------
      X2=X*X
      X3=X2*X  
*  
*     Fonctions de base
      IF (KELFCT(1:1).NE.'N')THEN
         P(1)=X3-X2
         P(2)=1.-P(1)
         P(3)=X3-2.*X2+X
         P(4)=2.*X3-3.*X2+1.
      ENDIF
*  
*      Derivees premieres  
      IF (KELFCT(2:2).NE.'N')THEN
         X2=3.*X2
         DP(1)=X2-2.*X
         DP(2)=-DP(1)
         DP(3)=X2-4.*X+1.
         DP(4)=2.*X2-6.*X
      ENDIF
*  
*     Derivees secondes
      IF (KELFCT(3:3).NE.'N')THEN  
         X2=6.*X-4.
         DDP(1)=X2+2.
         DDP(2)=-DDP(1)
         DDP(3)=X2
         DDP(4)=2.*X2+2.
      ENDIF  
                                                                    END !Se20Fb
