*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SEGMCF (TYPE,NBDLEL,TABCOF)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1989)
* Derniere modification : D.Martin (28 Decembre 2000)
* Version 1.0.3
*  
* Coefficients des fonctions de base sur le segment de type TYPE 
*  
*-- Arguments d'entree -- 
* TYPE   numero de type de l'element   
* NBDLEL nombre de degres de liberte de l'element 
*-- Argument de sortie -- 
* TABCOF : Tableau contenant les valeurs des coefficients rempli sous la forme 
*          TABCOF(IRANG,IDL): IRANG rang du coeff. (par ordre decroissant) 
*                             IDL numero de D.L.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,NBDLEL
      REAL    TABCOF(NBDLEL,*)
*-----------------------------------------------------------------------
      IF (TYPE.EQ.0) THEN
         TABCOF(1,1)=1.
      ELSEIF (TYPE.EQ.1) THEN
*        Coeff. de X (d.l. # 1 val.nodale en 1.)
         TABCOF(1,1)=1.
         TABCOF(2,1)=0.
*        Coeff. de 1-X (d.l. # 2 val.nodale en 0.)
         TABCOF(1,2)=-1.
         TABCOF(2,2)=1.
      ELSEIF (TYPE.EQ.2.OR.TYPE.EQ.202) THEN
*        Coeff. de 2X**2-X (d.l. # 1 val. nodale en 1.)
         TABCOF(1,1)=2.
         TABCOF(2,1)=-1.
         TABCOF(3,1)=0.
*        Coeff. de 2X**2-3X+1 (d.l. # 2 val. nodale en 0.)
         TABCOF(1,2)=2.
         TABCOF(2,2)=-3.
         TABCOF(3,2)=1.
*        Coeff. de -4X**2+4X (d.l. # 3 val. nodale en 1/2.)
         TABCOF(1,3)=-4.  
         TABCOF(2,3)=4.
         TABCOF(3,3)=0.
      ELSEIF (TYPE.EQ.3) THEN
*        Coeff. de   9/2 X**3-9/2 X**2+X (d.l. # 1 val. nodale en 1.)
         TABCOF(1,1)=4.5
         TABCOF(2,1)=-4.5
         TABCOF(3,1)=1.
         TABCOF(4,1)=0.
*        Coeff. de  -9/2 X**3+9 X**2-11/2 X+1 (d.l. # 2 val. nodale en 0.)
         TABCOF(1,2)=-4.5
         TABCOF(2,2)=9.
         TABCOF(3,2)=-5.5
         TABCOF(4,2)=1.
*        Coeff. de -27/2 X**+18 X**2-9/2 X (d.l. # 3 val. nodale en 2/3.)
         TABCOF(1,3)=-13.5
         TABCOF(2,3)=18.
         TABCOF(3,3)=-4.5
         TABCOF(4,3)=0.
*        Coeff. de  27/2 X**3-45/2 X**2+9 X (d.l. # 4 val. nodale en 1/3.)
         TABCOF(1,4)=13.5
         TABCOF(2,4)=-22.5
         TABCOF(3,4)=9.
         TABCOF(4,4)=0.
      ELSEIF (TYPE.EQ.200) THEN
*     Coefficients de P(3)=-2X**3+3X**2 (d.l. # 1 val. nodale en 1.)
         TABCOF(1,1)=-2.
         TABCOF(2,1)=3.
         TABCOF(3,1)=0.
         TABCOF(4,1)=0.
*     Coefficients de P(4)=X**3-X**2 (d.l. # 2 derivee 1ere en 1.)
         TABCOF(1,2)=1.
         TABCOF(2,2)=-1.
         TABCOF(3,2)=0.
         TABCOF(4,2)=0.
*        Coefficients de P(1)=2X**3-3X**2+1. (D.L. # 3 val. nodale en 0.)
         TABCOF(1,3)=2.
         TABCOF(2,3)=-3.
         TABCOF(3,3)=0.
         TABCOF(4,3)=1.
*        Coefficients de P(2)=X**3-2X**2+X (d.l. # 4 derivee 1ere en 0.)
         TABCOF(1,4)=1.
         TABCOF(2,4)=-2.
         TABCOF(3,4)=1.
         TABCOF(4,4)=0.
      ELSE
         CALL SEXXCF(TYPE,TABCOF)
      ENDIF
                                                                    END !Segmcf
