*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TE001B (KELFCT,X1,X2,X3,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 mai 2009)
* Version 3
*  
* Fonctions de base et derivees - Tetraedre de Lagrange (ordre 1) a 4 noeuds
*
*                          Arete:   v1 v2 equation  | Face:  v1  v2  v3  equation
*          4                   1:   1  4  y=0,z=0   |    1:  4   3   2   x=0
*          | \                 2:   2  4  x=0,z=0   |    2:  4   1   3   y=0
*         /|   \               3:   3  4  x=0,y=0   |    3:  4   2   1   z=0
*         III    V             4:   2  3  x=0,y+z=1 |    4:  1   2   3   x+y+z=1
*        / |       \           5:   3  1  y=0,x+z=1 | Numero d'aretes par face
*       IV 3----II---2         6:   1  2  z=0,x+z=1 | Face:  e1  e2  e3 
*       /  /       _                                |    1:  3   4   2
*        I     VI                                   |    2:  3   5   1  
*      //   _                                       |    3:  1   6   2  
*      / _                                          |    4:  6   4   5
*     1 
*-- Arguments d'entree -- cf. ElemFB
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT 
      REAL          X1,X2,X3,P(*),DP(3,*)
*
      INTEGER       I,J
*-----------------------------------------------------------------------
*   Fonctions de base  
*  
      IF (KELFCT(1:1).NE.'N') THEN  
         P(1)=X1
         P(2)=X2
         P(3)=X3
         P(4)=1.-(X1+X2+X3)
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
         DO 1 I=1,3
            DO 2 J=1,3 
2              DP(I,J)=0.
            DP(I,4)=-1.
1           DP(I,I)=1. 
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy  
*      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (26 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Te01FB
