*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TE002B (KELFCT,X1,X2,X3,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin & N.Kielbasiewicz (9 juin 2011)
* Version 3
*  
* Fonctions de base et derivees pour le tetraedre de Lagrange P2 a 10 noeuds 
*  
*-- Arguments d'entree -- cf. ElemFb
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT 
      REAL X1,X2,X3,P(*),DP(3,*),DDP(6,*)
*
      REAL X4,QX1,QX2,QX3,QX4,DX1M1,DX2M1,DX3M1,DX4M1,QX4M1 
*------------------------------------------------------------------------
      X4=1.-X1-X2-X3
      QX1=4*X1
      QX2=4*X2
      QX3=4*X3
*  
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         DX1M1 = X1+X1-1.
         DX2M1 = X2+X2-1.
         DX3M1 = X3+X3-1.
         DX4M1 = X4+X4-1.
         P(1) = X1*(X1+X1-1.) 
         P(2) = X2*(X2+X2-1.)
         P(3) = X3*(X3+X3-1.)
         P(4) = X4*(X4+X4-1.)
         P(5) = QX1*X4
         P(6) = QX2*X4
         P(7) = QX3*X4
         P(8) = QX2*X3
         P(9) = QX1*X3
         P(10)= QX1*X2
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN 
         QX4 = 4*X4
         QX4M1 = QX4-1.
         DP(1,1) = QX1-1.
         DP(2,1) = 0.
         DP(3,1) = 0.
         DP(1,2) = 0.
         DP(2,2) = QX2-1.
         DP(3,2) = 0.
         DP(1,3) = 0.
         DP(2,3) = 0.
         DP(3,3) = QX3-1.
         DP(1,4) = -QX4M1
         DP(2,4) = -QX4M1
         DP(3,4) = -QX4M1
         DP(1,5) = QX4-QX1
         DP(2,5) = -QX1
         DP(3,5) = -QX1
         DP(1,6) = -QX2
         DP(2,6) = QX4-QX2
         DP(3,6) = -QX2
         DP(1,7) = -QX3 
         DP(2,7) = -QX3 
         DP(3,7) = QX4-QX3 
         DP(1,8) = 0.  
         DP(2,8) = QX3  
         DP(3,8) = QX2  
         DP(1,9) = QX3  
         DP(2,9) = 0.  
         DP(3,9) = QX1  
         DP(1,10)= QX2
         DP(2,10)= QX1
         DP(3,10)= 0.
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*          DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dz2  
*          DDP(4,.) = d2P/dydz , DDP(5,.) = d2P/dxdz , DDP(6,.) = d2P/dxdy  
*      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin & N.Kielbasiewicz (9 juin 2011)
* - bugs variables QX3 (on avait QX3=4*X4 !) and QX4 (was QX4=4*QX4)
* Version 2 : D.Martin (26 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Te02FB
