*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TELKAR (K,NUARET,NUTYAR,NBNEAR,NUNEAR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*  
* Numerotation locale des noeuds d'une arete de l'element de reference 
* Tetraedre de Lagrange d'ordre k a (k+1)(k+2)(k+3)/6 noeuds
*
*-- Arguments --
* K      pour tetradre de type k
* NUARET numero de l'arete
* NUTYAR numero de type de l'arete (numero de type de l'element 1d associe)
* NBNEAR nombre de noeuds de l'arete
* NUNEAR tableau des numeros locaux des noeuds de l'arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  K,NUARET,NUTYAR,NBNEAR,NUNEAR(*),LAGDMX, NTYPFO
      PARAMETER ( LAGDMX = 100, NTYPFO = 1000)
*-----------------------------------------------------------------------
      IF (NUARET.EQ.1) THEN
         NUNEAR(1)=4 
         NUNEAR(2)=1
         IF (K.EQ.2) THEN
            NUNEAR(3)=5
         ENDIF
      ELSEIF (NUARET.EQ.2) THEN
         NUNEAR(1)=2 
         NUNEAR(2)=4
         IF (K.EQ.2) THEN
            NUNEAR(3)=6
         ENDIF
      ELSEIF (NUARET.EQ.3) THEN
         NUNEAR(1)=4
         NUNEAR(2)=3
         IF (K.EQ.2) THEN
            NUNEAR(3)=7
         ENDIF
      ELSEIF (NUARET.EQ.4) THEN
         NUNEAR(1)=2 
         NUNEAR(2)=3
         IF (K.EQ.2) THEN
            NUNEAR(3)=8
         ENDIF
      ELSEIF (NUARET.EQ.5) THEN
         NUNEAR(1)=1 
         NUNEAR(2)=3
         IF (K.EQ.2) THEN
            NUNEAR(3)=9
         ENDIF
      ELSEIF (NUARET.EQ.6) THEN
         NUNEAR(1)=1 
         NUNEAR(2)=2
         IF (K.EQ.2) THEN
            NUNEAR(3)=10
         ENDIF
      ENDIF
      NUTYAR=10*NTYPFO+K
      NBNEAR=K+1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Telkar
