*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TELKFA (K,NUFACE,NUTYFA,NBNEFA,NUNEFA)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1988)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*
* Numerotation locale des noeuds d'une face de l'element de reference 
* Tetraedre de Lagrange (ordre k) a (k+1)(k+2)(k+3)/6 noeuds
*
* K      pour tetraedre d'ordre k
* NUFACE numero de la face
* NUTYFA numero de type de la face (numero de type de l'elt 2d associe)
* NBNEFA nombre de noeuds de la face
* NUNEFA tableau des numeros locaux des noeuds de la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER K,NUFACE,NUTYFA,NBNEFA,NUNEFA(*)
*
      INTEGER NTYPFO
      PARAMETER (NTYPFO = 1000)
*------------------------------------------------------------------------
      IF (NUFACE.EQ.1) THEN
         NUNEFA(1) = 2
         NUNEFA(2) = 4
         NUNEFA(3) = 3
         IF (K.EQ.2) THEN
            NUNEFA(4) = 6
            NUNEFA(5) = 7
            NUNEFA(6) = 8
         ENDIF
      ELSEIF (NUFACE.EQ.2) THEN
         NUNEFA(1) = 4  
         NUNEFA(2) = 1  
         NUNEFA(3) = 3
         IF (K.EQ.2) THEN
            NUNEFA(4) = 5
            NUNEFA(5) = 9
            NUNEFA(6) = 7
         ENDIF
      ELSEIF (NUFACE.EQ.3) THEN
         NUNEFA(1) = 1  
         NUNEFA(2) = 4  
         NUNEFA(3) = 2
         IF (K.EQ.2) THEN
            NUNEFA(4) = 5
            NUNEFA(5) = 6
            NUNEFA(6) = 10
         ENDIF
      ELSEIF (NUFACE.EQ.4) THEN
         NUNEFA(1) = 1
         NUNEFA(2) = 2
         NUNEFA(3) = 3
         IF (K.EQ.2) THEN
            NUNEFA(4) = 10
            NUNEFA(5) = 8
            NUNEFA(6) = 9
         ENDIF
      ENDIF
      NUTYFA = 21*NTYPFO+K
      NBNEFA = ((K+1)*(K+2))/2
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Telkfa
