*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TELKP1 (K,NBLMP1,NUPOP1)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 2004)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*
* Construction des tableaux de correspondance des numerotations locales
* entre elements tetraedriques Pk et elements tetraedriques P1.
* Le tetraedre Pk est decoupe en k^3 tetraedres P1 par exemple, 
* le tetraedre P2 est decoupe en 8 tetraedres P1
*
*-- Argument d'entree --
* K      pour un tetraedre de degre k
*-- Arguments de sortie --
* NBLMP1 nombre de tetraedres P1
* NUPOP1 tableau de correspondance entre tetraedres P1 et tetraedre Pk
*        NUPOP1 (s,t) = numero dans le tetraedre Pk du sommet s du tetraedre t
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,NBLMP1,NUPOP1(4,*)
*
      INTEGER NK
*-----------------------------------------------------------------------
      NBLMP1=0
      NK=K
*
      IF (NK.EQ.1) THEN 
*
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1 
         NUPOP1(2,NBLMP1) = 2 
         NUPOP1(3,NBLMP1) = 3 
         NUPOP1(4,NBLMP1) = 4 
*
      ELSEIF (NK.EQ.2) THEN
* tetraedres externes :4 
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 1
         NUPOP1(2,NBLMP1) = 10
         NUPOP1(3,NBLMP1) = 5 
         NUPOP1(4,NBLMP1) = 9 
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 8 
         NUPOP1(2,NBLMP1) = 10 
         NUPOP1(3,NBLMP1) = 2 
         NUPOP1(4,NBLMP1) = 6
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 5 
         NUPOP1(2,NBLMP1) = 6 
         NUPOP1(3,NBLMP1) = 4 
         NUPOP1(4,NBLMP1) = 7 
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9 
         NUPOP1(2,NBLMP1) = 8
         NUPOP1(3,NBLMP1) = 7 
         NUPOP1(4,NBLMP1) = 3 
* tetraedres internes :4   
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 5 
         NUPOP1(2,NBLMP1) = 9
         NUPOP1(3,NBLMP1) = 8 
         NUPOP1(4,NBLMP1) = 7      
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 5
         NUPOP1(2,NBLMP1) = 10
         NUPOP1(3,NBLMP1) = 6
         NUPOP1(4,NBLMP1) = 9     
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9  
         NUPOP1(2,NBLMP1) = 6 
         NUPOP1(3,NBLMP1) = 8 
         NUPOP1(4,NBLMP1) = 10      
         NBLMP1=NBLMP1+1
         NUPOP1(1,NBLMP1) = 9 
         NUPOP1(2,NBLMP1) = 8 
         NUPOP1(3,NBLMP1) = 6 
         NUPOP1(4,NBLMP1) = 7 
      ELSE
         CALL ERELEM (15,'*Telkp1*',K) 
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      END
