*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TETRQF (NUFACE,NBPTQ,POIDQ2,COORQ2,POIDQ3,COORQ3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*
* Formule de quadrature sur une face du tetraedre de reference 
* construite a partir d'une formule de quadrature sur le triangle.
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUFACE numero de la face de l'element
* NBPTQ  nombre de points de la formule de quadrature sur le triangle
* POIDQ2 poids de la formule de quadrature sur le triangle
* COORQ2 coordonnees des points de la formule de quadrature sur le triangle
* POIDQ3 poids de la formule de quadrature sur la face du tetraedre
* COORQ3 coordonnees des points de la formule de quadrature sur la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE,NBPTQ
      REAL    POIDQ2(*),COORQ2(2,*),POIDQ3(*),COORQ3(3,*)
*
      INTEGER I
      REAL    SQRT3
*-----------------------------------------------------------------------
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x1=0.
         DO 3101 I=1,NBPTQ
            COORQ3(1,I) = 0.
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = COORQ2(1,I)
            POIDQ3(I)   = POIDQ2(I)
3101     CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x2=0.
         DO 3102 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = 0.
            COORQ3(3,I) = COORQ2(2,I)
            POIDQ3(I)   = POIDQ2(I)
3102     CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 3 : plan x3=0.
         DO 3103 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 0.
            POIDQ3(I)   = POIDQ2(I)
3103     CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x1+x2+x3=1.
         SQRT3 = SQRT (3.)
         DO 3104 I=1,NBPTQ
            COORQ3(1,I) = COORQ2(1,I)
            COORQ3(2,I) = COORQ2(2,I)
            COORQ3(3,I) = 1.-(COORQ2(1,I)+COORQ2(2,I))
            POIDQ3(I)   = SQRT3*POIDQ2(I)
3104     CONTINUE
      ELSE
         CALL ERELEM (6,'TetrQf',NUFACE)                                !Utilite
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !TetrQf
