*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TETRTA (NUARET,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*
* Projection du vecteur tangent sur une arete d'un tetraedre
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUARET numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteur tangent sur l'arete courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUARET
      REAL    JACOBF(3,*),JACOBT(3)
*
      INTEGER I,DIM
      REAL    USQRT2
*-----------------------------------------------------------------------
      DIM=3
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x2=0.,x3=0.
         DO 3001 I=1,DIM
            JACOBT(I)=JACOBF(I,1)
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x1=0.,x3=0.
         DO 3002 I=1,DIM
            JACOBT(I)=JACOBF(I,2)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x1=0.,x2=0.
         DO 3003 I=1,DIM
            JACOBT(I)=JACOBF(I,3)
3003     CONTINUE
      ELSEIF (NUARET.EQ.4) THEN
*        Arete 4 : droite x1=0.,x2+x3=1.
         USQRT2=SQRT(2.)/2.
         DO 3004 I=1,DIM
            JACOBT(I)=USQRT2*(JACOBF(I,3)-JACOBF(I,2))
3004     CONTINUE
      ELSEIF (NUARET.EQ.5) THEN
*        Aretes 5 : droites x1+x3=1.,x2=0.
          USQRT2=SQRT(2.)/2.
         DO 3005 I=1,DIM
            JACOBT(I)=USQRT2*(JACOBF(I,3)-JACOBF(I,1))
3005     CONTINUE
      ELSEIF (NUARET.EQ.6) THEN
*        Arete 6 : droite x1+x2=1.,x3=0.
         USQRT2=SQRT(2.)/2.
         DO 3006 I=1,DIM
            JACOBT(I)=USQRT2*(JACOBF(I,2)-JACOBF(I,1))
3006     CONTINUE
      ELSE
         CALL ERELEM (5,'TetrTa',NUARET)                                !Utilite
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                                                                    END !TetrTa
