*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TETRTF (NUFACE,JACOBF,JACOBT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (28 mai 2009)
* Version 2
*
* Projection des vecteurs tangents sur une face d'un tetraedre
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUFACE numero de la face de l'element
* JACOBF matrice jacobienne
* JACOBT vecteurs tangents sur la face courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUFACE
      REAL    JACOBF(3,*),JACOBT(3,*)
*
      INTEGER I,DIM
      REAL    USQRT2,USQRT3
*-----------------------------------------------------------------------
      DIM=3
      IF (NUFACE.EQ.1) THEN
*        Face 1 : plan x1=0.
         DO 3001 I=1,DIM
            JACOBT(I,1)=JACOBF(I,3)
            JACOBT(I,2)=JACOBF(I,2)
3001     CONTINUE
      ELSEIF (NUFACE.EQ.2) THEN
*        Face 2 : plan x2=0.
         DO 3002 I=1,DIM
            JACOBT(I,1)=JACOBF(I,1)
            JACOBT(I,2)=JACOBF(I,3)
3002     CONTINUE
      ELSEIF (NUFACE.EQ.3) THEN
*        Face 3 : plan x3=0.
         DO 3003 I=1,DIM
            JACOBT(I,1)=JACOBF(I,2)
            JACOBT(I,2)=JACOBF(I,1)
3003     CONTINUE
      ELSEIF (NUFACE.EQ.4) THEN
*        Face 4 : plan x1+x2+x3=1.
         USQRT2=SQRT (2.)/2.
         USQRT3=SQRT (2./3.)
         DO 3004 I=1,DIM
            JACOBT(I,1)= USQRT2*(JACOBF(I,2)-JACOBF(I,1))
            JACOBT(I,2)= USQRT3*(JACOBF(I,3)
     &                  - ((JACOBF(I,2)+JACOBF(I,1))/2.))
3004     CONTINUE
      ELSE
         CALL ERELEM (6,'TetrTf',NUFACE)                                !Utilite
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (28 mai 2009)
* - changement de la numerotation locale des tetraedres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !TetrTf
