*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR002B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees - Triangle de Lagrange (ordre 2) a 6 noeuds
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2  coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)
*
      DOUBLE PRECISION DZ1,DZ2,DZ3,DZ4,DZ6,KX1,KX2,KX6
*-----------------------------------------------------------------------
      DZ1=DBLE(X1)
      DZ2=DBLE(X2)
      DZ3=DZ1-0.5
      DZ4=DZ2-0.5
      DZ6=DZ3+DZ4
      KX1=DZ1+DZ1
      KX2=DZ2+DZ2
      KX6=DZ6+DZ6
*  
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         P(1)= KX1*DZ3
         P(2)= KX2*DZ4
         P(3)= DZ6*(KX6+1)
         P(4)= KX1*KX2
         P(5)=-KX2*KX6
         P(6)=-KX1*KX6
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
         DP(1,1)= KX1+KX1-1.
         DP(2,1)= 0.
         DP(1,2)= 0.
         DP(2,2)= KX2+KX2-1.
         DP(1,3)= DZ1+DZ4+DZ6
         DP(1,3)= DP(1,3)+DP(1,3)
         DP(1,4)= KX2+KX2
         DP(1,5)=-DP(1,4)  
         DP(1,6)=-4*(DZ1+DZ6)
         DP(2,3)= DP(1,3)
         DP(2,4)= KX1+KX1
         DP(2,5)=-4*(DZ2+DZ6)
         DP(2,6)=-DP(2,4)  
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*      DDP(1,.) = d2P/dxdx  , DDP(2,.) = d2P/dydy  , DDP(3,.) = d2P/dxdy
*      IF (KELFCT(3:3).NE.'N') THEN 
*         DO 1 I=1,3
*            DO 2 J=1,6
*2              DDP(I,J)=0.
*            DDP(I,I)=4.
*1           DDP(I,3)=4.
*         DDP(1,6)=-8. 
*         DDP(2,5)=-8. 
*         DDP(3,4)=4.  
*         DDP(3,5)=-4. 
*         DDP(3,6)=-4. 
*      ENDIF  
                                                                    END !Tr002b
