*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR003B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : G.Vial (Janvier 2000)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees - Triangle de Lagrange (ordre 3) a 10 noeuds
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees 1eres des fonctions de base
*        si KELFCT(3:3).NE.'N' Calcul des derivees 2ndes des fonctions de base
* X1,X2  coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions de base au point X1,X2
* DP        -       -            -     -  derivees 1eres
* DDP       -       -            -     -  derivees 2ndes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)
*
      DOUBLE PRECISION DZ1,DZ2,DZ3,KX1M1,XKX1M1,KX2M1,XKX2M1,KX3M1
     &                ,XKX3M1,DEMI,N9DEMI,V7DEMI
*-----------------------------------------------------------------------
      DZ1=X1
      DZ2=X2
      DZ3=1.-DZ1-DZ2
      KX1M1=3*DZ1-1
      XKX1M1=DZ1*KX1M1
      KX2M1=3*DZ2-1
      XKX2M1=DZ2*KX2M1
      KX3M1=3*DZ3-1
      XKX3M1=DZ3*KX3M1
      DEMI=1./2
      N9DEMI=9*DEMI
      V7DEMI=27*DEMI
*
*   Fonctions de base
*
      IF (KELFCT(1:1).NE.'N') THEN
         P(1) = DEMI*XKX1M1*(KX1M1-1.)
         P(2) = DEMI*XKX2M1*(KX2M1-1.)
         P(3) = DEMI*XKX3M1*(KX3M1-1.)
         P(4) = N9DEMI*XKX1M1*DZ2
         P(5) = N9DEMI*XKX2M1*DZ3
         P(6) = N9DEMI*XKX3M1*DZ1
         P(7) = N9DEMI*XKX2M1*DZ1
         P(8) = N9DEMI*XKX3M1*DZ2
         P(9) = N9DEMI*XKX1M1*DZ3
         P(10)= 27*DZ1*DZ2*DZ3
      ENDIF
*
*   Derivees premieres
*
      IF (KELFCT(2:2).NE.'N') THEN
         DP(1,1) = 1+(V7DEMI*DZ1-9.)*DZ1
         DP(2,1) = 0.
         DP(1,2) = 0.
         DP(2,2) = 1+(V7DEMI*DZ2-9.)*DZ2
         DP(1,3) =-1-(V7DEMI*DZ3-9.)*DZ3
         DP(2,3) = DP(1,3)
         DP(1,4) =(27*DZ1-N9DEMI)*DZ2
         DP(2,4) = N9DEMI*XKX1M1
         DP(1,5) =-N9DEMI*XKX2M1
         DP(2,5) = N9DEMI*((DZ3-DZ2)*KX2M1+3*DZ2*DZ3)
         DP(1,6) = N9DEMI*((DZ3-DZ1)*KX3M1-3*DZ1*DZ3)
         DP(2,6) =(N9DEMI-27*DZ3)*DZ1
         DP(1,7) = N9DEMI*XKX2M1
         DP(2,7) =(27*DZ2-N9DEMI)*DZ1
         DP(1,8) =(N9DEMI-27*DZ3)*DZ2
         DP(2,8) = N9DEMI*((DZ3-DZ2)*KX3M1-3*DZ2*DZ3)
         DP(1,9) = N9DEMI*((DZ3-DZ1)*KX1M1+3*DZ1*DZ3)
         DP(2,9) =-N9DEMI*XKX1M1
         DP(1,10)= 27*DZ2*(DZ3-DZ1)
         DP(2,10)= 27*DZ1*(DZ3-DZ2)
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*      DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dxdy

*      ENDIF  
                                                                    END !Tr003b
