*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR004B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : P.Carcaud, magistere 2eme annee (Juillet 2005)
* Derniere modification : D.Martin (3 octobre 2005)
* Version 0
*  
* Fonctions de base et derivees - Triangle de Lagrange (ordre 4) a 15 noeuds
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 : Coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)
      DOUBLE PRECISION T1,T3,T4,T7,T9,T10,T11,T12,T18,T19,T20,T21
     &                ,T22,T23,T27,T28,T29,T30,T32,T33,T34,T38,T39,T41
     &                ,T42,T43,T49,T50,T67,T80,T84,T94,T110,T111
     &                ,T116,T121,T126,T128,DZ1,DZ2,DZ3,HUITS3
*-----------------------------------------------------------------------
      DZ1 = DBLE(X1)
      DZ2 = DBLE(X2)
      DZ3 = 1-DZ1-DZ2
      HUITS3 = 8.D0/3.D0
*
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         T1 = 4*DZ1
         T3 = DZ1*(T1-1)
         T4 = T1-2
         T9 = 4*DZ2
         T10 = T9-1
         T11 = DZ2*T10
         T12 = T9-2
         T18 = 3-T1-T9
         T19 = 4*DZ3*T18
         T20 = 2-T1-T9
         T32 = T18*T20
         T39 = DZ1*DZ2
         T43 = 4*DZ2*DZ3
         P(1) = T3*T4*(T1-3)/6
         P(2) = T11*T12*(-3+T9)/6
         P(3) = T19*T20*(1-T1-T9)/24
         P(4) = HUITS3*T3*T4*DZ2
         P(5) = HUITS3*T11*T12*DZ3
         P(6) = HUITS3*DZ1*DZ3*T32
         P(7) = 4*T3*T11
         P(8) = T11*T19
         P(9) = T3*T19
         P(10) = HUITS3*T39*T10*T12
         P(11) = 2.D0/3.D0*T43*T32
         P(12) = HUITS3*T3*T4*DZ3
         P(13) = 8*T3*T43
         P(14) = 32*T39*T10*DZ3
         P(15) = 8*T39*T19
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
         T1 = 128.D0/3.D0*DZ1
         T7 = 128.D0/3.D0*DZ2
         T12 = 128*DZ2
         T19 = -25.D0/3.D0+(140.D0/3.D0+(-80+T7)*DZ2)*DZ2
     &       +(140.D0/3.D0+(-160+T12)*DZ2+(-80+T12+T1)*DZ1)*DZ1
         T20 = 16.D0/3.D0*DZ2
         T21 = 64*DZ2
         T22 = DZ1*DZ2
         T23 = 128*T22
         T27 = 4*DZ2
         T28 = T27-1
         T29 = DZ2*T28
         T30 = T27-2
         T32 = HUITS3*T29*T30
         T33 = 1-DZ2
         T34 = 3-T27
         T38 = 256*DZ2
         T39 = 384-T38
         T41 = 384*DZ2
         T42 = 512.D0/3.D0*DZ1
         T49 = T22*T28
         T50 = 32*T49
         T67 = (192-T12)*DZ2
         T80 = 4*DZ2*T33
         T84 = 384*T22
         T94 = 512*DZ2
         T110 = HUITS3*DZ1*(4*DZ1-1)*(4*DZ1-2)
         T111 = 512.D0/3.D0*DZ2
         T116 = 64-T12
         T121 = 128*DZ1
         T126 = 32*DZ2
         T128 = (T12-16)*DZ1
         DP(1,1) = -1+(44.D0/3.D0+(-48+T1)*DZ1)*DZ1
         DP(1,2) = 0
         DP(1,3) = T19
         DP(1,4) = T20+(-T21+T23)*DZ1
         DP(1,5) = -T32
         DP(1,6) = -HUITS3*T33*T34*T30+(-416.D0/3.D0+T39*DZ2
     &           + (288-T41-T42)*DZ1)*DZ1
         DP(1,7) = -4*T29+T50
         DP(1,8) = (28+(-144+T12)*DZ2)*DZ2+T50
         DP(1,9) = -4*T33*T34+(152+(-288+T12)*DZ2+(-384+T41+256*DZ1)
     &             *DZ1)*DZ1
         DP(1,10) = T32
         DP(1,11) = (-208.D0/3.D0+T67)*DZ2+((192-T38)*DZ2-T23)*DZ1
         DP(1,12) = 16.D0/3.D0-T20+(-224.D0/3.D0+T21+(224-T12-T42)
     &              *DZ1)*DZ1
         DP(1,13) = -8*T80+((320-T38)*DZ2-T84)*DZ1
         DP(1,14) = 32*T29*T33-64*T49
         DP(1,15) = 8*T80*T34+((-448+T94)*DZ2+T84)*DZ1
         DP(2,1) = 0
         DP(2,2) = -1+(44.D0/3.D0+(-48+T7)*DZ2)*DZ2
         DP(2,3) = T19
         DP(2,4) = T110
         DP(2,5) = 16.D0/3.D0+(-224.D0/3.D0+(224-T111)*DZ2)*DZ2
     &           + (-16.D0/3.D0+T116*DZ2)*DZ1
         DP(2,6) = (-208.D0/3.D0+T67+(192-T38-T121)*DZ1)*DZ1
         DP(2,7) = (4-T126+T128)*DZ1
         DP(2,8) = -12+(152-T39*DZ2)*DZ2+(28+(-288+T41)*DZ2+T128)*DZ1
         DP(2,9) = (28-T126+(-144+T12+T121)*DZ1)*DZ1
         DP(2,10) = (16.D0/3.D0-T116*DZ2)*DZ1
         DP(2,11) = 16+(-416.D0/3.D0+(288-T111)*DZ2)*DZ2
     &            + (-208.D0/3.D0+384*DZ2*T33+(96-T38-T1)*DZ1)*DZ1
         DP(2,12) = -T110
         DP(2,13) = (-32+T21+(160-T38-T121)*DZ1)*DZ1
         DP(2,14) = (-32+(320-T41)*DZ2+(-T38+32)*DZ1)*DZ1
         DP(2,15) = (96+(-448+T41)*DZ2+(T94-224+T121)*DZ1)*DZ1
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*      DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dxdy 

*      ENDIF  
                                                                    END !Tr004b
