*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR005B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : Pierre Carcaud, magistere 2eme annee (Juillet 2005)
* Derniere modification : D.Martin (30 septembre 2005)
* Version 0
*  
* Fonctions de base et derivees - Triangle de Lagrange (ordre 5) a 21 noeuds
*
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 : Coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)
      DOUBLE PRECISION T1,T3,T4,T6,T9,T11,T12,T13,T14,T15,T16,T21,T22
     &                ,T23,T24,T25,T30,T31,T32,T33,T34,T35,T39,T41,T42
     &                ,T43,T44,T45,T46,T48,T49,T50,T51,T54,T59,T62,T63
     &                ,T67,T73,T74,T85,T86,T97,T98,T123,T138,T141,T142
     &                ,T143,T160,T162,T167,T185,T198,T231,T238,T239
     &                ,T246,T253,T260,T261,T267,T281,T285,T290,T340,T381
     &                ,DZ1,DZ2,DZ3,KDZ1,KDZ2
*-----------------------------------------------------------------------
      DZ1 = DBLE(X1)
      DZ2 = DBLE(X2)
      DZ3 = 1-DZ1-DZ2
*  
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         T1 = 5*DZ1
         T3 = DZ1*(T1-1)
         T4 = T1-2
         T6 = T4*(T1-3)
         T11 = 5*DZ2
         T12 = T11-1
         T13 = DZ2*T12
         T14 = T11-2
         T15 = T11-3
         T16 = T14*T15
         T22 = 4-T1-T11
         T23 = 5*DZ3*T22
         T24 = 3-T1-T11
         T25 = 2-T1-T11
         T39 = T22*T24*T25
         T42 = T4*DZ2
         T50 = T23*T24
         T62 = DZ1*DZ2
         T63 = T12*T14
         T67 = 5*DZ2*DZ3
         P(1) = T3*T6*(T1-4)/24
         P(2) = T13*T16*(T11-4)/24
         P(3) = T23*T24*T25*(1-T1-T11)/120
         P(4) = 25.D0/24.D0*T3*T6*DZ2
         P(5) = 25.D0/24.D0*T13*T16*DZ3
         P(6) = 25.D0/24.D0*DZ1*DZ3*T39
         P(7) = 25.D0/12.D0*T3*T42*T12
         P(8) = 25.D0/12.D0*T13*T14*DZ3*T22
         P(9) = 5.D0/12.D0*T3*T50
         P(10) = 25.D0/12.D0*T3*T13*T14
         P(11) = 5.D0/12.D0*T13*T50
         P(12) = 25.D0/12.D0*T3*T4*DZ3*T22
         P(13) = 25.D0/24.D0*T62*T63*T15
         P(14) = 5.D0/24.D0*T67*T39
         P(15) = 25.D0/24.D0*T3*T6*DZ3
         P(16) = 125.D0/6.D0*T3*T42*DZ3
         P(17) = 125.D0/6.D0*T62*T63*DZ3
         P(18) = 25.D0/6.D0*T62*T50
         P(19) = 125.D0/4.D0*T3*T13*DZ3
         P(20) = 125.D0/4.D0*T62*T12*DZ3*T22
         P(21) = 25.D0/4.D0*T3*T67*T22
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
      T1 = 3125.D0/24*DZ1
      T9 = 3125.D0/24*DZ2
      T16 = 3125.D0/6*DZ2
      T21 = 3125.D0/4*DZ2
      T30 = -137.D0/12+(375.D0/4+(-2125.D0/8+(625.D0/2-T9)*DZ2)*DZ2)
     &*DZ2+(375.D0/4+(-2125.D0/4+(1875.D0/2-T16)*DZ2)*DZ2
     &+(-2125.D0/8+(1875.D0/2-T21)*DZ2+(625.D0/2-T16-T1)*DZ1)*DZ1)*DZ1
      T31 = 25.D0/4.D0*DZ2
      T32 = 1375.D0/12.D0*DZ2
      T33 = 1875.D0/4.D0*DZ2
      T34 = DZ1*DZ2
      T35 = 3125.D0/6.D0*T34
      T41 = 5*DZ2
      T42 = T41-1
      T43 = DZ2*T42
      T44 = T41-2
      T45 = T41-3
      T46 = T44*T45
      T48 = 25.D0/24.D0*T43*T46
      T49 = 1-DZ2
      T50 = 4-T41
      T51 = 5*T49*T50
      T54 = 3125.D0/3.D0*DZ2
      T59 = 9375.D0/4.D0*DZ2
      T62 = 6250.D0/3.D0*DZ2
      T63 = 15625.D0/24.D0*DZ1
      T73 = T34*T42
      T74 = 625.D0/4.D0*T73
      T85 = T34*T42*T44
      T86 = 125.D0/6.D0*T85
      T97 = 3125*DZ2
      T98 = 15625.D0/12.D0*DZ1
      T123 = 625.D0/2.D0*DZ2
      T138 = (8875.D0/12.D0+(-4375.D0/4.D0+T16)*DZ2)*DZ2
      T141 = 3125.D0/2.D0*DZ2
      T142 = -4375.D0/2.D0+T141
      T143 = T142*DZ2
      T160 = 5*T49*DZ2
      T162 = 625*DZ2
      T167 = 6250.D0/3.D0*T34
      T185 = 9375.D0/2.D0*DZ2
      T198 = 1875.D0/4.D0*T73
      T231 = 5*DZ1
      T238 = 25.D0/24.D0*DZ1*(T231-1)*(T231-2)*(T231-3)
      T239 = 15625.D0/24.D0*DZ2
      T246 = 1875.D0/4.D0-T16
      T253 = 3125.D0/6.D0*DZ1
      T260 = 125.D0/3.D0*DZ2
      T261 = T16-625.D0/12.D0
      T267 = 15625.D0/12.D0*DZ2
      T281 = (125.D0/6.D0+(-625.D0/2.D0+T21)*DZ2)*DZ1
      T285 = 625.D0/4.D0*DZ2
      T290 = 3125.D0/4.D0*DZ1
      T340 = -4375.D0/2.D0+T59
      T381 = -T141+625.D0/4.D0
      DP(1,1) = 1+(-125.D0/6.D0+(875.D0/8.D0+(-625.D0/3.D0+T1)
     &*DZ1)*DZ1)*DZ1
      DP(1,2) = 0
      DP(1,3) = T30
      DP(1,4) = -T31+(T32+(-T33+T35)*DZ1)*DZ1
      DP(1,5) = -T48
      DP(1,6) = 5.D0/24.D0*T51*T46+(-1925.D0/6.D0+(8875.D0/6.D0
     &+(-4375.D0/2.D0+T54)*DZ2)*DZ2+(8875.D0/8.D0+(-13125.D0/4.D0+T59)
     &*DZ2+(-4375.D0/3.D0+T62+T63)*DZ1)*DZ1)*DZ1
      DP(1,7) = 25.D0/6.D0*T43+(-125.D0/2.D0*T43+T74)*DZ1
      DP(1,8) = (-75.D0/2.D0+(3875.D0/12.D0+(-3125.D0/4.D0+T16)
     &*DZ2)*DZ2)*DZ2+T86
      DP(1,9) = 25.D0/12.D0*T49*T50*T45+(2675.D0/6.D0+(-8875.D0/6.D0
     &+(3125.D0/2.D0-T16)*DZ2)*DZ2+(-7375.D0/4.D0+(16875.D0/4.D0-T59)
     &*DZ2+(8125.D0/3.D0-T97-T98)*DZ1)*DZ1)*DZ1
      DP(1,10) = -25.D0/12.D0*T43*T44+T86
      DP(1,11) = (1175.D0/12.D0+(-8875.D0/12.D0+(5625.D0/4.D0-T21)
     #*DZ2)*DZ2)*DZ2+((-250+3125.D0/2.D0*T49*DZ2)*DZ2-T74)*DZ1
      DP(1,12) = 25.D0/6.D0*T49*T50+(-325+(3875.D0/6.D0-T123)*DZ2
     #+(6125.D0/4.D0+(-9375.D0/4.D0+T21)*DZ2+(-2500+T62+T98)*DZ1)*DZ1)
     &*DZ1
      DP(1,13) = T48
      DP(1,14) = (-1925.D0/12.D0+T138)*DZ2+((8875.D0/12.D0+T143)
     #*DZ2+((-4375.D0/4.D0+T141)*DZ2+T35)*DZ1)*DZ1
      DP(1,15) = -25.D0/4.D0+T31+(1525.D0/12.D0-T32+(-5125.D0/8.D0
     #+T33+(6875.D0/6.D0-T16-T63)*DZ1)*DZ1)*DZ1
      DP(1,16) = 25.D0/3.D0*T160+((-2125.D0/3.D0+T162)*DZ2
     #+((2500-T141)*DZ2-T167)*DZ1)*DZ1
      DP(1,17) = 125.D0/6.D0*T43*T44*T49-125.D0/3.D0*T85
      DP(1,18) = -25.D0/6.D0*T160*T50*T45+((-5875.D0/3.D0+(5000-T97)
     #*DZ2)*DZ2+((3750-T185)*DZ2-T167)*DZ1)*DZ1
      DP(1,19) = -125.D0/4.D0*T43*T49+((-375-T142*DZ2)*DZ2-T198)*DZ1
      DP(1,20) = 25.D0/4.D0*T43*T51+((1125.D0/2.D0+(-6875.D0/2.D0+T97)
     #*DZ2)*DZ2+T198)*DZ1
      DP(1,21) = -25.D0/4.D0*T160*T50+((3625.D0/2.D0+(-6875.D0/2.D0
     #+T141)*DZ2)*DZ2+(-9375.D0/2.D0*T49*DZ2+3125*T34)*DZ1)*DZ1
      DP(2,1) = 0
      DP(2,2) = 1+(-125.D0/6.D0+(875.D0/8.D0+(-625.D0/3.D0+T9)
     #*DZ2)*DZ2)*DZ2
      DP(2,3) = T30
      DP(2,4) = T238
      DP(2,5) = -25.D0/4.D0+(1525.D0/12.D0+(-5125.D0/8.D0+(6875.D0/6.D0
     #-T239)*DZ2)*DZ2)*DZ2+(25.D0/4.D0+(-1375.D0/12.D0+T246*DZ2)*DZ2)
     &*DZ1
      DP(2,6) = (-1925.D0/12.D0+T138+(8875.D0/12.D0+T143+(-4375.D0/4.D0
     #+T141+T253)*DZ1)*DZ1)*DZ1
      DP(2,7) = (T260-25.D0/6.D0+(-T123+125.D0/4.D0+T261*DZ1)*DZ1)*DZ1
      DP(2,8) = 50.D0/3.D0+(-325+(6125.D0/4.D0+(-2500+T267)*DZ2)*DZ2)
     #*DZ2+(-75.D0/2.D0+(3875.D0/6.D0+(-9375.D0/4.D0+T62)*DZ2)*DZ2
     &+T281)*DZ1
      DP(2,9) = (1175.D0/12.D0+(-250+T285)*DZ2+(-8875.D0/12.D0
     #+(3125.D0/2.D0-T21)*DZ2+(5625.D0/4.D0-T141-T290)*DZ1)*DZ1)*DZ1
      DP(2,10) = (-25.D0/6.D0+(125.D0/2.D0-T285)*DZ2+T281)*DZ1
      DP(2,11) = -25+(2675.D0/6.D0+(-7375.D0/4.D0+(8125.D0/3.D0-T267)
     #*DZ2)*DZ2)*DZ2+(1175.D0/12.D0+(-8875.D0/6.D0+(16875.D0/4.D0-T97)
     #*DZ2)*DZ2+(-125+(3125.D0/2.D0-T59)*DZ2-T261*DZ1)*DZ1)*DZ1
      DP(2,12) = (-75.D0/2.D0+T260+(3875.D0/12.D0-T123+(-3125.D0/4.D0
     #+T16+T253)*DZ1)*DZ1)*DZ1
      DP(2,13) = (-25.D0/4.D0+(1375.D0/12.D0-T246*DZ2)*DZ2)*DZ1
      DP(2,14) = 25+(-1925.D0/6.D0+(8875.D0/8.D0+(-4375.D0/3.D0+T239)
     #*DZ2)*DZ2)*DZ2+(-1925.D0/12.D0+(8875.D0/6.D0+(-13125.D0/4.D0+T62)
     #*DZ2)*DZ2+(8875.D0/24.D0+T340*DZ2+(T54-4375.D0/12.D0+T1)*DZ1)
     &*DZ1)*DZ1
      DP(2,15) = -T238
      DP(2,16) = (125.D0/3.D0-250.D0/3.D0*DZ2+(-2125.D0/6.D0+T162
     #+(2500.D0/3.D0-T54-T253)*DZ1)*DZ1)*DZ1
      DP(2,17) = (125.D0/3.D0+(-2125.D0/3.D0+(2500-T62)*DZ2)*DZ2
     #+(-125.D0/3.D0+(625-T141)*DZ2)*DZ1)*DZ1
      DP(2,18) = (250+(-5875.D0/3.D0+(3750-T62)*DZ2)*DZ2+(-5875.D0/6.D0
     #+(5000-T185)*DZ2+(1250-T97-T253)*DZ1)*DZ1)*DZ1
      DP(2,19) = (125.D0/4.D0+(-375+T33)*DZ2+(-375.D0/2.D0-T340*DZ2+T381
     #*DZ1)*DZ1)*DZ1
      DP(2,20) = (-125+(3625.D0/2.D0+(-9375.D0/2.D0+T97)*DZ2)*DZ2
     #+(1125.D0/4.D0+(-6875.D0/2.D0+T185)*DZ2-T381*DZ1)*DZ1)*DZ1
      DP(2,21) = (-125+(1125.D0/2.D0-T33)*DZ2+(3625.D0/4.D0
     #+(-6875.D0/2.D0+T59)*DZ2+(-3125.D0/2.D0+T97+T290)*DZ1)*DZ1)*DZ1
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*      DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dxdy 

*      ENDIF  
                                                                    END !Tr005b
