*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR006B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : Pierre Carcaud, magistere 2eme annee (Juillet 2005)
* Derniere modification : D.Martin (30 septembre 2005)
* Version 0
*  
* Fonctions de base et derivees - Triangle de Lagrange (ordre 6) a 28 noeuds
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 : Coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)
      DOUBLE PRECISION T1,T3,T5,T6,T8,T11,T13,T14,T15,T16,T17,T18,T19
     &                ,T20,T25,T26,T27,T28,T29,T30,T31,T42,T43,T44,T45
     &                ,T46,T47,T48,T49,T56,T57,T58,T59,T60,T61,T62,T65
     &                ,T66,T67,T68,T69,T72,T74,T79,T80,T81,T84,T86,T87
     &                ,T88,T101,T102,T116,T118,T119,T134,T137,T138,T148
     &                ,T151,T152,T164,T209,T210,T226,T248,T252,T254
     &                ,T258,T279,T281,T284,T287,T300,T304,T310,T315
     &                ,T334,T340,T350,T366,T369,T451,T460,T461,T470
     &                ,T479,T488,T490,T516,T520,T529,T538,T543,T714,T731
     &                ,DZ1,DZ2,DZ3
*-----------------------------------------------------------------------
      DZ1 = DBLE(X1)
      DZ2 = DBLE(X2)
      DZ3 = 1-DZ1-DZ2
*  
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         T1 = 6*DZ1
         T3 = DZ1*(T1-1)
         T5 = T3*(T1-2)
         T6 = T1-3
         T8 = T6*(T1-4)
         T13 = 6*DZ2
         T14 = T13-1
         T15 = DZ2*T14
         T16 = T13-2
         T17 = T15*T16
         T18 = T13-3
         T19 = T13-4
         T20 = T18*T19
         T25 = 1-DZ1-DZ2
         T26 = 5-T1-T13
         T28 = 4-T1-T13
         T29 = 6*T25*T26*T28
         T30 = 3-T1-T13
         T31 = 2-T1-T13
         T46 = T28*T30*T31
         T49 = T6*DZ2
         T59 = T26*T28*T30
         T67 = T3*DZ2
         T68 = T14*T16
         T72 = 6*T15*T25
         T79 = DZ1*DZ2
         T80 = T79*T14
         T81 = T16*T18
         T86 = 6*DZ2*T25*T26
         P(1) = T5*T8*(T1-5)/120
         P(2) = T17*T20*(T13-5)/120
         P(3) = T29*T30*T31*(1-T1-T13)/720
         P(4) = 3.D0/10.D0*T5*T8*DZ2
         P(5) = 3.D0/10.D0*T17*T20*T25
         P(6) = 3.D0/10.D0*DZ1*T25*T26*T46
         P(7) = 3.D0/4.D0*T5*T49*T14
         P(8) = 3.D0/4.D0*T17*T18*T25*T26
         P(9) = 3.D0/4.D0*T3*T25*T59
         P(10) = T5*T17
         P(11) = T17*T29/6
         P(12) = T5*T29/6
         P(13) = 3.D0/4.D0*T67*T68*T18
         P(14) = T72*T59/8
         P(15) = 3.D0/4.D0*T5*T6*T25*T26
         P(16) = 3.D0/10.D0*T80*T81*T19
         P(17) = T86*T46/20
         P(18) = 3.D0/10.D0*T5*T8*T25
         P(19) = 9*T5*T49*T25
         P(20) = 9*T80*T81*T25
         P(21) = 9*T79*T25*T59
         P(22) = 3*T5*T72
         P(23) = 18*T80*T16*T25*T26
         P(24) = 3*T67*T29
         P(25) = 18*T67*T68*T25
         P(26) = 3*T80*T29
         P(27) = 3*T5*T86
         P(28) = 27*T67*T14*T25*T26
      ENDIF
*
*   Derivee premieres
*
      IF (KELFCT(2:2).NE.'N') THEN
         T1 = 1944.D0/5.D0*DZ1
         T11 = 1944.D0/5.D0*DZ2
         T20 = 1944*DZ2
         T27 = 3888*DZ2
      T42 = -147.D0/10.D0+(812.D0/5.D0+(-1323.D0/2.D0+(1260+(-1134+T11)
     #*DZ2)*DZ2)*DZ2)*DZ2+(812.D0/5.D0+(-1323+(3780+(-4536+T20)*DZ2)
     #*DZ2)*DZ2+(-1323.D0/2.D0+(3780+(-6804+T27)*DZ2)*DZ2
     &+(1260+(-4536+T27)*DZ2+(-1134+T20+T1)*DZ1)*DZ1)*DZ1)*DZ1
         T43 = 36.D0/5.D0*DZ2
         T44 = 180*DZ2
         T45 = 1134*DZ2
         T46 = 2592*DZ2
         T47 = DZ1*DZ2
         T48 = 1944*T47
         T56 = 6*DZ2
         T57 = T56-1
         T58 = DZ2*T57
         T59 = T56-2
         T60 = T56-3
         T61 = T59*T60
         T62 = T56-4
         T65 = 3.D0/10.D0*T58*T61*T62
         T66 = 1-DZ2
         T67 = 5-T56
         T68 = 6*T66*T67
         T69 = T62*T60
         T74 = (10368-T27)*DZ2
         T79 = 11664*DZ2
         T84 = 15552*DZ2
         T87 = 9720*DZ2
         T88 = 11664.D0/5.D0*DZ1
         T101 = T47*T57
         T102 = 648*T101
         T116 = T57*T59
         T118 = T47*T116*T60
         T119 = 9*T118
         T134 = 23328*DZ2
         T137 = 19440*DZ2
         T138 = 5832*DZ1
         T148 = T58*T59
         T151 = T47*T116
         T152 = 108*T151
         T164 = 7776*DZ2
         T209 = -19440+T79
         T210 = T209*DZ2
         T226 = 594*DZ2
         T248 = (2088+(-5022+(5184-T20)*DZ2)*DZ2)*DZ2
         T252 = (15552-T164)*DZ2
         T254 = (-10044+T252)*DZ2
         T258 = (15552-T79)*DZ2
         T279 = 6*DZ2*T66
         T281 = 1188*DZ2
         T284 = 5832*DZ2
         T287 = 9720*T47
         T300 = -T67*T62
         T304 = -34992+T84
         T310 = 34992*DZ2
         T315 = 31104*DZ2
         T334 = 2592*T101
         T340 = 6*T59*T66
         T350 = 324*T151
         T366 = 46656*DZ2
         T369 = 19440*T47
         T451 = 6*DZ1
         T460 = 3.D0/10.D0*DZ1*(T451-1)*(T451-2)*(T451-3)*(T451-4)
         T461 = 11664.D0/5.D0*DZ2
         T470 = 2592-T20
         T479 = 1944*DZ1
         T488 = 54*DZ2
         T490 = (T20-162)*DZ1
         T516 = (-27+(594+(-2916+T27)*DZ2)*DZ2)*DZ1
         T520 = 648*DZ2
         T529 = 3888*DZ1
         T538 = 216*DZ2
         T543 = -1296+T27
         T714 = (-T164+648)*DZ1
         T731 = -3888+T79
      DP(1,1) = -1+(137.D0/5.D0+(-405.D0/2.D0+(612+(-810+T1)*DZ1)*DZ1)
     #*DZ1)*DZ1
         DP(1,2) = 0
         DP(1,3) = T42
         DP(1,4) = T43+(-T44+(T45+(-T46+T48)*DZ1)*DZ1)*DZ1
         DP(1,5) = -T65
      DP(1,6) = -T68*T69*T59/20+(-3132.D0/5.D0+(4176+(-10044+T74)*DZ2)
     #*DZ2+(3132+(-15066+(23328-T79)*DZ2)*DZ2+(-6696+(20736-T84)*DZ2
     #+(6480-T87-T88)*DZ1)*DZ1)*DZ1)*DZ1
      DP(1,7) = -9.D0/2.D0*T58+(99*T58+(-486*T58+T102)*DZ1)*DZ1
      DP(1,8) = (99.D0/2.D0+(-1197.D0/2.D0+(2376+(-3726+T20)*DZ2)
     #*DZ2)*DZ2)*DZ2+T119
      DP(1,9) = -3.D0/4.D0*T66*T67*T69+(1053+(-5220+(9342+(-7128+T20)
     #*DZ2)*DZ2)*DZ2+(-12447.D0/2.D0+(23652+(-29160+T79)*DZ2)*DZ2
     #+(14796+(-37584+T134)*DZ2+(-15390+T137+T138)*DZ1)*DZ1)*DZ1)*DZ1
      DP(1,10) = 2*T148+(-36*T148+T152)*DZ1
      DP(1,11) = (-148+(1692+(-6120+(8424-T27)*DZ2)*DZ2)*DZ2)*DZ2
     #+((360+(-3672+(10368-T164)*DZ2)*DZ2)*DZ2-T152)*DZ1
      DP(1,12) = -2*T66*T67*T62+(-1016+(3384+(-3672+1296*DZ2)*DZ2)*DZ2
     #+(6696+(-18360+(15552-T27)*DZ2)*DZ2+(-17424+(33696-T84)*DZ2
     #+(19440-T137-7776*DZ1)*DZ1)*DZ1)*DZ1)*DZ1
      DP(1,13) = -3.D0/4.D0*T58*T61+T119
      DP(1,14) = (513.D0/2.D0+(-2610+(7884+(-9396+T27)*DZ2)*DZ2)*DZ2)
     #*DZ2+((-1071+(9342+T210)*DZ2)*DZ2+((1458+(-10692+T79)*DZ2)
     &*DZ2+T102)*DZ1)*DZ1
      DP(1,15) = -9.D0/2.D0*T66*T67+(594+(-1197+T226)*DZ2
     #+(-8289.D0/2.D0+(7128-2916*DZ2)*DZ2+(11556+(-14904+T27)*DZ2
     &+(-13770+T87+T138)*DZ1)*DZ1)*DZ1)*DZ1
      DP(1,16) = T65
      DP(1,17) = (-1566.D0/5.D0+T248)*DZ2+((2088+T254)*DZ2
     #+((-5022+T258)*DZ2+((5184-T164)*DZ2-T48)*DZ1)*DZ1)*DZ1
      DP(1,18) = 36.D0/5.D0-T43+(-972.D0/5.D0+T44+(1404-T45+(-4104
     #+T46+(5184-T20-T88)*DZ1)*DZ1)*DZ1)*DZ1
      DP(1,19) = -9*T279+((1296-T281)*DZ2+((-7614+T284)*DZ2+(T252-T287)
     #*DZ1)*DZ1)*DZ1
      DP(1,20) = 9*T58*T61*T66-18*T118
      DP(1,21) = -3.D0/2.D0*T279*T300*T60+((-6156+(25704+T304*DZ2)*DZ2)
     #*DZ2+((19278+(-52488+T310)*DZ2)*DZ2+((-23328+T315)*DZ2+T287)
     &*DZ1)*DZ1)*DZ1
      DP(1,22) = 36*T58*T66+((720+(-4968+T27)*DZ2)*DZ2
     #+((-2916-T209*DZ2)*DZ2-T334)*DZ1)*DZ1
      DP(1,23) = 3*T58*T340*T67+((-792+(7992+(-22032+T84)
     #*DZ2)*DZ2)*DZ2+T350)*DZ1
      DP(1,24) = -3*T279*T300+((6984+(-22464+(23328-T164)*DZ2)*DZ2)
     #*DZ2+((-28836+(64152-T310)*DZ2)*DZ2+((41472-T366)*DZ2-T369)
     &*DZ1)*DZ1)*DZ1
      DP(1,25) = -3*T58*T340+((504+(-4968+(12960-T164)*DZ2)*DZ2)
     #*DZ2-T350)*DZ1
      DP(1,26) = -3*T58*T68*T62+((2664+(-22464+(42768-T134)*DZ2)
     #*DZ2)*DZ2+((-4860+34992*DZ2*T66)*DZ2-T334)*DZ1)*DZ1
      DP(1,27) = 6*T279*T67+((-4032+(7992-T27)*DZ2)*DZ2
     #+((21060+(-33048+T79)*DZ2)*DZ2+((-36288+T315)*DZ2+T369)*DZ1)
     &*DZ1)*DZ1
      DP(1,28) = -9.D0/2.D0*T58*T68+((-2214+(17496+(-27216+T79)
     #*DZ2)*DZ2)*DZ2+((5832+(-40824+T310)*DZ2)*DZ2+3888*T101)*DZ1)*DZ1
      DP(2,1) = 0
      DP(2,2) = -1+(137.D0/5.D0+(-405.D0/2.D0+(612+(-810+T11)*DZ2)
     #*DZ2)*DZ2)*DZ2
      DP(2,3) = T42
      DP(2,4) = T460
      DP(2,5) = 36.D0/5.D0+(-972.D0/5.D0+(1404+(-4104+(5184-T461)
     #*DZ2)*DZ2)*DZ2)*DZ2+(-36.D0/5.D0+(180+(-1134+T470*DZ2)*DZ2)
     &*DZ2)*DZ1
      DP(2,6) = (-1566.D0/5.D0+T248+(2088+T254+(-5022+T258+(5184-T164
     #-T479)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,7) = (-T488+9.D0/2.D0+(T226-99.D0/2.D0+(-T20+162+T490)
     #*DZ1)*DZ1)*DZ1
      DP(2,8) = -45.D0/2.D0+(594+(-8289.D0/2.D0+(11556+(-13770+T284)
     #*DZ2)*DZ2)*DZ2)*DZ2+(99.D0/2.D0+(-1197+(7128+(-14904+T87)*DZ2)
     #*DZ2)*DZ2+T516)*DZ1
      DP(2,9) = (513.D0/2.D0+(-1071+(1458-T520)*DZ2)*DZ2+(-2610
     #+(9342+(-10692+T27)*DZ2)*DZ2+(7884+T210+(-9396+T79+T529)
     &*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,10) = (4+(-72+T538)*DZ2+(-36+(648-T20)*DZ2+(72+T543*DZ2)
     #*DZ1)*DZ1)*DZ1
      DP(2,11) = 40+(-1016+(6696+(-17424+(19440-T164)*DZ2)*DZ2)*DZ2)
     &*DZ2+(-148+(3384+(-18360+(33696-T137)*DZ2)*DZ2)*DZ2+(180
     &+(-3672+15552*DZ2*T66)*DZ2+(-72-T543*DZ2)*DZ1)*DZ1)*DZ1
      DP(2,12) = (-148+(360-T538)*DZ2+(1692+(-3672+T20)*DZ2
     &+(-6120+T74+(8424-T164-T529)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,13) = (9.D0/2.D0+(-99+(486-T520)*DZ2)*DZ2+T516)*DZ1
      DP(2,14) = -45+(1053+(-12447.D0/2.D0+(14796+(-15390+T284)
     #*DZ2)*DZ2)*DZ2)*DZ2+(513.D0/2.D0+(-5220+(23652+(-37584+T137)
     &*DZ2)*DZ2)*DZ2+(-1071.D0/2.D0+(9342+(-29160+T134)*DZ2)*DZ2
     &+(486+(-7128+T79)*DZ2+T490)*DZ1)*DZ1)*DZ1
      DP(2,15) = (99.D0/2.D0-T488+(-1197.D0/2.D0+T226+(2376-T20
     #+(-3726+T20+T479)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,16) = (36.D0/5.D0+(-180+(1134-T470*DZ2)*DZ2)*DZ2)*DZ1
      DP(2,17) = 36+(-3132.D0/5.D0+(3132+(-6696+(6480-T461)*DZ2)
     #*DZ2)*DZ2)*DZ2+(-1566.D0/5.D0+(4176+(-15066+(20736-T87)*DZ2)
     &*DZ2)*DZ2+(1044+(-10044+(23328-T84)*DZ2)*DZ2+(-1674+(10368-T79)
     &*DZ2+(1296-T27-T1)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,18) = -T460
      DP(2,19) = (-54+108*DZ2+(-T281+648+(T27-2538+(-T27+3888-T479)
     #*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,20) = (-54+(1296+(-7614+(15552-T87)*DZ2)*DZ2)*DZ2
     #+(54+(-1188+(5832-T164)*DZ2)*DZ2)*DZ1)*DZ1
      DP(2,21) = (540+(-6156+(19278+(-23328+T87)*DZ2)*DZ2)*DZ2
     #+(-3078+(25704+(-52488+T315)*DZ2)*DZ2+(6426-34992*DZ2*T66
     &+(T84-5832+T479)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,22) = (-36+(504-T520)*DZ2+(360+(-4968+T284)*DZ2
     &+(-972+(12960-T79)*DZ2+T714)*DZ1)*DZ1)*DZ1
      DP(2,23) = (180+(-4032+(21060+(-36288+T137)*DZ2)*DZ2)*DZ2+(-396
     &+(7992+(-33048+T315)*DZ2)*DZ2+(216+T731*DZ2)*DZ1)*DZ1)*DZ1
      DP(2,24) = (-360+(2664+(-4860+T46)*DZ2)*DZ2+(3492+(-22464-T304
     #*DZ2)*DZ2+(-9612+(42768-T310)*DZ2+(-T134+10368-T529)*DZ1)*DZ1)
     &*DZ1)*DZ1
      DP(2,25) = (-36+(720+(-2916+T46)*DZ2)*DZ2
     #+(252+(-4968+(19440-T84)*DZ2)*DZ2+(-216-T731*DZ2)*DZ1)*DZ1)*DZ1
      DP(2,26) = (-360+(6984+(-28836+(41472-T137)*DZ2)*DZ2)*DZ2
     #+(1332+(-22464+(64152-T366)*DZ2)*DZ2+(-1620+(23328-T310)*DZ2
     &+T714)*DZ1)*DZ1)*DZ1
      DP(2,27) = (180+(-792+T520)*DZ2+(-2016+(7992-T284)*DZ2+(7020
     #+(-22032+T79)*DZ2+(T84-9072+T529)*DZ1)*DZ1)*DZ1)*DZ1
      DP(2,28) = (135+(-2214+(5832-T27)*DZ2)*DZ2+(-1107+(17496+
     #(-40824+T134)*DZ2)*DZ2+(1944+(-27216+T310)*DZ2+(T79-972)*DZ1)
     &*DZ1)*DZ1)*DZ1
      ENDIF
*  
*   Derivees secondes  
*
*      Notations
*      DDP(1,.) = d2P/dx2  , DDP(2,.) = d2P/dy2  , DDP(3,,) = d2P/dxdy 

*      ENDIF  
                                                                    END !Tr006b
