*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR200B (KELFCT,X1,X2,P,DP,DDP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & E.Masson (Fevrier 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees pour le triangle d'Hermite d'ordre 3 a 10 d.l. 
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*        si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*        si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*        si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     tableau contenant les valeurs des fonctions au point X1,X2 
* DP        -       -            -     -  derivees premieres  
* DDP       -       -            -     -  derivees secondes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*),DDP(3,*)  
*
      REAL          X3,XL,XX1,XX2,DX1,DX2,DX3,XX3
*-----------------------------------------------------------------------
      X3=1.-X1-X2
      XL=X1*X2*X3
      XX1=X1*(X3-X2)
      XX2=X2*(X3-X1)
      DX1=X1+X1
      DX2=X2+X2
      DX3=X3+X3
      XX3=X3*(X2-X1)
*
*   Fonctions de base
*
      IF (KELFCT(1:1).NE.'N') THEN
         P(10)=27*XL
         XL=7*XL
         P(1)=X1*X1*(3.-DX1)-XL
         P(4)=X2*X2*(3.-DX2)-XL
         P(7)=X3*X3*(3.-DX3)-XL
         P(2)=-X1*XX3
         P(3)=-X1*XX2
         P(5)=-X2*XX1
         P(6)=X2*XX3
         P(8)=X3*XX2
         P(9)=X3*XX1
      ENDIF
*
*   Derivees premieres
*
      IF (KELFCT(2:2).NE.'N')THEN
         DP(2,1)=-7.*XX1
         DP(2,4)=6.*X2*(1.-X2)+DP(2,1) 
         DP(1,4)=-7.*XX2
         DP(1,1)=6.*X1*(1.-X1)+DP(1,4) 
         DP(1,7)=6.*X3*(1.-X3) 
         DP(2,7)=-DP(1,7)+DP(2,1)
         DP(1,7)=-DP(1,7)+DP(1,4)
         DP(1,10)=27.*XX2
         DP(2,10)=27.*XX1
*  
         DP(1,2)=X1*(DX3-X1)-XX2
         DP(2,2)=-X1*X1-XX1
         DP(1,3)=X2*(3.*X1-X3)
         DP(2,3)=X1*X1-XX1
         DP(1,5)=X2*X2-XX2
         DP(2,5)=X1*(3*X2-X3)
         DP(1,6)=-X2*X2-XX2
         DP(2,6)=X2*(DX3-X2)-XX1
         DP(1,8)=X2*(X1-3.*X3)
         DP(2,8)=X3*(X3-DX2)-XX1
         DP(1,9)=X3*(X3-DX1)-XX2
         DP(2,9)=X1*(X2-3.*X3)
      ENDIF
*
*   Derivees secondes
*
*      IF (KELFCT(3:3).NE.'N')THEN
*         DX3=DX3-1.
*         DDP(1,1)=14.*X2-12.*X1+6.
*         DDP(2,1)=-7.*DX3
*         DDP(3,1)=14.*X1
*         DDP(1,2)=2.-6.*X1
*         DDP(2,2)=-DX1-DX3
*         DDP(3,2)=DX2
*         DDP(1,3)=4.*X2
*         DDP(2,3)=DX1-DX3
*         DDP(3,3)=DX1
*         DDP(1,4)=14*X2
*         DDP(2,4)=DDP(2,1)
*         DDP(3,4)=14.*X1-12.*X2+6.
*         DDP(1,5)=DX2
*         DDP(2,5)=2*X2-DX3
*         DDP(3,5)=4.*X1
*         DDP(1,6)=DX2
*         DDP(2,6)=-DX2-DX3
*         DDP(3,6)=2.-6.*X2
*         DDP(1,7)=-6.*DX3+14.*X2
*         DDP(2,7)=-13.*DX3
*         DDP(3,7)=-6.*DX3+14.*X1
*         DDP(1,8)=4.*X2
*         DDP(2,8)=X1+3.*(X2-X3)
*         DDP(3,8)=2.-6.*X3
*         DDP(1,9)=DDP(3,8)
*         DDP(2,9)=X2+3.*(X1-X3)
*         DDP(3,9)=4.*X1
*         DDP(1,10)=-54.*X2
*         DDP(2,10)=27.*DX3
*         DDP(3,10)=-54.*X1
*      ENDIF
                                                                    END !Tr20Fb
