*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR201B (KELFCT,X1,X2,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1996)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees - Triangle de Lagrange Non Conforme a 3 noeuds
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*         si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*         si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*         si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 : Coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     : Tableau contenant les valeurs des fonctions au point X1,X2 
* DP    :     -       -            -     -  derivees premieres  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*)
*-----------------------------------------------------------------------
*   Fonctions de base  
* 
      IF (KELFCT(1:1).NE.'N') THEN  
         P(1)=2*(X1+X2)-1.
         P(2)=1.-(X1+X1)
         P(3)=1.-(X2+X2)
      ENDIF
*  
*   Derivees premieres 
*
      IF (KELFCT(2:2).NE.'N') THEN  
         DP(1,1)=2.
         DP(1,2)=-2.
         DP(1,3)=0.
         DP(2,1)=2.
         DP(2,2)=0.
         DP(2,3)=-2.
      ENDIF
                                                                    END !Tr21FB

