*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TR203B (KELFCT,X1,X2,P,DP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (8 juin 2004)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Fonctions de base et derivees - Triangle de Lagrange a 4 noeuds P1 + bulle P3
*  
*-- Arguments d'entree --  
* KELFCT variable CHARACTER indiquant
*         si KELFCT(1:1).NE.'N' Calcul des fonctions de base
*         si KELFCT(2:2).NE.'N' Calcul des derivees premieres des fct. de base  
*         si KELFCT(3:3).NE.'N' Calcul des derivees secondes des fct. de base
* X1,X2 : Coordonnees du point ou on demande la calcul
*-- Arguments de sortie --
* P     : Tableau contenant les valeurs des fonctions au point X1,X2 
* DP    :     -       -            -     -  derivees premieres  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) KELFCT
      REAL          X1,X2,P(*),DP(2,*)
*
      REAL          X3,NEFBUL
*-----------------------------------------------------------------------
      X3=1.-X1-X2
*   Fonctions de base  
*  
      IF (KELFCT(1:1).NE.'N') THEN
         NEFBUL=9.*X1*X2*X3
         P(1)=X1-NEFBUL
         P(2)=X2-NEFBUL
         P(3)=X3-NEFBUL
*        bulle P3
         P(4)=3.*NEFBUL
      ENDIF
*  
*   Derivees premieres 
* 
      IF (KELFCT(2:2).NE.'N') THEN
*        bulle P3 : derivees
         NEFBUL=9.*X2*(X3-X1)
         DP(1,1)= 1.-NEFBUL
         DP(1,2)=   -NEFBUL
         DP(1,3)=-1.-NEFBUL
         DP(1,4)=3.*NEFBUL
         NEFBUL=9.*X1*(X3-X2)
         DP(2,1)=   -NEFBUL
         DP(2,2)= 1.-NEFBUL
         DP(2,3)=-1.-NEFBUL
         DP(2,4)=3.*NEFBUL
      ENDIF
                                                                    END !Tr23FB
