*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRIA (TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (8 juin 2004)
* Version 1.2
*  
*-- Variable d'entree --
* TYPE : k < 99 --> Triangle de Lagrange Pk a (k+1)(k+2)/2 noeud(s)
*       200      --> Triangle  d'Hermite  P3 a 4 noeuds et 10 d.l.
*       201      --> Triangle de Lagrange P1 a 3 noeuds Non Conforme H1
*       202      --> Triangle de Lagrange P2 a 6 noeuds
*       203      --> Triangle de Lagrange P1+bulle P3 a 4 noeuds
*  
*-- Variables de sortie --  
* LAGHER =0 Indique un element pour lequel :
*           Tous les d.l. sont de Lagrange (valeur nodale) ET tous les
*           noeuds porte un d.l. et un seul
*         1 Sinon (elements de Hermite, par exemple)
* CLASSE classe de l'element (Element de classe C^0, C^1,...etc)
* NBNEEL nombre de noeuds (i.e. points support d'au moins un d.l.)
* NBDLEL nombre de degres de liberte de l'element
* NBNEAX nombre maximum de noeuds sur une arete
* NBDLAX nombre maximum de d.l. sur une arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX
*
      INTEGER LAGDMX
      PARAMETER ( LAGDMX = 100)
*-----------------------------------------------------------------------
      LAGHER=0
      CLASSE=0
      IF (TYPE.LE.LAGDMX) THEN
         NBNEAX=TYPE+1
         NBDLAX=NBNEAX
         NBNEEL=(NBNEAX*(NBNEAX+1))/2
         NBDLEL=NBNEEL
      ELSEIF (TYPE.EQ.200) THEN
         NBNEEL=4 
         NBDLEL=10
         NBNEAX=2  
         NBDLAX=4  
         LAGHER=1
      ELSEIF (TYPE.EQ.201) THEN
         NBNEEL=3 
         NBDLEL=NBNEEL
         NBNEAX=1  
         NBDLAX=NBNEAX
       ELSEIF (TYPE.EQ.202) THEN
         NBNEEL=6
         NBDLEL=NBNEEL
         NBNEAX=3
         NBDLAX=NBNEAX
       ELSEIF (TYPE.EQ.203) THEN                                        !06/2004
         NBNEEL=4                                                       !06/2004
         NBDLEL=NBNEEL                                                  !06/2004
         NBNEAX=2                                                       !06/2004
         NBDLAX=NBNEAX                                                  !06/2004
      ELSE
         CALL TRIAXX(TYPE,LAGHER,CLASSE,NBNEEL,NBDLEL,NBNEAX,NBDLAX)
      ENDIF
                                                                    END !Tria
