*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRIAQA (NUARET,NBPTQ,POIDQ1,COORQ1,POIDQ2,COORQ2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.0.1
*
* Formule de quadrature sur une arete du triangle de reference 
* construite a partir d'une formule de quadrature sur le segment.
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUARET numero de l'arete de l'element
* NBPTQ  nombre de points de la formule de quadrature du segment
* POIDQ1 poids de la formule de quadrature sur le segment
* COORQ1 coordonnees des points de la formule de quadrature sur le segment
* POIDQ2 poids de la formule de quadrature sur l'arete de l'element
* COORQ2 coordonnees des points de la formule de quadrature sur l'arete
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUARET,NBPTQ
      REAL    POIDQ1(*),COORQ1(*),POIDQ2(*),COORQ2(2,*)
*
      INTEGER I
      REAL    SQRT2
*-----------------------------------------------------------------------
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1+x2=1.
         SQRT2 =  SQRT(2.)
         DO 3001 I=1,NBPTQ
            COORQ2(1,I) = COORQ1(I)
            COORQ2(2,I) = 1.-COORQ1(I)
            POIDQ2(I)   = SQRT2*POIDQ1(I)
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x1=0.
         DO 3002 I=1,NBPTQ
            COORQ2(1,I) = 0.
            COORQ2(2,I) = COORQ1(I)
            POIDQ2(I)   = POIDQ1(I)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x2=0.
         DO 3003 I=1,NBPTQ
            COORQ2(1,I) = COORQ1(I)
            COORQ2(2,I) = 0.
            POIDQ2(I)   = POIDQ1(I)
3003     CONTINUE
      ELSE
         CALL ERELEM (5,'Triaqa',NUARET)                                !Utilite
      ENDIF
                                                                    END !TriaQa
