*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRIATA (NUARET,JACOBF,TANGNT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1994)
* Derniere modification : D.Martin (30 Novembre 2000)
* Version 1.0.1
*
* Calcul d'un vecteur tangent sur une arete d'un triangle a partir de la
* matrice jacobienne sur l'element
* (programme pour que les valeurs des coeff. soit corrects en  double precision
*  pour les compilations implicites en double precision)
*
*-- Arguments d'entree --
* NUARET numero de la face de l'element
* JACOBF matrice jacobienne
* TANGNT vecteur tangent sur l'arete courante
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NUARET
      REAL     JACOBF(2,*),TANGNT(*)
*
      INTEGER I
      REAL   USQRT2
*-----------------------------------------------------------------------
      IF (NUARET.EQ.1) THEN
*        Arete 1 : droite x1+x2=1.
         USQRT2=SQRT(1./2.)
         DO 3001 I=1,2
         TANGNT(I)=USQRT2*(JACOBF(I,2)-JACOBF(I,1))
3001     CONTINUE
      ELSEIF (NUARET.EQ.2) THEN
*        Arete 2 : droite x1=0.
         DO 3002 I=1,2
            TANGNT(I)=-JACOBF(I,2)
3002     CONTINUE
      ELSEIF (NUARET.EQ.3) THEN
*        Arete 3 : droite x2=0.
         DO 3003 I=1,2
            TANGNT(I)=+JACOBF(I,1)
3003     CONTINUE
      ELSE
         CALL ERELEM (5,'TriaTa',NUARET)                                !Utilite
      ENDIF
                                                                    END !TriaTa
