*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRLKAR (TYPE,NUARET,NUTYAR,NBNEAR,NUNEAR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2000)
* Derniere modification : D.Martin (10 octobre 2005)
* Version 3
*  
* Numerotation locale des noeuds d'une arete de l'element de reference
* Triangle de Lagrange d'ordre k a (k+1)(k+2)/2 noeuds
*
*-- Arguments --
* TYPE   =K pour triangle de type k
* NUARET numero de l'arete
* NUTYAR numero de type de l'arete (numero de type de l'element 1d associe)
* NBNEAR nombre de noeuds de l'arete
* NUNEAR tableau des numeros locaux des noeuds de l'arete
* --> Remarque : La numerotation locale sur les aretes est telle que la base
*                constituee de la normale exterieure et du vecteur
*                'NUNEFA(1)-NUNEFA(2)' est directe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER TYPE  ,NUARET,NUTYAR,NBNEAR,NUNEAR(*)
*
      INTEGER TYPNEW,NBARET,I,MORE,LAGDMX, NTYPFO
      PARAMETER ( LAGDMX = 100, NTYPFO = 1000)
*-----------------------------------------------------------------------
      TYPNEW=TYPE
      IF (TYPNEW.GT.LAGDMX) TYPNEW=TYPNEW-LAGDMX
*
*  Segments
*  Numerotations locales des noeuds
*  2----1  2---3---1  2---4---3---1  2---5---4---3---1  2---6---5---4---3---1
*
*  Triangles
*  Numerotations des aretes
*  2
*  | \
*  |   \
* II     I 
*  |       \
*  |         \
*  3-----III---1
*  Numerotations des noeuds   
*
*  2     2         2              2                  2
*  | \   | \       | \            | \                | \
*  3---1 5   4     5   7          5  10              5  13
*   k=1  |     \   |     \        |     \            |     \
*        3---6---1 8  10   4      8  14   7          8  17  10
*           k=2    |         \    |         \        |         \
*                  3---6---9---1 11  15  13   4     11  20  19   7
*                       k=3       |             \    |             \
*                                 3---6---9--12---1 14  18  21  16   4 
*                                         k=4        |                 \
*                                                    3---6---9--12--15---1
*                                                             k=5
*
      NBARET=3
      NUTYAR=10*NTYPFO+TYPE  
      NBNEAR=TYPE+1
      NUNEAR(1)=NUARET+1
      NUNEAR(2)=NUARET
      IF (NUARET.EQ.NBARET) NUNEAR(1)=1
      MORE=NBARET
      DO 1 I=NBNEAR,3,-1
        NUNEAR(I)=NUARET+MORE
        MORE=MORE+NBARET
 1    CONTINUE
                                                                    END !Trlkar
