*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRLKCO (K,NDIM,CORLOC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 2000)
* Derniere modification : D.Martin (11 Juillet 2001)
* Version 1.1.0
*
* Coordonnees des noeuds de l'element de reference pour le triangle de
* Lagrange d'ordre k a (k+1)(k+2)/2 noeuds aux abscisses equidistantes
*
*-- Arguments --
* K      pour triangle de type k
* NDIM   dimension d'espace
* CORLOC tableau des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,NDIM
      REAL    CORLOC(NDIM,*)
*
      INTEGER NE,NK,J
      REAL    CORMIN,CORMI1,CORMAX,CORMA1,UNSURK
*---------------------------------------------------------------------
      UNSURK=1./K
*
*  2     2         2              2                  2
*  | \   | \       | \            | \                | \
*  3---1 5   4     5   7          5  10              5  13
*   k=1  |     \   |     \        |     \            |     \
*        3---6---1 8  10   4      8  14   7          8  17  10
*           k=2    |         \    |         \        |         \
*                  3---6---9---1 11  15  13   4     11  20  19   7
*                       k=3       |             \    |             \
*                                 3---6---9--12---1 14  18  21  16   4 
*                                         k=4        |                 \
*                                                    3---6---9--12--15---1
*                                                             k=5
      CORMAX=1.
      CORMIN=0.
      NE=0
      NK=K
1     IF (NK.GT.0) THEN
         CORMA1=CORMAX
         CORMI1=CORMIN
         DO 2 J=1,NK
            NE=NE+1
            CORLOC(1,NE)=CORMA1
            CORLOC(2,NE)=CORMI1
            NE=NE+1
            CORLOC(1,NE)=CORMIN
            CORLOC(2,NE)=CORMA1
            NE=NE+1
            CORLOC(1,NE)=CORMI1
            CORLOC(2,NE)=CORMIN
            CORMA1=CORMA1-UNSURK
            CORMI1=CORMI1+UNSURK
2        CONTINUE
         CORMAX=CORMAX-2*UNSURK
         CORMIN=CORMIN+UNSURK
         NK=NK-3
         GOTO 1
      ENDIF
*
      IF (MOD (K,3).EQ.0) THEN
         NE=NE+1
         CORLOC(1,NE)=CORMAX
         CORLOC(2,NE)=CORMIN           
      ENDIF
                                                                    END !TrlkCo