*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASSEFL (NMTERM,NVTERM,MODE,GEOM,NMCSTA,NBCSTA,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: O.DeBayser (Juillet 92)
* Derniere modification : D.Martin (10 Juillet 1997)
*   
* Creation et mise a jour d'un tableau associe pour un terme
* "elements finis localises". Il contient les coefficients
* des fonctions propres "spectrales" normees complexes.
*   
*-- Arguments d'entrees --
* NMTERM Nom du terme "element finis localises"
* NVTERM Son niveau
* MODE   Indicateur de predefinition pour les fct. spectrales
* GEOM   Indicateur de predefinition pour la geometrie de la frontiere
* NMCSTA Tableau des noms de constantes a plonger dans le tableau associe
* NBCSTA nombre de telles constantes
* NIVIMP Niveau d'impression
*
*-- Structure du tableau complexe associe -- 
* EQUIVALENCE entre TBASSO(1) (entier ou reel) et TBASSC(1) (complexe)
* TBASSO(1) NBCSTA nombre de constantes plongees
* TBASSO(2) NBSTAB nombre de sous-tableaux dans la structure
* TBASSO(3) NBFDEV nombre de tfonctions spectrales
* TBASSO(4) NBTFON nombre de termes par fonction spectrale
* TBASSO(5) IGEOME Indice de geometrie
*                       =1 --> segment horizontal
*                       =2 --> segment vertical
*                       =3 --> domaine circulaire
* TBASSC(5) ... TBASSC(4+NBCSTA) les constantes
*       si IGEOME = 3 cas du domaine circulaire
*       TBASSC(5) = RAYON  Rayon du cercle
*       TBASSC(6) = COORDH Abscisse du centre du cercle
*       TBASSC(7) = COORDV Ordonnee du centre du cercle
*       plus les autres constantes eventuelles ...
*
* IA0=4+NBCSTA
* TBASSC(IA0) premier sous-tableau de taille NBFDEV*NBTFON
*             IA1=IA0+NBFDEV*NBTFON
* TBASSC(IA1) second  sous-tableau de taille NBFDEV*NBTFON
*             IA2=IA1+NBFDEV*NBTFON
* TBASSC(IA2) etc ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM,MODE,GEOM,NMCSTA(*)
      INTEGER       NVTERM,NBCSTA,NIVIMP
*
      INCLUDE 'ALLOC'   
      INCLUDE 'CONTEX'  
*
      INTEGER   INTDON,INTTYP,KLTERM,KELCHN
      CHARACTER ERCODE*120
      CHARACTER NOM*16,NOMDON*16,NODONA*16
      COMMON /FORMAH/ERCODE
      EQUIVALENCE (ERCODE(73:73),NOMDON),(ERCODE(89:89),NODONA)
      EQUIVALENCE (ERCODE(105:105),NOM)
*----------------------------------------------------------------------- 
      CALL PRFXMJ (1,'*AssEfl*')
*
*     Caracteristiques du developpement en serie
      CALL TBAR5  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN
     &                   ,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !Sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !Sdexplo
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !Sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !Utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM)  ,NIVTRM,ITYPTR,ITYCAL,KINTEG,NUDONN
     &            ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &            ,NVDUML,NBLIGN,NVNUML,INDSTK,NVNUMS,NVCORC
     &            ,IATRDO,NIVIMP)                                       !Sdexplo
      IF (KINTEG.LE.2) THEN
         CALL SDEXCO (NUINCC,IST(MCINCO),ITYINC,INTINC,NBTNEU)          !Sdexplo
      ELSEIF (KINTEG.EQ.3) THEN
         CALL SDEXCO (NUINCL,IST(MCINCO),ITYINC,INTINC,NBTNEU)          !Sdexplo
      ELSEIF (KINTEG.EQ.4) THEN
         CALL SDEXCO (NUINCL,IST(MCINCO),ITYINC,INTINC,NBTNEU)          !Sdexplo
      ENDIF
      NBTFON=NBTNEU/1000000
      NBFDEV=NBTNEU-1000000*NBTFON
*
*     Tests de presence des donnees
      IF (NUDONN.LE.0) CALL ERTERM (2,NMTERM,NVTERM)                    !Utilite
*     Nom de la donnee
      CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NOMDON)                    !Utilite
*     Type de la donnee
      CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)             !Sdexplo
      IF (ITYDON.EQ.INTDON ('TABLEAU')) THEN                            !Utilite
         ITYRAS=ITYDON
         NIVASS=NIVDON
         ITYASS=ITYPDO
         NODONA(:NCHDON)=NOMDON(:NCHDON)
      ELSEIF (ITYDON.EQ.INTDON ('FONCTION')) THEN                       !Utilite
*        Caracteristiques de la donnee associee a la fonction
         CALL GETCHN(AST(MCMDON),NCHDON,NIVDON,NODONA)                  !Utilite
         CALL SDEXCO(NIVDON,IST(MCDONN),ITYRAS,NIVASS,ITYASS)           !Sdexplo
         IF (ITYRAS.NE.INTDON ('TABLEAU')) CALL ERDONN (2,NODONA)       !Sdexplo
      ELSE 
         CALL BAISE ('La donnee element finis localise doit etre '      !Utilite
     &          //'une fonction avec un tableau associe ou un tableau') !Utilite
      ENDIF
*
*     lOngueur d'un sous-tableau
      LGSTAB=NBFDEV*NBTFON
*     Nombre de sous-tableaux
      NBSTAB=4
*     Creation du tableau complexe associe au terme "element-finis localises"
      LGTBAS=4+NBCSTA+3*LGSTAB+NBFDEV
      CALL TBCREE (NODONA(:NCHDON),NIVASS,4,LGTBAS,'c') 
      CALL TBAR3  (ERCODE,NODONA(:NCHDON),NIVASS,MCASSC  
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
*     Adresse reelle ou entiere
      MCASSO=2*MCASSC-1
      MCCSTE=MCASSC+4
      IST(MCASSO)  =NBCSTA
      IST(MCASSO+1)=NBSTAB
      IST(MCASSO+2)=NBFDEV
      IST(MCASSO+3)=NBTFON
      IGEOME=1
      IF (GEOM(1:4).EQ.'VERT') IGEOME=2
      IF (GEOM(1:4).EQ.'CERC') IGEOME=3
*
*     constantes de la geometrie a plonger dans l'ordre 
*     dans le tableau associe
      DO 1 ICSTE=1,NBCSTA
         NOM=NMCSTA(ICSTE)
         NUDONN=KELCHN (NMCSTA(ICSTE),AST(MCMDON),NBDONN,NCHDON)        !Utilite
         IF (NUDONN.LE.0) CALL ERDONN (1,NOM)                           !Utilite
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !Sdexplo
         IF (ITYDON.NE.INTDON ('CONSTANTE')) CALL ERDONN (2,NOM)        !Utilite
         IF (ITYPDO.EQ.INTTYP ('ENTIER')) THEN                          !Utilite
            CALL TBAR1  (ERCODE,'$ECSTE',1,MCRSTE)
            CST(MCCSTE-1+ICSTE)=IST (MCRSTE+NIVDON)
         ELSEIF (ITYPDO.EQ.INTTYP ('REEL')) THEN                        !Utilite
            CALL TBAR1  (ERCODE,'$RCSTE',1,MCRSTE)
            CST(MCCSTE-1+ICSTE)=RST(MCRSTE+NIVDON)
         ELSEIF (ITYPDO.EQ.INTTYP ('COMPLEXE')) THEN                    !Utilite
            CALL TBAR1  (ERCODE,'$CCSTE',1,MCRSTE)
            CST(MCCSTE-1+ICSTE)=CST(MCRSTE+NIVDON)
         ENDIF
1     CONTINUE
      IST(MCASSO+4)=IGEOME
*
      MCDGAM=MCCSTE+NBCSTA
      MCDNU =MCDGAM+LGSTAB
      MCDALF=MCDNU +LGSTAB
      MCDOME=MCDALF+LGSTAB
      IF (ITYPTR.EQ.INTTYP ('REEL')) MCDOME=2*MCDOME-1
*   
*     Calcul des fonctions spectrales et remplissage du tableau associe
*
      IF (MODE(1:5).EQ.'SINUS') THEN
*        Cas ou les fonctions spectrales sont des "Sinus"
         IF (NBTFON.NE.2)
     &      CALL BAISE ('nombre de termes par fonction spectrale faux')
*        Y0 doit etre la derniere constante ...
         Y0=CST(MCCSTE-1+NBCSTA)
         PISURH=4.*ATAN(1.)/Y0
         DO 100 K=1,NBFDEV
            CST(MCDGAM)  =SQRT (2/Y0)*CMPLX(0.,-.5)
            CST(MCDGAM+1)=SQRT (2/Y0)*CMPLX(0., .5)
            CST(MCDNU)   =CMPLX (0., K*PISURH)
            CST(MCDNU +1)=CMPLX (0.,-K*PISURH)
            CST(MCDALF)  =0.
            CST(MCDALF+1)=0.
            IF (ITYPTR.EQ.INTTYP ('REEL')) THEN
               RST(MCDOME)=K*PISURH
            ELSE
               CST(MCDOME)=CMPLX (K*PISURH,0.)
            ENDIF 
*
            MCDGAM=MCDGAM+2
            MCDNU =MCDNU +2
            MCDALF=MCDALF+2
            MCDOME=MCDOME+1
100      CONTINUE
*     ELSE
*        Cas ou les fonctions spectrales sont calculees
*        CALL EQDISP (NODONA(:NCHDON),NIVASS,NBFDEV,NBTFON
*    &               ,MCDGAM,MCDNU,MCDALF,MCDOME,IST,RST,CST,DST)
*
      ENDIF
*
      CALL PRFXMJ (-1,'*AssEfl*')   
                                                                    END !AssEfl
