*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLADC(KINTEG,NDMDOM,NUINCC,NUINCL,NCPINL,NCPINC,IDLHRC
     &                 ,IDLHRL,NBCOLO,NBLIGN,NBFDEV,NBTFON,NBNEFX,NBNEFY
     &                 ,NBDLFX,NBDLFY,ITYPTR,IADINT,IAPLOC,LGWORC,IADCOF
     &                 ,IANEFA,IADLFA,IADUDL,IAGDLN,IALINL,LGWORK)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Avril 1992)
* Derniere modification: D.Martin  (18 Octobre 1999)
*
* Preparation des adresses relatives pour des tableaux temporaires et
* la matrice elementaire
*
*-- Arguments --
* KINTEG Type de calcul element finis localises
* NDMDOM Dimension d'espace du domaine courant
* NUINCC Numero d'inconnue en colonne
* NUINCL Numero d'inconnue en ligne
* IDLHRC indice de presence de degres de liberte de Hermitte en colonne
* IDLHRL indice de presence de degres de liberte de Hermitte en ligne
* NBCOLO Nombre de degres de liberte  en  colonne
* NBLIGN Nombre de degres de liberte  en  ligne
* NBFDEV Nombre de fonction propres
* NBTFON Nombre de termes par fonction propre
* NBNEFX Nombre de noeuds max. par face d'element en colonne
* NBNEFY Nombre de noeuds max. par face d'element en ligne
* NBDLFX Nombre de d.l. max. par face d'element en colonne
* NBDLFY Nombre de d.l. max. par face d'element en ligne
* ITYPTR type de declaration du resultat
* IADINT    "       "     des integrales exactes
* IAPLOC    "       "     de la matrice elementaire
* LGWORC Longueur du premier tableau auxiliaire evt. complexe
* IADCOF Adresse relative des monomes des fct. de base
* IANEFA    "       "     de numerotation locale en noeud
* IADLFA    "       "     de numerotation locale en d.l.
* IADUDL    "       "     des pointeurs vers le noeud du d.l.
* IAGDLN    "       "     des rangs des d.l. sur le noeud
* IALINL    "       "     des nombres de d.l. par noeud
* LGWORK longueur du second tableau temporaire reel ou entier
*-- Remarque --
* Le premier tableau temporaire est complexe. Le second est reel.
* L'emplacement de la matrice elementaire est donc reservee dans 
* le premier ou dans le second selon le type du resultat.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER*120 ERCODE
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EflAdc*')
*     Calculs d'adresses relatives
      CALL TBAR1  (ERCODE,'#NCONU',1,MCINCO)              
      IF (KINTEG.LE.2) THEN
*        Cas d'un terme variationnel en ligne , spectral en colonne
         CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTRPC,NBTNEC)          !sdexplo
         NBTFON=NBTNEC/1000000
         NBFDEV=NBTNEC-1000000*NBTFON
         NCPINL=1
         IF (NUINCL.GT.0)
     &      CALL SDEXCO(NUINCL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)        !sdexplo
*        Degre maximum des monomes dans les fonctions de base
         NDEGRE=INTRPL
*
         IADINT=0
         IF (ITYPTR.EQ.INTTYP ('COMPLEXE')) THEN
            IAPLOC=IADINT+NDEGRE+1
            LGWORC=IAPLOC+NBFDEV*NBLIGN*NCPINL*NCPINC
            IADCOF=0
         ELSE
            LGWORC=IADINT+NDEGRE+1
            IAPLOC=0
            IADCOF=IAPLOC+NBFDEV*NBLIGN*NCPINL*NCPINC
         ENDIF
         IANEFA=IADCOF+NBDLFY*(NDEGRE+1)
         IADLFA=IANEFA
         IF (NDMDOM.NE.NDIM) IADLFA=IANEFA+NBNEFY
         IADUDL=IADLFA
         IAGDLN=IADUDL
         IALINL=IAGDLN
         IF (NDMDOM.NE.NDIM.AND.IDLHRL.GT.0) THEN
            IADUDL=IADLFA+NBDLFY
            IAGDLN=IADUDL+NBDLFY
            IALINL=IAGDLN+NBDLFY
         ENDIF
         LGWORK=IALINL+NBNEFY
      ELSEIF (KINTEG.EQ.3) THEN
*        Cas d'un terme variationnel en colonne , spectral en ligne
         CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)          !sdexplo
         NBTFON=NBTNEL/1000000
         NBFDEV=NBTNEL-1000000*NBTFON
         NCPINC=1
         IF (NUINCC.NE.NDFINC)
     &      CALL SDEXCO(NUINCC,IST(MCINCO),NCPINC,INTRPC,NBTNEC)        !sdexplo
*        Degre maximum des monomes dans les fonctions de base
         NDEGRE=INTRPC
*
         IADINT=0
         IF (ITYPTR.EQ.INTTYP ('COMPLEXE')) THEN
            IAPLOC=IADINT+NDEGRE+1
            LGWORC=IAPLOC+NBFDEV*NBCOLO*NCPINL*NCPINC
            IADCOF=0
         ELSE
            LGWORC=IADINT+NDEGRE+1
            IAPLOC=0
            IADCOF=IAPLOC+NBFDEV*NBCOLO*NCPINL*NCPINC
         ENDIF
         IANEFA=IADCOF+NBDLFX*(NDEGRE+1)
         IADLFA=IANEFA
         IF (NDMDOM.NE.NDIM) IADLFA=IANEFA+NBNEFX
         IADUDL=IADLFA
         IAGDLN=IADUDL
         IALINL=IAGDLN
         IF (NDMDOM.NE.NDIM.AND.IDLHRC.GT.0) THEN
            IADUDL=IADLFA+NBDLFX
            IAGDLN=IADUDL+NBDLFX
            IALINL=IAGDLN+NBDLFX
         ENDIF
         LGWORK=IALINL+NBNEFX
      ELSEIF (KINTEG.EQ.4) THEN
*        Cas d'un terme spectral en ligne et en colonne
         CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)          !sdexplo
         NBTFON=NBTNEL/1000000
         NBFDEV=NBTNEL-1000000*NBTFON
         CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTRPC,NBTNEC)          !sdexplo
         IF (NBTNEC.NE.NBTNEL)
     &      CALL BAISE ('Cas ou les fonctions spectrales ne sont pas'
     &                //' les memes en ligne et en colonne non prevu')
         IADINT=0
         IF (ITYPTR.EQ.INTTYP ('COMPLEXE')) THEN
            IAPLOC=IADINT+1
            LGWORC=IAPLOC+NBFDEV*NBFDEV*NCPINL*NCPINC
            LGWORK=0
         ELSE
            LGWORC=IADINT+1
            IAPLOC=0
            LGWORK=IAPLOC+NBFDEV*NBFDEV*NCPINL*NCPINC
         ENDIF
         IADCOF=0
         IANEFA=0
         IADLFA=0
         IADUDL=0
         IAGDLN=0
         IALINL=0
      ENDIF
*
      CALL PRFXMJ (-1,'*EflAdc*')
                                                                    END !EflAdc
