*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLGBO (NDIM,CORPTL,IGEOME,MCASSC,CST,THETAA,THETAB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (octobre 1990)
* Derniere modification : D.Martin (21 octobre 2006)
* Version 2
*
* Recherche des extremites du domaine d'integration pour un terme EflLoc
*
*-- Arguments d'entree --
* CORPTL tableau des coordonnees
* IGEOME indice de geometrie
*        = 1 --> segment horizontal
*        = 2 --> segment vertical
*        = 3 --> domaine circulaire
* MCASSC adresse complexe des constantes du tableau associe
* THETAA 1ere  extremite
* THETAB 2ieme extremite
*-- Constantes du tableau associee dans le cas d'un domaine circulaire
*   (IGEOME = 3)
* RAYON  Rayon du cercle
* COORDH Abscisse du centre du cercle
* COORDV Ordonnee du centre du cercle
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NDIM,IGEOME,MCASSC
      REAL    CORPTL(NDIM,*),THETAA,THETAB
      COMPLEX CST(*)
*
      REAL    PI,RAYON,COORDH,COORDV
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EflGbo*')
*
      IF (IGEOME.EQ.1.OR.IGEOME.EQ.2) THEN
*
*     Cas d'un segment horizontal ou vertical
*
         THETAA=CORPTL(IGEOME,1)
         THETAB=CORPTL(IGEOME,2)
      ELSEIF (IGEOME.EQ.3) THEN
*
*        Cas d'un arc de cercle
*
         PI=4.*ATAN(1.)
         RAYON =REAL(CST(MCASSC))
         COORDH=REAL(CST(MCASSC+1))
         COORDV=REAL(CST(MCASSC+2))
*        Max (-1, ...) ajoute (Fantaisie IEEE ?) :
*        Dans le cas ou le resultat vaut par exemple -1.00000000000000155
*        ACOS retourne fort justement NaN
         THETAA=ACOS(MAX(-1.,(CORPTL(1,1)-COORDH)/RAYON))
         IF (CORPTL(2,1)-COORDV.LT.0) THETAA=2*PI-THETAA
         THETAB=ACOS(MAX(-1.,(CORPTL(1,2)-COORDH)/RAYON))
         IF (CORPTL(2,2)-COORDV.LT.0) THETAB=2*PI-THETAB
*
         IF ( ((THETAB.GE.0).AND.(THETAB.LT.PI)).AND.
     &        ((THETAA.GT.PI).AND.(THETAA.LE.2*PI)) )
     &       THETAB=2*PI+THETAB
         IF ( ((THETAA.GE.0).AND.(THETAA.LT.PI)).AND.
     &        ((THETAB.GT.PI).AND.(THETAB.LE.2*PI)) )
     &       THETAA=2*PI+THETAA
*
      ELSE
*
         CALL BAISE ('Valeur non prevue pour IGEOME')
*
      ENDIF
      CALL PRFXMJ (-1,'*EflGbo*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (21 octobre 2006)
* - Fantaisie IEEE / processeur en double precision ?
* Version 1.0.1 : C. Chambeyron (27 janvier 2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !EflGbo
    
   
