*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLINT (NU,NBQ,BETA,TABINT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (Octobre 1990)
* Derniere modification : D.Martin (9 Avril 1999)
*
* Calcul des integrales \int_0^1 exp(nu*x+beta) x**q dx  pour q = 0, nbq.
*
* Choix de la formule d'integration en fonction des valeurs de NU et NBQ
* afin d'eviter les instabilites quand NU est petit.
*
*-- Arguments d'entree --
* NU    Valeur de l'exposant de l'exponentielle de l'integrand
* NBQ    Degre du monome de l'integrand
* BETA   Exposant du coefficient exponentiel
* TABINT Resultat: I(NU,q), q=0,NBQ
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBQ
      COMPLEX TABINT(0:*),NU,BETA
*
      INTEGER N
*-----------------------------------------------------------------------
      IF (NBQ.GT.5) CALL BAISE (' *Eflint* Degre trop eleve.')
*
      IF (NBQ.EQ.0.AND.NU.NE.0) THEN
*
         TABINT(0)=(EXP(NU+BETA)-EXP(BETA))/NU
*
      ELSEIF (ABS(NU).LE.7.E-03) THEN
*
         CALL EFLXSE (NU,1,0,NBQ,BETA,TABINT)
*
      ELSEIF (ABS(NU).LE.1.E-01) THEN
*
         CALL EFLXRE (NU,0,BETA,TABINT)
*
         CALL EFLXSE (NU,3,1,NBQ,BETA,TABINT)
*
      ELSEIF (ABS(NU).LE.3.E-01) THEN
*
         N=MIN (NBQ,2)
*
         CALL EFLXRE (NU,N,BETA,TABINT)
*
         IF (NBQ.GE.3) CALL EFLXSE (NU,4,3,NBQ,BETA,TABINT)
*
      ELSE
*
         CALL EFLXRE(NU,NBQ,BETA,TABINT)
      ENDIF
                                                                    END !EflInt
