*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLMDM (NMTRMV,NVTRMV,NMTRMM,NVTRMM,NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (19 octobre 2006)
* Derniere mofification : D.Martin (13 novembre 2009)
* Version 1
*
* Multiplication D x M d'une matrice spectrale diagonale D 
* par une matrice spectrale pleine M.
* La matrice diagonale est un terme spectral vectoriel V 
*    
*-- Arguments d'entree --
* NMTRMV nom de la matrice diagonale ou du vecteur V 
* NMTRMV niveau de la matrice diagonale ou du vecteur V 
* NMTRMM nom de la matrice spectrale M 
* NMTRMM niveau de la matrice spectrale M 
* NMTERM nom de la matrice resultat R
* NMTERM niveau de la matrice resultat R
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*)  NMTRMV,NMTRMM,NMTERM
      INTEGER        NVTRMV,NVTRMM,NVTERM
*                                 
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER PRFXAS*8,ERCODE*120,STOIND*7,YKLINT*6,TYPINT*9
      CHARACTER NMSTOK*7,TYTRMV*9,TYTRMM*9,TYTERM*9
      INTEGER   KLTERM,INTYKL,INDSTO,INDSYM
      INTEGER   LGDTRM,LGMTRM,LGINCO,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM
     &         ,NCHTRM,NUTERM
     &         ,NVVTRM,ITTRMV,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &         ,NUINCV,NVDUCV,NBCOLV,NVNUCV,NUINLV,NVDULV,NBLIGV,NVNULV
     &         ,INSTOK,NVSTOK,NVCORC,IATRDM,NIVIMV,NCOEFV,INSTOV,NVSTOV
     &         ,ITYPMS,NUINCM,NVDUCM,NBCOLO,NVNUCM,NUINLM,NVDULM,NBLIGN
     &         ,NVNULM,NIVIMA,ITTERM,ITYSYR
     &         ,KUCTRM,KVDCRM,KBCOLO,KVNCRM,KULTRM,KVDLRM,KBLIGN,KVNLRM
     &         ,KNDSTR,KVSTRM,IATTRV,MCTRMM,MCTRMV,MCTERM,NIVIMT,KATRDM
     &         ,MCBMOR,NBPLL,MCPLAL,MCPLIL,LGL,NBPLU,MCPLAU,MCPLIU,LGU
      LOGICAL   CRETRM

      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EflMDM*')
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*
*     Caracteristiques du vecteur spectral (V)
*
      NUTERM=KLTERM (NMTRMV,NVTRMV,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMV,NVTRMV)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &            ,ITTRMV,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &            ,NUINCV,NVDUCV,NBCOLV,NVNUCV
     &            ,NUINLV,NVDULV,NBLIGV,NVNULV
     &            ,INSTOV,NVSTOV,NVCORC,IATRDM,NIVIMV)                  !sdexplo
      NCOEFV=MAX(NBCOLV,NBLIGV)
      IF (ITYCAL.NE.INTYKL ('SPECTR')) CALL ERTERM (41,NMTRMV,NVTRMV)
      TYTRMV=TYPINT(ITTRMV)
*
*     Caracteristiques de la matrice des coefficients spectraux (M)
*
      NUTERM=KLTERM (NMTRMM,NVTRMM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMM,NVTRMM)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &            ,ITYPMS,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &            ,NUINCM,NVDUCM,NBCOLO,NVNUCM
     &            ,NUINLM,NVDULM,NBLIGN,NVNULM
     &            ,INSTOK,NVSTOK,NVCORC,IATRDM,NIVIMA)                  !sdexplo
*       
      IF ((ITYCAL.NE.INTYKL ('ELFLQU')).AND.
     &         (ITYCAL.NE.INTYKL ('SPECTR'))) 
     &                    CALL ERTERM (44,NMTRMM,NVTRMM)
      IF (NBCOLO.NE.NCOEFV) CALL ERTERM (43,NMTRMM,NVTRMM)
      TYTRMM=TYPINT(ITYPMS)
      NMSTOK=STOIND(INSTOK)
*
*     Creation ou mise a jour des caracteristiques du terme resultat (R)
*
      IF (NMTRMM.EQ.NMTERM.AND.NVTRMM.EQ.NVTERM) THEN
         IF (ITYSYM.NE.INDSYM(' ')) CALL ERTERM (28,NMTRMM,NVTRMM)
         IF (TYTRMV(1:1).EQ.'C'.AND.TYTRMM(1:1).NE.'C')
     &      CALL ERTERS (1,NMTERM,NVTERM,NMTRMV,NVTRMV)                 !utilite
      ELSE
         NUDONN=NDFDON
         NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.GT.0) THEN
            CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &                  ,ITTERM,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &                  ,KUCTRM,KVDCRM,KBCOLO,KVNCRM
     &                  ,KULTRM,KVDLRM,KBLIGN,KVNLRM
     &                  ,KNDSTR,KVSTRM,NVCORC,KATRDM,NIVIMT)            !sdexplo
         ENDIF
*
         ITTERM=ITYPMS
         IF (TYTRMV(1:1).EQ.'C') ITTERM=ITTRMV
         NUKALE=1
         ITYSYR=INDSYM(' ')
         CALL CRTERM (NMTERM,NVTERM,NBLIGN*NBCOLO,ITTERM,ITYCAL,NUKALE
     &               ,NUDONN,ITYSYR,NDFDSM,NUINCM,NVDUCM,NBCOLO,NVNULM
     &               ,NUINLM,NVDULM,NBLIGN,NVNULM,INSTOV,NVSTOV,NDFCOR
     &               ,IATRDM,NIVIMT,.FALSE.,CRETRM)                     !sdexplo
      ENDIF
      TYTERM=TYPINT(ITTERM)
*
*     Adresse des termes 
      CALL TBRR3  (ERCODE,NMTRMM,NVTRMM,MCTRMM,NMTRMV,NVTRMV,MCTRMV
     &                   ,NMTERM,NVTERM,MCTERM)
      IF (NMSTOK.EQ.'BIMORSE') 
     &   CALL TBRR1  (ERCODE,'&BMORS',NVSTOK,MCBMOR)
      CALL TBAR3  (ERCODE,NMTRMM,NVTRMM,MCTRMM,NMTRMV,NVTRMV,MCTRMV
     &                   ,NMTERM,NVTERM,MCTERM)
*
*     Multiplication
*
      IF (NMSTOK.EQ.'BIMORSE') THEN
         CALL TBAR1  (ERCODE,'&BMORS',NVSTOK,MCBMOR)
         CALL EXBMOR (MCBMOR,IST(MCBMOR),NBLIGN,NBPLL,MCPLAL,MCPLIL,LGL
     &                                  ,NBCOLO,NBPLU,MCPLAU,MCPLIU,LGU)!sdexplo
*        Calcul des coefficients diagonaux
         CALL TCOCOT (NBLIGN,TYTRMV,MCTRMV,RST,CST,TYTRMM,MCTRMM,RST,CST
     &               ,TYTERM,MCTERM,RST,CST)                            !utilite
*        Calcul des coefficients de la partie triangulaire inferieure
         CALL DXML   (0,TYTRMV,MCTRMV,NBLIGN
     &               ,IST(MCPLAL),IST(MCPLIL),TYTRMM,MCTRMM+NBLIGN
     &               ,MCTERM+NBLIGN,RST,CST)                            !multmat
*        Calcul des coefficients de la partie triangulaire superieure
         IF (ITYSYM.NE.INDSYM(' ')) LGL=0
         CALL DXMU   (0,TYTRMV,MCTRMV,NBCOLO
     &               ,IST(MCPLAU),IST(MCPLIU),TYTRMM,MCTRMM+NBLIGN+LGL
     &               ,MCTERM+NBLIGN+LGL,RST,CST)                        !multmat
         CALL TBSAVE ('&BMORS',NVSTOK)
*
      ELSEIF (NMSTOK(1:5).EQ.'PLEIN') THEN
*
         CALL DXPL  (TYTRMV,MCTRMV,NBLIGN,NBCOLO,TYTRMM,NMSTOK,MCTRMM
     &              ,MCTERM,RST,CST)                                    !multmat
*
      ENDIF
*
*--   Sauvegarde
      CALL TBSAVE (NMTRMV,NVTRMV)
      CALL TBSAVE (NMTRMM,NVTRMM)
      IF (NMTRMM.NE.NMTERM.OR.NVTRMM.NE.NVTERM)
     &   CALL TBSAVE (NMTERM,NVTERM)
* 
      CALL PRFXMJ (-1,'*EflMDM*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1 : D.Martin & C. Chambeyron (13 novembre 2009)
* - cas d'une matrice symetrique
* Version 0 : D.Martin (19 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !EflMDM
                                                                 