*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLOCO (NMTRMA,NVTRMA,NMTRMB,NVTRMB
     &                  ,NMTERM,NVTERM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 1989)
* Derniere modification : D.Martin (16 octobre 2006)
* Version 2
*
* Calcul d'un terme element finis localise orthogonal dans le cas ou les
* fonctions propres sont developpees sur forme d'exponentielles
* (calcul dit 'analytique')
*                      R_{ij} = A_{ik} * V_k * (B^t)_kj
* A designe la matrice du terme NMTRMA,NVTRMA
* B designe la matrice du terme NMTRMB,NVTRMB
* V designe un sous-ensemble du tableau complexe associe a la matrice (A)
*
*-- Arguments d'entree --
* NMTRMA nom du terme variationnel en ligne, spectral en colonne (A)
* NVTRMA son niveau
* NMTRMB nom du terme variationnel en colonne, spectral en ligne (B)
* NVTRMB son niveau
* NMTERM nom du terme Element Finis Localises assemble (R)
* NVTERM son niveau
* NIVIMP niveau d'impression du terme assemble (R)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRMA,NMTRMB,NMTERM
      INTEGER       NVTRMA,NVTRMB,NVTERM,NIVIMP
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      LOGICAL       IDMTRM
      INTEGER       INTTYP,INDSTO,INDSYM,INTDON,INTYKL,KLNIVE,KLTERM
      INTEGER       INTCOM,NUTERM,IADTRM,NIVTRM
     &             ,LGMTRM,LGDTRM,MCTRDO,MCMTRM,MCMDON,MCINCO
     &             ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,MCDONN,LGEDON,NBDONN,INCDON,NCHDON
     &             ,ITTRMA,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR,NUINCA
     &             ,KVDUCA,NBFDEV,KVNUCA,NUINLA,KVDULA,NBLIGA,KVNULA
     &             ,INDSTA,KVNUMS,KVCORC,IATRDO,NIVIMA,ITTERM
     &             ,ITYDON,NIVDON,ITYPDO,ITYRAS,NIVASS,ITYASS
     &             ,NCPINC,INTRPC,NBTNEC,NCPINL,INTRPL,NBTNEU,NBTFON
     &             ,NUINCB,KVDUCB,KVNUCB,NBLIGB,ITTRMB,NUINLB,KVDULB
     &             ,NBFFDV,KVNULB,INDSTB,KVCOCR,NIVIVC,NUINNN,IATOLD
     &             ,NVVOLD,ITYOLD,ITYKAL,NUCOLD,KVDOLD,NBCOLD,KVCOLD
     &             ,NULOLD,NBLOLD,NVCOLD,NIVOLD,NVSOLD,INDOLD,NCOOLD
     &             ,MCTRMA,MCTRMB,LGBMOR,MCBMOR,LGTERM,MCTERM,ITYPVE
     &             ,MCASSC,MCASSO,NBCSTA,MCTRMV,NCATR1,NCATR2,NCATR3,K
      CHARACTER     PRFXAS*8,STOIND*7,TYPINT*9,YKLINT*6
      CHARACTER     ERCODE*120,NOMDON*16,NODONA*16,TYPEVE*9
     &             ,TYPEMA*9,STOIMA*7,TYPEMB*9,STOIMB*7,STOIMR*7
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Efloco*')
*
      INTCOM = INTTYP ('COMPLEXE')
      CALL TBAR6  (ERCODE,'#TERDO',1,MCTRDO,'#OMTRM',1,MCMTRM
     &                   ,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN
     &                   ,'#OMDON',1,MCMDON,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !sdexplo
      IDMTRM=NMTRMA.EQ.NMTRMB.AND.NVTRMA.EQ.NVTRMB
*
      IF (NIVIMP.GT.0.AND.IMPSDR.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
         CALL PRNTRM (NMTRMA,NVTRMA,ERCODE(NCATR1+1:),NCATR2)
         CALL PRNTRM (NMTRMB,NVTRMB,ERCODE(NCATR1+NCATR2+1:),NCATR3)
         WRITE (IMPSDR,10001) PRFXAS(0),ERCODE(1:NCATR1)
     &                ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &                ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCATR3)
      ENDIF
*
*--   Recherche des caracteristiques du terme spectral en colonne
*
      NUTERM=KLTERM (NMTRMA,NVTRMA,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMA,NVTRMA)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVTRM
     &            ,ITTRMA,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &            ,NUINCA,KVDUCA,NBFDEV,KVNUCA
     &            ,NUINLA,KVDULA,NBLIGA,KVNULA
     &            ,INDSTA,KVNUMS,KVCORC,IATRDO,NIVIMA)                  !sdexplo
      TYPEMA=TYPINT (ITTRMA)                                            !utilite
      STOIMA=STOIND (INDSTA)                                            !utilite
      IF (ITYCAL.NE.INTYKL ('ELFLOC')) GOTO 99991
      IF (NUKALE.NE.-2) GOTO 99992
*
      ITTERM=ITTRMA
*
*--   Nom de la donnee
      CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NOMDON)                    !utilite
*     Type de la donnee associee
      CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)             !sdexplo
      IF (ITYDON.EQ.INTDON ('TABLEAU')) THEN                            !utilite
         ITYRAS=ITYDON
         NIVASS=NIVDON
         ITYASS=ITYPDO
         NODONA(1:NCHDON)=NOMDON(1:NCHDON)
      ELSEIF (ITYDON.EQ.INTDON ('FONCTION')) THEN                       !utilite
*        Caracteristiques de la donnee associee a la fonction affectee
         CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NODONA)                 !utilite
         CALL SDEXCO (NIVDON,IST(MCDONN),ITYRAS,NIVASS,ITYASS)          !sdexplo
         IF (ITYRAS.NE.INTDON ('TABLEAU')) CALL ERDONN (3,NODONA)       !utilite
      ELSE
         CALL ERDONN (5,NOMDON)                                         !utilite
      ENDIF
      IF (ITYPDO.NE.ITTERM) CALL ERDONN (13,NOMDON)                     !utilite
*
      CALL SDEXCO (NUINCA,IST(MCINCO),NCPINC,INTRPC,NBTNEC)             !sdexplo
      NBTFON=NBTNEC/1000000
      NBFDEV=NBTNEC-1000000*NBTFON
      CALL SDEXCO (NUINLA,IST(MCINCO),NCPINL,INTRPL,NBTNEU)             !sdexplo
*
*     Recherche des caracteristiques du terme spectral en ligne
*
      IF (IDMTRM) THEN
*
*        Si les 2 termes sont identiques le terme spectral en ligne (B)
*        est le transpose du terme spectral en colonne (A)
*
         NUINCB=NUINLA
         KVDUCB=KVDULA
         KVNUCB=KVNULA
         NBLIGB=NBLIGA
         NCPINC=NCPINL
         INDSTB=INDSTA
         TYPEMB=TYPEMA
         STOIMB=STOIMA
      ELSE
*
         NUTERM=KLTERM (NMTRMB,NVTRMB,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMB,NVTRMB)                 !utilite
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM),NIVTRM
     &              ,ITTRMB,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &              ,NUINCB,KVDUCB,NBLIGB,KVNUCB
     &              ,NUINLB,KVDULB,NBFFDV,KVNULB
     &              ,INDSTB,KVNUMS,KVCOCR,IATRDO,NIVIVC)               !sdexplo
         TYPEMB=TYPINT (ITTRMB)                                            !utilite
         STOIMB=STOIND (INDSTB)                                            !utilite
         IF (ITTRMB.EQ.INTCOM) ITTERM=INTCOM
         IF (NUKALE.EQ.-2) THEN
*           Le terme attendu spectral en ligne est spectral en colonne
            NUINNN=NUINCB
            NUINCB=NUINLB
            NUINLB=NUINNN
            NBLIGB=NBFFDV
            KVDUCB=KVDULB
            KVNUCB=KVNULB
         ENDIF
         CALL SDEXCO (NUINCB,IST(MCINCO),NCPINC,INTRPC,NBTNEU)          !sdexplo
         IF (NUINCA.NE.NUINLB) GOTO 99993
         IF (NUINLA.NE.NUINCB) GOTO 99994
      ENDIF
*
*     Mise a jour des structures de description pour le terme resultat
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN
         CALL ALFANU (NBCHNT,NMTERM)                                    !utilite
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NCHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTERM)                 !sdexplo
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
         NUTERM=NBTERM
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         IATOLD=0
         NVSOLD=NDFSTO
         NUDONN=NDFDON
      ELSE
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM),  NVVOLD
     &               ,ITYOLD,ITYKAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &               ,NUCOLD,KVDOLD,NBCOLD,KVCOLD
     &               ,NULOLD,KVDOLD,NBLOLD,KVCOLD
     &               ,INDOLD,NVSOLD,NCOOLD,IATOLD,NIVOLD)               !sdexplo
      END IF
*
      STOIMR='BIMORSE'
      IF (NUINLA.GT.NUINCB) THEN
         STOIMR='PLEIN-L'
      ELSEIF (NUINLA.LT.NUINCB) THEN
         STOIMR='PLEIN-C'
      ENDIF
      INDOLD=INDSTO(STOIMR)
      IF (STOIMR.EQ.'BIMORSE'.AND.NVSOLD.EQ.NDFSTO) NVSOLD=KLNIVE ()    !sdexplo
      ITYCAL=INTYKL ('ELFLOC')
      ITYSYM=INDSYM (' ')                                               !utilite
      NUKALE=1
      CALL PUTTRM (IST(IADTRM),NVTERM
     &            ,ITTERM,ITYCAL,NUKALE,NUDONN,ITYSYM,NDFDSM
     &            ,NUINCB,KVDUCB,NBLIGB,KVNUCB
     &            ,NUINLA,KVDULA,NBLIGA,KVNULA
     &            ,INDOLD,NVSOLD,NDFCOR,IATOLD,NIVIMP)                  !sdexplo
*
*     Creation eventuelle de la structure Bi-Morse
*
      IF (STOIMR.EQ.'BIMORSE') CALL CRBMOP (NVSOLD,NBLIGA,NBLIGB,IST)   !sdexplo
*
*     Creation du tableau resultat
*
      LGTERM=NBLIGA*NBLIGB*NCPINC*NCPINL
      CALL TBCREE (NMTERM,NVTERM,ITTERM,LGTERM,'c')
*
*     Adresse des termes
      CALL TBRR2  (ERCODE,NODONA(1:NCHDON),NIVASS,MCASSC
     &                   ,NMTRMA,NVTRMA,MCTRMA)
      IF (.NOT.IDMTRM) CALL TBRR1  (ERCODE,NMTRMB,NVTRMB,MCTRMB)
      CALL TBAR3  (ERCODE,NODONA(1:NCHDON),NIVASS,MCASSC
     &                   ,NMTRMA,NVTRMA,MCTRMA,NMTERM,NVTERM,MCTERM)
      MCTRMB=MCTRMA
      IF (.NOT.IDMTRM) CALL TBAR1  (ERCODE,NMTRMB,NVTRMB,MCTRMB)
*
*     Determination de l'adresse du tableau TABOME dans le tableau associe
      MCASSO=2*MCASSC-1
      NBCSTA=IST(MCASSO)
      IF (NBFDEV.NE.IST(MCASSO+2)) GOTO 99995
      IF (NBTFON.NE.IST(MCASSO+3)) GOTO 99996
      MCTRMV=MCASSC+4+NBCSTA+3*NBTFON*NBFDEV
      ITYPVE=ITTRMA
      IF (ITYPVE.EQ.INTTYP ('REEL')) MCTRMV=2*MCTRMV-1
      TYPEVE=TYPINT (ITYPVE)
*
*     Produit des termes Elements finis localises
*
      IF (STOIMR.EQ.'BIMORSE') THEN
*        Stockage de la matrice sous forme Bimorse
         CALL EFLBRO (TYPEMA,NBLIGA,STOIMA,MCTRMA
     &                      ,NBLIGB,STOIMB,MCTRMB
     &               ,TYPEVE,NBFDEV,MCTRMV,ITYSYM,MCTERM,RST,CST)       !efloca
      ELSE
*        Stockage de la matrice sous forme pleine
         CALL EFLPRO (TYPEMA,NBLIGA,STOIMA,MCTRMA
     &                      ,NBLIGB,STOIMB,MCTRMB
     &               ,TYPEVE,NBFDEV,MCTRMV,STOIMR,MCTERM,RST,CST)       !efloca
      ENDIF
*
*--   Sauvegarde & Impressions
      IF (NIVIMP.GT.0) CALL PRTERM (NMTERM,NVTERM,NIVIMP,IMPSDR)        !sdexplo
      CALL TBSAVE (NMTRMA,NVTRMA)
      CALL TBSAVE (NODONA(1:NCHDON),NIVASS)
      IF (.NOT.IDMTRM) CALL TBSAVE (NMTRMB,NVTRMB)
      CALL TBSAVE (NMTERM,NVTERM)
*
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
         WRITE (IMPPAL,10000) PRFXAS (0),ERCODE(1:NCATR1)
     &                       ,YKLINT(ITYCAL),TYPINT(ITTERM),STOIMR
      ENDIF
*
      CALL PRFXMJ (-1,'*Efloco*')
      RETURN
*-----------------------------------------------------------------------
10001 FORMAT(/T2,A8,' Calcul du terme element finis localise assemble '
     &,A/T11,'Produit des termes ',A,' * V * (',A,')t')
10000 FORMAT(T2,A8,' Terme ',A,' de type ',A,', ',A,:,', ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTRMA,NVTRMA,ERCODE,NCATR1)
      CALL BAISE  ('Le terme '//ERCODE(1:NCATR1)
     &//' n''est pas de type element finis localises.')
99992 CALL PRNTRM (NMTRMA,NVTRMA,ERCODE,NCATR1)
      CALL BAISE  ('Le terme '//ERCODE(1:NCATR1)
     &//' n''est pas variationnel en ligne ou n''est pas calcule.')
99993 CALL PRNTRM (NMTRMB,NVTRMB,ERCODE,NCATR1)
      CALL PRNTRM (NMTRMA,NVTRMA,ERCODE(NCATR1+1:),NCATR2)
      CALL ENCLER (NUINLB,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+2))
      CALL ENCLER (NUINCA,ERCODE(NCATR1+NCATR2+3:NCATR1+NCATR2+4))
      CALL BAISE  ('Inconnue '//ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+2)
     &//' en colonne pour '//ERCODE(1:NCATR1)
     &//' et inconnue '//ERCODE(NCATR1+NCATR2+3:NCATR1+NCATR2+4)
     &//' en ligne pour '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' differentes.')
99994 CALL PRNTRM (NMTRMB,NVTRMB,ERCODE,NCATR1)
      CALL PRNTRM (NMTRMA,NVTRMA,ERCODE(NCATR1+1:),NCATR2)
      CALL ENCLER (NUINLA,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+2))
      CALL ENCLER (NUINCB,ERCODE(NCATR1+NCATR2+3:NCATR1+NCATR2+4))
      CALL BAISE  ('Inconnue '//ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+2)
     &//' en colonne pour '//ERCODE(1:NCATR1)
     &//' et inconnue '//ERCODE(NCATR1+NCATR2+3:NCATR1+NCATR2+4)
     &//' en ligne pour '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &//' differentes.')
99995 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  ('Calcul de '//ERCODE(1:NCATR1)
     &//'. Incoherence sur le nombre de fonctions spectrales')
99996 CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  ('Calcul de '//ERCODE(1:NCATR1)
     &//'. Incoherence sur le nombre de termes par fonction spectrale.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Version 2 : D.Martin (16 octobre 2006)
* - introduction des appels de CRBMOR et CRNEDO, mise a jour des appels de
*   EFLBRO et EFLPRO
* Version 1.0.4 : D.Martin (15 Juin 2003)
*
* Version 0 : O.DeBayser (Juin 1989)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Efloco
