*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLPRO (TYPEMA,NBLIMA,STOIMA,MCTRMA
     &                         ,NBLIMB,STOIMB,MCTRMB
     &                  ,TYPESP,NBCOSP,MCTRSP,STOIMR,MCTERM,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Juin 1989)
* Derniere modification : D.Martin (12 octobre 2006)
* Version 2
*
* Calcul par 'produit tensoriel' d'un terme element finis localise PLEIN
*                       R_{ij} = A_{ik} * S_k * (B*)_{kj}
*
*-- Arguments d'entree --
* TYPEMA type (REEL ou COMPLEXE) des matrices A et B
* NBLIMA nombre de lignes de la matrice A et du resultat R
* STOIMA indice du type de stockage de la premiere matrice A
* MCTRMA adresse de la matrice A
* NBLIMB nombre de lignes de la matrice B et de colonnes du resultat R
* STOIMB indice du type de stockage de la matrice B
* MCTRMB adresse de la matrice B
* TYPESP type (REEL ou COMPLEXE) du terme spectral S
* NBCOSP nombre de colonnes de la matrice A et du nombre delignes/colonnes de S
* MCTRSP adresse du terme spectral S
* STOIMR type de stockage de la matrice resultat (PLEIN-L/C)
* MCTERM adresse du resultat R
* RST,CST super tableau, version REELLE et COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPEMA,STOIMA,STOIMB,TYPESP,STOIMR
      INTEGER NBLIMA,MCTRMA,NBLIMB,MCTRMB,NBCOSP,MCTRSP,MCTERM
      REAL    RST(*)
      COMPLEX CST(*)
*
      INTEGER INCMAC,INCMBL,INCMAL,INCMBC,I,J,AI1,AIK,SK,BJ1,BJK,RIJ
     &       ,INCREC
      REAL    RSOM
      COMPLEX CSOM
*-----------------------------------------------------------------------
*
*     Increments de changement de ligne ou de colonne selon le stockage
*
*     INCMAC : increment d'adresse pour le changement de ligne dans A
*     INCMAC : increment d'adresse pour le changement de colonne dans A
      IF (STOIMA(1:7).EQ.'PLEIN-C') THEN
         INCMAC=NBLIMA  
         INCMAL=1        
      ELSEIF (STOIMA(1:7).EQ.'PLEIN-L') THEN
         INCMAC=1
         INCMAL=NBCOSP   
      ENDIF
*     INCMBL : increment d'adresse pour le changement de ligne dans B
*     INCMBC : increment d'adresse pour le changement de colonne dans B
      IF (STOIMB(1:7).EQ.'PLEIN-C') THEN
         INCMBL=NBLIMB
         INCMBC=1          
      ELSEIF (STOIMB(1:7).EQ.'PLEIN-L') THEN
         INCMBL=1
         INCMBC=NBCOSP    
      ENDIF
*     INCREC : increment d'adresse pour le changement de colonne dans R
      IF (STOIMR(1:7).EQ.'PLEIN-C') THEN
         INCREC=NBLIMA
      ELSEIF (STOIMR(1:7).EQ.'PLEIN-L') THEN
         INCREC=1  
      ENDIF
      RIJ=MCTERM
      AI1=MCTRMA
*
      IF (TYPEMA(1:1).EQ.'C') THEN
*
*        Les matrices EFL sont complexes
*
         DO 444 I=1,NBLIMA
            IF (STOIMR(1:7).EQ.'PLEIN-C') RIJ=MCTERM+I-1
            BJ1=MCTRMB
            DO 441 J=1,NBLIMB
               AIK=AI1
               BJK=BJ1
               CSOM=0.
               IF (TYPESP(1:1).EQ.'C') THEN
*              Terme spectral complexe
                  DO 440 SK=MCTRSP,MCTRSP-1+NBCOSP
                     CSOM=CSOM+CST(AIK)*CST(SK)*CONJG(CST(BJK))
                     AIK=AIK+INCMAC
                     BJK=BJK+INCMBL
440               CONTINUE
               ELSE
*              Terme spectral reel
                  DO 420 SK=MCTRSP,MCTRSP-1+NBCOSP
                     CSOM=CSOM+CST(AIK)*RST(SK)*CONJG(CST(BJK))
                     AIK=AIK+INCMAC
                     BJK=BJK+INCMBL
420               CONTINUE
               ENDIF
               CST(RIJ)=CSOM
               RIJ=RIJ+INCREC
               BJ1=BJ1+INCMBC
441         CONTINUE
            AI1=AI1+INCMAL
444      CONTINUE
*
      ELSE
*
*        Les matrices EFL sont reelles
*
         IF (TYPESP(1:1).EQ.'C') THEN
*           Terme spectral complexe
            DO 244 I=1,NBLIMA
               IF (STOIMR(1:7).EQ.'PLEIN-C') RIJ=MCTERM+I-1
               BJ1=MCTRMB
               DO 241 J=1,NBLIMB
                  AIK=AI1
                  BJK=BJ1
                  CSOM=0.
                  DO 240 SK=MCTRSP,MCTRSP-1+NBCOSP
                     CSOM=CSOM+RST(AIK)*CST(SK)*RST(BJK)
                     AIK=AIK+INCMAC
                     BJK=BJK+INCMBL
240               CONTINUE
                  CST(RIJ)=CSOM
                  RIJ=RIJ+INCREC
                  BJ1=BJ1+INCMBC
241            CONTINUE
               AI1=AI1+INCMAL
244         CONTINUE
         ELSE
*           Terme spectral reel
            DO 222 I=1,NBLIMA
               IF (STOIMR(1:7).EQ.'PLEIN-C') RIJ=MCTERM+I-1
               BJ1=MCTRMB
               DO 221 J=1,NBLIMB
                  AIK=AI1
                  BJK=BJ1
                  RSOM=0.
                  DO 220 SK=MCTRSP,MCTRSP-1+NBCOSP
                     RSOM=RSOM+RST(AIK)*RST(SK)*RST(BJK)
                     AIK=AIK+INCMAC
                     BJK=BJK+INCMBL
220               CONTINUE
                  RST(RIJ)=RSOM
                  RIJ=RIJ+INCREC
                  BJ1=BJ1+INCMBC
221            CONTINUE
               AI1=AI1+INCMAL
222         CONTINUE
         ENDIF
*
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (12 octobre 2006)
* - 
* Version 1.4 : D.Martin (6 fevrier 2004)
*  - 
* Version 1 : O.DeBayser (Juin 1989)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !ElfPro
