*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLQTR (NDMDOM,NDMDOE,NBELDO,NXLIST,INCRDO,NXDODO
     &                  ,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Avril 1992)
* Derniere modification : D.Martin (30 Novembre 1999)
*
* Calcul des termes Elements Finis Localises sur un domaine de Calcul
*
*-- Arguments --
* NDMDOM Dimension du domaine de calcul
* NBELDO nombre d'elements (de dimension NDMDOM) du domaine
* NXLIST adresse relative des numeros d'elements dans le #ISTEL du domaine
* INCRDO nombre d'attributs d'un domaine de calcul
* NXDODO adressse relative dans #TERDO des caracteristiques du domaine
* IMPFCH Unite d'impression des messages
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDMDOM,NBELDO,NXLIST,INCRDO,NXDODO,IMPFCH
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER ERCODE*120,NOMDON*16,NODONA*16,NOMTRM*16,TYPINT*4
      COMMON/FORMAH/ERCODE
      EQUIVALENCE (ERCODE(73:73),NOMDON),(ERCODE(89:89),NODONA)
      EQUIVALENCE (ERCODE(105:105),NOMWRK)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Eflqtr*')
*
      CALL TBAR3 (ERCODE,'#TERDO',1,MCTRDO,'$SDTRM',1,MCDTRM 
     &                                    ,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !Sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !Sdexplo
      CALL GETDOM (IST(MCTRDO+NXDODO),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &           ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &           ,NBDLFX,NVNUDC,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY
     &           ,NBDLEY,NBNEFY,NBDLFY,NVNUDL,NVCORC,INUTIL,NBTRDO
     &           ,IMPDOM)                                               !Sdexplo
*
*     Boucle sur les termes elements finis localises
      NXTRDO=NXDODO+INCRDO
      DO 100 NUINT=1,NBTRDO
         CALL TBAR4 (ERCODE,'#TERDO',1,MCTRDO,'$SDTRM',1,MCDTRM
     &                     ,'$DONNE',1,MCDONN,'#OMDON',1,MCMDON)
         NUTERM=IST(MCTRDO+NXTRDO)
         IADTRM=MCDTRM+LGETRM+(NUTERM-1)*INCTRM
         CALL GETTRM (IST(IADTRM),NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN     
     &               ,ITYSYM,IPTDIR,NUINCC,KVDUMC,KBCOLO,KVNUMC,NUINCL
     &               ,KVDUML,KBLIGN,KVNUML,INDSTK,KVNUMS,KVCORC,IATRDO
     &               ,NIVIMP)                                           !Sdexplo
*
         IF(ITYCAL.EQ.INTYKL ('ELFLOC').AND.NUKALE.GT.0) THEN
*
*        Tests de presence des donnees
         IF(NUDONN.LE.0) CALL BAISE('Il doit y avoir une donnee EFLOC') !Utilite
*        Nom de la donnee
         CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NOMDON)                 !Utilite
*        Type de la donnee
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !Sdexplo
         IF(ITYDON.EQ.INTDON ('TABLEAU')) THEN                          !Utilite
            ITYRAS=ITYDON
            NIVASS=NIVDON
            ITYASS=ITYPDO
            NODONA(:NCHDON)=NOMDON(:NCHDON)
         ELSE IF(ITYDON.EQ.INTDON('FONCTION')) THEN                     !Utilite
*           Caracteristiques de la donnee associee a la fonction
            CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NODONA)              !Utilite
            CALL SDEXCO (NIVDON,IST(MCDONN),ITYRAS,NIVASS,ITYASS)       !Sdexplo
            IF(ITYRAS.NE.INTDON ('TABLEAU')) CALL BAISE                 !Utilite
     &        ('La donnee associee a la fonction doit etre un tableau') !Utilite
         ELSE
            CALL BAISE ('La donnee element finis localise doit etre '   !Utilite
     &          //'une fonction avec un tableau associe ou un tableau') !Utilite
         ENDIF
*
*        Preparation des tableaux auxiliaires
         CALL EFLADC (NUKALE,NDMDOM,NUINCC,NUINCL,NCPINL,NCPINC,IDLHRC
     &               ,IDLHRL,KBCOLO,KBLIGN,NBFDEV,NBTFON,NBNEFX,NBNEFY
     &               ,NBDLFX,NBDLFY,ITYPTR,IADINT,IAPLOC,LGWORC,IADCOF
     &               ,IANEFA,IADLFA,IADUDL,IAGDLN,IALINL,LGWORK)        !Calefl
*        Creation du tableau de travail
         CALL TBCREE ('&WORKF',1,4,LGWORC,'c')
         CALL TBCREE ('&WORKF',2,2,LGWORK,'c')
         CALL TBRR1  (ERCODE,'#RGNDO',NUDOMK,MCRGND)
         CALL TBRR1  (ERCODE,'#GNEDO',KVNUML,MCNEDO)
         IF (KVNUMC.GT.0.AND.KVNUMC.NE.KVNUML) 
     &      CALL TBRR1 (ERCODE,'#GNEDO',KVNUMC,MCNEDO)
*
*        Nom du terme Element Finis Localises
         CALL TBAR1  (ERCODE,'#OMTRM',1,MCMTRM)
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NOMTRM)                 !Utilite
         CALL TBRR1  (ERCODE,NOMTRM(1:NCHTRM),NIVTRM,LGTERM)            !Utilite
         CALL TBAR7  (ERCODE,NODONA(1:NCHDON),NIVASS,MCASSC
     &                      ,NOMTRM(1:NCHTRM),NIVTRM,MCTERM
     &                      ,'&WORKF',1,MCWORC,'&WORKF',2,MCWORK
     &                      ,'#ISTEL',NUDOMG,MCLIST 
     &                      ,'#ORPTL',NUDOMK,MCCORP
     &                      ,'#RGNDO',NUDOMK,MCRGND)
         MCBLOK=MCLIST
         IF (NBBBLK.GE.2) CALL TBAR1 (ERCODE,'#LOKEL',1,MCBLOK)
         CALL TAZERO (LGWORC,'COMPLEXE',MCWORC,AST,IST,RST,CST)         !Utilite
         CALL TAZERO (LGWORK,'REEL',MCWORK,AST,IST,RST,CST)             !Utilite
*        Mise a zero du terme
         CALL TAZERO (LGTERM,TYPINT(ITYPTR),MCTERM,AST,IST,RST,CST)     !Utilite
*
*        Recherche des coefficients des fonctions spectrales
*
         MCASSO=2*MCASSC-1
         NBCSTA=IST(MCASSO)
         IF (NBFDEV.NE.IST(MCASSO+2)) CALL BAISE
     &            ('Incoherence sur le nombre de fonctions spectrales') !Utilite
         IF (NBTFON.NE.IST(MCASSO+3)) CALL BAISE 
     &   ('Incoherence sur le nombre de termes par fonction spectrale') !Utilite
         IGEOME=IST(MCASSO+4)
         MCCSTA=MCASSC+4
         MCDGAM=MCCSTA+NBCSTA
         MCDNU =MCDGAM+NBFDEV*NBTFON
         MCDALF=MCDNU +NBFDEV*NBTFON
*
*        Calculs des termes elements finis localises
*
         IF(NUKALE.LE.2) THEN
*          Cas variationnel en ligne, spectral en colonne
           MCGOLI=MCRGND+1
           MCPLOC=MCWORK+IAPLOC
           IF(ITYPTR.EQ.INTTYP ('COMPLEXE')) MCPLOC=MCWORC+IAPLOC
           CALL TBAR1  (ERCODE,'#GNEDO',KVNUML,MCNEDO)
           CALL TRPLOC (NDMDOM,NDMDOE,NBELDO,ITYPTR,MCTERM,MCDGAM,MCDNU
     &                 ,MCDALF,MCWORC+IADINT,MCPLOC,NBFDEV,NBTFON,IGEOME
     &                 ,MCCSTA,KBLIGN,INTRPL,IDLHRL,NCPINL,IST(MCBLOK)
     &                 ,IST(MCLIST+NXLIST),RST(MCCORP+2),IST(MCCORP)
     &                 ,IST(MCGOLI),IST(MCNEDO+2),RST(MCWORK+IADCOF)
     &                 ,IST(MCWORK+IANEFA),IST(MCWORK+IADLFA)
     &                 ,IST(MCWORK+IADUDL),IST(MCWORK+IAGDLN)
     &                 ,IST(MCWORK+IALINL),RST,CST,NIVIMP,IMPFCH)
         ELSE IF(NUKALE.EQ.3) THEN
*          Cas spectral en ligne, variationnel en colonne
           MCGOCO=MCRGND-1+IST(MCRGND)
           MCPLOC=MCWORK+IAPLOC
           IF(ITYPTR.EQ.INTTYP ('COMPLEXE')) MCPLOC=MCWORC+IAPLOC
           CALL TBAR1  (ERCODE,'#GNEDO',KVNUMC,MCNEDO)
           CALL TRPLOC (NDMDOM,NDMDOE,NBELDO,ITYPTR,MCTERM,MCDGAM,MCDNU
     &                 ,MCDALF,MCWORC+IADINT,MCPLOC,NBFDEV,NBTFON,IGEOME
     &                 ,MCCSTA,KBCOLO,INTRPC,IDLHRC,NCPINC,IST(MCBLOK)
     &                 ,IST(MCLIST+NXLIST),RST(MCCORP+2),IST(MCCORP)
     &                 ,IST(MCGOCO),IST(MCNEDO+2),RST(MCWORK+IADCOF)
     &                 ,IST(MCWORK+IANEFA),IST(MCWORK+IADLFA)
     &                 ,IST(MCWORK+IADUDL),IST(MCWORK+IAGDLN)
     &                 ,IST(MCWORK+IALINL),RST,CST,NIVIMP,IMPFCH)
*        ELSE IF(NUKALE.EQ.4) THEN
*          Cas spectral en ligne et en colonne
*          CALL TRQLOC (NDMDOM,NDMDOE,NBELDO,NXLIST,ITYPTR,MCTERM
*     &                ,MCWORK+IAPLOC
         ENDIF
         CALL TBTUER ('&WORKF',1)
         CALL TBTUER ('&WORKF',2)
         ENDIF
100      NXTRDO=NXTRDO+1
*
      CALL PRFXMJ (-1,'*Eflqtr*')
                                                                    END !Eflqtr
