*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLTRD (NBTRDO,INCRDO,NXDODO,NBNECO,NBNELI,NVNUMC
     &                  ,NVNUML,NIVALL,NVCORC,KALEFL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988)
* Derniere modification : D.Martin (16 octobre 2006)
* Version 2
*  
* Creation des tableaux des termes
* 'Elements Finis localises'
* sur un domaine de calcul. Mise a jour de la structure $SDTRM pour ces termes.
*  
*-- Arguments d'entree -- 
* NBTRDO Nombre de choses a faire sur le domaine (vachement clair)
*        En fait NBTRDO est la somme des nombres de matrices E.F.,
*        de conditions essentielles, de conditions de transmission, etc...
* INCRDO Nombre de descripteurs pour un domaine de calcul 
* NXDODO Adresse relative de depart dans la structure #TERDO pour le domaine  
* NBNECO nombre de colonnes d'un terme matrice 'elements finis'
* NBNELI    -       lignes       -        -        -      -
* NVNUMC niveau du tableau #GNEDO en colonne  
* NVNUML niveau du tableau #GNEDO en ligne
* NIVALL niveau des tableaux de stockage BiMorse, Morse-Ligne, Morse-Colonne 
* NVCORC niveau du tableau &NORMA sur le domaine
*-- Arguments en sortie --
* KALEFL indicateur de calculs de termes 'Element Finis localises'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER KALEFL
      INTEGER   NBTRDO,INCRDO,NXDODO,NBNECO,NBNELI,NVNUMC,NVNUML,NIVALL
     &         ,NVCORC
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER  INDSTO,INTDON,INTYKL,INTTYP,KLNIVE                       !utilite
      INTEGER  TAYTRM,INDSTP,INTEFL,INTDOT,INTDOF,NXTRDO,MCTRDO
     &        ,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCMTRM,IADTRM
     &        ,MCDONN,LGEDON,NBDONN,INCDON,NCHDON,MCMDON
     &        ,MCNEDO,MCINCO,NCPINL,INTINL,NBTNEL,NCPINC,INTINC,NBTNEC
     &        ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &        ,NUINCC,KVDUMC,KBCOLO,KVNUMC,NUINCL,KVDUML,KBLIGN
     &        ,KVNUML,INDSTK,KVNUMS,KVCORC,IATRDO,NIVIMP
     &        ,NVSTKM,NWCORC,NWKALE,ITYDON,NIVDON,ITYPDO,NIVASS
     &        ,NUTERM,NWDODO,IT,LGTAB,NVTAB
      CHARACTER     ERCODE*120,NOMDON*16,NOMTRM*16,READRE,NWNUME*2
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (ERCODE(89:89),NOMDON),(ERCODE(105:105),NOMTRM)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EflTrd*')
*
      READRE='Y'
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
      KALEFL='N'
*
      INDSTP=INDSTO ('PLEIN-C')                                         !utilite
*
      INTDOT=INTDON ('TABLEAU')                                         !utilite
      INTDOF=INTDON ('FONCTION')                                        !utilite
*
      INTEFL=INTYKL ('ELFLOC')                                          !utilite
*
      NXTRDO=NXDODO+INCRDO
      DO 1 IT=1,NBTRDO
         IF (READRE.EQ.'Y')
     &   CALL TBAR6(ERCODE,'#TERDO',1,MCTRDO,'#NCONU',1,MCINCO
     &                    ,'$DONNE',1,MCDONN,'#OMTRM',1,MCMTRM
     &                    ,'#OMDON',1,MCMDON,'$SDTRM',1,MCDTRM)
         READRE='N'
         NUTERM=IST(MCTRDO+NXTRDO)
*        Adresse dans $SDTRM des caracteristiques du terme courant
         IADTRM=LGETRM+(NUTERM-1)*INCTRM
*
*        Caracteristiques predefinies du terme courant
         CALL GETTRM (IST(MCDTRM+IADTRM),  NIVTRM,ITYPTR,ITYCAL,NUKALE
     &               ,NUDONN,ITYSYM,NVDSMB,NUINCC,KVDUMC,KBCOLO,KVNUMC
     &               ,NUINCL,KVDUML,KBLIGN,KVNUML,INDSTK,KVNUMS,KVCORC
     &               ,IATRDO,NIVIMP)                                    !sdexplo
*        Nom du terme
         CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NOMTRM(1:NCHTRM))       !utilite
*
*        Si le terme a deja ete calcule et que son calcul n'a pas ete
*        redemande , on saute ...
         IF (NUKALE.GT.0) THEN
            NWDODO = NXDODO+1
*
            NWKALE = NUKALE
            IF (KVNUMC.LE.0) THEN
               KVNUMC=NVNUMC
               KBCOLO=NBNECO
            ENDIF
            IF (KVNUML.LE.0) THEN
               KVNUML=NVNUML
               KBLIGN=NBNELI
            ENDIF
            TAYTRM=0
*            IF (INDSTK.EQ.-99999) INDSTK=INDSTP
            NVSTKM = NDFSTO
            NWCORC = NVCORC
            NCPINL = 1
            INTINL = 99999
            NCPINC = 1
            INTINC = 99999
            NWNUME='NN'
            IF (NUINCL.GT.0)
     &         CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTINL,NBTNEL)    !utilite
            IF (NUINCC.GT.0)
     &         CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTINC,NBTNEC)    !utilite
*
            IF (ITYCAL.EQ.INTEFL) THEN
*
*              Termes 'Elements Finis localises'
*
               KALEFL='Y'
               IF (NUKALE.EQ.2.OR.NUKALE.EQ.4) THEN
*
*                 Terme 'spectral en colonne'
*
                  KBCOLO=NBTNEC-1000000*(NBTNEC/1000000)
                  KVNUMC=-KBCOLO
               ENDIF
               IF (NUKALE.EQ.3.OR.NUKALE.EQ.4) THEN
*
*                 Terme 'spectral en ligne'
*
                  KBLIGN=NBTNEL-1000000*(NBTNEL/1000000)
                  KVNUML=-KBLIGN
               ENDIF
               TAYTRM=KBLIGN*NCPINL*KBCOLO*NCPINC
               INDSTK=INDSTP
               ITYSYM=NDFSYM
            ELSE
               GOTO 1
            ENDIF
*
*           Prise en compte de la donnee affectee au terme courant
*
            ITYPTR=INTTYP ('REEL')                                      !utilite
            LGTAB=0
            IF (NUDONN.NE.0) THEN
               CALL GETCHN(AST(MCMDON),NCHDON,NUDONN,NOMDON)            !utilite
               CALL SDEXCO(NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)     !utilite
*
               IF (ITYDON.EQ.INTDOT) THEN
*                 Recherche de la donnee TABLEAU affectee au terme
                  ITYPTR=ITYPDO
                  LGTAB=1
                  NVTAB=NIVDON
               ELSEIF (ITYDON.EQ.INTDOF) THEN
                  ITYPTR=ITYPDO
                  IF (NIVDON.GT.0) THEN
                  CALL SDEXCO (NIVDON,IST(MCDONN),ITYDON,NIVASS,ITYPDO) !utilite
                     IF (ITYDON.EQ.INTDOT) THEN
*                       Recherche du tableau associe a
*                       une donnee FONCTION affectee au terme
                        CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NOMDON)  !utilite
                        LGTAB=1
                        NVTAB=NIVASS
                     ENDIF
                  ENDIF
               ENDIF
               IF (LGTAB.EQ.1) THEN
                  ERCODE(1:1)='!'  
                  CALL TBRR1  (ERCODE,NOMDON(1:NCHDON),NIVASS,LGTAB)
                  READRE='Y'
               ENDIF
            ENDIF
*
*           Creation des numerotations triviales #GNEDO
*
            IF (KVNUMC.NE.NDFNUM) CALL CRNEDO (KVNUMC,KBCOLO,IST)       !sdexplo
            IF (KVNUML.NE.NDFNUM.AND.KVNUML.NE.KVNUMC)
     &         CALL CRNEDO (KVNUML,KBLIGN,IST)                          !sdexplo
*
*           Creation du terme
*           (la mise a zero des termes du domaine est faite dans EFLQTR)
*
            IF (READRE.EQ.'Y') CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
*
            CALL PUTTRM (IST(MCDTRM+IADTRM),NIVTRM,ITYPTR,ITYCAL,NWKALE
     &                  ,NUDONN,ITYSYM,NVDSMB,NUINCC,KVDUMC,KBCOLO
     &                  ,KVNUMC,NUINCL,KVDUML,KBLIGN,KVNUML,INDSTK
     &                  ,NVSTKM,NWCORC,NWDODO,NIVIMP)                   !sdexplo
*
            IF (NIVIMP.GT.3) THEN
               IF (READRE.EQ.'Y') CALL TBAR1  (ERCODE,'#OMTRM',1,MCMTRM)
               CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPSDR)      !prsd
            ENDIF
*
            IF (TAYTRM.GT.0) THEN
              CALL TBCREE (NOMTRM(:NCHTRM),NIVTRM,ITYPTR,TAYTRM,'c')
              READRE='Y'
            ENDIF
         ENDIF
1     NXTRDO=NXTRDO+1
      CALL PRFXMJ (-1,'*EflTrd*')  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 octobre 2006)
* - modification de l'appel de CRNEDO
* Version 1.0.1 : D.Martin (7 avril 2000)
*
* Version 0 : D.Martin & O.deBayser (Avril 1988)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !EflTrd
