*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLXRE (VNU,NBQ,BETA,TABINT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (Octobre 1990)
* Derniere modification : D.Martin (9 Avril 1999)
*
* Calcul par recurrence (formule instable pour nu petit) de l'integrale
*                      Sommme de exp(vnu*x) x**nuq dx .
*
*-- Arguments d'entree --
* VNU    coefficient de l'exposant de l'exponentielle des integrands
* NBQ    exposant maximum pour le monome des integrands
* BETA   exposant du coefficient exponentiel
* TABINT resultat: i(nu,0)=(1/nu)*(exp(nu)-1)
*                  i(nu,q)=(1/nu)*(exp(nu)-q*i(nu,q-1))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBQ
      COMPLEX VNU,BETA,TABINT(0:*)
*
      INTEGER NUQ
      COMPLEX ENU,SURNU
*-----------------------------------------------------------------------
      ENU=CEXP (VNU+BETA)
      SURNU=1./VNU
      TABINT(0)=SURNU*(ENU-EXP(BETA))
      DO 1 NUQ=1,NBQ
         TABINT(NUQ)=(ENU-NUQ*TABINT(NUQ-1))*SURNU
1     CONTINUE
                                                                    END !Eflxre
