*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EFLXSE (VNU,NBTERS,NUQMIN,NUQMAX,BETA,TABINT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (Octobre 1990)
* Derniere modification : D.Martin (9 Avril 1999)
*
* Calcul par serie tronquee de l'integrale (algorithme de Horner)
*           Somme de exp(vnu*x) x**nuq dx .
*
*-- Arguments d'entree --
* VNU    coefficient de l'exposant de l'exponentielle de l'integrand
* NBTERS nombre de termes dans la serie tronquee
* NUQMIN exposant minimum pour le monome des integrands
* NUQMAX exposant maximum pour le monome des integrands
* BETA   exposant du coeficient exponentiel
* TABINT resultat i(nu,q)= somme de (nu**i)/(i!(i+q+1)) pour i=0 a NBTERS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBTERS,NUQMIN,NUQMAX
      COMPLEX VNU,BETA,TABINT(0:*)
*
      INTEGER NUQ,I
      REAL    FACT,FAC
      COMPLEX SOM
*-------------------------------------------------------------------------
      FACT=1.
      DO 1 I=2,NBTERS
         FACT=FACT/I
1     CONTINUE
*
      DO 3 NUQ=NUQMIN,NUQMAX
         FAC=FACT
         SOM=FACT/(NUQ+1+NBTERS)
         DO 2 I=NBTERS,1,-1
            FAC=FAC*I
            SOM=VNU*SOM+FAC/(NUQ+I)
2        CONTINUE
         TABINT(NUQ)=SOM*EXP(BETA)
3     CONTINUE
                                                                    END !EflXse
