*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  EFLOCN (NMTRML,NVTRML,NMTRMC,NVTRMC,NMSPEC,NVSPEC 
     &                   ,ORTHO,NMFLOC,NVFLOC,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Juin 89)
* Derniere modification : D.Martin (10 Juillet 1997)
*  
* Calcul d'un terme element finis localise assemble
*  
*-- Arguments d'entree -- 
* NMTRML: Nom du terme variationnel en ligne, spectral en colonne
* NVTRML: Son niveau
* NMTRMC: Nom du terme variationnel en colonne, spectral en ligne
* NVTRMC: Son niveau
* NMSPEC: Nom du terme spectral en ligne et en colonne
* NVSPEC: Son niveau
* NMFLOC: Nom du terme assemble resultat
* NVFLOC: Son niveau
* NIVIMP: niveau d'impression du terme resultat
*-- Remarques --
* Il y a deux possibilitees:
* 1) cas orthogonal (ORTHO='ORTHO'): on fait le produit Aik * A(transpose)kj,
*    et NMSPEC,NVSPEC n'est pas utilise.
* 2) cas non-orthogonal (ORTHO=' '): on fait l'assemblage multi-inconnue 
*    des trois termes en entree.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTRML,NMTRMC,NMSPEC,NMFLOC,ORTHO
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*  
      LOGICAL       IDMTRM
      CHARACTER     ERCODE*120,NOMDON*16,NODONA*16 
      CHARACTER*4   TYMATR,TYVECT
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (ERCODE(81:81),TYMATR),(ERCODE(89:89),TYVECT)
*---------------------------------------------------------------------
      CALL PRFXMJ (1,'*Eflocn*')
*  
      CALL TBRR2  (ERCODE,'$SDTRM',1,LGDTRM,'#OMTRM',1,LGMTRM)          !alodyn
      CALL TBAR6  (ERCODE,'#TERDO',1,MCTRDO,'#OMTRM',1,MCMTRM
     &                   ,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN
     &                   ,'#OMDON',1,MCMDON,'#NCONU',1,MCINCO)          !alodyn
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !sdexplo
      IDMTRM=NMTRML.EQ.NMTRMC.AND.NVTRML.EQ.NVTRMC
*
      IF (NIVIMP.GT.0.AND.IMPSDR.GT.0) THEN 
         CALL PRNTRM (NMFLOC,NVFLOC,ERCODE,NCATR1)
         CALL PRNTRM (NMTRML,NVTRML,ERCODE(NCATR1+1:),NCATR2)
         CALL PRNTRM (NMTRMC,NVTRMC,ERCODE(NCATR1+NCATR2+1:),NCATR3)
         WRITE (IMPSDR,10000) ERCODE(1:NCATR1) 
     &                       ,ERCODE(NCATR1+1:NCATR1+NCATR2) 
     &                     ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCATR3) 
      ENDIF
      IF (ORTHO(1:1).NE.'O') 
     &   CALL BAISE ('Le cas non-orthogonal n''est pas encore fait')
*  
*     Recherche des caracteristiques du terme variationnel en ligne
      NUTERM=KLTERM(NMTRML,NVTRML,AST(MCMTRM),IST(MCDTRM))              !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRML,NVTRML)  
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),MVVMAT,ITYRML,ITYCAL,NUKALE,NUDONN
     &         ,ITSYMA,IPTDIR,NUINCL,NVNUCL,NBFDEV,NUINLL,NVNULL,NBNELM 
     &               ,INDSTK,NVNUMS,NVCOMA,INUTI1,INUTI2,IATRDO,NIVIMA) !sdexplo
      ITFLOC=ITYRML
*  
*     Nom de la donnee 'Fonction'
      CALL GETCHN(AST(MCMDON),NCHDON,NUDONN,NOMDON)                     !utilite
*     Type de la donnee associee
      CALL SDEXCO(NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)              !sdexplo
      IF(ITYDON.NE.INTDON('FONCTION')) CALL BAISE
     &                       ('La donnee element finis localise doite '
     &                   //'etre une fonction avec un tableau associe') !utilite
      IF(NIVDON.GT.0) THEN
*        Caracteristiques de la donnee associee a la fonction associee
         CALL GETCHN(AST(MCMDON),NCHDON,NIVDON,NODONA)                  !utilite
         CALL SDEXCO(NIVDON,IST(MCDONN),ITYRAS,NIVASS,ITYASS)           !sdexplo
         IF(ITYRAS.NE.INTDON('TABLEAU')) CALL BAISE
     &        ('La donnee associee a la fonction doit etre un tableau') !utilite
         CALL SDEXCO(NUINCL,IST(MCINCO),NCPINC,INTRPC,NBTNEC)           !sdexplo
         NBTFON=NBTNEC/1000000
         NBFDEV=NBTNEC-1000000*NBTFON
      ELSE
         CALL BAISE('La donnee associee a la fonction doit etre un '
     &                                                     //'tableau') !utilite
      ENDIF
*  
      IF(.NOT.IDMTRM) THEN
*        Recherche des caracteristiques du terme variationnel en colonne
         NUTERM=KLTERM(NMTRMC,NVTRMC,AST(MCMTRM),IST(MCDTRM))           !sdexplo
         IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMC,NVTRMC)  
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM),NVVVEC,ITYRMC,ITYCAL,NUKALE,NUDONN
     &         ,ITYSYM,IPTDIR,NUINCC,NVNUCC,NBNECM,NUINLC,NVNULC,NBFDEV 
     &               ,INDSKV,NVNNNN,NVCOCR,INUTI1,INUTI2,IATRDO,NIVIVC) !sdexplo
         IF(ITYRML.NE.ITYRMC) ITFLOC=INTTYP('COMPLEXE')
         IF(NUINCL.NE.NUINLC) GO TO 99993 
         IF(NUINLL.NE.NUINCC) GO TO 99994 
      ENDIF
*  
*     Mise a jour des structures de description pour le terme element 
*     finis localise resultat
      NUTERM=KLTERM(NMFLOC,NVFLOC,AST(MCMTRM),IST(MCDTRM))              !sdexplo
      IF(NUTERM.LE.0) THEN 
         CALL ALFANU(NBCHNT,NMFLOC)                                     !utilite
         CALL SDAJST('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)          !sdexplo
         CALL SDAJST('#OMTRM',1,LGMTRM,0,NCHTRM,NBTERM,1)               !sdexplo
         CALL TBAR2(ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)         !alodyn
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMFLOC)                 !sdexplo
         CALL SDMKDB(IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)           !sdexplo
         NUTERM=NBTERM 
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         IATOLD=0  
         INDOLD=0  
         NVSOLD=0  
         NUDONN=0 
      ELSE 
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM(IST(IADTRM)    ,NVVOLD,ITYOLD,ITYKAL,NUKOLD,NUDONN 
     &  ,ITYSYM,IPTDIR,NUCOLD,NVCOLD,NBCOLD,NULOLD,NVLOLD,NBLOLD,INDOLD
     &                       ,NVSOLD,NCOOLD,INUTI1,INUTI2,IATOLD,NIVOLD)!sdexplo
      ENDIF
*  
      ITYCAL=INTYKL('Assemb')  
      INDOLD=INDSTO('PLEIN')
      NVSOLD=KLNIVE()                                                   !sdexplo
      NVCOOR=NVCOCR
      IF(NVCOOR.LE.0) NVCOOR=NCOOLD
      CALL PUTTRM (IST(IADTRM)      ,NVFLOC,ITFLOC,ITYCAL,1     ,NUDONN
     &  ,0     ,0     ,NUINCC,NVNUCC,NBNECM,NUINLL,NVNULL,NBNELM,INDOLD 
     &                       ,NVSOLD,NVCOOR,INUTI1,INUTI2,IATOLD,NIVIMP)!sdexplo
*  
*     Creation du tableau resultat 
*******************************
*     initialisation bidon
      PRINT*,'eflocn ne marche pas'
      NCPINL=0
*******************************
      LGFLOC=NBNELM*NBNECM*NCPINC*NCPINL
      CALL TBCREE (NMFLOC,NVFLOC,ITFLOC,LGFLOC,'*Asmloc* resultat')     !alodyn
*
      IF(ORTHO(1:1).EQ.'O') THEN
*
***      Cas orthogonal: multiplication NMTRML * NMTRMC dans NMFLOC
*  
*        le resultat est une matrice pleine consideree comme MORSE-Ligne
*        pour l'assemblage ulterieur
*******************************
*     initialisation bidon
      NBLIGN=0
*******************************
         LGNECP=4+3*NBLIGN
         CALL TBCREE('&PLAGE',NVSOLD,1,LGNECP,'*Coumat* Table de'
     &            //' compactage morse pour un bout de matrice pleine') !alodyn
         CALL TBAR1 (ERCODE,'&PLAGE',NVSOLD,MCPLAG)                     !alodyn
         CALL CMPCPL (NBNELM,NBNECM,IST(MCPLAG))                        !morse
         CALL TBSAVE ('&PLAGE',NVSOLD)                                  !alodyn
*
         CALL TBAR4(ERCODE,NMTRML,NVTRML,MCTRML,NMTRMC,NVTRMC,MCTRMC    !alodyn
     &             ,NODONA(:NCHDON),NIVASS,MCASSO,NMFLOC,NVFLOC,MCFLOC) !alodyn
*
*        Determination du tableau TABOME
*******************************
*     initialisation bidon
      LGLIBR=0
*******************************
         IST(MCASSO)=LGLIBR
*******************************
*     initialisation bidon
      NBSTAB=0
*******************************
         IST(MCASSO+1)=NBSTAB
*        remarque: les trois premier sous-tableaux sont complexe; il faut
*        donc veiller a l'alignement des adresses pour respecter
*        l'equivalence entre les super-tableaux.
         MCRGAM=MCASSO+LGLIBR
         MCDGAM=MCRGAM/2
         NUL=MCRGAM-MCDGAM*2
         IF(NUL.EQ.0) MCDGAM=MCDGAM+1
*******************************
*     initialisation bidon
      LGSTAB=0
*******************************
         MCDOME=MCDGAM+3*LGSTAB
         IF(ITFLOC.EQ.INTYP('REEL')) MCDOME=2*MCDOME-1
*
*        Produit Elements finis localises
         CALL EFLPRO (NBNELM,NBNECM,NBFDEV,ITFLOC,MCTRML,MCTRMC
     &               ,MCDOME,MCFLOC,RST,CST)                            !calefl
      ELSE
         CALL BAISE('le cas non-orthogonal n''est pas encore pret')     !utilite
      ENDIF
*  
*     Impressions et Sauvegardes ...
      IF(NIVIMP.GT.0) CALL PRTERM (NMFLOC,NVFLOC,NIVIMP,IMPSDR)         !sdexplo
      CALL TBTUER ('&WORKF',1)                                          !alodyn
      CALL TBSAVE (NMTRML,NVTRML)                                       !alodyn
      IF(.NOT.IDMTRM)        CALL TBSAVE (NMTRMC,NVTRMC)                !alodyn
      IF(NMSPEC(1:1).NE.' ') CALL TBSAVE (NMSPEC,NVSPEC)                !alodyn
      CALL TBSAVE (NMFLOC,NVFLOC)                                       !alodyn
      ERCODE=NMFLOC
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMFLOC,NVFLOC,ERCODE,NCATR1)
         WRITE (IMPPAL,10001) ERCODE(1:NCATR1)
      ENDIF
*  
      CALL PRFXMJ (-1,'*Eflocn*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*Eflocn* Calcul du terme element finis localise ',A
     &/T11,'Produit du terme ',A,' et du terme ',A)  
10001 FORMAT(/' *Eflocn* Calcul du terme ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99993 CALL ENCLER(NUINCM,TYMATR)
      CALL ENCLER(NUINLV,TYVECT)
      CALL PRNTRM (NMTRMC,NVTRMC,ERCODE,NCATR1)
      CALL PRNTRM (NMTRML,NVTRML,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE ('Inconnue # '//TYMATR//' en colonne pour '
     &//ERCODE(1:NCATR1)//' et inconnue # '//TYVECT//' en ligne pour '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)//' differentes')
99994 CALL ENCLER(NUINLM,TYMATR)
      CALL ENCLER(NUINCV,TYVECT)
      CALL PRNTRM (NMTRMC,NVTRMC,ERCODE,NCATR1)
      CALL PRNTRM (NMTRML,NVTRML,ERCODE(NCATR1+1:),NCATR2)
      CALL BAISE ('Inconnue # '//TYMATR//' en ligne pour '
     &//ERCODE(1:NCATR1)//' et inconnue # '//TYVECT//' en colonne pour '
     &//ERCODE(NCATR1+1:NCATR1+NCATR2)//' differentes')
                                                                    END !Eflocn
