*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ELQLOC (ITYPTR,MCDNU,MCDGAM,MCDINT,MCPLOC,NBFDEV
     &                  ,NBTFON,THEMIN,THEMAX,TABCOF,NDEGRE,NBDLEL
     &                  ,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (Octobre 90)
* Derniere modification (O.DeBayser) le 23 Mars 1992
*
* Determination de la matrice locale "elements finis localises"
*
*-- Arguments d'entree --
* ITYPTR Type du resultat (reel ou complex)
* MCDNU  Adresse des exposants des termes des fonctions propres e.f.l.
* MCDGAM Adresse des coefficients des termes des fonctions propres e.f.l.
* MCDINT Adresse des integrales exactes
* MCPLOC Adresse du resultat dans le tableau du bon type
* NBFDEV Nombre de fonctions propres e.f.l.
* NBTFON Nombre de termes composant chaque fonction propre
* THEMIN,THEMAX: extremite du domaine d'integration
* TABCOF Tableau des coefficients de chaque monomes des fonctions de base
* NDEGRE Degre des fonctions de base
* NBDLEL Nombre de degres de liberte par element
* RST,CST Super tableau
*-- Remarque --
* Il se peut que les fonctions spectrales soient implicitement reelles. Mais
* comme elles sont formalisees par des combinaisons d'exponentielles, les
* calculs les concernant, sont effectues "en complexe" systematiquement.
* Le caractere eventuellement reel n'est pris en compte que dans la matrice
* elementaire en tronquant les nombres complexes.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL TABCOF (0:NDEGRE,*),RST(*)
      COMPLEX CST(*)
*
      COMPLEX VNU,EX,FAC,SOM
*-----------------------------------------------------------------------
      ECART=THEMAX-THEMIN
      ABSEC=ABS(ECART)
*
      IADNU =MCDNU
      IADGAM=MCDGAM
      IAPLAV=MCPLOC
*
      IF(ITYPTR.EQ.INTTYP('COMPLEXE')) THEN
         DO 10 IK=1,NBFDEV
            DO 7 IP=1,NBTFON
               VNU=CST(IADNU)*ECART
               CALL EFLINT (VNU,NDEGRE,CST(MCDINT))
               EX=CEXP(CST(IADNU)*THEMIN)
               FAC=EX*CST(IADGAM)*ABSEC
               IAPLOC=IAPLAV
               DO 3 IDL=1,NBDLEL
                  SOM=0.
                  DO 2 IQ=0,NDEGRE
2                    SOM=SOM+TABCOF(NDEGRE-IQ,IDL)*CST(MCDINT+IQ)
                  CST(IAPLOC)=CST(IAPLOC)+SOM*FAC
3              IAPLOC=IAPLOC+1
            IADNU =IADNU +1
7           IADGAM=IADGAM+1
10       IAPLAV=IAPLAV+NBDLEL
      ELSE
         DO 50 IK=1,NBFDEV
            DO 47 IP=1,NBTFON
               VNU=CST(IADNU)*ECART
               CALL EFLINT (VNU,NDEGRE,CST(MCDINT))
               EX=CEXP(CST(IADNU)*THEMIN)
               FAC=EX*CST(IADGAM)*ABSEC
               IAPLOC=IAPLAV
               DO 43 IDL=1,NBDLEL
                  SOM=0.
                  DO 42 IQ=0,NDEGRE
42                   SOM=SOM+TABCOF(NDEGRE-IQ,IDL)*CST(MCDINT+IQ)
                  RST(IAPLOC)=RST(IAPLOC)+SOM*FAC
43             IAPLOC=IAPLOC+1
            IADNU =IADNU +1
47          IADGAM=IADGAM+1
50       IAPLAV=IAPLAV+NBDLEL
      ENDIF
                                                                    END !Elqloc
