*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TRQLOC (NDMDOM,NBELDO,NXLIST,ITYPTR,MCTERM,MCPLOC 
     &                  ,TABNU,TABGAM,NBFDEV,NBTFON,IGEOM ,RAYON 
     &                  ,COORDH,COORDV,NBLIGN,COLLIG,INTRPL,IDLHRL
     &                  ,NCPINL,BLOKEL,LISTEL,CORPTL,NBPTEL,IRGNDO
     &                  ,NGNEDO,TABCOF,TABINT,NUNEFA,NUDLFA,NEDUDL
     &                  ,IRGDLN,NDLINL,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: M.Lenoir, B.Vigan, C.Politis, M.Rouquette (Octobre 90)
* Derniere modification (O.DeBayser) le 23 Mars 1992
*
* Construction d'un tableau elements finis localises preassembles
*
*-- Arguments d'entree --
* NDMDOM: Dimension d'espace du domaine
* NBELDO: Nombre d'elements
* NXLIST: Pointeurs sur le premier element du tableau LISTEL du domaine
* ITYPTR: Type de declaration du terme (reel ou complexe)
* MCTERM: Adresse du terme preassemble dans le tableau du bon type
* MCPLOC: Adresse du terme elementaire dans le tableau du bon type
* TABNU : Tableau des exposants des termes des fonctions propres e.f.l.
* TABGAM: Tableau des coefficients des termes des fonctions propres e.f.l.
* NBFDEV: Nombre de fonctions propres e.f.l.
* NBTFON: Nombre de termes composant chaque fonction propre
* IGEOM : =1 (domaine horizontal), 2 (domaine vertical), 3 (circulaire)
* RAYON : rayon du domaine (dans le cas d'un cercle)
* COORDH,COORDV: coordonees du centre du domaine (cas du cercle)
* NBLIGN: Nombre de d.l. sur le domaine
* COLLIG: Indicateur element finis en ligne ou en collone pour preassembler
* INTRPL: Numero de type de l'interpolation de l'inconnue element finis
* IDLHRL: Indice de presence de degre de liberte de hermite
* NCPINL: Nombre de composantes de l'inconnue element finis
* BLOKEL: Tableau des types d'elements
* LISTEL: Liste elements-faces du domaine
* CORPTL: Tableau des points par elements du domaine
* NBPTEL: Nombre de noeuds dans l'element
* IRGNDO: Tableau contenant pour chaque element le numero global des noeuds
* NGNEDO: Tableau contenant la numerotation globale du domaine
* TABCOF: Tableau des coefficients de chaque monomes des fonctions de base
* TABINT: Tableau auxilaire
* NUNEFA: Numerotation locale des noeuds de la face
* NUDLFA: Numerotation locale des d.l. de la face
* NEDUDL: Pointeur vers le noeud du d.l.
* IRGDLN: Tableau contenant pour chaque element le numero global des d.l.
* NDLINL: Tableau contenant pour chaque element le nombre de d.l. par noeud
* NIVIMP: Niveau d'impression
* IMPFCH: Unite logique d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER BLOKEL(*),LISTEL(*),NUDLFA(*),NUNEFA(*),NDLINL(*)
      INTEGER IRGNDO(*),NGNEDO(*),NBPTEL(*),NEDUDL(*),IRGDLN(*)
      CHARACTER*(*) COLLIG
      REAL    CORPTL(*),TABCOF(*),RST(*)
      COMPLEX TABNU(*),TABGAM(*),TABINT(*),CST(*)
*
      INCLUDE 'CONTEX'
*---------------------------------------------------------------------
      CALL PRFXMJ (1,'*Trqloc*')
      CALL BAISE  ('Procedure manifestement JAMAIS testee!'
     &            //' Voir arugments de EFLGBO dans TRPLOC!')
*
      IARGND=1
      NUTYFV=0
      LISRAN=NXLIST
      INCCOR=1
*
*     Boucle sur tous les elements du domaine
*
      DO 1 IEL=1,NBELDO
*        informations pour les elements finis
         CALL EXSTEL (NDMDOM,LISRAN,LISTEL,BLOKEL,NUTGEO,INTRPL,NUEL
     &               ,NUTYAV,NUTYLE,LAGHER,KCL,NBNEEL,NBDLEL,NUF,NUFAAV 
     &               ,NUTYFA,NBNEFA,NBDLFA,NUNEFA,NUDLFA,0,IMPFCH)      !SDexplo
*        tableau de numerotation des d.l. (interpolation Hermitte)
         IF (IDLHRL.GT.0) CALL ELEMDL (NUTYFA,NBNEFA,NBDLFA,NEDUDL
     &                                ,IRGDLN,NDLINL)                   !Ef2d
*        tableau des coefficients des fonctions de bases
         IF (NUTYFA.NE.NUTYFV) CALL ELEMCF (NUTYFA,NBDLFA,TABCOF)       !Ef2d
         NUTYFV=NUTYFA
*        Recherche des extremites de l' element
         CALL EFLGBO (NDIM,CORPTL(INCCOR),MCASSO,CST
     &               ,THEMIN,THEMAX)                                    !Calefl
         INCCOR=INCCOR+NBPTEL(INCCOR)*NDIM+2
*        Calculs elementaires
         NDEGRE=INTRPL
         CALL ELQLOC (ITYPTR,MCPLOC,TABNU ,TABGAM,NBFDEV,NBTFON,THEMIN
     &               ,THEMAX,TABCOF,NDEGRE,NBDLFA,TABINT,RST,CST)       !CalEfl
*        Preassemblage
         CALL ASQLOC (ITYPTR,MCTERM,MCPLOC,COLLIG,NBNEFA,NBDLFA,NBLIGN
     &               ,NBFDEV,NUNEFA,NDLINL,IRGNDO(IARGND+1),IDLHRL
     &               ,NGNEDO,NCPINL)                                    !CalEfl
         IARGND=IARGND+IRGNDO(IARGND)+1
1     CONTINUE

      CALL PRFXMJ (-1,'*Trqloc*')
                                                                    END !Trqloc
