*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLCISO (NDIM,NBTEL,NBBBLK,NU1BLK,BLOKEL,NPTMAX
     &                  ,NUMPTL,CORPTL,CORPTG)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Octobre 1995)
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*
* Remplissage du tableau GLobal des Coordonnees des points du maillage
*                        --         - 
* c'est a dire pour l'interpolation ISOparametrique
*                                   --
*-- Arguments --
* NDIM   dimension d'espace
* NBTEL  nombre total d'elements du maillaghe
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du 1er bloc (utilise si 1 seul bloc) 
* BLOKEL tableau de description des elements par blocs
* NPTMAX nombre max. de points dans un element du maillage
* NUMPTL tableau de numerotation global des points du maillage par element
*        on a 'INTEGER NUMPTL(NPTMAX,NBTEL)'
* CORPTL tableau des coordonnees des points element par element
*        on a 'REAL    CORPTL(1+NDIM*NPTMAX,NBTEL)
* CORPTG tableau global des coordonnees des points
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDIM,NBTEL,NBBBLK,NU1BLK,BLOKEL(*),NPTMAX,NUMPTL(*)
      REAL          CORPTL(*),CORPTG(*)
*
      INTEGER       ADCORL,ADNUMG,AWCORL,AWNUMG,ELEMEN,NUTGEO
     &             ,NBELBK,LGEBLK,PTRBBK,NUBBLK,NUELBK,NUPOIN,ADCORG
     &             ,AWCORG,LAG,KCL,NBSOMT,NBARET,NBFACE,NBNEEL,NBPTEL
     &             ,NBNF,NBPTSF,NBNA,NBPTSA
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GlcIso*')
      ADNUMG = 1 
      ADCORL = 2
      ELEMEN = 0  
      NUTGEO = NU1BLK
      NBELBK = NBTEL 
      IF (NBBBLK.GT.1) THEN 
         LGEBLK = BLOKEL(1)
         NBELBK = BLOKEL(LGEBLK+1)
         PTRBBK = LGEBLK+1+BLOKEL(3)
      ENDIF
      DO 20 NUBBLK = 1,NBBBLK
*
*        Nombre de points et noeuds de l'element
*
         CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBNEEL,NBPTEL,NBNA,NBPTSA,NBNF,NBPTSF)            !ef3d
         DO 10 NUELBK = 1,NBELBK
             ELEMEN=ELEMEN+1
             AWNUMG = ADNUMG
             AWCORL = ADCORL
             DO 5 NUPOIN = 1,NBPTEL
                ADCORG = NDIM*(NUMPTL(AWNUMG)-1)
                AWNUMG = AWNUMG+1
                DO 1 AWCORG = 1+ADCORG,NDIM+ADCORG
                   CORPTG (AWCORG) = CORPTL(AWCORL)
                   AWCORL = AWCORL+1
1               CONTINUE
5            CONTINUE
            ADCORL = ADCORL+1+NPTMAX*NDIM
            ADNUMG = ADNUMG+NPTMAX
10       CONTINUE
         IF (NBBBLK.GT.1) THEN
            NBELBK = BLOKEL(PTRBBK)
            NUTGEO = BLOKEL(PTRBBK+1)  
            PTRBBK = PTRBBK+BLOKEL(3)
         ENDIF
20    CONTINUE
      CALL PRFXMJ (-1,'*GlcIso*')
                                                                    END !GlcIso
