*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLCNIS (NDIM,INTERP,NBTEL,NBBBLK,NU1BLK,BLOKEL,NBPTEX
     &                  ,NBNEEX,NGNEEL,CORPTL,CORLOC,FCTBAS,COORNL
     &                  ,CORNOE,REAMAX,EPSMAC,NIVIMP,IMPFCH,IMPMES)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Octobre 1995)
* Derniere modification : D.Martin (25 juin 2002)
* Version 1.0.2
*
* Remplissage du tableau GLobal des CooRdonnees des noeuds du probleme
*                        --         -
* pour une (un numero de type d') interpolation donnee Non ISoparametrique
*                                                      -   --
*-- Arguments --
* NDIM   dimension d'espace
* INTERP numero de type de l'interpolation
* NBTEL  nombre total d'elements du maillaghe
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du 1er bloc (utilise si 1 seul bloc) 
* BLOKEL tableau de description des elements par blocs
* NBPTEX nombre max. de points dans un element
* NBNEEX nombre max. de noeuds dans un element pour l'interpolation en cours
* NGNEEL tableau de numerotation global des noeuds pour l'interpolation
*        on a "INTEGER NGNEEL(NBNEEX,NBTEL)
* CORPTL tableau des coordonnees des points element par element
*        on a "REAL CORPTL(1+NDIM*NBPTEX,NBTEL)"
* CORLOC tableau de travail pour les coordonnees locales
*        on a "REAL CORLOC(NDIM,NBPTEX)
* FCTBAS tableau de travail pour les valeurs des fonctions de base
* COORNL tableau de travail pour les coordonnees de noeuds dans l'element
*        on a "REAL CORLOC(NDIM,NBNEEX)
* CORNOE tableau global des coordonnees des noeuds
*        on a "REAL CORNOE(NDIM,*)
* REAMAX plus grand reel de la machine (pour test)
* EPSMAC epsilon machine (pour test)
* NIVIMP,IMPFCH quincaillerie habituelle
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NDIM,INTERP,NBTEL,NBBBLK,NU1BLK,BLOKEL(*),NBPTEX
     &       ,NBNEEX,NGNEEL(*),NIVIMP,IMPFCH,IMPMES
      REAL    CORPTL(*),CORNOE(*),CORLOC(*),FCTBAS(*),COORNL(*)
     &       ,REAMAX,EPSMAC
*
      INTEGER ADCORP,ADCORL,ADNUMG,AWNUMG,ELEMEN,NUTGEO,NBELBK
     &       ,LGEBLK,PTRBBK,NUBBLK,NUELBK,NUNEEL,ADCORN,AWCORN
     &       ,LAG,KCL,NBSOMT,NBARET,NBFACE,NBPTEL,NBNEEL
     &       ,NBDLEL,NBPTA,NBDLA,NBPTF,NBDLF,NIVAMP,NUTYLE
*
     &       ,NBDIFF,NBDFFF,IDCORL,IWCORL
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GlcNis*')
*
      NIVAMP = NIVIMP
      IF (NIVIMP.LE.3) NIVAMP=0
      ADNUMG = 1 
      ADCORP = 2
      ELEMEN = 0  
      NBELBK = NBTEL
      NUTGEO = NU1BLK 
      IF (NBBBLK.GT.1) THEN 
         LGEBLK = BLOKEL(1)
         NBELBK = BLOKEL(LGEBLK+1)
         PTRBBK = LGEBLK+1+BLOKEL(3)
      ENDIF
      NBDIFF=0
      DO 20 NUBBLK = 1,NBBBLK
*
*        Nombre de points de l'element
*
         CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBPTEL,NBDLEL,NBPTA,NBDLA,NBPTF,NBDLF)            !ef3d
*
*        Nombre de noeuds de l'element
*
         NUTYLE=INTERP+100*(NUTGEO/100)
         CALL ELEMNB (NUTYLE,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBNEEL,NBDLEL,NBPTA,NBDLA,NBPTF,NBDLF)            !ef3d
*
*        Coordonnees des noeuds de l'element de reference
*
         CALL ELEMCO (NUTYLE,NDIM,CORLOC)                               !ef3d
*
         DO 10 NUELBK = 1,NBELBK
             ELEMEN=ELEMEN+1
             CALL CORNEL (NDIM,NDIM,NUTGEO,NBPTEL,CORPTL(ADCORP)     
     &                   ,NBNEEL,CORLOC,FCTBAS,COORNL,NIVAMP,IMPFCH)    !calelem
             ADCORL=1
             AWNUMG = ADNUMG
             DO 5 NUNEEL = 1,NBNEEL
                ADCORN = NDIM*(NGNEEL(AWNUMG)-1)
                DO 1 AWCORN = 1+ADCORN,NDIM+ADCORN
                   CORNOE(AWCORN) = COORNL(ADCORL)
                   ADCORL = ADCORL+1
1               CONTINUE
*               ENDIF
                AWNUMG = AWNUMG+1
5            CONTINUE
            ADCORP = ADCORP + 1+NBPTEX*NDIM
            ADNUMG = ADNUMG + NBNEEX
10       CONTINUE
         IF (NBBBLK.GT.1) THEN
            NBELBK = BLOKEL(PTRBBK)
            NUTGEO = BLOKEL(PTRBBK+1)  
            PTRBBK = PTRBBK+BLOKEL(3)
         ENDIF
20    CONTINUE
      CALL PRFXMJ (-1,'*GlcNis*')
*-----------------------------------------------------------------------
10000 FORMAT (' Element Noeud  Ngneel ---------Nouvelles coordonnees'
     &,'--------- ---------Anciennes coordonnees---------')
10001 FORMAT (I8,I6,I8,2(' ',3E13.5))
                                                                    END !GlcNis
