*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLNUFA (NDIMBO,NBPTEX,NGPTEL,NBTEL ,NBBBLK,NU1BLK
     &                  ,BLOKEL,NBTBOG,NBBOCX,NUGBOL,NUPRBO,NBSOMX
     &                  ,NUSOBO,NGNEBO,NUNEBO,NUDLBO,NEDUDL,IRGDLN
     &                  ,NDLINN,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.deBayser (Decembre 1988), d'apres P.L.George (Modulef)
* Refonte complete (D.Martin) Octobre 1995
* Derniere modification : D.Martin (29 juin 2002)
* Version 1.0.2
*  
* Creation de la numerotation des faces ou aretes d'un maillage (2D ou 3D)  
* a partir de la numerotation de noeuds des points-sommets de la triangulation.
*  
*-- Arguments d'entree -- 
* NDIMBO = 2 pour les faces (3D), = 1 pour les aretes (2D ou 3D) 
* NBPTEX nombre maximum de points des elements du maillage
* NGPTEL numerotation des points du maillage element par element  
* NBTEL  nombre total d'elements du maillage  
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du premier bloc  
* BLOKEL tableau de description des elements du maillage par blocs
* NBBOCX nombre max. de faces/aretes dans les elements du maillage
* NBSOMX nombre max. de sommets dans les faces/aretes des elements du maillage
*  
*-- Arguments de sortie --
* NBTBOG nombre de faces/aretes du maillage  
* NUGBOL numerotation des faces/aretes des elements
*  
*-- Tableaux de travail --
* NGNEBO tableaux des numeros des points d'une face ranges par ordre croissant
* NUPRBO numero de la premiere face contenant un point
* NUSOBO premier argument : numero de la face suivante ayant le meme 1er noeud
*        arguments suivants : numeros de noeuds des sommets de la face
* NUNEBO tableau des numeros locaux des points d'un face
* NUDLBO idem pour les d.l.
* NEDUDL numeros des noeuds supports de d.l.
* IRGNDL tableau inutilise
* NDLINN tableau inutilise 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NDIMBO,NBPTEX,NGPTEL(NBPTEX,*),NBTEL,NBBBLK,NU1BLK
     &         ,BLOKEL(*),NBTBOG,NBBOCX,NUGBOL(NBBOCX,*),NUPRBO(*)
     &         ,NBSOMX,NUSOBO(NBSOMX,*),NGNEBO(*)
     &         ,NUNEBO(*),NUDLBO(*),NEDUDL(*),IRGDLN(*),NDLINN(*)
     &         ,NIVIMP,IMPFCH  
*
      CHARACTER PRFXAS*8
      INTEGER   PTRBLK,NBELBK,NUTGBK,LGEBLK,NUBBLK,NUELBK
     &         ,LAG,KCL,NBSOMT,NBBORD,NBNEEL,NBDLEL,NBNEFX
     &         ,NBDLFX,NBNEAX,NBDLAX,NUBORD,NUTBOG,NBDLBO
     &         ,NBSOME,NBARET,NBFACE,NUSOMT,IDLBO,JSOMT,KSOMT,ELEMEN
     &         ,IANF,IANF1,NGNEE1,NGNEEI,NBAREW,NBFACW
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GlnuFa*')
*
      IF (IMPFCH.GT.0.AND.NIVIMP.GT.5) THEN
         IF (NDIMBO.EQ.2) THEN
            WRITE (IMPFCH,10000) PRFXAS(1)//'>*GlnuFa*'
     &                   ,'faces',(' face',NUBORD,NUBORD=1,NBBOCX)
         ELSE IF (NDIMBO.EQ.1) THEN
            WRITE (IMPFCH,10000) PRFXAS(1)//'>*GlnuFa*'
     &                   ,'aretes',('arete',NUBORD,NUBORD=1,NBBOCX)
         ENDIF
      ENDIF
*
*     Caracteristiques des blocs d'elements du maillage
*
      NBELBK=NBTEL 
      NUTGBK=NU1BLK
      IF (NBBBLK.GT.1) THEN 
         LGEBLK=BLOKEL(1) 
         NBELBK=BLOKEL(LGEBLK+1)  
         PTRBLK=LGEBLK+1+BLOKEL(3) 
      ENDIF
*
*     Boucle sur tous les elements du maillage effectuee par blocs 
*     d'elements consecutifs de meme type (NUTGBK) 
      ELEMEN=0  
      DO 30 NUBBLK=1,NBBBLK
*  
*        Nombre de faces/aretes des elements du bloc ? -> NBBORD
*  
         CALL ELEMNB (NUTGBK,LAG,KCL,NBSOME,NBARET,NBFACE
     &               ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)        !ef3d
         IF (LAG.NE.0) GOTO 99991
         NBBORD=NBARET
         IF (NDIMBO.EQ.2) NBBORD=NBFACE
         DO 29 NUELBK=1,NBELBK 
*  
*           Numero global de l'element NUELBK du bloc 
            ELEMEN=ELEMEN+1
*  
*           Boucle sur les faces/aretes de l'element  
            DO 25 NUBORD=1,NBBORD 
*  
*              Attributs de la face (3D) ou de l'arete (3D ou 2D)
*
*              Numero de type de la face = numero de type de l'element
*              de reference de la face ou arete   -> NUTBOG
               CALL ELEMFA (NUTGBK,NDIMBO,NUBORD,NUTBOG,NBNEEL,NUNEBO
     &                     ,NBDLBO,NUDLBO)                              !ef3d
*              Nombre de sommets de la face/arete -> NBSOMT
               CALL ELEMNB (NUTBOG,LAG,KCL,NBSOMT,NBAREW,NBFACW
     &                     ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)  !ef3d
*Hermite       IF (LAG.NE.0) CALL ELEMDL (NUTBOG,NEDUDL,IRGDLN,NDLINN)  !ef3d
*
*              Rangement des sommets de la face/arete par numero de d.l.
*              croissant
*
               NUSOMT=0
               DO 5 JSOMT=1,NBSOMT
                  NGNEBO(JSOMT)=0
5              CONTINUE
               DO 10 IDLBO=1,NBDLBO 
*              Si le d.l. est un d.l.d'Hermite on saute ... 
*Hermite          IF (LAG.GT.0)THEN
*Hermite             IF (NEDUDL((NUDLBO(IDLBO)).NE.IDLBO) GOTO 10
*Hermite             NGNEEI=NGPTEL(NUDLBO(IDLBO),ELEMEN)
*Hermite          ELSE
                     NGNEEI=NGPTEL(NUNEBO(IDLBO),ELEMEN)
*Hermite          ENDIF
                  NUSOMT=NUSOMT+1 
                  DO 8 JSOMT=1,NUSOMT-1
                     IF (NGNEEI.LT.NGNEBO(JSOMT)) THEN
                        DO 7 KSOMT=NUSOMT,JSOMT+1,-1
                           NGNEBO(KSOMT)=NGNEBO(KSOMT-1)
7                       CONTINUE
                        NGNEBO(JSOMT)=NGNEEI
                        GOTO 9
                     ENDIF
8                 CONTINUE
                  NGNEBO(NUSOMT)=NGNEEI
9                 IF(NUSOMT.GE.NBSOMT) GOTO 11
10             CONTINUE
*  
*              Numero de la premiere face/arete rencontree precedemment
*              contenant le 1er point de la face en cours comme 1er noeud
*
11             NGNEE1=NGNEBO(1)
               IANF=NUPRBO(NGNEE1)
               IF (IANF.EQ.0) THEN
                  NUPRBO(NGNEE1)=NBTBOG+1 
*                 Pour la premiere face/arete pas de face/arete suivante
                  NUSOBO(1,NBTBOG+1)=0
               ENDIF
*  
20             IF (IANF.EQ.0) THEN  
*  
*                 Aucune face/arete contenant le point de numero NGNEE1  
*                 comme 1er point n'a ete rencontree, on incremente le 
*                 nombre de faces/aretes et on stocke les autres numeros 
*                 de noeuds des sommets de la face/arete
*  
                  NBTBOG=NBTBOG+1  
                  DO 21 JSOMT=2,NBSOMT  
                     NUSOBO(JSOMT,NBTBOG)=NGNEBO(JSOMT)
21                CONTINUE 
                  NUGBOL(NUBORD,ELEMEN)=NBTBOG 
               ELSE
*  
*                 La face/arete de numero IANF a deja ete rencontree,
*                 on recherche les autres faces contenant NGNEE1 en 1er point 
*  
                  DO 22 JSOMT=2,NBSOMT  
                     IF (NGNEBO(JSOMT).NE.NUSOBO(JSOMT,IANF)) GOTO 23
22                CONTINUE 
*  
*                 Si tous les sommets ont deja ete rencontres, il s'agit
*                 d'une face commune avec une face d'un element precedent  
*  
                  NUGBOL(NUBORD,ELEMEN)=IANF
                  GOTO 25 
*  
*                 Sinon passage a la face suivante ayant NGNEE1 comme 1er noeud 
*  
23                IANF1=NUSOBO(1,IANF)  
                  IF (IANF1.EQ.0) NUSOBO(1,IANF)=NBTBOG+1
                  IANF=IANF1
                  GOTO 20 
               ENDIF 
25          CONTINUE
         IF (IMPFCH.GT.0.AND.NIVIMP.GT.5) WRITE (IMPFCH,10002) ELEMEN
     &                         ,(NUGBOL(NUBORD,ELEMEN),NUBORD=1,NBBORD) 
29       CONTINUE  
         IF (NBBBLK.GT.1) THEN  
            NBELBK=BLOKEL(PTRBLK)
            NUTGBK=BLOKEL(PTRBLK+1) 
            PTRBLK=PTRBLK+BLOKEL(3)
          ENDIF
30    CONTINUE 
      CALL PRFXMJ (-1,'*GlnuFa*')
      RETURN
*----------------------------------------------------------------------- 
10000 FORMAT(/T2,A,' Numerotation des ',A,' du maillage ' 
     &/'   Element',12('  ',A5,I3:))
10002 FORMAT(I8,T13,12(I8,'  '))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('Cas des elements de Hermite supprime (mise en '
     &//' commentaire des lignes correspondant (*Hermite)')
                                                                    END !GlnuFa
