*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLNUNA (L,NUTYLE,NBARET,NBAREX,NUGARL,NEAREX
     &                  ,NGNEAR,NUNEAR,NUDLAR,NBNEEX,NGNEEL,NBTNEU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin  (Octobre 1995) 
* Derniere modification : D.Martin (12 Janvier 2000)
* Version 1.0.1
*  
* Numerotation globale des noeuds d'un element non-sommets des aretes
*
*-- Arguments --
* L      numero de l'element en cours
* NUTYLE type de l'element en cours
* NBARET nombre d'aretes ou de face de l'element
* NBAREX nombre max. d'aretes dans un element du maillage
* NUGARL numerotation globale des aretes du maillage
* NEAREX nombre max. de noeuds sur une arete/face des elements du maillage
* NGNEAR tableau de numerotation des noeuds des aretes/faces du maillage
* NUNEAR tableau de correspondance arete/face <-> element pour les noeuds
* NUDLAR tableau de correspondance arete/face <-> element pour les d.l.
* NBNEEX nombre max. de noeuds dans un element du maillage
* NGNEEL tableau de numerotation des noeuds des elements du maillage
* NBTNEU nombre de noeuds du maillage (pour l'interpolation en cours)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER L,NUTYLE,NBARET,NBAREX,NUGARL(NBAREX,*),NEAREX
     &       ,NGNEAR(NEAREX,*),NUNEAR(*),NUDLAR(*)
     &       ,NBNEEX,NGNEEL(NBNEEX,*),NBTNEU
*
      INTEGER NUARET,ARGLOB,NELOCA,NUTYAR,NBNEAR,NBDLAR
     &       ,NESOME,NEARET,NEFACE,NEINTE,NEINT1,INCREM
*-----------------------------------------------------------------------
*
*     Aretes deja rencontrees comme Arete d'un precedent element
*
      DO 12 NUARET = 1,NBARET
         ARGLOB = NUGARL(NUARET,L)
         IF (NGNEAR(1,ARGLOB).GT.0) THEN
            CALL ELEMFA (NUTYLE,1,NUARET,NUTYAR
     &                  ,NBNEAR,NUNEAR,NBDLAR,NUDLAR)                   !ef3d
            CALL ELEMNE (NUTYAR,NESOME,NEARET,NEFACE,NEINTE)            !ef3d
*
*           Noeuds non-sommets de l'arete numerotes de maniere croissante
*           si les noeuds sommets sont ranges par ordre croissant,
*           de maniere decroissante sinon
            IF (NGNEEL(NUNEAR(1),L).LT.NGNEEL(NUNEAR(2),L)) THEN
               NEINT1=NESOME+1
               INCREM=1
            ELSE
               NEINT1=NESOME+NEINTE
               INCREM=-1
            ENDIF
            DO 11 NELOCA = 1,NEINTE
               NGNEEL(NUNEAR(NEINT1),L) = NGNEAR(NELOCA,ARGLOB)
               NEINT1=NEINT1+INCREM
11          CONTINUE
         ENDIF
12    CONTINUE
*
*     Aretes non encore rencontrees
*     Les noeuds non-sommets de l'arete sont numerotes de maniere
*     croissante si les noeuds sommets sont ranges par ordre croissant
*     dans la numerotation globale, de maniere decroissante sinon
*
      DO 30 NUARET = 1,NBARET
         ARGLOB = NUGARL(NUARET,L)
         IF (NGNEAR(1,ARGLOB).LE.0) THEN
            CALL ELEMFA (NUTYLE,1,NUARET,NUTYAR
     &                  ,NBNEAR,NUNEAR,NBDLAR,NUDLAR)                   !ef3d
            CALL ELEMNE (NUTYAR,NESOME,NEARET,NEFACE,NEINTE)            !ef3d
*
            IF (NGNEEL(NUNEAR(1),L).LT.NGNEEL(NUNEAR(2),L)) THEN
               NEINT1=NESOME+1
               INCREM=1
            ELSE
               NEINT1=NESOME+NEINTE
               INCREM=-1
            ENDIF
            DO 29 NELOCA = 1,NEINTE
               NBTNEU = NBTNEU+1
               NGNEAR(NELOCA,ARGLOB)    = NBTNEU
               NGNEEL(NUNEAR(NEINT1),L) = NBTNEU
               NEINT1=NEINT1+INCREM
29          CONTINUE
         ENDIF
30    CONTINUE
                                                                    END !GlnuNa
