*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLNUNF (L,NUTYLE,NBFACE,NBFACX,NUGFAL,NEFACX
     &                  ,NGNEFA,NUNEFA,NUDLFA,NBNEEX,NGNEEL,NBTNEU
     &                  ,NUTGEO,NDIM,NBPTEX,NUPTFA,CORPTL,CORLOC
     &                  ,CORPTF,CORNEF,FCTBAS,EPSMAC)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1995) 
* Derniere modification : D.Martin (27 juin 2002)
* Version 1.2.4
*
* Numerotation globale des noeuds des faces d'un element non situes 
* sur une arete (i.e. noeuds internes des faces).
*
*-- Arguments --
* L      numero de l'element en cours
* NUTYLE numero de type de l'element en cours
* NBFACE nombre de faces de l'element
* NBFACX nombre max. de faces dans un element du maillage
* NUGFAL numerotation globale des faces du maillage
* NEFACX nombre maximum de noeuds sur une face des elements du maillage
* NGNEFA tableau de numerotation des noeuds des faces du maillage
* NUNEFA tableau de correspondance face <-> element pour les noeuds
* NUDLFA tableau de correspondance face <-> element pour les d.l.
* NBNEEX nombre maximum de noeuds dans un element du maillage
* NGNEEL tableau de numerotation des noeuds de tous elements du maillage
* NBTNEU nombre de noeuds du maillage (pour l'interpolation en cours)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER L,NUTYLE,NBFACE,NBFACX,NUGFAL(NBFACX,*),NEFACX
     &       ,NGNEFA(NEFACX+2,*),NUNEFA(*),NUDLFA(*)
     &       ,NBNEEX,NGNEEL(NBNEEX,*),NBTNEU
      INTEGER NUTGEO,NDIM,NBPTEX,NUPTFA(*)
      REAL    CORPTL(*),CORLOC(NDIM-1,*),CORPTF(NDIM,*),CORNEF(NDIM,*)
     &       ,FCTBAS(*),EPSMAC
*
      INTEGER NUFACE,FAGLOB,NUTYFA,NBNEFA,NBDLFA,NESOME,NEARET
     &       ,NEINTE,DJANUM,ITOUR,NGMAX,MORE
     &       ,NUS,NUNUS,NUSO1,NUSO2,NGNUS1,NGNUS2,NUSO(4),NUSOB(4)
     &       ,LAV,NUFAAV,NUTYFG,NBPTFA,ADCLAV,IPTFA,IPTEL,ADPTEL
     &       ,NEINFA,NEFACE,NEFACV,NEINFV,ID
      REAL    COORNE(3),PAUTIL
*-----------------------------------------------------------------------
*
*     Pour l'element courant on commence par numeroter les faces
*     deja rencontrees comme faces d'un precedent element
*===============================================================
      DO 30 NUFACE = 1,NBFACE
         FAGLOB = NUGFAL(NUFACE,L)
         IF (NGNEFA(1,FAGLOB).GT.0) THEN
*
*           Caracteristiques de la face en cours
*           NUmero de TYpe de la FAce, NomBre de NoEuds de la FAce
*           NUmero des NoEuds de la FAce dans la numerotation locale 
*           de l'element (et idem pour les d.l.)
*
            CALL ELEMFA (NUTYLE,2,NUFACE,NUTYFA
     &                  ,NBNEFA,NUNEFA,NBDLFA,NUDLFA)                   !ef3d
*
*           nombre de NoEuds SOmmets, de NoEuds sur une ARETe,
*           (le cas echeant sur une face) et nombre de NoEuds INTErnes
*
            CALL ELEMNE (NUTYFA,NESOME,NEARET,NEINFA,NEINTE)            !ef3d
*
*           nombre de noeuds deja numerotes comme sommets (NESOME)
*           ou comme noeuds situes sur des aretes (NEARET) dans
*           la face de l'element courant
*           DJANUM designe le nombre de noeuds numerotes de la face
*
            DJANUM=NESOME+NEARET
*
            IF (NEINTE.GT.1) THEN
*
*              Reperage du sens de parcours des sommets de la face
*              NUSO(1) est le sommet de plus petit numero global
*              NUSO(2) est le sommet suivant ou precedent qui porte
*              le plus petit numero global des 2.
*              Puis NUSO(j) est le sommet suivant de NUSO(j-1), pour j>3
*              dans l'ordre de la numerotation locale de la face.
*              Sens de parcours des sommets de la face
*
               CALL GLSNSF (L,NESOME,NUNEFA,NBNEEX,NGNEEL,NUSO)
*
*              Numerotation des sommets de l'element 2D forme de noeuds
*              internes de la face de l'element 3D
*
               NEINFV=0
               DO 1 NUS=1,NESOME
                  NEINFV=NEINFV+1
                  NGNEEL(NUNEFA(DJANUM+NUSO(NUS)),L) 
     &            = NGNEFA(NEINFV,FAGLOB)
1              CONTINUE
               DJANUM=DJANUM+NESOME
*
               IF (DJANUM.LT.NBNEFA) THEN
*
*                 Face precedente coincidente (Element LAV, face NUFAAV)
*
                  LAV=NGNEFA(NEFACX+1,FAGLOB)
                  NUFAAV=NGNEFA(NEFACX+2,FAGLOB)
*
*                 Attribut des points de la face coincidente de l'element LAV
*
                  CALL ELEMFA (NUTGEO,2,NUFAAV,NUTYFG
     &                        ,NBPTFA,NUPTFA,NBDLFA,NUDLFA)             !ef3d

*                 Adresse des coordonnees des points de l'element LAV
*                 (dans le tableau CORPTL des points du maillage)
                  ADCLAV=2+(1+NBPTEX*NDIM)*(LAV-1)
*                 Coordonnees des points de la face de l'element
                  DO 14 IPTFA=1,NBPTFA
                     IPTEL  = NUPTFA(IPTFA)
                     ADPTEL = ADCLAV+(IPTEL-1)*NDIM
                     DO 13 ID=1,NDIM
                        CORPTF(ID,IPTFA)=CORPTL(ADPTEL)
                        ADPTEL=ADPTEL+1
13                    CONTINUE
14                 CONTINUE
*
*                 Les coordonnees des noeuds de la face deja rencontree
*                 dans l'element LAV sont stockees dans CORNEF
*
                  CALL ELEMCO (NUTYFA,2,CORLOC)                         !ef3d
*
                  NEINFV=NESOME
                  DO 19 NEFACV=DJANUM+1,NBNEFA
                     NEINFV=NEINFV+1
                     CALL ELEMFB (NUTYFG,'YNN',CORLOC(1,NEFACV),FCTBAS
     &                           ,PAUTIL,PAUTIL,0)                      !ef3d
*
*                    Coordonnes du noeud courant de la face courante
*
                     CALL TRANSF (NDIM,NBPTFA,CORPTF,FCTBAS
     &                           ,CORNEF(1,NEINFV))                     !ef3d
19                CONTINUE
*
*                 Attribut des points de la face courante
*
                  CALL ELEMFA (NUTGEO,2,NUFACE,NUTYFG
     &                        ,NBPTFA,NUPTFA,NBDLFA,NUDLFA)             !ef3d
*
*                 Adresse des coordonnees des points de l'element L
*                 (dans le tableau CORPTL des points du maillage)
                  ADCLAV=2+(1+NBPTEX*NDIM)*(L-1)
*                 Coordonnees des points de la face de l'element
                  DO 24 IPTFA=1,NBPTFA
                     IPTEL  = NUPTFA(IPTFA)
                     ADPTEL = ADCLAV+(IPTEL-1)*NDIM
                     DO 23 ID=1,NDIM
                        CORPTF(ID,IPTFA)=CORPTL(ADPTEL)
                        ADPTEL=ADPTEL+1
23                   CONTINUE
24                CONTINUE
*
*                 Coordonnees des noeuds dans l'element de reference
*
                  CALL ELEMCO (NUTYFA,2,CORLOC)                         !ef3d
*
                  DO 29 NEFACE=DJANUM+1,NBNEFA
*
*                    COORNE : Coordonnees du noeud courant de la face courante
*
                     CALL ELEMFB (NUTYFG,'YNN',CORLOC(1,NEFACE),FCTBAS
     &                           ,PAUTIL,PAUTIL,0)                      !ef3d
                     CALL TRANSF (NDIM,NBPTFA,CORPTF,FCTBAS,COORNE)     !ef3d
*
*                    Comparaison avec les coordonnees des noeuds 
*                    interieurs de la face coincidente
*
                     DO 27 NEINFV=NESOME+1,NEINTE
                        DO 26 ID=1,NDIM
                           IF (ABS(COORNE(ID)-CORNEF(ID,NEINFV))
     &                     .GT.10*EPSMAC) GOTO 27
26                      CONTINUE
*                       Noeud coincidant de la face precedente
                        NGNEEL(NUNEFA(NEFACE),L)=NGNEFA(NEINFV,FAGLOB)
                        CORNEF(1,NEINFV)=EPSMAC
                        GOTO 29
27                   CONTINUE
                     WRITE(*,10000) NEFACE,NUFACE,NUNEFA(NEFACE),L
     &                             ,NUFAAV,LAV
10000 FORMAT (' Noeud',I4,' Face',I2,' (Noeud local',I5,') Element',I6
     &,' non retrouve dans la face',I2,' element',I6)
29                CONTINUE
               ENDIF
*
            ELSEIF (DJANUM.LT.NBNEFA) THEN
*
*              Cas d'un noeud central sur la face
*              (Utile seulement lorsque NEINTE = 1, cas Q2)
*
               NGNEEL(NUNEFA(NBNEFA),L) = NGNEFA(NEINTE,FAGLOB)
            ENDIF
         ENDIF
30    CONTINUE
*
*     Faces non encore rencontrees
*=================================
      DO 50 NUFACE = 1,NBFACE
         FAGLOB = NUGFAL(NUFACE,L)
         IF (NGNEFA(1,FAGLOB).LE.0) THEN
*
*           Reperage de la face pour eventuelle coincidence avec une face
*           d'un element ulterieur
*
            NGNEFA(NEFACX+1,FAGLOB)=L
            NGNEFA(NEFACX+2,FAGLOB)=NUFACE
*
*           Caracteristiques de la face en cours
*           NUmero de TYpe de la FAce, NomBre de NoEuds de la FAce
*           NUmero des NoEuds de la FAce dans la numerotation locale 
*           de l'element (et idem pour les d.l.)
*
            CALL ELEMFA (NUTYLE,2,NUFACE,NUTYFA
     &                  ,NBNEFA,NUNEFA,NBDLFA,NUDLFA)                   !ef3d
            CALL ELEMNE (NUTYFA,NESOME,NEARET,NEINFA,NEINTE)            !ef3d
*
*           Les noeuds situes sur les aretes sont deja numerotes
*
            DJANUM=NESOME+NEARET
            NEINFA=0
*
            IF (NEINTE.GT.1) THEN
*
*              Sens de parcours des sommets de la face (a partir du
*              plus petit numero global)
*
               CALL GLSNSF (L,NESOME,NUNEFA,NBNEEX,NGNEEL,NUSO)
*
*              Parcours des noeuds de la face non situes sur une arete
*              Les noeuds-sommets du perimetre en cours
*
               DO 40 NUS=1,NESOME
                  NBTNEU=NBTNEU+1
                  NEINFA=NEINFA+1
                  NGNEFA(NEINFA,FAGLOB)              = NBTNEU
                  NGNEEL(NUNEFA(DJANUM+NUSO(NUS)),L) = NBTNEU
40             CONTINUE
               DJANUM=DJANUM+NESOME
*
*              Les noeuds non-sommets du perimetre en cours sont
*              numerotes dans l'ordre local de la face
*
               DO 44 NEFACE=DJANUM+1,NBNEFA
                  NEINFA=NEINFA+1
                  NBTNEU=NBTNEU+1
                  NGNEFA(NEINFA,FAGLOB)    = NBTNEU
                  NGNEEL(NUNEFA(NEFACE),L) = NBTNEU
44             CONTINUE
*
            ELSEIF (NEINFA.LT.NEINTE) THEN
*
*              Cas d'un noeud central sur la face
*              (Utile seulement lorsque NEINTE = 1, cas Q2)
*
               NBTNEU = NBTNEU+1
               NGNEFA(NEINTE,FAGLOB)    = NBTNEU
               NGNEEL(NUNEFA(NBNEFA),L) = NBTNEU
            ENDIF
         ENDIF
50    CONTINUE
                                                                    END !GlnuNf
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLSNSF (L,NESOME,NUNEFA,NBNEEX,NGNEEL,NUSO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
* Reperage du sens de parcours des sommets de la face
*   NUSO(1) est le sommet de plus petit numero global
*   NUSO(2) est le sommet suivant ou precedent qui porte le plus petit numero 
*           global des 2.
*           Puis NUSO(j) est le sommet suivant de NUSO(j-1), pour j>3
*           dans l'ordre de la numerotation locale de la face.
*-- Arguments d'entree --
* L      numero de l'element en cours
* NESOME nombre de sommets de la face en cours
* NUNEFA numeros locaux des noeuds de la face en cours
*        (utilise ici seulement pour les sommets)
* NBNEEX nombre maximum de noeuds dans un element du maillage
*        dimension de NGNEEL
* NGNEEL tableau de numerotation des noeuds de tous elements du maillage
*        (utilise ici seulement pour les sommets)
*-- Arguments de sortie --
* NUSO   tableau indicateur du sens de parcours des sommets de la face
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER L,NESOME,NUNEFA(*),NBNEEX,NGNEEL(NBNEEX,*),NUSO(4)
*
      INTEGER NUSOM1,NGNUS1,NUSOM2,NGNUS2,NUSOM3,NUSOMI
*-----------------------------------------------------------------------
*     Recherche du sommet portant le plus petit numero global des
*     sommets de la face en cours
* 
      NUSOM1=1
      DO 10 NUSOMI=2,NESOME
         IF (NGNEEL(NUNEFA(NUSOMI),L).LT.NGNEEL(NUNEFA(NUSOM1),L)) 
     &      NUSOM1=NUSOMI
10    CONTINUE
      NUSO(1)=NUSOM1
*
*     Les sommets d'une face quadrangulaire sont numerotes 
*     soit dans l'ordre (1,2,3,4),(2,3,4,1),(3,4,1,2),(4,1,2,3)
*     i.e  i, 1+imod4, 1+(i+1)mod4, 1+(i+2)mod4  note "+i"
*     soit dans l'ordre (1,4,3,2),(2,1,4,3),(3,2,1,4),(4,3,2,1)
*     i.e  i, 1+(i+2)mod4, 1+(i+1)mod4, 1+imod4  note "-i"

      NUSOM2=1+MOD (NUSOM1,NESOME)
      NGNUS2=NGNEEL(NUNEFA(NUSOM2),L)
      NUSOM3=1+MOD (NUSOM2,NESOME)
      NUSO(3)=NUSOM3
*
*     Par les faces quadrangulaires
*
      IF (NESOME.EQ.4) THEN
         NUSO(NESOME)=1+MOD (NUSOM3,NESOME)
      ENDIF
*
*     Le cas echeant, echange des 2eme et dernier sommets
*
      IF (NGNEEL(NUNEFA(NUSO(NESOME)),L).LT.NGNUS2) THEN
         NUSO(2)=NUSO(NESOME)
         NUSO(NESOME)=NUSOM2
      ELSE
         NUSO(2)=NUSOM2
      ENDIF
                                                                    END !GlSnsF
