*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GLNUSO (NBPTEX,NGPTEL,NBTEL,NBBBLK,NU1BLK
     &                  ,BLOKEL,NBTSOG,NBBOCX,NUGBOL,NUPRBO
     &                  ,NEDUDL,IRGDLN,NDLINN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.deBayser (Decembre 1988), d'apres P.L.George (Modulef)
* Refonte complete (D.Martin) Octobre 1995
* Derniere modification : D.Martin (3 Juillet 1997)
* Version 1.0.0
*  
* Creation de la numerotation des sommets d'un maillage (2D ou 3D)  
* a partir de la numerotation de noeuds des points-sommets de la triangulation.
*  
*-- Arguments d'entree -- 
* NBPTEX nombre maximum de points des elements du maillage
* NGPTEL numerotation des points du maillage element par element  
* NBTEL  nombre total d'elements du maillage  
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du premier bloc  
* BLOKEL tableau de description des elements du maillage par blocs
* NBBOCX nombre max. de sommets dans les elements du maillage
*
*-- Arguments de sortie --
* NBTSOG nombre de faces/aretes du maillage  
* NUGBOL numerotation des faces/aretes des elements
*  
*-- Tableaux de travail --
* NUPRBO numero du noeud porte par un point
* NEDUDL numeros des noeuds supports de d.l.
* IRGNDL tableau inutilise
* NDLINN tableau inutilise 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NBPTEX,NGPTEL(NBPTEX,*),NBTEL,NBBBLK,NU1BLK
     &             ,BLOKEL(*),NBTSOG,NBBOCX,NUGBOL(NBBOCX,*),NUPRBO(*)
     &             ,NEDUDL(*),IRGDLN(*),NDLINN(*) 
*  
      INTEGER       PTRBLK,NBELBK,NUTGBK,LGEBLK,NUBBLK,NUELBK,LAG,KCL
     &             ,NBSOME,NBNEEL,NBDLEL,NBNEFX,NBDLFX,NBNEAX,NBDLAX
     &             ,NUSOME,NBARET,NBFACE,ELEMEN,IANF,NGNEE1
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*GlnuSo*')
*
*     Caracteristiques des blocs d'elements du maillage
*
      NBELBK=NBTEL 
      NUTGBK=NU1BLK
      IF (NBBBLK.GT.1) THEN 
         LGEBLK=BLOKEL(1) 
         NBELBK=BLOKEL(LGEBLK+1)  
         PTRBLK=LGEBLK+1+BLOKEL(3) 
      ENDIF
*  
*     Boucle sur tous les elements du maillage effectuee par blocs 
*     d'elements consecutifs de meme type (NUTGBK) 
      ELEMEN=0  
      DO 30 NUBBLK=1,NBBBLK
*  
*        Nombre de faces/aretes des elements du bloc ? -> NBSOME
*  
         CALL ELEMNB (NUTGBK,LAG,KCL,NBSOME,NBARET,NBFACE
     &               ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)        !ef3d
         IF (LAG.NE.0) GOTO 99991
*Hermite IF (LAG.NE.0) CALL ELEMDL (NUTGBK,NEDUDL,IRGDLN,NDLINN)        !ef3d
         DO 29 NUELBK=1,NBELBK 
*  
*           Numero global de l'element NUELBK du bloc 
            ELEMEN=ELEMEN+1
*  
*           Boucle sur les sommets de l'element  
            DO 25 NUSOME=1,NBSOME 
*              Si le d.l. est un d.l. d'Hermite on saute ... 
*Hermite       IF (LAG.GT.0)THEN
*Hermite          IF (NEDUDL(NUSOME).NE.NUSOME) GOTO 25
*Hermite       ENDIF
               NGNEE1=NGPTEL(NUSOME,ELEMEN)
*  
*              Numero du premier sommet rencontre precedemment
*              correspondant au sommet en cours
               IANF=NUPRBO(NGNEE1)
               IF (IANF.EQ.0) THEN  
*  
*                 Aucun sommet de numero NGNEE1 n'a ete rencontre,
*                 on incremente le nombre de sommets
                  NBTSOG=NBTSOG+1
                  NUPRBO(NGNEE1)=NBTSOG
                  NUGBOL(NUSOME,ELEMEN)=NBTSOG 
               ELSE
                  NUGBOL(NUSOME,ELEMEN)=IANF
               ENDIF
25          CONTINUE
29       CONTINUE  
         IF (NBBBLK.GT.1) THEN  
            NBELBK=BLOKEL(PTRBLK)
            NUTGBK=BLOKEL(PTRBLK+1) 
            PTRBLK=PTRBLK+BLOKEL(3)
          ENDIF
30    CONTINUE 
      CALL PRFXMJ (-1,'*GlnuSo*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('Cas des elements de Hermite supprime (mise en '
     &//' commentaire des lignes correspondant (*Hermite)')
                                                                    END !GlnuSo
