*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-----------------------------------------------------------------------
      SUBROUTINE RALGOR (NBTNEU,NBTEL,NBPTEX,NGNEEL,NEMARK,NELEVL,NTREE
     &                  ,MXDEG,ADVOIS,NEVOIS,NSNUMW,NGNEEW
     &                  ,LBANDI,LBANDO,PROFII,PROFIO,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : E.Masson (Juin 1993)  
* Derniere modification : D.Martin (30 juin 2002)
* Version 2.0.0
*
*-- Arguments d'entree --
* NBTNEU nombre maximum de dl du maillage
* NBTEL  nombre d''elements du maillage
* NBPTEX nombre maximum de points par element 
* NGNEEL structure #NGEEL a renumeroter
* NEMARK tableau de travail (marquage des noeuds)
* NELEVL tableau de travail
* NTREE  tableau de travail
* ADVOIS tableau des adresses des noeuds voisins des noeuds
* NEVOIS tableau du nombre et des numero des noeuds voisins des noeuds
* MXDEG  degre maximum dans la connectique des noeuds
* LBANDI largeur de bande de l'ancienne numerotation
* LBANDO largeur de bande de la nouvelle numerotation
* PROFII longueur du profil de l'ancienne numerotation
* PROFIO longueur du profil de la nouvelle numerotation
*-- Arguments de sortie --
* NSNUMW numerotation NSNUMW(nouveau)=ancien
* NGNEEW resultat de la renumerotation
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   NBTNEU,NBTEL,NBPTEX,NGNEEL(NBPTEX,*)
     &         ,NEMARK(*),NELEVL(*),NTREE(*),NSNUMW(*)
     &         ,NGNEEW(NBPTEX,*),MXDEG,ADVOIS(*),NEVOIS(*)
     &         ,LBANDI,LBANDO,PROFII,PROFIO,NIVIMP,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER   MXCONX,NBCONX,NBNUME,NLEVEL,ILEVEL,ITREE,NGI,IDEB,ISTART
     &         ,IBID,JBID
*     Nombre maximal de composantes connexes
      PARAMETER ( MXCONX = 99 )
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Ralgor*')
*
*     Relations de voisinage des noeuds
*     1ere evaluation de la largeur de bande. 
*     Classement de NEVOIS par degre croissant
*
      CALL RDLVOI (NBTNEU,NBTEL,NBPTEX,ADVOIS,NEVOIS,NGNEEL
     &            ,NEMARK,NELEVL,NIVIMP,IMPFCH)
*
      CALL RLBAND (NBTNEU,ADVOIS,NEVOIS,LBANDI,PROFII)
*
      CALL RDLTRI (NBTNEU,NBTEL,NBPTEX,MXDEG,ADVOIS,NEVOIS
     &            ,NIVIMP,IMPFCH)
*
*     Renumerotation composante par composante
*
      NBCONX=0
      NBNUME=0
      DO 10 NGI=1,NBTNEU
         NEMARK(NGI)=0
10    CONTINUE
*
*     Recherche d'une nouvelle composante connexe
*
11    IDEB=0
      DO 12 NGI=1,NBTNEU
         IF (NEMARK(NGI).EQ.0) THEN
            IDEB=NGI
            GOTO 13
         ENDIF
12    CONTINUE
*
13    IF (IDEB.NE.0) THEN
         NBCONX=NBCONX+1
         IF (NBCONX.GT.MXCONX)
     &      CALL BAISE  (' *RAlgor* Nombre de composantes depasse')     !Utilite
         NLEVEL=1
         CALL RMOTOR (IDEB,ISTART,ILEVEL,ITREE,NBTNEU,NELEVL,NTREE
     &               ,MXDEG,ADVOIS,NEVOIS,NEMARK,0,IMPFCH)
         IF (ILEVEL.GT.NLEVEL) IDEB=ISTART
*
         CALL RMOTOR (ISTART,IBID,JBID,ITREE,NBTNEU,NELEVL,NTREE
     &               ,MXDEG,ADVOIS,NEVOIS,NEMARK,NIVIMP,IMPFCH)
*
         CALL RMAJNU (ITREE,NTREE,NSNUMW,NBNUME)
*
         GOTO 11
      ENDIF
*
      IF (IMPFCH.GT.0.AND.NIVIMP.GE.0) THEN
         IF (NBCONX.GT.1) WRITE (IMPFCH,10000) NBCONX
         IF (NIVIMP.GT.5) THEN
            WRITE(IMPFCH,10001) PRFXAS(1),PRFXAS(0)
            WRITE(IMPFCH,10002) (NGI,NSNUMW(NGI),NGI=1,NBTNEU)
         ENDIF
      ENDIF
*
      CALL RRANGE (NBTEL,NBPTEX,NSNUMW,NGNEEL,NGNEEW)
*
*     Evaluation nouvelle largeur de bande
*
      CALL RINFOR (NBTNEU,NBTEL,NBPTEX,NGNEEW,NTREE,MXDEG,ADVOIS
     &            ,0,IMPFCH)
      CALL RDLVOI (NBTNEU,NBTEL,NBPTEX,ADVOIS,NEVOIS,NGNEEW
     &            ,NEMARK,NELEVL,0,IMPFCH)
      CALL RLBAND (NBTNEU,ADVOIS,NEVOIS,LBANDO,PROFIO)
*
      CALL PRFXMJ (-1,'*Ralgor*')
*-----------------------------------------------------------------------
10000 FORMAT(' *RAlgor* Nombre de composantes connexes :',I3)
10001 FORMAT(A8,'>',A8,' Correspondance Ancien -> Nouveau Noeud')
10002 FORMAT (10(I7,'->',I7,' |'))
                                                                    END !RAlgor
