*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDLVOI (NBTPTG,NBTEL,NBPTEX,ADVOIS,NEVOIS,NGNEEL
     &                  ,NEMARK,NELEVL,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (1er juillet 2002)
* Version 2.0.1
*
* Remplissage de NEVOIS : relations de voisinages des noeuds
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBTPTG,NBTEL,NBPTEX,ADVOIS(*),NEVOIS(*)
     &       ,NGNEEL(NBPTEX,*),NEMARK(*),NELEVL(*),NIVIMP,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER L,IDL,NGI,ADVOII,ADVIDD,NBVOII,JDL,NGJ,ADVOIJ,ADVJDD
     &       ,NBVOIJ,IELI,NBIMP,MAXVOI,MOYVOI
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Rdlvoi*')
*     Initialisation (mise a zero du nombre de voisins)
      DO 1 NGI=1,NBTPTG
         NEVOIS(ADVOIS(NGI))=0
1     CONTINUE
*
*     Parcours de elements
      DO 9 L=1,NBTEL
*        Un noeud de l'element
         DO 7 IDL=1,NBPTEX
            NGI=NGNEEL(IDL,L)
            IF (NGI.NE.0) THEN
*              Adresse du nombre de noeuds voisins et nombre de voisins
               ADVOII=ADVOIS(NGI)
               NBVOII=NEVOIS(ADVOII)
               DO 3 JDL=IDL+1,NBPTEX
                  NGJ=NGNEEL(JDL,L)
                  IF (NGJ.NE.0) THEN
                     ADVOIJ=ADVOIS(NGJ)
                     NBVOIJ=NEVOIS(ADVOIJ)
*
*                    Premier remplissage de NEVOIS
                     NBVOII=NBVOII+1
                     NEVOIS(ADVOII)=NBVOII
                     NEVOIS(ADVOII+NBVOII)=NGJ
                     NBVOIJ=NBVOIJ+1
                     NEVOIS(ADVOIJ+NBVOIJ)=NGI
                     NEVOIS(ADVOIJ)=NBVOIJ
                  ENDIF
3              CONTINUE
            ENDIF
7        CONTINUE
9     CONTINUE
*
*     Elimination des redondances
*
*     Initialisation
      DO 10 NGI=1,NBTPTG
         NEMARK(NGI)=0
10    CONTINUE
*
*     Boucle sur les noeuds
      MAXVOI=0
      MOYVOI=0
      DO 19 NGI=1,NBTPTG
         ADVOII=ADVOIS(NGI)
         NBVOII=NEVOIS(ADVOII)
*        Marquage des voisins
         DO 11 ADVIDD=ADVOII+1,ADVOII+NBVOII
            NEMARK(NEVOIS(ADVIDD))=1
11       CONTINUE
*        Rangement des voisins et demarquage
         IELI=0
         ADVIDD=ADVOII
         DO 13 JDL=1,NBVOII
            ADVIDD=ADVIDD+1
            NGJ=NEVOIS(ADVIDD)
            IF (NEMARK(NGJ).EQ.1) THEN
               IELI=IELI+1
               NELEVL(IELI)=NGJ
               NEMARK(NGJ)=0
            ENDIF
13       CONTINUE
*        Recopie dans NEVOIS
         NEVOIS(ADVOII)=IELI
         MAXVOI=MAX (MAXVOI,IELI)
         MOYVOI=MOYVOI+IELI
         ADVIDD=ADVOII
         DO 15 NGJ=1,IELI
            ADVIDD=ADVIDD+1
            NEVOIS(ADVIDD)=NELEVL(NGJ)
15       CONTINUE
19    CONTINUE
      CALL PRFXMJ (-1,'*Rdlvoi*')
*-----------------------------------------------------------------------
*     Impressions
      IF (IMPFCH.LE.0) RETURN
      IF (NIVIMP.LE.0) RETURN
      WRITE (IMPFCH,10000) PRFXAS(0),NBTPTG,MOYVOI/NBTPTG+1,MAXVOI
      NBIMP=10*NIVIMP
      IF (NIVIMP.GE.10) NBIMP=NBTPTG
      DO 9000 NGI=1,NBIMP
         ADVOII=ADVOIS(NGI)
         WRITE (IMPFCH,10001) NGI
     &            ,(NEVOIS(ADVIDD),ADVIDD=ADVOII,ADVOII+NEVOIS(ADVOII))
9000  CONTINUE
10000 FORMAT(/A8,'>*RDlVoi* Impression de NEVOIS (Nb de noeuds=',I6
     &,', Nb de voisins moyen =',I4,', maximum =',I4,')'
     &,/'  Noeud  NbVoisins / Listes des noeuds voisins')
10001 FORMAT(I6,' : ',I6,' voisins',/(20I10))
                                                                    END !RDlVoi
