*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RENUME (NIVEIN,NIVOUT,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (30 juin 2002)
* Version 2.0.0
*
* Renumerotation pour reduction de la largeur de bande et du profil
*
*-- Arguments --
* NIVEIN niveau de numerotation globale (#GNEEL) en entree
* NIVOUT niveau de numerotation globale (#GNEEL) en sortie
* NIVIMP niveau d'impression sur le fichier secondaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NIVIMP,NIVEIN,NIVOUT
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER ERCODE*120,PRFXAS*8
      COMMON/FORMAH/ERCODE
      INTEGER  LGNEEL,MCNEEL,MCWOR5,MXDEG,LGDEGX,MCVOIS,MCNEEW
     &        ,LBANDI,LBANDO,LPROFI,LPROFO
*-----------------------------------------------------------------------
      IF (NBTEL.LE.1) RETURN
      CALL PRFXMJ (1,'*ReNume*')
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GE.0) WRITE (IMPSDR,10000) PRFXAS (0)
*
*     Appel du tableau de numerotation #GNEEL et creation 
*     de 5 tableaux de longueur NBTPTG + 1 tableau de longueur LGNEEL
*
      CALL TBRR1  (ERCODE,'#GNEEL',NIVEIN,LGNEEL)
      CALL TBCREE ('$WORK$',5,1,5*NBTPTG+1+LGNEEL,'c')
      CALL TBAR2  (ERCODE,'#GNEEL',NIVEIN,MCNEEL,'$WORK$',5,MCWOR5)
*
      CALL RINFOR (NBTPTG,NBTEL,NBPTEX,IST(MCNEEL),IST(MCWOR5),MXDEG
     &            ,IST(MCWOR5+3*NBTPTG),NIVIMP,IMPSDR)                  !glonum
      LGDEGX=IST(MCWOR5+4*NBTPTG)
*
      IF (MXDEG.LE.0) CALL BAISE  (' Degre maximum negatif ou nul')     !utilite
      IF (IMPSDR.GT.0.AND.NIVIMP.GE.5)
     &   WRITE (IMPSDR,10021) PRFXAS(0),NBTPTG,NBTEL,NBPTEX
     &                                 ,LGDEGX/NBTPTG+1,MXDEG
*
*     Creation de NEVOIS : liste des voisins de chaque dl
*
      CALL TBCREE ('$WORK$',6,1,LGDEGX,'c')
*
      CALL TBAR3  (ERCODE,'#GNEEL',NIVEIN,MCNEEL,'$WORK$',5,MCWOR5
     &                   ,'$WORK$',6,MCVOIS)
*
      MCNEEW=MCWOR5+5*NBTPTG+1
      CALL RALGOR (NBTPTG,NBTEL,NBPTEX,IST(MCNEEL)
     &            ,IST(MCWOR5),IST(MCWOR5+NBTPTG),IST(MCWOR5+2*NBTPTG)
     &            ,MXDEG,IST(MCWOR5+3*NBTPTG),IST(MCVOIS)
     &            ,IST(MCWOR5+4*NBTPTG+1),IST(MCNEEW)
     &            ,LBANDI,LBANDO,LPROFI,LPROFO,NIVIMP,IMPSDR)           !glonum
*
      CALL TBTUER ('$WORK$',6)
*
*     Impressions
*
      IF (IMPPAL.GT.0) THEN
         WRITE (IMPPAL,10000) PRFXAS (0)
         IF (LBANDI.GT.LBANDO) THEN
            WRITE (IMPPAL,10022) NBTPTG,LBANDI,LBANDO
         ELSE
            WRITE (IMPPAL,10023) NBTPTG,LBANDI
         ENDIF
      ENDIF
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) THEN
         IF (LBANDI.GT.LBANDO) THEN
            WRITE (IMPSDR,10022) NBTPTG,LBANDI,LBANDO,LPROFI,LPROFO
         ELSE
            WRITE (IMPSDR,10023) NBTPTG,LBANDI,LPROFI,LPROFO
         ENDIF
      ENDIF
*
*     Creation eventuelle du tableau resultat et remplissage
*
      IF (NIVEIN.NE.NIVOUT) THEN
         CALL TBCREE ('#GNEEL',NIVOUT,1,LGNEEL,'c')
         IF (LBANDI.LE.LBANDO) THEN
            CALL TBTUER ('$WORK$',5)
            CALL TBAR2  (ERCODE,'#GNEEL',NIVEIN,MCNEEL            
     &                         ,'#GNEEL',NIVOUT,MCNEEW)
            CALL TDANST (LGNEEL,'ENTIER',MCNEEL,IST,RST,CST
     &                         ,'ENTIER',MCNEEW,IST,RST,CST)            !utilite
            CALL TBSAVE ('#GNEEL',NIVEIN)
            CALL TBSAVE ('#GNEEL',NIVOUT)
         ELSE
            CALL TBSAVE ('#GNEEL',NIVEIN)
            CALL TBAR2  (ERCODE,'$WORK$',5     ,MCWOR5            
     &                         ,'#GNEEL',NIVOUT,MCNEEW)
            CALL TDANST (LGNEEL,'ENTIER',MCWOR5+5*NBTPTG+1,IST,RST,CST
     &                         ,'ENTIER',MCNEEW,IST,RST,CST)            !utilite
            CALL TBTUER ('$WORK$',5)
            CALL TBSAVE ('#GNEEL',NIVOUT)
         ENDIF
      ELSEIF (LBANDI.GT.LBANDO) THEN
         CALL TBAR2  (ERCODE,'$WORK$',5     ,MCWOR5
     &                      ,'#GNEEL',NIVEIN,MCNEEW)
         CALL TDANST (LGNEEL,'ENTIER',MCWOR5+5*NBTPTG+1,IST,RST,CST
     &                      ,'ENTIER',MCNEEW,IST,RST,CST)               !utilite
         CALL TBTUER ('$WORK$',5)
         CALL TBSAVE ('#GNEEL',NIVEIN)
      ELSE
         CALL TBTUER ('$WORK$',5)
      ENDIF
*
      CALL PRFXMJ (-1,'*ReNume*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Optimisation de la largeur de bande')
10021 FORMAT(A8,' Nombre de noeuds du maillage NBTPTG=',I8
     &       ,', Nombre d''elements NBTEL=',I5
     &       ,', Nombre max. de points par elt. NBPTEX=',I8
     &/,T9,' Degre moyen LGDEGX/NBTPTG =',I8,', maximum MXDEG =',I8)
10022 FORMAT(T10,' La largeur de bande a ete reduite (',I8
     &,' d.l.) : ',I5,' > ',I5,:
     &/T10,' Nombre de coeff. du profil inferieur (en noeuds) :'
     &,I9,' > ',I9)
10023 FORMAT(T10,' La largeur de bande est deja optimale (',I8
     &,' d.l.) : ',I5,:
     &/T10,' Nombre de coeff. du profil inferieur (en noeuds) :'
     &,I9,' > ',I9)
                                                                    END !ReNume
