*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RINFOR (NBTPTG,NBTEL,NBPTEX,NGNEEL,NBVOIX,MXDEG,ADVOIS
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (1er juillet 2002)
* Version 2.0.1
*
* Recherche du degre maximum dans la connectique des noeuds
* (calcul d'un majorant du nombre de voisins d'un noeud)
*
*-- Arguments d'entree --
* NBTPTG nombre maximum de dl du maillage
* NBTEL  nombre d''elements du maillage
* NBPTEX nombre maximum de points par element 
* NGNEEL tableau #NGEEL,NIVENG
* NBVOIX tableau des nombres de voisins maxima par dl
*-- Argument de sortie --
* MXDEG  degre maximum dans la connectique (chaque voisin est compte
*        autant de fois qu'il apparait dans un element)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBTPTG,NBTEL,NBPTEX,NGNEEL(NBPTEX,*),NBVOIX(*)
     &       ,MXDEG,ADVOIS(*),NIVIMP,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER NGI,NBVOIS,L,IDL,LGDEGX,NBIMP
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Rinfor*')
*
*     Initialisation de NBVOIX
      LGDEGX=0
      DO 1 NGI=1,NBTPTG
         NBVOIX(NGI)=0
1     CONTINUE
*
*     Parcours des elements
      DO 4 L=1,NBTEL
*        Parcours des dl de l'element
         DO 3 IDL=1,NBPTEX
           NGI=NGNEEL(IDL,L)
           IF (NGI.GT.0) NBVOIX(NGI)=NBVOIX(NGI)+NBPTEX-1
3        CONTINUE
4     CONTINUE
*
*     Degre maximum ?
      MXDEG=0
      DO 5 NGI=1,NBTPTG
         NBVOIS=NBVOIX(NGI)
         IF (NBVOIS.LE.0) GOTO 99991
         MXDEG=MAX (MXDEG,NBVOIS)
         ADVOIS(NGI)=LGDEGX+1
         LGDEGX=LGDEGX+NBVOIS+1
5     CONTINUE
      ADVOIS(NBTPTG+1)=LGDEGX
      CALL PRFXMJ (-1,'*Rinfor*')
*-----------------------------------------------------------------------
*     Impressions
      IF (IMPFCH.LE.0) RETURN
      IF (NIVIMP.LE.0) RETURN
      WRITE (IMPFCH,10000) PRFXAS(0)//'>*Rinfor*',NBTPTG,LGDEGX/NBTPTG+1
     &,MXDEG
      IF (NIVIMP.GE.5) THEN
         WRITE (IMPFCH,10001) (NGI,ADVOIS(NGI+1)-ADVOIS(NGI)
     &,NGI=1,NBTPTG)
      ELSE
         NBIMP=MIN(10*NIVIMP+1,NBTPTG)
         WRITE (IMPFCH,10001) (NGI,ADVOIS(NGI+1)-ADVOIS(NGI)
     &,NGI=1,NBIMP-1)
      ENDIF
10000 FORMAT (A,' Noeud->Nombre max de voisins (Nb de noeuds=',I6
     &,', Nb de voisins moyen <=',I4,', maximum maximorum =',I4,')')
10001 FORMAT (10(I7,'->',I7,' |'))
      RETURN
*
*     Bugs
*
99991 WRITE (*,90991) PRFXAS(1)//'>*Rinfor*',NGI
      CALL BAISE(' *RInfor* Ce maillage est un vrai fromage !')
90991 FORMAT (A,' Le noeud global ',I12,' n''a pas de voisins ?')
                                                                    END !RInfor
