*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GBODYR (NOMINT,NOMTRM,NIVTRM,NOMDOM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : M.Lenoir & F.Mahe (1992), D.Martin (mars.2002)
* Derniere modification : D.Martin & C.Chambeyron (31.mars.2010)
* Version 2
*
* Ecriture de la partie numerique d'un resultat sur un domaine geometrique
*
*-- Arguments d'entree --
* NOMINT nom de la donnee chaine de caractere caracterisant le nom des 
*        fichiers resultats (nom interne du fichier)
* NOMTRM nom du terme resultat a ecrire
* NIVTRM niveau du terme resultat
* NOMDOM nom du domaine geometrique
*
* Les Structures $NomDS et $InfDS sont decrites dans GBegin
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINT,NOMTRM,NOMDOM
      INTEGER       NIVTRM
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER   INTTYP,KELCHN,KLTERM
      INTEGER   LNOUTP,LNPRFX,LNSUFX,LNMEXT,NUNITE,MC1DOM,MCNDOM
     &         ,LGENDS,NBDESS,LGCHAR,NBCARD,INCNDS,INCNDO,ADNETO
     &         ,LGNMDS,MCNMDS,LGINDS,MCINDS,LGTERM,MCMTRM,MCDTRM
     &         ,MCINCO,MCTRDO,LGERDO,NBDOMK,LGCANO,NCHDOM,NBCHN
     &         ,NUMCHN,NUMDES,MCDIRS,IBID,I,J,NENEDO,NCATR1
     &         ,NIVTRW,ITYPTR,ITYCAL,NUKALE,NUDONN
     &         ,NVALNE,NVDSMV,NUINCL,NVDUMC,NBNEUC,NVNUMC
     &         ,NUINCO,NVDUML,NBNEUL,NVNUMT,INSTOK,NVSTOK
     &         ,NVCOOR,IRTRDO,NIVIMP,NVALGR
      LOGICAL   OUVERT,EXISTE
      CHARACTER OUTPUT*8,PRFX*8,SUFX*8,NOMEXT*72,ERCODE*120
      COMMON/FORMAH/ERCODE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CALL PRFXMJ (1,'<GBodyR>')
*
*     Ecriture du resultat
*
      CALL TBRR3  (ERCODE,'$NomDS',1,LGNMDS,'$InfDS',1,LGINDS
     &                   , NOMTRM ,NIVTRM,LGTERM)
      CALL TBAR6  (ERCODE,'$NomDS',1,MCNMDS,'$InfDS',1,MCINDS
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,LGCANO,NCHDOM)             !utilite
      LGENDS=IST(MCINDS)
      NBDESS=IST(MCINDS+1)
      LGCHAR=IST(MCINDS+2)
      NBCARD=IST(MCINDS+3)
      INCNDS=IST(MCINDS+4)
      INCNDO=IST(MCINDS+5)
      NBCHN =NBCARD*NBDESS
*     Numero du dessin concerne
      NUMCHN=KELCHN (NOMINT,AST(MCNMDS),NBCHN,LGCHAR)
*     Chaine de caracteres definissant le format des fichiers de sortie
      CALL GETCHN (AST(MCNMDS),LGCHAR,NUMCHN+2,OUTPUT)                   !utilite
      NUMDES=1+NUMCHN/NBCARD
*
      LNOUTP=LEN (OUTPUT)
      CALL GCHARS (OUTPUT,'r',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
      CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
      INQUIRE (FILE=NOMEXT(1:LNMEXT),EXIST=EXISTE,OPENED=OUVERT
     &        ,NUMBER=NUNITE)
      IF (.NOT.EXISTE.OR..NOT.OUVERT) GOTO 99991
*
*     Recherche des caracteristiques du terme
*
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NOMTRM,NIVTRM)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NIVTRW
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMV
     &            ,NUINCL,NVDUMC,NBNEUC,NVNUMC
     &            ,NUINCO,NVDUML,NBNEUL,NVNUMT
     &            ,INSTOK,NVSTOK,NVCOOR,IRTRDO,NIVIMP)                  !sdexplo
      IF (NUINCO.EQ.NDFINC) THEN
         NUINCO=NUINCL
         NVNUMT=NVNUMC
      ENDIF
*
      CALL SDEXCO (NUINCO,IST(MCINCO),NCPINC,INTRPI,NBTNEC)             !utilite
*
      ERCODE(1:1)='!'
      CALL TBAR1  (ERCODE,'$DimRS',NUMDES,MCDIRS)
      IF (ERCODE(1:1).EQ.'C') GOTO 99995
      NVALGR=IST(MCDIRS)
*
*     Coherence des donnees
*
      IF (NVALGR.GT.NVALNE)      GOTO 99993
      DO 1 J=1,NVALGR
         IF (IST(MCDIRS+J).GT.NVALNE) GOTO 99994
1     CONTINUE
*
      MCNDOM=MCINDS+LGENDS+INCNDS*(NUMDES-1)
*
*     Recherche du domaine avec la bonne interpolation (et non etendu)
*
      CALL TBAR2  (ERCODE,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO)
      NUDOMG=KELCHN (NOMDOM,AST(MCMDOM),NBDOMG,NCHDOM)                  !sdexplo
      IF (NUDOMG.EQ.0) CALL ERDOMA (1,NOMDOM)                           !utilite
      NDEBMX=MCTRDO+LGERDO
      DO 5 IDOM=1,NBDOMK
         NBTRDO=IST(NDEBMX+LGCANO-2)
         NDEBMX=NDEBMX+LGCANO+NBTRDO
5     CONTINUE
      NDEBMX=NDEBMX-1  
      NBTRDO=0 
      NDEBDO=MCTRDO+LGERDO-LGCANO
6     NDEBDO=NDEBDO+LGCANO+NBTRDO 
      IF (NDEBDO.GT.NDEBMX) GOTO 99992 
      IDOMG=IST(NDEBDO) 
      IF (NUDOMG.EQ.IDOMG) THEN
         CALL GETDOM (IST(NDEBDO),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &               ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX
     &               ,NBNEFX,NBDLFX,NVNUMC
     &               ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY
     &               ,NBNEFY,NBDLFY,NVNUML,NVCOOR,INUTIL,NBTRDO,NIVDOM) !sdexplo
         IF (INDEXC.EQ.0.AND.INDEXL.EQ.0) THEN
            IF (INTRPI.EQ.INTRPC) THEN
               NVNUMD=NVNUMC
               INTRPD=INTRPC
            ELSEIF (INTRPI.EQ.INTRPL) THEN
               NVNUMD=NVNUML
               INTRPD=INTRPL
            ELSE
               GOTO 6
            ENDIF
         ELSE
            GOTO 6
         ENDIF
      ELSE
         NBTRDO=IST(NDEBDO+LGCANO-2)
         GOTO 6
      ENDIF
*
*     Enrichissement de la structure de donnees pour le cas du 1er terme
      CALL TBRR1  (ERCODE,'#GNEDO',NVNUMD,MCNEDO)
*
      IF (IST(MCNDOM+1).EQ.1) THEN
*
*        Nombre d'elements et nombre de noeuds
*
         CALL TBRR1  (ERCODE,'#ISTEL',NUDOMG,MCLIST)
         CALL TBAR2  (ERCODE,'#ISTEL',NUDOMG,MCLIST
     &                      ,'#GNEDO',NVNUMD,MCNEDO)
         CALL EXLIST (IST(MCLIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &               ,NBNEEZ,NBDLEZ,NBNEFZ,NBDLFZ)                      !sdexplo
         NBNEDO=IST(MCNEDO+1)
         CALL TBSAVE ('#ISTEL',NUDOMG)
*
*        Agrandissement
*
         LGINDS=LGINDS+INCNDO
         CALL TBAJST ('$InfDS',1,LGINDS)
         CALL TBAR1  (ERCODE,'$InfDS',1,MCINDS)
*
*        Decalage d'un domaine
*
         MCFDOM=MCINDS+LGINDS-1
         MCNDOM=MCINDS+LGENDS
         MC1DOM=MCNDOM+INCNDS*NBDESS+INCNDO
         DO 10 K=1,NUMDES
            MC1DOM=MC1DOM+INCNDO*IST(MCNDOM)
            MCNDOM=MCNDOM+INCNDS
10       CONTINUE
         DO 11 K=MCFDOM,MC1DOM,-1
            IST(K)=IST(K-INCNDO)
11       CONTINUE
*
*        Caracteristiques du domaine
*
         MCNDOM       =MCNDOM-INCNDS
         IST(MCNDOM)  =IST(MCNDOM)+1
         MC1DOM       =MC1DOM-INCNDO
         IST(MC1DOM  )=NUDOMG
         IST(MC1DOM+1)=NUDOMK
         IST(MC1DOM+2)=NXLIST
         IST(MC1DOM+3)=NVNUMD
         IST(MC1DOM+4)=NBELDO
         IST(MC1DOM+5)=NBNEDO
         IST(MC1DOM+6)=INTRPD
         IST(MC1DOM+7)=NDMDOM
      ENDIF
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      IF (OUTPUT(1:6).EQ.'unighn') THEN
*
*        Fichier de resultat au format 'unighn'
*
*        En cas de terme a valeurs complexes (SURTOUT NE RIEN FAIRE)
*        car le cas complexe est prevu dans matme / matlab
*
*        IF (ITYPTR.NE.INTTYP ('REEL')) CALL WATERM (4,NOMTRM,NIVTRM)
*
      ELSEIF (OUTPUT(1:7).EQ.'mesh&bb') THEN
*
*        Fichier de resultat au format 'bb'
*        Le 2 final indique que les valeurs sont attachees aux noeuds
*        (1 indiquerait une info attachee aux faces)
*
         WRITE (NUNITE,*) NDIM,NVALGR,LGTERM/NVALNE,2
*        En cas de terme a valeurs complexes
         IF (ITYPTR.NE.INTTYP ('REEL')) CALL WATERM (4,NOMTRM,NIVTRM)
*
      ELSEIF (OUTPUT(1:8).EQ.'paraview') THEN
*
*        Fichier de resultat au format 'bb' pour reinterpretation Paraview
*
         WRITE (NUNITE,*) NDIM,NVALGR,LGTERM/NVALNE,2,ITYPTR
*        En cas de terme a valeurs complexes
         IF (ITYPTR.NE.INTTYP ('REEL')) CALL WATERM (4,NOMTRM,NIVTRM)
      ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*     Ecriture des valeurs du terme
*
      NBERRN=0
      IF (NVNUMT.EQ.NVNUMD) THEN
*
*        Meme numerotation pour le terme et le domaine
*
         CALL TBAR2  (ERCODE,NOMTRM,NIVTRM,MCTERM
     &                      ,'$DimRS',NUMDES,MCDIRS)
         IF (ITYPTR.EQ.INTTYP ('REEL')) THEN
            DO 22 I=MCTERM,MCTERM+LGTERM-1,NVALNE
               WRITE (NUNITE,10000) 
     &               (RST(I+IST(MCDIRS+J)-1),J=1,NVALGR)
22          CONTINUE
         ELSE
            DO 24 I=MCTERM,MCTERM+LGTERM-1,NVALNE
               WRITE (NUNITE,10000) 
     &               (CST(I+IST(MCDIRS+J)-1),J=1,NVALGR)
24          CONTINUE
         ENDIF
      ELSE
*
*        Numerotation differente pour le terme et le domaine
*        Restriction du terme aux noeuds du domaine.
*
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUMT,MCNETO)
         CALL TBAR4  (ERCODE,NOMTRM,NIVTRM,MCTERM,'#GNEDO',NVNUMT,MCNETO
     &                   ,'#GNEDO',NVNUMD,MCNEDO,'$DimRS',NUMDES,MCDIRS)
         NBNEDO=IST(MCNEDO+1)
         NBNETO=IST(MCNETO+1)
         MCNEDO=MCNEDO+2
         NXNETO =1
         IF (ITYPTR.EQ.INTTYP ('REEL')) THEN
            DO 32 NENEDO=1,NBNEDO
               CALL DICOTO (NXNETO,NBNETO,IST(MCNETO+2),IST(MCNEDO)
     &                     ,NUNETR,*31)                                 !utilite
               NXNETO=NUNETR+1
*              Le noeud NENEDO du domaine est le noeud NUNETR du terme
               ADNETO=MCTERM+NVALNE*(NUNETR-1)
               WRITE (NUNITE,10000) 
     &               (RST(ADNETO+IST(MCDIRS+J)-1),J=1,NVALGR)
               MCNEDO=MCNEDO+1
               GOTO 32
31             NBERRN=NBERRN+1
               MCNEDO=MCNEDO+1
32          CONTINUE
            CALL TBSAVE ('#GNEDO',NVNUMT)
         ELSE
            DO 34 NENEDO=1,NBNEDO
               CALL DICOTO (NXNETO,NBNETO,IST(MCNETO+2),IST(MCNEDO)
     &                     ,NUNETR,*33)                                 !utilite
               NXNETO=NUNETR+1
*              Le noeud NENEDO du domaine est le noeud NUNETR du terme
               ADNETO=MCTERM+NVALNE*(NUNETR-1)
               WRITE (NUNITE,10000) 
     &               (CST(ADNETO+IST(MCDIRS+J)-1),J=1,NVALGR)
               MCNEDO=MCNEDO+1
               GOTO 34
33             NBERRN=NBERRN+1
               MCNEDO=MCNEDO+1
34          CONTINUE
            CALL TBSAVE ('#GNEDO',NVNUMT)
         ENDIF
         IF (NBERRN.GT.0) GOTO 99999
      ENDIF
*
      CALL TBSAVE ('#GNEDO',NVNUMD)
      CALL TBSAVE (NOMTRM,NIVTRM)
      CALL PRFXMJ (-1,'<GBodyR>')
      RETURN
*-----------------------------------------------------------------------
*10000 FORMAT(5E14.5) Modifié le 20 mai 2011 (cf. Journal 2011) en
10000 FORMAT(5E14.5E3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('Ouvrir prealablement (GrOpen) le fichier '
     & //NOMEXT(1:LNMEXT)//'!')
99992 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      CALL ENCLER (INTRPI,ERCODE(NCATR1+1:NCATR1+2))
      ERCODE(NCATR1+3:NCATR1+NCHDOM+2)=NOMDOM
      CALL BAISE  ('Impossible de trouver le domaine '
     & //ERCODE(NCATR1+3:NCATR1+NCHDOM+2)//' avec la meme interpolation'
     & //' ('//ERCODE(NCATR1+1:NCATR1+2)//') que le terme '
     &//ERCODE(1:NCATR1)//
     &', ou bien le domaine trouve est ''etendu'' en colonne ou ligne.'
     &//' Vous pouvez resoudre provisoirement ce probleme en calculant'
     &//' un terme de masse sur '//ERCODE(NCATR1+3:NCATR1+NCHDOM+2)
     &//' avec une inconnue correspondant a l''interpolation'
     &//ERCODE(NCATR1+1:NCATR1+2)//'.')
99993 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      CALL ENCLER (NVALGR,ERCODE(NCATR1+1:NCATR1+1))
      CALL ENCLER (NVALNE,ERCODE(NCATR1+2:NCATR1+2))
      CALL BAISE  ('Le terme ('//ERCODE(1:NCATR1)//') n''a que '
     &//ERCODE(NCATR1+2:NCATR1+2)
     &//' composantes, vous cherchez la composante '
     &//ERCODE(NCATR1+1:NCATR1+1)//'!')
99994 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      CALL ENCLER (IST(MCDIRS+J),ERCODE(NCATR1+1:NCATR1+1))
      CALL BAISE  ('Le terme ('//ERCODE(1:NCATR1)
     &//') n''a pas de composante numero '
     &//ERCODE(NCATR1+1:NCATR1+1)//'!')
99995 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      CALL BAISE  ('Vous avez sans doute oublie d''ecrire l''entete '
     &//'(avec M2UENR) pour le resultat '//ERCODE(1:NCATR1)
     &//' sur le fichier '//NOMEXT(1:LNMEXT)) 
99999 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      ERCODE(NCATR1+1:NCATR1+NCHDOM)=NOMDOM
      CALL ENCLER (NBERRN,ERCODE(NCATR1+NCHDOM+1:NCATR1+NCHDOM+10))
      CALL BAISE  ('Le terme '//ERCODE(1:NCATR1)
     &//' n''est pas defini sur tous les noeuds du domaine '
     &//ERCODE(NCATR1+1:NCATR1+NCHDOM)//'. Il manque '
     &//ERCODE(NCATR1+NCHDOM+1:NCATR1+NCHDOM+10)//' noeuds.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin & C.Chambeyron (23/31.mars.2010)
* added graphical output vtk for Paraview
* Version 1 : D.Martin (20.mars.2002)
* Version 0 : M.Lenoir & F.Mahe (1992)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !GBodyR
