*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GCHARS (INPUT,GEORES
     &                  ,OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Author : D.Martin (mars.2002)
* Last Update : D.Martin & C; Chambeyron (23.mars.2010)
* Version 2
*
* Returns prefixes/suffixes of output graphic files
* / Prefixes/suffixes des noms de fichiers de sorties graphiques
*
*-- input args --
* INPUT  input (user's) format type name :
*         'unighn' ( = 'grame' = 'matlab' = 'matme' )  
*         'mesh&bb' ( = 'medit' )
*         'paraview'
* GEORES geometry ('g') or numerical results ('r' or 'p') file prefixes/suffixes
*-- output args --
* OUTPUT standardized format type ('unighn' or 'mesh&bb' or 'paraview')
* LNOUTP 'OUTPUT' string length
* PRFX   prefix to file name
* LNPRFX length of prefix
* SUFX   suffix to file name
* LNSUFX length of suffix
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) INPUT,GEORES,OUTPUT,PRFX,SUFX
      INTEGER       LNOUTP,LNPRFX,LNSUFX
*-----------------------------------------------------------------------
      PRFX=' '
      LNPRFX=0
      SUFX=' '
      LNSUFX=0
*
      OUTPUT=INPUT
*
      IF (INPUT(1:5).EQ.'grame'.OR.INPUT(1:5).EQ.'matlab'.OR.
     &    INPUT(1:5).EQ.'matme') THEN
*
*     Format unighn : mots-cles acceptes : unighn*, grame*, matlab*
*
        OUTPUT='unighn'
*
      ELSEIF (INPUT(1:5).EQ.'medit') THEN
*
*     Format mesh&bb : mots-cles acceptes : mesh&bb*, medit*
*
         OUTPUT='mesh&bb'
*
      ELSEIF (INPUT(1:8).EQ.'paraview') THEN
*
*     Format paraview: mots-cles acceptes : paraview*
*
         OUTPUT='paraview'
*
      ENDIF
*
      IF (INPUT(1:7).EQ.'mesh&bb') THEN
         LNOUTP=7
         IF (GEORES(1:1).EQ.'g') THEN
            SUFX='.mesh'
            LNSUFX=5
         ELSEIF (GEORES(1:1).EQ.'r') THEN
            SUFX='.bb'
            LNSUFX=3
         ENDIF      
      ELSEIF (INPUT(1:6).EQ.'unighn') THEN
         LNOUTP=6
         IF (GEORES(1:1).EQ.'g') THEN
            PRFX='GE'
            LNPRFX=2
         ENDIF
      ELSEIF (INPUT(1:8).EQ.'paraview') THEN
         LNOUTP=8
         IF (GEORES(1:1).EQ.'g') THEN
            SUFX='_t.mesh'
            LNSUFX=7
         ELSEIF (GEORES(1:1).EQ.'r') THEN
            SUFX='_t.bb'
            LNSUFX=5
         ELSEIF (GEORES(1:1).EQ.'p') THEN
            SUFX='.vtk'
            LNSUFX=4
         ENDIF
      ELSE
         CALL BAISE ('Mot-cle '//INPUT(1:8)//' non reconnu. Utilisez '
     &              //'mesh&bb ou paraview ou unighn')
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : C. Chambeyron (23.mars.2010)
* added graphical output vtk for Paraview
* Version 1 : D.Martin (20.mars.2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !GChars

