*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX
     &                  ,NOMEXT,LNMEXT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Author : D.Martin (March 2002)
* Last Update : D.Martin (5 March 2002)
* Version 1.0.0
*
* Returns names of output graphic files
* / Nom des fichiers de sorties graphiques
*
*-- input args --
* NOMINT constant bearing the root part of file name
*        nom de la donnee chaine de caractere caracterisant le nom des 
*        fichiers resultats (nom interne du fichier)
* PRFX   prefix to file name (output of GCHARS)
* LNPRFX length of prefix (output of GCHARS)
* SUFX   suffix to file name (output of GCHARS)
* LNSUFX length of suffix (output of GCHARS)
*-- output args --
* NOMEXT graphic output file name (character string)
*        = PRFX + Value of NOMEXT + SUFX
* LNMEXT length of output file name
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NOMINT,PRFX,SUFX,NOMEXT
      INTEGER       LNPRFX,LNSUFX,LNMEXT
*
      INTEGER   IBID
      REAL      RBID
      COMPLEX   CBID
      CHARACTER ABID
*-----------------------------------------------------------------------
      NOMEXT=' '
      LNMEXT=0
*
*     Prefix
*
      IF (LNPRFX.GT.0) THEN
         NOMEXT=PRFX
         LNMEXT=LNMEXT+LNPRFX
      ENDIF      
*
*     File name Root = NOMEXT is the value of data constant NOMINT
*
      CALL GETCST (NOMINT,ABID,IBID,RBID,CBID,NOMEXT(LNPRFX+1:))        !sdexplo
*
*     Length of File Name (up to first blank character)
*
      LNMEXT=INDEX (NOMEXT,' ')-1
*
*     Suffix
*
      IF (LNSUFX.GT.0) THEN
         NOMEXT(LNMEXT+1:)=SUFX
         LNMEXT=LNMEXT+LNSUFX
      ENDIF
                                                                    END !GFileN


