*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GHEADR (NOMINT,COMENT,COMPOS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : M.Lenoir & F.Mahe (1992), D.Martin (mars.2002)
* Derniere modification : D.Martin (23.mars.2010)
* Version 2
*
*   Writes a graphics result header on a output file
* / Ecriture de l'entete d'un resultat de dessin
*
*-- Arguments d'entree --
* NOMINT nom de la donnee chaine de caractere caracterisant le nom des 
*        fichiers resultats (nom interne du fichier)
* COMENT chaine de commentaire apparaissant dans l'entete du resultat
* COMPOS chaine indiquant les composantes du resultat a tracer
*       =(' ','1','2','3','12','21','23','32','13','31',
*       = '123',312','231','132','321','213')
*       ' ' defaut : toutes les composantes du vecteur
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINT,COMENT,COMPOS
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER   LNOUTP,LNPRFX,LNSUFX,LNMEXT,NUNITR,AD1DOM,DIMRES
     &         ,LGENDS,NBDESS,LGCHAR,NBCARD,INCNDS,INCNDO
      INTEGER   INTTYP,KELCHN
      LOGICAL   OUVERT,EXISTE
      CHARACTER OUTPUT*8,PRFX*8,SUFX*8,NOMEXT*72,ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'<GHeadR>')
*
*     Structure de donnees
*
      CALL TBAR2  (ERCODE,'$NomDS',1,MCNMDS,'$InfDS',1,MCINDS)
      LGENDS=IST(MCINDS)
      NBDESS=IST(MCINDS+1)
      LGCHAR=IST(MCINDS+2)
      NBCARD=IST(MCINDS+3)
      INCNDS=IST(MCINDS+4)
      INCNDO=IST(MCINDS+5)
      NBCHN =NBCARD*NBDESS
*     Numero du dessin concerne
      NUMCHN=KELCHN (NOMINT,AST(MCNMDS),NBCHN,LGCHAR)                   !utilite
*     Chaine de caracteres definissant le format des fichiers de sortie
      CALL GETCHN (AST(MCNMDS),LGCHAR,NUMCHN+2,OUTPUT)                  !utilite
      NUMDES=1+NUMCHN/NBCARD
      AD1DOM=MCINDS+LGENDS+INCNDS*(NUMDES-1)
      IST(AD1DOM+1)=IST(AD1DOM+1)+1
*
      LNOUTP=LEN (OUTPUT)
      CALL GCHARS (OUTPUT,'r',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
      CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
*
      INQUIRE (FILE=NOMEXT(1:LNMEXT),EXIST=EXISTE,OPENED=OUVERT
     &        ,NUMBER=NUNITR)
      IF (.NOT.EXISTE.OR..NOT.OUVERT) GOTO 99990
*
*     Stockage des numeros des composantes du vecteur resultat
*
      CALL TBCREE ('$DimRS',NUMDES,INTTYP('ENTIER'),4,'c')
      CALL TBAR1  (ERCODE,'$DimRS',NUMDES,MCDIRS)
      IF (COMPOS(1:1).EQ.' ') THEN
         DIMRES=1
         IST(MCDIRS+1)=1
      ELSE
         DO 1 DIMRES=LEN(COMPOS),1,-1
            IF (COMPOS(DIMRES:DIMRES).NE.' ') GOTO 2
1        CONTINUE
2        IF(DIMRES.GT.3) GOTO 99991
         DO 3 I=1,DIMRES
            CALL RELCNE (COMPOS(I:I),NUMERO)                            !utilite
            IF (NUMERO.GT.3.OR.NUMERO.LT.1) GOTO 99992
            IST(MCDIRS+I)=NUMERO
3        CONTINUE
      ENDIF
      IST(MCDIRS)=DIMRES
*
*--   Fichier de resultats
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
      IF (OUTPUT(1:6).EQ.'unighn') THEN
*
*        Fichier de resultat au format 'unighn'
*
         WRITE (NUNITR,*)'RES'
         ERCODE=COMENT
         LG    =MIN (LEN (ERCODE),LEN (COMENT))
         WRITE (NUNITR,*)'NOM ',''''//ERCODE(:LG)//''''
         CALL ENCLER (DIMRES,ERCODE(1:1))
         ERCODE(2:2)='D'
         WRITE (NUNITR,*) ERCODE(1:2)
         WRITE (NUNITR,*)'REFGEO ','''GE'//NOMEXT(:LNMEXT)//''''
         WRITE (NUNITR,*)'VAL'
*
*      ELSEIF (OUTPUT(1:7).EQ.'mesh&bb'.OR.
*     &        OUTPUT(1:8).EQ.'paraview') THEN
*
*        Fichier de resultat au format 'bb' (pas de header)
*
      ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      CALL PRFXMJ (-1,'<GHeadR>')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 ERCODE=NOMEXT
      CALL BAISE  ('Ouvrir prealablement (avec GBegin) le fichier '
     & //ERCODE(1:LNMEXT)//'!')
99991 ERCODE=COMPOS
      CALL BAISE  ('Chaine '//ERCODE(1:LEN(COMPOS))//' impossible.')
99992 ERCODE=COMPOS(I:I)
      CALL BAISE  ('Numero de composante '//ERCODE(1:1)//' inconu.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (23.mars.2010)
* modified when no header is required in format ('mesh&bb', 'paraview'
* Version 1 : D.Martin (20.mars.2002)
* Version 0 : M.Lenoir & F.Mahe (1992)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !GHeadR                               
