*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M2UGEO
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : M.Lenoir & F.Mahe (1992)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*
* Ecriture des donnees geometriques pour le dessin de domaines.
* Dans le cas d'elements de type differents ne fonctionne que
* pour le cas 2D ou 2D5 et les elements Pk, Qk.
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       KLUNIT   
      INTEGER       NUNITG,NUNITR,ADNDOM,AD1DOM,ADNOMD,ADNUMD,ADNEDO
     &             ,LGENDS,NBDESS,LGCHAR,NBCARD,INCNDS,INCNDO,ADRDOM
      INTEGER       NUNEFA (10)
      REAL          RBID
      COMPLEX       CBID
      CHARACTER     NOMINT*20,NOMEXT*72,CHDIM*3,ERCODE*120,ELTDIF*5
      CHARACTER     LEYTUN*5,NWTYPE*2,TYPE*5
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'<M2uGeo>')
      CHDIM =' '
      NWTYPE=' '
      NOMEXT=' '
      ELTDIF =' '
*
      CALL TBAR1  (ERCODE,'$InfDS',1,MCINDS)                     
*
      LGENDS=IST(MCINDS)
      NBDESS=IST(MCINDS+1)
      LGCHAR=IST(MCINDS+2)
      NBCARD=IST(MCINDS+3)
      INCNDS=IST(MCINDS+4)
      INCNDO=IST(MCINDS+5)
      ADNDOM=LGENDS
      AD1DOM=LGENDS+INCNDS*NBDESS
      ADNOMD=1
      NUNITG=KLUNIT ( )                                                 !sdexplo
*
*     Boucle sur les dessins
*
      DO 10 NUMDES=1,NBDESS
         CALL TBAR2  (ERCODE,'$NomDS',1,MCNMDS,'$InfDS',1,MCINDS)
*
*--      Calcul du nombre d'elements et de degres de liberte du dessin
*
         NBDODS =IST(ADNDOM+MCINDS)
         ADNUMD=MCINDS+AD1DOM
         NUDOMG=IST(ADNUMD)
         NXLIST=IST(ADNUMD+2)
         INTERP=IST(ADNUMD+6)
         NDMDOM=IST(ADNUMD+7)
         NDMDOE=NDIM
         ADRDOM=AD1DOM
*        Les elements sont-ils tous de meme type?
*
         CALL M2UTYP (NBDODS,ADRDOM,INCNDO,ELTDIF,NBNEDS,NBELDS)
*
*--      Determination du nom interne, ouverture du fichier de geometrie
*
         NOMINT= ' '
         CALL GETCHN (AST(MCNMDS),LGCHAR,ADNOMD,NOMINT)                 !utilite
         NLONG=INDEX (NOMINT,' ')-1
         IF (NLONG.EQ.0) GOTO 90003
         CALL GETCHN (AST(MCNMDS),LGCHAR,ADNOMD+1,CHDIM)                !utilite
         ADNOMD=ADNOMD+NBCARD
*
*--      Determination du nom externe
*
         NOMEXT= ' '
         CALL GETCST (NOMINT(1:NLONG),ERCODE,IBID,RBID,CBID,NOMEXT)     !sdexplo
         NLONG=INDEX (NOMEXT,' ')-1
         OPEN (UNIT=NUNITG,FILE='GE'//NOMEXT(1:NLONG),STATUS='UNKNOWN'
     &        ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=90000)
         WRITE (NUNITG,*) 'GEO'
         WRITE (NUNITG,*) 'NOM',' ''GE'//NOMEXT(1:NLONG)//''' '
*
         IF (ELTDIF.EQ.' ') THEN
            CALL TBRR1 (ERCODE,'#ISTEL',NUDOMG,LGSTEL)
            CALL TBAR1 (ERCODE,'#ISTEL',NUDOMG,MCLIST)
            MCBLOK=MCLIST
            IF (NBBBLK.GE.2) CALL TBAR1(ERCODE,'#LOKEL',1,MCBLOK)
            NUTYAV=0
            NUFAAV=0
            CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MCLIST),IST(MCBLOK)
     &                  ,NUTGEO,INTERP,NUEL,NUTYAV,NUTYLE,LAGHER,KCLASS
     &                  ,NBNEEL,NBDLEL,NUF,NUFAAV,NUTYFA,NBNEFA,NBDLFA
     &                  ,NUNEFA,NUNEFA,0,IMPSDR)                        !Sdexplo
            IF (NDMDOM.LT.NDIM) NUTYLE=NUTYFA
*
*           Determination du type de l'element
            TYPE=LEYTUN (NUTYLE)                                        !Ef?d
            IF (TYPE(1:2).EQ.'TE'.OR.TYPE(1:2).EQ.'TR'
     &                           .OR.TYPE(1:2).EQ.'SE') THEN
               NWTYPE='P'
            ELSEIF (TYPE(1:2).EQ.'HE'.OR.TYPE(1:2).EQ.'QU') THEN
               NWTYPE='Q'
            ELSEIF (TYPE(1:2).EQ.'PR') THEN
               NWTYPE='R'
            ELSE
               GOTO 90004
            ENDIF
            CALL RELCNE (TYPE(3:5),NUTYPE)                              !utilite
            CALL ENCLER (NUTYPE,NWTYPE(2:2))                            !utilite
            CALL TBSAVE ('#ISTEL',NUDOMG)
            WRITE (NUNITG,*) CHDIM,' ',NWTYPE
         ELSE
            WRITE (NUNITG,*) CHDIM,' ','MIXTE'
         ENDIF
*
         WRITE (NUNITG,*) 'NBPTS ',NBNEDS,' NBEL ',NBELDS
*
*--      Ecriture des coordonnees des noeuds pour tous les domaines
*
         CALL TBRR1  (ERCODE,'#ORNOE',INTERP,MCORNO)
*
         NDIMCO=NDIM
         IF (CHDIM(3:3).EQ.'5') THEN
            CALL RELCNE (CHDIM(1:1),NDIMCO)
            NDIMCO=NDIMCO+1
         END IF
         WRITE (NUNITG,*) 'POINTS'
         ADNEDO=AD1DOM+5
         DO 3 NUDOMD=1,NBDODS
            CALL TBAR1  (ERCODE,'$InfDS',1,MCINDS)
            NVNUMD=IST(ADNEDO-2+MCINDS)
            CALL TBRR1 (ERCODE,'#GNEDO',NVNUMD,MCNUME)
            CALL TBAR3 (ERCODE,'#GNEDO',NVNUMD,MCNUME
     &                        ,'#ORNOE',INTERP,MCORNO
     &                        ,'$InfDS',1,MCINDS)
*           Boucle sur les noeuds
            DO 2 I=1,IST(ADNEDO+MCINDS)
               ID=MCORNO+NDIM*(IST(MCNUME+1+I)-1)
               WRITE (NUNITG,10000) (RST(K),K=ID,ID+NDIM-1)
     &                             ,(0.,K=NDIM,NDIMCO-1)
2           CONTINUE
            ADNEDO=ADNEDO+INCNDO
            CALL TBSAVE ('#GNEDO',NVNUMD)
3        CONTINUE
         CALL TBSAVE ('#ORNOE',INTERP)
*
*--      Ecriture de la numerotation des noeuds pour tous les domaines
*
         WRITE (NUNITG,*)'NUMEL'
         NBNE=0
         DO 8 NUDOMD=1,NBDODS
            NUDOMG=IST(AD1DOM  +MCINDS)
            NUDOMK=IST(AD1DOM+1+MCINDS)
            NXLIST=IST(AD1DOM+2+MCINDS)
            NBELDO=IST(AD1DOM+4+MCINDS)
            NBNEDO=IST(AD1DOM+5+MCINDS)
            NDMDOM=IST(AD1DOM+7+MCINDS)
            IF (ELTDIF.EQ.' ') THEN
*
               CALL TBRR1 (ERCODE,'#RGNDO',NUDOMK,LGGNDO)
               CALL TBAR1 (ERCODE,'#RGNDO',NUDOMK,MCGNDO)
*              Boucle sur les elements du domaine
               ID=MCGNDO+1
               DO 4 I=1,NBELDO
*                 Ecriture de la numerotation
                  NBNEEL=IST(ID)
                  WRITE (NUNITG,10001) (IST(K)+NBNE,K=ID+1,ID+NBNEEL)
                  ID=ID+NBNEEL+1
4              CONTINUE
            ELSE
*
               CALL TBRR2  (ERCODE,'#RGNDO',NUDOMK,LGGNDO
     &                            ,'#ISTEL',NUDOMG,LGSTEL)
               CALL TBAR2  (ERCODE,'#RGNDO',NUDOMK,MCGNDO
     &                            ,'#ISTEL',NUDOMG,MCLIST)
               MCBLOK=MCLIST
               IF (NBBBLK.GE.2) CALL TBAR1(ERCODE,'#LOKEL',1,MCBLOK)
*
*              Boucle sur les elements du domaine
               NUTYAV=0
               NUFAAV=0
               ID=MCGNDO+1
               DO 5 I=1,NBELDO
                  CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MCLIST)
     &                        ,IST(MCBLOK),NUTGEO,INTERP,NUEL,NUTYAV
     &                        ,NUTYLE,LAGHER,KCLASS
     &                        ,NBNEEL,NBDLEL,NUF,NUFAAV,NUTYFA
     &                        ,NBNEFA,NBDLFA,NUNEFA,NUNEFA,0,IMPSDR)    !sdexplo
*
*                 Determination du type de l'element
                  TYPE=LEYTUN (NUTYFA)
                  CALL RELCNE (TYPE(3:5),NUTYPE)
*                 A voir pour le cas 3D ----------------------------
                  IF (TYPE(1:2).EQ.'TR') THEN
                     IG=0
                  ELSEIF (TYPE(1:2).EQ.'QU') THEN
                     IG=2
                  ELSE
                     GOTO 90004
                  ENDIF
                  WRITE (NUNITG,*) NUTYPE+IG
*
*                 Ecriture de la numerotation
                  NBNEEL=IST(ID)
                  WRITE (NUNITG,*) (IST(K)+NBNE,K=ID+1,ID+NBNEEL)
                  ID=ID+NBNEEL+1
5              CONTINUE
               CALL TBSAVE ('#ISTEL',NUDOMG)                     
            ENDIF
            NBNE  =NBNE+NBNEDO
            AD1DOM=AD1DOM+INCNDO
            CALL TBSAVE ('#RGNDO',NUDOMK)
8        CONTINUE
*
*--      Fermeture du fichier de geometrie
*
         WRITE  (NUNITG,*) 'FIN'
         CLOSE  (UNIT=NUNITG,STATUS='KEEP')
*
*--      Fermeture du fichier de resultats
*
         INQUIRE (FILE=NOMEXT(1:NLONG),NUMBER=NUNITR)
         WRITE   (NUNITR,*) 'FIN'
         CLOSE   (UNIT=NUNITR,STATUS='KEEP')
*
         ADNDOM=ADNDOM+INCNDS
*
*        Destruction de la structure $DimRS pour le dessin
*
         CALL TBTUER ('$DimRS',NUMDES)
10    CONTINUE
*
*     Destruction des structures $InfDS et $NomDs
*
      CALL TBTUER ('$InfDS',1)
      CALL TBTUER ('$NomDS',1)
*
      CALL PRFXMJ (-1,'<M2uGeo>')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(3E14.5)
10001 FORMAT(10I8)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL BAISE  
     & (' Erreur sur l''ouverture du fichier de geometrie GE'
     & //NOMEXT(1:NLONG))                                               !utilite
90003 CALL ENCLER (NUMDES,ERCODE(1:3))                                  !utilite
      CALL BAISE  (' NOMINT de longueur nulle, dessin '//ERCODE(1:3))   !utilite
90004 CALL ENCLER (NUMDES,ERCODE(1:3))                                  !utilite
      CALL ENCLER (NUDOMD,ERCODE(4:8))                                  !utilite
      CALL ENCLER (1,ERCODE(9:9))                                       !utilite
      CALL BAISE  (' Type d''element :'//TYPE
     & //' non prevu dans UniGHN - Dessin '//ERCODE(1:3)
     & //'- Domaine '//ERCODE(4:8)//'-Element No'//ERCODE(9:9))         !utilite
                                                                    END !M2uGeo
