*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MB2VTK (OUTPUT,NOMINT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur :  C.Chambeyron (22.aout.2009)
* Derniere modification : D.Martin & C.Chambeyron (31.mars.2010)
* Version 1
*
* Conversion de 2 fichiers .bb et .mesh en fichier .vtk
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) OUTPUT,NOMINT
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER INTTYP
      INTEGER LNOUTP,LNPRFX,LNSUFX,LNMEXT,NUNITG,NUNITR,NUNITP
     &       ,KLUNIT, NBCOOR,N1,N2,N3,N4,TAI,RIEN,NBPTS,DIM,I,NBEL,TYPE
      REAL XPT,YPT,ZPT,VALR
      COMPLEX VALC
      CHARACTER INU*25,PRFX*8,SUFX*8,NOMEXT*72,PGON*10
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'<Mb2Vtk>')
*
      CALL GCHARS (OUTPUT,'r',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
      CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
      INQUIRE (FILE=NOMEXT(1:LNMEXT),NUMBER=NUNITR)   
      OPEN (UNIT=NUNITR,FILE=NOMEXT(1:LNMEXT),STATUS='UNKNOWN'
     &     ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=90000)
         
      CALL GCHARS (OUTPUT,'g',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
      CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
      INQUIRE (FILE=NOMEXT(1:LNMEXT),NUMBER=NUNITG)
      OPEN (UNIT=NUNITG,FILE=NOMEXT(1:LNMEXT),STATUS='UNKNOWN'
     &     ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=90000)
      
      CALL GCHARS (OUTPUT,'p',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
      CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
      NUNITP=KLUNIT ( )    
      OPEN (UNIT=NUNITP,FILE=NOMEXT(1:LNMEXT),STATUS='UNKNOWN'
     &     ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=90000)
*
* lecture du fichier de maillage
*===================================
      REWIND(NUNITG)
      READ(NUNITG,*) INU, RIEN, INU, DIM, INU, NBPTS
      TAI = DIM+1
*
* Entete du fichier vtk 
      WRITE (NUNITP,1001)  '# vtk DataFile Version 3.6'
      WRITE (NUNITP,1001)  'PolyDATA'
      WRITE (NUNITP,1001)  'ASCII'
      WRITE (NUNITP,1001)  'DATASET POLYDATA'
      WRITE (NUNITP,*)  'POINTS ',NBPTS,' float'
*
* lecture et recopie des coords des points
      IF ( DIM .EQ. 3 ) THEN
          DO I=1,NBPTS
               READ  (NUNITG,*)  XPT, YPT, ZPT, RIEN
               WRITE (NUNITP,*) XPT, YPT, ZPT 
          ENDDO
      ELSEIF ( DIM .EQ. 2 ) THEN
          DO I=1,NBPTS
               READ  (NUNITG,*)  XPT, YPT, RIEN
               WRITE (NUNITP,*) XPT, YPT, 0
          ENDDO
      ENDIF
*
      READ(NUNITG,*) PGON, NBEL
      IF ( DIM .EQ. 3 ) THEN
          WRITE (NUNITP,*) 'POLYGONS ', NBEL, NBEL*(TAI+1)
          DO I=1,NBEL
               READ  (NUNITG,*) N1, N2, N3, N4, RIEN
               WRITE (NUNITP,*) 4, N1-1, N2-1, N3-1, N4-1
          ENDDO
*
      ELSEIF ( DIM .EQ. 2 ) THEN
          WRITE (NUNITP,*) 'POLYGONS ', NBEL, NBEL*(TAI+1)
          DO I=1,NBEL
               READ  (NUNITG,*)  N1, N2, N3, RIEN
               WRITE (NUNITP,*) 3, N1-1, N2-1, N3-1
          ENDDO
      ENDIF
      WRITE (NUNITP,*)  'POINT_DATA ', NBPTS
      WRITE (NUNITP,*)  'SCALARS scalars float 1'
      WRITE (NUNITP,*)  'LOOKUP_TABLE default'
*
* lecture du fichier de valeurs
*===================================
*      
      REWIND (NUNITR)
      READ  (NUNITR,*)  RIEN, RIEN, RIEN, RIEN, TYPE
      IF (TYPE.EQ.INTTYP ('REEL')) THEN
         DO 2 I=1,NBPTS
            READ  (NUNITR,*) VALR 
            WRITE (NUNITP,*) VALR 
2        CONTINUE
      ELSE
         DO 4 I=1,NBPTS
            READ  (NUNITR,*) VALC
            WRITE (NUNITP,*) REAL(VALC), AIMAG(VALC) 
4        CONTINUE
      ENDIF

* 
      CLOSE (UNIT=NUNITP,STATUS='KEEP')  
*
      CALL PRFXMJ (-1,'<Mb2Vtk>')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL BAISE  ('Erreur sur l''ouverture du fichier VTK ')
1001  FORMAT(T1,A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (5.mai.2010)
* - bug : test sur TYPE avant les boucles 2 et 4 OUBLIE !
* Version 1 : D.Martin & C.Chambeyron (31.mars.2010)
* - cas complexe
* Version 0 : C.Chambeyron (22.aout.2009)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                     END !Mb2Vtk
