*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CREESD (NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI 
     &                  ,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSDI,NBCSCI
     &                  ,NBCSAI,NCCSAI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.deBayser (Mars 1989) 
* Derniere modification : D.Martin (26 Juin 2001)
* Version 1.0.1
*  
* Creation et initialisation des structures de donnees d'entree
*  
*-- Arguments d'entree --- 
* NBINCI nombre maximum initial d'inconnues
* NCINCI longueur maximum initiale d'un nom d'inconnue
* NBDONI nombre maximum initial de donnees
* NCINCI longueur maximum initiale d'un nom de donnee 
* NBDOMI nombre maximum initial de domaines geometriques
* NCINCI longueur maximum initiale d'un nom de domaine
* NBTRMI nombre maximum initial de termes 
* NCINCI longueur maximum initiale d'un nom de terme
* NBCSEI nombre maximum initial de constante entieres  
* NBCSRI nombre maximum initial de constantes reelles
* NBCSDI nombre maximum initial de constantes double precision  
* NBCSCI nombre maximum initial de constantes complexes
* NBCSAI nombre maximum initial de constantes chaines de caracteres
* NCINCI longueur maximum initiale d'une constante chaine de caracteres
*
*-- Structures initialisees --
* #OMINC noms des inconnues
* #OMDOM noms des domaines geometriques
* #OMTRM noms des termes
* #OMDON noms des donnees  
* #NCONU caracteristiques des inconnues
* $DONNE caracteristiques des donnees  
* #TERDO caracteristiques des domaines de calcul de des termes(acces sequentiel)
* $SDTRM caracteristiques des termes(acces direct) 
* $ECSTE tableau des constantes entieres
* $RCSTE tableau des constantes reelles
* $DCSTE tableau des constantes reelles
* $CCSTE tableau des constantes complexes  
* $ACSTE tableau des constantes chaines de caracteres  
* $LGCSA tableau des longueurs des constantes chaines de caracteres
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI 
     &       ,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSDI,NBCSCI,NBCSAI,NCCSAI
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*  
      CHARACTER ERCODE*120
      INTEGER   LGTNOM,MCTNOM,LGENTE,INCREM,LGSTRU,MCSTRU,MCC,MCA
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Creesd*')
*  
*--   Creation et initialisation des structures
*
*     Commons/GLOBAL/ et /BORDEL/
      NXTNIV=1 
      NBCSTE=0 
      ISYMGR=0
*
*     Structure #NCONU et tableau des noms #OMINC
      LGTNOM=NCINCI*NBINCI 
      IF (LGTNOM.GT.0) THEN 
         CALL TBCREE ('#OMINC',1,11,LGTNOM,'c')
         LGENTE=4 
         INCREM=3 
         LGSTRU=LGENTE+NBINCI*INCREM  
         CALL TBCREE ('#NCONU',1,1,LGSTRU,'c')
         CALL TBAR2  (ERCODE,'#NCONU',1,MCSTRU,'#OMINC',1,MCTNOM)
*
         CALL TAZERO (LGTNOM,'CA',1,AST(MCTNOM),IST,RST,CST)            !utilite
         CALL TAZERO (LGSTRU-LGENTE,'E',LGENTE+1,AST,IST(MCSTRU)
     &               ,RST,CST)                                          !utilite
         CALL SDMKDB (IST(MCSTRU),LGENTE,0,INCREM,0)                    !sdexplo
      ENDIF
*
*     Structure $DONNE et tableau des noms #OMDON 
      LGTNOM=NCDONI*NBDONI
      IF (LGTNOM.GT.0) THEN
         CALL TBCREE ('#OMDON',1,11,LGTNOM,'c')
         LGENTE=4 
         INCREM=3 
         LGSTRU=LGENTE+NBDONI*INCREM  
         CALL TBCREE ('$DONNE',1,1,LGSTRU,'c')
*
         CALL TBAR2  (ERCODE,'$DONNE',1,MCSTRU,'#OMDON',1,MCTNOM)
         CALL TAZERO (LGTNOM,'CA',1,AST(MCTNOM),IST,RST,CST)            !utilite
         CALL TAZERO (LGSTRU-LGENTE,'E',LGENTE+1,AST,IST(MCSTRU)
     &               ,RST,CST)                                          !utilite
         CALL SDMKDB (IST(MCSTRU),LGENTE,0,INCREM,0)                    !sdexplo
      ENDIF
*
*     Structure #TERDO et tableau des noms #OMDOM  
      NBDOMG=0 
      LGTNOM=NCDOMI*NBDOMI 
      IF (LGTNOM.GT.0) THEN 
         CALL TBCREE ('#OMDOM',1,11,LGTNOM,'c')
         LGENTE=4 
         INCREM=27
         LGSTRU=LGENTE+NBDOMI*(INCREM+3)+100 
         CALL TBCREE ('#TERDO',1,1,LGSTRU,'c')
*
         CALL TBAR2  (ERCODE,'#TERDO',1,MCSTRU,'#OMDOM',1,MCTNOM)
         CALL TAZERO (LGTNOM,'CA',1,AST(MCTNOM),IST,RST,CST)            !utilite
         CALL TAZERO (LGSTRU-LGENTE,'E',LGENTE+1,AST,IST(MCSTRU)
     &               ,RST,CST)                                          !utilite
         CALL SDMKDB (IST(MCSTRU),LGENTE,0,INCREM,0)                    !sdexplo
      ENDIF
*
*     Structure $SDTRM et tableau des noms #OMTRM
      LGTNOM=MIN(NCTRMI,NBCHNT)*NBTRMI 
      IF (LGTNOM.GT.0) THEN 
         CALL TBCREE ('#OMTRM',1,11,LGTNOM,'c')
         LGENTE=4 
         INCREM=20
         LGSTRU=LGENTE+NBTRMI*INCREM  
         CALL TBCREE ('$SDTRM',1,1,LGSTRU,'c')
*
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCSTRU,'#OMTRM',1,MCTNOM)
         CALL TAZERO (LGTNOM,'CA',1,AST(MCTNOM),IST,RST,CST)            !utilite
         CALL TAZERO (LGSTRU-LGENTE,'E',LGENTE+1,AST,IST(MCSTRU)
     &               ,RST,CST)                                          !utilite
         CALL SDMKDB (IST(MCSTRU),LGENTE,0,INCREM,0)                    !sdexplo
      ENDIF
*  
*--   Creation et initialisation des tableaux des constantes 
*
      IF (NBCSEI.GT.0) THEN
         CALL TBCREE ('$ECSTE',1,1,NBCSEI+1,'c') 
         CALL TBAR1  (ERCODE,'$ECSTE',1,MCC)                     
         ERCODE='.'
         CALL TINIT  ('ENTIER'  ,1,ERCODE,INTMAX,REAMAX               
     &               ,CMPLX(REAMAX,REAMAX),NBCSEI,'ENTIER',2
     &               ,AST,IST(MCC),RST,CST)                             !utilite
         IST(MCC)=0
      ENDIF
      IF (NBCSRI.GT.0) THEN
         CALL TBCREE ('$RCSTE',1,2,NBCSRI+1,'c')
         CALL TBAR1  (ERCODE,'$RCSTE',1,MCC)                     
         CALL TINIT  ('REEL'    ,1,ERCODE,INTMAX,REAMAX
     &               ,CMPLX(REAMAX,REAMAX),NBCSRI,'REEL'  ,2
     &               ,AST,IST,RST(MCC),CST)                             !utilite
         IST(MCC)=0
      ENDIF
      IF (NBCSDI.GT.0) THEN
         CALL TBCREE ('$DCSTE',1,3,NBCSDI+1,'c')
         CALL TBAR1  (ERCODE,'$DCSTE',1,MCC)                     
*-*-*    CALL TINIT  ('DOUBLE',1,ERCODE,INTMAX,REAMAX
*-*-* &               ,CMPLX(REAMAX,REAMAX),NBCSDI,'DOUBLE',2
*-*-* &               ,AST,IST,RST,CST(MCC))                            !utilite
         IST(2*MCC-1)=0
         IST(2*MCC)  =0
      ENDIF
      IF (NBCSCI.GT.0) THEN
         CALL TBCREE ('$CCSTE',1,4,NBCSCI+1,'c')
         CALL TBAR1  (ERCODE,'$CCSTE',1,MCC)                     
         CALL TINIT  ('COMPLEXE',1,ERCODE,INTMAX,REAMAX
     &               ,CMPLX(REAMAX,REAMAX),NBCSCI,'COMPLEXE',2
     &               ,AST,IST,RST,CST(MCC))                             !utilite
         IST(2*MCC-1)=0
         IST(2*MCC)  =0
      ENDIF
      IF (NCCSAI*NBCSAI.GT.0) THEN
         CALL TBCREE ('$ACSTE',1,11,NCCSAI*NBCSAI,'c')
         CALL TBCREE ('$LGCSA',1,1,NBCSAI,'c')
         CALL TBAR2  (ERCODE,'$ACSTE',1,MCA,'$LGCSA',1,MCC)
         CALL TINIT  ('CARACTER',1,ERCODE,INTMAX,REAMAX
     &               ,CST(1),NCCSAI*NBCSAI,'CARACTERE',MCA
     &               ,AST,IST,RST,CST)                                  !utilite
         CALL TAZERO (NBCSAI,'ENTIER',MCC,AST,IST,RST,CST)              !utilite
      ENDIF
      CALL PRFXMJ (-1,'*Creesd*')  
                                                                    END !Creesd
