*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INITIA (MOTMXR,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &                  ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &                  ,NUM,NUMOLD,LECACT,LECOLD,LCANTE,LASAPL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (13 Juin 2003)
* Version 1.0.8
*  
* Initialisation des valeurs par defaut
*
*-- Argument d'entree --
* MOTMXR nombre de mots du super-tableau scalaire
*-- Arguments de sortie --
* LGBUF  longueur des buffers d'entree/sortie  
* NBENRX nombre maximum d'enregistrements sur fichier a acces direct
* IMPALO unite logique d'impression de l'allocation dynamique
* IMPERR unite logique d'impression des erreurs d'allocation dynamique
* NBTBMX nombre initial maximal de fichiers d'allocation dynamique
* ISEUIL seuil
* NBBUF  nombre de buffers d'entree/sortie pour l'allcation dynamique
* NBUTMX plus grand numero d'unite logique disponible
* NBUNIT nombre d'unite ouverte
* STDIN  System Input File (stdin)
* STDOUT System Ouput File (stdout ou System Print file)
* NUM    numero
* NUMOLD valeur precedente de NUM
* LECACT unite de lecture actuelle des directives
* LECOLD precedente valeur de LECACT
* LCANTE precedente valeur de LECOLD
* LASAPL pour initialisation des appel de CHRONO
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
*
      INCLUDE 'CONTEX'
*
      INTEGER MOTMXR,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX,ISEUIL,NBBUF
     &       ,NBUTMX,NBUNIT,STDIN,STDOUT,NUM,NUMOLD,LECOLD,LCANTE,LECACT
     &       ,LASAPL
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Initia*')
*
*     Parametres dependant de la machine
      CALL OSARNM (OSARCH,NAMEMA,F77CMP,AUTODP)                         !utilite
*
*-    Initialisation du chronometre
      LASAPL=0
      IMPPAL=0
      CALL CHRONO (' ',IMPPAL)                                          !utilite
      NXTNUF=1
*
*-    Initialisation pour le 'System' 
*
      CALL OSINIT (OSARCH,F77CMP,AUTODP
     &            ,LASNUF,LGBUF,NBENRX,STDIN,STDOUT
     &            ,INTMIN,INTMAX,REAMIN,REAMAX,DOPMIN,DOPMAX,EPSMAC)    !utilite
*
*     Numero d'unite logique pour les fichiers principal, secondaire
*     et des messages des directives et des messages de l'allocation dynamique 
      IMPPAL=STDOUT
      IMPSDR=8 
      IMPMES=9 
      IMPALO=-10
      IMPERR=IMPPAL
      NBMESG=0
*
*-    Initialisation pour l'allocation dynamique
      NBTBMX=300
      ISEUIL=MOTMXR
      NBBUF=2  
      NBUTMX=LASNUF
      NBUNIT=NXTNUF 
*
*-    Initialisation globale pour la lecture par REDLEC 
      NUM=0
      LECACT=-99 
      LECOLD=-999
      LCANTE=-9999  
      NUMOLD=0 
      CALL PRFXMJ (-1,'*Initia*')
                                                                    END !Initia
