*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INITIE (MAXAST,MAXIST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988)
* Derniere modification : D.Martin (13 Juin 2003)
* Version 1.1
*
* Initialisation des valeurs par defaut et de l'allocation dynamique et
* eventuellement modification de ces valeurs par donnee
*  
*-- Arguments d'entree -- 
* MAXAST longueur declaree du super-tableau de caracteres 
* MAXIST longueur declaree du super-tableau numerique 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER MAXAST,MAXIST
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*  
      CHARACTER        TEXT*4,TEXTE*80
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,NUM,NRAN,LECACT,IMP
     &                ,IECR,KNUM,IRWD,NOCO,IRET,NAVA,LECOLD,LCANTE
     &                ,NUMOLD,LASAPL,NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI
     &                ,NCDOMI,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSCI,NBCSDI
     &                ,NBCSAI,NCCSAI,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &                ,ISEUIL,NBBUF,NBUTMX,NBUNIT,ISOR,LECNEW,NCAD
      INTEGER          STDIN,STDOUT
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXT(20)
      COMMON/REDCA1/   NUM,NRAN,LECACT,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVA
      COMMON/REDLST/   LECOLD,LCANTE,NUMOLD 
      COMMON/LASAPL/   LASAPL
      EQUIVALENCE     (TEXTE,TEXT(1))
*
*--   Pour procedures parallelles
*     MOI numero du processeur courant, NBEUX nombre de processeurs voisins
      INTEGER MOI,NBEUX,NBPROC
      COMMON/PARALL/MOI,NBEUX,NBPROC
*
*--   Valeur par defaut des parametres definissant les longueurs des
*     structures de donnees 
*              #OMINC, #OMDON, #OMDOM, #OMTRM, #NCONU, #TERDO,
*              $DONNE, $SDTRM, $ACSTE, $LGCSA $ECSTE, $RSCTE, $CCSTE :
*     Nombre initial maximum d'inconnues, de donnees, de domaines, de termes
*     de constantes entieres, reelles, complexes, chaines de caracteres
      DATA NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI,NBTRMI,NCTRMI
     &    /5     ,6     ,50    ,6     ,10    ,6     ,100   ,6/
     &    ,NBCSEI,NBCSRI,NBCSCI,NBCSDI,NBCSAI,NCCSAI/10,50,20,10,10,8/
*-----------------------------------------------------------------------
      NIVESP=0
      CALL PRFXMJ (1,'*$main$*')
      CALL PRFXMJ (1,'*Initie*')
*
*--   Initialisation et Valeurs par defaut
      CALL INITIA (MAXIST,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &            ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &            ,NUM,NUMOLD,LECACT,LECOLD,LCANTE,LASAPL)              !initial
*
*--   Date et heure du debut de l'execution
      CALL HORODA (IMPPAL,'M E L I N A',OSARCH,NAMEMA)                  !utilite
      CALL HORODA (IMPSDR,'Fichier secondaire',OSARCH,NAMEMA)           !utilite
      CALL HORODA (IMPMES,'Fichier des messages',OSARCH,NAMEMA)         !utilite
*
*--   Impression des constantes dependant de OS / compiler
      IF (IMPMES.GT.0) THEN
         WRITE (IMPMES,10100) OSARCH,F77CMP,INTMIN,INTMAX
         IF (AUTODP(1:3).EQ.'Yes') THEN
            WRITE (IMPMES,10101) REAMIN,REAMAX,DOPMIN,DOPMAX
     &                          ,EPSMAC
         ELSE
            WRITE (IMPMES,10102) REAMIN,REAMAX,DOPMIN,DOPMAX
     &                          ,EPSMAC
         ENDIF
         WRITE (IMPMES,10103) MAXIST,MAXAST
      ENDIF
*
      MOI=0
      NBEUX=0
      LECNEW=STDIN
      NCAD=LEN ('Directives')
      CALL REDDEF (LECNEW,NCAD,'Directives')                            !redlec
      IF (NCAD.LE.0) THEN
         NCAD=LEN ('directives.defaut')
         CALL REDDEF (LECNEW,NCAD,'directives.defaut')                  !redlec
      ENDIF
      ISOR=0
      CALL REDINI (LECNEW,ISOR)                                         !redlec
*
*--   Lecture des directives d'initialisation
      CALL REDLE                                                        !redlec
2     IF (IRE.NE.3) CALL REDERR (13,TEXT(1))                            !redlec
      IF (IMPMES.GT.0) WRITE (IMPMES,10001) '*Initie*',TEXTE(1:NCAR) 
      IF (TEXTE(1:10).EQ.'ALLOCATION') THEN 
*   
         CALL LCALDY (NBTBMX,LGBUF,NBENRX,NBBUF,IMPALO,0,IMPMES)        !initial
         GOTO 2
      ELSEIF (TEXTE(1:9).EQ.'STRUCTURE') THEN
*
         CALL LCSTRU (NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI
     &               ,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSDI,NBCSCI
     &               ,NBCSAI,NCCSAI,0,IMPMES)                           !initial
         GOTO 2
      ELSEIF (TEXTE(1:10).EQ.'IMPRESSION') THEN
*
         CALL LCIMPR (IMPPAL,0,IMPMES)                                  !initial
         GOTO 2
      ELSEIF (TEXTE(1:9).EQ.'PARALLELE') THEN
*
         CALL LCPARA (MOI,NBEUX,NBPROC,0,IMPMES)                        !initial
         GOTO 2
*
      ENDIF
*--   Initialisation de la gestion des tables de l'allocation dynamique
      CALL STINIT (MAXAST,MAXIST,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF        
     &            ,NBUTMX,NBUNIT,INTMAX,IMPALO,IMPERR)
*--   Initialisation du systeme d'unites logiques 
      CALL INIFIC (LASNUF,STDOUT,IMPPAL,IMPSDR,IMPMES,ABS(IMPALO)
     &            ,IMPERR)                                              !initial
*--   Creation de tableaux recepteurs des structures d'entree 
      CALL CREESD (NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI
     &            ,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSDI,NBCSCI
     &            ,NBCSAI,NCCSAI)                                       !initial
*--   Initialisation pour le maillage
      NDIM  =0
      NBTEL =0
      NBTPTG=0
      NBPTEX=0
      NBPTFX=0
      NBCNVE=0
      NBBBLK=0
      NU1BLK=0
      INCBLK=2
      CALL PRFXMJ (-1,'*Initie*')
*-----------------------------------------------------------------------
10001 FORMAT(T3,A8,' ->Debut de la directive : ',A)
10100 FORMAT ('*Initie*',/,' Machine constants for OSARCH = ',A
     &,', F77 = ',A/TR3,'Int_Min  =',I12/TR3,'Int_Max  =',I12)
10101 FORMAT (
     & TR3,'Real_Min =',1PE21.14/TR3,'Real_Max =',1PE21.14
     &/TR3,'Dbl_Min  =',1PE21.14/TR3,'Dbl_Max  =',1PE21.14
     &/TR3,'Eps_Mac  =',1PE21.14)
10102 FORMAT (
     & TR3,'Real_Min =',1PE15.8 /TR3,'Real_Max =',1PE15.8
     &/TR3,'Dbl_Min  =',1PE21.14/TR3,'Dbl_Max  =',1PE21.14
     &/TR3,'Eps_Mac  =',1PE15.8)
10103 FORMAT(/' Super-tableaux'
     &/TR3,'Numerique =',I12,' mots'
     &/TR3,'Character =',I12,' chars.')

                                                                    END !Initie
