*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DNW (NBL,DWL,NDIM,NORMAL
     &               ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1992)  
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*  
* Calcul de l'integrale elementaire dV/dn pour inconnue scalaire
*  
*-- Arguments --  
* NBL    nombre de lignes de l'integrand (= nombre de d.l. en ligne)
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coefficient variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points  
*        de quadrature (cas REEL) 
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points  
*        de quadrature (cas COMPLEXE) 
* IMP    numero du fichier d'impression si non nul .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NDIM,IMP
      REAL          DWL(NDIM,*),ELDIPQ,NORMAL(*)
     &             ,COFVAR,COEFFR(*)
      COMPLEX       COFVAC,COEFFC(*)
*
      INTEGER       I,I1
      REAL          DWIDN
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
         DO 22 I=1,NBL
            DWIDN=0.
            DO 21 I1=1,NDIM
               DWIDN = DWIDN + DWL(I1,I) * NORMAL(I1)
21          CONTINUE
            COEFFR(I) = COEFFR(I) + COFVAR * ELDIPQ * DWIDN
22       CONTINUE
*
         IF (IMP.GT.0) WRITE(IMP,10000) (COEFFR(I),I=1,NBL)
*
      ELSE
*
         DO 42 I=1,NBL
            DWIDN=0.
            DO 41 I1=1,NDIM
               DWIDN = DWIDN + DWL(I1,I) * NORMAL(I1)
41          CONTINUE
            COEFFC(I) = COEFFC(I) + COFVAC * ELDIPQ * DWIDN
42       CONTINUE
*
         IF (IMP.GT.0) WRITE(IMP,10001) (COEFFC(I),I=1,NBL)
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T6,'Integrand dV/dn reel (DNW)'/(T13,10E11.4))
10001 FORMAT(T6,'Integrand dV/dn complexe (DNW)'
     &/(T13,5(SS,E11.4,SP,E10.4,'*i')))
                                                                    END !dWn
