*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DNWDNW (NBL,DWL,NBC,DWC,NDIM,NORMAL
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire dU/dn dV/dn pour inconnues scalaires
*
*-- Arguments --
* NBL nombre de lignes de l'integrand
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC nombre de colonnes de l'integrand
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDIM,IMP
      REAL          DWL(NDIM,*),DWC(NDIM,*),ELDIPQ,NORMAL(*)
      REAL          COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I,J1
      REAL          DWJDN,DWIDN
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 J=1,NBC
*           Calcul de dWj/dn
            DWJDN=0.
            DO 21 J1=1,NDIM
               DWJDN = DWJDN + DWC(J1,J) * NORMAL(J1)
21          CONTINUE
            DO 23 I=1,NBL
*              Calcul de dWi/dn
               DWIDN=0.
               DO 22 J1=1,NDIM
                  DWIDN = DWIDN + DWL(J1,I) * NORMAL(J1)
22             CONTINUE
               COEFFR(I,J)=COEFFR(I,J) + COFVAR*ELDIPQ*DWJDN*DWIDN
23          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 J=1,NBC
            DWJDN=0.
            DO 41 J1=1,NDIM
               DWJDN = DWJDN + DWC(J1,J) * NORMAL(J1)
41          CONTINUE
            DO 43 I=1,NBL
               DWIDN=0.
               DO 42 J1=1,NDIM
                  DWIDN = DWIDN + DWL(J1,I) * NORMAL(J1)
42             CONTINUE
               COEFFC(I,J)=COEFFC(I,J) + COFVAC*ELDIPQ*DWJDN*DWIDN
43          CONTINUE
44       CONTINUE
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('dU/dn dV/dn (DNWDNW)'
     &               ,NBL,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !dnWdnW
