*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DNWW (NBL,WL,NBC,DWC,NDIM,NORMAL
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire dU/dn V pour inconnues scalaires
*
*-- Arguments --
* NBL nombre de lignes de l'integrand
* WL     fonctions de base pour l'interpolation en ligne
* NBC nombre de colonnes de l'integrand
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDIM,IMP
      REAL          WL(*),DWC(NDIM,*),ELDIPQ,NORMAL(*)
     &             ,COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,J1,I
      REAL          DWIDN
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 23 J=1,NBC
*           Calcul de dWi/dn
            DWIDN=0.
            DO 21 J1=1,NDIM
               DWIDN = DWIDN+ DWC(J1,J) * NORMAL(J1)
21          CONTINUE
            DO 22 I=1,NBL
               COEFFR(I,J) = COEFFR(I,J) + COFVAR*ELDIPQ*DWIDN * WL(I)
22          CONTINUE
23       CONTINUE
*
      ELSE
*
         DO 43 J=1,NBC
            DWIDN=0.
            DO 41 J1=1,NDIM
               DWIDN = DWIDN+ DWC(J1,J) * NORMAL(J1)
41          CONTINUE
            DO 42 I=1,NBL
               COEFFC(I,J) = COEFFC(I,J) + COFVAC*ELDIPQ*DWIDN * WL(I)
42          CONTINUE
43       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('dU/dn V (DNWW)'
     &               ,NBL,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !dnWW
