*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DTWDTW (NBL,DWL,NBC,DWC,NDOM
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (June 2003)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire dU/dt dV/dt pour inconnues scalaires
*                 (seulement valable en dimension 2)
*
*-- Arguments --
* NBL    nombre de lignes de l'integrale elementaire
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes de l'integrale elementaire
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDOM   dimension d'espace du domaine d'integration
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrale ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas REEL)
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDOM,IMP
      REAL          DWL(NDOM,*),DWC(NDOM,*),ELDIPQ
      REAL          COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I
      REAL          DWJDT,DWIDT
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 J=1,NBC
            DO 23 I=1,J
               COEFFR(I,J)=COEFFR(I,J) 
     &                    + COFVAR * ELDIPQ * DWC(1,J) * DWL(1,I)
               COEFFR(J,I)=COEFFR(I,J)
23          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 J=1,NBC
            DO 43 I=1,NBL
               COEFFC(I,J)=COEFFC(I,J) 
     &                    + COFVAC * ELDIPQ * DWC(1,J) * DWL(1,I)
43          CONTINUE
44       CONTINUE
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('dU/dt dV/dt (DTWDTW via CALINB)'
     &               ,NBL,NBC,0,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !dtWdtW
