*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DW (K,NBL,DWL,NDIM
     &              ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1990)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire dV/dxk pour inconnue scalaire
*
*-- Arguments --
* K      =k de dV/dxk
* NBL    nombre de lignes de l'integrand elementaire
* DWL    derivees des fonctions a l'image du point de quadrature dans
*        l'element courant pour l'interpolation en ligne
* NDIM   dimension des tableaux de derivees des fonctions de bases
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       K,NBL,NDIM,IMP
      REAL          DWL(NDIM,*),ELDIPQ
     &             ,COFVAR,COEFFR(*)
      COMPLEX       COFVAC,COEFFC(*)
*
      INTEGER       I
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 I=1,NBL
            COEFFR(I) = COEFFR(I) + COFVAR * ELDIPQ * DWL(K,I)
22       CONTINUE
*
         IF (IMP.GT.0) WRITE (IMP,10000) K,(COEFFR(I),I=1,NBL)
*
      ELSE
*
         DO 42 I=1,NBL
            COEFFC(I) = COEFFC(I) + COFVAC * ELDIPQ * DWL(K,I)
42       CONTINUE
*
         IF (IMP.GT.0) WRITE (IMP,10001) K,(COEFFC(I),I=1,NBL)
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T6,'Integrand dV/dx',I1,' reel (DW)'/(T13,10E11.4))
10001 FORMAT(T6,'Integrand dV/dx',I1,' complexe (DW)'
     &/(T13,5(SS,E11.4,SP,E10.4,'*i')))
                                                                    END !dW
