*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DWDWVE (MIXTE,L,M,NBL,DWL,NCL,NBC,DWC,NCC,NDIM
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : E.Luneville (Juillet 2000 )
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire dU/dxl.dV/dxm, inconnues vectorielles
*
*-- Arguments --
* MIXTE  indicateur de mixite des interpolations
* L, M   l et m dans dU/dxl.dV/dxm
* NBL    nombre de lignes (comptees en noeuds) de la matrice elementaire
* NCL    nombre de composantes pour l'inconnue en ligne
* DWL    derivees des fonctions a l'image du point de quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes (comptees en noeuds) de la matrice elementaire
* NCC    nombre de composantes pour l'inconnue en colonne
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de la matrice elementaire
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPE*(*)
      INTEGER   MIXTE,L,M,NBL,NCL,NBC,NCC,NDIM,IMP
      REAL      DWL(NDIM,*),DWC(NDIM,*),ELDIPQ
     &         ,COFVAR,COEFFR(NCL,NBL,NCC,*)
      COMPLEX   COFVAC,COEFFC(NCL,NBL,NCC,*)
*
      INTEGER   J,J1,I
      REAL      RCF,DWCJ
      COMPLEX   CCF
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         IF (L.EQ.M) THEN
*           Integrand symetrique
            DO 22 J=1,NBC
               DWCJ=ELDIPQ * DWC(L,J)
               DO 21 I=J,NBL
                  RCF=COEFFR(1,I,1,J) + COFVAR * DWCJ * DWL(M,I)
                  COEFFR(1,I,1,J)=RCF
                  COEFFR(1,J,1,I)=RCF
21             CONTINUE
22          CONTINUE
            DO 25 J=1,NBC
               DO 24 I=1,NBL
                  RCF=COEFFR(1,I,1,J)
                  DO 23 J1=2,NCC
                     COEFFR(J1,I,J1,J)=RCF
                     COEFFR(J1,J,J1,I)=RCF
23                CONTINUE
24             CONTINUE
25          CONTINUE
         ELSE
*           Integrand non symetrique
            DO 33 J=1,NBC
               DWCJ=ELDIPQ * DWC(L,J)
               DO 32 I=1,NBL
                  DO 31 J1=1,NCC
                     COEFFR(J1,I,J1,J)=COEFFR(J1,I,J1,J)
     &                                 + COFVAR * DWCJ * DWL(M,I)
31                CONTINUE
32             CONTINUE
33          CONTINUE
         ENDIF
*
      ELSE
*
         IF (L.EQ.M) THEN
*           Integrand symetrique
            DO 42 J=1,NBC
               DWCJ=ELDIPQ * DWC(L,J)
               DO 41 I=J,NBL
                  CCF=COEFFC(1,I,1,J) + COFVAC * DWCJ * DWL(M,I)
                  COEFFC(1,I,1,J)=CCF
                  COEFFC(1,J,1,I)=CCF
41             CONTINUE
42          CONTINUE
            DO 45 J=1,NBC
               DO 44 I=1,NBL
                  CCF=COEFFC(1,I,1,J)
                  DO 43 J1=2,NCC
                     COEFFC(J1,I,J1,J)=CCF
                     COEFFC(J1,J,J1,I)=CCF
43                CONTINUE
44             CONTINUE
45          CONTINUE
         ELSE
            DO 53 J=1,NBC
               DWCJ=ELDIPQ * DWC(L,J)
               DO 52 I=1,NBL
                  DO 51 J1=1,NCC
                     COEFFC(J1,I,J1,J)=COEFFC(J1,I,J1,J)
     &                                 + COFVAC * DWCJ * DWL(M,I)
51                CONTINUE
52             CONTINUE
53          CONTINUE
         ENDIF
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         J=NBC
         IF (MIXTE.EQ.0) J=0
         CALL PRINTV ('dU/dx'//CHAR(L+48)//'.dV/dx'//CHAR(M+48)
     &               //' (DWDWVE)'
     &               ,NCL,NBL,NCC,NBC,J,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !dWdWve

