*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DWW (K,NBL,WL,NBC,DWC,NDIM
     &               ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul des integrales elementaires dU/dxk V, inconnues scalaires
*
*-- Arguments --
* K      =k dans dU/dxk V
* NBL    nombre de lignes de la matrice elementaire
* WL     valeurs des fonctions de base au point de quadrature
*        pour l'interpolation en ligne
* NBC    nombre de colonnes de la matrice elementaire
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPE*(*)
      INTEGER   K,NBL,NBC,NDIM,IMP
      REAL      WL(*),DWC(NDIM,*),ELDIPQ
     &         ,COFVAR,COEFFR(NBL,*)
      COMPLEX   COFVAC,COEFFC(NBL,*)
*
      INTEGER   J,I
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 J=1,NBC
            DO 22 I=1,NBL
               COEFFR(I,J)=COEFFR(I,J)+COFVAR*ELDIPQ * DWC(K,J) * WL(I)
22          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 J=1,NBC
            DO 42 I=1,NBL
               COEFFC(I,J)=COEFFC(I,J)+COFVAC*ELDIPQ * DWC(K,J) * WL(I)
42          CONTINUE
44       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('dU/dx'//CHAR(48+K)//' V'//' (DWW)'
     &               ,NBL,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !dWW
