*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERINTG (ERRNUM,NUINTG)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995) 
* Derniere modification : D.Martin (26 octobre 2006)
* Version 2
*  
* Message d'erreurs pour une integrale elementaire 'elements finis'
*  
*-- Arguments d'entree --
* ERRNUM = 0 integrand de numero inexistant
* ERRNUM = 1 mixte non prevu
* ERRNUM = 2 prevu seulement en 2d
* ERRNUM = 3 prevu seulement en 3d
* ERRNUM = 4 valable pour des inconnues a 2 composantes
* ERRNUM = 5 valable pour des inconnues a 3 composantes
* ERRNUM = 6 incoherence avec la dimension d''espace
* ERRNUM = 7 non programme avec coefficient variable complexe
* ERRNUM = 8 valable pour des inconnues a meme nombre de composantes
* ERRNUM = 9 valable pour des inconnues scalaires
* ERRNUM =10 valable pour des inconnues vectorielles
* ERRNUM =11 valable pour inconnue vectorielle/fonction test scalaire
* ERRNUM =12 valable pour inconnue scalaire/fonction test vectorielle
* ERRNUM =13 integrand de 'volume' non prevu pour inconnues scalaires
* ERRNUM =14 integrand de 'volume' non prevu pour inconnues vectorielles
* ERRNUM =15 integrand de bord non prevu pour inconnues scalaires
* ERRNUM =16 integrand de bord non prevu pour inconnues vectorielles
* ERRNUM =17 incoherence avec le nb de composantes de l'inconnue en colonne
* ERRNUM =18 incoherence avec le nb de composantes de l'inconnue en ligne
* ERRNUM =100 integrand elements finis localises sans donnee affectee
* ERRNUM =101 integrand elements finis localises sans donnee FONCTION affectee
* ERRNUM =102 integrand elements finis localises sans donnee TABLEAU associee
* ERRNUM =103 integrand elements finis localises sans inconnue SPECTRALE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER       ERRNUM,NUINTG
*
      CHARACTER*10  INTGNM
      INTEGER       LGUCHN
      CHARACTER     NMINTG*10,NUMERR*10
      INTEGER       LNINTG,DIXTON,NBCARE
*-----------------------------------------------------------------------
      DIXTON=10
      DO 3 NBCARE=1,9
         IF (ERRNUM.LT.DIXTON) GOTO 4
         DIXTON=10*DIXTON
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,NUMERR(1:NBCARE))
*
      IF (ERRNUM.EQ.0) THEN
         CALL ENCLER (NUINTG,NMINTG)
         LNINTG=LGUCHN (NMINTG)
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- Pas d''integrand numero'//NMINTG(1:LNINTG))
      ELSE
         NMINTG=INTGNM (NUINTG)
         LNINTG=LGUCHN (NMINTG)
         IF (NMINTG(1:1).EQ.'?') THEN
            LNINTG=LEN (NMINTG)
            NMINTG='Num.'
            CALL ENCLER (NUINTG,NMINTG(5:LNINTG))
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est pas prevu pour des interpolations mixtes.')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu qu''en dimension 2.')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu qu''en dimension 3.')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour des inconnues a '
     &   //'2 composantes.')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour des inconnues a '
     &   //'3 composantes.')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''appel de l''integrand '//NMINTG(1:LNINTG)
     &   //' n''est pas coherent avec la dimension d''espace.')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''appel de l''integrand '//NMINTG(1:LNINTG)
     &   //' n''est pas programme avec coefficient variable complexe.')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''appel de l''integrand '//NMINTG(1:LNINTG)
     &   //' n''est possible qu''avec des inconnues ayant un meme'
     &   //' nombre de composantes!')
      ELSEIF (ERRNUM.EQ.9) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour des inconnues scalaires.')
      ELSEIF (ERRNUM.EQ.10) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour des inconnues vectorielles.')
       ELSEIF (ERRNUM.EQ.11) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour une inconnue vectorielle'
     &   //' et une fonction test scalaire.')
       ELSEIF (ERRNUM.EQ.12) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' n''est prevu que pour une inconnue scalaire'
     &   //' et une fonction test vectorielle.')
       ELSEIF (ERRNUM.EQ.13) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' ''en volume'', n''est pas prevu pour des inconnues'
     &   //' scalaires.')
       ELSEIF (ERRNUM.EQ.14) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' ''en volume'', n''est pas prevu pour des inconnues'
     &   //' vectorielles.')
       ELSEIF (ERRNUM.EQ.15) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' sur un bord, n''est pas prevu pour des inconnues'
     &   //' scalaires.')
       ELSEIF (ERRNUM.EQ.16) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' sur un bord, n''est pas prevu pour des inconnues'
     &   //' vectorielles.')
       ELSEIF (ERRNUM.EQ.17) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' est incoherent avec le nombre de composantes de'
     &   //' l''inconnue vectorielle en colonne.')
       ELSEIF (ERRNUM.EQ.18) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand '//NMINTG(1:LNINTG)
     &   //' est incoherent avec le nombre de composantes de'
     &   //' l''inconnue vectorielle en ligne.')
*-----------------------------------------------------------------------
       ELSEIF (ERRNUM.EQ.100) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand (EF localises avec integration numerique)'
     &   //' n''a pas de donnee affectee.')
       ELSEIF (ERRNUM.EQ.101) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand (EF localises avec integration numerique)'
     &   //' n''a pas de donnee FONCTION affectee.')
       ELSEIF (ERRNUM.EQ.102) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand (EF localises avec integration numerique)'
     &   //' a une donnee FONCTION affectee mais pas de TALEAU associe
     &   // a cette fonction.')
       ELSEIF (ERRNUM.EQ.103) THEN
         CALL BAISE  ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //'- L''integrand (EF localises avec integration numerique)'
     &   //' n''a pas d''inconnue de type SPECTRALE.')
*-----------------------------------------------------------------------
      ELSE
         CALL WARNNG ('<Erintg> Code '//NUMERR(1:NBCARE)
     &   //' non prevu - Integrand '//NMINTG(1:LNINTG))
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (26.oct.2006)
* - modif. cosmetique
* Version 1.0.6 : D.Martin (20.juin.2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Erintg
