*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FSPEC2 (NBFPRL,NBFPRC
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: C.Chambeyron (Juin 2006)
* Derniere modification : C.Chambeyron (Juin 2006)
* Version 0
*
* Calcul par quadrature de l'integrand \Phi_n \Phi_m pour une matrice a
* inconnues spectrale en ligne et colonne
*
* -- Arguments --
* NBFPRL nombre de fonctions propres en ligne   (inconnue spectrale)
* NBFPRC nombre de fonctions propres en colonne (inconnue spectrale) 
* ELDIPQ element differentiel elementaire au point de quadrature
*        (element de surface/longueur) multiplie par le poids de quadrature
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR tableau des valeurs des fonctions spectrales (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL) stockee par colonne
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPE
      INTEGER       NBFPRL,NBFPRC,IMP
      REAL          ELDIPQ,COFVAR(*),COEFFR(NBFPRL,*)
      COMPLEX       COFVAC(*),COEFFC(NBFPRL,*)
*
      INTEGER       J,I
*-----------------------------------------------------------------------
     
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBFPRC
            DO 21 I=1,NBFPRL
               COEFFR(I,J) = COEFFR(I,J) + ELDIPQ*COFVAR(J)*COFVAR(I)
21          CONTINUE
22       CONTINUE
*      
      ELSE        
*
         DO 42 J=1,NBFPRC
            DO 41 I=1,NBFPRL 
               COEFFC(I,J) = COEFFC(I,J) + ELDIPQ*COFVAC(J)*COFVAC(I)
41          CONTINUE
42       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0) CALL PRINTG ('(Fspec2)',NBFPRL,NBFPRC,NBFPRC
     &                          ,TYPE,COEFFR,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : C.Chambeyron (Juin 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Fspec2
    
