*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GRAGRA (MIXTE,NBL,DWL,NBC,DWC,NDIM
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire GradU . GradV pour inconnues scalaires
*
*-- Arguments --
* MIXTE  indicateur de mixite des interpolations colonne/ligne
* NBL     nombre de lignes (comptees en noeuds) de la matrice elementaire
* DWL    derivees des fonctions a l'image du point de quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes (comptees en noeuds) de la matrice elementaire
* DWC    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en colonne
* NDIM   dimension du tableau des derivees des fonctions de base
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NBC,NDIM,IMP
      REAL          DWL(NDIM,*),DWC(NDIM,*),ELDIPQ
     &             ,COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I,ID
      REAL          RX,DWIDWJ
      COMPLEX       CX
*----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
            DO 23 J=1,NBC
               DO 22 I=1,J
                  RX=COEFFR(I,J)
                  DWIDWJ=0.
                  DO 21 ID=1,NDIM
                     DWIDWJ=DWIDWJ+DWC(ID,J)*DWL(ID,I)
21                CONTINUE
                  RX=RX+COFVAR*ELDIPQ*DWIDWJ
                  COEFFR(I,J)=RX
                  COEFFR(J,I)=RX
22             CONTINUE
23          CONTINUE
*
      ELSE
*
            DO 43 J=1,NBC
               DO 42 I=1,J
                  CX=COEFFC(I,J)
                  DWIDWJ=0.
                  DO 41 ID=1,NDIM
                     DWIDWJ=DWIDWJ+DWC(ID,J)*DWL(ID,I)
41                CONTINUE
                  CX=CX+COFVAC*ELDIPQ*DWIDWJ
                  COEFFC(I,J)=CX
                  COEFFC(J,I)=CX
42             CONTINUE
43          CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         J=NBC
         IF (MIXTE.EQ.0) J=0
         CALL PRINTG ('GradU.GradV (GRAGRA)'
     &               ,NBL,NBC,J,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !GraGra
