*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GRTGRT (MIXTE,NBL,DWL,NBC,DWC,NDIM,NDMDOM,JACOBF
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Fevrier 1994)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*  
* Calcul de l'integrale elementaire: grad tangentiel u.grad tangentiel v
*        [dWi/dy2 n^f1 - dWi/dy1 n^f2].[dWj/dy2 n^f1 - dWj/dy1 n^f2]  
*
*-- Arguments --
* MIXTE  indice de mixite de l'interpolation  
* NBL nombre de lignes de l'integrand
* DWL derivees des fonctions de base pour l'interpolation en ligne
* NBC nombre de colonnes de l'integrand
* DWC derivees des fonctions de base pour l'interpolation en colonne
* NDIM   dimension d'espace
* NDMDOM dimension d'espace du domaine d'integration
* JACOBF matrice jacobienne directe
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable 
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points  
*        de quadrature (cas REEL) 
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points  
*        de quadrature (cas COMPLEXE) 
* IMP numero du fichier d'impression (pas d'impression si > 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NBC,NDIM,NDMDOM,IMP
      REAL          JACOBF(NDIM,*),DWC(NDMDOM,*),DWL(NDMDOM,*)
      REAL          COFVAR,COEFFR(NBL,*),ELDIPQ
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       I,J,IDIM
      REAL          RX,WORK1(3),WORK2(3),WORK3(3),F11,F22,F1F2,PROSCA
      COMPLEX       CX
*-----------------------------------------------------------------------
*
      F11 =PROSCA(NDIM,JACOBF(1,1),JACOBF(1,1))
      F22 =PROSCA(NDIM,JACOBF(1,2),JACOBF(1,2))
      F1F2=PROSCA(NDIM,JACOBF(1,1),JACOBF(1,2))
      DO 1 IDIM=1,NDIM
         WORK1(IDIM)=F11 *JACOBF(IDIM,2)-F1F2*JACOBF(IDIM,1)
         WORK2(IDIM)=F1F2*JACOBF(IDIM,2)-F22 *JACOBF(IDIM,1)
1     CONTINUE
*
      IF (TYPE(1:1).EQ.'R') THEN
         DO 25 I=1,NBC
*           Calcul de dWi/dy2 n^f1 - dWi/dy1 n^f2
            DO 22 IDIM=1,NDIM
               WORK3(IDIM)= DWC(2,I)*WORK1(IDIM)
     &                     -DWC(1,I)*WORK2(IDIM)
22          CONTINUE
            DO 24 J=1,I 
*              Calcul de dWj/dy2 n^f1 - dWj/dy1 n^f2
               RX=COEFFR(J,I)
               DO 23 IDIM=1,NDIM
                  RX=RX+COFVAR*ELDIPQ*WORK3(IDIM)
     &              *(DWL(2,J)*WORK1(IDIM)-DWL(1,J)*WORK2(IDIM))
23             CONTINUE
               COEFFR(J,I)=RX
               COEFFR(I,J)=RX    
24          CONTINUE 
25       CONTINUE
      ELSE
         DO 45 I=1,NBC
*           Calcul de dWi/dy2 n^f1 - dWi/dy1 n^f2
            DO 42 IDIM=1,NDIM
               WORK3(IDIM)= DWC(2,I)*WORK1(IDIM)
     &                     -DWC(1,I)*WORK2(IDIM)
42          CONTINUE
            DO 44 J=1,I
               CX=COEFFR(J,I) 
*              Calcul de dWj/dy2 n^f1 - dWj/dy1 n^f2
               DO 43 IDIM=1,NDIM
                  CX=CX+COFVAC*ELDIPQ*WORK3(IDIM)
     &              *(DWL(2,J)*WORK1(IDIM)-DWL(1,J)*WORK2(IDIM))
43             CONTINUE
               COEFFC(J,I)=CX
               COEFFC(I,J)=CX
44          CONTINUE
45       CONTINUE
      ENDIF
*
      IF (IMP.GT.0) THEN
        I=NBC
        IF (MIXTE.EQ.0) I=0
        CALL PRINTG ('Grad_T Wi.Grad_T Wj'
     &               ,NBL,NBC,I,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !GrtGrt
