*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INTCHK (NUINTG,MIXTE,NDIM,NCPINC,NCPINL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1999)
* Derniere modification : G.Legendre & D.Martin (27 mai/6 juin 2011)
* Version 9
*  
* Verification du contexte d'utilisation d'un integrand
*  
*-- Argument d'entree --  
* NUINTG numero d'integrand
* MIXTE  indicateur de mixite des interpolations en ligne et colonne
* NDIM   dimension d'espace
* NCPINC nombre de composantes de l'inconnue en colonne
* NCPINL nombre de composantes de l'inconnue en ligne
*-- Liste des integrands dans 00TOC --
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NUINTG,MIXTE,NDIM,NCPINC,NCPINL
*
      INTEGER  NWINTG,ERRNUM,ALPHA,BETA,GAMMA,DELTA
*-----------------------------------------------------------------------
*
      ERRNUM=0
*
      IF (NUINTG.LE.187) THEN
*
         CALL INTNOS (NUINTG,ALPHA,BETA,GAMMA,DELTA)
*
         IF (NUINTG.LE.12) THEN
            IF (NUINTG.LE.4) THEN
*              D1V D2V D3V
               IF (DELTA.GT.NDIM) ERRNUM=6
            ELSEIF (NUINTG.LE.6) THEN
*              UV U.V U.AV
               IF (NCPINC.NE.NCPINL) ERRNUM=8
            ELSEIF (NUINTG.LE.9) THEN
*              UD1V UD2V UD3V
               IF (DELTA.GT.NDIM) ERRNUM=6
            ELSE
*              D1UV D2UV D3UV
               IF (GAMMA.GT.NDIM) ERRNUM=6
            ENDIF
         ELSEIF (NUINTG.LE.21) THEN
*           D1UD1V D1UD2V D1UD3V D2UD1V D2UD2V D2UD3V D3UD1V D3UD2V D3UD3V
            IF (GAMMA.GT.NDIM.OR.DELTA.GT.NDIM) ERRNUM=6
         ELSEIF (NUINTG.EQ.22.OR.NUINTG.EQ.26) THEN
*           GRADGRAD AIJDIDJ
            IF (MIXTE.NE.0) ERRNUM=1
         ELSEIF (NUINTG.LE.25) THEN
*           ROTROT DIVDIV EIJEIJ
            IF (NCPINC.EQ.1.OR.NCPINL.EQ.1) ERRNUM=10
         ELSEIF (NUINTG.EQ.27.OR.NUINTG.EQ.30) THEN
*           GRADUV UDIVV
            IF (NCPINC.NE.1.OR.NCPINL.LE.1) ERRNUM=12
         ELSEIF (NUINTG.EQ.29) THEN
*           ROTUV
            IF (NDIM.EQ.2.AND.(NCPINL.NE.1.OR.NCPINC.LE.1)) ERRNUM=11
            IF (NDIM.EQ.3.AND.(NCPINL.NE.3.OR.NCPINC.NE.3)) ERRNUM=5
         ELSEIF (NUINTG.LE.31) THEN
*           DIVUV UGRADV
            IF (NCPINC.LE.1.OR.NCPINL.NE.1) ERRNUM=11
         ELSEIF (NUINTG.EQ.32) THEN
*           UROTV
            IF (NDIM.EQ.2.AND.(NCPINC.NE.1.OR.NCPINL.LE.1)) ERRNUM=12
            IF (NDIM.EQ.3.AND.(NCPINC.NE.3.OR.NCPINL.NE.3)) ERRNUM=5
         ELSEIF (NUINTG.LE.39) THEN
*           ROTROTBT0 ROTROTBT1 ROTROTBT2 DIVDIVBT0 DIVDIVBT1 DIVDIVBT2 EIJEIJBT0
            IF (MIXTE.NE.0)  CALL ERINTG (1,NUINTG)
            IF (NDIM.NE.2)   CALL ERINTG (2,NUINTG)
            IF (NCPINC.NE.3) ERRNUM=5
         ELSEIF (NUINTG.EQ.40) THEN
*           U^V
            IF (MIXTE.NE.0)  CALL ERINTG (1,NUINTG)
            IF (NCPINC.NE.2) ERRNUM=4
         ELSEIF (NUINTG.EQ.41) THEN
*           DIV
            ERRNUM=0
         ELSEIF (NUINTG.LE.50) THEN
*           UaVb (1 <= a,b <=3 )
            IF (ALPHA.GT.NCPINC) CALL ERINTG (17,NUINTG)
            IF (BETA.GT.NCPINL)  ERRNUM=18
         ELSEIF (NUINTG.LE.131) THEN
*           Ua,gVb,d (1<= a,g,b,d<=3)
            IF (MIXTE.NE.0) CALL ERINTG (1,NUINTG)
            IF (ALPHA.GT.NCPINC) CALL ERINTG (17,NUINTG)
            IF (BETA.GT.NCPINL)  CALL ERINTG (18,NUINTG)
            IF (GAMMA.GT.NDIM) ERRNUM=6
            IF (DELTA.GT.NDIM) ERRNUM=6
         ELSEIF (NUINTG.LE.133) THEN
*           UI,IVJ,J UI,JVJ,I
            IF (NDIM.NE.2) ERRNUM=2
         ELSEIF (NUINTG.LE.160) THEN
*           Ua,gVb ( 1<= a,b,g <= 3 )
            IF (MIXTE.NE.0) CALL ERINTG (1,NUINTG)
            IF (ALPHA.GT.NCPINC) CALL ERINTG (17,NUINTG)
            IF (BETA.GT.NCPINL)  CALL ERINTG (18,NUINTG)
            IF (GAMMA.GT.NDIM) ERRNUM=6
         ELSEIF (NUINTG.LE.187) THEN
*           UaVb,d ( 1<= a,b,d <= 3 )
            IF (MIXTE.NE.0) CALL ERINTG (1,NUINTG)
            IF (ALPHA.GT.NCPINC) CALL ERINTG (17,NUINTG)
            IF (BETA.GT.NCPINL)  CALL ERINTG (18,NUINTG)
            IF (DELTA.GT.NDIM) ERRNUM=6
         ENDIF
*
      ELSEIF (NUINTG.LE.300) THEN
*
         CALL INTNOS (NUINTG,ALPHA,BETA,GAMMA,DELTA)
*
         IF (NUINTG.LE.208) THEN
*           ROTROT DIVDIV EIJEIJ dans la methode PML (G. Legendre)
            ERRNUM=0
         ELSEIF (NUINTG.LE.215) THEN
*           UROTV                dans la methode PML (G. Legendre)
            IF (NDIM.EQ.2.AND.(NCPINC.NE.1.OR.NCPINL.LE.1)) ERRNUM=12
            IF (NDIM.EQ.3.AND.(NCPINC.NE.3.OR.NCPINL.NE.3)) ERRNUM=5
         ELSEIF (NUINTG.LE.222) THEN
*           ROTUV                dans la methode PML (G. Legendre)
            IF (NDIM.EQ.2.AND.(NCPINL.NE.1.OR.NCPINC.LE.1)) ERRNUM=11
            IF (NDIM.EQ.3.AND.(NCPINL.NE.3.OR.NCPINC.NE.3)) ERRNUM=5
         ELSEIF (NUINTG.LE.225) THEN
*           U1V U2V U3V
            IF (ALPHA.GT.NCPINC) CALL ERINTG (17,NUINTG)
            IF (NCPINC.LE.1) ERRNUM=11
         ELSEIF (NUINTG.LE.228) THEN
*           UV1 UV2 UV3
            IF (BETA.GT.NCPINL)  CALL ERINTG (18,NUINTG)
            IF (NCPINL.LE.1) ERRNUM=12
         ELSEIF (NUINTG.LE.284) THEN
            CALL ERINTG (0,NUINTG)
*-----------------------------------------------------------------------
*-----   C'est la ZONE (pour introduire de nouveaux integrands)
*
*        ELSEIF (NUINTG.EQ.285) THEN
*-----------------------------------------------------------------------
         ELSE
            CALL ERINTG (0,NUINTG)
         ENDIF
*
      ELSE
*
*        Integrand de bord, contenant la normale
*
         IF (NUINTG.EQ.301) THEN
*           VN (ou V.N)
            IF (NCPINL.LE.1) ERRNUM=10
         ELSEIF (NUINTG.EQ.302) THEN
*           V^N
            IF (NCPINL.NE.2) ERRNUM=4
         ELSEIF (NUINTG.EQ.303) THEN
*           DNV
            IF (NCPINL.NE.1.OR.NCPINC.NE.1) ERRNUM=9
         ELSEIF (NUINTG.LE.305) THEN
*           UDNV DNUV
            IF (NCPINL.NE.NCPINC) ERRNUM=8
         ELSEIF (NUINTG.EQ.306) THEN
*           DNUDNV
            IF (NCPINL.NE.1.OR.NCPINC.NE.1) CALL ERINTG (9,NUINTG)
            IF (NCPINL.NE.NCPINC) ERRNUM=8
         ELSEIF (NUINTG.LE.308) THEN
*           DTUDTV UDTV
            IF (NCPINL.NE.1.OR.NCPINC.NE.1) CALL ERINTG (9,NUINTG)
            IF (NDIM.NE.2) ERRNUM=2
         ELSEIF (NUINTG.EQ.309) THEN
*           N^ROTU.V
            IF (NCPINC.EQ.1) CALL ERINTG (5,NUINTG)
            IF (NDIM.NE.3.OR.NCPINC.NE.3) ERRNUM=3
         ELSEIF (NUINTG.EQ.310) THEN
*           NDIVU.V
            IF (NCPINC.EQ.1) ERRNUM=5
         ELSEIF (NUINTG.EQ.311.OR.NUINTG.EQ.312) THEN
*           U^N.V^N U.NV.N
            IF (NCPINL.LE.1.OR.NCPINC.LE.1) ERRNUM=10
         ELSEIF (NUINTG.EQ.313) THEN
*           U.NV
            IF (NCPINL.NE.1.OR.NCPINC.LE.1) ERRNUM=11
         ELSEIF (NUINTG.EQ.314) THEN
*           GRADGRADTG gradgrad tangentiel
            IF (MIXTE.NE.0) CALL ERINTG (1,NUINTG)
            IF (NDIM.NE.3)  CALL ERINTG (3,NUINTG)
            IF (NCPINL.NE.1.OR.NCPINC.NE.1) ERRNUM=9
         ENDIF
*
      ENDIF
      IF (ERRNUM.NE.0) CALL ERINTG (ERRNUM,NUINTG)
*-----------------------------------------------------------------------
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File History
* Version 9 : G.Legendre & D.Martin (27 mai/6 juin 2011)
* - ajout de l'integrand 2d UDTV
* Version 8 : C.Chambeyron, G.Legendre (10 mars 2011)
* - bug dans les tests pour les integrands ROTUV, ROTUV(PML), UROTV(PML) 
* Version 7 : C.Chambeyron (03 decembre 2010) & D.Martin (03 janvier 2011)
* - ajout des integrands PML 3d 
* Version 6 : D.Martin (06 novembre 2009)
* - ajout des integrands U_{alpha}V et UV_{alpha}
* Version 5 : D.Martin & G. Legendre (17 septembre 2009)
* - ajout de integrand U.ROT(V) 3D (G. Legendre)
* Version 4 : D.Martin (18 octobre 2006)
* - ajout des integrands PML generaux 2D :
*   ROTROTP1  ROTROTP2  ROTROTP12 DIVDIVP1  DIVDIVP2  DIVDIVP12
* Version 3 : D.Martin (03 octobre 2005)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !IntChk
