*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INTGKL (NMINTG)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)
* Derniere modificatio : D.Martin (19 octobre 2006)
* Version 2
*  
* Retourne le numero de l'integrand de nom NMINTG
* Returns the number of integrand named NMINTG
*  
*-- Arguments --  
* NMINTG chaine de caractere representant le nom de l'integrand
*        character string bearing the name of an integrand
*
*-- Definitions --
* NGRINT nombre de groupe d'integrands (quelque peu arbitraire)
*        number of groups of integrands (arbitrarily defined, somehow)
* NBINGR nombre d'integrands dans un groupe (cumule avec les groupes precedents)
*        number of integrands in a group (summed with the number of integrands
*        of previous groups)
* NBCAGR nombre de caracteres des noms d'integrands des groupes
*        number of characters of integrand names in the group
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMINTG
      INTEGER       INTGKL
*
      CHARACTER     UPPERC*20
      CHARACTER     NMINTW*20,CPLOUC*120,TPLOUC
      INTEGER       NBINTA,NBINTG,NBCARG,NCARAC,KELCHN,KLI,NBINTK,K
      COMMON/ONSEPA/CPLOUC 
      EQUIVALENCE  (CPLOUC,TPLOUC)
*
      INCLUDE 'intgroups.h'
*-----------------------------------------------------------------------
*     Aliases pour compatibilite
      NMINTW=UPPERC (NMINTG)
      NCARAC=0
      CPLOUC=NMINTG
*     Suite a changement de denomination des integrands PML
      IF (NMINTW(1:8).EQ.'ROTROTP '.OR.NMINTW(1:8).EQ.'DIVDIVP ') THEN
         NCARAC=8
         NMINTW=NMINTW(1:7)//'1'
      ELSEIF (NMINTW(1:7).EQ.'ROTUVP '.OR.NMINTW(1:7).EQ.'UROTVP ') THEN
         NCARAC=7
         NMINTW=NMINTW(1:6)//'1'
*     Aliases de noms d'integrands
      ELSEIF (NMINTW(1:9).EQ.'U1V1+U2V2') THEN
         NCARAC=-9
         NMINTW='ROTROTBT2'
      ELSEIF (NMINTW(1:4).EQ.'UV33')  THEN
         NCARAC=-9
         NMINTW='DIVDIVBT2'
      ELSEIF (NMINTW(1:17).EQ.'N^(DU^N).N^(DV^N)') THEN
         NCARAC=10
         NMINTW='GRADGRADTG'
      ENDIF
      IF (NCARAC.GT.0) THEN
         CALL WARNNG ('L''ancien nom d''integrand '
     &   //CPLOUC(1:LEN(NMINTG))//' a ete abandonne au profit de '
     &   //NMINTW(1:NCARAC)//'. Mettez a jour vos directives.')
      ELSEIF (NCARAC.LT.0) THEN
         NCARAC=-NCARAC
      ENDIF
      IF (NMINTW(1:3).EQ.'U.V') THEN
         NMINTW='UV'
      ELSEIF (NMINTW(1:3).EQ.'V.N') THEN
         NMINTW='VN'
      ENDIF
*
      NBINTA=0
      NBINTG=0
      DO 1 KLI=1,NGRINT
         NBINTG=NBINGR(KLI)-NBINTA
         NBINTK=NBINTA+NBINTG
         NBCARG=NBCAGR(KLI)
         IF (NBCARG.GT.0) THEN
            CPLOUC=NMINGR (KLI)
            INTGKL=KELCHN (NMINTW,TPLOUC,NBINTG,NBCARG)                 !utilite
            IF (INTGKL.GT.0) THEN 
               INTGKL=INTGKL+NBINTA  
               RETURN
            ENDIF
         ENDIF
         NBINTA=NBINTK
1     CONTINUE
*-----------------------------------------------------------------------
      WRITE(*,10000)
      NBINTA=0
      NBINTG=0
      DO 2 KLI=1,NGRINT
         NBINTG=NBINGR(KLI)-NBINTA
         NBINTK=NBINTA+NBINTG
         NBCARG=NBCAGR(KLI)
         IF (NBCARG.GT.0) THEN
            CPLOUC=NMINGR (KLI)
            IF (CPLOUC(1:1).NE.'*') THEN
               WRITE(*,10001)
     &         (K+NBINTA,CPLOUC(1+NBCARG*(K-1):NBCARG*K),K=1,NBINTG)
            ENDIF
         ENDIF
         NBINTA=NBINTK
2     CONTINUE
*
10000 FORMAT(/' *IntgKl* Liste des integrands'/)
10001 FORMAT((T4,4(I4,'-',A10,' |',:)))
      K=LEN (NMINTG)
      CPLOUC(:K)=NMINTG
      CALL BAISE  ('*IntgKl* Integrand non reconnu : '//CPLOUC(:K))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (24 octobre 2006)
* - ajout pour compatibilite des alias des anciens noms d'integrands PML
* - suppression des vieux alias
* Version 1.0.3 D.Martin (24 avril 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !IntgKl
