*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Fichier 'include' intgroups.h
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1999)
* Derniere modification : G.Legendre & D.Martin (27 mai/6 juin 2011)
* Version 9
*
* Les integrands 'elements finis' sont ranges par groupes. 
* Dans un groupe la caracteristique essentielle est la longueur du nom qui est
* la meme pour tous les integrands du groupe (en completant si necessaire de 
* caracteres blancs).
* Ci-dessous on a neanmoins regroupe des integrands aux caracteristiques
* 'similaires' (critere subjectif)
*
* NGRINT    nombre de groupes d''integrands
* NBINGR(g) le nombre d''integrands dans le groupe g est NBINGR(g)-NBINGR(g-1)
* NBCAGR(g) est le nombre de caracteres des noms d''integrands dans le groupe g
* NMINGR(g) est la chaine de caracteres resultant de la concatenation des noms
*           des integrands du groupe g (d''au plus 63 caracteres)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NGRINT
      PARAMETER    (NGRINT=42)
*
      INTEGER       NBINGR(NGRINT),NBCAGR(NGRINT)
*     Il y a 63 caracteres au plus sur une ligne de continuation :
*       123456789012345678901234567890123456789012345678901234567890123
*    &,'baratin de soixante trois caracteres sur ligne de continuation.'
      CHARACTER*63  NMINGR(NGRINT)
*
      DATA NBINGR/12, 21, 26, 32, 39, 50, 57, 64, 71, 77, 84, 91, 98,104
     &          ,111,118,125,131,133,143,153,160,170,180,187,193,194,200
     &          ,201,207,208,214,215,221,222,228,284,293,300,308,313,314
     &/
      DATA NBCAGR/ 4,  6,  8,  6,  9,  4,  8,  8,  8,  8,  8,  8,  8,  8
     &          ,  8,  8,  8,  8,  8,  6,  6,  6,  6,  6,  6,  9, 10,  9 
     &          , 10,  9, 10,  8,  9,  8,  9,  3,  1,  7,  9,  6,  8, 10
     &/
*-----------------------------------------------------------------------
      DATA NMINGR/
*       1   2   3   4   5   6   7   8   9   10  11  12
     1 'V   D1V D2V D3V UV  U.AVUD1VUD2VUD3VD1UVD2UVD3UV'
*       13    14    15    16    17    18    19    20    21
     2,'D1UD1VD1UD2VD1UD3VD2UD1VD2UD2VD2UD3VD3UD1VD3UD2VD3UD3V'
*       22      23      24      25      26
     3,'GRADGRADROTROT  DIVDIV  EIJEIJ  AIJDIDJ '
*       27    28    29    30    31    32
     4,'GRADUVDIVUV ROTUV UDIVV UGRADVUROTV '
*       33       34       35       36       37       38       39
     5,'ROTROTBT0ROTROTBT1ROTROTBT2DIVDIVBT0DIVDIVBT1DIVDIVBT2EIJEIJBT0'
*       40  41  42  43  44  45  46  47  48  49  50
     6,'U^V DIV U1V1U1V2U1V3U2V1U2V2U2V3U3V1U3V2U3V3'
*------- 'Integrands d_\gamma U\alpha d_\delta V\beta' -----------------
*       51      52      53      54      55      56      57
     7,'U1,1V1,1U1,1V1,2U1,1V1,3U1,1V2,1U1,1V2,2U1,1V2,3U1,1V3,1'
*       58      59      60      61      62      63      64
     8,'U1,1V3,2U1,1V3,3U1,2V1,1U1,2V1,2U1,2V1,3U1,2V2,1U1,2V2,2'
*       65      66      67      68      69      70      71
     9,'U1,2V2,3U1,2V3,1U1,2V3,2U1,2V3,3U1,3V1,1U1,3V1,2U1,3V1,3'
*       72      73      74      75      76      77
     *,'U1,3V2,1U1,3V2,2U1,3V2,3U1,3V3,1U1,3V3,2U1,3V3,3'
*       78      79      80      81      82      83      84
     1,'U2,1V1,1U2,1V1,2U2,1V1,3U2,1V2,1U2,1V2,2U2,1V2,3U2,1V3,1'
*       85      86      87      88      89      90      91
     2,'U2,1V3,2U2,1V3,3U2,2V1,1U2,2V1,2U2,2V1,3U2,2V2,1U2,2V2,2'  
*       92      93      94      95      96      97      98
     3,'U2,2V2,3U2,2V3,1U2,2V3,2U2,2V3,3U2,3V1,1U2,3V1,2U2,3V1,3'
*       99     100     101     102      103     104
     4,'U2,3V2,1U2,3V2,2U2,3V2,3U2,3V3,1U2,3V3,2U2,3V3,3'
*       105     106     107     108     109     110     111
     5,'U3,1V1,1U3,1V1,2U3,1V1,3U3,1V2,1U3,1V2,2U3,1V2,3U3,1V3,1'
*       112     113     114     115     116     117     118
     6,'U3,1V3,2U3,1V3,3U3,2V1,1U3,2V1,2U3,2V1,3U3,2V2,1U3,2V2,2'  
*       119     120     121     122     123     124     125
     7,'U3,2V2,3U3,2V3,1U3,2V3,2U3,2V3,3U3,3V1,1U3,3V1,2U3,3V1,3'
*       126     127     128     129     130     131
     8,'U3,3V2,1U3,3V2,2U3,3V2,3U3,3V3,1U3,3V3,2U3,3V3,3'
*       132     133
     9,'UI,IVJ,JUI,JVJ,I'
*-------'Integrands d_\gamma(U\alpha) V\beta'---------------------------
*       134   135   136   137   138   139   140   141   142   143
     *,'U1,1V1U1,1V2U1,1V3U1,2V1U1,2V2U1,2V3U1,3V1U1,3V2U1,3V3U2,1V1'
*       144   145   146   147   148   149   150   151   152   153
     1,'U2,1V2U2,1V3U2,2V1U2,2V2U2,2V3U2,3V1U2,3V2U2,3V3U3,1V1U3,1V2'
*       154   155   156   157   158   159   160
     2,'U3,1V3U3,2V1U3,2V2U3,2V3U3,3V1U3,3V2U3,3V3'
*-------'Integrands U\alpha d_\gamma(V\beta)'---------------------------
*       161   162   163   164   165   166   167   168   169   170
     3,'U1V1,1U2V1,1U3V1,1U1V1,2U2V1,2U3V1,2U1V1,3U2V1,3U3V1,3U1V2,1'
*       171   172   173   174   175   176   177   178   179   180
     4,'U2V2,1U3V2,1U1V2,2U2V2,2U3V2,2U1V2,3U2V2,3U3V2,3U1V3,1U2V3,1'
*       181   182   183   184   185   186   187
     5,'U3V3,1U1V3,2U2V3,2U3V3,2U1V3,3U2V3,3U3V3,3'
*-------'Integrands PML'------------------------------------------------
*       188      189      190      191      192      193
     6,'ROTROTP1 ROTROTP2 ROTROTP3 ROTROTP12ROTROTP23ROTROTP13'
*       194
     7,'ROTROTP123'
*       195      196      197      198      199      200
     8,'DIVDIVP1 DIVDIVP2 DIVDIVP3 DIVDIVP12DIVDIVP23DIVDIVP13'
*       201
     9,'DIVDIVP123'
*       202      203      204      205      206      207
     *,'EIJEIJP1 EIJEIJP2 EIJEIJP3 EIJEIJP12EIJEIJP23EIJEIJP13'
*       208
     1,'EIJEIJP123'
*       209     210     211     212     213     214
     2,'UROTVP1 UROTVP2 UROTVP3 UROTVP12UROTVP23UROTVP13'
*       215
     3,'UROTVP123'
*       216     217     218     219     220     221
     4,'ROTUVP1 ROTUVP2 ROTUVP3 ROTUVP12ROTUVP23ROTUVP13'
*       222
     5,'ROTUVP123'
*       223224225226227228
     6,'U1VU2VU3VUV1UV2UV3'
*        230       240       250       260       270       280 284
     7,'********************************************************'
*-----------------------------------------------------------------------
* Ci-dessous : Ligne prevue pour recueillir provisoirement de nouveau noms <= 7 caracteres
*       285    286    287    288    289    290    291    292    293
     8,'^use285^use286^use287^use288^use289^use290^use291^use292^use293'
* Ci-dessous : Ligne prevue pour recueillir provisoirement de nouveau noms <= 9 caracteres
*       294      295      296      297      298      299      300
     9,'^user$294^user$295^user$296^user$297^user$298^user$299^user$300'
*
*-----------------------------------------------------------------------
*      De facon totalement arbitraire les integrands specifiques de bord
*      sont numerotes a partir de 301
*-----------------------------------------------------------------------
*
*       301   302   303   304   305   306   307   308
     *,'VN    V^N   DNV   UDNV  DNUV  DNUDNVDTUDTVUDTV  '
*       309     310     311     312     313
     1,'N^ROTU.VNDIVU.V U^N.V^N U.NV.N  U.NV    '
*       314
     2,'GRADGRADTG'/
*-----------------------------------------------------------------------
* Groupe (nombre_noms x nombre_caracteres)
*        Liste des noms
*        des integrands      Procedure         Procedure
*                           Scal.  Vect.       appelant
* 1  (12 x 4 caracteres)
*        1:V , F.V        | WISCA ,WIVEC  | calint,calinb
*        2:D1V            | DW            | calint
*        3:D2V            | ''            |   ''
*        4:D3V            | ''            |   ''
*        5:UV , U.V       | WWISCA,WWIVEC | calint,calinb
*        6:U.AV           |       ,WAWVEC | calint
*        7:UD1V           | WDW   ,WDWVEC | calint
*        8:UD2V           | ''            |   ''
*        9:UD3V           | ''            |   ''
*       10:D1UV           | DWW   ,DWWVEC |   ''
*       11:D2UV           | ''     ''     |   ''
*       12:D3UV           | ''     ''     |   ''
* 2  (9 x 6 caracteres)
*       13:D1UD1V         | DWDW  ,DWDWVE | calint       ,calind
*       14:D1UD2V         | ''     ''     |   ''
*       15:D1UD3V         | ''     ''     |   ''
*       16:D2UD1V         | ''     ''     |   ''
*       17:D2UD2V         | ''     ''     |   ''
*       18:D2UD3V         | ''     ''     |   ''
*       19:D3UD1V         | ''     ''     |   ''
*       20:D3UD2V         | ''     ''     |   ''
*       21:D3UD3V         | ''     ''     |   ''
* 3  (5 x 8 caracteres)
*       22:GRADGRAD       | GRAGRA,GRVGRV | calint       ,calind
*       23:ROTROT         |       ,ROTROT | calint       ,calind
*       24:DIVDIV         |       ,DIVDIV | calint       ,calind
*       25:EIJEIJ         |       ,EIJEIJ | calint
*       26:AIJDIDJ        |       ,AIJDIJ | calint
* 4  (6 x 6 caracteres)
*       27:GRADUV         |       ,GRAWW  | calint
*       28:DIVUV          | DIVUQ         |   ''
*       29:ROTUV    (2/3d)| ROTU[Q/V]     |   ''
*       30:UDIVV          | PDIVV         | calint
*       31:UGRADV         | WGRAW         |   ''
*       32:UROTV   (2/3d) | [P/U]ROTV     | calint
* 5  (7 x 9 caracteres)
*       33:ROTROTBT0  (2d)|       ,ROTBT0 |   ''
*       34:ROTROTBT1  (2d)|       ,ROTBT1 |   ''
*       35:ROTROTBT2  (2d)|       ,ROTBT2 |   ''
*       36:DIVDIVBT0  (2d)|       ,DIVBT0 |   ''
*       37:DIVDIVBT1  (2d)|       ,DIVBT1 |   ''
*       38:DIVDIVBT2  (2d)|       ,DIVBT2 |   ''
*       39:EIJEIJBT0  (2d)|       ,EIJBT0 |   ''
* 6  (11 x 4 caracteres)
*       40:U^V        (2d)|       ,WVW    | calint,calinb
*       41:DIV            |       ,TENDW  |   ''  ,calind
*       42:U1V1           | WAWA          | calint
*       43:U1V2           | WAWB          |   ''
*       44:U1V3           | WAWB          |   ''
*       45:U2V1           | WAWA          |   ''
*       46:U2V2           | WAWB          |   ''
*       47:U2V3           | WAWB          |   ''
*       48:U3V1           | WAWA          |   ''
*       49:U3V2           | WAWB          |   ''
*       50:U3V3           | WAWB          |   ''
* 7  (7 x 8 caracteres)
*       51:U1,1V1,1       | WAGWAG        | calint
* 8  (7 x 8 caracteres)
*       58:U1,1V3,2       | WAGWBD        |   ''
*       64:U1,2V2,2       | WAGWBD        |   ''
* 9  (7 x 8 caracteres)
*       65:U1,2V2,3       | WAGWBD        |   ''
*       71:U1,3V1,3       | WAGWAG        |   ''
* 10 (6 x 8 caracteres)
*       72:U1,3V2,1       | WAGWBD        |   ''
*       77:U1,3V3,3       | WAGWBD        |   ''
* 11 (7 x 8 caracteres)
*       78:U2,1V1,1       | WAGWBD        |   ''
*       84:U2,1V3,1       | WAGWBD        |   ''
* 12 (7 x 8 caracteres)
*       85:U2,1V3,2       | WAGWBD        |   ''
*       91:U2,2V2,2       | WAGWBG        |   ''
* 13 (7 x 8 caracteres)
*       92:U2,2V2,3       | WAGWBD        |   ''
*       98:U2,3V1,3       | WAGWBD        |   ''
* 14 (6 x 8 caracteres)
*       99:U2,3V2,1       | WAGWBD        |   ''
*      104:U2,3V3,3       | WAGWBD        |   ''
* 15 (7 x 8 caracteres)
*      105:U3,1V1,1       | WAGWBD        |   ''
*      111:U3,1V3,1       | WAGWAG        |   ''
* 16 (7 x 8 caracteres)
*      112:U2,3V2,1       | WAGWBD        |   ''
*      118:U3,2V2,2       | WAGWBD        |   ''
* 17 (7 x 8 caracteres)
*      119:U3,2V2,3       | WAGWBD        |   ''
*      125:U3,3V1,3       | WAGWBD        |   ''
* 18 (6 x 8 caracteres)
*      126:U3,3V2,1       | WAGWBD        |   ''
*      131:U3,3V3,3       | WAGWAG        | calint
* 19 (2 x 8 caracteres)
*      132:Ui,iVj,j   (2d)| EIIEJJ        |   ''
*      133:Ui,jVj,i   (2d)| EIJEJI        |   ''
* 20 (10 x 6 caracteres)
*      134:U1,1V1         | WAGWB         | calint
*      135:U1,1V2         |   ''          |   ''
*      143:U2,1V1         | WAGWB         | calint
* 21 (10 x 6 caracteres)
*      144:U2,1V2         | WAGWB         | calint
*      153:U3,1V2         | WAGWB         | calint
* 22 ( 7 x 6 caracteres)
*      154:U3,1V3         | WAGWB         | calint
*      160:U3,3V3         | WAGWB         | calint
* 23 (10 x 6 caracteres)
*      161:U1V1,1         | WAWBD         | calint
*      170:U1V2,1         | WAWBD         | calint
* 24 (10 x 6 caracteres)
*      171:U2V2,1         | WAWBD         | calint
*      180:U2V3,1         | WAWBD         | calint
* 25 ( 7 x 6 caracteres)
*      181:U3V3,1         | WAWBD         | calint
*      187:U3V3,3         | WAWBD         | calint
*------Integrands PML---------------------------------------------------
* 26 ( 6 x 9 caracteres) Integrands PML
*      188:ROTROTP1       | ROTPML        | calint
*      189:ROTROTP2       | ROTPML        | calint
*      190:ROTROTP3       | ROTPML        | calint
*      191:ROTROTP12      | ROTPML        | calint
*      192:ROTROTP23      | ROTPML        | calint
*      193:ROTROTP13      | ROTPML        | calint
* 27 ( 1 x 10 caracteres) Integrand PML
*      194:ROTROTP123     | ROTPML        | calint
* 28 ( 6 x 9 caracteres) Integrands PML
*      195:DIVDIVP1       | DIVPML        | calint
*      196:DIVDIVP2       | DIVPML        |   ''
*      197:DIVDIVP3       | DIVPML        |   ''
*      198:DIVDIVP12      | DIVPML        |   ''
*      199:DIVDIVP23      | DIVPML        |   ''
*      200:DIVDIVP13      | DIVPML        |   ''
* 29 ( 1 x 10 caracteres) Integrand PML
*      201:DIVDIVP13      | DIVPML        | calint
* 30 ( 6 x 9 caracteres) Integrands PML
*      202:EIJEIJP1       | EIJPML        | calint
*      203:EIJEIJP2       | EIJPML        |   ''
*      204:EIJEIJP3       | EIJPML        |   ''
*      205:EIJEIJP12      | EIJPML        |   ''
*      206:EIJEIJP23      | EIJPML        |   ''
*      207:EIJEIJP13      | EIJPML        |   ''
* 31 ( 1 x 10 caracteres) Integrand PML
*      208:EIJEIJP123     | EIJPML        | calint
* 32 ( 6 x 8 caracteres) Integrands PML
*      209:UROTVP1 ([2/3]d) [P/U]ROTVP    | calint
*      210:UROTVP2 ([2/3]d) [P/U]ROTVP    |   ''
*      211:UROTVP3   (3d) | UROTVP        |   ''
*      212:UROTVP12 ([2/3]d) [P/U]ROTVP   |   ''
*      213:UROTVP23  (3d) | UROTVP        |   ''
*      214:UROTVP13  (3d) | UROTVP        |   ''
* 33 ( 1 x 9 caracteres) Integrand PML
*      215:UROTVP123 (3d) | UROTVP        | calint
* 34 ( 6 x 8 caracteres) Integrands PML
*      216:ROTUVP1 ([2/3]d) ROTU[Q/V]P    | calint
*      217:ROTUVP2 ([2/3]d) ROTU[Q/V]P    |   ''
*      218:ROTUVP3    (3d)| ROTUVP        |   ''
*      219:ROTUVP12 ([2/3]d) ROTU[Q/V]P   |   ''
*      220:ROTUVP23   (3d)| ROTUVP        |   ''
*      221:ROTUVP13   (3d)| ROTUVP        |   ''
* 35 ( 1 x 9 caracteres) Integrand PML
*      222:ROTUVP123  (3d)| ROTUVP        | calint
* 36 ( 6 x 3 caracteres)
*      223:U1V            | WAW           | calint, calinb
*      224:U2V            | WAW           | calint, calinb
*      225:U3V            | WAW           | calint, calinb
*      226:UV1            | WWA           | calint, calinb
*      227:UV2            | WWA           | calint, calinb
*      228:UV3            | WWA           | calint, calinb
*------Integrands PML---------------------------------------------------
* 37 (56 x 1 caractere)
*      229:
*      ...
*      284:
* 38 (9 x 7 caracteres)
*      285:^use285
*      286:^use286
*      ...
*      289:^use289
*      293:^use293
* 39 (7 x 9 caracteres)  
*      294:^user$294
*      ...
*      300:^user$300
*------Integrands de bords specifiques ---------------------------------
* 40 (7 x 6 caracteres)
*      301:VN             |       ,WN     |       ,calinb
*      302:V^N        (2d)|       ,WVN    |       ,calinb
*      303:DNV            | DNW           |              ,calind
*      304:UDNV           | WDNW  ,WNGRAW |              ,  ''
*      305:DNUV           | DNWW  ,NGRAWW |              ,  ''
*      306:DNUDNV         | DNWDNW        |              ,  ''
*      307:DTUDTV         | DTWDTW, DTWDTZ|       ,calinb,calind
*      308:UDTV       (2d)| WDTW          |       ,calinb
* 41 (5 x 8 caracteres)
*      309:N^ROTU.V       | NROTWW        |              ,  ''
*      310:NDIVU.V        | NDIVWW        |              ,  ''
*      311:U^N.V^N        |       ,WVNWVN |       ,calinb
*      312:U.NV.N         |       ,WNWN   |       ,  ''
*      313:U.NV           | WNV           |       ,  ''
* 42 (1 x 10 caracteres)
*      314:GRADGRADTG     | GRTGRT        |       ,  ''
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File History
* Version 9 : G.Legendre & D.Martin (27 mai/6 juin 2011)
* - nouvel integrand de bord 2d UdtV : 308
* Version 8 : D.Martin (3 decembre 2010/3 janvier 2011)
* - integrands PML 3d : les 15 integrands PML de 188 a 202 sont transformes 
*   en 35 integrands de 188 a 222. Le nombre de groupe (NGRINT) passe a 42.
* Version 7 : D.Martin & G.Chambeyron (06 novembre 2009)
* - ajout d'un groupe (29e) d'integrands supplementaires 203 -> 208 :
*   integrands U_{alpha}V et UV_{alpha} (C. Chambeyron)
* Version 6 : D.Martin & G.Legendre (17 septembre 2009)
* - ajout de integrand U.ROT(V) 3D (G. Legendre)
* Version 5 : D.Martin & G.Legendre (30 octobre 2008)
* - ajout des integrands PML generaux pour l''elasticite 2D (G. Legendre)
*   EIJEIJP1  EIJEIJP2  EIJEIJP12
* Version 4 : D.Martin (18 octobre 2006)
* - ajout des integrands PML generaux 2D (G. Legendre)
*   ROTROTP1  ROTROTP2  ROTROTP12 DIVDIVP1  DIVDIVP2  DIVDIVP12
*   UROTVP1   UROTVP2   UROTVP12  ROTUVP1   ROTUVP2   ROTUVP12
* Version 3 : D.Martin (03 octobre 2005)
* - ajout des integrales elementaires de bords pour inconnues vectorielles
*   U_{alpha} V_{beta}
* Version X : D. Martin (04 octobre 2004)
* - ajout de l''integrale elementaire : D_{nu}U.V pour inconnues vectorielles
* Version X : D. Martin (avril-mai 2004)
* - ajout de 78 integrales elementaires : U_{alpha} V_{beta} (alpha NE beta) et
*   U_{alpha,gamma} V_{beta,delta}
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
