*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NDIVWW (NBL,WL,NBC,DWC,NDIM,NORMAL
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire n.divU V
*
*-- Arguments --
* NBL    nombre de lignes de l'integrand
* WL     fonctions de base pour l'interpolation en ligne
* NBC    nombre de colonnes de l'integrand
* DWC    derivees des fonctions de base pour l'interpolation en colonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDIM,IMP
      REAL          WL(*),DWC(NDIM,*),ELDIPQ,NORMAL(*)
      REAL          COFVAR,COEFFR(NDIM,NBL,NDIM,*)
      COMPLEX       COFVAC,COEFFC(NDIM,NBL,NDIM,*)
*
      INTEGER       J,J1,I,I1
      REAL          DWCJ
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 J=1,NBC
            DO 23 J1=1,NDIM
               DWCJ=ELDIPQ*DWC(J1,J)
               DO 22 I=1,NBL
                  DO 21 I1=1,NDIM
                     COEFFR(I1,I,J1,J) = COEFFR(I1,I,J1,J)
     &                                 + COFVAR*DWCJ*NORMAL(I1)*WL(I)
21                CONTINUE
22             CONTINUE
23          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 J=1,NBC
            DO 43 J1=1,NDIM
               DWCJ=ELDIPQ*DWC(J1,J)
               DO 42 I=1,NBL
                  DO 41 I1=1,NDIM
                     COEFFC(I1,I,J1,J) = COEFFC(I1,I,J1,J)
     &                                 + COFVAC*DWCJ*NORMAL(I1)*WL(I)
41                CONTINUE
42             CONTINUE
43          CONTINUE
44       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTV ('n.DivU V (NDIVWW)'
     &  ,NDIM,NBL,NDIM,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !nDivWW
