*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NROTWW (NBL,WL,NBC,DWC,NDIM,NORMAL
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Juillet 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire n^RotU.V
*
*-- Arguments --
* NBL nombre de lignes de l'integrand
* WL     fonctions de base pour l'interpolation en ligne
* NBC nombre de colonnes de l'integrand
* DWC    derivees des fonctions de base pour l'interpolation en colonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDIM,IMP
      REAL          WL(*),DWC(NDIM,*),ELDIPQ,NORMAL(*)
      REAL          COFVAR,COEFFR(NDIM,NBL,NDIM,*)
      COMPLEX       COFVAC,COEFFC(NDIM,NBL,NDIM,*)
*
      INTEGER       J,J1,JDER,I,I1,IDER,NUT,NBTERM
      REAL          RX,ELTDIS,DWIDN
      COMPLEX       CX
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         IF (NDIM.EQ.3) THEN
            DO 25 J1=1,NDIM
               DO 24 I1=1,NDIM
                  NBTERM=1
                  JDER=I1
                  IDER=J1
                  ELTDIS=ELDIPQ
                  IF (J1.EQ.I1) THEN
                     NBTERM=NDIM-1
                     ELTDIS=-ELTDIS
                     JDER=J1-(J1/NDIM)*NDIM+1
                     IDER=JDER
                  ENDIF
                  DO 23 NUT=1,NBTERM
                     DO 22 J=1,NBC
                        DWIDN=ELTDIS*DWC(JDER,J)*NORMAL(IDER)
                        DO 21 I=1,NBL
                           RX=COEFFR(I1,I,J1,J)
                           RX=RX+COFVAR*DWIDN*WL(I)
                           COEFFR(I1,I,J1,J)=RX
21                      CONTINUE
22                   CONTINUE
                     JDER=J1-((J1+1)/NDIM)*NDIM+2
                     IDER=JDER
23                CONTINUE
24             CONTINUE
25          CONTINUE
         ENDIF
*
      ELSE
*
         IF (NDIM.EQ.3) THEN
            DO 45 J1=1,NDIM
               DO 44 I1=1,NDIM
                  NBTERM=1
                  JDER=I1
                  IDER=J1
                  ELTDIS=ELDIPQ
                  IF (J1.EQ.I1) THEN
                     NBTERM=NDIM-1
                     ELTDIS=-ELTDIS
                     JDER=J1-(J1/NDIM)*NDIM+1
                     IDER=JDER
                  ENDIF
                  DO 43 NUT=1,NBTERM
                     DO 42 J=1,NBC
                        DWIDN=ELTDIS*DWC(JDER,J)*NORMAL(IDER)
                        DO 41 I=1,NBL
                           CX=COEFFC(I1,I,J1,J)
                           CX=CX+COFVAC*DWIDN*WL(I)
                           COEFFC(I1,I,J1,J)=CX
41                      CONTINUE
42                   CONTINUE
                     JDER=J1-((J1+1)/NDIM)*NDIM+2
                     IDER=JDER
43                CONTINUE
44             CONTINUE
45          CONTINUE
         ENDIF
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTV ('n^RotU.V (NROTWW)'
     &               ,NDIM,NBL,NDIM,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !nRotWW
