*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRINTV (NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO,NBCOLP
     &                  ,TYPE,COEFFR,COEFFC,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1989)
* Derniere modification : D.Martin (25 septembre 2005)
* Version 2
*  
* Impression d'une matrice elementaire a inconnues vectorielles
*
*-- Arguments --
* NOMINT chaine de caracteres definissant l'integrale elementaire
* NCPINC nombre de composante de l'inconnue vectorielle en colonne
* NBCOLO nombre de colonnes de la matrice elementaire (par composante)
* NCPINL nombre de composante de l'inconnue vectorielle en ligne
* NBLIGN nombre de lignes de la matrice elementaire (par composante)
* NBCOLP nombre de colonnes (si =0 impression de la partie triang. inferieure)
* COEFFR tableau contenant la matrice elementaire transposee (cas reel)
* COEFFC tableau contenant la matrice elementaire transposee (cas complexe)
* IMPFCH numero du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINT,TYPE
      INTEGER       NCPINL,NBLIGN,NCPINC,NBCOLO,NBCOLP,IMPFCH
      REAL          COEFFR(NCPINL,NBLIGN,NCPINC,*)
      COMPLEX       COEFFC(NCPINL,NBLIGN,NCPINC,*)
*
      INTEGER       IT,I,JT,J
*-----------------------------------------------------------------------
      IF (NBCOLP.EQ.0) THEN
*
*        Impression de la partie triangulaire inferieure
*
         IF (TYPE(1:1).EQ.'R') THEN
            WRITE (IMPFCH,10020) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
            DO 1021 I=1,NBLIGN
               WRITE (IMPFCH,10021) I,
     &         ((COEFFR(1,I,JT,J),JT=1,MAX(NCPINC*MIN(1,I-J),1)),J=1,I)
               DO 1020 IT=2,NCPINL
                  WRITE (IMPFCH,10022)
     &            ((COEFFR(IT,I,JT,J),JT=1,MAX(NCPINC*MIN(1,I-J),IT))
     &           ,J=1,I)
1020            CONTINUE
1021        CONTINUE
         ELSEIF (TYPE(1:1).EQ.'C') THEN
            IF (NCPINL.EQ.3) THEN
               WRITE (IMPFCH,10340) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle',(J,J=1,NBCOLO)
               DO 1340 I=1,NBLIGN
                  WRITE (IMPFCH,10341) I,((REAL(COEFFC(1,I,JT,J))
     &                 ,JT=1,MAX(NCPINC*MIN(1,I-J),1)),J=1,I)
                  WRITE (IMPFCH,10342) ((REAL(COEFFC(2,I,JT,J))
     &                 ,JT=1,MAX(NCPINC*MIN(1,I-J),2)),J=1,I)
                  WRITE (IMPFCH,10342) ((REAL(COEFFC(3,I,JT,J))
     &                 ,JT=1,MAX(NCPINC*MIN(1,I-J),3)),J=1,I)
1340           CONTINUE 
            ELSEIF (NCPINL.EQ.2) THEN
               WRITE (IMPFCH,10240) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle'
               DO 1240 I=1,NBLIGN
                  WRITE (IMPFCH,10241) I,((REAL(COEFFC(1,I,JT,J))
     &                  ,JT=1,MAX(NCPINC*MIN(1,I-J),1)),J=1,I)
                  WRITE (IMPFCH,10242) ((REAL(COEFFC(2,I,JT,J))
     &                  ,JT=1,MAX(NCPINC*MIN(1,I-J),2)),J=1,I)
1240           CONTINUE
            ELSEIF (NCPINL.EQ.1) THEN
               WRITE (IMPFCH,10140) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle'
               DO 1140 I=1,NBLIGN
                  WRITE (IMPFCH,10141) I,((REAL(COEFFC(1,I,JT,J))
     &                  ,JT=1,MAX(NCPINC*MIN(1,I-J),1)),J=1,I)
1140           CONTINUE  
            ENDIF
         ENDIF
      ELSE
*
*        Impression de toute la matrice
*
         IF (TYPE(1:1).EQ.'R') THEN
            WRITE (IMPFCH,10020) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
            DO 2121 I=1,NBLIGN
               WRITE (IMPFCH,10021)I,
     &            ((COEFFR(1,I,JT,J),JT=1,NCPINC),J=1,NBCOLP)
               DO 2120 IT=2,NCPINL
                  WRITE (IMPFCH,10022)
     &            ((COEFFR(IT,I,JT,J),JT=1,NCPINC),J=1,NBCOLP)
2120           CONTINUE
2121        CONTINUE
         ELSEIF (TYPE(1:1).EQ.'C') THEN
            IF (NCPINL.EQ.3) THEN
               WRITE (IMPFCH,10340) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle',(J,J=1,NBCOLO)
               DO 2340 I=1,NBLIGN
                  WRITE (IMPFCH,10341) I,
     &                 ((REAL(COEFFC(1,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
                  WRITE (IMPFCH,10342)
     &                 ((REAL(COEFFC(2,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
                  WRITE (IMPFCH,10342)
     &                 ((REAL(COEFFC(3,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
2340           CONTINUE 
            ELSEIF (NCPINL.EQ.2) THEN
               WRITE (IMPFCH,10240) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle'
               DO 2241 I=1,NBLIGN
                  WRITE (IMPFCH,10241) I,
     &                 ((REAL(COEFFC(1,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
                  WRITE (IMPFCH,10242)
     &                 ((REAL(COEFFC(2,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
2241           CONTINUE
            ELSEIF (NCPINL.EQ.1) THEN
               WRITE (IMPFCH,10140) NOMINT,NCPINL,NBLIGN,NCPINC,NBCOLO
     &                             ,'part. reelle'
               DO 2140 I=1,NBLIGN
                  WRITE (IMPFCH,10141) I,
     &                 ((REAL(COEFFC(1,I,JT,J)),JT=1,NCPINC),J=1,NBCOLP)
2140           CONTINUE  
            ENDIF
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10020 FORMAT(T6,'Integrand ',A
     &,TR2,'(',I2,'*',I3,' lignes , ',I2,'*',I3,' colonnes)')
10021 FORMAT(T4,'i=',I4,' : ',10E11.4,:/(T7,'  ... ',10E11.4,:))
10022 FORMAT(T4,'       : '   ,10E11.4,:/(T7,'  ... ',10E11.4,:))
10140 FORMAT(T6,'Integrand ',A
     &,TR2,'(',I2,'*',I3,' lignes , ',I2,'*',I3,' colonnes) ',A,:
     &,/T16,5('j=',I2,15('-'),:,TR3)
     &,/(T9,'./.    ',5('j=',I2,15('-'),:,TR3)))  
10141 FORMAT(T4,'i=',I4,' : ',10E11.4,:/(T7,'  ... ',10E11.4,:))
10240 FORMAT(T6,'Integrand ',A
     &,TR2,'(',I2,'*',I3,' lignes , ',I2,'*',I3,' colonnes) ',A,:
     &,/T16,5('j=',I2,4('-'),:,TR3)
     &,/(T9,'./.    ',5('j=',I2,4('-'),:,TR3)))  
10241 FORMAT(T4,'i=',I4,' : ',10E11.4,:/(T7,'  ... ',10E11.4,:))
10242 FORMAT(T4,'       : '  ,10E11.4,:/(T7,'  ... ',10E11.4,:))
10340 FORMAT(T6,'Integrand ',A
     &,TR2,'(',I2,'*',I3,' lignes , ',I2,'*',I3,' colonnes) ',A,:
     &,/T16,3('j=',I2,26('-'),:,TR3)
     &,/(T9,'./.    ',3('j=',I2,26('-'),:,TR3)))  
10341 FORMAT(T4,'i=',I4,' : ',9E11.4,:/(T7,'  ... ',9E11.4,:))
10342 FORMAT(T4,'       : '  ,9E11.4,:/(T7,'  ... ',9E11.4,:))
                                                                    END !Printv
