*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ROTBT2 (MIXTE,NBL,WL,NCL,NBC,WC,NCC,NDIM
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Avril 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire pour inconnues vectorielles a 3 composantes
* en dimension 2,  en facteur de Beta^2 dans l'integrale
*                        rot_Beta(u).rot_Beta(v)
*                  (du_3/dx_2  - Beta u_2 )
* ou rot_Beta(u) = (Beta u_1   - du_3/dx_1)
*                  (du_2/dx_1  - du_1/dx_2) :
*
*                      |  WiWj      0       0  |
*      a_{i1,i,j1,j} = |    0     WiWj      0  |
*                      |    0       0       0  |
*-- Arguments --
* MIXTE  indicateur de mixite des interpolations
* NBL    nombre de lignes (comptees en noeuds) de la matrice elementaire
* WL     fonctions de base au point de quadrature pour l'interpolation
*        en ligne
* NCL    nombre de composantes pour l'inconnue en ligne
* NBC    nombre de colonnes (comptees en noeuds) de la matrice elementaire
* WC     fonctions de base au point de quadrature pour l'interpolation
*        en colonne
* NCC    nombre de composantes pour l'inconnue en ligne
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coefficient variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coefficient variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP unite logique d'impression (si > 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NCL,NBC,NCC,NDIM,IMP
      REAL          WL(*),WC(*),ELDIPQ
      REAL          COFVAR,COEFFR(NCL,NBL,NCC,*)
      COMPLEX       COFVAC,COEFFC(NCL,NBL,NCC,*)
*
      INTEGER       J,J1,I
      REAL          RX,WCJ
      COMPLEX       CX
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBC
            WCJ=ELDIPQ * WC(J)
            DO 21 I=1,J
               COEFFR(1,I,1,J)=COEFFR(1,I,1,J) + COFVAR * WCJ * WL(I)
21          CONTINUE
22       CONTINUE
         DO 25 J=1,NBC
            DO 24 I=1,J
               RX=COEFFR(1,I,1,J)
               COEFFR(1,J,1,I)=RX
               DO 23 J1=2,NDIM
                  COEFFR(J1,I,J1,J)=RX
                  COEFFR(J1,J,J1,I)=RX
23             CONTINUE
24          CONTINUE
25       CONTINUE
*
      ELSE
*
         DO 42 J=1,NBC
            WCJ=ELDIPQ * WC(J)
            DO 41 I=1,J
               COEFFC(1,I,1,J)=COEFFC(1,I,1,J) + COFVAC * WCJ * WL(I)
41          CONTINUE
42        CONTINUE
         DO 45 J=1,NBC
            DO 44 I=1,J
               CX=COEFFC(1,I,1,J)
               COEFFC(1,J,1,I)=CX
               DO 43 J1=2,NDIM
                  COEFFC(J1,I,J1,J)=CX
                  COEFFC(J1,J,J1,I)=CX
43             CONTINUE
44          CONTINUE
45       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         J=NBC
         IF (MIXTE.EQ.0) J=0
         CALL PRINTV ('Rot_beta2(U) Rot_beta2(V) (ROTBT2)'
     &               ,NCL,NBL,NCC,NBC,J,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !RotBt2
