*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TENDW (NBL,DWL,NDIM
     &                 ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.deBayser (Decembre 1990)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul des integrales elementaires dWj/dx1,dWj/dx2,dWj/dx3 pour
* le calcul de la divergence
*
*-- Arguments --
* NBL    nombre de lignes (comptees en noeuds) de la matrice elementaire
* DWL    derivees des fonctions a l'image du point de quadrature dans
*        l'element courant pour l'interpolation en ligne
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NDIM,IMP
      REAL          DWL(NDIM,*),ELDIPQ
     &             ,COFVAR,COEFFR(NDIM,*)
      COMPLEX       COFVAC,COEFFC(NDIM,*)
*
      INTEGER       K,I
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 K=1,NDIM
            DO 21 I=1,NBL
               COEFFR(K,I) = COEFFR(K,I) + COFVAR * ELDIPQ * DWL(K,I)
21          CONTINUE
22       CONTINUE
*
         IF (IMP.GT.0) THEN
            DO 23 K=1,NDIM
               WRITE(IMP,10000) K,(COEFFR(K,I),I=1,NBL)
23          CONTINUE
         ENDIF
*
      ELSE
*
         DO 42 K=1,NDIM
            DO 41 I=1,NBL
               COEFFC(K,I) = COEFFC(K,I) + COFVAC * ELDIPQ * DWL(K,I)
41          CONTINUE
42       CONTINUE
*
         IF (IMP.GT.0) THEN
            DO 43 K=1,NDIM
               WRITE(IMP,10001) K,(COEFFC(K,I),I=1,NBL)
43          CONTINUE
         ENDIF
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T6,'Integrand divWi',I1,' reel (TENDW)'/(T10,10E11.4))
10001 FORMAT(/T6,'Integrand divWi',I1,' complexe (TENDW)'
     &/(T10,5(SS,E11.4,SP,E10.4,'*i')))
                                                                    END !TendW
