*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WAW (MIXTE,ALPHA,NBL,WL,NCL,NBC,WC,NCC
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : E.Luneville (4 mai 2009))
* Version 0
*
* Calcul de l'integrale elementaire pour inconnues vectorielles
*
* a_{i1,i,j1,j} = delta_[i1,alpha}  WiWj
*
* pour le calcul de l'integrale
*              Int_K [ u_{alpha} v ] dx
*
*-- Arguments --
* MIXTE  indicateur de mixite des interpolations
* NBL    nombre de lignes de la matrice elementaire
* WL     fonctions de base au point de quadrature pour l'interpolation
*        en ligne
* ALPHA  alpha dans les formules ci-dessus
* NBC    nombre de colonnes de la matrice elementaire
* WC     fonctions de base au point de quadrature pour l'interpolation
*        en colonne
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coefficient variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coefficient variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    unite logique d'impression (si > 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NCL,ALPHA,NBC,NCC,IMP
      REAL          WL(*),WC(*),ELDIPQ
     &             ,COFVAR,COEFFR(NCL,NBL,NBC)
      COMPLEX       COFVAC,COEFFC(NCL,NBL,NBC)
*
      INTEGER       I,J
      CHARACTER     ALPHAC
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBC
            DO 21 I=1,NBL
               COEFFR(ALPHA,I,J) = COEFFR(ALPHA,I,J)
     &                                + COFVAR * ELDIPQ * WC(J) * WL(I)
 21         CONTINUE
 22      CONTINUE
*
      ELSE
*
         DO 42 J=1,NBC
            DO 41 I=1,NBL
               COEFFC(ALPHA,I,J) = COEFFC(ALPHA,I,J)
     &                                + COFVAC * ELDIPQ * WC(J) * WL(I)
 41         CONTINUE
 42       CONTINUE
      ENDIF
*
      IF (IMP.GT.0) THEN
         CALL ENCLER (ALPHA,ALPHAC)
         CALL PRINTV ('U'//ALPHAC//'V (WaW)'
     &               ,NCL,NBL,NCC,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !WaW
