*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WAWA (MIXTE,ALPHA,NBL,WL,NCL,NBC,WC,NCC
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1999)
* Derniere modification : D.Martin (03 octobre 2005)
* Version 2
*
* Calcul de l'integrale elementaire pour inconnues vectorielles
*
* a_{i1,i,j1,j} = delta_[i1,alpha} delta_{j1,alpha} WiWj
*
* issu, par exemple, de la decomposition de l'integrand U.V
* pour le calcul de l'integrale
*              Int_K [ u_{alpha} v_{alpha} ] dx
*
*-- Arguments --
* MIXTE  indicateur de mixite des interpolations
* ALPHA  alpha dans les formules ci-dessus
* NBL    nombre de lignes de la matrice elementaire
* WL     fonctions de base au point de quadrature pour l'interpolation
*        en ligne
* NBC    nombre de colonnes de la matrice elementaire
* WC     fonctions de base au point de quadrature pour l'interpolation
*        en colonne
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coefficient variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coefficient variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    unite logique d'impression (si > 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,ALPHA,NBL,NCL,NBC,NCC,IMP
      REAL          WL(*),WC(*),ELDIPQ
     &             ,COFVAR,COEFFR(NCL,NBL,NCC,*)
      COMPLEX       COFVAC,COEFFC(NCL,NBL,NCC,*)
*
      INTEGER       I,J
      REAL          RX
      COMPLEX       CX
      CHARACTER     ALPHAC
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBC
            DO 21 I=1,J
               RX = COEFFR(ALPHA,I,ALPHA,J)
               RX = RX + COFVAR * ELDIPQ * WC(J) * WL(I)
               COEFFR(ALPHA,I,ALPHA,J)=RX
               COEFFR(ALPHA,J,ALPHA,I)=RX
 21         CONTINUE
 22      CONTINUE
*
      ELSE
*
         DO 42 J=1,NBC
            DO 41 I=1,J
               CX = COEFFC(ALPHA,I,ALPHA,J)
               CX = CX + COFVAC * ELDIPQ * WC(J) * WL(I)
               COEFFC(ALPHA,I,ALPHA,J) = CX
               COEFFC(ALPHA,J,ALPHA,I) = CX
 41         CONTINUE
 42       CONTINUE
      ENDIF
*
      IF (IMP.GT.0) THEN
         I=NBC
*         IF (MIXTE.EQ.0) I=0
         CALL ENCLER (ALPHA,ALPHAC)
         CALL PRINTV ('U'//ALPHAC//'V'//ALPHAC//' (WaWa)'
     &               ,NCL,NBL,NCC,NBC,I,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !WaWa
