*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WDNW (NBL,DWL,NBC,WC,NDIM,NORMAL
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1992)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire U.dV/dn pour inconnues scalaires
*
*-- Arguments --
* NBC nombre de colonnes de l'integrand
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBL nombre de lignes de l'integrand
* WC     fonctions de base pour l'interpolation en olonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas REEL)
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*         de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBC,NBL,NDIM,IMP
      REAL          WC(*),DWL(NDIM,*),ELDIPQ,NORMAL(*)
     &             ,COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I,I1
      REAL          DWIDN
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 23 I=1,NBL
*           Calcul de dWi/dn
            DWIDN=0.
            DO 21 I1=1,NDIM
               DWIDN = DWIDN + DWL(I1,I) * NORMAL(I1)
21          CONTINUE
            DO 22 J=1,NBC
               COEFFR(I,J)=COEFFR(I,J)+COFVAR*ELDIPQ*DWIDN*WC(J)
22          CONTINUE
23       CONTINUE
*
      ELSE
*
         DO 43 I=1,NBL
            DWIDN=0.
            DO 41 I1=1,NDIM
               DWIDN = DWIDN + DWL(I1,I) * NORMAL(I1)
41          CONTINUE
            DO 42 J=1,NBC
               COEFFC(I,J)=COEFFC(I,J)+COFVAC*ELDIPQ*DWIDN*WC(J)
42          CONTINUE
43       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('U.dV/dn (WDNW)'
     &               ,NBL,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !WdnW
