*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WDTW (NBL,DWL,NBC,WC,NDOM
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : G. Legendre (mai 2011)
* Derniere modification : G.Legendre & D.Martin (5 juin 2011)
* Version 0
*
* Calcul de l'integrale elementaire U dV/dt pour inconnues scalaires
* (seulement valable en dimension 2)
*
*-- Arguments --
* NBL    nombre de lignes de l'integrale elementaire
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes de l'integrale elementaire
* WC     fonctions de base pour l'interpolation en colonne
* NDOM   dimension d'espace du domaine d'integration
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrale ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas REEL)
* COFVAC toeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBC,NBL,NDOM,IMP
      REAL          WC(*),DWL(NDOM,*),ELDIPQ
      REAL          COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I
*     REAL          DWJDT,DWIDT
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 I=1,NBL
            DO 23 J=1,NBC
               COEFFR(I,J)=COEFFR(I,J)+COFVAR*ELDIPQ*DWL(1,I)*WC(J)
23          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 I=1,NBL
            DO 43 J=1,NBC
               COEFFC(I,J)=COEFFC(I,J)+COFVAC*ELDIPQ*DWL(1,I)*WC(J)
43          CONTINUE
44       CONTINUE
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('U dV/dt (WDTW via CALINB)'
     &               ,NBL,NBC,0,TYPE,COEFFR,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File History
* Version 0 : G.Legendre & D.Martin (5 juin 2011)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !dtWdtW
