*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WDW (K,NBL,DWL,NBC,WC,NDIM
     &               ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul des integrales elementaires U dV/dxk
*
*-- Arguments --
* K      =k dans U dV/dxk
* NBL    nombre de lignes de la matrice elementaire
* DWL    derivees des fonctions de base a l'image du point de quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes de la matrice elementaire
* WC     valeurs des fonctions de base au point de quadrature
*        pour l'interpolation en colonne
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       K,NBC,NBL,NDIM,IMP
      REAL          WC(*),DWL(NDIM,*),ELDIPQ
      REAL          COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBC
            DO 21 I=1,NBL
               COEFFR(I,J)=COEFFR(I,J)+COFVAR*ELDIPQ*WC(J)*DWL(K,I)
21          CONTINUE
22       CONTINUE
*
      ELSE
*
         DO 42 J=1,NBC
            DO 41 I=1,NBL
               COEFFC(I,J)=COEFFC(I,J)+COFVAC*ELDIPQ*WC(J)*DWL(K,I)
41          CONTINUE
42       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTG ('U dV/dx'//CHAR(K+48)//' (WDW)'
     &               ,NBL,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !WdW
