*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WDWVEC (MIXTE,K,NBL,DWL,NCL,NBC,WC,NCC,NDIM
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : G.Legendre (Mai 2002)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul des integrales elementaires U.dV/dxk, inconnues vectorielles
*
*-- Arguments --
* K      =k dans U.dV/dxk
* MIXTE  indicateur de mixite des interpolations
* NBL    nombre de lignes de la matrice elementaire
* NCL    nombre de composantes pour l'inconnue en ligne
* DWL    derivees des fonctions a l'image du point quadrature dans
*        l'element courant pour l'interpolation en ligne
* NBC    nombre de colonnes de la matrice elementaire
* NCC    nombre de composantes pour l'inconnue en colonne
* WC     valeurs des fonctions de base au point de quadrature
* NDIM   dimension d'espace
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coefficient variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER TYPE*(*)
      INTEGER   K,MIXTE,NBC,NCC,NBL,NCL,NDIM,IMP
      REAL      DWL(NDIM,*),WC(*),ELDIPQ
      REAL      COFVAR,COEFFR(NCL,NBL,NCC,*)
      COMPLEX   COFVAC,COEFFC(NCL,NBL,NCC,*)
*
      INTEGER   I,I1,J
      REAL      RCF
      COMPLEX   CCF
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 I=1,NBC
            DO 21 J=1,NBL
               COEFFR(1,J,1,I)=COEFFR(1,J,1,I)
     &                        +COFVAR*ELDIPQ*WC(I)*DWL(K,J)
21          CONTINUE
22       CONTINUE
         DO 25 I=1,NBC
            DO 24 J=1,NBL
               RCF=COEFFR(1,J,1,I)
               DO 23 I1=2,NCC
                   COEFFR(I1,J,I1,I)=RCF
23             CONTINUE
24          CONTINUE
25       CONTINUE
*
      ELSE
*
         DO 42 I=1,NBC
            CCF=COFVAC*ELDIPQ*WC(I)
            DO 41 J=1,NBL
               COEFFC(1,J,1,I)=COEFFC(1,J,1,I)
     &                        +COFVAC*ELDIPQ*WC(I)*DWL(K,J)
41          CONTINUE
42       CONTINUE
         DO 45 I=1,NBC
            DO 44 J=1,NBL
               CCF=COEFFC(1,J,1,I)
               DO 43 I1=2,NCC
                  COEFFC(I1,J,I1,I)=CCF
43             CONTINUE
44          CONTINUE
45       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         I=NBC
         IF (MIXTE.EQ.0) I=0
         CALL PRINTV ('U'//'.dV/dx'//CHAR(K+48)//' (WDWVEC)'
     &  ,NCL,NBL,NCC,NBC,I,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                  END !WdWvec
