*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WISCA (NBL,WL
     &                 ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire V pour inconnue scalaire
*
*-- Arguments --
* NBL    nombre de lignes de l'integrand
* WL     valeurs de fonctions de base au point de quadrature courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand / coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYPE*(*)
      INTEGER   NBL,IMP
      REAL      WL(*),ELDIPQ
     &         ,COFVAR,COEFFR(*)
      COMPLEX   COFVAC,COEFFC(*)
*
      INTEGER I
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 2 I=1,NBL
            COEFFR(I)=COEFFR(I)+ COFVAR * ELDIPQ * WL(I)
2        CONTINUE
*
         IF (IMP.GT.0) WRITE(IMP,10000) (COEFFR(I),I=1,NBL)
*
      ELSE
*
         DO 4 I=1,NBL
            COEFFC(I)=COEFFC(I)+ COFVAC * ELDIPQ * WL(I)
4        CONTINUE
*
         IF (IMP.GT.0) WRITE(IMP,10001) (COEFFC(I),I=1,NBL)
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T6,'Integrand FV (WISCA)'/(T13,10E11.4))
10001 FORMAT(T6,'Integrand FV complexe (WISCA)'/
     &(T13,5(SS,E11.4,SP,E10.4,'*i')))
                                                                    END !Wisca
