*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WIVEC (NBL,WL,NCL
     &                 ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (12 mai 1997)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire F.V pour inconnue vectorielle
*
*-- Arguments --
* NBL    nombre de lignes (comptees en noeuds) de l'integrale
* WL     valeurs de fonctions de base au point de quadrature
* NCL    nombre de composantes de l'inconnue
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable a valeur vectorielle (cas REEL)
* COEFFR tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable a valeur vectorielle (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrales elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NCL,IMP
      REAL          WL(*),ELDIPQ
     &             ,COFVAR(*),COEFFR(*)
      COMPLEX       COFVAC(*),COEFFC(*)
*
      INTEGER       MCADRS,I,I1
*-----------------------------------------------------------------------
      MCADRS=1
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 I=1,NBL
            DO 21 I1=1,NCL
               COEFFR(MCADRS)=COEFFR(MCADRS)+COFVAR(I1)*ELDIPQ*WL(I)
               MCADRS=MCADRS+1
21          CONTINUE
22       CONTINUE
         IF (IMP.GT.0) THEN
            WRITE (IMP,10000) 'Integrand F.V reel (WIVEC)',NCL,NBL
            WRITE (IMP,10002) (COEFFR(MCADRS),MCADRS=1,NCL*NBL)
         ENDIF
*
      ELSE
*
         DO 42 I=1,NBL
            DO 41 I1=1,NCL
               COEFFC(MCADRS)=COEFFC(MCADRS)+COFVAC(I1)*ELDIPQ*WL(I)
               MCADRS=MCADRS+1
41          CONTINUE
42       CONTINUE
         IF (IMP.GT.0) THEN
            WRITE (IMP,10000) 'Integrand F.V complexe (WIVEC)',NCL,NBL
            WRITE (IMP,10004) (COEFFC(MCADRS),MCADRS=1,NCL*NBL)
         ENDIF
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T6,A,TR2,'(',I2,'*',I3,' lignes)')
10002 FORMAT((T13,10E11.4))
10004 FORMAT((T13,5(SS,E11.4,SP,E10.4,'*i')))
                                                                    END !Wivec
