*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WNGRAW (NBL,DWL,NBC,WC,NDIM,NORMAL
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 2004)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire U.dV/dn = \sum Ui dVi/dn avec 
* inconnues vectorielles
*
*-- Arguments --
* NBL    nombre de lignes de l'integrand
* DWL    derivees des fonctions de base pour l'interpolation en ligne
* NBC    nombre de colonnes de l'integrand
* WC     fonctions de base pour l'interpolation en colonne
* NDIM   dimension d'espace
* NORMAL vecteur normal a l'image du point de quadrature dans l'elt. courant
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP numero du fichier d'impression (pas d'impression si nul) .
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NDIM,IMP
      REAL          DWL(NDIM,*),WC(*),ELDIPQ,NORMAL(*)
      REAL          COFVAR,COEFFR(NDIM,NBL,NDIM,*)
      COMPLEX       COFVAC,COEFFC(NDIM,NBL,NDIM,*)
*
      INTEGER       J,I,I1
      REAL          RCF,DWIDN
      COMPLEX       CCF
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 23 I=1,NBL
*           Calcul de dWi/dn
            DWIDN=0.
            DO 21 I1=1,NDIM
               DWIDN=DWIDN+ELDIPQ*DWL(I1,I)*NORMAL(I1)
21          CONTINUE
            DO 22 J=1,NBL
               COEFFR(1,I,1,J)=COEFFR(1,I,1,J)+COFVAR*DWIDN*WC(J)
22          CONTINUE
23       CONTINUE
         DO 26 J=1,NBC
            DO 25 I=1,NBL
               RCF=COEFFR(1,I,1,J)
               DO 24 J1=2,NDIM
                  COEFFR(J1,I,J1,J)=RCF
24             CONTINUE
25          CONTINUE
26       CONTINUE
*
      ELSE
*
         DO 43 I=1,NBC
            DWIDN=0.
            DO 41 I1=1,NDIM
               DWIDN=DWIDN+ELDIPQ*DWL(I1,I)*NORMAL(I1)
41          CONTINUE
            DO 42 J=1,NBL
               COEFFC(1,I,1,J)=COEFFC(1,I,1,J)+COFVAC*DWIDN*WC(J)
42          CONTINUE
43       CONTINUE
         DO 46 J=1,NBC
            DO 45 I=1,NBL
               CCF=COEFFC(1,I,1,J)
               DO 44 J1=2,NDIM
                  COEFFC(J1,I,J1,J)=CCF
44             CONTINUE
45          CONTINUE
46       CONTINUE
      ENDIF
*
      IF (IMP.GT.0)
     &   CALL PRINTV ('U.dV/dn (WNGRAW)'
     &               ,NDIM,NBL,NDIM,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
                                                                    END !WNgraW
