*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WNV  (NBL,WL,NBC,WC,NCC,NORMAL
     &                ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (25 Juin 1999)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire U.n V pour inconnue vectorielle en colonne
*
*-- Arguments --
* MIXTE  indice de mixite de l'interpolation
* NBL    nombre de lignes (comptees en noeuds) de la matrice elementaire
* WL     valeurs de fonctions de base pour l'interpolation en ligne
* NBC    nombre de colonnes (comptees en noeuds) de la matrice elementaire
* WC     valeurs de fonctions de base pour l'interpolation en colonne
* NCC    nombre de composantes pour l'inconnue en colonne
* NORMAL composantes du vecteur normal a l'image du point de quadrature
*        complete de zeros si NCC > NDIM
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBL,NBC,NCC,IMP
      REAL          WC(*),WL(*),ELDIPQ,NORMAL(*)
      REAL          COFVAR,COEFFR(NBL,NCC,*)
      COMPLEX       COFVAC,COEFFC(NBL,NCC,*)
*
      INTEGER       J,J1,I
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 24 J=1,NBC
            DO 23 J1=1,NCC
               DO 22 I=1,NBL
                  COEFFR(I,J1,J) = COEFFR(I,J1,J) + COFVAR
     &                           * ELDIPQ*WL(I)*WC(J)*NORMAL(J1)
22             CONTINUE
23          CONTINUE
24       CONTINUE
*
      ELSE
*
         DO 44 J=1,NBC
            DO 43 J1=1,NCC
               DO 42 I=1,NBL
                  COEFFC(I,J1,J) = COEFFC(I,J1,J) + COFVAC
     &                           * ELDIPQ*WL(I)*WC(J)*NORMAL(J1)
42             CONTINUE
43          CONTINUE
44       CONTINUE
      ENDIF
*
      IF (IMP.GT.0) THEN
         CALL PRINTV ('U.n V '
     &               ,1,NBL,NCC,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !WnV
