*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WVW    (MIXTE,NBL,WL,NCL,NBC,WC,NCC
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1999)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire: U^V avec inconnues vectorielles en 2D
*                                |  0  1 |
*                a_{i1,i,j1,j} = |       | W_i W_j
*                                | -1  0 |
*-- Arguments --
* NBL    nombre de lignes (comptee en noeuds) de l'integrand
* WL     valeurs des fonctions de base au point de quadrature
*        pour l'interpolation en ligne
* NCL    nombre de composantes  de l'inconnue en ligne
* NBC    nombre de colonnes (comptee en noeuds) de l'integrand
* WC     valeurs des fonctions de base au point de quadrature
*        pour l'interpolation en colonne
* NCC    nombre de composantes de l'inconnue en ligne
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand
* COFVAR coefficient variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coefficient variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    unite logique d'impression (si > 0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NCL,NBC,NCC,IMP
      REAL          WL(*),WC(*),ELDIPQ
      REAL          COFVAR,COEFFR(NCL,NBL,NCC,*)
      COMPLEX       COFVAC,COEFFC(NCL,NBL,NCC,*)
*
      INTEGER       J,I
      REAL          RX
      COMPLEX       CX
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
*
         DO 22 J=1,NBC
            DO 21 I=1,NBC
               RX=COEFFR(2,J,1,I) - COFVAR * ELDIPQ * WC(J) * WC(I)
               COEFFR(2,J,1,I)= RX
               COEFFR(1,J,2,I)=-RX
21          CONTINUE
22       CONTINUE
*
      ELSE
*
         DO 42 J=1,NBC
            DO 41 I=1,NBC
               CX=COEFFC(2,J,1,I) - COFVAC * ELDIPQ * WC(J) * WC(I)
               COEFFC(2,J,1,I)= CX
               COEFFC(1,J,2,I)=-CX
41          CONTINUE
42       CONTINUE
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         I=NBC
         IF (MIXTE.EQ.0) I=0
         CALL PRINTV ('U^V (2D) (WVW)'
     &               ,NCL,NBL,NCC,NBC,NBC,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !WvW
