*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WWISCA (MIXTE,NBL,WL,NBC,WC
     &                  ,ELDIPQ,TYPE,COFVAR,COEFFR,COFVAC,COEFFC,IMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1988)
* Derniere modification : D.Martin (28 juin 2005)
* Version 2
*
* Calcul de l'integrale elementaire Wi . Wj pour inconnues scalaires
*
*-- Arguments --
* MIXTE  indice de mixite de l'interpolation
* NBL    nombre de lignes (=nombre de d.l. en ligne)
* WL     valeurs de fonctions de base pour l'interpolation en ligne
* NBC    nombre de colonnes (=nombre de d.l. en colonne)
* WC     valeurs de fonctions de base pour l'interpolation en ligne
* ELDIPQ poids de quadrature multiplie par l'element differentiel
* TYPE   type (REEL ou COMPLEXE) de l'integrand ou du coeff. variable
* COFVAR coeff. variable (cas REEL)
* COEFFR tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas REEL)
* COFVAC coeff. variable (cas COMPLEXE)
* COEFFC tableau des valeurs cumulees des integrands elementaires aux points
*        de quadrature (cas COMPLEXE)
* IMP    numero du fichier d'impression si non nul
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       MIXTE,NBL,NBC,IMP
      REAL          WC(*),WL(*),ELDIPQ
      REAL          COFVAR,COEFFR(NBL,*)
      COMPLEX       COFVAC,COEFFC(NBL,*)
*
      INTEGER       J,I
      REAL          RCF
      COMPLEX       CCF
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
*
         IF (MIXTE.EQ.0) THEN
            DO 22 J=1,NBC
               DO 21 I=1,J
                  RCF=COEFFR(I,J)
                  RCF=RCF + COFVAR * ELDIPQ * WC(J) * WL(I)
                  COEFFR(I,J)=RCF
                  COEFFR(J,I)=RCF
21             CONTINUE
22          CONTINUE
         ELSE
            DO 24 J=1,NBC
               DO 23 I=1,NBL
                  RCF=COEFFR(I,J)
                  RCF=RCF + COFVAR * ELDIPQ * WC(J) * WL(I)
                  COEFFR(I,J)=RCF
23            CONTINUE
24         CONTINUE
         ENDIF
*
      ELSE
*
         IF (MIXTE.EQ.0) THEN
            DO 42 J=1,NBC
               DO 41 I=1,J
                  CCF=COEFFC(I,J)
                  CCF=CCF + COFVAC * ELDIPQ * WC(J) * WL(I)
                  COEFFC(I,J)=CCF
                  COEFFC(J,I)=CCF
41             CONTINUE
42          CONTINUE
         ELSE
            DO 44 J=1,NBC
               DO 43 I=1,NBL
                  CCF=COEFFC(I,J)
                  CCF=CCF + COFVAC * ELDIPQ * WC(J) * WL(I)
                  COEFFC(I,J)=CCF
43            CONTINUE
44         CONTINUE
         ENDIF
*
      ENDIF
*
      IF (IMP.GT.0) THEN
         J=NBC
         IF (MIXTE.EQ.0) J=0
         CALL PRINTG ('U V (WWISCA)',NBL,NBC,J,TYPE,COEFFR,COEFFC,IMP)
      ENDIF
                                                                    END !WWisca
