*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCASSE (NIVIMP,NVASMB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993) 
* Derniere modification : D.Martin (24 Avril 2002)
* Version 1.0.4
*  
* Lecture de la directive d'assemblage d'un terme  
*  
*-- Arguments d'entree -- 
* NIVIMP niveau d'impression des messages 
*-- Argument de sortie --
* NVASMB numero du terme resultat de l'assemblage
*
*-- Mots-cles de la Directive ASSEMBLAGE --
*  
* ASSEMBLAGE [DU] [TERME]  ||C*6 [ [DE] [NIVEAU]  ||I ]
*   [ Impression [DE NIVEAU]  ||I ]
*   [ Symetrique / AntiSymetrique / AntiAdjoint / AutoAdjoint ]
*   [ Donnee [DE] [ NOM ] &C < CONSTANTE [ < ENTIERE / REELLE / COMPLEXE > ] ]
*   < COMPOSE [DES TERMES]    + ||C*6 [ [DE] [NIVEAU]  ||I ]
*   /MULTI-INCONNUE [TERMES]  + ||C*6 [ [DE] [NIVEAU]  ||I ]
*   >
*
* Plus tard, peut-etre les mots-cles suivants ?
*   / COMBINAISON [LINEAIRE]  + ||C*6 [ [DE] [NIVEAU]  ||I ]
*   / COPIE [DU TERME]          ||C*6 [ [DE] [NIVEAU]  ||I ]
*   / SOMME [DES TERMES]      + ||C*6 [ [DE] [NIVEAU]  ||I ]
*   / DIFFERENCE [DE]           ||C*6 [ [DE] [NIVEAU]  ||I ] 
*                [ET]           ||C*6 [ [DE] [NIVEAU]  ||I ]
*   / MULTIPLICATION [DE]       ||C*6 [ [DE] [NIVEAU]  ||I ] 
*                    [PAR]      ||C*6 [ [DE] [NIVEAU]  ||I ]
*
*-- Structure de donnees concernees --
* #OMTRM, $SDTRM, $ASMBL
*
* Remarque : 
* - Un terme ne peut apparaitre qu'une fois dans une structure d'assemblage
* - Le tableau ($WORK$,0) defini dans LCDIRE est utilise ci-dessous
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NIVIMP,NVASMB  
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER        TYPINT*4,YKLINT*6,PRFXAS*8
      CHARACTER*6      TEXTE*80,ERCODE*120,NOMTRA,NOMTRM,NMWORK
      CHARACTER        NMDONN*16,THETRM*16
      INTEGER          INDASS,INDSYM,INTDON,INTTYP,INTYKL,KELCHN,KLCSTE
     &                ,KLTERM,KLNIVE
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,NIVEAU,I,J
     &                ,LGETRA,NBTRAC,INCTRA,ITYASS,MCMTRM,MCDTRM,LGWORK
     &                ,LGETRM,NBTERM,INCTRM,NCHTRM,NCATRA,NIVTRA,NBTRAV
     &                ,NUTERA,ITTRMR,ITYCAL,NUASSE,NBTRAX,MCWORK
     &                ,NUTERM,NIVTRM,NCATRM,LGDTRM,LGMTRM,MCASMB,LGASMB
     &                ,NUC,NDC,NBNC,NVC,NUL,NDL,NBNL,NVL,IND,NVS
     &                ,IN2,IN3,NIVIMT,NWHTRM,ITYSYM,NUDONN,INTREL
     &                ,LUDONX,NCDONN,ITYDON,NIVDON,ITYPDO,LUDONN,NCHDON
     &                ,LGMDON,MCMDON,LGDONN,MCDONN,LGEDON,INCDON,NBDONN
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/FORMAH/ERCODE
      EQUIVALENCE      (ERCODE(97:97),NMWORK)
     &                ,(ERCODE(105:105),NOMTRM),(ERCODE(113:113),NOMTRA)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcAsse*')
      LGETRA=4
      NBTRAC=0
      INCTRA=1
      ITYASS=INTYKL ('ASSEMB')                                          !utilite
      INTREL=INTTYP ('REEL')                                            !utilite
      ITYSYM=NDFSYM
      NUDONN=NDFDON
      ITYDON=-1
      NIVDON=0
      ITYPDO=0
      NCDONN=0
      LUDONN=0
      LUDONX=1
*
      CALL TBRR5  (ERCODE,'$WORK$',0,LGWORK
     &                   ,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM
     &                   ,'#OMDON',1,LGMDON,'$DONNE',1,LGDONN)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Lecture des nom et eventuellement niveau du terme
*
1     CALL REDLE
*     Lecture eventuelle des mots [DU] [TERME]
      IF (IRE.EQ.3.AND.TEXTE(1:4).EQ.'TERM') GOTO 1
      IF (IRE.NE.4) CALL REDERR(14,' ')
*
*     Le nom du terme a ete lu
*
      NCATRA=NCAR
      NOMTRA=TEXTE(1:NCAR)
      IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &   WRITE (IMPMES,10004) '*LcAsse*',NCAR,TEXTE(1:NCAR)
*
*     Niveau du terme ?
*
      NIVTRA=1
      CALL REDLE
      IF (IRE.EQ.3.AND.(TEXTE(1:6).EQ.'NIVEAU'
     &              .OR.TEXTE(1:5).EQ.'LEVEL')) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2)
     &      WRITE(IMPMES,10003) '*LcAsse*',TEXTE(1:NCAR)
         CALL REDLE
      ENDIF
      IF (IRE.EQ.1) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.1)
     &      WRITE (IMPMES,10001) '*LcAsse*',NFIX
         NIVTRA=NFIX
         CALL REDLE
      ENDIF
*
      NBTRAV=0
      NUTERA=KLTERM (NOMTRA(:NCATRA),NIVTRA,AST(MCMTRM),IST(MCDTRM))    !sdexplo
      IF (NUTERA.GT.0) THEN
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU,ITTRMR 
     &               ,ITYCAL,NUASSE,NUDONN,ITYSYM,NVASMB,NUC,NDC,NBNC
     &               ,NVC,NUL,NDL,NBNL,NVL,IND,NVS,IN2,IN3,NIVIMT)      !sdexplo
         IF (ITYCAL.EQ.ITYASS) THEN
*           Agrandissement eventuel de la structure $ASMBL
            CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,LGASMB)
            CALL TBAR1  (ERCODE,'$ASMBL',NVASMB,MCASMB)
            CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAV,INCTRA,NBTRAV)       !utilite
            IF (NUASSE.LT.0) NBTRAV=0
            CALL SDAJST 
     &         ('$ASMBL',NVASMB,LGASMB,LGETRA,INCTRA,NBTRAV+1,5)        !sdexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         ELSE
            CALL PRNTRM (NOMTRA,NIVTRA,THETRM,NCATRM)                   !utilite
            NMWORK=YKLINT (ITYCAL)                                      !utilite
            CALL WARNNG ( ' Le terme '//THETRM(1:NCATRM)
     &                  //', prealablement de type '//NMWORK
     &                  //', est transforme en un terme d''assemblage.')!utilite
         ENDIF
      ELSE
         NIVIMT=0
*        Le terme resultat de l'assemblage n'existe pas: on l'ajoute  
*        apres agrandissement eventuel des structures #OMTRM et $SDTRM 
         CALL ALFANU (NBCHNT,NOMTRA(:NCATRA))                           !utilite
         NWHTRM=MAX (NCHTRM,NCATRA)
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,5)              !sdexplo 
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,5)         !sdexplo
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NOMTRA(:NCATRA))        !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERA=NBTERM
*        Creation de la structure $ASMBL de niveau NVASMB pour 6 termes
         LGASMB=LGETRA+6
         NVASMB=KLNIVE ()                                               !sdexplo
         CALL TBCREE ('$ASMBL',NVASMB,1,LGASMB,'c')
      ENDIF
*
      NUASSE=0
2     IF (IRE.EQ.3) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10003) '*LcAsse*',TEXTE(1:NCAR)
         IF (TEXTE(1:10).EQ.'IMPRESSION'.OR.TEXTE(1:5).EQ.'PRINT') THEN
*
*           Niveau d'impression du terme resultat de l'assemblage
*
            NIVIMT=1
            CALL REDLE
            IF (IRE.EQ.3) CALL REDLE
            IF (IRE.EQ.1) THEN
               NIVIMT=NFIX
               CALL REDLE
            ENDIF
         ELSEIF (TEXTE(1:10).EQ.'SYMETRIQUE'
     &       .OR.TEXTE(1:14).EQ.'ANTISYMETRIQUE'
     &       .OR.TEXTE(1:11).EQ.'AUTOADJOINT'
     &       .OR.TEXTE(1:11).EQ.'ANTIADJOINT') THEN
*
*           Type de symetrie du terme
*
            ITYSYM=INDSYM (TEXTE(1:NCAR))
            CALL REDLE
         ELSEIF (TEXTE(1:6).EQ.'DONNEE'.OR.TEXTE(1:4).EQ.'DATA') THEN
*
*           Donnee affectee au terme
*
            CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
            CALL LCDONT (AST(MCMDON),IST(MCDONN),LUDONX,NMDONN,NCDONN
     &                  ,ITYDON,NIVDON,ITYPDO,LUDONN,NIVIMP,IMPMES)     !lecdire
*           Seule une donnee CONSTANTE peut etre affectee a un terme
*           d'assemblage
            IF (ITYDON.NE.INTDON ('CONSTANTE')) CALL ERDONN (19,NMDONN) !utilite
         ELSE
*           Mot-cle definissant un assemblage particulier
            IF (NUASSE.LE.0) NUASSE=INDASS (TEXTE(1:NCAR))              !utilite
            CALL REDLE
         ENDIF
         GOTO 2
      ENDIF
*
      IF (NUASSE.LE.0) NUASSE=INDASS (' ')                              !utilite
*
*     Prochain terme de la structure
*
3     IF (IRE.NE.4) GOTO 99998
      NCATRM=NCAR
      NOMTRM=TEXTE(1:NCAR)
      IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &   WRITE (IMPMES,10004) '*LcAsse*',NCAR,TEXTE(1:NCAR)
      NIVTRM=1
*     Lecture eventuelle de son niveau
      CALL REDLE
      IF (IRE.EQ.3.AND.(TEXTE(1:6).EQ.'NIVEAU'
     &              .OR.TEXTE(1:5).EQ.'LEVEL')) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE(IMPMES,10003) '*LcAsse*',TEXTE(1:NCAR) 
         CALL REDLE
      ENDIF
      IF (IRE.EQ.1) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10001) '*LcAsse*',NFIX
         NIVTRM=NFIX
         CALL REDLE
      ENDIF
*  
*     Terme a ajouter a la structure $ASMBL  
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
*  
*        Le terme n'existe pas: on l'ajoute apres agrandissement eventuel  
*        des structures #OMTRM et $SDTRM
         CALL ALFANU (NBCHNT,NOMTRM(:NCATRM))                           !utilite
         NWHTRM=MAX (NCHTRM,NCATRM)
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,5)              !sdexplo
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,5)         !sdexplo
         CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                      ,'$WORK$',0,MCWORK)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NOMTRM(:NCATRM))        !utilite
         NUTERM=NBTERM 
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVTRM        
     &               ,INTREL,NDFCAL,NDFNDF,NDFDON,NDFSYM,NDFDSM
     &               ,NDFINC,NDFDUM,NDFNDF,NDFNUM,NDFINC,NDFDUM,NDFNDF
     &               ,NDFNUM,0,NDFSTO,NDFCOR,0,0)                       !sdexplo
      ELSE
         CALL TBAR1  (ERCODE,'$WORK$',0,MCWORK)                         !utilite
*        Un terme ne peut apparaitre qu'un fois dans la structure
         DO 5 I=1,NBTRAC
            IF (NUTERM.EQ.IST(MCWORK-1+I)) THEN
            CALL WATERM (1,NOMTRM,NIVTRM)
            GOTO 3
         ENDIF
5        CONTINUE
      ENDIF
*
*     Introduction du nouveau terme dans le tableau des numeros de termes
*
      NBTRAC=NBTRAC+1
      IF (NBTRAC.GT.LGWORK) GOTO 90001
      IST(MCWORK-1+NBTRAC)=NUTERM
      GOTO 3
*
*     Prise en compte d'un eventuelle donnee affectee
*
99998 IF (LUDONN.GT.0) THEN
*
*        On a trouve une donnee affectee au terme
*
         CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
         CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
         NUDONN=KELCHN (NMDONN(1:NCDONN),AST(MCMDON),NBDONN,NCHDON)     !utilite
         IF (NUDONN.LE.0) THEN
*
*           Si la donnee n'existe pas, on l'introduit dans les structures
*           de description des donnees (#OMDON et $DONNE)
*
*           Type et numero de la nouvelle constante
*
            ITYDON=MAX (ITYDON,0)
            NIVDON=KLCSTE (TYPINT (ITYPDO))                             !sdexplo
*
*           Ajustement eventuel de la taille de #OMDON et $DONNE
*
            IF (LGDONN.LT.LGEDON+INCDON*(NBDONN+1)) THEN
               CALL SDAJST ('$DONNE',1,LGDONN,LGEDON,INCDON,NBDONN,5)   !sdexplo
            ENDIF
            IF (LGMDON.LT.(NBDONN+1)*MAX (NCHDON,NCDONN)) THEN
               CALL TBAJST ('#OMDON',1,(NBDONN+5)*MAX (NCHDON,NCDONN))
            ENDIF
*
*           Introduction de la donnee nouvelle dans les structures
*
            CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
            CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN(1:NCDONN))    !utilite
            CALL SDMKDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)       !utilite
            NUDONN=NBDONN
            CALL SDMKCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)       !utilite
         ENDIF
      ENDIF
*
*     Caracteristiques du terme resultat de l'assemblage
*
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVTRA
     &            ,INTREL,ITYASS,NUASSE,NUDONN,ITYSYM,NVASMB
     &            ,NDFINC,NDFDUM,NDFNDF,NDFNUM,NDFINC,NDFDUM,NDFNDF
     &            ,NDFNUM,0,NDFSTO,NDFCOR,0,NIVIMT)                     !sdexplo
*  
**    Mise a jour de la structure d'assemblage
*
      CALL TBAJST ('$ASMBL',NVASMB,LGETRA+NBTRAV+NBTRAC)
      CALL TBAR3  (ERCODE,'$ASMBL',NVASMB,MCASMB,'$SDTRM',1,MCDTRM
     &                   ,'$WORK$',0     ,MCWORK)
      NBTRAX=NBTRAV 
      DO 11 I=1,NBTRAC
*        Un terme ne peut apparaitre qu'une seule fois dans la structure 
         NUTERM=IST(MCWORK-1+I)
         DO 10 J=LGETRA,LGETRA-1+NBTRAV
            IF (NUTERM.EQ.IST(MCASMB+J)) GOTO 11
10       CONTINUE
         IST(MCASMB+LGETRA+NBTRAX)=NUTERM
         NBTRAX=NBTRAX+1
11    CONTINUE
*     Entete et ajustement de la taille de la structure
      CALL SDMKDB (IST(MCASMB),LGETRA,NBTRAX,INCTRA,NUASSE)             !utilite
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.1) THEN
         CALL PRSDAS (NVASMB,NUTERA,NIVIMP,IMPSDR)                      !prsd
         WRITE (IMPSDR,10010) PRFXAS(1),'*LcAsse*'
      ENDIF
      CALL TBSAVE ('$ASMBL',NVASMB)
      CALL PRFXMJ (-1,'*LcAsse*') 
      RETURN 
* ---------------------------------------------------------------------- 
10000 FORMAT(T6,A8,' Lecture de la Sous-Directive : ',A)
10001 FORMAT(T6,A8,T56,' , suivi du nombre :',I9)
10003 FORMAT(T6,A8,T56,' , suivi du mot    :',A)
10004 FORMAT(T6,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
10010 FORMAT(' ',69('*'),'  ',A8,'>',A8,'  ',6('*'))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL ENCLER (NBTRAC,NMWORK)                                       !utilite
      CALL BAISE  (' Longueur du tableau de travail ($WORK$,0) depassee 
     &lors de la creation de la structure d''assemblage du terme '
     &//NOMTRA//' (voir LCDIRE/Lecdire)')                               !utilite
                                                                    END !LcAsse
