*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCDIRE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1988)
* Derniere modification : D.Martin (12 decembre 2002)
* Version 1.0.6
*  
* Sous-programme principal de LeCture des DIREctives de definition 
*   - des inconnues ( INCONNUE )
*   - du degre des formules de quadrature sur tous les domaines ( QUADRATURE )
*   - des domaines de calcul et de leurs termes      ( CALCUL SUR LE DOMAINE )
*   - des 'calculs spectraux'                              ( CALCUL SPECTRAL )
*   - des 'autres calculs'                     (CALCUL AUTRE ou AUTRE CALCUL )
*   - des symetries ou antisymetrie du probleme   ( SYMETRIE ou ANTISYMETRIE )
*   - des structures d'assemblage                               ( ASSEMBLAGE )
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*  
      CHARACTER        TEXTE*80,ERCODE*120,COMBAK
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,LECOLD,INUSE1,INUSE2
     &                ,NIVIMP,LECNEW,NBDOMK,NUDOMG,LGDIRE
     &                ,MCTRDO,LGERDO,LGCANO,NCHDOM,MCMDOM,NBINCO
     &                ,LGINCO,LGEINC,INCINC,NCHINC,LGMINC,MCMINC,MCINCO
     &                ,ISYM,MCVARE,NVASMB,NUSCHQ
      INTEGER          KELCHN
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/REDLST/   LECOLD,INUSE1,INUSE2
      COMMON/FORMAH/   ERCODE  
      EQUIVALENCE     (ERCODE(117:117),COMBAK)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcDire*')
      NIVIMP=0 
      LECNEW=LECOLD
*
*     Valeur par defaut du numero de schema de quadrature
*     pour tous les domaines :
*     Variable QUADEF du COMMON/GLOBAL/ du fichier CONTEX
      QUADEF=5
*
      CALL REDINI (LECNEW,0)
*  
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,LGCANO,NCHDOM)             !utilite
*  
*     Creation du tableau $DIREC recepteur de la liste des directives  
*     et du tableau de reception des numerotations locales (cf. LckDom)
      LGDIRE=200
      CALL TBCREE ('$DIREC',0,11,LGDIRE+5,'c')
      CALL TBCREE ('$WORK$',0,1,100,'c')
*  
      CALL REDLE
*
1     IF (IRE.NE.3) CALL REDERR (13,TEXTE(1:NCAR))
5     IF (NIVIMP.GT.1) WRITE (IMPMES,10009)
      IF (NIVIMP.GT.0) WRITE (IMPMES,10009) '*LcDire*',TEXTE(1:NCAR)
*
      IF (TEXTE(1:NCAR).EQ.'IMPRESSION'.OR.TEXTE(1:5).EQ.'PRINT') THEN
*
*--      Lecture du niveau d'impression d'interpretation des directives
*
         NIVIMP=1
         CALL REDLE
         IF (IRE.EQ.3.AND.(TEXTE(1:6).EQ.'NIVEAU'
     &                 .OR.TEXTE(1:5).EQ.'LEVEL')) CALL REDLE
         IF (IRE.EQ.1) THEN
            NIVIMP=NFIX
            CALL REDLE
         ENDIF
         IF (IMPMES.LE.0) NIVIMP=0
         IF (IRE.NE.3) CALL REDERR (13,TEXTE(1:NCAR))
         GOTO 5
*
      ELSEIF (TEXTE(1:8).EQ.'INCONNUE'
     &    .OR.TEXTE(1:7).EQ.'UNKNOWN') THEN
*  
*--      On a lu ' INCONNUE ' ou ' UNKNOWN '
*  
         COMBAK=' '
*        Agrandissement preventif de #NCONU pour 2 nouvelles inconnues
11       CALL TBRR1  (ERCODE,'#NCONU',1,LGINCO)
         CALL TBAR1  (ERCODE,'#NCONU',1,MCINCO)
         CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)          !utilite
         CALL SDAJST ('#NCONU',1,LGINCO,LGEINC,INCINC,NBINCO,2)         !sdexplo
         CALL TBRR1  (ERCODE,'#OMINC',1,LGMINC)
12       CALL TBAR2  (ERCODE,'#NCONU',1,MCINCO,'#OMINC',1,MCMINC)
         CALL LCINCO (AST(MCMINC),LGMINC,IST(MCINCO),LGINCO,INTRPG,NDIM
     &               ,NBTPTG,NIVIMP,IMPSDR,IMPMES,*11)                  !lecdire
*        Le tableau #OMINC est trop petit pour prendre en compte
*        une inconnue supplementaire : on l'agrandit ...
         IF (COMBAK.EQ.'I') THEN
            CALL TBAJST ('#OMINC',1,LGMINC)
            GOTO 12
         ENDIF
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'QUADRATURE') THEN
*
*--      On a lu ' QUADRATURE '
*
         CALL LCQUAD (NUSCHQ,NIVIMP,IMPMES)                             !lecdire
         QUADEF=NUSCHQ
         CALL REDLE
         GOTO 1
*
      ELSEIF (TEXTE(1:6).EQ.'CALCUL'
     &    .OR.TEXTE(1:6).EQ.'COMPUT') THEN
*  
*--      On a lu ' CALCUL '
*  
         CALL REDLE
         IF (IRE.EQ.3) THEN
            IF (TEXTE(1:6).EQ.'DOMAIN') THEN
*  
*--            On a lu ' CALCUL SUR LE DOMAINE'
*  
               IF (NIVIMP.GT.1)
     &            WRITE (IMPMES,10000) '*LcDire*',TEXTE(1:NCAR)
               CALL REDLE
               IF (IRE.NE.4) CALL REDERR(14,' ')
               IF (NIVIMP.GT.0)
     &            WRITE (IMPMES,10004) '*LcDire*',NCAR,TEXTE(1:NCAR)
               CALL TBAR1  (ERCODE,'#OMDOM',1,MCMDOM)
               NUDOMG=KELCHN (TEXTE(1:NCAR),AST(MCMDOM),NBDOMG,NCHDOM)  !utilite
               IF (NUDOMG.LE.0) THEN
                  CALL WARNNG (' Le domaine '//TEXTE(1:NCAR)
     &            //' n''est pas defini dans le fichier de maillage.'
     &            //' Toutes les sous-directives de la directive '
     &            //' CALCUL SUR LE DOMAINE associees sont ignorees.'
     &            //' Fote de frape dan vos directives ?')              !utilite
*                 On poursuit la lecture du fichier de directives jusqu'a
*                 la lecture de la prochaine directive principale
50                CALL REDLE
                  IF (IRE.NE.3) GOTO 50
                  IF (TEXTE(1:NCAR).EQ.'ANTISYMETRIE'
     &            .OR.TEXTE(1:NCAR).EQ.'SKEWSYMMETRY'
     &            .OR.TEXTE(1:NCAR).EQ.'ASSEMBLAGE'
     &            .OR.TEXTE(1:NCAR).EQ.'ASSEMBLY'
     &            .OR.TEXTE(1:NCAR).EQ.'AUTRE'
     &            .OR.TEXTE(1:NCAR).EQ.'OTHER'
     &            .OR.TEXTE(1:6).EQ.'CALCUL'
     &            .OR.TEXTE(1:6).EQ.'COMPUT'
     &            .OR.TEXTE(1:NCAR).EQ.'FIN'
     &            .OR.TEXTE(1:NCAR).EQ.'END'
     &            .OR.TEXTE(1:NCAR).EQ.'SYMETRIE'
     &            .OR.TEXTE(1:NCAR).EQ.'SYMMETRY') GOTO 1
                  GOTO 50
               ENDIF
               CALL LCKDOM (NUDOMG,NIVIMP)                              !lecdire
*
            ELSE IF (TEXTE(1:8).EQ.'SPECTRAL') THEN
*  
*--            On a lu ' CALCUL SPECTRAL'
*
               IF (NIVIMP.GT.1)
     &            WRITE (IMPMES,10000) '*LcDire*',TEXTE(1:NCAR) 
               CALL LCKSPE (NIVIMP)                                     !lecdire
*
            ELSE IF (TEXTE(1:5).EQ.'AUTRE') THEN
*  
*--            On a lu ' CALCUL AUTRE'
*
               IF (NIVIMP.GT.1)
     &            WRITE (IMPMES,10000) '*LcDire*',TEXTE(1:NCAR) 
               CALL LCAUTR (NIVIMP)                                     !lecdire
            ENDIF
         ENDIF
         GOTO 1
*
      ELSEIF (TEXTE(1:5).EQ.'AUTRE'
     &     .OR.TEXTE(1:5).EQ.'OTHER') THEN
*
*--      On a lu ' AUTRE CALCUL '
*
         CALL LCAUTR (NIVIMP)                                           !lecdire
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'SYMETRIE'
     &     .OR.TEXTE(1:NCAR).EQ.'SYMMETRY') THEN
*  
*--      On a lu ' SYMETRIE '
*  
         CALL TBAR1  (ERCODE,'#ARIAB',1,MCVARE)
         ISYM=2
         CALL LCSYME (ISYM,NDIM,AST(MCVARE),NBCNVE,ISYMGR,NIVIMP,IMPMES)!lecdire
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'ANTISYMETRIE'
     &    .OR.TEXTE(1:NCAR).EQ.'SKEWSYMMETRY') THEN
*
*--      On a lu ' ANTISYMETRIE '
*
         CALL TBAR1  (ERCODE,'#ARIAB',1,MCVARE)
         ISYM=1
         CALL LCSYME (ISYM,NDIM,AST(MCVARE),NBCNVE,ISYMGR,NIVIMP,IMPMES)!lecdire
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'ASSEMBLAGE'
     &    .OR.TEXTE(1:NCAR).EQ.'ASSEMBLY') THEN
*  
*--      On a lu ' ASSEMBLAGE '
*  
         CALL LCASSE (NIVIMP,NVASMB)                                    !lecdire
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'FIN'
     &    .OR.TEXTE(1:NCAR).EQ.'END') THEN
*  
*--      On a lu ' FIN '
*
         CALL TBTUER ('$DIREC',0)
         CALL TBTUER ('$WORK$',0)
         CALL TBAR1  (ERCODE,'#NCONU',1,MCINCO)
*        Longueur exacte de #NCONU pour ajustement du tableau
         CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)          !utilite
         IF (NBINCO.EQ.0)
     &     CALL BAISE  ('Vous avez oublie la directive INCONNUE')       !utilite
         CALL TBAJST ('#NCONU',1,LGEINC+NBINCO*INCINC)
*        Longueur exacte de #OMINC pour ajustement du tableau
         CALL TBAJST ('#OMINC',1,NBINCO*NCHINC)
*
      ELSE
         CALL REDERR (2,TEXTE(1:NCAR))
*
      ENDIF
*  
*     Impressions des structures de donnees
      IF (NIVIMP.GT.1.AND.IMPSDR.GT.0) THEN 
         CALL PRGLOB (IMPSDR)                                           !prsd
         CALL PRINCO (IMPSDR)                                           !prsd
         CALL PRDONN (IMPSDR)                                           !prsd
         WRITE(IMPSDR,10008) '*LcDire*'
      ENDIF
      CALL PRFXMJ (-1,'*LcDire*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(T2,A8,'-->Lecture de la sous-directive : ',A)
10001 FORMAT(T6,A8,T56,' , suivi de nombre : ',I12)
10002 FORMAT(T6,A8,T56,' , suivi de nombre : ',E12.4)
10003 FORMAT(T6,A8,T56,' , suivi du mot : ',A)
10004 FORMAT(T2,A8,T56,' , suivi de la chaine (*',I2,') : ',A) 
10008 FORMAT(/T2,A8,'  ',6('-'),' Fin de lecture des directives sur les
     &inconnues et les calculs sur les domaines ',('-'),/)
10009 FORMAT(T2,A8,'->Debut de la directive : ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !LcDire
