*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCDONT (NOMDON,DONNEE,LUDONX,NMDONN,NCDONN,ITYDON
     &                  ,NIVDON,ITYPDO,LUDONN,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1989) 
* Derniere modification : D.Martin (8 Mars 2001)
* Version 1.0.2
*  
* LeCture du nom et des caracteristiques d'une DONnee associee a  un Terme 
* 'Elements finis' ou une condition essentielle  
*  
*-- Arguments d'entree --
*NOMDON tableau des noms des donnees (#OMDON)
*DONNEE tableau des caracteristiques des donnees ($DONNE)
*LUDONX nombre maximum de donnees attendues
*NIVIMP niveau d'impression
*IMPMES unite d'impression des messages
*-- Arguments de sortie --
*NMDONN(1) nom de la donnee affectee au terme
*NCDONN(1) nombre de caracteres du nom de la donnee
*ITYDON(1) type de la donnee affectee au terme (CONSTANTE,FONCTION,...)
*NIVDON(1) niveau de la donnee affectee au terme
*ITYPDO(1) type de declaration de la donnee affectee au terme
*LUDONN    nombre de donnees lues
*-- Sous-directives de la sous-directive Donnee
*  Donnee [de] [NOM ] &C
*    < CONSTANTE [ < ENTIERE / REELLE / COMPLEXE > ]
*    / FONCTION  [ < REELLE / COMPLEXE > ]
*       [ Donnee ASSOCIEE DE NOM &C
*           < CONSTANTE / TABLEAU [ [DE] [ NIVEAU ] &I ] > ]
*              [ < ENTIERE / REELLE / COMPLEXE> ]
*    / TABLEAU [ [DE] [ NIVEAU ] &I ]
*       [ < ENTIERE / REELLE / COMPLEXE  / CARACTERE *I > ]
*    >
*  
*-DONNEE   Tableau de description des donnees
* ++++++
*-DONNEE( 1)= LGEDON Longueur de l'entete
*-DONNEE( 2)= NBDONN Nombre de numeros de donnees affectes
*-DONNEE( 3)= INCDON Increment de parcours du tableau
*-DONNEE( 4)= NCHDON Nombre de caracteres par nom de donnee  
*  
*             Boucle IDON = 1 a NBDONN 
*-DONNEE(LGEDON+INCDON*(IDON-1)+1)= ITYDON type de la donnee
*                       (CONSTANTE,FONCTION,TABLEAU)
*-DONNEE(LGEDON+INCDON*(IDON-1)+2)= NIVDON declaration et niveau de la donnee  
*                       = numero pour une donnee CONSTANTE 
*                       = niveau du tableau pour une donnee TABLEAU
*                       = numero de la donnee associes pour une FONCTION
*-DONNEE(LGEDON+INCDON*(IDON-1)+3)= ITYPDO type du resultat de la donnee
*                       (ENTIER, REEL, DOUBLE ,COMPLEXE ,CARACTERE)
*  
*-Remarque: pour une donnee de type TABLEAU ou un tableau associe a une
*           FONCTION, le nom du tableau est celui de la donnee.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          DONNEE(*),LUDONX,LUDONN,NCDONN(LUDONX)
     &                ,ITYDON(LUDONX),NIVDON(LUDONX),ITYPDO(LUDONX)
     &                ,NIVIMP,IMPMES
      CHARACTER        NOMDON(*)
      CHARACTER*(*)    NMDONN(LUDONX)
*    
      CHARACTER        DONINT*10,TYPINT*9
      CHARACTER        TEXTE*80,LUTYDO,LUCARA
      INTEGER          KELCHN,INTDON
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,LGEDON,NBDONN,INCDON
     &                ,NCHDON,NUDONN,ITYDOV,NIVDOV,ITYPDV
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Lcdont*')
*  
      LUTYDO='N'
      LUDONN=LUDONN+1
      CALL SDEXDB (DONNEE,LGEDON,NBDONN,INCDON,NCHDON)                  !utilite
*  
1     CALL REDLE
      IF (IRE.EQ.4) THEN
*
*        Lecture du nom de la donnee
*
         IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &       WRITE (IMPMES,10004) '*Lcdont*',NCAR,TEXTE(1:NCAR)
         IF (LUDONN.GT.LUDONX) GOTO 99990
*
         NMDONN(LUDONN)=TEXTE(1:NCAR)  
         NCDONN(LUDONN)=NCAR
         NUDONN        =0  
         IF (NBDONN.NE.0)
     &      NUDONN=KELCHN (TEXTE(1:NCAR),NOMDON,NBDONN,NCHDON)          !utilite
         IF (NUDONN.GT.0..AND.LUTYDO.EQ.'N') THEN
*
*           Caracteristiques de la donnee deja definie
*
            CALL SDEXCO (NUDONN,DONNEE,ITYDOV,NIVDOV,ITYPDV)            !utilite
            ITYDON(LUDONN)=ITYDOV
            NIVDON(LUDONN)=NIVDOV
            ITYPDO(LUDONN)=ITYPDV
            LUTYDO='Y'
            GOTO 1
         ENDIF
      ELSEIF (IRE.EQ.3) THEN
         IF (TEXTE(1:6).EQ.'ASSOCI'.OR.TEXTE(1:NCAR).EQ.'DATA') THEN
            IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &         WRITE (IMPMES,10003) '*Lcdont*',TEXTE(1:NCAR)  
            GOTO 1
         ENDIF
         IF (TEXTE(1:3).EQ.'NOM') GOTO 1
*
*        Lecture et actualisation des caracteristiques de la donnee
*
         CALL LCCADO (ITYDON(LUDONN),NIVDON(LUDONN),ITYPDO(LUDONN)
     &               ,LUCARA,NIVIMP,IMPMES)                             !lecdire
         IF (LUTYDO.EQ.'Y'.AND.LUCARA.EQ.'Y') THEN
            IF (ITYDON(LUDONN).NE.ITYDOV) GOTO 99991
            IF (ITYPDO(LUDONN).NE.ITYPDV) GOTO 99992
            IF (ITYPDV.EQ.INTDON ('TABLEAU')
     &     .AND.NIVDON(LUDONN).NE.NIVDOV)
     &         CALL ERDONN (18,NMDONN(LUDONN))
         ENDIF
         LUTYDO='Y'
      ENDIF
      IF (ITYDON(LUDONN).LT.0.OR.NCDONN(LUDONN).LE.0) GOTO 1
*  
      CALL PRFXMJ (-1,'*Lcdont*')
      RETURN
*----------------------------------------------------------------------- 
10003 FORMAT(T12,A8,T56,' , suivi du mot : ',A)
10004 FORMAT(T12,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL BAISE ('Dans ce contexte (lecture du nom de la donnee '
     &//TEXTE(1:NCAR)//'), on ne lire qu''une donnee.')
99991 TEXTE=NMDONN(LUDONN)
      CALL BAISE ('La redefinition du type de representation ('
     &//DONINT(ITYDOV)//') de la donnee '
     &//TEXTE(1:NCDONN(LUDONN))//' est interdite.')
99992 TEXTE=NMDONN(LUDONN)
      CALL BAISE ('La redefinition du type de declaration ('
     &//TYPINT(ITYPDV)//') de la donnee '
     &//TEXTE(1:NCDONN(LUDONN))//' est interdite.')
                                                                    END !Lcdont
