*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCESSE (NOMINC,INCONU,NDIM,NUINCO,NUESSE,NVALNE
     &                  ,IRPLOC,ICORNE,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Fevrier 1989) 
* Derniere modification : D.Martin (23 Fevrier 1999)
* Version # 1.0.0
*  
* LeCture du type de la condition ESSEntielle de Dirichlet 
* et de l'inconnue sur laquelle elle porte.  
*  
*-- Arguments d'entree -- 
* NOMINC tableau des noms d'inconnues 
* INCONU tableau des caracteristiques des inconnues
* NDIM   dimension d'espace
* NIVIMP niveau d'impression des directives
* IMPMES unite de sortie des messages 
*-- Arguments de sortie --
* NUINCO numero d'inconnue sur laquelle porte la condition
* NUESSE numero de type de condition essentielle
* NVALNE nombre de valeurs par noeud du terme de condition essentielle
* IRPLOC indice de calcul de repere local eventuellement modifie
* ICORNE indice de calcul des coordonnees des noeuds
*-- Syntaxe --
* La CONDITION ESSENTIELLE de Dirichlet est donnee par une chaine de caractere
* contenation du nom d'une inconnue et d'une des chaine '=G', '.N=G', '^N=G';
* par exemple 
*                    'PHI=G', 'U.N=G', 'Vitesse^N=G'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    NOMINC(*)
      INTEGER          INCONU(*),NDIM,NUINCO,NUESSE,NVALNE,IRPLOC,ICORNE
     &                ,NIVIMP,IMPMES
*
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
     &                ,LGEINC,NBINCO,INCINC,NCHINC,NUEGAL,NCPINC,NBTL
     &                ,INTINL,NNUEGA,LGNMIN
      INTEGER          INCESS,KELCHN
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80 
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Lcesse*')
*  
      CALL SDEXDB (INCONU,LGEINC,NBINCO,INCINC,NCHINC)                  !utilite
*  
      IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &   WRITE(IMPMES,10004) '*Lcesse*',TEXTE(1:NCAR)
*
*     Type de la condition essentielle
*
*     Recherche du signe '=' dans la chaine
      NUEGAL=INDEX (TEXTE(1:NCAR),'=')
      IF (NUEGAL.LE.0) CALL REDERR (1,'=')
      NNUEGA=INDEX (TEXTE(NUEGAL+1:NCAR),'=')
*     Pas de caractere '=' dans un nom d'inconnue pour une cond. essentielle
      IF (NNUEGA.GT.0) CALL ERINCO (6,TEXTE(1:NCAR))
*
      NUESSE=INCESS (TEXTE(MAX(1,NUEGAL-2):NUEGAL-1))                   !utilite
*
*     Longueur du nom de l'inconnue : LGNMIN
      LGNMIN=NUEGAL
      IF (NUESSE.LE.1) THEN
         LGNMIN=LGNMIN-1
      ELSEIF (NUESSE.LE.3) THEN
         IRPLOC=1  
         LGNMIN=LGNMIN-3 
      ENDIF
*
*     Numero de l'inconnue
*
      NUINCO=KELCHN (TEXTE(1:LGNMIN),NOMINC,NBINCO,NCHINC)              !utilite
      IF (NUINCO.LE.0) CALL ERINCO (1,TEXTE(1:LGNMIN))                  !utilite
      CALL SDEXCO (NUINCO,INCONU,NCPINC,INTINL,NBTL)                    !utilite
      IF (NCPINC.LE.1.AND.NUESSE.GT.1) CALL ERINCO (3,TEXTE(1:LGNMIN))  !utilite
*
*     Nombre de composantes par noeuds de la donnee de la condition essentielle
*
      CALL CESSAT (NUESSE,NDIM,NCPINC,NVALNE)                           !utilite
*
      CALL REDLE
      CALL PRFXMJ (-1,'*Lcesse*')
*-----------------------------------------------------------------------
10004 FORMAT(T12,A8,T56,' , suivi de la chaine : ',A) 
                                                                    END !Lcesse
