*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCINCT (TYPCAL,NOMINC,INCONU
     &                  ,NUINCC,NUINCL,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin & O.DeBayser (Fevrier 1989) 
* Derniere modification : D.Martin (12 decembre 2002)
* Version 1.0.2
*  
* LeCture des INConnues en colonne et en ligne pour un Terme
* ou lecture de l'inconnue pour une condition essentielle  
*  
*-- Arguments d'entree -- 
* TYPCAL type de calcul du terme
* NOMINC tableau des noms d'inconnues 
* INCONU tableau des caracteristiques des inconnues
* NIVIMP niveau d'impression  
* IMPMES unite d'impression des messages  
*-- Arguments de sortie --
* NUINCC numero de l'inconnue en colonne  
* NUINCL numero de l'inconnue em ligne
*
*-- Mots_cles de la sous-directive Inconnue
* Inconnue [de Nom] &C [en <LIGNE/COLONNE>]
*
* Cette directive utilise les tableaux :  
* --------------------------------------
* NOMINC Tableau des noms d'inconnues sur NCHINC caracteres
* ++++++
* INCONU Tableau de description des inconnues 
* ++++++
*    entete de longueur 4
* INCONU(1)= LGEINC longueur de l'entete de INCONU (4)
* INCONU(2)= NBINCO nombre d'inconnues
* INCONU(3)= INCINC increment de parcour du tableau INCONU
* INCONU(4)= NCHINC nombre de caracteres par nom d'inconnue
*    boucle IINC = 1 a NBINCO
* ADINCO=LGEINC+INCINC*(IINC-1)+1
* INCONU(ADINCO  )= NCPINC nombre de composantes de l'inconnue
* INCONU(ADINCO+1)= INTINC type d'interpolation pour une inc. Valeurs Nodales
*                          -1 pour une inc. Spectrale ou Supplementaire
* INCONU(ADINCO+2)= NBTNEU nb de noeuds pour une inc. Valeurs Nodales
*                 = NBFDEV+1000000*NBTFON pour une inc. Spectrale
*                   pour un terme Elements finis localises ('ELFLOC') calcule
*                   par integration exacte, ou
*                   NBFDEV est le nombre de fonctions spectrales
*                   NBTFON est le nombre de termes dans le developpement
*                   en exponentielles des fonction spectrales
*                 = NBFDEV nombre de fonctions propres pour une inc. Spectrale
*                   pour un terme Elements finis localises ('ELFLQU') calcule
*                   par integration numerique
*                 = nombre de composantes pour une inc. Supplementaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*)    TYPCAL,NOMINC(*)
      INTEGER          INCONU(*),NUINCC,NUINCL,NIVIMP,IMPMES
*
      LOGICAL          ONLYON
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80
      INTEGER          KELCHN
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,NUINC
     &                ,LGEINC,NBINCO,INCINC,NCHINC,NCPINC,INTINC,NBTNEU
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcIncT*')
*
      ONLYON=TYPCAL.EQ.'NONDEF'.OR.TYPCAL.EQ.'SPECTR'
      CALL SDEXDB (INCONU,LGEINC,NBINCO,INCINC,NCHINC)                  !utilite
1     CALL REDLE
      IF (TEXTE(1:NCAR).EQ.'NOM'.OR.TEXTE(1:4).EQ.'NAME') GOTO 1
      IF (IRE.NE.4) CALL REDERR (14,' ')
*
*     On a lu une chaine de caractere (un nom d'inconnue ?)
*
      IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &   WRITE (IMPMES,10004) '*LcInct*',NCAR,TEXTE(1:NCAR)
      NUINC=KELCHN (TEXTE(1:NCAR),NOMINC,NBINCO,NCHINC)                 !utilite
      IF (NUINC.LE.0) CALL REDERR (2,TEXTE(1:NCAR))
*
      CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
*
      IF (TEXTE(1:NCAR).EQ.'LIGNE'.OR.TEXTE(1:NCAR).EQ.'ROW') THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.3)
     &      WRITE (IMPMES,10003) '*LcInct*',TEXTE(1:NCAR) 
         NUINCL=NUINC  
         CALL REDLE
      ELSEIF (TEXTE(1:NCAR).EQ.'COLONNE'.OR.TEXTE(1:NCAR).EQ.'COLUMN')
     & THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.3) 
     &      WRITE(IMPMES,10003) '*LcInct*',TEXTE(1:NCAR) 
         NUINCC=NUINC  
         IF (NUINCL.LE.0.AND..NOT.(ONLYON)) NUINCL=NUINCC 
         CALL REDLE
      ELSE
         IF (ONLYON) THEN
            CALL REDERR (1,'LIGNE ou COLONNE')
         ELSE
            NUINCL=NUINC  
            NUINCC=NUINC 
         ENDIF 
      ENDIF
*
      CALL PRFXMJ (-1,'*LcIncT*')  
*-----------------------------------------------------------------------
10003 FORMAT(T12,A8,T56,' , suivi du mot : ',A)
10004 FORMAT(T12,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
                                                                    END !LcIncT
