*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCINTE (NUINCO,NOMINC,NCHINC,INTINC
     &                  ,NIVIMP,IMPSDR,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996)
* Derniere modification : D.Martin (8 juin 2004)
* Version 1.1
*
* LeCture du type d'INTErpolation d'une inconnue 
*
*-- Arguments d'entree --
* NUINCO numero de l'inconnue dont on a lu le nom
* NOMINC tableau des noms d'inconnues
* NCHINC nombre de caracteres par nom d'inconnue
* INTINC code numerique definissant l'interpolation
* NIVIMP undice d'impression secondaire
* IMPSDR unite d'impression secondaire
* IMPMES unite d'impression des messages
*
*-- Mots-cles de la sous directive INTERPOLATION --
* INTERPOLATION
*  < ISOPARAMETRIQUE
*  / < DE TYPE  / D''ORDRE > ||I
*    / DE LAGRANGE [ AUX ABSCISSES < EQUIDISTANTES / DE GAUSS-LOBATTO > ] 
*        < <P0 / Q0>
*        / <P1 [NON CONFORME] / Q1>
*        / <P2 / Q2 [SERENDIPITY]>
*        / <P3 / Q3> 
*        / <P3+bulleP3>                                                 !08/2004
*        / <Q4 / Q5 / Q6 ... Q20 / Q24 / Q32 / Q40 >                    !07/2005
*     >
*  / ELEMENTS D'ARETE [ ET CONDENSATION DE MASSE ]
*    < P0/Q0 / P1/Q1 / P2/Q2 >
*  / DE HERMITE [ P3 ]
*  >
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NUINCO,NCHINC,INTINC,NIVIMP,IMPSDR,IMPMES
      CHARACTER        NOMINC(*)
*
      CHARACTER        TEXTE*80,LUWHAT
      DOUBLE PRECISION FLOT
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,INTINP,INTKIP,I
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      INTEGER LAGDMX
      PARAMETER (LAGDMX = 100 )
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcInte*')
*
      INTKIP=INTINC
      INTINC=0
      LUWHAT=' '
10    CALL REDLE
*
      IF (IRE.EQ.3) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10003) '*LcInte*',TEXTE(1:NCAR)
         IF (TEXTE(1:12).EQ.'ISOPARAMETRI') THEN
            INTINC=INTKIP
            CALL REDLE
         ELSEIF (TEXTE(1:8).EQ.'LAGRANGE') THEN
            GOTO 10
         ELSEIF (TEXTE(1:7).EQ.'HERMITE') THEN
            LUWHAT=TEXTE(1:1)
            GOTO 10
         ELSEIF (TEXTE(1:11).EQ.'SERENDIPITY') THEN
            LUWHAT=TEXTE(1:1)
            GOTO 10
         ELSEIF (TEXTE(1:3).EQ.'NON') THEN
            LUWHAT=TEXTE(1:1)
            GOTO 10
         ELSEIF (TEXTE(1:7).EQ.'CONFORM') THEN
            IF (LUWHAT.EQ.'N') LUWHAT=TEXTE(1:1)
            GOTO 10
         ELSEIF (TEXTE(1:7).EQ.'ELEMENT') THEN
*           Interpolation par ''elements d'aretes''
            CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:5).NE.'ARETE') 
     &         CALL REDERR (14,'ARETE')
            LUWHAT='A'
            INTINC=300
            IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &         WRITE (IMPMES,10003) '*LcInte*',TEXTE(1:NCAR)
            CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:12).EQ.'CONDENSATION') THEN
               IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &            WRITE (IMPMES,10003) '*LcInte*',TEXTE(1:NCAR)
               INTINC=INTINC+10
               CALL REDLE
               IF (IRE.EQ.3.AND.TEXTE(1:5).EQ.'MASSE') CALL REDLE
            ENDIF
            GOTO 10
         ELSEIF (TEXTE(1:6).EQ.'POINTS'.OR.TEXTE(1:6).EQ.'ABSCIS'
     &       .OR.TEXTE(1:11).EQ.'EQUIDISTANT') THEN
            GOTO 10
         ELSEIF (TEXTE(1:13).EQ.'GAUSS-LOBATTO') THEN
            INTINC=LAGDMX
            GOTO 10
         ELSEIF (TEXTE(1:4).EQ.'TYPE'.OR.TEXTE(1:5).EQ.'ORDRE') THEN
            GOTO 10
         ELSEIF (NCAR.LE.3.AND.
     &          (TEXTE(1:1).EQ.'P'.OR.TEXTE(1:1).EQ.'Q')) THEN
            CALL RELCNE (TEXTE(2:NCAR),INTINP)                          !utilite
            INTINC=INTINC+INTINP
            GOTO 10
         ELSEIF (TEXTE(1:10).EQ.'P1+BULLEP3') THEN                      !06/2004
            INTINC=203                                                  !08/2004
            GOTO 10                                                     !08/2004
         ENDIF
      ELSEIF (IRE.EQ.1) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE(IMPMES,10001) '*LcInte*',NFIX  
         INTINC=INTINC+NFIX
         IF (INTINC.EQ.1) THEN
            CALL WARNNG ('Utiliser la nouvelle syntaxe pour declarer'
     &      //' l''interpolation :'
     &      //' Interpolation de Lagrange <P1/Q1>')
         ELSEIF (INTINC.EQ.2) THEN
            CALL WARNNG ('Utiliser la nouvelle syntaxe pour declarer'
     &      //' l''interpolation :'
     &      //' Interpolation de Lagrange <P2/Q2>')
         ELSE 
            GOTO 90000
         ENDIF
         CALL REDLE
      ENDIF
*
      IF (LUWHAT.EQ.'H') THEN
         INTINC=200
      ELSEIF (LUWHAT.EQ.'S') THEN
         IF (INTINC.EQ.2) THEN
            INTINC=202
         ELSE
            GOTO 90001
         ENDIF
      ELSEIF (LUWHAT.EQ.'C') THEN
         IF (INTINC.EQ.1) THEN
            INTINC=201
         ELSE
            GOTO 90003
         ENDIF
      ENDIF
*     Interpolation de Lagrange aux points de Gauss-Lobbatto 
*     et Lagrange standard identiques
      IF (INTINC.EQ.LAGDMX+1.OR.INTINC.EQ.LAGDMX+2) 
     &   INTINC=INTINC-LAGDMX
*
      CALL PRFXMJ (-1,'*LcInte*')
      RETURN
*-----------------------------------------------------------------------
10001 FORMAT(T6,A8,T56,' , suivi de nombre : ',I12)
10003 FORMAT(T6,A8,T56,' , suivi du mot : ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL BAISE  ('L''ancienne syntaxe de la directive INTERPOLATION'
     &//' n''est valable que pour les interpolations d''ordre 1 ou 2.')
90001 CALL ENCLER (INTINC,TEXTE(1:2))
      DO 90002 I=3,NCHINC+2
         TEXTE(I:I)=NOMINC(NCHINC*(NUINCO-1)+I-2)
90002 CONTINUE
      CALL BAISE  ('Interpolation SERENDIPITY de type '//TEXTE(1:2)
     &//' non admise. (demandee pour l''inconnue '//TEXTE(3:NCHINC+2))
90003 CALL ENCLER (NUINCO,TEXTE(1:2))
      DO 90004 I=3,NCHINC+2
         TEXTE(I:I)=NOMINC(NCHINC*(NUINCO-1)+I-2)
90004 CONTINUE
      CALL BAISE  ('Interpolation NON CONFORME de type '//TEXTE(1:2)
     &//' non admise. (demandee pour l''inconnue '//TEXTE(3:NCHINC+2))

                                                                    END !Lcinte
