*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCKDOM (NUDOMG,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)
* Derniere modification : D.Martin (6 novembre 2002)
* Version 1.0.8
*  
* Lecture des types de calculs ELements FINIs, VALeurs NODales,
* de Conditions ESSEntielles ou de TRANsmission
* qui definissent les termes ou les conditions essentielles associes 
* au domaine geometrique de numero NUDOMG (defini par le maillage). 
*  
*-- Arguments d'entree -- 
* NUDOMG numero du domaine geometrique
* NIVIMP indice d'impression  
*
*-- Mots-cles de la directive CALCUL SUR LE DOMAINE --
*  
* + < CALCUL SUR LE DOMAINE GEOMETRIQUE &C
*     ( ( Impression DE NIVEAU &I )
*       ( NORMALES ASSEMBLEES AUX NOEUDS )
*       ( COORDONNEES DES NOEUDS )
*       ( Quadrature )                              ==> Lcquad
*     + < TERME <   ELEMENT FINIS (STANDARD)        ==> Lcterm + Lcintg
*                 / MATRICE ELEMENTAIRE             ==> Lcterm + Lcintg
*                 / VALEURS NODALES                 ==>    "   + Lcvano
*                 / ELEMENT FINIS LOCALISES
*                    CALCULE PAR INTEGRATION EXACTE ==>    "   + Lcfloc
*                    CALCULE PAR INTEGRATION NUMERIQUE
*                 / INTERPOLE                       ==>    "   + Lcitrg
*                 / FORME LINEAIRE PONCTUELLE       ==>    "
*               >
*       / CONDITION ESSENTIELLE >                   ==>    "   + Lcesse
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NUDOMG,NIVIMP
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*  
      INTEGER          NCDONN(2),ITYDON(2),NIVDON(2),ITYPDO(2) 
      LOGICAL          AJUST
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80,TYPINT*2,PRFXAS*8,CADIRE(5)
      CHARACTER*16     ERCODE*120,NMTERM,NMDONN(2),THETRM
      CHARACTER        TYPCAL*6,TYPTRM*9
      INTEGER          INTDON,INTTYP,INTYKL,KELCHN,KLCSTE,KLTERM,NCATRM
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      INTEGER          NIVDOM,NUSCHQ,LGVRAI,NUDIRE,LGNEW ,MCDLFA
     &                ,IRPLOF,NUDKP1,NCTERM,NWHTRM,NUDONA,NWHDON,MORE
     &                ,LUDIRE,NBITEM,NADIRE
     &                ,MCLIST,MCBLOK,MCMINC,MCINCO
     &                ,LGTRDO,MCTRDO,LGERDO,NBDOMK,LGCANO,NCHDOM
     &                ,NDEBDO,NBTRDO
     &                ,LGMTRM,MCMTRM,IADTRM
     &                ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &                ,LGMDON,MCMDON
     &                ,LGDONN,MCDONN,LGEDON,NBDONN,INCDON,NCHDON
     &                ,NUTERM,NVTERM,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE
     &                ,NUINCC,NUINCL,IGEOME,ICORNE,IRPLOC,NIVIMT
     &                ,ITRM,I,IDOK,IDOM,ITYCOM
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/FORMAH/   ERCODE  
      EQUIVALENCE     (ERCODE(57:57),TYPCAL),(ERCODE(65:65),NMTERM)  
     &               ,(ERCODE(81:81),NMDONN)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcKdom*')
*
      CALL TAZERO (5,'CA',1,CADIRE,IST,RST,CST)                         !utilite
*
*     Quelques valeurs par defaut pour le domaine en cours
*
      NIVDOM=0 
      ICORNE=0 
      IRPLOC=0 
      NUSCHQ=QUADEF
      NUINCC=NDFINC
      NUINCL=NDFINC
      ITYCOM=INTTYP ('COMPLEXE')
*  
      LUDIRE=0 
      CALL REDLE
*  
1     IF (IRE.NE.3) CALL REDERR (13,' ')
*--   Lecture des directives ------------------------------------------
      NUDIRE=0
      NBITEM=0
      IF (TEXTE(1:NCAR).EQ.'CONDITION'.OR.TEXTE(1:NCAR).EQ.'BOUNDARY')
     &THEN
         NUDIRE=1
         NBITEM=1
      ELSEIF (TEXTE(1:5).EQ.'COORD') THEN
         NUDIRE=2
         NBITEM=1
      ELSEIF (TEXTE(1:NCAR).EQ.'IMPRESSION'.OR.TEXTE(1:5).EQ.'PRINT')
     &THEN
         NUDIRE=3
         NBITEM=1
      ELSEIF (TEXTE(1:6).EQ.'NORMAL') THEN
         NUDIRE=4
         NBITEM=1
      ELSEIF (TEXTE(1:NCAR).EQ.'QUADRATURE') THEN
         NUDIRE=5
         NBITEM=1
      ELSEIF (TEXTE(1:4).EQ.'TERM') THEN
         NUDIRE=6
         NBITEM=1
      ENDIF
*
      NADIRE=NUDIRE
      IF (TEXTE(1:4).EQ.'TERM') NADIRE=1
*  
      IF (LUDIRE.NE.0.AND.(NBITEM.LE.0.OR.CADIRE(NADIRE).EQ.'Y')) THEN
*  
*        Mise a jour des structure #TERDO et $SDTRM
*        Agrandissement eventuel de #TERDO pour un domaine de plus 
         CALL TBRR1  (ERCODE,'#TERDO',1,LGTRDO)
         CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)
         CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,LGCANO,NCHDOM)          !utilite
*        Calcul de la longueur utile de la structure #TERDO
         LGVRAI=LGERDO 
         DO 2 IDOM=1,NBDOMK
            LGVRAI=LGVRAI+LGCANO+IST(MCTRDO+LGVRAI+LGCANO-2)
2        CONTINUE
*        Disponibilite pour au moins deux domaines de plus
*        avec chacun 2 termes
         LGNEW=LGVRAI+2*LGCANO+4 
         IF (LGNEW.GT.LGTRDO) THEN  
            CALL TBAJST ('#TERDO',1,LGNEW)
            CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)
         ENDIF
         CALL TAZERO (LGCANO,'E',LGVRAI+1,AST,IST(MCTRDO),RST,CST)      !utilite
         CALL TBRR1  (ERCODE,'#ISTEL',NUDOMG,MCLIST)
*  
         MCBLOK=MCLIST 
         IF (NBBBLK.GE.2) CALL TBAR1 (ERCODE,'#LOKEL',1,MCBLOK)
         CALL TBAR4  (ERCODE,'#ISTEL',NUDOMG,MCLIST,'#NCONU',1,MCINCO
     &          ,'$WORK$',0,MCDLFA,'#TERDO',1,MCTRDO)
         IGEOME=10*ICORNE+MAX (IRPLOC,IRPLOF)
*  
         CALL MKTRDO (NUDOMG,IST(MCLIST),NDIM,INTRPG,IST(MCBLOK)
     &               ,IST(MCINCO),IST(MCTRDO),IST(MCDLFA),IGEOME,NUSCHQ
     &               ,NUTERM,NUINCC,NUINCL,ITYCAL,NUKALE,NIVDOM,NDEBDO
     &               ,NIVIMP,IMPSDR)                                    !sdexplo
         CALL TBSAVE ('#ISTEL',NUDOMG)
*  
         IF (NUTERM.GT.0) THEN  
            CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
            CALL PUTTRM (IST(MCDTRM+LGETRM+(NUTERM-1)*INCTRM),NVTERM
     &                  ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NDFDSM
     &                  ,NUINCC,NDFDUM,NDFNDF,NDFNUM
     &                  ,NUINCL,NDFDUM,NDFNDF,NDFNUM
     &                  ,0,NDFSTO,NDFCOR,NDEBDO,NIVIMT)                 !sdexplo
*  
*           Il faut riper de 1 dans $SDTRM toutes les adresses relatives
*           NDEBDO des termes des domaines de calcul situes a la suite 
*           dans #TERDO (si il-y-a eu egalement creation de domaine, 
*           on ne passe pas dans la boucle.  
            NUDKP1=IST(MCTRDO+NDEBDO)+1
            NDEBDO=NDEBDO+LGCANO
            NBTRDO=IST(MCTRDO+NDEBDO-3)
            NDEBDO=NDEBDO+NBTRDO
            DO 5 IDOK=NUDKP1,NBDOMK
               NDEBDO=NDEBDO+LGCANO
               NBTRDO=IST(MCTRDO+NDEBDO-3) 
               DO 4 ITRM=1,NBTRDO  
                  NUTERM=IST(MCTRDO-1+NDEBDO)  
                  IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)+18
                  IST(IADTRM)=IST(IADTRM)+1
                  NDEBDO=NDEBDO+1
4             CONTINUE
5          CONTINUE 
         ENDIF
      ENDIF
      IF (NBITEM.LE.0) GOTO 99999  
      CADIRE(NADIRE)='Y'
      LUDIRE=LUDIRE+1  
      NUTERM=0 
      NUKALE=0 
      ITYCAL=0 
      DO 6 I=1,2
         ITYDON(I)=-1  
         NIVDON(I)=0
         ITYPDO(I)=0
         NCDONN(I)=0
         NMDONN(I)=' '
6     CONTINUE
      IRPLOF=0 
      IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &   WRITE(IMPMES,10000) '*LcKdom*',TEXTE(1:NCAR) 
      GOTO (60,20,10,30,40,50) NUDIRE 
*--
*  
*-    On a lu IMPRESSION
10    NIVDOM=1 
      CALL REDLE
      IF (IRE.EQ.3.AND.(TEXTE(1:6).EQ.'NIVEAU'
     &              .OR.TEXTE(1:5).EQ.'LEVEL')) CALL REDLE
      IF (IRE.EQ.1) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE (IMPMES,10001) '*LcKdom*',NFIX
         NIVDOM=NFIX
         CALL REDLE
      ENDIF
      GOTO 1  
*  
*-    On a lu COORDONNEES
20    ICORNE=1 
      CALL REDLE
      IF (IRE.EQ.3.AND.(TEXTE(1:6).EQ.'NOEUDS'
     &              .OR.TEXTE(1:5).EQ.'NODES')) CALL REDLE
      GOTO 1  
*  
*-    On a lu NORMALE
30    IRPLOC=1 
      CALL REDLE
      IF (IRE.NE.3) CALL REDERR(13,' ')
      IF (TEXTE(1:10).EQ.'ASSEMBLEES') CALL REDLE
      IF (IRE.EQ.3.AND.TEXTE(1:6).EQ.'NOEUDS') THEN
         CALL REDLE
!        CALL TBAR1  (ERCODE,'#OMINC',1,MCMINC)
!        IF (IRE.NE.4) CALL REDERR(14,' ')
!        NUINC=KELCHN (TEXTE(1:NCAR),AST(MCMINC),NBINCO,NCHINC)         !utilite
      ENDIF
      GOTO 1  
*  
*-    On a lu QUADRATURE
40    CALL LCQUAD (NUSCHQ,NIVIMP,IMPMES)                                !lecdire
      CALL REDLE
      GOTO 1  
*  
*-    On a lu TERME
50    TYPCAL='ELFINI'
51    CALL REDLE
      IF (IRE.EQ.3) THEN
         IF (TEXTE(1:7).EQ.'ELEMENT'.OR.TEXTE(1:4).EQ.'FINI') GOTO 51
         IF (TEXTE(1:8).EQ.'STANDARD') THEN
            CALL REDLE
         ELSEIF (TEXTE(1:5).EQ.'MATRI') THEN
            TYPCAL='MATELM'
            CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:8).EQ.'ELEMENTA') CALL REDLE
         ELSEIF (TEXTE(1:6).EQ.'LOCALI') THEN
            TYPCAL='ELFLOC'
            CALL REDLE
         ELSEIF (TEXTE(1:6).EQ.'VALEUR') THEN  
            TYPCAL='VALNOD' 
            CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:6).EQ.'NODALE') CALL REDLE
            NUKALE=1  
         ELSEIF (TEXTE(1:5).EQ.'FORME') THEN
            TYPCAL='FORMLI' 
            CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:8).EQ.'LINEAIRE') CALL REDLE
            IF (IRE.EQ.3.AND.TEXTE(1:11).EQ.'PONCTUELLE') CALL REDLE
            NUKALE=1
            CALL WARNNG ('Vous utilisez la directive FORME LINEAIRE.'
     &      //' Pouvez-vous m''indiquer par e-mail dans quel cadre ?'
     &      //' Urgent. Daniel.Martin@univ-rennes1.fr')
         ELSEIF (TEXTE(1:13).EQ.'INTERPOLATION') THEN  
            TYPCAL='INTERP' 
            CALL REDLE
            CALL WARNNG ('Vous utilisez la directive INTERPOLATION.'
     &      //' Pouvez-vous m''indiquer par e-mail dans quel cadre ?'
     &      //' Urgent. Daniel.Martin@univ-rennes1.fr')
         ENDIF
      ENDIF
      GOTO 100
*  
*-    On a lu CONDITION
60    CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (TEXTE(1:NCAR).EQ.'LIMITES') GOTO 60
      IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &   WRITE(IMPMES,10003) '*LcKdom*',TEXTE(1:NCAR)
      IF (TEXTE(1:11).EQ.'ESSENTIELLE'.OR.TEXTE(1:9).EQ.'DIRICHLET')THEN
         TYPCAL='C.ESSE'
      ELSEIF (TEXTE(1:12).EQ.'TRANSMISSION') THEN
         TYPCAL='C.TRAN'
      ELSE
         CALL REDERR (1,'ESSENTIELLE ou TRANSMISSION')
      ENDIF
      CALL REDLE
*-----------------------------------------------------------------------
*     Lecture des caracteristiques du terme ou de la condition 
*  
100   ITYCAL=INTYKL (TYPCAL)                                            !utilite
      NIVIMT=0 
      CALL TBRR4  (ERCODE,'$DONNE',1,LGDONN,'#OMDON',1,LGMDON
     &                   ,'$SDTRM',1,LGDTRM,'#OMTRM',1,LGMTRM)  
      CALL TBAR6  (ERCODE,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN            
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)           
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
*     Nombre de composantes par noeuds pour les termes VALNOD, C.ESSE
      NVALNE=NDFSYM
      CALL LCTERM (AST(MCMINC),IST(MCINCO),AST(MCMDON),IST(MCDONN),NDIM
     &            ,TYPCAL,NMTERM,NCTERM,NVTERM,TYPTRM,NMDONN,NCDONN
     &            ,ITYDON,NIVDON,ITYPDO,NUINCC,NUINCL,NUKALE
     &            ,NVALNE,IRPLOF,ICORNE,NIVIMT,NIVIMP,IMPMES)           !lecdire
*
*     Type de calcul du terme (il peut etre change dans Lcterm)
      ITYCAL=INTYKL (TYPCAL)                                            !utilite
*     Type du terme
      ITYPTR=INTTYP (TYPTRM)                                            !utilite
      NUDONN=NDFDON
      AJUST=.FALSE.
*  
*     Mise a jour des structures $SDTRM et #OMTRM pour le terme
*  
      CALL ALFANU (NBCHNT,NMTERM(:NCTERM))                              !utilite
      NUTERM=KLTERM (NMTERM(:NCTERM),NVTERM,AST(MCMTRM),IST(MCDTRM))    !sdexplo
      IF (NUTERM.GT.0) THEN
*        Le terme existe deja
         CALL PRNTRM (NMTERM(:NCTERM),NVTERM,THETRM,NCATRM)             !utilite
         CALL WARNNG ('Le terme '//THETRM(1:NCATRM)
     &              //' a deja ete defini. Cette nouvelle declaration'
     &              //' est ignoree.')                                  !utilite
         GOTO 1
      ELSE
         IF (LGDTRM.LT.LGETRM+INCTRM*(NBTERM+1)) THEN
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,5)      !sdexplo
            AJUST=.TRUE.
         ENDIF
         NWHTRM=MAX (NCTERM,NCHTRM)
         IF (LGMTRM.LT.(NBTERM+1)*NWHTRM) THEN  
            CALL TBAJST ('#OMTRM',1,NWHTRM*(NBTERM+5))
            AJUST=.TRUE.
         ENDIF
         IF (AJUST)
     &   CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTERM(1:NCTERM))       !utilite
         NUTERM=NBTERM 
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
      ENDIF
*  
      IF (NCDONN(1).LE.0) GOTO 1
*  
*     Mise a jour des tableaux $DONNE et #OMDON pour la donnee affectee au terme,
*     et dans le cas d'une donnee 'FONCTION' pour la donnee associee a la FONCTION
*  
      NUDONA=0 
      NWHDON=0 
      MORE=0
      IF (AJUST) CALL TBAR1  (ERCODE,'#OMDON',1,MCMDON)
      NUDONN=KELCHN (NMDONN(1)(1:NCDONN(1)),AST(MCMDON),NBDONN,NCHDON)  !utilite
      IF (NUDONN.LE.0) THEN
*
*        Type de la (nouvelle) donnee affectee au terme
*
         ITYDON(1)=MAX (ITYDON(1),0)
         NWHDON=NCDONN(1)  
         MORE=MORE+1
      ENDIF
      IF (NCDONN(2).GT.0) THEN  
         NUDONA=KELCHN (NMDONN(2)(:NCDONN(2)),AST(MCMDON),NBDONN,NCHDON)!utilite
         IF (NUDONA.LE.0) THEN
*
*           Type de la (nouvelle) donnee associee a la donnee affectee au terme
*
            ITYDON(2)=MAX (ITYDON(2),0)
            NWHDON=MAX (NWHDON,NCDONN(2))
            MORE=MORE+1
         ENDIF
      ENDIF
      IF (MORE.GT.0) THEN
*
*        Ajustement eventuel de la taille de #OMDON et $DONNE
*
         IF (LGDONN.LT.LGEDON+INCDON*(NBDONN+MORE)) THEN
            CALL SDAJST ('$DONNE',1,LGDONN,LGEDON,INCDON,NBDONN,5)      !sdexplo
            AJUST=.TRUE.
         ENDIF
         IF (LGMDON.LT.(NBDONN+MORE)*MAX (NCHDON,NWHDON)) THEN
            CALL TBAJST ('#OMDON',1,(NBDONN+5)*MAX (NCHDON,NWHDON))
            AJUST=.TRUE.
         ENDIF
*  
         IF (AJUST)
     &      CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
         IF (NUDONN.LE.0)
     &    CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN(1)(1:NCDONN(1)))!utilite
         IF (NCDONN(2).GT.0.AND.NUDONA.LE.0)
     &    CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN(2)(1:NCDONN(2)))!utilite
         CALL SDMKDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
      ENDIF
*
*     Numero d'une nouvelle donnee constante
*
      IF (NCDONN(2).GT.0) THEN  
         IF (NUDONA.LE.0) NUDONA=NBDONN 
         IF (ITYDON(2).EQ.INTDON('CONSTANTE').AND.NIVDON(2).LE.0) THEN  !utilite
            NIVDON(2)=KLCSTE (TYPINT (ITYPDO(2)))                       !sdexplo
            AJUST=.TRUE.
         ENDIF
      ENDIF
      IF (NUDONN.LE.0) THEN 
         NUDONN=NBDONN+1-MORE  
         IF (ITYDON(1).EQ.INTDON ('CONSTANTE')) THEN                    !utilite
            NIVDON(1)=KLCSTE (TYPINT(ITYPDO(1)))                        !sdexplo
            AJUST=.TRUE.
         ELSEIF (ITYDON(1).EQ.INTDON ('FONCTION')) THEN                 !utilite
            IF (ITYPTR.NE.ITYCOM) ITYPTR=ITYPDO(1)
            NIVDON(1)=NUDONA
         ELSEIF (ITYDON(1).EQ.INTDON ('TABLEAU')) THEN                  !utilite
            IF (ITYPTR.NE.ITYCOM) ITYPTR=ITYPDO(1)
         ENDIF
      ENDIF
*
*     Mise a jour de la structure $DONNE
*
      IF (AJUST) CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
      CALL SDMKCO (NUDONN,IST(MCDONN),ITYDON(1),NIVDON(1),ITYPDO(1))    !utilite
      IF (NUDONA.GT.0)  
     &   CALL SDMKCO (NUDONA,IST(MCDONN),ITYDON(2),NIVDON(2),ITYPDO(2)) !utilite
*  
      GOTO 1
*
99999 IF (IMPSDR.GT.0.AND.(NIVIMP.GT.9.OR.NIVDOM.GT.9)) 
     &   CALL PRTRDO (NUDOMG,0,IMPSDR)                                  !prsd
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.1)
     &   WRITE(IMPSDR,10010) PRFXAS(1),'*LcKdom*'
      CALL PRFXMJ (-1,'*LcKdom*') 
*----------------------------------------------------------------------- 
10000 FORMAT(T6,A8,' Lecture de la Sous-Directive : ',A)
10001 FORMAT(T6,A8,T56,' , suivi du nombre : ',I12)
10003 FORMAT(T6,A8,T56,' , suivi du mot : ',A)
10010 FORMAT(' ',69('*'),'  ',A8,'>',A8,'  ',6('*'))
                                                                    END !Lckdom
