*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCKSPE (NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (12 Decembre 2002)
* Derniere modification : D.Martin (16 octobre 2006)
* Version 2
*  
* Lecture des termes de type 'calcul spectral'. 
*  
*-- Arguments d'entree -- 
* NIVIMP indice d'impression  
*
*-- Mots-cles de la directive CALCUL SPECTRAL --
*  
* + < CALCUL SPECTRAL
*     + < TERME <   SPECTRAL                        ==> Lcterm + Lcintg
*               >
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER          NUDOMG,NIVIMP
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*  
      INTEGER          NCDONN(2),ITYDON(2),NIVDON(2),ITYPDO(2) 
      LOGICAL          AJUST,CRETRM
      DOUBLE PRECISION FLOT
      CHARACTER        TYPCAL*6,TYPTRM*9,TYPINT*2
      CHARACTER        TEXTE*80,PRFXAS*8,CADIRE(2)
      CHARACTER*16     ERCODE*120,NMTERM,NMDONN(2),THETRM
      INTEGER          INDSTO,INTDON,INTTYP,INTYKL,KELCHN,KLCSTE,KLTERM
     &                ,KLNIVE
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      INTEGER          NCTERM,NWHTRM,NUDONA,NWHDON,MORE
     &                ,LUDIRE,NBITEM,NADIRE
     &                ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &                ,LGMTRM,MCMTRM,LGMDON,MCMDON
     &                ,LGDONN,MCDONN,LGEDON,NBDONN,INCDON,NCHDON
     &                ,NUTERM,NVTERM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM
     &                ,NUINCC,NUINCL,NIVIMT,NCATRM
     &                ,NUDIRE,INUTI1,INUTI2,I,INTTYC,INTDOF,INTDOT
     &                ,MCMINC,MCINCO,LGEINC,NBINCO,INCINC,NCHINC
     &                ,NVNUMC,NCPINC,INTINC,NBTNEC
     &                ,NVNUML,NCPINL,INTINL,NBTNEL
     &                ,LGTERM,NVSTOK,INSTOK,MCNEDO,MCBMOR,LGBMOR
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/FORMAH/   ERCODE  
      EQUIVALENCE     (ERCODE(57:57),TYPCAL),(ERCODE(65:65),NMTERM)  
     &               ,(ERCODE(81:81),NMDONN)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcKspe*')
*
      CALL TAZERO (2,'CA',1,CADIRE,IST,RST,CST)                         !utilite
*
      INTTYC=INTTYP ('COMPLEXE')                                        !utilite
      INTDOF=INTDON ('FONCTION')                                        !utilite
      INTDOT=INTDON ('TABLEAU')                                         !utilite
      LUDIRE=0
      CALL REDLE
*  
1     IF (IRE.NE.3) CALL REDERR (13,' ')
*--   Lecture des directives ------------------------------------------
      NUDIRE=0
      NBITEM=0
      IF (TEXTE(1:4).EQ.'TERM') THEN
         NUDIRE=1
         NBITEM=1
      ENDIF
*
      NADIRE=NUDIRE
*
      IF (LUDIRE.NE.0.AND.(NBITEM.LE.0.OR.CADIRE(NADIRE).EQ.'Y')) THEN
*   
         CALL TBAR1  (ERCODE,'#NCONU',1,MCINCO)
         CALL SDEXDB (IST(MCINCO),LGEINC,NBINCO,INCINC,NCHINC)          !utilite
*
*        Attributs et numerotation pour l'inconnue en colonne
*
         NCPINC=1
         NBTNEC=1
         NVNUMC=NDFNUM
         IF (NUINCC.NE.NDFINC) THEN
            CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTINC,NBTNEC)       !utilite
            IF (INTINC.NE.-1) CALL ERTERM (38,NMTERM(1:NCTERM),NVTERM)  !utilite
            NVNUMC=-NBTNEC
         ENDIF
*
*        Attributs et numerotation pour l'inconnue en ligne
*
         NCPINL=1
         NBTNEL=1
         NVNUML=NDFNUM
         IF (NUINCC.NE.NDFINC.AND.NUINCL.EQ.NUINCC) THEN 
            NCPINL=NCPINC
            NBTNEL=NBTNEC
            NVNUML=NVNUMC
         ELSEIF (NUINCL.NE.NDFINC) THEN
            CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTINL,NBTNEL)       !utilite
            IF (INTINL.NE.-1) CALL ERTERM (39,NMTERM(1:NCTERM),NVTERM)  !utilite
            NVNUML=-NBTNEL
         ENDIF
*
*        Type de stockage du terme et niveau du tableau de stockage
*
         NVSTOK=NDFSTO
         IF (NUINCC.NE.NDFINC.AND.NUINCL.NE.NDFINC) THEN
*           Lorsque deux inconnues sont declarees, type de stockage
            IF (NUINCC.EQ.NUINCL) THEN
               INSTOK=INDSTO ('BIMORSE')                                !utilite
               NVSTOK = -NBTNEC
            ELSEIF (NUINCC.LT.NUINCL) THEN
               INSTOK=INDSTO ('PLEIN-L')                                !utilite
            ELSEIF (NUINCC.GT.NUINCL) THEN
               INSTOK=INDSTO ('PLEIN-C')                                !utilite
            ENDIF
         ELSE
*           Dans le cas ou une seule inconnue est declaree le terme
*           est declare Diagonal
            INSTOK= INDSTO ('DIAG')                                     !utilite
         ENDIF
*
*        Type (REEL ou COMPLEXE) du terme
*
         IF (ITYPTR.NE.INTTYC.AND.NUDONN.GT.0) THEN
            IF (ITYDON(1).EQ.INTDOF.OR.ITYDON(1).EQ.INTDOT) THEN
               ITYPTR=ITYPDO(1)
            ENDIF
         ENDIF
*
*        Creation du terme
*
         LGTERM=NCPINC*NBTNEC*NCPINL*NBTNEL
         CALL CRTERM (NMTERM(1:NCTERM),NVTERM,LGTERM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NDFDSM
     &               ,NUINCC,NDFDUM,NBTNEC,NVNUMC
     &               ,NUINCL,NDFDUM,NBTNEL,NVNUML
     &               ,INSTOK,NVSTOK,NDFCOR,0,NIVIMT,.FALSE.,CRETRM)     !sdexplo
*
*         Creation des numerotations triviales #GNEDO
*
          IF (NVNUMC.NE.NDFNUM) CALL CRNEDO (NVNUMC,NBTNEC,IST)         !sdexplo
          IF (NVNUML.NE.NDFNUM.AND.NVNUML.NE.NVNUMC)
     &       CALL CRNEDO (NVNUML,NBTNEL,IST)                            !sdexplo
*
*         Creation du tableau de stockage, le cas echeant
*
          IF (INSTOK.EQ.INDSTO ('BIMORSE'))
     &       CALL CRBMOP (NVSTOK,NBTNEL,NBTNEC,IST)                     !sdexplo
*
          IF (IMPSDR.GT.0.AND.NIVIMP.GT.9) THEN
             CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
             NUTERM=KLTERM (NMTERM(1:NCTERM),NVTERM
     &                     ,AST(MCMTRM),IST(MCDTRM))                    !sdexplo
             CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPSDR)        !prsd 
          ENDIF
      ENDIF
*
      IF (NBITEM.LE.0) GOTO 99999
*-----------------------------------------------------------------------
*     Terme suivant (initialisation)
*
      CADIRE(NADIRE)='Y'
      LUDIRE=LUDIRE+1  
      NUTERM=0 
      NUKALE=0 
      ITYCAL=0 
      NUINCC=NDFINC
      NUINCL=NDFINC
      ITYSYM=NDFSYM
      NIVIMT=0 
      DO 6 I=1,2
         ITYDON(I) =-1  
         NIVDON(I) = 0
         ITYPDO(I) = 0
         NCDONN(I) = 0
         NMDONN(I) =' '
6     CONTINUE
      IF (IMPMES.GT.0.AND.NIVIMP.GT.1) 
     &   WRITE(IMPMES,10000) '*LcKspe*',TEXTE(1:NCAR) 
*
10    TYPCAL='SPECTR'
11    CALL REDLE
      IF (IRE.EQ.3) THEN
         IF (TEXTE(1:8).EQ.'SPECTRAL') GOTO 11
      ENDIF
*-----------------------------------------------------------------------
*     Lecture des caracteristiques du terme 
*  
      CALL TBRR4  (ERCODE,'$DONNE',1,LGDONN,'#OMDON',1,LGMDON
     &                   ,'$SDTRM',1,LGDTRM,'#OMTRM',1,LGMTRM)  
      CALL TBAR6  (ERCODE,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN            
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)           
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
      ITYCAL=INTYKL (TYPCAL)                                            !utilite
      CALL LCTERM (AST(MCMINC),IST(MCINCO),AST(MCMDON),IST(MCDONN),NDIM
     &            ,TYPCAL,NMTERM,NCTERM,NVTERM,TYPTRM,NMDONN,NCDONN
     &            ,ITYDON,NIVDON,ITYPDO,NUINCC,NUINCL,NUKALE
     &            ,ITYSYM,INUTI1,INUTI2,NIVIMT,NIVIMP,IMPMES)           !lecdire
*
*     Type du terme
*
      ITYPTR=INTTYP (TYPTRM)                                            !utilite
      NUKALE=1
*  
*     Mise a jour des structures $SDTRM et #OMTRM pour le terme
*  
      CALL ALFANU (NBCHNT,NMTERM(1:NCTERM))                             !utilite
      NUTERM=KLTERM (NMTERM(1:NCTERM),NVTERM,AST(MCMTRM),IST(MCDTRM))   !sdexplo
      IF (NUTERM.GT.0) THEN
*        Le terme existe deja
         CALL PRNTRM (NMTERM(1:NCTERM),NVTERM,THETRM,NCATRM)            !utilite
         CALL WARNNG ('Le terme '//THETRM(1:NCATRM)
     &              //' a deja ete defini. Cette nouvelle declaration'
     &              //' est ignoree.')                                  !utilite
         GOTO 1
      ENDIF
*
*     Donnee afectee au terme
*
      NUDONN=NDFDON
      AJUST=.FALSE.
      IF (NCDONN(1).LE.0) GOTO 1
*  
*     Mise a jour des tableaux $DONNE et #OMDON pour la donnee affectee 
*     au terme, et dans le cas d'une donnee 'FONCTION' pour la donnee 
*     associee a la FONCTION
*  
      NUDONA=0 
      NWHDON=0 
      MORE=0
      IF (AJUST) CALL TBAR1  (ERCODE,'#OMDON',1,MCMDON)
      NUDONN=KELCHN (NMDONN(1)(1:NCDONN(1)),AST(MCMDON),NBDONN,NCHDON)  !utilite
*
      IF (NUDONN.LE.0) THEN
*
*        Type de la (nouvelle) donnee affectee au terme
*
         ITYDON(1)=MAX (ITYDON(1),0)
         NWHDON=NCDONN(1)  
         MORE=MORE+1
      ENDIF
      IF (NCDONN(2).GT.0) THEN  
         NUDONA=KELCHN (NMDONN(2)(:NCDONN(2)),AST(MCMDON)
     &                 ,NBDONN,NCHDON)                                  !utilite
         IF (NUDONA.LE.0) THEN
*
*           Type de la (nouvelle) donnee associee a la donnee affectee au terme
*
            ITYDON(2)=MAX (ITYDON(2),0)
            NWHDON=MAX (NWHDON,NCDONN(2))
            MORE=MORE+1
         ENDIF
      ENDIF
      IF (MORE.GT.0) THEN
*
*        Ajustement eventuel de la taille de #OMDON et $DONNE
*
         IF (LGDONN.LT.LGEDON+INCDON*(NBDONN+MORE)) THEN
            CALL SDAJST ('$DONNE',1,LGDONN,LGEDON,INCDON,NBDONN,5)      !sdexplo
            AJUST=.TRUE.
         ENDIF
         IF (LGMDON.LT.(NBDONN+MORE)*MAX (NCHDON,NWHDON)) THEN
            CALL TBAJST ('#OMDON',1,(NBDONN+5)*MAX (NCHDON,NWHDON))
            AJUST=.TRUE.
         ENDIF
*  
         IF (AJUST)
     &      CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
         IF (NUDONN.LE.0)
     &    CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN(1)(1:NCDONN(1)))!utilite
         IF (NCDONN(2).GT.0.AND.NUDONA.LE.0)
     &    CALL RIPCHN (AST(MCMDON),NBDONN,NCHDON,NMDONN(2)(1:NCDONN(2)))!utilite
         CALL SDMKDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)          !utilite
      ENDIF
*
*     Numero d'une nouvelle donnee constante
*
      IF (NCDONN(2).GT.0) THEN  
         IF (NUDONA.LE.0) NUDONA=NBDONN 
         IF (ITYDON(2).EQ.INTDON('CONSTANTE').AND.NIVDON(2).LE.0) THEN  !utilite
            NIVDON(2)=KLCSTE (TYPINT (ITYPDO(2)))                       !sdexplo
            AJUST=.TRUE.
         ENDIF
      ENDIF
*
      IF (NUDONN.LE.0) THEN
         NUDONN=NBDONN+1-MORE  
         IF (ITYDON(1).EQ.INTDON ('CONSTANTE')) THEN                    !utilite
            NIVDON(1)=KLCSTE (TYPINT(ITYPDO(1)))                        !sdexplo
            AJUST=.TRUE.
         ELSEIF (ITYDON(1).EQ.INTDON ('FONCTION')) THEN                 !utilite
            NIVDON(1)=NUDONA
         ENDIF
      ENDIF
*
*     Mise a jour de la structure $DONNE
*
      IF (AJUST) CALL TBAR1  (ERCODE,'$DONNE',1,MCDONN)
      CALL SDMKCO (NUDONN,IST(MCDONN),ITYDON(1),NIVDON(1),ITYPDO(1))    !utilite
      IF (NUDONA.GT.0)  
     &   CALL SDMKCO (NUDONA,IST(MCDONN),ITYDON(2),NIVDON(2),ITYPDO(2)) !utilite
*
      GOTO 1
*
99999 IF (IMPSDR.GT.0.AND.NIVIMP.GT.1)
     &   WRITE(IMPSDR,10010) PRFXAS(1),'*LcKspe*'
      CALL PRFXMJ (-1,'*LcKspe*') 
*----------------------------------------------------------------------- 
10000 FORMAT(T6,A8,' Lecture de la Sous-Directive : ',A)
10001 FORMAT(T6,A8,T56,' , suivi du nombre : ',I12)
10003 FORMAT(T6,A8,T56,' , suivi du mot : ',A)
10010 FORMAT(' ',69('*'),'  ',A8,'>',A8,'  ',6('*'))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File History
* Version 2 : D. Martin (16 octobre 2006)
* - les matrices spectrales pour un meme couple d'inconnues sont BIMORSE
*   et le tableau de stockage &BMORS est cree et rempli ici
* - bug d'initialialisation des numeros d'inconnues lorsque plusieurs
*   termes sont declares apres une meme directive CALCUL SPECTRAL
* Version 1.1 : D.Martin (1er juillet 2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Lckspe
