*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCQUAD (NUQUAD,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1989)
* Derniere modification : D.Martin (05 juillet 2005)
* Version 2
*  
* LeCture du type de schema de QUADrature
*  
*-- Argument d'entree --
* NIVIMP niveau d'impression de lecture des directives
* IMPMES unite d'impression des messages  
*  
*-- Arguments de sortie --
* NUQUAD numero de schema de quadrature  
*  
*-- Mots-Cles de la (sous-)directive QUADRATURE --
*   [ QUADRATURE
*     < DE < GAUSS / GAUSS-LOBATTO > DE DEGRE &I
*     ^ NODALE < P1/Q1 / P2/Q2 >
*     >
*   ]
*   Par defaut Quadrature De Gauss de Degre 5
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NUQUAD,NIVIMP,IMPMES
*  
      CHARACTER        TEXTE*80 
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcQuad*')
      NUQUAD=0
*  
1     CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &   WRITE (IMPMES,10003) '*LcQuad*',TEXTE(1:NCAR)
*
      IF (TEXTE(1:13).EQ.'GAUSS-LOBATTO') THEN
         NUQUAD=NUQUAD+100
         GOTO 1
      ELSEIF (TEXTE(1:5).EQ.'GAUSS') THEN
         GOTO 1
      ENDIF
*
      IF (TEXTE(1:5).EQ.'DEGRE') THEN
*        Formules de Gauss(-Legendre)
*        Les points de quadrature sont les racines pi des polynomes
*        Pn de Legendre transportes sur [0,1] : (1+pi)/2
*        Les poids de quadrature sont 1/(1-pi^2)(P'n(pi))^2
         CALL REDLE
         IF (IRE.NE.1) CALL REDERR (11,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &      WRITE(IMPMES,10001) '*LcQuad*',NFIX  
         NUQUAD=NUQUAD+NFIX
      ELSEIF (TEXTE(1:5).EQ.'NODAL') THEN
*        Formules 'nodales'
*        Les points de quadrature sont les noeuds des elements finis
         CALL REDLE
         NUQUAD=0
         IF (IRE.EQ.3) THEN
            IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &         WRITE(IMPMES,10003) '*LcQuad*',TEXTE(1:NCAR)
            IF (TEXTE(1:1).EQ.'P'.OR.TEXTE(1:1).EQ.'Q')
     &         CALL RELCNE (TEXTE(2:NCAR),NUQUAD)                       !utilite
         ELSE
            CALL REDERR (13,' ')
         ENDIF
         IF (NUQUAD.EQ.0) THEN
            NUQUAD=1
         ELSE
            NUQUAD=-NUQUAD
         ENDIF
      ELSE
         CALL REDERR (2,TEXTE(1:NCAR))
      ENDIF
      CALL PRFXMJ (-1,'*LcQuad*')
*-----------------------------------------------------------------------
10001 FORMAT(T9,A8,T56,' , suivi de nombre : ',I12)
10003 FORMAT(T9,A8,T56,' , suivi du mot : ',A) 
                                                                    END !LcQuad
