*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCTRAN (NOMINC,INCONU,NDIM,NUINC1,NUINC2,NUESSE,NVALNE
     &                  ,IRPLOC,ICORNE,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Mars 1995) 
* Derniere modification : D.Martin (14 Octobre 1999)
* Version # 1.0.1
*  
* LeCture du type de la condition de TRANsmission et des inconnues
* sur lesquelles elle porte.  
*  
*-- Arguments d'entree -- 
* NOMINC tableau des noms d'inconnues 
* INCONU tableau des caracteristiques des inconnues
* NDIM   dimension d'espace
* NIVIMP niveau d'impression des directives
* IMPMES unite de sortie des messages 
*
*-- Arguments de sortie --
* NUINC1 numero d'une inconnue sur laquelle porte la condition
* NUINC2 numero de l'autre inconnue sur laquelle porte la condition
* NUESSE numero de type de condition essentielle de transmission
* NVALNE nombre de valeurs par noeud du terme de condition essentielle
* IRPLOC indice de repere local eventuellement modifie
* ICORNE indice de calcul des coordonnees des noeuds
*-- Syntaxe --
* La CONDITION DE TRANSMISSION est donnee par une chaine de caractere
* contenation du nom de la premiere inconnue, le cas echeant d'une des chaines 
*                    '.N' ou '^N', du signe '=',
* du nom de la seconde inconnue, d'une des chaines '.N' ou '^N' et,
* le cas echeant, de la chaine '+G'
* par exemple, pour les inconnues U et V
*             'U=V[+G]' ou 'U.N=V.N[+G]' ou 'U^N=V^N[+G]'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMINC(*)
      INTEGER       INCONU(*),NDIM,NUINC1,NUINC2,NUESSE,NVALNE,IRPLOC
     &             ,ICORNE,NIVIMP,IMPMES
*
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,NUESS2
     &                ,LGEINC,NBINCO,INCINC,NCHINC,NUEGAL,NUPLUS,ERROR
     &                ,NCARL,NCARL1,INTINL,NBTL,NCARL2,NCPIN1,NCPIN2
      INTEGER          INCESS,KELCHN,NNUEGA
      DOUBLE PRECISION FLOT
      CHARACTER        TEXTE*80 
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcTran*')
      ERROR=0
*  
      CALL SDEXDB (INCONU,LGEINC,NBINCO,INCINC,NCHINC)                  !utilite
*  
      IF (IMPMES.GT.0.AND.NIVIMP.GT.2) 
     &   WRITE(IMPMES,10004) '*LcTran*',TEXTE(1:NCAR)
*
*     Type de la condition de transmission
*
      NCARL=NCAR
      NUEGAL=INDEX (TEXTE(1:NCAR),'=')
      IF (NUEGAL.LE.0) CALL REDERR (1,'=')
      NNUEGA=INDEX (TEXTE(NUEGAL+1:NCAR),'=')
*     Pas de caractere '=' dans un nom d'inconnue pour une cond. essentielle
      IF (NNUEGA.GT.0) CALL ERINCO (6,TEXTE(1:NCAR))                    !utilite
*
      NUPLUS=INDEX (TEXTE(1:NCAR),'+')
      NNUEGA=INDEX (TEXTE(NUPLUS+1:NCAR),'+')
      IF (NNUEGA.GT.0) THEN
*        Au cas ou une inconnue contient le caractere '+'
         DO 10 NUPLUS=NCAR,1,-1
            IF (TEXTE(NUPLUS:NUPLUS).EQ.'+') GOTO 11
10       CONTINUE
         NUPLUS=0
      ENDIF
11    IF (NUPLUS.GT.0.AND.NUPLUS.GT.NUEGAL) THEN
         NCARL=NUPLUS-1
      ENDIF
*
*     Delimitation de la chaine de caractere definissant le type de condition
*
      NUESSE=INCESS (TEXTE(MAX(1,NUEGAL-2):NUEGAL-1))                   !utilite
      IF (NUESSE.LE.1) THEN
         NCARL1=NUEGAL-1
      ELSEIF (NUESSE.LE.3) THEN
         IRPLOC=1  
         NCARL1=NUEGAL-3 
      ENDIF
*     Verification de la syntaxe
      IF (NUESSE.EQ.2.OR.NUESSE.EQ.3) THEN
         NUESS2=INDEX (TEXTE(NUEGAL:),TEXTE(MAX(1,NUEGAL-2):NUEGAL-1))
         IF (NUESS2.EQ.0) ERROR=1
      ENDIF
*
*     Numero de la premiere inconnue et type
*
      NUINC1=KELCHN (TEXTE(1:NCARL1),NOMINC,NBINCO,NCHINC)              !utilite
      IF (NUINC1.LE.0) CALL ERINCO (1,TEXTE(1:NCARL1))                  !utilite
      CALL SDEXCO (NUINC1,INCONU,NCPIN1,INTINL,NBTL)                    !utilite
      IF (NCPIN1.LE.1.AND.NUESSE.GT.1) CALL ERINCO (3,TEXTE(1:NCARL1))  !utilite
*
*     Delimitation de la chaine de caractere definissant la seconde inconnue
*
      IF (NUESSE.LE.1) THEN
         NCARL2=NCARL
      ELSEIF (NUESSE.LE.3) THEN
         NCARL2=NCARL-2
      ENDIF
*
*     Numero de la seconde inconnue et type
*
      NUINC2=KELCHN (TEXTE(NUEGAL+1:NCARL2),NOMINC,NBINCO,NCHINC)       !utilite
      IF (NUINC2.LE.0) CALL ERINCO (1,TEXTE(NUEGAL+1:NCARL2))           !utilite
      CALL SDEXCO (NUINC2,INCONU,NCPIN2,INTINL,NBTL)                    !utilite
      IF (NCPIN2.LE.1.AND.NUESSE.GT.1) 
     &   CALL ERINCO (1,TEXTE(NUEGAL+1:NCARL2))                         !utilite
*
      IF (NUINC1.EQ.NUINC2) THEN
*
*         Les inconnues doivent etre differentes
         WRITE (*,10021) TEXTE(1:NCAR)
         ERROR=1
      ELSEIF (NCPIN1.NE.NCPIN2) THEN
*
*        mais actuellement etre de meme type (scalaire, vectoriel)
         WRITE (*,10022) TEXTE(1:NCARL1),TEXTE(NUEGAL+1:NCARL2)
     &                  ,TEXTE(1:NCAR)
         ERROR=1
      ENDIF
      IF (ERROR.EQ.1) CALL REDERR (2,TEXTE(1:NCAR))
*
*     Nombre de composantes par noeuds de la donnee de la condition essentielle
*
      CALL CESSAT (NUESSE,NDIM,NCPIN1,NVALNE)                           !utilite
*
      CALL REDLE
      CALL PRFXMJ (-1,'*LcTran*')
*-----------------------------------------------------------------------
10004 FORMAT(T12,A8,T56,' , suivi de la chaine : ',A)
10021 FORMAT(' Les inconnues de la condition de transmission ',A
     &,' doivent differer.'/)
10022 FORMAT(' Nombre de composantes differentes pour les inconnues ',A
     &,' et ',A,/,' de la condition de transmission ',A,'.')
                                                                    END !LcTran
