*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCVANO (NUVANO,NVALNE,IRPLOC,ICORNE,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993) 
* Derniere modification : D.Martin (2 Mai 2002)
* Version 1.0.1
*  
* LeCture du type d'un terme 'VAleurs NOdales'  
*  
*-- Arguments d'entree -- 
* NIVIMP niveau d'impression
* IMPMES unite de sortie des messages 
*
*-- Arguments de sortie --
* NUVANO numero de type de terme 'Valeurs Nodales' :
*        description dans le source INVANO/utiliter
* NVALNE nombre de composantes de terme par noeud pour un terme de type 'F'
*     =1 terme scalaire (une valeur) par noeud
*     =2 terme vectoriel par noeud (transforme en NCPINC)
*     =4 terme matriciel/tensoriel par noeud (transforme en NCPINC*NCPINC)
* IRPLOC indice de calcul de repere local eventuellement modifie
* ICORNE indice de calcul des coordonnees des noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NUVANO,NVALNE,IRPLOC,ICORNE,NIVIMP,IMPMES
*
      INTEGER INVANO
      INTEGER INVANF,INVANT,NCOMLU
      INTEGER NFIX,IRE,NER,NCAR,ILU,IOP
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
	  CHARACTER TEXTE*80 
      COMMON/REDCOM/   TEXTE  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcVano*')
*
      IF (IRE.EQ.4) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.4) 
     &      WRITE (IMPMES,10004) '*LcVano*',NCAR,TEXTE(1:NCAR)
         NUVANO=INVANO (TEXTE(1:NCAR))                                  !utilite
         CALL REDLE
      ENDIF
*
      INVANF=INVANO ('F')                                               !utilite
      INVANT=INVANO ('TABF')                                            !utilite
      IF (NUVANO.NE.INVANF.AND.NUVANO.NE.INVANT) IRPLOC=1
      IF (NUVANO.NE.INVANT) ICORNE=1
*
      NCOMLU=0
      IF (IRE.EQ.3) THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.4) 
     &      WRITE (IMPMES,10003) '*LcVano*',TEXTE(1:NCAR)
*        Type (Scalaire, Vectoriel, Matriciel/Tensoriel) pour
*        un terme de type 'F' ou 'TABF'
         IF (TEXTE(1:8).EQ.'SCALAIRE') THEN
            NCOMLU=1
         ELSEIF (TEXTE(1:9).EQ.'VECTORIEL') THEN
            NCOMLU=2
         ELSEIF (TEXTE(1:9).EQ.'MATRICIEL'.OR.
     &           TEXTE(1:9).EQ.'TENSORIEL') THEN
            NCOMLU=4
         ENDIF
         IF (NCOMLU.NE.0) THEN
            IF (NUVANO.EQ.INVANF.OR.NUVANO.EQ.INVANT) THEN
               NVALNE=NCOMLU
            ENDIF
            CALL REDLE
         ENDIF
      ENDIF
*  
      CALL PRFXMJ (-1,'*LcVano*') 
*-----------------------------------------------------------------------
10003 FORMAT(T12,A8,T56,' , suivi du mot : ',A)  
10004 FORMAT(T12,A8,T56,' , suivi de la chaine (*',I2,') : ',A)
                                                                    END !LcVano
