*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECDOMA (NUMFIC,NDMDOM,NDMDOE,NBELDO,LISTEL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (23 Janvier 2001)
* Verson 1.0.1
*
* Ecriture des constituants d'un domaine geometrique
*
* NUMFIC unite de lecture du maillage
* NDMDOM dimension des constituants du domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NBELDO nombre de constituants du domaine : nombre d'elements 
*        ou nombre de couples (elements,faces) ou (elements,aretes) 
*        ou (elements,points)
* LISTEL liste des constituants
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER      NUMFIC,NDMDOM,NDMDOE,NBELDO,LISTEL(*)
*
      CHARACTER*50 FORMAD
      INTEGER      MIELDO,MXELDO,MXXLDO,NMFADO,INCLIS,NBCARE,NBCARF,I
*-----------------------------------------------------------------------
      MIELDO=999999999
      MXELDO=0
      NMFADO=0
      IF (NDMDOM.EQ.NDMDOE) THEN
         INCLIS=1
         DO 5 I=1,NBELDO
            MIELDO=MIN (MIELDO,LISTEL(I))
            MXELDO=MAX (MXELDO,LISTEL(I))
5        CONTINUE
      ELSE
         INCLIS=2
         DO 6 I=1,2*NBELDO,INCLIS
            MIELDO=0
            MXELDO=MAX (MXELDO,LISTEL(I))
            NMFADO=MAX (NMFADO,LISTEL(I+1))
6        CONTINUE
      ENDIF
*
*     Nombre de caracteres maximum pour un numero d'element
*
      NBCARE=2
      MXXLDO=MXELDO
8     MXXLDO=MXXLDO/10
      IF (MXXLDO.GE.1) THEN
        NBCARE=NBCARE+1
        GOTO 8
      ENDIF
*
*     Nombre de caracteres maximum pour un numero de face, d'arete, de point
*
      NBCARF=0
      IF (NDMDOM.NE.NDMDOE) THEN
         NBCARF=2
9        NMFADO=NMFADO/10
         IF (NMFADO.GE.1) THEN
           NBCARF=NBCARF+1
           GOTO 9
         ENDIF
      ENDIF
*
*     Creation du format variable pour la description des domaines
*
      FORMAD=' '
      IF (NDMDOM.EQ.NDMDOE) THEN
         FORMAD='(xx(''E'',Iyy,:,'' ''))'
         IF (MXELDO-MIELDO+1.EQ.NBELDO)
     &      FORMAD='(''Elements'',Iyy,'' /'',Iyy)'
      ELSEIF (NDMDOM.EQ.0) THEN
         FORMAD='(xx(''E'',Iyy,'' P'',Izz,:,'' ''))'
      ELSEIF (NDMDOM.EQ.2) THEN
         FORMAD='(xx(''E'',Iyy,'' F'',Iz,:,'' ''))'
      ELSEIF (NDMDOM.EQ.1) THEN
         FORMAD='(xx(''E'',Iyy,'' A'',Iz,:,'' ''))'
      ENDIF
      IF (NBCARF.GT.0) THEN
         IF (NDMDOM.EQ.0) THEN
            I=INDEX(FORMAD,'zz')
            CALL ENCLER (NBCARF,FORMAD(I:I+1))                          !utilite
         ELSE
            I=INDEX(FORMAD,'z')
            CALL ENCLER (NBCARF,FORMAD(I:I))                            !utilite
         ENDIF
         NBCARF=NBCARF+2
      ENDIF
*
      IF (NDMDOM.EQ.NDMDOE.AND.MXELDO-MIELDO+1.EQ.NBELDO) THEN
*
*        Les elements du domaine volumique ont des numeros consecutifs
*        On ne retient que les numeros extremes
*
         I=INDEX (FORMAD,'yy')
         CALL ENCLER (NBCARE,FORMAD(I:I+1))                             !utilite
         I=INDEX (FORMAD,'yy')
         CALL ENCLER (NBCARE,FORMAD(I:I+1))                             !utilite
         WRITE (NUMFIC,FORMAD) LISTEL(1),LISTEL(NBELDO)
*
      ELSE
*
*        Liste des composants du domaine
*
         I=INDEX (FORMAD,'yy')
         CALL ENCLER (NBCARE,FORMAD(I:I+1))                             !utilite
         NBCARE=3+NBCARE+NBCARF
         CALL ENCLER (80/NBCARE,FORMAD(2:3))                            !utilite
         WRITE (NUMFIC,FORMAD) (LISTEL(I),I=1,INCLIS*NBELDO)
*
      ENDIF
                                                                    END !EcDoma
