*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECELEM (ULMAIL,BLOKEL,NDIM,NBBBLK,NU1BLK,NBTEL,CORPTL
     &                  ,FORMAC,NUGPTL,FORMAN,NBDLMX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & G.Michel-Belmiloudi (Avril 1993)
* Derniere modification : D.Martin (30 Juin 1997)  
*  
* Ecriture des coordonnees et des numeros globaux des points du maillage, 
* element par element .
*  
*-- Arguments --  
* ULMAIL unite de lecture du maillage 
* BLOKEL tableau de description des elements par blocs
* NDIM   dimension d'espace
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du 1er bloc (utilise si 1 seul bloc) 
* NBTEL  nombre total d'elements du maillage  
* CORPTL tableau des coordonnees element par element  
* FORMAC format de d'ecriture des coordonnees
* NUGPTL tableau des coordonnees element par element 
* FORMAN format d'ecriture des numeros globaux
* NBDLMX 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FORMAC,FORMAN
      INTEGER       ULMAIL,BLOKEL(*),NDIM,NBBBLK,NU1BLK,NBTEL,NUGPTL(*)
     &             ,NBDLMX
      REAL          CORPTL(*)
*
      INTEGER       IACORG,IANUMG,L,NUTGEO,NBELBK,LGDBLK,IBLK,IEL,I,K
     &             ,LAG,KCL,NBSOMT,NBARET,NBFACE,NBNE,NBPTS,NBNF,NBPTSF
     &             ,NBNA,NBPTSA,INIT
      REAL          TRANS(3)
      CHARACTER*120 ERCODE
      COMMON/FORMAH/ERCODE
      DATA TRANS/0.,0.,0./
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EcElem*')
*  
      IACORG=2
      IANUMG=1 
      L=0  
      NUTGEO=NU1BLK
      NBELBK=NBTEL 
      IF (NBBBLK.GT.1) THEN 
         LGDBLK=BLOKEL(1)  
         NBELBK=BLOKEL(LGDBLK+1)
         INIT=LGDBLK+1+BLOKEL(3)
      ENDIF
      DO 10 IBLK=1,NBBBLK  
         CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBNE,NBPTS,NBNA,NBPTSA,NBNF,NBPTSF)
         DO 9 IEL=1,NBELBK 
            L=L+1  
*  
*-          Ecriture des coordonnees des points dans l'element  
* 
            WRITE (ULMAIL,FMT=FORMAC,ERR=90001)
     &            ((CORPTL(I+K-1)+TRANS(K),K=1,NDIM)
     &             ,I=IACORG,IACORG-1+NDIM*NBPTS,NDIM)
            IACORG=IACORG+NBDLMX*NDIM+1
*  
*-          Ecriture des numeros globaux des points dans l'element  
*
            WRITE (ULMAIL,FMT=FORMAN,ERR=90002)
     &            (NUGPTL(I),I=IANUMG,IANUMG-1+NBPTS)
            IANUMG=IANUMG+NBDLMX
9        CONTINUE  
         IF (NBBBLK.LE.1) GOTO 10  
            NBELBK=BLOKEL(INIT)
            NUTGEO=BLOKEL(INIT+1)  
            INIT=INIT+BLOKEL(3)
10    CONTINUE 
      CALL PRFXMJ (-1,'*EcElem*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL ENCLER (L,ERCODE(1:5))
      CALL ENCLER (ULMAIL,ERCODE(6:10))
      CALL ENCLER (NBPTS,ERCODE(11:12))
      CALL BAISE  (' Erreur d''ecriture des coordonnees des points de'
     &//' l''element'//FORMAN(1:5)//'('//FORMAN(11:12)
     &//' points) sur l''unite'//FORMAN(6:10))
90002 CALL ENCLER (L,ERCODE(1:5))
      CALL ENCLER (ULMAIL,ERCODE(6:10))
      CALL ENCLER (NBPTS,ERCODE(11:12))
      CALL BAISE  (' Erreur d''ecriture des numeros globaux de'
     &//' l''element '//FORMAN(1:5)//'('//FORMAN(11:12)
     &//' points) sur l''unite '//FORMAN(6:10))
                                                                    END !EcElem
