*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCCOMM (LGCOMM,TBCOMM,NBDOMG,NCHDOM,NOMDOM
     &                  ,NIVIMP,IMPMES)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)  
* Derniere modification : D.Martin (30 Juin 1997)
*  
* Creation du tableau #COMMU de communication inter-processeurs pour un calcul
* parallele par decomposition de domaine (MS3D)
*  
*-- Arguments -- 
* LGCOMM en entree, longueur du tableau a sa creation, en sortie longueur utile
* TBCOMM tableau
* NBDOMG nombre de domaines geometriques deja rencontres
* NCHDOM nombre de caracteres par nom de domaine
* NOMDOM tableau des noms de domaine  
* NIVIMP niveau d'impression
* IMPMES unite logique d'impression des messages
*
*-- Structure #COMMU
* (1) nombre de processeurs voisins du processeur courant P_c
* (2) numero du premier processeur voisin P_1
* (3) numero du domaine geometrique inter-processeur P_c <--> P_1
* (4) nb_1 = nombre de noeuds de l'interface commune
* (5) liste des noeuds de l'interface commune
*...
* (4+nb_1) numero du second processeur voisin P_2
* (5+nb_1) numero du domaine geometrique inter-processeur P_c <--> P_2
*... et aisni de suite
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*)    NOMDOM(*) 
      INTEGER          LGCOMM,TBCOMM(*),NBDOMG,NCHDOM,NIVIMP,IMPMES
*  
      CHARACTER        TEXT*4,TEXTE*80 
      INTEGER          KELCHN
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP
     &                ,NUDOMG,NBLIST,ADRS,ADRSDO,ADRSNB,NVOIS1
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXT(20)
      EQUIVALENCE     (TEXTE,TEXT(1))  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcComm*')
*
      ADRS=2
      NVOIS1=0
1     CALL REDLE
2     IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &   WRITE (IMPMES,10004) '*LcComm*',TEXTE(1:NCAR)
      IF (TEXTE(1:5).EQ.'INTER'.OR.TEXTE(1:10).EQ.'PROCESSEUR') GOTO 1
      IF (TEXTE(1:6).EQ.'VOISIN') THEN
         CALL REDLE
         IF (IRE.NE.1) CALL REDERR (11,' ')
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &      WRITE (IMPMES,10006) '*LcComm*',NFIX
*
*        Numero du processeur voisin en cours
         TBCOMM(ADRS)=NFIX
         NVOIS1=NVOIS1+1
         ADRS=ADRS+1
*        Adresse du numero du domaine
         ADRSDO=ADRS
         ADRS=ADRS+1
*        Adresse du nombre de noeuds du domaine
         ADRSNB=ADRS
*        Premiere adresse de la liste des noeuds du domaine
         ADRS=ADRS+1
         NUDOMG=0 
         NBLIST=0
         IF (ADRS.GT.LGCOMM) GOTO 99991
         GOTO 1
      ELSEIF (TEXT(1).EQ.'FRON'.OR.TEXT(1).EQ.'DOMA') THEN
         IF (NUDOMG.NE.0) CALL REDERR (3,TEXTE(1:NCAR))
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &      WRITE (IMPMES,10005) '*LcComm*',TEXTE(1:NCAR)
*
*        Lecture du domaine 'inter-processeur'
*
         CALL REDLEC(8)
         IF (NBDOMG.NE.0) 
     &      NUDOMG=KELCHN (TEXTE(1:NCAR),NOMDOM,NBDOMG,NCHDOM)          !utilite
         IF (NUDOMG.EQ.0) CALL REDERR (3,TEXTE(1:NCAR))
         TBCOMM(ADRSDO)=NUDOMG
         GOTO 1
      ELSEIF (TEXTE(1:7).EQ.'MESSAGE') THEN
         IF (NBLIST.GT.0) CALL REDERR (3,TEXTE(1:NCAR))
*
*        Lecture de la liste de points 'inter-processeur'
*
11       CALL REDLE
         IF (IRE.EQ.1) THEN
            NBLIST=NBLIST+1
            TBCOMM(ADRS)=NFIX
            ADRS=ADRS+1
            IF (ADRS.GT.LGCOMM) GOTO 99991
            GOTO 11
         ENDIF
         TBCOMM(ADRSNB)=NBLIST
         GOTO 2
      ENDIF
*     Longueur utile du tableau
      LGCOMM=ADRS-1
*     Nombre de processeurs voisins
      TBCOMM(1)=NVOIS1
      CALL PRFXMJ (-1,'*LcComm*')
      RETURN
*-----------------------------------------------------------------------
10004 FORMAT(T6,A8,T56,' , suivi du mot :,',A)
10005 FORMAT(T6,A8,T56,' , suivi de la chaine(*',I2,') : ',A)
10006 FORMAT(T6,A8,T56,' , suivi du nombre : ',I12)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRFXMJ (-1,'*LcComm*')
      CALL ENCLER (LGCOMM,TEXTE(1:12))
      CALL BAISE  ('*LcComm* Longueur ('//TEXTE(1:12)//') '
     &//'sous-estimee pour le tableau de communication inter processeur'
     &//' #COMMU.')
                                                                    END !LcComm
            
