*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCDESG (NBTEL,NBCNVE,VARIAB,LGVARI,NIVIMP,COMBAK 
     &                  ,NDIM,IMPMES,IMPSDR)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.DeBayser (Avril 1988)
* Derniere modification : D.Martin (3 Juillet 2000)
* Version 1.0.2
*  
* LeCture de la DEScription Globale du maillage
*  
*-- Arguments d'entree -- 
* NIVIMP indice d'impression des messages
* COMBAK caractere indiquant l'agrandissement necessaire de VARIAB
* IMPMES unite d'impression des messages
* IMPSDR unite d'impression secondaire
*-- Arguments de sortie --
* NBTEL  nombre total d'elements
* NBCNVE nombre de caracteres par nom de variable d'espace
* VARIAB tableau des noms de variables d'espaces
* LGVARI longueur du tableau VARIAB
* NDIM   dimension d'espace (= nombre des variables d'espace)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) VARIAB(*),COMBAK*1
      INTEGER       NBTEL,NBCNVE,LGVARI,NIVIMP,NDIM,IMPMES,IMPSDR
*
      CHARACTER TEXTE*80,FORM*120
      INTEGER   KELCHN
      INTEGER   NFIX,IRE,NER,NCAR,ILU,IOP,NUVARE,LGVARW,INDEXF,IV,ICAR
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   
      COMMON/REDCOM/TEXTE
      COMMON/FORMAH/FORM
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcDesG*')
*
      IF (COMBAK.NE.' ') GOTO 35
*
*     On a lu 'DESCription'
*     Lecture dans le desordre du nombre d'elements,
*                              du nom des variables d'espaces
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) WRITE (IMPSDR,10000) '*LcDesG*'
*
1     CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
*
2     IF (TEXTE(1:6).EQ.'GLOBAL'.OR.TEXTE(1:4).EQ.'MAIL'.OR
     &   .TEXTE(1:NCAR).EQ.'NOM'.OR.TEXTE(1:NCAR).EQ.'NOMBRE'.OR
     &   .TEXTE(1:4).EQ.'DESC'.OR.TEXTE(1:NCAR).EQ.'MESH'.OR
     &   .TEXTE(1:NCAR).EQ.'NAME'.OR.TEXTE(1:NCAR).EQ.'NUMBER') THEN
         GOTO 1
      ELSEIF (TEXTE(1:7).EQ.'ELEMENT') THEN
         GOTO 20
      ELSEIF (TEXTE(1:8).EQ.'VARIABLE'.OR.TEXTE(1:NCAR).EQ.'SPACE') THEN
         GOTO 30
      ELSE
         GOTO 50
      ENDIF
      IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &   WRITE (IMPMES,10004) '*LcDesG*',TEXTE(1:NCAR)
*  
*--      Lecture du nombre d'elements du maillage
*
20       CALL REDLE
         IF (IRE.NE.1) CALL REDERR (11,' ')
*        En cas de maillage sur multiple fichiers
         NBTEL=NBTEL+NFIX
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPMES,10006) '*LcDesG*',NFIX
         GOTO 1
*  
*--      Lecture des noms (et calul du nombre) de variables d'espace
*
30       CALL REDLE
         IF (TEXTE(1:NCAR).EQ.'ESPACE'.OR.TEXTE(1:8).EQ.'VARIABLE')
     &      GOTO 30
         IF (IRE.NE.4) GOTO 2
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPMES,10005) '*LcDesG*',NCAR,TEXTE(1:NCAR)
*
         IF (NDIM.GE.3) GOTO 30
         NUVARE=0
         IF (NDIM.GT.0) NUVARE=KELCHN (TEXTE(1:NCAR),VARIAB,NDIM,NBCNVE)!utilite
         IF (NUVARE.EQ.0) THEN
*           Le nom de variable d'espace n'existe pas dans VARIAB :
*           verification de la taille de VARIAB
            LGVARW=(NDIM+1)*MAX(NBCNVE,NCAR)
            IF (LGVARW.GT.LGVARI) THEN
               COMBAK='v'
               LGVARI=LGVARW
               CALL PRFXMJ (-1,'*LcDesG*')
               RETURN
            ENDIF
         ENDIF
*  
35       COMBAK=' '
*
*        Introduction du nouveau nom de variable d'espace dans (#ARIAB,1)
*
         IF (NUVARE.EQ.0) CALL RIPCHN (VARIAB,NDIM,NBCNVE,TEXTE(1:NCAR))!utilite
         GOTO 30
*  
*--   Impressions des donnees descriptives globales du maillage
*
50    IF (NDIM.LE.0)
     &CALL BAISE  ('Dimension d''espace NULLE. Ca commence mal !')
      LGVARI=NDIM*NBCNVE
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) THEN 
         FORM='(T11,''Variables d''''espace'',TR13,'': '',' 
     &        //CHAR(NDIM+48)//'(??A1:,'' , ''))'
         INDEXF=INDEX(FORM,'??')
         CALL ENCLER (NBCNVE,FORM(INDEXF:INDEXF+1))                     !utilite
         WRITE (IMPSDR,FORM)
     &         ((VARIAB((IV-1)*NBCNVE+ICAR),ICAR=1,NBCNVE),IV=1,NDIM)
         WRITE (IMPSDR,10002) NBTEL 
      ENDIF
      CALL PRFXMJ (-1,'*LcDesG*')
*-----------------------------------------------------------------------
10000 FORMAT(/T5,A8,'   Description globale du maillage') 
10002 FORMAT(T11,'Nombre d''elements du maillage',T42,': ',I6) 
10004 FORMAT(T6,A8,' Lecture de la sous-directive : ',A)
10005 FORMAT(T6,A8,T56,' , suivi de la chaine(*',I2,') : ',A)
10006 FORMAT(T6,A8,T56,' , suivi du nombre : ',I12)
                                                                    END !LcDesG
