*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCDESL (NDIM,NBTEL,NBPTEX,NBPTFX,INTRPG,NIVENG
     &                  ,NBBBLK,NU1BLK,LGEBLK,INCBLK,LGBLOK,BLOKEL
     &                  ,FORMES,NBLTYP,NULTYP,NIVIMP,LGFORM,COMBAK,NK
     &                  ,IMPMES,IMPSDR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (avril 1988)
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Lecture de la Description du Maillage element par element
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* NBTEL  nombre total d'elements du maillage  
* NIVIMP unite logique d'impression des messages
* IMPMES unite logique d'impression des messages  
* IMPSDR unite logique d'impression secondaire
*
*-- Arguments de sortie --
* NBPTEX nombre max. de points dans un element du maillage
* NBPTFX   -     -        -    dans une face ou une arete d'un elt.
* INTRPG numero de type de l'interpolation geometrique
* NIVENG niveau du tableau #GNEEL de numerot. globale geometrique 
*         (= INTRPG sauf en cas d'interpolation geometrique d'Hermite) 
* NBBBLK nombre de blocs d'elements consecutifs de meme type dans le maillage 
* NU1BLK numero de type des elements du premier bloc (utilise si 1 seul bloc) 
* LGEBLK longueur de l'entete du tableau #LOKEL
* INCBLK increment de parcour du tableau #LOKEL
* LGBLOK longueur du tableau #LOKEL
* FORMES tableau des noms des formes d'elements . 
* LGFORM longueur du tableau FORMES
* BLOKEL tableau des types des blocs d'elements du maillage
* COMBAK caractere indiquant un agrandissement necessaire de #GLOBA
* NK     adresse dans BLOKEL pour le bloc suivant (si COMBAK.NE.' ') 
* 
*-- Tableaux de travail --
* NBLTYP nombre d'elements par type
* NULTYP leurs numeros de type
*  
* ->Remarque : Structure du tableau BLOKEL 
*  
* BLOKEL(1)=LGEBLK longueur de l'en-tete du tableau
* BLOKEL(2)=NBBBLK nombre de blocs
* BLOKEL(3)=INCBLK increment de parcours dans le tableau (pour le passage 
*                    d'un bloc au suivant)
* BLOKEL(BLOKEL(1)+1+(K-1)*BLOKEL(3)) nombre d'elements du bloc K
* BLOKEL(BLOKEL(1)+2+(K-1)*BLOKEL(3)) numeros de type des elements du bloc K

*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) COMBAK*1,FORMES(*)
      INTEGER       NDIM,NBTEL,NBPTEX,NBPTFX,INTRPG,NIVENG,NBBBLK,NU1BLK
     &             ,LGEBLK,INCBLK,LGBLOK,BLOKEL(*),IMPMES,IMPSDR
     &             ,NBLTYP(0:*),NULTYP(0:*),NIVIMP,LGFORM,NK
*  
      CHARACTER     TEXT*4,TEXTE*80
      CHARACTER*2   FORMEL,ELT(7)
      INTEGER       KELCHN,NUTYEL
      INTEGER       NFIX,IRE,NER,NCAR,ILU,IOP,INTINC,INTINP
     &             ,FELT,NUTGEO,INTRPA,NDIMEL,NFORMG,NBFORM
     &             ,NBSOMX,NBAREX,NBFACX,NBNEEX,NBNEAX,NBDLAX,NBNEFX
     &             ,IDLHRM,I,IBLK,LP
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   
      COMMON/REDCOM/TEXT(20)
      EQUIVALENCE   (TEXTE,TEXT(1))
      DATA ELT     /'HE','PR','TE','PY','QU','TR','SE'/  
*-----------------------------------------------------------------------
      IF (COMBAK.EQ.'g') GOTO 4
      IF (COMBAK.EQ.'c') THEN
         BLOKEL(1)=LGEBLK  
         BLOKEL(3)=INCBLK  
         NK=LGEBLK+1
         BLOKEL(NK)=NBBBLK 
         NK=NK+1
         BLOKEL(NK)=NU1BLK 
         NBBBLK=1  
         GOTO 1
      ENDIF
*  
      CALL PRFXMJ (1,'*LcDesL*')
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) WRITE(IMPSDR,10000) '*LcDesL*'
*     Mise a zero du nombre de blocs et du max de points par element
*  
*     Lecture du type des elements du bloc.
*  
1     IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (TEXTE(1:4).NE.'BLOC') CALL REDERR (4,'BLOC')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &   WRITE (IMPMES,10005) '*LcDesL*',TEXTE(1:NCAR) 
*
*     Lectures de mots definissant le bloc d'element
*
2     CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
*
      IF (TEXTE(1:4).EQ.'TYPE'.OR.TEXTE(1:4).EQ.'GEOM') THEN
*
*        On a lu BLOC [DE] [TYPE] [GEOMetrique]
*
         GOTO 2
*
      ELSEIF (NCAR.GT.5) THEN
*
         INTINC=0
         INTINP=0
         FELT=KELCHN (TEXTE(1:2),ELT,7,2)                               !utilite
         IF (FELT.LE.0) THEN
            CALL REDERR (2,TEXTE(1:NCAR))                               !redlib
         ELSE
*
*           On a lu BLOC [D'/DE] < HEXAEDRES / PRISMES / TETRADEDRES
*                                / QUADRANGLES / TRIANGLES / SEGMENTS >
*
            FORMEL=ELT(FELT)
*
3           CALL REDLE
            IF (IRE.NE.3) CALL REDERR (13,' ')
            IF (TEXTE(1:8).EQ.'LAGRANGE') GOTO 3
            IF (TEXTE(1:5).EQ.'DEGRE'.OR.TEXTE(1:5).EQ.'ORDRE') THEN
               CALL REDLEC (1)                  
               INTINP=INTINP+NFIX
            ELSEIF (TEXTE(1:6).EQ.'POINTS'.OR.TEXTE(1:6).EQ.'ABSCIS'
     &       .OR.TEXTE(1:11).EQ.'EQUIDISTANT') THEN
               INTINC=0
               GOTO 3
            ELSEIF (TEXTE(1:13).EQ.'GAUSS-LOBATTO') THEN
               INTINC=100
               GOTO 3
            ELSEIF (NCAR.LE.3.AND.
     &             (TEXTE(1:1).EQ.'P'.OR.TEXTE(1:1).EQ.'Q')) THEN
               CALL RELCNE (TEXTE(2:NCAR),INTINP)                       !redlib
            ELSE
               CALL REDERR (2,TEXTE(1:NCAR))                            !redlib
            ENDIF
*
*           Definition des elements du bloc
*
            TEXTE(1:2)=FORMEL
            INTINP=INTINC+INTINP
            IF (INTINP.LE.9) THEN
               TEXTE(3:4)='00'
               CALL ENCLER (INTINP,TEXTE(5:5))                          !utilite
            ELSEIF (INTINP.LE.99) THEN
               TEXTE(3:3)='0'
               CALL ENCLER (INTINP,TEXTE(4:5))                          !utilite
            ELSE
               CALL ENCLER (INTINP,TEXTE(3:5))                          !utilite
            ENDIF 
         ENDIF
      ENDIF
*     On a rencontre un nouveau bloc d'elements
*     Le tableau '#LOKEL' est-il assez grand ?  
      IF (NBBBLK.GE.1.AND.LGEBLK+INCBLK*(NBBBLK+1).GT.LGBLOK) THEN  
         LGBLOK=LGBLOK+100*INCBLK  
         COMBAK='g'
         RETURN
      ENDIF
*  
4     COMBAK=' '
*
*     Numero de type des elements du bloc
*
      NUTGEO=NUTYEL(TEXTE(1:NCAR))                                       !ef3d
*
*     Type des elements du bloc
*
      INTRPA=INTRPG
      CALL NUSPLT (NUTGEO, NDIMEL, NFORMG, INTRPG)
      NFORMG=NFORMG+NDIMEL-1
      IF (NDIMEL.GE.3) NFORMG=NFORMG+1
      IF (INTRPG.NE.INTRPA.AND.NBBBLK.GE.1) GOTO 99991
*
*     Lecture du nombre d'elements du bloc
*
      CALL REDLE
      IF (IRE.NE.1) CALL REDERR (11,' ')
      IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &   WRITE(IMPMES,10006) '*LcDesL*',TEXTE(1:NCAR),NFIX
      NBLTYP(NFORMG)=NBLTYP(NFORMG)+NFIX
      NULTYP(NFORMG)=NUTGEO
*     Lecture du mot obligatoire ELEMENT (fin de la sous-directive BLOC)
      CALL REDLE
      IF (IRE.NE.3) CALL REDERR (13,' ')
      IF (TEXTE(1:7).NE.'ELEMENT') CALL REDERR (4,'ELEMENTS')
*
*     A-t-on vu tous les elements du maillage ?
*
      LP=0 
      DO 9 NFORMG=0,6
         LP=LP+NBLTYP(NFORMG)
9     CONTINUE  
      IF (LP.LT.NBTEL) THEN 
         CALL REDLE
         IF (NBBBLK.EQ.0) THEN  
            COMBAK='c' 
            LGBLOK=LGEBLK+5*INCBLK 
            NU1BLK=NUTGEO  
*           detournement de memoire pour retenir NBELBK du 1er bloc
            NBBBLK=NFIX
            RETURN 
         ENDIF
*        Mise a jour du tableau BLOKEL 
         NBBBLK=NBBBLK+1
         NK=NK+1
*        Nombre d'elements du NK-eme bloc  
         BLOKEL(NK)=NFIX
         NK=NK+1
*        Numero de type des elements du NK-eme bloc
         BLOKEL(NK)=NUTGEO 
         GOTO 1
      ELSEIF (NBBBLK.EQ.0) THEN
         NBBBLK=1  
         NU1BLK=NUTGEO 
         GOTO 10  
      ELSE 
*        mise a jour du tableau BLOKEL pour le dernier bloc
         NBBBLK=NBBBLK+1
         BLOKEL(2)=NBBBLK  
         NK=NK+1
*        Nombre d'elements du dernier bloc 
         BLOKEL(NK)=NFIX
         NK=NK+1
*        Numero de type des elements du dernier bloc
         BLOKEL(NK)=NUTGEO 
      ENDIF
*  
*     Nombre max. de point par element et par face/arete d'element 
*
10    CALL MAXNBL (INTRPG,NBBBLK,NU1BLK,BLOKEL,NIVENG,NBSOMX,NBAREX
     &            ,NBFACX,NBNEEX,NBPTEX,NBNEAX,NBDLAX,NBNEFX,NBPTFX)    !sdexplo
*  
*     Mise a zero du niveau du tableau de la numerotation globale (NGNEEL) 
*     dans le cas ou l'interpolation geometrique est de type Hermite (!!!) 
      IDLHRM=NIVENG
      NIVENG=INTRPG
      IF (IDLHRM.NE.0) NIVENG=0
*
      LGFORM=0
      NBFORM=0
      CALL RIPCHN (FORMES,NBFORM,LGFORM,'   Segments')                  !utilite
      IF (NDIM.GE.2) THEN
         CALL RIPCHN (FORMES,NBFORM,LGFORM,'Quadrangles')               !utilite
         CALL RIPCHN (FORMES,NBFORM,LGFORM,'  Triangles')               !utilite
         IF (NDIM.GE.3) THEN
            CALL RIPCHN (FORMES,NBFORM,LGFORM,'  Hexaedres')            !utilite
            CALL RIPCHN (FORMES,NBFORM,LGFORM,'    Prismes')            !utilite
            CALL RIPCHN (FORMES,NBFORM,LGFORM,' Tetraedres')            !utilite
            CALL RIPCHN (FORMES,NBFORM,LGFORM,'  Pyramides')            !utilite
         ENDIF
      ENDIF
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) THEN
         DO 20 NFORMG=0,NBFORM-1
            LP=NBLTYP(NFORMG)
            IF (LP.GT.0) WRITE (IMPSDR,10003) NULTYP(NFORMG),LP
     &                  ,(FORMES(LGFORM*NFORMG+I),I=1,LGFORM-1)
20       CONTINUE  
*  
*        Impressions detaillees
         IF (NBBBLK.GT.1) THEN
            WRITE (IMPSDR,10004) (IBLK,(BLOKEL(BLOKEL(1)
     &      +(IBLK-1)*BLOKEL(3)+I),I=1,BLOKEL(3)),IBLK=1,BLOKEL(2))
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*LcDesL*')
      RETURN 
*-----------------------------------------------------------------------
10000 FORMAT(/T5,A8,'  Description elementaire du maillage')
10003 FORMAT(T11,'Nombre d''elements de type #',I5,' :',I5,' -> ',11A1)
10004 FORMAT(T11,'Bloc',I4,'  , ',I5,' elements de type geometrique'
     &,' # ',I7)
10005 FORMAT(T6,A8,' Lecture de la sous-directive : ',A) 
10006 FORMAT(T6,A8,T56,' , suivi du mot : ',A,' , puis du NOMBRE : ',I8) 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('L''ordre de l''interpolation geometrique n''est pas'
     &           //' le meme pour tous les blocs d''elements.')
                                                                    END !LcDesL
