*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCDOMA (LISTEL,NBTEL,BLOKEL,NUDLFA,IRCODE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (30 Janvier 2002)
* Version 1.0.3
*  
* Constitution d'un domaine geometrique
*  
*-- Arguments d'entree --
* NBTEL  nombre total d'elements du maillage
* BLOKEL tableau des types d'elements par bloc d'elements de meme type
* NUDLFA tableau local, inutilise ici mais rempli dans ELEMFA
* IRCODE indicateur d'erreur
*  
*-- Argument de sortie -- 
* LISTEL : Definition des elements du domaine en cours 
*    LISTEL(1) = LGLIST longueur effective du tableau LISTEL
*    LISTEL(2) = NDMDOM dimension (des constituants) du domaine
*    LISTEL(3) = NDMDOE dimension des elements supports des constituants
*                       du domaine
*    LISTEL(4) = NBELDO nombre d'elements supports des constituants
*    LISTEL(5) = ?????? inutilise
*    LISTEL(6) = NBDLEX nombre maximum de points par element
*    si NDMDOM = NDMDOE > 0 :
*       LISTEL(7 a  6+NBELDO)  =  Numeros des elements
*    si NDMDOM < NDMDOE et NDMDOM > 0 :
*       LISTEL(7) = ?????? inutilise
*       LISTEL(8) = NBDLFX nombre max. de points par face
*       LISTEL(9 a 8+NBELDO*2) = couples de numeros (element,face)
*    si NDMDOM = 0 :
*       LISTEL(7) = NBCPDO nombre de couples (element,point)
*       LISTEL(8) = 1      inutilise
*       LISTEL(9 a 8+2*NBCPDO) = Couples de numeros: (element,point)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  LISTEL(*),NBTEL,BLOKEL(*),NUDLFA(*),IRCODE
*  
      CHARACTER TEXT*4,MOTLU*4,TEXTE*80
      INTEGER   NFIX,IRE,NER,NCAR,ILU,IOP
     &         ,NBCPDO,NDMDAV,NUTGAV,NUTGAW,NBELDO,LGLIST
     &         ,NUFAAV,NUTGEO,NDMDOM,NDMDOE,L,LL
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXT(20)
      EQUIVALENCE     (TEXTE,TEXT(1))  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcDoma*')
*  
*     Debut de la 'boucle' de lecture des donnees des domaines du maillage 
*
      LGLIST=LISTEL(1)
      NDMDOM=LISTEL(2)
      NDMDOE=LISTEL(3)
      NDMDAV=NDMDOM
      NBELDO=LISTEL(4)
      NBCPDO=LISTEL(7)
      NUTGAV=0
      NUTGAW=0
      NUFAAV=0
      MOTLU=' '
*  
      CALL REDLE
*
      IF (IRE.NE.3.AND.TEXTE(1:1).NE.'E') CALL REDERR (4,'E(LEMENT)')
* 
*     On a lu 'E(LEMENT)', on va lire son numero
*
20    IRCODE=0
      CALL LCELDO (BLOKEL,NDMDOM,NDMDOE,NBELDO,NUTGEO,NUTGAV
     &            ,LISTEL,LGLIST,MOTLU,IRCODE)                          !lecgeom
      IF (IRCODE.GT.0) RETURN
      IF (MOTLU.NE.'DOMA'.AND.MOTLU.NE.'FIN ') THEN
*  
*        Cas d'un domaine de bord
*  
         CALL LCFADO (MOTLU,NDMDOM,NDMDOE,NDMDAV,NBCPDO,NBELDO,NUTGEO
     &               ,NUTGAW,NUFAAV,NUDLFA,LISTEL,LGLIST,IRCODE)        !lecgeom
         IF (IRCODE.LT.0) RETURN
         IF (TEXTE(1:1).EQ.'E') GOTO 20
*
      ENDIF
*
      LISTEL(1)=LGLIST
      LISTEL(2)=NDMDOM
      LISTEL(3)=NDMDOE
      LISTEL(4)=NBELDO
      IF (NDMDOM.EQ.0) THEN
         LISTEL(7)=NBCPDO
         LISTEL(8)=1
      ENDIF
*
      IF (NDMDOM.EQ.NDMDOE) THEN
         LL=7
         CALL TRI1TB (NBELDO,1,LISTEL(LL))
         DO 100 L=2,NBELDO
            IF (LISTEL(LL).EQ.LISTEL(LL+1))  THEN
               IRCODE=-LISTEL(LL)
               RETURN
            ENDIF
            LL=LL+1
100      CONTINUE
      ELSEIF (NDMDOM.GT.0) THEN
         LL=9
         CALL TRI1TB (NBELDO,2,LISTEL(LL))
         DO 101 L=2,NBELDO
            IF (LISTEL(LL).EQ.LISTEL(LL+2)
     &     .AND.LISTEL(LL+1).EQ.LISTEL(LL+3))  THEN
               IRCODE=LISTEL(LL)
               RETURN
            ENDIF
            LL=LL+2
101      CONTINUE
      ELSE
         CALL TRI1TB (NBCPDO,2,LISTEL(9))
      ENDIF
*
      CALL PRFXMJ (-1,'*LcDoma*')
*-----------------------------------------------------------------------
                                                                    END !LcDoma
