*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCELDO (BLOKEL,NDMDOM,NDMDOE,NBELDO,NUTGEO
     &                  ,NUTGAV,LISTEL,LGLIST,MOTLU,IRCODE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (30 Juin 2000)
* Version 1.0.1
*  
* Lecture des numeros des elements constituants un domaine 
*
*-- Arguments d'entree --
* BLOKEL tableau des types d'elements par bloc d'elements de meme type
* NDMDOM dimension (des constituants) du domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NBELDO nombre d'elements (supports des constituants) du domaine
* NUTGEO numero de type de l'element courant
* NUTGAV numero de type de l'element precedent
* LISTEL tableau definissant des elements du domaine en cours
* LGLIST longueur utile actuelle du tableau LISTEL
*-- Arguments de sortie
* MOTLU  dernier mot lu en sortie de la procedure
* IRCODE indicateur d'erreur
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) MOTLU
      INTEGER       BLOKEL(*),NUTGEO,NUTGAV,NBELDO
     &             ,NDMDOM,NDMDOE,LISTEL(*),LGLIST,IRCODE
*  
      CHARACTER     TEXT*4,TEXTE*80
      INTEGER       NFIX,IRE,NER,NCAR,ILU,IOP,LAG,KCL,NBSOMT,NBARET
     &             ,NDIMEL,NBFACE,NBPT,NBDLEL,NBNF,NBPTSF,NBNA,NBPTSA
     &             ,LULIST,L1LIST,L2LIST,ILIST
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   
      COMMON/REDCOM/TEXT(20)
      EQUIVALENCE      (TEXTE,TEXT(1))  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcEldo*')
*
      LULIST=0
2     CALL REDLE
      IF (NBELDO.EQ.0) THEN
         IF (IRE.NE.1) CALL REDERR (11,' ')
         L1LIST=NFIX
         L2LIST=NFIX
      ELSE
         IF (IRE.EQ.3.AND.TEXTE(1:1).EQ.'/') THEN
*
*           Numeros donnes par une liste ( &I1 / &In )
*           L'element I1 a deja ete retenu en compte, la liste commence
*           donc a I1+1
*
            LULIST=1
            L1LIST=LISTEL(LGLIST)+1
            GOTO 2
         ELSEIF (IRE.NE.1) THEN
            GOTO 3
         ENDIF
         IF (NFIX.LE.0) THEN
*           Probleme de traduction de maillage
            IRCODE=NBELDO+1
            RETURN
         ENDIF
*        Dernier element de la liste s'il s'agit d'une liste
*        Element actuel sinon
         L2LIST=NFIX
         IF (LULIST.EQ.1) THEN
             LULIST=0
         ELSE
             L1LIST=L2LIST
         ENDIF
      ENDIF
*
*     Renseignement de LISTEL pour l'element ou les elements de la liste
*
      DO 20 ILIST=L1LIST,L2LIST
         LGLIST=LGLIST+1
         LISTEL(LGLIST)=ILIST
         NBELDO=NBELDO+1
*
*        Recherche du type (geometrique) de l'element courant
*
         CALL EXBLOK (ILIST,BLOKEL,NUTGEO)                              !sdexplo
         NDIMEL=NUTGEO/10000
         IF (NDMDOM.EQ.99999) THEN
            NDMDOM=NDIMEL
            NDMDOE=NDMDOM
         ELSEIF (NDMDOM.EQ.NDMDOE.AND.NDMDOM.NE.NDIMEL) THEN
            CALL BAISE  ('Elements de dimensions differentes sur'
     &               //' un meme geometrique, cas interdit.')
         ENDIF
         IF (NUTGEO.NE.NUTGAV) THEN
*           Nombre de points de l'element (d.l. geometriques)
            CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &                  ,NBPT,NBDLEL,NBNA,NBPTSA,NBNF,NBPTSF)           !ef3d
            LISTEL(5)=MAX(NBPT,LISTEL(5))
            LISTEL(6)=MAX(NBDLEL,LISTEL(6))
            NUTGAV=NUTGEO
         ENDIF
20    CONTINUE
      GOTO 2  
*  
3     IF (IRE.NE.3) CALL REDERR (13,' ')
      MOTLU(1:4)=TEXT(1)
      IF (MOTLU(1:1).EQ.'E') GOTO 2
*     Si on arrive ici, on a rencontre un domaine de bord
*     On decale LISTEL de 2 ... (cf. definition)
      IF (NBELDO.EQ.1.AND.MOTLU(1:4).NE.'DOMA'.AND.MOTLU(1:3).NE.'FIN')
     & THEN
         LGLIST=LGLIST+2
         LISTEL(LGLIST)=LISTEL(7)
         LISTEL(7)=0
         LISTEL(8)=0
      ENDIF
      CALL PRFXMJ (-1,'*LcEldo*')
*-----------------------------------------------------------------------
                                                                    END !LcEldo
