*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCFADO (MOTLU,NDMDOM,NDMDOE,NDMDAV,NBCPDO,NBELDO
     &                  ,NUTGEO,NUTGAW,NUFAAV,NUDLFA,LISTEL,LGLIST
     &                  ,IRCODE)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1988) 
* Derniere modification : D.Martin (30 Juin 2000)
* Version 1.0.2
*
* Lecture des numeros de faces et d'aretes des elements d'un domaine
*
*-- Arguments d'entree --
* MOTLU  dernier mot lu en entree de la procedure
* NDMDOM dimension (des constituants) du domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NDMDAV dimension des precedents
* NBCPDO nombre de constituants du domaine
* NBELDO nombre d'elements (supports des constituants) du domaine
* NUTGEO numero de type de l'element support du constituant courant
* NUTGAW numero de type de l'element precedent
* NUFAAV numero de face ou d'arete du constituant precedent
* NUDLFA tableau de travail necessaire a l'appel de Elemfa
* LISTEL tableau definissant des elements du domaine en cours
* LGLIST longueur utile actuelle du tableau LISTEL
* IRCODE indicateur d'erreur
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) MOTLU
      INTEGER       NDMDOM,NDMDOE,NDMDAV,NBCPDO,NBELDO,NUTGEO,NUTGAW
     &             ,NUFAAV,NUDLFA(*),LISTEL(*),LGLIST,IRCODE
*  
      CHARACTER        TEXT*4,TEXTE*80
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,IB
     &                ,NBNEFX,NBDLFX
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)   
      COMMON/REDCOM/TEXT(20)
      EQUIVALENCE (TEXTE,TEXT(1))  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LcFado*')
      NDMDOM=99999 
*
40    CALL REDLE
*
*     On doit ici avoir lu un entier positif
*
      IF (IRE.NE.1) CALL REDERR (11,' ')
      IF (NFIX.LE.0) THEN
*        Probleme de traduction de maillage
         IRCODE=-NBELDO
         RETURN
      ENDIF
*
50    IF (MOTLU(1:1).EQ.'P') NDMDOM=0
      IF (MOTLU(1:1).EQ.'F'.AND.MOTLU(1:3).NE.'FIN') NDMDOM=NDMDOE-1
      IF (MOTLU(1:1).EQ.'A') NDMDOM=1
*
      IF (NDMDOM.EQ.99999) GOTO 99999
*
      IF (NDMDAV.NE.99999.AND.NDMDOM.NE.NDMDAV)
     &    CALL BAISE  ('Elements de dimensions differentes sur un meme'
     &               //' geometrique, cas interdit.')
*
      IF ((NUTGEO.NE.NUTGAW.OR.NFIX.NE.NUFAAV).AND.NDMDOM.GT.0) THEN
         CALL ELEMFA (NUTGEO,NDMDOM,NFIX,IB,NBNEFX,NUDLFA,NBDLFX,NUDLFA)!ef3d
*         LISTEL(7)=MAX (LISTEL(7),NBNEFX)
         LISTEL(8)=MAX (LISTEL(8),NBDLFX)
         NUTGAW=NUTGEO 
         NUFAAV=NFIX
      ENDIF
      NDMDAV=NDMDOM
*
*     Renseignements de la structure #ISTEL pour la face / l'arete lue
*
      LGLIST=LGLIST+1  
      LISTEL(LGLIST)=NFIX  
      NBCPDO=NBCPDO+1
*
      CALL REDLE
      IF (IRE.EQ.1) THEN
         LGLIST=LGLIST+1
         LISTEL(LGLIST)=LISTEL(LGLIST-2)
         NBELDO=NBELDO+1
         GOTO 50
      ELSEIF (IRE.EQ.3) THEN
         IF (TEXTE(1:1).NE.MOTLU(1:1).OR.TEXTE(1:3).EQ.'FIN') GOTO 99999
         LGLIST=LGLIST+1
         LISTEL(LGLIST)=LISTEL(LGLIST-2)
         NBELDO=NBELDO+1
         GOTO 40
      ENDIF
99999 CALL PRFXMJ (-1,'*LcFado*')
*-----------------------------------------------------------------------  
                                                                    END !LcFado
