*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LCGEOM 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Avril 1988) 
* Derniere modification : D.Martin (1er Juillet 2000)
* Version 1.0.1
*  
* LeCture de la GEOMetrie sur le fichier de transfert du maillage  
*  
* A la fin de LCGEOM on connait les elements du Common
* /GLOBAL/  parametres globaux du maillage et les tableaux suivants 
*  
* #LOKEL tableau BLOKEL de description des blocs d'elements
* #ARIAB tableau des noms des variables d'espace
* #ORPTL coordonnees des points element par element
* #GNEEL numeros globaux des points element par element
* #OMDOM noms des domaines geometriques
* #ISTEL liste des 'elements' constituants des domaines geometriques
*        un tableau LISTEL par domaine geometrique (niveau=numero du domaine)
*
* Mots-clefs de la directive GEOMETRIE (lus dans le fichier des directives)
* ------------------------------------
*
*  < GEOMETRIE / MAILLAGE / MESH >
*     < LECTURE [SUR] [FICHIER/UNITE] &C / IMPRESSION DE NIVEAU &I >
*     < READ [ON][FROM] [FILE/UNIT] &C / PRINT[ING] LEVEL &I >
*
*-- Procedure appelee --
* LCGMAI lecture proprement dite du fichier de maillage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*  
      CHARACTER        TEXTE*80
      INTEGER          NIVIMP,NFIX,IRE,NER,NCAR,ILU,IOP
     &                ,NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
     &                ,LUGEOM,LECOLD,INUSE1,INUSE2
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      COMMON/REDCA1/   NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDLST/   LECOLD,INUSE1,INUSE2
*-----------------------------------------------------------------------
      NIVIMP=0
      LUGEOM=0
      CALL PRFXMJ (1,'*LcGeom*')
*
1     IF (IRE.NE.3) CALL REDERR (13,' ')
*
      IF (TEXTE(1:7).EQ.'GEOMETR'.OR.
     &    TEXTE(1:NCAR).EQ.'MAILLAGE'.OR.TEXTE(1:NCAR).EQ.'MESH') THEN
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPMES,10001) '*LcGeom*',TEXTE(1:NCAR)
         LUGEOM=LUGEOM+1
         CALL REDLE
         GOTO 1
*
      ELSEIF (TEXTE(1:NCAR).EQ.'IMPRESSION'
     &    .OR.TEXTE(1:5).EQ.'PRINT') THEN
*
*--      Lecture du niveau d'impression du maillage
*
         IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPMES,10000) '*LcGeom*',TEXTE(1:NCAR)
         NIVIMP=1
         CALL REDLE
         IF (IRE.EQ.3.AND.(TEXTE(1:NCAR).EQ.'NIVEAU'
     &                 .OR.TEXTE(1:NCAR).EQ.'LEVEL')) CALL REDLE
         IF (IRE.EQ.1) THEN
            NIVIMP=NFIX
            IF (IMPMES.GT.0.AND.NIVIMP.GT.0)
     &          WRITE (IMPMES,10006) '*LcGeom*',NFIX
            CALL REDLE
         ENDIF
         GOTO 1
*
      ENDIF
*
      IF (LUGEOM.LE.0) CALL REDERR (4,'MAILLAGE / MESH')
*  
*--   Lecture de l'unite de lecture des donnees du maillage
*
      IF (IMPMES.GT.0.AND.NIVIMP.GT.0) 
     &   WRITE (IMPMES,10000) '*LcGeom*',TEXTE(1:NCAR)
*
*--   Lecture du fichier de maillage
*
      CALL LCGMAI (NIVIMP)                                              !lecgeom
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) WRITE (IMPSDR,10003) '*LcGeom*'
      CALL PRFXMJ (-1,'*LcGeom*')
*-----------------------------------------------------------------------
10000 FORMAT(T3,A8,' Lecture de la sous-directive :',A)
10001 FORMAT(/T2,A8,' ->Debut de la Directive : ',A)
10003 FORMAT(/T3,A8,'  ',70('*'),' Fin de lecture du maillage ',6('*'))
10006 FORMAT(T3,A8,T56,' , suivi du nombre : ',I12)
                                                                    END !LcGeom
