*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRELEM (BLOKEL,NDIM,NBBBLK,NU1BLK,NBTEL  
     &                  ,CORPTL,NBDLMX,FORMAC,NUGPTL,FORMAN
     &                  ,LGFORM,FORMES,NBCNVE,VARIAB,NIVIMP,IMPSDR)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1987)  
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Impression des coordonnees et des numeros globaux des points du maillage, 
* element par element
*  
*-- Arguments --
* BLOKEL tableau de description des elements par blocs
* NDIM   dimension d'espace
* NBBBLK nombre de blocs d'elements consecutifs de meme type
* NU1BLK numero de type d'element du 1er bloc (utilise si 1 seul bloc)
* NBTEL  nombre total d'elements du maillage
* CORPTL tableau des coordonnees element par element
* FORMAC format d'impression variable
* FORMAN format d'impression variable
* NUGPTL tableau des coordonnees element par element
* NBDLMX nombre maximum de points dans un element du maillage
* NBDLFX    -      -         -    sur une face d'un element (sortie)
* LGFORM nombre de caracteres par nom de forme d'element
* FORMES tableau de noms de formes d'element
* NBCNVE nombre de caracteres par nom de variable
* NIVIMP niveau d'impression
* IMPSDR numero d'unite logique d'impression secondaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   BLOKEL(*),NDIM,NBBBLK,NU1BLK,NBTEL,NBDLMX,NUGPTL(*)
     &         ,LGFORM,NBCNVE,NIVIMP,IMPSDR
      REAL      CORPTL(*)
      CHARACTER FORMAC*(*),FORMAN*(*),FORMES(*),VARIAB(NBCNVE,*)
*
      INTEGER   L,MUNDIM,NBCHAR,NDIM48,IANUMG,IACORG,NUTGEO,NBELBK
     &         ,LGEBLK,LAG,KCL,NBSOMT,NBARET,NBFACE,NBNE,NBPTS,NBNF,NBNA
     &         ,NBPTSF,NBPTSA,IBLK,IEL,I,NDIMEL,NFORMG,ID,IC,IDM,INIT
     &         ,NBPRL1,NBPRL2,INTRPG
*-----------------------------------------------------------------------
      L=0  
      MUNDIM=1+(-1)**NDIM  
      NBCHAR=MIN (8,NBCNVE) 
      NDIM48=NDIM+48
      FORMAC='('//CHAR(NDIM48+MUNDIM)//'('' Point '','//CHAR(NDIM48)// 
     &'(TR2,'//CHAR(NBCHAR+48)//'A1,TR'//CHAR(57-NBCHAR)//'),''  *'':))'
      FORMAN=FORMAC(1:2)//'(I5,TR3,'//CHAR(NDIM48)//'E11.4,'' *''))'
*  
      IANUMG=0 
      IACORG=1 
      NUTGEO=NU1BLK
      NBELBK=NBTEL 
      IF (NBBBLK.GT.1) THEN 
         LGEBLK=BLOKEL(1)  
         NBELBK=BLOKEL(LGEBLK+1)
         INIT=LGEBLK+BLOKEL(3)+1
      ENDIF
      DO 10 IBLK=1,NBBBLK  
         CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBNE,NBPTS,NBNA,NBPTSA,NBNF,NBPTSF)
         CALL NUSPLT (NUTGEO, NDIMEL, NFORMG, INTRPG)
         NFORMG=NFORMG+NDIMEL-1
         IF (NDIMEL.GE.3) NFORMG=NFORMG+1
         NBPRL1=MIN (NIVIMP,NBELBK)
         NBPRL2=MAX (NBPRL1,NBELBK-NBPRL1+1)
         IF (NBBBLK.GT.1) WRITE (IMPSDR,10000) IBLK,NBELBK
         DO 9 IEL=1,NBELBK 
            L=L+1
            IF (L.LE.NBPRL1.OR.L.GE.NBPRL2) THEN
*
*              Impression des coordonnees des points dans l'element
               WRITE (IMPSDR,10001) L,NBPTS
     &               ,(FORMES(I),I=NFORMG*LGFORM+1,(NFORMG+1)*LGFORM-1)
               WRITE (IMPSDR,FMT=FORMAC)(((VARIAB(IC,ID),IC=1,NBCHAR)
     &                          ,ID=1,NDIM),I=1,MIN(NBPTS,NDIM+MUNDIM))
               WRITE (IMPSDR,FMT=FORMAN)
     &         (I,(CORPTL(IACORG+(I-1)*NDIM+IDM),IDM=1,NDIM),I=1,NBPTS)
*
*              Impression des numeros globaux des points dans l'element
               WRITE (IMPSDR,10002) 'Melina'
     &                             ,(NUGPTL(I),I=IANUMG+1,IANUMG+NBPTS)
            ELSEIF (L.EQ.NBPRL1+1) THEN
               WRITE (IMPSDR,10003)
            ENDIF
            IACORG=IACORG+1+NDIM*NBDLMX
            IANUMG=IANUMG+NBDLMX
9        CONTINUE  
         IF (NBBBLK.LE.1) GOTO 10  
            NBELBK=BLOKEL(INIT)
            NUTGEO=BLOKEL(INIT+1)  
            INIT=INIT+BLOKEL(3)
10    CONTINUE 
*-----------------------------------------------------------------------
10000 FORMAT(/T11,'*Prelem* Bloc d''elements #',I3,' : ',I5,' elements')
10001 FORMAT(T11,'*PrElem* Element',I5,' a ',I5,' points -> ',10A1)
10003 FORMAT(T11,'*PrElem* ',33('.'))
10002 FORMAT(T14,'* Numerotation globale des points (',A6,') : '
     &/(T11,10I6))
                                                                    END !PrElem
