*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDELEM (ULMAIL,BLOKEL,NDIM,NBBBLK,NU1BLK,NBTEL
     &                  ,ISGDET,CORPTL,FORMAC,NUGPTL,FORMAN,NBDLMX
     &                  ,NBTPTG,COMENT,DFCTBG,JACOBF,JACOBM)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1987)  
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Lecture des coordonnees et des numeros globaux des points et calcul de
* l'orientation de chaque element du maillage, element par element.
*  
*-- Arguments --  
* ULMAIL unite de lecture du maillage
* BLOKEL tableau de description des elements par blocs
* NDIM   dimension d'espace
* NBBBLK nombre de blocs d'elements consecutifs de meme type
* NU1BLK numero de type des elements du 1er bloc (utilise si 1 seul bloc)
* NBTEL  nombre total d'elements du maillage
* ISGDET tableau en 'equivalence' avec CORPTL pour le signe du determinant
*        jacobien de chaque element.
* CORPTL tableau des coordonnees element par element
* FORMAC format de lecture des coordonnees
* NUGPTL tableau des coordonnees element par element
* FORMAN format de lecture des numeros globaux
* NBDLMX nombre maximum de points dans un element du maillage
* NBTPTG max. des numeros globaux rencontre (c.a.d. le nb. total de points)
* COMENT lecture des coordonnees et numeros globaux avec ou sans commentaire
* DFCTBG tableau pour le calcul des derivees des fct. de base
* JACOBF tableau pour la matrice jacobienne
* JACOBM tableau de travail en particulier pour l'inverse de la precedente
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FORMAC,FORMAN
      INTEGER       ULMAIL,BLOKEL(*),NDIM,NBBBLK,NU1BLK,NBTEL
     &             ,ISGDET(*),NUGPTL(*),NBDLMX,NBTPTG
      REAL          CORPTL(*),DFCTBG(*),JACOBF(*),JACOBM(*)
      LOGICAL       COMENT
*
      INTEGER       ADCORG,INCORG,ADNUMG,L,NUTGEO,NBELBK,IBLK,IEL,INTRPG
     &             ,LAG,KCL,NBSOMT,NBARET,NBFACE,NBNE,NBPTS,NBNF,NBPTSF
     &             ,NBNA,NBPTSA,NDIMEL,NFORMG,IDIM,INIT,JSGDET,LGDBLK
      REAL          DETDF
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdElem*')
*
*     Increment de parcours du tableau #ORPTL lors du passage
*     a l'element suivant
      INCORG=NDIM*NBDLMX+1
*
      ADCORG=1
      ADNUMG=1
      L=0
      NUTGEO=NU1BLK
      NBELBK=NBTEL
      IF (NBBBLK.GT.1) THEN
         LGDBLK=BLOKEL(1)
         NBELBK=BLOKEL(LGDBLK+1)
         INIT=LGDBLK+1+BLOKEL(3)
      ENDIF
*
*     Boucle sur les elements par blocs d'elements consecutifs de meme type
*
      DO 10 IBLK=1,NBBBLK
         CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     &               ,NBNE,NBPTS,NBNA,NBPTSA,NBNF,NBPTSF)               !ef3d
         CALL NUSPLT (NUTGEO, NDIMEL, NFORMG, INTRPG)
         DO 9 IEL=1,NBELBK
            L=L+1
*
*-          Lecture des coordonnees des points dans l'element
*
            CALL RDCOOR (ULMAIL,FORMAC,NDIM,NBPTS,L,CORPTL(ADCORG+1)
     &                  ,COMENT)                                       !lecgeom
            JSGDET=1
            IF (NDIMEL.EQ.NDIM) THEN
*
*-             Calcul du determinant jacobien au point image du point (1,0,[,0])
*-             dans l'element courant pour determiner son orientation
*
               JACOBM(1)=1.
               DO 1 IDIM=2,NDIM
                  JACOBM(IDIM)=0.
1              CONTINUE
               CALL ELEMFB (NUTGEO,'NYN',JACOBM,JACOBM,DFCTBG,JACOBM,0) !ef3d
               CALL DELAFO (NDIM,NDIM,NBPTS,CORPTL(ADCORG+1),DFCTBG
     &                     ,0,JACOBF)                                   !calelem
               CALL OFALED (NDIM,JACOBF,DETDF,JACOBM,1.E-8,0)           !calelem
               IF (DETDF.LT.0) JSGDET=-1
            ENDIF
            ISGDET(ADCORG)=JSGDET
            ADCORG=ADCORG+INCORG
*
*-          Lecture des numeros globaux des points dans l'element
*
            CALL RDNUGL (ULMAIL,FORMAN,NBPTS,L,NUGPTL(ADNUMG),NBTPTG
     &                  ,COMENT)                                        !lecgeom
            ADNUMG=ADNUMG+NBDLMX
9        CONTINUE  
         IF (NBBBLK.LE.1) GOTO 10
            NBELBK=BLOKEL(INIT)
            NUTGEO=BLOKEL(INIT+1) 
            INIT=INIT+BLOKEL(3)
10    CONTINUE 
      CALL PRFXMJ (-1,'*RdElem*') 
*----------------------------------------------------------------------- 
                                                                    END !RdElem
