*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRSOGN (KPERSO,NDIM,KLNOYO,LAMBDA,CONGRE,TYTBAS,MCTBAS
     &                  ,ISYMGR,TSYMGR,PSYMGR,NDLGAM,CORGAM,NDNOGA
     &                  ,NORGAM,ELTSIG,NUTSIG,NBNSIG,CORSIG,NUTSIC
     &                  ,NBNSIC,CORSIC,NDNOSI,NORSIC,NUTSIL,NBNSIL
     &                  ,TYNOYO,MCNOY1,MCNOY2,TYGDNO,TBGDNS,TBGDND
     &                  ,RST,CST,PREFIX,NIVESP,NIVIMP,IMPSDR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 1995)
* Derniere modification : D.Martin le 22 Septembre 1995
*
* Procedure 'utilisateur' pour le calcul des produits Gdelta*Noyau dans
* le calcul des termes de couplage
*
*-- Arguments --
* KPERSO chaine de caractere a la disposition de l'utilisateur indiquant 
*        par exemple le type de calcul.
* NDIM   dimension d'espace
* KLNOYO type ('FOUrier', 'NEUman' ou 'DIRichlet') du noyau de Green
* LAMBDC valeur COMPLEXE de la constante LAMBDA dans le cas 'FOUrier'
* CONGRE tableau des valeurs COMPLEXES des constantes necessaires au calcul de
*        la fonction de Green (si existe)
* TYTBAS type du tableau associe au calcul de Green (si existe)
* MCTBAS son adresse dans RST si TYTBAS(1:1)='R', dans CST si TYTBAS(1:1)='C'
* ISYMGR indicateur de symetries/antisymetries du probleme traite
* TSYMGR tableau indiquant les symetries, voir utilisation dans <Calgre/symgre>
* PSYMGR tableau de travail pour le stockage de points symetriques
* NDLGAM nombre de d.l. sur Gamma (=nombre de colonne de la matrice de couplage)
* CORGAM coordonnees des noeuds de Gamma
*        (pour le calcul des noyaux de Green)
* NDNOGA =NDIM indique que le tableau des normales aux noeuds de gamma existe
*        =0 sinon
* NORGAM composantes des normales aux noeuds de Gamma (si existe)
*        (pour le calcul des noyaux de Green de Double Couche)
* ELTSIG numero de l'element courant de Sigma
* NUTSIG numero de type de l'element geometrique courant de Sigma
* NBDLFG nombre de points de l'element (geometrique)
* CORSIG coordonnees des points de l'element de Sigma courant
*        (calculs geometriques comme la matrice jacobienne, par exemple)
* NUTSIC numero de type de l'element de Sigma pour l'interpolation en colonne
* NBNSIC nombre de noeuds de l'element de Sigma pour l'interpolation en colonne
* CORSIC coordonnees des noeuds de l'element de Sigma courant
*        (pour le calcul des noyaux de Green)
* NDNOSI =NDIM indique que le tableau des normales aux noeuds de l'element de 
*        Sigma existe, =0 sinon
* NORSIC composantes des normales aux noeuds de l'element de Sigma (si existe)
*        (couplage de type NEUman ou FOUrier)
* NUTSIL numero de type de l'element de Sigma pour l'interpolation en ligne
* NBNSIL nombre de noeuds de l'element de Sigma pour l'interpolation en ligne
* TYNOYO type 'REEL' ou 'COMPLEXE' des noyaux de Green
* MCNOY1 adresse dans le supertableau de type TYNOYO d'un tableau de travail
*        de longueur NDLGAM*NBNSIC(pour le calcul des noyaux locaux par exemple)
* MCNOY2 adresse dans le supertableau de type TYNOYO d'un tableau de travail
*        de longueur NDLGAM*NBNSIC
* TYGDNO type 'REEL' ou 'COMPLEXE' du produit Gdelta*Noyau
* TBGDNS tableau COMPLEXE recepteur du Produit Gdelta_{i,j}*G/d_{j,k} 
*        de longueur NDLGAM*NBNSIL (i=1,NBNSIL, k=1,NDLGAM)
* TBGDND tableau COMPLEXE recepteur du Produit Gdelta_{i,j} * dG/dn_{j,k}
*        de longueur NDLGAM*NBNSIL (i=1,NBNSIL, k=1,NDLGAM)
* RST    supertableau version reelle
* CST    supertableau version complexe
* PREFIX indicateur des procedures traversees
* NIVESP niveau de la procedure traversee
* NIVIMP niveau d'impression des calcul
* IMPSDR numero d'unite logique du fichier d'impression secondaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KPERSO,KLNOYO,TYTBAS,TYNOYO,TYGDNO,PREFIX(*)
      INTEGER       NDIM,MCTBAS,ISYMGR,TSYMGR(*),NDLGAM,NDNOGA,ELTSIG
     &             ,NUTSIG,NBNSIG,NUTSIC,NBNSIC,NDNOSI,NUTSIL,NBNSIL
     &             ,MCNOY1,MCNOY2,NIVESP,NIVIMP,IMPSDR
      REAL          PSYMGR(*),CORGAM(NDIM,*),NORGAM(*)
     &             ,CORSIG(NDIM,*),CORSIC(NDIM,*),NORSIC(*),RST(*)
      COMPLEX       LAMBDA,CONGRE(*),TBGDND(NBNSIL,*),TBGDNS(NBNSIL,*)
     &             ,CST(*)
*-----------------------------------------------------------------------
      CALL BAISE  (' <Modeles/prsogn> Vous avez oublie de fournir la '
     &//'procedure ''utilisateur'' : ''PRSOGN'', appelee pour le calcul'
     &//' des termes de couplage')
                                                                    END !PrsoGn
