*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRSONO (KLNOYO,NDIM,LAMBDA,CONGRE,CTBASS
     &                  ,CORGAM,NDNOGA,NORGAM,CORSIG,NDNOSI,NORSIG
     &                  ,ISYMGR,TSYMGR,PSYMGR,LGFGRE,CFGREE,CGS,CGD
     &                  ,NIVIMP,IMPSDR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1996)
* Derniere modification : D.Martin le 28 Mars 1996
*
* Procedure 'utilisateur' pour le calcul des Noyau de Green dans
* le calcul des termes de couplage
*
*-- Arguments --
* KLNOYO type (fourbni par l'utilisateur) du noyau de Green
* NDIM   dimension d'espace
* LAMBDA valeur COMPLEXE de la constante LAMBDA (si existe)
* CONGRE tableau des valeurs COMPLEXES des constantes necessaires au calcul de
*        la fonction de Green (si existe)
* CTBASS tableau COMPLEXE associe au calcul de Green (si existe)
* CORGAM coordonnees du noeud courant de Gamma
* NDNOGA =NDIM indique que le tableau des normales aux noeuds de Gamma existe
*        =0 sinon
* NORGAM composantes de la normale au noeud courant de Gamma (si existe)
* CORSIG coordonnees du noeud courant de Sigma
* NDNOSI =NDIM indique que le tableau des normales aux noeuds de Sigma existe,
*        =0 sinon
* NORSIG composantes de la normale au noeud courant Sigma (si existe)
* ISYMGR indicateur de symetries/antisymetries du probleme traite
* TSYMGR tableau indiquant les symetries, voir utilisation dans <Calgre/symgre>
* PSYMGR tableau de travail pour le stockage de points symetriques
* CFGREE tableau de travail pour le stockage de la fonction de Green et ses
*        derivees
* LGFGRE longueur du tableau de travail ci-dessus
* CGS    noyau de Green de simple couche
* CGD    noyau de Green de doucle couche
* NIVIMP niveau d'impression des calcul
* IMPSDR numero d'unite logique du fichier d'impression secondaire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) KLNOYO
      INTEGER       NDIM,ISYMGR,TSYMGR(*),NDNOGA,NDNOSI,NIVIMP,IMPSDR
      REAL          PSYMGR(*),CORGAM(*),NORGAM(*),LGFGRE
     &             ,CORSIG(*),NORSIG(*)
      COMPLEX       LAMBDA,CONGRE(*),CTBASS(*),CFGREE,CGS,CGD
*-----------------------------------------------------------------------
      CALL BAISE  (' <Modeles/Prsono> Vous avez oublie de fournir la '
     &//'procedure ''utilisateur'' : ''PRSONO'', appelee pour le calcul'
     &//' des noyaux de Green')
                                                                    END !PrsoNo
