*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FME2MO (TYPE,NBFACE,NUFAMO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)  
* Derniere modification : D.Martin (2 Avril 2004)
* Version 2
*   
* Passage de la numerotation locale 'Melina' des faces d'un element    
* a la numerotation locale 'Modulef' en fonction du type d'un element Melina
*
*       i.e. la face I de Melina est la face NUFAMO(I) de Modulef
*
* TYPE   chaine de caracteres definissant le type Melina
* NBFACE nombre de faces ou aretes de l'element
* NUFAMO numeros locaux des faces dans l'element Modulef
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPE
      INTEGER       NBFACE,NUFAMO(*)
*   
      INTEGER       FHEXAE(6),FPRISM(5),FTETRA(4),I
****  Ancienne numerotation Melina
****  DATA FHEXAE/1,3,5,6,2,4/,FPRISM/1,3,5,2,4/,FTETRA/1,3,4,2/
*     Nouvelle numerotation Melina
      DATA FHEXAE/3,5,4,6,2,1/,FPRISM/1,3,5,2,4/,FTETRA/1,3,4,2/
*-----------------------------------------------------------------------
      IF (TYPE(:2).EQ.'HE') THEN
         DO 3001 I=1,NBFACE 
3001        NUFAMO(I)=FHEXAE(I)
      ELSEIF (TYPE(:2).EQ.'PR') THEN 
         DO 3101 I=1,NBFACE 
3101        NUFAMO(I)=FPRISM(I)
      ELSEIF (TYPE(:2).EQ.'TE') THEN 
         DO 3201 I=1,NBFACE   
3201        NUFAMO(I)=FTETRA(I) 
      ELSEIF (TYPE(:2).EQ.'QU'.OR.TYPE(:2).EQ.'TR') THEN   
         DO 2001 I=1,NBFACE 
2001        NUFAMO(I)=I   
      ELSEIF (TYPE(:2).EQ.'SE') THEN
         DO 1000 I=1,NBFACE
1000        NUFAMO(I)=I
      ENDIF 
                                                                    END !FMe2Mo
