*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MACO2M (M,RM,LM,IST,RST,CST,MAXIST,AST,MAXAST
     &                  ,NUCOOR,NUMAIL,NUFOUT,NOFOUT)   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1993) 
* Derniere modification : D.Martin (13 Juin 2003)
* Version 1.0.6
*   
* Creer un maillage Melina sur unite sequentielle formattee a
* partir de structurse de donnees MAIL & COOR de Modulef.  
*   
*-- Entrees --
* M      super-tableau version entiere de l'allocation dynamique Modulef
* RM     super-tableau version reelle Modulef
* LM     longueur du super-tableau de Modulef
* IST    super-tableau version entiere de l'allocation dynamique Melina
* RST    super-tableau version reelle Melina
* CST    super-tableau version complexe Melina
* MAXIST longueur du super-tableau scalaire Melina (IST,RST,CST)
* AST    super-tableau de caracteres de Melina
* MAXAST longueur du super-tableau caractere de Melina
* NUCOOR numero d'unite logique du fichier de la SD COOR
* NUMAIL numero d'unite logique du fichier de la SD MAIL
* NUFOUT numero d'unite logique du fichier de maillage Melina
* NOFOUT nom du fichier de maillage Melina
*
*-- Procedures utilisees --
* RDNMVE          Mo2me   creation des noms de variables
* NO2BLK          Mo2me   creation de la structure #LOKEL
* MO2LME          Mo2me   d'un elt. Modulef a un elt. Melina
* MO2LSD          Mo2me   creation des structures #ISTEL de dimension NDIM
* MO2LSF          Mo2me   creation des structures #ISTEL de dimension 2 en 3d
* MO2LSA          Mo2me   creation des structures #ISTEL de dimension 1
* MO2LSS          Mo2me   creation des structures #ISTEL de dimension 0
* INITIS          Modulef lib.UTIL 
* SDREST, SAUCSD  Modulef lib.UTSD 
* INITIA, INIFIC  Melina  mod.Initial
* ECGEOM          Melina  mod.Lecgeom
* STINIT          Melina  lib.Allodyn
* TBCREE          Melina  lib.Allodyn (TBAR.., TBSAVE, TBTUER,  TBAJST...)
* TAZERO          Melina  lib.Utiliter
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER        AST(*)
      CHARACTER*(*)    NOFOUT
      INTEGER          M(*),LM,IST(*),MAXIST,MAXAST,NUCOOR,NUMAIL
     &                ,NUFOUT
      REAL             RM(*),RST(*)
      COMPLEX          CST(*)
*
      INCLUDE 'CONTEX'
*
      INTEGER          LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &                ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &                ,NUM,NUMOLD,LECOLD,LCANTE,LECACT,LASAPL
      INTEGER          NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      INTEGER          MEMAIL,NCMAI,IAMAIZ,NCOOR,IACOOR,IAMAIL
      INTEGER          NIMAIL,MOMAI0,MOMAI2,MOMAI3,MOMAIC,MOMAII,MOMAIJ
     &                ,MOMAIL,NICOOR,MOCOO2,NCOO4,MOCOO4,LGCOO4,LLCOO4
     &                ,NTYELM,NDSR,NCACAR,NCOPNP,NOPFI,NBTNEU,NDSD
     &                ,NTYCOO,NDCSMC,NCODS,NTACOO,NPAGCO,NBREST,NRET
     &                ,IACOO4,IANOP5,IPAG,LG,L
     &                ,MCVARE,LGVARE,LGBLOK,MEBLOK,NIVEGE,MENUMG,MECORG
     &                ,MEMEMO,MCFCTB,MCORL0,NCHDOM,LGMDOM,MESNIV,LGSNIV
     &                ,NUTYAV,IDOMG,NBDOAV,MCLIST,LGENTE,INCREM,LGSTRU
     &                ,MCTRDO,MCORLO
      COMMON/REDCA1/   NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDLST/   LECOLD,LCANTE,NUMOLD /LASAPL/LASAPL
*
      CHARACTER     CHAR4*4
      CHARACTER     REPONS*80,ERCODE*120
      COMMON/FORMAH/ERCODE
      INTEGER       NBDLXX(3) ,NBSOXX(3),NBARXX(3),NBFAXX(3)
      DATA NBDLXX/3,9,27/,NBSOXX/2,4,8/,NBARXX/0,4,12/,NBFAXX/0,0,6/
*----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Maco2M*')
*   
*--   Initialisation de l'allocation dynamique de Modulef
      CALL INITIS (M,LM,0,0)                                            !utii
*
*--   Initialisation et Valeurs par defaut 
      CALL INITIA (MAXIST,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &            ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &            ,NUM,NUMOLD,LECACT,LECOLD,LCANTE,LASAPL)              !initial
*
*--   Initialisation de l'allocation dynamique de Melina
      CALL STINIT (MAXAST,MAXIST,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF
     &            ,NBUTMX,NBUNIT,INTMAX,IMPALO,IMPERR)
*
*--   Initialisation du systeme d'unites logiques  
      CALL INIFIC (LASNUF,STDOUT,IMPPAL,IMPSDR,IMPMES,ABS(IMPALO) 
     &            ,IMPERR)                                              !initial
      CALL TBCREE ('%mail%',0,1,67,'c')
      CALL TBAR1  (ERCODE,'%mail%',0,MEMAIL)                     
*
*     Restauration des S.D.E. MAIL et COOR
*
      NIMAIL=1 
      CALL SDREST (M,'MAIL',NUMAIL,NIMAIL,IST(MEMAIL),67,NCMAI,IAMAIZ)  !utsd
      MOMAI0=IST(MEMAIL+2)
      MOMAI2=IST(MEMAIL+8)
      MOMAI3=IST(MEMAIL+11)
      MOMAIC=IST(MEMAIL+38)
      MOMAII=IST(MEMAIL+56)
      MOMAIJ=IST(MEMAIL+59)
      MOMAIL=IST(MEMAIL+65)
      NICOOR=1 
      CALL SDREST (M,'COOR',NUCOOR,NICOOR,IST(MEMAIL),16,NCOOR,IACOOR)  !utsd
      MOCOO2=IST(MEMAIL+8)
      NCOO4 =IST(MEMAIL+13)
      MOCOO4=IST(MEMAIL+14)
      LGCOO4=IST(MEMAIL+15)
* 
*     Tableau MAIL2 de la structure MAIL de Modulef
*  
      NDIM  =M(MOMAI2)
      NTYELM=M(MOMAI2+2)
      NDSR  =M(MOMAI2+3)
      NCACAR=M(MOMAI2+6)
      NCOPNP=M(MOMAI2+7)
      NOPFI =M(MOMAI2+11)
      IF (NOPFI.EQ.1) CALL BAISE (' Cas NOPFI non nul a voir')
* 
*     Tableau MAIL3 de la structure MAIL de Modulef
*
      NBTEL =M(MOMAI3) 
      NBTNEU=M(MOMAI3+1)
      NBTPTG=M(MOMAI3+2)
      NDSD  =M(MOMAI3+3)
*
*     Tableau COOR2 de la structure COOR de Modulef
*
      NTYCOO=M(MOCOO2)   
      NDCSMC=M(MOCOO2+3)   
      NCODS =M(MOCOO2+4)
      NTACOO=M(MOCOO2+6)
      NPAGCO=NBTPTG/NDCSMC
      NBREST=NBTPTG-NPAGCO*NDCSMC
      IF (NBREST.NE.0) NPAGCO=NPAGCO+1
*
*     On restaure le tableau COO4 au complet en memoire centrale
*
      LLCOO4=LGCOO4
      LGCOO4=MAX(LLCOO4,NDIM*NBTPTG)
      IF (LLCOO4.NE.LGCOO4) THEN
         CALL READRE (2,CHAR4(NCOO4),MOCOO4,LGCOO4,M,NRET)              !utii
         CALL SAUCSD (M,'COOR',NICOOR,IST(MEMAIL),16,NCOOR,IACOOR)      !utsd
      ENDIF
      IF (NPAGCO.GT.1) THEN
         IACOO4=MOCOO4
         DO 10 IPAG=1,NPAGCO
            READ (NUCOOR) LG,(RM(IACOO4+L-1),L=1,LG)
            IACOO4 = IACOO4 + LG
10       CONTINUE
      ELSE
         IPAG=0
         READ (NUCOOR) LG,(RM(MOCOO4+L-1),L=1,LG)
      ENDIF
      CALL TBTUER ('%mail%',0)
*   
*--   Tableau des noms des variables d'espace Melina
*
      LGVARE=18
      CALL TBCREE ('#ARIAB',1,11,LGVARE,'c')                     
      CALL TBAR1  (ERCODE,'#ARIAB',1,MCVARE)                     
      CALL RDNMVE (NTACOO,NDIM,AST(MCVARE),NBCNVE,LGVARE,IMPPAL)        !mo2me
      CALL TBAJST ('#ARIAB',1,NDIM*NBCNVE)
*
*--   Creation de la structure #LOKEL
*
      LGBLOK=3+2*NBTEL
      CALL TBCREE ('#LOKEL',1,1,LGBLOK,'c')
      CALL TBAR1  (ERCODE,'#LOKEL',1,MEBLOK)                     
      IANOP5=0
      IAMAIL=1
      CALL MO2BLK (NDIM,NBTEL,NCACAR,NCOPNP,IANOP5,M(1) 
     &            ,IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII),M(MOMAIJ)
     &            ,IST(MEBLOK),INTRPG,NBPTEX,NBBBLK,NU1BLK)             !mo2me
      LGBLOK=IST(MEBLOK)+IST(MEBLOK+2)*IST(MEBLOK+1)
      CALL TBAJST ('#LOKEL',1,LGBLOK)
*
*--   Creation des tableaux #ORPTL et #GNEEL de Melina
*
      NIVENG=INTRPG
      NIVEGE=0
      CALL TBCREE ('#ORPTL',NIVEGE,2,NBTEL*(NDIM*NBPTEX+1),'c')
      CALL TBCREE ('#GNEEL',NIVENG,1,NBTEL*NBPTEX,'c')
      CALL TBCREE ('#umemo',0,1,NBDLXX(NDIM),'c')
      CALL TBCREE ('#fctba',0,2,NBPTEX,'c')
      CALL TBCREE('#corlo',0,2,NDIM*NBPTEX,'c')
      CALL TBAR5  (ERCODE,'#GNEEL',NIVENG,MENUMG,'#ORPTL',NIVEGE,MECORG
     &                   ,'#umemo',0     ,MEMEMO,'#fctba',0     ,MCFCTB
     &                   ,'#corlo',0     ,MCORLO)
      IAMAIL=1
      CALL MO2LME (NDIM,NBTEL,NCACAR,NCOPNP,IANOP5,M(1),RM(1)
     &            ,IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII),M(MOMAIJ)
     &            ,RM(MOCOO4),NBPTEX,RST(MCORLO),RST(MCFCTB)
     &            ,IST(MEMEMO),IST(MENUMG),RST(MECORG))                 !Mo2me
      CALL TBSAVE ('#ORPTL',NIVEGE)
      CALL TBSAVE ('#GNEEL',NIVENG)
*
*     Creation des tableaux #ISTEL des domaines de dimension NDIM
*
      NBDOMG=0
      NCHDOM=0
      LGMDOM=1000
      LGSNIV=200+12
      CALL TBCREE ('#OMDOM',1,11,LGMDOM,'c')                     
      CALL TBCREE ('#isniv',0,1,LGSNIV,'c')
      CALL TBAR1  (ERCODE,'#isniv',0  ,MESNIV)
      CALL TAZERO (100,'E',MESNIV,AST,IST,RST,CST)
      IAMAIL=1
      CALL MO2LSD (NDIM,NBTEL,NCACAR,NDSD,NCOPNP,IANOP5,M(1)
     &            ,IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII),M(MOMAIJ)
     &            ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                        !mo2me
*     a posteriori ... #isniv a-t-il deborde ?
      IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv')    !utilite
*     Boucle pour ajuster les tableaux #ISTEL crees.
      DO 1 IDOMG=1,NBDOMG
         ERCODE='!'
         CALL TBAR1  (ERCODE,'#ISTEL',IDOMG,MCLIST)
         IF (ERCODE(1:1).EQ.' ')
     &      CALL TBAJST ('#ISTEL',IDOMG,6+IST(MCLIST+3))
1     CONTINUE
      NBDOAV=NBDOMG
*
*     Creation des tableaux #ISTEL des domaines de dimension 2 en 3D
*
      IF (NDIM.GE.3) THEN
         CALL TBAR2  (ERCODE,'#isniv',0  ,MESNIV,'#umemo',0  ,MEMEMO)
         CALL TAZERO (NBDOMG,'E',MESNIV,AST,IST,RST,CST)
         IAMAIL=1
         CALL MO2LSF (NDIM,NBTEL,NCACAR,NDSD,NCOPNP,IST(MEMEMO)
     &               ,IANOP5,M(1),IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII)
     &               ,M(MOMAIJ),LGMDOM,NBDOMG,NCHDOM,AST,IST)
      ENDIF
*
*     Creation des tableaux #ISTEL des domaines de dimension 1 en 2D et 3D
*
      IF (NDIM.GE.3) THEN
         WRITE (*,*) '>'
         WRITE (*,*) 
     &   '> Voulez-vous transmettre les references des lignes?'
         READ (*,'(A)') REPONS
         IF (REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &   .OR.REPONS(1:1).EQ.'y') REPONS='Y'
         IF (REPONS(1:1).NE.'Y') GOTO 99998
      ENDIF
      IF (NDIM.GE.2) THEN
         NUTYAV=0
         CALL TBAR2  (ERCODE,'#isniv',0  ,MESNIV,'#umemo',0  ,MEMEMO)
         CALL TAZERO (NBDOMG,'E',MESNIV,AST,IST,RST,CST)
         IAMAIL=1
         CALL MO2LSA (NDIM,NBTEL,NCACAR,NDSD,NCOPNP,IST(MEMEMO)
     &               ,IANOP5,M(1),IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII)
     &               ,M(MOMAIJ),LGMDOM,NBDOMG,NCHDOM,AST,IST)           !mo2me
      ENDIF
*
*--   Creation des tableaux #ISTEL des domaines de dimension 0 en 2D et 3D
*
99998 IF (NDIM.GE.2) THEN
         WRITE (*,*) '>'
         WRITE (*,*) 
     &   '> Voulez-vous transmettre les references des noeuds?'
         READ (*,'(A)') REPONS
         IF (REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &   .OR.REPONS(1:1).EQ.'y') REPONS='Y'
         IF (REPONS(1:1).NE.'Y') GOTO 99999
      ENDIF
      CALL TBAR2  (ERCODE,'#isniv',0  ,MESNIV,'#umemo',0  ,MEMEMO)
      CALL TAZERO (NBDOMG,'E',MESNIV,AST,IST,RST,CST)
      IAMAIL=1
      CALL MO2LSS (NDIM,NBTEL,NCACAR,NCOPNP,IST(MEMEMO),IANOP5,M(1)
     &            ,IAMAIL,M(MOMAIL),M(MOMAIC),M(MOMAII),M(MOMAIJ)
     &            ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                        !mo2me
*     a posteriori ... #isniv a-t-il deborde ?
      IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv')    !utilite
*     Boucle pour ajuster les tableaux #ISTEL crees.
      DO 4 IDOMG=NBDOAV,NBDOMG
         ERCODE='!'
         CALL TBAR1 (ERCODE,'#ISTEL',IDOMG,MCLIST)
         IF (ERCODE(1:1).EQ.' ') 
     &      CALL TBAJST('#ISTEL',IDOMG,8+2*IST(MCLIST+2))
4     CONTINUE
*
99999 CALL TBTUER ('#isniv',0)
      CALL TBTUER ('#umemo',0)
*
*     Structure #TERDO
*
      LGENTE=4 
      INCREM=27
      LGSTRU=LGENTE+NBDOMG*(INCREM+1)
      CALL TBCREE ('#TERDO',1,1,LGSTRU,'c')
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)                     
      CALL SDMKDB (IST(MCTRDO),LGENTE,NBDOMG,INCREM,NCHDOM)             !utilite
*   
*--   Constitution du fichier de sortie 
*
      WRITE(*,*) 'Le maillage contient ',NBTEL,' elements, et'
     &                                  ,NBTPTG,' points.'
      WRITE(*,*) '  '
      WRITE(*,*) '> Titre pour le fichier de maillage Melina ?'
      READ (*,'(A80)') REPONS 
*
      CALL ECGEOM (NOFOUT,REPONS)                                       !lcgeom
*
      CLOSE (NUFOUT,STATUS='KEEP')
      CALL PRFXMJ (-1,'*Maco2M*')
                                                                    END !MaCo2m
