*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ME2NOP (NDIM,NBDOMG,NBPTEX,NBTPTG,NBTEL
     &                  ,NBBBLK,NIVEGE,NIVENG,FICOUT
     &                  ,M,RM,AST,IST,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : O.DeBayser & D.Martin 
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
* 
* Construction des tableaux d'entree pour la routine CONOPO de Modulef
* en vue de la creation d'une Structure de donnees NOPO.
*
*-- Procedures utilisees --
* RDREFE          lecture des numerod de reference
* ME2LNO          d'un elt. Melina a un elt. Modulef
* NME2MO          de la num. loc. Melina des noeuds a celle de Modulef
* FME2MO          de la num. loc. Melina des faces a celle de Modulef
* AME2MO          de la num. loc. Melina des aretes a celle de Modulef
* TBCREE          Melina  lib.allodyn
* TAZERO          Melina  lib.utiliter
* ELEMNB          Melina  lib.ef3d
* SDEXDB          Melina  lib.sdexplo
* EXBLOK          Melina  lib.sdexplo
* EXLIST, EXSTEL  Malina  lib.sdexplo
* CONOPO          Modulef lib.NOPO
* READRE,TUER     Modulef lib.UTIL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) FICOUT
      CHARACTER     AST(*)
      INTEGER       NDIM,NBDOMG,NBPTEX,NBTPTG,NBTEL,NBBBLK
     &             ,NIVEGE,NIVENG
      INTEGER       M(*),IST(*)
      REAL          RM(*),RST(*)
      COMPLEX       CST(*)
*
      INTEGER   LECTEU,IMPRIM,FILUNI,NTITRE,INUTI,IMPRE,NUTI
      INTEGER   NUF,IFACE,IARET,NINOPO
     &         ,METRDO,LGERDO,NBDOMK,INCRDO,NCHDOM,INCFAC,INCARE,INCSOM
     &         ,MENEFA,MEREFE,MESDEL,MESOBL,MEARBL,MEFCBL,MEBLOK,IDOM
     &         ,MELIST,NXLIST,NDMDOM,NBELDO,NUTYAV,NUFAAV,NIVIMP,IEL
     &         ,NBNE,NBDL,NUTYFA,NBNEFA,NBDLFA,NWTPTG,ITYPE,NCGE
     &         ,NUTGEO,NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE,IFORME
     &         ,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NBNEAX,NBDLAX,MECORG
     &         ,MENUMG,MENUMR,MEJAVU,IAFCBL,IAARBL,IASOBL,NSORT
     &         ,MODESC,MOREFS,MOREFF,MOREFA,MOCOOR
     &         ,IADESC,IAREFS,IAREFA,IAREFF
      INTEGER   NBDLXX(3),NBSOXX(3),NBARXX(3),NBFAXX(3)
      CHARACTER*5 LEYTUN
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*
      COMMON/UNITES/LECTEU,IMPRIM,FILUNI(30)
      COMMON/TRAVA1/NTITRE(20),INUTI(9),IMPRE,NUTI(3)
*
      DATA NBDLXX/3,9,27/NBSOXX/2,4,8/,NBARXX/0,4,12/,NBFAXX/0,0,6/
*-----------------------------------------------------------------------
      IMPRIM=6
      IMPRE=1
      CALL PRFXMJ (1,'*Me2Nop*')
*
      CALL TBAR1  (ERCODE,'#TERDO',1,METRDO)                     
      CALL SDEXDB (IST(METRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !utilite
*
*     Numeros de sous-domaines et numeros de reference
*
      CALL TBCREE ('#urefe',0,1,NBDOMG,'c')
      CALL RDREFE (AST,IST,NDIM,NBDOMG,NCHDOM)
*
      CALL TBCREE ('#sdoel',0,1,NBTEL,'c')
      INCSOM=NBSOXX(NDIM)+1
      CALL TBCREE ('#sombl',0,1,INCSOM*NBTEL,'c')
      INCARE=NBARXX(NDIM)+1
      IF (NDIM.GE.2) CALL TBCREE ('#arebl',0,1,INCARE*NBTEL,'c')
      INCFAC=NBFAXX(NDIM)+1
      IF (NDIM.GE.3) CALL TBCREE ('#facbl',0,1,INCFAC*NBTEL,'c')
      CALL TBCREE ('#numer',0,1,2*NBDLXX(NDIM),'c')
      CALL TBCREE ('#ejavu',0,1,NBTPTG,'c')
      CALL TBAR4  (ERCODE,'#numer',0,MENEFA,'#urefe',0,MEREFE
     &                   ,'#sdoel',0,MESDEL,'#sombl',0,MESOBL)
      CALL TAZERO (NBTEL,'E',MESDEL,AST,IST,RST,CST)                    !utilite
      CALL TAZERO (INCSOM*NBTEL,'E',MESOBL,AST,IST,RST,CST)             !utilite
      IF (NDIM.GE.2) THEN
         CALL TBAR1  (ERCODE,'#arebl',0,MEARBL)
         CALL TAZERO (INCARE*NBTEL,'E',MEARBL,AST,IST,RST,CST)          !utilite
      ENDIF
      IF (NDIM.GE.3) THEN
         CALL TBAR1  (ERCODE,'#facbl',0,MEFCBL)
         CALL TAZERO (INCFAC*NBTEL,'E',MEFCBL,AST,IST,RST,CST)          !utilite
      ENDIF
*
      MEBLOK=MEFCBL
      IF (NBBBLK.GT.1) CALL TBAR1 (ERCODE,'#LOKEL',1,MEBLOK)
      DO 2 IDOM=1,NBDOMG
         NUREFE=IST(MEREFE)
         MEREFE=MEREFE+1
         CALL TBAR1  (ERCODE,'#ISTEL',IDOM,MELIST)
         CALL EXLIST (IST(MELIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &               ,NBNEEX,NBDLEX,NBNEFX,NBDLFX)                      !sdexplo
         NUTYAV=0
         NUFAAV=0
         NIVIMP=0
         DO 1 IEL=1,NBELDO
            CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MELIST),IST(MEBLOK)
     &                  ,NUTGEO,NIVENG,NUEL,NUTYAV,NUTYLE,LAGHER,KCLASS
     &                  ,NBNE,NBDL,NUF,NUFAAV,NUTYFA,NBNEFA,NBDLFA
     &                  ,IST(MENEFA),IST(MENEFA+NBNEFX),NIVIMP,IMPRIM)  !sdexplo
            IF (NDMDOM.EQ.NDIM) THEN
*              Numeros de sous-domaine pour l'element
               IST(MESDEL+NUEL-1)=NUREFE
            ELSEIF (NDMDOM.EQ.2) THEN
*              Numeros de reference pour une face de l'element
               IAFCBL         =MEFCBL+(NUEL-1)*INCFAC
               IST(IAFCBL)    =IST(IAFCBL)+1
               IST(IAFCBL+NUF)=NUREFE
            ELSEIF (NDMDOM.EQ.1) THEN
*              Numeros de reference pour une arete de l'element
               IAARBL         =MEARBL+(NUEL-1)*INCARE
               IST(IAARBL)    =IST(IAARBL)+1
               IST(IAARBL+NUF)=NUREFE
            ELSEIF (NDMDOM.EQ.0) THEN
*              Numeros de reference pour un sommet de l'element
               IASOBL         =MESOBL+(NUEL-1)*INCSOM
               IST(IASOBL)    =IST(IASOBL)+1
               IST(IASOBL+NUF)=NUREFE
            ENDIF
1        CONTINUE
         CALL TBSAVE ('#ISTEL',IDOM)
         NUTYAV=NUTYLE
         NUFAAV=NUF
2     CONTINUE
      CALL TBTUER ('#urefe',0)
*
*     Tableaux Melina
*
      CALL TBRR2  (ERCODE,'#ORPTL',NIVEGE,MECORG,'#GNEEL',NIVENG,MENUMG)
      CALL TBAR6  (ERCODE,'#ORPTL',NIVEGE,MECORG,'#GNEEL',NIVENG,MENUMG
     &                   ,'#numer',0     ,MENUMR,'#ejavu',0     ,MEJAVU
     &                   ,'#sdoel',0     ,MESDEL,'#sombl',0     ,MESOBL)
      IF (NDIM.GE.3) CALL TBAR1  (ERCODE,'#facbl',0,MEFCBL)
      IF (NDIM.GE.2) CALL TBAR1  (ERCODE,'#arebl',0,MEARBL)
      MECORG=MECORG+1
      MEBLOK=MEFCBL
      IF (NBBBLK.GT.1) CALL TBAR1  (ERCODE,'#LOKEL',1,MEBLOK)
      CALL TAZERO (NBTPTG,'E',MEJAVU,AST,IST,RST,CST)                   !utilite
*
*     Tableaux Modulef (dont les adresses sont arguments de CONOPO)
*
      CALL READRE (2,'COOR',MOCOOR,NDIM*NBTPTG,M,NSORT)
      CALL READRE (1,'DESC',MODESC,(2+NBPTEX)*NBTEL,M,NSORT)
      CALL READRE (1,'REFS',MOREFS,NBSOXX(NDIM)*NBTEL,M,NSORT)
      CALL TAZERO (NBSOXX(NDIM)*NBTEL,'E',MOREFS,AST,M,RM,CST)          !utilite
      MOREFA=1
      IF (NDIM.GE.2) THEN
         CALL READRE (1,'REFA',MOREFA,1+NBARXX(NDIM)*NBTEL,M,NSORT)
         CALL TAZERO (NBARXX(NDIM)*NBTEL,'E',MOREFA,AST,M,RM,CST)       !utilite
      ENDIF
      MOREFF=1
      IF (NDIM.GE.3) THEN
         CALL READRE (1,'REFF',MOREFF,1+NBFAXX(NDIM)*NBTEL,M,NSORT)
         CALL TAZERO (NBFAXX(NDIM)*NBTEL,'E',MOREFF,AST,M,RM,CST)       !utilite
      ENDIF
*
      IADESC=MODESC
      IAREFS=MOREFS
      IAREFA=MOREFA
      IAREFF=MOREFF
      IASOBL=MESOBL
      NWTPTG=0
      NUTYAV=0
*
      DO 20 L=1,NBTEL
         CALL EXBLOK (L,IST(MEBLOK),NUTYLE)                             !sdexplo
         IF (NUTYLE.NE.NUTYAV) THEN
            CALL ELEMNB (NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE
     &                  ,NBNE,NBDL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)         !ef3d
            CALL NUSPLT (NUTYLE,NDIML, IFORME, ITYPE)
            NCGE=NBSOMT
            IF (NDIM.EQ.3) NCGE=7-IFORME
         ENDIF
*
         CALL NME2MO (LEYTUN (NUTYLE),NBNE,IST(MENUMR))
*
*        Numero de Code Geometrique de l'Element
         M(IADESC)=NCGE
*
*        Numero de sous-domaine de l'element
         IADESC=IADESC+1
         M(IADESC)=IST(MESDEL)
         MESDEL=MESDEL+1
*
*        Transfert des numeros globaux des sommets et des
*        coordonnees des noeuds selon la numerotation globale Modulef
         CALL ME2LNO (NDIM,NBSOMT,NBNE,IST(MENUMR),IST(MEJAVU)
     &               ,IST(MENUMG),RST(MECORG),NWTPTG,M(IADESC+1)
     &               ,RM(MOCOOR))
         IADESC=IADESC+NBSOMT+1
         MECORG=MECORG+NBPTEX*NDIM+1
         MENUMG=MENUMG+NBPTEX
*
*        Numeros de references des faces
         IF (NDIM.EQ.3) THEN
            IF (IST(MEFCBL).GT.0) THEN
               CALL FME2MO (LEYTUN(NUTYLE),NBFACE,IST(MENUMR))
               DO 14 NUF=1,NBFACE
                  IFACE            =IST(MENUMR-1+NUF)
                  M(IAREFF-1+IFACE)=IST(MEFCBL+NUF)
14             CONTINUE
            ENDIF
            IAREFF=IAREFF+NBFACE
            MEFCBL=MEFCBL+INCFAC
         ENDIF
*
*        Numeros de references des aretes
         IF (NDIM.GE.2) THEN
            IF (IST(MEARBL).GT.0) THEN
               CALL AME2MO (LEYTUN(NUTYLE),NBARET,IST(MENUMR))
               DO 15 NUF=1,NBARET
                  IARET            =IST(MENUMR-1+NUF)
                  M(IAREFA-1+IARET)=IST(MEARBL+NUF)
15             CONTINUE
            ENDIF
            IAREFA=IAREFA+NBARET
            MEARBL=MEARBL+INCARE
         ENDIF
*
*        Numeros de references des sommets
         IF (IST(IASOBL).GT.0) THEN
            CALL NME2MO (LEYTUN(NUTYLE),NBSOMT,IST(MENUMR))
            DO 16 NUF=1,NBSOMT
               ISOMT            =IST(MENUMR-1+NUF)   
               M(IAREFS-1+ISOMT)=IST(IASOBL+NUF)
16          CONTINUE
         ENDIF 
         IAREFS=IAREFS+NBSOMT
         IASOBL=IASOBL+INCSOM 
20    CONTINUE
*
      IF (NBBBLK.GT.1) CALL TBSAVE ('#LOKEL',1)
      CALL TBSAVE ('#ORPTL',NIVEGE)
      CALL TBSAVE ('#GNEEL',NIVENG)
      IF (NDIM.GE.3) CALL TBTUER ('#facbl',0)
      IF (NDIM.GE.2) CALL TBTUER ('#arebl',0)
      CALL TBTUER ('#sombl',0)
      CALL TBTUER ('#numer',0)
      CALL TBTUER ('#ejavu',0)
*
      NINOPO=1
      CALL CONOPO (M,RM,NDIM,NBTEL,NWTPTG,MODESC,MOREFS,MOREFA,MOREFF
     &            ,MOCOOR,FICOUT,NINOPO)
      CALL TUER  ('COOR',M)
      CALL TUER  ('DESC',M)
      CALL TUER  ('REFS',M)
      IF (NDIM.GE.2) CALL TUER  ('REFA',M)
      IF (NDIM.GE.3) CALL TUER  ('REFF',M)
      CALL PRFXMJ (-1,'*Me2Nop*')   
                                                                    END !Me2Nop
