*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MELIS2 (NDIM,NDMDOM,NBBORD,NUREFE,NDSD,NDSDE,NBTEL,L
     &                  ,NBNE,NBDL,NBNEBX,NBDLBX
     &                  ,LGMDOM,NBDOMG,NCHDOM,AST,IST,CRETAB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin  
* Derniere modification : D.Martin (20 avril 2007)
* Version 3
*
* Construction d'une structure #ISTEL pour un domaine de Melina de dimension
* inferieure a la dimension d'espace
*
* NDIM   dimension d'espace
* NDMDOM dimension du domaine
* NBBORD nombre de faces ou aretes ou points pour l'element courant
* NUREFE tableau des numeros de references des faces/aretes de l'element courant
* NDSD   plus grand numero de sous-domaine au sens de Modulef
* NDSDE  numero  de sous domaine de l'element courant
* NBTEL  nombre total d'elements
* L      numero de l'element courant
* NBNE   nombre de noeuds de l'element courant
* NBDL   nombre de d.l. de l'element courant
* NBNEBX nombre maximum de noeuds sur un bord de l'element courant
* NBDLBX nombre maximum de d.l. sur un bord de l'element courant
* LGMDOM longueur du tableau de caracteres des noms de domaine
* NBDOMG nombre de domaine (au sens de Melina)
* NCHDOM nombre de caracteres maximum par nom de domaine
* AST    super-tableau de caracteres de Melina
* IST    super-tableau de Melina, version entiere
* CRETAB indicateur de creation d'un tableau #ISTEL
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER AST(*),CRETAB*(*)
      INTEGER   NDIM,NDMDOM,NBBORD,NUREFE(*),NDSD,NDSDE,NBTEL,L
     &         ,NBNE,NBDL,NBNEBX,NBDLBX,LGMDOM,NBDOMG,NCHDOM,IST(*)
*
      INTEGER   NUDOMG,NBELDO,MCMDOM,MCLIST,LGLIST,ADLIST,MESNIV,ADSNIV
     &         ,IREFEL,MEBORD,MOBORD,NIVLIS,NBBORX,MEMEMO,NCATRM
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MeLis2*')
*
      DO 10 MEBORD=1,NBBORD 
*        tableau des numeros de sous-domaines ou de reference des domaines
         CALL TBAR1  (ERCODE,'#isniv',0,MESNIV)
*        tableau de correspondance entre numeros locaux des faces
*        de Melina et de Modulef
         CALL TBAR1  (ERCODE,'#umemo',0,MEMEMO)
         MOBORD=IST(MEMEMO-1+MEBORD)
*        numero de reference au sens modulef
         IREFEL=NUREFE(MOBORD)
         IF (IREFEL.GT.0) THEN
            ADLIST=MESNIV
            DO 4 NIVLIS=1,NBDOMG
               IF (IREFEL.EQ.ABS(IST(ADLIST))
     &        .AND.NDSDE.EQ.ABS(IST(ADLIST+1))) GOTO 6
               ADLIST=ADLIST+2
 4          CONTINUE
*
*           Creation d'un nouveau domaine de bord
*
            NIVLIS=NBDOMG+1
            CALL TBAR1  (ERCODE,'#OMDOM',1,MCMDOM)
            CALL RDNOMD (NDIM,NDMDOM,IREFEL,NDSD,NDSDE,AST(MCMDOM)
     &                  ,LGMDOM,NBDOMG,NUDOMG,NCHDOM)                   !momeutil
*
            ADSNIV       = MESNIV+2*NIVLIS-2
            IST(ADSNIV)  = IREFEL
            IST(ADSNIV+1)= NDSDE
            IF (IREFEL.GT.0.AND.NDSDE.GT.0) THEN
*
*              Sur-estimation de la longueur du tableau #ISTEL
*              Nombre de bords d'un element :
*              1 element -> NBBORX
*              element sur une epaisseur 2*(NBBORX-1)*NBTEL
               NBBORX=2*NDIM
               LGLIST=8+2*MAX(NBBORX,(NBBORX-1)*(NBTEL-L+1))
*
*              Creation et initialisation du tableau #ISTEL,NIVLIS
*
               CALL TBCREE ('#ISTEL',NIVLIS,1,LGLIST,'c')
               CALL TBAR2  (ERCODE,'#ISTEL',NIVLIS,MCLIST
     &                            ,'#isniv',0,MESNIV)
               CRETAB(2:2)='Y'
*
*              Entete du tableau #ISTEL,NIVLIS
*
               NBELDO=0
*              longueur du tableau
               IST(MCLIST)   = LGLIST
*              dimension du domaine
               IST(MCLIST+1) = NDMDOM
*              dimension des elements supports des constituants du domaine
               IST(MCLIST+2) = NDIM
*              nombre de constituants du domaine
               IST(MCLIST+3) = NBELDO
*              maximum de points d'un element du domaine
               IST(MCLIST+4) = NBNE
               IST(MCLIST+5) = NBDL
*              maximum de points d'un bord d'un element du domaine
               IST(MCLIST+6) = NBNEBX
               IST(MCLIST+7) = NBDLBX
            ELSE
               NDSDE=ABS(NDSDE)
               IREFEL=ABS(IREFEL)
               GOTO 10
            ENDIF
*
*           Enrichissement de la structure d'un domaine existant
*
 6          ADSNIV=MESNIV+2*NIVLIS-2
            IF (IST(ADSNIV).GT.0.AND.IST(ADSNIV+1).GT.0) THEN
               CALL TBAR1  (ERCODE,'#ISTEL',NIVLIS,MCLIST)
               LGLIST=IST(MCLIST)
               NBELDO=IST(MCLIST+3)
*              test sur la longueur de #ISTEL
               IF (LGLIST.LT.8+2*NBELDO+2) GOTO 90000
               NBELDO=NBELDO+1
*              En commentaire le 21/10/2005 (qui avait ecrit cette ligne ?)
*              La longueur du tableau #ISTEL est ajustee en sortie
*               IST(MCLIST)  =8+2*NBELDO
*              un constituant de plus dans le domaine
               IST(MCLIST+3)=NBELDO
               ADLIST=MCLIST+8+2*(NBELDO-1)
               IST(ADLIST)   = L
               IST(ADLIST+1) = MEBORD
*
               IST(MCLIST+4) = MAX (NBNE,IST(MCLIST+4))
               IST(MCLIST+5) = MAX (NBDL,IST(MCLIST+5))
               IST(MCLIST+6) = MAX (NBNEBX,IST(MCLIST+6))
               IST(MCLIST+7) = MAX (NBDLBX,IST(MCLIST+7))
            ENDIF
         ENDIF
 10   CONTINUE
*
      CALL PRFXMJ (-1,'*MeLis2*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL PRNTRM ('#ISTEL',NIVLIS,ERCODE,NCATRM)
      CALL ENCLER (LGLIST,ERCODE(NCATRM+1:NCATRM+10))
      CALL ENCLER (NBELDO,ERCODE(NCATRM+11:NCATRM+20))
      CALL BAISE  ('Taille ('//ERCODE(NCATRM+1:NCATRM+10)
     &//' mots) sous-estimee pour le tableau '//ERCODE(1:NCATRM)
     &//'. Le domaine contient actuellement ' 
     &//ERCODE(NCATRM+11:NCATRM+20)//' elements.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (20 avril 2007)
* - suppression argument NDSR inutile (arg. de RDNOMD)
* Version 2 : D.Martin (21 octobre 2005)
* Version 1.4 : D.Martin (6 Fevrier 2004) bug longueur du tableau (LGLIST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !MeLis2
