*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MELIS3 (NDIM,NDSD,NDSDE,NBTEL,L,NBNE,NBDL
     &                  ,LGMDOM,NBDOMG,NCHDOM,AST,IST,CRETAB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1993)
* Derniere modification : D.Martin (20 avril 2007)
* Version 3
*
* Construction d'une structure #ISTEL pour un domaine de Melina dont
* la dimension est le dimension d'espace
*
* NDIM   dimension d'espace
* NDSD   plus grand numero de sous-domaine au sens de Modulef
* NDSDE  numero de sous-domaine au sens de Modulef
* NUMEMO tableau de correspondance entre numeros locaux des faces de Melina
*        et Modulef
* NBTEL  nombre total d'elements
* L      element courant
* NBNE   nombre de noeuds de l'element
* NBDL   nombre de d.l. de l'element
* LGMDOM longueur du tableau de caracteres des noms de domaine
* NBDOMG nombre de domaine (au sens de Melina)
* NCHDOM nombre de caracteres maximum par nom de domaine
* AST    super-tableau de caracteres de Melina
* IST    super-tableau de Melina, version entiere
* CRETAB indicateur de creation d'un tableau #ISTEL
*
* Historique
* Version 1.4 (6 Fevrier 2004) bug longueur du tableau (LGLIST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER AST(*),CRETAB
      INTEGER   NDIM,NDSD,NDSDE,NBTEL,L,NBNE,NBDL,LGMDOM,NBDOMG,NCHDOM
     &         ,IST(*)
*
      INTEGER   NUDOMG,NBELDO,MCMDOM,MCLIST,LGLIST,ADSNIV,MESNIV,IREFEL
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MeLis3*')
*
      CRETAB='N'
      IF (NDSDE.GT.0) THEN 
*        tableau des numeros de sous-domaines ou de reference des domaines
         CALL TBAR1  (ERCODE,'#isniv',0,MESNIV)
         IREFEL=0
         ADSNIV=MESNIV
         DO 4 NUDOMG=1,NBDOMG
            IF (IST(ADSNIV).EQ.NDSDE.AND.IST(ADSNIV+1).EQ.IREFEL) GOTO 6
            ADSNIV=ADSNIV+2
 4       CONTINUE
         CALL TBAR1  (ERCODE,'#OMDOM',1,MCMDOM)
         CALL RDNOMD (NDIM,NDIM,IREFEL,NDSD,NDSDE,AST(MCMDOM)
     &               ,LGMDOM,NBDOMG,NUDOMG,NCHDOM)                      !momeutil
*
         ADSNIV       = MESNIV+2*NUDOMG-2
         IST(ADSNIV)  = NDSDE
         IST(ADSNIV+1)= IREFEL
*
         IF (NDSDE.GT.0) THEN
            LGLIST = 6+NBTEL-L+1
*
*           Creation et initialisation du tableau #ISTEL,NUDOMG
*
            CALL TBCREE ('#ISTEL',NUDOMG,1,LGLIST,'c')            
            CALL TBAR2  (ERCODE,'#ISTEL',NUDOMG,MCLIST
     &                         ,'#isniv',0,MESNIV)
            CRETAB = 'Y'
*
*           Entete du tableau #ISTEL,NIVLIS
*
            NBELDO = 0
            IST(MCLIST)   = LGLIST
*           dimension du domaine
            IST(MCLIST+1) = NDIM
*           dimension d'espace
            IST(MCLIST+2) = NDIM
*           nombre d'element du domaine
            IST(MCLIST+3) = NBELDO
*           maximum de points d'un element du domaine
            IST(MCLIST+4) = NBNE
            IST(MCLIST+5) = NBDL
         ENDIF
         NDSDE=ABS(NDSDE)
*
*        Enrichissement de la structure d'un domaine existant
*
 6       ADSNIV=MESNIV+2*NUDOMG-2
            IF (IST(ADSNIV).GT.0) THEN
            CALL TBAR1  (ERCODE,'#ISTEL',NUDOMG,MCLIST)
            NBELDO=IST(MCLIST+3)
*           un element de plus dans le domaine
            NBELDO=NBELDO+1
*           En commentaire le 21/10/2005 (qui avait ecrit cette ligne ?)
*           La longueur du tableau #ISTEL est ajustee en sortie
*            IST(MCLIST)   = 6+NBELDO
            IST(MCLIST+3) = NBELDO
            IST(MCLIST+5+NBELDO) = L
*
            IST(MCLIST+4) = MAX(IST(MCLIST+4),NBNE)
            IST(MCLIST+5) = MAX(IST(MCLIST+5),NBDL)
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*MeLis3*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (20 avril 2007)
* - suppression argument NDSR inutile (arg. de RDNOMD)
* Version 2 : D.Martin (21 octobre 2005)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !MeLis3
