*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION MENUTY (NDIM,NCGE,NNO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur D.Martin (Avril 1993)
* Derniere modification : D.Martin (20 Octobre 2005)
* Version 2
*
* Definit le type d'element selon 'Melina' d'apres la dimension,
* le numero de code de Modulef (NCGE) et le nombre de noeuds (NNO)
*
* NDIM dimension d'espace
* NCGE numero de code de l'element selon Modulef
* NNO  nombre de noeuds
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER MENUTY,NDIM,NCGE,NNO
*
      INTEGER NTYPFO,IFORME,ITYPE
      PARAMETER (NTYPFO = 1000)
*-----------------------------------------------------------------------
      IFORME = -1
      ITYPE  = -1
      IF (NCGE.EQ.7) THEN
*        Cas des hexaedres
         IFORME=30
         IF(NNO.EQ.8)  ITYPE=1
         IF(NNO.EQ.27) ITYPE=2
         IF(NNO.EQ.20) ITYPE=202
      ELSEIF (NCGE.EQ.6) THEN
*        Cas des prismes
         IFORME=31
         IF(NNO.EQ.6)  ITYPE=1
         IF(NNO.EQ.18) ITYPE=2
         IF(NNO.EQ.15) ITYPE=202
      ELSEIF (NCGE.EQ.5) THEN
*        Cas des tetraedres
         IFORME=32
         IF(NNO.EQ.4)  ITYPE=1
         IF(NNO.EQ.10) ITYPE=2
      ELSEIF (NCGE.EQ.4) THEN
*        Cas des quadrangles
         IFORME=20
         IF(NNO.EQ.4)  ITYPE=1
         IF(NNO.EQ.9)  ITYPE=2
         IF(NNO.EQ.8)  ITYPE=202
      ELSEIF (NCGE.EQ.3) THEN
*        Cas des triangles
         IFORME=21
         IF(NNO.EQ.3) ITYPE=1
         IF(NNO.EQ.6) ITYPE=2
      ENDIF
*
      IF (NNO.EQ.1) ITYPE=0
      IF (ITYPE.LT.0.OR.IFORME.LT.0) THEN
         WRITE(*,*) ' *MeNuty* Incoherence dans les donnees :'
         WRITE(*,*) 'NDIM=',NDIM,'  NCGE=',NCGE,'  NNO=',NNO
         STOP ' *Menuty*'
      ENDIF
      MENUTY = IFORME * NTYPFO + ITYPE
                                                                    END !MeNuty
         
