*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MO2BLK (NDIM,NBTEL,NCACAR,NCOPNP
     &                  ,IANOP5,NOP5,IAMAIL,MAIL,MAIC,MAII,MAIJ
     &                  ,BLOKEL,INTRPG,NBPTEX,NBBBLK,NU1BLK)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)  
* Derniere modification : D.Martin (13 Juillet 1997)
* Version 1.0.0
*
* Remplissage du tableau #LOKEL a partir d'un tableau NOP5 d'une structure NOPO
* ou des tableaux MAIC, MAII, MAIJ et MAIL d'une structure MAIL
*
*-- Arguments d'entree --
* NDIM   dimension d'espace
* NBTEL  nombre d'elements
* NCACAR indicateur des caracteristiques des points (adresse 7 de MAI2)
* NCOPNP coincidence ou non des points et des noeuds (adresse 8 de MAI2)
* IANOP5 adresse variable dans NOP5 si >0
* NOP5   tableau NOP5 a son adresse initiale si IANOP5 >0
* IAMAIL adresse variable dans MAIL si >0
* MAIL,MAIC,MAII,MAIJ  tableaux MMAIL,AIC,MAII,MAIJ, si IAMAIL >0
*-- Arguments de sortie --
* BLOKEL tableau #LOKEL a son adresse initiale (Melina)
* INTRPG numero de type d'interpolation (Melina)
* NBPTEX nombre max. de points par element (Melina)
* NBBBLK nombre de blocs de #LOKEL
* NU1BLK nuemro de type Melina des elements du 1er bloc
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,NBTEL,NCACAR,NCOPNP,IANOP5,NOP5(*)
     &       ,IAMAIL,MAIL(*),MAIC(*),MAII(*),MAIJ(*)
     &       ,BLOKEL(*),INTRPG,NBPTEX,NBBBLK,NU1BLK
*
      INTEGER NBELBK,NUTYAV,NEXT,L,MENUTY,NUTYLE,LAGHER,KCLASS
     &       ,NBSOMT,NBARET,NBFACE,NBDL,NBNEFL,NBDLFL,NBNEAL,NBDLAL
      INTEGER NCGE,NMAE,NDSDE,NBNE,NTYE,NTALIR
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mo2Blk*')
      NBELBK=0
      NBBBLK=0
      NBPTEX=0
      NUTYAV=0
      NEXT=4
      DO 1 L=1,NBTEL
         CALL MOATRL (IANOP5,NOP5,IAMAIL,MAIL,MAIC,NCACAR               !mo2me
     &               ,NCGE,NMAE,NDSDE,NBNE,NTYE,NTALIR)
         NUTYLE=MENUTY (NDIM,NCGE,NBNE)                                 !momeutil
         INTRPG=MOD(NUTYLE,100)
         IF (NUTYLE.NE.NUTYAV) THEN
            IF (NUTYAV.NE.0) THEN
               BLOKEL(NEXT)  =NBELBK
               BLOKEL(NEXT+1)=NUTYAV
               NBBBLK        =NBBBLK+1
               NBELBK        =0
               NEXT          =NEXT+2
            ENDIF
            CALL ELEMNB (NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE      !efxd
     &                  ,NBNE,NBDL,NBNEAL,NBDLAL,NBNEFL,NBDLFL)
            NBPTEX=MAX (NBNE,NBPTEX)
         END IF
         NBELBK=NBELBK+1
         NUTYAV=NUTYLE
         CALL MORIP1 (IANOP5,NOP5,IAMAIL,MAIL,MAII,MAIJ,NCOPNP
     &               ,NBNE,NTYE,NTALIR)                                 !mo2me
         IF (NMAE.GT.0) THEN
            IF (IANOP5.GT.0) THEN
               IANOP5=IANOP5+NMAE
            ELSEIF (IAMAIL.GT.0) THEN
               IAMAIL=IAMAIL+NMAE
            ENDIF
         ENDIF
1     CONTINUE
      BLOKEL(NEXT)  =NBELBK
      BLOKEL(NEXT+1)=NUTYAV
      NBBBLK        =NBBBLK+1
      BLOKEL(1)     =3
      BLOKEL(2)     =NBBBLK
      BLOKEL(3)     =2
      NU1BLK        =BLOKEL(5)
      WRITE (*,10000) NBBBLK
      CALL PRFXMJ (-1,'*Mo2Blk*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*Mo2Blk* Construction de #LOKEL :',I3,' bloc(s)'/)
                                                                    END !Mo2Blk
