*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MO2LME (NDIM,NBTEL,NCACAR,NCOPNP,IANOP5,NOP5,NOP4
     &                  ,IAMAIL,MAIL,MAIC,MAII,MAIJ,COO4,NBPTEX,CORLOC
     &                  ,FCTBAS,NUMEMO,NGNEME,COORME)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1993) 
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*   
* Assure la traduction des tableaux Modulef: 
*      NOP5 et NOP4 d'une structure NOPO
*   ou MAIL & COOR4 des structures MAIL & COOR
*   en les tableaux type Melina : #GNEEL et #ORPTL
*
*-- Arguments --
* NDIM   dimension d'espace
* NBTEL  nombre d'elements
* NCACAR indicateur des caracteristiques des points (adresse 7 de MAI2)
* NCOPNP indicateur Modulef de coincidence des points et noeuds
* IANOP5 adresse variable dans NOP5 si >0
* NOP5   tableau NOP5 a son adresse initiale si IANOP5 >0
* NOP4   tableau des coordonnees NOP4 si IANOP5 >0
* IAMAIL adresse variable dans MAIL si >0
* MAIL,MAIC,MAII,MAIJ  tableaux MAIL,MAIC,MAII,MAIJ, si IAMAIL >0
* COO4   tableau des coordonnees NOP4 si IAMAIL > 0
* NBPTEX nombre maximum de points par elements
* NUMEMO tableau des correspondances numeros locaux modulef et melina
* NGNEME tableau #GNEEL de Melina
* COORME tableau #ORPTL de Melina
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NDIM,NBTEL,NCACAR,NCOPNP,IANOP5,NOP5(*)
     &             ,IAMAIL,MAIL(*),MAIC(*),MAII(*),MAIJ(*)
     &             ,NBPTEX,NUMEMO(*),NGNEME(*)
      REAL          NOP4(NDIM,*),COO4(NDIM,*),COORME(*),CORLOC(NDIM,*)
     &             ,FCTBAS(*)
*
      CHARACTER*5   LEYTUN
      INTEGER       MENUTY,IACORG,IANUMG,NUTYAV,NCGE,NMAE,NDSDE,NBNE
     &             ,NTYE,NTALIR,NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET
     &             ,NBFACE,NBDL,NBNEFL,NBDLFL,NBNEAL,NBDLAL,NUTGEO
     &             ,IACOOR,IANUME,NUMGLO,NBPO,L,IDLME,IDIM
      REAL          BID
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mo2Lme*')
      IACORG=2
      IANUMG=1
      NUTYAV=0
      DO 100 L=1,NBTEL
         CALL MOATRL (IANOP5,NOP5,IAMAIL,MAIL,MAIC,NCACAR,NCGE,NMAE
     &               ,NDSDE,NBNE,NTYE,NTALIR)                           !mo2me
         NUTYLE = MENUTY (NDIM,NCGE,NBNE)                               !mo2me
*
         IF (NUTYLE.NE.NUTYAV) THEN
            CALL ELEMNB (NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE
     &                  ,NBNE,NBDL,NBNEAL,NBDLAL,NBNEFL,NBDLFL)         !ef3d
            NUTGEO = MENUTY (NDIM,NCGE,NBSOMT)                          !mo2me
            CALL ELEMCO (NUTYLE,NDIM,CORLOC)                            !ef3d
            CALL NME2MO (LEYTUN(NUTYLE),NBNE,NUMEMO)                    !mo2me
            NUTYAV=NUTYLE
         ENDIF
*
         IACOOR = IACORG
         IANUME = IANUMG
         IF (IANOP5.GT.0) THEN
            DO 2 IDLME=1,NBNE
               NUMGLO           = NOP5(IANOP5-1+NUMEMO(IDLME))
               NGNEME(IANUME)   = NUMGLO
               IANUME           = IANUME+1
               DO 1 IDIM=1,NDIM
                  COORME(IACOOR)= NOP4(IDIM,NUMGLO)
                  IACOOR        = IACOOR+1
1              CONTINUE
2           CONTINUE
         ELSEIF (IAMAIL.GT.0) THEN
            DO 3 IDLME=1,NBNE
               NUMGLO           = MAIL(IAMAIL-1+NUMEMO(IDLME))
               NGNEME(IANUME)   = NUMGLO
               IANUME           = IANUME+1
3           CONTINUE
            IF (NCOPNP.NE.0) THEN
*              Points et noeuds coincident
               DO 5 IDLME=1,NBNE
                  NUMGLO           = MAIL(IAMAIL-1+NUMEMO(IDLME))
                  DO 4 IDIM=1,NDIM
                     COORME(IACOOR)= COO4(IDIM,NUMGLO)
                     IACOOR        = IACOOR+1
4                 CONTINUE
5              CONTINUE
            ELSE
*              Coordonnees des sommets
               NBPO=MAIL(IAMAIL+NBNE)
               IF (NBPO.NE.NBSOMT)
     &         CALL BAISE(' Nombre de points Modulef # nombre de points'
     &         //' Melina ?')
               DO 7 IDLME=1,NBPO
                  NUMGLO           = MAIL(IAMAIL+NBNE+NUMEMO(IDLME))
                  DO 6 IDIM=1,NDIM
                     COORME(IACOOR)= COO4(IDIM,NUMGLO)
                     IACOOR        = IACOOR+1
6                 CONTINUE
7              CONTINUE
*              Calcul des coordonnees des noeuds non sommets
               DO 20 IDLME=NBPO+1,NBNE
                  CALL ELEMFB (NUTGEO,'YNN',CORLOC(1,IDLME),FCTBAS
     &                        ,BID,BID,0)                               !ef3d
                  CALL TRANSF (NDIM,NBSOMT,COORME(IACORG),FCTBAS
     &                        ,COORME(IACOOR))                          !ef3d
                  IACOOR=IACOOR+NDIM
20             CONTINUE
*              Si les elements sont courbes recuperer les coordonnees
*              des noeuds dans COO4 ?????? et ecraser les valeurs ci-dessus
            END IF

         END IF
         IANUMG = IANUMG+NBPTEX
         IACORG = IACORG+NDIM*NBPTEX+1
*
         CALL MORIP1 (IANOP5,NOP5,IAMAIL,MAIL,MAII,MAIJ,NCOPNP,NBNE
     &               ,NTYE,NTALIR)                                      !mo2me
         IF (NMAE.GT.0) THEN
            IF (IANOP5.GT.0) THEN
               IANOP5=IANOP5+NMAE
            ELSEIF (IAMAIL.GT.0) THEN
               IAMAIL=IAMAIL+NMAE
            ENDIF
         ENDIF
100   CONTINUE
      WRITE (*,10000)
      CALL PRFXMJ (-1,'*Mo2Lme*')
*-----------------------------------------------------------------------
10000 FORMAT (/T2,'*Mo2Lme* Construction de #GNEEL et #ORPTL'/)
                                                                    END !Mo2lMe
