*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MO2LSD (NDIM,NBTEL,NCACAR,NDSD,NCOPNP,IANOP5,NOP5
     &                  ,IAMAIL,MAIL,MAIC,MAII,MAIJ
     &                  ,LGMDOM,NBDOMG,NCHDOM,AST,IST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (20 avril 2007)
* Version 2
*
* Construction des #ISTEL pour les domaines de Melina dont la dimension
* est la dimension d'espace, a partir soit de la structure NOPO de Modulef,
* soit des structures MAIL & COOR de Modulef.
*
* NDIM   dimension d'espace
* NBTEL  nombre d'elements du maillage
* NCACAR
* NDSD   plus grand numero de sous-domaine au sens de Modulef
* NCOPNP indique la coincidence sommets-noeuds
* IANOP5 adresse de l'element courant dans le tableau NOP5
* NOP5   tableau NOP5 de la structure NOPO de Modulef
* IAMAIL adresse de l'element courant dans le tableau MAIL
* MAIL   tableau MAIL de description des elements
* MAIC   tableau MAIC de description des types d'elements
* MAII   tableau MAII
* MAIJ   tableau MAIJ
* LGMDOM longueur du tableau de caracteres des noms de domaine
* NBDOMG nombre de domaine (au sens de Melina)
* NCHDOM nombre de caracteres maximum par nom de domaine
* AST    super-tableau de caracteres de Melina
* IST    super-tableau de Melina, version entiere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     AST(*)
      INTEGER       NDIM,NBTEL,NCACAR,NDSD,NCOPNP,IANOP5,NOP5(*)
     &             ,IAMAIL,MAIL(*),MAIC(*),MAII(*),MAIJ(*)
     &             ,LGMDOM,NBDOMG,NCHDOM,IST(*)
*
      INTEGER       MENUTY
      INTEGER       NCGE,NMAE,NDSDE,NBNE,NTYE,NTALIR,INING
     &             ,NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE,NBDL
     &             ,NBNEFL,NBDLFL,NBNEAL,NBDLAL,NUTYAV,L
     &             ,MEMEMO,IAA
      CHARACTER     ERCODE*120,CRETAB
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mo2Lsd*')
*
      NUTYAV=0
      CRETAB='Y'
      DO 1 L=1,NBTEL
         CALL MOATRL (IANOP5,NOP5,IAMAIL,MAIL,MAIC,NCACAR
     &               ,NCGE,NMAE,NDSDE,NBNE,NTYE,NTALIR)                 !momeutil
         NUTYLE=MENUTY (NDIM,NCGE,NBNE)                                 !momeutil
         IF (NUTYLE.NE.NUTYAV) THEN
	       CALL ELEMNB (NUTYLE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE
     &                ,NBNE,NBDL,NBNEAL,NBDLAL,NBNEFL,NBDLFL) !ef3d
            NUTYAV=NUTYLE
         ENDIF
         IF (NDSDE.NE.0)
     &      CALL MELIS3 (NDIM,NDSD,NDSDE,NBTEL,L,NBNE,NBDL
     &                  ,LGMDOM,NBDOMG,NCHDOM,AST,IST,CRETAB)           !momeutil
         CALL MORIP1 (IANOP5,NOP5,IAMAIL,MAIL,MAII,MAIJ,NCOPNP,NBNE     !momeutil
     &               ,NTYE,NTALIR)
         IF (NMAE.GT.0) THEN
            IF (IANOP5.GT.0) THEN
               IANOP5=IANOP5+NMAE
            ELSEIF (IAMAIL.GT.0) THEN
               IAMAIL=IAMAIL+NMAE
            ENDIF
         ENDIF
1     CONTINUE
      WRITE(*,10000) '*Mo2Lsd*'
      CALL PRFXMJ (-1,'*Mo2Lsd*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Construction des #ISTEL en dimension d''espace '/)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (20 avril 2007)
* - suppression argument NDSR inutile (arg. de MELIS3)
* Version 1 : D.Martin (28 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Mo2Lsd

