*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MORIP1 (IANOP5,NOP5,IAMAIL,MAIL,MAII,MAIJ,NCOPNP
     &                  ,NBNE,NTYE,NTALIR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1993)
* Derniere modification : D.Martin (2 Mars 1995)
* Version 1.0.0
*
* Translation d'adresse dans le tableau NOP5 d'une NOPO ou le tableau MAIL 
* d'une structure MAIL lors du passage a l'element suivant
* 1) si IANOP5 > 0
*   IANOP5 en entree adrs rel. dans NOP5 du code (NCGE) de l'elt courant
*          en sortie ------------------- du 1er elt du tableau des references
*          ou du code (NCGE) de l'elt suivant si NMAE=0
*   NOP5   tableau NOP5 d'une structure NOPO
* 2) sinon si IAMAIL > 0
*   IAMAIL en entree adrs rel. dans MAIL du numero (NEL) de l'elt courant
*          en sortie ------------------- du 1er elt du tableau des references
*          ou du numero (NEL) de l'elt suivant si NMAE=0
*   MAIL,MAII,MAIJ tableaux MAIL, MAII, MAIJ d'une structure MAIL
*
* NCOPNP indicateur de coincidence des noeuds et des points
* NBNE   nombre de noeuds de l'element courant
* NTYE   numero de type (cas d'une structure MAIL)
* NTALIR nombre de tableaux presents parmi ceux associes a ce type d'element
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IANOP5,NOP5(*),IAMAIL,MAIL(*),MAII(*),MAIJ(*),NCOPNP
     &       ,NBNE,NTYE,NTALIR
*
      INTEGER IMM,ITALIR,NTTE,NITE,LL,JJ
*-----------------------------------------------------------------------
      IF (IANOP5.GT.0) THEN
*
*        Saut au dessus des tableaux de numeros globaux des noeuds
*        et le cas echeant des points
         IANOP5=IANOP5+NBNE
         IF (NCOPNP.EQ.0) IANOP5=IANOP5+1+NOP5(IANOP5)
*
      ELSEIF (IAMAIL.GT.0) THEN
*        (voir par exemple la procedure IMTAIL dans la lib. UTSD)
*
*        Saut au dessus des tableaux de numeros globaux des noeuds
*        et le cas echeant des points
         IAMAIL=IAMAIL+NBNE
         IF (NCOPNP.EQ.0) IAMAIL=IAMAIL+1+MAIL(IAMAIL)
*
*        Saut par dessus les tableaux 'a lire' correspondant au type
*        de l'element de reference
         NTALIR=NTALIR-1
         IF (NTALIR.GT.0) THEN
            IMM=1+MAII(NTYE)
            DO 16 ITALIR=1,NTALIR
               NTTE=MAIJ(IMM)
               NITE=MAIJ(IMM+1)
               LL=1
               DO 15 JJ=1,NITE
                 LL=LL*MAIJ(IMM+1+JJ)
15             CONTINUE
               IAMAIL=IAMAIL+LL
               IMM=IMM+2+NITE
16          CONTINUE
         ENDIF
      ENDIF
                                                                    END !MoRip1
