*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NOPO2M (M,RM,LM,IST,RST,CST,MAXIST,AST,MAXAST
     &                  ,NUNOPO,NUFOUT,NOFOUT)   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin  
* Derniere modification : D.Martin (20 avril 2007)
* Version 3
*   
* Creer un maillage Melina sur unite sequentielle formattee a partir
* d'une structure de donnees NOPO de Modulef.
*   
*-- Arguments d'entree --
* M      super-tableau version entiere de l'allocation dynamique Modulef
* RM     super-tableau version reelle Modulef
* LM     lomgueur du super-tableau de Modulef
* IST    super-tableau version entiere de l'allocation dynamique Melina
* RST    super-tableau version reelle Melina
* CST    super-tableau version complexe Melina
* MAXIST longueur du super-tableau scalaire Melina (IST,RST,CST)
* AST    super-tableau de caracteres de Melina
* MAXAST longueur du super-tableau caractere de Melina
* NUNOPO numero d'unite logique du fichier contenant la S.D.E. NOPO
* NUFOUT numero d'unite logique du fichier de maillage Melina
* NOFOUT nom du fichier de maillage Melina
*
*-- Procedures utilisees --
* RDNMVE          creation des noms de variables
* NO2BLK          creation de la structure #LOKEL
* MO2LME          d'un elt. Modulef a un elt. Melina
* MO2LSD          creation des structures #ISTEL de dimension NDIM
* MO2LSF          creation des structures #ISTEL de dimension 2 en 3d
* MO2LSA          creation des structures #ISTEL de dimension 1
* MO2LSS          creation des structures #ISTEL de dimension 0
* INITIS          Modulef lib.utii (ex UTIL) 
* SDREST          Modulef lib.utsd 
* INITIA, INIFIC  Melina  mod.Initial
* ECGEOM          Melina  mod.Lecgeom
* STINIT          Melina  lib.allodyn
* TBCREE          Melina  lib.allodyn
* TAZERO          Melina  lib.Utiliter
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER        AST(*)
      CHARACTER*(*)    NOFOUT
      INTEGER          M(*),LM,IST(*),MAXIST,MAXAST,NUNOPO,NUFOUT
      REAL             RM(*),RST(*)
      COMPLEX          CST(*)
*
      INCLUDE 'CONTEX'
*
      INTEGER          LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &                ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &                ,NUM,NUMOLD,LECOLD,LCANTE,LECACT,LASAPL
      INTEGER          NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
     &                ,LGVARE,MCVARE,LGBLOK,MEBLOK,LGWORK,MENUMG,MECORG
     &                ,MEMEMO,MEWORK,NCHDOM,LGMDOM,LGSNIV,MESNIV,IDOMG
     &                ,NBDOAV,MCLIST,LGENTE,INCREM,LGSTRU,MCTRDO,NIVEGE
      INTEGER          menopo,lgnopo,ninopo,nnopo ,ianopo
     &                ,MONOP0,MONOP2,MONOP4,MONOP5,IANOP5,NDSR,NDSD
     &                ,NCOPNP,NTYCOO,NTACOO,IAMAIL
      COMMON/REDCA1/   NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDLST/   LECOLD,LCANTE,NUMOLD /LASAPL/LASAPL
*
      CHARACTER     ERCODE*120,REPONS*80
      COMMON/FORMAH/ERCODE
      INTEGER       NBDLXX(3) ,NBSOXX(3),NBARXX(3),NBFAXX(3)
      DATA NBDLXX/3,9,27/,NBSOXX/2,4,8/,NBARXX/0,4,12/,NBFAXX/0,0,6/
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Nopo2M*')
*   
*--   Initialisation de l'allocation dynamique de Modulef
      CALL INITIS (M,LM,0,0)                                            !utii
*
*--   Initialisation et Valeurs par defaut
      CALL INITIA (MAXIST,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &            ,ISEUIL,NBBUF,NBUTMX,NBUNIT,STDIN,STDOUT
     &            ,NUM,NUMOLD,LECACT,LECOLD,LCANTE,LASAPL)              !initial
* 
*--   Initialisation de l'allocation dynamique de Melina
      CALL STINIT (MAXAST,MAXIST,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF
     &            ,NBUTMX,NBUNIT,INTMAX,IMPALO,IMPERR)
*
*--   Initialisation du systeme d'unites logiques
      CALL INIFIC (LASNUF,STDOUT,IMPPAL,IMPSDR,IMPMES,ABS(IMPALO)
     &            ,IMPERR)                                              !initial
      lgnopo = 19
      CALL TBCREE ('%nopo%',0,1,lgnopo,'c')
      CALL TBAR1  (ERCODE,'%nopo%',0,menopo)                     
*
*--   Restauration de la S.D.E. NOPO
*
      ninopo=1
      CALL SDREST (M,'NOPO',NUNOPO,ninopo,IST(menopo),lgnopo
     &            ,nnopo,ianopo)                                        !utsd
      MONOP0=IST(menopo+2)
      MONOP2=IST(menopo+8)
      MONOP4=IST(menopo+14)
      MONOP5=IST(menopo+17)
      CALL TBTUER ('%nopo%',0)
*
*--   Tableau NOP2 de la structure NOPO de Modulef
*
      NDIM  =M(MONOP2)
      NDSR  =M(MONOP2+1)
      NDSD  =M(MONOP2+2)
      NCOPNP=M(MONOP2+3)
      NBTEL =M(MONOP2+4)
      NBTPTG=M(MONOP2+14)
      NTYCOO=M(MONOP2+22)
      NTACOO=M(MONOP2+26)
*
*--   Tableau des noms des variables d'espace Melina
*
      LGVARE=18
      CALL TBCREE ('#ARIAB',1,11,LGVARE,'c')                     
      CALL TBAR1  (ERCODE,'#ARIAB',1,MCVARE)                     
      CALL RDNMVE (NTACOO,NDIM,AST(MCVARE),NBCNVE,LGVARE,IMPPAL)        !momeutil
      CALL TBAJST ('#ARIAB',1,NDIM*NBCNVE)
*
*--   Creation de la structure #LOKEL
*
      LGBLOK=3+2*NBTEL
      CALL TBCREE ('#LOKEL',1,1,LGBLOK,'c')
      CALL TBAR1  (ERCODE,'#LOKEL',1,MEBLOK)                     
      IANOP5=1
      IAMAIL=0
      CALL MO2BLK (NDIM,NBTEL,0,NCOPNP,IANOP5,M(MONOP5)
     &            ,IAMAIL,M(1),M(1),M(1),M(1)
     &            ,IST(MEBLOK),INTRPG,NBPTEX,NBBBLK,NU1BLK)             !momeutil
      LGBLOK=IST(MEBLOK)+IST(MEBLOK+2)*IST(MEBLOK+1)
      CALL TBAJST ('#LOKEL',1,LGBLOK)
*
*--   Creation des tableaux #ORPTL et #GNEEL de Melina
*
      NIVENG=INTRPG
      NIVEGE=0
      CALL TBCREE ('#ORPTL',NIVEGE,2,NBTEL*(NDIM*NBPTEX+1),'c')
      CALL TBCREE ('#GNEEL',NIVENG,1,NBTEL*NBPTEX,'c')
      CALL TBCREE ('#umemo',0,1,NBDLXX(NDIM),'c')
      LGWORK=3*27+27
      CALL TBCREE ('#work#',0,2,LGWORK,'c')
      CALL TBAR4  (ERCODE,'#GNEEL',NIVENG,MENUMG,'#ORPTL',NIVEGE,MECORG
     &                   ,'#umemo',   0  ,MEMEMO,'#work#',0     ,MEWORK)
      IANOP5=1
      CALL MO2LME (NDIM,NBTEL,0,NCOPNP,IANOP5,M(MONOP5),RM(MONOP4)
     &            ,IAMAIL,M(1),M(1),M(1),M(1),RM(1)
     &            ,NBPTEX,RST(MEWORK),RST(MEWORK+3*27)
     &            ,IST(MEMEMO),IST(MENUMG),RST(MECORG))                 !mo2me
      CALL TBSAVE ('#ORPTL',NIVEGE)
      CALL TBSAVE ('#GNEEL',NIVENG)
      CALL TBTUER ('#work#',0)
*
*--   Creation des tableaux #ISTEL des domaines de dimension NDIM
*
      NBDOMG=0
      NCHDOM=0
*     2*100*(noms de domaine de 10 caracteres au plus)
      LGMDOM=2000
      CALL TBCREE ('#OMDOM',1,11,LGMDOM,'c')                     
*     2*( 100 references au plus ) et 12 faces, aretes ou point ...
      LGSNIV=200+12
      CALL TBCREE ('#isniv',0,1,LGSNIV,'c')
      CALL TBAR1  (ERCODE,'#isniv',0  ,MESNIV)
      CALL TAZERO (LGSNIV,'E',MESNIV,AST,IST,RST,CST)
      IANOP5=1
      CALL MO2LSD (NDIM,NBTEL,0,NDSD,NCOPNP,IANOP5,M(MONOP5)
     &            ,IAMAIL,M(1),M(1),M(1),M(1)
     &            ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                        !momeutil
*     a posteriori ... #isniv a-t-il deborde ?
      IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv')    !utilite
*     Boucle pour ajuster les tableaux #ISTEL crees.
      DO 1 IDOMG=1,NBDOMG
         ERCODE='!'
         CALL TBAR1  (ERCODE,'#ISTEL',IDOMG,MCLIST)
         IF (ERCODE(1:1).EQ.' ')
     &      CALL TBAJST ('#ISTEL',IDOMG,6+IST(MCLIST+3))
 1    CONTINUE
      NBDOAV=NBDOMG
*
*--   Creation des tableaux #ISTEL des domaines de dimension 2 en 3D
*
      IF (NDIM.GE.3) THEN
         CALL TBAR1  (ERCODE,'#isniv',0  ,MESNIV)
         CALL TAZERO (2*NBDOMG,'E',MESNIV,AST,IST,RST,CST)
         IANOP5=1
         CALL MO2LSF (NDIM,NBTEL,0,NDSD,NCOPNP,IANOP5,M(MONOP5)
     &               ,IAMAIL,M(1),M(1),M(1),M(1)
     &               ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                     !momeutil
*        a posteriori ... #isniv a-t-il deborde ?
         IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv') !utilite
*        Boucle pour ajuster les tableaux #ISTEL crees.
         DO 2 IDOMG=NBDOAV,NBDOMG
         ERCODE='!'
            CALL TBAR1  (ERCODE,'#ISTEL',IDOMG,MCLIST)
            IF (ERCODE(1:1).EQ.' ')
     &         CALL TBAJST ('#ISTEL',IDOMG,8+2*IST(MCLIST+3))
 2       CONTINUE
         NBDOAV=NBDOMG
      ENDIF
*
*--   Creation des tableaux #ISTEL des domaines de dimension 1 en 2D et 3D
*
      IF (NDIM.GE.3) THEN
         WRITE (*,*) '>'
         WRITE (*,*)
     &   '> Voulez-vous transmettre les references des lignes ? (N/o/y)'
         READ (*,'(A)') REPONS
         IF (REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &   .OR.REPONS(1:1).EQ.'y') REPONS='Y'
         IF (REPONS(1:1).NE.'Y') GOTO 99998
      ENDIF
      IF (NDIM.GE.2) THEN
         CALL TBAR1  (ERCODE,'#isniv',0  ,MESNIV)
         CALL TAZERO (2*NBDOMG,'E',MESNIV,AST,IST,RST,CST)
         IANOP5=1
         CALL MO2LSA (NDIM,NBTEL,0,NDSD,NCOPNP,IANOP5,M(MONOP5)
     &               ,IAMAIL,M(1),M(1),M(1),M(1)
     &               ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                     !momeutil
*        a posteriori ... #isniv a-t-il deborde ?
         IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv') !utilite
*        Boucle pour ajuster les tableaux #ISTEL crees.
         DO 3 IDOMG=NBDOAV,NBDOMG
         ERCODE='!'
            CALL TBAR1  (ERCODE,'#ISTEL',IDOMG,MCLIST)
            IF (ERCODE(1:1).EQ.' ')
     &         CALL TBAJST ('#ISTEL',IDOMG,8+2*IST(MCLIST+3))
 3       CONTINUE
         NBDOAV=NBDOMG
      ENDIF
*
*--   Creation des tableaux #ISTEL des domaines de dimension 0 en 2D et 3D
*
99998 IF (NDIM.GE.2) THEN
         WRITE (*,*) '>'
         WRITE (*,*)
     &   '> Voulez-vous transmettre les references des noeuds ? (N/o/y)'
         READ (*,'(A)') REPONS
         IF (REPONS(1:1).EQ.'o'.OR.REPONS(1:1).EQ.'O'
     &   .OR.REPONS(1:1).EQ.'y') REPONS='Y'
         IF (REPONS(1:1).NE.'Y') GOTO 99999
      ENDIF
      CALL TBAR1  (ERCODE,'#isniv',0  ,MESNIV)
      CALL TAZERO (2*NBDOMG,'E',MESNIV,AST,IST,RST,CST)
      IANOP5=1
      CALL MO2LSS (NDIM,NBTEL,0,NDSD,NCOPNP,IANOP5,M(MONOP5)
     &            ,IAMAIL,M(1),M(1),M(1),M(1)
     &            ,LGMDOM,NBDOMG,NCHDOM,AST,IST)                        !mo2me
*     a posteriori ... #isniv a-t-il deborde ?
      IF (2*NBDOMG.GT.LGSNIV) CALL BAISE  ('Erreur longueur #isniv')    !utilite
*     Boucle pour ajuster les tableaux #ISTEL crees.
      DO 4 IDOMG=NBDOAV,NBDOMG
         ERCODE='!'
         CALL TBAR1 (ERCODE,'#ISTEL',IDOMG,MCLIST)
         IF (ERCODE(1:1).EQ.' ')
     &      CALL TBAJST('#ISTEL',IDOMG,8+2*IST(MCLIST+3))
4     CONTINUE

*
99999 CALL TBTUER ('#isniv',0)
      CALL TBTUER ('#umemo',0)
*
*     Structure #TERDO
*
      LGENTE=4
      INCREM=27
      LGSTRU=LGENTE+NBDOMG*(INCREM+1)
      CALL TBCREE ('#TERDO',1,1,LGSTRU,'c')
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)                     
      CALL SDMKDB (IST(MCTRDO),LGENTE,NBDOMG,INCREM,NCHDOM)             !utilite
*   
*--   Constitution du fichier de sortie 
*
      IF (NBBBLK.LE.1) THEN
         IF ((NU1BLK/100).EQ.30) THEN
            WRITE(*,*) 'Le maillage contient ',NBTEL,' hexaedres et'
     &                                       ,NBTPTG,' points.'
         ELSEIF ((NU1BLK/100).EQ.31) THEN
            WRITE(*,*) 'Le maillage contient ',NBTEL,' prismes et'
     &                                       ,NBTPTG,' points.'
         ELSEIF ((NU1BLK/100).EQ.32) THEN
            WRITE(*,*) 'Le maillage contient ',NBTEL,' tetraedres et'
     &                                       ,NBTPTG,' points.'
         ELSEIF ((NU1BLK/100).EQ.20) THEN
            WRITE(*,*) 'Le maillage contient ',NBTEL,' quadrangles et'
     &                                       ,NBTPTG,' points.'
         ELSEIF ((NU1BLK/100).EQ.21) THEN
            WRITE(*,*) 'Le maillage contient ',NBTEL,' triangles et'
     &                                       ,NBTPTG,' points.'
         ENDIF
      ELSE
         WRITE(*,*) 'Le maillage contient ',NBTEL,' elements et'
     &                                    ,NBTPTG,' points.'
      ENDIF
      WRITE(*,*) '  '
      WRITE(*,*) '> Titre pour le fichier de maillage Melina ?'
      READ (*,'(A80)') REPONS 
*
      CALL ECGEOM (NOFOUT,REPONS)                                       !lecgeom
*
      CLOSE (NUFOUT,STATUS='KEEP')
      CALL PRFXMJ (-1,'*Nopo2M*')
*-----------------------------------------------------------------------
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (20 avril 2007)
* - suppression argument NDSR inutile (arg. de MO2LS*)
* Version 2 : D.Martin (13 Juin 2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                                                                    END !Nopo2m  
