*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RDNOMD (NDIM  ,NDMDOM,IREFEL,NDSD,NDSDE
     &                  ,NOMDOM,LGMDOM,NBDOMG,NUDOMG,NCHDOM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1993)
* Derniere modification : D.Martin (28 Aout 2000)
* Version 1.0.2
*
* Lecture du nom d'un domaine pour un numero de sous-domaine au sens de Modulef
*                               ou un numero de reference au sens de Modulef
*
*-- Arguments --
* NDIM   dimension d'espace
* NDMDOM dimension du domaine (au sens de Melina) en cours
* IREFEL numero de reference au sens de Modulef
* NDSD   plus grand numero de sous-domaine au sens de Modulef
* NDSDE  numero de sous-domaine au sens de Modulef
* NOMDOM tableau des noms de domaines de Melina (#OMDOM)
* NBDOMG nombre de domaines du maillage Melina
* NUDOMG numero du domaine courant
* NCHDOM nombre de caracteres par nom de domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER     NOMDOM(*)
      INTEGER       NDIM,NDMDOM,IREFEL,NDSD,NDSDE
     &             ,LGMDOM,NBDOMG,NCHDOM
*
      CHARACTER NAMDOM*72,VALDEF*20,REPONS
      INTEGER   NBCARE,NBCARN,NUDOMG,LGMDOW,KELCHN,DIXN
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RdNomd*')
*
10    NUDOMG=0
*        Valeur proposee pour un domaine de dimension NDIM 
*        'Omega' concatene avec le numero de sous-domaine 's' : Omega's'
*        Valeur proposee pour un domaine de dimension < NDIM
*        'Gamma' concatene avec le numero de sous-domaine 's'
*                et le numero de de reference 'r'             : Gamma's_r'
*
      IF (NDMDOM.EQ.NDIM) THEN
*
         NBCARE=5
         VALDEF='Omega'
         IF (NDSD.GT.1) THEN
            DIXN=10
            DO 11 NBCARN=1,6
               IF (NDSDE.LT.DIXN) GOTO 12
               DIXN=10*DIXN
11          CONTINUE
12          CALL ENCLER (NDSDE,VALDEF(NBCARE+1:NBCARE+NBCARN))
         ENDIF
         WRITE (*,10003) NDMDOM,NDSDE,VALDEF
      ELSEIF (NDMDOM.GT.0) THEN
*
         NBCARE=5
         VALDEF='Gamma'
         IF (NDSD.GT.1) THEN
            DIXN=10
            DO 13 NBCARN=1,6
               IF (NDSDE.LT.DIXN) GOTO 14
               DIXN=10*DIXN
13          CONTINUE
14          CALL ENCLER (NDSDE,VALDEF(NBCARE+1:NBCARE+NBCARN))
            NBCARE=NBCARE+NBCARN+1
            VALDEF(NBCARE:NBCARE)='_'
         ENDIF
         DIXN=10
         DO 15 NBCARN=1,6
            IF (IREFEL.LT.DIXN) GOTO 16
            DIXN=10*DIXN
15       CONTINUE
16       CALL ENCLER (IREFEL,VALDEF(NBCARE+1:NBCARE+NBCARN))
         WRITE (*,10001) NDMDOM,IREFEL,NDSDE,VALDEF
      ELSE
*
         NBCARE=1
         VALDEF='P'
         DIXN=10
         DO 23 NBCARN=1,6
            IF (IREFEL.LT.DIXN) GOTO 24
            DIXN=10*DIXN
23       CONTINUE
24       CALL ENCLER (IREFEL,VALDEF(NBCARE+1:NBCARE+NBCARN))
         WRITE (*,10000) IREFEL,VALDEF
      ENDIF
*
30    READ (*,'(A)') NAMDOM
      IF (NAMDOM(1:1).EQ.''''.OR.NAMDOM(1:1).EQ.'"') THEN
         WRITE (*,10010) VALDEF
         GOTO 30
      ENDIF
*
      IF (NAMDOM(1:1).EQ.' ') THEN
         IREFEL=-ABS (IREFEL)
         NDSDE =-ABS (NDSDE)
         NAMDOM=' '
         CALL RIPCHN (NOMDOM,NBDOMG,NCHDOM,NAMDOM(1:1))                !utilite
      ELSE
*
*        On a choisi le nom propose
*
         IF (NAMDOM(1:1).EQ.'=') NAMDOM=VALDEF
*
*        On elimine les caracteres blancs terminaux
*
         DO 40 NBCARE=32,1,-1
            IF (NAMDOM(NBCARE:NBCARE).NE.' ') GOTO 41
40       CONTINUE
*        Le nom existe deja ? Le tableau est-il assez grand ?
41       IF (NBDOMG.GT.0.AND.NBCARE.LE.NCHDOM)
     &      NUDOMG=KELCHN (NAMDOM(1:NBCARE),NOMDOM,NBDOMG,NCHDOM)      !utilite
         IF (NUDOMG.GT.0) THEN
            CALL BIP ()
            WRITE(*,10011)  NAMDOM(:NBCARE)
            READ (*,'(A)') REPONS
            IF (REPONS.EQ.'o'.OR.REPONS.EQ.'O'
     &      .OR.REPONS.EQ.'y') REPONS='Y'
            IF (REPONS.NE.'Y') GOTO 10
         ENDIF
         LGMDOW=(NBDOMG+1)* MAX (NCHDOM,NBCARE)
         IF (LGMDOM.LT.LGMDOW)
     &      CALL BAISE  (' Taille sous-estimee pour #OMDOM')           !utilite
*
         CALL RIPCHN (NOMDOM,NBDOMG,NCHDOM,NAMDOM(1:NBCARE))           !utilite
         NUDOMG=NBDOMG
      ENDIF
      CALL PRFXMJ (-1,'*RdNomd*')
*----------------------------------------------------------------------
10003 FORMAT('> NOM du domaine de dimension ',I1
     &,' designe par Modulef sous le numero de SOUS-DOMAINE : ',I3,' ?'
     &,/,'  -> Taper ''='' pour la valeur proposee : ',A)
10001 FORMAT('> NOM du domaine de dimension ',I1
     &,' designe par Modulef sous le numero de REFERENCE : ',I3
     &,/,'  et defini a partir du SOUS-DOMAINE numero : ',I3,' ?'
     &,/,'  -> Taper ''='' pour la valeur proposee : ',A
     &,/,'  -> Taper '' '' pour ignorer cette reference.')
10000 FORMAT('> NOM du domaine PONCTUEL'
     &,' designe par Modulef sous le numero de REFERENCE : ',I3
     &,/,'  -> Taper ''='' pour la valeur proposee : ',A
     &,/,'  -> Taper '' '' pour ignorer cette reference.')
10010 FORMAT(/'>>> Entrer les noms sans les apostrophes d''encadrement'
     &,' <<<'/'>>> Par exemple : = ou ',A,/)
10011 FORMAT(/'>>> Le nom de domaine ',A,' existe deja !'
     &,/,'>>> Concatener ce nouveau domaine avec l''ancien ?'
     &,' (N/o/y)')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (20 avril 2007)
* - suppression argument NDSR inutile
* Version 1.0.1 : D.Martin (28 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !RdNomd
