*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE B M 2 B M (NBLIGN,NBCOLO,TYPE
     *               ,ITSYMA,NULAPL,IPLAGL,NULAPU,IPLAGU,MCAD
     *               ,ITSYMB,NULBPL,IPLBGL,NULBPU,IPLBGU,MCBD,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Septembre 1993)  
* Derniere modification (O.DeBayser) le 23 Septembre 1993 
*
*  Passage d'une matrice Bi-Morse a une autre matrice Bi-Morse.
*          (MBM2BM --> Matrice BiMorse 'to' matrice BiMorse)
*
*     On suppose que la seconde structure BiMorse inf./sup. recouvre
*  la premiere structure BiMorse inf./sup., tout en respectant le profil
*  inferieur/superieur, c'est-a-dire en particulier que le numero de
*  debut de la premiere plage de chaque ligne/colonne est le meme dans
*  les deux structures. 
*     Ces hypotheses sont respectees si par exemple plusieurs plages
*  de la premiere structure BiMorse ont ete concatenees en une plage de
*  la seconde structure BiMorse inferieure/superieure.
*
*** Arguments ***
* NBLIGN nombre de lignes des matrices
* NBCOLO nombre colonnes des matrices
* TYPE   type de declaration commune des deux matrices
* matrice initiale:
* ITSYMA indice de symetrie de la matrice A 
* NULAPL nos de derniere plage de la struct. Bi-Morse inferieure
* IPLAGL nos de debut de plage et long. cumulees de la struct. Bi-Morse inf.
* NULAPU nos de derniere plage de la struct. Bi-Morse superieure
* IPLAGU nos de debut de plage et long. cumulees de la struct. Bi-Morse sup.
* MCAD   adresse de la diagonale de matrice Bi-Morse dans le s-t du bon type
* matrice finale:
* ITSYMB indice de symetrie de la matrice B 
* NULBPL nos de derniere plage de la struct. Bi-Morse inferieure
* IPLBGL nos de debut de plage et long. cumulees de la struct. Bi-Morse inf.
* NULBPU nos de derniere plage de la struct. Bi-Morse superieure
* IPLBGU nos de debut de plage et long. cumulees de la struct. Bi-Morse sup.
* MCBD   adresse de la diagonale de matrice Bi-Morse dans le s-t du bon type
* RST    tableau contenant les matrices (cas reel)
* CST    tableau contenant les matrices (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NULAPL(*),IPLAGL(2,*),NULAPU(*),IPLAGU(2,*)
      INTEGER       NULBPL(*),IPLBGL(2,*),NULBPU(*),IPLBGU(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      ITYSNO=INDSYM(' ')
      MCAL=MCAD+MIN(NBLIGN,NBCOLO)
      MCBL=MCBD+MIN(NBLIGN,NBCOLO)
      LGMORL=IPLBGL(2,NULBPL(NBLIGN-1))
      CALL TAZERO(LGMORL,TYPE,MCBL,TYPE,NULBPL,RST,CST)                 !Utilite
      MCAU=MCAL
      IF(ITSYMA.EQ.ITYSNO) MCAU=MCAL+IPLAGL(2,NULAPL(NBLIGN-1))
      IF(ITSYMB.EQ.ITYSNO) THEN
         MCBU=MCBL+LGMORL
         LGMORU=IPLBGU(2,NULBPU(NBCOLO-1))
         CALL TAZERO(LGMORU,TYPE,MCBU,TYPE,NULBPU,RST,CST)              !Utilite
      ENDIF
*
      IF(TYPE(1:1).EQ.'C') THEN
*
*        Coefficients diagonaux
         MCBB=MCBD
         DO 10 MCAA=MCAD,MCAD-1+MIN(NBLIGN,NBCOLO)
            CST(MCBB)=CST(MCAA)
10          MCBB=MCBB+1
*
*        Coefficients du triangle inferieur
         NUDRPA=0
         NUDRPB=0
         LGCUAA=0
         LGCUBB=0
         LGCUMB=0
         DO 20 LIGNE=2,NBLIGN
*           1ere et derniere plages de la ligne courante de A
            NUPRPA=NUDRPA+1
            NUDRPA=NULAPL(LIGNE-1)
*           1ere et derniere plages de la ligne courante de B
            NUPRPB=NUDRPB+1
            NUDRPB=NULBPL(LIGNE-1)
            IF(NUPRPB.GT.1) LGCUBB=IPLBGL(2,NUPRPB-1)
*           Boucle sur les plages de A
            DO 13 NUPLA=NUPRPA,NUDRPA
               KOLDEA=IPLAGL(1,NUPLA)
               LGCUMA=IPLAGL(2,NUPLA)
*              Recherche de la plage de B contenant le 1er coeff de
*              la plage courante de A
               CALL DIKLPL(KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGL,NUPLB
     *                                                           ,*998) !Morse
               KOLDEB=IPLBGL(1,NUPLB)
               IF(NUPLB.GT.1) LGCUMB=IPLBGL(2,NUPLB-1)
*              Adresse du 1er coeff. de la plage courante de B
               MCBB=MCBL+LGCUMB+KOLDEA-KOLDEB
*              Report de la plage courante de A dans la plage courante de B
               DO 11 MCAA=MCAL+LGCUAA,MCAL+LGCUMA-1
                  CST(MCBB)=CST(MCAA)
11                MCBB=MCBB+1
13             LGCUAA=LGCUMA
20       CONTINUE
*
         IF(ITSYMB.EQ.ITYSNO) THEN
*           Coefficients du triangle superieur
            NUDRPA=0
            NUDRPB=0
            LGCUAA=0
            LGCUBB=0
            LGCUMB=0
            DO 40 KOLON=2,NBCOLO
*              1ere et derniere plages de la colonne courante de A
               NUPRPA=NUDRPA+1
               NUDRPA=NULAPU(KOLON-1)
*              1ere et derniere plages de la colonne courante de B
               NUPRPB=NUDRPB+1
               NUDRPB=NULBPU(KOLON-1)
               IF(NUPRPB.GT.1) LGCUBB=IPLBGU(2,NUPRPB-1)
*              Boucle sur les plages de A
               DO 33 NUPLA=NUPRPA,NUDRPA
                  KOLDEA=IPLAGU(1,NUPLA)
                  LGCUMA=IPLAGU(2,NUPLA)
*                 Recherche de la plage de B contenant le 1er coeff de
*                 la plage courante de A
                  CALL DIKLPL(KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGU,NUPLB
     *                                                           ,*999) !Morse
                  KOLDEB=IPLBGU(1,NUPLB)
                  IF(NUPLB.GT.1) LGCUMB=IPLBGU(2,NUPLB-1)
*                 Adresse du 1er coeff. de la plage courante de B
                  MCBB=MCBU+LGCUMB+KOLDEA-KOLDEB
*                 Report de la plage courante de A dans la plage courante de B
                  DO 31 MCAA=MCAU+LGCUAA,MCAU+LGCUMA-1
                     CST(MCBB)=CST(MCAA)
31                   MCBB=MCBB+1
33                LGCUAA=LGCUMA
40          CONTINUE
         ENDIF
*
      ELSE IF(TYPE(1:1).EQ.'R') THEN
*
*        Coefficients diagonaux
         MCBB=MCBD
         DO 50 MCAA=MCAD,MCAD-1+MIN(NBLIGN,NBCOLO)
            RST(MCBB)=RST(MCAA)
50          MCBB=MCBB+1
*
*        Coefficients du triangle inferieur
         NUDRPA=0
         NUDRPB=0
         LGCUAA=0
         LGCUBB=0
         LGCUMB=0
         DO 60 LIGNE=2,NBLIGN
*           1ere et derniere plages de la ligne courante de A
            NUPRPA=NUDRPA+1
            NUDRPA=NULAPL(LIGNE-1)
*           1ere et derniere plages de la ligne courante de B
            NUPRPB=NUDRPB+1
            NUDRPB=NULBPL(LIGNE-1)
            IF(NUPRPB.GT.1) LGCUBB=IPLBGL(2,NUPRPB-1)
*           Boucle sur les plages de A
            DO 53 NUPLA=NUPRPA,NUDRPA
               KOLDEA=IPLAGL(1,NUPLA)
               LGCUMA=IPLAGL(2,NUPLA)
*              Recherche de la plage de B contenant le 1er coeff de
*              la plage courante de A
               CALL DIKLPL(KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGL,NUPLB
     *                                                           ,*998) !Morse
               KOLDEB=IPLBGL(1,NUPLB)
               IF(NUPLB.GT.1) LGCUMB=IPLBGL(2,NUPLB-1)
*              Adresse du 1er coeff. de la plage courante de B
               MCBB=MCBL+LGCUMB+KOLDEA-KOLDEB
*              Report de la plage courante de A dans la plage courante de B
               DO 51 MCAA=MCAL+LGCUAA,MCAL+LGCUMA-1
                  RST(MCBB)=RST(MCAA)
51                MCBB=MCBB+1
53             LGCUAA=LGCUMA
60       CONTINUE
*
         IF(ITSYMB.EQ.ITYSNO) THEN
*           Coefficients du triangle superieur
            NUDRPA=0
            NUDRPB=0
            LGCUAA=0
            LGCUBB=0
            LGCUMB=0
            DO 80 KOLON=2,NBCOLO
*              1ere et derniere plages de la colonne courante de A
               NUPRPA=NUDRPA+1
               NUDRPA=NULAPU(KOLON-1)
*              1ere et derniere plages de la colonne courante de B
               NUPRPB=NUDRPB+1
               NUDRPB=NULBPU(KOLON-1)
               IF(NUPRPB.GT.1) LGCUBB=IPLBGU(2,NUPRPB-1)
*              Boucle sur les plages de A
               DO 73 NUPLA=NUPRPA,NUDRPA
                  KOLDEA=IPLAGU(1,NUPLA)
                  LGCUMA=IPLAGU(2,NUPLA)
*                 Recherche de la plage de B contenant le 1er coeff de
*                 la plage courante de A
                  CALL DIKLPL(KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGU,NUPLB
     *                                                           ,*999) !Morse
                  KOLDEB=IPLBGU(1,NUPLB)
                  IF(NUPLB.GT.1) LGCUMB=IPLBGU(2,NUPLB-1)
*                 Adresse du 1er coeff. de la plage courante de B
                  MCBB=MCBU+LGCUMB+KOLDEA-KOLDEB
*                 Report de la plage courante de A dans la plage courante de B
                  DO 71 MCAA=MCAU+LGCUAA,MCAU+LGCUMA-1
                     RST(MCBB)=RST(MCAA)
71                   MCBB=MCBB+1
73                LGCUAA=LGCUMA
80          CONTINUE
         ENDIF
*
      END IF
*
      RETURN
998   CALL BAISE('colonne non retrouve dans les plage de B')            !Utilite
999   CALL BAISE('ligne   non retrouve dans les plage de B')            !Utilite
                                                                    END *Bm2Bm*
