*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE BM2BMG (TYPE,NBLIGN,NULAPL,IPLAGL,MCA,MCAL
     &                   ,NULBPL,IPLBGL,MCB,MCBL,IRCODE,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1994)  
* Derniere modification : D.Martin (22 Octobre 1999)
* Version # 1.0.0
*
* Transfert de la partie triangulaire inf/sup d'une matrice Bi-Morse A a une 
* autre matrice Bi-Morse B.
* (BM2BMG --> Matrice BiMorse 'to' matrice BiMorse generalisee)
*
* On suppose que la seconde structure BiMorse (B) inf/sup recouvre
* la premiere structure BiMorse (A) inf/sup. On commence par la fin
* afin qu'il soit possible de donner deux adresses egales: MCAL=MCBL.
*
*-- Arguments --
* TYPE   type de declaration commune des deux matrices
* NBLIGN nombre de lignes/colonnes des matrices
* NULAPL nos de derniere plage de la struct. Bi-Morse inf/sup de A
* IPLAGL nos de debut de plage et long. cumulees de la struct. Bi-Morse inf/sup
* MCA    adresse de A
* MCAL   adresse de la partie triangulaire inf/sup de A
* NULBPL nos de derniere plage de la struct. Bi-Morse inf/sup de B
* IPLBGL nos de debut de plage et long. cumulees de la struct. Bi-Morse inf/sup
* MCB    adresse de B
* MCBL   adresse de la partie triangulaire inf/sup de B
* IRCODE indicateur d'erreur sur la ligne IRCODE si GT.0
* RST    tableau contenant les matrices (cas reel)
* CST    tableau contenant les matrices (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLIGN,MCA,MCAL,MCB,MCBL,IRCODE
     &             ,NULAPL(*),IPLAGL(2,*),NULBPL(*),IPLBGL(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPA,NUDRPA,NUPLA,LGCUAV,LGCUMA,KOLDEA,LGPLA
     &             ,NUPRPB,NUDRPB,NUPLB,LGCUBV,LGCUMB,KOLDEB
     &             ,ADRSAL,ADRSBL,ADRSA,ADRSB1,ADRSB,LIGNE,LGCUBB
*-----------------------------------------------------------------------
      IRCODE=0
      NUDRPA=NULAPL(NBLIGN-1)
      NUDRPB=NULBPL(NBLIGN-1)
      LGCUAV=IPLAGL(2,NUDRPA)
      ADRSAL=MCAL+LGCUAV-1
      LGCUBV=IPLBGL(2,NUDRPB)
      ADRSBL=MCBL+LGCUBV-1
*
      IF (TYPE(1:1).EQ.'R') THEN
         DO 220 LIGNE=NBLIGN,2,-1
*           1eres plages de la ligne/colonne courante de A et B
            NUPRPA=1
            NUPRPB=1
            IF (LIGNE .GT.2) THEN 
               NUPRPA=NULAPL(LIGNE-2)+1
               NUPRPB=NULBPL(LIGNE-2)+1
            ENDIF
            LGCUBB=0
            IF (NUPRPB.GT.1) LGCUBB=IPLBGL(2,NUPRPB-1)
*           Boucle sur les plages de la ligne/colonne courante A
            DO 217 NUPLA=NUDRPA,NUPRPA,-1
               KOLDEA=IPLAGL(1,NUPLA)
               LGCUMA=0
               IF (NUPLA.GT.1) LGCUMA=IPLAGL(2,NUPLA-1)
               LGPLA =LGCUAV-LGCUMA
*              Recherche de la plage de B contenant le 1er coeff de
*              la plage courante de la ligne/colonne courante de A
               CALL DIKLPL (KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGL,NUPLB
     &                     ,*99991)                                     !morse
               KOLDEB=IPLBGL(1,NUPLB)
               LGCUMB=0
               IF (NUPLB.GT.1) LGCUMB=IPLBGL(2,NUPLB-1)
*              Adresse dans B du dernier coeff. de la plage courante de A
               ADRSB1 =MCBL+LGCUMB+KOLDEA-KOLDEB+LGPLA-1
               IF (MCA.EQ.MCB) THEN 
*                 si A et B sont a la meme adresse, mise a zero des vides
*                 apres la plage de A dans celle de B. 
                  DO 211 ADRSB=ADRSBL,ADRSB1+1,-1
                     RST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
211               CONTINUE
               ELSE
                  ADRSBL=ADRSB1+1
               ENDIF
*              Report de la plage courante de A dans la plage courante de B
               DO 212 ADRSA=MCAL+LGCUAV-1,MCAL+LGCUMA,-1
                  RST(ADRSBL)=RST(ADRSA)
                  ADRSBL=ADRSBL-1
212            CONTINUE
               LGCUAV=LGCUMA
*              Adresse du premier coeff. de la plage courante de B
               ADRSB1=MCBL+LGCUMB
               IF (NUPLA.EQ.NUPRPA) ADRSB1=MCBL+LGCUBB
               IF (MCA.EQ.MCB) THEN 
*                 Si A et B sont a la meme adresse, mise a zero des vides
*                 avant la plage de A dans celle de B.
                  DO 213 ADRSB=ADRSBL,ADRSB1,-1
                     RST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
213               CONTINUE
               ELSE
                  ADRSBL=ADRSB1
               ENDIF
217          CONTINUE
            IF (MCA.EQ.MCB) THEN
               IF (NUDRPA.LT.NUPRPA) THEN
*                 Cas d'une ligne courante de A vide
                  ADRSB1=MCBL+LGCUBB
                  DO 219 ADRSB=ADRSBL,ADRSB1,-1
                     RST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
219               CONTINUE
               ENDIF
            ELSE
               ADRSBL=ADRSB1
            ENDIF
            NUDRPA=NUPRPA-1
            NUDRPB=NUPRPB-1
220      CONTINUE
*
      ELSEIF (TYPE(1:1).EQ.'C') THEN
*
         DO 420 LIGNE=NBLIGN,2,-1
*           1eres plages de la ligne/colonne courante de A et B
            NUPRPA=1
            NUPRPB=1
            IF (LIGNE .GT.2) THEN
               NUPRPA=NULAPL(LIGNE-2)+1
               NUPRPB=NULBPL(LIGNE-2)+1
            ENDIF
            LGCUBB=0
            IF (NUPRPB.GT.1) LGCUBB=IPLBGL(2,NUPRPB-1)
*           Boucle sur les plages de la ligne/colonne courante A
            DO 417 NUPLA=NUDRPA,NUPRPA,-1
               KOLDEA=IPLAGL(1,NUPLA)
               LGCUMA=0
               IF (NUPLA.GT.1) LGCUMA=IPLAGL(2,NUPLA-1)
               LGPLA =LGCUAV-LGCUMA
*              Recherche de la plage de B contenant le 1er coeff de
*              la plage courante de la ligne/colonne courante de A
               CALL DIKLPL (KOLDEA,NUPRPB,NUDRPB,LGCUBB,IPLBGL,NUPLB
     &                     ,*99991)                                     !morse
               KOLDEB=IPLBGL(1,NUPLB)
               LGCUMB=0
               IF (NUPLB.GT.1) LGCUMB=IPLBGL(2,NUPLB-1)
*              Adresse dans B du dernier coeff. de la plage courante de A
               ADRSB1 =MCBL+LGCUMB+KOLDEA-KOLDEB+LGPLA-1
               IF (MCA.EQ.MCB) THEN
*                 si A et B sont a la meme adresse, mise a zero des vides
*                 apres la plage de A dans celle de B.
                  DO 411 ADRSB=ADRSBL,ADRSB1+1,-1
                     CST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
411               CONTINUE
               ELSE
                  ADRSBL=ADRSB1+1
               ENDIF
*              Report de la plage courante de A dans la plage courante de B
               DO 412 ADRSA=MCAL+LGCUAV-1,MCAL+LGCUMA,-1
                  CST(ADRSBL)=CST(ADRSA)
                  ADRSBL=ADRSBL-1
412            CONTINUE
               LGCUAV=LGCUMA
*              Adresse du premier coeff. de la plage courante de B
               ADRSB1=MCBL+LGCUMB
               IF (NUPLA.EQ.NUPRPA) ADRSB1=MCBL+LGCUBB
               IF (MCA.EQ.MCB) THEN
*                 Si A et B sont a la meme adresse, mise a zero des vides
*                 avant la plage de A dans celle de B.
                  DO 413 ADRSB=ADRSBL,ADRSB1,-1
                     CST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
413               CONTINUE
               ELSE
                  ADRSBL=ADRSB1
               ENDIF
417          CONTINUE
            IF (MCA.EQ.MCB) THEN
               IF (NUDRPA.LT.NUPRPA) THEN
*                 Cas d'une ligne courante de A vide
                  ADRSB1=MCBL+LGCUBB
                  DO 419 ADRSB=ADRSBL,ADRSB1,-1
                     CST(ADRSB)=0.
                     ADRSBL=ADRSBL-1
419               CONTINUE
               ENDIF
            ELSE
               ADRSBL=ADRSB1
            ENDIF
            NUDRPA=NUPRPA-1
            NUDRPB=NUPRPB-1
420      CONTINUE
*
      ELSE
         GOTO  99993
*
      ENDIF
*
      IF (MCA.EQ.MCB.AND.ADRSBL+1.NE.MCBL) THEN
         WRITE (*,*) 
         WRITE (*,*) 'Coeffs. manquants dans la matrice : '
     &  ,ADRSBL-MCBL+1
         GOTO 99992
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 IRCODE=LIGNE
      RETURN
99992 IRCODE=1
      RETURN
99993 IRCODE=-1
                                                                    END !Bm2Bmg
