*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BM2PR (NBLICO,NBCOLI,NULAPL,IPLAGL,LENV)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (novembre 91)
* Derniere modification : D.Martin (21 octobre 2006)
* Version 1  
*  
* Calcul des pointeurs de l'enveloppe inferieure (resp. superieure) d'un
* stockage 'Profil' inf. (resp sup.) a partir des tables de compactage
* 'BiMorse' inferieur (resp. superieur)
*                 (Bm2Pr --> Bi-Morse 'to' PRofil)
*                            -  -      --  --
*  
*-- Arguments
* NBLICO nombre de lignes (resp. colonnes) de la matrice
* NBCOLI nombre de colonnes (resp. lignes) de la matrice
* NULAPL numeros de derniere plage sur chaque ligne (resp. colonne)
* IPLAGL tableau des numeros de ligne (resp. colonne) de debut de plage
*        et des adresses des derniers coefficients de chaque plage.  
* LENV   tableau contenant le nombre de lignes (resp. colonnes) suivi de
*        l'enveloppe inferieure (resp. sup) stricte avec ici
*        LENV(I) adresse dans la partie triangulaire inf (resp. sup)
*        'Profil' du 1er coeff. non nul de la ligne I (resp colonne I)
*        et LENV(I+1)=LENV(I) si le 1er coeff. de la lig. I (resp col. I)
*        est le coeff. diagonal
*        et LENV(NBLICO+1)-1 est la taille de la partie triangulaire inferieure
*        (resp. superieure) stricte.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLICO,NBCOLI,NULAPL(*),IPLAGL(2,*),LENV(*)
*
      INTEGER ADRS,NUPRPL,NUDRPL
*-----------------------------------------------------------------------
      ADRS = 1
      NUDRPL = 0
      LENV(1)=NBLICO
      DO 1 LIOUCO=2,NBLICO
         LENV(LIOUCO)=ADRS
         NUPRPL = NUDRPL+1
         NUDRPL = NULAPL(LIOUCO-1)
         IF (NUDRPL.GE.NUPRPL)
     &      ADRS = ADRS+MAX(0,MIN(LIOUCO,NBCOLI+1)-IPLAGL(1,NUPRPL))
*                             --- (pour une matrice rectangulaire)
1     CONTINUE
      LENV(NBLICO+1)=ADRS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1 : D.Martin (21 octobre 2006)
* - translation d'une adresse dans LENV pour y stocker NBLICO (LENV(1))
* Version 0 : D.Martin (5 decembre 1991)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Bm2Pr
