*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M F I L D (NSSDIA,NBLICO,NBCOLI,NULAPL,IPLAGL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Oct. 1991)
* Derniere modification (D.Martin) le 6 Dec. 91
*
*   Remplissage d'une structure BiMorse inferieure (resp. superieure) par  
*   creation des colonnes sous-(resp. sur-)diagonales dans les plages
*   voisines de la derniere (resp. premiere) plage sous-(resp. sur-)diagonale
*   en une plage atteignant la colonne sous-(resp. sur-)diagonale dans une
*   structure 'BiMorse' inferieure (resp. superieure). 
* > Remarque : Le remplissage peut provoquer un accroissement du nombre de
*              plage au plus egal au nombre de lignes-1. Il est donc necessaire
*              de prevoir un tableau (IPLAGL) plus long que l'original d'au
*              moins 2 fois le nombre de lignes -1. 
*   
*** Arguments ***   
* NSSDIA: Nb. de colonnes sous-(resp. sur-)diagonales crees 
* NBLICO: Nb. de lignes de la matrice (resp. colonnes)
* NBCOLI: Nb. de colonnes de la matrice (resp. lignes)
* NULAPL: Tableau des numeros de derniere plage de chaque ligne(resp. colonne)
* IPLAGL: Pointeurs des plages sous-(resp. sur-)diagonales
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPL(*),IPLAGL(2,*) 
* 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CALL BAISE(' *BmFilD* en chantier en chantier en chantier en chant
     *ier en chantier en chantier...............enchante ')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IF(NSSDIA.LE.0) RETURN 
      NBPLAW=0
      LGCUMW=0
      NUDRPL=0
      LGCUAV=0
      LIGNM1=1
      NBPLAG=NULAPL(NBLICO-1)
      DO 100 LIGNE=2,NBLICO
*        Numero de la premiere colonne rajoutee
         KOLCR1=MAX(1,LIGNE-NSSDIA)
         NUPRPL=NUDRPL+1
         NUDRPL=NULAPL(LIGNM1)
         IF(NUDRPL.LT.NUPRPL) THEN
*           Cas d'une ligne vide : une plage est creee sur la ligne
*           depuis la 1ere colonne rajoutee jusqu'a la sous-diagonale
            KOLFIN=0
            GO TO 2
         END IF
         KOLFIN=IPLAGL(1,NUDRPL)+IPLAGL(2,NUDRPL)-1
         IF(NUDRPL.GT.1) KOLFIN=KOLFIN-IPLAGL(2,NUDRPL-1)
*
         CALL DIKLPL(KOLCR1,NUPRPL,NUDRPL,LGCUAV,IPLAGL,NUDRPW,*2)
*
***      La premiere colonne creee existe dans la plage NUDRPW :
*        numero de la nouvelle derniere plage sur la ligne :
*        les plages NUDRPW a NUDRPL sont concatenees
*        Les plages NUPRPL a NUDRPW-1 restent inchangees
         DO 1 NUPL=NUPRPL,NUDRPW-1
           KOLDEB=IPLAGL(1,NUPL)
           LGCUMU=IPLAGL(2,NUPL)
           LGPLAG=LGCUMU-LGCUAV
           LGCUAV=LGCUMU
*          Report des pointeurs de ces plages
           NBPLAW=NBPLAW+1
           LGCUMW=LGCUMW+LGPLAG
           IPLAGL(1,NBPLAW)=KOLDEB
           IPLAGL(2,NBPLAW)=LGCUMW
1       CONTINUE
*       Concatenation des dernieres plages de la ligne
*       en une plage atteignant la derniere colonne (sous-diagonale)
        KOLDEB=IPLAGL(1,NUDRPW)
        LGPLAG=MAX(MIN(LIGNE,NBCOLI+1)-KOLDEB,0)
        LGCUMW=LGCUMW+LGPLAG
        IF(LGPLAG.GT.0)  NBPLAW=NBPLAW+1
        IPLAGL(1,NBPLAW)=KOLDEB
        IPLAGL(2,NBPLAW)=LGCUMW
        GO TO 99
*
***     La premiere colonne creee n'est pas dans une plage
*       NUDRPW est le numero de la plage a creer ou a modifier
*
2       IF(KOLCR1.GT.KOLFIN) THEN
*          La colonne creee est entre la derniere plage et la diagonale. :
*          ceci provoque un accroissement du nombre de plages
*          Les plages NUPRPL a NUDRPL restent inchangees
           DO 11 NUPL=NUPRPL,NUDRPL
              KOLDEB=IPLAGL(1,NUPL)
              LGCUMU=IPLAGL(2,NUPL)
              LGPLAG=LGCUMU-LGCUAV
              LGCUAV=LGCUMU
*             Report des pointeurs de ces plages
              LGCUMW=LGCUMW+LGPLAG
              NBPLAW=NBPLAW+1
              IPLAGL(1,NBPLAW)=KOLDEB
              IPLAGL(2,NBPLAW)=LGCUMW
11         CONTINUE
           NUDRPL=NUDRPL+1
*          Decalage des plages suivantes
           NBPLAG=NBPLAG+1
           DO 12 I=LIGNE+1,NBLICO
              NULAPL(I)=NULAPL(I)+1
12         CONTINUE
           DO 13 I=NUDRPL,NBPLAG
              IPLAGL(1,I+1)=IPLAGL(1,I)
              IPLAGL(2,I+1)=IPLAGL(2,I)
13         CONTINUE
         ELSE
*          La colonne creee est avant la plage NUDRPW :
*          on la rallonge et on la concatene avec les suivantes
*          Les plages NUPRPL a NUDRPW-1 restent inchangees
           DO 21 NUPL=NUPRPL,NUDRPW-1
              KOLDEB=IPLAGL(1,NUPL)
              LGCUMU=IPLAGL(2,NUPL)
              LGPLAG=LGCUMU-LGCUAV
              LGCUAV=LGCUMU
*             Report des pointeurs de ces plages
              NBPLAW=NBPLAW+1
              LGCUMW=LGCUMW+LGPLAG
              IPLAGL(1,NBPLAW)=KOLDEB
              IPLAGL(2,NBPLAW)=LGCUMW
21         CONTINUE
         END IF
*        Creation de la plage sous-diagonale ou concatenation des dernieres
*        plages de la ligne en une plage atteignant la derniere colonne 
*        (sous-diagonale)
         LGPLAG=MAX(MIN(LIGNE,NBCOLI+1)-KOLCR1,0)
         LGCUMW=LGCUMW+LGPLAG
         IF(LGPLAG.GT.0)  NBPLAW=NBPLAW+1
         IPLAGL(1,NBPLAW)=KOLCR1
         IPLAGL(2,NBPLAW)=LGCUMW
*
99       NULAPL(LIGNM1)  =NBPLAW
         LGCUAV=IPLAGL(2,NUDRPL)
         LIGNM1=LIGNE
100   CONTINUE
                                                                    END *BmFilP*
