*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M F I L P (NPLCAT,NBLICO,NBCOLI,NULAPL,IPLAGL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Oct. 1991)
* Derniere modification (D.Martin) le 6 Dec. 91
*
*   Remplissage d'une structure BiMorse inferieure (resp. superieure) par  
*   concatenation des plages sous-(resp. sur-)diagonales voisines de la 
*   derniere (resp. premiere) plage sous-(resp. sur-)diagonale en une plage
*   atteignant la colonne sous-(resp. sur-)diagonale dans un structure 
*   'BiMorse' inferieure (resp. superieure).  
*   
*** Arguments ***   
* NPLCAT: Nb. de plages sous-(resp. sur-)diagonales concatenees en une plage 
* NBLICO: Nb. de lignes de la matrice (resp. colonnes)
* NBCOLI: Nb. de colonnes de la matrice (resp. lignes)
* NULAPL: Tableau des numeros de derniere plage de chaque ligne(resp. colonne)
* IPLAGL: Pointeurs des plages sous-(resp. sur-)diagonales
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPL(*),IPLAGL(2,*) 
*
*     Les commentaires sont valables dans le cas de la partie triang.
*     inferieure, dans l'autre cas les 'transposer'
      IF(NPLCAT.LE.0) RETURN 
      NBPLAW=0
      LGCUMW=0
      NUDRPL=0
      LGCUAV=0
      LIGNM1=1
      DO 10 LIGNE=2,NBLICO
         NUPRPL=NUDRPL+1
         NUDRPL=NULAPL(LIGNM1)
*        Il n'y a pas de creation de plage sur une ligne vide
         IF(NUDRPL.GE.NUPRPL) THEN
*           Numero de la nouvelle derniere plage sur la ligne :
*           les plages NUDRPL-NPLCAT a NUDRPL sont concatenees
            NUDRPW=NUDRPL-NPLCAT
*           Cas ou la derniere plage est strictement sous-diagonale
            KOLFIN=IPLAGL(1,NUDRPL)+IPLAGL(2,NUDRPL)-1
            IF(NUDRPL.GT.1) KOLFIN=KOLFIN-IPLAGL(2,NUDRPL-1)
            IF(KOLFIN.LT.LIGNE-1) NUDRPW=NUDRPW+1
            NUDRPW=MAX(NUPRPL,NUDRPW)
*           Les plages NUPRPL a NUDRPL-NPLCAT-1 restent inchangees
            DO 5 NUPL=NUPRPL,NUDRPW-1
               KOLDEB=IPLAGL(1,NUPL)
               LGCUMU=IPLAGL(2,NUPL)
               LGPLAG=LGCUMU-LGCUAV
               LGCUAV=LGCUMU
*              Report des pointeurs de ces plages
               LGCUMW=LGCUMW+LGPLAG
               NBPLAW=NBPLAW+1
               IPLAGL(1,NBPLAW)=KOLDEB
               IPLAGL(2,NBPLAW)=LGCUMW
5           CONTINUE
*           Concatenation des NPLCAT dernieres plages de la ligne
*           en une plage atteignant la derniere colonne (sous-diagonale)
            KOLDEB=IPLAGL(1,NUDRPW)
            LGPLAG=MAX(MIN(LIGNE,NBCOLI+1)-KOLDEB,0)
            LGCUMW=LGCUMW+LGPLAG
            IF(LGPLAG.GT.0)  NBPLAW=NBPLAW+1
            IPLAGL(1,NBPLAW)=KOLDEB
            IPLAGL(2,NBPLAW)=LGCUMW
            LGCUAV=IPLAGL(2,NUDRPL)
         END IF
         NULAPL(LIGNM1)  =NBPLAW
         LIGNM1=LIGNE
10    CONTINUE
                                                                    END *BmFilP*
