*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BML2NL (MOOUBM,NBLIGN,NULAPL,IPLAGE
     &                  ,ADPRCL,NUMCOL,ADSUCL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification (D.Martin) le 17 Mars 1995  
*  
* Calcul des pointeurs des coefficients sous-diagonaux d'une matrice BiMorse ou
* des coefficients d'une matrice Morse-L dans une structure NUME-L
*
*-- Arguments d'entree --
* MOOUBM =1 pour une matrice BiMorse
*        =0 pour une matrice Morse-L
* NBLIGN nombre de lignes
* NULAPL numeros de derniere plage de chaque ligne (longueur NBLIGN)
* IPLAGE numeros de colonne ou de ligne de debut de plage et
*        adresses des derniers coefficients de plage (longueur 2*NULAPL(NBLIGN))
*-- Arguments remplis en sortie
* ADPRCL adresses des 1ers coeff. de chaque ligne (longueur NBLIGN+1)
* NUMCOL numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NBLIGN,NULAPL(*),IPLAGE(2,*)
     &       ,ADPRCL(*),NUMCOL(*),ADSUCL(*)
*
      INTEGER LGCUMU,NUPRPL,NUDRPL,PLAGE,KOLDEB,KOLFIN,LIGNE,KOLONE
     &       ,LASTAD,LASTKP,LINU
*-----------------------------------------------------------------------
      LASTAD=ADPRCL(NBLIGN+1)
      LGCUMU=0
      NUPRPL=1
      LINU  =1
      ADPRCL(1)=0
      DO 3 LIGNE=1+MOOUBM,NBLIGN
         NUDRPL       =NULAPL(LINU)
         LINU         =LINU+1
*        Adresse du premier coefficient de la ligne
         LASTKP       =LASTAD
         DO 2 PLAGE=NUPRPL,NUDRPL 
            KOLDEB =IPLAGE(1,PLAGE) 
            KOLFIN =IPLAGE(2,PLAGE)-LGCUMU  
            DO 1 KOLONE=KOLDEB,KOLDEB+KOLFIN-1
               NUMCOL(LASTAD)=KOLONE
               ADSUCL(LASTAD)=LASTAD+1
               LASTAD        =LASTAD+1
1           CONTINUE
            LGCUMU=LGCUMU+KOLFIN 
2        CONTINUE
         IF (LASTAD.GT.LASTKP) THEN
            ADPRCL(LIGNE)=LASTKP
            ADSUCL(LASTAD-1)=0
         ELSE
*           Cas ou la partie sous-diagonale de la ligne est vide
            ADPRCL(LIGNE)=0
         ENDIF
         NUPRPL        =NUDRPL+1
3     CONTINUE
      ADPRCL(NBLIGN+1) =LASTAD
                                                                    END !BMl2Nl
