*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BML2SP (MOOUBM,NBLIGN,NCPINL,NBCOLO,NCPINC
     &                  ,NULAPL,IPLAGE,ADRESS,NUMLIG,NUMCOL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1999)
* Derniere modification : D.Martin  (27 Mars 1999) 
*  
* Listes des numeros de lignes et colonnes des coefficients sous-diagonaux 
* d'une matrice BiMorse ou des coefficients d'une matrice Morse-L
* range dans l'ordre des coefficients de la matrice
* (pour structure matriciel SPARSE de Matlab)
*
*-- Arguments d'entree --
* MOOUBM =1 pour une matrice BiMorse, =0 pour une matrice Morse-L
* NBLIGN nombre de lignes (compte en noeuds si NCPINL>1)
* NCPINL nombre de d.l. par noeud en ligne (cas d'inconnue vectorielle)
* NBCOLO nombre de colonnes (compte en noeuds si NCPINC>1)
* NCPINC nombre de d.l. par noeud en colonne (cas d'inconnue vectorielle)
* NULAPL numeros de derniere plage de chaque ligne (longueur NBLIGN)
* IPLAGE numeros de colonne de debut de plage et
*        adresses des derniers coefficients de plage (longueur 2*NULAPL(NBLIGN))
* ADRESS adresse de depart dans les tableau NUMLIG et NUMCOL
*-- Arguments remplis en sortie
* NUMLIG numeros de lignes des coefficients (longueur = taille de la matrice)
* NUMCOL numeros de colonnes des coefficients (longueur = taille de la matrice)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NBLIGN,NULAPL(*),IPLAGE(2,*)
     &       ,ADRESS,NUMLIG(*),NUMCOL(*)
*
      INTEGER LGCUAV,PRPL,DRPL,PL,C1N,NCN,LIG,COL,LGCUAD,LINENE,LPARNE
*-----------------------------------------------------------------------
      LGCUAV=0
      PRPL=1
      LINENE=1
      LIG =0
      IF (MOOUBM.EQ.1) THEN
*        Lignes correspondant au 1er noeud (Cas bimorse)
*        Coefficients sous-diagonaux non decrits par les pointeurs
*        de la structure bimorse
         DO 15 LPARNE=1,NCPINL
            LIG=LIG+1
            DO 10 COL=LIG-(LPARNE-1),LIG-1
               NUMLIG(ADRESS)=LIG
               NUMCOL(ADRESS)=COL
               ADRESS        =ADRESS+1
10          CONTINUE
15       CONTINUE
      ENDIF
      DO 50 LINE=1+MOOUBM,NBLIGN
         DRPL=NULAPL(LINENE)
         LINENE=LINENE+1
         LGCUAD=LGCUAV
*        Boucle sur les d.l. du noeud
         DO 35 LPARNE=1,NCPINL
            LIG=LIG+1
            LGCUAV=LGCUAD
            DO 25 PL=PRPL,DRPL
*              1er colonne de la plage
               C1N=IPLAGE(1,PL)
*              longueur de la plage
               NCN=IPLAGE(2,PL)-LGCUAV
               LGCUAV=LGCUAV+NCN
               DO 20 COL=1+(C1N-1)*NCPINC,(C1N+NCN-1)*NCPINC
                  NUMLIG(ADRESS)=LIG
                  NUMCOL(ADRESS)=COL
                  ADRESS        =ADRESS+1
20             CONTINUE
25          CONTINUE
            IF (MOOUBM.EQ.1) THEN
*               Coefficients sous-diagonaux non decrits par les pointeurs
*               de la structure bimorse
                DO 30 COL=LIG-(LPARNE-1),LIG-1
                   NUMLIG(ADRESS)=LIG
                   NUMCOL(ADRESS)=COL
                   ADRESS        =ADRESS+1
30             CONTINUE
            ENDIF
35       CONTINUE
         PRPL=DRPL+1
50    CONTINUE
                                                                    END !BMl2Sp
