*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BMU2NL (MOOUBM,NBLIGN,NBCOLO,NULAPL,IPLAGE
     &                  ,ADPRCL,NUMCOL,ADSUCL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification (D.Martin) le 12 Janvier 1995  
*  
* Calcul des pointeurs des coefficients sur-diagonaux d'une matrice BiMorse ou
* des coefficients d'une matrice Morse-C dans une structure NUME-L
*
*-- Arguments d'entree --
* MOOUBM =1 pour une matrice BiMorse
*        =0 pour une matrice Morse-C
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
* NULAPL numeros de derniere plage de chaque colonne (longueur NBCOLO)
* IPLAGE numeros de colonne ou de ligne de debut de plage et
*        adresses des derniers coefficients de plage (longueur 2*NULAPL(NBLIGN))
*-- Arguments modifies en sortie
* ADPRCL adresses des 1ers coeff. de chaque ligne (longueur NBLIGN+1)
* NUMCOL numeros de colonnes des coefficients (longueur =taille de la matrice)
* ADSUCL adresse du suivant sur une ligne (longueur =taille de la matrice)
*        (tableau provisoire)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NBLIGN,NBCOLO,NULAPL(*),IPLAGE(2,*)
     &       ,ADPRCL(*),NUMCOL(*),ADSUCL(*)
*
      INTEGER LGCUMU,NUPRPL,NUDRPL,PLAGE,LIGDEB,LIGFIN,LIGNE,KOLONE
     &       ,LASTAD,ADPRLI,NXTADR
*-----------------------------------------------------------------------
      LGCUMU=0
      LASTAD=ADPRCL(NBLIGN+1)
      NUPRPL=1
      DO 4 KOLONE=1+MOOUBM,NBCOLO
         NUDRPL=NULAPL(KOLONE-MOOUBM)
         DO 3 PLAGE=NUPRPL,NUDRPL 
            LIGDEB=IPLAGE(1,PLAGE) 
            LIGFIN=IPLAGE(2,PLAGE)-LGCUMU
            DO 2 LIGNE=LIGDEB,LIGDEB+LIGFIN-1 
               NXTADR=ADPRCL(LIGNE)
*
               IF (NXTADR.LE.0) THEN
*                 Cas d'une ligne vide
                  ADPRCL(LIGNE)=LASTAD
               ELSE
*                 Cas d'une ligne non vide
1                 ADPRLI=NXTADR
                  NXTADR=ADSUCL(ADPRLI)
                  IF (NXTADR.GT.0) GOTO 1
                  ADSUCL(ADPRLI)= LASTAD
               ENDIF
*
               ADSUCL(LASTAD)= 0
               NUMCOL(LASTAD)= KOLONE
               LASTAD        = LASTAD+1
2              CONTINUE
               LGCUMU=LGCUMU+LIGFIN 
3           CONTINUE
            NUPRPL=NUDRPL+1
4        CONTINUE
      ADPRCL(NBLIGN+1)=LASTAD
                                                                    END !Bmu2Nl
