*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE C M 2 L P R (NBLINE,NBCOLO,NULAPL,IPLAGE,LENV)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)
* Derniere modification (D.Martin) le 4 Juil. 91  
*  
*     Calcul des pointeurs de l'enveloppe sous-diagonale d'un stockage 'Profil'
*              a partir des tables de compactage 'Morse ligne'
*              (CM2LPr --> Compactage Morse 'to' Lower PRofile)
*  
*** Arguments de la Liste d'Entree *** 
* NBLINE: Nombre de lignes de la matrice
* NBCOLO: Nombre de colonnes de la matrice
* NULAPL: Numeros de derniere plage sur chaque ligne
* IPLAGE: Tableau des numeros de debut de plage et des longueurs cumulees  
* LENV  : Tableau contenant l'enveloppe inferieure stricte avec
*         LENV(I-1) adresse dans la partie triangulaire inferieure compactee
*         du 1er coeff. non nul de la ligne I, et LENV(I)=LENV(I-1) si le 1er 
*         coeff. de la ligne I+1 est le coeff. diagonal, et LENV(NBLINE)-1 
*         est la taille de la partie triangulaire inferieure stricte compactee.
*
*** Exemple : Pour la matrice suivante, le profil sous-diagonal est
*                     D . . . .
*                     X D . . .         LENV(1)=1
*                     0 X D . .         LENV(2)=2
*                     0 0 0 D .         LENV(3)=3
*                     X X X X D         LENV(4)=3
*                     0 X X X X         LENV(5)=7
*                     0 0 0 X X         LENV(6)=11
*                                       LENV(7)=13
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPL(*),IPLAGE(2,*),LENV(*)  
*
      IADL=1
      NUDRPL=NULAPL(1)
      DO 1 LIGNE=2,NBLINE
         LENV(LIGNE-1)=IADL
         NUPRPL=NUDRPL+1
         NUDRPL=NULAPL(LIGNE)
1        IADL=IADL+MAX(0,MIN(LIGNE,NBCOLO+1)-IPLAGE(1,NUPRPL))
*                        --- (pour une matrice rectangulaire)
      LENV(NBLINE)=IADL
                                                                    END *Cm2LPr*

