*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE C M 2 U B M (NBLIGN,NBCOLO,NULAPM,IPLAGM
     *                                            ,NULAPU,IPLAGU,NXCOLI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)
* Derniere modification (D.Martin) le 5 Dec. 91
*
*  Passage du compactage Morse ligne standard au compactage Bi-Morse superieur
*  Les pointeurs de la struct. Bi-Morse superieure sont ceux de la struct. 
*  Morse transposee (morse colonne) pour les coeff. de la partie triangulaire
*  superieure stricte a compter de la colonne 2 .
*          (CM2UBM --> Compactage Morse 'to' Upper BiMorse)
*
*** Arguments d'entree ***
* NBLIGN nombre de lignes
* NBCOLO nombre de lignes
* NULAPM numeros des dernieres plages de chaque ligne de la struct. Morse
* IPLAGM numeros colonnes de debut de plage et adresses des derniers coeff.
*        de chaque plage de la struct. Morse
* NXCOLI tableau de travail de longueurs 3*NBLIGN
* NXCOLI(1,I): numero de colonne du prochain coeff non nul de la ligne # I 
*       (2,I): numero de plage en cours de la ligne # I
*       (3,I): adresse du dernier coefficient de la plage en cours.
*** Arguments de sortie ***
* NULAPU numeros des dernieres plages de chaque colonne de la struct. Bi-Morse
* IPLAGU numeros de lignes de debut de plage et adresses des derniers coeff.
*        de chaque plage de la structure biMorse superieure
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPM(*),IPLAGM(2,*),NULAPU(*),IPLAGU(2,*)
      INTEGER NXCOLI(3,*)
*
      LGCUMA = 0
      NUDRPM = NULAPM(1)
*
*     Phase preliminaire : Reperage du premier coeff. sur-diagonal
*     de chaque ligne, de son numero de plage et de son adresse
      NUMPLM = 1
      KOLDEB = IPLAGM(1,1)
      KOLFIN = IPLAGM(2,1)
      IF(KOLDEB.EQ.1) THEN
         IF(KOLFIN.EQ.1) THEN
            KOLDEB = 0
            IF(NUDRPM.GT.1) THEN
               KOLDEB = IPLAGM(1,2)
               NUMPLM = 2
               LGCUMA = 1
            END IF
         ELSE
            KOLDEB = 2
         END IF
      END IF
      NXCOLI(1,1) = KOLDEB
      NXCOLI(2,1) = NUMPLM
      NXCOLI(3,1) = LGCUMA
*
      LGCUMA = IPLAGM(2,NUDRPM)
      DO 10 LIGNE = 2,NBLIGN
         NUPRPM = NUDRPM+1
         NUDRPM = NULAPM(LIGNE)
         CALL DIKLPL(LIGNE,NUPRPM,NUDRPM,LGCUMA,IPLAGM,NUMPLM,*1)
*        Cas d'une plage diagonale sur la ligne de A
         KOLDEB = IPLAGM(1,NUMPLM)
         LGCUMA = IPLAGM(2,NUMPLM-1)
         KOLFIN = KOLDEB+IPLAGM(2,NUMPLM)-LGCUMA-1
         IF(KOLFIN.EQ.LIGNE) THEN
            KOLDEB = 0
            IF(NUDRPM.GT.NUMPLM) THEN
               LGCUMA = IPLAGM(2,NUMPLM)
               NUMPLM = NUMPLM+1
               KOLDEB = IPLAGM(1,NUMPLM)
            END IF
         ELSE
            KOLDEB = LIGNE+1
         END IF
         GO TO 3
1        NXCOLI(1,LIGNE) = 0
         DO 2 NUMPLM = NUPRPM,NUDRPM
            KOLDEB = IPLAGM(1,NUMPLM)
            IF(KOLDEB.GT.LIGNE) GO TO 3
            LGCUMA = IPLAGM(2,NUMPLM)
2        CONTINUE
         GO TO 9
3        NXCOLI(1,LIGNE) = KOLDEB
         NXCOLI(2,LIGNE) = NUMPLM
         NXCOLI(3,LIGNE) = LGCUMA
9        LGCUMA = IPLAGM(2,NUDRPM)
10    CONTINUE
*
*     Calcul du stockage BiMorse triangulaire superieur
      NBPLAU = 0
      LGCUPU = 0
      LGPLAU = 0
      KOLOM1 = 1
      DO 22 KOLON = 2,NBCOLO
         DO 21 LIGNE = 1,MIN(KOLOM1,NBLIGN)
            NXCOL = NXCOLI(1,LIGNE)
            IF(KOLON.EQ.NXCOL) THEN
               NUMPLM = NXCOLI(2,LIGNE)
               KOLDEB = IPLAGM(1,NUMPLM)
               LGCUMA = IPLAGM(2,NUMPLM)
               LGCUAM = NXCOLI(3,LIGNE)
               KOLFIN = KOLDEB+LGCUMA-LGCUAM-1
               NXCOLI(1,LIGNE) = 0
               IF(KOLON.LT.KOLFIN) THEN
                  NXCOLI(1,LIGNE) = KOLON+1
               ELSE
                  NXCOLI(3,LIGNE) = LGCUMA
                  NUMPLM = NUMPLM+1
                  IF(NUMPLM.LE.NULAPM(LIGNE)) THEN
                     NXCOLI(2,LIGNE) = NUMPLM
                     NXCOLI(1,LIGNE) = IPLAGM(1,NUMPLM)
                  END IF
               END IF
               LGCUPU = LGCUPU+1
               IF(LGPLAU.EQ.0) THEN
*                 Debut d'une plage sur la colonne : Numero de debut de plage
                  NBPLAU = NBPLAU+1
                  IPLAGU(1,NBPLAU) = LIGNE
               END IF
               LGPLAU = LGPLAU+1
            ELSE IF((KOLON.LT.NXCOL.OR.NXCOL.EQ.0).AND.LGPLAU.GT.0) THEN
*              Fin d'une plage sur la colonne : adrs. de son dernier coeff.
               IPLAGU(2,NBPLAU) = LGCUPU
               LGPLAU = 0
            END IF
21       CONTINUE
*        Fin de la derniere plage sur la colonne : adrs. de son dernier coeff.
         NULAPU(KOLOM1) = NBPLAU
         IF(NBPLAU.GT.0) IPLAGU(2,NBPLAU) = LGCUPU
         LGPLAU = 0
         KOLOM1 = KOLON
22    CONTINUE
                                                                    END *Cm2UBm*
