*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE C M 2 U P R (NBLINE,NBCOLO,NULAPL,IPLAGE,UENV)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)
* Derniere modification (D.Martin) le 4 Juil. 91  
*  
*      Calcul des pointeurs de l'enveloppe superieure d'un stockage 'Profil'
*              a partir des tables de compactage 'Morse ligne'
*              (CM2UPr --> Compactage Morse 'to' Upper PRofile)
*  
*** Arguments de la Liste d'Entree *** 
* NBLINE: Nombre de lignes de la matrice
* NBCOLO: Nombre de colonnes de la matrice
* NULAPL: Numeros de derniere plage sur chaque ligne
* IPLAGE: Tableau des numeros de debut de plage et des longueurs cumulees  
* UENV  : Tableau contenant l'enveloppe superieure stricte avec
*         UENV(I-1) adresse dans la partie triangulaire superieure compactee
*         du 1er coeff. non nul de la colonne I, et UENV(I)=UENV(I-1) si le 1er 
*         coeff. de la colonne I+1 est le coeff. diagonal, et UENV(NBLINE)-1 
*         est la taille de la partie triangulaire superieure stricte compactee.
*
*** Exemple : Pour la matrice :  D X 0 0 X 0 0
*                                . D X 0 X X 0
*                                . . D 0 X X 0     
*                                . . . D X X X
*                                . . . . D X X 
* UENV(1)=1, UENV(2)=2, UENV(3)=3, UENV(4)=3, UENV(5)=7, UENV(6)=11, UENV(7)=13
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPL(*),IPLAGE(2,*),UENV(*)  
*
      DO 1 I=1,NBCOLO-1
1        UENV(I)=I+1
*     On repere tout d'abord le numero de ligne du 1er coeff non nul
*     de chaque colonne
*     Plage 1 de la premiere ligne
      KOLDEB=IPLAGE(1,1)
      LGCUMU=IPLAGE(2,1)
*     Le pointeur NEXT repere la prochaine colonne pour laquelle
*     on n'a pas repere le 1er coeff. non nul
      NEXT=2
      IF(KOLDEB.EQ.1) THEN
         NEXT=LGCUMU+1
         KOLDEB=2
      END IF
      DO 2 KOL=KOLDEB,LGCUMU+IPLAGE(1,1)-1
2        UENV(KOL-1)=1
*     Autres plages de la premiere ligne
      NUDRPL=NULAPL(1)
      DO 3 NUPLA=2,NUDRPL
         LGCUAV=LGCUMU+1
         KOLDEB=IPLAGE(1,NUPLA)
         LGCUMU=IPLAGE(2,NUPLA)
         KOLFIN=KOLDEB+LGCUMU-LGCUAV
         DO 3 KOL=KOLDEB,KOLFIN
3           UENV(KOL-1)=1
*     Autres lignes
      DO 10 LIGNE=2,NBLINE-1
         NUPRPL=NUDRPL+1
         NUDRPL=NULAPL(LIGNE)
         CALL DIKLPL(LIGNE,NUPRPL,NUDRPL,LGCUMU,IPLAGE,NUDGPL,*7)
*
**       Ligne dont une plage NUDGPL contient le coefficient diagonal
*
         KOLDEB=IPLAGE(1,NUDGPL)
         LGCUAV=IPLAGE(2,NUDGPL-1)+1
         LGCUMU=IPLAGE(2,NUDGPL)
         KOLFIN=KOLDEB+LGCUMU-LGCUAV
*        Plage contenant le coeff. diagonal
         DO 4 KOL=LIGNE+1,KOLFIN
4           UENV(KOL-1)=MIN(UENV(KOL-1),LIGNE)
         IF(NEXT.GE.LIGNE) NEXT=MAX(NEXT,KOLFIN+1)
*        Plages surdiagonales
         DO 6 NUPLA=NUDGPL+1,NUDRPL
            LGCUAV=LGCUMU+1
            KOLDEB=IPLAGE(1,NUPLA)
            LGCUMU=IPLAGE(2,NUPLA)
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 5 KOL=KOLDEB,KOLFIN
5              UENV(KOL-1)=MIN(UENV(KOL-1),LIGNE)
6           IF(NEXT.GE.KOLDEB) NEXT=MAX(NEXT,KOLFIN+1)
         GO TO 10
*
**       Ligne sans plage contenant la coeff. diagonal
*        (les plages sous-diagonales sont sautees)
*
7        DO 9 NUPLA=NUPRPL,NUDRPL
            LGCUAV=LGCUMU+1
            KOLDEB=IPLAGE(1,NUPLA)
            LGCUMU=IPLAGE(2,NUPLA)
            IF(KOLDEB.LE.LIGNE) GO TO 9
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 8 KOL=KOLDEB,KOLFIN
8              UENV(KOL-1)=MIN(UENV(KOL-1),LIGNE)
            IF(NEXT.GE.KOLDEB) NEXT=MAX(NEXT,KOLFIN+1)
9           CONTINUE
10       IF(NEXT.GT.NBCOLO) GO TO 11
*
*     Calcul des adresses dans la partie triangulaire superieure stricte
*     des premiers coefficients non nuls de chaque colonne
*
11    IADU=1
      DO 12 KOLON=1,NBLINE-1
         LIG1=UENV(KOLON)
         UENV(KOLON)=IADU
12       IADU=IADU+MIN(KOLON,NBLINE+1)+1-LIG1
*                  --- (pour une matrice rectangulaire)
      UENV(NBLINE)=IADU
                                                                    END *Cm2UPr*

