*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CMPACT (NBNEUC,IRGNEC,NBNEUL,IRGNEL,NBNELI
     &                  ,NBPLAX,NBPLAJ,NULAPL,IPLAGE,IMPFCH,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : A.Jami, M.Lenoir, D.Martin (dans l'antiquite)
* Derniere modification : D.Martin (16 mars 2008)
* Version 2
*  
* Constitution des tableaux de stockage 'Morse-ligne' (resp. 'Morse-colonne').
*  
*-- Arguments de la Liste d'Entree -- 
* NBNEUC nombre de noeuds en colonnes (resp. lignes) pour l'element en cours 
*        = nombre de colonnes (resp. lignes) des matrices elementaires
* IRGNEC rang dans la numerotation en colonne (resp. ligne) des noeuds
* NBNEUL nombre de noeuds en lignes (resp. colonnes) pour l'element en cours
*        = nombre de lignes (resp. colonnes) des matrices elementaires
* IRGNEL rang dans la numerotation en ligne (res. colonne) des noeuds 
* NBNELI nombre de lignes (resp. colonnes) des matrices des termes du domaine
* NBPLAX nombre maximum de plages : La taille declaree du tableau IPLAGE  
*        lors de sa creation (sa taille est a priori inconnue) est 2*NBPLAX
* NBPLAJ nombre de plages des matrices des termes du domaine  
* NULAPL numeros de derniere plage sur chaque ligne (resp. colonne)
* IPLAGE tableau des numeros de debut de plage et des longueurs cumulees   
* IMPFCH unite logique d'impression
* IRCODE indicateur d'erreur en cas de depassement de la taille de ces tableaux
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* REMARQUES : Remettre a zero NBPLAJ et le tableau NULAPL pour chaque domaine.
*             Ajuster la taille du tableau IPLAGE apres le dernier element 
*             du domaine ( il est a priori 'surdimensionne' ).
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBNEUC,IRGNEC(*),NBNEUL,IRGNEL(*),NBNELI,NBPLAX,NBPLAJ
     &       ,NULAPL(*),IPLAGE(2,*),IMPFCH,IRCODE
*
      INTEGER IDL,IGLO,JDL,JGLO
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Cmpact*')
*
*     Boucle sur les noeuds en lignes
      DO 21 IDL=1,NBNEUL
         IGLO=IRGNEL(IDL)
*        Boucle sur les noeuds en colonnes
         DO 20 JDL=1,NBNEUC
            JGLO=IRGNEC(JDL)
            CALL CMPLGN (IGLO,JGLO,NBNELI
     &                  ,NBPLAJ,NULAPL,IPLAGE,NBPLAX,IRCODE)            !Morse
            IF (IRCODE.NE.0) GOTO 90001
20       CONTINUE
21    CONTINUE
      CALL PRFXMJ (-1,'*Cmpact*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 IRCODE=IGLO
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
*  dans l'appel de CMPLGN
* Version 1 : D.Martin (20 Decembre 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Cmpact
