*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CMPHRM (NBNELI,NUCONE,NULINE,MATDIM,NULAPL,IPLAGE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin et O.deBayser (Septembre 1988)
* Derniere modification D.Martin le 23 jan.89  
*  
* Prise en compte des d.l. d'Hermite dans les tableaux de compactage
* si l'une des interpolations en ligne ou en colonne est Hermite
*  
*** Arguments d'entree *** 
* NBNELI : nombre de noeuds 'en ligne' du domaine =Nombre de lignes
*          de la matrice correspondant aux d.l. 'valeur nodales'.  
* NUCONE(I) : nombre de d.l. portes par le I-eme noeud et tous ses precedents  
*               dans la numerotation des noeuds du domaine en colonne  
* NULINE(I) : idem mais pour la numerotation en ligne  
* NULAPL : numeros de derniere plage sur chaque ligne (resp. colonne)  
* IPLAGE : tableau des numeros de debut de plage et des longueurs cumulees .
*          Ces tableaux sont modifies ci-dessous pour prendre en compte dans  
*          les longueurs cumulees et les numeros de debut de plage les d.l. 
*          d'Hermite.  
* MATDIM : En sortie nombre de coefficients de la matrice  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUCONE(*),NULINE(*),NULAPL(*),IPLAGE(2,*)  
*  
*     LOCUDL : longueur cumulee en D.L. des plages d'une ligne 
*     MATDIM : longueur cumulee en D.L. des plages precedant la plage en cours 
*  
      NULIG=1  
*     Tableaux de compactage pour la premiere plage :  
      NUMPL1=1 
      NEDBPL=IPLAGE(1,NUMPL1)  
      NEFNPL=NEDBPL-1+IPLAGE(2,NUMPL1) 
      LOCUDL=NUCONE(NEFNPL+1)-NUCONE(NEDBPL)
      IPLAGE(1,NUMPL1)=NUCONE(NEDBPL)  
*  
*     Tableaux de compactage pour les plages de la premiere ligne  
      NUMPL2=NULAPL(NULIG) 
      DO 1 NUMPLA=2,NUMPL2 
         NEDBPL=IPLAGE(1,NUMPLA)
         NEFNPL=NEDBPL-1+IPLAGE(2,NUMPLA)-IPLAGE(2,NUMPLA-1)
         IPLAGE(2,NUMPLA-1)=LOCUDL 
         LOCUDL=LOCUDL+NUCONE(NEFNPL+1)-NUCONE(NEDBPL) 
         IPLAGE(1,NUMPLA)=NUCONE(NEDBPL)
1     CONTINUE 
      MATDIM=LOCUDL
      DO 4  NULIG=2,NBNELI 
         NUMPL1=NULAPL(NULIG-1)+1  
         NUMPL2=NULAPL(NULIG)  
*  
*        Tableaux de compactage pour la premiere plage de la NULIG-eme ligne : 
         NEDBPL=IPLAGE(1,NUMPL1)
         NEFNPL=NEDBPL-1+IPLAGE(2,NUMPL1)-IPLAGE(2,NUMPL1-1)
         IPLAGE(2,NUMPL1-1)=MATDIM 
*        pour chaque ligne comptee en noeuds (NULIG), il faut compter  
*        autant de lignes identiques que de d.l. au noeud NULIG
         DO 2 IDLM1=1,NULINE(NULIG)-NULINE(NULIG-1)-1  
2           MATDIM=MATDIM+LOCUDL
         LOCUDL=NUCONE(NEFNPL+1)-NUCONE(NEDBPL)
*  
*        Tableaux de compactage pour les autres plages de la NULIG-eme ligne : 
         IPLAGE(1,NUMPL1)=NUCONE(NEDBPL)
         DO 3 NUMPLA=NUMPL1,NUMPL2 
            NEDBPL=IPLAGE(1,NUMPLA)
            NEFNPL=NEDBPL-1+IPLAGE(2,NUMPLA)-IPLAGE(2,NUMPLA-1)
            IPLAGE(2,NUMPLA-1)=MATDIM+LOCUDL
            LOCUDL=LOCUDL+NUCONE(NEFNPL+1)-NUCONE(NEDBPL)  
            IPLAGE(1,NUMPLA)=NUCONE(NEDBPL)
3        CONTINUE  
         MATDIM=MATDIM+LOCUDL  
4     CONTINUE 
      IPLAGE(2,NUMPL2)=MATDIM  
      DO 5 IDLM1=1,NULINE(NBNELI)-NULINE(NBNELI-1)-1
5        MATDIM=MATDIM+LOCUDL  
                                                                    END *Cmphrm*
