*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CMPLGN (NUMLIG,NUMCOL,NBNELI,NBPLAJ,NULAPL,IPLAGE
     &                  ,NBPLAX,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : A.Jami, M.Lenoir, D.Martin (dans l'antiquite)
* Derniere modification : D.Martin (16 mars 2008)
*  
* Plongement d'un coefficient dans le tableau de stockage d'une matrice
* Morse-Ligne ou Morse-Colonne ou dans l'une des parties triangulaires
* inferieure ou superieure d'une matrice BiMorse
*  
*-- Arguments de la Liste d'Entree --
* NUMLIG numero de ligne (resp. colonne) du coefficient
* NUMCOL numero de colonne (resp. ligne) du coefficient 
* NBNELI nombre de lignes (resp. colonnes) de la matrice
* NBPLAJ nombre de plages de la matrice (mis a jour dans cette procedure)
* NULAPL numeros de derniere plage sur chaque ligne (resp. colonne) (idem)
* IPLAGE tableau des numeros de debut de plage et des adresses des
*        derniers coefficients de chaque plage  
* NBPLAX nombre maximum de plages (calcule a la creation du tab. de stockage) 
* IRCODE flag en cas de depassement de NBPLAX  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NUMLIG,NUMCOL,NBNELI,NBPLAJ,NULAPL(*),IPLAGE(2,*),NBPLAX
     &        ,IRCODE
*
      INTEGER NOLIG,IDEL,IDER,IDEV,NUPLAG,NUMPLA,NUMPL1,NUMPL2
     &       ,LGCUAV,LGCUMU,NDBPLN,NFNPLN,NK,NA
*-----------------------------------------------------------------------
*
*     Recherche du numero de la 1ere plage de la ligne courante
*
      IRCODE=0
      NOLIG=NUMLIG
1     NOLIG=NOLIG-1
      IF (NOLIG.GE.1) THEN
         NUMPL1=NULAPL(NOLIG)
         IF (NUMPL1.EQ.0) GOTO 1
         NUMPL1=NUMPL1+1
      ELSE
         NUMPL1=1
      ENDIF
*
*     Recherche du numero de la 1ere plage de la ligne suivante
*
      NOLIG=NUMLIG+1
2     NOLIG=NOLIG-1
      IF (NOLIG.GE.1) THEN
         NUMPL2=NULAPL(NOLIG)
         IF (NUMPL2.EQ.0) GOTO 2
         IDEL=NUMPL2+1
      ELSE
         IDEL=1
      ENDIF
*  
      IDER=0
      IDEV=0
*
*     Boucle sur les plages de la ligne NUMLIG
*
      LGCUAV=0
      IF (NUMPL1.GT.1) LGCUAV=IPLAGE(2,NUMPL1-1)
      NUMPLA=NUMPL1-1
3     NUMPLA=NUMPLA+1
      IF (NUMPLA.LE.NUMPL2) THEN
         NDBPLN=IPLAGE(1,NUMPLA)-1
         IF (NUMCOL.LT.NDBPLN) THEN
            IDEL=NUMPLA
         ELSEIF (NUMCOL.EQ.NDBPLN) THEN
            IDER=NUMPLA
         ELSE
            LGCUMU=IPLAGE(2,NUMPLA)
            NFNPLN=NDBPLN+1+LGCUMU-LGCUAV
            LGCUAV=LGCUMU 
            IF (NUMCOL.LT.NFNPLN) RETURN
            IF (NUMCOL.EQ.NFNPLN) IDEV=NUMPLA
            GOTO 3
         ENDIF
      ENDIF
*
      IF (IDER.EQ.0.AND.IDEV.EQ.0) THEN
*
*        Creation d'une plage
*
         IF (NBPLAJ.GE.NBPLAX) GOTO 90000
         NULAPL(NUMLIG)=NUMPL2+1  
         DO 10 NOLIG=NUMLIG+1,NBNELI  
            NUPLAG=NULAPL(NOLIG)  
            IF (NUPLAG.GT.0) NULAPL(NOLIG)=NUPLAG+1
10       CONTINUE
         DO 11 NK=NBPLAJ,IDEL,-1  
            IPLAGE(1,NK+1)=IPLAGE(1,NK)
            IPLAGE(2,NK+1)=IPLAGE(2,NK)+1
11       CONTINUE
         IPLAGE(1,IDEL)=NUMCOL
         NA=0 
         IF (IDEL.GT.1) NA=IPLAGE(2,IDEL-1)
         IPLAGE(2,IDEL)=NA+1  
         NBPLAJ=NBPLAJ+1
*
      ELSEIF (IDER*IDEV.NE.0) THEN
*
*       Concatenation de deux plages
*
         DO 20 NOLIG=NUMLIG,NBNELI
            NUPLAG=NULAPL(NOLIG)  
            IF (NUPLAG.GT.0) NULAPL(NOLIG)=NUPLAG-1
20       CONTINUE
         IPLAGE(2,IDEV)=IPLAGE(2,IDER)+1  
         NBPLAJ=NBPLAJ-1  
         DO 21 NK=IDER,NBPLAJ 
            IPLAGE(1,NK)=IPLAGE(1,NK+1)
            IPLAGE(2,NK)=IPLAGE(2,NK+1)+1
21       CONTINUE
*
      ELSEIF (IDER.EQ.0) THEN
*
*        Ajout apres une plage
*
         DO 30 NK=IDEV,NBPLAJ 
            IPLAGE(2,NK)=IPLAGE(2,NK)+1
30       CONTINUE
      ELSE
*
*        Ajout devant une plage
*
         IPLAGE(1,IDER)=NUMCOL
         DO 40 NK=IDER,NBPLAJ 
            IPLAGE(2,NK)=IPLAGE(2,NK)+1
40       CONTINUE
      ENDIF
      RETURN
*-----------------------------------------------------------------------
90000 IRCODE = 1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 mars 2008)
*  Substitution de l'etiquette de retour au code de retour IRCODE
* Version 1 : D.Martin (30 Mars 1992)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Cmplgn
