*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE D I K L P L(NUCOL,NUMPL1,NUMPL2,LGCUDB,IPLAGE,LAPLAG,*)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Sep.88) 
* Derniere modification (O.deBayser) le 8 Avril 1994
*  
*     Recherche dichotomique d'une plage d'une ligne contenant une colonne 
*  
*** Arguments ***  
* NUCOL  Colonne pour laquelle on recherche la plage  
* NUMPL1 Premiere plage de la ligne
* NUMPL2 Derniere plage de la ligne sur laquelle porte la recherche
* LGCUDB Longueur cumulee des plages precedent la premiere plage  
* IPLAGE Tableau descriptif des plages
* LAPLAG Le numero de plage trouvee en cas de succes,
*        le numero potentiel de plage en cas d'echec, c'est-a-dire
*        NUMPLI   si NUCOL< numero de debut de la plage NUMPLI=NUMPL1, NUMPL2
*        NUMPL2+1 si NUCOL> numero de fin de plage de la plage NUMPL2
* (*)    Retour en cas d'echec dans la recherche dichotomique 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER IPLAGE(2,*)
*  
      IPLDEB=NUMPL1
      IPLFIN=NUMPL2
      LAPLAG=IPLFIN 
      IF(IPLDEB.GT.IPLFIN) RETURN 1
*  
*     Recherche dans la premiere plage de la ligne 
*  
      IDEBPL=IPLAGE(1,IPLDEB) 
      LAPLAG=IPLDEB 
      IF(NUCOL.LT.IDEBPL) RETURN 1
      IFINPL=IDEBPL-1+IPLAGE(2,IPLDEB)-LGCUDB
      IF(NUCOL.LE.IFINPL) RETURN
*  
*     Recherche dans la derniere plage de la ligne 
*  
      IDEBPL=IPLAGE(1,IPLFIN)  
      IFINPL=IDEBPL-1+IPLAGE(2,IPLFIN)-IPLAGE(2,IPLFIN-1)
      LAPLAG=IPLFIN+1  
      IF(NUCOL.GT.IFINPL) RETURN 1
      LAPLAG=IPLFIN
      IF(NUCOL.GE.IDEBPL) RETURN
*  
*     Recherche dans les autres plages de la ligne 
*  
      MEME=0
*     MEME > 1 indique la stagnation de la recherche dichotomique
*
1     LAPLAG=(IPLFIN+IPLDEB)/2  
      IDEBPL=IPLAGE(1,LAPLAG)
      IFINPL=IDEBPL-1+IPLAGE(2,LAPLAG)-IPLAGE(2,LAPLAG-1)
      IF(NUCOL.LT.IDEBPL) THEN  
         IPLFIN=LAPLAG
         LAPLAG=IPLDEB 
      ELSE IF(NUCOL.GT.IFINPL) THEN 
         IPLDEB=LAPLAG
         LAPLAG=IPLFIN+1  
      ELSE  
         RETURN 
      END IF 
      IF(IPLFIN.LE.IPLDEB+1) MEME=MEME+1
      IF(MEME.GT.1) RETURN 1
      GO TO 1 
                                                                    END *Diklpl*
