*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MB2PR  (NBLICO,NBCOLI,NULAP,IPLAG,TYPE,MCB
     *                  ,ENV,MCP,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991)
* Derniere modification : D.Martin (15 mai 1992)  
*  
* Transformation d'une matrice stockee 'Bi-Morse' inferieure (res. superieure)
* en la meme matrice stockee 'Profil inferieur' (resp. superieur)
*               (MB2PR --> Matrice Bimorse 'to' PRofil)
*  
*-- Arguments
* NBLICO Nombre de lignes (resp. colonnes) de la matrice
* NBCOLI Nombre de colonnes (resp. lignes) de la matrice
* NULAP  Numeros de derniere plage sur chaque ligne (resp. colonne)
* IPLAG  Tableau des numeros de ligne (resp. colonne) de debut de plage
*        et des adresses des derniers coefficients de chaque plage. 
* TYPE   Type REEL ou COMPLEXE de la matrice
* MCB    Adresse de la matrice bimorse dans le s-t RST ou CST du bon type
* ENV    Tableau contenant l'enveloppe inferieure(resp. sup) stricte avec
*        ENV(I-1) adresse dans la partie triangulaire inf (resp. sup)
*        'Profil' du 1er coeff. non nul de la ligne I(resp colonne I)
*       , et ENV(I-1)=ENV(I-2) si le 1er coeff. de la lig. I(resp col. I)
*        est le coeff. diagonal
*       , et ENV(NBLICO)-1 est la taille de la partie triangulaire inferieure
*        (resp. superieure) stricte compactee.
* MCP    Adresse de l'enveloppe inferieure de la matrice profil dans RST ou CST
* RST    Super-tableau version REELLE
* CST    Super-tableau version COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLICO,NBCOLI,NULAP(*),IPLAG(2,*),MCB,ENV(*),MCP
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER NUPRPL,NUDRPL,LGCUMU,LGCUAV,LIOUC1,KOLON1,KOLDEB,KOLFIN
     &       ,MCBB,MCP1,MCPP,NUPLA
*-----------------------------------------------------------------------
      CALL TAZERO(ENV(NBLICO)-1,TYPE,MCP,TYPE,ENV,RST,CST)
*
      NUDRPL=0
      MCBB=MCB
      LIOUC1=1
      LGCUMU=0
      IF (TYPE(1:1).EQ.'C') THEN
*
*       'Decompactage' des lignes 2 a NBLICO
*
         DO 41 LIOUCO=2,NBLICO
            NUPRPL=NUDRPL+1
            NUDRPL=NULAP(LIOUC1)
            IF (NUDRPL.GE.NUPRPL) THEN
*              Adresse dans l'enveloppe du premier coeff. de la ligne
               MCP1  =MCP-1+ENV(LIOUC1)
*              Numero de colonne du premier coefficient de la ligne
               KOLON1=IPLAG(1,NUPRPL)
*
               DO 40 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAG(1,NUPLA)
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAG(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  MCPP  =MCP1+KOLDEB-KOLON1
                  DO 40 KOLON=KOLDEB,KOLFIN
                     CST(MCPP)=CST(MCBB)
                     MCBB=MCBB+1
                     MCPP=MCPP+1
40                CONTINUE
            END IF
41       LIOUC1=LIOUCO
      ELSE
         DO 21 LIOUCO=2,NBLICO
            NUPRPL=NUDRPL+1
            NUDRPL=NULAP(LIOUC1)
            IF (NUDRPL.GE.NUPRPL) THEN
               MCP1  =MCP-1+ENV(LIOUC1)
               KOLON1=IPLAG(1,NUPRPL)
               DO 20 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAG(1,NUPLA)
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAG(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  MCPP  =MCP1+KOLDEB-KOLON1
                  DO 20 KOLON=KOLDEB,KOLFIN
                     RST(MCPP)=RST(MCBB)
                     MCBB=MCBB+1
                     MCPP=MCPP+1
20                CONTINUE
            END IF
21       LIOUC1=LIOUCO
      END IF
                                                                    END *MB2Pr*


