*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE M M 2 B M (NBLIGN,NBCOLO,NULAPM,IPLAGM,TYPE,MCA
     *          ,NULAPL,IPLAGL,NULAPU,IPLAGU,MCD,MCL,MCU,NXCOLI,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)  
* Derniere modification (D.Martin) le 20 Nov. 1991 
*
*  Passage d'une matrice Morse ligne standard a une matrice Bi-Morse.
*          (MM2BM --> Matrice Morse 'to' matrice BiMorse)
*
*     On suppose que la structure BiMorse inf./sup. recouvre la structure
*  Morse de la partie triangulaire inf./sup., tout en respectant le profil
*  inferieur/superieur, c'est-a-dire en particulier que le numero de
*  debut de la premiere plage de chaque ligne/colonne est le meme dans les
*  deux structures. 
*     Ces hypotheses sont respectees si par exemple plusieurs plages
*  de la structure Morse ont ete concatenees en une plage de la structure
*  BiMorse inferieure/superieure.
*
*** Arguments ***
* NBLIGN nombre de lignes des matrices
* NBCOLO nombre colonnes des matrices
* NULAPM numeros des dernieres plages de chaque ligne de la struct. Morse
* IPLAGM numeros de debut de plage et longueurs cumulees de la struct. Morse
* MCA    adresse de la matrice initiale dans le s-t du bon type
* NULAPL nos de derniere plage de la struct. Bi-Morse inferieure
* IPLAGL nos de debut de plage et long. cumulees de la struct. Bi-Morse inf.
* NULAPU nos de derniere plage de la struct. Bi-Morse superieure
* IPLAGU nos de debut de plage et long. cumulees de la struct. Bi-Morse sup.
* MCD    adresse de la diagonale de matrice Bi-Morse dans le s-t du bon type
* MCL    adresse de L partie triang. inferieure de la matrice Bi-Morse 
* MCU    adresse de U partie triang. superieure de la matrice Bi-Morse
* NXCOLI Tableau de travail de dimension 3 x NBCOLO  
* NXCOLI(1,I): numero de ligne du prochain coef. de la colonne I de U
*       (2,I): numero de plage en cours de la colonne I de U
*       (3,I): longueur cumulee des plages precedant la plage en cours.
* RST    tableau contenant les matrices (cas reel)
* CST    tableau contenant les matrices (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NULAPM(*),IPLAGM(2,*),NXCOLI(3,*)
     *             ,NULAPL(*),IPLAGL(2,*),NULAPU(*),IPLAGU(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      LGMORL=IPLAGL(2,NULAPL(NBLIGN-1))
      CALL TAZERO(LGMORL,TYPE,MCL,TYPE,NULAPL,RST,CST)                  !Utilite
      LGMORU=IPLAGU(2,NULAPU(NBCOLO-1))
      CALL TAZERO(LGMORU,TYPE,MCU,TYPE,NULAPU,RST,CST)                  !Utilite
*
*     Initialisation du tableau NXCOLI pour la premiere plage 
*     du stockage Bi-morse superieur de chaque colonne  
*
      CALL INCOLI (NBCOLO,NULAPU,IPLAGU,NXCOLI)
*
      NUDRPL=0
      LGCUML=0
      MCDD=MCD
      MCAA=MCA
      LIGNE=1
      KOLDEM=IPLAGM(1,1)
      LGCUMM=IPLAGM(2,1)
      KOLFIM=LGCUMM
      NUDRPM=NULAPM(1)
*
      IF(TYPE(1:1).EQ.'C') THEN
*
*        Premier coeff. diagonal
         CST(MCDD)=0.
         IF(KOLDEM.EQ.1) THEN
            CST(MCDD)=CST(MCAA)
            MCAA=MCAA+1
            KOLDEM=2
         END IF
*
*        Premiere plage de la premiere ligne - Stockage bi-morse superieur
         DO 400 KOLON=KOLDEM,KOLFIM
         IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
            CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
*---------->
            CST(MCU+LGCUAU)=CST(MCAA)
            MCAA=MCAA+1
         END IF
400      CONTINUE
*
*        Premiere ligne, plage 2 a NULAPM(1) - Stockage bi-morse superieur
         DO 403 NUPM=2,NUDRPM
            KOLDEM=IPLAGM(1,NUPM)
            DO 401 KOLON=KOLFIM+1,KOLDEM-1
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
            END IF
401         CONTINUE
            LGCUMA=IPLAGM(2,NUPM)
            KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
            LGCUMM=LGCUMA
            DO 402 KOLON=KOLDEM,KOLFIM
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
*------------->
               CST(MCU+LGCUAU)=CST(MCAA)
               MCAA=MCAA+1
            END IF
402         CONTINUE
403      CONTINUE 
         DO 404 KOLON=KOLFIM+1,NBCOLO
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
            END IF
404      CONTINUE
*
         DO 420 LIGNE=2,NBLIGN
            MCDD=MCDD+1
            IF(LIGNE.LE.NBCOLO) CST(MCDD)=0.
*           1ere et derniere plages de la ligne courante de A
            NUPRPM=NUDRPM+1
            NUDRPM=NULAPM(LIGNE)
*
*           Stockage bi-morse inferieur de la ligne
*           1ere et derniere plages de la ligne courante de L
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE-1)
*
            DO 413 NUPM=NUPRPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
*              Depassement de la diagonale :
               NXNUPM=NUPM
               KOLFIM=LIGNE
               IF(KOLDEM.GT.LIGNE) GO TO 415
*
*              Sinon la plage courante de A est incluse dans une plage de L
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
*
*              Recherche de la plage de L contenant le 1er coeff de
*              la plage courante de A
               CALL DIKLPL(KOLDEM,NUPRPL,NUDRPL,LGCUML,IPLAGL,NUPL,*412)!Morse
               NUPRPL=NUPL
               IF(NUPRPL.GT.1) LGCUML=IPLAGL(2,NUPRPL-1)
               KOLDEL=IPLAGL(1,NUPRPL)
*
*              Report de la partie strict. sous-diag. de la plage courante 
*              de A dans une plage de L
*              Adresse du 1er coeff. de la plage courante de L :
               MCLL=MCL+LGCUML+KOLDEM-KOLDEL
               DO 411 KOLON=KOLDEM,MIN(KOLFIM,LIGNE-1)
*---------------->
                  CST(MCLL)=CST(MCAA)
                  MCLL=MCLL+1
                  MCAA=MCAA+1
411            CONTINUE
*
*              Cas ou la plage courante de A contient un coef. diagonal
412            IF(KOLFIM.GE.LIGNE) THEN
*---------------->Coefficient diagonal
                  CST(MCDD)=CST(MCAA)
                  MCAA=MCAA+1
*                 Coefficients sur-diagonaux de la plage diagonale
                  DO 414 KOLON=LIGNE+1,KOLFIM
                  IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN 
                     CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
*------------------->
                     CST(MCU+LIGNE-LIGDEB+LGCUAU)=CST(MCAA)
                     MCAA=MCAA+1
                  END IF  
414               CONTINUE
                  GO TO 415
               END IF
413         CONTINUE        
*
*           Stockage bi-morse superieur de la ligne
415         LGCUML=IPLAGL(2,NUDRPL)
            DO 418 NUPM=NXNUPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
               DO 416 KOLON=KOLFIM+1,KOLDEM-1
               IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN 
                  CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
               END IF  
416            CONTINUE
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
               DO 417 KOLON=KOLDEM,KOLFIM
               IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
                  CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
*---------------->
                  CST(MCU+LIGNE-LIGDEB+LGCUAU)=CST(MCAA)
                  MCAA=MCAA+1
               END IF  
417            CONTINUE
418         CONTINUE
            DO 419 KOLON=KOLFIM+1,NBCOLO
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
            END IF
419         CONTINUE
*   
420      CONTINUE
*
      ELSE IF(TYPE(1:1).EQ.'R') THEN
*
         RST(MCDD)=0.
         IF(KOLDEM.EQ.1) THEN
            RST(MCDD)=RST(MCAA)
            MCAA=MCAA+1
            KOLDEM=2
         END IF
         DO 200 KOLON=KOLDEM,KOLFIM
         IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
            CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
            RST(MCU+LGCUAU)=RST(MCAA)
            MCAA=MCAA+1
         END IF
200      CONTINUE
         DO 203 NUPM=2,NUDRPM
            KOLDEM=IPLAGM(1,NUPM)
            DO 201 KOLON=KOLFIM+1,KOLDEM-1
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
            END IF
201         CONTINUE
            LGCUMA=IPLAGM(2,NUPM)
            KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
            LGCUMM=LGCUMA
            DO 202 KOLON=KOLDEM,KOLFIM
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
               RST(MCU+LGCUAU)=RST(MCAA)
               MCAA=MCAA+1
            END IF
202         CONTINUE
203      CONTINUE 
         DO 204 KOLON=KOLFIM+1,NBCOLO
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI(1,KOLON)
     *                                                   ,LIGDEB,LGCUAU)
            END IF
204      CONTINUE
         DO 220 LIGNE=2,NBLIGN
            MCDD=MCDD+1
            IF(LIGNE.LE.NBCOLO) RST(MCDD)=0.
            NUPRPM=NUDRPM+1
            NUDRPM=NULAPM(LIGNE)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE-1)
            DO 213 NUPM=NUPRPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
               NXNUPM=NUPM
               KOLFIM=LIGNE
               IF(KOLDEM.GT.LIGNE) GO TO 215
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
               CALL DIKLPL(KOLDEM,NUPRPL,NUDRPL,LGCUML,IPLAGL,NUPL,*212)!Morse
               NUPRPL=NUPL
               IF(NUPRPL.GT.1) LGCUML=IPLAGL(2,NUPRPL-1)
               KOLDEL=IPLAGL(1,NUPRPL)
               MCLL=MCL+LGCUML+KOLDEM-KOLDEL
               DO 211 KOLON=KOLDEM,MIN(KOLFIM,LIGNE-1)
                  RST(MCLL)=RST(MCAA)
                  MCLL=MCLL+1
                  MCAA=MCAA+1
211            CONTINUE
212            IF(KOLFIM.GE.LIGNE) THEN
                  RST(MCDD)=RST(MCAA)
                  MCAA=MCAA+1
                  DO 214 KOLON=LIGNE+1,KOLFIM
                  IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN 
                     CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
                     RST(MCU+LIGNE-LIGDEB+LGCUAU)=RST(MCAA)
                     MCAA=MCAA+1
                  END IF  
214               CONTINUE
                  GO TO 215
               END IF
213         CONTINUE        
215         LGCUML=IPLAGL(2,NUDRPL)
            DO 218 NUPM=NXNUPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
               DO 216 KOLON=KOLFIM+1,KOLDEM-1
               IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN 
                  CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
               END IF  
216            CONTINUE
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
               DO 217 KOLON=KOLDEM,KOLFIM
               IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
                  CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
                  RST(MCU+LIGNE-LIGDEB+LGCUAU)=RST(MCAA)
                  MCAA=MCAA+1
               END IF  
217            CONTINUE
218         CONTINUE
            DO 219 KOLON=KOLFIM+1,NBCOLO
            IF(NXCOLI(1,KOLON).EQ.LIGNE) THEN
               CALL MJCOLI(LIGNE,KOLON,NULAPU,IPLAGU
     *                                   ,NXCOLI(1,KOLON),LIGDEB,LGCUAU)
            END IF
219         CONTINUE
*
220      CONTINUE
      END IF
                                                                    END *MM2Bm*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE I N C O L I (NBCOLO,NULAPU,IPLAGU,NXCOLI)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
*  Initialisation du tableau NXCOLI pour toutes colonnes.
*
*** Arguments ***
* NBCOLO nombre colonnes des matrices
* NULAPU nos de derniere plage de la struct. Bi-Morse superieure
* IPLAGU nos de debut de plage et long. cumulees de la struct. Bi-Morse sup.
* NXCOLI Tableau de travail de dimension 3 x NBCOLO  
* NXCOLI(1,I): numero de colonne du prochain coef. de la colonne I de U
*       (2,I): numero de plage en cours de la colonne I de U
*       (3,I): adresse dans U du dernier coefficient de la plage precedente
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPU(*),IPLAGU(2,*),NXCOLI(3,*)
*
      NUDRPU=0
      LGCUAU = 0
      DO 1 KOLON = 2 , NBCOLO 
         NUPRPU = NUDRPU+1
         NUDRPU = NULAPU(KOLON-1)
         NXCOLI(1,KOLON) = 0
         IF(NUDRPU.GE.NUPRPU) THEN
            NXCOLI(1,KOLON) = IPLAGU(1,NUPRPU)
            NXCOLI(2,KOLON) = NUPRPU
            NXCOLI(3,KOLON) = LGCUAU
         END IF
         LGCUAU = IPLAGU(2,NUDRPU)
1     CONTINUE
                                                                    END *InColi*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M J C O L I (LIGNE,KOLON,NULAPU,IPLAGU,NXCOLI
     *                                                   ,LIGDEB,LGCUAU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
*  Mise a jour du tableau NXCOLI pour une colonne de la ligne en cours
*
*** Arguments d'entree ***
* LIGNE ligne en cours
* KOLON colonne de mise a jour
* IPLAGU nos de debut de plage et long. cumulees de la struct. Bi-Morse sup.
* NXCOLI Tableau de travail de dimension 3 x NBCOLO  
* NXCOLI(1): numero de colonne du prochain coef. de la colonne en cours de U
*       (2): numero de plage de la colonne en cours de U
*       (3): adresse dans U du dernier coefficient de la plage precedente
*** Arguments de sortie ***
* LIGDEB numero de ligne de debut de la plage en cours
* LGCUAU adresse du dernier coeff. de la plage precedente
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPU(*),IPLAGU(2,*),NXCOLI(*)
*
      NUMPLU = NXCOLI(2)
      LIGDEB = IPLAGU(1,NUMPLU)
      LGCUMU = IPLAGU(2,NUMPLU)
      LGCUAU = NXCOLI(3)
      LIGFIN = LIGDEB+LGCUMU-LGCUAU-1
      NXCOLI(1) = 0  
      IF(LIGNE.LT.LIGFIN) THEN  
         NXCOLI(1) = LIGNE+1 
      ELSE 
         NXCOLI(3) = LGCUMU
         NUMPLU = NUMPLU+1
         IF(NUMPLU.LE.NULAPU(KOLON-1)) THEN
            NXCOLI(2) = NUMPLU  
            NXCOLI(1) = IPLAGU(1,NUMPLU)
         END IF
      END IF
                                                                    END *MjColi*
