*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE M M 2 L B M (NBLIGN,NBCOLO,NULAPM,IPLAGM,TYPE,MCA
     *                                   ,NULAPL,IPLAGL,MCD,MCL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)  
* Derniere modification (D.Martin) le 20 Nov. 1991 
*
*  Passage d'une matrice Morse ligne standard a une matrice Bi-Morse inferieure
*          (MM2LBM --> Matrice Morse 'to' matrice 'Lower' BiMorse)
*
*     On suppose que la structure BiMorse inferieure recouvre la structure
*  Morse de la partie triangulaire inferieure, tout en respectant le profil
*  inferieur, c'est-a-dire en particulier que le numero de colonne de
*  debut de la premiere plage de chaque ligne est le meme dans les deux
*  structures. 
*     Ces hypotheses sont respectees si par exemple plusieurs plages
*  de la structure Morse ont ete concatenees en une plage de la structure
*  BiMorse inferieure/superieure.
*
*** Arguments ***
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
* NULAPM numeros des dernieres plages de chaque ligne de la struct. Morse
* IPLAGM numeros de debut de plage et longueurs cumulees de la struct. Morse
* MCA    adresse de la matrice initiale dans le s-t du bon type
* NULAPL numeros des dernieres plages de chaque ligne de la struct. Bi-Morse
* IPLAGL numeros de debut de plage et longueurs cumulees de la struct. Bi-Morse
* MCD    adresse de la diagonale de matrice Bi-Morse dans le s-t du bon type
* MCL    adresse de la partie triang. de mat. Bi-Morse dans le s-t du bon type
* RST    tableau contenant les matrices (cas reel)
* CST    tableau contenant les matrices (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NULAPM(*),IPLAGM(2,*),NULAPL(*),IPLAGL(2,*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      LGMORL=IPLAGL(2,NULAPL(NBLIGN-1))
      CALL TAZERO(LGMORL,TYPE,MCL,TYPE,NULAPL,RST,CST)                  !Utilite
*
      NUDRPL=0
      LGCUML=0
      MCDD=MCD
      MCAA=MCA
      NUDRPM=NULAPM(1)
      LGCUMM=IPLAGM(2,NUDRPM)

*
      IF(TYPE(1:1).EQ.'C') THEN
*        Premier coeff. diagonal
         CST(MCDD)=0.
         IF(IPLAGM(1,1).EQ.1) CST(MCD)=CST(MCAA)
*
         DO 420 LIGNE=2,NBLIGN
            MCDD=MCDD+1
            IF(LIGNE.LE.NBCOLO) CST(MCDD)=0.
*           1ere et derniere plages de la ligne courante de A
            NUPRPM=NUDRPM+1
            NUDRPM=NULAPM(LIGNE)
*
*           Stockage bi-morse inferieur de la ligne
*           1ere et derniere plages de la ligne courante de L
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE-1)
*           Adresse du 1er coeff. de la ligne courante de A
            MCAA=MCA+LGCUMM
            DO 413 NUPM=NUPRPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
*              Depassement de la diagonale :
               IF(KOLDEM.GT.LIGNE) GO TO 415
*
*              Sinon la plage courante de A est incluse dans une plage de L
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
*
*              Recherche de la plage de L contenant le 1er coeff de
*              la plage courante de A
               CALL DIKLPL(KOLDEM,NUPRPL,NUDRPL,LGCUML,IPLAGL,NUPL,*412)!Morse
               NUPRPL=NUPL
               IF(NUPRPL.GT.1) LGCUML=IPLAGL(2,NUPRPL-1)
               KOLDEL=IPLAGL(1,NUPRPL)
*
*              Report de la partie strict. sous-diag. de la plage courante 
*              de A dans une plage de L
*              Adresse du 1er coeff. de la plage courante de L :
               MCLL=MCL+LGCUML+KOLDEM-KOLDEL
               DO 411 KOLON=KOLDEM,MIN(KOLFIM,LIGNE-1)
*---------------->
                  CST(MCLL)=CST(MCAA)
                  MCLL=MCLL+1
                  MCAA=MCAA+1
411            CONTINUE
*
*              Cas ou la plage courante de A contient un coef. diagonal
412            IF(KOLFIM.GE.LIGNE) CST(MCDD)=CST(MCAA)
413         CONTINUE
*        
415         LGCUML=IPLAGL(2,NUDRPL)
            LGCUMM=IPLAGM(2,NUDRPM)
420      CONTINUE
*
      ELSE IF(TYPE(1:1).EQ.'R') THEN
         RST(MCDD)=0.
         IF(IPLAGM(1,1).EQ.1) RST(MCD)=RST(MCAA)
         DO 220 LIGNE=2,NBLIGN
            MCDD=MCDD+1
            IF(LIGNE.LE.NBCOLO) RST(MCDD)=0.
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE-1)
            NUPRPM=NUDRPM+1
            NUDRPM=NULAPM(LIGNE)
            MCAA=MCA+LGCUMM
            DO 213 NUPM=NUPRPM,NUDRPM
               KOLDEM=IPLAGM(1,NUPM)
               IF(KOLDEM.GT.LIGNE) GO TO 215
               LGCUMA=IPLAGM(2,NUPM)
               KOLFIM=KOLDEM+LGCUMA-LGCUMM-1
               LGCUMM=LGCUMA
               CALL DIKLPL(KOLDEM,NUPRPL,NUDRPL,LGCUML,IPLAGL,NUPL,*212)!Morse
               NUPRPL=NUPL
               IF(NUPRPL.GT.1) LGCUML=IPLAGL(2,NUPRPL-1)
               KOLDEL=IPLAGL(1,NUPRPL)
               MCLL=MCL+LGCUML+KOLDEM-KOLDEL
               DO 211 KOLON=KOLDEM,MIN(KOLFIM,LIGNE-1)
                  RST(MCLL)=RST(MCAA)
                  MCLL=MCLL+1
                  MCAA=MCAA+1
211            CONTINUE
212            IF(KOLFIM.GE.LIGNE) RST(MCDD)=RST(MCAA)
213         CONTINUE       
215         LGCUML=IPLAGL(2,NUDRPL)
            LGCUMM=IPLAGM(2,NUDRPM)
220      CONTINUE
      END IF
                                                                    END *MM2LBm*
