*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MM2LPR (NBLINE,NBCOLO,NULAPL,IPLAGE,TYPA,MCA
     &                  ,LENV,MCD,MCL,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991)
* Derniere modification (D.Martin) le 27 Juin 1995  
*  
* Transformation d'une matrice stockee 'Morse ligne' 
* en la meme matrice stockee 'Profil inferieur' 
* (MM2LPr --> Matrice Morse 'to' Lower PRofil)
*  
*** Arguments de la Liste d'Entree *** 
* NBLINE: Nombre de lignes de la matrice
* NBCOLO: Nombre de colonnes de la matrice
* NULAPL: Numeros de derniere plage sur chaque ligne
* IPLAGE: Tableau des numeros de debut de plage et des longueurs cumulees 
* TYPA  : Type REEL ou COMPLEXE de la matrice
* MCA   : Adresse de la matrice morse dans le s-t RST ou CST du bon type
* LENV  : Tableau contenant l'enveloppe inferieure stricte avec
*         LENV(I-1) adresse dans la partie triangulaire inferieure compactee
*         du 1er coeff. non nul de la ligne I, et LENV(I)=LENV(I-1) si le 1er 
*         coeff. de la ligne I+1 est le coeff. diagonal, et LENV(NBLINE)-1 
*         est la taille de la partie triangulaire inferieure stricte compactee.
* MCD   : Adresse de la diagonale de la matrice profil dans RST ou CST
* MCL   : Adresse de l'enveloppe inferieure de la matrice profil dans RST ou CST
* RST   : Super-tableau version REELLE
* CST   : Super-tableau version COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPA
      INTEGER       NBLIGN,NBCOLO,NULAPL(*),IPLAGE(2,*),MCA
     &             ,LENV(*),MCD,MCL
      REAL          RST(*)
      COMPLEX       CST(*)
*-----------------------------------------------------------------------
      NUDRPL=NULAPL(1)
      LGCUMU=IPLAGE(2,NUDRPL)
      IF (TYPA(1:1).EQ.'R') THEN
*    
*        Cas d'une matrice a coefficients reels
*        ======================================
         DO 20 MCLL=MCL,MCL-2+LENV(NBLINE)
20          RST(MCLL)=0.
*
*       'Decompactage' de la 1ere ligne 
*
         IF (IPLAGE(1,1).EQ.1) THEN 
            RST(MCD)=RST(MCA)
         ELSE
            RST(MCD)=0.
         ENDIF
         MCD1=MCD+1
*
*       'Decompactage' des lignes 2 a NBLINE
*
         LIGNM1=1
         DO 25 LIGNE=2,NBLINE
            IF (LIGNE.LE.NBCOLO) THEN
               RST(MCD1)=0.
               MCD1=MCD1+1
            ENDIF
            MCL1=MCL-1+LENV(LIGNM1)
            MCAA=MCA+LGCUMU
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            KOLON1=IPLAGE(1,NUPRPL)
*
            DO 21 NUPLA=NUPRPL,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               IF (KOLDEB.GT.LIGNE) GOTO 24
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCLL=MCL1+KOLDEB-KOLON1
               IF (KOLFIN.GE.LIGNE) GOTO 22
*
*              Plages strictement sous-diagonales
               DO 21 KOLON=KOLDEB,KOLFIN
                  RST(MCLL)=RST(MCAA)
                  MCAA=MCAA+1
21                MCLL=MCLL+1
            GOTO 25
*
*           Plage contenant le coeff. diagonal
*           1 - coefficients sous-diagonaux
22          DO 23 KOLON=KOLDEB,LIGNM1
               RST(MCLL)=RST(MCAA)
               MCAA=MCAA+1
23             MCLL=MCLL+1
*           2 - coefficient diagonal
            RST(MCD1-1)=RST(MCAA)
            MCAA=MCAA+1
*
24          LGCUMU=IPLAGE(2,NUDRPL)
25          LIGNM1=LIGNE
      ELSE
*    
*        Cas d'une matrice a coefficients reels
*        ======================================
         DO 40 MCLL=MCL,MCL-2+LENV(NBLINE)
40          CST(MCLL)=0.
         IF (IPLAGE(1,1).EQ.1) THEN 
            CST(MCD)=CST(MCA)
         ELSE
            CST(MCD)=0.
         ENDIF
         MCD1=MCD+1
         LIGNM1=1
         DO 45 LIGNE=2,NBLINE
            IF (LIGNE.LE.NBCOLO) THEN
               CST(MCD1)=0.
               MCD1=MCD1+1
            ENDIF
            MCL1=MCL-1+LENV(LIGNM1)
            MCAA=MCA+LGCUMU
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            KOLON1=IPLAGE(1,NUPRPL)
*
            DO 41 NUPLA=NUPRPL,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               IF (KOLDEB.GT.LIGNE) GOTO 44
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCLL=MCL1+KOLDEB-KOLON1
               IF (KOLFIN.GE.LIGNE) GOTO 42
*
               DO 41 KOLON=KOLDEB,KOLFIN
                  CST(MCLL)=CST(MCAA)
                  MCAA=MCAA+1
41                MCLL=MCLL+1
            GOTO 45
*
42          DO 43 KOLON=KOLDEB,LIGNM1
               CST(MCLL)=CST(MCAA)
               MCAA=MCAA+1
43             MCLL=MCLL+1
            CST(MCD1-1)=CST(MCAA)
            MCAA=MCAA+1
*
44          LGCUMU=IPLAGE(2,NUDRPL)
45          LIGNM1=LIGNE
      ENDIF
                                                                    END !MM2LPr


