*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M M 2 M O C (MCMATM,ITMATR,NBCOLO,NBLIGN
     *                             ,MCMATC,NULAPC,IPLAGC,NXCOCO,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Sept. 89) 
* Derniere modification (D.Martin) le 24 Oct. 91
*  
*     Transformation d'une matrice stockee compactee morse par ligne en une
*     matrice compactee morse par colonne (pour multiplication a gauche)
*     connaissant le compactage en colonne 
*                 MM2MOC -> Matrice Morse ligne 'to' MOrse Colonne 
*  
*** Arguments ***  
* MCMATM Adresse de la matrice compactee morse en ligne
* ITMATR Indice de type de declaration des matrices
* NBCOLO nombre de noeuds en 'colonne' de la matrice  
* NBLIGN nombre de noeuds en 'ligne' de la matrice
* MCMATC Adresse de la matrice compactee morse en colonne 
* NULAPC tableau des numeros de derniere plage de chaque colonne 
* IPLAGC numeros de lignes de debut de plage et longueurs cumulees en colonne
* NXCOCO Tableau de travail de dimension 3 x NBCOLO  
* NXCOCO(1,I): numero de colonne du prochain coeff non nul de la colonne I
*       (2,I): numero de plage en cours de la colonne I  
*       (3,I): longueur cumulee des plages precedant la plage en cours.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPC(*),IPLAGC(2,*),NXCOCO(3,*)
      REAL    RST(*)
      COMPLEX CST(*)
*  
      LGCUPC=0 
      NUDRPC=0 
*
*     Initialisation du tableau NXCOCO pour la premiere plage 
*     du stockage Morse-Colonne de chaque colonne  
*
      DO 10 KOLON=1,NBCOLO 
         NUPRPC=NUDRPC+1
         NUDRPC=NULAPC(KOLON) 
         NXCOCO(1,KOLON)=IPLAGC(1,NUPRPC)
         NXCOCO(2,KOLON)=NUPRPC
         NXCOCO(3,KOLON)=LGCUPC
         LGCUPC=IPLAGC(2,NUPRPC)
10    CONTINUE 
*
      MCAM=MCMATM
*
      IF(ITMATR.EQ.INTTYP('REEL')) THEN
*
         DO 29 LIGNE=1,NBLIGN
            DO 27 KOLON=1,NBCOLO 
               IF(LIGNE.EQ.NXCOCO(1,KOLON)) THEN 
                  NUMPLC=NXCOCO(2,KOLON)
                  LIGDEB=IPLAGC(1,NUMPLC)
                  LGCUAC=NXCOCO(3,KOLON)
                  LGCUPC=LIGNE-LIGDEB+LGCUAC
*---------------->
                  RST(MCMATC-1+LGCUPC)=RST(MCAM)
                  MCAM=MCAM+1  
                  LIGFIN=LIGDEB-1+IPLAGC(2,NUMPLC)-LGCUAC
*
                  IF(LIGNE.LT.LIGFIN) THEN  
                     NXCOCO(1,KOLON)=LIGNE+1 
                  ELSE 
                     NXCOCO(3,KOLON)=IPLAGC(2,NUMPLC)
                     NUMPL1=NUMPLC+1
                     NXCOCO(1,KOLON)=0  
                     IF(NUMPL1.LE.NULAPC(KOLON)) THEN
                        NXCOCO(2,KOLON)=NUMPL1  
                        NXCOCO(1,KOLON)=IPLAGC(1,NUMPL1)
                     END IF
                  END IF
*
               END IF
27        CONTINUE  
29        CONTINUE  
*
      ELSE 
*
         DO 49 LIGNE=1,NBLIGN
            DO 47 KOLON=1,NBCOLO 
               IF(LIGNE.EQ.NXCOCO(1,KOLON)) THEN 
                  NUMPLC=NXCOCO(2,KOLON)
                  LIGDEB=IPLAGC(1,NUMPLC)
                  LGCUAC=NXCOCO(3,KOLON)
                  LGCUPC=LIGNE-LIGDEB+LGCUAC
*---------------->
                  CST(MCMATC-1+LGCUPC)=CST(MCAM)
                  MCAM=MCAM+1  
                  LIGFIN=LIGDEB-1+IPLAGC(2,NUMPLC)-LGCUAC
                  IF(LIGNE.LT.LIGFIN) THEN  
                     NXCOCO(1,KOLON)=LIGNE+1 
                  ELSE 
                     NXCOCO(3,KOLON)=IPLAGC(2,NUMPLC)
                     NUMPL1=NUMPLC+1
                     NXCOCO(1,KOLON)=0  
                     IF(NUMPL1.LE.NULAPC(KOLON)) THEN
                        NXCOCO(2,KOLON)=NUMPL1  
                        NXCOCO(1,KOLON)=IPLAGC(1,NUMPL1)
                     END IF
                  END IF
               END IF
47          CONTINUE  
49       CONTINUE  
      END IF
                                                                    END *MM2Moc*
