*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M M 2 P R (NBLINE,NBCOLO,NULAPL,IPLAGE,TYPA,MCA
     *                                   ,LENV,UENV,MCD,MCL,MCU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)
* Derniere modification (D.Martin) le 17 Oct. 91  
*  
*             Transformation d'une matrice stockee 'Morse ligne' 
*                   en la meme matrice stockee 'Profil' 
*                  (MM2Pr --> Matrice Morse 'to' PRofil)
*  
*** Arguments de la Liste d'Entree *** 
* NBLINE: Nombre de lignes de la matrice
* NBCOLO: Nombre de colonnes de la matrice
* NULAPL: Numeros de derniere plage sur chaque ligne
* IPLAGE: Tableau des numeros de debut de plage et des longueurs cumulees 
* TYPA  : Type REEL ou COMPLEXE de la matrice
* MCA   : Adresse de la matrice morse dans le s-t RST ou CST du bon type
* LENV  : Tableau contenant l'enveloppe inferieure stricte avec
*         LENV(I-1) adresse dans la partie triangulaire inferieure compactee
*         du 1er coeff. non nul de la ligne I, et LENV(I)=LENV(I-1) si le 1er 
*         coeff. de la ligne I+1 est le coeff. diagonal, et LENV(NBLINE)-1 
*         est la taille de la partie triangulaire inferieure stricte compactee.
* UENV  : Tableau contenant l'enveloppe inferieure stricte avec
*         UENV(I-1) adresse dans la partie triangulaire superieure compactee
*         du 1er coeff. non nul de la colonne I, et UENV(I)=UENV(I-1) si le 1er 
*         coeff. de la colonne I+1 est le coeff. diagonal, et UENV(NBLINE)-1 
*         est la taille de la partie triangulaire superieure stricte compactee.
* MCD   : Adresse de la diagonale de la matrice profil dans RST ou CST
* MCL   : Adresse de l'enveloppe inferieure de la matrice profil dans RST ou CST
* MCU   : Adresse de l'enveloppe superieure de la matrice profil dans RST ou CST
* RST   : Super-tableau version REELLE
* CST   : Super-tableau version COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPA
      INTEGER       NULAPL(*),IPLAGE(2,*),LENV(*),UENV(*)
      REAL          RST(*)
      COMPLEX       CST(*)
*
      MCU1=MCU-1
      NUDRPL=NULAPL(1)
      LGCUMU=IPLAGE(2,1)
      IF(TYPA(1:1).EQ.'R') THEN
*    
*        Cas d'une matrice a coefficients reels
*        ======================================
         DO 20 MCLL=MCL,MCL-2+LENV(NBLINE)
20          RST(MCLL)=0.
         DO 21 MCUU=MCU,MCU-2+UENV(NBCOLO)
21          RST(MCUU)=0.
*
*       'Decompactage' de la 1ere ligne 
*
         NEXT=IPLAGE(1,1)
         IF(NEXT.EQ.1) THEN 
            RST(MCD)=RST(MCA)
            MCAA=MCA+1
            NEXT=2
         ELSE
            RST(MCD)=0.
            MCAA=MCA
         END IF
         MCD1=MCD+1
*
*        Enveloppe superieure de la ligne 1
*
         DO 22 KOLON=NEXT,LGCUMU+IPLAGE(1,1)-1
            RST(MCU1+UENV(KOLON-1))=RST(MCAA)
22          MCAA=MCAA+1
         DO 23 NUPLA=2,NUDRPL
            KOLDEB=IPLAGE(1,NUPLA)
            LGCUAV=LGCUMU+1
            LGCUMU=IPLAGE(2,NUPLA)
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 23 KOLON=KOLDEB,KOLFIN
               RST(MCU1+UENV(KOLON-1))=RST(MCAA)
23             MCAA=MCAA+1
*
*       'Decompactage' des lignes 2 a NBLINE
*
         LIGNM1=1
         DO 35 LIGNE=2,NBLINE
            IF(LIGNE.LE.NBCOLO) THEN
               RST(MCD1)=0.
               MCD1=MCD1+1
            END IF
            MCL1=MCL-1+LENV(LIGNM1)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            KOLON1=IPLAGE(1,NUPRPL)
*
            DO 25 NUPLA=NUPRPL,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               NUDGPL=NUPLA-1
*
               IF(KOLDEB.GT.LIGNE) GO TO 29
*
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCLL=MCL1+KOLDEB-KOLON1
*
               IF(KOLFIN.GE.LIGNE) GO TO 26
*
*              Plages strictement sous-diagonales - Enveloppe inferieure
               DO 25 KOLON=KOLDEB,KOLFIN
                  RST(MCLL)=RST(MCAA)
                  MCAA=MCAA+1
25                MCLL=MCLL+1
               GO TO 35
*
*           Plage contenant le coeff. diagonal
*           1 - enveloppe inferieure
26          DO 27 KOLON=KOLDEB,LIGNM1
               RST(MCLL)=RST(MCAA)
               MCAA=MCAA+1
27             MCLL=MCLL+1
*           2 - coeficient diagonal
            RST(MCD1-1)=RST(MCAA)
            MCAA=MCAA+1
*           3 - enveloppe superieure ( l'adresse relative du coeff.
*               surdiagonal de la ligne # LIGNE est UENV(LIGNE)-1 )
            MCU1=MCU-2
            MCUU=MCU1
            DO 28 KOLON=LIGNE+1,KOLFIN
               RST(MCUU+UENV(KOLON))=RST(MCAA)
               MCUU=MCUU-1
28             MCAA=MCAA+1
*
*           Plages sur-diagonales - Enveloppe superieure
29          MCU1=MCU+LIGNM1
            DO 30 NUPLA=NUDGPL+1,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCUU=MCU1-KOLDEB
               DO 30 KOLON=KOLDEB,KOLFIN
                 RST(MCUU+UENV(KOLON))=RST(MCAA)
                 MCUU=MCUU-1
30               MCAA=MCAA+1
            LGCUMU=IPLAGE(2,NUDRPL)
35       LIGNM1=LIGNE
      ELSE
*    
*        Cas d'une matrice a coefficients reels
*        ======================================
         DO 40 MCLL=MCL,MCL-2+LENV(NBLINE)
40          CST(MCLL)=0.
         DO 41 MCUU=MCU,MCU-2+UENV(NBCOLO)
41          CST(MCUU)=0.
*
*       'Decompactage' de la 1ere ligne 
*
         NEXT=IPLAGE(1,1)
         IF(NEXT.EQ.1) THEN 
            CST(MCD)=CST(MCA)
            MCAA=MCA+1
            NEXT=2
         ELSE
            CST(MCD)=0.
            MCAA=MCA
         END IF
         MCD1=MCD+1
*
*        Enveloppe superieure de la ligne 1
*
         DO 42 KOLON=NEXT,LGCUMU+IPLAGE(1,1)-1
            CST(MCU1+UENV(KOLON-1))=CST(MCAA)
42          MCAA=MCAA+1
         DO 43 NUPLA=2,NUDRPL
            KOLDEB=IPLAGE(1,NUPLA)
            LGCUAV=LGCUMU+1
            LGCUMU=IPLAGE(2,NUPLA)
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 43 KOLON=KOLDEB,KOLFIN
               CST(MCU1+UENV(KOLON-1))=CST(MCAA)
43             MCAA=MCAA+1
*
*       'Decompactage' des lignes 2 a NBLINE
*
         LIGNM1=1
         DO 55 LIGNE=2,NBLINE
            IF(LIGNE.LE.NBCOLO) THEN
               CST(MCD1)=0.
               MCD1=MCD1+1
            END IF
            MCL1=MCL-1+LENV(LIGNM1)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            KOLON1=IPLAGE(1,NUPRPL)
*
            DO 45 NUPLA=NUPRPL,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               NUDGPL=NUPLA-1
*
               IF(KOLDEB.GT.LIGNE) GO TO 49
*
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCLL=MCL1+KOLDEB-KOLON1
*
               IF(KOLFIN.GE.LIGNE) GO TO 46
*
*              Plages strictement sous-diagonales - Enveloppe inferieure
               DO 45 KOLON=KOLDEB,KOLFIN
                  CST(MCLL)=CST(MCAA)
                  MCAA=MCAA+1
45                MCLL=MCLL+1
               GO TO 55
*
*           Plage contenant le coeff. diagonal
*           1 - enveloppe inferieure
46          DO 47 KOLON=KOLDEB,LIGNM1
               CST(MCLL)=CST(MCAA)
               MCAA=MCAA+1
47             MCLL=MCLL+1
*           2 - coeficient diagonal
            CST(MCD1-1)=CST(MCAA)
            MCAA=MCAA+1
*           3 - enveloppe superieure ( l'adresse relative du coeff.
*               surdiagonal de la ligne # LIGNE est UENV(LIGNE)-1 )
            MCU1=MCU-2
            MCUU=MCU1
            DO 48 KOLON=LIGNE+1,KOLFIN
               CST(MCUU+UENV(KOLON))=CST(MCAA)
               MCUU=MCUU-1
48             MCAA=MCAA+1
*
*           Plages sur-diagonales - Enveloppe superieure
49          MCU1=MCU+LIGNM1
            DO 50 NUPLA=NUDGPL+1,NUDRPL
               KOLDEB=IPLAGE(1,NUPLA)
               LGCUAV=LGCUMU+1
               LGCUMU=IPLAGE(2,NUPLA)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               MCUU=MCU1-KOLDEB
               DO 50 KOLON=KOLDEB,KOLFIN
                 CST(MCUU+UENV(KOLON))=CST(MCAA)
                 MCUU=MCUU-1
50               MCAA=MCAA+1
            LGCUMU=IPLAGE(2,NUDRPL)
55       LIGNM1=LIGNE
      END IF
                                                                    END *MM2Pr*


