*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M O 2 M O C (MCMATM,ITMATR,NBCOLO,NBLIGN,NULAPM,IPLAGM
     *                    ,MCMATC,NULAPC,IPLAGC,NBPLAC,NXCOLI,RST,CST,*)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Sept. 89) 
* Derniere modification (D.Martin) le 17 Oct. 91
*  
*     Transformation d'une matrice stockee compactee morse par ligne en une
*     matrice compactee morse par colonne (pour multiplication a gauche)
*     avec creation des tableaux de compactage 'Morse colonne' 
*                 MO2MOC -> MOrse ligne 'to' MOrse Colonne 
*  
*** Arguments ***  
* MCMATM: Adresse de la matrice compactee morse en ligne
* ITMATR: Son indice de type de declaration
* NBCOLO: nombre de noeuds en 'colonne' de la matrice  
* NBLIGN: nombre de noeuds en 'ligne' de la matrice
* NULAPM: tableau des numeros de derniere plage de cahque ligne
* IPLAGM: tableau de numeros de colonnes et des longueurs cumulees en ligne
* MCMATC: Adresse de la matrice compactee morse en colonne 
* NULAPC: analogue a NULAPM mais pour le compactage en colonne 
* IPLAGC: analogue a IPLAGM mais pour le compactage morse en colonne
* NBPLAC: nombre maximum de plages en morse colonne en entree  
*                effectif      -        -      -    en sortie  
* NXCOLI(3,*): Tableau de travail de dimension 3 x NBLIGN  
*     NXCOLI(1,I): numero de colonne du prochain coeff non nul de la ligne # I 
*     NXCOLI(2,I): numero de plage en cours de la ligne # I
*     NXCOLI(3,I): longueur cumulee des plages precedant la plage .
*  (*)  : retour etiquete en cas de depassement du nombre max. de plages
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NULAPM(*),IPLAGM(2,*),NULAPC(*),IPLAGC(2,*),NXCOLI(3,*)  
      REAL    RST(*)
      COMPLEX CST(*)
*  
      NBPLAX=NBPLAC
      LGCUPM=0 
      NUMPLM=1  
*  
*    Initialisation du tableau NXCOLI pour la premiere plage de chaque ligne  
      DO 10 LIGNE=1,NBLIGN 
         NXCOLI(1,LIGNE)=IPLAGM(1,NUMPLM)
         NXCOLI(2,LIGNE)=NUMPLM 
         NXCOLI(3,LIGNE)=LGCUPM
         NUMPLM=NULAPM(LIGNE)
         LGCUPM=IPLAGM(2,NUMPLM)
         NUMPLM=NUMPLM+1
10    CONTINUE
*  
*    Initialisation du nombre de plages, de la longueur cumulee des plages 
*    de la longueur de la plage en cours : 
      NBPLAC=0 
      LGCUPC=0 
      LGPLAC=0  
      IF(ITMATR.EQ.INTTYP('REEL')) THEN
         DO 22 KOLON=1,NBCOLO
            DO 21 LIGNE=1,NBLIGN
               NXCOL=NXCOLI(1,LIGNE)
               IF(KOLON.EQ.NXCOL) THEN    
                  NUMPLM=NXCOLI(2,LIGNE)
                  KOLON1=IPLAGM(1,NUMPLM)
                  LGCUPM=IPLAGM(2,NUMPLM)
                  IACUPM=NXCOLI(3,LIGNE)-KOLON1
                  KOLON2=LGCUPM-1-IACUPM
*---------------->
                  RST(MCMATC+LGCUPC)=RST(MCMATM+IACUPM+KOLON)
                  LGCUPC=LGCUPC+1  
*                 Mise a jour de NXCOLI
                  IF(KOLON.LT.KOLON2) THEN 
                     NXCOLI(1,LIGNE)=KOLON+1
                  ELSE 
                     NXCOLI(3,LIGNE)=LGCUPM
                     NUMPL1=NUMPLM+1
                     NXCOLI(1,LIGNE)=0 
                     IF(NUMPL1.LE.NULAPM(LIGNE)) THEN  
                        NXCOLI(2,LIGNE)=NUMPL1 
                        NXCOLI(1,LIGNE)=IPLAGM(1,NUMPL1)
                     END IF
                  END IF
                  IF(LGPLAC.EQ.0) THEN 
*                    Debut d'une plage : numero de ligne de debut de plage 
                     NBPLAC=NBPLAC+1
                     IF(NBPLAC.GT.NBPLAX) RETURN 1 
                     IPLAGC(1,NBPLAC)=LIGNE
                  END IF
                  LGPLAC=LGPLAC+1
               ELSE IF((KOLON.LT.NXCOL.OR.NXCOL.EQ.0).AND.LGPLAC.GT.0)
     *                                                              THEN 
*                 Fin d'une plage en colonne : adrs. de son dernier coeff.
                  IPLAGC(2,NBPLAC)=LGCUPC  
                  LGPLAC=0
               END IF  
21          CONTINUE
*           Fin de la derniere plage sur la colonne : adrs. de son dernier coeff.
            NULAPC(KOLON)=NBPLAC
            IF(LGPLAC.GT.0) IPLAGC(2,NBPLAC)=LGCUPC
            LGPLAC=0
22       CONTINUE
      ELSE 
         DO 44 KOLON=1,NBCOLO
            DO 43 LIGNE=1,NBLIGN
               NXCOL=NXCOLI(1,LIGNE)
               IF(KOLON.EQ.NXCOL) THEN    
                  NUMPLM=NXCOLI(2,LIGNE)
                  KOLON1=IPLAGM(1,NUMPLM)
                  LGCUPM=IPLAGM(2,NUMPLM)
                  IACUPM=NXCOLI(3,LIGNE)-KOLON1
                  KOLON2=LGCUPM-1-IACUPM
                  CST(MCMATC+LGCUPC)=CST(MCMATM+IACUPM+KOLON)
                  LGCUPC=LGCUPC+1  
*                 Mise a jour de NXCOLI
                  IF(KOLON.LT.KOLON2) THEN 
                     NXCOLI(1,LIGNE)=KOLON+1
                  ELSE 
                     NXCOLI(3,LIGNE)=LGCUPM
                     NUMPL1=NUMPLM+1
                     NXCOLI(1,LIGNE)=0 
                     IF(NUMPL1.LE.NULAPM(LIGNE)) THEN  
                        NXCOLI(2,LIGNE)=NUMPL1 
                        NXCOLI(1,LIGNE)=IPLAGM(1,NUMPL1)
                     END IF
                  END IF
                  IF(LGPLAC.EQ.0) THEN 
*                    Debut d'une plage : numero de ligne de debut de plage 
                     NBPLAC=NBPLAC+1
                     IF(NBPLAC.GT.NBPLAX) RETURN 1 
                     IPLAGC(1,NBPLAC)=LIGNE
                  END IF
                  LGPLAC=LGPLAC+1
               ELSE IF((KOLON.LT.NXCOL.OR.NXCOL.EQ.0).AND.LGPLAC.GT.0)
     *                                                              THEN 
*                 Fin d'une plage en colonne : longueur cumulee
                  IPLAGC(2,NBPLAC)=LGCUPC  
                  LGPLAC=0
               END IF  
43          CONTINUE
            NULAPC(KOLON)=NBPLAC
            IF(LGPLAC.GT.0) IPLAGC(2,NBPLAC)=LGCUPC
            LGPLAC=0
44       CONTINUE
      END IF
                                                                    END *Mo2Moc*
