*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M O 2 P L (ICMPLX,NBNELI,NBDLLI,NBDLCO,NULAPL,IPLAGE  
     *                                     ,IDLHRL,NULINE,MATMOL,MATPLE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 89)  
* Derniere modification (D.Martin) le 26 Juin 91
*  
*     Transformation d'une matrice stockee compactee morse (par ligne) en une  
*     matrice pleine (i.e. dans son stockage 'naturel' : decompactage) 
*            MO2PL -> MOrse ligne 'to' PLein
*  
*** Arguments ***  
* ICMPLX: type reel (=1) ou complexe (=2) de la matrice
* NBNELI: Nombre de noeuds 'en ligne' de la matrice
* NBDLLI: Nombre de lignes de la matrice (i.e. compte en D.L.) 
* NBDLCO: Nombre de colonnes        -         -      -       - 
* NULAPL: tableau des numeros de derniere des lignes
* IPLAGE: tableau des numeros de debut de plage et des longueurs cumulees  
* IDLHRL: indicateur de numerotation comptee en D.L. d'Hermite en ligne
* NULINE: tableau des pointeurs des numeros de ligne des noeuds
* MATMOL: La matrice stockee sous forme 'Morse ligne'  
* MATPLE : matrice decompactee (tableau NBDLLI lignes x NBDLCO colonnes)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NULAPL(*),IPLAGE(*),NULINE(*)  
      REAL          MATMOL(ICMPLX,*),MATPLE(ICMPLX,NBDLLI,*)
*  
      NCOMP=0  
      NULIG=0  
      NUMPL1=1 
      LGPL=0
      IAD=1
*  
*     Parcours des noeuds 'en ligne' de la matrice 
      DO 10 INEL=1,NBNELI  
         NUMPL2=NULAPL(INEL)
*        Nombre de d.l. du noeud : 
         NBDLI=1
         IF(IDLHRL.GE.1) THEN  
            NBDLI=NBDLLI+1 
            IF(INEL.LT.NBNELI) NBDLI=NULINE(INEL+1)
            NBDLI=NBDLI-NULINE(INEL)
         END IF
*  
*        Nombre de coefficients sur la ligne compactee du noeud
         LGLIGN=IPLAGE(2*NUMPL2)-LGPL  
         NLAS=0
         NULIG1=NULIG  
*  
*        Parcours des plages de la ligne du noeud INEL 
         DO 4 NUMPLA=NUMPL1,NUMPL2 
*           Numero de colonne de debut de la plage NUMPLA  
            NDEB=IPLAGE(IAD)
            IAD=IAD+1  
*  
*           Mise a 0 des colonnes de la matrice decompactee precedant la plage 
            NULIG=NULIG1
            DO 1 IDLNE=1,NBDLI 
               NULIG=NULIG+1
               DO 1 NUCOL=NLAS+1,NDEB-1
                  DO 1 ICMP=1,ICMPLX
1                 MATPLE(ICMP,NULIG,NUCOL)=0.  
*  
*           Longueur de la plage
            NLAS=IPLAGE(IAD)-LGPL  
            IAD=IAD+1  
            LGPL=LGPL+NLAS 
*           Numero de colonne de fin de plage  
            NLAS=NDEB+NLAS-1
*  
*           Transfert des coefficients de la plage dans la matrice decompactee 
            DO 3 NUCOL=NDEB,NLAS
               NCOMP=NCOMP+1
               NCOMPA=NCOMP
               NULIG=NULIG1
               DO 3 IDLNE=1,NBDLI  
                  NULIG=NULIG+1
                  DO 2 ICMP=1,ICMPLX
2                    MATPLE(ICMP,NULIG,NUCOL)=MATMOL(ICMP,NCOMPA)  
3                 NCOMPA=NCOMPA+LGLIGN 
4        CONTINUE  
*  
*        Mise a 0 des dernieres colonnes de la ligne de la matrice decompactee 
         NULIG=NULIG1  
         DO 5 IDLNE=1,NBDLI
            NULIG=NULIG+1  
            DO 5 NUCOL=NLAS+1,NBDLCO
               DO 5 ICMP=1,ICMPLX  
5                 MATPLE(ICMP,NULIG,NUCOL)=0.  
10    NUMPL1=NUMPL2+1  
                                                                    END *Mo2Pl*
