*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MPL2BM (TYPEMA,NBLIGS,NBCOLS,STOIMA,MCMATO
     &                   ,MCMATW,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (9 octobre 2006)
* Derniere modification : D.Martin (12 octobre 2006)
* Version 0
*
* Transformation d'une matrice PLEIN-L ou PLEIN-C en matrice BIMORSE
* avec accumulation des valeurs preexistantes dans la matrice BIMORSE
*
* L'initilisation de la matrice resultat n'est pas faite dans cette procedure
*
*-- Arguments d'entree --
* TYPEMA type REEL ou COMPLEXE des matrices
* NBLIGS nombre de lignes des matrices
* NBCOLS nombre de colonnes des matrices
* STOIMA type de stockage PLEIN-L ou PLEIN-C de la matrice original
* MCMATO adresse de la matrice originale
* MCMATW adresse de la matrice transformee
* RST,CST super-tableaux versions REELLE ou COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPEMA,STOIMA
      INTEGER NBLIGS,NBCOLS,MCMATO,MCMATW
      REAL    RST(*)
      COMPLEX CST(*)
*
      INTEGER NWADRS,OLADRS,OLADR,I,J
*-----------------------------------------------------------------------
      IF (STOIMA(1:7).EQ.'PLEIN-L') THEN
*
*        Stockage PLEIN-L vers BIMORSE
*
         NWADRS=MCMATW
         OLADRS=MCMATO
         IF (TYPEMA(1:1).EQ.'R') THEN
*
*           Coeff. diagonaux
            DO 521 I=1,MIN(NBLIGS,NBCOLS)
               RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
               NWADRS=NWADRS+1
               OLADRS=OLADRS+NBCOLS+1
521         CONTINUE
*           Coeff. de la partie triangulaire inferieure
            OLADR=MCMATO+NBCOLS
            DO 523 I=2,NBLIGS     
               DO 522 OLADRS=OLADR,OLADR-1+MIN(I-1,NBCOLS)
                  RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
                  NWADRS=NWADRS+1 
522            CONTINUE
               OLADR=OLADR+NBCOLS
523         CONTINUE 
*           Coeff. de la partie triangulaire superieure
            OLADR=MCMATO+1
            DO 525 J=2,NBCOLS
               DO 524 OLADRS=OLADR,OLADR-1+NBCOLS*MIN(J-1,NBLIGS),NBCOLS
                  RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
                  NWADRS=NWADRS+1  
524            CONTINUE
               OLADR=OLADR+1              
525         CONTINUE
*
         ELSE
*
            DO 541 I=1,MIN(NBLIGS,NBCOLS)
               CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
               NWADRS=NWADRS+1
               OLADRS=OLADRS+NBCOLS+1
541         CONTINUE
            OLADR=MCMATO+NBCOLS
            DO 543 I=2,NBLIGS     
               DO 542 OLADRS=OLADR,OLADR-1+MIN(I-1,NBCOLS)
                  CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
                  NWADRS=NWADRS+1 
542            CONTINUE
               OLADR=OLADR+NBCOLS
543         CONTINUE 
            OLADR=MCMATO+1
            DO 545 J=2,NBCOLS
               DO 544 OLADRS=OLADR,OLADR-1+NBCOLS*MIN(J-1,NBLIGS),NBCOLS
                  CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
                  NWADRS=NWADRS+1  
544            CONTINUE
               OLADR=OLADR+1              
545         CONTINUE
         ENDIF

      ELSEIF (STOIMA(1:7).EQ.'PLEIN-C') THEN
*
*        Stockage PLEIN-C vers BIMORSE
*
         NWADRS=MCMATW
         OLADRS=MCMATO
         IF (TYPEMA(1:1).EQ.'R') THEN
*
            DO 221 I=1,MIN(NBLIGS,NBCOLS)
               RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
               NWADRS=NWADRS+1
               OLADRS=OLADRS+NBLIGS+1
221         CONTINUE
            OLADR=MCMATO+1
            DO 223 I=2,NBLIGS
               DO 222 OLADRS=OLADR,OLADR-1+NBLIGS*MIN(I-1,NBCOLS),NBLIGS
                  RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
                  NWADRS=NWADRS+1
222            CONTINUE
               OLADR=OLADR+1
223         CONTINUE
            OLADR=MCMATO+NBLIGS
            DO 225 J=2,NBCOLS
               DO 224 OLADRS=OLADR,OLADR-1+MIN(J-1,NBLIGS)
                  RST(NWADRS)=RST(NWADRS)+RST(OLADRS)
                  NWADRS=NWADRS+1
224            CONTINUE
               OLADR=OLADR+NBLIGS
225         CONTINUE
*
         ELSE
*
            DO 241 I=1,MIN(NBLIGS,NBCOLS)
               CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
               NWADRS=NWADRS+1
               OLADRS=OLADRS+NBLIGS+1
241         CONTINUE
            OLADR=MCMATO+1
            DO 243 I=2,NBLIGS
               DO 242 OLADRS=OLADR,OLADR-1+NBLIGS*MIN(I-1,NBCOLS),NBLIGS
                  CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
                  NWADRS=NWADRS+1
242            CONTINUE
               OLADR=OLADR+1
243         CONTINUE
            OLADR=MCMATO+NBLIGS
            DO 245 J=2,NBCOLS
               DO 244 OLADRS=OLADR,OLADR-1+MIN(J-1,NBLIGS)
                  CST(NWADRS)=CST(NWADRS)+CST(OLADRS)
                  NWADRS=NWADRS+1
244            CONTINUE
               OLADR=OLADR+NBLIGS
245         CONTINUE
*
         ENDIF
*
      ENDIF
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (12 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !MBm2Pl
