*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE N2DLMO (MOOUBM,NCPINC,NCPINL,NBNELI,NBNECO,NULAPL
     &                  ,IPLAGL,NBLIDL,NULAPD,IPLAGD)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1992)  
* Derniere modification (D.Martin) le 11 Avril 1997  
*  
* Creation du tableau de stockage (Bi)Morse(-L/C) en d.l. pour une inconnue
* vectorielle a partir du tableau de stockage (Bi)Morse(-L/C) en noeud
*  
*-- Arguments d'entree --
* MOOUBM =1 si stockage BiMorse, 0 si stockage Morse-L ou Morse-C
* NCPINC nombre de composantes de l'inconnue vectorielle en colonne
* NCPINL nombre de composantes de l'inconnue vectorielle en ligne
* NBNELI nombre de lignes en noeud
* NBNECO nombre de colonnes en noeud
* NULAPL numeros de derniere plage de chaque ligne en noeud
* IPLAGL numeros de debut de plage et adresses des coeff. de fin des plages
*        en ligne dans le stockage en noeud
* NBLIDL nombre de lignes en noeud
* NULAPD numeros de derniere plage de chaque ligne en d.l. vectoriel
* IPLAGD numeros de debut de plage et adresses des coeff. de fin des plages
*        en ligne dans le stockage en d.l. vectoriel
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MOOUBM,NCPINC,NCPINL,NBNELI,NBNECO,NULAPL(*),IPLAGL(2,*)
     &       ,NBLIDL,NULAPD(*),IPLAGD(2,*)

      INTEGER LIGN1,LIGNE,NUPRPL,NUDRPL,LGCUAB,LGCUAV,NBPLDL,LGCUMW,IDLV
     &       ,KOLDEB,KOLFIN,LGPLAG
*-----------------------------------------------------------------------
      LIGN1=1
      NUDRPL=0
      LGCUAB=0
      NBLIDL=0
      NBPLDL=0
      LGCUMW=0
      IF (MOOUBM.EQ.1) THEN
*        Cas BiMorse seulement
*        Lignes supplem. correspondant aux d.l. du premier noeud en ligne
         DO 1 IDLV=2,NCPINL
            NBLIDL=NBLIDL+1
            NBPLDL=NBPLDL+1
            NULAPD(NBLIDL)=NBPLDL
            IPLAGD(1,NBPLDL)=1
            LGCUMW=LGCUMW+IDLV-1
            IPLAGD(2,NBPLDL)=LGCUMW
1        CONTINUE
*        Lignes supplementaires correspondant aux d.l. des noeuds en ligne
*        ne contenant que des coeff. diagonaux (en noeud)
         DO 3 LIGN1=2,NBNELI
            IF (NULAPL(LIGN1-1).GE.1) GO TO 5
*           une ligne vide s'intercalle ...
            NBLIDL=NBLIDL+1
            NULAPD(NBLIDL)=NBPLDL
            DO 2 IDLV=2,NCPINL
               NBLIDL=NBLIDL+1
               NBPLDL=NBPLDL+1
               NULAPD(NBLIDL)=NBPLDL
               IPLAGD(1,NBPLDL)=1+NCPINL*(LIGN1-1)
               LGCUMW=LGCUMW+IDLV-1
               IPLAGD(2,NBPLDL)=LGCUMW
2           CONTINUE
3        CONTINUE
      ENDIF
*
5     DO 20 LIGNE=LIGN1,NBNELI
         NUPRPL=NUDRPL+1
         NUDRPL=NULAPL(LIGNE-MOOUBM)
         DO 18 IDLV=1,NCPINL
            NBLIDL=NBLIDL+1
            LGCUAV=LGCUAB
*           et en cas de ligne vide ...
            KOLDEB=1
            LGPLAG=0
            DO 16 NUPLNE=NUPRPL,NUDRPL
               NBPLDL=NBPLDL+1
               KOLDEB=IPLAGL(1,NUPLNE)
               IPLAGD(1,NBPLDL)=1+NCPINC*(KOLDEB-1)
               LGCUPL=IPLAGL(2,NUPLNE)
               LGPLAG=LGCUPL-LGCUAV
               LGCUAV=LGCUPL
               LGCUMW=LGCUMW+NCPINC*LGPLAG
               IPLAGD(2,NBPLDL)=LGCUMW
16          CONTINUE
            IF (MOOUBM.EQ.1.AND.LIGNE.LE.NBNECO.AND.IDLV.GT.1) THEN
*              Cas BiMorse seulement
*              Lignes et colonnes supplem. correspondant aux d.l. du noeud
*              pour le coeff. diagonal (en noeud)
               KOLFIN=KOLDEB-1+LGPLAG
               LGCUMW=LGCUMW+IDLV-1
               IF (KOLFIN.LT.LIGNE-1) THEN
*                 Plage supplementaire en bout de ligne
                  NBPLDL=NBPLDL+1
                  IPLAGD(1,NBPLDL)=1+NCPINC*(LIGNE-1)
               ENDIF
               IPLAGD(2,NBPLDL)=LGCUMW
            ENDIF
            NULAPD(NBLIDL)=NBPLDL
18       CONTINUE
         LGCUAB=LGCUPL
20    CONTINUE
                                                                    END !N2DlMo
