*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PL2MOL (LIOUCO,COOULI,MORSE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Octobre 1989)
* Derniere modification : E.Luneville (31 Octobre 2003)
*
* Construction de la table de stockage Morse-ligne ou Morse-colonne
* pour une matrice stockee pleine
*
*-- Arguments --
* LIOUCO nombre de lignes / colonnes
* COOULI nombre de colonnes / lignes
* MORSE  tableau contenant la structure Morse a construire
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  LIOUCO,COOULI,MORSE(*)
*
      INTEGER  ADRS,I,LGCUAV
*-----------------------------------------------------------------------
*     Nombre de lignes (resp. de colonnes)
      MORSE(1)=LIOUCO
*     Nombre de colonnes (resp. de lignes)
      MORSE(2)=COOULI
*     Nombre de plages de la matrice
      MORSE(3)=LIOUCO
*     Taille (nombre de coefficients) de la matrice
      MORSE(4)=LIOUCO*COOULI
*     Numero des dernieres plages de chaque ligne (resp. colonne)
      DO 1 ADRS=5,LIOUCO+4
         MORSE(ADRS)=ADRS-4
1     CONTINUE
*     Numero de colonne (resp. ligne) de debut de plage et adresse
*     du dernier coefficient de chaque plage.
      ADRS=LIOUCO+4
      LGCUAV=COOULI
      DO 2 I=1,LIOUCO
         MORSE(ADRS+1)=1
         MORSE(ADRS+2)=LGCUAV
         ADRS         =ADRS+2
         LGCUAV       =LGCUAV+COOULI
2     CONTINUE  
                                                                    END !Pl2Mol
