*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PLELIM (TYMATR,LIOUKO,KOOULI,INLIKO,INKOLI,MCMATR
     &                  ,NBKEEP,JNLIKO,JNKOLI,MCMATS,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996)
* Derniere modification (D.Martin) le 2 Juillet 1996
*
* Suppression de premieres lignes ou colonnes d'une matrice pleine 
* (stockee pleine a la fortran, colonne apres colonne) 
*
*-- Arguments --
* TYMATR type (REEL ou COMPLEXE) de la matrice
* LIOUKO nombre de lignes/colonnes de la matrice originale
* KOOULI nombre de colonnes/lignes de la matrice originale
* INLIKO increment d'adresse en cas de changement de ligne/colonne
*        de la matrice originale
*        (1 en cas de supp. de lignes, KOOULI en cas de supp. de colonnes)
* INKOLI increment d'adresse en cas de changement de colonne/ligne
*        de la matrice originale
*        (LIOUKO en cas de supp. de lignes, 1 en cas de supp. de colonnes)
* MCMATR adresse de la matrice originale dans RST ou CST
* NBKEEP nombre de lignes/colonnes a conserver
* JNLIKO increment d'adresse en cas de changement de ligne/colonne
*        de la matrice en sortie
*        (1 en cas de supp. de lignes, NBKEEP en cas de supp. de colonnes)
* JNKOLI increment d'adresse en cas de changement de colonne/ligne
*        de la matrice en sortie
*        (NBKEEP en cas de supp. de lignes, 1 en cas de supp. de colonnes)
* MCMATS adresse de la matrice resultat dans RST ou CST
* RST    tableau contenant la matrice (cas REEL)
* CST    tableau contenant la matrice (cas COMPLEXE)
*
*-- Voir exemple d'utilisation dans PGAUSS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYMATR*(*)
      INTEGER   LIOUKO,KOOULI,INLIKO,INKOLI,MCMATR
     &         ,NBKEEP,JNLIKO,JNKOLI,MCMATS
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER   MCNEXT,MCKEEP,ADNEXT,ADKEEP,IKEEP,KL
*-----------------------------------------------------------------------
      MCNEXT=MCMATR+(LIOUKO-NBKEEP)*INLIKO
      MCKEEP=MCMATS
      IF (TYMATR(1:1).EQ.'R') THEN
         DO 21 IKEEP=1,NBKEEP
            ADNEXT=MCNEXT
            ADKEEP=MCKEEP
            DO 20 KL=1,KOOULI
               RST(ADKEEP)=RST(ADNEXT)
               ADKEEP     =ADKEEP+JNKOLI
               ADNEXT     =ADNEXT+INKOLI
20          CONTINUE
            MCNEXT=MCNEXT+INLIKO
            MCKEEP=MCKEEP+JNLIKO
21       CONTINUE
      ELSEIF (TYMATR(1:1).EQ.'C') THEN
         DO 41 IKEEP=1,NBKEEP
            ADNEXT=MCNEXT
            ADKEEP=MCKEEP
*     Write(*,*)' Plelim Adresse ',ADNEXT-MCMATR+1,' dans '
*    &,ADKEEP-MCMATS+1,' (',JNKOLI,INKOLI,')'
            DO 40 KL=1,KOOULI
               CST(ADKEEP)=CST(ADNEXT)
               ADKEEP     =ADKEEP+JNKOLI
               ADNEXT     =ADNEXT+INKOLI
40          CONTINUE
*     if(koouli.gt.1)
*    &Write(*,*)' Plelim jusqu''a ',ADNEXT-MCMATR+1-INKOLI,' dans '
*    &,ADKEEP-MCMATS+1-JNKOLI
            MCNEXT=MCNEXT+INLIKO
            MCKEEP=MCKEEP+JNLIKO
41       CONTINUE
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !PlElim
