*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PLPERM (TYMATR,LIOUKO,KOOULI,INLIKO,INKOLI
     &                  ,NBPERM,PERMUT,MCMATR,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996)
* Derniere modification (D.Martin) le 2 Juillet 1996
*
* Permutation de lignes ou de colonnes donnees d'une matrice pleine 
* (a la fortran) avec les dernieres lignes ou colonnes de la matrice
*
*-- Arguments --
* TYMATR type (REEL ou COMPLEXE) de la matrice
* LIOUKO nombre de lignes/colonnes de la matrice
* KOOULI nombre de colonnes/lignes de la matrice
* INLIKO increment d'adresse en cas de changement de ligne/colonne
*        (1 en cas de perm. de lignes, KOOULI en cas de perm. de colonnes)
* INKOLI increment d'adresse en cas de changement de colonne/ligne
*        (LIOUKO en cas de perm. de lignes, 1 en cas de perm. de colonnes)
* NBPERM nombre de permutations de lignes/colonnes
* PERMUT tableau des numeros des lignes/colonnes a permuter ranges par
*        numeros croissants
* MCMATR adresse de la matrice dans RST ou CST
* RST    tableau contenant la matrice (cas REEL)
* CST    tableau contenant la matrice (cas COMPLEXE)
*
*-- voir exemple d'utilisation dans PGAUSS
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER TYMATR*(*)
      INTEGER   LIOUKO,KOOULI,INLIKO,INKOLI,MCMATR
     &         ,NBPERM,PERMUT(*)
      REAL      RST(*)
      COMPLEX   CST(*)
*
      INTEGER   MCNEXT,NEXTLK,PERMLK,ADPERM,ADNEXT,IPERM,KL
      REAL      RAUX
      COMPLEX   CAUX
*-----------------------------------------------------------------------
      NEXTLK=LIOUKO-NBPERM
      MCNEXT=MCMATR+NEXTLK*INLIKO
      IF (TYMATR(1:1).EQ.'R') THEN
         DO 21 IPERM=1,NBPERM
            NEXTLK=NEXTLK+1
            PERMLK=PERMUT(IPERM)
            IF (PERMLK.NE.NEXTLK) THEN
*              Echange des lignes ou colonnes PERMLK et NEXTLK
               ADPERM=MCMATR+INLIKO*(PERMLK-1)
               ADNEXT=MCNEXT
               DO 20 KL=1,KOOULI
                  RAUX       =RST(ADPERM)
                  RST(ADPERM)=RST(ADNEXT)
                  RST(ADNEXT)=RAUX
                  ADPERM     =ADPERM+INKOLI
                  ADNEXT     =ADNEXT+INKOLI
20             CONTINUE
            ENDIF
            MCNEXT=MCNEXT+INLIKO
21       CONTINUE
      ELSEIF (TYMATR(1:1).EQ.'C') THEN
         DO 41 IPERM=1,NBPERM
            NEXTLK=NEXTLK+1
            PERMLK=PERMUT(IPERM)
            IF (PERMLK.NE.NEXTLK) THEN
               ADPERM=MCMATR+INLIKO*(PERMLK-1)
               ADNEXT=MCNEXT
               DO 40 KL=1,KOOULI
                  CAUX       =CST(ADPERM)
                  CST(ADPERM)=CST(ADNEXT)
                  CST(ADNEXT)=CAUX
                  ADPERM     =ADPERM+INKOLI
                  ADNEXT     =ADNEXT+INKOLI
40             CONTINUE
            ENDIF
            MCNEXT=MCNEXT+INLIKO
41       CONTINUE
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !PlPerm
