*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRPTRB (INFSUP,NBNEUL,NBNEUC,PTRDBL,PTRDBC,PTRBML
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1992) 
* Derniere modification : D.Martin (22 Novembre 1999)
* Version 1
*  
* Impression des pointeurs d'assemblage de la partie triangulaire inferieure
* ou superieure d'une matrice stockee BiMorse
*  
*-- Arguments d'entree --
* INFSUP ='Inf' ou 'Sup'
* NBNEUL nombre de noeuds en ligne dans l'element
* NBNEUC nombre de noeuds en colonne sur la ligne
* PTRDBL tableau des adresses de debut des lignes de la matrice compactee
* PTRDBC tableau des adresses de debut des colonnes de la matrice compactee
* PTRBML tableau des adresses a partir du debut de la ligne (resp. colonne)
*        dans la matrice BiMorse des coefficients d'une matrice elementaire
* NIVIMP niveau d'impression
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) INFSUP
      INTEGER NBNEUL,NBNEUC,PTRDBL(*),PTRDBC(*),PTRBML(NBNEUL,*)
     &       ,NIVIMP,IMPFCH
*
      INTEGER KONOEU,NOEULI,NOEUKO,IADBLI
*-----------------------------------------------------------------------
*
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
      IF (INFSUP(1:1).EQ.'I') THEN
         WRITE (IMPFCH,10001) 'inferieur',(KONOEU,KONOEU=1,NBNEUC)
         DO 201 NOEULI=1,NBNEUL
            IADBLI=PTRDBL(NOEULI)
            WRITE(IMPFCH,10002) NOEULI,(IADBLI-1+PTRBML(NOEULI,NOEUKO)+
     &               (1-IADBLI)*((1-SIGN(1,PTRBML(NOEULI,NOEUKO)-1))/2)
     &                                                 ,NOEUKO=1,NBNEUC)
201      CONTINUE
      ELSE
         WRITE (IMPFCH,10001) 'inferieur et superieur'
     &                        ,(KONOEU,KONOEU=1,NBNEUC)
         DO 202 NOEULI=1,NBNEUL
            WRITE (IMPFCH,10002) NOEULI,
     &     (((1+SIGN(1,PTRDBL(NOEULI)-PTRDBC(NOEUKO)))/2)*PTRDBL(NOEULI)
     &     +((1-SIGN(1,PTRDBL(NOEULI)-PTRDBC(NOEUKO)))/2)*PTRDBC(NOEUKO)
     &     -1+PTRBML(NOEULI,NOEUKO)
     &  +(1-((1+SIGN(1,PTRDBL(NOEULI)-PTRDBC(NOEUKO)))/2)*PTRDBL(NOEULI)
     &    +((1-SIGN(1,PTRDBL(NOEULI)-PTRDBC(NOEUKO)))/2)*PTRDBC(NOEUKO))
     &    *((1-SIGN(1,PTRBML(NOEULI,NOEUKO)-1))/2)
     &  ,NOEUKO=1,NBNEUC)
202      CONTINUE
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10001 FORMAT(/T6,'*PrPtrB* Pointeurs BiMorse ',A/
     &T16,10('j=',I2,:,TR7)/(T10,'./.  ',10('j=',I3,:,TR6)))
10002 FORMAT(T5,'i=',I3,' : ',10(I7,TR4),:/(T10,'./.',10(I7,TR4),:))
                                                                    END !PrPtrB
