*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRPTRM (LIGCOL,NBNEUL,NBNEUC,PTRDBL,PTRMOR
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1992) 
* Derniere modification : D.Martin (22 Novembre 1999)
*  
* Impression des pointeurs d'assemblage d'une matrice stockee Morse-L ou Morse-C
*  
*-- Arguments d'entree --
* LIGCOL ='L(IGNE)' ou 'COLONNE'
* NBNEUL nombre de noeuds en ligne dans l'element
* NBNEUC nombre de noeuds en colonne sur la ligne
* PTRDBL tableau des adresses de debut des lignes (resp. colonnes) de la 
*        matrice compactee
* PTRMOR tableau des adresses a partir du debut de la ligne (resp. colonne)
*        dans la matrice BiMorse des coefficients d'une matrice elementaire
* NIVIMP niveau d'impression
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIGCOL
      INTEGER NBNEUL,NBNEUC,PTRDBL(*),PTRMOR(NBNEUL,*),NIVIMP,IMPFCH
*
      INTEGER KONOEU,NOEULI,LINOEU,NOEUKO
*-----------------------------------------------------------------------
*
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
      IF (LIGCOL(1:1).EQ.'L') THEN
         WRITE(IMPFCH,10001) 'Ligne',(KONOEU,KONOEU=1,NBNEUC)
         DO 201 NOEULI=1,NBNEUL
            WRITE (IMPFCH,10002) NOEULI
     &     ,(PTRDBL(NOEULI)-1+PTRMOR(NOEULI,NOEUKO)
     &     +(1-PTRDBL(NOEULI))*((1-SIGN(1,PTRMOR(NOEULI,NOEUKO)-1))/2)
     &    ,NOEUKO=1,NBNEUC)
201   CONTINUE
      ELSE
         WRITE (IMPFCH,10001) 'Colonne',(LINOEU,LINOEU=1,NBNEUC)
         DO 202 NOEULI=1,NBNEUL
            WRITE (IMPFCH,10002) NOEULI
     &     ,(PTRDBL(NOEUKO)-1+PTRMOR(NOEULI,NOEUKO)
     &     +(1-PTRDBL(NOEUKO))*((1-SIGN(1,PTRMOR(NOEULI,NOEUKO)-1))/2)
     &     ,NOEUKO=1,NBNEUC)
202   CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10001 FORMAT(/T6,'*PrPtrM* Pointeurs Morse-',A/
     &T16,10('j=',I2,:,TR7)/(T10,'./.   ',10('j=',I2,:,TR7)))
10002 FORMAT(T6,'i=',I2,' : ',10(I7,TR4),:/(T10,'./.',10(I7,TR4),:))
                                                                    END !Prptrm
