*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PTRBML (NBNEUL,RGNELI,NBNEUC,RGNECO,NULAPL,IPLAGE
     &                  ,PTRDEB,LGLIGN,PTRMOR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1992) 
* Derniere modification : D.Martin (25 mars 2002)
* Version 1.0.1
*  
* Calcul des pointeurs des coefficients d'une matrice elementaire dans 
* la partie triangulaire inferieure d'une matrice stockee Bi-Morse
*  
*-- Arguments d'entree --
* NBNEUL nombre de noeuds dans l'element pour l'interpolation en ligne
* RGNELI rang des noeuds en ligne de l'element dans la 
*        numerotation des noeuds pour l'interpolation en ligne du domaine
* NBNEUC nombre de noeuds dans l'element pour l'interpolation en colonne 
* RGNECO rang des noeuds en colonne de l'element dans la 
*        numerotation des noeuds pour l'interpolation en colonne du domaine  
* NULAPL tableau des numeros de derniere plage des lignes
* IPLAGE tableau des numeros de colonne de debut de plage
*        et des adresses des derniers coefficients de chaque plage
*-- Arguments de sortie --
* PTRDEB pointeurs des coefficients de debut des lignes dans la partie triang.
*        inferieure de la matrice compactee
* LGLIGN tableau des longueurs des lignes de la partie triang. inferieure
* PTRMOR tableau des adresses relatives a partir du debut de ligne des
*        coefficients de la matrice elementaire dans la partie triangulaire
*        inferieure de la matrice
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   RGNELI(*),RGNECO(*),NULAPL(*),IPLAGE(2,*)
     *         ,PTRDEB(*),LGLIGN(*),PTRMOR(NBNEUL,*)
*-----------------------------------------------------------------------
      DO 20 NELOCL=1,NBNEUL
         LIGNE=RGNELI(NELOCL)
         NUPRPL=1  
         LGCUDB=0
         IF (LIGNE.LE.1) THEN 
            LGLIGN(NELOCL)=0
         ELSE
            NUDRPL=NULAPL(LIGNE-1)  
            IF (LIGNE.GT.2) THEN
               NUPRPL=NULAPL(LIGNE-2)+1
               IF(NUPRPL.GT.1) LGCUDB=IPLAGE(2,NUPRPL-1)  
            ENDIF
            IF (NUDRPL.GE.NUPRPL) THEN
               LGLIGN(NELOCL)=IPLAGE(2,NUDRPL)-LGCUDB
               LAPLAV=0
               KOLOAV=-99999
               DO 10 NELOCC=1,NBNEUC
                  KOLON=RGNECO(NELOCC)
                  IF (LIGNE.GT.KOLON) THEN
*                    Recherche dichotomique du numero de la plage de 
*                    la ligne du stockage Bi-Morse contenant le noeud KOLON
                     CALL DIKLPL (KOLON,NUPRPL,NUDRPL,LGCUDB,IPLAGE
     &                           ,LAPLAG,*1000)
                     IF (LAPLAG.EQ.LAPLAV) THEN
                        NCOMPT=NCOMPT-KOLOAV+KOLON
                     ELSE
                        NCOMPT=KOLON+1-IPLAGE(1,LAPLAG)
                        IF (LAPLAG.GT.1) 
     &                     NCOMPT=NCOMPT+IPLAGE(2,LAPLAG-1)
                        LAPLAV=LAPLAG
                     ENDIF
                     KOLOAV=KOLON
                     PTRMOR(NELOCL,NELOCC)=NCOMPT-LGCUDB
                  ELSE
                     PTRMOR(NELOCL,NELOCC)=0
                  ENDIF
10             CONTINUE
            ELSE
               LGLIGN(NELOCL)=0
               DO 15 NELOCC=1,NBNEUC
                  PTRMOR(NELOCL,NELOCC)=0
15             CONTINUE
            ENDIF
         ENDIF
         PTRDEB(NELOCL)=LGCUDB+1
20    CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1000  WRITE(*,*) ' *PtrBml* --> Echec de la recherche dichotomique'
      WRITE(*,*) '    NUPRPL,NUDRPL,LGLIGN',NUPRPL,NUDRPL,LGLIGN(NELOCL)
      DO 1001 IPLA=NUPRPL,NUDRPL
1001  WRITE(*,*) '    IPLA,IPLAGE(1 et 2,IPLA)'
     &                               ,IPLA,IPLAGE(1,IPLA),IPLAGE(2,IPLA)
      WRITE(*,*) '    LIGNE,KOLON,LAPLAG,LGCUDB'
     &                                        ,LIGNE,KOLON,LAPLAG,LGCUDB
      WRITE(*,*) '    NELOCC,NCOMPT',NELOCC,NCOMPT
      CALL BAISE(' *PtrBml* ne trouve pas ses moutons ...')
                                                                    END !PtrBml
