*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PTRBMU (NBNEUL,RGNELI,NBNEUC,RGNECO,NULAPL,IPLAGE
     &                  ,PTRDBC,LGCOLO,PTRMOR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1992) 
* Derniere modification : D.Martin (26 juin 2002)
* Version 1.0.2
*  
* Calcul des pointeurs des coefficients d'une matrice elementaire dans 
* la partie triangulaire superieure d'une matrice stockee Bi-Morse
*  
*-- Arguments d'entree --
* NBNEUL nombre de noeuds en ligne dans l'element
* RGNELI rang des noeuds en ligne de l'element dans la 
*        numerotation des noeuds en ligne du domaine
* NBNEUC nombre de noeuds en colonne  dans l'element
* RGNECO rang des noeuds en colonne de l'element dans la 
*        numerotation des noeuds en colonne du domaine  
* NULAPL tableau des numeros de derniere plage des colonnes
* IPLAGE tableau des numeros de colonne de debut de plage
*        et des adresses des derniers coefficients de chaque plage
*-- Arguments de sortie --
* PTRDBC pointeurs des coefficients de debut des colonnes dans la partie
*        triangulaire superieure de la matrice compactee
* LGCOLO tableau des longueurs des colonnes de la partie triang. superieure
* PTRMOR tableau des adresses relatives a partir du debut de colonne des
*        coefficients de la matrice elementaire dans la partie triangulaire
*        superieure de la matrice
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NBNEUL,RGNELI(*),NBNEUC,RGNECO(*),NULAPL(*),IPLAGE(2,*)
     &        ,PTRDBC(*),LGCOLO(*),PTRMOR(NBNEUL,*)
*
      INTEGER NELOCC,KOLON,NUPRPL,NUDRPL,LGCUDB,LAPLAG,LAPLAV
     &       ,NELOCL,LIGNE,LIGNAV,NCOMPT
*-----------------------------------------------------------------------
      DO 2 NELOCC=1,NBNEUC
*
         LGCOLO(NELOCC)=0
*
         KOLON=RGNECO(NELOCC)
         NUPRPL=1  
         LGCUDB=0
         IF (KOLON.GT.1) THEN
            NUDRPL=NULAPL(KOLON-1)  
            IF (KOLON.GT.2) THEN
               NUPRPL=NULAPL(KOLON-2)+1
               IF(NUPRPL.GT.1) LGCUDB=IPLAGE(2,NUPRPL-1) 
            ENDIF 
            IF (NUDRPL.GE.NUPRPL) THEN
               LGCOLO(NELOCC)=IPLAGE(2,NUDRPL)-LGCUDB
               LAPLAV=0
               LIGNAV=-99999
               DO 1 NELOCL=1,NBNEUL
                  LIGNE=RGNELI(NELOCL)
                  IF (KOLON.GT.LIGNE) THEN
*                    Recherche dichotomique du numero de la plage de
*                   la colonne du stockage Bi-Morse contenant le noeud LIGNE
                     CALL DIKLPL (LIGNE,NUPRPL,NUDRPL,LGCUDB,IPLAGE
     &                           ,LAPLAG,*1000)
                     IF (LAPLAG.EQ.LAPLAV) THEN
                        NCOMPT=NCOMPT-LIGNAV+LIGNE
                     ELSE
                        NCOMPT=LIGNE+1-IPLAGE(1,LAPLAG)
                        IF (LAPLAG.GT.1)
     &                     NCOMPT=NCOMPT+IPLAGE(2,LAPLAG-1)
                        LAPLAV=LAPLAG
                     ENDIF
                     LIGNAV=LIGNE
                     PTRMOR(NELOCL,NELOCC)=NCOMPT-LGCUDB
                  ENDIF
1              CONTINUE
            ENDIF
         ENDIF
         PTRDBC(NELOCC)=LGCUDB+1
2     CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1000  WRITE(*,*) ' *PtrBmu* --> Echec de la recherche dichotomique'
      WRITE(*,*) '    NUPRPL,NUDRPL,LGCOLO',NUPRPL,NUDRPL,LGCOLO(NELOCC)
      WRITE(*,*) '    KOLON,LIGNE,LAPLAG',KOLON,LIGNE,LAPLAG
      WRITE(*,*) '    NELOCC,NELOCL,NCOMPT',NELOCC,NELOCL,NCOMPT
      CALL BAISE(' *PtrBmu* ne trouve pas ses moutons ...')
                                                                    END !PtrBmu
