*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PTRMCO (NBNEUL,RGNELI,NBNEUC,RGNECO,NULAPL,IPLAGE
     *                  ,PTRDMO,LGCOLO,PTRMOR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Septembre 1988) 
* Derniere modification : D.Martin (18 Mars 2002)
* Version 1.0.1
*  
* Calcul des pointeurs des coefficients d'une matrice elementaire dans 
* une matrice de pre-assemblage stockee Morse-Colonne
*  
*-- Arguments d'entree --
* NBNEUL nombre de noeuds en ligne dans l'element
* RGNELI rang des noeuds en ligne de l'element dans la numerotation des noeuds
*        de l'interpolation en ligne du domaine
* NBNEUC nombre de noeuds en colonne dans l'element
* RGNECO rang des noeuds en colonne de l'element dans la numerotation des noeuds
*        de l'interpolation en colonne du domaine  
* NULAPL tableau des numeros de derniere plage des colonnes
* IPLAGE tableau des numeros de colonne de debut de plage et des adresses des 
*        derniers coefficients de chaque plage
*-- Arguments de sortie --
* PTRDMO pointeurs des coefficients de debut de colonne dans la matrice
* LGCOLO tableau des longueurs des colonnes du terme compacte
* PTRMOR tableau des adresses relatives a partir du debut de colonne des
*        coefficients de la matrice elementaire dans la matrice assemblee
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBNEUL,RGNELI(*),NBNEUC,RGNECO(*),NULAPL(*),IPLAGE(2,*)
     &       ,PTRDMO(*),LGCOLO(*),PTRMOR(NBNEUL,*)
*
      INTEGER NELOCC,NGNECO,PRECED,NELOCL,NGNELI
     &       ,NUPRPL,NUDRPL,LGCUDB,LAPLAV,LAPLAG,NCOMPT
*-----------------------------------------------------------------------
      DO 2 NELOCC=1,NBNEUC 
         NGNECO=RGNECO(NELOCC)
         NUPRPL=1  
         LGCUDB=0  
         NUDRPL=NULAPL(NGNECO)  
         IF (NGNECO.GT.1) THEN
            NUPRPL=NULAPL(NGNECO-1)+1
            LGCUDB=IPLAGE(2,NUPRPL-1)  
         ENDIF
*
         LAPLAV=0
         DO 1 NELOCL=1,NBNEUL
            NGNELI=RGNELI(NELOCL)
*  
*           Recherche dichotomique du numero de la plage de la colonne NGNECO
*           du stockage Morse-Ligne contenant le noeud NGNELI
*  
            CALL DIKLPL (NGNELI,NUPRPL,NUDRPL,LGCUDB,IPLAGE
     &                  ,LAPLAG,*1000)                                  !utilite
*
            IF (LAPLAG.EQ.LAPLAV) THEN
               NCOMPT=NCOMPT-PRECED+NGNELI
            ELSE
               NCOMPT=NGNELI+1-IPLAGE(1,LAPLAG)
               IF (LAPLAG.GT.1) NCOMPT=NCOMPT+IPLAGE(2,LAPLAG-1)
               LAPLAV=LAPLAG
            ENDIF
            PRECED=NGNELI
            PTRMOR(NELOCL,NELOCC)=NCOMPT-LGCUDB
1        CONTINUE
         PTRDMO(NELOCC)=LGCUDB+1
         LGCOLO(NELOCC)=IPLAGE(2,NUDRPL)-LGCUDB
2     CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1000  WRITE(*,*) ' *PtrMco* --> Echec de la recherche dichotomique'
      WRITE(*,*) '    NUPRPL,NUDRPL,LGCOLO',NUPRPL,NUDRPL,LGCOLO(NELOCC)
      WRITE(*,*) '    NGNECO,NGNELI,LAPLAG',NGNECO,NGNELI,LAPLAG
      WRITE(*,*) '    NELOCL,NCOMPT',NELOCL,NCOMPT
      CALL BAISE(' *PtrMco* ne trouve pas ses moutons ...')             !Utilite
                                                                    END !PtrMco
