*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PTRMLI (NBNEUL,RGNELI,NBNEUC,RGNECO,NULAPL,IPLAGE
     &                  ,PTRDMO,LGLIGN,PTRMOR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Septembre 1988) 
* Derniere modification : D.Martin (18 Mars 2002)
* Version 1.0.1
*  
* Calcul des pointeurs des coefficients d'une matrice elementaire dans 
*une matrice de pre-assemblage stockee Morse-Ligne
*  
*-- Arguments d'entree --
* NBNEUL nombre de noeuds en ligne dans l'element
* RGNELI rang des noeuds en ligne de l'element dans la numerotation des noeuds
*        de l'interpolation en ligne du domaine
* NBNEUC nombre de noeuds en colonne dans l'element
* RGNECO rang des noeuds en colonne de l'element dans la numerotation des noeuds
*        de l'interpolation en colonne du domaine  
* NULAPL tableau des numeros de derniere plage des lignes
* IPLAGE tableau des numeros de colonne de debut de plage et des adresses des
*        derniers coefficients de chaque plage
*-- Arguments de sortie --
* PTRDMO pointeurs des coefficients de debut de ligne dans la matrice
* LGLIGN tableau des longueurs des lignes du terme compacte
* PTRMOR tableau des adresses relatives a partir du debut de ligne des
*        coefficients de la matrice elementaire dans la matrice assemblee
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER NBNEUL,RGNELI(*),NBNEUC,RGNECO(*),NULAPL(*),IPLAGE(2,*)
     *       ,PTRDMO(*),LGLIGN(*),PTRMOR(NBNEUL,*)
*
      INTEGER NELOCL,NGNELI,PRECED,NELOCC,NGNECO
     &       ,NUPRPL,NUDRPL,LGCUDB,LAPLAV,LAPLAG,NCOMPT
*-----------------------------------------------------------------------
      DO 2 NELOCL=1,NBNEUL 
         NGNELI=RGNELI(NELOCL)
         NUPRPL=1  
         LGCUDB=0  
         NUDRPL=NULAPL(NGNELI)  
         IF (NGNELI.GT.1) THEN
            NUPRPL=NULAPL(NGNELI-1)+1
            LGCUDB=IPLAGE(2,NUPRPL-1)  
         ENDIF
*
         LAPLAV=0
         DO 1 NELOCC=1,NBNEUC
            NGNECO=RGNECO(NELOCC)
*  
*           Recherche dichotomique du numero de la plage de la ligne NGNELI
*           du stockage Morse-Ligne contenant le noeud NGNECO
*  
            CALL DIKLPL (NGNECO,NUPRPL,NUDRPL,LGCUDB,IPLAGE
     &                  ,LAPLAG,*1000)                                   !utilite
*
            IF (LAPLAG.EQ.LAPLAV) THEN
               NCOMPT=NCOMPT-PRECED+NGNECO
            ELSE
               NCOMPT=NGNECO+1-IPLAGE(1,LAPLAG)
               IF (LAPLAG.GT.1) NCOMPT=NCOMPT+IPLAGE(2,LAPLAG-1)
               LAPLAV=LAPLAG
            ENDIF
            PRECED=NGNECO
            PTRMOR(NELOCL,NELOCC)=NCOMPT-LGCUDB
1        CONTINUE
         PTRDMO(NELOCL)=LGCUDB+1
         LGLIGN(NELOCL)=IPLAGE(2,NUDRPL)-LGCUDB
2     CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
1000  WRITE(*,*) ' *PtrMli* --> Echec de la recherche dichotomique'
      WRITE(*,*) '    NUPRPL,NUDRPL,LGLIGN',NUPRPL,NUDRPL,LGLIGN(NELOCL)
      WRITE(*,*) '    NGNELI,NGNECO,LAPLAG',NGNELI,NGNECO,LAPLAG
      WRITE(*,*) '    NELOCC,NCOMPT',NELOCC,NCOMPT
      CALL BAISE(' *PtrMli* ne trouve pas ses moutons ...')             !utilite
                                                                    END *PtrMli
