*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M A L V C (NBLIGN,NULAPL,IPLAGL,TYMATR,MCL 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov 91
*  
*   Produit L*xV de l'adjointe d'une matrice L strictement triangulaire
*   inferieure stockee sous forme 'Bi-Morse' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.  
*  
*** Arguments d'entree *** 
* NBLIGN: nombre de lignes de la matrice L
* NULAPL: numeros des dernieres plages de chaque ligne
* IPLAGL: numeros de colonne de debut de plage et adresses des derniers
*         coefficients de chaque plage
* TYMATR: Type (reel ou complexe) de la matrice
* MCL   : adresse dans le super-tab. de type adhoc de L 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NULAPL(*),IPLAGL(2,*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF
      EQUIVALENCE  (CCOEFF,RCOEFF)
*
      IF(TYMATR(1:1).EQ.'R') THEN
*
         CALL BMUVC (NBLIGN,NULAPL,IPLAGL,TYMATR,MCL
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
      ELSE
*
         IF(TYRESU(1:1).NE.'C') GO TO 90001
         MC=MCL
         MCVV=MCVECT
         NUDRPL=0
         LGCUAL=1
         KOLOM1=1
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 KOLON=2,NBLIGN 
               MCVV=MCVV+1  
               CCOEFF=CST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(KOLOM1)
               KOLOM1=KOLON
               DO 443 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 443 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+CONJG(CST(MC))*CCOEFF
443                  MC=MC+1                
444            CONTINUE
         ELSE
            DO 424 KOLON=2,NBLIGN 
               MCVV=MCVV+1  
               RCOEFF=RST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(KOLOM1)
               KOLOM1=KOLON
               DO 423 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 423 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+CONJG(CST(MC))*RCOEFF
423                  MC=MC+1                
424            CONTINUE  
         END IF
      END IF
      RETURN
90001 CALL BAISE('*BmaLVc* Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *BmaLVc*
