*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M A U V C (NBCOLO,NULAPU,IPLAGU,TYMATR,MCU 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov. 91
*  
*   Produit U*xV de l'adjointe d'une matrice U strictement triangulaire
*   superieure stockee sous forme 'Bi-Morse' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p. 
*  
*** Arguments d'entree *** 
* NBCOLO: nombre de colonnes de la matrice U
* NULAPU: numeros des dernieres plages de chaque colonne
* IPLAGU: numeros de ligne de debut de plage et adresses des derniers
*         coefficients de chaque plage
* TYMATR: Type (reel ou complexe) de la matrice
* MCU   : adresse dans le super-tab. de type adhoc de U 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NULAPU(*),IPLAGU(2,*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*
      IF(TYMATR(1:1).EQ.'R') THEN
         CALL BMLVC(NBCOLO,NULAPU,IPLAGU,TYMATR,MCU
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
      ELSE
         IF(TYRESU(1:1).EQ.'R') GO TO 90001
         MC=MCU
         MCRR=MCRESU
         NUDRPL=0
         LGCUAL=1
         LIGNM1=1
*
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=2,NBCOLO 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(LIGNM1)
               LIGNM1=LIGNE
               DO 443 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 443 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+CST(MC)*CST(MCVV)
443                  MC=MC+1                
444            CST(MCRR)=CCOEFF
         ELSE
            DO 424 LIGNE=2,NBCOLO 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(LIGNM1)
               LIGNM1=LIGNE
               DO 423 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 423 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+CST(MC)*RST(MCVV)
423                  MC=MC+1                
424            CST(MCRR)=CCOEFF  
         END IF
      END IF
      RETURN
90001 CALL BAISE('*BmaUVc* Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *BmaUVc*
