*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  BMLPL (LIDMOR,LIFMOR,NULAPL,IPLAGL,TYMORS,MCMORS
     &                  ,LIDPLE,LIFPLE,KODPLE,KOFPLE,TYPLEI,MCPLEI
     &                  ,INCREL,INCREC,TYRESU,MCRESU,RST,CST) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 92) 
* Derniere modification : D.Martin (3 Juillet 1997)
*  
* Produit MxP d'un bloc de lignes completes du triangle inferieur
* la matrice M compactee 'BiMorse' stockee ligne apres ligne, par un bloc
* de colonnes d'une matrice 'Plein' stockee colonne apres colonne.
* Le resultat est range par ligne incomplete. 
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* LIDMOR: Premiere ligne de la matrice morse intervenant dans le produit
* LIFMOR: Derniere ligne de la matrice morse intervenant dans le produit
* NULAPL: Tableau des numeros de derniere plage de chaque ligne
* IPLAGL: Numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMORS: type (reel ou complexe) de la matrice morse  
* MCMORS: adresse de la matrice compactee dans le super-tableau ad hoc 
* LIDPLE: Numero de premiere ligne dans la matrice pleine  
* LIFPLE: Numero de derniere ligne dans la matrice pleine  
* KODPLE: Numero de premiere colonne du bloc dans la matrice pleine
* KOFPLE: Numero de derniere colonne du bloc dans la matrice pleine
* TYPLEI: type (reel ou complexe) de la matrice pleine 
* MCPLEI: adresse de la matrice pleine dans le super-tableau ad hoc
* INCREL: Increment lors d'un changement sur la ligne du resultat
* INCREC: Increment lors d'un changement sur la colonne
*         (Ces indices permettent de transposer ou non le resultat)
* MCRESU: adresse de la matrice morceau de resultat
* RST,CST: super-tableau considere reel ou complexe
*  
*-- Remarques --
* 1) Les calculs sont effectues avec les pointeurs de compactage de
*    la matrice bimorse inferieure; mais ne sont utilises que les  
*    coeff. situes entre les colonnes de numeros LIDPLE et LIFPLE. 
* 2) Exemples d'utilisation de INCREL et INCREC:
*    - resultat range par ligne   INCREL=1,INCREC=KOFPLE-KODPLE+1
*    - resultat range par colonne INCREL=IDRLIG-IPRLIG+1,INCREC=1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMORS,TYPLEI,TYRESU  
      INTEGER LIDMOR,LIFMOR,NULAPL(*),IPLAGL(2,*),MCMORS,LIDPLE,LIFPLE
     &       ,KODPLE,KOFPLE,MCPLEI,INCREL,INCREC,MCRESU
      REAL    RST(*)
      COMPLEX CST(*)
*-----------------------------------------------------------------------
      IADRES=INCREC
      NUDRPL=0 
      LGCUAL=1
      IF (LIDMOR.GT.2) THEN 
         NUDRPL=NULAPL(LIDMOR-2)
         LGCUAL=IPLAGL(2,NUDRPL)+1 
         IADRES=(LIDMOR-1)*INCREC
      ENDIF
*->   Increment pour changement de colonne dans la matrice pleine  
      INCPLE=LIFPLE-LIDPLE+1
      IF (TYMORS(1:1).EQ.'R') THEN  
         IF (TYPLEI(1:1).EQ.'R') THEN
            IF(TYRESU (1:1).NE.'R') GOTO 90001 
*           Boucle sur les lignes de la matrice bimorse
            DO 5 ILIG=MAX (2,LIDMOR),LIFMOR
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(ILIG-1) 
*              Boucle sur les plages d'une ligne de la matrice bimorse
               DO 4 NUMPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUMPLA)  
                  LGCUML=IPLAGL(2,NUMPLA)
                  KOLFIN=KOLDEB+LGCUML-LGCUAL  
                  IPTMOR=MCMORS-1+LGCUAL+MAX(0,LIDPLE-KOLDEB)
                  LGCUAL=LGCUML+1
*                 Boucle sur les colonnes d'une plage de la matrice bimorse
                  DO 3 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE)  
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 2 NUCOP=KODPLE,KOFPLE  
                        RST(IPTRES)=RST(IPTRES)+RST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
2                    CONTINUE
                     IPTMOR=IPTMOR+1
3                 CONTINUE
4              CONTINUE
               IADRES=IADRES+INCREC
5           CONTINUE
         ELSE  
            IF (TYRESU(1:1).NE.'C') GOTO 90002 
*           Boucle sur les lignes de la matrice bimorse
            DO 15 ILIG=MAX(2,LIDMOR),LIFMOR
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(ILIG-1) 
*              Boucle sur les plages d'une ligne de la matrice bimorse
               DO 14 NUMPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUMPLA)  
                  LGCUML=IPLAGL(2,NUMPLA)
                  KOLFIN=KOLDEB+LGCUML-LGCUAL  
                  IPTMOR=MCMORS-1+LGCUAL+MAX(0,LIDPLE-KOLDEB)
                  LGCUAL=LGCUML+1
*                 Boucle sur les colonnes d'une plage de la matrice bimorse
                  DO 13 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE)  
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 12 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+RST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
12                   CONTINUE
                     IPTMOR=IPTMOR+1
13                CONTINUE
14             CONTINUE
               IADRES=IADRES+INCREC
15          CONTINUE
         ENDIF
      ELSEIF (TYMORS(1:1).EQ.'C') THEN 
         IF (TYRESU(1:1).NE.'C') GOTO 90002
         IF (TYPLEI(1:1).EQ.'C') THEN
*           Boucle sur les lignes de la matrice bimorse
            DO 25 ILIG=MAX(2,LIDMOR),LIFMOR
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(ILIG-1) 
*              Boucle sur les plages d'une ligne de la matrice bimorse
               DO 24 NUMPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUMPLA)  
                  LGCUML=IPLAGL(2,NUMPLA)
                  KOLFIN=KOLDEB+LGCUML-LGCUAL  
                  IPTMOR=MCMORS-1+LGCUAL+MAX(0,LIDPLE-KOLDEB)
                  LGCUAL=LGCUML+1
*                 Boucle sur les colonnes d'une plage de la matrice bimorse
                  DO 23 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE)  
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 22 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
22                   CONTINUE
                     IPTMOR=IPTMOR+1
23                CONTINUE
24             CONTINUE
               IADRES=IADRES+INCREC
25          CONTINUE
         ELSE  
*           Boucle sur les lignes de la matrice bimorse
            DO 35 ILIG=MAX (2,LIDMOR),LIFMOR
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(ILIG-1) 
*              Boucle sur les plages d'une ligne de la matrice bimorse
               DO 34 NUMPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUMPLA)  
                  LGCUML=IPLAGL(2,NUMPLA)
                  KOLFIN=KOLDEB+LGCUML-LGCUAL  
                  IPTMOR=MCMORS-1+LGCUAL+MAX(0,LIDPLE-KOLDEB)
                  LGCUAL=LGCUML+1
*                 Boucle sur les colonnes d'une plage de la matrice bimorse
                  DO 33 ICOL=MAX (KOLDEB,LIDPLE),MIN (KOLFIN,LIFPLE)  
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 32 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
32                   CONTINUE
                     IPTMOR=IPTMOR+1
33                CONTINUE
34             CONTINUE
               IADRES=IADRES+INCREC
35          CONTINUE
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE  ('*Bmlpl * Incompatibilite entre le type reel des'
     *//' operandes et le type COMPLEXE du resultat')                   !Utilite
90002 CALL BAISE  ('*Bmlpl * Incompatibilite entre les types reel et'
     *//' complexe des operandes et le type REEL du resultat')          !Utilite
                                                                    END !Bmlpl
