*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M L V C (NBLIGN,NULAPL,IPLAGL,TYMATR,MCL 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov. 91
*  
*   Produit LxV d'une matrice L strictement triangulaire inferieure
*   stockee sous forme 'Bi-Morse' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p. 
*  
*** Arguments d'entree *** 
* NBLIGN: nombre de lignes de la matrice L
* NULAPL: numeros des dernieres plages de chaque ligne
* IPLAGL: numeros de colonne de debut de plage et adresses des derniers
*         coefficients de chaque plage
* TYMATR: Type (reel ou complexe) de la matrice L
* MCL   : adresse dans le super-tab. de type adhoc de L 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NULAPL(*),IPLAGL(2,*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*
      MC=MCL
      MCRR=MCRESU
      NUDRPL=0
      LGCUAL=1
      LIGNM1=1
      IF (TYRESU(1:1).EQ.'R') THEN
*
*        Vecteur resultat de type reel
* 
         IF (TYMATR(1:1).NE.'R'.OR.TYVECT(1:1).NE.'R') GO TO 90001
         DO 222 LIGNE=2,NBLIGN
            MCRR=MCRR+1  
            RCOEFF=RST(MCRR)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNM1)
            LIGNM1=LIGNE
            DO 221 NUPL=NUPRPL,NUDRPL
               KOLDEB=IPLAGL(1,NUPL)
               LGCUMU=IPLAGL(2,NUPL)
               KOLFIN=KOLDEB+LGCUMU-LGCUAL
               LGCUAL=LGCUMU+1
               DO 221 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                  RCOEFF=RCOEFF+RST(MC)*RST(MCVV)
221               MC=MC+1       
            RST(MCRR)=RCOEFF
222         CONTINUE
*
*     Vecteur resultat de type complexe
*
      ELSEIF (TYMATR(1:1).EQ.'C') THEN 
         IF (TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=2,NBLIGN 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNM1)
               LIGNM1=LIGNE
               DO 443 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 443 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+CST(MC)*CST(MCVV)
443                  MC=MC+1                
444            CST(MCRR)=CCOEFF
         ELSE
            DO 424 LIGNE=2,NBLIGN 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNM1)
               LIGNM1=LIGNE
               DO 423 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 423 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+CST(MC)*RST(MCVV)
423                  MC=MC+1                
424            CST(MCRR)=CCOEFF  
         END IF
      ELSEIF (TYMATR(1:1).EQ.'R') THEN 
         IF (TYVECT(1:1).EQ.'C') THEN
            DO 244 LIGNE=2,NBLIGN
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNM1)
               LIGNM1=LIGNE
               DO 243 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 243 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+RST(MC)*CST(MCVV)
243                  MC=MC+1                
244            CST(MCRR)=CCOEFF
         ELSE
            DO 224 LIGNE=2,NBLIGN
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNM1)
               LIGNM1=LIGNE
               DO 223 NUPL=NUPRPL,NUDRPL
                  KOLDEB=IPLAGL(1,NUPL)
                  LGCUMU=IPLAGL(2,NUPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 223 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                     CCOEFF=CCOEFF+RST(MC)*RST(MCVV)
223                  MC=MC+1                
224            CST(MCRR)=CCOEFF
         END IF
      END IF
      RETURN
90001 CALL BAISE('*BmLVc * Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *BmLVc*
