*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  BMUPL (LIDMOR,LIFMOR,NULAPU,IPLAGU,TYMORS,MCMORS
     &                  ,LIDPLE,LIFPLE,KODPLE,KOFPLE,TYPLEI,MCPLEI
     &                  ,INCREL,INCREC,TYRESU,MCRESU,RST,CST) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 92) 
* Derniere modification : D.Martin (3 Juillet 1997)
*  
* Produit MxP d'un bloc de colonnes completes du triangle superieur de
* la matrice M compactee 'BiMorse' stockee colonne apres colonne, par 
* un bloc de colonnes d'une matrice 'Plein' stockee colonne apres colonne.
* Le resultat est range par ligne incomplete. 
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* LIDMOR premiere ligne de la matrice morse intervenant dans le produit
* LIFMOR derniere ligne de la matrice morse intervenant dans le produit
* NULAPU tableau des numeros de derniere plage de chaque ligne
* IPLAGU numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMORS type (reel ou complexe) de la matrice morse  
* MCMORS adresse de la matrice compactee dans le super-tableau ad hoc 
* LIDPLE numero de premiere ligne dans la matrice pleine  
* LIFPLE numero de derniere ligne dans la matrice pleine  
* KODPLE numero de premiere colonne du bloc dans la matrice pleine
* KOFPLE numero de derniere colonne du bloc dans la matrice pleine
* TYPLEI type (reel ou complexe) de la matrice pleine 
* MCPLEI adresse de la matrice pleine dans le super-tableau ad hoc
* INCREL increment lors d'un changement sur la ligne du resultat
* INCREC increment lors d'un changement sur la colonne
*        (Ces indices permettent de transposer ou non le resultat)
* MCRESU: adresse de la matrice morceau de resultat
* RST,CST: super-tableau considere reel ou complexe
*  
*-- Remarques --
* 1) Les calculs sont effectues avec les pointeurs de compactage de
*    la matrice bimorse superieure; mais ne sont utilises que les  
*    coeff. situes entre les colonnes de numeros LIDPLE et LIFPLE. 
* 2) Exemples d'utilisation de INCREL et INCREC:
*    - resultat range par ligne   INCREL=1,INCREC=KOFPLE-KODPLE+1
*    - resultat range par colonne INCREL=IDRLIG-IPRLIG+1,INCREC=1
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMORS,TYPLEI,TYRESU
      INTEGER LIDMOR,LIFMOR,NULAPU(*),IPLAGU(2,*),MCMORS,LIDPLE,LIFPLE
     &,KODPLE,KOFPLE,MCPLEI,INCREL,INCREC,MCRESU
      REAL    RST(*)
      COMPLEX CST(*)
*-----------------------------------------------------------------------
      NUDRPU=0 
      LGCUAU=1
      IF (LIDPLE.GT.2) THEN 
         NUDRPU=NULAPU(LIDPLE-2)
         LGCUAU=IPLAGU(2,NUDRPU)+1 
      ENDIF
*->   Increment pour changement de colonne dans la matrice pleine  
      INCPLE=LIFPLE-LIDPLE+1
      IF (TYMORS(1:1).EQ.'R') THEN  
         IF (TYPLEI(1:1).EQ.'R') THEN
            IF (TYRESU(1:1).NE.'R') GOTO 90001 
*           Boucle sur les colonnes de la matrice bimorse
            DO 5 ICOL=MAX(2,LIDPLE),LIFPLE
               NUPRPU=NUDRPU+1
               NUDRPU=NULAPU(ICOL-1) 
*              Boucle sur les plages d'une colonne de la matrice bimorse
               DO 4 NUMPLA=NUPRPU,NUDRPU
                  LIGDEB=IPLAGU(1,NUMPLA)  
                  LGCUMU=IPLAGU(2,NUMPLA)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAU  
                  IPTMOR=MCMORS+LGCUAU-1+MAX(0,LIDMOR-LIGDEB)
                  LGCUAU=LGCUMU+1
                  IADRES=(MAX(LIDMOR,LIGDEB)-1)*INCREC
*                 Boucle sur les lignes d'une plage de la matrice bimorse
                  DO 3 ILIG=MAX(LIDMOR,LIGDEB),MIN(LIFMOR,LIGFIN)
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 2 NUCOP=KODPLE,KOFPLE  
                        RST(IPTRES)=RST(IPTRES)+RST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
2                    CONTINUE
                     IPTMOR=IPTMOR+1
                     IADRES=IADRES+INCREC
3                 CONTINUE
4              CONTINUE
5           CONTINUE
         ELSE  
            IF (TYRESU(1:1).NE.'C') GOTO 90002 
*           Boucle sur les colonnes de la matrice bimorse
            DO 15 ICOL=MAX (2,LIDPLE),LIFPLE
               NUPRPU=NUDRPU+1
               NUDRPU=NULAPU(ICOL-1) 
*              Boucle sur les plages d'une colonne de la matrice bimorse
               DO 14 NUMPLA=NUPRPU,NUDRPU
                  LIGDEB=IPLAGU(1,NUMPLA)  
                  LGCUMU=IPLAGU(2,NUMPLA)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAU  
                  IPTMOR=MCMORS+LGCUAU-1+MAX(0,LIDMOR-LIGDEB)
                  LGCUAU=LGCUMU+1
                  IADRES=(MAX (LIDMOR,LIGDEB)-1)*INCREC
*                 Boucle sur les lignes d'une plage de la matrice bimorse
                  DO 13 ILIG=MAX (LIDMOR,LIGDEB),MIN (LIFMOR,LIGFIN)
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 12 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+RST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
12                   CONTINUE
                     IPTMOR=IPTMOR+1
                     IADRES=IADRES+INCREC
13                CONTINUE
14             CONTINUE
15          CONTINUE
         ENDIF
      ELSEIF (TYMORS(1:1).EQ.'C') THEN 
         IF (TYRESU(1:1).NE.'C') GOTO 90002
         IF (TYPLEI(1:1).EQ.'C') THEN
*           Boucle sur les colonnes de la matrice bimorse
            DO 25 ICOL=MAX (2,LIDPLE),LIFPLE
               NUPRPU=NUDRPU+1
               NUDRPU=NULAPU(ICOL-1) 
*              Boucle sur les plages d'une colonne de la matrice bimorse
               DO 24 NUMPLA=NUPRPU,NUDRPU
                  LIGDEB=IPLAGU(1,NUMPLA)  
                  LGCUMU=IPLAGU(2,NUMPLA)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAU  
                  IPTMOR=MCMORS+LGCUAU-1+MAX (0,LIDMOR-LIGDEB)
                  LGCUAU=LGCUMU+1
                  IADRES=(MAX (LIDMOR,LIGDEB)-1)*INCREC
*                 Boucle sur les lignes d'une plage de la matrice bimorse
                  DO 23 ILIG=MAX(LIDMOR,LIGDEB),MIN(LIFMOR,LIGFIN)
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 22 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
22                   CONTINUE
                     IPTMOR=IPTMOR+1
                     IADRES=IADRES+INCREC
23                CONTINUE
24             CONTINUE
25          CONTINUE
         ELSE  
*           Boucle sur les colonnes de la matrice bimorse
            DO 33 ICOL=MAX (2,LIDPLE),LIFPLE
               NUPRPU=NUDRPU+1
               NUDRPU=NULAPU(ICOL-1) 
*              Boucle sur les plages d'une colonne de la matrice bimorse
               DO 33 NUMPLA=NUPRPU,NUDRPU
                  LIGDEB=IPLAGU(1,NUMPLA)  
                  LGCUMU=IPLAGU(2,NUMPLA)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAU  
                  IPTMOR=MCMORS+LGCUAU-1+MAX (0,LIDMOR-LIGDEB)
                  LGCUAU=LGCUMU+1
                  IADRES=(MAX (LIDMOR,LIGDEB)-1)*INCREC
*                 Boucle sur les lignes d'une plage de la matrice bimorse
                  DO 33 ILIG=MAX (LIDMOR,LIGDEB),MIN (LIFMOR,LIGFIN)
                     IPTPLE=MCPLEI+ICOL-LIDPLE
                     IPTRES=MCRESU+IADRES  
*                    Boucle sur les colonnes du resultat
                     DO 32 NUCOP=KODPLE,KOFPLE  
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
32                   CONTINUE
                     IPTMOR=IPTMOR+1
                     IADRES=IADRES+INCREC
33                CONTINUE
34             CONTINUE
35          CONTINUE
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE  ('*Bmupl * Incompatibilite entre le type reel des'
     *//' operandes et le type COMPLEXE du resultat')                   !Utilite
90002 CALL BAISE  ('*Bmupl * Incompatibilite entre les types reel et'
     *//'  complexe des operandes et le type REEL du resultat')         !Utilite
                                                                    END !Bmupl
