*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE B M U V C (NBCOLO,NULAPU,IPLAGU,TYMATR,MCU 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov. 91
*  
*   Produit UxV d'une matrice U strictement triangulaire superieure 
*   stockee sous forme 'Bi-Morse' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p. 
*  
*** Arguments d'entree *** 
* NBCOLO: nombre de colonnes de la matrice U
* NULAPU: numeros des dernieres plages de chaque colonne
* IPLAGU: numeros de ligne de debut de plage et adresses des derniers
*         coefficients de chaque plage
* TYMATR: Type (reel ou complexe) de la matrice U
* MCU   : adresse dans le super-tab. de type adhoc de U 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       NULAPU(*),IPLAGU(2,*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*
      MC=MCU
      MCVV=MCVECT
      NUDRPL=0
      LGCUAL=1
      KOLOM1=1
      IF(TYRESU(1:1).EQ.'R') THEN
*
*        Vecteur resultat de type reel
* 
         IF(TYMATR(1:1).NE.'R'.OR.TYVECT(1:1).NE.'R') GO TO 90001
         DO 222 KOLON=2,NBCOLO 
            MCVV=MCVV+1  
            RCOEFF=RST(MCVV)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPU(KOLOM1)
            KOLOM1=KOLON
            DO 221 NUPL=NUPRPL,NUDRPL
               LIGDEB=IPLAGU(1,NUPL)
               LGCUMU=IPLAGU(2,NUPL)
               LIGFIN=LIGDEB+LGCUMU-LGCUAL
               LGCUAL=LGCUMU+1
               DO 221 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                  RST(MCRR)=RST(MCRR)+RST(MC)*RCOEFF
221               MC=MC+1                
222         CONTINUE
*
*     Vecteur resultat de type complexe
*
      ELSE IF(TYMATR(1:1).EQ.'C') THEN 
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 KOLON=2,NBCOLO 
               MCVV=MCVV+1  
               CCOEFF=CST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(KOLOM1)
               KOLOM1=KOLON
               DO 443 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 443 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+CST(MC)*CCOEFF
443                  MC=MC+1                
444            CONTINUE
         ELSE
            DO 424 KOLON=2,NBCOLO 
               MCVV=MCVV+1  
               RCOEFF=RST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(KOLOM1)
               KOLOM1=KOLON
               DO 423 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 423 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+CST(MC)*RCOEFF
423                  MC=MC+1                
424            CONTINUE  
         END IF
      ELSE IF(TYMATR(1:1).EQ.'R') THEN 
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 244 KOLON=2,NBCOLO
               MCVV=MCVV+1  
               CCOEFF=CST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(KOLOM1)
               KOLOM1=KOLON
               DO 243 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 243 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+RST(MC)*CCOEFF
243                  MC=MC+1                
244            CONTINUE
         ELSE
            DO 224 KOLON=2,NBCOLO
               MCVV=MCVV+1  
               RCOEFF=RST(MCVV)
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPU(KOLOM1)
               KOLOM1=KOLON
               DO 223 NUPL=NUPRPL,NUDRPL
                  LIGDEB=IPLAGU(1,NUPL)
                  LGCUMU=IPLAGU(2,NUPL)
                  LIGFIN=LIGDEB+LGCUMU-LGCUAL
                  LGCUAL=LGCUMU+1
                  DO 223 MCRR=MCRESU-1+LIGDEB,MCRESU-1+LIGFIN
                     CST(MCRR)=CST(MCRR)+RST(MC)*RCOEFF
223                  MC=MC+1                
224            CONTINUE
         END IF
      END IF
      RETURN
90001 CALL BAISE('*BmUVc * Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *BmUVc*
