*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DPL (LIDD,LIFD,TYD,MCD,LIDPLE,LIFPLE,KODPLE
     &               ,KOFPLE,TYPLEI,MCPLEI,INCREL,INCREC
     &               ,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 92) 
* Derniere modification : O.DeBayser (16 Decembre 1992)
*  
* Produit MxP d'un bloc de lignes de la diagonale de la matrice M
* stockee 'BiMorse' stockee ligne apres ligne, par un bloc
* de colonnes d'une matrice stockee 'Pleine' colonne apres colonne.
* Le resultat est range par ligne incomplete.
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree --
* LIDD   premiere ligne de la matrice diagonale intervenant dans le produit
* LIFD   derniere ligne de la matrice diagonale intervenant dans le produit
* TYD    type (reel ou complexe) de la matrice diagonale
* MCD    adresse de la matrice diagonale
* LIDPLE numero de premiere ligne dans la matrice pleine
* LIFPLE numero de derniere ligne dans la matrice pleine
* KODPLE numero de premiere colonne du bloc dans la matrice pleine
* KOFPLE numero de derniere colonne du bloc dans la matrice pleine
* TYPLEI type (reel ou complexe) de la matrice pleine
* MCPLEI adresse de la matrice pleine dans le super-tableau ad hoc
* INCREL increment lors d'un changement dans la ligne du resultat
* INCREC increment lors d'un changement dans la colonne du resultat
*         (Ces indices permettent de transposer ou non le resultat)
* MCRESU adresse de la matrice morceau de resultat
* RST,CST super-tableau considere reel ou complexe
*  
*-- Remarques --
* 1) Les calculs sont effectues avec les pointeurs diagonaux de
*    la matrice bimorse complete; mais ne sont utilises que les
*    coeff. situes entre les colonnes de numeros LIDPLE et LIFPLE.
* 2) Exemples d'utilisation de INCREL et INCREC:
*    - resultat range par ligne   INCREL=1,INCREC=KOFPLE-KODPLE+1
*    - resultat range par colonne INCREL=IDRLIG-IPRLIG+1,INCREC=1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYD,TYPLEI,TYRESU
      REAL    RST(*)
      COMPLEX CST(*)
*-----------------------------------------------------------------------
*  
*->   Increment pour changement de colonne dans la matrice pleine  
      INCPLE=LIFPLE-LIDPLE+1
      IADRES=0 
      LIGDEB=MAX (LIDD,LIDPLE)
      IPTD=MCD-1+LIGDEB
*
      IF (TYD(1:1).EQ.'R') THEN
*
         IF (TYPLEI(1:1).EQ.'R') THEN
            IF (TYRESU(1:1).NE.'R') GOTO 90001
*           Boucle sur les lignes de la matrice
            DO 3 ILIG=LIGDEB,MIN(LIFD,LIFPLE)  
               IPTRES=MCRESU+IADRES  
               IPTPLE=MCPLEI+ILIG-LIDPLE
*              Boucle sur les colonnes du resultat
               DO 2 NUCOP=KODPLE,KOFPLE  
                  RST(IPTRES)=RST(IPTRES)+RST(IPTD)*RST(IPTPLE)
                  IPTRES=IPTRES+INCREL
2                 IPTPLE=IPTPLE+INCPLE
               IADRES=IADRES+INCREC
3           IPTD=IPTD+1
         ELSE  
            IF (TYRESU(1:1).NE.'C') GO TO 90002
*           Boucle sur les lignes de la matrice
            DO 13 ILIG=LIGDEB,MIN(LIFD,LIFPLE)  
               IPTRES=MCRESU+IADRES  
               IPTPLE=MCPLEI+ILIG-LIDPLE
*              Boucle sur les colonnes du resultat
               DO 12 NUCOP=KODPLE,KOFPLE  
                  CST(IPTRES)=CST(IPTRES)+RST(IPTD)*CST(IPTPLE)
                  IPTRES=IPTRES+INCREL
12                IPTPLE=IPTPLE+INCPLE
               IADRES=IADRES+INCREC
13          IPTD=IPTD+1
         ENDIF
*
      ELSEIF (TYD(1:1).EQ.'C') THEN
*
         IF (TYRESU(1:1).NE.'C') GO TO 90002
         IF (TYPLEI(1:1).EQ.'C') THEN
*           Boucle sur les lignes de la matrice
            DO 23 ILIG=LIGDEB,MIN(LIFD,LIFPLE)  
               IPTRES=MCRESU+IADRES  
               IPTPLE=MCPLEI+ILIG-LIDPLE
*              Boucle sur les colonnes du resultat
               DO 22 NUCOP=KODPLE,KOFPLE  
                  CST(IPTRES)=CST(IPTRES)+CST(IPTD)*CST(IPTPLE)
                  IPTRES=IPTRES+INCREL
22                IPTPLE=IPTPLE+INCPLE
               IADRES=IADRES+INCREC
23          IPTD=IPTD+1
         ELSE  
*           Boucle sur les lignes de la matrice
            DO 33 ILIG=LIGDEB,MIN(LIFD,LIFPLE)  
               IPTRES=MCRESU+IADRES  
               IPTPLE=MCPLEI+ILIG-LIDPLE
*              Boucle sur les colonnes du resultat
               DO 32 NUCOP=KODPLE,KOFPLE  
                  CST(IPTRES)=CST(IPTRES)+CST(IPTD)*RST(IPTPLE)
                  IPTRES=IPTRES+INCREL
32                IPTPLE=IPTPLE+INCPLE
               IADRES=IADRES+INCREC
33          IPTD=IPTD+1
         ENDIF
*
      ENDIF
*
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE('*Dpl   * Incompatibilite entre le type reel des'
     &//' operandes et le type COMPLEXE du resultat.')
90002 CALL BAISE('*Dpl   * Incompatibilite entre les types reel et'
     &//' complexe des operandes et le type REEL du resultat.')
                                                                    END !Dpl
