*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DXML  (MOOUBM,TYDIAG,MCDIAG,NBLIGN,NULAPL,IPLAGL
     &                 ,TYMATR,MCMATR,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (12 juin 2008)  
* Derniere modification : D.Martin (12 juin 2008)
* Version 0
*
* Produit D x M d'une matrice D diagonale par la partie triangulaire
* inferieure stricte d'une matrice stockee sous forme 'Bi-Morse'.
*   ou 
* Produit D x M d'une matrice D diagonale par une matrice M stockee 'Morse-L'.
* La matrice resultat est stockee selon le meme stockage que la matrice M
*  
*-- Arguments d'entree
* MOOUBM indicateur de matrice Bimorse (1) ou non (0)
* TYDIAG type (reel ou complexe) de la matrice D
* MCDIAG adresse dans le super-tableau de type ad'hoc de D 
* NBLIGN nombre de lignes de matrice M
* NULAPL numeros des dernieres plages de chaque ligne
* IPLAGL numeros de colonne de debut de plage et adresses des derniers
*        coefficients de chaque plage
* TYMATR type (reel ou complexe) de la matrice M
* MCMATR adresse de la partie triangulaire inferieure stricte de la matrice M
*    ou  adresse dans le super-tableau de type adhoc de M 
* MCRESU adresse de la partie triangulaire inferieure stricte du resultat
*    ou  adresse dans le super-tableau de type adhoc de la matrice resultat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       MOOUBM,NBLIGN,NULAPL(*),IPLAGL(2,*),MCMATR
      CHARACTER*(*) TYDIAG,TYMATR
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER MCR,MCM1,MCML,MCM,MCD,NUPRPL,NUDRPL,LIGNE,LGCUAV,LGCUMU
      REAL    RCOEF
      COMPLEX CCOEF
*-----------------------------------------------------------------------
      MCM1=MCMATR
      MCR=MCRESU
      NUDRPL=0
      LGCUAV=0
      MCD=MCDIAG+MOOUBM
*
      DO 101 LIGNE=1+MOOUBM,NBLIGN
*        Premiere plage sur la ligne
         NUPRPL=NUDRPL+1
*        Derniere plage sur la ligne
         NUDRPL=NULAPL(LIGNE-MOOUBM)
*        Calcul de l'adresse du dernier coefficient de la ligne de M
         LGCUMU=IPLAGL(2,NUDRPL)
         MCML=MCM1+LGCUMU-LGCUAV
*        Multiplication de tous les coefficients de la ligne LIGNE de M
*        par le coefficient diagonal de la ligne LIGNE de D
         IF (TYDIAG(1:1).EQ.'C') THEN
*           Matrice diagonale complexe
            CCOEF=CST(MCD)
            IF (TYMATR(1:1).EQ.'C') THEN
               DO 44 MCM=MCM1,MCML-1
                  CST(MCR) = CCOEF*CST(MCM)
                  MCR=MCR+1
44             CONTINUE
            ELSE
               DO 42 MCM=MCM1,MCML-1
                  CST(MCR)=CCOEF*RST(MCM)
                  MCR=MCR+1
42             CONTINUE
            ENDIF
         ELSE
*           Matrice diagonale reelle
            RCOEF=RST(MCD)
            IF (TYMATR(1:1).EQ.'C') THEN
               DO 24 MCM=MCM1,MCML-1
                  CST(MCR) = RCOEF*CST(MCM)
                  MCR=MCR+1
24             CONTINUE
            ELSE
               DO 22 MCM=MCM1,MCML-1
                  RST(MCR) = RCOEF*RST(MCM)
                  MCR=MCR+1
22             CONTINUE
            ENDIF
         ENDIF
         MCM1=MCML
         LGCUAV=LGCUMU
         MCD=MCD+1
101   CONTINUE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 1 : D.Martin (12 juin 2008)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DxMl
