*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DXMU   (MOOUBM,TYDIAG,MCDIAG,NBCOLO,NULAPU,IPLAGU
     &                  ,TYMATR,MCMATR,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (19 octobre 2006)  
* Derniere modification : D.Martin (12 juin 2008)
* Version 0
*  
* Produit D x M d'une matrice D diagonale par la partie triangulaire
* superieure stricte d'une matrice stockee sous forme 'Bi-Morse'.
*   ou 
* Produit D x M d'une matrice D diagonale par une matrice M stockee 'Morse-L'.
* La matrice resultat est stockee selon le meme stockage que la matrice M.
*  
*-- Arguments d'entree
* MOOUBM indicateur de matrice Bimorse (1) ou non (0)
* TYDIAG type (reel ou complexe) de la matrice D
* MCDIAG adresse dans le super-tableau de type ad'hoc de D 
* NBCOLO nombre de colonnes de la matrice M
* NULAPU numeros des dernieres plages de chaque colonne
* IPLAGU numeros de ligne de debut de plage et adresses des derniers
*        coefficients de chaque plage
* TYMATR type (reel ou complexe) de la matrice M
* MCMATR adresse de la partie triangulaire superieure stricte de la matrice M
*    ou  adresse dans le super-tableau de type adhoc de M 
* MCRESU adresse de la partie triangulaire superieure stricte du resultat
*    ou  adresse dans le super-tableau de type adhoc de la matrice resultat
* RST,CST super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       MOOUBM,NBCOLO,NULAPU(*),IPLAGU(2,*),MCMATR
      CHARACTER*(*) TYDIAG,TYMATR
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER MCR,MCM,MCD,NUPRPL,NUDRPL,KOLON,LGCUAV,LGCUMU
      REAL    RCOEF
      COMPLEX CCOEF
*-----------------------------------------------------------------------
      MCM=MCMATR
      MCR=MCRESU
      NUDRPL=0
      LGCUAV=1
*
      DO 101 KOLON=1+MOOUBM,NBCOLO
*        Premiere plage sur la colonne
         NUPRPL=NUDRPL+1
*        Derniere plage sur la colonne
         NUDRPL=NULAPU(KOLON-MOOUBM)
         DO 100 NUPL=NUPRPL,NUDRPL
*           Premiere ligne de la plage sur la colonne
            LIGDEB=IPLAGU(1,NUPL)
            LGCUMU=IPLAGU(2,NUPL)
*           Derniere ligne de la plage sur la colonne
            LIGFIN=LIGDEB+LGCUMU-LGCUAV
            LGCUAV=LGCUMU+1
*           Multiplication de tous les coefficients de la colonne KOLON de M
*           par les coefficients diagonaux des lignes correspondantes de D
            IF (TYDIAG(1:1).EQ.'C') THEN
*              Matrice diagonale complexe
               IF (TYMATR(1:1).EQ.'C') THEN
                  DO 44 MCD=MCDIAG-1+LIGDEB,MCDIAG-1+LIGFIN
                     CST(MCR)=CST(MCD)*CST(MCM)
                     MCM=MCM+1
                     MCR=MCR+1
44                CONTINUE
               ELSE
                  DO 42 MCD=MCDIAG-1+LIGDEB,MCDIAG-1+LIGFIN
                     CST(MCR)=CST(MCD)*RST(MCM)
                     MCM=MCM+1
                     MCR=MCR+1
42                CONTINUE
               ENDIF
            ELSE
*              Matrice diagonale reelle
               IF (TYMATR(1:1).EQ.'C') THEN
                  DO 24 MCD=MCDIAG-1+LIGDEB,MCDIAG-1+LIGFIN
                     CST(MCR)=RST(MCD)*CST(MCM)
                     MCM=MCM+1
                     MCR=MCR+1
24                CONTINUE
               ELSE
                  DO 22 MCD=MCDIAG-1+LIGDEB,MCDIAG-1+LIGFIN
                     RST(MCR)=RST(MCD)*RST(MCM)
                     MCM=MCM+1
                     MCR=MCR+1
22                CONTINUE
               ENDIF
            ENDIF
100      CONTINUE
101   CONTINUE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (12 juin 2008)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DxMu
