*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DXPL  (TYDIAG,MCDIAG
     &                 ,NBLIGN,NBCOLO,TYMATR,STMATR,MCMATR
     &                 ,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (19 octobre 2006)
* Derniere modification : D.Martin (19 octobre 2006)
* Version 0
*
* Produit D x M d'une matrice diagonale D par une matrice PLEIN-L/C M 
*
* La matrice D est reelle ou complexe
* La matrice M peut etre stockee sous forme PLEIN-L ou PLEIN-C
* La matrice resultat a le meme type de stockage que la matrice M
*
*
*-- Arguments d'entree --
* TYDIAG Type (reel ou complexe) de la matrice D
* MCDIAG adresse dans le super-tableau de type ad'hoc de D
* NBLIGN nombre de lignes de la matrice M
* NBCOLO nombre de colonnes de la matrice M
* TYMATR Type (reel ou complexe) de la matrice M
* STMATR type de stockage de la matrice M (PLEIN-L ou PLEIN-C)
* MCMATR adresse de la matrice M
* MCRESU adresse de la matrice resultat dans le super-tableau ad'hoc
* RST,CST super tableau, version REEL et COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYDIAG,TYMATR,STMATR
      INTEGER       MCDIAG,NBLIGN,NBCOLO,MCMATR,MCRESU
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER INCMAC,INCMAL,AI1,AIJ,RI1,RIJ,DII,I,J
      REAL    RRIJ
      COMPLEX CRIJ
*-----------------------------------------------------------------------
*
*     Increments de changement de ligne ou de colonne selon le stockage
*
*     INCMAC : increment d'adresse pour le changement de colonne dans M
*     INCMAL : increment d'adresse pour le changement de ligne dans M
      INCMAL=1
      INCMAC=1
      IF (STMATR.EQ.'PLEIN-C') THEN
         INCMAC=NBLIGN
      ELSEIF (STMATR.EQ.'PLEIN-L') THEN
         INCMAL=NBCOLO
      ELSE
         CALL BAISE  ('DxPL : Matrice M non  PLEIN-L ou PLEIN-C.')
      ENDIF
*
      AI1=MCMATR
      RI1=MCRESU
      DII=MCDIAG
*
      IF (TYDIAG(1:1).EQ.'C') THEN
*  
         IF (TYMATR(1:1).EQ.'C') THEN
*
*           Matrice D complexe et matrice M complexe ==> R complexe
*
            DO 441 I=1,NBLIGN
*              Adresse du 1er coeff. de la ligne I de R
               RIJ=RI1
               AIJ=AI1
               DO 440 J=1,NBCOLO
                  CST(RIJ)=CST(DII)*CST(AIJ)
                  AIJ=AIJ+INCMAC
                  RIJ=RIJ+INCMAC
440            CONTINUE
*              Adresse du 1er coeff. de la prochaine ligne de A
               AI1=AI1+INCMAL
*              Adresse du 1er coeff. de la prochaine ligne de R
               RI1=RI1+INCMAL
               DII=DII+1
441         CONTINUE
*
         ELSE
*
*           Matrice D complexe et matrice M reelle ==> R complexe
*
            DO 421 I=1,NBLIGN
               RIJ=RI1
               AIJ=AI1
               DO 420 J=1,NBCOLO
                  CST(RIJ)=CST(DII)*RST(AIJ)
                  AIJ=AIJ+INCMAC
                  RIJ=RIJ+INCMAC
420            CONTINUE
               AI1=AI1+INCMAL
               RI1=RI1+INCMAL
               DII=DII+1
421         CONTINUE
*
         ENDIF
*
      ELSE
*
         IF (TYMATR(1:1).EQ.'C') THEN  
*
*           Matrice D reelle et matrice M complexe ==> R complexe
*
            DO 241 I=1,NBLIGN
               RIJ=RI1
               AIJ=AI1
               DO 240 J=1,NBCOLO
                  CST(RIJ)=RST(DII)*CST(AIJ)
                  AIJ=AIJ+INCMAC
                  RIJ=RIJ+INCMAC
240            CONTINUE
               AI1=AI1+INCMAL
               RI1=RI1+INCMAL
               DII=DII+1
241         CONTINUE
*
         ELSE
*         
*           Matrices D et M sont reelles ==> R reelle
*
            DO 221 I=1,NBLIGN
               RIJ=RI1
               AIJ=AI1
               DO 220 J=1,NBCOLO
                  RST(RIJ)=RST(DII)*RST(AIJ)
                  AIJ=AIJ+INCMAC
                  RIJ=RIJ+INCMAC
220            CONTINUE
               AI1=AI1+INCMAL
               RI1=RI1+INCMAL
               DII=DII+1
221         CONTINUE
*
         ENDIF
*
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (19 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !DxPl
