*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE M O A V C (NBLIGM,NBCOLM,NULAPL,IPLAGE,TYMORS,MCMORS  
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Dec. 89)  
* Derniere modification (D.Martin) le 16 Oct. 90
*  
*   Produit M*xV de la transposee (cas reel) ou adjointe (cas complexe) d'une  
*   matrice M stockee compactee 'Morse' ligne apres ligne par un vecteur
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*** Arguments d'entree *** 
* NBLIGM: Nombre de lignes de la matrice M 
* NBCOLM: Nombre de colonnes de la matrice (argument inutilise)
* NULAPL: Tableau des numeros de derniere plage de chaque ligne
* IPLAGE: Numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMORS: type (reel ou complexe) de la matrice morse  
* MCMORS: adresse de la matrice compactee dans le super-tableau ad hoc 
* TYVECT: type (reel ou complexe) du vecteur operande  
* MCVECT: adresse de la matrice pleine dans le super-tableau ad hoc
* TYRESU: type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat  
* RST,CST: super-tableau considere reel ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMORS,TYVECT,TYRESU
      INTEGER       NULAPL(*),IPLAGE(2,*)  
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*  
      IF(TYMORS(1:1).EQ.'R') THEN  
         CALL MOTVC (NBLIGM,NBCOLM,NULAPL,IPLAGE,TYMORS,MCMORS          !Multmat
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)!Multmat
      ELSE IF(TYMORS(1:1).EQ.'C') THEN 
         IF(TYRESU(1:1).NE.'C') GO TO 90002
         NUDRPL=0  
         LGCUMU=0  
         IADVEC=MCVECT 
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 31 LIGNE=1,NBLIGM
               CCOEFF=CST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
               MCCOEF=MCMORS+LGCUMU
               DO 30 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 30 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     CST(IADRES)=CST(IADRES)+CCOEFF*CONJG(CST(MCCOEF)) 
30                   MCCOEF=MCCOEF+1
31             IADVEC=IADVEC+1 
         ELSE  
            DO 41 LIGNE=1,NBLIGM
               CCOEFF=RST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
               MCCOEF=MCMORS+LGCUMU
               DO 40 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 40 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     CST(IADRES)=CST(IADRES)+CCOEFF*CONJG(CST(MCCOEF)) 
40                   MCCOEF=MCCOEF+1
41             IADVEC=IADVEC+1 
         END IF
      END IF
      RETURN
90002 CALL BAISE('*MoaVc * Incompatibilite entre les types reel et compl
     *exe des operandes et le type REEL du resultat')  
                                                                    END *MoaVc *
