*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MOLMOC (KOLDR
     &                  ,PRPLL,DRPLL,LGCUL,IPLAGL,TYPL,MCL,RSTL,CSTL  
     &                  ,PRPLU,DRPLU,LGCUU,IPLAGU,TYPU,MCU,RSTU,CSTU
     &                  ,COEFF)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (fevrier 1990)
* Derniere modification : D.Martin (16 octobre 1990)
* Version 1.0.0
*  
* Produit scalaire partiel d'une ligne d'une matrice L stockee 'MORSE ligne'
* par une colonne d'une matrice U stockee 'MORSE colonne'  
*  
*-- Arguments d'entree -- 
* KOLDR  numero de derniere colonne de la ligne pour laquelle a lieu la
*        multiplication
* PRPLL  numero de la premiere plage de la ligne de la matrice L
* DRPLL  numero de la plage de la ligne de L contenant la colonne KOLDR
* LGCUL  longueur cumulee des lignes de L precedant la ligne en cours  
* IPLAGL tableau des numeros de debut de plage et des longueurs cumulees
*        du compactage 'MORSE' ligne de la matrice L
* TYPL   type (REEL,COMPLEXE) de la matrice L  
* MCL    adresse en M.C. de la mat. L dans le tab. reel RSTL ou complexe CSTL  
* RSTL   tableau contenant la matrice L (cas reel) 
* CSTL   tableau contenant la matrice L (cas complexe) 
* PRPLU,DRPLU,LGCUU,IPLAGU,TYPU,MCU,RSTU,CSTU : Idem pour la matrice U 
*        mais pour le compactage 'Morse colonne'
*  
*-- Argument de sortie -- 
* COEFF  resultat COMPLEXE du produit quel que soit le type des matrices
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPL,TYPU  
      INTEGER       PRPLL,DRPLL,IPLAGL(2,*),PRPLU,DRPLU,IPLAGU(2,*)
      REAL          RSTL(*),RSTU(*)
      COMPLEX       CSTL(*),CSTU(*),COEFF,DOTPRO
*-----------------------------------------------------------------------  
      COEFF=0. 
*  
*     Adresse du premier coeff. de la plage PRPLU de U et  
*     longueur cumulee, numeros de debut et de fin de plage
      LIGDBU=IPLAGU(1,PRPLU)
      IF (LIGDBU.GT.KOLDR) RETURN
      IADUKJ=LGCUU+1
      LGCUU=IPLAGU(2,PRPLU)
      LIGFNU=MIN(KOLDR,LIGDBU+LGCUU-IADUKJ)
      NUPLU=PRPLU
*  
*     Boucle sur les plages des coefficients Lik
*  
      IF (TYPU(1:1).EQ.TYPL(1:1)) THEN  
         IF (TYPL(1:1).EQ.'R') THEN 
*
            DO 10 NUPLL=PRPLL,DRPLL  
*              Adresse du premier coeff. de la plage NUPLL de L et
*              longueur cumulee, numeros de debut et de fin de plage 
               IADLIK=LGCUL+1
               LGCUL=IPLAGL(2,NUPLL) 
               KOLDBL=IPLAGL(1,NUPLL)
               KOLFNL=MIN(KOLDR,KOLDBL+LGCUL-IADLIK) 
3              IF (KOLFNL.GE.LIGDBU) THEN 
                  IF (KOLDBL.LE.LIGFNU) THEN  
*                    Cas d'une intersection non vide entre les numeros de colonne
*                    de la ligne de L et les numeros de ligne de la colonne de U 
                     IRIP=KOLDBL-LIGDBU  
*                    Cumul de Somme( Lik x Ukj ) pour les numeros k communs  
*                    a la plage en colonne de L et a la plage en ligne de U  
                     NBCOEF=MIN(KOLFNL,LIGFNU)-MAX(KOLDBL,LIGDBU)+1 
                     DOTPRO=0.
                     MCT2=MCU-1+IADUKJ+MAX(0,IRIP)
                     MCT1=MCL-1+IADLIK-MIN(0,IRIP)
                     DO 5 ICOEF=MCT1,MCT1-1+NBCOEF
                        DOTPRO=DOTPRO+RSTL(ICOEF)*RSTU(MCT2)
5                       MCT2=MCT2+1 
                     COEFF=COEFF+DOTPRO  
                  ENDIF 
*                 On doit s'assurer, avant de changer de plage en L, de l'epuisement 
*                 des plages de U dont la fin est anterieure a celle de la plage de L
                  IF (LIGFNU.LT.KOLFNL) THEN  
*                    Passage a la plage suivante de la colonne de U  
                     NUPLU=NUPLU+1
                     IF (NUPLU.GT.DRPLU) RETURN
                     LIGDBU=IPLAGU(1,NUPLU)  
                     IF (LIGDBU.GT.KOLDR) RETURN  
                     IADUKJ=LGCUU+1 
                     LGCUU=IPLAGU(2,NUPLU)
                     LIGFNU=LIGDBU+LGCUU-IADUKJ  
                     GOTO 3 
                  ENDIF 
               ENDIF
10          CONTINUE 
*
         ELSEIF (TYPL(1:1).EQ.'C') THEN
*  
            DO 20 NUPLL=PRPLL,DRPLL  
               IADLIK=LGCUL+1
               LGCUL=IPLAGL(2,NUPLL) 
               KOLDBL=IPLAGL(1,NUPLL)
               KOLFNL=MIN(KOLDR,KOLDBL+LGCUL-IADLIK) 
13             IF (KOLFNL.GE.LIGDBU) THEN 
                  IF (KOLDBL.LE.LIGFNU) THEN  
                     IRIP=KOLDBL-LIGDBU  
                     NBCOEF=MIN(KOLFNL,LIGFNU)-MAX(KOLDBL,LIGDBU)+1 
                     DOTPRO=0.
                     MCT2=MCU-1+IADUKJ+MAX(0,IRIP)
                     MCT1=MCL-1+IADLIK-MIN(0,IRIP)
                     DO 15 ICOEF=MCT1,MCT1-1+NBCOEF
                        DOTPRO=DOTPRO+CSTL(ICOEF)*CSTU(MCT2)
15                      MCT2=MCT2+1 
                     COEFF=COEFF+DOTPRO  
                  ENDIF 
                  IF (LIGFNU.LT.KOLFNL) THEN  
                     NUPLU=NUPLU+1
                     IF (NUPLU.GT.DRPLU) RETURN
                     LIGDBU=IPLAGU(1,NUPLU)  
                     IF (LIGDBU.GT.KOLDR) RETURN  
                     IADUKJ=LGCUU+1 
                     LGCUU=IPLAGU(2,NUPLU)
                     LIGFNU=LIGDBU+LGCUU-IADUKJ  
                     GOTO 13
                  ENDIF 
               ENDIF
20          CONTINUE 
*
         ENDIF
*
      ELSEIF (TYPL(1:1).EQ.'C') THEN
*  
         DO 30 NUPLL=PRPLL,DRPLL  
            IADLIK=LGCUL+1
            LGCUL=IPLAGL(2,NUPLL) 
            KOLDBL=IPLAGL(1,NUPLL)
            KOLFNL=MIN(KOLDR,KOLDBL+LGCUL-IADLIK) 
23          IF (KOLFNL.GE.LIGDBU) THEN 
               IF (KOLDBL.LE.LIGFNU) THEN  
                  IRIP=KOLDBL-LIGDBU  
                  NBCOEF=MIN(KOLFNL,LIGFNU)-MAX(KOLDBL,LIGDBU)+1 
                  DOTPRO=0.
                  MCT2=MCU-1+IADUKJ+MAX(0,IRIP)
                  MCT1=MCL-1+IADLIK-MIN(0,IRIP)
                  DO 25 ICOEF=MCT1,MCT1-1+NBCOEF
                     DOTPRO=DOTPRO+CSTL(ICOEF)*RSTU(MCT2)
25                   MCT2=MCT2+1 
                  COEFF=COEFF+DOTPRO  
               ENDIF 
               IF (LIGFNU.LT.KOLFNL) THEN  
                  NUPLU=NUPLU+1
                  IF (NUPLU.GT.DRPLU) RETURN
                  LIGDBU=IPLAGU(1,NUPLU)  
                  IF (LIGDBU.GT.KOLDR) RETURN  
                  IADUKJ=LGCUU+1 
                  LGCUU=IPLAGU(2,NUPLU)
                  LIGFNU=LIGDBU+LGCUU-IADUKJ  
                  GOTO 23 
               ENDIF 
            ENDIF
30       CONTINUE 
*
      ELSEIF (TYPL(1:1).EQ.'R') THEN
*  
         DO 40 NUPLL=PRPLL,DRPLL  
            IADLIK=LGCUL+1
            LGCUL=IPLAGL(2,NUPLL) 
            KOLDBL=IPLAGL(1,NUPLL)
            KOLFNL=MIN(KOLDR,KOLDBL+LGCUL-IADLIK) 
33          IF (KOLFNL.GE.LIGDBU) THEN 
               IF (KOLDBL.LE.LIGFNU) THEN  
                  IRIP=KOLDBL-LIGDBU  
                  NBCOEF=MIN(KOLFNL,LIGFNU)-MAX(KOLDBL,LIGDBU)+1 
                  DOTPRO=0.
                  MCT2=MCU-1+IADUKJ+MAX(0,IRIP)
                  MCT1=MCL-1+IADLIK-MIN(0,IRIP)
                  DO 35 ICOEF=MCT1,MCT1-1+NBCOEF
                     DOTPRO=DOTPRO+RSTL(ICOEF)*CSTU(MCT2)
35                   MCT2=MCT2+1 
                  COEFF=COEFF+DOTPRO  
               ENDIF 
               IF (LIGFNU.LT.KOLFNL) THEN  
                  NUPLU=NUPLU+1
                  IF (NUPLU.GT.DRPLU) RETURN
                  LIGDBU=IPLAGU(1,NUPLU)  
                  IF (LIGDBU.GT.KOLDR) RETURN  
                  IADUKJ=LGCUU+1 
                  LGCUU=IPLAGU(2,NUPLU)
                  LIGFNU=LIGDBU+LGCUU-IADUKJ  
                  GOTO 33 
               ENDIF 
            ENDIF
40       CONTINUE 
*
      ENDIF
                                                                    END !MoLMoC
