*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MOPL (LIDMOR,LIFMOR,NULAPL,IPLAGE,TYMORS,MCMORS
     &                ,LIDPLE,LIFPLE,KODPLE,KOFPLE,TYPLEI,MCPLEI
     &                ,INCREL,INCREC,TYRESU,MCRESU,RST,CST) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser & D.Martin (Octobre 1989) 
* Derniere modification : D.Martin (3 Juillet 1997)
*  
* Produit MxP d'un bloc de lignes completes de la matrice M compactee 'morse'
* stockee ligne apres ligne) par un bloc de colonnes d'une matrice P pleine  
* stockee colonne apres colonne. Le resultat est range par ligne incomplete. 
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* LIDMOR premiere ligne de la matrice morse intervenant dans le produit
* LIFMOR derniere ligne de la matrice morse intervenant dans le produit
* NULAPL tableau des numeros de derniere plage de chaque ligne
* IPLAGE numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMORS type (reel ou complexe) de la matrice morse  
* MCMORS adresse de la matrice compactee dans le super-tableau ad hoc 
* LIDPLE numero de premiere ligne dans la matrice pleine  
* LIFPLE numero de derniere ligne dans la matrice pleine  
* KODPLE numero de premiere colonne du bloc dans la matrice pleine
* KOFPLE numero de derniere colonne du bloc dans la matrice pleine
* TYPLEI type (reel ou complexe) de la matrice pleine 
* MCPLEI adresse de la matrice pleine dans le super-tableau ad hoc
* INCREL increment lors d'un changement dans la ligne du resultat. 
* INCREC increment lors d'un changement dans la colonne du resultat. 
*        (Ces indices permettent de transposer ou non le resultat)
* MCRESU adresse de la matrice morceau de resultat
* RST,CST super-tableau considere reel ou complexe
*  
*-- Remarques --
* 1) Les calculs sont effectues avec les pointeurs de compactage de
*    la matrice morse complete; mais ne sont utilises que les  
*    coeff. situes entre les colonnes de numeros LIDPLE et LIFPLE. 
* 2) Exemples d'utilisation de INCREL et INCREC:
*    - resultat range par ligne   INCREL=1,INCREC=KOFPLE-KODPLE+1
*    - resultat range par colonne INCREL=IDRLIG-IPRLIG+1,INCREC=1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMORS,TYPLEI,TYRESU
      INTEGER LIDMOR,LIFMOR,NULAPL(*),IPLAGE(2,*),MCMORS,LIDPLE,LIFPLE
     &       ,KODPLE,KOFPLE,MCPLEI,INCREL,INCREC,MCRESU
      REAL    RST(*)
      COMPLEX CST(*)
*-----------------------------------------------------------------------
      NUPRPL=1 
      LGCUAV=-1
      IF (LIDMOR.GT.1) THEN 
         NUPRPL=NULAPL(LIDMOR-1)
         LGCUAV=IPLAGE(2,NUPRPL)-1 
         NUPRPL=NUPRPL+1
      ENDIF
*->   Increment pour changement de colonne dans la matrice pleine  
      INCPLE=LIFPLE-LIDPLE+1
      IADRES=0 
      IF (TYMORS(1:1).EQ.'R') THEN  
         IF (TYPLEI(1:1).EQ.'R') THEN
            IF (TYRESU(1:1).NE.'R') GOTO 90001 
            DO 5 ILIG=LIDMOR,LIFMOR
               NFINPL=NULAPL(ILIG) 
*              Boucle sur les plages d'une ligne de la matrice morse
               DO 4 NUMPLA=NUPRPL,NFINPL
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+IPLAGE(2,NUMPLA)-LGCUAV-2  
*                 Boucle sur les colonne d'une plage de la matrice morse
                  LGCUAV=LGCUAV+MAX (0,LIDPLE-KOLDEB)
                  DO 3 ICOL=MAX (KOLDEB,LIDPLE),MIN (KOLFIN,LIFPLE)  
                     LGCUAV=LGCUAV+1
                     IPTMOR=MCMORS+LGCUAV  
*->                  pointeur dans la matrice resultat 
                     IPTRES=MCRESU+IADRES  
*->                  point. dans la matrice pleine(a partir de la ligne LIDPLE)
                     IPTPLE=MCPLEI+ICOL-LIDPLE 
                     DO 2 NUCOP=KODPLE,KOFPLE  
                        RST(IPTRES)=RST(IPTRES)+RST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
2                    CONTINUE
3                 CONTINUE
4              CONTINUE
               IADRES=IADRES+INCREC
               LGCUAV=IPLAGE(2,NFINPL)-1  
               NUPRPL=NFINPL+1
5           CONTINUE
         ELSE  
            IF (TYRESU(1:1).NE.'C') GOTO 90002 
            DO 15 ILIG=LIDMOR,LIFMOR
               NFINPL=NULAPL(ILIG) 
               DO 14 NUMPLA=NUPRPL,NFINPL  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+IPLAGE(2,NUMPLA)-LGCUAV-2  
                  LGCUAV=LGCUAV+MAX(0,LIDPLE-KOLDEB)
                  DO 13 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE) 
                     LGCUAV=LGCUAV+1
                     IPTMOR=MCMORS+LGCUAV  
                     IPTRES=MCRESU+IADRES  
                     IPTPLE=MCPLEI+ICOL-LIDPLE 
                     DO 12 NUCOP=KODPLE,KOFPLE 
                        CST(IPTRES)=CST(IPTRES)+RST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
12                   CONTINUE
13                CONTINUE
14             CONTINUE
               IADRES=IADRES+INCREC
               LGCUAV=IPLAGE(2,NFINPL)-1  
               NUPRPL=NFINPL+1
15          CONTINUE
         ENDIF
      ELSEIF (TYMORS(1:1).EQ.'C') THEN 
         IF (TYRESU(1:1).NE.'C') GOTO 90002
         IF (TYPLEI(1:1).EQ.'C') THEN
            DO 25 ILIG=LIDMOR,LIFMOR
               NFINPL=NULAPL(ILIG) 
               DO 24 NUMPLA=NUPRPL,NFINPL  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+IPLAGE(2,NUMPLA)-LGCUAV-2  
                  LGCUAV=LGCUAV+MAX(0,LIDPLE-KOLDEB)
                  DO 23 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE) 
                     LGCUAV=LGCUAV+1
                     IPTMOR=MCMORS+LGCUAV  
                     IPTRES=MCRESU+IADRES  
                     IPTPLE=MCPLEI+ICOL-LIDPLE 
                     DO 22 NUCOP=KODPLE,KOFPLE 
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*CST(IPTPLE)
                        IPTRES=IPTRES+INCREL
                        IPTPLE=IPTPLE+INCPLE
22                   CONTINUE
23                CONTINUE
24             CONTINUE
               IADRES=IADRES+INCREC
               LGCUAV=IPLAGE(2,NFINPL)-1  
               NUPRPL=NFINPL+1
25          CONTINUE
         ELSE  
            DO 35 ILIG=LIDMOR,LIFMOR
               NFINPL=NULAPL(ILIG) 
               DO 34 NUMPLA=NUPRPL,NFINPL  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+IPLAGE(2,NUMPLA)-LGCUAV-2  
                  LGCUAV=LGCUAV+MAX(0,LIDPLE-KOLDEB)
                  DO 33 ICOL=MAX(KOLDEB,LIDPLE),MIN(KOLFIN,LIFPLE) 
                     LGCUAV=LGCUAV+1
                     IPTMOR=MCMORS+LGCUAV  
                     IPTRES=MCRESU+IADRES  
                     IPTPLE=MCPLEI+ICOL-LIDPLE 
                     DO 32 NUCOP=KODPLE,KOFPLE 
                        CST(IPTRES)=CST(IPTRES)+CST(IPTMOR)*RST(IPTPLE)
                        IPTRES=IPTRES+INCREL
32                   CONTINUE
33                CONTINUE
34             CONTINUE
               IADRES=IADRES+INCREC
               LGCUAV=IPLAGE(2,NFINPL)-1  
               NUPRPL=NFINPL+1
35          CONTINUE
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE  ('*MoPl  * Incompatibilite entre le type reel des'
     *//'operandes et le type COMPLEXE du resultat')                    !Utilite
90002 CALL BAISE  ('*MoPl  * Incompatibilite entre les types reel et'
     *//' complexe des operandes et le type REEL du resultat')          !Utilite
                                                                    END !MoPl
