*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  M O S V C (NBLIGM,NULAPL,IPLAGE,TYMORS,MCMORS
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 91) 
* Derniere modification (D.Martin) le 8 Oct. 91
*  
*   Produit MxV d'une matrice M symetrique stockee compactee 'Morse'
*   ligne apres ligne par un vecteur. Ce sous-programme n'utilise que
*   la partie triangulaire inferieure de la matrice
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*** Arguments d'entree *** 
* NBLIGM: Nombre de lignes de la matrice Morse
* NULAPL: Tableau des numeros de derniere plage de chaque ligne
* IPLAGE: Numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMORS: type (reel ou complexe) de la matrice morse  
* MCMORS: adresse de la matrice compactee morse dans le super-tableau ad hoc 
* TYVECT: type (reel ou complexe) du vecteur operande
* MCVECT: adresse de la matrice pleine dans le super-tableau ad hoc
* TYRESU: type (reel ou complexe) du vecteur resultat
* MCRESU: adresse du vecteur resultat  
* RST,CST: super-tableau considere reel ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMORS,TYVECT,TYRESU
      INTEGER       NULAPL(*),IPLAGE(2,*)  
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF,CCOEFG  
      EQUIVALENCE  (CCOEFF,RCOEFF),(CCOEFG,RCOEFG) 
*  
      NUDRPL=0 
      LGCUAV=0 
      MCR=MCRESU-1
      MCV=MCVECT-1
      IF(TYRESU(1:1).EQ.'R') THEN
*        Cas d'un vecteur resultat reel 
         IF(TYVECT(1:1).EQ.TYMORS(1:1)) THEN
            IF(TYVECT(1:1).EQ.'R') THEN
*              Matrice, vecteur operande et resultat reels
               DO 222 LIGNE=1,NBLIGM
                  NUPRPL=NUDRPL+1
                  NUDRPL=NULAPL(LIGNE)
                  MCV=MCV+1
                  RCOEFG=RST(MCV)
                  MCR=MCR+1
                  RCOEFF=RST(MCR)
*
                  DO 3222 NUPLA=NUPRPL,NUDRPL
                     KOLDEB=IPLAGE(1,NUPLA)
                     LGCUMU=IPLAGE(2,NUPLA)
                     KOLFIN=KOLDEB+LGCUMU-LGCUAV-1
                     IAMORS=MCMORS+LGCUAV
                     LGCUAV=LGCUMU
                     MCRR=MCRESU-1+KOLDEB
                     IF(KOLFIN.LT.LIGNE) THEN
                        DO 1222 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                           RCOEFF   =RCOEFF   +RST(IAMORS)*RST(MCVV)
                           RST(MCRR)=RST(MCRR)+RST(IAMORS)*RCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
1222                       CONTINUE
                     ELSE
                        DO 2222 MCVV=MCVECT-1+KOLDEB,MCVECT-2+LIGNE
                           RCOEFF   =RCOEFF   +RST(IAMORS)*RST(MCVV)
                           RST(MCRR)=RST(MCRR)+RST(IAMORS)*RCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
2222                       CONTINUE
                        IF(KOLDEB.LE.LIGNE)
     *                     RCOEFF   =RCOEFF   +RST(IAMORS)*RCOEFG
                        GO TO 4222
                     END IF
3222                 CONTINUE
*
4222           RST(MCR)=RCOEFF
               LGCUAV=IPLAGE(2,NUDRPL)
222            CONTINUE
            ELSE
*              Matrice, vecteur operande complexes et resultat reel
               GO TO 99442
            END IF
         ELSE IF(TYVECT(1:1).EQ.'R') THEN
*              Matrice complexe, vecteur operande et resultat reels
            GO TO 99422
         ELSE
*              Matrice reelle, vecteur operande complexe, resultat reel
            GO TO 99242
         END IF
*
      ELSE
*        Cas d'un vecteur resultat complexe
         IF(TYVECT(1:1).EQ.TYMORS(1:1)) THEN
            IF(TYVECT(1:1).EQ.'C') THEN
*              Matrice, vecteur operande et resultat complexes
               DO 444 LIGNE=1,NBLIGM
                  NUPRPL=NUDRPL+1
                  NUDRPL=NULAPL(LIGNE)
                  MCV=MCV+1
                  CCOEFG=CST(MCV)
                  MCR=MCR+1
                  CCOEFF=CST(MCR)
*
                  DO 3444 NUPLA=NUPRPL,NUDRPL
                     KOLDEB=IPLAGE(1,NUPLA)
                     LGCUMU=IPLAGE(2,NUPLA)
                     KOLFIN=KOLDEB+LGCUMU-LGCUAV-1
                     IAMORS=MCMORS+LGCUAV
                     LGCUAV=LGCUMU
                     MCRR=MCRESU-1+KOLDEB
                     IF(KOLFIN.LT.LIGNE) THEN
                        DO 1444 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                           CCOEFF   =CCOEFF   +CST(IAMORS)*CST(MCVV)
                           CST(MCRR)=CST(MCRR)+CST(IAMORS)*CCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
1444                       CONTINUE
                     ELSE
                        DO 2444 MCVV=MCVECT-1+KOLDEB,MCVECT-2+LIGNE
                           CCOEFF   =CCOEFF   +CST(IAMORS)*CST(MCVV)
                           CST(MCRR)=CST(MCRR)+CST(IAMORS)*CCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
2444                       CONTINUE
                        IF(KOLDEB.LE.LIGNE)
     *                     CCOEFF   =CCOEFF   +CST(IAMORS)*CCOEFG
                        GO TO 4444
                     END IF
3444                 CONTINUE
*
4444           CST(MCR)=CCOEFF
               LGCUAV=IPLAGE(2,NUDRPL)
444            CONTINUE
            ELSE
*              Matrice reelle, vecteur operande reel et resultat complexe
               DO 224 LIGNE=1,NBLIGM
                  NUPRPL=NUDRPL+1
                  NUDRPL=NULAPL(LIGNE)
                  MCV=MCV+1
                  RCOEFG=RST(MCV)
                  MCR=MCR+1
                  CCOEFF=CST(MCR)
*
                  DO 3224 NUPLA=NUPRPL,NUDRPL
                     KOLDEB=IPLAGE(1,NUPLA)
                     LGCUMU=IPLAGE(2,NUPLA)
                     KOLFIN=KOLDEB+LGCUMU-LGCUAV-1
                     IAMORS=MCMORS+LGCUAV
                     LGCUAV=LGCUMU
                     MCRR=MCRESU-1+KOLDEB
                     IF(KOLFIN.LT.LIGNE) THEN
                        DO 1224 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                           CCOEFF   =CCOEFF   +RST(IAMORS)*RST(MCVV)
                           CST(MCRR)=CST(MCRR)+RST(IAMORS)*RCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
1224                       CONTINUE
                     ELSE
                        DO 2224 MCVV=MCVECT-1+KOLDEB,MCVECT-2+LIGNE
                           CCOEFF   =CCOEFF   +RST(IAMORS)*RST(MCVV)
                           CST(MCRR)=CST(MCRR)+RST(IAMORS)*RCOEFG
                           MCRR=MCRR+1
                           IAMORS=IAMORS+1
2224                       CONTINUE
                        IF(KOLDEB.LE.LIGNE)
     *                     CCOEFF   =CCOEFF   +RST(IAMORS)*RCOEFG
                        GO TO 4224
                     END IF
3224                 CONTINUE
*
4224           CST(MCR)=CCOEFF
               LGCUAV=IPLAGE(2,NUDRPL)
224            CONTINUE
            END IF
         ELSE IF(TYVECT(1:1).EQ.'R') THEN
*           Matrice complexe, vecteur operande reel et resultat complexe
            DO 424 LIGNE=1,NBLIGM
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
               MCV=MCV+1
               RCOEFG=RST(MCV)
               MCR=MCR+1
               CCOEFF=CST(MCR)
*
               DO 3424 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGE(1,NUPLA)
                  LGCUMU=IPLAGE(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV-1
                  IAMORS=MCMORS+LGCUAV
                  LGCUAV=LGCUMU
                  MCRR=MCRESU-1+KOLDEB
                  IF(KOLFIN.LT.LIGNE) THEN
                     DO 1424 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                        CCOEFF   =CCOEFF   +CST(IAMORS)*RST(MCVV)
                        CST(MCRR)=CST(MCRR)+CST(IAMORS)*RCOEFG
                        MCRR=MCRR+1
                        IAMORS=IAMORS+1
1424                    CONTINUE
                  ELSE
                     DO 2424 MCVV=MCVECT-1+KOLDEB,MCVECT-2+LIGNE
                        CCOEFF   =CCOEFF   +CST(IAMORS)*RST(MCVV)
                        CST(MCRR)=CST(MCRR)+CST(IAMORS)*RCOEFG
                        MCRR=MCRR+1
                        IAMORS=IAMORS+1
2424                    CONTINUE
                     IF(KOLDEB.LE.LIGNE)
     *                  CCOEFF   =CCOEFF   +CST(IAMORS)*RCOEFG
                     GO TO 4424
                  END IF
3424              CONTINUE
*
4424        CST(MCR)=CCOEFF
            LGCUAV=IPLAGE(2,NUDRPL)
424         CONTINUE
         ELSE 
*           Matrice reelle, vecteur operande et resultat complexes
            DO 442 LIGNE=1,NBLIGM
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
               MCV=MCV+1
               CCOEFG=CST(MCV)
               MCR=MCR+1
               CCOEFF=CST(MCR)
*
               DO 3442 NUPLA=NUPRPL,NUDRPL
                  KOLDEB=IPLAGE(1,NUPLA)
                  LGCUMU=IPLAGE(2,NUPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV-1
                  IAMORS=MCMORS+LGCUAV
                  LGCUAV=LGCUMU
                  MCRR=MCRESU-1+KOLDEB
                  IF(KOLFIN.LT.LIGNE) THEN
                     DO 1442 MCVV=MCVECT-1+KOLDEB,MCVECT-1+KOLFIN
                        CCOEFF   =CCOEFF   +RST(IAMORS)*CST(MCVV)
                        CST(MCRR)=CST(MCRR)+RST(IAMORS)*CCOEFG
                        MCRR=MCRR+1
                        IAMORS=IAMORS+1
1442                    CONTINUE
                  ELSE
                     DO 2442 MCVV=MCVECT-1+KOLDEB,MCVECT-2+LIGNE
                        CCOEFF   =CCOEFF   +RST(IAMORS)*CST(MCVV)
                        CST(MCRR)=CST(MCRR)+RST(IAMORS)*CCOEFG
                        MCRR=MCRR+1
                        IAMORS=IAMORS+1
2442                    CONTINUE
                     IF(KOLDEB.LE.LIGNE)
     *                  CCOEFF   =CCOEFF   +RST(IAMORS)*CCOEFG
                     GO TO 4442
                  END IF
3442              CONTINUE
*
4442        CST(MCR)=CCOEFF
            LGCUAV=IPLAGE(2,NUDRPL)
442         CONTINUE
         END IF
      END IF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99442 CALL BAISE(' *MosVc * Incompatibilite entre le type COMPLEXE des' !Utilite
     *//' matrice et vecteur operande et le type REEL du resultat')
99422 CALL BAISE(' *MosVc * Incompatibilite entre le type COMPLEXE de'  !Utilite
     *//' la matrice,le type REEL du vecteur operande et le type REEL'
     *//' du resultat')
99242 CALL BAISE(' *MosVc * Incompatibilite entre le type REEL de la'   !Utilite
     *//' matrice, le type COMPLEXE du vecteur operande et le type REEL'
     *//' du resultat')
                                                                    END *MosVc*
