*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  M O T V C (NBLIGM,NBCOLM,NULAPL,IPLAGE,TYMATR,MCMATR 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Decembre 1989) 
* Derniere modification : D.Martin) le 9 Avril 1993
*  
*   Produit tMxV de la transposee d'une matrice M stockee 'Morse-L' 
*   par un vecteur ou 
*   Produit MxV d'une matrice stockee 'Morse-C' par un vecteur
*
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*** Arguments d'entree *** 
* NBLIGM nombre de lignes de la matrice 
* NBCOLM nombre de colonnes de la matrice (arg. inutilise actuellement)
* NULAPL numeros de derniere plage de chaque ligne
* IPLAGE numeros de 1ere colonne de chaque plage et longueur cumulee  
* TYMATR type (reel ou complexe) de la matrice morse  
* MCMATR adresse de la matrice compactee dans le super-tableau ad hoc 
* TYVECT type (reel ou complexe) du vecteur operande
* MCVECT adresse du vecteur operande
* TYRESU type (reel ou complexe) du vecteur resultat  
* MCRESU adresse du vecteur resultat  
* RST,CST super-tableau considere reel ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      INTEGER       NBLIGM,NBCOLM,NULAPL(*),IPLAGE(2,*),MCMATR,MCVECT
     *             ,MCRESU 
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE (CCOEFF,RCOEFF)  
*  
      NUDRPL=0 
      LGCUMU=0 
      IADVEC=MCVECT
      IF(TYMATR(1:1).EQ.'R') THEN  
         IF(TYVECT(1:1).EQ.'R') THEN
            IF(TYRESU(1:1).NE.'R') GO TO 90001 
            DO 11 LIGNE=1,NBLIGM
               RCOEFF=RST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
*->            MCCOEF : adresse du premier coeff. de la ligne  
               MCCOEF=MCMATR+LGCUMU
               DO 10 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 10 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     RST(IADRES)=RST(IADRES)+RCOEFF*RST(MCCOEF)
10                   MCCOEF=MCCOEF+1
11             IADVEC=IADVEC+1 
         ELSE  
            IF(TYRESU(1:1).NE.'C') GO TO 90002 
            DO 21 LIGNE=1,NBLIGM
               CCOEFF=CST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
               MCCOEF=MCMATR+LGCUMU
               DO 20 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 20 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     CST(IADRES)=CST(IADRES)+CCOEFF*RST(MCCOEF)
20                   MCCOEF=MCCOEF+1
21             IADVEC=IADVEC+1 
         END IF
      ELSE IF(TYMATR(1:1).EQ.'C') THEN 
         IF(TYRESU(1:1).NE.'C') GO TO 90002
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 31 LIGNE=1,NBLIGM
               CCOEFF=CST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
               MCCOEF=MCMATR+LGCUMU
               DO 30 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 30 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     CST(IADRES)=CST(IADRES)+CCOEFF*CST(MCCOEF)
30                   MCCOEF=MCCOEF+1
31             IADVEC=IADVEC+1 
         ELSE  
            DO 41 LIGNE=1,NBLIGM
               CCOEFF=RST(IADVEC)  
               NUPRPL=NUDRPL+1 
               NUDRPL=NULAPL(LIGNE)
               MCCOEF=MCMATR+LGCUMU
               DO 40 NUMPLA=NUPRPL,NUDRPL  
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPLA)  
                  KOLDEB=IPLAGE(1,NUMPLA)  
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  DO 40 IADRES=MCRESU-1+KOLDEB,MCRESU-1+KOLFIN 
                     CST(IADRES)=CST(IADRES)+CCOEFF*CST(MCCOEF)
40                   MCCOEF=MCCOEF+1
41             IADVEC=IADVEC+1 
         END IF
      END IF
      RETURN
90001 CALL BAISE('*MotVc * Incompatibilite entre le type reel des operan!Utilite
     *des et le type COMPLEXE du resultat')                             !Utilite
90002 CALL BAISE('*MotVc * Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *MotVc *
