*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE  MOVC (NBLIGM,NBCOLM,NULAPL,IPLAGE,TYMATR,MCMATR
     &                 ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Octobre 1989) 
* Derniere modification : D.Martin (9 Avril 1993)
*  
* Produit MxV d'une matrice M stockee 'Morse-L' par un vecteur.
*
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* NBLIGM nombre de lignes de la matrice
* NBCOLM nombre de colonnes de la matrice 
* NULAPL numeros de derniere plage de chaque ligne
* IPLAGE numeros de 1ere colonne de chaque plage et longueurs cumulees  
* TYMATR type (reel ou complexe) de la matrice  
* MCMATR adresse de la matrice compactee Morse dans le super-tableau ad hoc 
* TYVECT type (reel ou complexe) du vecteur operande 
* MCVECT adresse du vecteur operande
* TYVERU type (reel ou complexe) du vecteur resultat
* MCRESU adresse du vecteur resultat  
* RST,CST super-tableau considere reel ou complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      INTEGER       NBLIGM,NBCOLM,NULAPL(*),IPLAGE(2,*)
     &             ,MCMATR,MCVECT,MCRESU  
      REAL          RST(*),RCOEFF 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
      
      INTEGER NUPRPL,NUDRPL,LGCUAV,LGCUMU,IADRES,LIGNE,IAD1
*-----------------------------------------------------------------------
      NUDRPL=0
      LGCUAV=0
      IADRES=MCRESU
      IF (TYRESU(1:1).EQ.'R') THEN
*        Boucle sur les lignes de la matrice morse
         DO 1 LIGNE=1,NBLIGM
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            CALL MOLIV  (1,NBCOLM,NUPRPL,NUDRPL,LGCUAV,IPLAGE,TYMATR
     &                  ,MCMATR,RST,CST,TYVECT,MCVECT,RST,CST
     &                  ,CCOEFF,IAD1,LGCUMU)
            RST(IADRES)=RST(IADRES)+RCOEFF
            LGCUAV=LGCUMU
            IADRES=IADRES+1
1        CONTINUE
      ELSE
         DO 2 LIGNE=1,NBLIGM
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            CALL MOLIV  (1,NBCOLM,NUPRPL,NUDRPL,LGCUAV,IPLAGE,TYMATR
     &                  ,MCMATR,RST,CST,TYVECT,MCVECT,RST,CST
     &                  ,CCOEFF,IAD1,LGCUMU)
            CST(IADRES)=CST(IADRES)+CCOEFF
            LGCUAV=LGCUMU
            IADRES=IADRES+1
2        CONTINUE
      ENDIF
                                                                    END !MoVc
