*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PLXPLB (TYPEMA,NBLIMA,NBCOMA,STOIMA,MCMATA
     &                  ,TYPEMB       ,NBCOMB,STOIMB,MCMATB
     &                                       ,STOIMR,MCMATR,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (13 octobre 2006)
* Derniere modification : D.Martin (20 octobre 2006)
* Version 0
*
* Produit de 2 matrices rectangulaires Pleines A et B dont la seconde est
* stockee BIMORSE 
*                        R_{ij} = A_{ik} * B_{kj}
*
* La matrice A reelle ou complexe peut etre stockee sous forme PLEIN-L, PLEIN-C 
* et de meme pour la matrice Resultat R.
* La matrice B reelle ou complexe est pleine mais est aussi stockee BIMORSE.
*
* On suppose que la matrice R est adressee dans le super-tableau du bon type.
*
*-- Arguments d'entree --
* TYPEMA type (REEL ou COMPLEXE) de la matrice A
* NBLIMA nombre de lignes de la matrice A 
* NBCOMA nombre de colonnes de la matrice A et de lignes de la matrice B
* STOIMA type de stockage de la matrice A ('PLEIN-L' ou 'PLEIN-C')
* MCMATA adresse de la matrice A
* NBCOMB nombre de colonnes de la matrice B
* TYPEMB type (REEL ou COMPLEXE) de la matrice B
* STOIMB type de stockage de la matrice B ('BIMORSE')
* MCMATB adresse de la matrice B
* STOIMB type de stockage de la matrice R ('PLEIN-L' ou 'PLEIN-C')
* MCMATR adresse de la matrice resultat R
* RST,CST super tableau, version REEL et COMPLEXE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPEMA,TYPEMB,STOIMA,STOIMB,STOIMR
      INTEGER NBLIMA,NBCOMA,MCMATA,NBCOMB,MCMATB,MCMATR
      REAL    RST(*)
      COMPLEX CST(*)
*
      INTEGER INCMAC,INCMAL,INCMBL,INCMBC,INCMRC,INCMRL,I,K,P
     &       ,AIK1,AIK,BKJ1,BKJ,RIJ,RIJ1
     &       ,MCL,MCU,NBLIMB,LGDIAG,LGL,DKK1,LKJ1,UKJ1
      REAL    RRIJ
      COMPLEX CRIJ
*-----------------------------------------------------------------------
      NBLIMB=NBCOMA
*
*     Increments de changement de ligne ou de colonne selon le stockage
*
*     INCMAC : increment d'adresse pour le changement de colonne dans A
*     INCMAL : increment d'adresse pour le changement de ligne dans A
      INCMAL=1
      INCMAC=1
      IF (STOIMA.EQ.'PLEIN-C') THEN
         INCMAC=NBLIMA
      ELSEIF (STOIMA.EQ.'PLEIN-L') THEN
         INCMAL=NBCOMA
      ELSE
         CALL BAISE  ('PLxPLB : Matrice A non PLEIN-L ou PLEIN-C.')
      ENDIF
      IF (STOIMB.NE.'BIMORSE') THEN
         CALL BAISE  ('PLxPLB : Matrice B non BIMORSE.')
      ENDIF
*     INCMRC : increment d'adresse pour le changement de colonne dans R
*     INCMRL : increment d'adresse pour le changement de ligne dans R
      INCMRC=1
      INCMRL=1
      IF (STOIMR.EQ.'PLEIN-C') THEN
         INCMRC=NBLIMA
      ELSEIF (STOIMR.EQ.'PLEIN-L') THEN
         INCMRL=NBCOMB
      ELSE
         CALL BAISE  ('PLxPLB : Matrice R non  PLEIN-L ou PLEIN-C.')
      ENDIF
*
      AIK1=MCMATA
      RIJ1=MCMATR
      LGDIAG=MIN(NBLIMB,NBCOMB)
*     Adresse de la partie triangulaire inferieure
      MCL=MCMATB+LGDIAG
*     Longueur de la partie triangulaire inferieure
      LGL=(LGDIAG*(LGDIAG-1))/2+ABS(NBLIMB-NBCOMB)*LGDIAG
*     Adresse de la partie triangulaire superieure
      MCU=MCL+LGL
*
      IF (TYPEMA(1:1).EQ.'C') THEN
*  
         IF (TYPEMB(1:1).EQ.'C') THEN
*
*           Matrice A complexe et matrice B complexe ==> R complexe
*
            DO 443 I=1,NBLIMA
               RIJ=RIJ1
               DKK1=MCMATB
               LKJ1 = MCL
               UKJ1 = MCU
               DO 442 K=1,NBCOMB
                  CRIJ = 0.
                  AIK = AIK1
*                 Produit par la sur-diagonale de la colonne K de B
                  BKJ = UKJ1
                  DO 440 P=1,MIN(K-1,NBCOMA)
                     CRIJ = CRIJ+CST(AIK)*CST(BKJ)
*                    Changement de colonne sur la ligne I de A
                     AIK = AIK+INCMAC
*                    Changement de ligne sur la colonne K de B
                     BKJ = BKJ+1
440               CONTINUE
                  UKJ1 = BKJ 
*                 Produit par la diagonale de la colonne K de B
                  CRIJ = CRIJ+CST(AIK)*CST(DKK1)
*                 Changement de colonne sur la ligne I de A
                  AIK=AIK+INCMAC
                  DKK1 = DKK1 + 1
*                 Produit par la sous-diagonale de la colonne K de B 
                  BKJ = LKJ1                 
                  DO 441 P=K+1,NBCOMA
                     CRIJ = CRIJ+CST(AIK)*CST(BKJ)
*                    Changement de colonne sur la ligne I de A
                     AIK = AIK+INCMAC
*                    Changement de ligne sur la colonne K de B
                     BKJ = BKJ+MIN(P-1,NBCOMB)
441               CONTINUE
                  LKJ1 = LKJ1+MIN(K+1,NBCOMB)
*                 Coefficient R_{ik}
                  CST(RIJ) = CRIJ
                  RIJ = RIJ+INCMRC
442            CONTINUE
               AIK1 = AIK1+INCMAL
               RIJ1 = RIJ1+INCMRL
443         CONTINUE
*
         ELSE
*
*           Matrice A complexe et matrice B reelle ==> R complexe
*
            DO 423 I=1,NBLIMA
               RIJ=RIJ1
               DKK1=MCMATB
               LKJ1 = MCL
               UKJ1 = MCU
               DO 422 K=1,NBCOMB
                  CRIJ = 0.
                  AIK = AIK1
                  BKJ = UKJ1
                  DO 420 P=1,MIN(K-1,NBCOMA)
                     CRIJ = CRIJ+CST(AIK)*RST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+1
420               CONTINUE
                  UKJ1 = BKJ 
                  CRIJ = CRIJ+CST(AIK)*RST(DKK1)
                  AIK=AIK+INCMAC
                  DKK1 = DKK1 + 1
                  BKJ = LKJ1                 
                  DO 421 P=K+1,NBCOMA
                     CRIJ = CRIJ+CST(AIK)*RST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+MIN(P-1,NBCOMB)
421               CONTINUE
                  LKJ1 = LKJ1+MIN(K+1,NBCOMB)
                  CST(RIJ) = CRIJ
                  RIJ = RIJ+INCMRC
422            CONTINUE
               AIK1 = AIK1+INCMAL
               RIJ1 = RIJ1+INCMRL
423         CONTINUE
*
         ENDIF
*
      ELSE
*
         IF (TYPEMB(1:1).EQ.'C') THEN  
*
*           Matrice A reelle et matrice B complexe ==> R complexe
*
            DO 243 I=1,NBLIMA
               RIJ=RIJ1
               DKK1=MCMATB
               LKJ1 = MCL
               UKJ1 = MCU
               DO 242 K=1,NBCOMB
                  CRIJ = 0.
                  AIK = AIK1
                  BKJ = UKJ1
                  DO 240 P=1,MIN(K-1,NBCOMA)
                     CRIJ = CRIJ+RST(AIK)*CST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+1
240               CONTINUE
                  UKJ1 = BKJ 
                  CRIJ = CRIJ+RST(AIK)*CST(DKK1)
                  AIK=AIK+INCMAC
                  DKK1 = DKK1 + 1
                  BKJ = LKJ1                 
                  DO 241 P=K+1,NBCOMA
                     CRIJ = CRIJ+RST(AIK)*CST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+MIN(P-1,NBCOMB)
241               CONTINUE
                  LKJ1 = LKJ1+MIN(K+1,NBCOMB)
                  CST(RIJ) = CRIJ
                  RIJ = RIJ+INCMRC
242            CONTINUE
               AIK1 = AIK1+INCMAL
               RIJ1 = RIJ1+INCMRL
243         CONTINUE
*
         ELSE
*         
*           Matrices A et B sont reelles ==> R reelle
*
            DO 223 I=1,NBLIMA
               RIJ=RIJ1
               DKK1=MCMATB
               LKJ1 = MCL
               UKJ1 = MCU
               DO 222 K=1,NBCOMB
                  RRIJ = 0.
                  AIK = AIK1
                  BKJ = UKJ1
                  DO 220 P=1,MIN(K-1,NBCOMA)
                     RRIJ = RRIJ+RST(AIK)*RST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+1
220               CONTINUE
                  UKJ1 = BKJ 
                  RRIJ = RRIJ+RST(AIK)*RST(DKK1)
                  AIK=AIK+INCMAC
                  DKK1 = DKK1 + 1
                  BKJ = LKJ1                 
                  DO 221 P=K+1,NBCOMA
                     RRIJ = RRIJ+RST(AIK)*RST(BKJ)
                     AIK = AIK+INCMAC
                     BKJ = BKJ+MIN(P-1,NBCOMB)
221               CONTINUE
                  LKJ1 = LKJ1+MIN(K+1,NBCOMB)
                  RST(RIJ) = RRIJ
                  RIJ = RIJ+INCMRC
222            CONTINUE
               AIK1 = AIK1+INCMAL
               RIJ1 = RIJ1+INCMRL
223         CONTINUE
*
         ENDIF
*
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (20 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !PlxPlb
