*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PPLVC (IPRLIA,IDRLIA,TYMATR,MCPLEI,INCPLA,INCPCA
     &                 ,IPRLIV,IDRLIV,TYVECT,MCVECT
     &                 ,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Octobre 1989) 
* Derniere modification : D.Martin le 9 Avril 1993
*  
* Produit partiel AxV d'un bloc de colonnes d'une matrice A pleine stockee
* colonne apres colonne ('a la Fortran') par un bloc de coeff. d'un vecteur 
* 
* ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p.
*  
*-- Arguments d'entree -- 
* IPRLIA numero de premiere ligne dans la matrice pleine
* IDRLIA numero de derniere ligne dans la matrice pleine  
* TYMATR type (reel ou complexe) de la matrice
* MCPLEI adresse dans le super-tableau de type adequat de la matrice  
* INCPLA increment lors d'un changement de ligne sur la meme colonne  
* INCPCA increment lors d'un changement de colonne sur la meme ligne  
* IPRLIV numero de premiere ligne du vecteur  
* IDRLIV numero de derniere ligne du vecteur  
* TYVECT type (reel ou complexe) du vecteur operande  
* MCVECT adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU type (reel ou complexe) du vecteur resultat  
* MCRESU adresse du vecteur resultat dans le super-tableau adequat
* RST,CST super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++:  
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      INTEGER       IPRLIA,IDRLIA,MCPLEI,INCPLA,INCPCA,IPRLIV,IDRLIV
     &             ,MCVECT,MCRESU
      REAL          RST(*) 
      COMPLEX       CST(*) 
*
      INTEGER       IPTA1,IPTV1,IPTRES,ILIGA,IPTA,ILIGV,IPTV
*-----------------------------------------------------------------------
      IPTA1=MCPLEI+INCPCA*(IPRLIV-1)
      IPTV1=MCVECT+IPRLIV-1
      IPTRES=MCRESU+IPRLIA-1
      IF (TYMATR(1:1).EQ.'C') THEN  
*  
         IF (TYRESU(1:1).NE.'C') GOTO 90002
         IF (TYVECT(1:1).EQ.'C') THEN
            DO 2 ILIGA=IPRLIA,IDRLIA
               IPTA=IPTA1  
               IPTV=IPTV1  
               DO 1 ILIGV=IPRLIV,IDRLIV
                  CST(IPTRES)=CST(IPTRES)+CST(IPTA)*CST(IPTV)  
                  IPTV=IPTV+1  
1                 IPTA=IPTA+INCPCA 
               IPTA1=IPTA1+INCPLA  
2           IPTRES=IPTRES+1 
         ELSE  
            DO 4 ILIGA=IPRLIA,IDRLIA
               IPTA=IPTA1  
               IPTV=IPTV1  
               DO 3 ILIGV=IPRLIV,IDRLIV
                  CST(IPTRES)=CST(IPTRES)+CST(IPTA)*RST(IPTV)  
                  IPTV=IPTV+1  
3                 IPTA=IPTA+INCPCA 
               IPTA1=IPTA1+INCPLA  
4           IPTRES=IPTRES+1 
         ENDIF
*  
      ELSE 
*  
         IF (TYVECT(1:1).EQ.'R') THEN
            IF (TYRESU(1:1).NE.'R') GOTO 90001 
            DO 6 ILIGA=IPRLIA,IDRLIA
               IPTA=IPTA1  
               IPTV=IPTV1  
               DO 5 ILIGV=IPRLIV,IDRLIV
                  RST(IPTRES)=RST(IPTRES)+RST(IPTA)*RST(IPTV)  
                  IPTV=IPTV+1  
5                 IPTA=IPTA+INCPCA 
               IPTA1=IPTA1+INCPLA  
6           IPTRES=IPTRES+1 
         ELSE  
            IF (TYRESU(1:1).NE.'C') GOTO 90002 
            DO 8 ILIGA=IPRLIA,IDRLIA
               IPTA=IPTA1  
               IPTV=IPTV1  
               DO 7 ILIGV=IPRLIV,IDRLIV
                  CST(IPTRES)=CST(IPTRES)+RST(IPTA)*CST(IPTV)  
                  IPTV=IPTV+1  
7                 IPTA=IPTA+INCPCA 
               IPTA1=IPTA1+INCPLA  
8           IPTRES=IPTRES+1 
         ENDIF
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90001 CALL BAISE('*PPlVc * Incompatibilite entre le type reel des'
     &//'  operandes et le type COMPLEXE du resultat')
90002 CALL BAISE('*PPlVc * Incompatibilite entre les types reel et'
     &//' complexe des operandes et le type REEL du resultat')
                                                                    END !PPlvc
