*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE P R A U V C (NBLIGN,NBCOLO,UENV,TYMATR,MCU 
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov. 91
*  
*   Produit U*xV de l'adjointe d'une matrice U strictement triangulaire
*   superieure stockee sous forme 'Profil' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p. 
*  
*** Arguments d'entree *** 
* NBCOLO: nombre de lignes de la matrice U
* NBLIGN: nombre de colonnes de la matrice U
* UENV  : tableau des pointeurs du profil (superieur) de U
* TYMATR: Type (reel ou complexe) de la matrice
* MCU   : adresse dans le super-tab. de type adhoc de la partie superieure 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       UENV(*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*
      IF(TYMATR(1:1).EQ.'R') THEN
         CALL PRLVC(NBCOLO,NBLIGN,UENV,TYMATR,MCU
     *                             ,TYVECT,MCVECT,TYRESU,MCRESU,RST,CST)
      ELSE
         IF(TYRESU(1:1).EQ.'R') GO TO 90001
*
         MC=MCU
         MCRR=MCRESU
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=2,NBCOLO 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCU-1+UENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBLIGN)-NBCOF-1
                  DO 443 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+CONJG(CST(MC))*CST(MCVV)
443                  MC=MC+1                
               END IF
444            CST(MCRR)=CCOEFF
         ELSE
            DO 424 LIGNE=2,NBCOLO 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCU-1+UENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBLIGN)-NBCOF-1
                  DO 423 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+CONJG(CST(MC))*RST(MCVV)
423                  MC=MC+1                
               END IF
424            CST(MCRR)=CCOEFF  
         END IF
      END IF
      RETURN
90001 CALL BAISE('*PraUVc* Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *PraUVc*
