*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE P R L V C (NBLIGN,NBCOLO,LENV,TYMATR,MCL,TYVECT,MCVECT 
     *                                           ,TYRESU,MCRESU,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)  
* Derniere modification (D.Martin) le 25 Nov. 91
*  
*   Produit LxV d'une matrice L strictement triangulaire inferieure 
*   stockee sous forme 'Profil' par un vecteur V.
*   ATTENTION : Le vecteur resultat n'est pas initialise a zero dans ce s.p. 
*  
*** Arguments d'entree *** 
* NBLIGN: nombre de lignes de la matrice L
* NBCOLO: nombre de colonnes de la matrice L
* LENV  : tableau des pointeurs du profil inferieure
* TYMATR: Type (reel ou complexe) de la matrice L
* MCL   : adresse dans le super-tab. de type adhoc de la partie triang. inf. 
* TYVECT: Type (reel ou complexe) du vecteur operande  
* MCVECT: adresse dans le super-tableau de type adequat du vecteur operande
* TYRESU: Type (reel ou complexe) du vecteur resultat  
* MCRESU: adresse du vecteur resultat dans le super-tableau adequat
* RST,CST: super-tableau utilise en temps que tableau reel ou complexe 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       LENV(*)
      CHARACTER*(*) TYMATR,TYVECT,TYRESU
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*
      MC=MCL
      MCRR=MCRESU
      IF(TYRESU(1:1).EQ.'R') THEN  
         IF(TYMATR(1:1).NE.'R'.OR.TYVECT(1:1).NE.'R') GO TO 90001
         DO 222 LIGNE=2,NBLIGN 
            MCRR=MCRR+1  
            RCOEFF=RST(MCRR)
            MCNX=MCL-1+LENV(LIGNE)
            NBCOF=MCNX-MC
            IF(NBCOF.GT.0) THEN
               MCV1=MCVECT+MIN(LIGNE,NBCOLO)-NBCOF-1
*                          --- (dans le cas d'une matrice rectangulaire)
               DO 221 MCVV=MCV1,MCV1+NBCOF-1
                  RCOEFF=RCOEFF+RST(MC)*RST(MCVV)
221               MC=MC+1                
            END IF
222         RST(MCRR)=RCOEFF
      ELSE IF(TYMATR(1:1).EQ.'C') THEN 
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 444 LIGNE=2,NBLIGN 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 443 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+CST(MC)*CST(MCVV)
443                  MC=MC+1                
               END IF
444            CST(MCRR)=CCOEFF
         ELSE
            DO 424 LIGNE=2,NBLIGN 
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 423 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+CST(MC)*RST(MCVV)
423                  MC=MC+1                
               END IF
424            CST(MCRR)=CCOEFF  
         END IF
      ELSE IF(TYMATR(1:1).EQ.'R') THEN 
         IF(TYVECT(1:1).EQ.'C') THEN
            DO 244 LIGNE=2,NBLIGN
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 243 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+RST(MC)*CST(MCVV)
243                  MC=MC+1                
               END IF
244            CST(MCRR)=CCOEFF
         ELSE
            DO 224 LIGNE=2,NBLIGN
               MCRR=MCRR+1  
               CCOEFF=CST(MCRR)
               MCNX=MCL-1+LENV(LIGNE)
               NBCOF=MCNX-MC
               IF(NBCOF.GT.0) THEN
                  MCV1=MCVECT+MIN(LIGNE,NBCOLO)-NBCOF-1
                  DO 223 MCVV=MCV1,MCV1+NBCOF-1
                     CCOEFF=CCOEFF+RST(MC)*RST(MCVV)
223                  MC=MC+1                
               END IF
224            CST(MCRR)=CCOEFF
         END IF
      END IF
      RETURN
90001 CALL BAISE('*PrLVc * Incompatibilite entre les types reel et compl!Utilite
     *exe des operandes et le type REEL du resultat')                   !Utilite
                                                                    END *PrLVc*
