*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRBMOR (STRUCT,COMEN1,NOMTRM,NIVTRM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)  
* Derniere modification : D.Martin (28 Juin 2000)
* Version 1.0.1
*  
* Impression d'une structure 'Bi-Morse' pour un terme  
*  
*-- Arguments --  
* STRUCT tableau contenant la structure Bi-Morse
* COMEN1 commentaire (chaine de caracteres)
* NOMTRM nom du terme (chaine de caracteres)
* NIVTRM son niveau
* NIVIMP niveau d'impression du terme
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER COMEN1*(*),NOMTRM*(*)  
      INTEGER   STRUCT(*),NIVTRM,NIVIMP,IMPFCH
*
      INTEGER   NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGMORL,NBLIMP
     &         ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGMORU,NCATR1,N1,N2,K,IDB,I
      CHARACTER PRFXAS*8,THETR1*16
*-----------------------------------------------------------------------
      CALL EXBMOR (1,STRUCT,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGMORL 
     &                     ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGMORU)         !utilite
*
      CALL PRNTRM (NOMTRM,NIVTRM,THETR1,NCATR1)
      IF (STRUCT(1).EQ.2) THEN
         WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                       ,THETR1(1:NCATR1),'Structure symetrique'
      ELSE
         WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                       ,THETR1(1:NCATR1)
      ENDIF
      WRITE (IMPFCH,10001) 'lignes',NBLIGN,'inf.',NBPLAL,'inf.',LGMORL
*
      IF (NBCOLO.LE.400) THEN
*
         WRITE (IMPFCH,10005) NIVIMP
         CALL VIBMOR (' Ligne ',NBLIGN,NBCOLO              
     &               ,STRUCT(MCPLAL),STRUCT(MCPLIL),IMPFCH)             !prsd
         IF (NBLIGN.LE.400.AND.STRUCT(1).GT.2) THEN
            WRITE (IMPFCH,10001) 'colonnes',NBCOLO,'sup.',NBPLAU,'sup.'
     &            ,LGMORU
            CALL VIBMOR (' Colon.',NBCOLO,NBLIGN                
     &                  ,STRUCT(MCPLAU),STRUCT(MCPLIU),IMPFCH)          !prsd
         ENDIF
*
      ELSE
*
         NBLIMP=MIN (10*NIVIMP,NBLIGN)  
         IF (NIVIMP.GT.10) NBLIMP=NBLIGN
         WRITE (IMPFCH,10005) NIVIMP,'lignes',NBLIMP
         WRITE (IMPFCH,10002) '       ','Derniere',' ','  Ligne'
     &         ,' plage','Numeros de debut de plage(longueur)'
*        Impression de la premiere ligne non vide
         N2=0 
         DO 5 IDB=2,NBLIMP
            N1=N2+1
            N2=STRUCT(MCPLAL+IDB-2)
            IF (N2.GT.0) THEN 
               WRITE (IMPFCH,10003) IDB,N2,STRUCT(MCPLIL)
     &               ,STRUCT(MCPLIL+1),(STRUCT(MCPLIL+2*K-2)
     &               ,STRUCT(MCPLIL+2*K-1)-STRUCT(MCPLIL+2*K-3),K=2,N2)
               GOTO 7
            ENDIF
            WRITE (IMPFCH,10003) IDB,0
5        CONTINUE
         GOTO 13
*
7        DO 10 I=IDB+1,NBLIMP
            N1=N2+1
            N2=STRUCT(MCPLAL+I-2) 
            WRITE (IMPFCH,10003) I,N2,(STRUCT(MCPLIL+2*K-2) 
     &            ,STRUCT(MCPLIL+2*K-1)-STRUCT(MCPLIL+2*K-3),K=N1,N2)
10       CONTINUE
*
13       IF(STRUCT(1).GT.2) THEN
            WRITE (IMPFCH,10001) 'colonnes',NBCOLO,'sup.',NBPLAU,'sup.'
     &            ,LGMORU
            NBLIMP=MIN (10*NIVIMP,NBCOLO)  
            IF (NIVIMP.GT.10) NBLIMP=NBCOLO
            WRITE (IMPFCH,10005) NIVIMP,'colonnes',NBLIMP
            WRITE (IMPFCH,10002) '       ','Derniere',' ','  Colon'
     &           ,' plage','Numeros de debut de plage(longueur)'
*           Impression de la premiere ligne non vide
            N2=0 
            DO 15 IDB=2,NBLIMP
               N1=N2+1
               N2=STRUCT(MCPLAU+IDB-2)
               IF (N2.GT.0) THEN 
                  WRITE (IMPFCH,10003) IDB,N2,STRUCT(MCPLIU)
     &                 ,STRUCT(MCPLIU+1),(STRUCT(MCPLIU+2*K-2)
     &                ,STRUCT(MCPLIU+2*K-1)-STRUCT(MCPLIU+2*K-3),K=2,N2)
                  GOTO 17
               ENDIF
               WRITE(IMPFCH,10003) IDB,0
15          CONTINUE
            RETURN
17          DO 20 I=IDB+1,NBLIMP
               N1=N2+1
               N2=STRUCT(MCPLAU+I-2) 
               WRITE (IMPFCH,10003) I,N2,(STRUCT(MCPLIU+2*K-2) 
     &              ,STRUCT(MCPLIU+2*K-1)-STRUCT(MCPLIU+2*K-3),K=N1,N2)
20          CONTINUE
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A,'>*PrBmor*',A,' ',A,', ',A) 
10001 FORMAT(T6,'Nb. de ',A,' de la matrice :',T55,I7,/
     &,T6,'Nb. de plages de la partie triang. ',A,' morse :',T55,I7,/ 
     &,T6,'Nb. de coeff. de la partie triang. ',A,' morse :',T55,I7)
10002 FORMAT(A,TR3,A:,TR3,A)
10003 FORMAT(2(I6,TR3),(T23,9(I4,'(',I4,') ')))
10005 FORMAT(T6,'--> Impression de niveau ',I3,:,' : ',A,' de 1 a',I6) 
                                                                    END !PrBMor
