*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLIMO (LIOUCO,L1,L2,NCPINC,NCPINL,NUDRPL,IADFIN
     &                  ,NULAPL,IPLAGE,TYPE,MCA,RST,CST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991)
* Derniere modification: D.Martin (8 Septembre 2001)
* Version 1.0.2
*
* Impression d'un groupe de lignes d'une matrice 'Morse-Ligne' ou d'un groupe
* de colonnes d'une matrice 'Morse-Colonne'
*
*-- Arguments --
* LIOUCO 'Lig.' ou 'Col.'
* L1,L2  premiere et derniere ligne (resp. colonne) du groupe
* NCPINC nombre de d.l. par noeud en colonne (pour un stockage compte en noeuds)
* NCPINL nombre de d.l. par noeud en ligne
* NUDRPL numero de la derniere plage precedent la ligne (resp. colonne) L1
* IADFIN adresse relative precedent la ligne (resp. colonne) L1 (=-1 si L1=1)
* NULAPL tableau des numeros de derniere plage de chaque ligne (resp. colonne)
* IPLAGE tableau des numeros de ligne (resp. colonne) de debut de plage
*        et des adresses des derniers coefficients de chaque plage
* TYPE   type REEL ou COMPLEXE de la matrice
* MCA    adresse absolue de la matrice dans le s-t du bon type
* RST,CST super-tableau version reelle ou complexe
* IMPFCH numero d'unite logique du fichier d'impression (IMPFCH >0)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE,LIOUCO
      INTEGER       L1,L2,NCPINC,NCPINL,NUDRPL,IADFIN,NULAPL(*)
     &             ,IPLAGE(2,*),MCA,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LINE,LIGNE,LGLIGN,NUPRPL,IADDEB,LGCUAP,I,ICP
*----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
         IF (NCPINC*NCPINL.EQ.1) THEN
            DO 20 LIGNE=L1,L2
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
               IADDEB=IADFIN+1
               IADFIN=IPLAGE(2,NUDRPL)-1
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL
               WRITE (IMPFCH,10020) (RST(I),I=MCA+IADDEB,MCA+IADFIN)
20          CONTINUE
         ELSE
            LIGNE=1+NCPINL*(L1-1)
            DO 21 LINE=L1,L2
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LINE)
               IADDEB=(IADFIN+1)*NCPINC*NCPINL
               LGCUAP=0
               IF (NUDRPL.GT.0) LGCUAP=IPLAGE(2,NUDRPL)
               IADFIN=IADDEB+(LGCUAP-IADFIN-1)*NCPINC-1
               LGLIGN=(IADFIN-IADDEB+1)/NCPINC
               WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                             ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL
               WRITE (IMPFCH,10020) (RST(I),I=MCA+IADDEB,MCA+IADFIN)
               LIGNE=LIGNE+1
               IADDEB=IADFIN+1
               IADFIN=IADFIN+LGLIGN*NCPINC
               DO 22 ICP=2,NCPINL
                  WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                                ,IADDEB+1,IADFIN+1
                  WRITE (IMPFCH,10020) (RST(I),I=MCA+IADDEB,MCA+IADFIN)
                  LIGNE=LIGNE+1
                  IADDEB=IADFIN+1
                  IADFIN=IADFIN+LGLIGN*NCPINC
22             CONTINUE
               IADFIN=LGCUAP-1
21          CONTINUE
         ENDIF
      ELSE
         IF (NCPINC*NCPINL.EQ.1) THEN
            DO 40 LIGNE=L1,L2
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LIGNE)
               IADDEB=IADFIN+1
               IADFIN=IPLAGE(2,NUDRPL)-1
               WRITE (IMPFCH,10001) LIOUCO,LIGNE
     &                             ,IADDEB+1,IADFIN+1 ,NUPRPL,NUDRPL
               WRITE (IMPFCH,10040) (CST(I),I=MCA+IADDEB,MCA+IADFIN)
40          CONTINUE
         ELSE
            LIGNE=1+NCPINL*(L1-1)
            DO 41 LINE=L1,L2
               NUPRPL=NUDRPL+1
               NUDRPL=NULAPL(LINE)
               IADDEB=(IADFIN+1)*NCPINC*NCPINL
               LGCUAP=0
               IF (NUDRPL.GT.0) LGCUAP=IPLAGE(2,NUDRPL)
               IADFIN=IADDEB+(LGCUAP-IADFIN-1)*NCPINC-1
               LGLIGN=(IADFIN-IADDEB+1)/NCPINC
               WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                             ,IADDEB+1,IADFIN+1,NUPRPL,NUDRPL
               WRITE (IMPFCH,10040) (CST(I),I=MCA+IADDEB,MCA+IADFIN)
               LIGNE=LIGNE+1
               IADDEB=IADFIN+1
               IADFIN=IADFIN+LGLIGN*NCPINC
               DO 42 ICP=2,NCPINL
                  WRITE (IMPFCH,10002) LIOUCO,LIGNE,LINE
     &                                ,IADDEB+1,IADFIN+1
                  WRITE (IMPFCH,10040) (CST(I),I=MCA+IADDEB,MCA+IADFIN)
                  LIGNE=LIGNE+1
                  IADDEB=IADFIN+1
                  IADFIN=IADFIN+LGLIGN*NCPINC
42             CONTINUE
               IADFIN=LGCUAP-1
41          CONTINUE
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10020 FORMAT((T14,10(E10.4,' ')))
10040 FORMAT((T14,5(SS,E10.4,SP,E10.4,'*i ')))
10001 FORMAT(T14,A4,I6,:,' (adresses ',I10,' a ',I10,')',:
     &,' (plages ',I8,' a ',I8,') ',:,A)
10002 FORMAT(T14,A4,I6,', noeud',I6,:,' (adresses ',I10,' a ',I10,')',:
     &,' (plages ',I8,' a ',I8,') ',:,A)
                                                                    END !PrLiMo
