*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLIPT (LIOUCO,L1,L2,NBCOLO,NUDRPL,IADFIN,NCPINC
     &                  ,NCPINL,NULAPL,IPLAGL,MCD,MCL,IST,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser & D.Martin (Avril 1994)
* Derniere modification : D.Martin (3 Juillet 1997)
*
* Impression des pointeurs d'un groupe de lignes d'une matrice 'BiMorse'
*
*-- Arguments --
* LIOUCO indicateur de ligne ou colonne 
* L1,L2  premiere et derniere plage du groupe
* NBCOLO numero de colonne a ne pas depasser
* NUDRPL numero de la derniere plage precedent la ligne L1
* IADFIN adresse relative precedent la ligne L1 (=-1 si L1=1)
* NCPINC nombre de d.l. par noeud en colonne
* NCPINL nombre de d.l. par noeud en ligne
* NULAPL table des derniere plage en ligne
* IPLAGL table des descripteurs de plage
* MCD    adresse de la diagonale dans le super tableau du bon type 
* MCL    adresse du profil inferieur dans le super tableau du bon type
* IST    super-tableaux d'entier
* IMPFCH unite logique d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) LIOUCO*4
      INTEGER       L1,L2,NBCOLO,NUDRPL,IADFIN,NCPINC,NCPINL
     &             ,NULAPL(*),IPLAGL(2,*),MCD,MCL,IST(*),IMPFCH
*
      INTEGER       LIGNE,NUPRPL,IADDEB,I,NCFSSD,LGCUAP
*-----------------------------------------------------------------------
         IF (NCPINC*NCPINL.EQ.1) THEN
            DO 20 LIGNE=L1,L2
               NUPRPL=NUDRPL+1
               IADDEB=IADFIN+1
               NUDRPL=NULAPL(LIGNE-1)
               IADFIN=IPLAGL(2,NUDRPL)-1
               IF (LIGNE.GE.1.AND.LIGNE.LE.NBCOLO) THEN
                  WRITE (IMPFCH,201) LIOUCO
     &                 ,LIGNE,NUPRPL,NUDRPL,IADDEB+1,IADFIN+1
     &                 ,(IST(I),I=MCL+IADDEB,MCL+IADFIN)
     &                 ,IST(MCD-1+LIGNE)
               ELSE
                  WRITE (IMPFCH,202) LIOUCO
     &                 ,LIGNE,NUPRPL,NUDRPL,IADDEB+1,IADFIN+1
     &                 ,(IST(I),I=MCL+IADDEB,MCL+IADFIN)
               ENDIF
20          CONTINUE
         ELSE
            NCFSSD=MAX(1,MIN(NCPINC,NCPINL))
            IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
            DO 25 LIGNE=L1,L2
               NUPRPL=NUDRPL+1
               IADDEB=(IADFIN+1)*NCPINC*NCPINL
     &               +NCFSSD*MIN(LIGNE-1,NBCOLO)
               NUDRPL=NULAPL(LIGNE-1)
               LGCUAP=IPLAGL(2,NUDRPL)
               IADFIN=IADDEB+(LGCUAP-IADFIN-1)*NCPINC-1
               IF (LIGNE.GE.1.AND.LIGNE.LE.NBCOLO) THEN
                  WRITE (IMPFCH,201) LIOUCO
     &                 ,LIGNE,NUPRPL,NUDRPL,IADDEB+1,IADFIN+1
     &                 ,(IST(I),I=MCL+IADDEB,MCL+IADFIN,NCPINC)
     &                 ,IST(MCD+(LIGNE-1)*NCFSSD)
               ELSE
                  WRITE (IMPFCH,202) LIOUCO
     &                 ,LIGNE,NUPRPL,NUDRPL,IADDEB+1,IADFIN+1
     &                 ,(IST(I),I=MCL+IADDEB,MCL+IADFIN,NCPINC)
               ENDIF
               IADFIN=LGCUAP-1
25          CONTINUE
         ENDIF
*-----------------------------------------------------------------------
201   FORMAT(T5,A4,I6,'   Plages',I6,' a ',I6,' (adresses ',I6,' a ',I6
     &,') et diagonale '/(T14,10(I10,' ')))
202   FORMAT(T5,A4,I6,'   Plages',I6,' a ',I6,' (adresses ',I6,' a ',I6
     &,')'/(T14,10(I10,' ')))
                                                                    END !PrLipt
