*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRLIST (NUDOMG,NCHDOM,IMPFCH)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1990)  
* Derniere modification : D.Martin  (1er Juillet 2000)
* Version 1.0.1
*  
* Impression du tableau #ISTEL pour le domaine geometrique de numero NUDOMG
*  
*-- Arguments d'entree -- 
* NUDOMG numero du domaine geometrique 
* NCHDOM nombre de caracteres par nom de domaine
* IMPFCH numero logique d'impression
*
*-- Definition de LISTEL
* LISTEL(1) longueur du tableau LISTEL
* LISTEL(2) = NDMDOM dimension (des constituants) du domaine, par exemple
*             0 pour des points
*             1 pour des elements 1d, des aretes d'elements 2d ou 3d
*             2 pour des elements 2d, des faces d'elements 3d
*             3 pour des elements 3d
* LISTEL(3) = NDMDOE dimension des elements supports des constituants du domaine
*             1 pour des elements 1d, des points d'elements 1d
*             2 pour des elements 2d, des aretes/points d'elements 2d
*             3 pour des elements 3d, des faces/aretes/points d'elements 3d
* LISTEL(4) = NBELDO nombre d'elements supports des constituants du domaine
* LISTEL(5) = NBNEEX nombre maximum de noeuds par element
* LISTEL(6) = NBDLEX nombre maximum de d.l. par element (Hermite)
* si NDMDOM = NDMDOE > 0 :
*  LISTEL(7  a  6 + NBELDO) liste des numeros des elements
* si NDMDOM < NDMDOE et NDMDOM > 0 :
*  LISTEL(7) = NBNEFX nombre maximum de noeuds par face/arete d'element
*  LISTEL(8) = NBDLFX nombre maximum de d.l. par face/arete d'element (Hermite)
*  LISTEL(9 a 8+2*NBELDO) couples de (no d'element,no de face/arete )
* si NDMDOM=0 :
*  LISTEL(7) = NBCPDO nombre de couples (no d'element,no de point)
*  LISTEL(8) inutilise
*  LISTEL(9 a 8+2*NBCPDO) liste des couples (no d'element,no de point)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER   NUDOMG,NCHDOM,IMPFCH
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER   MCMDOM,MCLIST,NDMDOM,NDMDOE,NBELDO,NBCPDO,I
      CHARACTER ERCODE*120,PRFXAF*8
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL TBAR2  (ERCODE,'#OMDOM',1,MCMDOM,'#ISTEL',NUDOMG,MCLIST)
*  
      WRITE (IMPFCH,10000) PRFXAF ( ),NUDOMG
     &     ,(AST(I),I=MCMDOM+NCHDOM*(NUDOMG-1),MCMDOM+NCHDOM*NUDOMG-1)
      NDMDOM=IST(MCLIST+1)
      NDMDOE=IST(MCLIST+2)
      NBELDO=IST(MCLIST+3)
      WRITE (IMPFCH,30000) IST(MCLIST),NDMDOM,NBELDO
*
      IF (NDMDOM.EQ.NDMDOE) THEN
         WRITE (IMPFCH,30001) IST(MCLIST+5)
         WRITE (IMPFCH,30002)(IST(I),I=MCLIST+6,MCLIST+5+NBELDO)
      ELSEIF (NDMDOM.EQ.0) THEN
         NBCPDO=IST(MCLIST+6)
         WRITE (IMPFCH,30001) IST(MCLIST+5)
         WRITE (IMPFCH,30003) 'point',NBCPDO
         WRITE (IMPFCH,30006) ('point',I=1,MIN (8,NBCPDO))
         WRITE (IMPFCH,30007)
     &                  (IST(MCLIST+6+2*I),IST(MCLIST+7+2*I),I=1,NBCPDO)
      ELSEIF (NDMDOM.EQ.1) THEN
         WRITE (IMPFCH,30001) IST(MCLIST+5),'arete',IST(MCLIST+7)
         WRITE (IMPFCH,30003) 'arete',NBELDO
         WRITE (IMPFCH,30006) ('arete',I=1,MIN (8,NBELDO))
         WRITE (IMPFCH,30007)
     &                  (IST(MCLIST+6+2*I),IST(MCLIST+7+2*I),I=1,NBELDO)
      ELSEIF (NDMDOM.EQ.2) THEN
         WRITE (IMPFCH,30001) IST(MCLIST+5),'face',IST(MCLIST+7)
         WRITE (IMPFCH,30003) 'face',NBELDO
         WRITE (IMPFCH,30006) ('face ',I=1,MIN (8,NBELDO))
         WRITE (IMPFCH,30007)
     &                  (IST(MCLIST+6+2*I),IST(MCLIST+7+2*I),I=1,NBELDO)
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T5,A8,'>*PrList* Definition du domaine #',I5,' : ',50(A1))
30000 FORMAT(T8,'Tableau #ISTEL (',I6,' mots )'
     &      /T8,'Dimension du domaine (NDMDOM)',T44,I6
     &      ,T58,'Nombre d''elements (NBELDO)',T94,I6)
30001 FORMAT(T8,'Nombre de points maximum par element ',T44,I6,:
     &      ,T58,'Nombre de points maximum par ',A,T94,I6) 
30002 FORMAT(T8,'Elements :'/((T10,20(I6))))
30003 FORMAT(T8,'Nombre de couples (element,',A,')',T44,I6)
30006 FORMAT((T8,10('Element/',A5,'|',:,' ')))
30007 FORMAT((T8,8(I6,' /',I3,'  | ')))
                                                                    END !PrList
