*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMABM (BMORSE,ITYSYM,NCPINC,NCPINL,TYPE,MCA
     &                  ,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1991)
* Derniere modification : D.Martin (23 Juin 2000)
* Version 1.0.2
*
* Impression d'une matrice stockee sous forme 'Bimorse'
*
*-- Arguments --
* BMORSE structure definissant le stockage de la matrice
* ITYSYM indicateur de matrice symetrique (=1) ou non
* NCPINC nombre de d.l. par noeud en colonne (pour un stockage compte en noeuds)
* NCPINL nombre de d.l. par noeud en ligne
* TYPE   type REEL ou COMPLEXE de la matrice
* MCA    adresse de la matrice dans le super-tableau de type TYPE
* RST,CST super-tableau version REELLE et COMPLEXE
* NIVIMP niveau d'impression du terme
*         NIVIMP = I, 0 < I < 10 ==> impression de la diagonale et
*         des NIVIMP premieres et dernieres lignes et colonnes
*         NIVIMP > 9 ==> impression de la diagonale et des parties
*         sous- et sur-diagonale en totalite
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       BMORSE(*),ITYSYM,NCPINC,NCPINL,MCA,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL,NBCOLO,NBPLAU,MCPLAU
     &             ,MCPLIU,LGU,MCL,MCU,NCFSSD,NBPRL1,NUDRPL,MCAFIN
     &             ,NBPRL2
*-----------------------------------------------------------------------
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
      CALL EXBMOR (1,BMORSE,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &                     ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)            !sdexplo
      NCFSSD=MAX (1,MIN (NCPINC,NCPINL))
      IF (NCFSSD.LT.3) NCFSSD=NCFSSD-1
*
      WRITE (IMPFCH,10000) PRFXAF ( ),'>*PrMaBm*'
*
      MCL=MCA+MIN (NBLIGN*NCPINL,NBCOLO*NCPINC)
      NBPRL1=MIN (NIVIMP,NBLIGN)
      IF (NIVIMP.GT.10) NBPRL1=NBLIGN
      NUDRPL=0
      MCAFIN=-1
      CALL PRLIBM ('Lig.',1,NBPRL1,NCPINC,NCPINL,NBCOLO
     &            ,NUDRPL,MCAFIN,BMORSE(MCPLAL),BMORSE(MCPLIL)
     &            ,TYPE,MCA,MCL,RST,CST,IMPFCH)
*
      NBPRL2=MAX (NBPRL1+1,NBLIGN-NBPRL1+1)
      IF (NBPRL1.LT.NBLIGN) THEN
         IF (NBPRL2.GT.NBPRL1+1) WRITE (IMPFCH,10000) '   ..........'
         NUDRPL=BMORSE(MCPLAL+NBPRL2-3)
         MCAFIN=BMORSE(MCPLIL+2*NUDRPL-1)-1
         CALL PRLIBM ('Lig.',NBPRL2,NBLIGN,NCPINC,NCPINL,NBCOLO
     &               ,NUDRPL,MCAFIN,BMORSE(MCPLAL),BMORSE(MCPLIL)
     &               ,TYPE,MCA,MCL,RST,CST,IMPFCH)
      ENDIF
*
      IF (ITYSYM.EQ.0) THEN
         MCU=MCL+LGL*NCPINC*NCPINL+NCFSSD*MIN (NBLIGN,NBCOLO)
         NBPRL1=MIN (NIVIMP,NBCOLO)
         IF (NIVIMP.GT.10) NBPRL1=NBCOLO
         NUDRPL=0
         MCAFIN=-1
         CALL PRLIBM ('Col.',1,NBPRL1,NCPINL,NCPINC,NBLIGN
     &               ,NUDRPL,MCAFIN,BMORSE(MCPLAU),BMORSE(MCPLIU)
     &               ,TYPE,MCA,MCU,RST,CST,IMPFCH)
*
         NBPRL2=MAX (NBPRL1+1,NBCOLO-NBPRL1+1)
         IF (NBPRL1.LT.NBCOLO) THEN
            IF (NBPRL2.GT.NBPRL1+1) WRITE(IMPFCH,10000) '   ..........'
            NUDRPL=BMORSE(MCPLAU+NBPRL2-3)
            MCAFIN=BMORSE(MCPLIU+2*NUDRPL-1)-1
            CALL PRLIBM ('Col.',NBPRL2,NBCOLO,NCPINL,NCPINC,NBLIGN
     &                  ,NUDRPL,MCAFIN,BMORSE(MCPLAU),BMORSE(MCPLIU)
     &                  ,TYPE,MCA,MCU,RST,CST,IMPFCH)
         ENDIF
*
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,A)
                                                                    END !PrMaBm
