*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMAMO (LIOUCO,PLAGE,NCPINC,NCPINL,TYPE,MCA
     &                  ,RST,CST,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)
* Derniere modification : D.Martin (23 Juin 2000)
* Version 1.0.1
*
* Impression (partielle) d'une matrice stockee sous forme 'Morse-Ligne'
* ou 'Morse-Colonne'
*
*-- Arguments --
* LIOUCO 'Lig.' ou 'Col.'
* PLAGE  structure definissant la structure 'Morse-L' ou 'Morse-C' de la matrice
* NCPINC nombre de d.l. par noeud en colonne (pour un stockage compte en noeuds)
* NCPINL nombre de d.l. par noeud en ligne
* TYPE   type REEL ou COMPLEXE de la matrice
* MCA    adresse de la matrice dans le super-tableau de type TYPE
* RST,CST super-tableau version REELLE et COMPLEXE
* NIVIMP niveau d'impression du terme
*        NIVIMP = I, 0 < I < 10 ==> impression des NIVIMP premieres
*        et dernieres lignes
*        NIVIMP > 9 ==> impression de la matrice en totalite ligne par ligne
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE,LIOUCO
      INTEGER       PLAGE(*),NCPINC,NCPINL,MCA,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBLINE,MCAFIN,NUDRPL,NBPRL1,NBPRL2
*-----------------------------------------------------------------------
      IF(IMPFCH.LE.0.OR.NIVIMP.LE.0) RETURN
*
      NBLINE=PLAGE(1)
      MCAFIN=-1
      NUDRPL=0
      NBPRL1=MIN(NIVIMP,NBLINE)
      IF (NIVIMP.GT.10) NBPRL1=NBLINE
      WRITE(IMPFCH,10000) PRFXAF ( ),'>*PrMaMo*'
*
      CALL PRLIMO (LIOUCO,1,NBPRL1,NCPINC,NCPINL,NUDRPL,MCAFIN
     &            ,PLAGE(5),PLAGE(5+NBLINE),TYPE,MCA,RST,CST,IMPFCH)
      NBPRL2=MAX(NBPRL1,NBLINE-NBPRL1)
      IF (NBPRL1.LT.NBLINE.AND.NBPRL2.GT.NBPRL1+1)
     &   WRITE(IMPFCH,10000) '  ..........'
      NUDRPL=PLAGE(4+NBPRL2)
      MCAFIN=PLAGE(4+NBLINE+2*NUDRPL)-1
*
      CALL PRLIMO (LIOUCO,NBPRL2+1,NBLINE,NCPINC,NCPINL,NUDRPL,MCAFIN
     &            ,PLAGE(5),PLAGE(5+NBLINE),TYPE,MCA,RST,CST,IMPFCH)
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,A)
                                                                    END !PrMaMo
