*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRMORS (STRUCT,LIOUCO,COMEN1,NOMTRM,NIVTRM
     &                  ,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)
* Derniere modification : D.Martin (9 Septembre 2006)
* Version 1.2
*  
* Impression des tableaux de stockage 'Morse-L' ou 'Morse-C' pour un terme
*  
*-- Arguments --  
* STRUCT tableau de stockage Morse-L ou Morse-C pour le domaine
* LIOUCO 'L' ou 'C' selon le stockage Morse-L ou Morse-C
* COMEN1 commentaire (chaine de caracteres)
* NOMTRM nom du terme (chaine de caracteres)
* NIVTRM niveau du terme
* NIVIMP niveau d'impression du terme
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) COMEN1,NOMTRM,LIOUCO
      INTEGER       STRUCT(*),NIVTRM,NIVIMP,IMPFCH
*
      INTEGER       NBLIGN,NBCOLO,NBPLAG,MCPLAG,MCPLIG,LGMORS,NCATR1
     &             ,NBLIMP,N1,N2,I,K
      CHARACTER PRFXAS*8,THETR1*16
*-----------------------------------------------------------------------
      CALL EXMORS (1,STRUCT,NBLIGN,NBCOLO,NBPLAG,MCPLAG,MCPLIG,LGMORS)  !utilite
*
      CALL PRNTRM (NOMTRM,NIVTRM,THETR1,NCATR1)
      WRITE (IMPFCH,10000) PRFXAS (1)//'>'//PRFXAS (0),COMEN1
     &                    ,THETR1(1:NCATR1)
*
      THETR1='  lignescolonnes'
      IF (LIOUCO(1:1).EQ.'C') THETR1='colonneslignes'
      WRITE (IMPFCH,10001) THETR1(1:8),NBLIGN,NBPLAG,LGMORS
*
      IF (LIOUCO(1:1).EQ.'C') WRITE (IMPFCH,10006)
      IF (NBCOLO.LE.400) THEN
         CALL VIPLAG (THETR1(1:7),NBLIGN,NBCOLO
     &               ,STRUCT(MCPLAG),STRUCT(MCPLIG),IMPFCH)             !prsd
      ELSE 
         WRITE (IMPFCH,10002) '       ','Derniere',' ',THETR1(1:7)
     &                       ,' plage','Numeros de '//THETR1(9:15)
     &                       //' de debut de plage(longueur)'
         WRITE (IMPFCH,10003) 1,NBPLAG,STRUCT(MCPLIG),STRUCT(MCPLIG+1)
     &                       ,(STRUCT(MCPLIG+2*K)
     &          ,STRUCT(MCPLIG+2*K+1)-STRUCT(MCPLIG+2*K-1),K=1,NBPLAG-1)
         N1=1+STRUCT(MCPLAG)
         NBLIMP=MIN (10*NIVIMP,NBLIGN)
         IF (NIVIMP.GT.10) NBLIMP=NBLIGN
         WRITE (IMPFCH,10005) NIVIMP,THETR1(1:8),NBLIMP
         DO 1 I=2,NBLIMP
            N2=STRUCT(MCPLAG+I-1)
            WRITE (IMPFCH,10003) I,N2,(STRUCT(MCPLIG+2*K)
     &               ,STRUCT(MCPLIG+2*K+1)-STRUCT(MCPLIG+2*K-1),K=N1,N2)
            N1=N2+1
1        CONTINUE
         WRITE (IMPFCH,10002) THETR1(1:7),'      '
     &                       ,'Longueurs cumulees des plages'
         N1=1  
         DO 2 I=1,NBLIMP
            N2=STRUCT(MCPLAG+I-1)
            WRITE (IMPFCH,10004) I,(STRUCT(MCPLIG+2*K+1),K=N1,N2)
            N1=N2+1
2        CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A,'>*PrMors* ',A,' ',A)
10001 FORMAT(T6,'Nb. de ',A,' de la matrice :',T55,I7/
     &       T6,'Nb. de plages de la matrice :',T55,I7/ 
     &       T6,'Nb. de coeff. de la matrice morse :',T55,I7,' ',A)
10002 FORMAT(A,TR3,A:,TR3,A)
10003 FORMAT(2(I6,TR3),(T23,9(I4,'(',I4,') ')))
10004 FORMAT(I6,(T18,10I10))
10005 FORMAT(T6,'--> Impression de niveau ',I3,:,' : ',A,' de 1 a',I6)
10006 FORMAT(T6,'** Tableau de stockage transpose **')
                                                                    END !PrMors
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 1.2 : D.Martin (9 Septembre 2006)
*   Rajout du format 1006
* Version anterieure : D.Martin (8 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
