*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRSDDS (NVDSSA,NMTERA,NVTERA,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1992)
* Derniere modification : D.Martin (27 Juin 2000)
* Version 1.0.1
*  
* Impression des termes d'une structure d'assemblage multi-inconnues $DSMBL
*  
*-- Arguments d'entree -- 
* NVDSSA niveau de la structure d'assemblage
* NMTERA nom du terme correspondant
* NVTERA son niveau
* NIVIMP niveau d'impression
* IMPFCH numero d'unite logique de fichier d'impression
*-- Structure $DSMBL
* $DSMBL(1)=LGETRD (=4)
*       (2)=NBLOCC nombre de termes en colonne
*       (3)=INCTRD (=5) nb. de caracteristiques par terme de la structure
*       (4)=NBLOCL nombre de termes en ligne
* puis pour chaque terme de la structure ( . = LGETRD+INCTRD*(NUTRAS-1))
*       (.  ) numero du terme (utile seulement pour l'assemblage)
*       (.+1) numero de l'inconnue en colonne du terme
*       (.+2) numero de l'inconnue en ligne du terme
*       (.+3) niveau de la numerotation en colonne du terme
*       (.+4) niveau de la numerotation en ligne du terme
*       (.+5) case de travail
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NMTERA*(*)
      INTEGER   NVDSSA,NVTERA,NIVIMP,IMPFCH
* 
      INCLUDE 'ALLOC'  
*
      CHARACTER PRFXAF*8,THETR1*16
      INTEGER   MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NCATR1
     &         ,MCDSSA,LGEASM,INCASM,NBLOCC,NBLOCL,NUTERM,NVTERM,NUBOEX
     &         ,NUBOIN,ADDSSA,ADMTRM,LRIPEX
      INTEGER   NIVTRM(10)
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'$DSMBL',NVDSSA,MCDSSA)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)
      CALL SDEXDB (IST(MCDSSA),LGEASM,NBLOCC,INCASM,NBLOCL)
*
      CALL PRNTRM (NMTERA,NVTERA,THETR1,NCATR1)
      WRITE (IMPFCH,10000) PRFXAF ( ),THETR1(1:NCATR1),NVDSSA
*
      IF (NBLOCC.LE.10) THEN
         LRIPEX=LGEASM
         DO 9 NUBOEX=1,NBLOCL
            ADDSSA=MCDSSA+LRIPEX
            ADMTRM=1
            DO 1 NUBOIN=0,NBLOCC-1
               NUTERM=IST(ADDSSA)
               IF (NUTERM.GT.0) THEN
                  CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM
     &            ,ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM))
                  NIVTRM(NUBOIN+1)=IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
               ELSEIF (NUTERM.EQ.-1) THEN
                  ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM)='$ndef$'
                  NIVTRM(NUBOIN+1)=-9999999
               ELSEIF (NUTERM.EQ.0) THEN
                  ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM)='$vide$'
                  NIVTRM(NUBOIN+1)=-9999999
               ENDIF
               ADMTRM=ADMTRM+NCHTRM
               ADDSSA=ADDSSA+INCASM*NBLOCL
1           CONTINUE
            WRITE (IMPFCH,10003) ('--------',NUBOIN=1,NBLOCC)
            WRITE (IMPFCH,10002)
     &     (ERCODE(1+NUBOIN*NCHTRM:(NUBOIN+1)*NCHTRM),NUBOIN=0,NBLOCC-1)
            WRITE (IMPFCH,10004) (NIVTRM(NUBOIN),NUBOIN=1,NBLOCC)
            LRIPEX=LRIPEX+INCASM
9        CONTINUE
         WRITE (IMPFCH,10003)    ('--------',NUBOIN=1,NBLOCC)
      ENDIF
*
      IF (NIVIMP.GT.1.OR.NBLOCC.GT.10) THEN
         ADDSSA=MCDSSA+LGEASM
         DO 12 NUBOEX=1,NBLOCC
            DO 11 NUBOIN=1,NBLOCL
               NUTERM=IST(ADDSSA)
               IF (NUTERM.GT.0) THEN
                  CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM
     &                        ,ERCODE(1:NCHTRM))
                  NVTERM=IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))
                  CALL PRNTRM (ERCODE(1:NCHTRM),NVTERM,THETR1,NCATR1)
                  WRITE (IMPFCH,10001) THETR1(1:NCATR1)
     &                             ,IST(ADDSSA+1),IST(ADDSSA+2)
     &                             ,IST(ADDSSA+3),IST(ADDSSA+4)
                  IF (NIVIMP.GE.5)
     &               CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPFCH)
               ELSEIF (NUTERM.EQ.-1) THEN
                  WRITE (IMPFCH,10001) ' $ndef$'
     &                             ,IST(ADDSSA+1),IST(ADDSSA+2)
     &                             ,IST(ADDSSA+3),IST(ADDSSA+4)

               ELSE
                  WRITE (IMPFCH,10001) ' $vide$'
     &                             ,IST(ADDSSA+1),IST(ADDSSA+2)
     &                             ,IST(ADDSSA+3),IST(ADDSSA+4)
               ENDIF
               ADDSSA=ADDSSA+INCASM
11          CONTINUE
12       CONTINUE
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,'>*PrsdDs* Structure de l''assemblage '
     &,'multi-inconnue du terme ',A
     &,/T20,'Structure d''assemblage de niveau ',I4/)
10001 FORMAT(/T9,'Terme ',A,:,' , Inconnues C/L ',I4,'/',I4
     &,' , Numerotations C/L ',I4,'/',I4)
10002 FORMAT (T9,'|',10(' ',A6,' |',:))
10003 FORMAT (T9,'|',10(A8,'|',:))
10004 FORMAT (T9,'|',10(I7,' |',:))
                                                                    END !PrsdDs
