*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRSDTR (NUTERM,ISDTRM,NOMTRM,IMPNUM) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1989)
* Derniere modification : D.Martin (30 janvier 2003)
* Version 1.0.5
*  
* Impression des attributs d'un terme 
*  
*--  Arguments d'entree --
* NUTERM numero du terme dans les structures $SDTRM et #OMTRM  
* ISDTRM structure $SDTRM a l'adresse 1
* NOMTRM structure #OMTRM a l'adresse 1
* IMPNUM numero logique de l'unite d'impression
*
*-- Caracteristiques d'un terme --
* NIVTRM niveau du terme (ou du tableau contenant le terme)
* ITYPTR indice de type (reel,complexe) du terme
* ITYCAL type de calcul du terme (ELFINI,VALNOD,C.ESSE,....)
* NUKALE numero du calcul a effectuer (numero d'integrand, de cond. essen...)
* NUDONN numero de donnee affectee
* ITYSYM numero de type de symetrie pour un terme matricielle
*        nombre de valeurs par noeud pour un terme de type valeurs nodales
* NVDSMB numero de la structure d'assemblage associee pour un terme
*        resultant d'un assemblage uni-inconnue ou multi-inconnues
* NUINCC numero de l'inconnue en colonne (0 pour un terme multi-inconnues)
* NVDUMC niveau du tableau de numerotation des d.l. en colonne
* NBCOLO nombre de colonnes du terme, compte en noeuds
*        ou en d.l. pour un terme multi-inconnues
* NVNUMC niveau du tableau de numerotation des noeuds en colonne
* NUINCL numero de l'inconnue en ligne (0 pour un terme multi-inconnues)
* NVDUML niveau du tableau de numerotation des d.l. en ligne
* NBLIGN nombre de lignes du terme, compte en noeuds
*        ou en d.l. pour un terme multi-inconnues
* NVNUML niveau du tableau de numerotation des noeuds en ligne
* INSTOK numero de type de stockage
* NVSTOK numero du tableau des tables de stockage
* NVCORC numero du tableau des coordonnees des noeuds/normales en colonne
* IATRDO adresse relative du domaine de calcul dans #TERDO (si terme primaire)
* NIVIMP niveau d'impression pour le terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER NOMTRM(*)  
      INTEGER   NUTERM,ISDTRM(*),IMPNUM 
*  
      INCLUDE 'CONTEX'
*
      CHARACTER STOIND*9,TYPINT*9,YKLINT*6,FACIND*6,SYMIND*14,PRFXAS*8
     &         ,VANOIN*7                                                !utilite
      CHARACTER TYKL*6
      INTEGER   LGETRM,NBTERM,INCTRM,NCHTRM,I
     &         ,NIVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &         ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &         ,NVNUML,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PrSdtr*')                                        !utilite
*
      CALL SDEXDB (ISDTRM,LGETRM,NBTERM,INCTRM,NCHTRM)
*
      CALL GETTRM (ISDTRM(LGETRM+INCTRM*(NUTERM-1)+1),NIVTRM,ITYPTR      
     &            ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB,NUINCC,NVDUMC
     &            ,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INDSTK
     &            ,NVSTOK,NVCORC,IATRDO,NIVIMP)
      WRITE (IMPNUM,10000) PRFXAS (1)
     &             ,(NOMTRM(I),I=NCHTRM*(NUTERM-1)+1,NCHTRM*NUTERM)
*  
      TYKL=YKLINT (ITYCAL)
      WRITE (IMPNUM,10010) 'Numero du terme ',NUTERM
     &                    ,'Niveau du terme ',NIVTRM
      WRITE (IMPNUM,10013) 'Type de declaration ',TYPINT(ITYPTR)        !utilite
     &                    ,'Type de calcul ',TYKL
      IF (TYKL.EQ.'ELFINI'.OR.TYKL.EQ.'MATELM')     THEN
         WRITE (IMPNUM,10010) 'Integrand ''E.F.'' ',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'ELFLOC') THEN
         WRITE (IMPNUM,10010) '''E.F.Loc.'' intg.analytique',NUKALE
     &                       ,'Numero de donnee',NUDONN 
      ELSEIF (TYKL.EQ.'ELFLQU') THEN
         WRITE (IMPNUM,10010) '''E.F.Loc.'' intg.numerique',NUKALE
     &                       ,'Numero de donnee',NUDONN 
      ELSEIF (TYKL.EQ.'C.ESSE') THEN
         WRITE (IMPNUM,10010) 'Cond. ESSEntielle',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'C.TRAN')  THEN
         WRITE (IMPNUM,10010) 'Cond. de TRANsmission',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'VALNOD') THEN
         WRITE (IMPNUM,10012) 'Terme VALeur NODales',VANOIN(ABS(NUKALE))!utilite
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'SPECTR') THEN
         WRITE (IMPNUM,10010) 'Terme Spectral',NUKALE
     &                       ,'Numero de donnee',NUDONN  
      ELSEIF (TYKL.EQ.'ASSEMB') THEN
         WRITE (IMPNUM,10010) 'Terme ASSEMBle',NUKALE
     &                       ,'Numero de donnee',NUDONN 
      ELSEIF (TYKL.EQ.'COUPLA') THEN
         WRITE (IMPNUM,10010) 'Terme de COUPLAge',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'SOLUTI') THEN
         WRITE (IMPNUM,10010) 'Terme SOLUTIon',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'VALPRO') THEN
         WRITE (IMPNUM,10010) 'Terme ELement PROpre',NUKALE
      ELSEIF (TYKL.EQ.'FACTOR') THEN
         WRITE (IMPNUM,10012) 'Terme FACTORise :',FACIND(NUKALE)        !utilite
      ELSEIF (TYKL.EQ.'INTERP') THEN
         WRITE (IMPNUM,10010) 'Interpolation ''E.F.'' ',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSEIF (TYKL.EQ.'FORMLI') THEN
         WRITE (IMPNUM,10010) 'Forme lineaire ',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ELSE 
         WRITE (IMPNUM,10010) 'Terme de type non defini :',NUKALE
     &                       ,'Numero de donnee',NUDONN
      ENDIF
*
      IF (NUINCL.NE.NDFINC.AND.NUINCC.NE.NDFINC) THEN
         WRITE (IMPNUM,10010) 'Inconnue       (colonne)',NUINCC
     &                       ,'               (ligne)',NUINCL
         IF (NBLIGN.GT.0.OR.NBCOLO.GT.0)
     &      WRITE (IMPNUM,10010) 'Nb. noeuds     (colonne)',NBCOLO
     &                          ,'               (ligne)',NBLIGN
         IF (NVNUML.NE.NDFNUM.OR.NVNUMC.NE.NDFNUM)
     &      WRITE (IMPNUM,10010) 'Numerot. noeuds(colonne)',NVNUMC
     &                          ,'               (ligne)',NVNUML
         IF (NVDUML.NE.NDFDUM.OR.NVDUMC.NE.NDFDUM)
     &      WRITE (IMPNUM,10010) 'Numerot. d.l.  (colonne)',NVDUMC
     &                          ,'               (ligne)',NVDUML
      ELSEIF (NUINCL.NE.NDFINC) THEN
         WRITE(IMPNUM,10010) 'Inconnue (ligne)',NUINCL
         IF (NBLIGN.GT.0)
     &      WRITE (IMPNUM,10010) 'Nb. noeuds     ',NBLIGN
     &                          ,'Nb. colonnes ',NBCOLO
         IF (NVNUML.NE.NDFNUM)
     &      WRITE (IMPNUM,10010) 'Numerot. noeuds',NVNUML
         IF (NVDUML.NE.NDFDUM)
     &      WRITE (IMPNUM,10010) 'Numerot. d.l.  ',NVDUML
      ELSEIF (NUINCC.NE.NDFINC) THEN
         WRITE (IMPNUM,10010) 'Inconnue (colonne)',NUINCC
         IF (NBCOLO.GT.0)
     &      WRITE (IMPNUM,10010) 'Nb. noeuds ',NBCOLO
     &                          ,'Nb. lignes ',NBLIGN
          IF (NVNUMC.NE.NDFNUM)
     &      WRITE (IMPNUM,10010) 'Numerot. noeuds ',NVNUMC
         IF (NVDUMC.NE.NDFDUM)
     &      WRITE (IMPNUM,10010) 'Numerot. d.l.',NVDUMC
      ELSE
         IF (NVDSMB.NE.NDFDSM)
     &      WRITE (IMPNUM,10010) 'Struct. multi-inconnues',NVDSMB
         IF (NBLIGN.GT.0.OR.NBCOLO.GT.0)
     &      WRITE (IMPNUM,10010) 'Nombre de colonnes',NBCOLO
     &                          ,'Nombre de lignes',NBLIGN
         IF (NVDSMB.NE.NDFDSM)
     &      WRITE (IMPNUM,10011) 'Niveau geometrie',NVCORC
     &                          ,'Type de symetrie',SYMIND(ITYSYM)      !utilite
      ENDIF
      IF (NUKALE.LE.0) THEN
         IF (NUINCL.EQ.NDFINC.AND.NUINCC.EQ.NDFINC
     &  .AND.NVDSMB.NE.NDFDSM) THEN
            WRITE (IMPNUM,10011) 'Niveau geometrie',NVCORC
     &                          ,'Type de symetrie',SYMIND(ITYSYM)      !utilite
         ELSEIF (NUINCL.EQ.NDFINC.OR.NUINCC.EQ.NDFINC
     &         .OR.TYKL.EQ.'C.ESSE'.OR.TYKL.EQ.'C.TRAN') THEN
            WRITE (IMPNUM,10010) 'Niveau geometrie',NVCORC
     &                          ,'Nombre de valeurs/noeud',ITYSYM
         ELSE
            WRITE (IMPNUM,10011) 'Niveau geometrie',NVCORC
     &                          ,'Type de symetrie',SYMIND(ITYSYM)      !utilite
         ENDIF
      ENDIF
      IF (INDSTK.NE.0) THEN
         WRITE (IMPNUM,10012) 'Type de stockage',STOIND(INDSTK)         !utilite
     &                       ,'Niveau stockage',NVSTOK
      ENDIF
      WRITE (IMPNUM,10010) 'Adr. ''#TERDO'' =',IATRDO
     &                    ,'Impression :',NIVIMP
*
      CALL PRFXMJ (-1,'*PrSdtr*')                                       !utilite
*-----------------------------------------------------------------------
10000 FORMAT(T11,A,'>*PrSdtr* terme ',50(A1)) 
10010 FORMAT(T12,A,T36,I9,:,T46,A:,T70,I9)
10011 FORMAT(T12,A,T36,I9,:,T46,A:,T70,A)
10012 FORMAT(T12,A,T36, A,:,T46,A:,T70,I9)
10013 FORMAT(T12,A,T36, A,:,T46,A:,T70,A)
                                                                    END !PrSdtr
