*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRTERM (NMTERM,NVTERM,NIVIMP,IMPFCH) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)
* Version 6 : D.Martin (17 novembre 2009)
*
* Impression d'un tableau ou d'un terme, et dans ce dernier cas,
* et le cas echeant impression de ses caracteristiques
*  
*-- Arguments --  
* NMTERM nom du tableau ou du (tableau contenant le) terme
* NVTERM niveau du (tableau contenant le) terme
* NIVIMP niveau d'impression (impression partielle ou totale du terme)  
*        NIVIMP < 10 impression des 10*NIVIMP premiers coefficients
*                    et des 10*NIVIMP derniers coefficients
*        NIVIMP > 9 impression de tous les coefficients
*        De plus si NIVIMP > 4 impression des caracteristiques du terme
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NIVIMP,IMPFCH
*  
      INCLUDE 'ALLOC'  
      INCLUDE 'CONTEX' 
*
      INTEGER       INDSTO,INTYKL,KLTERM                                !utilite
      CHARACTER     STODLN*6,TYPINT*9,SYMIND*14,YKLINT*6,PRFXAS*8       !utilite
      CHARACTER     TYKL*6,TYTERM*9,THETR1*16,MULTIN*1
      INTEGER       LGTERM,MCTERM,MCDTRM,MCMTRM,MCINCO,LGETRM,NBTERM
     &             ,INCTRM,NCHTRM,NUTERM,MCSTOK
     &             ,NVVTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN
     &             ,NVNUML,INSTOK,NVSTOK,NVCORC,IATRDO,NIVOLD
     &             ,NCPINL,INTRPL,NBTNEL,NCPINC,INTRPC,NBTNEC,NCATR1
      CHARACTER     ERCODE*120,NMSTOK*6
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      IF (NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
*
      CALL PRFXMJ (1,'*PrTerm*')
*
      LGTERM=0
*     CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
*
*     Adresses des structures $SDTRM description des termes
*                             #OMTRM noms des termes
*                             #NCONU noms des inconnues
*
      CALL TBAR3  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM
     &                   ,'#NCONU',1,MCINCO)                     
*
*     Caracteristiques de la structure $SDTRM
*
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Numero du terme/tableau a imprimer
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      CALL PRNTRM (NMTERM,NVTERM,THETR1,NCATR1)
*
      IF (NUTERM.GT.0) THEN
*
*        Il s'agit d'un terme (defini dans #OMTRM,$SDTRM)
*
         CALL GETTRM (IST(MCDTRM+LGETRM+(NUTERM-1)*INCTRM),NVVTRM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSSS
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INSTOK,NVSTOK,NVCORC,IATRDO,NIVOLD)               !sdexplo
         TYKL  =YKLINT (ITYCAL)
         TYTERM=TYPINT (ITYPTR)
         NCPINL=1
         NCPINC=1
         MULTIN='N'
         IF (NVDSSS.NE.NDFDSM.AND.NUINCL.EQ.NDFINC.AND.NUINCC.EQ.NDFINC)
     &   MULTIN='Y'
         IF (MULTIN.EQ.'N') THEN
*
*           Pour un terme uni-inconnue, caracteristiques des inconnues
*           en ligne et en colonne
*
            IF (NUINCL.NE.NDFINC) 
     &      CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)       !utilite
            NCPINC=NCPINL
            IF (NUINCC.NE.NDFINC.AND.NUINCC.NE.NUINCL)
     &      CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTRPC,NBTNEC)       !utilite
         ENDIF
*
         IF (ITYSYM.EQ.NDFSYM.OR.NUINCL.EQ.NDFINC.OR.NUINCC.EQ.NDFINC
     &   .OR.TYKL.EQ.'VALNOD'.OR.TYKL.EQ.'C.ESSE'.OR.TYKL.EQ.'C.TRAN') 
     &   THEN
            WRITE (IMPFCH,10000) PRFXAS(1)//'>'//PRFXAS (0)
     &                          ,'terme',THETR1(1:NCATR1),TYKL,TYTERM
         ELSE
            WRITE (IMPFCH,10000) PRFXAS(1)//'>'//PRFXAS (0)
     &                          ,'terme',THETR1(1:NCATR1),TYKL,TYTERM
     &                          ,SYMIND(ITYSYM)
         ENDIF
*
*        Impression des caracteristiques du terme, et, pour un terme resultant
*        d'un assemblage multi-inconnues, de sa structure d'assemblage
*
         IF (NIVIMP.GE.2) THEN
            CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPFCH)
            IF (MULTIN.EQ.'Y') THEN
               CALL TBRR1  (ERCODE,'$DSMBL',NVDSSS,LGTERM)
               CALL PRSDDS (NVDSSS,NMTERM,NVTERM,NIVIMP,IMPFCH)
            ENDIF
         ENDIF
*
*        Longueur et niveau d'impression pour l'impression en cours
*
         CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
         WRITE (IMPFCH,10001) LGTERM,NIVIMP
*
         IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN                         !utilite
            NMSTOK = '&BMORS'
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            IF (ERCODE(1:1).NE.' ') THEN
*
*              Structure de stockage comptee en d.l.
*
               NMSTOK = STODLN (INSTOK,NCPINC,NCPINL)
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
               NCPINC=1
               NCPINL=1
            ENDIF
            CALL TBAR2  (ERCODE,NMTERM,NVTERM,MCTERM
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMABM (IST(MCSTOK),ITYSYM,NCPINC,NCPINL           
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)                    
            CALL TBSAVE(NMSTOK,NVSTOK)
*
         ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                     !utilite
            NMSTOK = '&PLAGE'
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            IF (ERCODE(1:1).NE.' ') THEN
               NMSTOK = STODLN (INSTOK,NCPINC,NCPINL)
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
               NCPINC=1
               NCPINL=1
            ENDIF
            CALL TBAR2  (ERCODE,NMTERM,NVTERM,MCTERM
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMAMO ('Lig.',IST(MCSTOK),NCPINC,NCPINL
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            CALL TBSAVE (NMSTOK,NVSTOK)                     
*
         ELSEIF (INSTOK.EQ.INDSTO ('MORSE-C')) THEN                     !utilite
            NMSTOK = '&EGALP'
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            IF (ERCODE(1:1).NE.' ') THEN
               NMSTOK = STODLN (INSTOK,NCPINC,NCPINL)
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
               NCPINC=1
               NCPINL=1
            ENDIF
            CALL TBAR2  (ERCODE,NMTERM,NVTERM,MCTERM
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMAMO ('Col.',IST(MCSTOK),NCPINL,NCPINC
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            CALL TBSAVE (NMSTOK,NVSTOK)                     
*
         ELSEIF (INSTOK.EQ.INDSTO ('PROFIL')) THEN                      !utilite
            NMSTOK = '&PROFL'
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            IF (ERCODE(1:1).NE.' ') THEN
               NMSTOK = STODLN (INSTOK,NCPINC,NCPINL)
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
            ENDIF
            CALL TBAR2  (ERCODE,NMTERM,NVTERM,MCTERM 
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMAPR (IST(MCSTOK),ITYSYM
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)                    
            CALL TBSAVE (NMSTOK,NVSTOK)                     
*
         ELSEIF (INSTOK.EQ.INDSTO ('NUME-L')) THEN                      !utilite
            NMSTOK = '&NUMEL'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            CALL TBAR2  (ERCODE,NMTERM,NVTERM,MCTERM 
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMANL ('Lig.',IST(MCSTOK)
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            CALL TBSAVE (NMSTOK,NVSTOK)
*
         ELSEIF (INSTOK.EQ.INDSTO ('NUME-C')) THEN                      !utilite
            NMSTOK = '&NUMEC'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGTERM)
            CALL TBAR2  (ERCODE, NMTERM ,NVTERM,MCTERM 
     &                         ,NMSTOK,NVSTOK,MCSTOK)
            CALL PRMANL ('Col.',IST(MCSTOK)
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            CALL TBSAVE (NMSTOK,NVSTOK)
*
         ELSEIF (ITYCAL.EQ.INTYKL ('MATELM')) THEN
            CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
            CALL PRNOTR (LGTERM
     &                  ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
*
         ELSE
*           Matrices pleines ou vecteurs
            CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
            IF (NUINCC.NE.NDFINC.AND.NUINCL.NE.NDFINC) THEN
*              Matrice pleine uni-inconnue
               IF (INSTOK.EQ.INDSTO ('PLEIN-L')) THEN                   !utilite
*                 Matrice pleine par ligne
                  CALL PRMAPL (NBLIGN,NBCOLO,NCPINC,NCPINL
     &                        ,NBCOLO*NCPINC,1
     &                        ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-C')) THEN               !utilite
*                 Matrice pleine par colonne ('a la fortran')
                  CALL PRMAPL (NBLIGN,NBCOLO,NCPINC,NCPINL
     &                        ,1,NBLIGN*NCPINL
     &                        ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ELSE
*                 Vecteur de condition de Transmission
                  IF (NBLIGN.GT.1) THEN 
                     CALL PRVECT ('Ligne',NBCOLO,NBLIGN,1
     &                           ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
                  ELSEIF (NBCOLO.GT.1) THEN
                     CALL PRVECT ('Colonne',NBLIGN,NBCOLO,1
     &                           ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
                  ENDIF
               ENDIF
            ELSEIF (NUINCL.NE.NDFINC) THEN
*              Vecteur (multi-)colonne uni-inconnue
               IF (ITYSYM.NE.NDFSYM) NCPINL=ITYSYM
               CALL PRVECT ('Colonne',NBCOLO,NBLIGN,NCPINL
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            ELSEIF (NUINCC.NE.NDFINC) THEN
*              Vecteur (multi-)ligne uni-inconnue
               IF (ITYSYM.NE.NDFSYM) NCPINC=ITYSYM
               CALL PRVECT ('Ligne',NBLIGN,NBCOLO,NCPINC
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
            ELSEIF (NVDSSS.NE.NDFDSM) THEN
               IF (INSTOK.EQ.INDSTO ('PLEIN-L').AND.NBCOLO.GT.1)
     &         THEN
*              Vecteur multi-lignes multi-inconnues
               CALL PRVECT ('Ligne',NBLIGN,NBCOLO,1
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-C').AND.NBLIGN.GT.1)
     &         THEN
*              Vecteur multi-colonnes multi-inconnues
               CALL PRVECT ('Colonne',NBCOLO,NBLIGN,1
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ELSEIF (NBLIGN.GT.0) THEN
*              Vecteur ligne multi-inconnue
               CALL PRVECT ('Ligne',NBCOLO,NBLIGN,1
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ELSEIF (NBCOLO.GT.0) THEN
*              Vecteur colonne multi-inconnue
               CALL PRVECT ('Colonne',NBLIGN,NBCOLO,1
     &                     ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
               ENDIF
            ENDIF
*
         ENDIF
         WRITE (IMPFCH,10002) PRFXAS (1)//'>'//PRFXAS (0)
     &                       ,'terme',THETR1(1:NCATR1)
*
      ELSE
*        Le tableau n'est pas un terme
         CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
         WRITE (IMPFCH,10001) LGTERM,NIVIMP
         CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
         CALL TBTYPE (NMTERM,NVTERM,ITYPTR)
         TYTERM=TYPINT (ITYPTR)                                         !utilite
         WRITE (IMPFCH,10000) PRFXAS(1)//'>'//PRFXAS (0)
     &                       ,'tableau',THETR1(1:NCATR1),TYTERM
         CALL PRNOTR (LGTERM
     &               ,TYTERM,MCTERM,RST,CST,NIVIMP,IMPFCH)
         WRITE (IMPFCH,10002) PRFXAS(1)//'>'//PRFXAS (0)
     &                       ,'tableau',THETR1(1:NCATR1)
*
      ENDIF
      CALL TBSAVE (NMTERM,NVTERM)
 1000 CALL PRFXMJ (-1,'*PrTerm*')
*-----------------------------------------------------------------------
10000 FORMAT (/T2,A,' ',A,' ',A,' de type ',A,:,', ',A,:,', ',A)
10001 FORMAT (T19,' (',I9,' coeff., impression de niveau',I3,')')
10002 FORMAT (T2,A,' Fin d''impression du ',A,' ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 6 : D.Martin (17 novembre 2009)
* Version 5 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 4 : D.Martin (8 septembre 2006)
*   Bug : NCPINC <-> NCPINL dans l'appel de PRMAPL pour le cas Morse-L
* Version 2 : D.Martin (31 mars 2005)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Prterm
