*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRVECT (LIOUCO,NBCOLO,NBLINE,NCPINL,TYPE,MCA
     &                  ,RST,CST,NIVIMP,IMPFCH)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)
* Derniere modification : D.Martin (27 Avril 1999)
* Version 1.0.0
*  
* Impression d'un vecteur (multi-lignes ou multi-colonnes)
*  
*-- Arguments --
* LIOUCO 'Ligne' ou Colonne'
* NBCOLO nombre de colonnes du vecteur multi-colonnes
* NBLINE nombre de lignes du vecteur (compte par noeud)
* NCPINL nombre de composantes de l'inconnue
* TYPE   type ('REEL' ou 'COMPLEXE') du vecteur
* MCA    adresse du vecteur dans le super-tableau RST ou CST
* RST,CST Super-tableau version reelle ou complexe
* NIVIMP niveau d'impression (impression partielle du vecteur)  
*        NIVIMP < 10 impression des 10*NIVIMP premiers coefficients
*                    et des 10*NIVIMP dernieres coeficients du vecteur 
*        NIVIMP > 9 impression de tous les coefficients du vecteur 
* IMPFCH numero d'unite logique du fichier d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE,LIOUCO
      INTEGER       NBCOLO,NBLINE,NCPINL,MCA,NIVIMP,IMPFCH
      REAL          RST(*)
      COMPLEX       CST(*)
*
      CHARACTER     PRFXAF*8
      INTEGER       NBPRL1,I,MCA1,K
*-----------------------------------------------------------------------
      IF (NIVIMP.LE.0.OR.IMPFCH.LE.0) RETURN
      WRITE (IMPFCH,10000) PRFXAF ( )
      MCA1=MCA
      NBPRL1=10*NIVIMP
      IF (TYPE(1:1).EQ.'R') THEN
         IF (NIVIMP.GE.10.OR.2*NBPRL1.GE.NBLINE) THEN
            DO 21 K=1,NBCOLO
            IF (NBCOLO.GT.1) WRITE (IMPFCH,10003) LIOUCO,K
            WRITE (IMPFCH,10002) 1,NBLINE*NCPINL
     &                        ,(RST(I),I=MCA1,MCA1+NBLINE*NCPINL-1)
            MCA1=MCA1+NBLINE*NCPINL
21          CONTINUE
         ELSE
            DO 22 K=1,NBCOLO
            IF (NBCOLO.GT.1) WRITE (IMPFCH,10003) LIOUCO,K
            WRITE (IMPFCH,10002) 1,NBPRL1*NCPINL
     &                        ,(RST(I),I=MCA1,MCA1+NBPRL1*NCPINL-1)
            WRITE (IMPFCH,10001)
            WRITE (IMPFCH,10002) (NBLINE-NBPRL1)*NCPINL+1,NBLINE*NCPINL
     &      ,(RST(I),I=MCA1+(NBLINE-NBPRL1)*NCPINL,MCA1+NBLINE*NCPINL-1)
            MCA1=MCA1+NBLINE*NCPINL
22          CONTINUE
         ENDIF 
      ELSEIF (TYPE(1:1).EQ.'C') THEN
         IF (NIVIMP.GE.10.OR.2*NBPRL1.GE.NBLINE) THEN
            IF (NBCOLO.GT.1) WRITE (IMPFCH,10003) LIOUCO,K
            DO 41 K=1,NBCOLO
            WRITE (IMPFCH,10004) 1,NBLINE*NCPINL
     &                        ,(CST(I),I=MCA1,MCA1+NBLINE*NCPINL-1)
            MCA1=MCA1+NBLINE*NCPINL
41          CONTINUE
         ELSE 
            DO 42 K=1,NBCOLO
            IF (NBCOLO.GT.1) WRITE (IMPFCH,10003) LIOUCO,K
            WRITE (IMPFCH,10004) 1,NBPRL1*NCPINL
     &                        ,(CST(I),I=MCA1,MCA1+NBPRL1*NCPINL-1)
            WRITE (IMPFCH,10001)
            WRITE (IMPFCH,10004) (NBLINE-NBPRL1)*NCPINL+1,NBLINE*NCPINL
     &      ,(CST(I),I=MCA1+(NBLINE-NBPRL1)*NCPINL,MCA1+NBLINE*NCPINL-1)
            MCA1=MCA1+NBLINE*NCPINL
42          CONTINUE
         ENDIF
      ENDIF
*-----------------------------------------------------------------------
10000 FORMAT(T11,A8,'>*PrVect*')
10001 FORMAT(T14,'..........')
10002 FORMAT(T14,'Coefficients',I6,' a ',I6/(T14,10(E10.4,' ')))
10003 FORMAT(T14,A,' ',I5)
10004 FORMAT(T14,'Coefficients',I6,' a ',I6/
     &(T14,5(SS,E10.4,SP,E10.4,'*i ')))
                                                                    END !PrVect
