*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VIPLAG (LIOUCO,NBLIGN,NBCOLO,NULAPL,IPLAGE,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1990)
* Derniere modification : D.Martin (9 Septembre 2001)
* Version 1.0.2
*  
* Visualisation des elements non nuls d'une matrice a l'aide  
* des tableaux de stockage matriciel Morse-Ligne ou Morse_Colonne.
* 
*-- Arguments --
* LIOUCO 'Ligne' ou 'Colon.'
* NBLIGN nombre de lignes (colonnes)
* NBCOLO nombre de colonnes (lignes)
* NULAPL numeros de derniere plage de chaque ligne (colonne)
* IPLAGE numeros de colonne (ou de ligne) de debut de plage et
*        adresses des derniers coefficients de plage 
* IMPFCH numero d'unite logique du fichier d'impression 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*7   LIOUCO
      INTEGER       NBLIGN,NBCOLO,NULAPL(*),IPLAGE(2,*),IMPFCH
*  
      CHARACTER     STAR(400),FORMA*28
      INTEGER       LIGNE,KOLONE,LGPL,NP,N1,N2,NDEB,NLAS,LGCUAV
*-----------------------------------------------------------------------
      IF (NBCOLO.GT.20) WRITE(IMPFCH,10000) (LIGNE,LIGNE=1,NBCOLO/10)  
      WRITE(IMPFCH,10001) (MOD(LIGNE,10),LIGNE=1,NBCOLO)
*
      LGPL=0
      N1=1
      LGCUAV=0
      FORMA='(I4,''   '',400A1,I8,'' a '',I8)'
      CALL ENCLER (NBCOLO,FORMA(11:13))
      DO 10 LIGNE=1,NBLIGN
         N2=NULAPL(LIGNE) 
         DO 2 KOLONE=1,NBCOLO
2           STAR(KOLONE)='.'
         DO 3 NP=N1,N2 
            NDEB=IPLAGE(1,NP) 
            NLAS=IPLAGE(2,NP)-LGPL  
            DO 4 KOLONE=NDEB,NDEB+NLAS-1
               STAR(KOLONE)='x'
4           CONTINUE
            LGPL=LGPL+NLAS 
3        CONTINUE
         IF(N2.GE.N1) N1=N2+1
         WRITE(IMPFCH,FORMA) LIGNE,(STAR(KOLONE),KOLONE=1,NBCOLO)
     &                      ,LGCUAV+1,LGPL
         LGCUAV=LGPL
10    CONTINUE
      WRITE(IMPFCH,10001) (MOD(LIGNE,10),LIGNE=1,NBCOLO)
      IF (NBCOLO.GT.20) WRITE(IMPFCH,10000) (LIGNE,LIGNE=1,NBCOLO/10)
      WRITE(IMPFCH,*)
*-----------------------------------------------------------------------
10000 FORMAT(T8,40I10)
10001 FORMAT(T8,400I1)
                                                                    END !Viplag
