*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE REDLE
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1988)
* Derniere modification : D.Martin (5 juin 2000)
* Version # 1.0.6
*  
* Lecture d'articles de donnees de type non connu a priori 
*  
*   Les donnees 'MOT'-articles (FIORIT,EIORIT) sont ignorees.
*  
*   Le mot LECTURE permet de changer de fichier de lecture 
*   Syntaxe : <LECTURE/LIRE> (AVEC ECHO) sur <FICHIER/UNITE> &C
*              READ[ING] (WITH ECHO) <from/on> <FILE/UNIT> &C
*             (ou &C est un nom de fichier)
*
*   Le mot ECRITURE permet de changer de fichier d'impression principale 
*   Syntaxe : <ECRITURE/ECRIRE> sur <FICHIER/UNITE> &C
*             <WRITE/WRITING> [onto] [to] <FILE/UNIT> &C
*             (ou &C est un nom de fichier)
*  
*   Les donnees 'TITRE' sont imprimees, centrees sur les 82 premieres colonnes 
*   Syntaxe : <TITRE/TITLE> &I   (ou &I est le nombre de lignes de titre)
*              suivi des &I lignes de commentaire
*  
*   Les mots-cles 'STOP' et 'ARRET' mettent fin immediatement a l'execution
*   Syntaxe : STOP ou ARRET
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER          NBCHAR,NBFIOR,NBEIOR
      PARAMETER       (NBCHAR=4,NBFIOR=16,NBEIOR=14)
      CHARACTER*80     FIORIT,EIORIT,TEXTE
      CHARACTER        FIORIW(NBCHAR*NBFIOR),EIORIW(NBCHAR*NBEIOR)
      INTEGER          NFIX,IRE,NER,NCAR,ILU,IOP,KTYPLI,IT,NBIT
      DOUBLE PRECISION FLOT
      COMMON/REDCO1/   FLOT,NFIX,IRE,NER,NCAR,ILU,IOP(5)
      COMMON/REDCOM/   TEXTE
      EQUIVALENCE     (FIORIW,FIORIT),(EIORIW,EIORIT)
*
*     Listes des mots non interpretes (Francais & English)
*               1         2         3         4         5         6
*      1234567890123456789012345678901234567890123456789012345678901234
      DATA FIORIT/
     &'AU  AUX D   DE  DES DU  EN  ET  L   LA  LE  LES PAR SUR UN  UNE '
     &/
      DATA EIORIT/
     &'AND AT  BY  FROMIN  OF  OFF ON  ONTOOUT OVERTHE TO  UPON'/
*-----------------------------------------------------------------------
      KTYPLI=15
      IF (ILU.EQ.0) GOTO 1 
      ILU=0
      RETURN
1     CALL REDLEC (KTYPLI)
      IF (IRE.NE.3) RETURN
*
      IF (TEXTE(1:NCAR).EQ.'LECTURE'.OR.TEXTE(1:NCAR).EQ.'LIRE'
     &.OR.TEXTE(1:4).EQ.'READ') THEN
*
*        Lecture du nom de l'unite de lecture et
*        reinitialisation (par REDINI) des lectures par REDLEC 
         CALL REDUNI (*1)
*
      ELSEIF (TEXTE(1:NCAR).EQ.'ECRITURE'.OR.TEXTE(1:NCAR).EQ.'ECRIRE'
     &.OR.TEXTE(1:4).EQ.'WRIT') THEN
*
*        Lecture du nom de l'unite d'impression principale
         CALL REDOUT (*1)
*
      ENDIF
*
      IF (TEXTE(1:NCAR).EQ.'TITRE'.OR.TEXTE(1:NCAR).EQ.'TITLE') THEN
*        Lecture et impression d'un titre sur l'unite principale
         CALL REDTIT
*
      ELSEIF (TEXTE(1:NCAR).EQ.'ARRET'.OR.TEXTE(1:NCAR).EQ.'STOP') THEN
*
         CALL BYE  
     &    ('   Fin de lecture des directives et arret de l''execution.')
*
      ELSE
         IF (NCAR.LE.NBCHAR) THEN
*
*           Recherche des mots non interpretes (Francais & English)
*
            CALL DICCHN (1,NBFIOR,NBCHAR,FIORIW,TEXTE(1:NCAR),IT,NBIT)  !utilite
            IF (NBIT.GT.0) GOTO 1
            CALL DICCHN (1,NBEIOR,NBCHAR,EIORIW,TEXTE(1:NCAR),IT,NBIT)  !utilite
            IF (NBIT.GT.0) GOTO 1
         ENDIF
         RETURN
*
      ENDIF
      GOTO 1  
                                                                    END !Redle
