*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE REDNBR (CARTE,NRAN,NRANMX,LITERA,EXCLLU,IRE,NFIX,FLOT)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : (D.Martin, d'apres un programmme de M.Lepareux)
* Derniere modification : D.Martin (20 Mai 1996)
* Version  1.0.0
*  
* Reconnaissance de nombres sous forme de chaine de caracteres ASCII
*
*-- Arguments d'entree --
* CARTE  tableau de caracteres a reconnaitre
* NRAN   rang initial dans le tableau (final en sortie)
* NRANMX valeur maximum de NRAN
* LITERA .TRUE. si on peut lire des nombres comme 'PI'
* EXCLLU .TRUE. en sortie si on a lu '!'
* IRE    type du nombre reconnu (1 entier, 2 reel)
* NFIX   valeur de l'entier reconnu
* FLOT   valeur du reel reconnu (DOUBLE PRECISION)
*
*-- Procedure utilisee --
* CHARTY recherche du type de lecture d'un caractere (utiliter)
*        =0  separateur (blanc ou # : ; =)      =1 ! ou % ou @
*        =2  ( ou < ou [ ou {                   =3 ) ou > ou ] ou }
*        =4  ' ou " ou `                        =5 + ou - 
*        =6  . ou ,                             =7 lettre
*        =8  chiffre                            =9 $ (dollar)
*        =10 \ (antislash)                      =11 autre caractere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER       CARTE(*)
      INTEGER         NRAN,NRANMX,NFIX,IRE
      DOUBLEPRECISION FLOT
      LOGICAL         EXCLLU,LITERA
*
      INTEGER          ITCHAR,MFIX,NBCHIF,NBDECI,IEXP,NLU
      CHARACTER        CHNEXT,SIGNE,SIGNEX
      INTEGER          INTMIN,INTMAX
      REAL             REAMIN,REAMAX
      DOUBLE PRECISION DOPMIN,DOPMAX,EPSI,DP,DIX
      COMMON/MINMAX/   INTMIN,INTMAX,REAMIN,REAMAX,DOPMIN,DOPMAX
      DATA             EPSI/3.D-16/,DIX/1.D+01/
*-----------------------------------------------------------------------
      CHNEXT=CARTE(NRAN)
      SIGNE=CHNEXT
      IRE=0
      IF (LITERA) THEN
         IF (CHNEXT.EQ.'-'.OR.CHNEXT.EQ.'+') IRE=1
         NRAN=NRAN+IRE
         IF (CARTE(NRAN).EQ.'P'.AND.CARTE(NRAN+1).EQ.'I') THEN
            FLOT = 4.D0*ATAN(1.D0)
            IF (SIGNE.EQ.'-') FLOT=-FLOT
            NRAN=NRAN+2
            GOTO 20
         ENDIF
         NRAN=NRAN-IRE
      ENDIF
      NFIX=0
*-    Nombre de chiffre de la mantisse : 
      NBCHIF=0 
*-    Nombre de chiffres decimaux de la mantisse (apres un . ou une ,) : 
      NBDECI=-1
*-    Valeur de l'exposant du nombre reel:
      IEXP=0
*--   Lecture de la mantisse
      IF (CHNEXT.NE.'-'.AND.CHNEXT.NE.'+') GOTO 3  
2     IF (NRAN+1.GT.NRANMX) GOTO 5
      NRAN =NRAN+1 
      CHNEXT=CARTE(NRAN)
3     NLU = 1
      CALL CHARTY(CHNEXT,NLU,ITCHAR)                                    !utilite
      IF (ITCHAR.EQ.8) THEN
         NBCHIF=NBCHIF+1  
         IF (NBDECI.GE.0) NBDECI=NBDECI+1  
         IF (NBCHIF.LT.10) THEN
            NFIX=NLU+10*NFIX 
         ELSEIF (NBCHIF.EQ.10) THEN
            MFIX=NFIX
            NFIX=NLU 
         ELSE 
            IF (NBCHIF.LT.19) THEN
               NFIX=NLU+10*NFIX 
            ELSE 
               IF (NBDECI.LT.0) THEN
                  IEXP=IEXP+1  
               ELSE
                  NBDECI=NBDECI-1 
               ENDIF 
            ENDIF
         ENDIF
         GOTO 2
      ELSEIF (ITCHAR.EQ.0) THEN
         GOTO 5
      ELSEIF (ITCHAR.EQ.1) THEN
         EXCLLU=.TRUE.
         GOTO 5
      ELSEIF (ITCHAR.EQ.5) THEN
         GOTO 12
      ELSEIF (ITCHAR.EQ.6) THEN
         IF (NBDECI.GE.0) RETURN
         NBDECI=0
         GOTO 2
      ELSEIF (ITCHAR.EQ.7) THEN
         IF (CHNEXT.EQ.'D'.OR.CHNEXT.EQ.'E') GOTO 12
      ENDIF
      RETURN 
5     IF (NBDECI.GE.0.OR.NBCHIF.GT.9) GOTO 12
* 
*--    On a lu un ENTIER 
*  
      IRE=1  
      IF (SIGNE.EQ.'-') NFIX=-NFIX  
      FLOT=NFIX
      RETURN
*
*--    On a lu un REEL
*  
*     Prise en compte de la mantisse du reel
12    SIGNEX=' '  
      FLOT=NFIX
      NFIX=0
      IF (NBCHIF.GE.10) THEN
         DP=MFIX  
         IF (NBCHIF.GT.18) NBCHIF=18
         FLOT=FLOT+DP*DIX**(NBCHIF-9)
      ENDIF 
      FLOT=FLOT*(1.D0+EPSI) 
*     Lecture de l'exposant 
      IF (NBDECI.LT.0) NBDECI=0 
      IEXP=IEXP-NBDECI 
      NLU = 1
      CALL CHARTY (CHNEXT,NLU,ITCHAR)                                   !utilite
      IF (ITCHAR.EQ.0) THEN
         GOTO 19
      ELSEIF (ITCHAR.EQ.1) THEN
         EXCLLU=.TRUE.
         GOTO 19
      ELSEIF (ITCHAR.EQ.5) THEN
         SIGNEX=CHNEXT
      ELSEIF (ITCHAR.EQ.8) THEN
         GOTO 13
      ENDIF  
      CARTE(NRAN)=CHNEXT
13    IF (NRAN+1.LE.NRANMX) THEN
         NRAN =NRAN+1
         CHNEXT=CARTE(NRAN)
         NLU = 1
         CALL CHARTY (CHNEXT,NLU,ITCHAR)                                !utilite
         IF (ITCHAR.EQ.8) THEN
            NFIX=NLU+10*NFIX 
            GOTO 13
         ELSEIF (ITCHAR.EQ.5) THEN
            IF (SIGNEX.NE.' ') RETURN
            SIGNEX=CHNEXT
            GOTO 13
         ELSEIF (ITCHAR.EQ.1) THEN
            EXCLLU=.TRUE.
         ELSEIF (ITCHAR.GT.0) THEN
            RETURN
         ENDIF 
      ENDIF
19    IF (SIGNEX.EQ.'-') NFIX=-NFIX
      IEXP=IEXP+NFIX
      FLOT=FLOT*DIX**IEXP
*
*     Prise en compte du signe des reels
*
20    IF (FLOT.LT.0) THEN
          FLOT=-FLOT
          SIGNE='-'
      ENDIF
      IF (FLOT.GT.INTMAX*1.D0) THEN
          NFIX=INTMAX
      ELSE 
          NFIX=INT(FLOT)
      ENDIF
      IF (SIGNE.EQ.'-') THEN
         FLOT=-FLOT 
         NFIX=-NFIX
      ENDIF
      IRE=2
                                                                    END !RedNbr
