*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ASMAKE (NOMTRM,NIVTRM,NOMTRA,NIVTRA) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification : D.Martin (30 Mai 2000)
* Version 1.0.3
*
* Creation de la structure d'assemblage $ASMBL du terme (NOMTRA,NIVTRA)
* ou ajout du terme (NOMTRM,NIVTRM) dans cette structure 
*  
*-- Arguments d'entree -- 
* NOMTRM nom du terme a ajouter dans la structure d'assemblage  
* NIVTRM niveau de terme a ajouter dans la structure d'assemblage
* NOMTRA nom du terme resultant de l'assemblage  
* NIVTRA niveau du terme resultant de l'assemblage
*-- Remarque --
* Structure $ASMBL 
* $ASMBL(1)=LGETRA longueur de l'entete = 4
* $ASMBL(2)=NBTRAC nombre de termes a assembler
* $ASMBL(3)=INCTRA =1 
* $ASMBL(4)=NBTRAL inutilise
*           puis pour "." signifiant LGETRA+(i-1)*INCTRA :
*   "   (.)=NUTERM Numero du i-eme terme dans la structure $SDTRM
*           etc ...
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTRM,NOMTRA 
      INTEGER       NIVTRM,NIVTRA 
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDASS,INTTYP,INTYKL,KLNIVE,KLTERM
      INTEGER       LGMTRM,MCMTRM,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM
     &             ,NCHTRM,NWHTRM,NUTERM,NUTERA,NVASMB,NIVEAU,ITYPTR
     &             ,ITYCAL,NUASSE,NUD,ITS,NUC,NDC,NBNC,NVC,NUL
     &             ,NDL,NBNL,NVL,IND,NVS,NVCO,IN3,NIV,ITYASS
     &             ,LGASMB,MCASMB,LGETRA,INCTRA,NBTRAL,NBTRAC,MCASAS,I
      CHARACTER     ERCODE*120 
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AsMake*')
      NUASSE=INDASS (' ')                                               !utilite
*
      ITYASS=INTYKL ('ASSEMB')                                          !utilite
      LGETRA=4
      INCTRA=1
      NBTRAL=0
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*     Numero du terme a ajouter a la structure $ASMBL  
*  
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
*  
*        Le terme n'existe pas: on l'ajoute apres agrandissement eventuel  
*        des structures #OMTRM et $SDTRM
         CALL ALFANU (NBCHNT,NOMTRM)                                    !utilite
         NWHTRM=MAX (NCHTRM,LEN (NOMTRM))
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,5)              !sdexplo
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,5)         !sdexplo
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NOMTRM)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERM=NBTERM
         CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NIVTRM
     &               ,INTTYP('REEL'),NDFCAL,NDFNDF,NDFDON,NDFSYM,NDFDSM
     &               ,NDFINC,NDFDUM,NDFNDF,NDFNUM,NDFINC,NDFDUM,NDFNDF
     &               ,NDFNUM,0,NDFSTO,NDFCOR,0,0)                       !sdexplo
      ENDIF
*  
*     Numero du resultat de l'assemblage
*  
      NUTERA=KLTERM (NOMTRA,NIVTRA,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERA.LE.0) THEN
*  
*        Le terme resultant de l'assemblage n'existe pas: on l'ajoute  
*        apres agrandissement eventuel des structures #OMTRM et $SDTRM 
         CALL ALFANU (NBCHNT,NOMTRA)                                    !utilite
         NWHTRM=MAX (NCHTRM,LEN (NOMTRA))
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,5)              !sdexplo
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,5)         !sdexplo
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NOMTRA)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERA=NBTERM
         NVASMB=NDFDSM
      ELSE 
*  
*        Le terme existe : s'il a deja ete assemble, on remet a jour
*        sa structure d'assemblage 
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVEAU,ITYPTR 
     &               ,ITYCAL,NUASSE,NUD,ITS,NVASMB,NUC,NDC,NBNC,NVC,NUL
     &               ,NDL,NBNL,NVL,IND,NVS,NVCO,IN3,NIV)                !sdexplo
         IF (ITYCAL.NE.ITYASS) CALL ERTERM (12,NOMTRA,NIVTRA)           !utilite
         IF (NUASSE.LT.0) THEN
            NBTRAC=0
            CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,LGASMB)
            CALL TBAR1  (ERCODE,'$ASMBL',NVASMB,MCASMB)
            CALL SDMKDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)       !sdexplo
         ENDIF
      END IF
*  
*-    Creation ou agrandissement de la structure d'assemblage pour le terme
*
      IF (NVASMB.LE.0) THEN
         NVASMB=KLNIVE ()                                               !sdexplo
*  
*        Creation de la structure $ASMBL de niveau NUTERA pour 10 termes
         LGASMB=LGETRA+10*INCTRA
         CALL TBCREE ('$ASMBL',NVASMB,1,LGASMB,'c')
         NBTRAC=0
      ELSE
*  
*        Agrandissement eventuel de la structure $ASMBL pour 10 termes
         CALL TBRR1  (ERCODE,'$ASMBL',NVASMB,LGASMB)
         CALL TBAR1  (ERCODE,'$ASMBL',NVASMB,MCASMB)
         CALL SDEXDB (IST(MCASMB),LGETRA,NBTRAC,INCTRA,NBTRAL)          !sdexplo
         IF (LGASMB.LT.LGETRA+INCTRA*(NBTRAC+1))
     &   CALL SDAJST ('$ASMBL',NVASMB,LGASMB,LGETRA,INCTRA,NBTRAC,10)   !sdexplo
      ENDIF
*  
*-    Mise a jour de la structure pour le nouveau terme (NOMTRM,NIVTRM)
      CALL TBAR1  (ERCODE,'$ASMBL',NVASMB,MCASMB)
      MCASAS=MCASMB+LGETRA
      DO 10 I=1,NBTRAC
*        Un terme ne peut apparaitre qu'une seule fois dans la structure
         IF (NUTERM.EQ.IST(MCASAS)) THEN
            CALL WATERM (1,NOMTRM,NIVTRM)
            GOTO 99999
         ENDIF
         MCASAS=MCASAS+INCTRA
10    CONTINUE
      IST(MCASAS)=NUTERM
      CALL SDMKDB (IST(MCASMB),LGETRA,NBTRAC+1,INCTRA,NBTRAL+1)         !sdexplo
*
      IF (NBTRAC.LE.0) THEN
         ITYPTR=INTTYP ('REEL')                                         !utilite
         CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
         CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERA-1)),NIVTRA
     &               ,ITYPTR,ITYASS,ABS(NUASSE),NDFDON,NDFSYM,NVASMB
     &               ,NDFINC,NDFDUM,0,NDFNUM,NDFINC,NDFDUM,0,NDFNUM
     &               ,0,NDFSTO,NDFCOR,0,0)                              !sdexplo
      ENDIF
99999 CALL PRFXMJ (-1,'*AsMake*')
                                                                    END !AsMake

