*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ATTERM (NMTERM,NVTERM
     &                  ,TYTERM,SYTERM,NBCOLO,NBLIGN,STTERM) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : F.Mahe & D.Martin (Mars 1996) 
* Derniere modification : D.Martin (13 Novembre 2001)
* Version 1.0.1
*  
* Recherche des attributs principaux d'un terme de type reel ou complexe
*  
*-- Arguments d'entree --
* NMTERM nom du terme
* NVTERM niveau du terme
*-- Arguments de sortie --
* TYTERM type ('REEL','COMPLEXE') du terme
* SYTERM type de symetrie du terme 
*        (' ','SYMETRIQUE','ANTISYMETRIQUE','AUTOADJOINT','ANTIADJOINT')
* NBCOLO nombre de colonnes du terme
* NBLIGN nombre de lignes du terme
* STTERM structure de stockage du terme
*       ('PLEIN-L','PLEIN-C','MORSE-L','MORSE-C','BIMORSE','PROFIL','NUME-L'
*       ,'NUME-C','DIAG')   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM,TYTERM,SYTERM,STTERM
      INTEGER       NVTERM,NBLIGN,NBCOLO
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       KLTERM                                              !sdexplo
      INTEGER       MCMTRM,MCDTRM,MCINCO,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NUTERM,ADTERM,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &             ,ITYSYM,NVDSMA,NUINCC,NVDUMC,NVNUMC,NUINCL,NVDUML
     &             ,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
     &             ,NCPINC,NCPINL,INTRPC,INTRPL,NBTNEC,NBTNEL,NCATR1
      CHARACTER     STOIND*7,SYMIND*14,TYPINT*11                        !utilite
      CHARACTER     ERCODE*120,MULTII*1
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*AtTerm*')
*
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)              
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
*     Recherche des caracteristiques du terme
*
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(ADTERM)  ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,NVDSMA,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &            ,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMP)                                              !sdexplo
*
      MULTII='N'
      IF (NVDSMA.NE.NDFDSM.AND.NUINCC.EQ.0.AND.NUINCL.EQ.0) MULTII='Y'
      NCPINC=1
      NCPINL=1
      IF (MULTII.EQ.'N') THEN
         IF (NUINCC.EQ.NDFINC.AND.NUINCL.EQ.NDFINC)
     &   CALL ERTERM (22,NMTERM,NVTERM)                                 !utilite
         IF (NUINCC.NE.NDFINC)
     &   CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTRPC,NBTNEC)          !sdexplo
         IF (NUINCL.NE.NDFINC)
     &   CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTRPL,NBTNEL)          !sdexplo
      ENDIF
      TYTERM=TYPINT (ITYPTR)                                            !utilite
      SYTERM=SYMIND (ITYSYM)                                            !utilite
      NBLIGN=NCPINL*NBLIGN
      NBCOLO=NCPINC*NBCOLO
      STTERM=STOIND (INSTOK)                                            !utilite
*
      CALL PRFXMJ (-1,'*AtTerm*')
                                                                    END !Atterm
