*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BMO2DL (NVSTOK,NCPINL,NCPINC,ITYSYM,NMTERM,NVTERM
     &                  ,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Fevrier 1995)  
* Derniere modification : D.Martin (03 novembre 2008)
* Version 2
*
* Calcul des tables de stockage Bimorse pour une inconnue(s) vectorielle(s)
* a partir des tables de stockage en noeuds (pour inconnues scalaires).
*  
*-- Arguments d'entree -- 
* NVSTOK niveau commun des tables de stockage Bimorse
* NCPINL nombre de composantes de l'inconnue en ligne
* NCPINC nombre de composantes de l'inconnue en colonne
* ITYSYM indicateur de structure symetrique
* NMTERM nom du terme correspondant (pour impression)
* NVTERM niveau du terme
* NIVIMP niveau d'impression du terme 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER       NVSTOK,NCPINL,NCPINC,ITYSYM,NVTERM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER STODLN*6
      INTEGER INDSTO
      INTEGER       MCSTON,MCSTOK,LGSTOK,NCHTRM,NCHT
     &             ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCPLAD,MCPLID,NBLIDL
     &             ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU,MCPCAD,MCPCID,NBCODL
      CHARACTER     ERCODE*120,NMSTOK*6,NMSTON*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Bmo2dl*')
*
      ERCODE(1:1)='!'
      NMSTOK = STODLN (INDSTO('BIMORSE'),NCPINC, NCPINL)
      NMSTON = '&BMORS'
      CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      IF (ERCODE(1:1).NE.' ') THEN
         CALL TBRR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL TBAR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL EXBMOR (MCSTON,IST(MCSTON),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !sdexplo
         LGSTOK=1+NBL*NCPINL+2*NCPINL*NBPLAL+2*NBL*(NCPINL-1)
         IF (ITYSYM.EQ.NDFSYM)
     &       LGSTOK=LGSTOK+NBC*NCPINC+2*NCPINC*NBPLAU+2*NBC*(NCPINC-1)
         CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
         CALL TBAR2  (ERCODE,NMSTON,NVSTOK,MCSTON 
     &                      ,NMSTOK,NVSTOK,MCSTOK)
*        La creation du tableau ci-dessus a pu modifier les adresses ...
         CALL EXBMOR (MCSTON,IST(MCSTON),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !sdexplo
         MCPLAD=MCSTOK+2
         MCPLID=MCPLAD+NBL*NCPINL-1
         CALL N2DLMO (1,NCPINC,NCPINL,NBL,NBC,IST(MCPLAL),IST(MCPLIL)
     &               ,NBLIDL,IST(MCPLAD),IST(MCPLID))                   !morse
         IST(MCSTOK)=2
         IST(MCPLAD-1)=NBLIDL+1
         LGSTOK=2+NBLIDL+2*IST(MCPLID-1)
         IF (ITYSYM.EQ.NDFSYM) THEN
            NBPLAL=IST(MCPLID-1)
            IST(MCSTOK)=2+NBLIDL+2*NBPLAL
            MCPCAD=MCPLID+2*NBPLAL+1
            MCPCID=MCPCAD+NBC*NCPINC-1
            CALL N2DLMO (1,NCPINL,NCPINC,NBC,NBL,IST(MCPLAU),IST(MCPLIU)
     &                  ,NBCODL,IST(MCPCAD),IST(MCPCID))                !morse
            IST(MCPCAD-1)=NBCODL+1
            LGSTOK=LGSTOK+NBCODL+1+2*IST(MCPCID-1)
         ENDIF
*
         IF (NIVIMP.GE.5) THEN
            NCHTRM=LEN(NMTERM)
            DO 1 NCHT=1,NCHTRM
               IF (NMTERM(NCHT:NCHT).EQ.' ') GOTO 2
1           CONTINUE
            NCHT=NCHTRM
2           CALL PRBMOR (IST(MCSTOK),'Tables BiMorse d.l. pour'
     &                  ,NMTERM(1:NCHT),NVTERM,NIVIMP,IMPSDR)           !prsd
         ENDIF
         CALL TBAJST (NMSTOK,NVSTOK,LGSTOK)
         CALL TBSAVE (NMSTON,NVSTOK)
      ENDIF
      CALL PRFXMJ (-1,'*Bmo2dl*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre/03 novembre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1 : D.Martin (16 Decembre 1998)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Bmo2dl
