*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CRTERM (NMTERM,NVTERM,LGTERM,ITTERM,ITYCAL,NUKALE
     &                  ,NUDONN,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO
     &                  ,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK
     &                  ,NVSTOK,NVCOOR,IATRDO,NIVIMP,IDEMTR,CRETRM)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1994) 
* Derniere modification : D.Martin (30 Juin 1997)
* Version 1.0.0
*  
* Creation d'un nouveau terme a partir d'un terme existant
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme cree
* NVTERM niveau du terme cree
* LGTERM longueur du terme cree
* ITTERM type du terme cree
* ITYCAL type de calcul du terme cree
* NUKALE numero de type de calcul du terme cree
* ITYSYM,NVDSMB,NUINCC,NVDUMC
*,NBCOLO,NVNUMC,NUINCL,NVDUML
*,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO caracteristiques du terme
* IDEMTR indique la coincidence des 2 termes
* CRETRM indique que le terme a effectivement ete cree
* NIVIMP niveau d'impression du 2nd terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,LGTERM,ITTERM,ITYCAL,NUKALE,NUDONN,ITYSYM
     &             ,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL,NVDUML
     &             ,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
      LOGICAL       IDEMTR,CRETRM
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       KLTERM
      INTEGER       LGMTRM,LGDTRM,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM
     &             ,NCHTRM,NUTERM,NWHTRM,LGTRM2,ITTRM2,IADTRM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CrTerm*')
*  
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
*     Creation (si necessaire) du terme (mise a jour des structures)
*
      CRETRM=.FALSE.
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (.NOT.IDEMTR) THEN
         IF (NUTERM.LE.0) THEN 
*           Le terme n'existe pas. On le cree et on l'introduit dans 
*           les tableaux de descriptions des termes $SDTRM et #OMTRM 
            CALL ALFANU (NBCHNT,NMTERM)                                 !utilite
            CRETRM=.TRUE. 
            NWHTRM=MAX (NCHTRM,LEN (NMTERM))
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)           !sdexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)      !sdexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTERM)              !utilite
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !sdexplo
            NUTERM=NBTERM
         ELSE
*           Si le terme existe. On verifie ses type et taille
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTRM2)
            IF (ERCODE(1:1).NE.'C') THEN
               CALL TBTYPE (NMTERM,NVTERM,ITTRM2)
               IF (LGTRM2.NE.LGTERM.OR.ITTRM2.NE.ITTERM) CRETRM=.TRUE.
            ELSE  
               CRETRM=.TRUE.  
            ENDIF
            CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
         ENDIF
      ENDIF
*
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL PUTTRM (IST(IADTRM)  ,NVTERM,ITTERM,ITYCAL,NUKALE,NUDONN 
     &            ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &            ,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMP)                                              !sdexplo
*  
      IF (CRETRM) 
     &   CALL TBCREE (NMTERM,NVTERM,ITTERM,LGTERM,'c')
*
      CALL PRFXMJ (-1,'*CrTerm*')  
      RETURN
                                                                    END !CrTerm
