*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DETERM (NMTRM1,NVTRM1,NMTRM2,NVTRM2,NIVIMP
     &                  ,ERRQUA,ERRMAX) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1990)
* Derniere modification : D.Martin (20 Mars 2002)
* Version 1.0.4
*
* Calcul de l'ecart entre deux termes vectoriels (unicolonnes)
*
*-- Arguments d'entree --
* NMTRM1,NVTRM1 nom et niveau du 1er vecteur
* NMTRM2,NVTRM2 nom et niveau du 2nd vecteur
* NIVIMP niveau d'impression
*-- Arguments de sortie
* ERRQUA erreur quadratique relative
* ERRMAX erreur maximum relative
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRM1,NMTRM2
      INTEGER       NVTRM1,NVTRM2,NIVIMP
      REAL          ERRQUA,ERRMAX
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*  
      LOGICAL       PRTOUT
      INTEGER       KLTERM
      INTEGER       MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,IADTRM,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVDSMB
     &             ,NVDUMC,NVDUML,NUINCC,NBNEUC,NVNUMC,INSTOK,NVSTOK
     &             ,NVALN1,NUINC1,NBNET1,NVNUM1,MCNUL1,NCPIN1,INTER1
     &             ,NBTNE1,LGTRM1,MCTRM1,ITEMN1,NOEUD1,NU1MAX,NU1CMX
     &             ,VALEI1,DLN1M1,NCATR1
     &             ,NVALN2,NUINC2,NBNET2,NVNUM2,MCNUL2,NCPIN2,INTER2
     &             ,NBTNE2,LGTRM2,MCTRM2,ITEMN2,NOEUD2,NU2MAX,NU2CMX
     &             ,VALEI2,DLN2M1,NCATR2
     &             ,NVCOOR,IATRDO,NIVIMR,NBNEIN,MCCOOR,MCINCO
     &             ,NBNINX,LGREEL,NBNIMP,NUNEIN,NUNEGL,NUDLGL
     &             ,IVALNE,IDIM,MCNEIN,ADCOOR
      REAL          U1NOR2,U1NOIN,ABVAL1,VALER1
     &             ,U2NOR2,U2NOIN,ABVAL2,VALER2
     &             ,GTZERO,ARECAR,ABECAR,RBDLIN,ERRQUR,ERRMAR
*f   &             ,ERRQUA,ERRMAX
      COMPLEX       VALEC1,VALEC2
      CHARACTER     PRFXAS*8,TYPINT*4
      CHARACTER*16  NOMWR1,NOMWR2,TYTRM1*4,TYTRM2*4
      CHARACTER     ERCODE*120,ABORRE,COMPLE,PACOOR
*f    COMMON/ERRNRM/ERRQUA,ERRMAX,ERRQUR,ERRMAR
      COMMON/FORMAH/ERCODE
      EQUIVALENCE  (VALER1,VALEC1),(VALER2,VALEC2)
      EQUIVALENCE  (ERCODE(65:65),TYTRM1),(ERCODE(73:73),TYTRM2)
     &            ,(ERCODE(81:81),NOMWR1),(ERCODE(97:97),NOMWR2)
      DATA GTZERO/1.E-3/  
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*DeTerm*')
*
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                  ,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Recherche des caracteristiques du 1er terme
      NUTERM = KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))           !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      IADTRM = MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NIVEAU,ITYPTR,ITYCAL,NUKALE
     &            ,NUDONN,NVALN1,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &            ,NUINC1,NVDUML,NBNET1,NVNUM1
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR)                  !sdexplo
      IF (NUINC1.EQ.NDFINC) THEN
         NUINC1=NUINCC
         NBNET1=NBNEUC
         NVNUM1=NVNUMC
      ENDIF
      TYTRM1 = TYPINT (ITYPTR)
      CALL SDEXCO (NUINC1,IST(MCINCO),NCPIN1,INTER1,NBTNE1)             !utilite
      IF (NVALN1.LE.0) NVALN1=NCPIN1
*
*     Recherche des caracteristiques du 2eme terme
      NUTERM = KLTERM (NMTRM2,NVTRM2,AST(MCMTRM),IST(MCDTRM))           !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM2,NVTRM2)                    !utilite
      IADTRM = MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM)  ,NIVEAU,ITYPTR,ITYCAL,NUKALE
     &            ,NUDONN,NVALN2,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEUC,NVNUMC
     &            ,NUINC2,NVDUML,NBNET2,NVNUM2
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMR)                  !sdexplo
      IF (NUINC2.EQ.NDFINC) THEN
         NUINC2=NUINCC
         NBNET2=NBNEUC
         NVNUM2=NVNUMC
      ENDIF
      TYTRM2 = TYPINT (ITYPTR)
      CALL SDEXCO (NUINC2,IST(MCINCO),NCPIN2,INTER2,NBTNE2)             !utilite
      IF (NVALN2.LE.0) NVALN2=NCPIN2
*
      IF (INTER2.NE.INTER1) THEN
         IF (NUINC2.EQ.NDFINC) THEN
            CALL ERTERS (3,NMTRM1,NVTRM1,NMTRM2,NVTRM2)                 !utilite
         ELSEIF (NUINC1.EQ.NDFINC) THEN
            CALL ERTERS (3,NMTRM2,NVTRM2,NMTRM1,NVTRM1)                 !utilite
         ELSE
            CALL ERTERS (4,NMTRM1,NVTRM1,NMTRM2,NVTRM2)                 !utilite
         ENDIF
      ENDIF
*
*     Quelques impressions
      CALL PRNTRM (NMTRM1,NVTRM1,NOMWR1,NCATR1)
      CALL PRNTRM (NMTRM2,NVTRM2,NOMWR2,NCATR2)
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
      IF (NCPIN1.EQ.NCPIN2) THEN
         IF (NCPIN1.EQ.1) THEN
            WRITE (IMPPAL,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'scalaire'
     &            ,NOMWR2(1:NCATR2),'scalaire'
            IF (IMPSDR.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPSDR,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'scalaire'
     &            ,NOMWR2(1:NCATR2),'scalaire',NIVIMP
         ELSE
            WRITE (IMPPAL,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'vectorielle'
     &            ,NOMWR2(1:NCATR2),'vectorielle'
            IF (IMPSDR.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPSDR,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'vectorielle'
     &            ,NOMWR2(1:NCATR2),'vectorielle',NIVIMP
         ENDIF
      ELSE
         IF (NCPIN1.EQ.1) THEN
            WRITE (IMPPAL,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'scalaire'
     &            ,NOMWR2(1:NCATR2),'vectorielle'
            IF (IMPSDR.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPSDR,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'scalaire'
     &            ,NOMWR2(1:NCATR2),'vectorielle',NIVIMP
         ELSE
            WRITE (IMPPAL,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'vectorielle'
     &            ,NOMWR2(1:NCATR2),'scalaire'
            IF (IMPSDR.GT.0.AND.NIVIMP.GT.0)
     &      WRITE (IMPSDR,10000) PRFXAS (0)
     &            ,NOMWR1(1:NCATR1),'vectorielle'
     &            ,NOMWR2(1:NCATR2),'scalaire',NIVIMP
         ENDIF
      ENDIF
      ENDIF
*
*     Creation du tableau de l'intersection des numerotations des noeuds
*
      CALL TBRR5  (ERCODE,'#GNEDO',NVNUM1,MCNUL1,'#GNEDO',NVNUM2,MCNUL2
     &                   ,'#ORNOE',INTER1,MCCOOR
     &                   , NMTRM1 ,NVTRM1,LGTRM1, NMTRM2 ,NVTRM2,LGTRM2)

      NBNINX = MIN (LGTRM1,LGTRM2)
      CALL TBCRSU ('#GNEDO',0,1,NBNINX,LGREEL,'c')
      NBNINX = LGREEL
      CALL TBAR6  (ERCODE,'#GNEDO',0     ,MCNEIN,'#ORNOE',INTER1,MCCOOR
     &                   ,'#GNEDO',NVNUM1,MCNUL1,'#GNEDO',NVNUM2,MCNUL2
     &                   , NMTRM1 ,NVTRM1,MCTRM1, NMTRM2 ,NVTRM2,MCTRM2)
      NBNET1 = IST(MCNUL1+1)
      MCNUL1 = MCNUL1+2
      NBNET2 = IST(MCNUL2+1)
      MCNUL2 = MCNUL2+2
*
*     Calcul de l'intersection des numerotations
*
      CALL LISINT (NBNET1,IST(MCNUL1),NBNET2,IST(MCNUL2),NBNEIN
     &            ,IST(MCNEIN),NBNINX,*99994)                           !utilite
*
      COMPLE = 'N'
      IF (TYTRM1(1:2).EQ.'CO'.OR.TYTRM2(1:2).EQ.'CO') COMPLE = 'Y'
*
      IF (IMPSDR.GT.0.AND.NIVIMP.GT.0) THEN
         IF (NDIM.EQ.3) THEN
            IF (COMPLE.EQ.'Y') THEN
               WRITE (IMPSDR,13041) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ELSEIF (NDIM.EQ.3) THEN
               WRITE (IMPSDR,13021) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ENDIF
         ELSEIF (NDIM.EQ.2) THEN
            IF (COMPLE.EQ.'Y') THEN
               WRITE (IMPSDR,12041) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ELSE
               WRITE (IMPSDR,12021) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ENDIF
         ELSEIF (NDIM.EQ.1) THEN
            IF (COMPLE.EQ.'Y') THEN
               WRITE (IMPSDR,11041) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ELSE
               WRITE (IMPSDR,11021) NOMWR1(1:NCATR1),NOMWR2(1:NCATR2)
            ENDIF
         ENDIF
      ENDIF
*
*     Boucle sur les noeuds de l'intersection des numerotations
*
      U1NOR2 = 0.
      U1NOIN = 0.
      U2NOR2 = 0.
      U2NOIN = 0.
      ERRQUA = 0.
      ERRMAX = 0.
      NBNIMP = 10*NIVIMP
      ITEMN1 = 1
      ITEMN2 = 1
      PRTOUT = IMPSDR.GT.0.AND.(NIVIMP.GE.10.OR.2*NBNIMP.GE.NBNEIN)
*
      DO 2 NUNEIN = 1,NBNEIN
         NUNEGL = IST(MCNEIN+NUNEIN-1)
         CALL DICOTO (ITEMN1,NBNET1,IST(MCNUL1),NUNEGL,NOEUD1,*2)       !utilite
         ITEMN1 = NOEUD1+1
         DLN1M1 = (NOEUD1-1)*NVALN1
         CALL DICOTO (ITEMN2,NBNET2,IST(MCNUL2),NUNEGL,NOEUD2,*2)       !utilite
         ITEMN2 = NOEUD2+1
         DLN2M1 = (NOEUD2-1)*NVALN2
*
         PACOOR = 'Y'
         NUDLGL = MAX (NVALN1,NVALN2)*(NUNEGL-1)
         ADCOOR = MCCOOR+(NUNEGL-1)*NDIM
         DO 1 IVALNE = 1,MIN (NVALN1,NVALN2)
            NUDLGL = NUDLGL+1
            VALEC1 = 0.
            VALEC2 = 0.
            CALL TOUTPU (TYTRM1,MCTRM1,IST,RST,CST,DLN1M1+IVALNE
     &                  ,VALEI1,VALER1,VALEC1)                          !utilite
            CALL TOUTPU (TYTRM2,MCTRM2,IST,RST,CST,DLN2M1+IVALNE
     &                  ,VALEI2,VALER2,VALEC2)                          !utilite
*
*           Calcul des normes L2 des vecteurs et de l'erreur
*
            ABVAL1 = ABS (VALEC1)
            U1NOR2 = U1NOR2+ABVAL1*ABVAL1
            IF (ABVAL1.GT.U1NOIN) THEN
               U1NOIN = ABVAL1
               NU1MAX = NUNEGL
               NU1CMX = ADCOOR
            ENDIF
            ABVAL2 = ABS (VALEC2)
            U2NOR2 = U2NOR2+ABVAL2*ABVAL2
            IF (ABVAL2.GT.U2NOIN) THEN
               U2NOIN = ABVAL2
               NU2MAX = NUNEGL
               NU2CMX = ADCOOR
            ENDIF
            ABECAR = ABS (VALEC2-VALEC1)
            ERRQUA = ERRQUA+ABECAR*ABECAR
            IF (ABECAR.GT.ERRMAX) ERRMAX = ABECAR
*
            IF (PRTOUT
     &      .OR.NUNEIN.LE.NBNIMP.OR.NUNEIN.GE.NBNEIN-NBNIMP+1) THEN
               IF (ABVAL1+ABVAL2.GT.GTZERO) THEN
*                 Erreur relative
                  ABORRE = 'r'
                  ARECAR = 200.*ABECAR/(ABVAL1+ABVAL2)
               ELSE
*                 Erreur absolue
                  ABORRE = 'a'
                  ARECAR = ABECAR
               ENDIF
               IF (NDIM.EQ.3) THEN
                  IF (COMPLE.EQ.'Y') THEN
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10342)
     &                        VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,13042)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                       ,VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ELSE
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10322)
     &                        VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,13022)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                       ,VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ENDIF
               ELSEIF (NDIM.EQ.2) THEN
                  IF (COMPLE.EQ.'Y') THEN
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10242)
     &                         VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,12042)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                        ,VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ELSE
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10222)
     &                         VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,12022)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                        ,VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ENDIF
               ELSEIF (NDIM.EQ.1) THEN
                  IF (COMPLE.EQ.'Y') THEN
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10142)
     &                         VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,11042)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                        ,VALEC1,VALEC2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ELSE
                     IF (PACOOR.EQ.'N') THEN
                        WRITE (IMPSDR,10122)
     &                         VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ELSE
                        WRITE (IMPSDR,11022)
     &                        (RST(ADCOOR+IDIM),IDIM=0,NDIM-1)
     &                        ,VALER1,VALER2,ARECAR,ABORRE,ABECAR,NUDLGL
                     ENDIF
                  ENDIF
               ENDIF
            ENDIF
            PACOOR = 'N'
1        CONTINUE
2     CONTINUE
*
      RBDLIN = SQRT(REAL(NBNEIN*MIN(NCPIN1,NCPIN2)))
      U2NOR2 = SQRT(U2NOR2)
      U1NOR2 = SQRT(U1NOR2)
      ERRQUA = SQRT(ERRQUA)
      ABVAL1 = ERRQUA
      IF (U1NOR2+U2NOR2.GE.GTZERO) ABVAL1 =2.*ERRQUA/(U1NOR2+U2NOR2)
      ABVAL2 = ERRMAX
      IF (U1NOIN+U2NOIN.GE.GTZERO) ABVAL2 =2.*ERRMAX/(U1NOIN+U2NOIN)
      ERRQUA = ERRQUA/RBDLIN
      ERRQUR = 100*ABVAL1
      ERRMAR = 100*ABVAL2
*
      IF (NIVIMP.GT.0.AND.IMPSDR.GT.0) THEN
         WRITE (IMPSDR,10001) NOMWR1(1:NCATR1),U1NOR2/RBDLIN
     &                       ,U1NOIN,NU1MAX
     &                       ,(RST(NU1CMX+IDIM),IDIM=0,NDIM-1)
         WRITE (IMPSDR,10001) NOMWR2(1:NCATR2),U2NOR2/RBDLIN
     &                       ,U2NOIN,NU2MAX
     &                       ,(RST(NU2CMX+IDIM),IDIM=0,NDIM-1)
         WRITE (IMPSDR,10002) ERRQUA,ERRMAX
         IF (ERRQUR.GT.0.01) THEN
            WRITE (IMPSDR,10004) ERRQUR,ERRMAR
         ELSE
            WRITE (IMPSDR,10003) ERRQUR,ERRMAR
         ENDIF
      ENDIF
      IF (NIVIMP.GT.0) THEN
         WRITE (IMPPAL,10002) ERRQUA,ERRMAX
         IF (ERRQUR.GT.0.01) THEN
            WRITE (IMPPAL,10004) ERRQUR,ERRMAR
         ELSE
            WRITE (IMPPAL,10003) ERRQUR,ERRMAR
         ENDIF
      ENDIF
      CALL TBTUER ('#GNEDO',0)
      CALL TBSAVE ('#GNEDO',NVNUM1)
      IF (NVNUM1.NE.NVNUM2) CALL TBSAVE ('#GNEDO',NVNUM2)
      CALL TBSAVE ('#ORNOE',INTER1)
      CALL TBSAVE (NMTRM1,NVTRM1)
      CALL TBSAVE (NMTRM2,NVTRM2)
      CALL PRFXMJ (-1,'*DeTerm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,T11,'Comparaison des termes ',A,', inconnue ',A
     &,/T31,'et ',A,', inconnue ',A,:,' (Niveau d''impression:',I3,')')
10001 FORMAT(T2,A,' : Norme L2    :',E11.4,'   Norme du max.:',E11.4
     &      ,/T14,'   Max. atteint au point #',I6,:,' (',3E11.4,')')
10002 FORMAT(T11,'> Erreur quadratique :',E11.4
     &          ,'    maximum     :',E11.4)
10003 FORMAT(T20,'quad. relat.:',E11.4,'%   max. relat. :',E11.4,'%')
10004 FORMAT(T20,'quad. relat.:',F11.4,'%   max. relat. :',F11.4,'%')
*--   Formats dans le cas reel------------------------------------------
10122 FORMAT(T12,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
11021 FORMAT(T2,'Abscisse>',2(' <',A12,'>')
     &,'    Ecart(r)      Ecart(a)  D.L. No ')
11022 FORMAT(E11.4,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
10222 FORMAT(T23,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
12021 FORMAT(T2,'<',TR4,'Coordonnees',TR4,'> ',2(' <',A12,'>')
     &,'    Ecart(r)      Ecart(a)  D.L. No ')
12022 FORMAT(2E11.4,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
10322 FORMAT(T34,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
13021 FORMAT(T2,'<',TR9,'Coordonnees',TR10,'>',2(' <',A12,'>')
     &,'     Ecart(r)     Ecart(a) D.L. No ')   
13022 FORMAT(3E11.4,2(E14.5,' '),' ',F7.3,'%(',A,') ',E11.4,'(a)',I9)
*--   Formats dans le cas complexe--------------------------------------
10142 FORMAT(T12,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
11041 FORMAT(T2,'Abscisse> ',2(' <  ',A16,'  >')
     &,'    Ecart(r)      Ecart(a)  D.L. No ')
11042 FORMAT(E11.4,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
10242 FORMAT(T23,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
12041 FORMAT(T2,'<',TR4,'Coordonnees',TR4,'> ',2(' <  ',A16,'  >')
     &,'    Ecart(r)      Ecart(a)  D.L. No ')
12042 FORMAT(2E11.4,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
10342 FORMAT(T34,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
13041 FORMAT(T2,'<',TR9,'Coordonnees',TR10,'>',2(' <   ',A16,'  >')
     &,'    Ecart(r)      Ecart(a)  D.L. No ')
13042 FORMAT(3E11.4,2(SS,E12.4,SP,E10.4,'*i'),' ',SS,F7.3,'%(',A,') '
     &,E11.4,'(a)',I9)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99994 CALL PRNTRM (NMTRM1,NVTRM1,NOMWR1,NCATR1)
      CALL PRNTRM (NMTRM2,NVTRM2,NOMWR2,NCATR2)
      CALL BAISE  (' La taille de l''intersection est plus grosse que' 
     &//' le Max. des tailles des deux vecteurs '
     &//NOMWR1(1:NCATR1)//' et '//NOMWR2(1:NCATR2))
                                                                    END !DeTerm
