*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECMATR (NOMTRM,NIVTRM,OUTPUT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1995)
* Derniere modification : D.Martin (23 novembre 2009)
* Version 3
*  
* Ecriture du terme matriciel de nom NOMTRM de niveau NIVTRM
* sur le fichier de nom NOMTRM//.//'NIVTRM'
*
* Si la matrice est symetrique, antisymetrique, autoadjointe, antiadjointe
* seule la partie triangulaire inferieure est ecrite sur le fichier.
*
* Si la sortie 'NUMEL-L' est demandee la matrice doit etre prealablement
* stockee selon ce format (utiliser Mat2NL)
*
*-- Arguments d'entree -- 
* NOMTRM nom du terme matriciel a ecrire sur le fichier
* NIVTRM niveau du terme de nom NOMTRM a ecrire
* OUTPUT chaine de caracteres definissant la structure matricielle de sortie
*
*-- Structure du fichier de sortie --
* 1ere ligne 
*    NOM, NIVEAU ,TYPE (REEL ou COMPLEXE) DU TERME, TYPE DE SYMETRIE
* 2eme ligne
*    NBLIGN,NBCOLO,NBCOEF,ITYPTR  
*    nb. de lignes, nb. de colonnes, nb. de coeff., type (2->REEL,4->COMPLEXE)
* Suite du fichier
* - Output = 'Nume-L'
*   ADPRCL  ((I),I=1,NBLIGN+1) adresses des 1ers coeff. de chaque ligne 
*           suivi du nombre de coeff. (NBCOEF) de la matrice +1
*           (ADPRCL(NBLIGN+1)=NBCOEF+1)
*   NUMCOL  ((K),K=1,NBCOEF) numero de colonne du K-eme coeff.
*   VALEURS ((K),K=1,NBCOEF) coefficients de la matrice
* - Output = 'Sparse'
*   NUMLIG  ((K),K=1,NBCOEF) numero de ligne du K-eme coeff.
*   NUMCOL  ((K),K=1,NBCOEF) numero de colonne du K-eme coeff.
*   VALEURS ((K),K=1,NBCOEF) coefficients de la matrice
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTRM,OUTPUT
      INTEGER       NIVTRM
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     STODLN*6,SYMIND*14,TYPINT*9,UPPERC*12
      CHARACTER     ERCODE*120,NOMWRK*16,NOMFIC*24,NMSTOK*6,OUTPUW*12
     &             ,MULTIN,TYTERM*9
      LOGICAL       OPNED,JEXIST
      INTEGER       INDSYM,INTTYP,KLTERM
      INTEGER       NOUNIT,NVTERM,LENTRM,LENFIC
     &             ,MCMTRM,MCDTRM,MCINCO,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NUTERM,NBCOEF,MCTERM,ADRESS,K,ITYPTR
     &             ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB,NUINCC,NVDUMC
     &             ,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK
     &             ,NVSTOK,NVCOOR,IATRDO,NIVIMP
     &             ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCADPR,MCNUCO
     &             ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU,MCSTOK,MCWORK
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (NOMFIC,ERCODE(81:81)),(NOMWRK,ERCODE(105:105))
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EcMatr*')
*
      OUTPUW=UPPERC (OUTPUT)
      NOMWRK=NOMTRM
      LENTRM=LEN (NOMTRM)
      LENFIC=LENTRM
*
*     Nom du fichier de sortie
*
      NOMFIC=NOMTRM//'.'
      DO 1 LENFIC=LENTRM+2,LEN (NOMFIC)
         CALL ENCLER (NIVTRM,NOMFIC(LENTRM+2:LENFIC))                   !utilite
         IF (NOMFIC(LENTRM+2:LENTRM+2).NE.'+')  GOTO 2
1     CONTINUE
      GOTO 99903
*
*     Ouverture du fichier
* 
2     INQUIRE (FILE=NOMFIC(1:LENFIC),OPENED=OPNED,EXIST=JEXIST)
      IF (.NOT.(JEXIST.AND.OPNED)) THEN
         NOUNIT=KLUNIT ()                                               !sdexplo
         OPEN  (UNIT=NOUNIT,FILE=NOMFIC(1:LENFIC),STATUS='UNKNOWN'
     &         ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=99902) 
      ENDIF
*
*     Structures des termes et des inconnues
*
      CALL TBRR1  (ERCODE,NOMTRM,NIVTRM,NBCOEF)
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
*     Caracteristiques du terme
*
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NOMTRM,NIVTRM)
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTERM,ITYPTR
     &            ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB,NUINCC,NVDUMC
     &            ,NBCOLO,NVNUMC,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK
     &            ,NVSTOK,NVCOOR,IATRDO,NIVIMP)                         !sdexplo
*
      NCPINL=1
      NCPINC=NCPINL
      MULTIN='N'
      IF (NVDSMB.NE.NDFDSM.AND.NUINCL.EQ.NDFINC.AND.NUINCC.EQ.NDFINC)
     &   MULTIN='Y'
      IF (MULTIN.EQ.'N') THEN
         IF (NUINCL.NE.NDFINC)
     &      CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTERP,NBTNEU)       !utilite
         IF (NUINCC.NE.NDFINC)
     &      CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTERP,NBTNEU)       !utilite
      ENDIF
      NBLIGN=NBLIGN*NCPINL
      NBCOLO=NBCOLO*NCPINC
      TYTERM=TYPINT(ITYPTR)
*
*     Ecriture du titre et de l'entete pour la matrice
*
      WRITE (NOUNIT,*) '!Terme ',NOMWRK(1:NCHTRM),' ',NIVTRM
     &                   ,' ',TYTERM,' ',SYMIND(ITYSYM)
      WRITE (NOUNIT,*) NBLIGN,NBCOLO,NBCOEF,ITYPTR
*
*
*
      IF (OUTPUW(1:6).EQ.'NUME-L') THEN
         NMSTOK='&NUMEL'
         IF (INSTOK.NE.INDSTO ('NUME-L')) 
     &      CALL ERTERM (18,NOMTRM,NIVTRM)
         CALL TBRR1 (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL TBAR1 (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXNUML (MCSTOK,IST(MCSTOK),NBL,NBC,MCADPR,MCNUCO,LGL)  !utilite
*
*        Ecriture des pointeurs de la structure Nume-L du terme
*
         WRITE (NOUNIT,10001) (IST(K),K=MCADPR,MCADPR+NBL)
         WRITE (NOUNIT,10001) (IST(K),K=MCNUCO,MCNUCO+LGL-1)
         CALL TBSAVE (NMSTOK,NVSTOK)
*
      ELSEIF (OUTPUW(1:6).EQ.'SPARSE') THEN
*
         IF (INSTOK.EQ.INDSTO ('PLEIN-L')) THEN
*
            NMSTOK='PLEINL'
            WRITE (NOUNIT,10001) ((I, J=1,NBCOLO), I=1,NBLIGN)
            WRITE (NOUNIT,10001) ((J, J=1,NBCOLO), I=1,NBLIGN)
*
         ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-C')) THEN
*
            NMSTOK='PLEINC'
            WRITE (NOUNIT,10001) ((I, I=1,NBLIGN), J=1,NBCOLO)
            WRITE (NOUNIT,10001) ((J, I=1,NBLIGN), J=1,NBCOLO)
*
         ELSE
*
            CALL TBCREE ('$WORK$',0,1,2*NBCOEF,'c')
*           Stockages BiMorse, Morse-L ou Morse-C
            NMSTOK = STODLN(INSTOK,1,1)
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
            IF (ERCODE(1:1).NE.' ') THEN
               NMSTOK = STODLN(INSTOK,NCPINC,NCPINL)
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
               NCPINL=1
               NCPINC=1
            ENDIF
            CALL TBAR2  (ERCODE,'$WORK$',0,MCWORK,NMSTOK,NVSTOK,MCSTOK)
            ADRESS=1
*
            IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN
               ADRESS=0
               DO K=1,MIN (NBLIGN,NBCOLO)
                  IST(MCWORK+ADRESS)=K
                  IST(MCWORK+NBCOEF+ADRESS)=K
                  ADRESS=ADRESS+1
               ENDDO
               ADRESS=ADRESS+1
               CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL
     &                     ,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)           !utilite
               CALL BML2SP (1,NBL,NCPINL,NBC,NCPINC
     &                     ,IST(MCPLAL),IST(MCPLIL)
     &                     ,ADRESS,IST(MCWORK),IST(MCWORK+NBCOEF))      !morse
               IF (ITYSYM.EQ.INDSYM (' '))
     &         CALL BML2SP (1,NBC,NCPINC,NBL,NCPINL
     &                     ,IST(MCPLAU),IST(MCPLIU)
     &                     ,ADRESS,IST(MCWORK+NBCOEF),IST(MCWORK))      !morse
*
            ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN
               CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAG,MCPLAG
     &                     ,MCPLIG,LGMORS)                              !utilite
               CALL BML2SP (0,NBL,NCPINL,NBC,NCPINC
     &                     ,IST(MCPLAG),IST(MCPLIG)
     &                     ,ADRESS,IST(MCWORK),IST(MCWORK+NBCOEF))      !morse

*
            ELSEIF (INSTOK.EQ.INDSTO ('MORSE-C')) THEN
               CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAG,MCPLAG
     &                     ,MCPLIG,LGMORS)                              !utilite
               CALL BML2SP (0,NBC,NCPINC,NBL,NCPINL
     &                     ,IST(MCPLAG),IST(MCPLIG)
     &                     ,ADRESS,IST(MCWORK+NBCOEF),IST(MCWORK))      !morse
            ELSE
               CALL ERTERM (18,NOMTRM,NIVTRM)
            ENDIF
            CALL TBSAVE (NMSTOK,NVSTOK)
*
*           Ecriture des pointeurs de la structure Sparse
*
            WRITE (NOUNIT,10001) 
     &         (IST(K),K=MCWORK,MCWORK+NBCOEF-1)
            WRITE (NOUNIT,10001) 
     &         (IST(K),K=MCWORK+NBCOEF,MCWORK+2*NBCOEF-1)
            CALL TBTUER ('$WORK$',0)
         ENDIF
      ELSE
         GOTO 99910
      ENDIF
*
*     Ecriture des coefficients du terme
*
      CALL TBAR1  (ERCODE,NOMTRM,NIVTRM,MCTERM)
      IF (TYTERM(1:4).EQ.'REEL') THEN
         WRITE (NOUNIT,10002) (RST(K),K=MCTERM,MCTERM+NBCOEF-1)
      ELSEIF (TYTERM(1:8).EQ.'COMPLEXE') THEN
         WRITE (NOUNIT,10004) (CST(K),K=MCTERM,MCTERM+NBCOEF-1)
      END IF
      CALL TBSAVE (NOMTRM,NIVTRM)
*
      CALL TBAR1  (ERCODE,'#Unite',0,MCFICH)                            !utilite
      AST(MCFICH-1+NOUNIT)=' '
*
      CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)                         !utilite
      WRITE (IMPMES,10000) ERCODE(1:NCATR1),NOMFIC,OUTPUW
*
      CLOSE (UNIT=NOUNIT,STATUS='KEEP')
      CALL PRFXMJ (-1,'*EcMatr*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(' *EcMatr* Ecriture du terme ',A,' sur le fichier ',A,
     &/T11,' au format ',A)
10001 FORMAT(10I6)
10002 FORMAT(E16.8)
10004 FORMAT(2E16.8)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99901 CALL BAISE  ('Probleme sur ''Inquire'' avec le fichier'
     &//NOMFIC)
99902 CALL ENCLER (NOUNIT,ERCODE(1:4))
      CALL BAISE  (' Probleme a l''ouverture du fichier '
     &//NOMFIC(1:LENFIC)//' - Unite logique '//ERCODE(1:4))
99903 CALL ENCLER (NIVTRM,NOMFIC)
      CALL BAISE  ('Chaine NOMFIC trop courte pour representer NIVTRM='
     &//NOMFIC)
99910 CALL PRNTRM (NOMTRM,NIVTRM,ERCODE,NCATR1)
      CALL BAISE  ('Ecriture du terme '//ERCODE(1:NCATR1)
     &//'. Structure de sortie non prevue : '//OUTPUW)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin & C.Chambeyron (23 novembre 2009)
*  sorties SPARSE pour tous les type de stockage matriciels
* Version 2 : D.Martin (08 octobre 2008)
*  changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (11 Fevrier 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !EcMatr
