*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ECTERM (NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)
* Derniere modification : D.Martin (6 Juillet 2000)
* Version 1.0.3
*  
* Ecriture du terme de nom NMTERM de niveau NVTERM sur le fichier sequentiel
* de nom NMTERM//.//'NVTERM'
*
* N.B. Le fichier NMTERM//.//'NVTERM' doit necessairement ouvert avant l'appel
*      a l'aide de la procedure OpTerm.
*      Il pourra etre si necessaire ferme (CLOSE) a l'aide de FeTerm.
*  
*-- Arguments d'entree -- 
* NMTERM nom de terme a ecrire sur le fichier
* NVTERM niveau du terme
*
*-- Remarques --
* Format du fichier :
*  enregistrement 1 - le titre sur une ligne ignoree en lecture
*  enregistrement 2 - le nombre de composantes par noeuds du terme (NCPINC)
*                     pour un terme vectoriel uni-inconnue, 1 sinon
*                   - la longueur en articles du 3ieme enregistrement (NBVALV)
*                   - un indice qui vaut 2 en reel, 4 en complexe.
*  enregistrement 3 - les valeurs du terme (NCPINC*NBVALV)
*  enregistrement 4 - les caracteristiques du terme (au sens de $SDTRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     TYPINT*9
      LOGICAL       OPNED,JEXIST
      INTEGER       KELCHN,KLTERM,INTTYP
      INTEGER       NOUNIT,LENTRM,LENFIC
     &             ,MCMTRM,MCDTRM,LGENTE,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,LGTERM,MCTERM,MCTERA,MCTERB,NBVALV
     &             ,NWTERM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &             ,NUINCL,NVDUML,NBLIGN,NVNUML
     &             ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
     &             ,MCINCO,INTERP,NCPINC,NBTNEL,J,IV,NCATR1
      CHARACTER     ERCODE*120,NOMFIC*24
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*EcTerm*')
*
      LENTRM=LEN (NMTERM)
      LENFIC=LENTRM
*
*     Nom du fichier de sortie
*
      NOMFIC=NMTERM//'.'
      DO 1 LENFIC=LENTRM+2,LEN (NOMFIC)
         CALL ENCLER (NVTERM,NOMFIC(LENTRM+2:LENFIC))                   !utilite
         IF (NOMFIC(LENTRM+2:LENTRM+2).NE.'+')  GOTO 2
1     CONTINUE
      GOTO 99903
*
*     Test de l'ouverture prealable du fichier
*
2     INQUIRE (FILE=NOMFIC(1:LENFIC),NUMBER=NOUNIT,OPENED=OPNED
     &        ,EXIST=JEXIST,ERR=99900)
      IF ((.NOT.JEXIST).OR.(JEXIST.AND..NOT.OPNED)) GOTO 99901
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGENTE,NBTERM,INCTRM,NCHTRM)             !utilite
*
10    NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !utilite
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
*
*     Caracteristiques du terme
*
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#NCONU',1,MCINCO)
      CALL GETTRM (IST(MCDTRM+LGENTE+INCTRM*(NUTERM-1)),NWTERM,ITYPTR
     &            ,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &            ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &            ,NUINCL,NVDUML,NBLIGN,NVNUML
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP)
*
      IF (NUINCC.NE.NDFINC.AND.NUINCL.NE.NDFINC) THEN
*        Terme matriciel uni-inconnue
         NCPINC=1
      ELSEIF (NUINCC.NE.NDFINC) THEN
         CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTERP,NBTNEL)          !utilite
      ELSEIF (NUINCL.NE.NDFINC) THEN
         CALL SDEXCO (NUINCL,IST(MCINCO),NCPINC,INTERP,NBTNEL)          !utilite
      ELSE
*        Terme matriciel ou vectoriel multi-inconnues
         NCPINC=1
      ENDIF
*
      CALL TBRR1  (ERCODE,NMTERM,NVTERM,LGTERM)
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*
*     Ecriture du titre et de l'entete pour le terme
*
      NBVALV=LGTERM/NCPINC
      CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      WRITE (NOUNIT,*) '!Terme ',ERCODE(1:NCATR1),' ',TYPINT(ITYPTR)
      WRITE (NOUNIT,*) NCPINC,NBVALV,ITYPTR
*
*     Ecriture des coefficients du terme
*
      MCTERA=MCTERM
      IF (ITYPTR.EQ.INTTYP ('REEL')) THEN                               !utilite
         DO 20 IV=1,NBVALV
            MCTERB=MCTERA+NCPINC
            WRITE (NOUNIT,10002) (RST(J),J=MCTERA,MCTERB-1)
            MCTERA=MCTERB
20       CONTINUE
      ELSE
         DO 40 IV=1,NBVALV
            MCTERB=MCTERA+NCPINC
            WRITE (NOUNIT,10002) (CST(J),J=MCTERA,MCTERB-1)
            MCTERA=MCTERB
40       CONTINUE
      ENDIF
*
      CALL TBSAVE (NMTERM,NVTERM)
*
*     Ecriture des caracteristiques du terme
*
      WRITE (NOUNIT,10003) ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &                    ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &                    ,NUINCL,NVDUML,NBLIGN,NVNUML
     &                    ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
*
      WRITE (IMPMES,10000) ERCODE(1:NCATR1),NOMFIC(1:LENFIC)
      CALL PRFXMJ (-1,'*EcTerm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(' *EcTerm*>Ecriture du terme ',A,' sur le fichier ',A)
10002 FORMAT(6E16.8)
10003 FORMAT(6I12)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99900 CALL BAISE  (' Probleme sur ''Inquire'' avec le fichier'
     &//NOMFIC(1:LENFIC))
99901 CALL PRNTRA (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  (' Le fichier '//NOMFIC(1:LENFIC)//
     &' doit etre ouvert a l''aide de OPTERM, avant l''appel de  ECTERM'
     &//'. Syntaxe : CALL OPTERM '//ERCODE(1:NCATR1)//'.')
99903 CALL BAISE  ('Chaine de caracteres de longueur insuffisante'
     &//' pour definir le nom du fichier.')
                                                                    END !EcTerm
