*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXDUVC (NVDSMO,NMVECO,NVVECO,TYVECO
     &                  ,NVDSMW,NMVECW,NVVECW,TYVECW)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1997)
* Modifications : D.Martin (31 Mars 2005), (3 mars 1998)
* Version 2
*  
* Adaptation d'un vecteur "multi-inconnues" a une structure "multi-inconnues"
*  
*-- Arguments d'entree --
* NVDSMO niveau de la structure d'assemblage $DSMBL du vecteur original
* NMVECO nom du vecteur original
* NVVECO son niveau
* TYVECO type de sa declaration (REEL, COMPLEXE, ...)
* NVDSMW niveau de la nouvelle structure d'assemblage $DSMBL 
* NMVECW nom du vecteur modifie
* NVVECW son niveau
* TYVECW type de sa declaration (REEL, COMPLEXE, ...)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMVECO,TYVECO,NMVECW,TYVECW
      INTEGER       NVDSMO,NVVECO,NVDSMW,NVVECW
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       MCDSMO,ADDSMO,NBLOCO,NBLOLO,LGEDSO,INCDSO,LRIPIO
     &             ,NUINCO,NVNUMO,MCNUMO,LGNELO,NBNELO,MCVECO
     &             ,MCDSMW,ADDSMW,NBLOCW,NBLOLW,LGEDSW,INCDSW,LRIPIW
     &             ,NUINCW,NVNUMW,MCNUMW,LGNELW,NBNELW,MCVECW
     &             ,I,NUTERM,NVCOOR,NULOLO
      CHARACTER     ERCODE*120,READRE
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*ExDuvc*')
*
      CALL TBAR2  (ERCODE,'$DSMBL',NVDSMW,MCDSMW
     &                   ,'$DSMBL',NVDSMO,MCDSMO)
      READRE='N'
      CALL SDEXDB (IST(MCDSMO),LGEDSO,NBLOCO,INCDSO,NBLOLO)             !sdexplo
      CALL SDEXDB (IST(MCDSMW),LGEDSW,NBLOCW,INCDSW,NBLOLW)             !sdexplo
      IF (NBLOLO.LT.NBLOLW) THEN
         CALL TBAJST ('$DSMBL',NVDSMO,LGEDSO+NBLOLW*INCDSO)
         CALL TBAR2  (ERCODE,'$DSMBL',NVDSMW,MCDSMW
     &                      ,'$DSMBL',NVDSMO,MCDSMO)
      ENDIF
      READRE='N'
*
*     Synchronisation des inconnues en ligne des deux structures
*     d'assemblage "multi-inconnue"
*
      LRIPIW=LGEDSW
      LRIPIO=LGEDSO
      DO 50 NULOLO=1,MAX (NBLOLW,NBLOLO)
         ADDSMW=MCDSMW+LRIPIW
         LRIPIW=LRIPIW+INCDSW
         ADDSMO=MCDSMO+LRIPIO
         LRIPIO=LRIPIO+INCDSO
         NUINCW=IST(ADDSMW+2)
         NUINCO=IST(ADDSMO+2)
*
         IF (NUINCO.GT.NUINCW) THEN
*
            IF (NBLOLO.EQ.NBLOLW) GOTO 99991 
*           Decalage d'un rang de l'inconnue du second membre
            DO 20 I=MCDSMO+LGEDSO+NBLOLO*INCDSO-1,ADDSMO,-1
               IST(I+INCDSO)=IST(I)
20          CONTINUE
*           Vide correspondant a l'inconnue de la matrice
            IF (NUINCW.LE.0) THEN
*              Il n'y a pas de bloc dans cette colonne de la matrice,
*              colonne suivante pour recueillir le numero d'inconnue
               DO 29 I=2,NBLOCW
                  ADDSMW=ADDSMW+INCDSW*NBLOLW
                  NUINCW=IST(ADDSMW+2)
                  IF (NUINCW.GT.0) GOTO 30
29             CONTINUE
               GOTO 99994
            ENDIF
         ELSEIF (NUINCO.LT.NUINCW) THEN
            IF (NUINCO.GT.0) GOTO 99992
*           Le second membre peut avoir a une case vide a la fin
         ELSE
            GOTO 50
         ENDIF
30       NBLOLO=NBLOLO+1
         NVNUMO=IST(ADDSMW+4)
         NVCOOR=IST(ADDSMW+5)
         IST(ADDSMO)  =0
         IST(ADDSMO+1)=0
         IST(ADDSMO+2)=NUINCW
         IST(ADDSMO+3)=NDFNUM
         IST(ADDSMO+4)=NVNUMO
         IST(ADDSMO+5)=NVCOOR
50    CONTINUE
      CALL SDMKDB(IST(MCDSMO),LGEDSO,NBLOCO,INCDSO,NBLOLO)              !sdexplo
*
*     Extension eventuelle du vecteur pour chaque inconnue en ligne
*
      LGNELW=0
      LRIPIW=LGEDSW
      LGNELO=0
      LRIPIO=LGEDSO
      DO 100 NULOLO=1,NBLOLO
         IF (READRE.EQ.'Y') CALL TBAR2  (ERCODE,'$DSMBL',NVDSMO,MCDSMO
     &                                         ,'$DSMBL',NVDSMW,MCDSMW)
         ADDSMW=MCDSMW+LRIPIW
         LRIPIW=LRIPIW+INCDSW
         NUINCW=IST(ADDSMW+2)
         NVNUMW=IST(ADDSMW+4)
         ADDSMO=MCDSMO+LRIPIO
         LRIPIO=LRIPIO+INCDSO
         NUINCO=IST(ADDSMO+2)
         NVNUMO=IST(ADDSMO+4)
         IF (NUINCW.NE.NUINCO) GOTO 99993
         IST(ADDSMO+4)=NVNUMW
         NUTERM=IST(ADDSMO)
*
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUMW,MCNUMW)
         READRE='Y'
         IF (NUTERM.EQ.0) THEN
            CALL TBAR2  (ERCODE,NMVECW,NVVECW,MCVECW
     &                         ,'#GNEDO',NVNUMW,MCNUMW)
            NBNELW=IST(MCNUMW+1)
            NBNELO=NBNELW
            CALL TAZERO (NBNELW,TYVECW,MCVECW+LGNELW,AST,IST,RST,CST)   !utilite
         ELSE
            IF (NVNUMO.EQ.NVNUMW) THEN
               CALL TBAR3  (ERCODE,NMVECW,NVVECW,MCVECW
     &                            ,NMVECO,NVVECO,MCVECO
     &                            ,'#GNEDO',NVNUMW,MCNUMW)
               NBNELW=IST(MCNUMW+1)
               NBNELO=NBNELW
               CALL TDANST (NBNELO,TYVECO,MCVECO+LGNELO,IST,RST,CST 
     &                            ,TYVECW,MCVECW+LGNELW,IST,RST,CST)    !utilite
            ELSE
               CALL TBRR1  (ERCODE,'#GNEDO',NVNUMO,MCNUMO)
               CALL TBAR4  (ERCODE,NMVECW,NVVECW,MCVECW
     &                            ,NMVECO,NVVECO,MCVECO
     &                            ,'#GNEDO',NVNUMW,MCNUMW
     &                            ,'#GNEDO',NVNUMO,MCNUMO)
               NBNELW=IST(MCNUMW+1)
               NBNELO=IST(MCNUMO+1)
               CALL EXNUVC (NBNELO,IST(MCNUMO+2),TYVECO,MCVECO+LGNELO,1
     &                     ,NBNELW,IST(MCNUMW+2),TYVECW,MCVECW+LGNELW
     &                     ,RST,CST)                                    !sdexplo
               CALL TBSAVE('#GNEDO',NVNUMO)
            ENDIF
*           DM 31 Mars 2005 correction 
*           la ligne suivante a ete remonte d'une ligne ! (au dessus du ENDIF)
            LGNELO=LGNELO+NBNELO
         ENDIF
         LGNELW=LGNELW+NBNELW
         CALL TBSAVE ('#GNEDO',NVNUMW)
 100  CONTINUE
*
      CALL PRFXMJ (-1,'*ExDuvc*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMVECW,NVVECW,ERCODE,NCATR1)
      CALL BAISE  ('Le vecteur '//ERCODE(1:NCATR1)//
     &' a plus d''inconnues en ligne que la structure multi-inconnue.')
99992 CALL PRNTRM (NMVECW,NVVECW,ERCODE,NCATR1)
      CALL BAISE  ('Le vecteur '//ERCODE(1:NCATR1)
     &//' a une inconnue en ligne sans equivalent dans la structure'
     &//' multi-inconnue.')
99993 WRITE (IMPPAL,90000) NULOLO,NUINCW,NUINCO
90000 FORMAT(/' Bloc',I5,', Inconnue en ligne de la structure',I5
     &                  ,', Inconnue en ligne du vecteur',I5/)
      CALL PRNTRM (NMVECW,NVVECW,ERCODE,NCATR1)
      CALL BAISE  ('Incoherence sur les inconnues en ligne'
     &//' de la structure et du terme '//ERCODE(1:NCATR1))
99994 CALL PRNTRM (NMVECW,NVVECW,ERCODE,NCATR1)
      CALL ENCLER (NUINCO,ERCODE(NCATR1+1:NCATR1+3))
      CALL BAISE  ('L''inconnue numero '//ERCODE(NCATR1+1:NCATR1+3)
     &//' du terme multi-inconnues '//ERCODE(1:NCATR1)
     &//' n''est pas retrouve dans la structure matricielle pour '
     &//' laquelle on cherche a l''etendre.')
                                                                    END !ExDuvc
