*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXTERM (NMTRM1,NVTRM1,NOMDOM,INDEXC,INDEXL
     &                  ,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Mai 1991)
* Derniere modification : D.Martin (15 septembre 2006)
* Version 2 
*
* Extraction d'un terme a partir d'un terme uni-ligne ou uni-colonne selon 
* la numerotation en ligne d'un domaine
*
*-- Arguments d'entree ---
* NMTRM1,NVTRM1 nom et niveau du vecteur source
* NOMDOM        nom du domaine sur lequel on realise l'extraction
* INDEXC indice d'extension recherche en colonne (negatif si sans importance)
* INDEXL indice d'extension recherche en ligne (negatif si sans importance)
* NMTRM2,NVTRM2 nom et niveau du vecteur resultat
* NIVIMP niveau d'impression du vecteur resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRM1,NMTRM2,NOMDOM
      INTEGER       NVTRM1,INDEXC,INDEXL,NVTRM2,NIVIMP
*
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER ERCODE*120,TYPINT,TYTRM1,LIGCOL
      INTEGER   INDSTO,KLTERM,KLNIVE
      INTEGER   LGMTRM,LGDTRM,MCMTRM,MCDTRM,MCMDOM,MCTRDO
     &         ,LGETRM,NBTERM,INCTRM,NCHTRM,NWHTRM,NUTERM
     &         ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &         ,NUINCL,NVDUML,NBNEL1,NVNUL1,NUINCC,NVDUMC,NBNEC1,NVNUC1
     &         ,INSTOK,NVSTOK,NVCORT,IATRDO,NIVDOM
     &         ,NUDOMK,NUDOMG,IGEOME,INDMIX,NUSCHQ
     &         ,INDECC,IDLHRC,INTRDC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &         ,NBDLFX,NVNUUU
     &         ,INDELL,IDLHRL,INTRDL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &         ,NBDLFY,NVNUMD,NVCOOR,INUTIL,NBTRDO
     &         ,IATOLD,NVVOLD,ITYOLD,NVAOLD,ITYCLD,NUKALD
     &         ,NUCOLD,NBNECZ,NVNUCZ,NULOLD,NBNELZ,NVNULZ
     &         ,NIVOLD,MCTRM1,MCNUL1
     &         ,NVNUM2,NBNEE2,MCNUMD,NBNEUD,MCNULZ,LGREEL,NNEUTI
     &         ,MCTRM2,MCNUM2,J,I,ADTRM1,ID,IF,NCATR1,NCATR2,ITEMD1
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*ExTerm*')
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR4  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*     Caracteristiques du terme original
*
      NUTERM=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))  ,NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEC1,NVNUC1
     &            ,NUINCL,NVDUML,NBNEL1,NVNUL1
     &            ,INSTOK,NVSTOK,NVCORT,IATRDO,NIVDOM)                  !sdexplo
      LIGCOL='L'
      IF (NUINCL.EQ.NDFINC) THEN
         NUINCL=NUINCC
         NBNEL1=NBNEC1
         NVNUL1=NVNUC1
         LIGCOL='C'
      ENDIF
      TYTRM1=TYPINT (ITYPTR)                                            !utilite
*
*     Caracteristiques du domaine
*
      CALL KLDOMN (NOMDOM,INDEXC,INDEXL
     &            ,IST(MCTRDO),AST(MCMDOM),NBDOMG,NUDOMK,IATRDO)        !sdexplo
      CALL GETDOM (IST(MCTRDO+IATRDO)
     &            ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,INDECC,IDLHRC,INTRDC,NBNECX,NBNEEX,NBDLEX
     &            ,NBNEFX,NBDLFX,NVNUUU
     &            ,INDELL,IDLHRL,INTRDL,NBNELX,NBNEEY,NBDLEY
     &            ,NBNEFY,NBDLFY,NVNUMD,NVCOOR,INUTIL,NBTRDO,NIVDOM)    !sdexplo
*
*     Mise a jour des structures de description pour le vecteur resultat
*
      NUTERM=KLTERM (NMTRM2,NVTRM2,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
         CALL ALFANU (NBCHNT,NMTRM2)                                    !utilite
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         NWHTRM=MAX (NCHTRM,LEN (NMTRM2))
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTRM2)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERM=NBTERM 
         IATOLD=IATRDO+1  
         NUDONN=0
         NBNELZ=0
      ELSE 
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVOLD
     &               ,ITYOLD,ITYCLD,NUKALD,NUDONN,NVAOLD,NVDSMB
     &               ,NUCOLD,NVDUMC,NBNECZ,NVNUCZ
     &               ,NULOLD,NVDUML,NBNELZ,NVNULZ
     &               ,INSTOK,NVSTOK,NVCORT,IATOLD,NIVOLD)               !sdexplo
         IF (NULOLD.EQ.NDFINC) THEN
            NBNELZ=NBNECZ
            NVNULZ=NVNUCZ
            LIGCOL='C'
         ENDIF
      ENDIF
*
*     On recherche si la numerotation du domaine est un sous-ensemble
*     de la numerotation du terme; ceci correspond par exemple au cas 
*     courant ou le domaine d'extraction est un bord du domaine sur
*     lequel le terme source est calcule
*
      CALL TBRR3  (ERCODE,NMTRM1,NVTRM1,MCTRM1
     &                   ,'#GNEDO',NVNUL1,MCNUL1,'#GNEDO',NVNUMD,MCNUMD)
      CALL TBAR2  (ERCODE,'#GNEDO',NVNUL1,MCNUL1,'#GNEDO',NVNUMD,MCNUMD)
      NBNEUD=IST(MCNUMD+1)
      NVNUM2=NVNUMD
      NBNEE2=NBNEUD
*
      CALL LISINC (NBNEUD,IST(MCNUMD+2),NBNEL1,IST(MCNUL1+2),ID,IF,*1)  !utilite
      GOTO 2
*     L'une des numerotations est un sous-ensemble de noeuds consecutifs
*     de l'autre, le calcul est direct.
1     IF (IF-ID+1.EQ.NBNEUD) GOTO 5
*
*     Creation de la numerotation de l'intersection si la numerotation
*     en ligne du domaine n'est pas incluse dans celle du terme source
*
2     IF (NBNELZ.GT.0) CALL TBRR1  (ERCODE,'#GNEDO',NVNULZ,MCNULZ)
      NVNUM2=KLNIVE ()                                                  !sdexplo
      CALL TBCRSU ('#GNEDO',NVNUM2,1,MIN(NBNEUD,NBNEL1)+2,LGREEL,'c')
      CALL TBAR3  (ERCODE,'#GNEDO',NVNUL1,MCNUL1                     
     &                   ,'#GNEDO',NVNUMD,MCNUMD,'#GNEDO',NVNUM2,MCNUM2)
      CALL LISINT (NBNEUD,IST(MCNUMD+2),NBNEL1,IST(MCNUL1+2)
     &            ,NBNEE2,IST(MCNUM2+2),LGREEL-2,*99991)                !utilite
*
*     L'ancienne numerotation du terme est elle correcte ?
*
      IF (NBNELZ.GT.0) THEN
         CALL TBAR2  (ERCODE,'#GNEDO',NVNULZ,MCNULZ
     &                      ,'#GNEDO',NVNUM2,MCNUM2)
         CALL LISINC (NBNELZ,IST(MCNULZ+2),NBNEE2,IST(MCNUM2+2)
     &               ,ID,IF,*3)                                         !utilite
3        IF (NBNEE2.EQ.NBNELZ) THEN
*           La numerotation pre-existe et est correcte
            CALL TBTUER ('#GNEDO',NVNUM2)                               !utilite
            NVNUM2=NVNULZ
            LGREEL=NBNEE2+2
         ENDIF
      ELSE
         IST(MCNUM2)  =0
         IST(MCNUM2+1)=NBNEE2
         IF (NBNEE2+2.LT.LGREEL) CALL TBAJST ('#GNEDO',NVNUM2,NBNEE2+2) !utilite
      ENDIF
*
*     Creation du terme resultat
*
5     CALL TBCREE (NMTRM2,NVTRM2,ITYPTR,NBNEE2*NVALNE,'c')
      CALL TBAR4  (ERCODE,NMTRM1,NVTRM1,MCTRM1,'#GNEDO',NVNUL1,MCNUL1
     &                   ,NMTRM2,NVTRM2,MCTRM2,'#GNEDO',NVNUM2,MCNUM2)
      ITEMD1=1
      MCNUL1=MCNUL1+2
      MCNUM2=MCNUM2+2
      IF (TYTRM1.EQ.'R') THEN
         DO 22 J=1,NBNEE2
            CALL DICOTO (ITEMD1,NBNEL1,IST(MCNUL1),IST(MCNUM2) 
     &                  ,NNEUTI,*22)                                    !utilite
            ITEMD1=NNEUTI+1
            ADTRM1=MCTRM1+(NNEUTI-1)*NVALNE
            DO 21 I=ADTRM1,ADTRM1-1+NVALNE
               RST(MCTRM2)=RST(I)
               MCTRM2=MCTRM2+1
21          CONTINUE
            MCNUM2=MCNUM2+1
22       CONTINUE
      ELSE
         DO 42 J=1,NBNEE2
            CALL DICOTO (ITEMD1,NBNEL1,IST(MCNUL1),IST(MCNUM2) 
     &                  ,NNEUTI,*42)                                    !utilite
            ITEMD1=NNEUTI+1
            ADTRM1=MCTRM1+(NNEUTI-1)*NVALNE
            DO 41 I=ADTRM1,ADTRM1-1+NVALNE
               CST(MCTRM2)=CST(I)
               MCTRM2=MCTRM2+1
41          CONTINUE
            MCNUM2=MCNUM2+1
42       CONTINUE
      ENDIF
*
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      IF (LIGCOL.EQ.'L') THEN
*
*        Cas ou le terme original a une inconnue en ligne
*
         CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTRM2
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NDFDSM
     &               ,NDFINC,NDFDUM,1,NDFNUM
     &               ,NUINCL,NDFDUM,NBNEE2,NVNUM2
     &               ,INDSTO('PLEIN-L'),NDFSTO,NDFCOR,IATOLD,NIVIMP)   !sdexplo
      ELSE
*
*        Cas ou le terme original a une inconnue en colonne
*
         CALL PUTTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVTRM2
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NDFDSM
     &               ,NUINCL,NDFDUM,NBNEE2,NVNUM2
     &               ,NDFINC,NDFDUM,1,NDFNUM
     &               ,INDSTO('PLEIN-L'),NDFSTO,NDFCOR,IATOLD,NIVIMP)   !sdexplo
      ENDIF
*
      IF (NVNUM2.NE.NVNUMD) CALL TBSAVE ('#GNEDO',NVNUM2)
      CALL TBSAVE ('#GNEDO',NVNUMD)
      CALL TBSAVE ('#GNEDO',NVNUL1)
      CALL TBSAVE (NMTRM1,NVTRM1)
      CALL TBSAVE (NMTRM2,NVTRM2)
*
      IF (NIVIMP.GE.0) THEN 
         CALL PRNTRM (NMTRM1,NVTRM1,ERCODE,NCATR1)
         CALL PRNTRM (NMTRM2,NVTRM2,ERCODE(NCATR1+1:),NCATR2)
         ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+16)=NOMDOM
         IF (NBNEUD.LT.NBNEL1) THEN
            WRITE (IMPPAL,10000) ERCODE(NCATR1+1:NCATR1+NCATR2)
     &           ,'Restriction',ERCODE(1:NCATR1)
     &           ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+16)
         ELSE
            WRITE (IMPPAL,10000) ERCODE(NCATR1+1:NCATR1+NCATR2)
     &           ,'Extension',ERCODE(1:NCATR1)
     &           ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+16)
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*ExTerm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT (/T2,'*ExTerm* Terme ',A,' : '
     &,A,' du terme ',A,' au domaine ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL PRNTRM (NMTRM2,NVTRM2,ERCODE,NCATR1)
      CALL BAISE  (' La taille du tableau de numerotation pour le terme'
     &            //ERCODE(1:NCATR1)//' est insuffisante')
                                                                    END !ExTerm
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history --
* Version 2 : D.Martin (15 septembre 2006)
*  - le terme resultat etait jusqu'a present cree avec une inconnue en ligne,
*    on lui affecte maintenant la meme structure que le terme original
*  - de plus dans le cas ou le tableau existe anterieurement, on conserve
*    sa structure
* Version 1.1 : D.Martin (9 Avril 2002)
*  - substitution de GETTRV par GETTRM
* Version 1.0.1 : D.Martin (5 Mai 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
