*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FONUDL (NCPICA,NCPILA,NVNUCA,NVNULA,NVNUCM,NVNULM
     &                  ,NVDUCM,NVDULM,NVDUCA,NVDULA,YANDLC,YANDLL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & F.Mahe (mars 1997)
* Derniere modification : D.Martin & F.Mahe (19 Juin 1997)
*  
* Faut-il creer une numerotation en d.l. (vectoriels) pour une matrice A.
* Si une telle numerotation existe pour une matrice M et convient a la 
* matrice A, il ne sera pas necessaire d'en creer de nouvelle.
*
*-- Arguments d'entree --
* NCPICA nombre de composantes de l'inconnue en colonnes pour A
* NCPILA nombre de composantes de l'inconnue en lignes pour A
* NVNUCA Niveau de la numerotation des noeuds de l'inconnue en colonne de A
* NVNULA Niveau de la numerotation des noeuds de l'inconnue en ligne de A
* NVNUCM Niveau de la numerotation des noeuds de l'inconnue en colonne de M
*           =0 s'il n'y a pas de numerotation comparable.
* NVNULM Niveau de la numerotation des noeuds de l'inconnue en ligne de M
*           =0 s'il n'y a pas de numerotation comparable.
* NVDUCM Niveau de la numerotation des d.l. (vectoriels) de l'inconnue en 
*        colonne de M
* NVDULM Niveau de la numerotation des d.l. (vectoriels) de l'inconnue en 
*        ligne de M
*-- Arguments de sortie --
* NVDUCA Niveau de la numerotation des d.l. (vectoriels) de l'inconnue en 
*        colonne de A 
*           =NVDUCM si NVDUCM.NE.0 et si cette numerotation convient
*           =prochain numero de disponible pour une structure sinon
* NVDULA Niveau de la numerotation des d.l. (vectoriels) de l'inconnue en 
*        ligne de A (comme ci-dessus en remplacant `C' par `L')
* YANDLC Caractere indiquant l'etat de la numerotation d.l. en colonne
*           ='N' pas besoin de numerotation en d.l.
*           ='E' la numerotation en d.l. existe deja
*           ='A' on va affecter a A la numerotation deja existante de M.
*           ='C' on va creer une nouvelle numerotation pour A.
* YANDLL Caractere indiquant l'etat de la numerotation d.l. en ligne
*           memes possiblites que pour YANDLC.
*-- Voir VPPREP pour un exemple d'utilisation
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NCPICA,NCPILA,NVNUCA,NVNULA,NVNUCM,NVNULM
     &       ,NVDUCM,NVDULM,NVDUCA,NVDULA
      CHARACTER*(*) YANDLC,YANDLL
*
      INTEGER KLNIVE
*-----------------------------------------------------------------------
      NDFDUM=-999999999
      YANDLC='N'
      YANDLL='N'
      IF (NCPICA*NCPILA.GT.1) THEN
         YANDLC='E'
         YANDLL='E'
         IF (NCPICA.GT.1.AND.NVDUCA.EQ.NDFDUM) THEN
            IF (NVNUCA.EQ.NVNUCM) THEN
               NVDUCA=NVDUCM
               YANDLC='A'
            ELSE
               NVDUCA=KLNIVE ()                                         !sdexplo
               YANDLC='C'
            ENDIF
         ENDIF
         IF (NCPILA.GT.1.AND.NVDULA.EQ.NDFDUM) THEN
            IF (NVNULA.EQ.NVNUCA.AND.NCPILA.EQ.NCPICA) THEN
               NVDULA=NVDUCA
               YANDLL='A'
            ELSEIF (NVNULA.EQ.NVNULM) THEN
               NVDULA=NVDULM
               YANDLL='A'
            ELSE
               NVDULA=KLNIVE ()                                         !sdexplo
               YANDLL='C'
            ENDIF
         ENDIF
      ENDIF
                                                                    END !FoNudl
