*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GETDOM (ITERDO,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &                  ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX
     &                  ,NBNEFX,NBDLFX,NVNUMC
     &                  ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY
     &                  ,NBNEFY,NBDLFY,NVNUML
     &                  ,NVCORC,INUTIL,NBTRDO,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Octobre 1989) 
* Derniere modification : D.Martin (2 Juillet 1997)
* Version 1.0.0
*  
* Valeurs de la structure de donnees #TERDO pour un domaine
*
*-- Arguments d'entree -- 
* ITERDO structure #TERDO a l'adresse concernant le domaine en cours  
* NUDOMG numero du domaine geometrique
* NUDOMK numero du domaine de calcul  
* IGEOME indice de calculs geometriques
* INDMIX indice de mixite des interpolations en colonne et ligne  
* NUSCHQ numero du schema de quadrature sur le domaine
* INDEXC indice d'extension du domaine geometrique en colonne 
* IDLHRC indice d'interpolation d'Hermite en colonne  
* INTRPC numero de l'interpolation en colonne 
* NBNECX nombre max. de noeuds en colonne pour un terme dans un elt. du domaine
* NBNEEX max. de noeuds d'un elt du domaine pour l'interpolation en colonne
* NBDLEX max. de d.l. d'un elt du domaine pour l'interpolation en colonne 
* NBNEFX max. de noeuds dune face d'un elt  pour l'interpolation en colonne
* NBDLFX max. de d.l. d'une face d'un elt. pour l'interpolation en colonne
* NVNUMC niveau du tableau #GNEDO de numerotation des noeuds en colonne
* INDEXL indice d'extension du domaine geometrique en ligne
* IDLHRL indice d'interpolation d'Hermite en ligne
* INTRPL numero de l'interpolation en ligne
* NBNELX nombre max. de noeuds en ligne pour un terme dans un elt. du domaine 
* NBNEEY max. de noeuds d'un elt du domaine pour l'interpolation en ligne 
* NBDLEY max. de d.l. d'un elt du domaine pour l'interpolation en ligne
* NBNEFY max. de noeuds dune face d'un elt  pour l'interpolation en ligne 
* NBDLFY max. de d.l. d'une face d'un elt. pour l'interpolation en colonne
* NVNUML niveau du tableau #GNEDO de numerotation des noeuds en ligne 
* NVCORC niveau du tableau &NORMA sur le domaine
* INUTIL inutilise
* NBTRDO nombre de termes sur le domaine  
* NIVIMP niveau d'impression sur le domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER ITERDO(*),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ,INDEXC,IDLHRC
     &       ,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC,INDEXL
     &       ,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY,NBDLFY,NVNUML
     &       ,NVCORC,INUTIL,NBTRDO,NIVIMP 
*-----------------------------------------------------------------------
      NUSCHQ=ITERDO(5) 
      INTRPC=ITERDO(8) 
      NBNECX=ITERDO(9) 
      NBNEEX=ITERDO(10)
      NBDLEX=ITERDO(11)
      NBNEFX=ITERDO(12)
      NBDLFX=ITERDO(13)
      INTRPL=ITERDO(17)
      NBNELX=ITERDO(18)
      NBNEEY=ITERDO(19)
      NBDLEY=ITERDO(20)
      NBNEFY=ITERDO(21)
      NBDLFY=ITERDO(22)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      ENTRY GETDOR (ITERDO,NUDOMG,NUDOMK,IGEOME,INDMIX
     &             ,INDEXC,IDLHRC,NVNUMC,INDEXL,IDLHRL,NVNUML
     &             ,NVCORC,INUTIL,NBTRDO,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      NUDOMG=ITERDO(1) 
      NUDOMK=ITERDO(2) 
      IGEOME=ITERDO(3) 
      INDMIX=ITERDO(4) 
      INDEXC=ITERDO(6) 
      IDLHRC=ITERDO(7) 
      NVNUMC=ITERDO(14)
      INDEXL=ITERDO(15)
      IDLHRL=ITERDO(16)
      NVNUML=ITERDO(23)
      NVCORC=ITERDO(24)
      INUTIL=ITERDO(25)
      NBTRDO=ITERDO(26)
      NIVIMP=ITERDO(27)
                                                                    END !Getdom
