*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ISSYME (NMTERM,NVTERM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (22 Aout 2000)
* Derniere modification : D.Martin (08 octobre 2008)
* Version 2
*  
* Test de la symetrie d'un terme matriciel
* La matrice est necessairement stockee BiMorse
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme
* NVTERM niveau du terme
* NIVIMP niveau d'impression
* IMPFCH unite logique d'impression du resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM,NIVIMP,IMPFCH
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER PRFXAS*8,STODLN*6,SYMIND*14,TYPINT*4
      INTEGER INDSTO,KLTERM
      INTEGER NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &       ,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL,NVDUML,NBNELI,NVNUML
     &       ,INDSTK,NVSTOK,NVCOOR,IATRDO,NIVIMR,MCMTRM,NUTERM,MCTERM
     &       ,LGTERM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NCATR1,MCSTOK
     &       ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,NBC,NBPLAU,MCPLAU,MCPLIU,LGU
     &       ,MCL,MCU,ADECAR,NBDIFF,I,MCINCO,NCPINC,NCPINL,INTERP,NBTNEU
      REAL    ECART,ECARTM,SEUIL
      CHARACTER     ERCODE*120,NMSTOK*6,TYTERM*4
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*IsSyme*')
      SEUIL=1.E-6
*
*     Recherche des caracteristiques du terme
*
*     Adresses des tableaux de noms et de description des termes
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
*     Caracteristiques de la structure de description des termes
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*     Numero du terme dans la structure de description des termes
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTERM,NVTERM)                    !utilite
*
*     Caracteristiques du terme
*
      MCTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(MCTERM)  ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBNECO,NVNUMC,NUINCL
     &            ,NVDUML,NBNELI,NVNUML,INDSTK,NVSTOK,NVCOOR,IATRDO
     &            ,NIVIMR)                                              !sdexplo
*
      NCPINC=1
      IF (NUINCC.NE.NDFINC)
     &   CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTERP,NBTNEU)
      NCPINL=NCPINC
      IF (NUINCL.NE.NDFINC.AND.NUINCL.NE.NUINCC)
     &   CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTERP,NBTNEU)

      IF (ITYSYM.NE.NDFSYM) THEN
*
*        Cas ou le terme est connu comme symetrique dans sa description
*        (seule sa partie triangulaire inferieure est stockee)
*
         CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
         WRITE (IMPFCH,10000) PRFXAS(0),ERCODE(1:NCATR1),SYMIND(ITYSYM)
         GOTO 99999
      ENDIF
*
      IF (INDSTK.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         NMSTOK = STODLN (INDSTK,1,1)
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         IF (ERCODE(1:1).NE.' ') THEN
*
*           Cas ou la structure de stockage est comptee en d.l.
*           (inconnues vectorielles ou multi-inconnues)
*
            NMSTOK = STODLN (INDSTK,NCPINC,NCPINL)
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         ENDIF
*
*        Symetrie structurelle de la matrice ?
*
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !utilite
*
         IF (IST(MCSTOK).NE.2) THEN
*
*           Cas ou la matrice n'a pas une structure connue comme symetrique
*
            IF (NBL.NE.NBC.OR.NCPINC.NE.NCPINL) THEN
*
*              Matrice non carree.
*
               CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
               WRITE (IMPFCH,10010) PRFXAS(0),ERCODE(1:NCATR1)
               IF (NIVIMP.GT.0) WRITE (IMPFCH,10011) NBL,NBC
               GOTO 99999
            ENDIF
*
            IF (NBPLAL.NE.NBPLAU.OR.LGL.NE.LGU) THEN
*
*              Matrice carree dont les parties triangulaires stockees
*              ont des longueurs differentes.
*
               CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
               WRITE (IMPFCH,10020) PRFXAS(0),ERCODE(1:NCATR1)
               GOTO 99999
            ELSE
*              On doit ici comparer la structure des plages
*              des parties triangulaires inferieure et superieure
*              1- comparaison des numeros de dernieres plages
               DO 10 I=0,NBL-1
                  IF (IST(MCPLAL+I).NE.IST(MCPLAU+I)) THEN
                     CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
                     WRITE (IMPFCH,10020) PRFXAS(0),ERCODE(1:NCATR1)
                     GOTO 99999
                  ENDIF
10             CONTINUE
*              2- comparaison des numeros de debut des plages
*                 et des longueurs des plages
               DO 11 I=0,2*NBPLAL-2
                  IF (IST(MCPLIL+I).NE.IST(MCPLIU+I)
     &            .OR.IST(MCPLIL+I+1).NE.IST(MCPLIU+I+1)) THEN
                     CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
                     WRITE (IMPFCH,10020) PRFXAS(0),ERCODE(1:NCATR1)
                     GOTO 99999
                  ENDIF
11             CONTINUE
            ENDIF
         ENDIF
*
         CALL TBSAVE (NMSTOK,NVSTOK)
*
*        La matrice est symetrique en structure
*        On compare les valeurs des coefficients symetriques
*
*        Restauration si necessaire en memoire centrale
         CALL TBRR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*        Adresse de la matrice en memoire centrale
         CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*        Type, reel ou complexe, de la matrice
         TYTERM=TYPINT (ITYPTR)
*        Adresses absolues des parties triangulaires inferieure et superieure
         MCL=MCTERM+NBL
         MCU=MCL+LGL
*        ADECAR contiendra l'adresse relative d'ecart maximum
*        entre deux coefficients symetriques par rapport a la diagonale
*        ECARTM contiendra l'ecart maximum
         NBDIFF=0
         ADECAR=0
         ECARTM=0.
         IF (TYTERM.EQ.'REEL') THEN
*           Matrice a coefficients reels
            DO 12 I=0,LGL-1
               ECART=ABS(RST(MCL)-RST(MCU))
               IF (ECART.GT.SEUIL) THEN
                  NBDIFF=NBDIFF+1
                  IF (NIVIMP.GT.1) THEN
                     IF (ADECAR.EQ.0) THEN
                        CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
                        WRITE (IMPFCH,10031) PRFXAS(0),ERCODE(1:NCATR1)
                     ENDIF
                     WRITE (IMPFCH,10032) NBDIFF,I,RST(MCL),RST(MCU)
                  ENDIF
                  IF (ECART.GT.ECARTM) ADECAR=I
               ENDIF
               IF (ECART.GT.ECARTM) ECARTM=ECART
               MCL=MCL+1
               MCU=MCU+1
12          CONTINUE
         ELSEIF (TYTERM.EQ.'COMP') THEN
*           Matrice a coefficients complexe
            DO 14 I=0,LGL-1
               ECART=ABS(CST(MCL)-CST(MCU))
               IF (ECART.GT.SEUIL) THEN
                  NBDIFF=NBDIFF+1
                  IF (NIVIMP.GT.1) THEN
                     IF (ADECAR.EQ.0) THEN
                        CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
                        WRITE (IMPFCH,10031) PRFXAS(0),ERCODE(1:NCATR1)
                     ENDIF
                     WRITE (IMPFCH,10034) NBDIFF,I,CST(MCL),CST(MCU)
                  ENDIF
                  IF (ECART.GT.ECARTM) ADECAR=I
               ENDIF
               IF (ECART.GT.ECARTM) ECARTM=ECART
               MCL=MCL+1
               MCU=MCU+1
14          CONTINUE
         ELSE
            CALL ERTERM (6,NMTERM,NVTERM)
         ENDIF
*
         IF (ADECAR.GT.0) THEN
*           Ecart maximum superieur au seuil
            CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
            WRITE (IMPFCH,10030) PRFXAS(0),ERCODE(1:NCATR1)
     &                          ,ECARTM,ADECAR
         ELSE
*           Matrice symetrique a ECARTM pres
            CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
            WRITE (IMPFCH,10000) PRFXAS(0),ERCODE(1:NCATR1)
     &                          ,'SYMETRIQUE',ECARTM,LGL
         ENDIF
*
*        Mise en etat de sauvegarde differee du terme
         CALL TBSAVE (NMTERM,NVTERM)
*
      ELSE
*
         CALL WATERM (3,NMTERM,NVTERM)
*
      ENDIF

99999 CALL PRFXMJ (-1,'*IsSyme*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT (/T2,A,' Le Terme ',A,' est ',A,:,' (a ',E10.4,' pres'
     &,', ',I6,' coefficients).')
10010 FORMAT (/T2,A,' Le Terme ',A,' n''est pas une matrice carree.')
10011 FORMAT (/T11,'Elle a ',I6,' lignes et ',I6,' colonnes.')
10020 FORMAT (/T2,A,' Le Terme ',A,' n''a pas une structure symetrique')
10030 FORMAT (/T2,A,' Le Terme ',A,' n''est pas symetrique.'
     &/T11
     &,'Le plus grand ecart : ',E10.4,' correspond aux coefficients '
     &,'d''adresse relative ',I10,' des parties triangulaires.')
10031 FORMAT (/T2,A,' Le Terme ',A,' n''est pas symetrique.'
     &/T11,'  Rang  Adresse   Triang. Inferieur     Triang. Superieur')
10032 FORMAT (T11,I6,I9,' ',2(E10.4,' ',TR10,' '))
10034 FORMAT (T11,I6,I9,' ',4(E10.4,' '))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (23 Aout 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !IsSyme
