*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE KLINDX (INTRPC,INTRPL,NDIM,NUINTG,LISTEL,BLOKEL  
     &                  ,INDEXC,INDEXL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & O.deBayser (Mai 1988)
* Derniere modification : D.Martin (11 Decembre 1999)
*  
* Calcul des indices d'extension en colonne et ligne pour  
* un terme 'Element finis' standard.
*  
*-- Arguments d'entree --
* INTRPC Numero de type de l'interpolation en colonne
* INTRPL Numero de type de l'interpolation en ligne
* NDIM   Dimension d'espace  
* NUINTG Numero d'integrand  
* LISTEL Tableau descriptif du domaine geometrique
* BLOKEL Tableau des blocs d'elements consecutifs de meme type  
*-- Arguments de sortie --
* INDEXC Indice d'extension en colonne
* INDEXL Indice d'extension en ligne 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER INTRPC,INTRPL,NDIM,NUINTG,LISTEL(*),BLOKEL(*)
     &       ,INDEXC,INDEXL
*
      INTEGER KC,KL,ITYSYM,NXLIST,NDMDOM,NDMDOE,NBELDO,NUTGEO
     &       ,LAG,KCL,NBS,NBA,NBF,NBN,NBD,NBNA,NBDA,NBNF,NBDF
*-----------------------------------------------------------------------
      INDEXC=0 
      INDEXL=0 
*  
*     Recherche des caracteristiques pour l'integrand NUINTG
*
      CALL INTATR (NUINTG,KC,INDEXC,KL,INDEXL,ITYSYM)                   !integra
*  
      IF (KC.LE.0.AND.KL.LE.0) RETURN
*  
      CALL EXLIST (LISTEL,NXLIST,NDMDOM,NDMDOE,NBELDO,NBN,NBD,NBNF,NBDF)!sdexplo
*
      IF (NDMDOE.EQ.NDMDOM) THEN
         INDEXL=0  
         INDEXC=0  
      ENDIF
*
      IF (INDEXC.EQ.0.AND.INDEXL.EQ.0) RETURN
*  
*     Recherche du numero de type de l'element pour les interpolations 
*     en colonne et ligne
*
      CALL EXBLOK (LISTEL(NXLIST+1),BLOKEL,NUTGEO)                      !sdexplo
*
      CALL ELEMNB (INTRPL+100*(NUTGEO/100),LAG,KCL
     &            ,NBS,NBA,NBF,NBN,NBD,NBNA,NBDA,NBNF,NBDF)             !ef3d
      IF (KCL.EQ.KL) INDEXL=0
*
      CALL ELEMNB (INTRPC+100*(NUTGEO/100),LAG,KCL
     &            ,NBS,NBA,NBF,NBN,NBD,NBNA,NBDA,NBNF,NBDF)             !ef3d
      IF (KCL.EQ.KC) INDEXC=0
                                                                    END !Klindx
