*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE KLSYME (NDIM,ISYMGR,IGNSYM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Novembre 89)
* Derniere modification : O.DeBayser (17 Juillet 1991)
* Version 1.0.0
*  
* Constitution des coefficients multiplicatifs pour la prise en compte 
* des symetries de la fonction de Green.
*  
*-- Arguments d'entree -- 
* NDIM   dimension d'espace
* ISYMGR indice des symetries declarees
*  
*-- Argument de sortie -- 
* IGNSYM tableau de dim. 3 (independament de NDIM) contenant les indices  
*        de symetrie du probleme par rapport aux plans de coordonnees :
*        IGNSYM(i) = 1 pas de symetrie en la i-eme variable d'espace  
*        IGNSYM(i) = 2  symetrie en la i-eme variable d'espace
*        IGNSYM(i) =-2  antisymetrie en la i-eme variable d'espace
*        Remarques : Si NDIM =1 ce tableau doit necessairement contenir  
*                    les valeurs 1 en 2 et 3-ieme positions  
*                    Si NDIM =2 ce tableau doit necessairement contenir  
*                    la valeur 1 en 3-ieme positions 
*-- Codage du parametre ISYMGR -- 
* La puissance de 10 indique la variable d'espace rangee de G a D  
* Le poids correspondant indique si c'est : Symetrique     2
*                                           Antisymetrique 1
*                                           Rien           0
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NDIM,ISYMGR,IGNSYM(*)
*-----------------------------------------------------------------------
      DO 1 IDIM=1,3
         IGNSYM(IDIM)=1
1     CONTINUE
*  
      IF (ISYMGR.GT.0) THEN 
         IDIV=10**NDIM 
         ISYMG=ISYMGR  
         DO 2 IDIM=1,NDIM  
            IDIV=IDIV/10
            ISYM=ISYMG/IDIV
            IGNSYM(IDIM)=1 
            IF (ISYM.EQ.2) IGNSYM(IDIM)= 2
            IF (ISYM.EQ.1) IGNSYM(IDIM)=-2  
            ISYMG=ISYMG-ISYM*IDIV
2       CONTINUE 
      ENDIF
                                                                    END !KLsyme
