*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LITERM (NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)
* Derniere modification : D.Martin (6 Juillet 2000)
* Version # 1.0.3
*
* Lecture du terme de nom NMTERM de niveau NVTERM sur le fichier sequentiel
* de nom NMTERM//.//'NVTERM' (ecrit avec EcTerm)
*
* N.B. Le fichier NMTERM//.//'NVTERM' doit necessairement ouvert avant l'appel
*      a l'aide de la procedure OpTerm.
*      Il devra etre ferme (CLOSE) a l'aide de FeTerm s'il doit etre relu
*      au cours de la meme execution.
*
*-- Arguments d'entree --
* NMTERM nom du terme a lire
* NVTERM niveau du terme
*
*-- Remarques --
* Format du fichier :
*  enregistrement 1 - le titre sur une ligne ignoree en lecture
*  enregistrement 2 - le nombre de composantes par noeuds du terme (NCPINC)
*                     pour un terme vectoriel uni-inconnue, 1 sinon
*                   - la longueur en articles du 3ieme enregistrement (NBVALV)
*                   - un indice qui vaut 2 en reel, 4 en complexe.
*  enregistrement 3 - les valeurs du terme
*  enregistrement 4 - les caracteristiques du terme (au sens de $SDTRM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      LOGICAL       OPNED,JEXIST
      INTEGER       INTTYP,KLUNIT
      INTEGER       NOUNIT,LENTRM,LENFIC
     &             ,NCPINC,NBVALV,MCTERA,MCTERB,MCTERM
     &             ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &             ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &             ,NUINCL,NVDUML,NBLIGN,NVNUML
     &             ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
     &             ,J,IV,NCATR1
      CHARACTER     ERCODE*120,NOMFIC*24
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*LiTerm*')
*
      CALL ALFANU (NBCHNT,NMTERM)                                       !utilite
      LENTRM=LEN (NMTERM)
      LENFIC=LENTRM
*
*     Nom du fichier de sortie
*
      NOMFIC=NMTERM//'.'
      DO 1 LENFIC=LENTRM+2,LEN (NOMFIC)
         CALL ENCLER (NVTERM,NOMFIC(LENTRM+2:LENFIC))                   !utilite
         IF (NOMFIC(LENTRM+2:LENTRM+2).NE.'+')  GOTO 2
1     CONTINUE
      GOTO 99903
*
*     Test de l'ouverture prealable du fichier
*
2     INQUIRE (FILE=NOMFIC(1:LENFIC),NUMBER=NOUNIT,OPENED=OPNED
     &        ,EXIST=JEXIST,ERR=99900)
      IF ((.NOT.JEXIST).OR.(JEXIST.AND..NOT.OPNED)) GOTO 99901
*
*     Lecture du titre et de l'entete du fichier
*
      READ (NOUNIT,*)
      READ (NOUNIT,*) NCPINC,NBVALV,ITYPTR
*
*     Creation du tableau
*
      CALL TBCREE (NMTERM,NVTERM,ITYPTR,NCPINC*NBVALV,'c')
      CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
*
*     Lecture des coefficients
*
      MCTERA=MCTERM
      IF (ITYPTR.EQ.INTTYP ('REEL')) THEN                               !utilite
         DO 20 IV=1,NBVALV
            MCTERB=MCTERA+NCPINC
            READ (NOUNIT,*) (RST(J),J=MCTERA,MCTERB-1)
            MCTERA=MCTERB
20       CONTINUE
      ELSEIF (ITYPTR.EQ.INTTYP ('COMPLEXE')) THEN                       !utilite
         MCTERA=2*MCTERA-1
         DO 40 IV=1,NBVALV
            MCTERB=MCTERA+2*NCPINC
            READ (NOUNIT,*) (RST(J),J=MCTERA,MCTERB-1)
            MCTERA=MCTERB
40       CONTINUE
      ENDIF
*
      CALL TBSAVE (NMTERM,NVTERM)
*
*     Lecture des caracteristiques du terme
*
      READ (NOUNIT,*) ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP
*
*     Mise a jour des caracteristiques du terme
*
      CALL CRTERM (NMTERM,NVTERM,NCPINC*NBVALV,ITYPTR,ITYCAL,NUKALE
     &            ,NUDONN,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &            ,NUINCL,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR
     &            ,IATRDO,NIVIMP,.FALSE.,JEXIST)
*
      CALL PRNTRM (NMTERM,NVTERM,ERCODE,NCATR1)
      WRITE (IMPMES,10000) ERCODE(1:NCATR1),NOMFIC(1:LENFIC)
      CALL PRFXMJ (-1,'*EcTerm*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(' *LiTerm*>Lecture du terme ',A,' sur le fichier ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99900 CALL BAISE  ('Probleme sur ''Inquire'' avec le fichier '
     &//NOMFIC(1:LENFIC))
99901 CALL PRNTRA (NMTERM,NVTERM,ERCODE,NCATR1)
      CALL BAISE  (' Le fichier '//NOMFIC(1:LENFIC)//
     &' doit etre ouvert a l''aide de OPTERM, avant l''appel de  LITERM'
     &//'. Syntaxe : CALL OPTERM '//ERCODE(1:NCATR1)//'.')
99902 ERCODE=NOMFIC
      CALL BAISE  ('Erreur en lecture des coefficients reels '
     &//'sur fichier '//ERCODE(1:16))
99903 CALL BAISE  ('Chaine de caracteres de longueur insuffisante'
     &//' pour definir le nom du fichier.')
99904 ERCODE=NOMFIC
      CALL BAISE  ('Erreur en lecture des coefficients '
     &//'complexes sur fichier '//ERCODE(1:16))
                                                                    END !LiTerm
