*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MAT2NL (NMMATR,NVMATR,NMMATL,NVMATL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1994)
* Derniere modification : D.Martin (30 Juin 2010)
* Version 2
*  
* Transformation d'une matrice selon le stockage Nume-L
*
* La matrice peut etre stockee sous forme 'BIMORSE', 'PROFIL'
* et dans les cas 'BIMORSE' et 'PROFIL', elle peut etre
* 'SYMETRIQUE', 'AUTOADJOINTE', 'ANTISYMETRIQUE' ou 'ANTIADJOINTE'.
*  
*-- Arguments d'entree -- 
* NMMATR nom de la matrice
* NVMATR son niveau
* NMMATL nom du terme matriciel resultat 
* NVMATL son niveau
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMMATR,NMMATL
      INTEGER       NVMATR,NVMATL
*  
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC'  
*
      CHARACTER STOIND*7,TYPINT*4
      CHARACTER ERCODE*120,NMWOR0*6,NMSTOK*6,NMSTOD*6,TYMATR*4
      INTEGER   INDSTO,KLTERM,INDSYM
      INTEGER   MVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN,ITYSYM
     &         ,IPTDIR,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM,NVDULM
     &         ,NBNELM,NVNULM,INDSTK,NVSTOK,NVCOMA,IATRDO,NIVIMP
      LOGICAL       CRETRM
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (ERCODE(89:89),NMWOR0),(ERCODE(97:97),NMSTOD)
     &           ,(ERCODE(105:105),NMSTOK),(ERCODE(113:113),TYMATR)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mat2Nl*')
      ERCODE=' '
*
      CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGMATR)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !Sdexplo
      IF (NMMATR.EQ.NMMATL.AND.NVMATR.EQ.NVMATL)
     &   CALL ERTERM (9,NCHTRM,NMMATR,NVMATR)                           !Sdexplo
*
      ITYSNO=INDSYM (' ')                                               !Utilite
*  
*--   Recherche des caracteristiques de la matrice
*
      NUTERM=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !Sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NCHTRM,NMMATR,NVMATR)             !Sdexplo
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),MVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN,ITYSYM
     &            ,IPTDIR,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM,NVDULM
     &            ,NBNELM,NVNULM,INDSTK,NVSTOK,NVCOMA,IATRDO,NIVIMP)    !Sdexplo
*
      TYMATR=TYPINT (ITYMAT)                                            !Utilite
      NMSTOK=' '
      NMSTOD=' '
*
      IF (INDSTK.EQ.INDSTO ('BIMORSE')) THEN
         NMSTOK='&BMORS'
         CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !Sdexplo
         LGD=MIN (NBL,NBC)
         LGMATL=LGD+LGL+LGU
      ELSEIF (INDSTK.EQ.INDSTO ('PROFIL')) THEN
         NMSTOK='&PROFL'
         CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXPROF (MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                  ,NBC,MCUENV,LGU)                !Sdexplo
         LGD=MIN (NBL,NBC)
         LGMATL=LGD+LGL+LGU
      ELSE
         GOTO 99996
      ENDIF
*  
*--   Matrice resultat -------------------------------------------------
*
      INDSTN=INDSTO('NUME-L')
      CALL CRTERM (NMMATL,NVMATL,LGMATL,ITYMAT,ITYCAL,NUKALE,NUDONN
     &            ,ITYSYM,IPTDIR,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM
     &            ,NVDULM,NBNELM,NVNULM,INDSTN,NVSTOK,NVCOMA,IATRDO
     &            ,NIVIMP,.FALSE.,CRETRM)                               !Sdexplo
*
*--   Creation de la structure Nume-L provisoire
*
      CALL TBCREE ('$WORK$',1,1,2+NBNELM+1+LGMATL+LGMATL,'c')
*
      IF (NMSTOK(1:4).EQ.'&BMO') THEN
*
         CALL TBAR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK,'$WORK$',1,MCWORK)
*
*        Construction de la structure Nume-L provisoire
*
*        Initialisation
         CALL TAZERO (NBL,'ENTIER',3,AST,IST(MCWORK),RST,CST)           !Utilite
         IST(MCWORK)      =NBL
         IST(MCWORK+1)    =NBC
         IST(MCWORK+2+NBL)=1
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)  !Sdexplo
*
*        Pointeurs Nume-L pour la partie triangulaire inferieure
         CALL BML2NL (1,NBL,IST(MCPLAL),IST(MCPLIL),IST(MCWORK+2)
     &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
*        Pointeurs Nume-L pour la diagonale (a partir de la ligne 2)
         CALL D2NL   (NBL,IST(MCWORK+2)
     &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
*        Pointeurs Nume-L pour la partie triangulaire superieure
         CALL BMU2NL (1,NBL,NBC,IST(MCPLAU),IST(MCPLIU),IST(MCWORK+2)
     &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
*
      ELSEIF (NMSTOK(1:4).EQ.'&PRO') THEN
*
         CALL TBAR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK,'$WORK$',1,MCWORK)
*
*        Construction de la structure Nume-L provisoire
*
*        Initialisation
         CALL TAZERO (NBL,'ENTIER',3,AST,IST(MCWORK),RST,CST)           !Utilite
         IST(MCWORK)      =NBL
         IST(MCWORK+1)    =NBC
         IST(MCWORK+2+NBL)=1
         CALL EXPROF (MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                  ,NBC,MCUENV,LGU)                !Sdexplo
*
*        Pointeurs Nume-L pour la partie triangulaire inferieure
*        CALL PRL2NL (NBL,IST(MCLENV),IST(MCWORK+2)
*    &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
*        Pointeurs Nume-L pour la diagonale (a partir de la ligne 2)
*        CALL D2NL   (NBL,IST(MCWORK+2)
*    &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
*        Pointeurs Nume-L pour la partie triangulaire superieure
*        CALL PRU2NL (NBL,NBC,IST(MCUENV),IST(MCWORK+2)
*    &               ,IST(MCWORK+3+NBL),IST(MCWORK+3+NBL+LGMATL))       !Morse
      call baise (' Profil a revoir')
      ENDIF
      CALL TBSAVE (NMSTOK,NVSTOK)
*
*--   Transformation de la matrice
*
      IF (NMSTOK(1:4).EQ.'&BMO'.OR.NMSTOK(1:4).EQ.'&PRO') THEN
*
         IF (ITYSYM.EQ.ITYSNO) THEN
*           Cas d'une matrice non symetrique : 
*           on la rearrange provisoirement avec copie de la diagonale
            CALL TBCREE ('$WORK$',0,ITYMAT,LGD,'c')
            CALL TBAR2  (ERCODE,NMMATR,NVMATR,MCMATR
     &                         ,'$WORK$',0,MCWOR0)
*           Copie de la diagonale
            CALL TDANST (LGD,TYMATR,MCMATR,IST,RST,CST
     &                      ,TYMATR,MCWOR0,IST,RST,CST)                 !Utilite
*           Copie de la partie triangulaire inferieure en tete de matrice
            CALL TDANST (LGL,TYMATR,MCMATR+LGD,IST,RST,CST
     &                      ,TYMATR,MCMATR    ,IST,RST,CST)             !Utilite
*           Copie de la diagonale au milieu
            CALL TDANST (LGD,TYMATR,MCWOR0,IST,RST,CST
     &                      ,TYMATR,MCMATR+LGL,IST,RST,CST)             !Utilite
*           La partie triangulaire superieure est inchangee
            NMWOR0=NMMATR
            NVWOR0=NVMATR
         ELSE
*           Cas d'une matrice (anti)symetrique, auto- ou anti-adjointe
*           on rearrange la matrice dans un tableau de travail
            CALL TBCREE ('$WORK$',0,ITYMAT,LGMATL,'c')
            CALL TBAR2  (ERCODE,NMMATR,NVMATR,MCMATR
     &                         ,'$WORK$',0,MCWOR0)
*           Copie de la partie triangulaire inferieure en tete de matrice
            CALL TDANST (LGL,TYMATR,MCMATR+LGD,IST,RST,CST
     &                      ,TYMATR,MCWOR0    ,IST,RST,CST)             !Utilite
*           Copie de la diagonale au milieu
            CALL TDANST (LGD,TYMATR,MCMATR    ,IST,RST,CST
     &                      ,TYMATR,MCWOR0+LGL,IST,RST,CST)             !Utilite
*           Copie de la partie triangulaire superieure en fin de matrice
            IF (ITYSYM.EQ.INDSYM ('SYMETRIQUE')) THEN                   !Utilite
               CALL TDANST (LGL,TYMATR,MCWOR0        ,IST,RST,CST
     &                         ,TYMATR,MCWOR0+LGL+LGD,IST,RST,CST)      !Utilite
            ELSEIF (ITYSYM.EQ.INDSYM ('ANTISYMETRIQUE')) THEN           !Utilite
               CALL TMDANT (LGL,TYMATR,MCWOR0        ,RST,CST
     &                         ,TYMATR,MCWOR0+LGL+LGD,RST,CST)          !Utilite
            ELSEIF (ITYSYM.EQ.INDSYM ('AUTOADJOINT')) THEN              !Utilite
               CALL TCDANT (LGL,TYMATR,MCWOR0        ,RST,CST
     &                         ,TYMATR,MCWOR0+LGL+LGD,RST,CST)          !Utilite
            ELSEIF (ITYSYM.EQ.INDSYM ('ANTIADJOINT')) THEN              !Utilite
               CALL TCDANT (LGL,TYMATR,MCWOR0        ,RST,CST
     &                         ,TYMATR,MCWOR0+LGL+LGD,RST,CST)          !Utilite
               CALL TMDANT (LGL,TYMATR,MCWOR0+LGL+LGD,RST,CST
     &                         ,TYMATR,MCWOR0+LGL+LGD,RST,CST)          !Utilite
            ENDIF
            CALL TBSAVE (NMMATR,NVMATR)                                 !Utilite
            NMWOR0='$WORK$'
            NVWOR0=0
         ENDIF
      ENDIF
*
*--   Re-arrangement de la structure Nume-L et la matrice
*
      CALL TBCREE ('&NUMEL',NVSTOK,1,2+NBL+1+LGMATL,'c')
      CALL TBAR4  (ERCODE,NMMATL,NVMATL,MCMATL,'&NUMEL',NVSTOK,MCNUML
     &                        ,'$WORK$',1,MCWORK,NMWOR0,NVWOR0,MCWOR0)
      CALL TDANST (NBL+3,'E',MCWORK,IST,RST,CST
     &                  ,'E',MCNUML,IST,RST,CST)                        !Utilite
      CALL EXNUML (MCNUML,IST(MCNUML),NBL,NBC,MCADPR,MCNUCO,LGNUML)     !Sdexplo
      IF (LGMATL.NE.LGNUML) GOTO 99991
*
      CALL NLNO2O (NBL,NBC,TYMATR,IST(MCADPR),IST(MCWORK+3+NBL)
     &            ,IST(MCWORK+3+NBL+LGMATL),MCWOR0
     &            ,IST(MCNUCO),MCMATL,RST,CST)                          !Morse
*
      CALL TBTUER ('$WORK$',1)
*
*--   Retour a la matrice originale lorsqu'elle a ete rearrangee
*
      IF (NMSTOK(1:4).EQ.'&BMO'.OR.NMSTOK(1:4).EQ.'&PRO') THEN
         IF (ITYSYM.EQ.ITYSNO) THEN
*           Cas d'une matrice non symetrique : 
            CALL TBAR2  (ERCODE,NMMATR,NVMATR,MCMATR
     &                         ,'$WORK$',0,MCWOR0)
*           Recopie de la partie triangulaire inferieure
            CALL TSNADT (LGL,TYMATR,MCMATR    ,IST,RST,CST
     &                      ,TYMATR,MCMATR+LGD,IST,RST,CST)             !Utilite
*           Recopie de la diagonale
            CALL TDANST (LGD,TYMATR,MCWOR0,IST,RST,CST
     &                      ,TYMATR,MCMATR,IST,RST,CST)                 !Utilite
            CALL TBSAVE (NMMATR,NVMATR)                                 !Utilite
         ENDIF
      ENDIF
*
      CALL TBTUER ('$WORK$',0)
*
************************************************
*     Test : Difference entre les deux matrices
************************************************
      CALL TBRR2  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK)
      CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK
     &                   ,NMMATL,NVMATL,MCMATL,'&NUMEL',NVSTOK,MCNUML)
      CALL EXNUML (MCNUML,IST(MCNUML),NBL,NBC,MCADPR,MCNUCO,LGNUML)
      CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGL
     &                               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGU)
      MCL=MCMATR+LGD
      MCU=MCL
      IF (ITYSYM.EQ.ITYSNO) MCU=MCL+LGL
      NBERRE=0
      CALL DFBMNL (TYMATR,LGD,MCMATR
     &            ,NBL,MCL,IST(MCPLAL),IST(MCPLIL)
     &            ,NBC,MCU,IST(MCPLAU),IST(MCPLIU)
     &            ,MCMATL,IST(MCADPR),IST(MCNUCO),RST,CST,NBERRE)
      CALL TBSAVE (NMMATR,NVMATR)
      CALL TBSAVE (NMSTOK,NVSTOK)
      IF (NBERRE.GT.0) THEN
         ERCODE=NMMATR
         WRITE (*,*) '> Mat2Nl> Difference detectee entre les structures
     & BiMorse et NumeL' 
         WRITE (*,*) '         de la matrice (',ERCODE(:NCHTRM),'/'
     &        ,NVMATR,')'
      ENDIF
************************************************
      CALL TBSAVE ('&NUMEL',NVSTOK)
      CALL TBSAVE (NMMATL,NVMATL)
*
      CALL PRFXMJ (-1,'*Mat2Nl*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99996 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      CALL BAISE  ('Type de stockage non prevu : '
     &//STOIND (INDSTK)//' pour le terme '//ERCODE(1:NCATR1))
99991 WRITE (*,*) 'Lgmatl',LGMATL,'Lgnuml',LGNUML
      CALL PRNTRM (NMMATL,NVMATL,ERCODE,NCATR1)
      CALL BAISE  ('Bug algorithmique dans la construction du terme '
     &//ERCODE(1:NCATR1)//'. On ne retrouve pas tous les coeff.')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (30 juin 2010)
* - supression du PRTERM en sortie
* Version 1 : D.Martin (30 juin 1997)
                                                                    END !Mat2Nl
