*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MAXNBL (INTERP,NBBBLK,NU1BLK,BLOKEL
     &                  ,LAGHER,NBSOMX,NBAREX,NBFACX
     &                  ,NBNEEX,NBDLEX,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin (Octobre 1995)  
* Derniere modification : D.Martin (9 Fevrier 2000)
* Version # 1.0.0
*  
* Calcul des nombres maximum de sommets, d'aretes, de faces
* de noeuds et d.l. dans un element,
* de noeuds et d.l. sur une face
* de noeuds et d.l. sur une arete pour une interpolation donnee
*  
*-- Arguments d'entree -- 
* INTERP numero de type de l'interpolation
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du premier bloc  
* BLOKEL description des elements du maillage par bloc
*-- Arguments de sortie --
* LAGHER indicateur d'elements d'Hermite  
* NBSOMX nombre maximum de sommets des elements
* NBAREX nombre maximum d'aretes des elements
* NBFACX nombre maximum de faces des elements
* NBNEEX nombre maximum de noeuds dans les elements de l'interpolation
* NBDLEX nombre maximum de d.l. dans les elements pour l'interpolation 
* NBNEAX idem pour les noeuds sur une arete (2D ou 3D) 
* NBDLAX idem pour les d.l. sur une arete (2D ou 3D) 
* NBNEFX idem pour les noeuds sur une face (3D) (=NBNEAX en 2D) 
* NBDLFX idem pour les d.l. sur une face (3D) (=NBDLAX en 2D)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       INTERP,NBBBLK,NU1BLK,BLOKEL(*),NBSOMX,NBFACX,NBAREX
     &             ,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NBNEAX,NBDLAX
*
      INTEGER       LGEBLK,PTRBLK,NUBBLK,NUTYPE,LAGHER,KCLASS
     &             ,NBSOMT,NBARET,NBFACE,NBNEEL,NBDLEL,NBNEFA,NBDLFA
     &             ,NBNEAR,NBDLAR
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MaxNbl*')
*
*     Initialisation des parametres correspondant au 1er bloc d'elements
*
      NUTYPE = INTERP+100*(NU1BLK/100)
      CALL ELEMNB (NUTYPE,LAGHER,KCLASS,NBSOMX,NBAREX,NBFACX
     &            ,NBNEEX,NBDLEX,NBNEAX,NBDLAX,NBNEFX,NBDLFX)           !ef3d
*
      IF(NBBBLK.GT.1) THEN  
*  
         LGEBLK = BLOKEL(1) 
         PTRBLK = LGEBLK+2+BLOKEL(3)
         DO 1 NUBBLK = 2,BLOKEL(2)  
            NUTYPE = INTERP+100*(BLOKEL(PTRBLK)/100)
            CALL ELEMNB (NUTYPE,LAGHER,KCLASS,NBSOMT,NBARET,NBFACE
     &                  ,NBNEEL,NBDLEL,NBNEAR,NBDLAR,NBNEFA,NBDLFA)     !ef3d
            NBSOMX = MAX (NBSOMT,NBSOMX)
            NBAREX = MAX (NBARET,NBAREX)
            NBFACX = MAX (NBFACE,NBFACX)
            NBNEEX = MAX (NBNEEL,NBNEEX)
            NBDLEX = MAX (NBDLEL,NBDLEX)  
            NBNEFX = MAX (NBNEFA,NBNEFX) 
            NBDLFX = MAX (NBDLFA,NBDLFX)
            NBNEAX = MAX (NBNEAR,NBNEAX) 
            NBDLAX = MAX (NBDLAR,NBDLAX)
            PTRBLK = PTRBLK+BLOKEL(3)
1        CONTINUE
      ENDIF
      CALL PRFXMJ (-1,'*MaxNbl*')  
                                                                    END !MaxNbl
