*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKDOMK (NUDOMG,INTRPG,LISTEL,NDIM  ,BLOKEL,ITERDO
     &                  ,NDEBDO,NUDLFA,NUDOMK,INDMIX,IGEOME,NUSCHQ
     &                  ,INTRPC,INTRPL,NCPINC,NCPINL,ITYCAL,NUINTG
     &                  ,NIVDOM,NIVDIR,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Avril 1989)  
* Derniere modification : D.Martin (25 Mars 2002)
* Version 1.0.1
*  
* Mise a jour des attributs d'un domaine de calcul 
*  
*-- Arguments d'entree -- 
* NUDOMG numero du domaine geometrique
* INTRPG numero de l'interpolation geometrique 
* LISTEL tableau descriptif du domaine geometrique (#ISTEL,NUDOMG)
* NDIM   dimension d'espace
* BLOKEL tableau des blocs d'elements consecutifs de meme type
* ITERDO tableau de description des termes et des domaines de calculs 
* NDEBDO adresse relative du domaine dans #TERDO  
* NUDLFA numerotation elememtaire des d.l. dans la face de l'element  
* NUDOMK numero du domaine de calcul  
* INDMIX indice de mixite des interpolations en colonne et ligne  
* IGEOME indicateur de calcul geometriques sur le domaine 
* NUSCHQ numero de schema de quadrature
* INTRPC numero de l'interpolation en colonne 
* INTRPL numero de l'interpolation en ligne
* NCPINC nombre de composantes de l'inconnue en colonne pour le terme en cours
* NCPINL idem en ligne
* ITYCAL indice de type de calcul (ELFINI,ELFLOC,VALNOD,C.ESSE,...)
* NUINTG numero de type de calcul (numero d'integrand,...)
* NIVDOM niveau d'impression pour le domaine  
* NIVDIR indice d'impression des directives
* IMPFCH unite logique d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NUDOMG,INTRPG,LISTEL(*),NDIM,BLOKEL(*),ITERDO(*)
     &       ,NDEBDO,NUDLFA(*),NUDOMK,INDMIX,IGEOME,NUSCHQ
     &       ,INTRPC,INTRPL,NCPINC,NCPINL,ITYCAL,NUINTG,NIVDOM
     &       ,NIVDIR,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER INTYKL
      INTEGER LGERDO,NBDOMK,LGCANO,NCHDOM,ICOORN,JCOORN,IRPLOC,JRPLOC
     &       ,KRPLOC,JUDOMG,JUDOMK,KGEOME,JGEOME,JNDMIX,JUSCHQ,JNDEXC
     &       ,JDLHRC,JNTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC
     &       ,JNDEXL,JDLHRL,JNTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY,NBDLFY
     &       ,NVNUML,NVCORC,INUTIL,NBTRDO,JIVDOM
     &       ,INDEXC,INDEXL,KC,KL,NXLIST,NDMDOM,NDMDOE,NBELDO,IB,INSYME
     &       ,NUTYAV,NUFAAV
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mkdomk*')
*
      NDFNUM=-999999999
      NDFSTO=-99999
      NDFCOR=-77777
      CALL SDEXDB (ITERDO,LGERDO,NBDOMK,LGCANO,NCHDOM)                  !utilite
      ICOORN=IGEOME/10 
      IRPLOC=MOD (IGEOME,10)
      CALL GETDOM (ITERDO(NDEBDO),JUDOMG,JUDOMK,KGEOME,JNDMIX,JUSCHQ
     &            ,JNDEXC,JDLHRC,JNTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &            ,NBDLFX,NVNUMC,JNDEXL,JDLHRL,JNTRPL,NBNELX,NBNEEY
     &            ,NBDLEY,NBNEFY,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO
     &            ,JIVDOM)                                              !sdexplo
      JGEOME=ABS (KGEOME)
      IF (JIVDOM.GT.0) NIVDOM=MAX (NIVDOM,JIVDOM)
      JCOORN=JGEOME/10 
      JRPLOC=MOD(JGEOME,10)
*     IF (NCPINC.GT.1.OR.NCPINL.GT.1) IRPLOC=MAX (1,IRPLOC)
      KRPLOC=MAX (IRPLOC,JRPLOC)
      IGEOME=KRPLOC+10*MAX (ICOORN,JCOORN)  
      IF (JGEOME.EQ.IGEOME) IGEOME=KGEOME
      IB=0 
      INDEXC=0 
      INDEXL=0 
      KC=0 
      KL=0 
      CALL EXLIST (LISTEL,NXLIST,NDMDOM,NDMDOE,NBELDO,IB,IB,IB,IB)      !sdexplo
*
      IMP=0
      IF (NIVDIR.GT.5) IMP=NIVDIR
      IF (IMPFCH.GT.0.AND.IMP.GE.1) WRITE (IMPFCH,10000) PRFXAS(1)
     &                            ,PRFXAS(0),NUDOMG,NUDOMK,NDMDOM,NBELDO
*
      IF (NDIM.GT.NDMDOM) THEN
         IF (ITYCAL.EQ.INTYKL ('ELFINI')
     &   .OR.ITYCAL.EQ.INTYKL ('MATELM')) THEN
            CALL INTATR (NUINTG,KC,INDEXC,KL,INDEXL,INSYME)             !integra
         ELSEIF (ITYCAL.EQ.INTYKL ('INTERP')) THEN
            CALL ITRATR (NUINTG,NDIM,KC,INDEXC,KL,INDEXL)               !integra
         ENDIF 
      ENDIF
      NUTYAV=0 
      NUFAAV=0 
*
      IDLHRL=0 
      IDLHRC=0 
      KBNELX=0
      NBNELX=0
      KBNECX=0 
      NBNECX=0 
      NBNEEX=0 
      NBDLEX=0 
      NBNEFX=0 
      NBDLFX=0
      NVNUMC=NDFNUM
      NBNEEY=0 
      NBDLEY=0 
      NBNEFY=0 
      NBDLFY=0 
      NVNUML=NVNUMC
      NVCORC=NDFCOR
      DO 1 IEL=1,NBELDO
         CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,LISTEL,BLOKEL,NUTGEO,INTRPC
     &               ,NUEL,NUTYAV,NUTELT,LAG,KCL,NBNELL,NBDLEL,NUF
     &               ,NUFAAV,NUTYFA,NBNEFL,NBDLFL,NUDLFA,NUDLFA
     &               ,IMP,IMPFCH)                                       !sdexplo
         IDLHRC=MAX (IDLHRC,LAG)
         IF (KCL.EQ.KC) INDEXC=0
         KBNECX=MAX (KBNECX,NBNEFL)
         NBNECX=MAX (NBNECX,KBNECX)
         IF (INDEXC.NE.0) NBNECX=MAX (NBNECX,NBNELL) 
*        Calcul des max. de noeuds et de d.l.
         NBNEEX=MAX (NBNEEX,NBNELL)
         NBDLEX=MAX (NBDLEX,NBDLEL)
         NBNEFX=MAX (NBNEFX,NBNEFL)
         NBDLFX=MAX (NBDLFX,NBDLFL)
         IF (INTRPL.NE.INTRPC) THEN
            NUTYAV=NUTELT
            CALL EXSTEW (NDMDOM,INTRPL,NUTGEO,NUEL,NUTYAV,NUTELT
     &                  ,LAG,KCL,NBNELL,NBDLEL,NUF,NUFAAV,NUTYFA
     &                  ,NBNEFL,NBDLFL,NUDLFA,NUDLFA,IMP,IMPFCH)        !sdexplo
            IDLHRL=MAX (IDLHRL,LAG)
            IF (KCL.EQ.KL) INDEXL=0
*           Calcul des max. de noeuds et de d.l.
            NBNEEY=MAX (NBNEEY,NBNELL)
            NBDLEY=MAX (NBDLEY,NBDLEL)
            NBNEFY=MAX (NBNEFY,NBNEFL)
            NBDLFY=MAX (NBDLFY,NBDLFL)
         ENDIF
         KBNELX=MAX (KBNELX,NBNEFL)
         NBNELX=KBNELX
         IF (INDEXL.NE.0) NBNELX=MAX (NBNELX,NBNELL)
         NUFAAV=NUF
         NUTYAV=NUTELT
1     CONTINUE
      IF (INTRPL.EQ.INTRPC) THEN
         IDLHRL=IDLHRC 
         NBNEEY=NBNEEX 
         NBDLEY=NBDLEX 
         NBNEFY=NBNEFX 
         NBDLFY=NBDLFX 
      ENDIF
*
      IF (IGEOME.GE.1.AND.(INDEXC.EQ.1.OR.INDEXL.EQ.1)) THEN
*
*        On cree un premier domaine sans terme avec les calculs geometriques
*
         CALL PUTDOM (ITERDO(NDEBDO) ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &               ,0     ,IDLHRC,INTRPC,KBNECX,NBNEEX,NBDLEX,NBNEFX
     &               ,NBDLFX,NVNUMC,0     ,IDLHRL,INTRPL,KBNELX,NBNEEY
     &               ,NBDLEY,NBNEFY,NBDLFY,NVNUML,NVCORC,INUTIL,0
     &               ,NIVDOM)                                           !sdexplo
         NUDOMK=NUDOMK+1
         IGEOME=0  
         NDEBDO=NDEBDO+LGCANO
      ENDIF
      CALL PUTDOM (ITERDO(NDEBDO),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ 
     &            ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &            ,NBDLFX,NVNUMC,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY
     &            ,NBDLEY,NBNEFY,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO
     &            ,NIVDOM)                                              !sdexplo
      CALL PRFXMJ (-1,'*Mkdomk*')
      RETURN
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10000 FORMAT(/T2,A8,'>',A8,' Domaine geometrique No',I4
     &,', de calcul No',I4,', dimension ',I1,', nb. constituants ',I6)
                                                                    END !Mkdomk
