*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKGRCO(NUTGEO,NDIM,ISGDET,CORPTL,NGNEEL,PASX,PASY
     * ,NBPTX,NBPTY,ORIG,RINIT,NBELBK,NBNEEL,NBDLEL,NBPTEX,NBTPTG,
     *                                                     GEOGRL)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : J-L Bellier (Janvier 1994) 
* Derniere modification (O.DeBayser) le 9 Mars 1994  
*  
*   Calcul des coordonnees de chaque element de la grille
*
*** Arguments ***  
* NUTGEO: Type commun de tous les elements la grille
* NDIM  : Dimension d'espace  des maillages pre-existants
* ISGDET: Tableau en 'equivalence' avec CORPTL pour le signe du determinant
*                 jacobien de chaque element. 
* CORPTL: Tableau des coordonnees element par element  
* NGNEEL: Tableau des coordonnees element par element
* PASX  : pas de discretisation en x 
* PASY  : id. que PASX mais sur l'axe des y
* NBPTX : nb de points de discretisation en x
* NBPTY : id. que NBPTX mais sur l'axe des y
* ORIG  : point origine de la grille
* NBNEEL: Nombre de noeuds par element
* NBDLEL: Nombre de d.l. par element
* NBPTEX: Nombre maximum de points dans un element du maillage
* NBTPTG: Max. des numeros globaux rencontre (c.a.d. le nb. total de points)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NGNEEL(*),ISGDET(*)
      REAL    CORPTL(*),ORIG(*)
      CHARACTER*(*)     GEOGRL
*  
      IACORG=2
      IANEEL=0
      CALL ELEMNB (NUTGEO,LAG,KCL,NBSOMT,NBARET,NBFACE
     *            ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)              !Ef3d
      CALL NUSPLT (NUTGEO, NDIML,IFORM,NORDRE)
*     NBDLX=NORDRE*(NBPTX-1)+1
      PASX=PASX/FLOAT(NORDRE)
      PASY=PASY/FLOAT(NORDRE)
*
*     Remarque: on se sert des numeros globaux pour situer les points
*               dans la grille et calculer leurs coordonnees.
*
      DO 9 IEL=1,NBELBK 
*
*        Coordonnees des noeuds de la grille, element par element
         IACORL=IACORG
*     Cas de la grille rectangulaire
         IF (GEOGRL(1:1).EQ.'R') THEN
         DO 10 K=1,NBNEEL
            NUGLO =NGNEEL(IANEEL+K)-NBTPTG
*           NUMLIG=(NUGLO-1)/NBDLX+1
            NUMLIG=(NUGLO-1)/NBPTX+1
*           NUMCOL=NUGLO-(NUMLIG-1)*NBDLX
            NUMCOL=NUGLO-(NUMLIG-1)*NBPTX
            CORPTL(IACORL ) =ORIG(1)+(NUMCOL-1)*PASX
            CORPTL(IACORL+1)=ORIG(2)+(NUMLIG-1)*PASY
            IF(NDIM.GE.3) CORPTL(IACORL+2)=ORIG(3)
            IACORL=IACORL+NDIM
10       CONTINUE
*     Cas de la grille circulaire
         ELSE IF (GEOGRL(1:1).EQ.'C') THEN
         DO 11 K=1,NBNEEL
            NUGLO =NGNEEL(IANEEL+K)-NBTPTG
*           NUMLIG=(NUGLO-1)/NBDLX+1
            NUMLIG=(NUGLO-1)/NBPTX+1
*           NUMCOL=NUGLO-(NUMLIG-1)*NBDLX
            NUMCOL=NUGLO-(NUMLIG-1)*NBPTX
            CORPTL(IACORL ) =ORIG(1)+(RINIT+(NUMCOL-1)*PASX)
     *                       *COS((NUMLIG-1)*PASY)
            CORPTL(IACORL+1)=ORIG(2)+(RINIT+(NUMCOL-1)*PASX)
     *                       *SIN((NUMLIG-1)*PASY)
            IF(NDIM.GE.3) CORPTL(IACORL+2)=ORIG(3)
            IACORL=IACORL+NDIM
11       CONTINUE
         ELSE 
         CALL BAISE('geometrie de grille non prevue')
         ENDIF
*
*        Orientation arbitraire positive
         JSGDET=1
         ISGDET(IACORG-1)=JSGDET
         IACORG=IACORG+NBPTEX*NDIM+1
         IANEEL=IANEEL+NBPTEX
9     CONTINUE
*  
      RETURN
                                                                    END *Mkgrco*
