*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKGRNE (TYELEM,NGNEEL,NBPTX,NBPTY,NBPTEX,NBTPTG,
     *                                                    UNTOUR)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : J.L.Bellier (Janvier 1994)
* Derniere modification (J-L Bellier) le 17 Juin 1994
*
*   Fonction: construction de la numerotation globale pour 
*   tous les elements de la grille.
*
*** Arguments d'entree ***
* TYELEM Type d'element commun a tous les elements de la grille
* NBPTX  Nombre de sommets de discretisation en x (initialement pour 
*        des quadrangles d'ordre 1)
* NBPTY  Nombre de sommets de discretisation en y (initialement pour 
*        des quadrangles d'ordre 1)
* NBPTEX Nombre maximum de points dans un element du maillage
* NBTPTG Nombre total de points du maillage independement de la grille
*** Argument de sortie ***
* NGNEEL Tableau des numeros globaux des points de tous les elements
* UNTOUR variable booleenne qui indique, dans le cas d'un domaine 
*        circulaire, si on a fait un tour complet ou non
* NBPTX  Nombre de sommets de discretisation en x (mis a jour en 
*        fonction de l'ordre des elements)
* NBPTY  Idem        "              "        en y (mis a jour en 
*        fonction de l'ordre des elements)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYELEM
      INTEGER       NGNEEL(*)
      LOGICAL       UNTOUR
*
      NORDRE=1
      
      IF (UNTOUR) THEN
         IF (TYELEM(1:4).EQ. 'QU01') THEN
* Quadrangles d'ordre 1
            IANEEL=1
            NBNEAV=NBTPTG
            DO 101 K=1,NBPTY-2
               DO 100 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+J
                  NGNEEL(IANEEL+1)=NBNEAV+J+1
                  NGNEEL(IANEEL+2)=NBNEAV+J+1+NBPTX
                  NGNEEL(IANEEL+3)=NBNEAV+J  +NBPTX
                  IANEEL=IANEEL+NBPTEX
100            CONTINUE
               NBNEAV=NBNEAV+NBPTX 
101         CONTINUE 
            DO 102 J=1,NBPTX-1          
               NGNEEL(IANEEL  )=NBNEAV+J
               NGNEEL(IANEEL+1)=NBNEAV+J+1
               NGNEEL(IANEEL+2)=NBTPTG+J+1
               NGNEEL(IANEEL+3)=NBTPTG+J
               IANEEL=IANEEL+NBPTEX
102         CONTINUE
         ELSE IF (TYELEM(1:4).EQ. 'TR01') THEN
* Triangles d'ordre 1
            IANEEL=1
             NBNEAV=NBTPTG
             DO 111 K=1,NBPTY-2
                DO 110 J=1,NBPTX-1
                   NGNEEL(IANEEL  )=NBNEAV+J
                   NGNEEL(IANEEL+1)=NBNEAV+J+1
                   NGNEEL(IANEEL+2)=NBNEAV+J  +NBPTX
                   IANEEL=IANEEL+NBPTEX
                   NGNEEL(IANEEL  )=NBNEAV+J+1+NBPTX
                   NGNEEL(IANEEL+1)=NBNEAV+J  +NBPTX
                   NGNEEL(IANEEL+2)=NBNEAV+J+1
                   IANEEL=IANEEL+NBPTEX
110             CONTINUE
                NBNEAV=NBNEAV+NBPTX
111          CONTINUE
             DO 112 J=1,NBPTX-1
                NGNEEL(IANEEL  )=NBNEAV+J
                NGNEEL(IANEEL+1)=NBNEAV+J+1
                NGNEEL(IANEEL+2)=NBTPTG+J
                IANEEL=IANEEL+NBPTEX
                NGNEEL(IANEEL  )=NBTPTG+J+1
                NGNEEL(IANEEL+1)=NBTPTG+J
                NGNEEL(IANEEL+2)=NBNEAV+J+1
                IANEEL=IANEEL+NBPTEX
112          CONTINUE
          ELSE IF (TYELEM(1:4).EQ. 'QU02') THEN 
* Quadrangles d'ordre 2
            NORDRE=2
            IANEEL=1
            NBNEAV=NBTPTG
            NBDLX=NORDRE*NBPTX-1
            DO 121 K=1,NBPTY-2
               DO 120 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+1
                  NGNEEL(IANEEL+1)=NBNEAV+3
                  NGNEEL(IANEEL+2)=NBNEAV+3+NORDRE*NBDLX
                  NGNEEL(IANEEL+3)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+4)=NBNEAV+2
                  NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
                  NGNEEL(IANEEL+6)=NBNEAV+2+NORDRE*NBDLX
                  NGNEEL(IANEEL+7)=NBNEAV+1+NBDLX
                  NGNEEL(IANEEL+8)=NBNEAV+2+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NBNEAV=NBNEAV+NORDRE
120            CONTINUE
               NBNEAV=NBNEAV+1+NBDLX 
121         CONTINUE 
            DO 122 J=1,NBPTX-1
               NGNEEL(IANEEL  )=NBNEAV+1
               NGNEEL(IANEEL+1)=NBNEAV+3
               NGNEEL(IANEEL+2)=NBTPTG+NORDRE*J+1
               NGNEEL(IANEEL+3)=NBTPTG+NORDRE*J-1
               NGNEEL(IANEEL+4)=NBNEAV+2
               NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
               NGNEEL(IANEEL+6)=NBTPTG+NORDRE*J
               NGNEEL(IANEEL+7)=NBNEAV+1+NBDLX
               NGNEEL(IANEEL+8)=NBNEAV+2+NBDLX
               IANEEL=IANEEL+NBPTEX
               NBNEAV=NBNEAV+NORDRE
122         CONTINUE
         ELSE IF (TYELEM(1:4).EQ. 'TR02') THEN 
* Triangles d'ordre 2
            NORDRE=2
            IANEEL=1
            NBNEAV=NBTPTG
            NBDLX=NORDRE*NBPTX-1
            DO 131 K=1,NBPTY-2
               DO 130 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+1
                  NGNEEL(IANEEL+1)=NBNEAV+3
                  NGNEEL(IANEEL+2)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+3)=NBNEAV+2
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+1+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NGNEEL(IANEEL  )=NBNEAV+3+NORDRE*NBDLX
                  NGNEEL(IANEEL+1)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+2)=NBNEAV+3
                  NGNEEL(IANEEL+3)=NBNEAV+2+NORDRE*NBDLX
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NBNEAV=NBNEAV+NORDRE
130            CONTINUE 
               NBNEAV=NBNEAV+1+NBDLX 
131         CONTINUE
               DO 132 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+1
                  NGNEEL(IANEEL+1)=NBNEAV+3
                  NGNEEL(IANEEL+2)=NBTPTG+NORDRE*J-1
                  NGNEEL(IANEEL+3)=NBNEAV+2
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+1+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NGNEEL(IANEEL  )=NBTPTG+NORDRE*J+1
                  NGNEEL(IANEEL+1)=NBTPTG+NORDRE*J-1
                  NGNEEL(IANEEL+2)=NBNEAV+3
                  NGNEEL(IANEEL+3)=NBTPTG+NORDRE*J
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NBNEAV=NBNEAV+NORDRE
132            CONTINUE
         ENDIF
      ELSE 
         IF (TYELEM(1:4).EQ. 'QU01') THEN
* Quadrangles d'ordre 1
            IANEEL=1
            NBNEAV=NBTPTG
            DO 11 K=1,NBPTY-1
               DO 10 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+J
                  NGNEEL(IANEEL+1)=NBNEAV+J+1
                  NGNEEL(IANEEL+2)=NBNEAV+J+1+NBPTX
                  NGNEEL(IANEEL+3)=NBNEAV+J  +NBPTX
                  IANEEL=IANEEL+NBPTEX
10             CONTINUE
               NBNEAV=NBNEAV+NBPTX 
11          CONTINUE 
         ELSE IF (TYELEM(1:4).EQ. 'TR01') THEN
* Triangles d'ordre 1
            IANEEL=1
            NBNEAV=NBTPTG
            DO 21 K=1,NBPTY-1
               DO 20 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+J
                  NGNEEL(IANEEL+1)=NBNEAV+J+1
                  NGNEEL(IANEEL+2)=NBNEAV+J  +NBPTX
                  IANEEL=IANEEL+NBPTEX
                  NGNEEL(IANEEL  )=NBNEAV+J+1+NBPTX
                  NGNEEL(IANEEL+1)=NBNEAV+J  +NBPTX
                  NGNEEL(IANEEL+2)=NBNEAV+J+1
                  IANEEL=IANEEL+NBPTEX
20             CONTINUE
               NBNEAV=NBNEAV+NBPTX
21          CONTINUE
         ELSE IF (TYELEM(1:4).EQ. 'QU02') THEN 
* Quadrangles d'ordre 2
            NORDRE=2
            IANEEL=1
            NBNEAV=NBTPTG
            NBDLX=NORDRE*NBPTX-1
            DO 31 K=1,NBPTY-1
               DO 30 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+1
                  NGNEEL(IANEEL+1)=NBNEAV+3
                  NGNEEL(IANEEL+2)=NBNEAV+3+NORDRE*NBDLX
                  NGNEEL(IANEEL+3)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+4)=NBNEAV+2
                  NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
                  NGNEEL(IANEEL+6)=NBNEAV+2+NORDRE*NBDLX
                  NGNEEL(IANEEL+7)=NBNEAV+1+NBDLX
                  NGNEEL(IANEEL+8)=NBNEAV+2+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NBNEAV=NBNEAV+NORDRE
30             CONTINUE
               NBNEAV=NBNEAV+1+NBDLX 
31          CONTINUE 
         ELSE IF (TYELEM(1:4).EQ. 'TR02') THEN 
* Triangles d'ordre 2
            NORDRE=2
            IANEEL=1
            NBNEAV=NBTPTG
            NBDLX=NORDRE*NBPTX-1
            DO 41 K=1,NBPTY-1
               DO 40 J=1,NBPTX-1
                  NGNEEL(IANEEL  )=NBNEAV+1
                  NGNEEL(IANEEL+1)=NBNEAV+3
                  NGNEEL(IANEEL+2)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+3)=NBNEAV+2
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+1+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NGNEEL(IANEEL  )=NBNEAV+3+NORDRE*NBDLX
                  NGNEEL(IANEEL+1)=NBNEAV+1+NORDRE*NBDLX
                  NGNEEL(IANEEL+2)=NBNEAV+3
                  NGNEEL(IANEEL+3)=NBNEAV+2+NORDRE*NBDLX
                  NGNEEL(IANEEL+4)=NBNEAV+2+NBDLX
                  NGNEEL(IANEEL+5)=NBNEAV+3+NBDLX
                  IANEEL=IANEEL+NBPTEX
                  NBNEAV=NBNEAV+NORDRE
40             CONTINUE 
               NBNEAV=NBNEAV+1+NBDLX 
41          CONTINUE
         ENDIF
      ENDIF
* 
* On sort avec le veritable nombre de sommets 
*   
      NBPTX=NORDRE*(NBPTX-1)+1
      NBPTY=NORDRE*(NBPTY-1)+1
      RETURN
                                                                     END*Mkgrne* 
