*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKSDDS (NVDSMI,LIOUCO,NUTERM
     &                  ,NUINCC,NUINCL,NVNUMC,NVNUML,NVCOOR,NVDSMO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1997)
* Derniere modification : D.Martin (4 Decembre 1998)
* Version # 1.0.0
*  
* Copie de la structure $DSMBL en ligne/colonne d'une matrice multi-inconnue
*   ou 
* Creation d'une structure multi-inconnue $DSMBL pour un terme uni-inconnue.
*  
*-- Arguments d'entree -- 
* NVDSMI niveau de la structure d'assemblage '$DSMBL' d'entree
* LIOUCO copie de la structure pour un vecteur ligne ou colonne
* NUTERM numero du terme uni-inconnue
* NUINCC numero de l'inconnue en colonne pour le terme uni-inconnue
* NUICNL numero de l'inconnue en ligne pour le          "
* NVNUMC niveau du tableau de numerotation en colonne   "
* NVNUML niveau du tableau de numerotation en ligne     "
* NVDSMO niveau de la structure d'assemblage '$DSMBL' de sortie
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER LIOUCO*(*)
      INTEGER NVDSMI,NUTERM,NUINCC,NUINCL,NVNUMC,NVNUML,NVCOOR,NVDSMO
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER LGEDSM,NBBLOC,INCDSM,NBBLOL,LGEDSB,INCDSB,LGDSMB,MCDSMB
     &       ,MCDSMM,MCDSMC,BLOC,BLOL,NUINCO
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MksdDs*')
* 
      IF (NVDSMI.NE.NDFDSM) THEN
         IF (LIOUCO(1:1).EQ.'L') THEN
*
*           Creation de la nouvelle structure avec les blocs de colonne
*           de l'ancienne en n'en conservant que les informations en ligne
*           ( Cas du resultat d'un produit matrice x vecteur, par exemple)
*
            CALL TBAR1  (ERCODE,'$DSMBL',NVDSMI,MCDSMM)
            CALL SDEXDB (IST(MCDSMM),LGEDSM,NBBLOC,INCDSM,NBBLOL)       !sdexplo
            LGEDSB=LGEDSM
            INCDSB=INCDSM
            LGDSMB=LGEDSB+NBBLOL*INCDSB
            CALL TBCREE ('$DSMBL',NVDSMO,1,LGDSMB,'c')
            CALL TBAR2  (ERCODE,'$DSMBL',NVDSMI,MCDSMM
     &                         ,'$DSMBL',NVDSMO,MCDSMB)
            CALL SDMKDB (IST(MCDSMB),LGEDSB,1,INCDSB,NBBLOL)            !sdexplo
            MCDSMM=MCDSMM+LGEDSM
            MCDSMB=MCDSMB+LGEDSB
            DO 11 BLOL=1,NBBLOL
               MCDSMC=MCDSMM
               NUINCO=IST(MCDSMC+2)
               DO 10 BLOC=1,NBBLOC
                  IF (NUINCO.NE.NDFINC) THEN
                     IST(MCDSMB)  =-1
                     IST(MCDSMB+1)=NDFINC
                     IST(MCDSMB+2)=NUINCO
                     IST(MCDSMB+3)=NDFNUM
                     IST(MCDSMB+4)=IST(MCDSMC+4)
                     IST(MCDSMB+5)=IST(MCDSMC+5)
                  ELSE
                     NUINCO=IST(MCDSMC+NBBLOL*INCDSM+2)
                  ENDIF
                  MCDSMC=MCDSMC+NBBLOL*INCDSM
10             CONTINUE
               MCDSMM=MCDSMM+INCDSM
               MCDSMB=MCDSMB+INCDSB
11          CONTINUE
         ELSEIF (LIOUCO(1:1).EQ.'C') THEN
*
*           Creation de la nouvelle structure avec les bloc de lignes
*           de l'ancienne en n'en conservant que les informations en colonne
*           ( Cas de la solution d'un systeme lineaire, par exemple )
*
            CALL TBAR1  (ERCODE,'$DSMBL',NVDSMI,MCDSMM)
            CALL SDEXDB (IST(MCDSMM),LGEDSM,NBBLOC,INCDSM,NBBLOL)       !sdexplo
            LGEDSB=LGEDSM
            INCDSB=INCDSM
            LGDSMB=LGEDSB+NBBLOC*INCDSB
            CALL TBCREE ('$DSMBL',NVDSMO,1,LGDSMB,'c')
            CALL TBAR2  (ERCODE,'$DSMBL',NVDSMI,MCDSMM
     &                         ,'$DSMBL',NVDSMO,MCDSMB)
*            CALL SDMKDB (IST(MCDSMB),LGEDSB,NBBLOC,INCDSB,1)            !sdexplo
            CALL SDMKDB (IST(MCDSMB),LGEDSB,1,INCDSB,NBBLOC)            !sdexplo
            MCDSMM=MCDSMM+LGEDSM
            MCDSMB=MCDSMB+LGEDSB
            DO 21 BLOC=1,NBBLOC
               NUINCO=IST(MCDSMM+1)
               DO 20 BLOL=1,NBBLOL
                  IF (NUINCO.NE.NDFINC) THEN
                     IST(MCDSMB)  =-1
                     IST(MCDSMB+1)=NDFINC
                     IST(MCDSMB+2)=NUINCO
                     IST(MCDSMB+3)=NDFNUM
                     IST(MCDSMB+4)=IST(MCDSMM+3)
                     IST(MCDSMB+5)=IST(MCDSMM+5)
                  ELSE
                     NUINCO=IST(MCDSMM+INCDSM+1)
                  ENDIF
                  MCDSMM=MCDSMM+INCDSM
20             CONTINUE
               MCDSMB=MCDSMB+INCDSB
21          CONTINUE
         ENDIF
*
      ELSE
*
*        Creation de la nouvelle structure '$DSMBL' a partir des informations
*        concernant le terme uni-inconnue
*
         LGEDSB=4
         INCDSB=6
         LGDSMB=LGEDSB+INCDSB
         CALL TBCREE ('$DSMBL',NVDSMO,1,LGDSMB,'c')
         CALL TBAR1  (ERCODE,'$DSMBL',NVDSMO,MCDSMB)
         CALL SDMKDB (IST(MCDSMB),LGEDSB,1,INCDSB,1)                    !sdexplo
         MCDSMB=MCDSMB+LGEDSB
         IST(MCDSMB  )=NUTERM
         IST(MCDSMB+1)=NUINCC
         IST(MCDSMB+2)=NUINCL
         IST(MCDSMB+3)=NVNUMC
         IST(MCDSMB+4)=NVNUML
         IST(MCDSMB+5)=NVCOOR
      ENDIF
      CALL PRFXMJ (-1,'*MksdDs*')  
                                                                    END !MksdDs
