*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKSDGN (NMGDNS,NVGDNS,NMGDND,NVGDND,CHAINE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 1995)
* Derniere modification : D.Martin (13 Septembre 1997)
*
* Creation et mise a jour d'une structure $GDNOY pour le calcul des produits
* Gdelta*Noyau
*
*-- Arguments --
* NMGDNS nom du terme Gdelta*Noyau pour le noyau de Simple couche
* NVGDNS son niveau
* NMGDND nom du terme Gdelta*Noyau pour le noyau de Double couche
* NVGDND son niveau
* CHAINE chaine de caracteres pour decrire les attributs de calcul des termes
*        <Gdelta*Noyau>. La chaine est structuree sous la forme d'articles de
*        la forme <ITEM=ITEMVA> separes par des virgules ou ITEM vaut l'une 
*        des chaines :
*   Domaine_Sigma
*   Domaine_Gamma
*   Inconnue_Ligne_Gdelta ou Inconnue_Ligne_Sigma
*   Inconnue_Colonne_Gdelta ou Inconnue_Colonne_Sigma ou Inconnue_Ligne_Noyau
*   Inconnue_Ligne_Pdelta ou Inconnue_Ligne_Gamma ou Inconnue_Colonne_Noyau
*   Inconnue_Colonne_Pdelta
*   Nom_Gdelta
*   Niveau_Gdelta      (par defaut =1 si Nom_Gdelta est donnee)
*   Type_Gdelta        (par defaut REEL)
*   Nom_Pdelta
*   Niveau_Pdelta      (par defaut =1 si Nom_Pdelta est donnee)
*   Type_Pdelta        (par defaut REEL)
*   Donnee_Lambda
*   Niveau_Noyau_Simple
*   Niveau_Noyau_Double
*   Type_Green         (par defaut REEL)
*   Donnee1, Donnee2, Donnee3 ...
*
*-- Remarque -- Structure $GDNOY
* 1  numero du domaine Sigma de couplage
* 2  numero du domaine Gamma de representation integrale
* 3  numero de l'inconnue en ligne de Gdelta et du resultat
* 4  numero de l'inconnue en colonne de Gdelta et en ligne de la matrice noyau
* 5  numero de l'inconnue en colonne de la matrice noyau (en ligne de Pdelta)
* 6  numero de l'inconnue en colonne de la matrice Pdelta
* 7  numero de terme de la matrice Gdelta
* 8  numero de type (REEL ou COMPLEXE) de la matrice Gdelta
* 9  numero de terme de la matrice Pdelta
* 10  numero de type (REEL ou COMPLEXE) de la matrice Pdelta
* 11 numero de donnee de la constante Lambda 
* 12 numero de type (REEL ou COMPLEXE) de la fonction de Green
* 13 niveau de la matrice Noyau de simple couche de nom 'Noyo_S'
* 14 niveau de la matrice Noyau de simple couche de nom 'Noyo_D'
* 15 nombre de donnees necessaires pour les calculs de Green
* 15+i numero de la i-eme donnee associee
*>> Les articles 'Inconnue1', 'Inconnue2', 'Type_Gdelta' sont inutiles 
*   si la matrice Gdelta existe en tant que terme et est donnee ici
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMGDNS,NMGDND,CHAINE
      INTEGER       NVGDNS,NVGDND
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     ERCODE*120
      CHARACTER*16  NMITEM,NMDELT,TYDELT
      INTEGER       ADDONA,INTTYP,KELCHN,KLNIVE,KLTERM
      INTEGER       LGCHAI,NBLEFT,ARTICH,ARTIDB,ARDEB,IDBNU,IFNNU
     &             ,NUDKSI,NUDKGA,INCOGL,INCOGC,INCOPL,INCOPC
     &             ,NUGDEL,ITGDEL,NUPDEL,ITPDEL,NULAMB
     &             ,NBDOAS,NWDOAS,NBDOAW,NVGDEL,NVPDEL
     &             ,LGMTRM,MCMTRM,LGDTRM,MCDTRM
     &             ,NUGDNS,IAGDNS,NUGDND,IAGDND,ADTERM
      PARAMETER    (ADDONA=15)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MksdGN*')
*
*     Nombre maximum de donnees = plus grand numero de donnee dans CHAINE
*
      NWDOAS = 0
      NBDOAW = 0
      LGCHAI = LEN(CHAINE)
      ARDEB=1
10    CALL DCOCHN (CHAINE(ARDEB:LGCHAI),LGCHAI,'Donnee'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      IF(ITEMCH.GT.0) THEN
         ARDEB=ARDEB+ARTIDB
         IDBNU  = ARDEB+5
         IF (CHAINE(IDBNU:IDBNU).NE.'_') THEN
            IFNNU  = IDBNU+INDEX(CHAINE(IDBNU:LGCHAI),'=')-2            !Utilite
            NUDOAS = 1
            IF (IFNNU.GE.IDBNU) CALL RELCNE (CHAINE(IDBNU:IFNNU),NUDOAS)!Utilite
            NWDOAS = MAX (NWDOAS,NUDOAS)
            NBDOAW = NBDOAW + 1
         ENDIF
         IF (ARDEB.LT.LGCHAI) GOTO 10
      ENDIF
      NMDELT = ' '
      NVGDEL = 0
      NVPDEL = 0
      ITREEL = INTTYP ('REEL')                                          !Utilite
*
      INCOGL = NDFINC
      INCOGC = NDFINC
      INCOPL = NDFINC
      INCOPC = NDFINC
      NUGDEL = -1
      ITGDEL = ITREEL
      NUPDEL = -1
      ITPDEL = ITREEL
      NBDOAS = 0
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !SDexplo
*
      IF (NMGDNS.NE.' ') THEN
         NUGDNS=KLTERM (NMGDNS,NVGDNS,AST(MCMTRM),IST(MCDTRM))          !SDexplo
         IF (NUGDNS.LE.0) THEN
*  
*           Le terme Gdelta*Noyau de simple couche n'existe pas: on l'ajoute  
*           apres agrandissement eventuel des structures #OMTRM et $SDTRM 
            CALL ALFANU (NBCHNT,NMGDNS)                                 !Utilite
            NWHTRM=MAX (NCHTRM,LEN (NMGDNS))
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,2)           !SDexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,2)      !SDexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM) 
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMGDNS)              !Utilite
            NUGDNS             = NBTERM
            IAGDNS             = LGETRM+INCTRM*(NUGDNS-1)
            IST(MCDTRM+IAGDNS) = NVGDNS
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !SDexplo
            NUSGGD = NDFDSM
         ELSE 
*  
*           Le terme existe 
            IAGDNS = LGETRM+INCTRM*(NUGDNS-1)
            NUSGGD = IST(MCDTRM+IAGDNS+6)
         ENDIF
      ENDIF
*
      IF (NMGDND.NE.' ') THEN
         NUGDND=KLTERM (NMGDND,NVGDND,AST(MCMTRM),IST(MCDTRM))          !SDexplo
         IF (NUGDND.LE.0) THEN
*  
*           Le terme Gdelta*Noyau de simple couche n'existe pas: on l'ajoute  
*           apres agrandissement eventuel des structures #OMTRM et $SDTRM 
            CALL ALFANU (NBCHNT,NMGDND)                                 !Utilite
            NWHTRM=MAX (NCHTRM,LEN (NMGDND))
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)           !SDexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)      !SDexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM) 
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMGDND)              !Utilite
            NUGDND             = NBTERM
            IAGDND             = LGETRM+INCTRM*(NUGDND-1)
            IST(MCDTRM+IAGDND) = NVGDND
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !SDexplo
            IF (NUSGGD.LE.0) NUSGGD = NDFDSM
         ELSE 
*  
*           Le terme existe
            IAGDND=LGETRM+INCTRM*(NUGDND-1)
            NUSGGD=IST(MCDTRM+IAGDND+6)
         ENDIF
      ENDIF

*
*     Creation de la structure $GDNOY
*
      IF (NUSGGD.GT.0) THEN
         CALL TBRR1  (ERCODE,'$GDNOY',NUSGGD,LGSD)
         CALL TBAR1  (ERCODE,'$GDNOY',NUSGGD,MCSDGD)
         INCOGL = IST(MCSDGD+2)
         INCOGC = IST(MCSDGD+3)
         INCOPL = IST(MCSDGD+4)
         INCOPC = IST(MCSDGD+5)
         NUGDEL = IST(MCSDGD+6)
         ITGDEL = IST(MCSDGD+7)
         NUPDEL = IST(MCSDGD+8)
         ITPDEL = IST(MCSDGD+9)
         NBDOAS = IST(MCSDGD+ADDONA-1)
         IF (NWDOAS.GT.NBDOAS) 
     &      CALL TBAJST ('$GDNOY',NUSGGD,ADDONA+NWDOAS)                 !SDexplo
      ELSE
         NUSGGD=KLNIVE( )                                               !SDexplo
         LGSDGD=ADDONA+NWDOAS
         CALL TBCREE ('$GDNOY',NUSGGD,1,LGSDGD,'c')
         CALL TBAR1  (ERCODE,'$GDNOY',NUSGGD,MCSDGD)
         CALL TINIT  ('ENTIER',1,AST,NDFNDF,RST,CST
     &               ,LGSDGD,'ENTIER',MCSDGD,AST,IST,RST,CST)           !Utilite
         IST(MCSDGD+ADDONA-1)=0
      ENDIF
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      IF (NMGDNS.NE.' ') IST(MCDTRM+IAGDNS+6)=NUSGGD
      IF (NMGDND.NE.' ') IST(MCDTRM+IAGDND+6)=NUSGGD
*
*--   Tableaux de gestion des Termes, Domaines et Inconnues
*
      NBLEFT = LGCHAI
*
*     Recherche du nom de la matrice Gdelta
*
      CALL DCOCHN (CHAINE,LGCHAI,'Nom_Gdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NBCHDE = ITEMCH
         NVGDEL = 1
         NMDELT=NMITEM(1:ITEMCH)
*
*        Recherche du niveau de la matrice Gdelta
*
         CALL DCOCHN (CHAINE,LGCHAI,'Niveau_Gdelta'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
         NBLEFT = NBLEFT-ARTICH
         IF (ITEMCH.GT.0) CALL RELCNE (NMITEM(1:ITEMCH),NVGDEL)
         NUGDEL=KLTERM (NMDELT(1:NCHTRM),NVGDEL,AST(MCMTRM),IST(MCDTRM))!SDexplo
         IF (NUGDEL.LE.0) THEN
*  
*           Le terme Gdelta n'existe pas: on l'ajoute apres agrandissement 
*           eventuel des structures #OMTRM et $SDTRM 
            CALL ALFANU (NBCHNT,NMDELT(1:NBCHDE))                       !Utilite
            NWHTRM=MAX (NCHTRM,NBCHDE)
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,2)           !SDexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,2)      !SDexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM) 
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMDELT(1:NBCHDE))    !Utilite
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !SDexplo
            NUGDEL = NBTERM
            IST(MCDTRM+LGETRM+INCTRM*(NUGDEL-1)) = NVGDEL
         ELSE 
*  
*           Le terme matriciel Gdelta existe
            CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUGDEL-1))
     &                  ,NIVEAU,ITGDEL,ITYCAL,NUKALE,NUDONN,ITYSYG
     &                  ,IPTDIR,INCOGC,NVDUCG,KOGDEL,NVNUCG,INCOGL
     &                  ,NVDULG,LIGDEL,NVNULG,INDSTG,NVNUSG,NVCOGD
     &                  ,IATRGD,NIVIGD)                                 !SDexplo
         ENDIF
      ENDIF
*
*     Recherche du nom de la matrice Pdelta
*
      CALL DCOCHN (CHAINE,LGCHAI,'Nom_Pdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NBCHDE = ITEMCH
         NVPDEL = 1
         NMDELT=NMITEM(1:ITEMCH)
*
*        Recherche du niveau de la matrice Pdelta
*
         CALL DCOCHN (CHAINE,LGCHAI,'Niveau_Pdelta'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
         NBLEFT = NBLEFT-ARTICH
         IF (ITEMCH.GT.0) CALL RELCNE (NMITEM(1:ITEMCH),NVPDEL)
         NUPDEL=KLTERM (NMDELT(1:NCHTRM),NVPDEL,AST(MCMTRM),IST(MCDTRM))!SDexplo
         IF (NUPDEL.LE.0) THEN
*  
*           Le terme Pdelta n'existe pas: on l'ajoute apres agrandissement 
*           eventuel des structures #OMTRM et $SDTRM 
            CALL ALFANU (NBCHNT,NMDELT(1:NBCHDE))                       !Utilite
            NWHTRM=MAX (NCHTRM,NBCHDE)
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,2)           !SDexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,2)      !SDexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM) 
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMDELT(1:NBCHDE))    !Utilite
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !SDexplo
            NUPDEL = NBTERM
            IST(MCDTRM+LGETRM+INCTRM*(NUPDEL-1)) = NVPDEL
         ELSE 
*  
*           Le terme matriciel Pdelta existe
            CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUPDEL-1))
     &                  ,NIVEAU,ITPDEL,ITYCAL,NUKALE,NUDONN,ITYSYP
     &                  ,IPTDIR,INCOPC,NVDUCG,KOPDEL,NVNUCP,INCOPL
     &                  ,NVDULP,LIPDEL,NVNULP,INDSTP,NVNUSP,NVCOPD
     &                  ,IATRPD,NIVIPD)                                 !SDexplo
         ENDIF
      ENDIF
      CALL TBAR7  (ERCODE,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO
     &                   ,'#OMINC',1,MCMINC,'#NCONU',1,MCCONU
     &                   ,'#OMDON',1,MCMDON,'$DONNE',1,MCDDON
     &                   ,'$GDNOY',NUSGGD,MCSDGD)
      CALL SDEXDB (IST(MCDDON),LGEDON,NBDONN,INCDON,NCHDON)             !SDexplo
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !SDexplo
      CALL SDEXDB (IST(MCCONU),LGEINC,NBINCO,INCINC,NCHINC)             !Sdexplo
*
*     Type de la matrice Gdelta
*
      CALL DCOCHN (CHAINE,LGCHAI,'Type_Gdelta'
     &            ,ARTICH,ARTIDB,TYDELT,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         ITGDEW=INTTYP (TYDELT(1:ITEMCH))                               !Utilite
         IF (ITGDEL.NE.-99999.AND.ITGDEW.NE.ITGDEL) GOTO 99993
         ITGDEL=ITGDEW
      ENDIF
      IST(MCSDGD+6 ) = NUGDEL
      IST(MCSDGD+7 ) = ITGDEL
*
*     Type de la matrice Pdelta
*
      CALL DCOCHN (CHAINE,LGCHAI,'Type_Pdelta'
     &            ,ARTICH,ARTIDB,TYDELT,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         ITGDEW=INTTYP (TYDELT(1:ITEMCH))                               !Utilite
         IF (ITPDEL.NE.-99999.AND.ITGDEW.NE.ITPDEL) GOTO 99993
         ITPDEL=ITGDEW
      ENDIF
      IST(MCSDGD+8 ) = NUPDEL
      IST(MCSDGD+9 ) = ITPDEL
*
*     Nom du domaine de couplage (Sigma)
*
      CALL DCOCHN (CHAINE,LGCHAI,'Domaine_Sigma'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         CALL KLDOMN (NMITEM(1:ITEMCH),0,0,IST(MCTRDO),AST(MCMDOM)
     &               ,NBDOMG,NUDKSI,IATRSI)                             !SDexplo
         IST(MCSDGD) = NUDKSI
      ENDIF
*
*     Nom du domaine de representation integrale (Gamma)
*
      CALL DCOCHN (CHAINE,LGCHAI,'Domaine_Gamma'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         CALL KLDOMN (NMITEM(1:ITEMCH),0,0,IST(MCTRDO),AST(MCMDOM)
     &               ,NBDOMG,NUDKGA,IATRGA)                             !SDexplo
         IST(MCSDGD+1) = NUDKGA
      ENDIF
*
*     Noms des inconnues
*
      LUINCO=0
      CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Ligne_Gdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      IF (ITEMCH.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Ligne_Sigma'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
      ENDIF
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         LUINCO=LUINCO+1
         INCWGL=KELCHN(NMITEM(1:ITEMCH),AST(MCMINC),NBINCO,NCHINC)      !Utilite
         IF (INCOGL.GT.0.AND.INCWGL.NE.INCOGL) GOTO 99991
         INCOGL=INCWGL
      ENDIF
*
      CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Colonne_Gdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      IF (ITEMCH.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Colonne_Sigma'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
      ENDIF
      IF (ITEMCH.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Ligne_Noyau'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
      ENDIF
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         LUINCO=LUINCO+1
         INCWGC=KELCHN(NMITEM(1:ITEMCH),AST(MCMINC),NBINCO,NCHINC)      !Utilite
         IF (INCOGC.GT.0.AND.INCWGC.NE.INCOGL) GOTO 99992
         INCOGC=INCWGC
      ENDIF
*
      CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Ligne_Pdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Ligne_Gamma'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
      ENDIF
      IF (ITEMCH.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Colonne_Noyau'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
      ENDIF
      IF (ITEMCH.GT.0) THEN
         LUINCO=LUINCO+1
         INCOPL=KELCHN(NMITEM(1:ITEMCH),AST(MCMINC),NBINCO,NCHINC)      !Utilite
      ENDIF
*
      CALL DCOCHN (CHAINE,LGCHAI,'Inconnue_Colonne_Pdelta'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         LUINCO=LUINCO+1
         INCOPC=KELCHN(NMITEM(1:ITEMCH),AST(MCMINC),NBINCO,NCHINC)      !Utilite
      ENDIF
*
      IF (LUINCO.LE.0) THEN
         CALL DCOCHN (CHAINE,LGCHAI,'Inconnue'
     &               ,ARTICH,ARTIDB,NMITEM,ITEMCH)                      !Utilite
         NBLEFT = NBLEFT-ARTICH
         IF (ITEMCH.GT.0) THEN
            INCONU=KELCHN(NMITEM(1:ITEMCH),AST(MCMINC),NBINCO,NCHINC)   !Utilite
            IF (INCOGL.GT.0.AND.INCONU.NE.INCOGL) GOTO 99991
            IF (INCOGC.GT.0.AND.INCONU.NE.INCOGC) GOTO 99992
            INCOGL=INCONU
            INCOGC=INCONU
            INCOPL=INCONU
            INCOPC=INCONU
         ENDIF
      ENDIF
      IST(MCSDGD+2 ) = INCOGL
      IST(MCSDGD+3 ) = INCOGC
      IST(MCSDGD+4 ) = INCOPL
      IST(MCSDGD+5 ) = INCOPC
*
*     Nom de la donnee Lambda
*
      CALL DCOCHN (CHAINE,LGCHAI,'Donnee_Lambda'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NULAMB=KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)     !Utilite
         IF (NULAMB.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))              !Utilite
         IST(MCSDGD+10) = NULAMB
      ENDIF
*
*     Type 'REEL' ou 'COMPLEXE' de la fonction de Green
*
      CALL DCOCHN (CHAINE,LGCHAI,'Type_Green'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         IST(MCSDGD+11) = INTTYP (NMITEM(1:ITEMCH))                     !Utilite
      ENDIF
*
*     Numero des termes 'Noyau de simple et double couche'
*
      CALL DCOCHN (CHAINE,LGCHAI,'Niveau_Noyau_Simple'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) CALL RELCNE (NMITEM(1:ITEMCH),IST(MCSDGD+12))    !Utilite
      CALL DCOCHN (CHAINE,LGCHAI,'Niveau_Noyau_Double'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !Utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) CALL RELCNE (NMITEM(1:ITEMCH),IST(MCSDGD+13))    !Utilite
*
*     Recherche des donnees associees au calcul de Green
*
      ARDEB=1
      IST(MCSDGD+ADDONA-1) = MAX(NBDOAS,NWDOAS)      
      IF (NWDOAS.GE.1) THEN
         DO 20 I = 1,NBDOAW
            CALL DCOCHN (CHAINE(ARDEB:LGCHAI),LGCHAI,'Donnee'
     &                  ,ARTICH,ARTIDB,NMITEM,ITEMCH)                   !Utilite
            IF (ITEMCH.LE.0) GOTO 21
            NBLEFT = NBLEFT-ARTICH
*           Recherche du numero de la donnee associee
            ARDEB=ARDEB+ARTIDB
            IDBNU=ARDEB+5
            IF (CHAINE(IDBNU:IDBNU).NE.'_') THEN
              IFNNU=IDBNU+INDEX(CHAINE(IDBNU:LGCHAI),'=')-2             !Utilite
              NUDOAS=1
              IF (IFNNU.GE.IDBNU)
     &            CALL RELCNE (CHAINE(IDBNU:IFNNU),NUDOAS)              !Utilite
              NUDONN=KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)!Utilite
              IF (NUDONN.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))
              IST(MCSDGD+ADDONA-1+NUDOAS) = NUDONN
            ENDIF
20       CONTINUE
      ENDIF
21    IF (NBLEFT.GT.0) THEN
         NBLIGN=1+(LGCHAI-1)/80
         NDEB = 1
         WRITE (IMPPAL,90001) 'MksdGN',NBLEFT
         DO 90000 I=1,NBLIGN
            NFIN  = MIN (NDEB+79,LGCHAI)
            WRITE (IMPPAL,90002) CHAINE(NDEB:NFIN)
            NDEB = NDEB +80
90000    CONTINUE
         CALL PRSDGN (NUSGGD,IMPPAL)
         GOTO 99999 
      ENDIF
      CALL TBSAVE ('$GDNOY',NUSGGD)                                     !Utilite
      CALL PRFXMJ (-1,'*MksdGN*')
      RETURN
*-----------------------------------------------------------------------
90001 FORMAT (/T2,A8,'La chaine suivante n''a pu etre totalement dechif'
     &,'free (reste',I3,' caracteres)')
90002 FORMAT ((T5,A))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 CALL BAISE  ('Inconnue_Ligne_Sigma incompatible avec '
     &//'l''inconnue en ligne de la matrice Gdelta.')                   !Utilite
99992 CALL BAISE  ('Inconnue_Colonne_Sigma incompatible avec '
     &//'l''inconnue en colonne de la matrice Gdelta.')                 !Utilite
99993 CALL BAISE  ('Type declare de la matrice Gdelta et type actuel '
     &//'differents.')                                                  !Utilite
99999 CALL BAISE  ('Revoir la syntaxe de la chaine-argument')           !Utilite
                                                                    END !MksdGN

