*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKTERM (NOMTRM,NIVTRM,TYPTRM,NOMDOM,TYPCAL,NMTYPE
     &                  ,NUSCHQ,NMINCC,NMINCL,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 1990)  
* Derniere modification : D.Martin (25 Mars 2002)
* Version 1.0.3
*  
* Mise a jour des tableaux #OMTRM, #TERDO et $SDTRM pour un nouveau terme
*  
*-- Arguments d'entree -- 
* NOMTRM nom du terme 
* NIVTRM niveau du (tableau contenant le) terme
* TYPTRM type du terme ('REEL', 'COMPLEXE')
* NOMDOM nom du domaine geometrique ou l'on calcule le terme  
* TYPCAL type de calcul ('ELFINI','VALNOD','C.ESSE','INTERP' ,'C.TRAN' ...)
* NMTYPE nom d'integrand ou de type de condition essentielle ou ...
* NUSCHQ 1) numero (degre) de schema de quadrature pour un terme 'ELFINI'
*        2) nombre de composantes par noeud pour un terme 'VALNOD' [nouveaute]
*        >= 4 tensoriel, >= 2 vectoriel, =1 scalaire
* NMINCC nom d'inconnue en colonne ou sur laquelle porte la condition esentielle
* NMINCL nom d'inconnue en ligne (le cas echeant) 
* NIVIMP indice de niveau d'impression du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOMTRM,TYPTRM,NOMDOM,TYPCAL,NMINCL,NMINCC,NMTYPE
      INTEGER       NIVTRM,NUSCHQ,NIVIMP
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      INTEGER       INCESS,INDSTO,INDSYM,INTGKL,INTTYP,ITRGKL,INTYKL
     &             ,INVANO,KELCHN,KLTERM                                !utilite
      INTEGER       LGTRDO,MCTRDO,LGERDO,NBDOMK,LGCANO,NCHDOM,MCMDOM
     &             ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCMTRM
     &             ,LGMTRM
     &             ,MCINCO,LGINCO,NBINCO,INCINC,NCHINC,MCMINC
      INTEGER       NUDOMG,OLYPTR,OLYCAL,OLKALE,OLINCC,OLINCL,OLVIMP
     &             ,NUINCL,NUINCC,NUEGAL,ISGNKL,NUPLUS,NCAR,NCARL
     &             ,NCARL1,NCARL2,NUINC1,NUINC2,NUTERM,IADTRM
     &             ,NIWTRM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &             ,NVDUMC,NBNECO,NVNUMC,NVDUML,NBNELI,NVNUML
     &             ,INSTOK,NVNUMS,NVCORC,NDEBDO,NUSCHG,NCATR1
     &             ,MCLIST,MCBLOK,KC,IC,KL,IL,LGVRAI,LGNEW,IGEOME
     &             ,NIVDOM,NBTRDO,ITR,IDO,NXDOMK,MC1TRM,MCTTDO,MCDRDO
      CHARACTER     ERCODE*120,TYCALK*6,YKLINT*6
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(113:113),TYCALK) 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*MkTerm*')
      ITYCAL=INTYKL (TYPCAL)                                            !utilite
      TYCALK=YKLINT (ITYCAL)                                            !utilite
*
      CALL TBRR4  (ERCODE,'#TERDO',1,LGTRDO,'$SDTRM',1,LGDTRM
     &                   ,'#OMTRM',1,LGMTRM,'#NCONU',1,MCINCO)
      CALL TBAR6  (ERCODE,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO
     &                   ,'#OMINC',1,MCMINC,'#NCONU',1,MCINCO
     &                   ,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,LGCANO,NCHDOM)             !utilite
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXDB (IST(MCINCO),LGINCO,NBINCO,INCINC,NCHINC)             !utilite
*  
*     Numero du domaine geometrique de nom NOMDOM  
      NUDOMG=KELCHN (NOMDOM,AST(MCMDOM),NBDOMG,NCHDOM)                  !utilite
      IF (NUDOMG.LE.0) CALL ERDOMA (1,NOMDOM)                           !utilite
*  
*     Recherche des numeros des inconnues en ligne et colonne
      NUINCL=0 
      IF (NMINCL.NE.' ') THEN
         IF (LEN (NMINCL).GT.NCHINC) CALL REDERR (5,NMINCL)             !redlec
         NUINCL=KELCHN (NMINCL,AST(MCMINC),NBINCO,NCHINC)               !utilite
         IF (NUINCL.LE.0) CALL ERINCO (1,NMINCL)                        !utilite
      ENDIF
      NUINCC=0 
      IF (NMINCC.NE.' ') THEN
         NUINCC=NUINCL 
         IF (NMINCL.NE.NMINCC) THEN 
            IF (LEN (NMINCC).GT.NCHINC) CALL REDERR (5,NMINCC)          !redlec
            NUINCC=KELCHN (NMINCC,AST(MCMINC),NBINCO,NCHINC)            !utilite
            IF (NUINCC.LE.0) CALL ERINCO (1,NMINCC)                     !utilite
         ENDIF
      ENDIF
*  
*     Numero de type de calcul, symetrie, ... 
      ITYSYM=INDSYM (' ')                                               !utilite
      IF (TYCALK(1:6).EQ.'ELFINI'.OR.TYCALK(1:6).EQ.'MATELM') THEN 
         NUKALE=INTGKL (NMTYPE)                                         !integra
         IF (NUKALE.LE.0) GOTO 90001
         CALL INTATR (NUKALE,KC,IC,KL,IL,ITYSYM)                        !integra
      ELSEIF (TYCALK(1:6).EQ.'VALNOD') THEN
         NUKALE=INVANO (NMTYPE)                                         !utilite
         IF (NUKALE.LE.0) GOTO 90001
         ITYSYM=NUSCHQ
         NUSCHQ=0
      ELSEIF (TYCALK(1:6).EQ.'C.ESSE') THEN
         NUKALE=1  
         NUEGAL=INDEX (NMTYPE,'=')  
         IF (NUEGAL.LE.0) GOTO 90002
         NUKALE=INCESS (NMTYPE(MAX(1,NUEGAL-2):NUEGAL-1))               !utilite
         IF (NUKALE.LE.0) GOTO 90001
      ELSEIF (TYCALK(1:6).EQ.'C.TRAN') THEN
         NUKALE=1 
         NCAR =LEN (NMTYPE) 
         NCARL=NCAR
         NUEGAL=INDEX (NMTYPE,'=')  
         IF (NUEGAL.LE.0) GOTO 90002
         NUPLUS=INDEX(NMTYPE,'+')
         IF (NUPLUS.GT.0) NCARL=NUPLUS-1
*
         NUKALE=INCESS (NMTYPE(MAX(1,NUEGAL-2):NUEGAL-1))               !utilite
         IF (NUKALE.LE.0) GOTO 90001
         IF (NUKALE.LE.1) THEN
            NCARL1=NUEGAL-1
            NCARL2=NCARL
         ELSEIF (NUKALE.LE.3) THEN
            NCARL1=NUEGAL-3
            NCARL2=NCARL-2 
         ENDIF
*        Premiere inconnue
         NUINC1=KELCHN (NMTYPE(1:NCARL1),AST(MCMINC),NBINCO,NCHINC)     !utilite
         IF (NUINC1.NE.NUINCC) WRITE (IMPPAL,10021)
     &                       'premiere',NMTYPE(1:NCARL1),NMTYPE(1:NCAR)
*        Seconde  inconnue
         NUINC2=KELCHN (NMTYPE(NUEGAL+1:NCARL2),AST(MCMINC),NBINCO
     &                 ,NCHINC)                                         !utilite
         IF (NUINC2.NE.NUINCL) WRITE (IMPPAL,10021)
     &                 'seconde',NMTYPE(NUEGAL+1:NCARL2),NMTYPE(1:NCAR)
      ELSEIF (TYCALK(1:6).EQ.'INTERP') THEN 
         NUEGAL=INDEX (NMTYPE,'-')  
         IF (NUEGAL.EQ.1) THEN
*           le signe "moins" devant le type d'interpolant signifie
*           que l'on declare le terme, mais que l'on differe son calcul 
*           par rapport au prochain CalkEF.
            ISGNKL=-1
            NUKALE=ITRGKL (NMTYPE(2:))                                  !calkit
         ELSE
            ISGNKL=+1
            NUKALE=ITRGKL (NMTYPE)                                      !calkit
         ENDIF
         IF (NUKALE.LE.0) GOTO 90001
         CALL ITRATR (NUKALE,NDIM,KC,IC,KL,IL)                            !calkit
      ELSE 
         GOTO 90001
      ENDIF
*
      NUTERM=KLTERM (NOMTRM,NIVTRM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.GT.0) THEN 
*        Le terme est deja defini
*        On verifie la coherence de ses attributs non modifiables
         IADTRM=MCDTRM+LGETRM+(NUTERM-1)*INCTRM
         CALL GETTRM (IST(IADTRM),NIWTRM
     &               ,OLYPTR,OLYCAL,OLKALE,NUDONN,ITYSYM,IPTDIR    
     &               ,OLINCC,NVDUMC,NBNECO,NVNUMC
     &               ,OLINCL,NVDUML,NBNELI,NVNUML
     &               ,INSTOK,NVNUMS,NVCORC,NDEBDO,OLVIMP)               !sdexplo
*        Test sur le numero du domaine geometrique
         IF (NDEBDO.NE.0.OR.OLKALE.NE.NDFCAL) THEN
            IF (NUDOMG.NE.IST(MCTRDO+NDEBDO-1) 
*           Tests sur le type de terme et le type de calcul
     &     .OR.OLYPTR.NE.INTTYP (TYPTRM).OR.OLYCAL.NE.INTYKL (TYCALK)   !utilite
*           Tests sur les numeros des inconnues en colonne et ligne
     &     .OR.OLINCC.NE.NUINCC.OR.OLINCL.NE.NUINCL
*           Test sur le numero de type de calcul No d'integrand,...)  
     &     .OR.ABS(OLKALE).NE.ABS(NUKALE)) GOTO 90003
         ENDIF
         CALL PUTTRM (IST(IADTRM),NIVTRM
     &               ,OLYPTR,OLYCAL,NUKALE,NUDONN,ITYSYM,IPTDIR
     &               ,NUINCC,NVDUMC,NBNECO,NVNUMC
     &               ,NUINCL,NVDUML,NBNELI,NVNUML
     &               ,INSTOK,NVNUMS,NVCORC,NDEBDO,NIVIMP)               !sdexplo
         GOTO 10000
      ELSE 
*        On n'a jamais rencontre ce terme  
*  
*        Il faut prealablement agrandir #OMTRM, #TERDO et $SDTRM
         LGVRAI=LGERDO+LGCANO*NBDOMK+NBTERM
         LGNEW=LGVRAI+2*LGCANO+104
         IF (LGNEW.GT.LGTRDO) THEN  
            CALL TBAJST ('#TERDO',1,LGNEW)
            CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)
         ENDIF
         DO 1 ITR=MCTRDO+LGVRAI,MCTRDO+LGVRAI+LGCANO-1 
            IST(ITR)=0
1        CONTINUE
         LGTRDO=LGNEW-100  
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,2)         !sdexplo
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NCHTRM,NBTERM,2)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
*  
*        Introduction du nouveau terme dans le tableau des noms de termes  
         CALL ALFANU (NBCHNT,NOMTRM)                                    !utilite
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NOMTRM)                 !utilite
         NUTERM=NBTERM 
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
      ENDIF
*
      ITYPTR=INTTYP (TYPTRM)                                            !utilite
      IF (TYCALK(1:6).NE.'ELFINI') THEN
         INSTOK=NDFSTO
      ELSE
         IF (NUINCC.LE.0.OR.NUINCL.LE.0) THEN
            INSTOK=INDSTO ('PLEIN-L')                                     !utilite
         ELSEIF (NUINCC.EQ.NUINCL) THEN
            INSTOK=INDSTO ('BIMORSE')                                   !utilite
         ELSEIF (NUINCC.LE.NUINCL) THEN
            INSTOK=INDSTO ('MORSE-L')                                   !utilite
            ITYSYM=NDFSYM
         ELSE
            INSTOK=INDSTO ('MORSE-C')                                   !utilite
            ITYSYM=NDFSYM
         ENDIF
      ENDIF
      IF (TYCALK(1:6).EQ.'INTERP') NUKALE=SIGN (NUKALE,ISGNKL)
*  
*     Mise a jour de la structure #TERDO
*  
      NUSCHG=NUSCHQ
      IF (NUSCHG.EQ.0) NUSCHG=5
      CALL TBRR1  (ERCODE,'#ISTEL',NUDOMG,MCLIST)
      MCBLOK=MCLIST
      IF (NBBBLK.GE.2) CALL TBAR1  (ERCODE,'#LOKEL',1,MCBLOK)
      CALL TBAR4  (ERCODE,'#ISTEL',NUDOMG,MCLIST,'#NCONU',1,MCINCO 
     &                   ,'#TERDO',1     ,MCTRDO,'$SDTRM',1,MCDTRM)
      IGEOME=0 
      NIVDOM=-1
      CALL MKTRDO (NUDOMG,IST(MCLIST),NDIM,INTRPG,IST(MCBLOK)
     &            ,IST(MCINCO),IST(MCTRDO),IST(MCTRDO+LGTRDO),IGEOME
     &            ,NUSCHG,NUTERM,NUINCC,NUINCL,ITYCAL,NUKALE,NIVDOM
     &            ,NDEBDO,NIVIMP,IMPSDR)                                !sdexplo
*  
      CALL TBSAVE ('#ISTEL',NUDOMG)
*  
*     Mise a jour de la structure $SDTRM
*
      CALL TBAR1(ERCODE,'$SDTRM',1,MCDTRM)
      CALL PUTTRM (IST(MCDTRM+LGETRM+(NUTERM-1)*INCTRM),NIVTRM
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NDFDSM
     &            ,NUINCC,NDFDUM,NDFNDF,NDFNUM
     &            ,NUINCL,NDFDUM,NDFNDF,NDFNUM
     &            ,0,NDFSTO,NDFCOR,NDEBDO,NIVIMP)                       !sdexplo
*     Il faut riper de 1 dans $SDTRM toutes les adresses relatives 
*     des termes des domaines de calcul situes a la suite
      NXDOMK=IST(MCTRDO+NDEBDO)+1  
      NDEBDO=NDEBDO+LGCANO 
      NBTRDO=IST(MCTRDO+NDEBDO-3)  
      MC1TRM=MCDTRM+LGETRM-2
      DO 20 IDO=NXDOMK,NBDOMK  
         NDEBDO=NDEBDO+LGCANO+NBTRDO
         NBTRDO=IST(MCTRDO+NDEBDO-3)
         MCTTDO=MCTRDO-1+NDEBDO
         DO 10 ITR=1,NBTRDO
            MCDRDO=MC1TRM+INCTRM*IST(MCTTDO)  
            IST(MCDRDO)=IST(MCDRDO)+1  
            MCTTDO=MCTTDO+1
10       CONTINUE
20    CONTINUE
*
10000 IF (NIVIMP.GE.2) THEN 
         CALL TBAR2  (ERCODE ,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPSDR)            !prsd
      ENDIF
      CALL PRFXMJ (-1,'*MkTerm*')  
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10021 FORMAT(' La ',A,' inconnue ',A,' pour la condition de transmission
     &',A,' est incoherente.'/)
10022 FORMAT(T2,'*Mkterm*',/(T2,A20,I8,' ->',I8,:,' et ',I8,' ->',I8))
90001 ERCODE=NMTYPE
      ERCODE(11:)=TYCALK
      CALL PRNTRM (NOMTRM,NIVTRM,ERCODE(21:),NCATR1)
      CALL BAISE  (' Type de calcul errone: '//ERCODE(1:10)
     &//' pour le terme '//ERCODE(21:20+NCATR1)
     &//' de type '//ERCODE(11:16))
90002 ERCODE=NMTYPE
      ERCODE(11:)=TYCALK
      CALL PRNTRM (NOMTRM,NIVTRM,ERCODE(21:),NCATR1)
      CALL BAISE  (' Type de condition essentielle non reconnu : ' 
     &//ERCODE(:10)//' pour le terme '//ERCODE(21:20+NCATR1)
     &//' de type '//ERCODE(11:16))
90003 WRITE (IMPPAL,10022) 'Domaine ',NUDOMG,IST(MCTRDO+NDEBDO-1) 
      WRITE (IMPPAL,10022) 'Type    ',OLYPTR,INTTYP(TYPTRM)
      WRITE (IMPPAL,10022) 'Calcul  ',OLYCAL,INTYKL(TYCALK)
      WRITE (IMPPAL,10022) 'Inconnue',OLINCC,NUINCC,OLINCL,NUINCL
      WRITE (IMPPAL,10022) 'NuCalcul',OLKALE,NUKALE
      CALL PRSDTR (NUTERM,IST(MCDTRM),AST(MCMTRM),IMPPAL)               !sdexplo
      CALL PRNTRM (NOMTRM,NIVTRM,ERCODE(21:),NCATR1)
      CALL BAISE  (' Le terme '//ERCODE(21:20+NCATR1)         
     &//' existe deja avec des attributs differents non modifiables')
                                                                    END !MkTerm
