*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MKTRDO (NUDOMG,LISTEL,NDIM,INTRPG,BLOKEL,INCONU,ITERDO
     &                  ,NUDLFA,IGEOMB,NUSCHQ,NUTERM,NUINCC,NUINCL
     &                  ,ITYCAL,NUKALE,NIVDOM,NDEBDO,IMPDIR,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Decembre 1988)
* Derniere modification : D.Martin & C.Chambeyron (7 octobre 2006)
* Version 2
*  
* Creation ou mise a jour d'un domaine de calcul dans la structure #TERDO  
*  
*-- Arguments d'entree -- 
* NUDOMG numero du domaine geometrique
* LISTEL tableau descriptif du domaine geometrique (#ISTEL,NUDOMG)
* NDIM   dimension d'espace
* INTRPG numero de type de l'interpolation geometrique
* BLOKEL tableau des blocs d'elements consecutifs de meme type
* INCONU tableau des caracteristiques des inconnues
* ITERDO tableau de description des termes et des domaines de calculs 
* NUDLFA numerotation elememtaire des d.l. dans la face NUF
* IGEOMB indicateur de calcul geometrique sur le domaine 
* NUSCHQ numero de schema de quadrature
* NUTERM numero du terme (rang dans #OMTRM)
* NIVTRM niveau du (tableau contenant le) terme
* NUINCC numero d'inconnue en colonne 
* NUINCL numero d'inconnue en ligne
* ITYCAL indice de type de calcul
* NUKALE numero d'integrand ou de con. essentielle ou de valeur nodale
* NIVDOM niveau d'impression pour les calculs sur le domaine  
* NDEBDO adresse relative du domaine dans la structure #TERDO (arg. de sortie)
* IMPDIR indice d'impression des directives
* IMPFCH unite logique d'impression  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER  NUDOMG,LISTEL(*),NDIM,INTRPG,BLOKEL(*),INCONU(*)
     &        ,ITERDO(*),NUDLFA(*),IGEOMB,NUSCHQ,NUTERM,NUINCC
     &        ,NUINCL,ITYCAL,NUKALE,NIVDOM,NDEBDO,IMPDIR
     &        ,IMPFCH
*
      CHARACTER*6 YKLINT,TYPCAL
      INTEGER  NCPINC,INTRPC,NCPINL,INTRPL,NBTNEU,IGEOME,IRPLOC,ICOORN
     &        ,LGERDO,NBDOMK,LGCANO,NCHDOM,NDEBMX,IDOM,NBTRDO,IDOMG
     &        ,INDMIX,NUDOMK,KGEOME,JNDMIX,JUSCHQ
     &        ,JNDEXC,JDLHRC,JNTRPC,JBNECX,JBNEEX,JBDLEX,JBNEFX,JBDLFX
     &        ,JNDEXL,JDLHRL,JNTRPL,JBNELX,JBNEEY,JBDLEY,JBNEFY,JBDLFY
     &        ,NVNUMC,NVNUML,NVCORC,INUTIL,JIVDOM,JGEOME,JCOORN,JRPLOC
     &        ,NDEBTR,INDEXC,INDEXL,ITERM,I
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Mktrdo*')
*
      TYPCAL=YKLINT (ITYCAL)                                            !utilite
*
      NCPINC=0
      NCPINL=0
      NBTNEU=0
      INTRPC=INTRPG
      INTRPL=INTRPG
      IF (NUINCC.NE.0) CALL SDEXCO (NUINCC,INCONU,NCPINC,INTRPC,NBTNEU) !sdexplo
      IF (INTRPC.GE.0) INTRPL=INTRPC
      IF (NUINCL.NE.0) CALL SDEXCO (NUINCL,INCONU,NCPINL,INTRPL,NBTNEU) !sdexplo
*
*     Cas d'inconnues non 'NODALES' (interpolation negative)
*
      IF (INTRPC.LT.0.AND.INTRPL.LT.0.AND.TYPCAL.EQ.'ELFLQU') THEN
*        Il faudrait plutot trouver un domaine de calcul
*        deja defini sur le domaine
         INTRPC=INTRPG
         INTRPL=INTRPG
      ELSEIF (INTRPC.LT.0) THEN
         INTRPC=INTRPL
      ELSEIF (INTRPL.LT.0) THEN
         INTRPL=INTRPC
      ENDIF
*  
      IGEOME=IGEOMB
      IRPLOC=MOD (IGEOME,10)
      ICOORN=IGEOME/10
      CALL SDEXDB (ITERDO,LGERDO,NBDOMK,LGCANO,NCHDOM)                  !sdexplo
*
*     Calcul de la longueur utile de la structure #TERDO
*
      NDEBMX=LGERDO+1  
      DO 1  IDOM=1,NBDOMK  
         NBTRDO=ITERDO(NDEBMX+LGCANO-2)
         NDEBMX=NDEBMX+LGCANO+NBTRDO
1     CONTINUE
      NDEBMX=NDEBMX-1
*
*     On cherche quel est le domaine de calcul concerne
*
      NBTRDO=0 
      NDEBDO=1+LGERDO-LGCANO
10    NDEBDO=NDEBDO+LGCANO+NBTRDO  
      IDOMG=ITERDO(NDEBDO)
      IF (NUDOMG.NE.IDOMG) THEN 
*        le domaine de calcul courant n'a pas le bon numero de domaine 
*        geometrique : on passe au domaine suivant 
         IF (NDEBDO.LT.NDEBMX) THEN 
            NBTRDO=ITERDO(NDEBDO+LGCANO-2) 
            GOTO 10
         ELSE  
*           Tous les domaines de calculs ont ete vu; il faut donc un
*           domaine de calcul de plus pour au moins un terme supplementaire
            NBDOMK=NBDOMK+1
            INDMIX=1
            IF (INTRPL.NE.INTRPC) INDMIX=2
            CALL MKDOMK (NUDOMG,INTRPG,LISTEL,NDIM,BLOKEL,ITERDO,NDEBDO
     &                  ,NUDLFA,NBDOMK,INDMIX,IGEOME,NUSCHQ,INTRPC
     &                  ,INTRPL,NCPINC,NCPINL,ITYCAL,NUKALE,NIVDOM
     &                  ,IMPDIR,IMPFCH)                                 !sdexplo
            CALL SDMKDB (ITERDO,LGERDO,NBDOMK,LGCANO,NCHDOM)            !sdexplo
            IF (TYPCAL(1:6).NE.'NONDEF') THEN  
               ITERDO(NDEBDO+LGCANO-2)=1
               ITERDO(NDEBDO+LGCANO)=NUTERM
            ENDIF 
            GOTO 99999
         ENDIF
      ELSE 
*        On a trouve le bon domaine geometrique
         CALL GETDOM (ITERDO(NDEBDO),NUDOMG,NUDOMK,KGEOME,JNDMIX,JUSCHQ
     &               ,JNDEXC,JDLHRC,JNTRPC,JBNECX,JBNEEX,JBDLEX,JBNEFX
     &               ,JBDLFX,NVNUMC
     &               ,JNDEXL,JDLHRL,JNTRPL,JBNELX,JBNEEY,JBDLEY,JBNEFY
     &               ,JBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,JIVDOM)        !sdexplo
         JGEOME=ABS (KGEOME)
         JCOORN=JGEOME/10  
         JRPLOC=MOD(JGEOME,10) 
         INDMIX=ABS(JNDMIX)
         IGEOME=MAX(JRPLOC,IRPLOC)+10*MAX(JCOORN,ICOORN)
         IF (JGEOME.EQ.IGEOME) IGEOME=KGEOME
         IF (NUSCHQ.EQ.0) NUSCHQ=JUSCHQ 
         IF (JIVDOM.GT.0) NIVDOM=MAX(NIVDOM,JIVDOM) 
         IF (TYPCAL(1:6).EQ.'NONDEF') THEN 
*           Incompatibilite Calcul des normales <--> Extension en colonne  
            IF (IRPLOC.GE.1.AND.JNDEXC.EQ.1) GO TO 10
            GOTO 40
         ELSEIF (TYPCAL(1:3).EQ.'ELF'  .OR.TYPCAL(1:6).EQ.'MATELM'
     &      .OR.TYPCAL(1:6).EQ.'INTERP'.OR.TYPCAL(1:6).EQ.'VALNOD') THEN
*  
*           Incompatibilite a cause des interpolations 
            IF (NBTRDO.NE.0.AND.(JNTRPL.NE.INTRPL.OR.JNTRPC.NE.INTRPC)) 
     &         GOTO 10
            INDEXC=0
            INDEXL=0
            IF (TYPCAL(1:6).EQ.'ELFINI'.OR.TYPCAL(1:6).EQ.'MATELM') 
     &         CALL KLINDX (INTRPC,INTRPL,NDIM,NUKALE,LISTEL,BLOKEL
     &                     ,INDEXC,INDEXL)                              !sdexplo
*
*           Incompatibilite entre les extensions et les calculs geometriques
            IF (JGEOME.GE.1.AND.(INDEXC.EQ.1.OR.INDEXL.EQ.1)) THEN
*              Ce domaine-ci existe avec les normales et les coordonnees
*              donc on peut ne plus les demander avec le terme a etendre
               IRPLOC=0
               ICOORN=0
               IGEOME=0
               GOTO 10
            ENDIF
*
*           Ce cas ne peut se produire en principe. Il ne pourait se
*           produire que si l'on demandait les coordonnees ou les normales
*           pour le domaine, 
*           et un premier terme E.F. sur le bord avec extension en Col.
*           On a alors creer deux domaine de calcul distincts.
*           (cf: MKDOMK). (ici IGEOME=0).
            IF (IGEOME.GE.1.AND.INDEXC.EQ.1) 
     &      CALL BAISE ('Bug interne impossible. voir Mktrdo/Sdexplo')
*
*           Incompatibilite a cause des extensions necessaires
            IF (INDEXL.NE.JNDEXL.OR.INDEXC.NE.JNDEXC) GOTO 10
*
*           Incompatibilite a cause des extensions deja presentes
            IF ((TYPCAL(1:6).EQ.'ELFLQU'.OR.TYPCAL(1:6).EQ.'ELFLOC'
     &       .OR.TYPCAL(1:6).EQ.'VALNOD'.OR.TYPCAL(1:6).EQ.'INTERP')  
     &          .AND.(JNDEXC.EQ.1.OR.JNDEXL.EQ.1)) GOTO 10
         ELSEIF (TYPCAL(1:6).EQ.'C.ESSE'
     &       .OR.TYPCAL(1:6).EQ.'C.TRAN') THEN
            IF (JNTRPC.NE.INTRPC) GOTO 10  
            IF (IRPLOC.GE.1.AND.JNDEXC.EQ.1) GOTO 10
         ELSE  
            CALL BAISE  ('Type de calcul inconnu : '//TYPCAL)           !utilite
         ENDIF
      ENDIF
*  
      IF (NBTRDO.EQ.0) THEN 
*        Attention il s'agit d'un domaine qui a d'abord ete prevu sans 
*        terme et qu'il faut completer.
         CALL MKDOMK (NUDOMG,INTRPG,LISTEL,NDIM  ,BLOKEL,ITERDO,NDEBDO
     &               ,NUDLFA,NUDOMK,INDMIX,IGEOME,NUSCHQ,INTRPC
     &               ,INTRPL,NCPINC,NCPINL,ITYCAL,NUKALE,NIVDOM
     &               ,IMPDIR,IMPFCH)                                    !sdexplo
         NDEBTR=NDEBDO+LGCANO
      ELSE 
         NDEBTR=NDEBDO+LGCANO
         DO 20 ITERM=1,NBTRDO
            IF (NUTERM.EQ.ITERDO(NDEBTR)) GOTO 99999
20          NDEBTR=NDEBTR+1
      ENDIF
*     On decale pour inserer un terme de plus  
      DO 30 I=NDEBMX+1,NDEBTR+1,-1
30       ITERDO(I)=ITERDO(I-1) 
      NBTRDO=NBTRDO+1
      ITERDO(NDEBTR)=NUTERM
40    CALL PUTDOM (ITERDO(NDEBDO),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,JNDEXC,JDLHRC,JNTRPC,JBNECX,JBNEEX,JBDLEX,JBNEFX
     &            ,JBDLFX,NVNUMC
     &            ,JNDEXL,JDLHRL,JNTRPL,JBNELX,JBNEEY,JBDLEY,JBNEFY
     &            ,JBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM)           !sdexplo
99999 CALL PRFXMJ (-1,'*Mktrdo*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Version 2 : C.Chambeyron (25 juillet 2006)
*  - cas d'un terme spectral x spectral calcule par integration numerique
* Version 1.0.2 : D.Martin & C.Chambeyron (7 novembre 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Mktrdo
