*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE MOC2DL (NVSTOK,NCPINL,NCPINC,NMTERM,NVTERM,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Fevrier 1995)  
* Derniere modification : D.Martin (03 novembre 2008)
* Version 2
*
* Calcul des tables de stockage pour une inconnue(s) vectorielle(s)
* a partir des tables de stockage en noeuds (pour inconnue(s) scalaire(s))
*  
*-- Arguments d'entree -- 
* NVSTOK niveau commun des tables de stockage Morse-C
* NCPINL nombre de composantes pour l'inconnue en ligne
* NCPINC nombre de composantes pour l'inconnue en colonne
* NMTERM nom du terme correspondant (pour impression)
* NVTERM niveau du terme
* NIVIMP niveau d'impression du terme 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTERM
      INTEGER       NVSTOK,NCPINL,NCPINC,NVTERM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER STODLN*6
      INTEGER INDSTO
      INTEGER MCSTON,MCSTOK,LGSTOK,NBC
     &       ,NBL,NBPLAL,MCPLAL,MCPLIL,LGL,MCPLAD,MCPLID,NBLIDL
      CHARACTER     ERCODE*120,PRFXAF*8,NMSTOK*6,NMSTON*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Moc2dl*')
*
      ERCODE(1:1)='!'
      NMSTOK = STODLN (INDSTO('MORSE-C'),NCPINC, NCPINL)
      NMSTON = '&EGALP'
      CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
      IF (ERCODE(1:1).NE.' ') THEN
         CALL TBRR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL TBAR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL EXMORS (MCSTON,IST(MCSTON)
     &               ,NBC,NBL,NBPLAL,MCPLAL,MCPLIL,LGL)                 !utilite
         LGSTOK=4+NBC*NCPINC+2*NCPINC*NBPLAL+2*NBC*(NCPINC-1)
         CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
         CALL TBAR2  (ERCODE,NMSTON,NVSTOK,MCSTON 
     &                      ,NMSTOK,NVSTOK,MCSTOK)
*        La creation du tableau ci-dessus a pu modifier les adresses ...
         CALL EXMORS (MCSTON,IST(MCSTON)
     &               ,NBC,NBL,NBPLAL,MCPLAL,MCPLIL,LGL)                 !utilite
         MCPLAD=MCSTOK+4
         MCPLID=MCPLAD+NBC*NCPINC
         CALL N2DLMO (0,NCPINL,NCPINC,NBC,NBL,IST(MCPLAL)
     &               ,IST(MCPLIL),NBLIDL,IST(MCPLAD),IST(MCPLID))       !morse
         IST(MCSTOK)  =NBC*NCPINC
         IST(MCSTOK+1)=NBL*NCPINL
         NBPLAL       =IST(MCPLID-1)
         IST(MCSTOK+2)=NBPLAL
         LGSTOK       =4+NBLIDL+2*NBPLAL
         IST(MCSTOK+3)=IST(MCSTOK-1+LGSTOK)
*
         IF (NIVIMP.GE.5) THEN
            CALL PRMORS (IST(MCSTOK),'C','Tables Morse-C d.l. pour'
     &                  ,NMTERM,NVTERM,NIVIMP,IMPSDR)                   !prsd
         ENDIF
         CALL TBAJST (NMSTOK,NVSTOK,LGSTOK)
         CALL TBSAVE (NMSTON,NVSTOK)
      ENDIF
      CALL PRFXMJ (-1,'*Moc2dl*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre/03 novembre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1 : D.Martin (4 Decembre 1998)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Moc2dl
