*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NEELEM (INTERP,NBBBLK,NU1BLK,BLOKEL,NUNEFA,NUDLFA
     &                  ,NESOME,NEARET,NEFACE,NEINTE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: D.Martin (Octobre 1995)  
* Derniere modification : D.Martin (9 Fevrier 2000)
* Version # 1.0.0
*  
* Determine les nombres maxima de noeuds sommets, 
* de noeuds sur les aretes, de noeuds sur les faces, de noeuds internes
* pour un type d'interpolation donnee et tous les elements d'un maillage.
*  
*-- Arguments d'entree -- 
* INTERP numero de type de l'interpolation
* NBBBLK nombre de blocs d'elements consecutifs de meme type  
* NU1BLK numero de type des elements du premier bloc  
* BLOKEL description des elements du maillage par bloc
*-- Arguments de sortie --
* NESOME nombre maximum de noeuds sommets dans un element
* NEARET nombre maximum de noeuds non sommets sur les aretes
* NEFACE nombre maximum de noeuds sur les faces non situes sur les aretes 
* NEINTE nombre maximum de noeuds internes
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       INTERP,NBBBLK,NU1BLK,BLOKEL(*),NUNEFA(*),NUDLFA(*)
     &             ,NESOME,NEARET,NEFACE,NEINTE
*
      INTEGER       LGEBLK,PTRBLK,NUBBLK,NUTYPE,NUTGEO,NDIMEL,LAGHER
     &             ,KCLASS,NESOMT,NBARET,NBFACE,NBNEEL,NBDLEL
     &             ,NBNEAX,NBDLAX,NBNEFX,NBDLFX,NUFACE,NUTYFA
     &             ,NESOML,NEAREL,NEFACL,NEINTL,NEAREW,NEFACW,NTYPFO
      PARAMETER (NTYPFO = 1000)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*NeElem*')
*
*     Initialisation des parametres correspondant au 1er bloc d'elements
*
      NUTGEO = NU1BLK
      NDIMEL = NUTGEO/(10*NTYPFO) 
      NUTYPE = INTERP+NTYPFO*(NUTGEO/NTYPFO)
      CALL ELEMNB (NUTYPE,LAGHER,KCLASS,NESOMT,NBARET,NBFACE
     &                   ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
      CALL ELEMNE (NUTYPE,NESOME,NEARET,NEFACE,NEINTE)                  !ef3d
      NEARET=0
      NEFACE=0
*
      IF (INTERP.GT.0) THEN
*
      IF (NDIMEL.GT.1) THEN
            DO 1 NUFACE=1,NBARET
               CALL ELEMFA (NUTYPE,1,NUFACE,NUTYFA
     &                     ,NBNEEL,NUNEFA,NBDLEL,NUDLFA)                !ef3d
               CALL ELEMNE (NUTYFA,NESOML,NEAREW,NEFACW,NEAREL)         !ef3d
               NEARET = MAX (NEARET,NEAREL)
1           CONTINUE
         ENDIF
*
         IF (NDIMEL.GT.2) THEN
            DO 2 NUFACE=1,NBFACE
               CALL ELEMFA (NUTYPE,2,NUFACE,NUTYFA
     &                     ,NBNEEL,NUNEFA,NBDLEL,NUDLFA)                !ef3d
               CALL ELEMNE (NUTYFA,NESOML,NEAREW,NEFACW,NEFACL)         !ef3d
               NEFACE = MAX (NEFACE,NEFACL)
2           CONTINUE
         ENDIF
*
         IF (NBBBLK.GT.1) THEN  
*  
            LGEBLK = BLOKEL(1) 
            PTRBLK = LGEBLK+2+BLOKEL(3)
            DO 100 NUBBLK = 2,BLOKEL(2)
               NUTGEO = BLOKEL(PTRBLK)
               NDIMEL = NUTGEO/(10*NTYPFO) 
               NUTYPE = INTERP+NTYPFO*(NUTGEO/NTYPFO)
               CALL ELEMNE (NUTYPE,NESOML,NEAREL,NEFACL,NEINTL)         !ef3d
               NESOME=MAX(NESOME,NESOML)
               NEINTE=MAX(NEINTL,NEINTE)
*
               IF (NDIMEL.GT.1) THEN
                  DO 11 NUFACE=1,NBARET
                     CALL ELEMFA (NUTYPE,1,NUFACE,NUTYFA
     &                           ,NBNEEL,NUNEFA,NBDLEL,NUDLFA)          !ef3d
                     CALL ELEMNE (NUTYFA,NESOML,NEAREW,NEFACW,NEAREL)   !ef3d
                     NEARET = MAX (NEARET,NEAREL)
11                CONTINUE
               ENDIF
*
               IF (NDIMEL.GT.2) THEN
                  DO 12 NUFACE=1,NBFACE
                     CALL ELEMFA (NUTYPE,2,NUFACE,NUTYFA
     &                           ,NBNEEL,NUNEFA,NBDLEL,NUDLFA)          !ef3d
                     CALL ELEMNE (NUTYFA,NESOML,NEAREW,NEFACW,NEFACL)   !ef3d
                     NEFACE = MAX (NEFACE,NEFACL)
12                CONTINUE
               ENDIF
*
               PTRBLK = PTRBLK+BLOKEL(3)
100         CONTINUE
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*NeElem*')  
                                                                    END !NeElem
