*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE NUDUNI (DOMAIN,INTERP,NBNOEX,NBUNIO,NVUNIO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996)
* Derniere modification : D.Martin (30 Mai 2000)
* Version # 1.0.1
*
* Union de numerotations de plusieurs domaines pour une interpolation donnee
*
*-- Arguments d'entree --
* DOMAIN chaine de caracteres decrivant les noms des domaines
*        structuree sous la forme de domaines separes par des &
* INTERP numero de l'interpolation
* NBNOEX nombre maximum de noeuds de l'union
*-- Argument de sortie --
* NBUNIO nombre de noeuds de l'union
* NVUNIO niveau du tableau de numerotation #GNEDO resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) DOMAIN
      INTEGER       INTERP,NBNOEX,NBUNIO,NVUNIO
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       KELCHN,KLNIVE
      INTEGER       MCTRDO,MCMDOM,LGERDO,NBDOMK,INCRDO,NCHDOM
     &             ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ,JNDEXC,IDLHRC
     &             ,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC
     &             ,JNDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &             ,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM
     &             ,ARTIFN,ARTIDB,UNIOND,NWDOMG,LGDOMA,LGUNIO,ADUNIO
     &             ,NVNUME,ADDBDX,ADDBDO,ADNUME
      CHARACTER     ERCODE*120,UNION*7
      COMMON/FORMAH/ERCODE
      DATA UNION/' Union '/
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*NuDUni*')
      NVUNIO=0
      NBUNIO=0
      LGUNIO=LEN (UNION)
      LGDOMA=LEN (DOMAIN)
      ARTIDB=1
      UNIOND=INDEX (DOMAIN(ARTIDB:LGDOMA),UNION)
      IF (UNIOND.GT.0) THEN
         NVUNIO=KLNIVE ()                                               !sdexplo
         CALL TBCREE ('#GNEDO',NVUNIO,1,2+NBNOEX,'c')
      ENDIF
*
*     Recherche des noms des domaines et creation de l'union
*     des numerotations
*
      CALL TBAR2  (ERCODE,'#TERDO',1,MCTRDO,'#OMDOM',1,MCMDOM)
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,INCRDO,NCHDOM)             !utilite
*
1     IF (UNIOND.LE.0) THEN
         ARTIFN=LGDOMA
      ELSE
         ARTIFN=UNIOND-1
      ENDIF
*     Nom du domaine courant
      NUDOMG=KELCHN (DOMAIN(ARTIDB:ARTIFN),AST(MCMDOM),NBDOMG,NCHDOM)   !utilite
      IF (NUDOMG.LE.0) CALL ERDOMA (1,DOMAIN(ARTIDB:ARTIFN))            !utilite
*     Recherche d'un domaine de calcul avec la bonne interpolation
*     en ligne ou en colonne dans la structure #TERDO
*     Calcul de la longueur de #TERDO
      ADDBDX=MCTRDO+LGERDO  
      DO 10 NUDOMK=1,NBDOMK
         NBTRDO=IST(ADDBDX+INCRDO-2)
         ADDBDX=ADDBDX+INCRDO+NBTRDO
10    CONTINUE
      ADDBDX=ADDBDX-1
*     Parcours de #TERDO pour trouver la bonne adresse 
      NBTRDO=0 
      ADDBDO=MCTRDO+LGERDO-INCRDO
11    ADDBDO=ADDBDO+INCRDO+NBTRDO 
      IF (ADDBDO.GT.ADDBDX) CALL ERDOMA (2,DOMAIN(ARTIDB:ARTIFN))       !utilite
      NWDOMG=IST(ADDBDO) 
      IF (NUDOMG.EQ.NWDOMG) THEN 
*        On a trouve un domaine geometrique portant le bon nom
         CALL GETDOM (IST(ADDBDO)  ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &               ,JNDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &               ,NBDLFX,NVNUMC
     &               ,JNDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &               ,NBDLFY,NVNUML,NVCORC,INUTIL,NBTRDO,NIVDOM)        !sdexplo
         IF (INTRPC.EQ.INTERP) THEN
            IF (JNDEXC.NE.0) GOTO 11
            NVNUME=NVNUMC
         ELSEIF (INTRPL.EQ.INTERP) THEN
            IF (JNDEXL.NE.0) GOTO 11
            NVNUME=NVNUML
         ELSE
            GOTO 11
         ENDIF
      ELSE 
         NBTRDO=IST(ADDBDO+INCRDO-2)
         GOTO 11
      ENDIF
*
      IF (NVUNIO.GT.0) THEN
         CALL TBRR1  (ERCODE,'#GNEDO',NVNUME,ADNUME)
*        Cas ou il y a plusieurs domaines
         CALL TBAR2  (ERCODE,'#GNEDO',NVNUME,ADNUME
     &                      ,'#GNEDO',NVUNIO,ADUNIO)
         IF (NBUNIO.EQ.0) THEN
*           Premier domaine
            NBUNIO=IST(ADNUME+1)
            CALL TDANST (NBUNIO,'E',ADNUME+2,IST,RST,CST
     &                         ,'E',ADUNIO+2,IST,RST,CST)
         ELSE
*           Domaines suivants
            CALL LISUNI (NBUNIO,IST(ADUNIO+2),IST(ADNUME+1)
     &                  ,IST(ADNUME+2),.FALSE.,IST(ADNUME+2),.TRUE.
     &                  ,NBNOEX,*99990)                                 !utilite
         ENDIF
         IST(ADUNIO)=0
         IST(ADUNIO+1)=NBUNIO
         CALL TBSAVE ('#GNEDO',NVNUME)                                  !utilite
         IF (ARTIFN.LT.LGDOMA) THEN
            ARTIDB=ARTIFN+LGUNIO+1
            CALL TBAR2  (ERCODE,'#TERDO',1,MCTRDO,'#OMDOM',1,MCMDOM)
            UNIOND=INDEX (DOMAIN(ARTIDB:LGDOMA),UNION)
            GOTO 1
         ENDIF
      ENDIF
*
      IF (NBUNIO.GT.0) THEN
         CALL TBAJST ('#GNEDO',NVUNIO,NBUNIO+2)
      ELSE
*        Cas d'un seul domaine
         NVUNIO=NVNUME
         CALL TBRR1  (ERCODE,'#GNEDO',NVUNIO,ADUNIO)
         CALL TBAR1  (ERCODE,'#GNEDO',NVUNIO,ADUNIO)
         NBUNIO=IST(ADUNIO+1)
      ENDIF
      CALL TBSAVE ('#GNEDO',NVUNIO)
      CALL PRFXMJ (-1,'*NuDUni*')    
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL BAISE  ('Erreur interne!')
                                                                    END !NuDUni
      

