*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PRO2DL (NVSTOK,NCPINL,NCPINC,ITYSYM,NMTERM,NVTERM
     &                  ,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 1998)  
* Derniere modification : D.Martin (03 novembre 2008)
* Version 2
*  
* Calcul des tables de stockage PROFIL de compactage pour inconnue(s) vectorielle(s)
* a partir des tables PROFIL de stockage en noeuds.
*  
*-- Arguments d'entree -- 
* NVSTOK niveau commun des tables de stockage PROFIL
* NCPINL nombre de composantes de l'inconnue en ligne
* NCPINC nombre de composantes de l'inconnue en colonne
* ITYSYM indicateur de structure symetrique
* NMTERM nom du terme correspondant (pour impression)
* NVTERM niveau du terme
* NIVIMP niveau d'impression du terme 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVSTOK,NCPINL,NCPINC,ITYSYM,NVTERM,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER STODLN*6
      INTEGER INDSTO
      INTEGER MCSTON,MCSTOK,LGSTOK,NBLIDL,NBCODL,NCHTRM,NCHT
     &       ,NBL,MCLENV,LGL,MCLVDL,NBC,MCUENV,LGU,MCUVDL
      CHARACTER ERCODE*120,NMSTOK*6,NMSTON*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Pro2dl*')
*
      ERCODE(1:1)='!'
      NMSTOK = STODLN (INDSTO('PROFIL'),NCPINC, NCPINL)
      NMSTON='&PROFL'
      CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTON)
      IF (ERCODE(1:1).NE.' ') THEN
         CALL TBRR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL TBAR1  (ERCODE,NMSTON,NVSTOK,MCSTON)
         CALL EXPROF (MCSTON,IST(MCSTON),NBL,MCLENV,LGL
     &                                  ,NBC,MCUENV,LGU)                !sdexplo
         LGSTOK=2+NBL*NCPINL
         IF (ITYSYM.EQ.NDFSYM) LGSTOK=LGSTOK+NBC*NCPINC+1
         CALL TBCREE (NMSTOK,NVSTOK,1,LGSTOK,'c')
         CALL TBAR2  (ERCODE,NMSTON,NVSTOK,MCSTON
     &                      ,NMSTOK,NVSTOK,MCSTOK)
*        La creation du tableau ci-dessus a pu modifier les adresses ...
         CALL EXPROF (MCSTON,IST(MCSTON),NBL,MCLENV,LGL
     &                                  ,NBC,MCUENV,LGU)                !sdexplo
         MCLVDL=MCSTOK+2
         CALL N2DLPR (NCPINC,NCPINL,NBL,NBC,IST(MCLENV),NBLIDL
     &               ,IST(MCLVDL))                                      !sdexplo
         IST(MCSTOK)=2
         IST(MCLVDL-1)=NBLIDL
         IF (ITYSYM.EQ.NDFSYM) THEN
            IST(MCSTOK)=3+NBLIDL
            MCUVDL=MCLVDL+NBLIDL+1
            CALL N2DLPR (NCPINL,NCPINC,NBC,NBL,IST(MCUENV),NBCODL
     &                  ,IST(MCUVDL))                                   !sdexplo
            IST(MCUVDL-1)=NBCODL
         ENDIF
*
         IF (NIVIMP.GE.5) THEN
            NCHTRM=LEN(NMTERM)
            DO 1 NCHT=1,NCHTRM
               IF (NMTERM(NCHT:NCHT).EQ.' ') GOTO 2
1           CONTINUE
            NCHT=NCHTRM
2           CALL PRPROF (IST(MCSTOK),'Tables Profil en d.l. pour'
     &                  ,NMTERM(1:NCHT),NVTERM,NIVIMP,IMPSDR)           !prsd
         ENDIF
         CALL TBSAVE (NMSTON,NVSTOK)
      ENDIF
      CALL PRFXMJ (-1,'*Pro2dl*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre/03 novembre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1 : D.Martin (10 Septembre 1999)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      
                                                                    END !Pro2dl
