*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PUTDOM (ITERDO,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &                  ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX
     &                  ,NBNEFX,NBDLFX,NVNUMC
     &                  ,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY
     &                  ,NBNEFY,NBDLFY,NVNUML
     &                  ,NVCORC,INUTIL,NBTRDO,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Octobre 1989) 
* Derniere modification : D.Martin (5 Mai 2001)
* Version 1.0.1
*  
* Mise a jour de la structure de donnees #TERDO pour un domaine
*  
*-- Arguments d'entree -- 
* ITERDO structure #TERDO a l'adresse concernant le domaine en cours  
* NUDOMG numero du domaine geometrique
* NUDOMK numero du domaine de calcul  
* IGEOME indice de calculs geometriques
* INDMIX indice de mixite des interpolations en colonne et ligne  
* NUSCHQ numero du schema de quadrature sur le domaine
* INDEXC indice d'extension du domaine geometrique en colonne 
* IDLHRC indice d'interpolation d'Hermite en colonne  
* INTRPC numero de l'interpolation en colonne 
* NBNECX nombre max. de noeuds en colonne pour un terme dans un elt. du domaine
* NBNEEX max. de noeuds d'un elt du domaine pour l'interpolation en colonne
* NBDLEX max. de d.l. d'un elt du domaine pour l'interpolation en colonne 
* NBNEFX max. de noeuds dune face d'un elt  pour l'interpolation en colonne
* NBDLFX max. de d.l. d'une face d'un elt. pour l'interpolation en colonne
* NVNUMC niveau du tableau #GNEDO de numerotation des noeuds en colonne
* INDEXL indice d'extension du domaine geometrique en ligne
* IDLHRL indice d'interpolation d'Hermite en ligne
* INTRPL numero de l'interpolation en ligne
* NBNELX nombre max. de noeuds en ligne pour un terme dans un elt. du domaine 
* NBNEEY max. de noeuds d'un elt du domaine pour l'interpolation en ligne 
* NBDLEY max. de d.l. d'un elt du domaine pour l'interpolation en ligne
* NBNEFY max. de noeuds dune face d'un elt  pour l'interpolation en ligne 
* NBDLFY max. de d.l. d'une face d'un elt. pour l'interpolation en colonne
* NVNUML niveau du tableau #GNEDO de numerotation des noeuds en ligne 
* NVCORC niveau du tableau &NORMA sur le domaine
* INUTIL inutilise
* NBTRDO nombre de termes sur le domaine  
* NIVIMP niveau d'impression sur le domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER ITERDO(*),NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ,INDEXC,IDLHRC
     &       ,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC,INDEXL
     &       ,IDLHRL,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY,NBDLFY,NVNUML
     &       ,NVCORC,INUTIL,NBTRDO,NIVIMP
*-----------------------------------------------------------------------
      ITERDO(1)=NUDOMG 
      ITERDO(2)=NUDOMK 
      ITERDO(3)=IGEOME 
      ITERDO(4)=INDMIX 
      ITERDO(5)=NUSCHQ
      ITERDO(6)=INDEXC 
      ITERDO(7)=IDLHRC 
      ITERDO(8)=INTRPC 
      ITERDO(9)=NBNECX 
      ITERDO(10)=NBNEEX
      ITERDO(11)=NBDLEX
      ITERDO(12)=NBNEFX
      ITERDO(13)=NBDLFX
      ITERDO(14)=NVNUMC
      ITERDO(15)=INDEXL
      ITERDO(16)=IDLHRL
      ITERDO(17)=INTRPL
      ITERDO(18)=NBNELX
      ITERDO(19)=NBNEEY
      ITERDO(20)=NBDLEY
      ITERDO(21)=NBNEFY
      ITERDO(22)=NBDLFY
      ITERDO(23)=NVNUML
      ITERDO(24)=NVCORC
      ITERDO(25)=INUTIL
      ITERDO(26)=NBTRDO
      ITERDO(27)=NIVIMP
                                                                    END !Putdom
