*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TUTERM (NMTERM,NVTERM)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998) 
* Derniere modification : D.Martin (24 juin 2010)
* Version 3
*
* Destruction d'un terme, et le cas echeant, des tableaux de numerotation
* et de stockage qui lui sont associes
*  
*-- Arguments d'entree -- 
* NMTERM nom du terme
* NVTERM niveau du terme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       NVTERM
*  
      INCLUDE 'CONTEX'
      INCLUDE 'ALLOC'
*
      CHARACTER     STODLN*6
      INTEGER       INDSTO,KLTERM
      INTEGER       MCMTRM,MCDTRM,MCINCO,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NUTERM,IADTRM,NWTERM,ITTERM,ITYCAL,NUKALE,NUDONN
     &             ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &             ,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO
     &             ,NIVIMP,NFOUNS,NFOUNC,NFOUNL,NFOUDC,NFOUDL,LGSTOK
     &             ,NCPINC,INTERP,NBTNEU,NCPINL
      CHARACTER     ERCODE*120,NMSTOK*6
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*TuTerm*')
*  
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
      NUTERM=KLTERM (NMTERM,NVTERM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.GT.0) THEN 
*
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM)  ,NWTERM,ITTERM,ITYCAL,NUKALE,NUDONN 
     &               ,ITYSYM,NVDSMB,NUINCC,NVDUMC,NBCOLO,NVNUMC,NUINCL
     &               ,NVDUML,NBLIGN,NVNUML,INSTOK,NVSTOK,NVCOOR,IATRDO
     &               ,NIVIMP)                                           !sdexplo
        NCPINC=1
        IF (NUINCC.NE.NDFINC)
     &     CALL SDEXCO (NUINCC,IST(MCINCO),NCPINC,INTERP,NBTNEU)
        NCPINL=NCPINC
        IF (NUINCL.NE.NDFINC.AND.NUINCL.NE.NUINCC)
     &     CALL SDEXCO (NUINCL,IST(MCINCO),NCPINL,INTERP,NBTNEU)
*
*        recherche des tableaux de numerotation inutiles
*
*        tableau de stockage
         NFOUNS=1
         IF (NVSTOK.NE.NDFSTO) 
     &      CALL CNTSTK (INSTOK,NVSTOK,NUTERM,NFOUNS)                   !sdexplo
*        tableau de numerotation des noeuds en colonne
         NFOUNC=1
         IF (NVNUMC.GT.0) 
     &      CALL CNTGDO (NVNUMC,NUTERM,NFOUNC)                          !sdexplo
*        tableau de numerotation des noeuds en ligne
         NFOUNL=1
         IF (NVNUMC.GT.0.AND.NVNUMC.NE.NVNUMC) 
     &      CALL CNTGDO (NVNUML,NUTERM,NFOUNL)                          !sdexplo
*        tableau de numerotation des d.l. en colonne
         NFOUDC=1
         IF (NVDUMC.GT.0) 
     &      CALL CNTGDO (NVDUMC,NUTERM,NFOUDC)                          !sdexplo
*        tableau de numerotation des d.l. en ligne
         NFOUDL=1
         IF (NVDUMC.GT.0.AND.NVDUMC.NE.NVDUML) 
     &      CALL CNTGDO (NVDUML,NUTERM,NFOUDL)                          !sdexplo
*
         CALL PUTTRM (IST(IADTRM)  ,NVTERM,0,0,0,0,NDFSYM,NDFDSM
     &               ,0,NDFDUM,0,NDFNUM,0,NDFDUM,0,NDFNUM
     &               ,0,NDFSTO,NDFCOR,0,0)                              !sdexplo
*
*        destruction du terme et de ses tableaux de numerotations inutiles
*
         CALL TBTUER (NMTERM,NVTERM)
*
*        tableaux de numerotation comptes en noeuds ou d.l.
         IF (NFOUNC.LE.0) CALL TBTUER ('#GNEDO',NVNUMC)
         IF (NFOUNL.LE.0) CALL TBTUER ('#GNEDO',NVNUML)
         IF (NFOUDC.LE.0) CALL TBTUER ('#GNEDO',NVDUMC)
         IF (NFOUDL.LE.0) CALL TBTUER ('#GNEDO',NVDUML)
*
*        tableau de stockage matriciel
         IF (NFOUNS.LE.0) THEN
            NMSTOK = STODLN (INSTOK,1,1)
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGSTOK)
            IF (ERCODE(1:1).NE.' ') THEN
               NMSTOK = STODLN (INSTOK,NCPINC,NCPINL)
               ERCODE(1:1)='!'
               CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,LGSTOK)
            ENDIF
            IF (ERCODE(1:1).EQ.' ') CALL TBTUER (NMSTOK,NVSTOK)
         ENDIF
      ENDIF
*
      CALL PRFXMJ (-1,'*TuTerm*')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (24 juin 2010)
* argument ERCODE oublie (!) dans les appels de TBRR1
* Version 2 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (16 novembre 2005)
* Version 1. : D.Martin (31 Mars 1998)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !TuTerm
