*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE XETERM (NMTRM1,NVTRM1,NOMDOM,INDEXC,INDEXL
     &                  ,NMTRM2,NVTRM2,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Janvier 1996) 
* Derniere modification : D.Martin (9 Avril 2002)
* Version 1.0.2
*  
* Extraction d'un terme a partir d'un terme vectoriel source
* selon le complementaire de la numerotation en ligne d'un domaine (!)
*  
*-- Arguments d'entree ---
* NMTRM1,NVTRM1 nom et niveau du vecteur source
* NOMDOM        nom du domaine sur lequel on realise l'extraction  
* INDEXC indice d'extension recherche en colonne (negatif si sans importance)  
* INDEXL indice d'extension recherche en ligne (negatif si sans importance)
* NMTRM2,NVTRM2 nom et niveau du vecteur resultat
* NIVIMP niveau d'impression du vecteur resultat
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMTRM1,NMTRM2,NOMDOM
      INTEGER       NVTRM1,INDEXC,INDEXL,NVTRM2,NIVIMP
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER ERCODE*120,TYPINT,TYTRM1
      INTEGER   INDSTO,KLTERM,KLNIVE
      INTEGER   LGMTRM,LGDTRM,MCMTRM,MCDTRM,MCMDOM,MCTRDO,MCINCO
     &         ,LGETRM,NBTERM,INCTRM,NCHTRM,NWHTRM,NUTERM,IADTRM
     &         ,NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &         ,NUINCC,NVDUMC,NBNEC1,NVNUC1,NUINCL,NVDUML,NBNEL1,NVNUL1
     &         ,INSTOK,NVSTOK,NVCORT,IATRDO,NIVDOM
     &         ,NUDOMK,NUDOMG,IGEOME,INDMIX,NUSCHQ,NBDLFX,NVNUUU
     &         ,INDECC,IDLHRC,INTRDC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &         ,INDELL,IDLHRL,INTRDL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &         ,NBDLFY,NVNUMD,NVCOOR,INUTIL,NBTRDO,NCPINC,INTRPC,NBTNEC
     &         ,IATOLD,NVVOLD,ITYOLD,NVAOLD,ITYCLD,NUKALD
     &         ,NUCOLD,NVDUCZ,NBNECZ,NVNUCZ,NULOLD,NVDULZ,NBNELZ,NVNULZ
     &         ,NIVOLD,MCTRM1,MCNUM1,MCTRM2,MCNUM2
     &         ,NVNUM2,NBNEE2,MCNUMD,NBNEUD,MCNURZ,LGREEL,NNEUTI
     &         ,ID,IF,NCATR1,NCATR2,ITEMD1,NBDEUT,NVDUM2,MCDUM2
     &         ,MCDUMT,LGNEDO,NBNERS,NBDLRS,MCNEEE
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Xeterm*')
*
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR5  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#OMDOM',1,MCMDOM,'#TERDO',1,MCTRDO
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*     Caracteristiques du terme original
* 
      NUTERM=KLTERM (NMTRM1,NVTRM1,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRM1,NVTRM1)                    !Utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1))  ,NIVEAU
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,NVALNE,NVDSMB
     &            ,NUINCC,NVDUMC,NBNEC1,NVNUC1
     &            ,NUINCL,NVDUML,NBNEL1,NVNUL1
     &            ,INSTOK,NVSTOK,NVCORT,IATRDO,NIVDOM)                  !sdexplo
      IF (NUINCL.EQ.NDFINC) THEN
         NUINCL=NUINCC
         NBNEL1=NBNEC1
         NVNUL1=NVNUC1
      ENDIF
      CALL SDEXCO (NUINCL,IST(MCINCO),NCPINC,INTRPC,NBTNEC)             !utilite
      IF (NUINCL.LE.0) CALL ERTERM (22,NMTRM1,NVTRM1)                   !utilite
      TYTRM1=TYPINT (ITYPTR)                                            !utilite
*
      NBDEUT=NBNEL1*NCPINC
      IF (NCPINC.GT.1) THEN
*        Cas d'un terme a inconnues vectorielles
         IF (NVDUML.LT.0) NVDUML=KLNIVE ()                              !sdexplo
         CALL PUTTRM (IST(IADTRM),NIVEAU,ITYPTR,ITYCAL,NUKALE,NUDONN
     &               ,NDFSYM,NVDSMB,NDFINC,NDFDUM,1,NDFNUM,NUINCL
     &               ,NVDUML,NBNEL1,NVNUL1,INDSTO('PLEIN-L'),NDFSTO
     &               ,NVCORT,IATRDO,NIVDOM)                             !sdexplo
      ENDIF
*
*     Caracteristiques du domaine
*
      CALL KLDOMN (NOMDOM,INDEXC,INDEXL
     &            ,IST(MCTRDO),AST(MCMDOM),NBDOMG,NUDOMK,IATRDO)        !sdexplo
      CALL GETDOM (IST(MCTRDO+IATRDO)
     &            ,NUDOMG,NUDOMK,IGEOME,INDMIX,NUSCHQ
     &            ,INDECC,IDLHRC,INTRDC,NBNECX,NBNEEX,NBDLEX
     &            ,NBNEFX,NBDLFX,NVNUUU
     &            ,INDELL,IDLHRL,INTRDL,NBNELX,NBNEEY,NBDLEY,NBNEFY
     &            ,NBDLFY,NVNUMD,NVCOOR,INUTIL,NBTRDO,NIVDOM)           !sdexplo
*
*     Mise a jour des structures de description pour le vecteur resultat
*
      NUTERM=KLTERM (NMTRM2,NVTRM2,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) THEN 
         CALL ALFANU (NBCHNT,NMTRM2)                                    !Utilite
         CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)         !sdexplo
         NWHTRM=MAX (NCHTRM,LEN (NMTRM2))
         CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)              !sdexplo
         CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#OMTRM',1,MCMTRM)
         CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMTRM2)                 !utilite
         CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !utilite
         NUTERM=NBTERM 
         IATOLD=IATRDO+1  
         NUDONN=0
         NBNELZ=0 
      ELSE 
         CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVOLD
     &               ,ITYOLD,ITYCLD,NUKALD,NUDONN,NVAOLD,NVDSMB
     &               ,NUCOLD,NVDUCZ,NBNECZ,NVNUCZ
     &               ,NULOLD,NVDULZ,NBNELZ,NVNULZ
     &               ,INSTOK,NVSTOK,NVCORT,IATOLD,NIVOLD)               !sdexplo
      ENDIF
*
*     On recherche si la numerotation du domaine est un sous-ensemble
*     de la numerotation du terme; ceci correspond par exemple au cas 
*     courant ou le domaine d'extraction est un bord du domaine sur
*     lequel le terme source est calcule
*
      CALL TBRR3  (ERCODE, NMTRM1 ,NVTRM1,MCTRM1
     &                   ,'#GNEDO',NVNUL1,MCNUM1,'#GNEDO',NVNUMD,MCNUMD)
      CALL TBAR2  (ERCODE,'#GNEDO',NVNUL1,MCNUM1,'#GNEDO',NVNUMD,MCNUMD)
      NBNEUD=IST(MCNUMD+1)
      NVNUM2=NVNUMD
      NVDUM2=0
*
*        Creation de la numerotation du complementaire de la numerotation
*        en ligne du domaine dans celle du terme source
2        IF (NBNELZ.NE.0) CALL TBRR1  (ERCODE,'#GNEDO',NVNULZ,MCNURZ)
         NVNUM2=KLNIVE ()                                               !sdexplo
         LGNEDO=MAX(NBNEUD,NBNEL1)+2
         CALL TBCRSU ('#GNEDO',NVNUM2,1,LGNEDO,LGREEL,'c')
         CALL TBAR3  (ERCODE,'#GNEDO',NVNUL1,MCNUM1                     
     &               ,'#GNEDO',NVNUMD,MCNUMD,'#GNEDO',NVNUM2,MCNUM2)
         CALL LISCOM (NBNEL1,IST(MCNUM1+2),NBNEUD,IST(MCNUMD+2)
     &               ,NBNERS,IST(MCNUM2+2),LGREEL-2,*99993)             !Utilite
         IST(MCNUM2)  =0
         IST(MCNUM2+1)=NBNERS
         IF (NBNERS.LT.LGREEL-2) CALL TBAJST ('#GNEDO',NVNUM2,NBNERS+2) !Utilite
*
*        L'ancienne numerotation du terme est elle correcte ?
         IF (NBNELZ.NE.0) THEN
            CALL TBAR2  (ERCODE,'#GNEDO',NVNULZ,MCNURZ
     &                         ,'#GNEDO',NVNUM2,MCNUM2)
            CALL LISINC (NBNELZ,IST(MCNURZ+2),NBNERS,IST(MCNUM2+2)
     &                  ,ID,IF,*3)                                      !Utilite
3           IF (NBNERS.EQ.NBNELZ) THEN
*              La numerotation preexiste et est correcte
               CALL TBTUER ('#GNEDO',NVNUM2)                            !Utilite
               NVNUM2=NVNULZ
               NVDUM2=NVDULZ
               LGREEL=NBNERS+2
            ENDIF
         ENDIF
*
      NBDLRS=NBNERS
      IF (NCPINC.GT.1) THEN
*        Cas d'une inconnue vectorielle: numerotation en d.l.
         NBDLRS=NBNERS*NCPINC
         IF (NVDUM2.LT.0) NVDUM2=KLNIVE ()                              !sdexplo
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,'#GNEDO',NVDUM2,MCDUM2)
         IF (ERCODE(1:1).NE.' ') THEN
            CALL TBCREE ('#GNEDO',NVDUM2,1,2+NBDLRS,'c')
            CALL TBRR1  (ERCODE,'#GNEDO',NVNUM2,MCNUM2)
            CALL TBAR2  (ERCODE,'#GNEDO',NVNUM2,MCNUM2
     &                         ,'#GNEDO',NVDUM2,MCDUM2)
            CALL N2DLNU (NCPINC,IST(MCNUM2+1),IST(MCNUM2+2)
     &                         ,IST(MCDUM2+1),IST(MCDUM2+2))            !sdexplo
            IST(MCDUM2)=IST(MCNUM2)
            IF (NIVIMP.GE.2) CALL PRNEDO ('*Xeterm*','Colonne (d.l.)'   !prsd
     &                                   ,IST(MCDUM2),IMPSDR)
         ENDIF
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,'#GNEDO',NVDUML,MCDUM2)
         IF (ERCODE(1:1).NE.' ') THEN
            CALL TBCREE ('#GNEDO',NVDUML,1,2+NBDEUT,'c')
            CALL TBRR1  (ERCODE,'#GNEDO',NVNUL1,MCNUM1)
            CALL TBAR2  (ERCODE,'#GNEDO',NVNUL1,MCNUM1
     &                         ,'#GNEDO',NVDUML,MCDUMT)
            CALL N2DLNU (NCPINC,IST(MCNUM1+1),IST(MCNUM1+2) 
     &                         ,IST(MCDUMT+1),IST(MCDUMT+2))            !sdexplo
            IST(MCDUMT)=IST(MCNUM1)
            IF (NIVIMP.GE.2) CALL PRNEDO ('*Xeterm*','Colonne (d.l.)'   !prsd
     &                                   ,IST(MCDUMT),IMPSDR)
         ENDIF
      ENDIF
*
*     Creation du terme resultat
      CALL TBCREE (NMTRM2,NVTRM2,ITYPTR,NBDLRS,'c')
*
      IF (NCPINC.GT.1) THEN
      CALL TBAR4  (ERCODE,'#GNEDO',NVDUML,MCNUM1,'#GNEDO',NVDUM2,MCNUM2
     &                   , NMTRM1 ,NVTRM1,MCTRM1, NMTRM2 ,NVTRM2,MCTRM2)
      ELSE 
      CALL TBAR4  (ERCODE,'#GNEDO',NVNUL1,MCNUM1,'#GNEDO',NVNUM2,MCNUM2 
     &                   , NMTRM1 ,NVTRM1,MCTRM1, NMTRM2 ,NVTRM2,MCTRM2)
      ENDIF
*  
*     Extraction du terme pour les noeuds du complementaire des numerotations 
*     du terme source et du domaine
      ITEMD1=1
      MCNEEE=MCNUM2+2
      IF (TYTRM1.EQ.'R') THEN
         DO 22 NBNEE2=1,NBDLRS
            CALL DICOTO (ITEMD1,NBDEUT,IST(MCNUM1+2),IST(MCNEEE) 
     &                 ,NNEUTI,*22)                                     !utilite
            ITEMD1=NNEUTI+1
            RST(MCTRM2)=RST(MCTRM1+NNEUTI-1)
            MCTRM2=MCTRM2+1
            MCNEEE=MCNEEE+1
22       CONTINUE
      ELSE
         DO 42 NBNEE2=1,NBDLRS
            CALL DICOTO (ITEMD1,NBDEUT,IST(MCNUM1+2),IST(MCNEEE) 
     &                 ,NNEUTI,*42)                                     !utilite
            ITEMD1=NNEUTI+1
            CST(MCTRM2)=CST(MCTRM1+NNEUTI-1)
            MCTRM2=MCTRM2+1
            MCNEEE=MCNEEE+1
42       CONTINUE
      ENDIF
*
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL PUTTRM (IST(IADTRM) ,NVTRM2,ITYPTR,ITYCAL,NUKALE,NUDONN
     &            ,NDFSYM,NDFDSM,NDFINC,NDFDUM,1,NDFNUM,NUINCL,NVDUM2
     &            ,NBNERS,NVNUM2,INDSTO('PLEIN-L'),NDFSTO,NDFCOR
     &            ,IATOLD,NIVIMP)                                       !sdexplo
*
      IF (NVNUM2.NE.NVNUMD) CALL TBSAVE ('#GNEDO',NVNUM2)
      CALL TBSAVE ('#GNEDO',NVNUL1)
      CALL TBSAVE ('#GNEDO',NVNUMD)
      IF (NCPINC.GT.1) THEN
         CALL TBSAVE ('#GNEDO',NVDUM2)
         CALL TBSAVE ('#GNEDO',NVDUML)
      ENDIF
      CALL TBSAVE (NMTRM1,NVTRM1)
      CALL TBSAVE (NMTRM2,NVTRM2)
*
      IF (NIVIMP.GE.0) THEN
         CALL PRNTRM (NMTRM2,NVTRM2,ERCODE,NCATR1)
         CALL PRNTRM (NMTRM2,NVTRM2,ERCODE(NCATR1+1:),NCATR2)
         ERCODE(NCATR1+NCATR2+1:) =NOMDOM
         IF (NBNEUD.LT.NBNEL1) THEN
            WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &           ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &           ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+16)
         ELSE
            WRITE (IMPPAL,10000) ERCODE(1:NCATR1)
     &           ,ERCODE(NCATR1+1:NCATR1+NCATR2)
     &           ,ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+16)
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*XeTerm*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT (/T2,'*XeTerm* Complementaire du terme ',A,/
     &T10,' dans le terme ',A,' par rapport au domaine ',A)
10001 FORMAT (/T2,'*XeTerm* Le complementaire du terme ',A,/
     &T10,' dans le terme ',A,' par rapport au domaine ',A,' est vide')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99993 CALL PRNTRM (NMTRM2,NVTRM2,ERCODE,NCATR1)
      CALL BAISE  (' La taille du tableau de numerotation pour le terme'
     &            //ERCODE(1:NCATR1)//' est insuffisante')
                                                                    END !Xeterm
