*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEI0 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*
* Fonction de Bessel modifiee I_0 simple precision multipliee par EXP(-x)
*
* Bibliographie : HANDBOOK OF MATHEMATICAL FUNCTIONS  
*                 Ed. M.ABRAMOWITZ et I.A. STEGUN  
*                 Chap. 9 : Bessel Functions of Integer Order (p.375-378)
*
**     Programme principal de test 
*         - valeur de Abramowitz & Stegun pp. 416, 418, 420
*pp      REAL X,BEI0
*pp      IPAGE=416
*pp      WRITE(*,101) IPAGE,'I0(x)','I1(x)','I2(X)'
*pp      X=0.
*pp      WRITE(*,100) X,BEI0(X)
*pp      ISAUT=51
*pp      DO 1 I=1,101
*pp      X=X+0.1 
*pp      IF (I.EQ.ISAUT) THEN 
*pp         ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,101) IPAGE,'I0(x)','I1(x)','I2(X)'
*pp         X=X-0.1  
*pp      ENDIF  
*pp1     WRITE(*,100) X,BEI0(X)
*pp      IPAGE=IPAGE+2
*pp      WRITE(*,101) IPAGE,'I0(x)','I1(x)','I2(X)' 
*pp      X=X-0.2
*pp      DO 2 I=1,51
*pp      X=X+0.2 
*pp2     WRITE(*,100) X,BEI0(X)
*pp100   FORMAT(T2,F5.2,3F15.8)
*pp101   FORMAT('1'//' Page',I4//TR3,'x  ',3(A13,TR2)/)
*pp      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL X,BEI0
*
      DOUBLE PRECISION DT,DX,DZ
      REAL Z,Z2,T2,T3,T4
*-----------------------------------------------------------------------
      IF (ABS(X).LE.15.) THEN
*
*        Developpement en serie (A.-S. page 375)
*
         DX=DBLE(X)
         DT=DX*DX
         DZ=REAL(((((((((((( .14296642417D-21 *DT+.26775691297D-19)*DT
     &                      +.39649021349D-16)*DT+.1440954996D-13 )*DT
     &                      +.57181876042D-11)*DT+.15779772328D-8 )*DT
     &                      +.33519032604D-6 )*DT+.51209299088D-4 )*DT
     &                      +.53658167953D-2 )*DT+.35555776396D0  )*DT
     &                      +.13112613531D+2 )*DT+.21280175822D+3 )*DT
     &                      +.855207051916D+3)/(DT-.855207051055D+3)
         BEI0=-DZ*EXP(-DX)
      ELSE
*
*        Developpement en serie (A.-S. page 377)
*
         Z=30./X-1.
         Z2=Z*Z
         T2=2.*Z2-1.  
         T3=(4.*Z2-3.)*Z  
         T4=(8.*Z2-8.)*Z2+1.  
         BEI0=(.34651983E+6   -.14346463E+6*Z+.78403425E+4*T2
     &        -.11559198E+3*T3+.24392608*T4)
     &      /((.86566528E+6   -.36184778E+6*Z+.20312844E+5*T2
     &        -.32519733E+3*T3+T4)*SQRT(X))
      ENDIF
                                                                    END !BEI0
