*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEJ0 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul de la fonction de Bessel de 1eme espece d'ordre 0 : J0
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL             X,BEJ0
*
      DOUBLE PRECISION ABSX,DX,DX2,DBEJ0,S4SUX2,XMPIS4
*-----------------------------------------------------------------------
      ABSX=ABS (X)
      DX=DBLE (X)
      IF (ABSX.LE.8.) THEN
*
*        Approximation par fraction rationnelle
*
         DX2=DX*DX
         DBEJ0=(((((((( .338483314D-10*DX2-.289552532D-7)*DX2
     &                 +.113825372D-4)*DX2-.258008068D-2)*DX2
     &                 +.351527847D0 )*DX2-.277849812D+2)*DX2
     &                 +.114749848D+4)*DX2-.198342667D+5)*DX2
     &                 +.813241206D+5)
     &               /((DX2+.49676332D+3)*DX2+.813241206D+5)
      ELSE
*
*        Developpements asymptotiques de Hankel (A.-S. page 364)
*
         S4SUX2=64./(DX*DX)
         XMPIS4=DX-.78539816
         DBEJ0=((((( .20938872E-6 *S4SUX2-.20733706E-5)*S4SUX2
     &             +.27345104E-4)*S4SUX2-.10986286E-2)*S4SUX2+1.)
     &             *COS(XMPIS4)
     &    -8.*((((-.93494515E-7 *S4SUX2+.76210952E-6)*S4SUX2
     &             -.69111476E-5)*S4SUX2+.14304888E-3)*S4SUX2
     &             -.15625E-1)/X*SIN(XMPIS4))*.79788456/SQRT(ABSX)
      ENDIF
      BEJ0=REAL(DBEJ0)
                                                                    END !BeJ0
