*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEJ1 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul de la fonction de Bessel de 1eme espece d'ordre 0 : J0
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL             X,BEJ1
*
      REAL             ABSX,XM3PI4,S4SUX2
      DOUBLE PRECISION DX2,DX
*-----------------------------------------------------------------------
      ABSX=ABS (X)
      IF (ABSX.LE.8.) THEN
*
*        Approximation par fraction rationnelle
*
         DX=DBLE(X)
         DX2=DX*DX
         BEJ1=REAL((((((((-.47427072618D-9 *DX2+.35236457401D-6)*DX2
     &                    -.11764050281D-3)*DX2+.21979683808D-1)*DX2
     &                    -.23652383961D+1)*DX2+.13812534164D+3)*DX2
     &                    -.373650260707D+4)*DX2+.31625993793D+5)
     &              /((DX2+.433493017D+3)*DX2+.6325198765D+5)*DX)
      ELSE 
*
*        Developpements asymptotiques de Hankel (A.-S. page 364)
*
         S4SUX2=64./(X*X)
         XM3PI4=X-.23561945E+1
         BEJ1=(((((-.24033702E-6 *S4SUX2+.24575202E-5)*S4SUX2
     &             -.35163965E-4)*S4SUX2+.18310500E-2)*S4SUX2+1.)
     *             *COS(XM3PI4)
     &     -8.*(((( .10578741E-6 *S4SUX2-.88228987E-6)*S4SUX2
     &             +.84491991E-5)*S4SUX2-.20026909E-3)*S4SUX2
     &             +.46875000E-1)/X*SIN(XM3PI4))*.79788456/SQRT(ABSX)
      ENDIF
                                                                    END !BeJ1
