*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        SUBROUTINE BEJN (X,N,J) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul des fonctions de Bessel standard de 1ere espece d'ordre 0 a N 
* (par recurrence regressive)  
*  
**     Programme principal de test - 
*      valeur de Abramowitz & Stegun pp. 390, 392, 394, 396, 398, 400
*pp   REAL JN(0:9)  
*pp      IPAGE=390
*pp      WRITE(*,101) IPAGE,'J0(x)','J1(x)','J2(x)'  
*pp      X=0.
*pp      CALL BEJN(X,2,JN)  
*pp      WRITE(*,100) X,(JN(K),K=0,2)
*pp      ISAUT=51
*pp      DO 1 I=1,178
*pp      X=X+0.1 
*pp      IF(I.EQ.ISAUT) THEN 
*pp         ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,101) IPAGE,'J0(x)','J1(x)','J2(x)'
*pp         X=X-0.1  
*pp      ENDIF  
*pp      CALL BEJN(X,2,JN)
*pp1     WRITE(*,100) X,(JN(K),K=0,2)
*pp100   FORMAT(T2,F5.2,3F15.8)
*pp101   FORMAT('1'//' Page',I4//(TR3,'x  ',3(A13,TR2))/)
*pp      IPAGE=398
*pp      WRITE(*,201) IPAGE,'J3(x)','J4(x)','J5(x)','J6(x)','J7(x)'
*pp     &                  ,'J8(x)','J9(x)'
*pp      X=0.
*pp      CALL BEJN(X,9,JN)  
*pp      WRITE(*,200) X,(JN(K),K=3,9)
*pp      ISAUT=51
*pp      DO 2 I=1,101
*pp      X=X+0.2 
*pp      IF(I.EQ.ISAUT) THEN 
*pp      ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,201) IPAGE,'J3(x)','J4(x)','J5(x)','J6(x)','J7(x)'
*pp     &                     ,'J8(x)','J9(x)'
*pp         X=X-0.2  
*pp      ENDIF  
*pp      CALL BEJN(X,9,JN)
*pp2     WRITE(*,200) X,(JN(K),K=3,9)
*pp200   FORMAT(T2,F5.2,7E13.5))
*pp201   FORMAT('1'//' Page',I4//(TR3,'x   ',7(A11,TR2))/)
*pp      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER N
      REAL    X,J(0:N)
*
      INTEGER NINIT,I
      REAL    JN,JNMS1,BEJ0
*-----------------------------------------------------------------------
      IF (X.GT.1.E-10) THEN 
         IF (X.LE.5.) THEN  
            NINIT=INT(4.*X+21. )
         ELSEIF (X.LE.10) THEN 
            NINIT=INT(2.4*X+28.)
         ELSEIF (X.LE.20.) THEN
            NINIT=INT(2.*X+32. )
         ELSEIF (X.LE.50.) THEN
            NINIT=INT(1.5*X+42.)
         ELSE  
            NINIT=INT(1.3*X+52.)
         ENDIF
         DO 1 I=NINIT,N  
            J(I)=0.
1        CONTINUE
*  
         JN=0. 
         DO 2 I=NINIT,1,-1 
            JNMS1=1./((I+I)/X-JN)
            JN=JNMS1
            IF (I.LE.N) J(I)=JN
2        CONTINUE
*  
         J(0)=BEJ0(X)  
*  
         DO 3 I=0,N-1  
            J(I+1)=J(I)*J(I+1)
3        CONTINUE  
      ELSE 
         J(0)=1.
         DO 4 I=1,N
            J(I)=0.
4        CONTINUE
      ENDIF
                                                                    END !Bejn
