*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEK0 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*
* Fonction de Bessel modifiee K0 simple precision multipliee par EXP(x)
*
* Bibliographie : HANDBOOK OF MATHEMATICAL FUNCTIONS  
*                 Ed. M.ABRAMOWITZ et I.A. STEGUN  
*                 Chap. 9 : Bessel Functions of Integer Order (p.375-378)
*
**     Programme principal de test 
*         - valeur de Abramowitz & Stegun pp. 417, 419, 421
*pp      REAL X,BEK0,BEK1
*pp      IPAGE=417
*pp      WRITE(*,101) IPAGE,'K0(x)','K1(x)','K2(X)'
*pp      X=0.
*pp      WRITE(*,102) X,'Inf','Inf'
*pp      ISAUT=51
*pp      DO 1 I=1,101
*pp      X=X+0.1 
*pp      IF (I.EQ.ISAUT) THEN 
*pp         ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,101) IPAGE,'K0(x)','K1(x)','K2(X)'
*pp         X=X-0.1  
*pp      ENDIF  
*pp1     WRITE(*,100) X,BEK0(X),BEK1(X)
*pp      IPAGE=IPAGE+2
*pp      WRITE(*,101) IPAGE,'K0(x)','K1(x)','K2(X)' 
*pp      X=X-0.2
*pp      DO 2 I=1,51
*pp      X=X+0.2 
*pp2     WRITE(*,100) X,BEK0(X),BEK1(X)
*pp100   FORMAT(T2,F5.2,3F15.8)
*pp102   FORMAT(T2,F5.2,3(A12,TR3))
*pp101   FORMAT('1'//' Page',I4//TR3,'x  ',3(A13,TR2)/)
*pp      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL BEK0,X
*
      INTEGER I
      REAL Z
      DOUBLE PRECISION DFACT,DP,DR,DS,DT,DX,DXS2,DX2S4
*-----------------------------------------------------------------------
      IF (X.LE.5.) THEN
*
*        Developpement en serie (A.-S. page 375)
*
         DX=DBLE(X)
         DXS2=.5D0*DX
         DX2S4=DXS2*DXS2  
         DR=-(.5772156649015329D0+LOG(DXS2)) 
         DT=1.D0
         DS=DR  
         DFACT=1.D0
         I=0  
1        I=I+1
         DR=DR+1.D0/I
         DFACT=DFACT*I*I  
         DT=DT*DX2S4
         DP=DT*DR/DFACT  
         DS=DS+DP
         IF (ABS(DP).GE.ABS(DS)*1.D-15) GOTO 1 
         BEK0=REAL(DS*EXP(DX))
      ELSE
*
*        Developpement en serie (A.-S. page 377)
*
         Z=10./X-1.
         BEK0=(((((((((-.11724637E-8 *Z+.49976007E-8)*Z-.2069298E-7)*Z
     &                 +.11138069E-6)*Z-.68190665E-6)*Z+.4884784E-5)*Z
     &                 -.43545659E-4)*Z+.53407165E-3)*Z-.1127741E-1)*Z
     &                 +.98813927)*SQRT(.15707963E+1/X)
      ENDIF
                                                                    END !BeK0  
