*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEK1 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)
* Derniere modification (D.Martin) le 16 Septembre 1996
*
* Fonction de Bessel modifiee K1 simple precision
*
* Bibliographie : HANDBOOK OF MATHEMATICAL FUNCTIONS  
*                 Ed. M.ABRAMOWITZ et I.A. STEGUN  
*                 Chap. 9 : Bessel Functions of Integer Order (p.375-378)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL BEK1,X
*
      INTEGER I
      REAL Z
      DOUBLE PRECISION DFACT,DP,DR,DS,DT,DX,DXS2,DX2S4,DIIP1
*-----------------------------------------------------------------------
      IF (X.LE.5.) THEN
*
*        Developpement en serie (A.-S. page 375)
*
         DX=DBLE(X) 
         DXS2=DX*0.5D0
         DX2S4=DXS2*DXS2  
         DR=LOG(DXS2)+0.0772156649015329D0
         DS=DR  
         DT=1.D0
         DFACT=1.D0
         I=0  
1        I=I+1
         DIIP1=I*(I+1.D0)
         DR=DR-(I+0.5D0)/DIIP1
         DFACT=DFACT*DIIP1
         DT=DT*DX2S4
         DP=DT*DR/DFACT  
         DS=DS+DP
         IF (ABS(DP).GE.ABS(DS)*1.D-15) GOTO 1
         BEK1=REAL((DS*DXS2+1.D0/DX)*EXP(DX))
      ELSE
*
*        Developpement en serie (A.-S. page 377)
*
         Z=10./X-1.
         BEK1=((((((((( .1353762E-8  *Z-.58569340E-8)*Z+.24820745E-7)*Z
     &                 -.13694388E-6)*Z+.86763322E-6)*Z-.65457109E-5)*Z
     &                 +.63621360E-4)*Z-.93027084E-3)*Z+.35417019E-1)*Z
     &                 +.10364185E+1)*SQRT(.15707963E+1/X)
      ENDIF
                                                                    END !BeK1
