*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BESFYN (X,N,Y) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul des fonctions de BESSEL spheriques de 2eme espece d'ordre 0 a N 
*  
* Bibliographie : HANDBOOK Of MATHEMATICAL FUNCTIONS  
*                 Ed. M.ABRAMOWITZ & I.A. STEGUN  
*                 Chap. 10 : Bessel Functions of Fractional Order (p.437-494)
*
*pp      REAL YN(0:2)  
*pp      IPAGE=457
*pp      WRITE(*,101) IPAGE,'y0(x)','y1(x)','y2(x)'  
*pp      X=0.
*pp      WRITE(*,102) X,'-Inf','-Inf','-Inf'
*pp      DO 1 I=1,50
*pp      X=X+0.1 
*pp      CALL BESFYN(X,2,YN)
*pp1     WRITE(*,100) X,(YN(K),K=0,2)
*pp100   FORMAT(T2,F5.2,3F15.8)
*pp102   FORMAT(T2,F5.2,3(A11,TR4))
*pp101   FORMAT('1'//' Page',I4//TR3,'x  ',3(A13,TR2)/)
*pp      IPAGE=458
*pp      WRITE(*,101) IPAGE,'y0(x)','y1(x)','y2(x)'
*pp      X=5.0
*pp      CALL BESFYN(X,2,YN)  
*pp      WRITE(*,200) X,(YN(K),K=0,2)
*pp      DO 2 I=1,50
*pp      X=X+0.1 
*pp      CALL BESFYN(X,2,YN)
*pp2     WRITE(*,200) X,(YN(K),K=0,2)
*pp200   FORMAT(T2,F5.2,3(1PF15.8))
*pp201   FORMAT('1'//' Page',I4//TR3,'x   ',7(A11,TR2)/)
*pp      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER N
      REAL    X,Y(0:N) 
*
      INTEGER I
      REAL    X2IM3,YN,YNM1,YNM2
*-----------------------------------------------------------------------
*     Calcul par recurrence progressive (Cf.A-S page 385, paragraphe 9.12)
*  
      YNM2=-COS(X)/X
      YNM1=(YNM2-SIN(X))/X 
      Y(0)=YNM2
      Y(1)=YNM1
      X2IM3=3. 
      DO 1 I=2,N
         IF (ABS(YNM1).LT.1.E+34) GOTO 2  
         Y(I)=YNM1
         GOTO 1  
2        YN=X2IM3*YNM1/X-YNM2 
         Y(I)=YN  
         YNM2=YNM1
         YNM1=YN  
1        X2IM3=X2IM3+2.
                                                                    END !Besfyn
