*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEY0 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul de la fonction de bessel de 2eme espece d'ordre 0 : Y0
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL             X,BEY0
*
      REAL             XMPIS4,S4SUX2,BEJ0
      DOUBLE PRECISION DX2,DX
*-----------------------------------------------------------------------
      IF (X.LE.8.) THEN
*
*        Approximation par fraction rationnelle
*
         DX=DBLE(X)
         DX2=DX*DX
         BEY0=REAL(((((((((-.108224715D-7 *DX2  +.104316882D-4)*DX2
     &                     -.4431910446D-2)*DX2 +.1039561053D+1)*DX2
     &                     -.1398601246D+3)*DX2 +.10309017074D+5)*DX2
     &                     -.36371585984D+6)*DX2+.43903566116D+7)*DX2
     &                     -.18304579902D+7)
     &              /(((DX2+.6633216233D+3)*DX2+.19701912582D+6)*DX2
     &                   +.2480151036D+8))
     &       +.63661977*ALOG(X)*BEJ0(X) 
      ELSE
*
*        Developpements asymptotiques de Hankel (A.-S. page 364)
*
         S4SUX2=64./(X*X)
         XMPIS4=X-.78539816
         BEY0=((((( .20938872E-6 *S4SUX2-.20733706E-5)*S4SUX2 
     &             +.27345104E-4)*S4SUX2-.10986286E-2)*S4SUX2+1.)
     &             *SIN(XMPIS4)
     &     +8.*((((-.93494515E-7 *S4SUX2+.76210952E-6)*S4SUX2
     &             -.69111476E-5)*S4SUX2+.14304888E-3)*S4SUX2
     &             -.15625E-1)/X*COS(XMPIS4))*.79788456/SQRT(X)
      ENDIF
                                                                    END !BeY0
