*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION BEY1 (X)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*  
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul de la fonction de Bessel de 2eme espece d'ordre 1 : Y1
*  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      REAL             X,BEY1
*
      REAL             XM3PI4,S4SUX2,BEJ1
      DOUBLE PRECISION DX2,DX
*------------------------------------------------------------------------
      IF (ABS(X).LE.8.) THEN
*
*        Approximation par fraction rationnelle
*
         DX=DBLE(X)
         DX2=DX*DX
         BEY1=REAL(((((((((-.40215545652D-11*DX2+.36878633134D-8)*DX2
     &                     -.15738840726D-5)*DX2+.39245490948D-3)*DX2
     &                     -.59689930762D-1)*DX2+.53561134713D+1)*DX2
     &                     -.25571167226D+3)*DX2+.51367887399D+4)*DX2
     &                     -.1891581383D+5)
     &               /((DX2+.54491911711D+3)*DX2+.96481151335D+5)*DX)
     &       +.63661977*(BEJ1(X)*LOG(X)-1./X) 
      ELSE
*
*        Developpements asymptotiques de Hankel (A.-S. page 364)
*
         S4SUX2=64./(X*X)  
         XM3PI4=X-.23561945E+1
         BEY1=(((((-.24033702E-6 *S4SUX2+.24575202E-5)*S4SUX2
     &             -.35163965E-4)*S4SUX2+.18310500E-2)*S4SUX2+1.)
     &             *SIN(XM3PI4)
     &     +8.*(((( .10578741E-6 *S4SUX2-.88228987E-6)*S4SUX2
     &             +.84491991E-5)*S4SUX2-.20026909E-3)*S4SUX2
     &             +.46875000E-1)/X*COS(XM3PI4))*.79788456/SQRT(X)
      ENDIF
                                                                    END !BeY1  
