*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE BEYN (X,N,Y)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Janvier 1990)  
* Derniere modification (D.Martin) le 16 Septembre 1996
*  
* Calcul des fonctions de BESSEL standard de 2-eme espece d'ordre 0 a N
*  
* Bibliographie : HANDBOOK Of MATHEMATICAL FUNCTIONS  
*                 Ed. M.ABRAMOWITZ & I.A. STEGUN  
*                 Chap. 9 : Bessel Functions of Integer Order (p.359-433) 
*
**     Programme principal de test - valeur de Abramowitz & Stegun pp. 390, 397
*pp      REAL YN(0:9)  
*pp      IPAGE=391
*pp      WRITE(*,101) IPAGE,'Y0(x)','Y1(x)','Y2(x)'  
*pp      X=0.
*pp      WRITE(*,102) X,'-Inf','-Inf','-Inf'
*pp      ISAUT=51
*pp      DO 1 I=1,178
*pp      X=X+0.1 
*pp      IF(I.EQ.ISAUT) THEN 
*pp         ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,101) IPAGE,'Y0(x)','Y1(x)','Y2(x)'
*pp         X=X-0.1  
*pp      ENDIF  
*pp      CALL BEYN(X,2,YN)
*pp1     WRITE(*,100) X,(YN(K),K=0,2)
*pp100   FORMAT(T2,F5.2,3F15.8)
*pp102   FORMAT(T2,F5.2,3A12,TR3)
*pp101   FORMAT('1'//' Page',I4//(TR3,'x  ',3(A13,TR2))/)
*pp      IPAGE=399
*pp      WRITE(*,201) IPAGE,'Y3(x)','Y4(x)','Y5(x)','Y6(x)','Y7(x)'
*pp     &                  ,'Y8(x)','Y9(x)'
*pp      X=0.
*pp      WRITE(*,202) X,('-Inf',K=3,9)
*pp      ISAUT=51
*pp      DO 2 I=1,101
*pp      X=X+0.2 
*pp      IF(I.EQ.ISAUT) THEN 
*pp      ISAUT=ISAUT+51
*pp         IPAGE=IPAGE+2
*pp         WRITE(*,201) IPAGE,'Y3(x)','Y4(x)','Y5(x)','Y6(x)','Y7(x)'
*pp     &                     ,'Y8(x)','Y9(x)'
*pp         X=X-0.2  
*pp      ENDIF  
*pp      CALL BEYN(X,9,YN)
*pp2     WRITE(*,200) X,(YN(K),K=3,9)
*pp200   FORMAT(T2,(F5.2,7E13.5))
*pp202   FORMAT(T2,(F5.2,7(A10,TR3)))
*pp201   FORMAT('1'//' Page',I4//(TR3,'x   ',7(A11,TR2))/)
*pp      END
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER N
      REAL    X,Y(0:N)
*
      INTEGER I
      REAL    X2IM2,J0,J1,YN,YNM1,YNM2 
*-----------------------------------------------------------------------
*     Calcul par recurrence progressive (Cf.A-S page 385, paragraphe 9.12)
*  
      CALL BEJY01 (X,J0,J1,YNM2,YNM1,.TRUE.) 
* 
      Y(0)=YNM2
      Y(1)=YNM1
      X2IM2=2. 
      DO 1 I=2,N
         IF (ABS(YNM1).LT.1.E+34) GOTO 2  
         Y(I)=YNM1
         GOTO 1  
2        YN=X2IM2*YNM1/X-YNM2 
         Y(I)=YN  
         YNM2=YNM1
         YNM1=YN  
1        X2IM2=X2IM2+2.
                                                                    END !BeYn
