*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FAERR (ERRNUM,FATYPE,NMTERM,NVTERM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998) 
* Derniere modification : D.Martin (23 Janvier 2001)
* Version 1.0.1
*  
* Message d'erreur pour une factorisation matricielle
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
* FATYPE type de factorisation 
* NMTERM nom du tableau contenant la matrice a factoriser
* NVTERM son niveau
* NIVIMP son niveau d'impression
* IMPFCH numero d'unite logique du fichier des messages secondaires
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) FATYPE,NMTERM
      INTEGER       ERRNUM,NVTERM,NIVIMP,IMPFCH
*
      INTEGER       NCATR1,LFATYP
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*------------------------------------------------------------------------
      LFATYP=LEN(FATYPE)
*
      IF (ERRNUM.GT.0) THEN
         CALL PRTERM (NMTERM,NVTERM,NIVIMP,IMPFCH)
         CALL PRNTRM (NMTERM,NVTERM,ERCODE(1:16),NCATR1)
         ERCODE(NCATR1+11:)=FATYPE
         CALL ENCLER (ERRNUM,ERCODE(NCATR1+1:NCATR1+10))
         CALL BAISE  (' Factorisation '
     &//ERCODE(NCATR1+11:NCATR1+10+LFATYP)//' impossible de la matrice'
     &//ERCODE(1:NCATR1)
     &//'. Coefficient diagonal nul ligne '
     &//ERCODE(NCATR1+1:NCATR1+10)//'.')
      ELSEIF (ERRNUM.LT.0) THEN
         CALL PRTERM (NMTERM,NVTERM,NIVIMP,IMPFCH)
         CALL PRNTRM (NMTERM,NVTERM,ERCODE(1:16),NCATR1)
         ERCODE(NCATR1+11:)=FATYPE
         CALL ENCLER (-ERRNUM,ERCODE(NCATR1+1:NCATR1+10))
         CALL BAISE  (' Factorisation '
     &//ERCODE(NCATR1+11:NCATR1+10+LFATYP)//' impossible de la matrice'
     &//ERCODE(1:NCATR1)
     &//'. Coefficient diagonal negatif ou nul ligne '
     &//ERCODE(NCATR1+1:NCATR1+10)//'.')
      ELSE
         CALL PRNTRM (NMTERM,NVTERM,ERCODE(1:16),NCATR1)
         ERCODE(NCATR1+11:)=FATYPE
         CALL BAISE  (' Factorisation '
     &//ERCODE(NCATR1+11:NCATR1+10+LFATYP)//' impossible de la matrice'
     &//ERCODE(1:NCATR1)
     &//'.')
      ENDIF
                                                                   END !Faerr
