*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FALU (NMMATR,NVMATR,SYMSTR,NMFACT,NVFACT,NIVIMP) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991) 
* Derniere modification : D.Martin (26 Juin 2001)
* Version 1.0.2
*
* Factorisation L.U d'une matrice 
*   Le resultat est un terme stocke sous forme 'Profil'.
*   L (resp. U) est une matrice triang. inf. a diag. unite (triang. sup.)
*  
*-- Arguments d'entree -- 
* NMMATR Nom du tableau contenant la matrice a factoriser 
* NVMATR Son niveau
* SYMSTR indicateur de structure symetrique de la matrice NMMATR,NVMATR
*        SYMSTR(1:1) = 'S' ==> Matrice symetrique en structure
* NMFACT Nom du terme stocke 'Profil' devant contenir la decomposition L.U
* NVFACT Son niveau
* NIVIMP Niveau d'impression pour la la matrice factorisee
*  
* N.B. Les termes NMMATR,NVMATR et NMFACT,NVFACT doivent etre differents 
*      si le terme a factoriser n'est pas stocke 'Profil'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) SYMSTR,NMMATR,NMFACT
      INTEGER       NVMATR,NVFACT,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*  
      CHARACTER*6   ERCODE*120,TYMATR*4,TYFACT,NMSTOK,NMPROF
      INTEGER       INDSYM
      INTEGER       NBLIGN,MCLENV,LGL,NBC,MCUENV,LGU
     &             ,ITYSYM,INSTOK,MCMATR,MCFACT,NVPROF,MCPROF,IRCODE
     &             ,MCMATL,MCMATU,MCFACL,MCFACU
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(89:89),TYMATR),(ERCODE(97:97),TYFACT)
     &            ,(ERCODE(105:105),NMPROF),(ERCODE(113:113),NMSTOK)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FaLU*')
      ERCODE=' '
      TYFACT='L.U'
*
*--   Transformation eventuelle du stockage de la matrice et adresses
*     des  matrices et tableaux de pointeurs
*
      CALL FAPREP (NMMATR,NVMATR,SYMSTR,TYMATR,ITYSYM,NMSTOK,INSTOK
     &            ,MCMATR
     &            ,TYFACT,NMFACT,NVFACT,MCFACT,NMPROF,NVPROF,MCPROF
     &            ,NIVIMP,IMPSDR)                                       !syslin
*
*--   Pointeurs PROFIL et longueurs de la matrice factorisee
*
      CALL EXPROF (MCPROF,IST(MCPROF),NBLIGN,MCLENV,LGL,NBC,MCUENV,LGU) !sdexplo
*
*--   Factorisation proprement dite
*
      MCMATL=MCMATR+NBLIGN
      MCMATU=MCMATL
      IF (ITYSYM.EQ.INDSYM (' ')) MCMATU=MCMATL+LGL
      MCFACL=MCFACT+NBLIGN
      MCFACU=MCFACL+LGL
*     L.U. , la matrice factorisee n'est pas symetrique
*
      CALL LUPR   (TYMATR,NBLIGN,IST(MCLENV),IST(MCUENV),MCMATR,MCMATL
     &            ,MCMATU,EPSMAC,MCFACT,MCFACL,MCFACU,RST,CST,IRCODE)    !syslin
      IF (IRCODE.NE.0) GOTO 99990
*
*--   Sauvegarde des tableaux
*
      CALL FAFINA (NMMATR,NVMATR,INSTOK
     &            ,NMFACT,NVFACT,TYFACT,NMPROF,NVPROF,NIVIMP)           !syslin
*  
      CALL PRFXMJ (-1,'*FaLU*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL FAERR  (IRCODE,TYFACT,NMMATR,NVMATR,NIVIMP,IMPSDR)
                                                                    END !FaLU
