*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FAPREP (NMMATR,NVMATR,SYMSTR,TYMATR,ITSYMA,NMSTOK
     &                  ,INSTOK,MCMATR,TYFACT,NMFACT,NVFACT,MCFACT
     &                  ,NMSTOF,NVSTOF,MCPROF,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991) 
* Derniere modification : D.Martin (03 novembre 2008)
* Version 2
*  
* Preparation des matrices initiale et factorisee avant une factorisation
* de type Gauss (L1.U) ou Choleski (L.tL, L.L*, L1.D.tL1 ou L1.D.L1*)
*
* La matrice initiale est stockee sous forme 'Bimorse','Profil' ou 'morse-L'
* La matrice a factoriser est stockee sous forme 'Profil' en sortie,
* ses pointeurs etant soit repris s'ils existent, soit recalcules a partir
* des pointeurs de la matrice initiale.
*
*-- Arguments d'entree --
* NMMATR nom du tableau contenant la matrice a factoriser 
* NVMATR son niveau
* SYMSTR indicateur de matrice a structure symetrique dans le cas morse-L
*        inutilise sinon
* TYFACT type de factorisation
* NMFACT nom du terme stocke 'Profil' devant contenir la factorisee
* NVFACT son niveau
* NIVIMP niveau d'impression du terme factorise
* IMPFCH numero d'unite logique d'impression
*-- Arguments de sortie --
* TYMATR type reel ou complexe des matrices
* ITSYMA indicateur de symetrie de la matrice a factoriser
* NMSTOK nom du tableau de stockage de la matrice a factoriser
* INSTOK indice de type de stockage de la matrice a factoriser
* MCMATR adresse de la diagonale du terme a factoriser sous forme profil
* MCFACT adresse de la diagonale du terme factorise
* NMSTOF nom du tableau de stockage de la matrice factorisee
* NVSTOF niveau du tableau de stockage 'Profil' de la matrice factorisee
* MCPROF adresse du tableau de stockage de la matrice factorisee
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYFACT,TYMATR,SYMSTR,NMMATR,NMFACT,NMSTOK,NMSTOF
      INTEGER       NVMATR,ITSYMA,INSTOK,MCMATR,NVFACT,MCFACT
     &             ,NVSTOF,MCPROF,NIVIMP,IMPFCH
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDFAC,INDSTO,INDSYM,INTYKL,KLTERM,KLNIVE
      INTEGER       NUFACT,INSTOF,MCINCO,LGMTRM,MCMTRM,NUTERM
     &             ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,ADTERM
     &             ,NVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN,NVDSMB
     &             ,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM,NVDULM,NBNELM
     &             ,NVNULM,NVSTOK,NVCOMA,IATRDO,NIVIMA,MCDSMB
     &             ,INTERP,NBTNEU,NWHTRM,NCPINC,NCPINL,MCSTOK,MORELG
     &             ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL,LGL,MCLENV,LGENVL
     &             ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU,LGU,MCUENV,LGENVU
     &             ,LGMATR,MCMATL,ITSYFA,MCFAVL,MCFAVU,NCATR1
      LOGICAL       IDEMTR
      CHARACTER     STOIND*7,TYPINT*9,PRFXAS*8,SYMIND*14,STODLN*6
      CHARACTER     ERCODE*120,SYMVTR,MULTIM,TYWORK*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FaPrep*')
*
      IDEMTR = NMMATR.EQ.NMFACT.AND.NVMATR.EQ.NVFACT
*
*--   Indicateur de structure symetrique ou non
*
      SYMVTR=SYMSTR(1:1)
      IF (TYFACT(1:3).NE.'L.U'.AND.TYFACT(1:5).NE.'L.D.U') SYMVTR='S'
      NUFACT=INDFAC (TYFACT)                                            !utilite
      INSTOF=INDSTO ('PROFIL')                                          !utilite
*  
*--   Recherche des longueurs et adresses des structures de description
*     des termes : #OMTRM et $SDTRM
*
      CALL TBRR3  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*  
*--   Recherche des attributs de la matrice NMMATR 
*
      NUTERM=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATR,NVMATR)                    !utilite
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(ADTERM),NVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN
     &            ,ITSYMA,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM
     &            ,NUINLM,NVDULM,NBNELM,NVNULM,INSTOK,NVSTOK
     &            ,NVCOMA,IATRDO,NIVIMA)                                !sdexplo
*
      MULTIM='N'
      IF (NVDSMB.NE.NDFDSM.AND.NUINCM.EQ.NDFINC.AND.NUINLM.EQ.NDFINC)
     &   MULTIM='Y'
*
      TYMATR=TYPINT (ITYMAT)                                            !utilite
      NCPINC=1
      NCPINL=1
      IF (MULTIM.EQ.'N') THEN
         IF (NBNECM.NE.NBNELM) CALL ERTERM (11,NMMATR,NVMATR)           !utilite
         CALL SDEXCO (NUINCM,IST(MCINCO),NCPINC,INTERP,NBTNEU)          !sdexplo
         NCPINL=NCPINC
         IF (NUINLM.NE.NUINCM)
     &      CALL SDEXCO (NUINLM,IST(MCINCO),NCPINL,INTERP,NBTNEU)       !sdexplo
         IF (NCPINC.NE.NCPINL) CALL ERTERM (16,NMMATR,NVMATR)           !utilite
      ELSE
*        Cas "multi-inconnue".
         CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMB)
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      ENDIF
*
*--   Recherche des attributs de la matrice NMFACT
*
      IF (.NOT.IDEMTR) THEN
         NUTERM=KLTERM (NMFACT,NVFACT,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.LE.0) THEN
            CALL ALFANU (NBCHNT,NMFACT)                                 !utilite
            NWHTRM=MAX (NCHTRM,LEN (NMFACT)) 
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)           !sdexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)      !sdexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMFACT)              !utilite
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !sdexplo
            NUTERM=NBTERM
         ENDIF
      ENDIF
*
*--   Type de symetrie pour le stockage de la matrice factorisee
*
      ITSYFA=ITSYMA
      IF (TYFACT(1:4).EQ.'L.LT'.OR.TYFACT(1:6).EQ.'L.D.LT') THEN
         ITSYFA=INDSYM ('SYMETRIQUE')
      ELSEIF (TYFACT(1:4).EQ.'L.L*'.OR.TYFACT(1:6).EQ.'L.D.L*') THEN
         ITSYFA=INDSYM ('AUTOADJOINTE')
      ELSEIF (TYFACT(1:3).EQ.'L.U') THEN
         ITSYFA=NDFSYM
      ENDIF
*
*--   Niveau du tableau de stockage de la matrice factorisee
*
      NVSTOF=NVSTOK
      IF (NVSTOF.EQ.NDFSTO) NVSTOF=KLNIVE ()                            !sdexplo
*
      IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
*--                 Cas d'une matrice Bi-morse en entree
*
*  1)    Factorisation de la matrice stockee 'Bimorse' dans une autre
         NMSTOK = STODLN (INSTOK, NCPINC, NCPINL)                       !utilite
         NMSTOF = STODLN (INSTOF, NCPINC, NCPINL)                       !utilite
         CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGMATR)
         IF (IDEMTR) CALL ERTERM (3,NMMATR,NVMATR)                      !utilite
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,NMSTOF,NVSTOF,MCPROF)
*
         IF (ERCODE(1:1).EQ.'C') THEN
            IF (NCPINL.GT.1) THEN
*              Cas d'inconnue vectorielle, compactage en d.l.
               CALL BMO2DL (NVSTOK,NCPINL,NCPINC,ITSYMA,NMMATR,NVMATR
     &                     ,NIVIMP)                                     !sdexplo
            ENDIF
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
*  
*--         Creation du tableau de contenant les pointeurs 'PROFIL' de
*           la future matrice factorisee
*
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
            CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !sdexplo
            MORELG=0
            IF (ITSYFA.EQ.NDFSYM) MORELG=NBC+1 
            CALL TBCREE (NMSTOF,NVSTOF,1,2+NBL+MORELG,'c')
            CALL TBAR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK
     &                         ,NMSTOF,NVSTOF,MCPROF)
            CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !sdexplo
*
*           Pointeurs et des tailles des env. inf. et sup.
            IST(MCPROF)=2
            CALL BM2PR  (NBL,NBC,IST(MCPLAL),IST(MCPLIL),IST(MCPROF+1)) !morse
            IF (ITSYFA.EQ.NDFSYM) THEN
               IST(MCPROF)=3+NBL
               MCUENV=MCPROF+IST(MCPROF)-1
               CALL BM2PR  (NBC,NBL,IST(MCPLAU),IST(MCPLIU),IST(MCUENV))!morse
            ENDIF
            TYWORK=NMFACT
            IF (NIVIMP.GT.1.AND.IMPFCH.GT.0) 
     &         CALL PRPROF (IST(MCPROF),' terme'
     &                     ,TYWORK,NVFACT,NIVIMP,IMPFCH)                !prsd
         ELSE
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         ENDIF
*
         CALL TBAR1  (ERCODE,NMSTOF,NVSTOF,MCPROF)
         CALL EXPROF (MCPROF,IST(MCPROF),NBL,MCLENV,LGENVL
     &                                  ,NBC,MCUENV,LGENVU)             !sdexplo
         IF (ITSYFA.NE.NDFSYM) LGENVU=0
*
*--      Creation du tableau contenant la factorisee sous forme 'Profil'
*
         TYWORK=TYFACT
         CALL TBCREE (NMFACT,NVFACT,ITYMAT,NBL+LGENVL+LGENVU,'c')
         CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR,NMFACT,NVFACT,MCFACT
     &                      ,NMSTOK,NVSTOK,MCSTOK,NMSTOF,NVSTOF,MCPROF)
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)                  !sdexplo
         CALL EXPROF (MCPROF,IST(MCPROF),NBL,MCLENV,LGENVL
     &                                  ,NBC,MCUENV,LGENVU)             !sdexplo
         CALL TDANST (NBL,TYMATR,MCMATR,IST,RST,CST
     &                   ,TYMATR,MCFACT,IST,RST,CST)                    !utilite
         MCMATL=MCMATR+NBL
         CALL MB2PR  (NBL,NBC,IST(MCPLAL),IST(MCPLIL),TYMATR,MCMATL
     &               ,IST(MCLENV),MCFACT+NBL,RST,CST)                   !morse
*
         IF (ITSYFA.EQ.NDFSYM) THEN
            IF (ITSYMA.EQ.NDFSYM) MCMATL=MCMATL+LGMORL
            CALL MB2PR  (NBC,NBL,IST(MCPLAU),IST(MCPLIU),TYMATR,MCMATL
     &                  ,IST(MCUENV),MCFACT+NBL+LGENVL,RST,CST)         !morse
         ENDIF
         CALL TBSAVE (NMSTOK,NVSTOK)
         MCMATR=MCFACT
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
*
*--                Cas d'une matrice morse-Ligne en entree
*
*  2)    Factorisation de la matrice stockee 'morse' dans une autre
         CALL TBRR2 (ERCODE,NMMATR,NVMATR,LGMATR,'&PLAGE',NVSTOK,MCSTOK)
         IF (IDEMTR) CALL ERTERM (3,NMMATR,NVMATR)                      !utilite
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,'&PROFL',NVSTOF,MCPROF)
*
         IF (ERCODE(1:1).EQ.'C') THEN
            IF (NCPINL.GT.1) THEN
               CALL ERTERM (18,NMMATR,NVMATR)                           !utilite
            ENDIF
            MORELG=0
            IF (SYMVTR.NE.'S') MORELG=NBNELM+1
*  
*--         Creation du tableau de contenant les pointeurs 'PROFIL'
            CALL TBCREE ('&PROFL',NVSTOF,1,2+NBNELM+MORELG,'c')
            CALL TBAR2  (ERCODE,'&PLAGE',NVSTOK,MCSTOK
     &                         ,'&PROFL',NVSTOF,MCPROF)
            CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAL,MCPLAL
     &                  ,MCPLIL,LGMORL)                                 !sdexplo
            IST(MCPROF)  =2+MORELG
            IST(MCPROF+1)=NBNELM
*           Calcul des pointeurs et des tailles des env. inf. et sup.
            CALL CM2LPR (NBNELM,NBNELM,IST(MCPLAL),IST(MCPLIL)
     &                  ,IST(MCPROF+2))                                 !morse
            IF (SYMVTR.NE.'S')THEN
               MCUENV=MCPROF+IST(MCPROF)
               IST(MCUENV-1)=NBNELM
               CALL CM2UPR (NBNELM,NBNELM,IST(MCPLAL),IST(MCPLIL)
     &                     ,IST(MCUENV))                                !morse
            ENDIF
            TYWORK=NMFACT
            IF (NIVIMP.GT.1.AND.IMPFCH.GT.0) 
     &         CALL PRPROF (IST(MCPROF),'terme'
     &                     ,TYWORK,NVFACT,NIVIMP,IMPFCH)                !prsd
         ELSE
            CALL TBAR1  (ERCODE,'&PROFL',NVSTOF,MCPROF)
         ENDIF
         CALL EXPROF (MCPROF,IST(MCPROF),NBL,MCLENV,LGENVL
     &                                  ,NBC,MCUENV,LGENVU)             !sdexplo
         IF (ITSYFA.NE.NDFSYM) LGENVU=0
*
*--      Creation du tableau contenant la factorisee sous forme 'Profil'
         TYWORK=TYFACT
         CALL TBCREE (NMFACT,NVFACT,ITYMAT,NBNELM+LGENVL+LGENVU,'c')
         CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR, NMFACT ,NVFACT,MCFACT
     &              ,'&PLAGE',NVSTOK,MCSTOK,'&PROFL',NVSTOF,MCPROF)
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBL,NBC,NBPLAL,MCPLAL,MCPLIL   
     &               ,LGMORL)                                           !sdexplo
         CALL EXPROF (MCPROF,IST(MCPROF),NBL,MCLENV,LGENVL
     &                                  ,NBC,MCUENV,LGENVU)             !sdexplo
         MCFAVL=MCFACT+NBNELM
*
         IF (ITSYFA.EQ.NDFSYM) THEN
            MCFAVU=MCFAVL+LGENVL
            CALL MM2PR  (NBNELM,NBNELM,IST(MCPLAL),IST(MCPLIL),TYMATR
     &                  ,MCMATR,IST(MCLENV),IST(MCUENV),MCFACT,MCFAVL
     &                  ,MCFAVU,RST,CST)                                !morse
         ELSE
            CALL MM2LPR (NBNELM,NBNELM,IST(MCPLAL),IST(MCPLIL),TYMATR
     &                  ,MCMATR,IST(MCLENV)            ,MCFACT,MCFAVL 
     &                         ,RST,CST)                                !morse
         ENDIF
*
         CALL TBSAVE ('&PLAGE',NVSTOK)
         MCMATR=MCFACT
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-C')) THEN                        !utilite
*--               Cas d'une matrice morse-Colonne en entree
         CALL ERTERM (15,NMMATR,NVMATR)                                 !utilite
*
      ELSEIF (INSTOK.EQ.INSTOF) THEN                         !utilite
*--                Cas d'une matrice Profil en entree
*
         NMSTOF = '&PROFL'
         CALL TBRR2  (ERCODE,NMMATR,NVMATR,LGMATR,NMSTOF,NVSTOF,MCPROF) 
         IF (NCPINL.GT.1) THEN
            CALL PRO2DL (NVSTOF,NCPINL,NCPINC,ITSYMA,NMMATR,NVMATR
     &                  ,NIVIMP)
            NMSTOF = STODLN (INSTOK, NCPINL, NCPINL)
         ENDIF
         CALL TBAR1  (ERCODE,NMSTOF,NVSTOF,MCPROF)
         CALL EXPROF (MCPROF,IST(MCPROF),NBL,MCLENV,LGL,NBC,MCUENV,LGU) !sdexplo
*
         IF (.NOT.IDEMTR) THEN
*  3)       Factorisation de la matrice stockee 'Profil' dans une autre
*           Creation du tableau contenant la factorisee
            TYWORK=TYFACT
            IF (ITSYFA.NE.ITSYMA) LGMATR=2*(LGMATR-NBL)
            CALL TBCREE (NMFACT,NVFACT,ITYMAT,LGMATR,'c')
            CALL TBAR3  (ERCODE,NMSTOF,NVSTOF,MCPROF
     &                  ,NMMATR,NVMATR,MCMATR,NMFACT,NVFACT,MCFACT)
         ELSE
            IF (ITSYFA.NE.ITSYMA) CALL ERTERM (3,NMMATR,NVMATR)         !utilite
*  4)       Factorisation de la matrice stockee 'Profil' dans elle-meme
            CALL TBAR2  (ERCODE,NMSTOF,NVSTOF,MCPROF
     &                         ,NMFACT,NVFACT,MCFACT)
            MCMATR=MCFACT
         ENDIF
*
      ELSE
*--                            Autres cas

         CALL ERTERM (15,NMMATR,NVMATR)                                 !utilite
*
      ENDIF
*
*--   Mise a jour de la structure $SDTRM pour le terme factorise
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      ADTERM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
*
      CALL PUTTRM (IST(ADTERM),NVFACT,ITYMAT,INTYKL('FACTOR'),NUFACT
     &            ,0     ,ITSYFA,NVDSMB,NUINCM,NVDUCM,NBNELM,NVNUCM
     &            ,NUINLM,NVDULM,NBNELM,NVNULM,INSTOF,NVSTOF
     &            ,NDFCOR,0,NIVIMP)                                     !sdexplo
*--
      TYWORK=TYFACT
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE(1:32),NCATR1)                !utilite
         IF (ITSYMA.EQ.0) THEN
            WRITE (IMPPAL,10000) PRFXAS (1),TYWORK,ERCODE(1:NCATR1)
     &                          ,TYPINT(ITYMAT),STOIND (INSTOK)
         ELSE
            WRITE (IMPPAL,10000) PRFXAS (1),TYWORK,ERCODE(1:NCATR1)
     &                          ,TYPINT(ITYMAT),STOIND (INSTOK)
     &                          ,SYMIND(ITSYMA)
         ENDIF
         WRITE (IMPPAL,10001) NBNECM*NCPINC
      ENDIF
*
      CALL PRFXMJ (-1,'*FaPrep*') 
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Factorisation ',A,' de la matrice ',A,', ',A
     &,', ',A,:,', ',A)
10001 FORMAT(T11,'Nombre de lignes :',I12)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre/03 novembre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (28 Juin 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !FaPrep
