*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FASV (NMMATR,NVMATR,NMSCMB,NVSCMB,NMSOLU,NVSOLU,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Juillet 1990)  
* Derniere modification : D.Martin (3 novembre 2008)
* Version 3
*  
* Resolution d'un systeme lineaire reel ou complexe dont la matrice est
* factorisee (L1.U, L1.D.U1, L.LT ou L.L*, ou L.D.LT ou L1.D.L1*)
*
* - L  (resp. U ) est une matrice triang. inf. (resp. sup.)
* - L1 (resp. U1) est une matrice triang. inf. (resp. sup.) a diagonale unite
* - D  est une matrice diagonale
* - M* (resp. MT) represente l'adjointe (resp. la transposee) de la matrice M
*  
*-- Arguments d'entree -- 
* NMMATR nom du terme contenant la matrice factorisee stockee 'Profil'
* NVMATR son niveau
* NMSCMB nom du terme contenant le second membre
* NVSCMB son niveau
* NMSOLU nom du terme contenant la solution 
* NVSOLU son niveau
* NIVIMP niveau d'impression pour la solution 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATR,NMSCMB,NMSOLU
      INTEGER       NVMATR,NVSCMB,NVSOLU,NIVIMP
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     STOIND*7,FACIND*6,STODLN*6
      CHARACTER*8   TYFACT*6,TYMATP,TYMATR,TYSCMB,TYSOLU
      CHARACTER     ERCODE*120,NMSTOK*6,NM2MMB*6
      INTEGER       INDSTO,INTYKL                                       !utilite
      INTEGER       MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NV2MMB
     &             ,ITYSYM,NVDSMA,NUINLM,NCPINL,NVDULM,NBNELM,NVNULM
     &             ,INDSTM,NVSTOK,NVCOMA,NVDSSC,NVDUSC,NBNESC,NVNUSC
     &             ,ITFACT,NUFACT,INDSTP,NVSTOP,NBSCMB
     &             ,MCMATR,MCSTOK,MCSOLU,MC2MMB,NBLIGN
     &             ,NCATR1,NCATR2,NCATR3,IRCODE
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(57:57),NMSTOK)
     &            ,(ERCODE(65:65),TYFACT),(ERCODE(73:73),TYMATP)
     &            ,(ERCODE(81:81),TYMATR),(ERCODE(89:89),TYSCMB)
     &            ,(ERCODE(97:97),TYSOLU),(ERCODE(105:105),NM2MMB)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FaSv  *')
*  
*     Recherche des longueurs et adresses des structures de description
*     des termes : tableaux #OMTRM et $SDTRM
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
      NM2MMB=' '
      NV2MMB=0
* 
*--   Caracteristiques du systeme
*
      CALL SYPREP (NMMATR,NVMATR,NMSCMB,NVSCMB,NM2MMB,NV2MMB,TYMATR
     &            ,ITYSYM,NVDSMA,NUINLM,NCPINL,NVDULM,NBNELM,NVNULM
     &            ,INDSTM,NVSTOK,NVCOMA,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,TYMATP,ITFACT,NUFACT,INDSTP,NVSTOP,NBLIGN)    !syslin
      IF (ITFACT.NE.INTYKL ('FACTOR')) CALL ERTERM (14,NMMATR,NVMATR)   !utilite
      TYFACT=FACIND (NUFACT)                                            !utilite
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN    
         WRITE (IMPPAL,10000) TYFACT,STOIND (INDSTM),NBLIGN
      ENDIF
      NMSTOK = STODLN (INDSTM, NCPINL, NCPINL)                          !utilite
      IF (NMSTOK(1:4).NE.'&BMO'.AND.NMSTOK(1:4).NE.'&PRO'
     &.AND.NMSTOK(1:4).NE.'&PLA') CALL ERTERM (18,NMMATR,NVMATR)        !utilite
*  
*--   Vecteur solution
*
      TYSOLU=TYSCMB 
      IF (TYMATR(:1).EQ.'C') TYSOLU='COMPLEXE'
      NBSCMB=1
      CALL SOPREP (NMSCMB,NVSCMB,NBSCMB,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,NMSOLU,NVSOLU,TYSOLU,NUINLM,NCPINL,NVDULM
     &            ,NBNELM,NVNULM,NVCOMA,NIVIMP,NVDSMA,NM2MMB,NV2MMB)    !syslin
*  
*--   Resolution proprement dite
*
      CALL TBRR2  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK)
      CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR,NMSOLU,NVSOLU,MCSOLU
     &                   ,NMSTOK,NVSTOK,MCSTOK,NM2MMB,NV2MMB,MC2MMB)
*
      CALL RSMAFA (NMSTOK,MCSTOK,TYFACT,TYMATR,MCMATR
     &            ,NBSCMB,TYSCMB,MC2MMB,TYSOLU,MCSOLU
     &            ,IST,RST,CST,IRCODE)                                  !syslin
      IF (IRCODE.EQ.1) CALL ERTERM (19,NMMATR,NVMATR)                   !utilite
*
      CALL TBSAVE (NMMATR,NVMATR)
      CALL TBSAVE (NMSTOK,NVSTOK)
      IF (NM2MMB.EQ.'$WORK$'.AND.NV2MMB.EQ.1) THEN 
         CALL TBTUER ('$WORK$',1)
      ELSE
         CALL TBSAVE (NMSCMB,NVSCMB)
      ENDIF
*
      IF (NIVIMP.GE.0.AND.IMPSDR.GT.0) 
     &   CALL PRTERM (NMSOLU,NVSOLU,NIVIMP,IMPSDR)                      !sdexplo
      CALL TBSAVE (NMSOLU,NVSOLU)
*
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
         CALL PRNTRM (NMSCMB,NVSCMB,ERCODE(NCATR1+1:),NCATR2)
         CALL PRNTRM (NMSOLU,NVSOLU,ERCODE(NCATR1+NCATR2+1:),NCATR3)
         WRITE (IMPPAL,10001) 'Matrice',ERCODE(1:NCATR1)
     &        ,'2nd membre',ERCODE(NCATR1+1:NCATR1+NCATR2)
     &        ,'Solution',ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCATR3)
      ENDIF
      CALL PRFXMJ (-1,'*FaSv  *')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*Fasv*',T11,'Resolution de systeme lineaire apres'
     &,' factorisation ',A,', stockage ',A
     &/,T11,'Nombre d''inconnues :',I12)
10001 FORMAT(T11,3(A,' : ',A,:' ; '))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (03 novembre 2008)
*  bug de debutant dans un test logique
* Version 2 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (30 mai 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !FaSv
