*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FILU (NMMATR,NVMATR,SYMSTR,NMFACT,NVFACT,NIVIMP) 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Juillet 90) 
* Derniere modification : D.Martin (08 octobre 2008)
* Version 2
*  
* Factorisation L.U incomplete d'une matrice 'BiMorse' ou 'Morse-Ligne'.
*    La matrice factorisee est stockee sous la meme forme.
*  
*-- Arguments d'entree -- 
* NMMATR nom du tableau contenant la matrice a factoriser 
* NVMATR son niveau
* SYMSTR indicateur de structure symetrique de la matrice NMMATR,NVMATR
*        SYMSTR(1:1) = 'S' ==> Matrice symetrique en structure
* NMFACT nom du tableau devant contenir la matrice factorisee LU
* NVFACT son niveau
* NIVIMP niveau d'impression pour la matrice factorisee
*  
* N.B. Les matrices NMMATR,NVMATR et NMFACT,NVFACT peuvent coincider ; 
*      pour cela il suffit d'entrer les memes noms et niveaux.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) SYMSTR,NMMATR,NMFACT
      INTEGER       NVMATR,NVFACT,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER STODLN*6,TYPINT*4,PRFXAF*8
      INTEGER INDFAC,INDSTO,INDSYM,INTYKL,KLTERM
      INTEGER LGDTRM,MCDTRM,LGMTRM,MCMTRM,LGETRM,NBTERM,INCTRM
     &       ,NCHTRM,NWHTRM,NUTERM,IADTRM,NVVMAT,ITYMAT,ITYCAL,NUKALE
     &       ,NUDONN,ITSYMA,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM
     &       ,NVDULM,NBNELM,NVNULM,INSTOK,NVPLAG,NVCOMA,IATRDO,NIVIMA
     &       ,MCMATR,MCFACT,NVBMOR,MCBMOR,NBL,NBPLAG,MCPLAL,MCPLIL
     &       ,LGMORL,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU,MCMATL,MCMATU
     &       ,MCFACL,MCFACU,NUFACT,LGMATR,MCPLAG,LGWORK,LGCOMP
     &       ,LGPLAC,NBPLAX,MCTRAM,MCCOLI,MCDIAG,MCLIGN,MCPLAJ
     &       ,NCATR1,LGREEL,MCGALP,NCPINC
      LOGICAL NOTIDM
      CHARACTER ERCODE*120,TYMATR*4,TYFACT*6,TYWORK*6,NMSTOK*6
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE (ERCODE(89:89),TYFACT),(ERCODE(97:97),TYMATR)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FiLU*')
      TYFACT='L.U'
      NOTIDM=NMMATR.NE.NMFACT.OR.NVMATR.NE.NVFACT 
*  
*     Recherche des longueurs et adresses des structures de description
*     des termes : #OMTRM et $SDTRM
      CALL TBRR2  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
* 
*--   Recherche des attributs de la matrice
*
      NUTERM=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATR,NVMATR)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN,ITSYMA
     &            ,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM,NVDULM
     &            ,NBNELM,NVNULM,INSTOK,NVPLAG,NVCOMA,IATRDO,NIVIMA)    !sdexplo
      IF (NBNECM.NE.NBNELM) CALL ERTERM (1,NMMATR,NVMATR)               !utilite
*
*--   Cas d'une matrice stockee sous forme Bi-Morse
*
      IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
*        Cas d'une matrice stockee Bi-Morse
*        (voir FIMLU avec concatenation de plages)

         CALL FIPREP (NMMATR,NVMATR,' ',0     ,TYMATR,ITSYMA,INSTOK
     &               ,MCMATR,TYFACT,NMFACT,NVFACT,MCFACT,NVBMOR,MCBMOR
     &               ,NCPINC,NIVIMP,IMPSDR)                             !syslin
*
         CALL EXBMOR (MCBMOR,IST(MCBMOR)
     &               ,NBL,NBPLAG,MCPLAL,MCPLIL,LGMORL
     &               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)                  !utilite
*
         MCMATL=MCMATR+MIN(NBL,NBC)
         MCMATU=MCMATL+LGMORL
*        La matrice a factoriser est:
*        soit identique a la factorisee L.U. non-symetrique,
*        soit a ete recopiee en entier dans la factorisee L.U. non-symetrique
         MCFACL=MCFACT+MIN(NBL,NBC)
         MCFACU=MCFACL+LGMORL
*
         CALL LUIBM (TYMATR,NBL
     &              ,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU),IST(MCPLIU)
     &              ,MCMATR,MCMATL,MCMATU,EPSMAC,MCFACT,MCFACL,MCFACU
     &              ,RST,CST)                                           !syslin
*  
*        Elimination des tableaux de travail et sauvegarde des matrices 
         CALL TBSAVE ('&BMORS',NVBMOR)
         IF (NCPINC.GT.1) THEN
            NMSTOK = STODLN (INSTOK,NCPINC,NCPINC)                         !utilite
            CALL TBSAVE (NMSTOK,NVBMOR)
         ENDIF
*
      ELSE
*        Le cas d'une inconnue vectorielle n'est pas considere
*        dans le cas d'une matrice non bimorse
         TYMATR=TYPINT (ITYMAT)                                         !utilite
*  
         IF (NOTIDM) THEN  
*--         Mise a jour de la structure $SDTRM pour le terme factorise
            CALL ALFANU (NBCHNT,NMFACT)                                 !utilite
            NUTERM=KLTERM (NMFACT,NVFACT,AST(MCMTRM),IST(MCDTRM))       !sdexplo
            IF (NUTERM.LE.0) THEN  
               NWHTRM=MAX(NCHTRM,LEN(NMFACT)) 
               CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)        !sdexplo
               CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)   !sdexplo
               CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
               CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMFACT)           !utilite
               CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)    !utilite
               NUTERM=NBTERM  
            ENDIF
            IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         ENDIF
*
         NUFACT=INDFAC (TYFACT)
         ITSYMA=INDSYM (' ')
         CALL PUTTRM (IST(IADTRM),NVFACT,ITYMAT,INTYKL('FACTOR'),NUFACT
     &               ,0,ITSYMA,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM
     &               ,NVDULM,NBNELM,NVNULM,INSTOK,NVPLAG,NVCOMA,IATRDO
     &               ,NIVIMP)                                           !sdexplo
*
         IF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                         !utilite

            CALL TBRR2  (ERCODE,NMMATR,NVMATR,LGMATR
     &                         ,'&PLAGE',NVPLAG,MCPLAG)
*  
*--         Creation si necessaire du tableau contenant la factorisee
            IF (NOTIDM) CALL TBCREE (NMFACT,NVFACT,ITYMAT,LGMATR,'c')
*--         Creation des tableaux de travail pour la fact. LU incomplete 
            LGWORK=LGMATR
            LGCOMP=2*NBNELM  
            IF (SYMSTR(1:1).NE.'S') LGCOMP=LGCOMP+NBNELM  
            IF (TYMATR(1:1).EQ.'C') LGCOMP=(LGCOMP+1)/2
            LGWORK=LGWORK+LGCOMP 
            CALL TBCREE ('$WORK$',0,ITYMAT,LGWORK,'c')
*  
            IF (SYMSTR(1:1).NE.'S') THEN  
*  
*--            Creation des tableaux de travail pour le compactage colonne
*              dans le cas d'une matrice non symetrique en structure  
               LGPLAC=5+(NBNECM+1)*(NBNELM+1)
               CALL TBCRSU ('&PLAGE',0,1,LGPLAC,LGREEL,'c')
               NBPLAX=(LGREEL-4-NBNECM)/2
               CALL TBAR4  (ERCODE,'$WORK$',0,MCTRAM,'&PLAGE',0  ,MCGALP
     &                     ,NMMATR,NVMATR,MCMATR,'&PLAGE',NVPLAG,MCPLAG)
               IST(MCGALP)  =NBNECM  
               IST(MCGALP+1)=NBNELM  
               IST(MCGALP+2)=NBPLAX  
               IST(MCGALP+3)=IST(MCPLAG+3)
               MCCOLI=MCTRAM+LGMATR  
               IF (TYMATR(1:1).EQ.'C') MCCOLI=2*MCCOLI-1  
*  
               CALL MO2MOC (MCMATR,ITYMAT,NBNECM,NBNELM
     &                     ,IST(MCPLAG+4),IST(MCPLAG+4+NBNELM)
     &                     ,MCTRAM,IST(MCGALP+4),IST(MCGALP+4+NBNECM)
     &                     ,IST(MCGALP+2),IST(MCCOLI),RST,CST,*99990)   !morse
               IF (NIVIMP.GT.2) THEN
                  CALL PRMORS (IST(MCGALP),'C',' Terme'
     &                        ,NMMATR,NVMATR,NIVIMP,IMPSDR)             !prsd
               ENDIF 
            ELSE 
               CALL TBAR3  (ERCODE,NMMATR,NVMATR,MCMATR                 
     &                   ,'&PLAGE',NVPLAG,MCPLAG,'$WORK$',0,MCTRAM)
               MCGALP=MCPLAG 
            ENDIF 
            MCFACT=MCMATR
            IF (NOTIDM) CALL TBAR1  (ERCODE,NMFACT,NVFACT,MCFACT)
         ELSE
            CALL ERTERM (15,NMMATR,NVMATR)                              !utilite
         ENDIF
*  
*--      Factorisation incomplete proprement dite
*
         MCDIAG=MCTRAM+LGMATR 
         IF (TYMATR(1:1).EQ.'C') MCDIAG=2*MCDIAG-1 
         MCLIGN=MCDIAG+NBNELM
         MCPLAJ=MCPLAG+4+IST(MCPLAG)
*
         CALL LUIMO  (TYMATR,NBNELM,IST(MCPLAG+4),IST(MCPLAJ),MCMATR
     &               ,EPSMAC,MCFACT,IST(MCGALP+4),IST(MCGALP+4+NBNECM)
     &               ,MCTRAM,IST(MCDIAG),IST(MCLIGN),RST,CST)           !syslin
*  
*        Elimination des tableaux de travail et sauvegarde des matrices 
         IF (SYMSTR(1:1).NE.'S') CALL TBTUER ('&PLAGE',0)
         CALL TBTUER ('$WORK$',0)
         CALL TBSAVE ('&PLAGE',NVPLAG)
      ENDIF
*
      IF (NIVIMP.GT.0) CALL PRTERM (NMFACT,NVFACT,NIVIMP,IMPSDR)        !prsd
      IF (NOTIDM) CALL TBSAVE (NMMATR,NVMATR)
      CALL TBSAVE (NMFACT,NVFACT)
      CALL PRFXMJ (-1,'*FiLU*')  
      RETURN
*-----------------------------------------------------------------------
99990 CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
      IF (NOTIDM) THEN  
         CALL BAISE  (' Depassement du nombre de plage pour le stockage'
     &   //' Morse-colonne de la matrice '//ERCODE(1:NCATR1)
     &   //'. Une solution (?): La factoriser dans elle-meme.')
      ELSE 
         CALL BAISE  (' Depassement du nombre de plage pour le stockage'
     &   //' Morse-colonne de la matrice '//ERCODE(1:NCATR1)
     &   //'. Avez-vous bien sauvegarde vos autres tableaux ?')
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (26 juin 2001)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !FiLU
