*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE FIPREP (NMMATR,NVMATR,SYMSTR,NPLCAT,TYMATR,ITSYMA
     &                  ,INSTOK,MCMATR,TYFACT,NMFACT,NVFACT,MCFACT
     &                  ,NVSTFA,MCSTFA,NCPICM,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991) 
* Derniere modification : D.Martin (08 octobre 2008)
* Version 2
*  
* Preparation des matrices initiale et factorisee avant une factorisation
* incomplete de type Gauss, eventuellement modifiee par remplissage partiel.
*
* La matrice initiale est stockee sous forme 'BiMorse' ou sous forme 'Morse-L'
* La matrice a factoriser est stockee sous forme 'BiMorse' en sortie,
* ses pointeurs etant soit repris s'ils existent, soit recalcules a partir
* des pointeurs de la matrice initiale.
*  
*-- Arguments d'entree --
* NMMATR nom du tableau contenant la matrice a factoriser 
* NVMATR son niveau
* SYMSTR indicateur de matrice a structure symetrique dans le cas 'Morse-L'
* NPLCAT nombre de plages concatenees dans la matrice 'BiMorse'
* TYFACT type de factorisation
* NMFACT nom du terme (stocke 'Bi-morse') devant contenir la factorisee
* NVFACT son niveau
* NIVIMP niveau d'impression du terme factorise
* IMPFCH numero d'unite logique d'impression
*-- Arguments de sortie --
* TYMATR type reel ou complexe de la matrice
* ITSYMA indicateur de symetrie de la matrice en entree
* INSTOK type de stockage de la matrice en entree
* MCMATR adresse de la diagonale du terme a factoriser
* MCFACT adresse de la diagonale du terme factorise
* NCPINC nombre de composantes de l'inconnue
* NVSTFA niveau du tableau de stockage 'BiMorse' de la matrice factorisee
* MCSTFA adresse du tableau de stockage 'Bimorse'
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYFACT,TYMATR,SYMSTR,NMMATR,NMFACT
      INTEGER       NVMATR,ITSYMA,INSTOK,MCMATR,NVFACT,MCFACT,NPLCAT
     &             ,NVSTFA,MCSTFA,NCPICM,NIVIMP,IMPFCH
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDFAC,INDSTO,INTYKL,KLTERM,KLNIVE
      INTEGER       NUFACT,INDSTF,MCINCO,LGMTRM,MCMTRM,NUTERM,IADTRM
     &             ,LGDTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NWHTRM
     &             ,NVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN,NVDSMB
     &             ,NUINCM,NVDUCM,NBNECM,NVNUCM,NUINLM,NVDULM,NBNELM
     &             ,NVNULM,NVSTOK,NVCOMA,IATRDO,NIVIMA
     &             ,ITMAFA,ITSYFA,NVDSFA,NUINCA,NVDUCA,NBNECA,NVNUCA
     &             ,NUINLA,NVDULA,NBNELA,NVNULA,INDSFA,NVCOMO
     &             ,NIVIPR,LGAJST
     &             ,INTRPC,NBTNEC,NCPILM,INTRPL,NBTNEL,NWLCAT
     &             ,MCSTOK,MCPLAG,MCPLAJ,NBPLAG,MORELG,LGMATR,LGSTFA
     &             ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL,MCFLAL,MCFLIL,MCFAVL
     &             ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU,MCFLAU,MCFLIU,MCFAVU
     &             ,NBZ,NBPLAZ,MCPLAZ,MCPLIZ,LGMORZ,MCCOLI
     &             ,MCDSMA
     &             ,NCATR1,I
      LOGICAL       IDEMTR
      CHARACTER     STODLN*6,STOIND*7,TYPINT*4,PRFXAS*8
      CHARACTER     ERCODE*120,SYMVTR,MULTIM,TYWORK*6,NMSTOK*6
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*FiPrep*')
*
      IDEMTR=NMMATR.EQ.NMFACT.AND.NVMATR.EQ.NVFACT
      SYMVTR=SYMSTR(1:1)
      IF (TYFACT(1:3).NE.'L.U'.AND.TYFACT(1:5).NE.'L.D.U') SYMVTR='S'
      NUFACT=INDFAC (TYFACT)                                            !utilite
      INDSTF=INDSTO ('BIMORSE')                                         !utilite
*  
*--   Recherche des longueurs et adresses des structures de description
*     des termes : #OMTRM et $SDTRM
*
      CALL TBRR3  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*  
*--   Recherche des attributs de la matrice NMMATR 
*
      NUTERM=KLTERM (NMMATR,NVMATR,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATR,NVMATR)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NVVMAT,ITYMAT,ITYCAL,NUKALE,NUDONN
     &            ,ITSYMA,NVDSMB,NUINCM,NVDUCM,NBNECM,NVNUCM
     &            ,NUINLM,NVDULM,NBNELM,NVNULM,INSTOK,NVSTOK
     &            ,NVCOMA,IATRDO,NIVIMA)                                !sdexplo
*
      MULTIM='N'
      IF (NVDSMB.NE.NDFDSM.AND.NUINCM.EQ.NDFINC.AND.NUINLM.EQ.NDFINC)
     &   MULTIM='Y'
*
      TYMATR=TYPINT (ITYMAT)                                            !utilite
      NCPICM=1
      NCPILM=1
      IF (MULTIM.EQ.'N') THEN
         IF (NBNECM.NE.NBNELM) CALL ERTERM (11,NMMATR,NVMATR)           !utilite
         CALL SDEXCO (NUINCM,IST(MCINCO),NCPICM,INTRPC,NBTNEC)          !utilite
         NCPILM=NCPICM
         IF (NUINLM.NE.NUINCM)
     &      CALL SDEXCO (NUINLM,IST(MCINCO),NCPILM,INTRPL,NBTNEL)       !utilite
         IF (NCPICM.NE.NCPILM) CALL ERTERM (16,NMMATR,NVMATR)           !utilite
      ELSE
*        Cas "multi-inconnue"
         CALL TBRR1  (ERCODE,'$DSMBL',NVDSMB,MCDSMA)
         CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      ENDIF
*
      NWLCAT=NPLCAT
      IF (NPLCAT.EQ.-1) THEN
*        Factorisation complete
         NWLCAT=MAX (NBNECM,NBNELM)
      ENDIF
*
*--   Recherche des attributs de la matrice NMFACT
*
      IF (.NOT.IDEMTR) THEN
         NUTERM=KLTERM (NMFACT,NVFACT,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.LE.0) THEN 
            CALL ALFANU (NBCHNT,NMFACT)                                 !utilite
            NWHTRM=MAX (NCHTRM,LEN (NMFACT)) 
            CALL SDAJST ('#OMTRM',1,LGMTRM,0,NWHTRM,NBTERM,1)           !sdexplo
            CALL SDAJST ('$SDTRM',1,LGDTRM,LGETRM,INCTRM,NBTERM,1)      !sdexplo
            CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
            CALL RIPCHN (AST(MCMTRM),NBTERM,NCHTRM,NMFACT)              !utilite
            CALL SDMKDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)       !utilite
            NUTERM=NBTERM
            NVSTFA=NVSTOK
            IF (INSTOK.NE.INDSTF) NVSTFA=NDFSTO
         ELSE
            IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
            CALL GETTRM (IST(IADTRM),NVVMAT,ITMAFA,ITYCAL,NUKALE,NUDONN
     &                  ,ITSYFA,NVDSFA,NUINCA,NVDUCA,NBNECA,NVNUCA
     &                  ,NUINLA,NVDULA,NBNELA,NVNULA,INDSFA,NVSTFA
     &                  ,NVCOMO,IATRDO,NIVIPR)                          !sdexplo
            IF (INDSFA.NE.INDSTF) NVSTFA=NDFSTO
         ENDIF
         IF (NWLCAT.GT.0) NVSTFA=NDFSTO
      ENDIF
*
      ITSYFA=ITSYMA
      IF (TYFACT(1:3).EQ.'L.U'.OR.TYFACT(1:5).EQ.'L.D.U') ITSYFA=NDFSYM
      INDSFA=INDSTF
*
      IF (INSTOK.EQ.INDSTF) THEN
*
*--                Cas d'une matrice Bi-Morse en entree
*
         NMSTOK = STODLN (INSTOK, NCPILM, NCPILM)                       !utilite
         CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGMATR)
         IF (NVSTFA.LE.0) NVSTFA=KLNIVE ()                              !sdexplo
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,NMSTOK,NVSTFA,LGSTFA)
*
         IF (ERCODE(1:1).EQ.'C') THEN
            IF (NCPILM.GT.1) THEN
*              Cas d'inconnue vectorielle, compactage en d.l.
               CALL BMO2DL (NVSTOK,NCPILM,NCPICM,ITSYMA,NMMATR,NVMATR
     &                     ,NIVIMP)                                     !sdexplo
            ENDIF
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
*  
*--         Creation du tableau de contenant les pointeurs 'BIMORSE' de
*           la  future matrice factorisee
*
            CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
            CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !utilite
            LGSTFA=1+NBL+2*NBPLAL
            IF (IST(MCSTOK).GT.2) LGSTFA=LGSTFA+NBC+2*NBPLAU
            CALL TBCREE (NMSTOK,NVSTFA,1,LGSTFA,'c')
            CALL TBAR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK
     &                         ,NMSTOK,NVSTFA,MCSTFA)
            CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !utilite
*
*           Pointeurs et taille de la partie triang. inferieure
            IST(MCSTFA)=2
            DO 5 I=1,NBL+2*NBPLAL
               IST(MCSTFA+I)=IST(MCSTOK+I)
5           CONTINUE
*
*           Le cas echeant concatenation de plages sous-diagonales
            IF (NWLCAT.GT.0)                  
     &      CALL BMFILP (NWLCAT,NBL,NBC,IST(MCSTFA+2),IST(MCSTFA+1+NBL))!Morse
            CALL EXBMOR (MCSTFA,IST(MCSTFA)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBZ,NBPLAZ,MCPLAZ,MCPLIZ,LGMORZ)               !utilite
            LGAJST=1+NBL+2*NBPLAL
*
            IF (IST(MCSTOK).GT.2) THEN
*
*              Pointeurs et taille de la partie triang. superieure
               IST(MCSTFA)=LGAJST+1
               DO 6 I=0,NBC+2*NBPLAU-1
                  IST(MCSTFA+LGAJST+I)=IST(MCPLAU-1+I)
6              CONTINUE
*
               CALL EXBMOR (MCSTFA,IST(MCSTFA)
     &                     ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                     ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)            !utilite
*
*              Le cas echeant concatenation de plages sur-diagonales
               IF (NWLCAT.GT.0)                
     &         CALL BMFILP (NWLCAT,NBC,NBL,IST(MCPLAU),IST(MCPLIU))     !morse
            ENDIF
            TYWORK=NMFACT
            IF (NIVIMP.GT.1) CALL PRBMOR (IST(MCSTFA),PRFXAS (0)
     &                //' Terme ',TYWORK,NVFACT,NIVIMP,IMPFCH)          !sdexplo
            CALL EXBMOR (MCSTFA,IST(MCSTFA)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !utilite

            IF (IST(MCSTFA).GT.2) LGAJST=LGAJST+NBC+2*NBPLAU
            CALL TBAJST (NMSTOK,NVSTFA,LGAJST)
         ELSE
            CALL TBRR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         ENDIF
*
         CALL TBAR1  (ERCODE,NMSTOK,NVSTFA,MCSTFA)
         CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)                  !utilite
         IF (ITSYFA.NE.NDFSYM) LGMORU=0
*
         IF (.NOT.IDEMTR) THEN
*  1)       Pour la factorisation de la matrice stockee 'BiMorse' dans
*           une autre, creation du tableau contenant la future factorisee
            TYWORK=TYFACT
            CALL TBCREE (NMFACT,NVFACT,ITYMAT,NBL+LGMORL+LGMORU,'c')
            CALL TBAR4 (ERCODE,NMSTOK,NVSTFA,MCSTFA,NMSTOK,NVSTOK,MCSTOK
     &                       ,NMMATR,NVMATR,MCMATR,NMFACT,NVFACT,MCFACT)
            CALL EXBMOR (MCSTFA,IST(MCSTFA)
     &                 ,NBL,NBPLAL,MCFLAL,MCFLIL,LGMORL 
     &                 ,NBC,NBPLAU,MCFLAU,MCFLIU,LGMORU)                !utilite
            CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &                  ,NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL
     &                  ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)               !utilite
            CALL BM2BM  (NBL,NBC,TYMATR,ITSYMA,IST(MCPLAL),IST(MCPLIL)
     &                  ,IST(MCPLAU),IST(MCPLIU),MCMATR,ITSYFA
     &                  ,IST(MCFLAL),IST(MCFLIL),IST(MCFLAU),IST(MCFLIU)
     &                  ,MCFACT,RST,CST)                                !morse
            CALL TBSAVE (NMSTOK,NVSTOK)
            MCMATR=MCFACT
         ELSE
*           La factorisee L.U. ne peut entrer dans une matrice symetrique
*           (cas ITSYFA.NE.ITSYMA)
            IF (LGMATR.NE.NBL+LGMORL+LGMORU) 
     &         CALL ERTERM (3,NMMATR,NVMATR)                            !utilite
*  2)       Pour la factorisation de la matrice stockee 'BiMorse' dans
*           elle-meme
            CALL TBAR2  (ERCODE,NMSTOK,NVSTFA,MCSTFA
     &                         ,NMFACT,NVFACT,MCFACT)
            MCMATR=MCFACT
         ENDIF
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
*
*--              Cas d'une matrice Morse-Ligne en entree
*
*  3)    Factorisation de la matrice stockee 'Morse' 
*        dans une autre matrice stockee BiMorse
         CALL TBRR2 (ERCODE,NMMATR,NVMATR,LGMATR,'&PLAGE',NVSTOK,MCPLAG)
         IF (IDEMTR) CALL ERTERM (3,NMMATR,NVMATR)                      !utilite
         IF (NVSTFA.LE.0) NVSTFA=KLNIVE ()                              !sdexplo
         ERCODE(1:1)='!'
         CALL TBRR1  (ERCODE,'&BMORS',NVSTFA,MCSTFA)
*
         IF (ERCODE(1:1).EQ.'C') THEN
            IF (NCPILM.GT.1) CALL ERTERM (18,NMMATR,NVMATR)             !utilite
            CALL TBAR1  (ERCODE,'&PLAGE',NVSTOK,MCPLAG)
            NBPLAG=IST(MCPLAG+3+NBNELM)
            MORELG=0
            IF (SYMVTR.NE.'S') MORELG=NBNELM+2*NBPLAG+3*NBNELM
*  
*--         Creation du tableau de contenant les pointeurs 'BIMORSE'
*
            CALL TBCREE ('&BMORS',NVSTFA,1,1+NBNELM+2*NBPLAG+MORELG,'c')
            CALL TBAR2  (ERCODE,'&PLAGE',NVSTOK,MCPLAG 
     &                         ,'&BMORS',NVSTFA,MCSTFA)
            MCPLAG=MCPLAG+4
            MCPLAJ=MCPLAG+NBNELM
            IST(MCSTFA)  =2
            IST(MCSTFA+1)=NBNELM
*
*           Pointeurs et taille de la partie triang. inferieure
            CALL CM2LBM (NBNELM,NBNELM,IST(MCPLAG),IST(MCPLAJ) 
     &                  ,IST(MCSTFA+2),IST(MCSTFA+1+NBNELM))            !morse
*           Le cas echeant concatenation de plages sous-diagonales
            IF (NWLCAT.GT.0) CALL BMFILP (NWLCAT,NBNELM,NBNELM
     &                              ,IST(MCSTFA+2),IST(MCSTFA+1+NBNELM))!morse
            CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL
     &                  ,LGMORL,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)        !utilite
            LGAJST=1+NBNELM+2*NBPLAL
*
            IF (SYMVTR.NE.'S')THEN
*              Pointeurs et taille de la partie triang. superieure
               IST(MCSTFA)=LGAJST+1
               IST(MCSTFA+LGAJST)=NBNELM
               CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL
     &                     ,LGMORL,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)     !utilite
               MCCOLI=MCPLIU+2*NBPLAG
               CALL CM2UBM (NBNELM,NBNELM,IST(MCPLAG),IST(MCPLAJ)
     &                     ,IST(MCPLAU),IST(MCPLIU),IST(MCCOLI))        !morse
*              Le cas echeant concatenation de plages sur-diagonales
               IF (NWLCAT.GT.0) CALL BMFILP (NWLCAT,NBNELM,NBNELM
     &                                     ,IST(MCPLAU),IST(MCPLIU))    !morse
            ENDIF
*
            TYWORK=NMFACT
            IF (NIVIMP.GT.1) CALL PRBMOR (IST(MCSTFA),PRFXAS (0)
     &                //' Terme ',TYWORK,NVFACT,NIVIMP,IMPFCH)          !prsd
            CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL
     &                          ,LGMORL,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)!utilite
            IF (IST(MCSTFA).GT.2) LGAJST=LGAJST+NBNELM+2*NBPLAU
            CALL TBAJST ('&BMORS',NVSTFA,LGAJST)
*
         ELSE
*
            CALL TBAR1  (ERCODE,'&BMORS',NVSTFA,MCSTFA)
            CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL     
     &                  ,LGMORL,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)        !utilite
         ENDIF
*
*--      Creation du tableau contenant la factorisee sous forme 'Bi-morse'
*
         IF (TYFACT(1:3).NE.'L.U') THEN
            LGMORU=0
         ELSE
            CALL TBCREE ('$WORK$',0,1,3*NBNELM,'c')
         ENDIF
         TYWORK=TYFACT
         CALL TBCREE (NMFACT,NVFACT,ITYMAT,NBNELM+LGMORL+LGMORU,'c')
         CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR, NMFACT ,NVFACT,MCFACT 
     &               ,'&PLAGE',NVSTOK,MCPLAG,'&BMORS',NVSTFA,MCSTFA)
         CALL EXBMOR (MCSTFA,IST(MCSTFA),NBL,NBPLAL,MCPLAL,MCPLIL,LGMORL 
     &               ,NBC,NBPLAU,MCPLAU,MCPLIU,LGMORU)                  !utilite
         MCFAVL=MCFACT+NBNELM
         MCFAVU=MCFAVL+LGMORL
         MCPLAG=MCPLAG+4
         MCPLAJ=MCPLAG+NBNELM
*
         IF (TYFACT(1:3).EQ.'L.U') THEN
            CALL TBAR1  (ERCODE,'$WORK$',0,MCCOLI)
*
            CALL MM2BM  (NBNELM,NBNELM,IST(MCPLAG),IST(MCPLAJ),TYMATR
     &                  ,MCMATR,IST(MCPLAL),IST(MCPLIL),IST(MCPLAU)
     &                  ,IST(MCPLIU),MCFACT,MCFAVL,MCFAVU,IST(MCCOLI)
     &                  ,RST,CST)                                       !Morse
*
            CALL TBTUER ('$WORK$',0)
         ELSE
            CALL MM2LBM (NBNELM,NBNELM,IST(MCPLAG),IST(MCPLAJ),TYMATR
     &                  ,MCMATR,IST(MCPLAL),IST(MCPLIL),MCFACT,MCFAVL
     &                  ,RST,CST)                                       !Morse
         ENDIF
         CALL TBSAVE ('&PLAGE',NVSTOK)
         MCMATR=MCFACT
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-C')) THEN                        !utilite
*
*--              Cas d'une matrice Morse-Colonne en entree
         CALL ERTERM (15,NMMATR,NVMATR)                                 !utilite
      ELSEIF (INSTOK.EQ.INDSTO ('PROFIL')) THEN                         !utilite
*
*--               Cas d'une matrice Profil en entree
         CALL ERTERM (15,NMMATR,NVMATR)                                 !utilite
      ELSE
         CALL ERTERM (15,NMMATR,NVMATR)                                 !utilite
      ENDIF
*
*--   Mise a jour de la structure $SDTRM pour le terme factorise
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
*
      CALL PUTTRM (IST(IADTRM),NVFACT,ITYMAT,INTYKL('FACTOR'),NUFACT,0  
     &            ,ITSYFA,NVDSMB,NUINCM,NVDUCM,NBNELM,NVNUCM,NUINLM
     &            ,NVDULM,NBNELM,NVNULM,INDSFA,NVSTFA,NVCOMA,IATRDO
     &            ,NIVIMP)                                              !sdexplo
*--
      TYWORK=TYFACT
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         IF (NWLCAT.LE.0) THEN
            CALL PRNTRM (NMMATR,NVMATR,ERCODE(1:32),NCATR1)
            WRITE (IMPPAL,10000) PRFXAS (1),TYWORK
     &                          ,STOIND (INSTOK),ERCODE(1:NCATR1)
         ELSE
            CALL PRNTRM (NMMATR,NVMATR,ERCODE(1:32),NCATR1)
            WRITE (IMPPAL,10001) PRFXAS (1),TYWORK
     &                          ,STOIND (INSTOK),ERCODE(1:NCATR1)
            WRITE (IMPPAL,10003) NWLCAT
         ENDIF
         IF (.NOT.IDEMTR) THEN
            CALL PRNTRM (NMFACT,NVFACT,ERCODE(1:32),NCATR1)
            WRITE (IMPPAL,10002) ERCODE(1:NCATR1)
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*FiPrep*')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Factorisation ',A,' incomplete'
     &,' de la matrice ',A,': ',A)
10001 FORMAT(/T2,A8,' Factorisation ',A,' incomplete modifiee'
     &,' de la matrice ',A,': ',A)
10002 FORMAT(T10   ,' sous le nom de terme : ',A
     &,' et la structure BIMORSE.')
10003 FORMAT(T10   ,' (concatenation des',I6,' premieres plages '
     &,'a partir de la diagonale)')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1 : D.Martin (30 Janvier 1998)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                                                                    END !FiPrep
