*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GAUSMC (NMMATR,NVMATR,NMSCMB,NVSCMB,NBSCMB  
     &                  ,EPSILO,PIVO,NMSOLU,NVSOLU,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.DeBayser (Septembre 1989)
* Derniere modification : D.Martin (8 octobre 2008)
* Version 2
*  
* Resolution d'un systeme lineaire reel ou complexe par la methode de Gauss 
* en memoire centrale, avec/sans recherche de pivot maximum partiel/total 
*  
*-- Arguments d'entree -- 
* NMMATR nom du tableau contenant la matrice  
* NVMATR son niveau
* NMSCMB nom du tableau contenant le(s) second(s) membre(s)
* NVSCMB son niveau
* NBSCMB nombre effectif de Seconds Membres
* EPSILO seuil  de non-inversibilite portant sur le pivot mimimum .
* PIVO   recherche de pivot maximum , partiel si PIVO(1:1) = 'P' ;
*                                   , total   si PIVO(1:1) = 'T' ;
*        sans recherche de pivot maximum sinon .  
* NMSOLU nom du tableau contenant la(les) solution(s) 
* NVSOLU son niveau
* NIVIMP niveau d'impression pour la solution 
* Remarque : Le sous-programme de resolution par methode de GAUSS proprement dit
*            utilise deux tableaux pleins :
*           - la matrice decompactee correspondant a NMMATR
*           - le second membre correspondant a NMSCMB renumerote dans 
*                lequel le sous-programme retourne la solution.  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATR,NMSCMB,NMSOLU,PIVO
      INTEGER       NVMATR,NVSCMB,NBSCMB,NVSOLU,NIVIMP
      REAL          EPSILO
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDSTO,INDSYM,INTTYP
      CHARACTER     STODLN*6,TYPINT*8
      LOGICAL       SINGUL,IDSOLU,IDSCMB
      INTEGER       NIVPLE,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NV2MMB
     &             ,ITYSYM,NVDSMA,NUINLM,NCPINC,NVDULM,NBNELM,NVNULM
     &             ,INSTOK,NVSTOK,NVCOMA,NVDSSC,NVDUSC,ITFACT,NUFACT
     &             ,INDSTP,NVSTOP,LNSOLU,LNSCMB
     &             ,ITMATR,ITSCMB,ITSOLU,MCSTOK,MCMATR,MC2MMB,MCSOLU
     &             ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL,ICMPLX,IDLHRM
     &             ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU,MCPLEI
     &             ,NBNESC,NVNUSC,MCNUML,MCPIVO,NCATR1,NCATR2,NCATR3
      REAL          RDETER,PIVMIN
      COMPLEX       CDETER
      CHARACTER*8   TYMATR,TYSCMB,TYSOLU,TYMATP
      CHARACTER     ERCODE*120,MATPLE*6,NOMPLE*6,NMSTOK*6,NM2MMB*6
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(73:73),TYMATP),(ERCODE(81:81),TYMATR)
     &            ,(ERCODE(89:89),TYSCMB),(ERCODE(97:97),TYSOLU)
     &            ,(ERCODE(105:105),NOMPLE),(ERCODE(111:111),NM2MMB)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Gausmc*')
*  
      CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*
      MATPLE='!MATPL'
      NOMPLE=NMMATR
      NIVPLE=NVMATR
      NM2MMB=' '
      NV2MMB=0
      LNSOLU=LEN (NMSOLU)
      LNSCMB=LEN (NMSCMB)
* 
*--   Caracteristiques du systeme
      CALL SYPREP (NMMATR,NVMATR,NMSCMB,NVSCMB,NM2MMB,NV2MMB,TYMATR
     &            ,ITYSYM,NVDSMA,NUINLM,NCPINC,NVDULM,NBNELM,NVNULM
     &            ,INSTOK,NVSTOK,NVCOMA,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,TYMATP,ITFACT,NUFACT,INDSTP,NVSTOP,NBLIGN)    !syslin
      ITMATR=INTTYP (TYMATR)                                            !utilite
      ITSCMB=INTTYP (TYSCMB)                                            !utilite
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         IF (PIVO(1:1).EQ.'T') THEN
           WRITE (IMPPAL,10000) 'avec strategie de pivot total',NBLIGN
         ELSEIF (PIVO(1:1).EQ.'P') THEN
           WRITE (IMPPAL,10000) 'avec strategie de pivot partiel',NBLIGN
         ELSE
           WRITE (IMPPAL,10000) ' ',NBLIGN
         ENDIF
      ENDIF
*  
*--   Changement eventuel de stockage de la matrice 
      IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         NOMPLE=MATPLE(1:NCHTRM)
         NIVPLE=0
         NMSTOK = STODLN (INSTOK, NCPINC, NCPINC)                       !utilite
         CALL TBRR2  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &               ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)                  !utilite
         IF (NBLIGN.NE.NBCOLO) CALL ERTERM (11,NMMATR,NVMATR)           !utilite
* 
         CALL TBCREE (NOMPLE(1:NCHTRM),NIVPLE,ITMATR,NBLIGN*NBLIGN,'c')                     
         CALL TBAR3  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK
     &                      ,NOMPLE(1:NCHTRM),NIVPLE,MCPLEI)
         CALL TAZERO (NBLIGN*NBLIGN,TYMATR,MCPLEI,AST,IST,RST,CST)      !utilite
         CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &               ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)                  !sdexplo
*        Changement de structure de la matrice en une matrice pleine
         CALL BMD2PL (TYMATR,NBLIGN,NBLIGN,MCMATR,MCPLEI,RST,CST)       !morse
         CALL BMU2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &               ,MCMATR+NBLIGN,MCPLEI,RST,CST)                     !morse
         IF (ITYSYM.EQ.INDSYM (' ')) THEN                               !utilite
            CALL BML2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAU),IST(MCPLIU)
     &                  ,MCMATR+NBLIGN+LGL,MCPLEI,RST,CST)              !morse
         ELSEIF (ITYSYM.EQ.INDSYM('SYMETRIQUE')) THEN                   !utilite
            CALL BML2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &                  ,MCMATR+NBLIGN,MCPLEI,RST,CST)                  !morse
         ELSE
            CALL BAISE  ('Cas de symetrie non prevu')                   !utilite
         ENDIF
         CALL TBSAVE (NMSTOK,NVSTOK)
         CALL TBSAVE (NMMATR,NVMATR)
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
*
         NOMPLE=MATPLE(1:NCHTRM)
         NIVPLE=0
         NMSTOK='&PLAGE' 
         CALL TBRR2  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXMORS (MCSTOK,IST(MCSTOK)
     &               ,NBLIGN,NBCOLO,NBPLAL,MCSTOK,MCPLAL,LGL)           !sdexplo
         IF (NBLIGN.NE.NBCOLO) CALL ERTERM (11,NMMATR,NVMATR)           !utilite
*
         CALL TBCREE (NOMPLE(1:NCHTRM),NIVPLE,ITMATR,NBLIGN*NBLIGN,'c')                     
         CALL TBAR4  (ERCODE,NMMATR,NVMATR,MCMATR,NMSTOK,NVSTOK,MCSTOK
     &                      ,NOMPLE(1:NCHTRM),NIVPLE,MCPLEI
     &                      ,'#GNEDO',NVNULM,MCNUML)
         CALL TAZERO (NBLIGN*NBLIGN,TYMATR,MCPLEI,AST,IST,RST,CST)      !utilite
         CALL EXMORS (MCSTOK,IST(MCSTOK)
     &               ,NBLIGN,NBCOLO,NBPLAL,MCSTOK,MCPLAL,LGL)           !sdexplo
*        Changement de structure de la matrice en une matrice pleine 
         ICMPLX=1  
         IF (TYMATR(1:1).EQ.'C') THEN
            ICMPLX=2
            MCMATR=1+2*(MCMATR-1)  
            MCPLEI=1+2*(MCPLEI-1)  
         ENDIF 
         IDLHRM=0
         CALL MO2PL (ICMPLX,NBNELM,NBLIGN,NBLIGN,IST(MCSTOK),IST(MCPLAL) 
     &              ,IDLHRM,IST(MCNUML+2),RST(MCMATR),RST(MCPLEI))      !morse
         CALL TBSAVE ('#GNEDO',NVNULM)
         CALL TBSAVE (NMSTOK,NVSTOK)
         CALL TBSAVE (NMMATR,NVMATR)
*
      ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-L')) THEN                        !utilite
         CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGL)
         NBLIGN=NBNELM*NCPINC
         IF (LGL.NE.NBLIGN*NBLIGN) CALL ERTERM (11,NMMATR,NVMATR)       !utilite
*
      ELSE 
         CALL ERTERM (18,NMMATR,NVMATR)                                 !utilite
      ENDIF
*  
*--   Vecteur(s) solution
      ITSOLU=ITSCMB
      IF (TYMATR(1:1).EQ.'C') ITSOLU=ITMATR 
      TYSOLU=TYPINT(ITSOLU)                                             !utilite
      CALL SOPREP (NMSCMB,NVSCMB,NBSCMB,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,NMSOLU,NVSOLU,TYSOLU,NUINLM,NCPINC,NVDULM
     &            ,NBNELM,NVNULM,NVCOMA,NIVIMP,NVDSMA,NM2MMB,NV2MMB)    !syslin
*
*     Ici il y a plusieurs cas en sortie de SOPREP:
*     - si la numerotation du second membre est coherente avec les colonnes
*       de la matrice, on a:                 NM2MMB=NMSCMB 
*     - si la numerotation du second membre n'est pas coherente avec les 
*       colonnes de la matrice,  alors il y a deux cas:
*     - si le terme solution n'existait pas, il est cree et rempli avec le
*       second membre renumerote et on a:    NM2MMB=NMSOLU
*     - si il preexistait, un tableau de travail est cree et rempli avec 
*       le second membre renumerote et on a: NM2MMB='$WORK$'
      IDSOLU=NM2MMB(1:LNSOLU).EQ.NMSOLU.AND.NV2MMB.EQ.NVSOLU
      IF (IDSOLU.AND.LNSOLU.LT.NCHTRM
     &   .AND.NM2MMB(LNSOLU+1:LNSOLU+1).NE.' ') IDSOLU=.FALSE.
      IDSCMB=NM2MMB(1:LNSCMB).EQ.NMSCMB.AND.NV2MMB.EQ.NVSCMB
      IF (IDSCMB.AND.LNSCMB.LT.NCHTRM
     &   .AND.NM2MMB(LNSCMB+1:LNSCMB+1).NE.' ') IDSCMB=.FALSE.
*
      IF (.NOT.IDSOLU) THEN
*        ici on decide d'ecraser le terme solution preexistant
         CALL TBAR2  (ERCODE,NM2MMB,NV2MMB,MC2MMB,NMSOLU,NVSOLU,MCSOLU)
         CALL TDANST (NBLIGN*NBSCMB,TYSCMB,MC2MMB,IST,RST,CST
     &                             ,TYSOLU,MCSOLU,IST,RST,CST)          !utilite
         IF (.NOT.IDSCMB) THEN
            CALL TBTUER (NM2MMB,NV2MMB)
         ELSE 
            CALL TBSAVE (NMSCMB,NVSCMB)
         ENDIF
      ENDIF  
*
*     Impression du second membre eventuellement renumerote
      IF (NIVIMP.GT.1) THEN
         CALL PRTERM (NOMPLE(1:NCHTRM),NIVPLE,NIVIMP,IMPSDR)            !prsd
         IF (NBSCMB.LE.1)
     &      CALL PRTERM (NMSOLU,NVSOLU,NIVIMP,IMPSDR)                   !prsd
         CALL TBRR2  (ERCODE,NOMPLE(1:NCHTRM),NIVPLE,MCMATR
     &                      ,NMSOLU,NVSOLU,MCSOLU)
      ENDIF
*
*     Creation du tableau des permutations du second membre en cas de  
*     recherche de pivot maximum total
* 
      MCPIVO=1 
      IF (PIVO(1:1).EQ.'T') THEN
         CALL TBCREE ('$PIVOT',1,1,NBLIGN,'c')
         CALL TBAR1  (ERCODE,'$PIVOT',1,MCPIVO)
      ENDIF
*  
*--   Resolution proprement dite
*
      CALL TBAR2  (ERCODE,NOMPLE(1:NCHTRM),NIVPLE,MCMATR
     &                   ,NMSOLU,NVSOLU,MCSOLU)
      IF (TYMATR(1:1).EQ.'C') THEN  
         CALL GAUSSC (NBLIGN,CST(MCMATR),NBSCMB,CST(MCSOLU),EPSILO
     &               ,PIVO,PIVMIN,IST(MCPIVO),CDETER,SINGUL)            !syslin
      ELSEIF (TYMATR(1:1).EQ.'R'.AND.TYSOLU(1:1).EQ.'R') THEN  
         CALL GAUSSR (NBLIGN,RST(MCMATR),NBSCMB,RST(MCSOLU),EPSILO
     &               ,PIVO,PIVMIN,IST(MCPIVO),RDETER,SINGUL)            !syslin
      ELSE 
         CALL BAISE  (' Type de matrice et second membre differents')   !utilite
      ENDIF
      IF (SINGUL) GOTO 99990
*  
      IF (NIVIMP.GT.0.AND.IMPSDR.GT.0) WRITE (IMPSDR,10001) PIVMIN
*  
      IF (NIVIMP.GT.1.AND.IMPSDR.GT.0) 
     &   CALL PRTERM (NMSOLU,NVSOLU,NIVIMP,IMPSDR)                      !prsd

*     Sauvegarde et Destruction des tableaux temporaires de travail
      IF (PIVO(1:1) .EQ.'T') CALL TBTUER ('$PIVOT',1)
      IF (NOMPLE(1:NCHTRM).EQ.MATPLE(1:NCHTRM)) THEN
         CALL TBTUER (NOMPLE(1:NCHTRM),NIVPLE)
      ELSE
         CALL TBSAVE (NOMPLE(1:NCHTRM),NIVPLE)
      ENDIF
      CALL TBSAVE (NMSOLU,NVSOLU)
*--   Impressions
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
         CALL PRNTRM (NMSCMB,NVSCMB,ERCODE(NCATR1+1:),NCATR2)
         CALL PRNTRM (NMSOLU,NVSOLU,ERCODE(NCATR1+NCATR2+1:),NCATR3)
         WRITE (IMPPAL,10002) 'Matrice',ERCODE(1:NCATR1)
     &        ,'2nd mb.',ERCODE(NCATR1+1:NCATR1+NCATR2)
     &        ,'Solution',ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+NCATR3)
      ENDIF
      CALL PRFXMJ (-1,'*Gausmc*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'*GausMc* Resolution de systeme lineaire ',A
     &/,T11,'Nombre d''inconnues :',I12)
10002 FORMAT(T11,3(A,' : ',A,:' ; '))
10001 FORMAT(/,T2,'*GausMc* '
     &,'Module minimal des pivots de l''elimination de Gauss ',E11.4)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL ERTERM (17,NMMATR,NVMATR)                                    !utilite
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 1.0.1 : D.Martin (17 Janvier 2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !Gausmc
