*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GCFINA (NMMATR,NVMATR,NMSCMB,NVSCMB,NMPREC,NVPREC
     &                  ,NMSOLU,NVSOLU,NBLIGN,TITRE ,TYFACT,NMSTOK
     &                  ,NVSTOK,NMSTOP,NVSTOP,NM2MMB,NV2MMB,NBITER
     &                  ,MXITER,RESIDU,NIVIMP,IMPPAL,IMPSDR,IRETUR)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (7 Juillet 1997)
* Derniere modification : D.Martin (27 Septembre 2000)
* Version 1.0.1
*
* Final apres resolution par une methode du Gradient Conjugue avec ou 
* sans Preconditionnement.
*
*-- Arguments d'entree -- 
* NMMATR,NVMATR nom,niveau de la matrice du systeme stockee Bimorse ou Morse
* NMSCMB,NVSCMB nom,niveau du second membre
* NMPREC,NVPREC nom,niveau de la matrice de precond. Bimorse,Morseou Profil 
*              (NMPREC=' ' pour le cas sans preconditionnement)
* NMSOLU,NVSOLU nom, niveau de la solution
* NBLIGN rang du systeme lineaire
* TITRE  commentaire de la preocedure appelant
* TYFACT type de factorisation de la matrice de preconditionnement
* NMSTOK,NVSTOK nom,niveau du tableau de stockage de la matrice du systeme
* NMSTOP,NVSTOP nom,niveau du tableau de stockage de la matrice de precond.
* NM2MMB,NV2MMB nom,niveau du second membre intermediaire
* NIVIMP niveau d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATR,NMSCMB,NMPREC,NMSOLU,NMSTOK,NMSTOP,NM2MMB
     &             ,TITRE,TYFACT
      INTEGER       NVMATR,NVSCMB,NVPREC,NVSOLU,NBLIGN,NVSTOK,NVSTOP
     &             ,NV2MMB,NBITER,MXITER,NIVIMP,IMPPAL,IMPSDR,IRETUR
      REAL          RESIDU
*
      INTEGER       NCATR1,NCATR2
      CHARACTER     PRFXAS*8
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
*     Impressions
      IF (NIVIMP.GE.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
         CALL PRNTRM (NMSCMB,NVSCMB,ERCODE(NCATR1+1:),NCATR2)
         IF (NMPREC.EQ.' ') THEN
            WRITE (IMPPAL,10000) PRFXAS(0),TITRE,' '
     &                          ,NBLIGN
            WRITE (IMPPAL,10001) 'Matrice ',ERCODE(1:NCATR1)
     &                   ,'2nb membre',ERCODE(NCATR1+1:NCATR1+NCATR2)
            CALL PRNTRM (NMSOLU,NVSOLU,ERCODE(NCATR1+1:),NCATR2)
            WRITE (IMPPAL,10001) 
     &                    'Solution',ERCODE(NCATR1+1:NCATR1+NCATR2)
         ELSE
            WRITE (IMPPAL,10000) PRFXAS(0),TITRE,' Preconditionne'
     &                          ,NBLIGN
            WRITE (IMPPAL,10001) 'Matrice ',   ERCODE(1:NCATR1)
     &                   ,'2nb membre',ERCODE(NCATR1+1:NCATR1+NCATR2)
            CALL PRNTRM (NMPREC,NVPREC,ERCODE,NCATR1)
            CALL PRNTRM (NMSOLU,NVSOLU,ERCODE(NCATR1+1:),NCATR2)
            ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+LEN(TYFACT))=TYFACT
            WRITE (IMPPAL,10001) 
     &                    'Preconditionnement '
     &          //ERCODE(NCATR1+NCATR2+1:NCATR1+NCATR2+LEN(TYFACT))
     &                   ,ERCODE(1:NCATR1)
     &                   ,'Solution',ERCODE(NCATR1+1:NCATR1+NCATR2)
         ENDIF
      ENDIF
      IF (NBITER.GE.MXITER) THEN
         WRITE (IMPPAL,10004) PRFXAS(-1),NBITER,RESIDU
         IRETUR=1
      ELSEIF (NIVIMP.GE.0) THEN
         WRITE (IMPPAL,10003) PRFXAS(-1),NBITER,RESIDU
      ENDIF
*
*     Suppression des tableaux temporaires de travail
      CALL TBTUER ('$WORK$',0)
      IF (NM2MMB(:6).EQ.'$WORK$'.AND.NV2MMB.EQ.1) THEN  
         CALL TBTUER ('$WORK$',1)
      ELSE 
         CALL TBSAVE (NMSCMB,NVSCMB)
      ENDIF
      IF (NMPREC(1:1).NE.' ') THEN
         CALL TBSAVE (NMSTOP,NVSTOP)
         CALL TBSAVE (NMPREC,NVPREC)
      ENDIF
      CALL TBSAVE (NMSTOK,NVSTOK)
      CALL TBSAVE (NMMATR,NVMATR)
*
      IF (NIVIMP.GT.0) CALL PRTERM (NMSOLU,NVSOLU,NIVIMP,IMPSDR)        !Prsd
      CALL TBSAVE (NMSOLU,NVSOLU)
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Resolution de systeme lineaire - ',A,A
     &/,T11,'Nombre d''inconnues :',I12)
10001 FORMAT(T11,2(A,' : ',A,:' ; '))
10003 FORMAT(T11,A8,' -> Nombre d''iterations ',I6,' , Residu =',E12.4)
10004 FORMAT(T11,A8,' !! Nombre maximum d''iterations atteint : ',I6
     &,' , Residu =',E12.4/T11,56('!'))
                                                                    END !GCfina
