*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INVMAT (NMTRMA,NVTRMA,NMTRMB,NVTRMB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D. Martin & C.Chambeyron (20 octobre 2006)
* Derniere modification : D. Martin (1 juillet 2010)
* Version 0
*
* Calcul de l'INVerse d'une Matrice (pleine pour le moment)
*
* Cette procedure est limitee au cas d'une matrice BIMORSE ou PLEIN-L/C
* La matrice inverse B pleine est retournee selon le meme type de stockage 
* que la matrice A
*
*-- Arguments d'entree --
* NMTRMA nom de la matrice A 
* NMTRMA niveau de la matrice A 
* NMTRMB nom de la matrice B 
* NMTRMB niveau de la matrice B
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*)  NMTRMA,NMTRMB
      INTEGER        NVTRMA,NVTRMB
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER PRFXAS*8,STOIND*7,SYMIND*14,TYPINT*9
     &         ,NMSTOK*7,TYMATR*9,TYFACT*5
      INTEGER INDSYM,KLTERM
      INTEGER LGMTRM,LGDTRM,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM
     &       ,NVVTRM,ITYPTR,NUTERM,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &       ,NUINCA,NVDUCA,NBCOLA,NVNUCA,NUINLA,NVDULA,NBLIGA,NVNULA
     &       ,INSTOK,NVSTOK,NVCORC,IATRDA,NIVIMA,NIVIMP,IRCODE
     &       ,MCTRMA,MCTMAL,MCTMAU,MCTRMB,MCTTMP,MCINVM,MCINV1
     &       ,MCSTOK,MCFACT,MCFACL,MCFACU,MCPROF
     &       ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL,LGMBMO,MCLENV
     &       ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU,LGMPRO,MCUENV,I,NCATR1
      COMPLEX CUN
      CHARACTER ERCODE*120,THETR1*16  
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*InvMat*')
*
      CALL TBRR3  (ERCODE,'#OMTRM',1,LGMTRM,'$SDTRM',1,LGDTRM
     &                   ,NMTRMA,NVTRMA,MCTRMA)
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*          
*     Caracteristiques de la matrice (A)
*
      NUTERM=KLTERM (NMTRMA,NVTRMA,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMTRMA,NVTRMA)                    !utilite
      CALL GETTRM (IST(MCDTRM+LGETRM+INCTRM*(NUTERM-1)),NVVTRM
     &            ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &            ,NUINCA,NVDUCA,NBCOLA,NVNUCA
     &            ,NUINLA,NVDULA,NBLIGA,NVNULA
     &            ,INSTOK,NVSTOK,NVCORC,IATRDA,NIVIMP)                  !sdexplo
      IF (NBCOLA.NE.NBLIGA) CALL ERTERM (11,NMTRMA,NVTRMA)              !utilite
      NMSTOK=STOIND (INSTOK)
      TYMATR=TYPINT (ITYPTR)
*
      IF (NMSTOK.EQ.'BIMORSE') THEN
*
*        Inverse d'une matrice BIMORSE
*
*        Creation du tableau de stockage PROFIL pour la matrice A
*        a partir du stockage BIMORSE
*
         CALL TBRR1  (ERCODE,'&BMORS',NVSTOK,MCSTOK)
         CALL TBAR1  (ERCODE,'&BMORS',NVSTOK,MCSTOK)
*        Parametres de la structure BIMORSE de la matrice A
         CALL EXBMOR (MCSTOK,IST(MCSTOK)
     &               ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)                  !morse
         LGMBMO=NBLIGN+LGL+LGU
         LGMPRO=3+NBLIGN
         IF (IST(MCSTOK).GT.2) LGMPRO=LGMPRO+2+NBLIGN
         CALL TBCREE ('&PROFL',NVSTOK,1,LGMPRO,'c')
         CALL TBAR2  (ERCODE,'&PROFL',NVSTOK,MCPROF
     &                      ,'&BMORS',NVSTOK,MCSTOK)
*        Construction de la structure PROFIL de la matrice A
         IST(MCPROF)=2
         CALL BM2PR  (NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &               ,IST(MCPROF+1))                                    !morse
         IF (IST(MCSTOK).GT.2) THEN
            IST(MCPROF) = NBLIGN+3
            CALL BM2PR  (NBLIGN,NBLIGN,IST(MCPLAU),IST(MCPLIU)
     &                  ,IST(MCPROF+IST(MCPROF)-1))                     !morse
         ENDIF
*
*        Factorisation L.U de la matrice
*
*        Parametres de la structure PROFIL de la matrice A
         CALL EXPROF (MCPROF,IST(MCPROF),NBLIGN,MCLENV,LGL
     &                                  ,NBCOLO,MCUENV,LGU)             !morse
         LGMPRO=NBLIGN+LGL+LGU
*        Tableau de travail pour stocker la matrice factorise
         CALL TBCREE ('$work$',1,ITYPTR,LGMPRO,'c')
*        Tableau de travail pour stocker la matrice inverse PLEIN-C
         CALL TBCREE ('$work$',2,ITYPTR,NBLIGN*NBLIGN,'c')
*
         CALL TBAR4  (ERCODE,NMTRMA,NVTRMA,MCTRMA,'&PROFL',NVSTOK,MCPROF
     &                      ,'$work$',1,MCFACT,'$work$',2,MCINVM)
         CALL EXPROF (MCPROF,IST(MCPROF),NBLIGN,MCLENV,LGL
     &                                  ,NBCOLO,MCUENV,LGU)             !morse
*
*        Factorisation proprement dite (sans plus d'information : L.U)
*
         MCTMAL=MCTRMA+NBLIGN
         MCTMAU=MCTMAL
         MCFACL=MCFACT+NBLIGN
         MCFACU=MCFACL
         IF (ITYSYM.EQ.INDSYM (' ')) THEN
            MCFACU=MCFACL+LGL
            MCTMAU=MCTMAL+LGL
         ENDIF
         IF (LGMPRO.GT.LGMBMO) THEN
*            Si les stockages BIMORSE et PROFIL ne definissent pas
*            le meme ensemble de coefficients (en cas de remplissage)
*            on pose la matrice sous forme PROFIL dans la factorisee
             CALL TDANST (NBLIGN,TYMATR,MCTRMA,IST,RST,CST
     &                          ,TYMATR,MCFACT,IST,RST,CST)             !utilite
             MCTRMA=MCFACT
             CALL MB2PR  (NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &                   ,TYMATR,MCTMAL,MCLENV,MCFACL)                  !morse
             MCTMAL=MCFACL
             IF (ITYSYM.EQ.INDSYM (' '))
     &          CALL MB2PR  (NBLIGN,NBLIGN,IST(MCPLAU),IST(MCPLIU)
     &                      ,TYMATR,MCTMAU,MCUENV,MCFACU)               !morse
             MCTMAU=MCFACU
         ENDIF
*
         TYFACT='L.U'
         CALL LUPR  (TYMATR,NBLIGN,IST(MCLENV),IST(MCUENV),MCTRMA
     &              ,MCTMAL,MCTMAU,EPSMAC,MCFACT,MCFACL,MCFACU
     &              ,RST,CST,IRCODE)                                    !syslin
         IF (IRCODE.NE.0) 
     &      CALL FAERR  (IRCODE,TYFACT,NMTRMA,NVTRMA,NIVIMP,IMPSDR)     !syslin
         CALL TBSAVE (NMTRMA,NVTRMA)
*
*        Resolution des systemes lineaires avec comme second membre
*        la matrice identite
*
         CALL TAZERO (NBLIGN*NBLIGN,TYMATR,MCINVM,AST,IST,RST,CST)      !utilite
         CUN=CMPLX(1.,0.)
         MCINV1=MCINVM
         DO 5 I=1,NBLIGN
            CALL TINPUT (I,1,1.,CUN,TYMATR,MCINV1,IST,RST,CST)          !utilite
            CALL RSMAFA ('&PROFL',MCPROF,TYFACT,TYMATR,MCFACT
     &                  ,1,TYMATR,MCINV1,TYMATR,MCINV1
     &                  ,IST,RST,CST,IRCODE)                            !syslin
            IF (IRCODE.NE.0) CALL ERTERM (19,NMTRMA,NVTRMA)             !utilite
            MCINV1=MCINV1+NBLIGN
 5       CONTINUE
         CALL TBTUER ('$work$',1)
         CALL TBTUER ('&PROFL',NVSTOK)
         CALL TBSAVE ('&BMORS',NVSTOK)
*
*        Stockage de l'inverse sous forme BIMORSE
*        Actuellement on utilise la meme tableau de stockage BIMORSE que 
*        la matrice a inverser : il faudrait sinon creer le tableau
*        de stockage BIMORSE associe au stockage de la matrice inverse
         IF (NBLIGN*NBLIGN.GT.LGMBMO)
     &      CALL BAISE  ('Matrice BIMORSE pleine seulement. Au boulot')
*
         CALL T1TERM (NMTRMA,NVTRMA,'ZERO',NMTRMB,NVTRMB,0)             !assembl
         CALL TBRR1  (ERCODE,NMTRMB,NVTRMB,MCTRMB)
         CALL TBAR2  (ERCODE,'$work$',2,MCINVM,NMTRMB,NVTRMB,MCTRMB)
         CALL MPL2BM (TYMATR,NBLIGN,NBLIGN,'PLEIN-C',MCINVM
     &               ,MCTRMB,RST,CST)                                   !morse
*
*        Sauvegarde et nettoyage
         CALL TBSAVE (NMTRMB,NVTRMB)
         CALL TBTUER ('$work$',2)
*
      ELSEIF (NMSTOK(1:5).EQ.'PLEIN') THEN
*
*        Inverse d'une matrice pleine
*
*        Initialisation de la matrice inverse par la matrice Identite
*
         CALL T1TERM (NMTRMA,NVTRMA,'IDENTITY',NMTRMB,NVTRMB,0)         !assembl
*
*        Copie de la matrice A a inverser
*
         CALL T1TERM (NMTRMA,NVTRMA,'=','$work$',1,0)                   !assembl
         CALL TBSAVE (NMTRMA,NVTRMA)
*  
*        Adresses des matrices:
*     
         CALL TBRR1  (ERCODE,'$work$',1,MCTTMP)       
         CALL TBAR2  (ERCODE,'$work$',1,MCTTMP,NMTRMB,NVTRMB,MCTRMB)
*
*        Calcul de l'inverse
*
         CALL INVMPL (TYMATR,NMSTOK,NBLIGA,MCTTMP,MCTRMB,RST,CST
     &               ,EPSMAC,IRCODE)                                    !syslin
         IF (IRCODE.NE.0) CALL ERTERM (17,NMTRMA,NVTRMA)                !utilite
*
*        Sauvegarde et nettoyage
         CALL TBSAVE (NMTRMB,NVTRMB)
         CALL TBTUER ('$work$',1)
*
      ELSE
*
         CALL BAISE ('Inversion matrice '//NMSTOK//' a faire ?')
      ENDIF 
*
      IF (IMPPAL.GT.0) THEN
         CALL PRNTRM (NMTRMA,NVTRMA,THETR1,NCATR1)                      !utilite
         IF (ITYSYM.EQ.0) THEN
            WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                          ,TYMATR,NMSTOK
         ELSE
            WRITE (IMPPAL,10000) PRFXAS (0),THETR1(1:NCATR1)
     &                          ,TYMATR,NMSTOK,SYMIND(ITYSYM)
         ENDIF
      ENDIF
*
      CALL PRFXMJ (-1,'*InvMat*')
*-----------------------------------------------------------------------
10000 FORMAT(T5,A8,' Inverse du terme ',A,', ',A,', ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 0 : D.Martin (1 juillet 2010)
* - Tableaux '_TMPR_' renommes '$work$'
* - NMSTOK(1:5).EQ.'PLEIN-L' remplace par NMSTOK(1:5).EQ.'PLEIN'
* Version 0 : D.Martin (24 octobre 2006)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !InvMat
                                                                  