*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LALPR (TYPE,NBLINE,LENV,MCAD,MCAL,EPSIL
     &                 ,MCD,MCL,RST,CST,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Juin 1991)
* Derniere modification : D.Martin (23 Avril 1998) 
*  
* Factorisation L.tL (cas reel) ou L.L* (cas complexe) 
* d'une matrice stockee sous forme 'Profil'
*  
*-- Arguments de la Liste d'Entree --
* TYPE   Type REEL ou COMPLEXE de la matrice
* NBLINE Nombre de lignes de la matrice
* LENV   Tableau contenant l'enveloppe inferieure stricte avec
*        LENV(I-1) adresse dans la partie triangulaire inferieure compactee
*        du 1er coeff. non nul de la ligne I, et LENV(I)=LENV(I-1) si le 1er 
*        coeff. de la ligne I+1 est le coeff. diagonal, et LENV(NBLINE)-1 
*        est la taille de la partie triangulaire inferieure stricte compactee.
* MCAD   Adresse de la diagonale de la matrice dans le super-tab. du bon type
* MCAL   Adresse de la partie triangulaire inf. dans le super-tab. du bon type
* EPSIL  Seuil en dessous duquel la matrice n'est pas factorisable
*        i.e. un coeff. Di de la diagonale est tel que Di < EPSIL
* MCD    Adresse de la diagonale de la matrice factorisee dans RST ou CST
* MCL    Adresse de la partie triangulaire inf. de la matrice factorisee
* RST,CST Super-tableau version REELLE ou COMPLEXE
* IRCODE code de retour en cas d'erreur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLINE,LENV(*),MCAD,MCAL,MCD,MCL,IRCODE
      REAL          EPSIL,RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LIGNE,MCDD,MCADD,IADLNX,IAD,NBCOF,KOL1,MCLL
      COMPLEX       CCOEFF
*-----------------------------------------------------------------------
      IF (TYPE(1:1).EQ.'R') THEN
         CALL LTLPR (TYPE,NBLINE,LENV,MCAD,MCAL,EPSIL,MCD,MCL,RST,CST
     &              ,IRCODE)                                            !syslin
      ELSE
*        Cas d'une matrice a coefficients complexes
         CALL PRFXMJ  (1,'*LaLPr*')
         IRCODE=0
         LIGNE=1
         MCDD=MCD+1
         MCADD=MCAD+1
         IADLNX=1  
         IF (ABS(CST(MCAD)).LT.EPSIL) GOTO 99991
         CST(MCD)=SQRT (CST(MCAD))
         DO 41 LIGNE=2,NBLINE
            CCOEFF=CST(MCADD)
            MCADD=MCADD+1
*           Calcul des coeff. de la LIGNE-eme ligne de L
            IAD=IADLNX
            IADLNX=LENV(LIGNE)
            NBCOF=IADLNX-IAD
            IF (NBCOF.GT.0) THEN
               KOL1=LIGNE-NBCOF
*              Resolution d'une descente : un systeme type Lb.x=b ou Lb
*              est la matrice dont les coeff. sont conjugues de ceux de L
               CALL RSPRAU (NBCOF,LENV(KOL1),'C',MCD-1+KOL1,MCL
     &                     ,'C',MCAL-1+IAD,'C',MCL-1+IAD,RST,CST)       !syslin
*              Calcul du coeff. diagonal de la LIGNE-eme ligne/colonne
               MCLL=MCL-1+IADLNX
               DO 40 J=1,NBCOF
                  MCLL=MCLL-1
40                CCOEFF=CCOEFF-CST(MCLL)*CONJG (CST(MCLL))
            ENDIF
            IF (ABS(CCOEFF).LT.EPSIL) GOTO 99991
            CST(MCDD)=SQRT (CCOEFF)
41          MCDD=MCDD+1
         CALL PRFXMJ  (-1,'*LaLPr*')
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 IRCODE=LIGNE
                                                                    END !LaLPr


