*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LDALPR (TYPE,NBLINE,LENV,MCAD,MCAL,EPSIL
     &                  ,MCD,MCL,RST,CST,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : A.S.Bonnet (Septembre 1989) puis D.Martin (Juin 1991)
* Derniere modification : D.Martin (23 Avril 1998)
*  
* Factorisation L.D.tL (cas reel) ou L.D.L* (cas complexe) 
* d'une matrice stockee sous forme 'Profil'
*  
*-- Arguments de la Liste d'Entree --
* TYPE   type REEL ou COMPLEXE de la matrice
* NBLINE nombre de lignes de la matrice
* LENV   tableau contenant l'enveloppe inferieure stricte avec
*        LENV(I-1) adresse dans la partie triangulaire inferieure compactee
*        du 1er coeff. non nul de la ligne I, et LENV(I)=LENV(I-1) si le 1er 
*        coeff. de la ligne I+1 est le coeff. diagonal, et LENV(NBLINE)-1 
*        est la taille de la partie triangulaire inferieure stricte compactee.
* MCAD   adresse de la diagonale de la matrice dans le super-tab. du bon type
* MCAL   adresse de la partie triangulaire inf. dans le super-tab. du bon type
* EPSIL  seuil en dessous duquel la matrice n'est pas factorisable
*        i.e. un coeff. Di de la diagonale est tel que Di < EPSIL
* MCD    adresse de la diagonale de la matrice factorisee dans RST ou CST
* MCL    adresse de la partie triangulaire inf. de la matrice factorisee
* RST,CST super-tableau version REELLE ou COMPLEXE
* IRCODE code de retour en cas d'erreur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPE
      INTEGER       NBLINE,LENV(*),MCAD,MCAL,MCD,MCL,IRCODE
      REAL          EPSIL,RST(*)
      COMPLEX       CST(*)
*
      INTEGER       LIGNE,MCDD,MCADD,IADLNX,IAD,NBCOF,KOL1,MCLL
      REAL          RCOEFF,SCOEFF
      COMPLEX       CCOEFF,DCOEFF
      EQUIVALENCE  (CCOEFF,RCOEFF),(DCOEFF,SCOEFF)
*-----------------------------------------------------------------------
*
      IF (TYPE(1:1).EQ.'R') THEN
         CALL LDTLPR (TYPE,NBLINE,LENV,MCAD,MCAL,EPSIL,MCD,MCL,RST,CST
     &               ,IRCODE)                                           !syslin
      ELSE
*        Cas d'une matrice a coefficients complexes
         CALL PRFXMJ (1,'*LDaLPr*')
         IRCODE=0
         LIGNE=1
         MCDD=MCD+1
         MCADD=MCAD+1
         IADLNX=1
         IF (ABS(CST(MCAD)).LT.EPSIL) GOTO 99991
         CST(MCD)=CST(MCAD)
         DO 41 LIGNE=2,NBLINE
            CCOEFF=CST(MCADD)
            MCADD=MCADD+1
            IAD=IADLNX
            IADLNX=LENV(LIGNE)
            NBCOF=IADLNX-IAD
            IF (NBCOF.GT.0) THEN
               KOL1=LIGNE-NBCOF
*              Resolution d'un systeme L1b.x=b ou L1b est la matrice
*              dont les coeficients sont conjugues de ceux de L1
               CALL RSPAU1 (NBCOF,LENV(KOL1),'C',MCL                     
     &                     ,'C',MCAL-1+IAD,'C',MCL-1+IAD,RST,CST)       !syslin
               MCD1=MCDD
               MCLL=MCL-1+IADLNX
               DO 40 J=1,NBCOF
                  MCLL=MCLL-1
                  MCD1=MCD1-1
                  DCOEFF=CST(MCLL)/CST(MCD1)
                  CCOEFF=CCOEFF-CST(MCLL)*CONJG(DCOEFF)
40                CST(MCLL)=DCOEFF
            ENDIF
            IF (ABS(CCOEFF).LT.EPSIL) GOTO 99991
            CST(MCDD)=CCOEFF
41          MCDD=MCDD+1
         CALL PRFXMJ (-1,'*LDaLPr*')
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 IRCODE=LIGNE
                                                                    END !LDaLPr


