*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PGAUSC (NBLIGN,NBLIGE,MAT,NBSEC,SEC,EPS,SINGUL)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1996)
* Derniere modification (D.Martin) le 2 Juillet 1996
*  
* Elimination partielle de Gauss avec recherche de pivot maximum partiel
*                             (Cas complexe)
*  
*-- Arguments d'entree -- 
* NBLIGN nombre de lignes de la matrice MAT
* NBLIGE nombre de lignes sur lequel porte l'elimination
* MAT    la matrice
* NBSEC  nombre de seconds membres
* SEC    le(s) second(s) membre(s) du systeme lineaire en entree, 
*        la(les) solution(s) en sortie. Les seconds membres sont ranges
*         consecutivement en memoire centrale
* EPS    seuil  de non-inversibilite portant sur le pivot mimimum
* SINGUL .TRUE. pour une matrice singuliere
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NBLIGN,NBLIGE,NBSEC
      REAL    EPS
      COMPLEX MAT(NBLIGN,*),SEC(NBLIGN,*)
      LOGICAL SINGUL
*
      INTEGER LIGPIV,K,I,J
      REAL    ABSPIV
      COMPLEX TRUC,PIV
*-----------------------------------------------------------------------
      SINGUL=.FALSE.
      DO 30 K=1,NBLIGE
         LIGPIV=K 
         PIV   =MAT(K,K) 
         ABSPIV=ABS (PIV)  
         DO 11 I=K+1,NBLIGE  
            IF (ABSPIV.LT.ABS (MAT(I,K))) THEN
               LIGPIV=I
               PIV   =MAT(I,K)
               ABSPIV=ABS (PIV)
            ENDIF
11       CONTINUE
         IF (ABSPIV.LT.EPS) GOTO 90000 
*        Permutation des lignes K et LIGPIV (ligne du pivot maximum)  
         IF (LIGPIV.GT.K) THEN 
            DO 21 J=1,NBSEC
               TRUC         =SEC(K,J) 
               SEC(K,J)     =SEC(LIGPIV,J)  
               SEC(LIGPIV,J)=TRUC
21          CONTINUE
            DO 22 J=K,NBLIGN 
               TRUC         =MAT(K,J)
               MAT(K,J)     =MAT(LIGPIV,J)  
               MAT(LIGPIV,J)=TRUC 
22          CONTINUE 
         ENDIF
*        Elimination de l'inconnue K dans les lignes K+1, .. ,NBLIGN  
         PIV=1./PIV
         DO 29 I=K+1,NBLIGN
            TRUC=-MAT(I,K)*PIV
            DO 27 J=K+1,NBLIGN
               MAT(I,J)=MAT(I,J)+TRUC*MAT(K,J)
27          CONTINUE
            DO 28 J=1,NBSEC
               SEC(I,J)=SEC(I,J)+TRUC*SEC(K,J)
28          CONTINUE 
29       CONTINUE
30    CONTINUE
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 SINGUL=.TRUE.
                                                                    END !PGausC
