*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE PGAUSS (NMMATR,NVMATR,NMSCMB,NVSCMB,DOMAIN 
     &                  ,NMMATS,NVMATS,NMSCMS,NVSCMS,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin (Juin 1996)
* Derniere modification : D.Martin (8 octobre 2008)
* Version 2
*  
* Elimination de Gauss partielle dans un systeme lineaire pour les valeurs
* nodales d'une inconnue appartenant a des (sous-)domaines donnes.
*  
*-- Arguments d'entree -- 
* NMMATR nom du tableau contenant la matrice  
* NVMATR son niveau
* NMSCMB nom du tableau contenant le second membre
* NVSCMB son niveau
* NBSCMB nombre effectif de Seconds Membres
* DOMAIN chaine de caracteres decrivant les noms des domaines structuree
*        sous forme de noms de domaines separes de la chaine ' Union '
*        Exemples: 'Domaine' ou  'Domaine1 Union Domaine2'
* NMMATR nom du tableau contenant la matrice condensee  
* NVMATR son niveau
* NMSCMS nom du tableau contenant le second membre condense 
* NVSCMS son niveau
* NIVIMP niveau d'impression pour les matrices et seconds membres 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATR,NMMATS,NMSCMB,NMSCMS,DOMAIN 
      INTEGER       NVMATR,NVSCMB,NVMATS,NVSCMS,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     TYPINT*8,STODLN*6
      LOGICAL       SINGUL,CRETRM
      INTEGER       INDSTO,INDSYM,INTTYP,INTYKL
      INTEGER       NBSCMB,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NV2MMB
     &             ,ITYSYM,NVDSMA,NUINLM,NCPINC,NVDULM,NBNELM,NVNULM
     &             ,INSTOK,NVSTOK,NVCOMA,NVDSSC,NVDUSC,ITFACT,NUFACT
     &             ,INDSTP,NVSTOP,ITYCAL,NUKALE,NBNESC,NVNUSC
     &             ,ITMATR,ITSCMB,ITSCMS,MCSTOK,MCMATR,MC2MMB
     &             ,NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &             ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU,MCMATS,MCSCMS
     &             ,MCNUML,MCNUMS,MCWORK,NUNOEU,NXNOEU,LIGNE,ICP,NULIGN
     &             ,MCINCO,INTERP,NBTNEL,NVNUMS,NBLIKE,NBNUMS
     &             ,NCATR1,NCATR2
      CHARACTER*8   TYMATR,TYSCMB,TYSCMS,TYMATP
      CHARACTER     ERCODE*120,NMSTOK*6,NM2MMB*6
      COMMON/FORMAH/ERCODE 
      EQUIVALENCE  (ERCODE(73:73),TYMATP),(ERCODE(81:81),TYMATR)
     &            ,(ERCODE(89:89),TYSCMB),(ERCODE(97:97),TYSCMS)
     &            ,(ERCODE(105:105),NM2MMB)
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*PGauss*')
*
      IF (NMMATR.EQ.NMMATS.AND.NVMATR.EQ.NVMATS) 
     &   CALL ERTERM (9,NMMATR,NVMATR)                                  !utilite
      IF (NMSCMB.EQ.NMSCMS.AND.NVSCMB.EQ.NVSCMS)
     &   CALL ERTERM (9,NMSCMB,NVSCMB)                                  !utilite
      NBSCMB=1
      NM2MMB=' '
      NV2MMB=0
      Write(*,*) NMMATR,NVMATR,NMSCMB,NVSCMB
*
*--   Caracteristiques du systeme
      CALL SYPREP (NMMATR,NVMATR,NMSCMB,NVSCMB,NM2MMB,NV2MMB,TYMATR
     &            ,ITYSYM,NVDSMA,NUINLM,NCPINC,NVDULM,NBNELM,NVNULM
     &            ,INSTOK,NVSTOK,NVCOMA,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,TYMATP,ITFACT,NUFACT,INDSTP,NVSTOP,NBLIGN)    !syslin
      IF (NVDSMA.GT.0) CALL ERTERM (12,NMMATR,NVMATR)                   !utilite
      IF (NVDSSC.GT.0) CALL ERTERM (12,NMSCMB,NVSCMB)                   !utilite
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         WRITE(IMPPAL,10000) NBLIGN
      ENDIF
*
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      CALL SDEXCO (NUINLM,IST(MCINCO),NCPINC,INTERP,NBTNEL)             !utilite
      ITMATR=INTTYP (TYMATR)                                            !utilite
      ITSCMB=INTTYP (TYSCMB)                                            !utilite
*
*--   Changement eventuel de stockage de la matrice
      IF (INSTOK.EQ.INDSTO ('BIMORSE')) THEN                            !utilite
*
         NMSTOK = STODLN (INSTOK,NCPINC,NCPINC)                         !utilite
         CALL TBRR2  (ERCODE,NMSTOK,NVSTOK,MCSTOK,NMMATR,NVMATR,MCMATR)
         CALL TBAR1  (ERCODE,NMSTOK,NVSTOK,MCSTOK)
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)                  !sdexplo
         IF (NBLIGN.NE.NBCOLO) CALL ERTERM (11,NMMATR,NVMATR)           !utilite
*
         CALL TBCREE (NMMATS,NVMATS,ITMATR,NBLIGN*NBLIGN,'c')
         CALL TBAR3  (ERCODE,NMMATR,NVMATR,MCMATR,NMMATS,NVMATS,MCMATS
     &               ,NMSTOK,NVSTOK,MCSTOK)
         CALL TAZERO (NBLIGN*NBLIGN,TYMATR,MCMATS,AST,IST,RST,CST)      !utilite
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBLIGN,NBPLAL,MCPLAL,MCPLIL,LGL
     &               ,NBCOLO,NBPLAU,MCPLAU,MCPLIU,LGU)                  !sdexplo
*        Changement de structure de la matrice en une matrice pleine
*        rangee par colonne
         CALL BMD2PL (TYMATR,NBLIGN,NBLIGN,MCMATR,MCMATS,RST,CST)       !morse
         CALL BMU2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &               ,MCMATR+NBLIGN,MCMATS,RST,CST)                     !morse
         IF (ITYSYM.EQ.INDSYM (' ')) THEN                               !utilite
            CALL BML2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAU),IST(MCPLIU)
     &                  ,MCMATR+NBLIGN+LGL,MCMATS,RST,CST)              !morse
         ELSEIF (ITYSYM.EQ.INDSYM ('SYMETRIQUE')) THEN                  !utilite
            CALL BML2PL (TYMATR,NBLIGN,NBLIGN,IST(MCPLAL),IST(MCPLIL)
     &                  ,MCMATR+NBLIGN,MCMATS,RST,CST)                  !morse
         ELSE
            CALL BAISE  ('Cas de symetrie non prevu')                   !utilite
         ENDIF
         CALL TBSAVE (NMSTOK,NVSTOK)
         CALL TBSAVE (NMMATR,NVMATR)
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-L')) THEN                        !utilite
         CALL ERTERM (18,NMMATR,NVMATR)                                 !utilite
*
      ELSEIF (INSTOK.EQ.INDSTO ('MORSE-C')) THEN                        !utilite
         CALL ERTERM (18,NMMATR,NVMATR)                                 !utilite
*
      ELSEIF (INSTOK.EQ.INDSTO ('PLEIN-L')) THEN                        !utilite
         CALL TBRR1  (ERCODE,NMMATR,NVMATR,LGL)
         NBLIGN=NBNELM*NCPINC
         IF (LGL.NE.NBLIGN*NBLIGN) CALL ERTERM (11,NMMATR,NVMATR)       !utilite
         CALL TBCREE (NMMATS,NVMATS,ITMATR,LGL,'c')
         CALL TBAR2  (ERCODE,NMMATR,NVMATR,MCMATR,NMMATS,NVMATS,MCMATS)
         CALL TDANST (LGL,TYMATR,MCMATR,IST,RST,CST
     &                   ,TYMATR,MCMATS,IST,RST,CST)
         CALL TBSAVE (NMMATR,NVMATR)
*
      ELSEIF (INSTOK.EQ.INDSTO ('PROFIL')) THEN                         !utilite
         CALL ERTERM (18,NMMATR,NVMATR)                                 !utilite
      ELSE
         CALL ERTERM (18,NMMATR,NVMATR)                                 !utilite
      ENDIF
*
*--   Vecteur second membre condense
      ITSCMS=ITSCMB
      IF (TYMATR(1:1).EQ.'C') ITSCMS=ITMATR
      TYSCMS=TYPINT (ITSCMS)                                            !utilite
      CALL SOPREP (NMSCMB,NVSCMB,NBSCMB,TYSCMB,NVDSSC,NVDUSC,NBNESC
     &            ,NVNUSC,NMSCMS,NVSCMS,TYSCMS,NUINLM,NCPINC,NVDULM
     &            ,NBNELM,NVNULM,NVCOMA,NIVIMP,NVDSMA,NM2MMB,NV2MMB)    !syslin
*
*     Ici il y a plusieurs cas en sortie de SOPREP:
*     - si la numerotation du second membre est coherente avec les colonnes
*       de la matrice, on a:                 NM2MMB=NMSCMB
*     - si la numerotation du second membre n'est pas coherente avec les
*       colonnes de la matrice,  alors il y a deux cas:
*     - si le terme solution n'existait pas, il est cree et rempli avec le
*       second membre renumerote et on a:    NM2MMB=NMSCMS
*     - si il preexistait, un tableau de travail est cree et rempli avec
*       le second membre renumerote et on a: NM2MMB='$WORK$'
*
      IF (NM2MMB(:NCHTRM).NE.NMSCMS(:NCHTRM).OR.NV2MMB.NE.NVSCMS) THEN
*        Ici on decide d'ecraser le terme solution preexistant
         CALL TBAR2  (ERCODE,NM2MMB,NV2MMB,MC2MMB,NMSCMS,NVSCMS,MCSCMS)
         CALL TDANST (NBLIGN*NBSCMB,TYSCMB,MC2MMB,IST,RST,CST
     &                             ,TYSCMS,MCSCMS,IST,RST,CST)          !utilite
         IF (NM2MMB(:NCHTRM).NE.NMSCMB(:NCHTRM).OR.NV2MMB.NE.NVSCMB)
     &      THEN
            CALL TBTUER (NM2MMB,NV2MMB)
         ELSE
            CALL TBSAVE (NMSCMB,NVSCMB)
         ENDIF
      ENDIF
*
      ITYCAL=INTYKL ('ASSEMB')                                          !utilite
      NUKALE=-1
      INSTOK=INDSTO ('PLEIN-L')                                         !utilite
      IF (NIVIMP.GT.1) THEN
         CALL CRTERM (NMMATS,NVMATS,NBLIGN*NBLIGN,ITMATR,ITYCAL,NUKALE
     &               ,NDFDON,NDFSYM,NVDSMA,NUINLM,NVDULM,NBNELM,NVNULM
     &               ,NUINLM,NVDULM,NBNELM,NVNULM,INSTOK,NDFSTO,NDFCOR
     &               ,0     ,NIVIMP,.FALSE.,CRETRM)                     !sdexplo
         CALL CRTERM (NMSCMS,NVSCMS,NBLIGN*NBSCMB,ITSCMS,ITYCAL,NUKALE
     &               ,NDFDON,NDFSYM,NVDSMA,NDFINC,NDFDUM,1     ,NDFNUM
     &               ,NUINLM,NVDULM,NBNELM,NVNULM,INSTOK,NDFSTO,NDFCOR
     &               ,0     ,NIVIMP,.FALSE.,CRETRM)                     !sdexplo
         CALL PRTERM (NMMATS,NVMATS,NIVIMP,IMPSDR)                      !prsd
         CALL PRTERM (NMSCMS,NVSCMS,NIVIMP,IMPSDR)                      !prsd
         CALL TBRR2  (ERCODE,NMMATS,NVMATS,MCMATS,NMSCMS,NVSCMS,MCSCMS)
      ENDIF
*
*--   Recherche des noeuds a eliminer et reordonnement de la matrice
*     (les lignes a conserver sont reportees a la fin)
*
*     Tableau de numerotation des inconnues a conserver
*
      CALL NUDUNI (DOMAIN,INTERP,NBLIGN,NBNUMS,NVNUMS)                  !sdexplo
*
*     Reordonnement des lignes de la matrice pleine
*
      CALL TBCREE ('$WORK$',0,1,NBNUMS*NCPINC,'c')
      CALL TBRR2  (ERCODE,'#GNEDO',NVNULM,MCNUML,'#GNEDO',NVNUMS,MCNUMS)
      CALL TBAR3  (ERCODE,'#GNEDO',NVNULM,MCNUML,'#GNEDO',NVNUMS,MCNUMS
     &                   ,'$WORK$',0,MCWORK)                     
      NBNELM=IST(MCNUML+1)
      MCNUML=MCNUML+2
      MCNUMS=MCNUMS+1
      NXNOEU=1
      NBLIKE=0
      DO 10 NUNOEU=1,NBNUMS
         MCNUMS=MCNUMS+1
         CALL DICOTO (NXNOEU,NBNELM,IST(MCNUML),IST(MCNUMS),LIGNE,*10)  !utilite
         NXNOEU=LIGNE+1
         NULIGN=NCPINC*(LIGNE-1)
         NBLIKE=NBLIKE+NCPINC
         DO 9 ICP=1,NCPINC
           IST(MCWORK)=NULIGN+ICP
           MCWORK=MCWORK+1
9        CONTINUE
10    CONTINUE
      CALL TBSAVE ('#GNEDO',NVNUMS)
      CALL TBSAVE ('#GNEDO',NVNULM)
*
      CALL TBAR1  (ERCODE,'$WORK$',0,MCWORK)                     
      IF (NBLIKE.LT.NBLIGN.OR.IST(MCWORK).NE.NBLIGN-NBLIKE+1
     &   .OR.IST(MCWORK-1+NBLIKE).NE.NBLIGN) THEN
*
*        Permutation des lignes et colonnes correspondant aux noeuds du
*        domaine avec les dernieres lignes et colonnes de la matrice
         CALL TBAR2  (ERCODE,NMMATS,NVMATS,MCMATS,NMSCMS,NVSCMS,MCSCMS)
         CALL PLPERM (TYMATR,NBLIGN,NBLIGN,1,NBLIGN,NBLIKE,IST(MCWORK)
     &               ,MCMATS,RST,CST)                                   !morse
         CALL PLPERM (TYMATR,NBLIGN,NBLIGN,NBLIGN,1,NBLIKE,IST(MCWORK)
     &               ,MCMATS,RST,CST)                                   !morse
         CALL PLPERM (TYSCMS,NBLIGN,NBSCMB,1,NBLIGN,NBLIKE,IST(MCWORK)
     &               ,MCSCMS,RST,CST)                                   !morse
*
         IF (NIVIMP.GT.1) THEN
            CALL PRTERM (NMMATS,NVMATS,NIVIMP,IMPSDR)                   !prsd
            CALL PRTERM (NMSCMS,NVSCMS,NIVIMP,IMPSDR)                   !prsd
            CALL TBRR2  (ERCODE,NMMATS,NVMATS,MCMATS
     &                         ,NMSCMS,NVSCMS,MCSCMS)
         ENDIF
      ENDIF
      CALL TBTUER ('$WORK$',0)
*
*--   Elimination partielle de Gauss proprement dite portant sur les
*     NBLIGN-NBLIKE premieres lignes/colonnes.
*
      CALL TBAR2  (ERCODE,NMMATS,NVMATS,MCMATS,NMSCMS,NVSCMS,MCSCMS)
      SINGUL=.FALSE.
      IF (TYMATR(1:1).EQ.'C') THEN
         CALL PGAUSC (NBLIGN,NBLIGN-NBLIKE,CST(MCMATS),NBSCMB
     &               ,CST(MCSCMS),EPSMAC,SINGUL)                        !syslin
      ELSEIF (TYMATR(1:1).EQ.'R'.AND.TYSCMS(1:1).EQ.'R') THEN
         CALL PGAUSR (NBLIGN,NBLIGN-NBLIKE,RST(MCMATS),NBSCMB
     &               ,RST(MCSCMS),EPSMAC,SINGUL)                        !syslin
      ELSE
         CALL BAISE  (' Type de matrice et second membre differents')   !utilite
      ENDIF
      IF (SINGUL) GOTO 99990
*
      IF (NBLIKE.LT.NBLIGN) THEN
*
*--      Elimination des lignes et colonnes des noeuds n'appartenant pas
*        aux domaines
*
         CALL PLELIM (TYMATR,NBLIGN,NBLIGN,1,NBLIGN,MCMATS,NBLIKE
     &               ,1,NBLIKE,MCMATS,RST,CST)                          !morse
         CALL PLELIM (TYMATR,NBLIGN,NBLIKE,NBLIKE,1,MCMATS,NBLIKE
     &               ,NBLIKE,1,MCMATS,RST,CST)                          !morse
         CALL PLELIM (TYSCMS,NBLIGN,NBSCMB,1,NBLIGN,MCSCMS,NBLIKE
     &               ,1,NBSCMB,MCSCMS,RST,CST)                          !morse
      ENDIF
*
*--   Creation des termes NMMATS et NMSCMS
*
      CALL CRTERM (NMMATS,NVMATS,NBLIKE*NBLIKE,ITMATR,ITYCAL,NUKALE
     &            ,NDFDON,NDFSYM,NDFDSM,NUINLM,NDFDUM,NBNUMS,NVNUMS
     &            ,NUINLM,NDFDUM,NBNUMS,NVNUMS,INSTOK,NDFSTO,NDFCOR
     &            ,0     ,NIVIMP,.FALSE.,CRETRM)                        !sdexplo
      CALL CRTERM (NMSCMS,NVSCMS,NBLIKE,ITSCMS,ITYCAL,NUKALE
     &            ,NDFDON,NDFSYM,NDFDSM,NDFINC,NDFDUM,1     ,NDFNUM
     &            ,NUINLM,NDFDUM,NBNUMS,NVNUMS,INSTOK,NDFSTO,NDFCOR
     &            ,0     ,NIVIMP,.FALSE.,CRETRM)                        !sdexplo
*
*--   Impressions
*
      IF (NIVIMP.GT.1) THEN
         CALL PRTERM (NMMATS,NVMATS,NIVIMP,IMPSDR)                      !prsd
         CALL PRTERM (NMSCMS,NVSCMS,NIVIMP,IMPSDR)                      !prsd
      ENDIF
      CALL TBSAVE (NMMATS,NVMATS)
      CALL TBSAVE (NMSCMS,NVSCMS)
      IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
         CALL PRNTRM (NMMATR,NVMATR,ERCODE,NCATR1)
         CALL PRNTRM (NMSCMB,NVSCMB,ERCODE(NCATR1+1:),NCATR2) 
         WRITE (IMPPAL,10001) 'Matrice',ERCODE(1:NCATR1) 
     &                       ,'2nd mb.',ERCODE(NCATR1+1:NCATR1+NCATR2)
         ERCODE(1:)=DOMAIN
         WRITE (IMPPAL,10002) ERCODE(1:LEN(DOMAIN))
      ENDIF
      CALL PRFXMJ (-1,'*PGauss*')  
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(/,T2,'*PGauss* Condensation statique du systeme lineaire'
     &/,T11,'Nombre d''inconnues :',I12)  
10001 FORMAT(T11,2(A,' : ',A,:' ; '))
10002 FORMAT(T11,'sur les noeuds du domaine ',A)
*-----------------------------------------------------------------------
99990 CALL ERTERM (17,NMMATS,NVMATS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (08 octobre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 2 : D.Martin (13 Octobre 1997)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !PGauss
