*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSAD (RANG,TYPM,MCD,TYPB,MCB,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 91)
* Derniere modification : D.Martin (15 Novembre 1991)
* Version 1.0.0
*  
* Resolution d'un systeme triangulaire diagonale D*.X=B
* Remarque : On suppose dans ce s-p la matrice D inversible
*  
* Arguments d'entree
* RANG  rang de la matrice
* TYPM  type ('REEL' ou 'COMPLEXE') de la matrice
* MCD   adresse (dans le s-t du bon type) de la diagonale
* TYPB  type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   adresse (dans le s-t du bon type) du second membre B
* TYPX  type ('REEL' ou 'COMPLEXE') de la solution X
* MCX   adresse (dans le s-t du bon type) de la solution X
*       MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,MCD,MCB,MCX
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER       MCB1,MCD1,MCX1
*----------------------------------------------------------------------
      IF (TYPM(1:1).EQ.'R') THEN
*
         CALL RSD   (RANG,TYPM,MCD,TYPB,MCB,TYPX,MCX,RST,CST)
*
      ELSE
         MCB1=MCB
         MCD1=MCD
         IF (TYPX(1:1).EQ.'R') THEN
            CALL BAISE('*RsAD  * Incompatibilite entre le type COMPLEXE'
     &                //' de la matrice et le type REEL de la solution')
*
         ELSEIF (TYPM(1:1).EQ.TYPB(1:1)) THEN
               DO 444 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=CST(MCB1)/CONJG(CST(MCD1))
                  MCB1=MCB1+1
444               MCD1=MCD1+1
         ELSE
               DO 424 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=RST(MCB1)/CONJG(CST(MCD1))
                  MCB1=MCB1+1
424               MCD1=MCD1+1
         ENDIF
*
      ENDIF
                                                                    END *RsAD
