*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSBAL1 (RANG,NULAPL,IPLAGE,TYPM,MCT,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)
* Derniere modification : D.Martin (5 Decembre 1991)
* Version 1.0.0
*
* Resolution d'un systeme triangulaire superieur L1*.X=B  (remontee)
* ou la matrice L1 a diagonale unite est stockee Bi-Morse inferieur.
* L1* est la transposee (cas reel) ou l'adjointe (cas complexe) de L1
*
* Arguments d'entree
* RANG   rang de la matrice
* NULAPL tableau des numeros de derniere ligne des plages
* IPLAGE numeros de debut de plage et longueurs cumulees des plages
* TYPM   type ('REEL' ou 'COMPLEXE') de L1
* MCT    adresse (dans le s-t du bon type) de la partie triang. inf.
* TYPB   type ('REEL' ou 'COMPLEXE') du second membre B
* MCB    adresse (dans le s-t du bon type) du second membre B
* TYPX   type ('REEL' ou 'COMPLEXE') de la solution X
* MCX    adresse (dans le s-t du bon type) de la solution X
*        MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),MCT,MCB,MCX
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPLA,LGCUMU,LGCUAV,KOLON,MCCOEF
     &             ,KOLDEB,KOLFIN,MCX1,MCXX,IST
      COMPLEX       CCOEFF
*----------------------------------------------------------------------
      IF (TYPM(1:1).NE.'C') THEN
*
         CALL RSBMU1 (RANG,NULAPL,IPLAGE,TYPM,MCT,TYPB,MCB
     &               ,TYPX,MCX,RST,CST)
*
      ELSEIF (TYPX(1:1).EQ.'C') THEN
*
         IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))
     &   CALL TDANST (RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)
*
         NUPRPL=NULAPL(RANG-1)
         MCX1=MCX-1+RANG
         CCOEFF=CST(MCX1)
*
         DO 44 KOLON=RANG,3,-1
            NUDRPL=NUPRPL
            NUPRPL=NULAPL(KOLON-2)
            LGCUMU=0
            IF (NUPRPL.GT.0) LGCUMU=IPLAGE(2,NUPRPL)
            MCCOEF=MCT+LGCUMU
            DO 43 NUMPLA=NUPRPL+1,NUDRPL
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUMPLA)
                  KOLDEB=IPLAGE(1,NUMPLA)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  DO 43 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                     CST(MCXX)=CST(MCXX)-CCOEFF*CONJG(CST(MCCOEF))
                     MCCOEF=MCCOEF+1
43                CONTINUE
               MCX1=MCX1-1
*
               CCOEFF=CST(MCX1)
*
44          CONTINUE
            IF (NUDRPL.GT.NUPRPL)
     &         CST(MCX)=CST(MCX)-CCOEFF*CONJG(CST(MCT))
      ELSE
         CALL BAISE (' *RsBAL1* Incompatibilite entre le type COMPLEXE '
     &             //' de la matrice et le type REEL de la solution')
      ENDIF
                                                                    END *RsBAL1
