*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSBAU1 (RANG,NULAPL,IPLAGE,TYPM,MCT,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)
* Derniere modification : D.Martin (15 Novembre 1991)
* Version 1.0.0
*
* Resolution d'un systeme triangulaire inferieur U1*.X=B  (descente)
* ou la matrice  U1 a diagonale unite  est stockee bi-morse superieur.
* U1* est la transposee (cas reel) ou l'adjointe (cas complexe) de U1
*
*-- Arguments d'entree --
* RANG   rang de la matrice
* NULAPL tableau des numeros de derniere ligne des plages
* IPLAGE numeros de debut de plage et longueurs cumulees des plages
* TYPM   TYPM ('REEL' ou 'COMPLEXE') de la matrice
* MCT    adresse (dans le s-t du bon TYPM) de la partie triang. sup.
* TYPB   TYPM ('REEL' ou 'COMPLEXE') de B
* MCB    adresse (dans le s-t du bon TYPM) du second membre B
* TYPX   TYPM ('REEL' ou 'COMPLEXE') de X
* MCX    adresse (dans le s-t du bon TYPM) de la solution X
*        MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*          MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),MCT,MCB,MCX
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPL,LGCUMU,LGCUAV,KOLON,MCCOEF
     &             ,LIGNM1,LIGNE,KOLDEB,KOLFIN,MCX1,MCXX,IST
      COMPLEX       CCOEFF
*----------------------------------------------------------------------
      IF (TYPM(1:1).NE.'C') THEN
*
         CALL RSBML1 (RANG,NULAPL,IPLAGE,TYPM,MCT,TYPB,MCB
     &               ,TYPX,MCX,RST,CST)

      ELSEIF (TYPX(1:1).EQ.'C') THEN
*
         IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))
     &   CALL TDANST (RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)
*
         NUDRPL=0
         LGCUAV=1
         LIGNM1=1
         MCX1=MCX+1
*
         MCCOEF=MCT
         DO 44 LIGNE=2,RANG
            CCOEFF=0.
            NUPRPL=NUDRPL
            NUDRPL=NULAPL(LIGNM1)
            DO 43 NUMPL=NUPRPL+1,NUDRPL
               LGCUMU=IPLAGE(2,NUMPL)
               KOLDEB=IPLAGE(1,NUMPL)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               LGCUAV=LGCUMU+1
               DO 43 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                  CCOEFF=CCOEFF+CONJG(CST(MCCOEF))*CST(MCXX)
                  MCCOEF=MCCOEF+1
43             CONTINUE
            CST(MCX1)=CST(MCX1)-CCOEFF
            MCX1=MCX1+1
*
            LIGNM1=LIGNE
44       CONTINUE
      ELSE
         CALL BAISE  (' *RsBAU1* Incompatibilite entre le TYPM COMPLEXE'
     &               //' de la matrice et le TYPM REEL de la solution')
      END IF
                                                                    END *RsBAU1
