*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSBMAL (RANG,NULAPL,IPLAGE,TYPM,MCD,MCT,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)
* Derniere modification : D.Martin (5 Decembre 1991)
* Version 1.0.0
*
* Resolution d'un systeme triangulaire superieur L*.X=B  (remontee)
* ou la matrice  L  est stockee bi-morse inferieur.
* L* est la transposee (cas reel) ou l'adjointe (cas complexe) de L
* Remarque : On suppose dans ce s-p la matrice L inversible
*
*-- Arguments d'entree --
* RANG   rang de la matrice
* NULAPL tableau des numeros de derniere ligne des plages
* IPLAGE numeros de debut de plage et longueurs cumulees des plages
* TYPM   type ('REEL' ou 'COMPLEXE') de L
* MCD    adresse (dans le s-t du bon type) de la diagonale
* MCT    adresse (dans le s-t du bon type) de la partie triang. inf.
* TYPB   type ('REEL' ou 'COMPLEXE') du second membre B
* MCB    adresse (dans le s-t du bon type) du second membre B
* TYPX   type ('REEL' ou 'COMPLEXE') de la solution X
* MCX    adresse (dans le s-t du bon type) de la solution X
*        MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),MCD,MCT,MCB,MCX
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPL,LGCUMU,LGCUAV,KOLON,MCCOEF
     &             ,KOLDEB,KOLFIN,MCX1,MCD1,MCXX,IST
      COMPLEX       CCOEFF
*----------------------------------------------------------------------
      IF (TYPM(1:1).NE.'C') THEN
*
         CALL RSBMU (RANG,NULAPL,IPLAGE,TYPM,MCD,MCT,TYPB,MCB
     &              ,TYPX,MCX,RST,CST)
      ELSEIF (TYPX(1:1).EQ.'C') THEN
*
         IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))
     &   CALL TDANST (RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)
*
         NUPRPL=NULAPL(RANG-1)
         MCX1=MCX-1+RANG
         MCD1=MCD-1+RANG
         CCOEFF=CST(MCX1)/CONJG(CST(MCD1))
         CST(MCX1)=CCOEFF
         DO 44 KOLON=RANG,3,-1
            NUDRPL=NUPRPL
            NUPRPL=NULAPL(KOLON-2)
            LGCUMU=0
            IF (NUPRPL.GT.0) LGCUMU=IPLAGE(2,NUPRPL)
            MCCOEF=MCT+LGCUMU
            DO 43 NUMPL=NUPRPL+1,NUDRPL
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  DO 43 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                     CST(MCXX)=CST(MCXX)-CCOEFF*CONJG(CST(MCCOEF))
                     MCCOEF=MCCOEF+1
43                CONTINUE
               MCX1=MCX1-1
               MCD1=MCD1-1
               CCOEFF=CST(MCX1)/CONJG(CST(MCD1))
               CST(MCX1)=CCOEFF
44          CONTINUE
            IF (NUDRPL.GT.NUPRPL)
     &      CST(MCX)=CST(MCX)-CONJG(CST(MCT))*CCOEFF
            CST(MCX)=CST(MCX)/CONJG(CST(MCD))
*
      ELSE
         CALL BAISE  (' *RsBmAL* Incompatibilite entre le type COMPLEXE'
     &              //' de la matrice et le type REEL de la solution')
      ENDIF
                                                                    END *RsBmAL
