*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSBMAU (RANG,NULAPL,IPLAGE,TYPM,MCD,MCT,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)
* Derniere modification : D.Martin (15 Novembre 1991)
* Version 1.0.0
*
* Resolution d'un systeme triangulaire inferieur U*.X=B  (descente)
* ou la matrice  U  est stockee bi-morse superieur.
* U* est la transposee (cas reel) ou l'adjointe (cas complexe) de U
* Remarque : On suppose dans ce s-p la matrice U inversible
*
*-- Arguments d'entree --
* RANG   rang de la matrice
* NULAPL tableau des numeros de derniere ligne des plages
* IPLAGE numeros de debut de plage et longueurs cumulees des plages
* TYPM   type ('REEL' ou 'COMPLEXE') de U
* MCD    adresse (dans le s-t du bon type) de la diagonale de la matrice U
* MCT    adresse (dans le s-t du bon type) de la matrice triang. superieure U
* TYPB   type ('REEL' ou 'COMPLEXE') de B
* MCB    adresse (dans le s-t du bon type) du second membre B
* TYPX   type ('REEL' ou 'COMPLEXE') de X
* MCX    adresse (dans le s-t du bon type) de la solution X
*        MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),MCD,MCT,MCB,MCX
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPL,LGCUMU,LGCUAV,LIGNE,MCCOEF
     &             ,LIGNM1,KOLDEB,KOLFIN,MCX1,MCD1,MCXX,IST
      COMPLEX       CCOEFF
*----------------------------------------------------------------------
      IF (TYPM(1:1).NE.'C') THEN
*
         CALL RSBML (RANG,NULAPL,IPLAGE,TYPM,MCD,MCT,TYPB,MCB
     &              ,TYPX,MCX,RST,CST)
*
      ELSEIF (TYPX(1:1).EQ.'C') THEN
*
         IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))
     &   CALL TDANST (RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)
*
         NUDRPL=0
         LGCUAV=1
         LIGNM1=1
         MCX1=MCX+1
         MCD1=MCD+1
         MCCOEF=MCT
         CST(MCX)=CST(MCX)/CONJG(CST(MCD))
         DO 44 LIGNE=2,RANG
            CCOEFF=0.
            NUPRPL=NUDRPL
            NUDRPL=NULAPL(LIGNM1)
            DO 43 NUMPL=NUPRPL+1,NUDRPL
               LGCUMU=IPLAGE(2,NUMPL)
               KOLDEB=IPLAGE(1,NUMPL)
               KOLFIN=KOLDEB+LGCUMU-LGCUAV
               LGCUAV=LGCUMU+1
               DO 43 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                  CCOEFF=CCOEFF+CONJG(CST(MCCOEF))*CST(MCXX)
                  MCCOEF=MCCOEF+1
43             CONTINUE
            CST(MCX1)=(CST(MCX1)-CCOEFF)/CONJG(CST(MCD1))
            MCX1=MCX1+1
            MCD1=MCD1+1
            LIGNM1=LIGNE
44       CONTINUE
      ELSE
         CALL BAISE  (' *RsBmAU* Incompatibilite entre le type COMPLEXE'
     &              //' de la matrice et le type REEL de la solution')
      ENDIF
                                                                    END *RsBmAU
