*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSBMU1 (RANG,NULAPL,IPLAGE,TYPM,MCT,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 91)
* Derniere modification : D.Martin (5 Decembre 1991)
* Version 1.0.0
*
* Resolution du systeme U1xX=B ou U1 est une matrice triangulaire superieure
* a diagonale unite stockee BiMorse.
*
*-- Arguments d'entree --
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPM  : type ('REEL' ou 'COMPLEXE') de U1
*
* MCT   : adresse (dans le s-t du bon type) de la matrice triang. superieure U1
* TYPB  : type ('REEL' ou 'COMPLEXE') de B
* MCB   : adresse (dans le s-t du bon type) du second membre B
* TYPX  : type ('REEL' ou 'COMPLEXE') de X
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX = TYPB)
* RST   : tableau (cas reel) contenant la matrice U1 a l'adresse MCT,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX
* CST   : idem mais dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),MCT,MCB,MCX,IST
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NUPRPL,NUDRPL,NUMPL,LGCUMU,LGCUAV,KOLDEB,KOLFIN
     &             ,MCCOEF,KOLON,MCX1,MCXX
      REAL          RCOEFF
      COMPLEX       CCOEFF
      EQUIVALENCE  (CCOEFF,RCOEFF)
*-----------------------------------------------------------------------
      IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))
     *   CALL TDANST (RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)
*
      NUPRPL=NULAPL(RANG-1)
      MCX1=MCX-1+RANG
*
      IF (TYPX(1:1).EQ.TYPM(1:1)) THEN
         IF (TYPX(1:1).EQ.'C') THEN
            CCOEFF=CST(MCX1)
*
            DO 44 KOLON=RANG,3,-1
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(KOLON-2)
               LGCUMU=0
               IF (NUPRPL.GT.0) LGCUMU=IPLAGE(2,NUPRPL)
               MCCOEF=MCT+LGCUMU
               DO 43 NUMPL=NUPRPL+1,NUDRPL
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  DO 43 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                     CST(MCXX)=CST(MCXX)-CCOEFF*CST(MCCOEF)
                     MCCOEF=MCCOEF+1
43                CONTINUE
               MCX1=MCX1-1
*
               CCOEFF=CST(MCX1)
*
44          CONTINUE
            IF (NUDRPL.GT.NUPRPL) CST(MCX)=CST(MCX)-CCOEFF*CST(MCT)
*
         ELSE
            RCOEFF=RST(MCX1)
*
            DO 22 KOLON=RANG,3,-1
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(KOLON-2)
               LGCUMU=0
               IF (NUPRPL.GT.0) LGCUMU=IPLAGE(2,NUPRPL)
               MCCOEF=MCT+LGCUMU
               DO 21 NUMPL=NUPRPL+1,NUDRPL
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  DO 21 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                     RST(MCXX)=RST(MCXX)-RCOEFF*RST(MCCOEF)
                     MCCOEF=MCCOEF+1
21                CONTINUE
               MCX1=MCX1-1
*
               RCOEFF=RST(MCX1)
*
22          CONTINUE
            IF (NUDRPL.GT.NUPRPL) RST(MCX)=RST(MCX)-RCOEFF*RST(MCT)
*
         ENDIF
      ELSEIF (TYPX(1:1).EQ.'C') THEN
            CCOEFF=CST(MCX1)
*
            DO 24 KOLON=RANG,3,-1
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(KOLON-2)
               LGCUMU=0
               IF (NUPRPL.GT.0) LGCUMU=IPLAGE(2,NUPRPL)
               MCCOEF=MCT+LGCUMU
               DO 23 NUMPL=NUPRPL+1,NUDRPL
                  LGCUAV=LGCUMU+1
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV
                  DO 23 MCXX=MCX-1+KOLDEB,MCX-1+KOLFIN
                     CST(MCXX)=CST(MCXX)-CCOEFF*RST(MCCOEF)
                     MCCOEF=MCCOEF+1
23                CONTINUE
               MCX1=MCX1-1
*
               CCOEFF=CST(MCX1)
*
24          CONTINUE
            IF (NUDRPL.GT.NUPRPL) CST(MCX)=CST(MCX)-CCOEFF*RST(MCT)
*
      ELSE
         CALL BAISE  (' *RsBmU1* Incompatibilite entre le type COMPLEXE'
     &             // ' de la matrice et le type REEL de la solution')
      ENDIF
                                                                    END *RsBmU1
