*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSD (RANG,TYPM,MCD,TYPB,MCB,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 91)
* Derniere modification : D.Martin (15 Novembre 1991)
* Version 1.0.0
*  
* Resolution d'un systeme triangulaire diagonale D.X=B
* Remarque : On suppose dans ce s-p la matrice D inversible
*  
*-- Arguments d'entree--
* RANG  Rang de la matrice
* TYPM  type ('REEL' ou 'COMPLEXE') de la matrice
* MCD   adresse (dans le s-t du bon type) de la diagonale
* TYPB  type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   adresse (dans le s-t du bon type) du second membre B
* TYPX  type ('REEL' ou 'COMPLEXE') de la solution X
* MCX   adresse (dans le s-t du bon type) de la solution X
*       MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,MCD,MCB,MCX
      REAL          RST(*) 
      COMPLEX       CST(*)
*
      INTEGER       MCB1,MCD1,MCX1
*----------------------------------------------------------------------
      MCB1=MCB
      MCD1=MCD
      IF (TYPX(1:1).EQ.'R') THEN
         IF (TYPM(1:1).EQ.TYPB(1:1)) THEN
            IF (TYPM(1:1).EQ.'R') THEN
               DO 222 MCX1=MCX,MCX-1+RANG
                  RST(MCX1)=RST(MCB1)/RST(MCD1)
                  MCB1=MCB1+1
                  MCD1=MCD1+1
222            CONTINUE
            ELSE
                CALL BAISE('*RsD   * Incompatibilite entre le type'
     &          //' COMPLEXE de la matrice et du second membre'
     &          //' et le type REEL de la solution')
            ENDIF
         ELSEIF (TYPM(1:1).EQ.'R') THEN
            CALL BAISE('*RsD   * Incompatibilite entre le type COMPLEXE'
     &      //' du second membre et le type REEL de la solution')
         ELSE
            CALL BAISE('*RsD   * Incompatibilite entre le type COMPLEXE'
     &      //' de la matrice et le type REEL de la solution')
         ENDIF
      ELSE 
         IF (TYPM(1:1).EQ.TYPB(1:1)) THEN
            IF (TYPM(1:1).EQ.'R') THEN
               DO 224 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=RST(MCB1)/RST(MCD1)
                  MCB1=MCB1+1
                  MCD1=MCD1+1
224            CONTINUE
            ELSE
               DO 444 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=CST(MCB1)/CST(MCD1)
                  MCB1=MCB1+1
                  MCD1=MCD1+1
444            CONTINUE
            ENDIF
         ELSEIF (TYPM(1:1).EQ.'R') THEN
               DO 244 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=CST(MCB1)/RST(MCD1)
                  MCB1=MCB1+1
                  MCD1=MCD1+1
244            CONTINUE
         ELSE
               DO 424 MCX1=MCX,MCX-1+RANG
                  CST(MCX1)=RST(MCB1)/CST(MCD1)
                  MCB1=MCB1+1
                  MCD1=MCD1+1
424            CONTINUE
         ENDIF
      ENDIF
                                                                    END *RsD
