*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSMAFL (NMSTOK,MCSTOK,TYFAC,TYMATR,MCMATR
     &                  ,NBSCMB,TYSCMB,MCSCMB,TYSOLU,MCSOLU
     &                  ,IST,RST,CST,IRCODE)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1999)  
* Derniere modification : D.Martin (21 Mai 1999)
*
* Resolution d'un systeme lineaire reel ou complexe dont la matrice est 
* triangulaire inferieure (descente pour une matrice factorisee)
*
*-- Arguments d'entree -- 
* NMSTOK nom du type de stockage de la matrice. 
* MCSTOK adresse du tableau de stockage de la matrice (le cas echeant).
* TYFAC  type de factorisation de la matrice
* TYMATR type (reel ou complexe) de la matrice
* MCMATR adresse de la matrice dans le super-tableau ad hoc
* NBSCMB nombre de seconds membres
* TYSCMB type (reel ou complexe) du  vecteur second membre
* MCSCMB adresse du second membre
* TYSOLU type (reel ou complexe) du vecteur solution
* MCSCMB adresse du vecteur solution
* IST,RST,CST super-tableau considere entier, reel ou complexe
* IRCODE code de retour en cas d'erreur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMSTOK,TYFAC,TYMATR,TYSCMB,TYSOLU
      INTEGER       IST(*),MCSTOK,MCMATR,NBSCMB,MCSCMB,MCSOLU,IRCODE
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       NBLIGN,NBPLAL,MCSTAL,MCSTIL,LGL,MCL
     &             ,NBCOLO,NBPLAU,MCSTAU,MCSTIU,LGU
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*RsmafL*')
*
      IRCODE=0
      IF (NMSTOK(1:4).EQ.'&PRO') THEN
         CALL EXPROF (MCSTOK,IST(MCSTOK),NBLIGN,MCSTAL,LGL
     &                                  ,NBCOLO,MCSTAU,LGU)             !sdexplo
         MCL=MCMATR+NBLIGN
*
         IF (TYFAC(1:4).EQ.'L.LT'.OR.TYFAC(1:4).EQ.'L.L*') THEN
*
            CALL RSPRL  (NBLIGN,IST(MCSTAL),TYMATR,MCMATR
     &                  ,MCL,TYSCMB,MCSCMB,TYSOLU,MCSOLU,RST,CST)
*
         ELSEIF (TYFAC(1:3).EQ.'L.U'.OR.TYFAC(1:5).EQ.'L.D.U'.OR.
     &           TYFAC(1:6).EQ.'L.D.LT'.OR.TYFAC(1:6).EQ.'L.D.L*') THEN
*
            CALL RSPRL1 (NBLIGN,IST(MCSTAL),TYMATR
     &                  ,MCL,TYSCMB,MCSCMB,TYSOLU,MCSOLU,RST,CST)
         ELSE
            IRCODE=1
         ENDIF
      ELSEIF (NMSTOK(1:4).EQ.'&BMO') THEN
         CALL EXBMOR (MCSTOK,IST(MCSTOK),NBLIGN,NBPLAL,MCSTAL,MCSTIL,LGL
     &               ,NBCOLO,NBPLAU,MCSTAU,MCSTIU,LGU)                  !sdexplo
         MCL=MCMATR+NBLIGN
*
         IF (TYFAC(1:4).EQ.'L.LT'.OR.TYFAC(1:4).EQ.'L.L*') THEN
*
            CALL RSBML  (NBLIGN,IST(MCSTAL),IST(MCSTIL),TYMATR,MCMATR    
     &                  ,MCL,TYSCMB,MCSCMB,TYSOLU,MCSOLU,RST,CST)
*
         ELSEIF (TYFAC(1:3).EQ.'L.U'.OR.TYFAC(1:5).EQ.'L.D.U'.OR.
     &           TYFAC(1:6).EQ.'L.D.LT'.OR.TYFAC(1:6).EQ.'L.D.L*') THEN
*
            CALL RSBML1 (NBLIGN,IST(MCSTAL),IST(MCSTIL),TYMATR 
     &                  ,MCL,TYSCMB,MCSCMB,TYSOLU,MCSOLU,RST,CST)
*
         ELSE
            IRCODE=1
         ENDIF
*
      ELSEIF (NMSTOK(1:4).EQ.'&PLA') THEN
         CALL EXMORS (MCSTOK,IST(MCSTOK),NBLIGN,NBCOLO,NBPLAL,MCSTAL
     &               ,MCSTIL,LGL)                                       !sdexplo
         IF (TYFAC(1:3).EQ.'L.U') THEN
*
            CALL RSMOL1 (NBLIGN,IST(MCSTAL),IST(MCSTIL),TYMATR,MCMATR
     &                  ,TYSCMB,MCSCMB,TYSOLU,MCSOLU,RST,CST)
         ELSE
            IRCODE=1
         ENDIF
      ENDIF
      CALL PRFXMJ (-1,'*RsMafL*')    
                                                                    END !RsMafL
