*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S M A L 1 (RANG,NULAPL,IPLAGE,TYPL,MCL,TYPB,MCB
     *                                                ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Nov. 89)  
* Derniere modification (D.Martin) le 26 Sept. 91
*  
*     Resolution du systeme L1*xX=Y ou L1* est l'adjointe de la matrice L1
*     triangulaire inferieure a diagonale unite stockee MORSE selon son propre 
*     compactage ou selon le compactage d'une matrice factorisee L1xU incomplet
*      (il s'agit donc d'une 'remontee')
*  
*** Arguments d'entree *** 
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages 
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPL  : type ('REEL' ou 'COMPLEXE') de la matrice L  
* MCL   : adresse (dans le s-t du bon type) de la matrice triang. inferieure L 
* TYPB  : type ('REEL' ou 'COMPLEXE') du vecteur second membre B
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') du vecteur solution X
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB 
* RST   : tableau (cas reel) contenant la matrice L a l'adresse MCL,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX 
* CST   : idem mais dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPL,TYPB,TYPX 
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*) ,IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*  
      IF(TYPL(1:1).EQ.'R') THEN
         CALL RSMTL1(RANG,NULAPL,IPLAGE,'R',MCL,TYPB,MCB                !Syslin
     *                                                ,TYPX,MCX,RST,CST)!Syslin
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*  
         IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1))  
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
         MCX1=MCX-1+RANG 
            NUPRPL=NULAPL(RANG)  
            DO 15 LIGNE=RANG,2,-1
               CCOEFF=CST(MCX1)
               MCX1=MCX1-1 
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(LIGNE-1)  
               LGCUMU=IPLAGE(2,NUPRPL) 
*->            MCUCOF : adresse du premier coeff. de la ligne  
               MCUCOF=MCL+LGCUMU
               DO 12 NUMPL=NUPRPL+1,NUDRPL 
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  IF(KOLFIN.GE.LIGNE-1) GO TO 13
*                 Plages ne contenant pas le coefficient sous-diagonal 
                  DO 11 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN 
                     CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF)) 
11                   MCUCOF=MCUCOF+1
12                CONTINUE 
               GO TO 15
*              Plage contenant le coefficient diagonal 
13             DO 14 MCXJ=MCX-1+KOLDEB,MCX-2+LIGNE 
                  CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF))
14                MCUCOF=MCUCOF+1  
15             CONTINUE
      ELSE 
         CALL BAISE('*RsMAL1* Incompatibilite entre le type COMPLEXE de'!Utilite
     *                   //' la matrice et le type REEL de la solution')!Utilite
      END IF
                                                                    END *RsMaL1*
