*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S M O A U (RANG,NULAPL,IPLAGE,TYPU,MCU,TYPB,MCB
     *                                                ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Nov. 89)  
* Derniere modification (D.Martin) le 9 Oct. 90
*  
*     Resolution du systeme U*xY=B ou U* est l'adjointe de la matrice U
*     triangulaire superieure stockee MORSE 'ligne' selon son propre compactage
*     ou selon le compactage 'MORSE ligne' d'une matrice A factorisee LxU inc. 
*     (il s'agit donc d'une 'descente').
*  
*** Arguments d'entree *** 
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages 
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPU  : type ('REEL' ou 'COMPLEXE') de la matrice U  
* MCU   : adresse (dans le s-t du bon type) de la matrice triang. superieure U 
* TYPB  : type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') du vecteur solution X
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB !)  
* RST   : tableau (cas reel) contenant la matrice U a l'adresse MCU,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX 
* CST   : idem mais dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPU,TYPB,TYPX 
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),IST  
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*  
      IF(TYPU(1:1).EQ.'R') THEN
         CALL RSMOTU(RANG,NULAPL,IPLAGE,'R',MCU,TYPB,MCB                !Syslin
     *                                                ,TYPX,MCX,RST,CST)!Syslin
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*  
         IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
         NUDRPL=NULAPL(1) 
         MCX1=MCX+1
         MCUCOF=MCU+1   
         CST(MCX)=CST(MCX)/CONJG(CST(MCU)) 
         CCOEFF=CST(MCX)
         DO 22 MCXJ=MCX1,MCX-1+IPLAGE(2,1) 
            CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF))  
22          MCUCOF=MCUCOF+1
         LGCUMU=IPLAGE(2,1)
         DO 23 NUMPL=2,NUDRPL  
            LGCUAV=LGCUMU+1
            LGCUMU=IPLAGE(2,NUMPL) 
            KOLDEB=IPLAGE(1,NUMPL) 
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 23 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN
               CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF))
23             MCUCOF=MCUCOF+1 
         DO 29 LIGNE=2,RANG-1
            CCOEFF=CST(MCX1)
            LGCUAV=IPLAGE(2,NUDRPL)
            NUPRPL=NUDRPL+1
            NUDRPL=NULAPL(LIGNE)
            CALL DIKLPL(LIGNE,NUPRPL,NUDRPL,LGCUAV,IPLAGE,NUPLDG,*29)   !Morse 
*  
            KOLDEB=IPLAGE(1,NUPLDG)
            LGCUAV=IPLAGE(2,NUPLDG-1)+1
            MCUCOF=MCU-1+LGCUAV+LIGNE-KOLDEB
            CCOEFF=CCOEFF/CONJG(CST(MCUCOF))
            CST(MCX1)=CCOEFF
            MCUCOF=MCUCOF+1
            LGCUMU=IPLAGE(2,NUPLDG)
            KOLFIN=KOLDEB+LGCUMU-LGCUAV
            DO 25 MCXJ=MCX+LIGNE,MCX-1+KOLFIN  
               CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF))
25             MCUCOF=MCUCOF+1 
            DO 26 NUMPL=NUPLDG+1,NUDRPL
               LGCUAV=LGCUMU+1 
               LGCUMU=IPLAGE(2,NUMPL)  
               KOLDEB=IPLAGE(1,NUMPL)  
               KOLFIN=KOLDEB+LGCUMU-LGCUAV 
               DO 26 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN
                  CST(MCXJ)=CST(MCXJ)-CCOEFF*CONJG(CST(MCUCOF))
26                MCUCOF=MCUCOF+1  
29          MCX1=MCX1+1
         CST(MCX1)=CST(MCX1)/CONJG(CST(MCU-1+IPLAGE(2,NULAPL(RANG))))
      ELSE 
         CALL BAISE('*RsMoAU* Incompatibilite entre le type COMPLEXE de'!Utilite
     *                   //' la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsMoaU*
