*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S M O L (RANG,NULAPL,IPLAGE,TYPL,MCL,TYPB,MCB 
     *                                                ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Nov. 89)  
* Derniere modification (D.Martin) le 30 Sept. 91
*  
*     Resolution du systeme LxX=B ou L est une matrice triangulaire inferieure 
*     stockee MORSE ligne. 
*  
*** Arguments d'entree *** 
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages 
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPL  : type ('REEL' ou 'COMPLEXE') de L
* MCL   : adresse (dans le s-t du bon type) de la matrice triang. inferieure L
* TYPB  : type ('REEL' ou 'COMPLEXE') de B 
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX = TYPB)  
* RST   : tableau (cas reel) contenant la matrice L1 a l'adresse MCL,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX 
* CST   : idem mais dans le cas complexe
*  
*** Sous-programme utilises ***
* TDANST Report d'un tableau dans un autre (UTILITER)  
* MOLIV  Prod. scalaire partiel d'une ligne d'une matrice stockee 'Morse ligne'
*        par un vecteur
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPL,TYPB,TYPX 
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*
*     Recopie prealable du second membre dans le vecteur solution
*
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      NUDRPL=NULAPL(1)
      LIGNM1=1
      MCX1=MCX+1 
      IF(TYPX(1:1).EQ.TYPL(1:1)) THEN
*
         IF(TYPX(1:1).EQ.'R') THEN
            RST(MCX)=RST(MCX)/RST(MCL)
            DO 22 LIGNE=2,RANG
               NUPRPL=NUDRPL  
               NUDRPL=NULAPL(LIGNE)
*
*              Calcul de Somme(k=1,..,i-1) Lik Xk  
               CALL MOLIV(1,LIGNM1,NUPRPL+1,NUDRPL,IPLAGE(2,NUPRPL)     !Multmat
     *       ,IPLAGE,'R',MCL,RST,CST,'R',MCX,RST,CST,CCOEFF,IADPR,IADDR)!Multmat
*
*              Calcul de Xi = ( Xi -  Somme(k=1,..,i-1) Lik Xk ) / Lii
               RST(MCX1)=(RST(MCX1)-RCOEFF)/RST(MCL+IADDR)
               MCX1=MCX1+1
22             LIGNM1=LIGNE 
*  
         ELSE
*
            CST(MCX)=CST(MCX)/CST(MCL)
            DO 44 LIGNE=2,RANG
               NUPRPL=NUDRPL  
               NUDRPL=NULAPL(LIGNE)
               CALL MOLIV(1,LIGNM1,NUPRPL+1,NUDRPL,IPLAGE(2,NUPRPL)     !Multmat
     *       ,IPLAGE,'C',MCL,RST,CST,'C',MCX,RST,CST,CCOEFF,IADPR,IADDR)!Multmat
               CST(MCX1)=(CST(MCX1)-CCOEFF)/CST(MCL+IADDR)
               MCX1=MCX1+1
44             LIGNM1=LIGNE 
         END IF
*
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*
            CST(MCX)=CST(MCX)/RST(MCL)
            DO 24 LIGNE=2,RANG
               NUPRPL=NUDRPL  
               NUDRPL=NULAPL(LIGNE)
               CALL MOLIV(1,LIGNM1,NUPRPL+1,NUDRPL,IPLAGE(2,NUPRPL)     !Multmat
     *       ,IPLAGE,'R',MCL,RST,CST,'C',MCX,RST,CST,CCOEFF,IADPR,IADDR)!Multmat
               CST(MCX1)=(CST(MCX1)-CCOEFF)/RST(MCL+IADDR)
               MCX1=MCX1+1
24             LIGNM1=LIGNE
*
      ELSE
         CALL BAISE(' *RsMoL * Incompatibilite entre le type COMPLEXE'//!Utilite
     *                  ' de la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsMoL*
