*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S M O U (RANG,NULAPL,IPLAGE,TYPU,MCU,TYPB,MCB 
     *                                                ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Nov. 89)  
* Derniere modification (D.Martin) le 30 Sept. 91
*  
*     Resolution du systeme UxX=B ou U est une matrice triangulaire superieure 
*     stockee MORSE selon son propre compactage ou selon le compactage d'une
*     matrice A factorisee LxU incomplet.  
*  
*** Arguments d'entree *** 
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages 
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPU  : type ('REEL' ou 'COMPLEXE') de U 
* MCU   : adresse (dans le s-t du bon type) de la matrice triang. superieure U 
* TYPB  : type ('REEL' ou 'COMPLEXE') de B 
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel TYPX doit etre egal a TYPB!)
* RST   : tableau (cas reel) contenant la matrice U a l'adresse MCU,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX 
* CST   : idem mais dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPU,TYPB,TYPX 
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*) ,IST 
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF)  
*  
*     Remarque: Dans ce s-p NUPRPL est la derniere plage de la ligne precedente,
*               NUDRPL la derniere plage de la ligne en cours. 
*  
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      MCX1=MCX-1+RANG
      NUPRPL=NULAPL(RANG-1)  
      IF(TYPU(1:1).EQ.TYPX(1:1)) THEN
* 
         IF(TYPX(1:1).EQ.'R') THEN 
            RST(MCX1)=RST(MCX1)/RST(MCU-1+IPLAGE(2,NULAPL(RANG)))
*  
*           De la 2eme a l'avant derniere ligne (parcours retrograde)  
*           (La ligne no 1 necessite un traitement special)
            DO 1 LIGNE=RANG-1,2,-1
               MCX1=MCX1-1 
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(LIGNE-1)  
               LGCUMU=IPLAGE(2,NUPRPL) 
               CALL MOLIV(LIGNE+1,RANG,NUPRPL+1,NUDRPL,LGCUMU,IPLAGE    !Multmat
     *           ,'R',MCU,RST,CST,'R',MCX,RST,CST,CCOEFF,IADCOF,IADDR)  !Multmat
1              RST(MCX1)=(RST(MCX1)-RCOEFF)/RST(MCU+IADCOF-2)  
*  
*           Cas de la 1ere ligne
            CALL MOLIV(2,RANG,1,NULAPL(1),0,IPLAGE                      !Multmat
     *         ,'R',MCU,RST,CST,'R',MCX,RST,CST,CCOEFF,IADCOF,IADDR)    !Multmat
            RST(MCX)=(RST(MCX)-RCOEFF)/RST(MCU)
         ELSE  
            CST(MCX1)=CST(MCX1)/CST(MCU-1+IPLAGE(2,NULAPL(RANG)))
            DO 2 LIGNE=RANG-1,2,-1
               MCX1=MCX1-1 
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(LIGNE-1)  
               LGCUMU=IPLAGE(2,NUPRPL) 
               CALL MOLIV(LIGNE+1,RANG,NUPRPL+1,NUDRPL,LGCUMU,IPLAGE    !Multmat
     *           ,'C',MCU,RST,CST,'C',MCX,RST,CST,CCOEFF,IADCOF,IADDR)  !Multmat
2              CST(MCX1)=(CST(MCX1)-CCOEFF)/CST(MCU+IADCOF-2)  
            CALL MOLIV(2,RANG,1,NULAPL(1),0,IPLAGE                      !Multmat
     *           ,'C',MCU,RST,CST,'C',MCX,RST,CST,CCOEFF,IADCOF,IADDR)  !Multmat
            CST(MCX)=(CST(MCX)-CCOEFF)/CST(MCU)
         END IF
*
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*
         CST(MCX1)=CST(MCX1)/RST(MCU-1+IPLAGE(2,NULAPL(RANG)))
         DO 6 LIGNE=RANG-1,2,-1  
            MCX1=MCX1-1
            NUDRPL=NUPRPL  
            NUPRPL=NULAPL(LIGNE-1) 
            LGCUMU=IPLAGE(2,NUPRPL)
            CALL MOLIV(LIGNE+1,RANG,NUPRPL+1,NUDRPL,LGCUMU,IPLAGE       !Multmat
     *           ,'R',MCU,RST,CST,'C',MCX,RST,CST,CCOEFF,IADCOF,IADDR)  !Multmat
6           CST(MCX1)=(CST(MCX1)-CCOEFF)/RST(MCU+IADCOF-2) 
         CALL MOLIV(2,RANG,1,NULAPL(1),0,IPLAGE                         !Multmat
     *           ,'R',MCU,RST,CST,'C',MCX,RST,CST,CCOEFF,IADCOF,IADDR)  !Multmat
         CST(MCX)=(CST(MCX)-CCOEFF)/RST(MCU)
*
      ELSE
         CALL BAISE('*RsMoU * Incompatibilite entre le type COMPLEXE de'!Utilite
     *                   //' la matrice et le type REEL de la solution')!Utilite
      END IF
                                                                    END *RsmoU*
