*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S M T L 1 (RANG,NULAPL,IPLAGE,TYPL,MCL,TYPB,MCB
     *                                                ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Nov. 89)  
* Derniere modification (D.Martin) le 30 Sept. 91
*  
*     Resolution du systeme tL1xX=Y ou tL1 est la transposee de la matrice L1 
*     triangulaire inferieure a diagonale unite stockee 'Morse ligne' selon son
*     propre compactage ou selon le compactage d'une matrice A fact. LxU incomp.
*      (il s'agit donc d'une 'remontee')
*  
*** Arguments d'entree *** 
* RANG  : nombre de 'noeuds' en ligne de la matrice
* NULAPL: tableau des numeros de derniere ligne des plages 
* IPLAGE: numeros de debut de plage et longueurs cumulees des plages
* TYPL  : type ('REEL' ou 'COMPLEXE') de L1 
* MCL   : adresse (dans le s-t du bon type) de la matrice triang. inf. L1 
* TYPB  : type ('REEL' ou 'COMPLEXE') de B 
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de B 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB 
* RST   : tableau (cas reel) contenant la matrice L1 a l'adresse MCL,
*         le 2nd membre a l'adresse MCB et le vecteur solution a l'adresse MCX 
* CST   : idem mais dans le cas complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPL,TYPB,TYPX 
      INTEGER       RANG,NULAPL(*),IPLAGE(2,*),IST  
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*  
*     Remarque: Dans ce s-p NUPRPL est la derniere plage de la ligne precedente,
*               NUDRPL la derniere plage de la ligne en cours. 
*  
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      MCX1=MCX-1+RANG
      NUPRPL=NULAPL(RANG)
      IF(TYPL(1:1).EQ.TYPX(1:1)) THEN  
         IF(TYPL(1:1).EQ.'C') THEN 
*  
            DO 15 LIGNE=RANG,2,-1
               CCOEFF=CST(MCX1)
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(LIGNE-1)  
               LGCUMU=IPLAGE(2,NUPRPL) 
*->            MCUCOF : adresse du premier coeff. de la ligne  
               MCUCOF=MCL+LGCUMU
               DO 12 NUMPL=NUPRPL+1,NUDRPL 
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  IF(KOLFIN.GE.LIGNE-1) GO TO 13
*                 Plages ne contenant pas le coefficient sous-diagonal 
                  DO 11 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN 
                     CST(MCXJ)=CST(MCXJ)-CCOEFF*CST(MCUCOF)
11                   MCUCOF=MCUCOF+1
12                CONTINUE 
               GO TO 15
*              Plage contenant le coefficient diagonal 
13             DO 14 MCXJ=MCX-1+KOLDEB,MCX-2+LIGNE 
                  CST(MCXJ)=CST(MCXJ)-CCOEFF*CST(MCUCOF)
14                MCUCOF=MCUCOF+1  
15             MCX1=MCX1-1 
         ELSE  
*  
            DO 25 LIGNE=RANG,2,-1
               RCOEFF=RST(MCX1)
               NUDRPL=NUPRPL
               NUPRPL=NULAPL(LIGNE-1)  
               LGCUMU=IPLAGE(2,NUPRPL) 
               MCUCOF=MCL+LGCUMU
               DO 22 NUMPL=NUPRPL+1,NUDRPL 
                  LGCUAV=LGCUMU+1  
                  LGCUMU=IPLAGE(2,NUMPL)
                  KOLDEB=IPLAGE(1,NUMPL)
                  KOLFIN=KOLDEB+LGCUMU-LGCUAV  
                  IF(KOLFIN.GE.LIGNE-1) GO TO 23
                  DO 21 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN 
                     RST(MCXJ)=RST(MCXJ)-RCOEFF*RST(MCUCOF)
21                   MCUCOF=MCUCOF+1
22                CONTINUE 
               GO TO 25
23             DO 24 MCXJ=MCX-1+KOLDEB,MCX-2+LIGNE 
                  RST(MCXJ)=RST(MCXJ)-RCOEFF*RST(MCUCOF)
24                MCUCOF=MCUCOF+1  
25             MCX1=MCX1-1 
         END IF
*  
      ELSE IF(TYPL(1:1).EQ.'R') THEN
*  
         DO 45 LIGNE=RANG,2,-1
            CCOEFF=CST(MCX1)
            NUDRPL=NUPRPL  
            NUPRPL=NULAPL(LIGNE-1) 
            LGCUMU=IPLAGE(2,NUPRPL)
            MCUCOF=MCL+LGCUMU  
            DO 42 NUMPL=NUPRPL+1,NUDRPL
               LGCUAV=LGCUMU+1 
               LGCUMU=IPLAGE(2,NUMPL)  
               KOLDEB=IPLAGE(1,NUMPL)  
               KOLFIN=KOLDEB+LGCUMU-LGCUAV 
               IF(KOLFIN.GE.LIGNE-1) GO TO 43  
               DO 41 MCXJ=MCX-1+KOLDEB,MCX-1+KOLFIN
                  CST(MCXJ)=CST(MCXJ)-CCOEFF*RST(MCUCOF)
41                MCUCOF=MCUCOF+1  
42             CONTINUE
            GO TO 45
43          DO 44 MCXJ=MCX-1+KOLDEB,MCX-2+LIGNE
               CST(MCXJ)=CST(MCXJ)-CCOEFF*RST(MCUCOF)  
44             MCUCOF=MCUCOF+1 
45          MCX1=MCX1-1
      ELSE
*  
         CALL BAISE('*RsMtL1* Incompatibilite entre le type COMPLEXE de'!Utilite
     *                   //' la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsMtL1*
