*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S P R A L (RANG,LENV,TYPM,MCD,MCM,TYPB,MCB  
     *                                              ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)
* Derniere modification (D.Martin) le 26 Sept. 91
*  
*     Resolution d'un systeme triangulaire superieur L*.X=B  (remontee) 
*     ou la matrice  L  est stockee profil inferieur.
*     L* est la transposee (cas reel) ou l'adjointe (cas complexe) de L
***   Remarque : On suppose dans ce s-p la matrice L inversible
*  
*** Arguments d'entree *** 
* RANG  : Rang de la matrice
* LENV  : Adresse dans la matrice du premier coeff. non nul des ligness 
* TYPM  : type ('REEL' ou 'COMPLEXE') de la matrice
* MCD   : adresse (dans le s-t du bon type) de la diagonale 
* MCM   : adresse (dans le s-t du bon type) de la partie triang. inf.
* TYPB  : type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de la solution X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST: tableau (cas reel ou complexe) contenant la matrice a l'adresse
*          MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,LENV(*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF
*  
      IF(TYPM(1:1).NE.'C') THEN
* 
         CALL RSPRU (RANG,LENV,TYPM,MCD,MCM,TYPB,MCB,TYPX,MCX,RST,CST)  !Syslin
* 
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*
         IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*
         MCX1=MCX-1+RANG
         MCD1=MCD-1+RANG 
         CCOEFF=CST(MCX1)/CONJG(CST(MCD1))
         CST(MCX1)=CCOEFF
         DO 44 I=RANG,2,-1
            IAD=LENV(I-1)
            NBCOEF=IADNXT-IAD
            IF(NBCOEF.GE.I) NBCOEF=I-1
            MCM1=MCM-1+IADNXT
            MCXX=MCX1-NBCOEF
            IADNXT=IAD
            DO 43 MCMM=MCM1-NBCOEF,MCM1-1  
               CST(MCXX)=CST(MCXX)-CCOEFF*CONJG(CST(MCMM))
43             MCXX=MCXX+1
            MCX1=MCX1-1  
            MCD1=MCD1-1  
            CCOEFF=CST(MCX1)/CONJG(CST(MCD1))
44          CST(MCX1)=CCOEFF
      ELSE
         CALL BAISE(' *RsPrAL* Incompatibilite entre le type COMPLEXE '
     *                //' de la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsPrAL* 
