*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S P R A U (RANG,UENV,TYPM,MCD,MCM,TYPB,MCB  
     *                                              ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 91)
* Derniere modification (D.Martin) le 26 Sept. 91
*  
*     Resolution d'un systeme triangulaire inferieur U*.X=B  (descente) 
*     ou la matrice  U  est stockee profil superieur.
*     U* est la transposee (cas reel) ou l'adjointe (cas complexe) de U
***   Remarque : On suppose dans ce s-p la matrice U inversible
*  
*** Arguments d'entree *** 
* RANG  : Rang de la matrice 
* UENV  : Adresse dans la matrice du premier coeff. non nul des colonnes
* TYPM  : type ('REEL' ou 'COMPLEXE') de Ula matrice
* MCD   : adresse (dans le s-t du bon type) de la diagonale
* MCM   : adresse (dans le s-t du bon type) de la partie triang. sup.
* TYPB  : type ('REEL' ou 'COMPLEXE') de B 
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST: tableau (cas reel ou complexe) contenant la matrice a l'adresse
*          MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,UENV(*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
*  
      IF(TYPM(1:1).NE.'C') THEN
* 
         CALL RSPRL (RANG,UENV,TYPM,MCD,MCM,TYPB,MCB,TYPX,MCX,RST,CST)  !Syslin
 
      ELSE IF(TYPX(1:1).EQ.'C') THEN
*
         IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*
         MCX1=MCX+1
         MCD1=MCD+1
         IAD=UENV(1)
         CST(MCX)=CST(MCX)/CONJG(CST(MCD))  
         DO 44 I=2,RANG
            MCM1=MCM-1+IAD
            IADNXT=UENV(I) 
            CCOEFF=0.
            DO 41 MCXX=MCX1-MIN(IADNXT-IAD,I-1),MCX1-1 
               CCOEFF=CCOEFF+CONJG(CST(MCM1))*CST(MCXX) 
41             MCM1=MCM1+1
            CST(MCX1)=(CST(MCX1)-CCOEFF)/CONJG(CST(MCD1))
            MCD1=MCD1+1  
            MCX1=MCX1+1
44          IAD=IADNXT
      ELSE
         CALL BAISE(' *RsPrAU* Incompatibilite entre le type COMPLEXE '
     *                //' de la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsPrAU*
