*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSPRL  (RANG,LENV,TYPM,MCD,MCM,TYPB,MCB
     &                  ,TYPX,MCX,RST,CST)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : A.S.Bonnet (Septembre 1989) + D.Martin (Juin 1991)
* Derniere modification : D.Martin (27 Fevrier 1999)
*  
* Resolution d'un systeme triangulaire inferieur L.X=B  (descente)
* ou la matrice L est stockee profil.
* Remarque : On suppose dans ce s-p la matrice L inversible.
*  
*-- Arguments d'entree --
* RANG rang de la matrice
* LENV adresses dans la matrice du premier coefficient non nul des lignes
* TYPM type ('REEL' ou 'COMPLEXE') de la matrice
* MCD  adresse (dans le s-t du bon type) de la diagonale de la matrice
* MCM  adresse (dans le s-t du bon type) de la partie triangulaire inferieure
* TYPB type ('REEL' ou 'COMPLEXE')  du second membre B
* MCB  dresse (dans le s-t du bon type) du second membre B
* TYPX type ('REEL' ou 'COMPLEXE') de la solution X
* MCX  adresse (dans le s-t du bon type) de la solution X
*      MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse
*         MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX
      INTEGER       RANG,LENV(*),MCD,MCM,MCB,MCX
      REAL          RST(*)
      COMPLEX       CST(*)
*
      INTEGER       MCD1,MCX1,MCXX,MCM1,MCMM,IAD,IADNXT,NBCOEF,IST
      REAL          RCOEFF
      COMPLEX       CCOEFF
*-----------------------------------------------------------------------
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     &   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      MCD1=MCD+1
      MCX1=MCX+1
      IAD=LENV(1)
      IF(TYPM(1:1).EQ.TYPX(1:1)) THEN
         IF(TYPM(1:1).EQ.'R') THEN
           RST(MCX)=RST(MCX)/RST(MCD)
           DO 22 I=2,RANG
              RCOEFF=0.
              IADNXT=LENV(I)
              NBCOEF=IADNXT-IAD
*             L'instruction incongrue suivante permet la resolution
*             d'un sous-systeme (cf. s-p de factorisation LUpr ou LLTpr)
              IF(NBCOEF.GE.I) NBCOEF=I-1
              MCM1=MCM-1+IADNXT
              MCXX=MCX1-NBCOEF
              DO 21 MCMM=MCM1-NBCOEF,MCM1-1
                 RCOEFF=RCOEFF+RST(MCMM)*RST(MCXX)
21               MCXX=MCXX+1
              RST(MCXX)=(RST(MCXX)-RCOEFF)/RST(MCD1)
              MCD1=MCD1+1
              MCX1=MCX1+1
              IAD=IADNXT
22         CONTINUE
         ELSE
           CST(MCX)=CST(MCX)/CST(MCD)
           DO 44 I=2,RANG
              CCOEFF=0.
              IADNXT=LENV(I)
              NBCOEF=IADNXT-IAD
              IF(NBCOEF.GE.I) NBCOEF=I-1
              MCM1=MCM-1+IADNXT
              MCXX=MCX1-NBCOEF
              DO 43 MCMM=MCM1-NBCOEF,MCM1-1
                 CCOEFF=CCOEFF+CST(MCMM)*CST(MCXX)
43               MCXX=MCXX+1
              CST(MCXX)=(CST(MCXX)-CCOEFF)/CST(MCD1)
              MCD1=MCD1+1
              MCX1=MCX1+1
              IAD=IADNXT
44         CONTINUE   
         ENDIF
      ELSEIF (TYPM(1:1).EQ.'R') THEN 
         CST(MCX)=CST(MCX)/RST(MCD)
         DO 24 I=2,RANG
            CCOEFF=0.
            IADNXT=LENV(I)
            NBCOEF=IADNXT-IAD
            IF(NBCOEF.GE.I) NBCOEF=I-1
            MCM1=MCM-1+IADNXT
            MCXX=MCX1-NBCOEF
            DO 23 MCMM=MCM1-NBCOEF,MCM1-1
               CCOEFF=CCOEFF+RST(MCMM)*CST(MCXX)
23             MCXX=MCXX+1
            CST(MCXX)=(CST(MCXX)-CCOEFF)/RST(MCD1)
            MCD1=MCD1+1
            MCX1=MCX1+1
            IAD=IADNXT
24       CONTINUE
      ELSE 
         CALL BAISE  ('*RsPrL* Incompatibilite entre le type COMPLEXE'
     &              //' de la matrice et le type REEL de la solution')
      ENDIF
                                                                    END !RsPrL
