*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S P R L 1 (RANG,LENV,TYPM,MCM,TYPB,MCB  
     *                                          ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : A.S.Bonnet (Sep.89) + D.Martin (Juin 91)
* Derniere modification (D.Martin) le 26 Sept. 91
*  
*     Resolution d'un systeme triangulaire inferieur L.X=B  (descente) 
*     ou la matrice a diagonale unite  L  est stockee profil 
*  
*** Arguments d'entree *** 
* RANG  : Rang de la matrice 
* LENV  : Adresse dans la matrice du premier coeff. non nul des lignes
* TYPM  : type ('REEL' ou 'COMPLEXE') de la matrice
* MCM   : adresse (dans le s-t du bon type) de la partie triang. inf.
* TYPB  : type ('REEL' ou 'COMPLEXE') de B 
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST: tableau (cas reel ou complexe) contenant la matrice a l'adresse
*          MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,LENV(*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*  
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      MCX1=MCX+1
      IAD=LENV(1)
      IF(TYPM(1:1).EQ.TYPX(1:1)) THEN  
         IF(TYPM(1:1).EQ.'R') THEN  
           DO 22 I=2,RANG
              RCOEFF=0.
              IADNXT=LENV(I)
              NBCOEF=IADNXT-IAD
              IF(NBCOEF.GE.I) NBCOEF=I-1
*             L'instruction incongrue suivante permet la resolution
*             d'un sous-systeme, cf. s-p de factorisation FALU ou FALLT
              MCM1=MCM-1+IADNXT
              MCXX=MCX1-NBCOEF
              IAD=IADNXT
              DO 21 MCMM=MCM1-NBCOEF,MCM1-1
                 RCOEFF=RCOEFF+RST(MCMM)*RST(MCXX)
21               MCXX=MCXX+1
              RST(MCXX)=RST(MCXX)-RCOEFF
22            MCX1=MCX1+1 
         ELSE
           DO 44 I=2,RANG
              CCOEFF=0.
              IADNXT=LENV(I)
              NBCOEF=IADNXT-IAD
              IF(NBCOEF.GE.I) NBCOEF=I-1
              MCM1=MCM-1+IADNXT
              MCXX=MCX1-NBCOEF
              IAD=IADNXT
              DO 43 MCMM=MCM1-NBCOEF,MCM1-1
                 CCOEFF=CCOEFF+CST(MCMM)*CST(MCXX)
43               MCXX=MCXX+1
              CST(MCXX)=CST(MCXX)-CCOEFF
44            MCX1=MCX1+1
         END IF
      ELSE IF(TYPM(1:1).EQ.'R') THEN
           DO 24 I=2,RANG
              CCOEFF=0.
              IADNXT=LENV(I)
              NBCOEF=IADNXT-IAD
              IF(NBCOEF.GE.I) NBCOEF=I-1
              MCM1=MCM-1+IADNXT
              MCXX=MCX1-NBCOEF
              IAD=IADNXT
              DO 23 MCMM=MCM1-NBCOEF,MCM1-1
                 CCOEFF=CCOEFF+RST(MCMM)*CST(MCXX)
23               MCXX=MCXX+1
              CST(MCXX)=CST(MCXX)-CCOEFF
24            MCX1=MCX1+1  
      ELSE 
         CALL BAISE('*RsPrL1* Incompatibilite entre le type COMPLEXE de'
     *                  //' la matrice et le type REEL de la solution')
      END IF
                                                                    END *RsPrL1*
