*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RSPRU (RANG,UENV,TYPM,MCD,MCM
     &                 ,TYPB,MCB,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)
* Derniere modification : D.Martin (27 Mai 1999)
*  
* Resolution d'un systeme triangulaire superieur U.X=B  (remontee)
* ou la matrice U a diagonale unite est stockee profil superieur 
*-Remarque : On suppose dans ce s-p la matrice U inversible;
*            aucun test de division par 0 n'est donc effectue.
*  
*-- Arguments d'entree -- 
* RANG  rang de la matrice
* UENV  tableau des adresses dans la partie triangulaire superieure stricte
*       du premier coefficient non nul de chaque colonne 
* TYPM  type ('REEL' ou 'COMPLEXE') de la matrice
* MCD   adresse de la diagonale de la matrice
* MCM   adresse de la partie triangulaire superieure stricte
* TYPB  type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   adresse du second membre B 
* TYPX  type de la solution X 
* MCX   adresse de la solution X (MCX peut etre egal a MCB)
* RST,CST tableau (cas reel ou complexe) contenant la matrice a l'adresse MCM,
*         le 2nd membre a l'adresse MCB et la solution a l'adresse MCX 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,UENV(*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*-----------------------------------------------------------------------
      IF (MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     &   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
* 
      MCX1=MCX-1+RANG
      MCD1=MCD-1+RANG
      IADNXT=UENV(RANG)
      IF (TYPM(1:1).EQ.TYPX(1:1)) THEN  
         IF (TYPM(1:1).EQ.'R') THEN
            RCOEFF=RST(MCX1)/RST(MCD1)
            RST(MCX1)=RCOEFF
            DO 22 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF (NBCOEF.GE.I) NBCOEF=I-1
*              L'instruction incongrue suivante permet la resolution
*              d'un sous-systeme.
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 21 MCMU=MCM1-NBCOEF,MCM1-1  
                  RST(MCXX)=RST(MCXX)-RST(MCMU)*RCOEFF
21                MCXX=MCXX+1
               MCX1=MCX1-1  
               MCD1=MCD1-1  
               RCOEFF=RST(MCX1)/RST(MCD1)
22             RST(MCX1)=RCOEFF
         ELSE
            CCOEFF=CST(MCX1)/CST(MCD1)
            CST(MCX1)=CCOEFF
            DO 44 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF (NBCOEF.GE.I) NBCOEF=I-1
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 43 MCMU=MCM1-NBCOEF,MCM1-1  
                  CST(MCXX)=CST(MCXX)-CST(MCMU)*CCOEFF
43                MCXX=MCXX+1
               MCX1=MCX1-1  
               MCD1=MCD1-1  
               CCOEFF=CST(MCX1)/CST(MCD1)
44             CST(MCX1)=CCOEFF
         ENDIF
      ELSEIF (TYPM(1:1).EQ.'R') THEN
            CCOEFF=CST(MCX1)/RST(MCD1)
            CST(MCX1)=CCOEFF
            DO 42 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF (NBCOEF.GE.I) NBCOEF=I-1
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 41 MCMU=MCM1-NBCOEF,MCM1-1  
                  CST(MCXX)=CST(MCXX)-RST(MCMU)*CCOEFF
41                MCXX=MCXX+1
               MCX1=MCX1-1  
               MCD1=MCD1-1  
               CCOEFF=CST(MCX1)/RST(MCD1)
42             CST(MCX1)=CCOEFF
      ELSE
         CALL BAISE  ('*RsPrU* Incompatibilite entre le type COMPLEXE '
     &              //'de la matrice et le type REEL de la solution')
      ENDIF 
                                                                    END !RsPrU 
