*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE R S P R U 1 (RANG,UENV,TYPM,MCM,TYPB,MCB  
     *                                          ,TYPX,MCX,RST,CST)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : A-S.Bonnet (Sept.89) + D.Martin (Juin 91)
* Derniere modification (D.Martin) le 26 Sept. 91
*  
*     Resolution d'un systeme triangulaire superieur U1.X=B  (remontee) 
*     ou la matrice  U1 a diagonale unite est stockee profil superieur
*  
*** Arguments d'entree *** 
* RANG  : Rang de la matrice
* UENV  : Adresse dans la matrice du premier coeff. non nul des colonnes 
* TYPM  : type ('REEL' ou 'COMPLEXE') de la matrice 
* MCM   : adresse (dans le s-t du bon type) de la partie triang. sup.
* TYPB  : type ('REEL' ou 'COMPLEXE') du second membre B
* MCB   : adresse (dans le s-t du bon type) du second membre B 
* TYPX  : type ('REEL' ou 'COMPLEXE') de la solution X 
* MCX   : adresse (dans le s-t du bon type) de la solution X
*         MCX peut etre egal a MCB (auquel cas on doit avoir TYPX=TYPB)
* RST,CST: tableau (cas reel ou complexe) contenant la matrice a l'adresse
*          MCM,le 2nd membre a l'adresse MCB et la solution a l'adresse MCX 
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPM,TYPB,TYPX 
      INTEGER       RANG,UENV(*),IST
      REAL          RST(*) 
      COMPLEX       CST(*),CCOEFF  
      EQUIVALENCE  (CCOEFF,RCOEFF) 
*  
      IF(MCX.NE.MCB.OR.TYPX(1:1).NE.TYPB(1:1)) 
     *   CALL TDANST(RANG,TYPB,MCB,IST,RST,CST,TYPX,MCX,IST,RST,CST)    !Utilite
*  
      MCX1=MCX+RANG-1
      IADNXT=UENV(RANG)
      IF(TYPM(1:1).EQ.TYPX(1:1)) THEN  
         IF(TYPM(1:1).EQ.'R') THEN 
            RCOEFF=RST(MCX1)
            DO 22 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF(NBCOEF.GE.I) NBCOEF=I-1
*              L'instruction incongrue suivante permet la resolution
*              d'un sous-systeme.
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 21 MCMM=MCM1-NBCOEF,MCM1-1  
                  RST(MCXX)=RST(MCXX)-RST(MCMM)*RCOEFF
21                MCXX=MCXX+1
               MCX1=MCX1-1
22             RCOEFF=RST(MCX1)
         ELSE
            CCOEFF=CST(MCX1)
            DO 44 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF(NBCOEF.GE.I) NBCOEF=I-1
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 43 MCMM=MCM1-NBCOEF,MCM1-1  
                  CST(MCXX)=CST(MCXX)-CST(MCMM)*CCOEFF
43                MCXX=MCXX+1
               MCX1=MCX1-1  
44             CCOEFF=CST(MCX1)
         END IF
      ELSE IF(TYPM(1:1).EQ.'R') THEN
            CCOEFF=CST(MCX1)
            DO 42 I=RANG,2,-1
               IAD=UENV(I-1)
               NBCOEF=IADNXT-IAD
               IF(NBCOEF.GE.I) NBCOEF=I-1
               MCM1=MCM-1+IADNXT
               MCXX=MCX1-NBCOEF
               IADNXT=IAD
               DO 41 MCMM=MCM1-NBCOEF,MCM1-1  
                  CST(MCXX)=CST(MCXX)-RST(MCMM)*CCOEFF
41                MCXX=MCXX+1
               MCX1=MCX1-1  
42             CCOEFF=CST(MCX1)
      ELSE 
         CALL BAISE('*RsPrU1* Incompatibilite entre le type COMPLEXE de'!Utilite
     *                   //' la matrice et le type REEL de la solution')!Utilite
      END IF
                                                                    END *RsPrU1* 
