*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SOPREP (NMSCMB,NVSCMB,NBSCMB,TYSCMB,NVDSSC,NVDUSC
     &                  ,NBNESC,NVNUSC,NMSOLU,NVSOLU,TYSOLU,NUINLM
     &                  ,NCPINL,NVDULM,NBNELM,NVNULM,NVCOMA,NIVIMP
     &                  ,NVDSMA,NM2MMB,NV2MMB)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juillet 1991)  
* Derniere modification : D.Martin (11 Janvier 2001)
* Version 1.0.3
*  
* Preparation du second membre d'un systeme lineaire avant resolution
* (changement de numerotation, de type, ...)
*  
*-- Arguments d'entree -- 
* NMSCMB nom du terme 2nd membre du systeme lineaire
* NVSCMB son niveau
* NBSCMB nombre effectif de 2nds membres
* TYSCMB type du 2nd membre (REEL ou COMPLEXE)
* NVDSSC niveau de la structure d'assemblage multi-inconnue du 2nd membre
* NVDUSC niveau du tableau de numerotation #GNEDO en d.l. du 2nd membre
* NBNELM nombre de noeuds du vecteur 2nd membre
* NVNUSC niveau du tableau de numerotation #GNEDO du 2nd membre
* NMSOLU nom du terme solution 
* NVSOLU son niveau
* TYSOLU son type (REEL ou COMPLEXE)
* NUINLM numero de l'inconnue attachee au terme solution
* NCPINL nombre de composante de cette inconnue
* NVDULM niveau du tableau de numerotation en d.l. de la solution
* NBNELM nombre de composantes du vecteur solution
* NVNULM niveau du tableau de numerotation en noeuds de la solution
* NVCOMA niveau du tableau des coordonnees des noeuds pour le vecteur solution
* NIVIMP niveau d'impression du vecteur solution
* NVDSMA niveau de la structure d'assemblage multi-inconnue de la matrice
* NM2MMB nom du terme 2nd membre en sortie si modifie
*        (= NMSCMB, NMSOLU ou '$WORK$' selon le cas)
* NV2MMB son niveau (= NVSCMB, NVSOLU ou 1, cf. ci-dessus)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMSCMB,TYSCMB,NMSOLU,TYSOLU,NM2MMB
      INTEGER       NVSCMB,NBSCMB,NVDSSC,NVDUSC,NBNESC,NVNUSC,NVSOLU
     &             ,NUINLM,NCPINL,NVDULM,NBNELM,NVNULM,NVCOMA,NIVIMP
     &             ,NVDSMA,NV2MMB
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDSTO,INTTYP,INTYKL,KLTERM,KLNIVE
      INTEGER       MCMTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCDTRM,MCNUSC
     &             ,MCNULM,MCSCMB,MC2MMB,MCSOLU,MCASSC,MCASMA,MCNESC
     &             ,MCNELI,NBDLLM,NBDLSC,NCPINC
     &             ,LGETRA,NBSECC,INCTRA,NBSECL,NBMATC,NBMATL,LGRIPP
     &             ,ITSCMB,LGSCMB,ITSOLU,LGSOLU,NVDSSO,ITYCAL,INDSTK
     &             ,NUIMAL,NVNMAL,NUISCL,NVNSCL,LGNUSC,LGNULM,NUTSCL
     &             ,NBNULM,NBNUSC,INCL,NC2MMB
      LOGICAL       CRETRM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*SoPrep*')
      ITSCMB=INTTYP (TYSCMB)                                            !utilite
      ITSOLU=INTTYP (TYSOLU)                                            !utilite
*     Faut-il PREVOIR que NCPINC differe de NCPINL ???
      NCPINC=NCPINL
*  
*     Recherche des longueurs et adresses des structures de description
*     des termes : tableaux #OMTRM et $SDTRM
*
      CALL TBAR2  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
      NC2MMB=NCHTRM
      IF (NMSCMB.EQ.NMSOLU.AND.NVSCMB.EQ.NVSOLU)
     &   CALL ERTERM (9,NMSCMB,NVSCMB)                                  !utilite
*
*--   Mise a jour de la structure $SDTRM pour le terme solution
*
      LGSOLU=NBNELM*NCPINC*NBSCMB
      NVDSSO=NDFDSM
      IF (NVDSMA.NE.NDFDSM.AND.NUINLM.EQ.NDFINC) THEN
*        Cas multi-inconnues
         LGSOLU=NBNELM*NBSCMB
         NVDSSO=KLNIVE ()                                               !sdexplo
      ENDIF
      ITYCAL=INTYKL ('ASSEMB')                                          !utilite
      INDSTK=INDSTO ('PLEIN-L')                                         !utilite
      CRETRM=.FALSE.
      CALL CRTERM (NMSOLU,NVSOLU,LGSOLU,ITSOLU,ITYCAL,-1,NDFDON
     &            ,NCPINC,NVDSSO,NDFINC,NDFDUM,NBSCMB,NDFNUM
     &            ,NUINLM,NVDULM,NBNELM,NVNULM,INDSTK,NDFSTO,NDFCOR,0
     &            ,NIVIMP,.FALSE.,CRETRM)                               !sdexplo
      CALL TBRR1 (ERCODE,NMSCMB,NVSCMB,LGSCMB)
      NM2MMB=NMSCMB
      NV2MMB=NVSCMB
*
      IF (NVDSSO.EQ.NDFDSM) THEN
*
*        Cas d'un systeme lineaire non Multi-inconnues
*
         IF (NVNUSC.NE.NVNULM) THEN
*           Le second membre n'est pas range dans la meme numerotation
*           que les lignes de la matrice, on change sa numerotation pour
*           l'accorder aux lignes de la matrice.
            IF (CRETRM) THEN
*              Si le terme solution a ete cree, on y deposera le second
*              membre renumerote
               NM2MMB=NMSOLU  
               NV2MMB=NVSOLU 
            ELSE
*              Si le terme solution n'a pas eu besoin d'etre recree
*              on cree un tableau de travail pour le second membre renumerote 
               NM2MMB='$WORK$'
               NC2MMB=MAX(6,NCHTRM)
               NV2MMB=1
               CALL TBCREE (NM2MMB(1:NC2MMB),NV2MMB,ITSCMB,LGSOLU,'c')
            ENDIF
*
*           Numerotations en d.l. si necessaire
            NBDLLM=NBNELM
            NBDLSC=NBNESC
            IF (NCPINL.GT.1) THEN
               NBDLLM=NBNELM*NCPINL
               CALL NUM2DL (NCPINL,NVNULM,NVDULM,NBDLLM,NIVIMP)         !sdexplo
               NVNULM=NVDULM
               NBDLSC=NBNESC*NCPINL
               CALL NUM2DL (NCPINL,NVNUSC,NVDUSC,NBDLSC,NIVIMP)         !sdexplo
               NVNUSC=NVDUSC
            ENDIF 
*
            CALL TBRR2  (ERCODE,'#GNEDO',NVNUSC,MCNUSC
     &                         ,'#GNEDO',NVNULM,MCNULM)
            CALL TBAR4  (ERCODE, NMSCMB,NVSCMB,MCSCMB
     &                         ,'#GNEDO',NVNUSC,MCNUSC 
     &                         , NM2MMB(1:NC2MMB),NV2MMB,MC2MMB
     &                         ,'#GNEDO',NVNULM,MCNULM)

            CALL EXNUVC (NBDLSC,IST(MCNUSC+2),TYSCMB,MCSCMB,NBSCMB
     &                  ,NBDLLM,IST(MCNULM+2),TYSCMB,MC2MMB,RST,CST)    !sdexplo
*
            CALL TBRR1  (ERCODE,NM2MMB(1:NC2MMB),NV2MMB,MC2MMB)
            CALL TBSAVE ( NMSCMB ,NVSCMB)
            CALL TBSAVE ('#GNEDO',NVNULM)
            CALL TBSAVE ('#GNEDO',NVNUSC)
         ELSE
*           Cas standard:
*           Dans le cas ou les numerotations en ligne de la matrice et du 
*           second membre coincident, on recopie ce dernier.
            CALL TBAR2  (ERCODE,NMSCMB,NVSCMB,MCSCMB
     &                         ,NMSOLU,NVSOLU,MCSOLU)
            CALL TDANST (LGSCMB,TYSCMB,MCSCMB,IST,RST,CST
     &                         ,TYSOLU,MCSOLU,IST,RST,CST)              !utilite
            NM2MMB=NMSOLU  
            NV2MMB=NVSOLU
            CALL TBSAVE (NMSCMB,NVSCMB)
         ENDIF
*
      ELSE
*
*        Cas multi-inconnues:
*
*        Recherche des structures $DSMBL de niveau NVDSMA (matrice)
*        et NVDSSC (second membre) pour renumeroter la solution
*        selon la numerotation en ligne de la matrice.
         CALL TBRR2  (ERCODE,'$DSMBL',NVDSSC,MCASSC
     &                      ,'$DSMBL',NVDSMA,MCASMA)
         CALL TBAR3  (ERCODE,'$DSMBL',NVDSSC,MCASSC
     &                      ,'$DSMBL',NVDSMA,MCASMA,'$SDTRM',1,MCDTRM)
         CALL SDEXDB (IST(MCASSC),LGETRA,NBSECC,INCTRA,NBSECL)          !utilite
         CALL SDEXDB (IST(MCASMA),LGETRA,NBMATC,INCTRA,NBMATL)          !utilite
*
         IF (NBSECL.NE.NBMATL) CALL BAISE
     &   ('Incoherence dans le systeme lineaire multi-inconnues')       !utilite
*
*        Boucle de preparation des numerotations pour les inconnues en ligne
*
         LGRIPP=LGETRA
         DO 10 INCL=1,NBMATL
            CALL TBAR2  (ERCODE,'$DSMBL',NVDSSC,MCASSC
     &                         ,'$DSMBL',NVDSMA,MCASMA)
*           Inconnues et numerotations en ligne de la matrice
*           et du second membre
            NUIMAL=IST(MCASMA+LGRIPP+2)
            NVNMAL=IST(MCASMA+LGRIPP+4)
            NUISCL=IST(MCASSC+LGRIPP+2)
            NVNSCL=IST(MCASSC+LGRIPP+4)
            IF (NUIMAL.NE.NUISCL) GOTO 99991
*
*           Restauration en memoire centrale des tableaux de numerotations
*
            CALL TBRR1  (ERCODE,'#GNEDO',NVNMAL,MCNELI)
            IF (NVNSCL.NE.NDFNUM.AND.NVNSCL.NE.NVNMAL)
     &         CALL TBRR1  (ERCODE,'#GNEDO',NVNSCL,MCNESC)
            LGRIPP=LGRIPP+INCTRA
10       CONTINUE
*
         IF (.NOT.CRETRM) THEN  
            NM2MMB='$WORK$'
            NC2MMB=MAX(6,NCHTRM)
            NV2MMB=1
            CALL TBCREE (NM2MMB(1:NC2MMB),NV2MMB,ITSOLU,LGSOLU,'c')
         ELSE  
            NM2MMB=NMSOLU  
            NV2MMB=NVSOLU
         ENDIF
*
*        Boucle de changement eventuel de num. sur les inconnues en ligne
*
         LGRIPP=LGETRA
         LGNUSC=0
         LGNULM=0
         DO 20 INCL=1,NBMATL
            CALL TBAR2  (ERCODE,'$DSMBL',NVDSSC,MCASSC
     &                         ,'$DSMBL',NVDSMA,MCASMA)
            NUTSCL=IST(MCASSC+LGRIPP)
            NVNSCL=IST(MCASSC+LGRIPP+4)
            NVNMAL=IST(MCASMA+LGRIPP+4)
            CALL TBAR3  (ERCODE, NMSCMB,NVSCMB,MCSCMB
     &                         ,'#GNEDO',NVNMAL,MCNULM
     &                         , NM2MMB(1:NC2MMB),NV2MMB,MC2MMB)
*
*           Mise a zero de la partie du second membre correspondant
*           a l'inconnue en ligne en cours (de numero NUTSCL)
*
            NBNULM=IST(MCNULM+1)
            CALL TAZERO (NBNULM,TYSOLU,MC2MMB+LGNULM,AST,IST,RST,CST)   !utilite
*
            IF (NUTSCL.NE.0) THEN
               CALL TBAR1  (ERCODE,'#GNEDO',NVNSCL,MCNUSC)
               NBNUSC=IST(MCNUSC+1)
*
               IF (NVNMAL.NE.NVNSCL) THEN
                  CALL EXNUVC (NBNUSC,IST(MCNUSC+2),TYSCMB,MCSCMB+LGNUSC
     &                        ,1,NBNULM,IST(MCNULM+2),TYSOLU
     &                        ,MC2MMB+LGNULM,RST,CST)                   !sdexplo
               ELSE
                  CALL TDANST (NBNUSC,TYSCMB,MCSCMB+LGNUSC,IST,RST,CST
     &                               ,TYSOLU,MC2MMB+LGNULM,IST,RST,CST) !utilite
               ENDIF
               LGNUSC=LGNUSC+NBNUSC
            ELSEIF (NVNSCL.NE.NDFINC) THEN
               CALL TBAR1  (ERCODE,'#GNEDO',NVNSCL,MCNUSC)
               LGNUSC=LGNUSC+IST(MCNUSC+1)
            ENDIF
            LGNULM=LGNULM+NBNULM
            LGRIPP=LGRIPP+INCTRA
20       CONTINUE
*
*        Boucle de sauvegarde des tableaux de numerotations
*
         LGRIPP=LGETRA
         DO 30 INCL=1,NBMATL
            CALL TBAR2  (ERCODE,'$DSMBL',NVDSSC,MCASSC
     &                         ,'$DSMBL',NVDSMA,MCASMA)
            NVNMAL=IST(MCASMA+LGRIPP+4)
            NVNSCL=IST(MCASSC+LGRIPP+4)
            CALL TBSAVE  ('#GNEDO',NVNMAL)
            IF (NVNSCL.NE.NDFNUM.AND.NVNSCL.NE.NVNMAL)
     &         CALL TBSAVE  ('#GNEDO',NVNSCL)
            LGRIPP=LGRIPP+INCTRA
30       CONTINUE
*
*        Creation de la structure $DSMBL pour le resultat.
*        On recopie les attributs liee aux colonnes de la matrice 
*        mais en ligne pour le resultat
*
         CALL MKSDDS (NVDSMA,'C',0,0,0,0,0,0,NVDSSO)                    !sdexplo

*        Impression de la structure d'assemblage
         IF (NIVIMP.GT.0) THEN
            CALL PRSDDS (NVDSSO,NMSOLU,NVSOLU,NIVIMP,IMPSDR)            !prsd
         ENDIF
         CALL TBSAVE ('$DSMBL',NVDSSC)
         CALL TBSAVE ('$DSMBL',NVDSMA)
         CALL TBSAVE ('$DSMBL',NVDSSO)
      ENDIF
*
      CALL PRFXMJ (-1,'*SoPrep*')
      RETURN 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 WRITE (IMPPAL,89991) INCL,NUIMAL,NUISCL
89991 FORMAT(/' Ligne',I5,', Inconnue en ligne de la matrice',I5
     &                   ,', Inconnue en ligne du second membre',I5)
      CALL BAISE  ('Incoherence sur les inconnues en ligne de la matrice
     & et du second membre multi-inconnues')
                                                                    END !SoPrep
