*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE SYPREP (NMMATM,NVMATM,NMSCMB,NVSCMB,NMMATP,NVMATP
     &                  ,TYMATM,ITSYMM,NVDSMA,NUINLM,NCPILM,NVDULM
     &                  ,NBNELM,NVNULM,INDSTM,NVSTOM,NVCOOM,TYSCMB
     &                  ,NVDSSC,NVDUSL,NBNESL,NVNUSL,TYMATP,ITFACT
     &                  ,NUFACT,INSTOP,NVSTOP,NBLIGN)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1991)
* Derniere modification : D.Martin (3 novembre 2008)
* Version 2
*  
* Recherche des caracteristiques de la matrice et du second membre, et le
* cas echeant de la matrice de preconditionnement, prealablement a la
* resolution par une methode de gradient avec ou sans preconditionnement.
*  
*-- Arguments d'entree -- 
* NMMATM nom du tableau contenant la matrice du systeme
* NVMATM son niveau
* NMSCMB nom du tableau contenant le second membre
* NVSCMB son niveau
* NMMATP nom de la matrice de preconditionnement factorisee
* NVMATP son niveau
*-- Arguments de sortie --
* TYMATM type (reel ou complexe) de la matrice du systeme
* ITSYMM indice de symetrie de la matrice
* NVDSMA tableau d'assemblage multi-inconnues de la matrice (le cas echeant)
* NUINLM numero de l'inconnue en ligne de la matrice
* NCPILM nombre de composante de cette inconnue
* NVDULM niveau de la structure de numerotation en dl en ligne de la matrice
* NBNELM nombre de noeuds en ligne de la numerotation en ligne de la matrice
* NVNULM niveau de la structure de numerotation en noeuds ligne de la matrice
* INDSTM indice de stockage de la matrice du systeme
* NVSTOM niveau du tableau de stockage de la matrice
* NVCOOM niveau du tableau des coordonnees des noeuds (inutilise)
* TYSCMB type du second membre du systeme
* NVDSSC tableau d'assemblage multi-inconnues du 2nd membre (le cas echeant)
* NVDUSL niveau de la structure de numerotation en dl. du second membre
* NBNESL nombre de noeuds du second membre
* NVNUSL niveau de la structure de numerotation en noeuds du second membre
* TYMATP type de la matrice de preconditionnement
* ITFACT numero de type de calcul de la matrice (de preconditionnement)
* NUFACT numero de type (de factorisation) de la matrice (de preconditionnement)
* INSTOP numero de type de stockage de la matrice de preconditionnement
* NVSTOP niveau du tableau de stockage de la matrice de preconditionnement
* NBLIGN rang du systeme
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMMATM,TYMATM,NMSCMB,TYSCMB,NMMATP,TYMATP
      INTEGER       NVMATM,NVSCMB,NVMATP,ITSYMM,NVDSMA,NUINLM,NCPILM
     &             ,NVDULM,NBNELM,NVNULM,INDSTM,NVSTOM,NVCOOM,NVDSSC
     &             ,NVDUSL,NBNESL,NVNUSL,ITFACT,NUFACT,INSTOP,NVSTOP
     &             ,NBLIGN
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INDSTO,INTTYP,KLTERM
      INTEGER       MCMTRM,MCDTRM,MCINCO,LGETRM,NBTERM,INCTRM,NCHTRM
     &             ,NUTERM,ADTERM,NCPICM,INTERP,NBTNEU
     &             ,NVVMAT,ITMATM,NUDONN,NUINCM,NVDUCM,NBNECM,NVNUCM
     &             ,IATRDO,NIVIMP
     &             ,ITSCMB,ITYCSC,NUKASC,NVALNE,NUINSC,NVDUSC,NBNESC
     &             ,NVNUSC,NUINSL,NVCOOR,INSTOK,NVSTOK,NCPINV,MCDSMB
     &             ,ITSYMP,NVDSMP,NUINCP,NVDUCP,NBNECP,NVNUCP,NUINLP
     &             ,NVDULP,NBNELP,NVNULP,ITMATP,NCPIPC,NCPIPL
     &             ,NVINUT,NCATR1,NCATR2,INDSBI,INDSPR,INDSPL
      CHARACTER     ERCODE*120,TYPINT*8,MULTIM*1
      CHARACTER     YANDLC,YANDLL,YANDLV,YANDLE,YANDPC,YANDPL
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*SyPrep*')
      INDSBI=INDSTO ('BIMORSE')                                         !utilite
      INDSPR=INDSTO ('PROFIL')                                          !utilite
      INDSPL=INDSTO ('PLEIN-L')                                         !utilite
*  
*     Recherche des adresses des structures de description des termes :
*     tableaux #INCONU, #OMTRM et $SDTRM
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*
*--   Recherche des attributs de la matrice NMMATM 
*
      NUTERM=KLTERM (NMMATM,NVMATM,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATM,NVMATM)                    !utilite
      ADTERM=LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(MCDTRM+ADTERM),NVVMAT
     &            ,ITMATM,ITFACT,NUFACT,NUDONN,ITSYMM,NVDSMA
     &            ,NUINCM,NVDUCM,NBNECM,NVNUCM
     &            ,NUINLM,NVDULM,NBNELM,NVNULM
     &            ,INDSTM,NVSTOM,NVCOOM,IATRDO,NIVIMP)                  !sdexplo
      MULTIM='N'
      IF (NVDSMA.NE.NDFDSM.AND.NUINCM.EQ.NDFINC.AND.NUINLM.EQ.NDFINC) 
     &   MULTIM='Y'
*
      TYMATM=TYPINT (ITMATM)                                            !utilite
      NCPICM=1
      NCPILM=1
      IF (MULTIM.EQ.'N') THEN
         CALL SDEXCO (NUINCM,IST(MCINCO),NCPICM,INTERP,NBTNEU)          !sdexplo
         NCPILM=NCPICM
         IF (NUINLM.NE.NUINCM) 
     &      CALL SDEXCO (NUINLM,IST(MCINCO),NCPILM,INTERP,NBTNEU)       !sdexplo
         IF (NBNECM.NE.NBNELM) CALL ERTERM (11,NMMATM,NVMATM)           !utilite
         IF (NCPICM.NE.NCPILM) CALL ERTERM (16,NMMATM,NVMATM)           !utilite
         NBLIGN=NCPILM*NBNELM
*
         CALL FONUDL (NCPICM,NCPILM,NVNUCM,NVNULM,0,0,0,0
     &               ,NVDUCM,NVDULM,YANDLC,YANDLL)                      !sdexplo
         IF (YANDLC.NE.'N'.OR.YANDLL.NE.'N') 
     &   CALL PUTTRM (IST(MCDTRM+ADTERM),NVVMAT,ITMATM,ITFACT,NUFACT
     &               ,NUDONN,ITSYMM,NVDSMA,NUINCM,NVDUCM,NBNECM
     &               ,NVNUCM,NUINLM,NVDULM,NBNELM,NVNULM,INDSTM
     &               ,NVSTOM,NVCOOM,IATRDO,NIVIMP)                      !sdexplo
         NVDSMA=NDFDSM
      ELSE
*        Cas "multi-inconnue".
         CALL TBRR1  (ERCODE,'$DSMBL',NVDSMA,MCDSMB)
         CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                      ,'#NCONU',1,MCINCO)
         NBLIGN=NBNELM
      ENDIF
*  
*--   Recherche des attributs du second membre NMSCMB
*
      NUTERM=KLTERM (NMSCMB,NVSCMB,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMSCMB,NVSCMB)                    !utilite
      ADTERM=LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(MCDTRM+ADTERM),NVVMAT
     &            ,ITSCMB,ITYCSC,NUKASC,NUDONN,NVALNE,NVDSSC
     &            ,NUINSC,NVDUSC,NBNESC,NVNUSC
     &            ,NUINSL,NVDUSL,NBNESL,NVNUSL
     &            ,INSTOK,NVSTOK,NVCOOR,IATRDO,NIVIMP)                  !sdexplo
      IF (NUINSL.EQ.NDFINC) THEN
          NUINSL=NUINSC
          NVDUSL=NVDUSC
          NBNESL=NBNESC
          NVNUSL=NVNUSC
      ENDIF
      TYSCMB=TYPINT (ITSCMB)                                            !utilite
      NCPINV=1
      IF (MULTIM.EQ.'N') THEN
         CALL SDEXCO (NUINSL,IST(MCINCO),NCPINV,INTERP,NBTNEU)          !sdexplo
         IF (NCPINV.NE.NCPILM) GOTO 99992
*
         CALL FONUDL (1,NCPILM,NVNUCM,NVNUSL,NVNUCM,NVNULM,NVDUCM,NVDULM
     &               ,NVINUT,NVDUSL,YANDLE,YANDLV)
         IF (YANDLV.NE.'N')
     &   CALL PUTTRM (IST(MCDTRM+ADTERM),NVVMAT
     &               ,ITSCMB,ITYCSC,NUKASC,NUDONN,NVALNE,NVDSSC
     &               ,NDFINC,NDFDUM,1,NDFNUM
     &               ,NUINSL,NVDUSL,NBNESL,NVNUSL     
     &               ,INDSPL,NDFSTO,NVCOOR,IATRDO,NIVIMP)               !sdexplo
         NVDSSC=NDFDSM
      ENDIF
*  
*--   Recherche des attributs de la matrice de preconditionnement NMMATP
*
      ITMATP=INTTYP ('REEL')                                            !utilite
      INSTOP=0
      NVSTOP=0
      NCPIPC=1
      NCPIPL=1
      IF (NMMATP(1:1).NE.' ') THEN
         NUTERM=KLTERM (NMMATP,NVMATP,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.LE.0) CALL ERTERM (1,NMMATP,NVMATP)                 !utilite
         ADTERM=LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(MCDTRM+ADTERM)  ,NVVMAT,ITMATP,ITFACT,NUFACT 
     &               ,NUDONN,ITSYMP,NVDSMP,NUINCP,NVDUCP,NBNECP,NVNUCP
     &               ,NUINLP,NVDULP,NBNELP,NVNULP,INSTOP,NVSTOP,NVCOOR
     &               ,IATRDO,NIVIMP)                                    !sdexplo
         IF (NBNECP.NE.NBNELP) CALL ERTERM (11,NMMATP,NVMATP)           !utilite
         IF (NBNECM.NE.NBNECP) GOTO 99993
         IF (MULTIM.EQ.'N') THEN
            CALL SDEXCO (NUINCP,IST(MCINCO),NCPIPC,INTERP,NBTNEU)       !sdexplo
            CALL SDEXCO (NUINLP,IST(MCINCO),NCPIPL,INTERP,NBTNEU)       !sdexplo
            IF (NCPIPC.NE.NCPIPL) CALL ERTERM (16,NMMATM,NVMATM)        !utilite
            IF (NCPIPL.NE.NCPILM) GOTO 99991
            CALL FONUDL (NCPIPC,NCPIPL,NVNUCP,NVNULP,NVNUCM,NVNULM
     &                  ,NVDUCM,NVDULM,NVDUCP,NVDULP,YANDPC,YANDPL)     !sdexplo
            IF (YANDPC.NE.'N'.OR.YANDPL.NE.'N')
     &      CALL PUTTRM (IST(MCDTRM+ADTERM),NVVMAT,ITMATP,ITFACT,NUFACT
     &                  ,NUDONN,ITSYMP,NVDSMP,NUINCP,NVDUCP,NBNECP
     &                  ,NVNUCP,NUINLP,NVDULP,NBNELP,NVNULP,INSTOP
     &                  ,NVSTOP,NVCOOR,IATRDO,NIVIMP)                   !sdexplo
         ENDIF
      ENDIF
      TYMATP=TYPINT (ITMATP)                                            !utilite
*
      IF (NCPILM.GT.1) THEN
*
*--      Stockage de la matrice NMMATM pour inconnue vectorielle
*
         IF (INDSTM.EQ.INDSBI) THEN
            CALL BMO2DL (NVSTOM,NCPILM,NCPILM,ITSYMM,NMMATM,NVMATM
     &                  ,NIVIMP)                                        !sdexplo
         ELSEIF (INDSTM.EQ.INDSPR) THEN
            CALL PRO2DL (NVSTOM,NCPILM,NCPILM,ITSYMM,NMMATM,NVMATM
     &                  ,NIVIMP)                                        !sdexplo
         ELSE
            CALL ERTERM (18,NMMATM,NVMATM)                              !utilite
         ENDIF
      ENDIF
*
      IF (NMMATP(1:1).NE.' '.AND.NCPIPL.GT.1) THEN
*
*--      Stockage de la matrice de preconditionnement pour inconnue vectorielle
*
         IF (INSTOP.EQ.INDSBI) THEN
            CALL BMO2DL (NVSTOP,NCPIPL,NCPIPL,ITSYMP,NMMATP,NVMATP
     &                  ,NIVIMP)                                        !sdexplo
         ELSEIF (INSTOP.EQ.INDSPR) THEN
            CALL PRO2DL (NVSTOP,NCPIPL,NCPIPL,ITSYMP,NMMATP,NVMATP
     &                  ,NIVIMP)                                        !sdexplo
         ELSE
            CALL ERTERM (18,NMMATP,NVMATP)                              !utilite
         ENDIF
      ENDIF
*
      CALL PRFXMJ (-1,'*SyPrep*')
      RETURN
*-----------------------------------------------------------------------
99991 CALL PRNTRM (NMMATM,NVMATM,ERCODE,NCATR1)
      CALL PRNTRM (NMMATP,NVMATP,ERCODE(NCATR1:),NCATR2)
      CALL BAISE  (' Incompatibilite entre les inconnues de la matrice ' 
     &//' du systeme : '//ERCODE(1:NCATR1)
     &//' et la matrice de preconditionnement:' 
     &//ERCODE(NCATR1+1:NCATR1+NCATR2))
99992 CALL PRNTRM (NMMATM,NVMATM,ERCODE,NCATR1)
      CALL BAISE  (' Matrice '//ERCODE(1:NCATR1)
     &//', incompatibilite avec l''inconnue du second membre.')
99993 CALL PRNTRM (NMMATM,NVMATM,ERCODE,NCATR1)
      CALL PRNTRM (NMMATP,NVMATP,ERCODE(NCATR1:),NCATR2)
      CALL BAISE  (' Incompatibilite entre les rangs de la matrice du '
     &//'systeme : '//ERCODE(1:NCATR1)
     &//' et la matrice de preconditionnement :'
     &//ERCODE(NCATR1+1:NCATR1+NCATR2))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (03 novembre 2008)
*  rajout d'un test maintenant necessaire concernant les tables de stockage de 
* la matrice de preconditionnement
* Version 1.0.2 : D.Martin (4 Avril 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !SyPrep
