/*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  cdate : return day,month,year,hour,minute,seconds as integers
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Author : P.Gentil (December 1998)  
  Last Update : P.Gentil & D.Martin (26 September 2000)
  Version 1.0.0
 
  Called in Utiliter/Horoda
*/

#include<time.h>

#ifdef C_NO_TRAILING_UNDERSCORE
/*
  xlf (IBM compiler) version : AIX-IBM / Mac OS X-Darwin
*/
void cdate (int *day, int *month, int *year, int *hour, int *min, int *sec)
#else
/* 
  g77 (GNU compiler) : Darwin (MacOSX) / Linux / SunOS ...
  f77 (native compiler) SunOS / OSF1-DEC / IRIX-SGI
*/
void cdate_ (int *day, int *month, int *year, int *hour, int *min, int *sec)
#endif
{
   struct tm *date_heure;
   long temps;
   
   (void) time(&temps);  
   date_heure = localtime(&temps);

   *day   = date_heure->tm_mday;
   *month = date_heure->tm_mon+1;
   *year  = date_heure->tm_year+1900;
   *hour  = date_heure->tm_hour;
   *min   = date_heure->tm_min;
   *sec   = date_heure->tm_sec;
}

