/*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  climit : returns some 'limits.h' & 'float.h' machine constants
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Author : Y.Lafranche (Octobre 2001)
  Last Update : D.Martin (1er Octobre 2001)
  Version 1.0.0

 Called in Utiliter/Osinit
*/

#include <limits.h>
#include <float.h>

#ifdef C_NO_TRAILING_UNDERSCORE
/*
  xlf (IBM compiler) version : AIX-IBM / Mac OS X-Darwin
*/
void climit (int *intmin, float *fltmin, double *dblmin,
             int *intmax, float *fltmax, double *dblmax,
             float *flteps, double *dbleps)
#else
/* 
  g77 (GNU compiler) : Darwin (MacOSX) / Linux / SunOS ...
  f77 (native compiler) SunOS / OSF1-DEC / IRIX-SGI
*/
void climit_(int *intmin, float *fltmin, double *dblmin,
             int *intmax, float *fltmax, double *dblmax,
             float *flteps, double *dbleps)
#endif

{
        *intmin = INT_MIN;
        *intmax = INT_MAX;
        *fltmin = FLT_MIN;
        *fltmax = FLT_MAX;
        *dblmin = DBL_MIN;
        *dblmax = DBL_MAX;
        *flteps = FLT_EPSILON;
        *dbleps = DBL_EPSILON;
}
