/*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  ctemps : returns time elapsed since 01/01/1970 00:00 TU as a float
           (precision = 1 microseconde)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  Author : P.Gentil (December 1998)  
  Derniere modification : P.Gentil & D.Martin (26 September 2000)
  Version 1.0.0

  Called in Utiliter/Chrono
*/

#include<sys/time.h>

#ifdef C_NO_TRAILING_UNDERSCORE
/*
  xlf (IBM compiler) version : AIX-IBM / Mac OS X-Darwin
*/
void ctemps (double *t)
#else
/* 
  g77 (GNU compiler) : Darwin (MacOSX) / Linux / SunOS ...
  f77 (native compiler) SunOS / OSF1-DEC / IRIX-SGI
*/
void ctemps_ (double *t)
#endif

{
  struct timeval date_heure;
  long s,m;   
  gettimeofday(&date_heure, (struct timezone *) 0) ;

  s=date_heure.tv_sec;
  m=date_heure.tv_usec;
  *t=(double)s + 1.0E-6*(double)m;
}

