*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DICCHN (IDBCHN,IFNCHN,NBCCHN,TBCHEN,CHAINE,NUCHEN
     &                  ,NBIDEM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1989)  
* Derniere modification : D.Martin (27 janvier 2006)
* Version 2 (pour gfortran)
* Precedente modification (D.Martin) le 6 Decembre 1996
*  
* Recherche dichotomique du rang d'une chaine de caracteres dans un tableau
* de tableaux de caracteres de longueur constante assimiles a des chaines  
* et ranges dans l'ordre defini par le code ASCII.
*  
*-- Arguments d'entree (non modifies) -- 
* IDBCHN adresse (en nb. de ss-tableaux) initiale dans le tableau 
* IFNCHN adresse finale de recherche dans le tableau  
* NBCCHN nombre de caracteres par sous-tableau du tableau 
* TBCHEN tableau des sous-tableaux assimiles a des chaines
* CHAINE chaine dont on cherche la position dans le tableau
*-- Arguments de sortie --
* NUCHEN rang dans le tableau de la 1ere ocurrence de la chaine CHAINE
*         si la chaine y est presente, sinon rang qu'elle doit y occuper . 
* NBIDEM nombre de chaines identiques a CHAINE dans le tableau
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER TBCHEN(*),CHAINE*(*)
      INTEGER   IDBCHN,IFNCHN,NBCCHN,NUCHEN,NBIDEM
*  
      CHARACTER CHKL
      INTEGER   IDEPAR,IARRIV,NBCAR,LGKLIT,ICHKL,IND,MEME,NEXTIT,ICHTB
     &         ,ITEM,ICH
*-----------------------------------------------------------------------
      IDEPAR=IDBCHN
      IARRIV=IFNCHN
      NBCAR=0  
      LGKLIT=LEN(CHAINE)
*     Boucle sur les caracteres de la chaine CHAINE
1     NBCAR=NBCAR+1
*        Retour en cas de succes dans la recherche dichotomique
         IF (NBCAR.GT.NBCCHN) GOTO 100 
      NBIDEM=0 
*  
*     Recherche pour le NBCAR-eme caractere de CHAINE  
      IF (LGKLIT.GE.NBCAR) THEN 
         CHKL=CHAINE(NBCAR:NBCAR)  
         ICHKL=ICHAR(CHKL) 
      ELSE 
*        Si la chaine recherchee est plus courte que celles du tableau 
*        on procede comme si elle se terminait par des blancs  
         CHKL=' '  
         ICHKL=ICHAR(CHKL) 
      ENDIF
*  
*     CHAINE precede-t-il le premier tableau du bloc de tableaux en cours ?
      NUCHEN=IDEPAR
      IND=NBCAR+NBCCHN*(NUCHEN-1)  
      ICH=ICHKL-ICHAR(TBCHEN(IND))
      IF (ICH.LT.0) THEN
*        Retour en cas d'echec (CHAINE precede le 1er sous-tableau)
         RETURN
      ELSEIF (ICH.EQ.0) THEN
         GOTO 20
      ENDIF
*  
*     CHAINE suit-t-il le dernier tableau du bloc de tableaux en cours ?
3     NUCHEN=IARRIV
      IND=NBCAR+NBCCHN*(NUCHEN-1)  
      ICH=ICHKL-ICHAR(TBCHEN(IND))
      IF (ICH.GT.0) THEN
         NUCHEN=IARRIV+1
         RETURN
      ELSEIF (ICH.EQ.0) THEN
         GOTO 20
      ENDIF
*  
*     Recherche dans les autres sous-tableaux du bloc en cours 
*     MEME > 0 indique que la recherche dichotomique n'avance plus 
10    MEME=0
11    NUCHEN=(IARRIV+IDEPAR)/2 
      IND=NBCAR+NBCCHN*(NUCHEN-1)  
      ICH=ICHKL-ICHAR(TBCHEN(IND))
      IF (ICH.LT.0) THEN
         IARRIV=NUCHEN
         NUCHEN=IDEPAR
         GOTO 14
      ELSEIF (ICH.EQ.0) THEN
         GOTO 20
      ENDIF
      IDEPAR=NUCHEN
      NUCHEN=IARRIV
14    IF (IARRIV.LE.IDEPAR+1) MEME=MEME+1
*        Retour en cas d'echec (CHAINE n'appartient pas au tableau)
         IF (MEME.GT.1) RETURN 
      GOTO 11 
*  
***   Succes dans la recherche dichotomique :  
*     Le sous-tableau de rang NUCHEN a les memes NBCAR premiers caracteres 
*     que CHAINE. On cherche le premier et le nombre de tels sous-tableaux 
*     parmi les sous-tableaux voisins (de IDEPAR a IARRIV) 
20    NBIDEM=1 
*  
*     Recherche dans les sous-tableaux precedant le sous-tableau NUCHEN
      NEXTIT=NUCHEN-1  
      ICHTB=IND-NBCCHN 
      DO 30 ITEM=NEXTIT,IDEPAR,-1  
         IF (CHKL.NE.TBCHEN(ICHTB)) GOTO 35
         NBIDEM=NBIDEM+1
         NUCHEN=ITEM
30       ICHTB=ICHTB-NBCCHN
*  
*     Recherche dans les sous-tableaux suivant le sous-tableau NUCHEN  
35    NEXTIT=NEXTIT+2  
      ICHTB=IND+NBCCHN 
      DO 33 ITEM=NEXTIT,IARRIV 
         IF (CHKL.NE.TBCHEN(ICHTB)) GOTO 40
         NBIDEM=NBIDEM+1
33       ICHTB=ICHTB+NBCCHN
*  
*     Bornes de la recherche dichotomique pour le caractere suivant
*     et passage au caractere suivant  
40    IDEPAR=NUCHEN
      IARRIV=IDEPAR-1+NBIDEM
      GOTO 1  
*  
*     Avant de se casser on verifie la longueur de la chaine : 
*     si la chaine recherchee est plus longue que celles du tableau
*     on compare le caractere suivant a un caractere blanc :
100   IF (LGKLIT.GE.NBCAR) THEN 
         ICHKL=ICHAR(CHAINE(NBCAR:NBCAR))
         ICH = ICHKL-ICHAR(' ')
         IF (ICH.EQ.0) RETURN
         IF (ICH.GT.0) NUCHEN=NUCHEN+NBIDEM    
         NBIDEM=0  
      ENDIF
      RETURN
                                                                    END !Dicchn
