*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE DICOTO (ITEMDB,ITEMFN,ITEMTB,KLITEM,ITEMRG,*)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)  
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recherche dichotomique du rang d'un nombre dans un tableau de nombres
* ranges par ordre strictement croissant
*  
*-- Arguments --  
* ITEMDB adresse initiale de recherche dans le tableau (non modifie)  
* ITEMFN adresse finale de recherche dans le tableau (non modifie)
* ITEMTB tableau des nombres  
* KLITEM nombre a rechercher dans le tableau  
* ITEMRG rang dans le tableau du nombre KLITEM en cas de succes
*  (*)   adresse de retour en cas d'echec dans la recherche dichotomique  
*        Dans ce cas ITEMRG contient l'adresse ou le nombre s'implanterait
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER ITEMDB,ITEMFN,ITEMTB(*),KLITEM,ITEMRG
*
      INTEGER IDEPAR,IARRIV,ITEM,MEME
*-----------------------------------------------------------------------
      ITEMRG=ITEMDB
      IF (ITEMFN.LT.ITEMDB) RETURN 1
*  
      IDEPAR=ITEMDB
      IARRIV=ITEMFN
*  
*     On commence par regarder les extremites du tableau
      ITEMRG=IDEPAR
      ITEM=ITEMTB(ITEMRG)  
      IF (KLITEM.EQ.ITEM) THEN  
         RETURN
      ELSEIF (KLITEM.LT.ITEM) THEN 
         RETURN 1  
      ENDIF
      ITEMRG=IARRIV
      ITEM=ITEMTB(ITEMRG)  
      IF (KLITEM.EQ.ITEM) THEN  
         RETURN
      ELSEIF (KLITEM.GT.ITEM) THEN 
         ITEMRG=ITEMRG+1
         RETURN 1  
      ENDIF
*  
*     Puis on regarde a l'interieur ...
*     MEME > 0 indique la fin de la recherche dichotomique 
      MEME=0
1     ITEMRG=(IARRIV+IDEPAR)/2 
      ITEM=ITEMTB(ITEMRG)  
      IF (KLITEM.EQ.ITEM) THEN  
         RETURN
      ELSEIF (KLITEM.LT.ITEM) THEN 
         IARRIV=ITEMRG 
         ITEMRG=IDEPAR 
      ELSE 
         IDEPAR=ITEMRG 
         ITEMRG=IARRIV 
      ENDIF
      IF (IARRIV.LE.IDEPAR+1) MEME=MEME+1
      IF (MEME.GT.1) RETURN 1
      GOTO 1  
                                                                    END !Dicoto
