*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERDOMA (ERRNUM,NMDOMA)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995) 
* Derniere modification : D.Martin (1er Juillet 2000)
* Version 1.0.1
*  
* Message d'erreurs pour un domaine 
*
*-- Arguments d'entree --
* ERRNUM code d'erreur
* NMTERM nom du domaine
*-- Messages d'erreurs --
*- 1 Domaine geometrique inexistant
*- 2 Domaine de calcul inexistant
*- 3 Domaine sans tableau de coordonnees
*- 4 Domaine sans tableau de normales
*- 5 Arete d'element repetee dans la definition du domaine lineique
*- 6 Face d'element repetee dans la definition du domaine surfacique
*- 7 Element repete dans la definition du domaine volumique
*- 8 Numero d'element negatif ou nul dans la definition du domaine
*- 9 Numero de face/arete negatif ou nul dans la definition du domaine
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMDOMA
      INTEGER       ERRNUM
*
      INTEGER       NCHDOM,DIXN,NBCARE
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      NCHDOM=LEN (NMDOMA)
      ERCODE=NMDOMA
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ERRNUM.LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(113:112+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine geometrique '//ERCODE(1:NCHDOM)
     &   //' n''existe pas dans les structures des donnees?')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine de calcul '//ERCODE(1:NCHDOM)
     &   //' n''existe pas dans les structures des donnees?')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' n''a pas de tableau de coordonnees de noeuds associe!')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' n''a pas de tableau de normales associe!')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' contient 2 fois la meme arete d''element'
     &   //' dans sa definition! Voir fichier de maillage')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' contient 2 fois la meme face d''element'
     &   //' dans sa definition! Voir fichier de maillage')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' contient 2 fois le meme element'
     &   //' dans sa definition! Voir fichier de maillage')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' contient un numero d''element negatif ou nul'
     &   //' dans sa definition! Voir fichier de maillage')
      ELSEIF (ERRNUM.EQ.9) THEN
         CALL BAISE  ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le domaine '//ERCODE(1:NCHDOM)
     &   //' contient un numero d''arete/face negatif ou nul'
     &   //' dans sa definition! Voir fichier de maillage')
      ELSE
         CALL WARNNG ('<ErDoma> Code '//ERCODE(113:112+NBCARE)
     &   //' non prevu - Domaine '//ERCODE(1:NCHDOM))
      ENDIF
                                                                    END !ErDoma
