*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERELEM (ERRNUM,WHERE,NUTYPE)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1997) 
* Derniere modification : D.Martin (04 juillet 2005)
* Version 2
*  
* Message d'erreurs pour un type  d'element fini.
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
*  1 Element inexistant
*  2 Dimension non autorisee
*  3 Forme inexistante en dimension
*  4 Dimension de face/arete incorrecte
*  5 Numero d'arete incoherent avec le type
*  6 Numero de face incoherent avec le type
* 10 Type de segment non prevu
* 11 Type de quadrangle non prevu
* 12 Type de triangle non prevu
* 13 Type d'hexaedre non prevu 
* 14 Type de prisme non prevu
* 15 Type de tetraedre non prevu      
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER       ERRNUM,NUTYPE
      CHARACTER*(*) WHERE
*
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
      INTEGER       LWHERE,DIML,FORM,TYPE,DIXN,NBCARE
*-----------------------------------------------------------------------
      LWHERE=LEN (WHERE)
      ERCODE=WHERE
      CALL NUSPLT (NUTYPE, DIML, FORM, TYPE)
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ERRNUM.LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(113:112+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+6))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type d''element non reconnu :'
     &   //ERCODE(LWHERE+1:LWHERE+6)//' dans '//ERCODE(1:LWHERE))
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL ENCLER (DIML,ERCODE(LWHERE+1:LWHERE+3))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Dimension d''espace non autorisee :'
     &   //ERCODE(LWHERE+1:LWHERE+3)//' dans '//ERCODE(1:LWHERE))
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL ENCLER (DIML,ERCODE(LWHERE+1:LWHERE+3))
         CALL ENCLER (FORM,ERCODE(LWHERE+4:LWHERE+6))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Forme d''element non reconnue :'
     &   //ERCODE(LWHERE+4:LWHERE+6)//' en dimension '
     &   //ERCODE(LWHERE+1:LWHERE+3)//' dans '//ERCODE(1:LWHERE))
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+6))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Dimension de face/arete incorrecte pour le type '
     &   //ERCODE(LWHERE+1:LWHERE+6)//' dans '//ERCODE(1:LWHERE))
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Numero d''arete incorrecte :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.6) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Numero de face incorrecte :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.10) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type de segment non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.11) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type de quadrangle non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.12) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type de triangle non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.13) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type d''hexaedre non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.14) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type de prisme non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
       ELSEIF (ERRNUM.EQ.15) THEN
         CALL ENCLER (NUTYPE,ERCODE(LWHERE+1:LWHERE+2))
         CALL BAISE  ('<ErElem> Code '//ERCODE(113:112+NBCARE)
     &   //'- Type de tetraedre non prevu :'
     &   //ERCODE(LWHERE+1:LWHERE+2)//' dans '//ERCODE(1:LWHERE))
*
      ELSE
         CALL WARNNG ('<ErElem> Code '//ERCODE(119:120)
     &   //' non prevu dans '//ERCODE(1:LWHERE))
      ENDIF
                                                                    END !ErElem
