*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERINCO (ERRNUM,NMINCO)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1995) 
* Derniere modification : D.Martin (6 novembre 2002)  
*  
* Message d'erreurs pour une inconnue
*  
*-- Arguments d'entree --
* ERRNUM = 1 Inconnue inexistante
* ERRNUM = 2 Inconnue non scalaire
* ERRNUM = 3 Inconnue non vectorielle
* ERRNUM = 4 Inconnue non 'Valeurs Nodales'
* ERRNUM = 5 Inconnue non 'Spectrale'
* ERRNUM = 6 Le nom de l'inconnue contient le caractere '='
* ERRNUM = 7 L'inconnue Spectrale n'a pas les caracteristiques attendues
*            pour un calcul Element Finis Localises par integration exacte
* ERRNUM = 8 L'inconnue Spectrale n'a pas les caracteristiques attendues
*            pour un calcul Element Finis Localises par integration numerique
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) NMINCO
      INTEGER       ERRNUM
*
      INTEGER       NCHINC,DIXN,NBCARE
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      NCHINC=LEN (NMINCO)
      ERCODE=NMINCO
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ERRNUM.LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(113:112+NBCARE)) 
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(1:NCHINC)
     &   //' n''existe pas dans les structures des donnees?')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(1:NCHINC)//' n''est pas scalaire!')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(:NCHINC)//' n''est pas vectorielle')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(:NCHINC)//' n''est pas de type'
     &   //' ''Valeurs Nodales''.')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(:NCHINC)//' n''est pas de type'
     &   //' ''Spectrale''.')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- Le nom d''une inconnue dans la chaine '//ERCODE(:NCHINC)
     &   //' contient le signe ''=''!')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(:NCHINC)
     &   //' n''a pas les caracteristiques attendues pour un calcul'
     &   //' pour un calcul Element Finis Localises '
     &   //' par integration exacte. Vous avez oublie le NOMBRE DE'
     &   //' TERMES dans le developpement en exponentielles,'
     &   //' ou bien cette inconnue est aussi utilisee dans un calcul'
     &   //' Element Finis Localises par integration numerique.')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //'- L''inconnue '//ERCODE(:NCHINC)
     &   //' n''a pas les caracteristiques attendues pour un calcul'
     &   //' pour un calcul Element Finis Localises '
     &   //' par integration numerique. Vous avez donne le NOMBRE DE'
     &   //' TERMES dans le developpement en exponentielles,'
     &   //' ou bien cette inconnue est aussi utilisee dans un calcul'
     &   //' Element Finis Localises par integration exacte.')
      ELSE
         CALL WARNNG ('<ErInco> Code '//ERCODE(113:112+NBCARE)
     &   //' non prevu - Inconnue '//ERCODE(1:NCHINC))
      ENDIF
                                                                    END !ErInco
