*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERTBAL (ERRNUM,ALPROC,NMTABL,NVTABL)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (4 Juillet 1997) 
* Derniere modification : D.Martin (20 Avril 2007)
* Version 2
*  
* Message d'erreurs pour un tableau gere par l'allocation dynamique
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
* ALPROC nom de la procedure d'allocation dynamique ou survient l'erreur
* NMTABL nom du tableau
* NVTABL niveau du tableau
*-- Messages d'erreurs --
*  1 tableau inexistant
*  2 tableau en memoire secondaire ou en etat de sauvegarde differee
*  3 tableau inexistant ne peut etre tuer
*  4 tableau non en memoire centrale
*  5 super-tableau trop petit pour introduire le tableau en memoire
*  6 tableau existe deja avec un type different
*  7 super-tableau trop petit pour creer le tableau
*  8 super-tableau trop petit pour agrandir le tableau
*  9 impossible de sauvegarder le tableau
* 10 tableau a creer de longueur negative
* 20 pas de tableau tampon dans le systeme
* 21 le tableau n'a pas d'adresse absolue dans le systeme
*-- Procedures utilisees --
* ENCLER (Utilite), BAISE (Utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) ALPROC,NMTABL
      INTEGER       ERRNUM,NVTABL
*
      INTEGER       DIXN,NBCARE,NCATRM,NBCHAL
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRNTRA (NMTABL,NVTABL,ERCODE,NCATRM)
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ABS(ERRNUM).LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(NCATRM+1:NCATRM+NBCARE))
      NBCHAL=LEN(ALPROC)
      ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)=ALPROC
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' n''existe pas dans les tables d''allocation ?')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' est en memoire secondaire ou en etat de sauvegarde'
     &   //' differee : utiliser TbRr..')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' n''existe pas. Le crime n''a pas eu lieu.')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' n''est pas pas en memoire centrale. L''y restaurer')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' ne peut etre reintroduit en memoire centrale.'
     &   //' Super tableau trop petit.')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' existe deja avec un type different.')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' ne peut etre cree. Super tableau trop petit.')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' ne peut etre agrandi. Super tableau trop petit.')
      ELSEIF (ERRNUM.EQ.9) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' ne peut etre sauvegarde.')
      ELSEIF (ERRNUM.EQ.10) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' ne peux etre cree, sa longueur est negative!')
      ELSEIF (ERRNUM.EQ.20) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' Pas de tableau Tampon dans le systeme. Initialisation ?.')
      ELSEIF (ERRNUM.EQ.21) THEN
         CALL BAISE  ('<ErTbAL> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //'- Le tableau '//ERCODE(1:NCATRM)
     &   //' n''a pas d''adresse absolue dans le systeme de fichiers.')
      ELSE
         CALL WARNNG ('<ErTbAl> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //ERCODE(NCATRM+NBCARE+1:NCATRM+NBCARE+NBCHAL)
     &   //' non prevu - Tableau '
     &   //ERCODE(1:NCATRM))
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (20 avril 2007)
* - ajout erreur de code 10 : longueur negative
* Version 1 : D.Martin (4 Juillet 1997)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !ErTbAl
