*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERTERM (ERRNUM,NMTERM,NVTERM)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Novembre 1994) 
* Derniere modification : D.Martin (08 avril 2003)
* Version 1.0.8
*  
* Message d'erreurs pour un terme
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
* NMTERM nom du terme
* NVTERM niveau du terme
*-- Messages d'erreurs --
*- 1 Terme inexistant
*- 2 Terme sans donnee affecte
*- 3 Changement de type de terme impossible
*- 4 Terme non REEL
*- 5 Terme non COMPLEX
*- 6 Terme ni REEL ni COMPLEX
*- 7 Adresse relative fausse
*- 8 Terme de type CARACTERE
*- 9 Terme ne peut etre repete
*-10 Terme non matriciel
*-11 Matrice non carree
*-12 Terme non defini comme terme d'assemblage simple
*-13 Terme non defini comme terme d'assemblage multi-inconnues
*-14 Matrice non factorisee
*-15 Type de factorisation inconnue
*-16 Incompatibilite entre les inconnues
*-17 Matrice non inversible
*-18 Type de stockage incompatible avec la procedure
*-19 Type de factorisation incompatible avec la procedure
*-20 Type de stockage incompatible avec une matrice sym. en structure
*-21 Composante inexistante dans le terme
*-22 Terme multi-inconnue ou sans inconnue affectee
*-23 Terme sans tableau de coordonnees associe
*-24 Terme avec donnee affectee de type CARACTERE interdit
*-25 Terme avec donnee CONSTANTE de type CARACTERE interdit
*-26 Terme avec donnee FONCTION de type CARACTERE interdit
*-27 Terme produit scalaire a plus d'une composante par noeud
*-28 Type de symetrie de matrice non prevu
*-29 Pas d'inconnue en colonne pour un assemblage matriciel multi-inconnue
*-30 Pas d'inconnue en ligne pour un assemblage matriciel multi-inconnue
*-31 Terme non associe a une inconnue vectorielle
*-32 Terme non a valeurs vectorielles
*-33 Operation illegale pour transformer le terme
*-34 Operation non prevue pour transformer le terme
*-35 Assemblage de termes PLEINS non prevu
*-36 Assemblage avec nombre de composantes de l'inconnue different du nombre
*    de valeurs par noeuds
*-37 Terme non (multi)colonne
*-38 Terme Spectral a inconnue en colonne non "spectrale"
*-39 Terme Spectral a inconnue en ligne non "spectrale"
*-40 Terme a stockage non plein
*-41 Terme non spectral
*-42 Les 2 termes matriciels ne sont pas du meme type
*-43 Les dimensions des matrices ne sont pas coherentes
*-44 Terme non EFL numerique
*-45 Terme "Autres Calculs" a inconnue en colonne "supplementaire"
*-46 Terme "Autres Calculs" a inconnue en ligne "supplementaire"
*-- Procedures utilisees --
* PRNTRA, ENCLER, BAISE (Utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       ERRNUM,NVTERM
*
      INTEGER       DIXN,NBCARE,NCATRM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRNTRA (NMTERM,NVTERM,ERCODE,NCATRM)
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ABS(ERRNUM).LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(NCATRM+1:NCATRM+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''existe pas dans les structures des termes ?')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''a pas de donnee affctee !')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le type du terme '//ERCODE(1:NCATRM)
     &   //' ne peut etre modifie. Changer le nom du tableau cible')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas REEL.')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas COMPLEXE.')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est ni REEL ni COMPLEXE.')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''a pas de coefficient a cette adresse.')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' est un tableau de caracteres.')
      ELSEIF (ERRNUM.EQ.9) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' ne peut etre repete dans la liste d''entree.')
      ELSEIF (ERRNUM.EQ.10) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas un terme matriciel.')
      ELSEIF (ERRNUM.EQ.11) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas un terme matriciel carre.')
      ELSEIF (ERRNUM.EQ.12) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas un terme d''assemblage.')
      ELSEIF (ERRNUM.EQ.13) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas un terme d''assemblage multi-inconnue.')
      ELSEIF (ERRNUM.EQ.14) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- La matrice '//ERCODE(1:NCATRM)
     &   //' n''est pas factorisee.')
      ELSEIF (ERRNUM.EQ.15) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Type de factorisation inconnu pour la matrice '
     &   //ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.16) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Incompatibilite entre les inconnues pour la matrice '
     &   //ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.17) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- La matrice '//ERCODE(1:NCATRM)
     &   //' n''est pas inversible !')
      ELSEIF (ERRNUM.EQ.18) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Type de stockage incompatible avec la procedure,'
     &   //' pour la matrice '//ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.19) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Type de factorisation incompatible avec la procedure,'
     &   //' pour la matrice '//ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.20) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Type de stockage incompatible avec une structure'
     &   //' matricielle symetrique, pour la matrice '
     &   //ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.21) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Numero de composante imcompatible avec l''inconnue'
     &   //' associee au terme '//ERCODE(1:NCATRM))
      ELSEIF (ERRNUM.EQ.22) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' est ''multi-inconnues'' ou n''a pas d''inconnue associe.'
     &   //' Le terme peut aussi ne pas avoir ete calcule.')
      ELSEIF (ERRNUM.EQ.23) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''a pas de tableau de coordonnees associe?')
      ELSEIF (ERRNUM.EQ.24) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' ne peut avoir une donnee affectee de type CARACTERE!')
      ELSEIF (ERRNUM.EQ.25) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' ne peut avoir une donnee affectee CONSTANTE CARACTERE!')
      ELSEIF (ERRNUM.EQ.26) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' ne peut avoir une donnee affectee FONCTION CARACTERE!')
      ELSEIF (ERRNUM.EQ.27) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' (produit scalaire) a plus d''une valeur par noeud!')
      ELSEIF (ERRNUM.EQ.28) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- La matrice '//ERCODE(1:NCATRM)
     &   //' a un type de symetrie non admis actuellement!')
      ELSEIF (ERRNUM.EQ.29) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Dans l''assemblage multi-inconnue de la matrice '
     &   //ERCODE(1:NCATRM)//', absence d''une inconnue en colonne!'
     &   //' (Peut-etre assemblage d''un vecteur avec les routines '
     &   //' reservees aux matrices (DSMTRM au lieu de DSVTRM)?)')
      ELSEIF (ERRNUM.EQ.30) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Dans l''assemblage multi-inconnue de la matrice '
     &   //ERCODE(1:NCATRM)//', absence d''une inconnue en ligne!'
     &   //' (Peut-etre assemblage d''un vecteur avec les routines '
     &   //' reservees aux matrices (DSMTRM au lieu de DSVTRM)?)')
      ELSEIF (ERRNUM.EQ.31) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas associe a une inconnue vectorielle?')
      ELSEIF (ERRNUM.EQ.32) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas a valeurs vectorielles.')
      ELSEIF (ERRNUM.EQ.33) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Transformation interdite pour le terme '
     &   //ERCODE(1:NCATRM)//'.')
      ELSEIF (ERRNUM.EQ.34) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Transformation non prevue pour le terme '
     &   //ERCODE(1:NCATRM)//'.')
      ELSEIF (ERRNUM.EQ.35) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Tous les termes a assembler pour construire '
     &   //ERCODE(1:NCATRM)//' sont pleins. Cas non prevu.')
      ELSEIF (ERRNUM.EQ.36) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Assemblage uni-inconnue de '//ERCODE(1:NCATRM)
     &   //' Le nombre de valeurs par noeud est different du nombre'
     &   //' de composantes de l''inconnue. Cas non prevu.')
      ELSEIF (ERRNUM.EQ.37) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas (uni/multi) colonnes. Cas non prevu.')
      ELSEIF (ERRNUM.EQ.38) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme spectral '//ERCODE(1:NCATRM)
     &   //' n''a pas une inconnue ''spectrale'' en colonne.')
      ELSEIF (ERRNUM.EQ.39) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme spectral '//ERCODE(1:NCATRM)
     &   //' n''a pas une inconnue ''spectrale'' en ligne.')
      ELSEIF (ERRNUM.EQ.40) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme spectral '//ERCODE(1:NCATRM)
     &   //' n''est pas stocke PLEIN.')
      ELSEIF (ERRNUM.EQ.41) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas un terme spectral.')
      ELSEIF (ERRNUM.EQ.42) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas du meme type que la premiere matrice.')
      ELSEIF (ERRNUM.EQ.43) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- La dimension du terme '//ERCODE(1:NCATRM)
     &   //' n''est pas coherente avec celle des matrices.')
      ELSEIF (ERRNUM.EQ.44) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme EFL '//ERCODE(1:NCATRM)
     &   //' n''est pas calcule par integration numerique.')
      ELSEIF (ERRNUM.EQ.45) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme ''autres calculs'' '//ERCODE(1:NCATRM)
     &   //' n''a pas une inconnue ''supplementaire'' en colonne.')
      ELSEIF (ERRNUM.EQ.46) THEN
         CALL BAISE  ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme ''autres calculs'' '//ERCODE(1:NCATRM)
     &   //' n''a pas une inconnue ''supplementaire'' en ligne.')
      ELSE
         CALL WARNNG ('<Erterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //' non prevu - Terme '//ERCODE(1:NCATRM))
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (19 mars 2008)
* code d'erreur ajoutés : 45 & 46
* Version 1.0.8 : D.Martin (08 avril 2003)
                                                                    END !ErTerm
