*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE ERTERS (ERRNUM,NMTER1,NVTER1,NMTER2,NVTER2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998) 
* Derniere modification : D.Martin (31 Mars 2005)
* Version 2
*  
* Message d'incompatibilite entre 2 termes
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
* NMTERi nom du terme i
* NVTERi niveau du terme i
*-- Messages d'erreurs --
*- 1 termes de types differents
*- 2 termes d'inconnues differentes
*- 3 terme 1 uni-inconnue, terme 2 multi-inconnue
*- 4 incompatibilite inconnue/interpolation
*- 5 incompatibite entre structures multi-inconnues
*- 6 incompatibite entre types de declaration
*- 7 incompatibite entre longueurs
*- 8 incompatibilite entre termes a valeurs vectorielles
*- 9 incompatibilite pour l'inconnue en colonne pendant assemblage
*-10 incompatibilite pour l'inconnue en ligne pendant assemblage
*-11 type de stockage non prevu dans l'assemblage
*-12 assemblage avec nombre de composantes de l'inconnue
*    different du nombre de valeurs par noeud non prevu
*-13 assemblage avec nombre de composante par noeud variant selon les termes
*-- Procedures utilisees --
* PRNTRA, ENCLER, BAISE (Utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTER1,NMTER2
      INTEGER       ERRNUM,NVTER1,NVTER2
*
      INTEGER       DIXN,NBCARE,NCATR1,NCATR2,NCATR3
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRNTRA (NMTER1,NVTER1,ERCODE,NCATR1)
      CALL PRNTRA (NMTER2,NVTER2,ERCODE(NCATR1+1:),NCATR2)
      NCATR3=NCATR1+NCATR2
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ABS(ERRNUM).LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(NCATR3+1:NCATR3+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' sont de types differents.')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' ont des inconnues differentes.')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATR1)
     &   //' est uni-inconnue, le terme '
     &   //ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' est multi-inconnues. Transformer '//ERCODE(1:NCATR1)
     &   //' par assemblage multi-inconnues.')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' correspondent a des interpolations/inconnues differentes.')
      ELSEIF (ERRNUM.EQ.5) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' ont des structures multi-inconnues incompatibles.')
      ELSEIF (ERRNUM.EQ.6) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' ont des types de declaration incompatibles.')
      ELSEIF (ERRNUM.EQ.7) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' ont des longueurs incompatibles.')
      ELSEIF (ERRNUM.EQ.8) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Les termes '//ERCODE(1:NCATR1)
     &   //' et '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' , a valeurs vectorielles sont incompatibles'
     &   //' (nombre de valeurs par noeud differentes).')
      ELSEIF (ERRNUM.EQ.9) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Assemblage du terme '//ERCODE(1:NCATR1)
     &   //' Incompatibilite de l''inconnue en colonne pour le terme '
     &   //ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' Utiliser l''assemblage multi-inconnues : DSMTRM.'
     &//' (il est aussi possible que ce dernier terme n''existe pas !)')
      ELSEIF (ERRNUM.EQ.10) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Assemblage du terme '//ERCODE(1:NCATR1)
     &   //' Incompatibilite de l''inconnue en ligne pour le terme '
     &   //ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //' Utiliser l''assemblage multi-inconnues : DSMTRM.'
     &//' (il est aussi possible que ce dernier terme n''existe pas !)')
      ELSEIF (ERRNUM.EQ.11) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Assemblage du terme '//ERCODE(1:NCATR1)
     &   //' Type de stockage non prevu (terme '
     &   //ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //')')
      ELSEIF (ERRNUM.EQ.12) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Assemblage inconnue du terme '//ERCODE(1:NCATR1)
     &   //' Cas non prevu : nombre de composantes par noeud de'
     &   //' l''inconnue different du nombre de valeur par noeud,'
     &   //' pour le terme '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //')')
      ELSEIF (ERRNUM.EQ.13) THEN
         CALL BAISE  ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //'- Assemblage inconnue du terme '//ERCODE(1:NCATR1)
     &   //' Cas non prevu : nombre de composantes par noeud '
     &   //' different des termes precedents'
     &   //' pour le terme '//ERCODE(NCATR1+1:NCATR1+NCATR2)
     &   //')')
      ELSE
         CALL WARNNG ('<Erters> Code '//ERCODE(NCATR3+1:NCATR3+NBCARE)
     &   //' non prevu - Terme '//ERCODE(1:NCATR1))
      ENDIF
                                                                    END !ErTers
