*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       SUBROUTINE GLAP2C (NOYO,CORM,CORP,R,E,D1EM,D1EP,D2EMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)  
* Derniere modification : D.Martin (15 Decembre 2000)
* Version 1.0.0
*
* Solution elementaire au point 'M' du Laplacien dans R2
*
*                   E = [1/2Pi] Log R, avec R = || MP ||
*
* Attention : On travaille avec des arguments complexes !!!!!
*
* Attention : La multiplication par 1./2*PI n'est pas effectuee dans ce s-p.
*
*-- Arguments d'entree --
* NOYO  = 'D' (Dirichlet), 'N' ou 'F' (Neumann ou Fourier)
*       'D' implique le calcul du noyau et des derivees 1eres
*       'N' ou 'F'      calcul du noyau, des derivees 1eres et 2ndes croisees
* CORM  coordonnees du point source
* CORP  coordonnees du point image
*-- Arguments de sortie --
* R     distance des 2 points M et P
* E     = LOG(R)
* D1EM  dE/dxm, dE/dym
* D1EP  dE/dxp, dE/dyp
* D2EMP derivees secondes croisees dans l'ordre suivant
*         d2E/dxmdxp, d2E/dxmdyp
*         d2E/dymdxp, d2E/dymdyp
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NOYO
      REAL          R,CORP(*),CORM(*)
      COMPLEX       E,D1EP(*),D1EM(*),D2EMP(*)
*
      INTEGER       NDIM,IDIM,JDIM,IRANG
      PARAMETER    ( NDIM = 2)
      REAL          DESUR4,UNSUR,UNSUR2,X,XM(NDIM),XMSRN
*-----------------------------------------------------------------------
      R=0. 
      DO 1 IDIM=1,NDIM
         X=CORP(IDIM)-CORM(IDIM)
         R=R+X*X
         XM(IDIM)=X
1     CONTINUE
      IF (R.LT.1.E-06)  GOTO 99999
*
      R     = SQRT(R)
      UNSUR = 1./R 
      E     = E + LOG(R)
      UNSUR2=UNSUR*UNSUR
*
*
*     Derivees premieres
*
      DO 2 IDIM=1,NDIM
         X         =XM(IDIM)
         XMSRN     =X*UNSUR2
         D1EP(IDIM)=D1EP(IDIM)+XMSRN
         D1EM(IDIM)=D1EM(IDIM)-XMSRN
2     CONTINUE
*
      IF (NOYO(1:1).NE.'D') THEN
*
*        Derivees secondes croisees
*
         DESUR4=2.*UNSUR2*UNSUR2
         IRANG=1
         DO 4 IDIM=1,NDIM
            X=XM(IDIM) 
            XMSRN=X*DESUR4
            DO 3 JDIM=1,NDIM
              D2EMP(IRANG)= D2EMP(IRANG)+ XMSRN * XM(JDIM)
              IRANG=IRANG+1
3           CONTINUE
4        CONTINUE
         IRANG=1
         DO 5 IDIM=1,NDIM
            D2EMP(IRANG)=D2EMP(IRANG)-UNSUR2
            IRANG=IRANG+NDIM+1
5        CONTINUE
      ENDIF
*
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99999 WRITE(*,10) (CORP(IDIM),IDIM=1,NDIM),(CORM(IDIM),IDIM=1,NDIM)
      CALL BAISE  ('Erreur dans le maillage ?')
10    FORMAT('   Rigolo on essaie de calculer la fonction de Green pour'
     &,' une distance < 10**-6'
     &/T11,'Xp=',E12.4,' Yp=',E12.4
     &/T11,'Xm=',E12.4,' Ym=',E12.4/)
                                                                    END !Glapl2
