*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INTDEG (K)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Fevrier 2000)
* Derniere modification : D.Martin (8 juillet 2005)
* Version 2
*
* Retourne le degre des polynomes pour un numero de code d'interpolation
*
*-- Argument d'entree --
* K code entier definissant l'interpolation
*   0 <K< 100 interpolation de Lagrange de type k standard
* 100 <K< 200 interpolation de Lagrange de type k-30 aux points de Gauss-Lobatto
*      K= 200 interpolation de Hermite standard de type 3
*      K= 201 interpolation de Lagrange de degre 1 non conforme
*      K= 202 interpolation de Lagrange de type 2 Serendipity
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER K,INTDEG
*
      INTEGER KNEW, LAGDMX
      PARAMETER ( LAGDMX = 100 )
      CHARACTER ERR*5
*-----------------------------------------------------------------------
      KNEW = K
      IF (K.GT.LAGDMX) KNEW = KNEW-LAGDMX
*
      IF (KNEW.LE.LAGDMX) THEN
         INTDEG=KNEW
      ELSEIF (K.EQ.200) THEN
         INTDEG=3
      ELSEIF (K.EQ.201) THEN
         INTDEG=1
      ELSEIF (K.EQ.202) THEN
         INTDEG=2
      ELSEIF (K.EQ.203) THEN                                            !06/2004
         INTDEG=3                                                       !06/2004
      ELSE
         CALL ENCLER (K,ERR)
         CALL BAISE ('<IntDeg> Interpolation de numero non prevu :'
     &              //ERR//'.')
      ENDIF
                                                                    END !IntDeg



