*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION INVANO (NMVANO)
*++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1993)  
* Derniere modification : D.Martin (3 Mars 2000)
* Version # 1.0.1
*  
* Codage du type de calcul d'un terme 'Valeurs Nodales' par un entier
*  
*-- Argument d'entree --  
* NMVANO chaine de caractere representant le type de calcul
*
*-- Liste des types de termes 'Valeurs Nodales' --
* Mot-cle           Calcul
* F             (F fourni par Fctrm)
* DF/DN         (grad F fourni par DFctrm)
* TABF          (tableau rempli par l'utilisateur)
* NF ou FN      (prod. par la normale)(F fourni par Fctrm)
* N.F ou F.N    (prod. scalaire )     (comp. de F fournies par Fctrm)
* N^F           (prod. vectoriel)     (comp. de F fournies par Fctrm)
* F^N           (prod. vectoriel)     (comp. de F fournies par Fctrm)
* N^(N^F)       (double prod. vect.)  (comp. de F fournies par Fctrm)
* N(N.F) ou (F.N)N  (prod. par la normale d'un prod. scalaire)(idem Fctrm
* N1F ou FN1    (prod. par 1ere comp. de la normale)      (idem Fctrm)
* N2F ou FN2    (prod. par 2ere comp. de la normale)      (idem Fctrm)
* N3F ou FN3    (prod. par 3ere comp. de la normale)      (idem Fctrm)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMVANO 
      INTEGER       INVANO
*
      INTEGER       NBCHEN,NBCCHN,LNVANO,KELCHN,K
      CHARACTER     NMVANW*7,UPPERC*7
      CHARACTER     CCCHEN*120,TBCHEN(120)
      PARAMETER    (NBCCHN=7,NBCHEN=12)
      COMMON/ONSEPA/CCCHEN 
      EQUIVALENCE  (TBCHEN,CCCHEN)
*-----------------------------------------------------------------------
      NMVANW=UPPERC (NMVANO)
      LNVANO=LEN (NMVANO)
      IF (LNVANO.EQ.1.OR.NMVANW(1:6).EQ.'SIMPLE') THEN
         NMVANW='F'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(1:2).EQ.'N.') THEN
         NMVANW='F.N'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(2:3).EQ.'.N') THEN
         NMVANW='F.N'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(1:2).EQ.'N^') THEN
         NMVANW='N^F'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(2:3).EQ.'^N') THEN
         NMVANW='F^N'
      ELSEIF (LNVANO.EQ.2.AND.NMVANW(2:2).EQ.'N') THEN
         NMVANW='NF'
      ELSEIF (NMVANW(1:7).EQ.'DERIVEE') THEN
         NMVANW='DF/DN'
      ELSEIF ((LNVANO.EQ.4.AND.NMVANW(1:3).EQ.'TAB')
     &    .OR.NMVANW(1:6).EQ.'FOURNI') THEN
         NMVANW='TABF'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(2:3).EQ.'N1') THEN
         NMVANW='N1F'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(2:3).EQ.'N2') THEN
         NMVANW='N2F'
      ELSEIF (LNVANO.EQ.3.AND.NMVANW(2:3).EQ.'N3') THEN
         NMVANW='N3F'
      ELSEIF (LNVANO.EQ.6.AND.(NMVANW(1:6).EQ.'(N.F)N'
     &   .OR.NMVANO(1:6).EQ.'N(F.N)'.OR.NMVANO(1:6).EQ.'(F.N)N')) THEN
         NMVANW='N(N.F)'
      ENDIF
      CCCHEN(1:NBCCHN*NBCHEN)='F      F.N    F^N    N^F    DF/DN  '
     & //'TABF   NF     N^(N^F)N(N.F) N1F    N2F    N3F    '
      INVANO=KELCHN (NMVANW,TBCHEN,NBCHEN,NBCCHN)
*
      IF (INVANO.GT.0) RETURN
*-----------------------------------------------------------------------
      WRITE (*,10000)
      WRITE (*,10001) (K,CCCHEN(1+NBCCHN*(K-1):NBCCHN*K),K=1,NBCHEN)
10000 FORMAT (/' *InVano* Liste des types de Valeurs Nodales'/)
10001 FORMAT ((T3,10(I4,'-',A7,' |',:)))
      K=LEN (NMVANO)
      CCCHEN(1:K)=NMVANO
      CALL BAISE  ('*InVano* Type de Terme Valeur Nodale non reconnu :'
     &//CCCHEN(1:K)//'.')
                                                                    END !Invano
