*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE INVSMA (RANG,M,M1,IRCODE)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1998)
* Derniere modification : D.Martin (20 avril 1998)
*  
* Calcul de l'inverse d'une matrice de rang inferieur a 3
*  
*-- Arguments --  
* RANG   rang de la matrice
* M      matrice a inverser
* M1    inverse de la matrice 
* IRCODE indicateur d'erreur
*        1 matrice non inversible
*        2 matrice de rang > 3
*-- Remarque --
* Les tableaux contenant les matrices sont distincts.
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER RANG,IRCODE
      REAL    M(RANG,*),M1(RANG,*)  
*
      REAL    DETMAT
*-----------------------------------------------------------------------
      IF (RANG.EQ.3) THEN
*        Calculs des mineurs des coefficients de la premiere ligne 
         M1(1,1)=M(2,2)*M(3,3)-M(2,3)*M(3,2)
         M1(2,1)=M(2,3)*M(3,1)-M(2,1)*M(3,3)
         M1(3,1)=M(2,1)*M(3,2)-M(2,2)*M(3,1)
         DETMAT=M(1,1)*M1(1,1)+M(1,2)*M1(2,1)+M(1,2)*M1(3,1)
         IF (DETMAT.LE.1.E-20) GOTO 99991
         M1(1,1)=M1(1,1)/DETMAT
         M1(2,1)=M1(2,1)/DETMAT
         M1(3,1)=M1(3,1)/DETMAT
         M1(1,2)=(M(1,3)*M(3,2)-M(1,2)*M(3,3))/DETMAT
         M1(2,2)=(M(1,1)*M(3,3)-M(1,3)*M(3,1))/DETMAT
         M1(3,2)=(M(1,2)*M(3,1)-M(1,1)*M(3,2))/DETMAT
         M1(1,3)=(M(1,2)*M(2,3)-M(1,3)*M(2,2))/DETMAT
         M1(2,3)=(M(1,3)*M(2,1)-M(1,1)*M(2,3))/DETMAT
         M1(3,3)=(M(1,1)*M(2,2)-M(1,2)*M(2,1))/DETMAT
      ELSEIF (RANG.EQ.2) THEN
         DETMAT=M(1,1)*M(2,2)-M(1,2)*M(2,1) 
         IF (DETMAT.LE.1.E-20) GOTO 99991
         M1(1,1)= M(2,2)/DETMAT
         M1(2,2)= M(1,1)/DETMAT
         M1(1,2)=-M(1,2)/DETMAT
         M1(2,1)=-M(2,1)/DETMAT
      ELSEIF (RANG.EQ.1) THEN  
         DETMAT=M(1,1)
         IF (DETMAT.LE.1.E-20) GOTO 99991
         M1(1,1)=1./DETMAT
      ELSE
         IRCODE=2
      ENDIF
      RETURN
*-----------------------------------------------------------------------
99991 IRCODE=1
                                                                    END !Invsma
