*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      FUNCTION LGSTMO (NMSTOK,NBLIGN,NBCOLO,ITYSYM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Septembre 2000)
* Derniere modification : D.Martin (12 Decembre 2000)
* Version 1.0.1
*
* Calcul la taille maximum d'une structure de stockage matriciel Morse
*
*-- Arguments d'entree --
* NMSTOK nom du tableau de stockage morse ('B' pour le stockage Bimorse,
*                                          'L' pour le stockage Morse-L,
*                                          'C' pour le stockage Morse-C)
* NBLIGN nomre de lignes de la matrice
* NBCOLO nombre de colonnes de la matrice
* ISYSYM indicateur de structure matricielle symetrique
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       IMPLICIT NONE
       INTEGER LGSTMO,NBLIGN,NBCOLO,ITYSYM
       CHARACTER*(*) NMSTOK
*-----------------------------------------------------------------------
       IF (NMSTOK(1:1).EQ.'B') THEN
          LGSTMO=3+MIN(100,1+MIN(NBLIGN,NBCOLO))*(1+MAX(NBLIGN,NBCOLO))
          IF (ITYSYM.NE.0) LGSTMO=LGSTMO/2
       ELSEIF (NMSTOK(1:1).EQ.'L') THEN
          LGSTMO=5+NBLIGN*MIN(100,NBCOLO+1)
       ELSEIF (NMSTOK(1:1).EQ.'C') THEN
          LGSTMO=5+NBCOLO*MIN(100,NBLIGN+1)
       ENDIF
       END
