*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE OSINIT (OSARCH,F77CMP,AUTODP
     &                  ,LASNUF,LGBUF,NBENRX,STDIN,STDOUT
     &                  ,INTMIN,INTMAX,FLTMIN,FLTMAX,DBLMIN,DBLMAX
     &                  ,FLTEPS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (mars 1990)
* Derniere modification : D.Martin (11 septembre 2008)
* Version 2
* 
* Initialisation de donnees dependant du systeme / compilateur
*      (utilise les valeurs de 'limits.h' et 'float.h')
*
*-- Arguments d'entree --
* OSARCH OS and architecture as the string : `uname` // `uname -m`
* F77CMP f77 compiler name according to Melina (output of options_machine)
* AUTODP 'Yes' is one uses compiler options to promote REAL computations
*        to DOUBLE PRECISION computations (else 'No') :
*        
*-- Arguments de sortie --
* LASNUF plus grand numero de fichier possible, could be set
*        to sysconf ("_SC_OPEN_MAX") or sysconf ("_SC_STREAM_MAX") ???
* LGBUF  longueur des buffers d'entree/sortie, could be set to
*        BUFSIZ in <stdio.h> 
* NBENRX nombre maximum d'enregistrements sur fichier a acces direct
* STDIN  System Input File (stdin) 
* STDOUT System Ouput File (stdout)
* INTMIN Plus petit nombre entier negatif             (= INT_MIN in limits.h)
* INTMAX Plus grand nombre entier positif             (= INT_MAX in limits.h)
* FLTMIN Plus petit reel simple precision positif     (= FLT_MIN in float.h)
* FLTMAX Plus grand reel simple precision             (= FLT_MAX in float.h)
* DBLMIN Plus petit reel double precision positif     (= DBL_MIN in float.h)
* DBLMAX Plus grand reel double precision             (= DBL_MAX in float.h)
* FLTEPS (verifie '1+FLTEPS = 1')                     (= FLT_EPSILON in float.h)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*)    OSARCH,F77CMP,AUTODP
      INTEGER          LASNUF,LGBUF,MURECL,NBENRX,STDIN,STDOUT
      INTEGER          INTMIN,INTMAX
      REAL             FLTMIN,FLTMAX,FLTEPS
      DOUBLE PRECISION DBLMIN,DBLMAX,DBLEPS
*     For memory alignement in case of '-i8 -r8/ 'autodbl' compiler option
*     to promote REAL to DOUBLE PRECISION
      INTEGER*4        INTMIC,INTMAC
      REAL*4           FLTMIC,FLTMAC,FLTEPC
      REAL*8           DBLMIC,DBLMAC,DBLEPC
*-----------------------------------------------------------------------
      STDIN  = 5
      STDOUT = 6
      LGBUF  = 1024*16
      NBENRX = 256
      MURECL = 4
      LASNUF = 0
*
      CALL CLIMIT (INTMIC,FLTMIC,DBLMIC,INTMAC,FLTMAC,DBLMAC
     &            ,FLTEPC,DBLEPC)
      INTMIN=INTMIC
      INTMAX=INTMAC
      FLTMIN=FLTMIC
      FLTMAX=FLTMAC
      DBLMIN=DBLMIC
      DBLMAX=DBLMAC
      FLTEPS=FLTEPC
      DBLEPS=DBLEPC
*
      IF (AUTODP.EQ.'Yes') THEN
*
*        Version 'Double precision' 'automatique'
*        (par option de compilation)
*  |           | OS          | Compiler   | Options
*  |-----------|-------------|------------|------------------
*  | MacOS X   | Darwin      | xlf        | -qautodbl=dblpad
*  |           |             | gfortran   | -fdefault-integer-8 -fdefault-real-8
*  |           |             | g95        | -d8
*  |           |             | Absoft f77 | -i8 -N113
*  | IBM       | AIX         | xlf        | -qautodbl=dblpad
*  | Intel     | Linux-Intel | ifc        | -i8 -r8
*  | Dec_Alpha | OSF1        | f77        | -i8 -r8
*  |-----------|-------------|------------|------------------
         FLTMIN = DBLMIN
         FLTMAX = DBLMAX
         FLTEPS = DBLEPS
*
      ENDIF
*
*     Encore dependant de la machine utilisee ...
*
      IF (OSARCH(1:6).EQ.'Darwin') THEN
*        Version Darwin-MacOSX, g77
         LASNUF = 99
*
      ELSEIF (OSARCH(1:5).EQ.'Linux') THEN
*        Version Linux / g77
         LASNUF = 99
*
      ELSEIF (OSARCH(1:3).EQ.'AIX'.AND.F77CMP(1:3).EQ.'xlf') THEN
*        Version AIX-IBM / xlf -qautodbl=dblpad
         LASNUF = 999
*
      ELSEIF (OSARCH(1:3).EQ.'OSF'.AND.F77CMP(1:3).EQ.'f77') THEN
*        Version OSF1-DEC-Alpha / f77
         LASNUF = 999
*        A cause d'une petite coquetterie du cc sur Dec
         INTMIN=(-INTMAX-1)

      ELSEIF (OSARCH(1:4).EQ.'IRIX') THEN
*        Version Silicon Graphics (IRIX & IRIX64) / f77
         LASNUF = 199
         MURECL = 1
*
      ELSEIF (OSARCH(1:3).EQ.'Sun') THEN
*        Version Sun (SunOS 4.1.x & SunOS 5.5.x) / f77
         LASNUF = 63
*
      ELSEIF (OSARCH(1:6).EQ.'CYGWIN') THEN
*        Version CYGWIN / g77
         LASNUF = 99
*
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Version 2 : D.Martin (11 septembre 2008)
* - LGBUF change de 4096 a 4*4096, NBRERX de 1024 a 256.
* Version 1.0.9 : D.Martin (2 septembre 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                                                                   END !OsInit
