*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RELCRE (STRING,NUMBER)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 2000)
* Derniere modification : D.Martin (7 Juin 2000)
* Version  1.0.1
*  
* Reconnaissance de nombres reels sous forme de chaine de caracteres ASCII
* La chaine en entree est de la forme
*                          [+-]iii.ddd[E/D][+-]eee
* ou iii, ddd et eee sont des chaines representant des entiers
* (eventuellement vides)
*
*-- Arguments --
* STRING  chaine de caracteres a reconnaitre
* NUMBER valeur du reel DOUBLE PRECISION reconnu en sortie
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER STRING*(*)
      DOUBLE PRECISION NUMBER
*
      INTEGER   LGUCHN
      INTEGER   NRANMX,NRAN,NFIX,MFIX,NBCHIF,NBDECI,EXPO,NLU,MAXINT
      CHARACTER NEXTCH,SIGNE,SIGNEX
      DOUBLEPRECISION DP,EPSI,TEN
      DATA      EPSI/3.D-16/,TEN/1.D+01/,MAXINT/2147483647/
*-----------------------------------------------------------------------
*
*     Suppression des blancs en fin de chaine
*
      NRANMX = LGUCHN (STRING)
*
      NRAN=1
      NEXTCH=STRING(NRAN:NRAN)
      SIGNE =NEXTCH
      NFIX=0
*-    Nombre de chiffres de la mantisse :
      NBCHIF=0 
*-    Nombre de chiffres decimaux de la mantisse (apres un . ou une ,) : 
      NBDECI=-1
*-    Valeur de l'exposant du nombre reel:
      EXPO=0
*--   Lecture de la mantisse
      IF (NEXTCH.NE.'-'.AND.NEXTCH.NE.'+') GOTO 3
2     IF (NRAN+1.GT.NRANMX) GOTO 5
      NRAN =NRAN+1 
      NEXTCH=STRING(NRAN:NRAN)
3     NLU = 1
*
      IF (LGE(NEXTCH,'0').AND.LLE(NEXTCH,'9')) THEN
*        Le caractere est un chiffre de valeur NLU
         NLU=ICHAR (NEXTCH)-48
         NBCHIF=NBCHIF+1
         IF (NBDECI.GE.0) NBDECI=NBDECI+1
         IF (NBCHIF.LT.10) THEN
            NFIX=NLU+10*NFIX
         ELSEIF (NBCHIF.EQ.10) THEN
            MFIX=NFIX
            NFIX=NLU
         ELSE
            IF (NBCHIF.LT.19) THEN
               NFIX=NLU+10*NFIX
            ELSE
               IF (NBDECI.LT.0) THEN
                  EXPO=EXPO+1
               ELSE
                  NBDECI=NBDECI-1
               ENDIF
            ENDIF
         ENDIF
         GOTO 2
      ELSEIF (NEXTCH.EQ.'+'.OR.NEXTCH.EQ.'-') THEN
*        Le caractere est + ou -
         GOTO 12
      ELSEIF (NEXTCH.EQ.'.'.OR.NEXTCH.EQ.',') THEN
*        Le caractere est . ou ,
         IF (NBDECI.GE.0) RETURN
         NBDECI=0
         GOTO 2
      ELSEIF (NEXTCH.EQ.'D'.OR.NEXTCH.EQ.'E') THEN
         GOTO 12
      ENDIF
      RETURN
5     IF (NBDECI.GE.0.OR.NBCHIF.GT.9) GOTO 12
*
*--    On a lu un ENTIER
*
      IF (SIGNE.EQ.'-') NFIX=-NFIX
      NUMBER=NFIX
      RETURN
*
*--    On a lu un REEL
*
*     Prise en compte de la mantisse du reel
12    SIGNEX=' '
      NUMBER=NFIX
      NFIX=0
      IF (NBCHIF.GE.10) THEN
         DP=MFIX
         IF (NBCHIF.GT.18) NBCHIF=18
         NUMBER=NUMBER+DP*TEN**(NBCHIF-9)
      ENDIF
      NUMBER=NUMBER*(1.D0+EPSI)
*     Lecture de l'exposant
      IF (NBDECI.LT.0) NBDECI=0
      EXPO=EXPO-NBDECI
      NLU = 1
      IF (NEXTCH.EQ.'+'.OR.NEXTCH.EQ.'-') THEN
         SIGNEX=NEXTCH
      ELSEIF (LGE(NEXTCH,'0').AND.LLE(NEXTCH,'9')) THEN
*        Le caractere est un chiffre de valeur NLU
         NLU=ICHAR (NEXTCH)-48
         GOTO 13
      ENDIF
13    IF (NRAN+1.LE.NRANMX) THEN
         NRAN =NRAN+1
         NEXTCH=STRING(NRAN:NRAN)
         NLU = 1
         IF (LGE(NEXTCH,'0').AND.LLE(NEXTCH,'9')) THEN
            NLU=ICHAR (NEXTCH)-48
            NFIX=NLU+10*NFIX
            GOTO 13
         ELSEIF (NEXTCH.EQ.'+'.OR.NEXTCH.EQ.'-') THEN
            IF (SIGNEX.NE.' ') RETURN
            SIGNEX=NEXTCH
            GOTO 13
         ENDIF 
      ENDIF
19    IF (SIGNEX.EQ.'-') NFIX=-NFIX
      EXPO=EXPO+NFIX
      NUMBER=NUMBER*TEN**EXPO
*
*     Prise en compte du signe des reels
*
20    IF (NUMBER.LT.0) THEN
          NUMBER=-NUMBER
          SIGNE='-'
      ENDIF
      IF (NUMBER.GT.MAXINT*1.D0) THEN
          NFIX=MAXINT
      ELSE 
          NFIX=INT(NUMBER)
      ENDIF
      IF (SIGNE.EQ.'-') THEN
         NUMBER=-NUMBER
         NFIX=-NFIX
      ENDIF
      END

