*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TBRAND (IRND,NBC,TYPT,MCT,ISTT,RSTT,CSTT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: C.Hazard (1989), F.Mahe, D.Martin (Novembre 1996)
* Derniere modification (D.Martin) le 29 Novembre 1996
*  
* Creation d'un tableau de valeurs aleatoires
* Tire de la procedure RITZIT 
* ( Wilkinson & Reinsch, Handbook, contribution II/9 : RUTISHAUSER )
*  
*-- Arguments --
* IRND entier initialisant le processus aleatoire. 
*      Il est modifie en sortie pour etre reutilise pour un nouveau passage
* NBC  nombre de coefficients a remplir  
* TYPT type du tab. a mettre a zero ('ENTIER','REEL','COMPLEXE','CARACTERE')
* MCT  adresse du tableau dans le tableau du bon type
* ISTT,RSTT,CSTT: tab. contenant le tab. ENTIERE,REEL,COMPLEXE  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYPT*(*)
      INTEGER       IRND,NBC,MCT,ISTT(*)
      REAL          RSTT(*)
      COMPLEX       CSTT(*)
*
      INTEGER I,M1,M2,K1,K2,K3,AD,RE,IM
*----------------------------------------------------------------------- 
      M1 = INT( IRND/4096. + 0.0001 )
      M2 = IRND - 4096*M1
*
      AD=MCT
      IF (TYPT(1:1).EQ.'E') THEN
*         CALL BAISE  ('TBRAND non prevu pour des entiers')
          STOP
      ELSEIF (TYPT(1:1).EQ.'R') THEN
         DO 2 I = 1,NBC
            K1 = 1001*M2 + 3721
            K2 = INT ( K1/4096. + 0.0001 )
            K1 = K1 - 4096*K2
            K3 = 1001*(M1+M2) + K2 + 173
            K2 = INT( K3/4096. + 0.0001)
            K3 = K3 - 4096*K2
            M1 = K3
            M2 = K1
            RSTT(AD) = (M1 + M2/4096.)/2048. - 1.
            AD=AD+1
2        CONTINUE
      ELSEIF (TYPT(1:1).EQ.'C') THEN
         DO 4 I = 1,NBC
            K1 = 1001*M2 + 3721
            K2 = INT ( K1/4096. + 0.0001 )
            K1 = K1 - 4096*K2
            K3 = 1001*(M1+M2) + K2 + 173
            K2 = INT( K3/4096. + 0.0001)
            K3 = K3 - 4096*K2
            M1 = K3
            M2 = K1
            RE = (M1 + M2/4096.)/2048. - 1.
            K1 = 1001*M2 + 3721
            K2 = INT ( K1/4096. + 0.0001 )
            K1 = K1 - 4096*K2
            K3 = 1001*(M1+M2) + K2 + 173
            K2 = INT( K3/4096. + 0.0001)
            K3 = K3 - 4096*K2
            M1 = K3
            M2 = K1
            IM = (M1 + M2/4096.)/2048. - 1.
            CSTT(AD) = CMPLX(RE,IM)
            AD=AD+1
4        CONTINUE
      ENDIF
      IRND = 4096*M1 + M2
                                                                    END !TbRand

