*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TCOCOT (NBC,TYP1,MC1,RST1,CST1,TYP2,MC2,RST2,CST2
     &                                         ,TYP3,MC3,RST3,CST3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991)  
* Derniere modification: D.Martin (6 Decembre 1996)
* Version # 1.0.1
*  
* Produit composante a composante de deux tableaux avec cumul dans
* le tableau resultat (qui n'est donc pas mis a zero)
*  
*-- Arguments d'entree --
* NBC   nombre de coefficients
* TYP1  type du 1er tableau ('REEL','COMPLEXE')  
* MC1   adresse du 1er tableau dans le tab. reel RST1 ou complexe CST1
* RST1  tableau contenant le 1er tableau (cas reel)  
* CST1  tableau contenant le 1er tableau (cas complexe)  
* TYP2  type du 2eme tableau ('REEL','COMPLEXE') 
* MC2   adresse du 2eme tableau dans le tab. reel RST2 ou complexe CST2
* RST2  tableau contenant le 2eme tableau (cas reel) 
* CST2  tableau contenant le 2eme tableau (cas complexe) 
* TYP3  type du tableau cible
* MC3   adresse du tab. cible dans le tab. reel RST3 ou complexe CST3
* RST3  tableau contenant le tableau cible (cas reel)
* CST3  tableau contenant le tableau cible (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYP3
      INTEGER       NBC,MC1,MC2,MC3
      REAL          RST1(*),RST2(*),RST3(*)
      COMPLEX       CST1(*),CST2(*),CST3(*)
*
      INTEGER       MCT1,MCT2,I
*-----------------------------------------------------------------------
      MCT1=MC1 
      MCT2=MC2 
      IF (TYP3(1:1).EQ.'R') THEN
*        Cas d'un tableau cible reel  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN  
               DO 11 I=MC3,MC3-1+NBC 
                  RST3(I)=RST3(I)+RST1(MCT1)*RST2(MCT2) 
                  MCT1=MCT1+1 
11                MCT2=MCT2+1 
            ELSEIF (TYP1(1:1).EQ.'C') THEN 
               DO 12 I=MC3,MC3-1+NBC 
                  RST3(I)=RST3(I)+REAL(CST1(MCT1)*CST2(MCT2)) 
                  MCT1=MCT1+1 
12                MCT2=MCT2+1 
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 13 I=MC3,MC3-1+NBC 
               RST3(I)=RST3(I)+RST1(MCT1)*REAL(CST2(MCT2))
               MCT1=MCT1+1
13             MCT2=MCT2+1
         ELSE  
            DO 14 I=MC3,MC3-1+NBC 
               RST3(I)=RST3(I)+REAL(CST1(MCT1))*RST2(MCT2)
               MCT1=MCT1+1
14             MCT2=MCT2+1
         ENDIF
      ELSE 
*        Cas d'un tableau cible complexe  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN  
               DO 21 I=MC3,MC3-1+NBC 
                  CST3(I)=CST3(I)+CST1(MCT1)*CST2(MCT2) 
                  MCT1=MCT1+1 
21                MCT2=MCT2+1 
            ELSEIF (TYP1(1:1).EQ.'R') THEN 
               DO 22 I=MC3,MC3-1+NBC 
                  CST3(I)=CST3(I)+RST1(MCT1)*RST2(MCT2) 
                  MCT1=MCT1+1 
22                MCT2=MCT2+1 
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 23 I=MC3,MC3-1+NBC 
               CST3(I)=CST3(I)+RST1(MCT1)*CST2(MCT2)
               MCT1=MCT1+1
23             MCT2=MCT2+1
         ELSE  
            DO 24 I=MC3,MC3-1+NBC 
               CST3(I)=CST3(I)+CST1(MCT1)*RST2(MCT2)
               MCT1=MCT1+1
24             MCT2=MCT2+1
         ENDIF
      ENDIF
                                                                    END !TcocoT
