*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TDANST (NBCOEF,TYP1,MC1,IST1,RST1,CST1
     &                         ,TYP2,MC2,IST2,RST2,CST2)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mai 1990)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Recopie d'un tableau de type scalaire (entier,reel ou complexe) dans un autre
*  
*-- Arguments --  
* NBCOEF: nombre de coefficients a recopier
* TYP1  : type du tableau a recopier ('ENTIER','REEL','COMPLEXE')  
* MC1   : adresse dans le tableau IST1,RST1 ou CST1 du tableau a recopier  
* IST1,RST1,CST1: tab. contenant le tab. a recopier(cas entier,reel,complexe)  
* TYP2,MC2,IST2,RST2,CST2: idem pour le tab. cible
* 
*-- Exemples d'utilisation 
*  
* Si les 2 tableaux sont des tableaux standards ( declares dans la procedure
* appelante TAB1(*),TAB2(*) ) l'appel sera : 
* CALL TDANST(NBC,TYP1,1,IBID,TAB1,CBID,TYP2,1,IBID,TAB2,CBID)
*  
* Si le 1er tableau reel TAB1 est un tableau standard ( TAB1(*) dans la procedure
* appelant) et le 2nd est adresse dans RST ou CST a l'adresse MC2, l'appel sera 
* CALL TDANST(NBC,TYP1,1,IBID,TAB1,CBID,TYP2,MC2,IBID,RST,CST)
* ou encore
* CALL TDANST(NBC,TYP1,1,IBID,TAB1,CBID,TYP2,1,IBID,RST(MC2),CST(MC2))
*  
* Si le 1er tableau complexe TAB1 est un tableau standard ( COMPLEX TAB1(*)
* dans la procedure appelant) et le 2nd est un sous-tableau adresse a l'adresse
* relative MC2 d'un tableau adresse dans RST ou CST a l'adresse MC 
* l'appel sera 
* CALL TDANST(NBC,TYP1,1,IBID,BID,TAB,TYP2,MC2,IBID,RST(MC),CST(MC)) 
* ou encore
* CALL TDANST(NBC,TYP1,1,IBID,BID,TAB,TYP2,1,IBID,RST(MC+MC2-1),CST(MC+MC2-1))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1   ,TYP2
      INTEGER       NBCOEF,MC1,IST1(*),MC2,IST2(*)
      REAL          RST1(*),RST2(*)
      COMPLEX       CST1(*),CST2(*)
*
      INTEGER MCT2,I
*-----------------------------------------------------------------------
      IF (TYP1(1:2).EQ.'CA'.OR.TYP2(1:2).EQ.'CA')
     &CALL BAISE ('*TdansT non prevu pour les tableaux de caracteres')  !Utilite
      MCT2=MC2
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
         IF (TYP1(1:1).EQ.'E') THEN
            DO 11 I=MC1,MC1-1+NBCOEF
               IST2(MCT2)=IST1(I)
11             MCT2=MCT2+1
         ELSEIF (TYP1(1:1).EQ.'R') THEN
            DO 22 I=MC1,MC1-1+NBCOEF
               RST2(MCT2)=RST1(I)
22             MCT2=MCT2+1
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 44 I=MC1,MC1-1+NBCOEF
               CST2(MCT2)=CST1(I)
44             MCT2=MCT2+1
         ELSE
            CALL BAISE  ('*Tdanst* Type de tableau non reconnu')        !Utilite
         ENDIF
*  
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         IF (TYP1(1:1).EQ.'R') THEN 
           DO 24 I=MC1,MC1-1+NBCOEF
              CST2(MCT2)=CMPLX(RST1(I),0.)
24            MCT2=MCT2+1
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 14 I=MC1,MC1-1+NBCOEF
               CST2(MCT2)=CMPLX(REAL(IST1(I)),0.)
14             MCT2=MCT2+1
         ELSE  
            CALL BAISE  ('*TdansT'//
     &           'Tab. 2 complexe incompatible avec le type du tab. 1') !Utilite
         ENDIF 
      ELSEIF (TYP2(1:1).EQ.'R') THEN
         IF (TYP1(1:1).EQ.'C') THEN 
            DO 42 I=MC1,MC1-1+NBCOEF
               RST2(MCT2)=REAL(CST1(I))
42             MCT2=MCT2+1 
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 12 I=MC1,MC1-1+NBCOEF
               RST2(MCT2)=REAL(IST1(I))
12             MCT2=MCT2+1 
         ELSE  
            CALL BAISE  ('*TdansT'//
     &           'Tab. 2 reel incompatible avec le type du tab. 1')     !Utilite
         ENDIF
      ELSE
         CALL BAISE
     &         ('*TDansT* Incompatibilite entre les types de tableaux')
      ENDIF
                                                                    END !TDansT
