*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE THERMT (NBC,TYP1,MC1,RST1,CST1
     &                      ,TYP2,MC2,RST2,CST2,RESULT)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mai 1990)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Produit hermitien de deux tableaux
*  
*-- Arguments -- 
* NBC    nombre de coefficients des tableaux  
* TYP1   type du 1er tableau ('REEL','COMPLEXE')  
* MC1    adresse du 1er tab. dans le tab. reel RST1 ou complexe CST1  
* RST1   tableau contenant le 1er tableau (cas reel)  
* CST1   tableau contenant le 1er tableau (cas complexe)  
* TYP2   type du 2eme tableau 
* MC2    adresse du 2eme tableau dans le tableau reel RST1 ou complexe CST1
* RST2   tableau contenant le 2eme tableau (cas reel) 
* CST2   tableau contenant le 2eme tableau (cas complexe) 
* RESULT resultat TOUJOURS complexe
*  
* Voir idees d'exemples d'utilisation dans le source de TDANST 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2 
      INTEGER       NBC,MC1,MC2 
      REAL          RST1(*),RST2(*)  
      COMPLEX       CST1(*),CST2(*),RESULT
*
      INTEGER       MCT2,I
*-----------------------------------------------------------------------
      RESULT=0.
      MCT2=MC2 
      IF (TYP2(1:1).EQ.TYP1(1:1))THEN
         IF (TYP1(1:1).EQ.'R') THEN 
            DO 22 I=MC1,MC1-1+NBC
               RESULT=RESULT+RST1(I)*RST2(MCT2)
22             MCT2=MCT2+1 
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 44 I=MC1,MC1-1+NBC
               RESULT=RESULT+CST1(I)*CONJG(CST2(MCT2)) 
44             MCT2=MCT2+1 
          ENDIF
      ELSEIF (TYP1(1:1).EQ.'C') THEN
         DO 42 I=MC1,MC1-1+NBC  
            RESULT=RESULT+CST1(I)*RST2(MCT2)
42          MCT2=MCT2+1
      ELSE 
         DO 24 I=MC1,MC1-1+NBC  
            RESULT=RESULT+RST1(I)*CONJG(CST2(MCT2))
24          MCT2=MCT2+1
       ENDIF
                                                                    END !THermT
