*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TNENET (NBNE,NBV1,TYP1,MC1,RST1,CST1
     &                       ,NBV2,TYP2,MC2,RST2,CST2
     &                            ,TYP3,MC3,RST3,CST3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Decembre 2001)  
* Derniere modification: D.Martin (14 Decembre 2001)
* Version 1.0.0
*  
* Produit noeud a noeud de deux tableaux avec cumul dans le tableau resultat 
* (qui n'est donc pas mis a zero)
*  
*-- Arguments d'entree --
* NBNE  nombre de noeuds
* NBV1  nombre de valeurs par noeud du tableau 1
* TYP1  type du 1er tableau ('REEL','COMPLEXE')  
* MC1   adresse du 1er tableau dans le tab. reel RST1 ou complexe CST1
* RST1  tableau contenant le 1er tableau (cas reel)  
* CST1  tableau contenant le 1er tableau (cas complexe)  
* TYP2  type du 2eme tableau ('REEL','COMPLEXE') 
* MC2   adresse du 2eme tableau dans le tab. reel RST2 ou complexe CST2
* NBV2  nombre de valeur par noeud du tableau 2
* RST2  tableau contenant le 2eme tableau (cas reel) 
* CST2  tableau contenant le 2eme tableau (cas complexe) 
* TYP3  type du tableau cible
* MC3   adresse du tab. cible dans le tab. reel RST3 ou complexe CST3
* RST3  tableau contenant le tableau cible (cas reel)
* CST3  tableau contenant le tableau cible (cas complexe)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYP3
      INTEGER       NBNE,MC1,NBV1,MC2,NBV2,MC3
      REAL          RST1(*),RST2(*),RST3(*)
      COMPLEX       CST1(*),CST2(*),CST3(*)
*
      CHARACTER    T1,T2
      INTEGER       AD1,AD2,AD3,I
*-----------------------------------------------------------------------
      T1=TYP1(1:1)
      T2=TYP2(1:1)
      AD1=MC1
      NBV=NBV1
      AD2=MC2
      AD3=MC3
      IF (NBV2.NE.1) THEN
         CALL BAISE  ('*Tnenet* NbValne second tableau > 1 ?')
      ENDIF 
*
      IF (TYP3(1:1).EQ.'R') THEN
*
*        Cas d'un tableau cible reel
* 
         IF (T2.EQ.T1) THEN
            IF (T1.EQ.'R') THEN
               DO 21 I=MC3,MC3-1+NBNE
                  DO 11 J=1,NBV
                    RST3(AD3)=RST3(AD3)+RST1(AD1)*RST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
11                CONTINUE
                  AD2=AD2+1
21             CONTINUE
            ELSEIF (T1.EQ.'C') THEN
               DO 22 I=MC3,MC3-1+NBNE
                  DO 12 J=1,NBV
                    RST3(AD3)=RST3(AD3)+REAL(CST1(AD1)*CST2(AD2))
                    AD1=AD1+1
                    AD3=AD3+1
12                CONTINUE
                  AD2=AD2+1
22             CONTINUE
            ENDIF
         ELSEIF (T2.EQ.'C') THEN
               DO 23 I=MC3,MC3-1+NBNE
                  DO 13 J=1,NBV
                    RST3(AD3)=RST3(AD3)+RST1(AD1)*REAL(CST2(AD2))
                    AD1=AD1+1
                    AD3=AD3+1
13                CONTINUE
                  AD2=AD2+1
23             CONTINUE
         ELSE
               DO 24 I=MC3,MC3-1+NBNE
                  DO 14 J=1,NBV
                    RST3(AD3)=RST3(AD3)+REAL(CST1(AD1))*RST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
14                CONTINUE
                  AD2=AD2+1
24             CONTINUE
         ENDIF
      ELSE
*
*        Cas d'un tableau cible complexe 
* 
         IF (T2.EQ.T1) THEN
            IF (T1.EQ.'C') THEN
               DO 41 I=MC3,MC3-1+NBNE
                  DO 31 J=1,NBV
                    CST3(AD3)=CST3(AD3)+CST1(AD1)*CST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
31                CONTINUE
                  AD2=AD2+1
41             CONTINUE 
            ELSEIF (T1.EQ.'R') THEN 
               DO 42 I=MC3,MC3-1+NBNE
                  DO 32 J=1,NBV
                    CST3(AD3)=CST3(AD3)+RST1(AD1)*RST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
32                CONTINUE
                  AD2=AD2+1
42             CONTINUE
            ENDIF
         ELSEIF (T2.EQ.'C') THEN
               DO 43 I=MC3,MC3-1+NBNE
                  DO 33 J=1,NBV
                    CST3(AD3)=CST3(AD3)+RST1(AD1)*CST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
33                CONTINUE
                  AD2=AD2+1
43             CONTINUE
         ELSE
               DO 44 I=MC3,MC3-1+NBNE
                  DO 34 J=1,NBV
                    CST3(AD3)=CST3(AD3)+CST1(AD1)*RST2(AD2)
                    AD1=AD1+1
                    AD3=AD3+1
34                CONTINUE
                  AD2=AD2+1
44             CONTINUE
         ENDIF
      ENDIF
                                                                    END !TneneT
