*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPLUAT (NBC,TYP1,MC1,RST1,CST1,TYPA,MCA,ISTA,RSTA,CSTA
     &                      ,TYP2,MC2,RST2,CST2,TYP3,MC3,RST3,CST3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 1990)
* Derniere modification : D.Martin (6 Decembre 1996)
*  
* Calcul de Tableau3 = Tableau1 + A * Tableau2
*  
*-- Arguments --  
* NBC   nombre de coefficients
* TYP1  type du 1er tableau ('REEL','COMPLEXE')  
* MC1   adresse du 1er tableau dans le tab. reel RST1 ou complexe CST1
* RST1  tableau contenant le 1er tableau (cas reel)  
* CST1  tableau contenant le 1er tableau (cas complexe)  
* TYPA  type de la constante ('REEL','COMPLEXE') 
* MCA   adresse de la cste dans le tab. entier ISTA,reel RSTA ou complexe CSTA
* ISTA  tableau contenant la constante (cas entier)  
* RSTA  tableau contenant la constante (cas reel)
* CSTA  tableau contenant la constante (cas complexe)
* TYP2  type du 2eme tableau ('REEL','COMPLEXE') 
* MC2   adresse du 2eme tableau dans le tab. reel RST1 ou complexe CST1  
* RST2  tableau contenant le 2eme tableau (cas reel) 
* CST2  tableau contenant le 2eme tableau (cas complexe) 
* TYP3  type du tableau cible
* MC3   adresse du tab. cible dans le tab. reel RST1 ou complexe CST1
* RST3  tableau contenant le tableau cible (cas reel)
* CST3  tableau contenant le tableau cible (cas complexe)
*  
* Voir idees d'exemples d'utilisation dans le source de TDANST 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYP3,TYPA
      INTEGER       NBC,ISTA(*),MC1,MCA,MC2,MC3
      REAL          RST1(*),RSTA(*),RST2(*),RST3(*)
      COMPLEX       CST1(*),CSTA(*),CST2(*),CST3(*)
*
      INTEGER       MCT1,MCT2,MCT3
      REAL          RCSTE
      COMPLEX       CCSTE
      EQUIVALENCE  (CCSTE,RCSTE)
*-----------------------------------------------------------------------
      CCSTE=0. 
      MCT1=MC1 
      MCT2=MC2 
      IF (TYPA(1:1).EQ.'R') THEN
         RCSTE=RSTA(MCA) 
      ELSEIF (TYPA(1:1).EQ.'C') THEN
         CCSTE=CSTA(MCA) 
      ELSEIF (TYPA(1:1).EQ.'E') THEN
         RCSTE=REAL(ISTA(MCA))
      ENDIF
      IF (TYP3(1:1).EQ.'R') THEN
*        Cas d'un tableau cible reel  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN  
               DO 11 MCT3=MC3,MC3-1+NBC 
                  RST3(MCT3)=RST1(MCT1)+RCSTE*RST2(MCT2)
                  MCT1=MCT1+1 
11                MCT2=MCT2+1 
            ELSEIF (TYP1(1:1).EQ.'C') THEN 
               DO 12 MCT3=MC3,MC3-1+NBC 
                  RST3(MCT3)=REAL(CST1(MCT1)+CCSTE*CST2(MCT2))
                  MCT1=MCT1+1 
12                MCT2=MCT2+1 
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 13 MCT3=MC3,MC3-1+NBC 
               RST3(MCT3)=RST1(MCT1)+REAL(CCSTE*CST2(MCT2))
               MCT1=MCT1+1
13             MCT2=MCT2+1
         ELSE  
            DO 14 MCT3=MC3,MC3-1+NBC 
               RST3(MCT3)=REAL(CST1(MCT1)+CCSTE*RST2(MCT2))
               MCT1=MCT1+1
14             MCT2=MCT2+1
         ENDIF
      ELSE 
*        Cas d'un tableau cible complexe  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN  
               DO 21 MCT3=MC3,MC3-1+NBC 
                  CST3(MCT3)=CST1(MCT1)+CCSTE*CST2(MCT2)
                  MCT1=MCT1+1 
21                MCT2=MCT2+1 
            ELSEIF (TYP1(1:1).EQ.'R') THEN 
               DO 22 MCT3=MC3,MC3-1+NBC 
                  CST3(MCT3)=RST1(MCT1)+CCSTE*RST2(MCT2)
                  MCT1=MCT1+1 
22                MCT2=MCT2+1 
            ENDIF 
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 23 MCT3=MC3,MC3-1+NBC 
               CST3(MCT3)=RST1(MCT1)+CCSTE*CST2(MCT2)
               MCT1=MCT1+1
23             MCT2=MCT2+1
         ELSE  
            DO 24 MCT3=MC3,MC3-1+NBC 
               CST3(MCT3)=CST1(MCT1)+CCSTE*RST2(MCT2)
               MCT1=MCT1+1
24             MCT2=MCT2+1
         ENDIF
      ENDIF
                                                                    END !TPluaT
