*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTDMT (NBC,TYP1,MC1,IST1,RST1,CST1,PTR122
     &                      ,TYP2,MC2,IST2,RST2,CST2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: D.Martin (Mars 1993)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Report de l'oppose d'un tableau dans un autre 
*  
*-- Arguments --  
* NBC    nombre de coefficients a recopier
* TYP1   type du tableau a recopier ('REEL','COMPLEXE')
* MC1    Adresse du tab. a recopier dans le tab. reel RST1 ou complexe CST1
* RST1   tableau contenant le tableau a recopier (cas reel)
* CST1   tableau contenant le tableau a recopier (cas complexe)
* PTR122 tableau des addresses des coefficients de 1 dans 2
* TYP2   type du tableau cible
* MC2    Adresse du tab. cible dans le tab. reel RST1 ou complexe CST1
* RST2   tableau contenant le tableau cible (cas reel)
* CST2   tableau contenant le tableau cible (cas complexe)
*  
*-- Exemples d'utilisation dans le Source de TDANST
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2
      INTEGER       NBC,MC1,MC2,IST1(*),IST2(*),PTR122(*)  
      REAL          RST1(*),RST2(*) 
      COMPLEX       CST1(*),CST2(*) 
*
      INTEGER       MCT1,MCT2,I 
*-----------------------------------------------------------------------
      MCT1=MC1
      IF (TYP2(1:1).EQ.TYP1(1:1)) THEN 
         IF (TYP1(1:1).EQ.'E') THEN 
            DO 11 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               IST2(MCT2)=-IST1(MCT1)  
11             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'R') THEN
            DO 22 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=-RST1(MCT1)  
22             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 33 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=-CST1(MCT1)  
33             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*TptdmT* Type de tableau non reconnu')        !Utilite
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'C') THEN
         IF (TYP1(1:1).EQ.'R') THEN 
            DO 44 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=-RST1(MCT1)
44             MCT1=MCT1+1  
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 55 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=-IST1(MCT1)  
55             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*TptdmT'//
     *           'Tab. 2 complexe incompatible avec le type du tab. 1') !Utilite
         ENDIF
      ELSEIF (TYP2(1:1).EQ.'R') THEN
         IF (TYP1(1:1).EQ.'C') THEN 
            DO 66 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=-REAL(CST1(MCT1)) 
66             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'E') THEN
            DO 77 I=1,NBC
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=-IST1(MCT1)  
77             MCT1=MCT1+1 
         ELSE  
            CALL BAISE  ('*TptdmT'//
     *               'Tab. 2 reel incompatible avec le type du tab. 1') !Utilite
         ENDIF
      ELSE 
         CALL BAISE
     *         ('*TptdmT* Incompatibilite entre les types de tableaux') !Utilite

      ENDIF
                                                                    END !TptdmT
