*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TPTQAT (NBC,TYP1,MC1,RST1,CST1,PTR122
     &                      ,TYPA,MCA,ISTA,RSTA,CSTA,TYP2,MC2,RST2,CST2)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur: O.DeBayser (Mars 93)
* Derniere modification (D.Martin) le 6 Decembre 1996
*  
* Calcul de A * Tableau1 et resultat dans Tableau2 connaissant le tableau
* des adresses des coefficients de Tableau1 dans Tableau2.
*  
*-- Arguments --  
* NBC    nombre de coefficients
* TYP1   type du 1er tableau ('REEL','COMPLEXE')  
* MC1    Adresse du 1er tableau dans le tab. reel RST1 ou complexe CST1
* RST1   tableau contenant le 1er tableau (cas reel)  
* CST1   tableau contenant le 1er tableau (cas complexe)
* PTR122 tableau des addresses des coefficients de 1 dans 2
* TYPA   type de la constante ('REEL','COMPLEXE') 
* MCA    Adresse de la cste dans le tab. entier ISTA,reel RSTA ou complexe CSTA
* ISTA   tableau contenant la constante (cas entier)  
* RSTA   tableau contenant la constante (cas reel)
* CSTA   tableau contenant la constante (cas complexe)
* TYP2   type du tableau cible
* MC2    Adresse du tab. cible dans le tab. reel RST2 ou complexe CST2
* RST2   tableau contenant le tableau cible (cas reel)
* CST2   tableau contenant le tableau cible (cas complexe)
*  
* Voir idees d'exemples d'utilisation dans le source de TDANST 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYPA
      INTEGER       NBC,MC1,MCA,MC2,ISTA(*),PTR122(*)
      REAL          RST1(*),RSTA(*),RST2(*),RCSTE
      COMPLEX       CST1(*),CSTA(*),CST2(*),CCSTE  
      EQUIVALENCE   (CCSTE,RCSTE)
*
      INTEGER       MCT1,MCT2,I
*-----------------------------------------------------------------------
      CCSTE=0. 
      MCT1=MC1 
      IF (TYPA(1:1).EQ.'R') RCSTE=RSTA(MCA) 
      IF (TYPA(1:1).EQ.'C') CCSTE=CSTA(MCA) 
      IF (TYPA(1:1).EQ.'E') RCSTE=FLOAT(ISTA(MCA))  
      IF (TYP2(1:1).EQ.'R') THEN
*        Cas d'un tableau cible reel  
         IF (TYP1(1:1).EQ.'R') THEN 
            DO 11 I=1,NBC
               MCT2=MC2-1+PTR122(I) 
               RST2(MCT2)=RCSTE*RST1(MCT1)
11             MCT1=MCT1+1  
         ELSEIF (TYP1(1:1).EQ.'C') THEN
            DO 13 I=1,NBC 
               MCT2=MC2-1+PTR122(I)
               RST2(MCT2)=REAL(CCSTE*CST1(MCT1))
13             MCT1=MCT1+1
         ENDIF  
      ELSEIF (TYP2(1:1).EQ.'C') THEN 
*        Cas d'un tableau cible complexe  
         IF (TYP1(1:1).EQ.'C') THEN  
            DO 21 I=1,NBC 
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=CCSTE*CST1(MCT1)
21             MCT1=MCT1+1 
         ELSEIF (TYP1(1:1).EQ.'R') THEN 
            DO 22 I=1,NBC 
               MCT2=MC2-1+PTR122(I)
               CST2(MCT2)=CCSTE*RST1(MCT1)
22             MCT1=MCT1+1
         ENDIF
      ENDIF
                                                                    END !Tptqat
