*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TTENST (NBC1,TYP1,MC1,RST1,CST1
     &                  ,NBC2,TYP2,MC2,RST2,CST2,TYP3,MC3,RST3,CST3)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 1991)  
* Derniere modification (D.Martin) le 6 Decembre 1996 
*  
* Produit tensoriel de deux tableaux : Aij = T1i x T2j
*  
*-- Arguments d'entree -- 
* NBC1  nombre de coefficients du 1er tableau
* TYP1  type du 1er tableau ('REEL','COMPLEXE')  
* MC1   adresse du 1er tableau dans le tab. reel RST1 ou complexe CST1
* RST1  tableau contenant le 1er tableau (cas reel)  
* CST1  tableau contenant le 1er tableau (cas complexe)
* NBC2  nombre de coefficients du 2eme tableau  
* TYP2  type du 2eme tableau ('REEL','COMPLEXE') 
* MC2   adresse du 2eme tableau dans le tab. reel RST2 ou complexe CST2  
* RST2  tableau contenant le 2eme tableau (cas reel) 
* CST2  tableau contenant le 2eme tableau (cas complexe) 
* TYP3  type du tableau cible
* MC3   adresse du tab. cible dans le tab. reel RST3 ou complexe CST3
* RST3  tableau contenant le tableau cible (cas reel)
* CST3  tableau contenant le tableau cible (cas complexe)
*
* voir exemple d'utilisation dans le source de TDANST
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) TYP1,TYP2,TYP3 
      INTEGER       NBC1,MC1,NBC2,MC2,MC3
      REAL          RST1(*),RST2(*),RST3(*)
      COMPLEX       CST1(*),CST2(*),CST3(*)
*
      INTEGER       MCT1,MCT2,MCT3,LIG,IAD
*-----------------------------------------------------------------------
      MCT3=MC3
      MCT1=MC1-1
      IF (TYP3(1:1).EQ.'R') THEN
*        Cas d'un tableau cible reel  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN 
               DO 223 LIG=1,NBC1
                  MCT1=MCT1+1 
                  MCT2=MC2 
                  DO 222 IAD=MCT3,MCT3-1+NBC2 
                     RST3(IAD)=RST1(MCT1)*RST2(MCT2) 
222                  MCT2=MCT2+1
223               MCT3=MCT3+NBC2 
            ELSEIF (TYP1(1:1).EQ.'C') THEN 
               DO 443 LIG=1,NBC1
                  MCT1=MCT1+1 
                  MCT2=MC2 
                  DO 442 IAD=MCT3,MCT3-1+NBC2 
                     RST3(IAD)=REAL(CST1(MCT1)*CST2(MCT2))
442                  MCT2=MCT2+1
443               MCT3=MCT3+NBC2
            ENDIF
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 243 LIG=1,NBC1
               MCT1=MCT1+1 
               MCT2=MC2 
               DO 242 IAD=MCT3,MCT3-1+NBC2 
                  RST3(IAD)=RST1(MCT1)*REAL(CST2(MCT2)) 
242               MCT2=MCT2+1
243            MCT3=MCT3+NBC2      
         ELSE  
            DO 423 LIG=1,NBC1
               MCT1=MCT1+1 
               MCT2=MC2 
               DO 422 IAD=MCT3,MCT3-1+NBC2 
                  RST3(IAD)=REAL(CST1(MCT1))*RST2(MCT2) 
422               MCT2=MCT2+1
423            MCT3=MCT3+NBC2
         ENDIF
      ELSE 
*        Cas d'un tableau cible complexe  
         IF (TYP2(1:1).EQ.TYP1(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN 
               DO 225 LIG=1,NBC1
                  MCT1=MCT1+1 
                  MCT2=MC2 
                  DO 224 IAD=MCT3,MCT3-1+NBC2 
                     CST3(IAD)=RST1(MCT1)*RST2(MCT2) 
224                  MCT2=MCT2+1
225               MCT3=MCT3+NBC2 
            ELSEIF (TYP1(1:1).EQ.'C') THEN 
               DO 445 LIG=1,NBC1
                  MCT1=MCT1+1 
                  MCT2=MC2 
                  DO 444 IAD=MCT3,MCT3-1+NBC2 
                     CST3(IAD)=CST1(MCT1)*CST2(MCT2) 
444                  MCT2=MCT2+1
445               MCT3=MCT3+NBC2
            ENDIF
         ELSEIF (TYP2(1:1).EQ.'C') THEN
            DO 245 LIG=1,NBC1
               MCT1=MCT1+1 
               MCT2=MC2 
               DO 244 IAD=MCT3,MCT3-1+NBC2 
                  CST3(IAD)=RST1(MCT1)*CST2(MCT2) 
244               MCT2=MCT2+1
245            MCT3=MCT3+NBC2
         ELSE  
            DO 425 LIG=1,NBC1
               MCT1=MCT1+1 
               MCT2=MC2 
               DO 424 IAD=MCT3,MCT3-1+NBC2 
                  CST3(IAD)=CST1(MCT1)*RST2(MCT2) 
424               MCT2=MCT2+1
425            MCT3=MCT3+NBC2
         ENDIF
      ENDIF
                                                                    END !TtensT
