*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE TVECTT (NDIM1,TYP1,MC1,RST1,CST1
     &                  ,NDIM2,TYP2,MC2,RST2,CST2
     &                        ,TYP3,MC3,RST3,CST3)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1998)
* Derniere modification : D.Martin (7 Mars 1999)
* Version 1.0.0
*  
* Calcul du produit exterieur de deux vecteurs u et v
*
* NDIM1=2=NDIM2   : determinant de la matrice formee des vecteurs colonnes
*                 ( u_1*v_2 - u_2*v_1 )
* NDIM1=2 NDIM2=3 : produit exterieur 3D en completant u par u_3=0
*                 ( u_2*v_3           )
*                 (         - u_1*v_3 )
*                 ( u_1*v_2 - u_2*v_1 )
* NDIM1=3 NDIM2=2 : produit exterieur 3D en completant v par v_3=0
*                 (         - u_3*v_2 )
*                 ( u_3*v_1           )
*                 ( u_1*v_2 - u_2*v_1)
* NDIM1=3=NDIM2   : produit exterieur des 2 vecteurs
*                 ( u_2*v_3 - u_3*v_2 )
*                 ( u_3*v_1 - u_1*v_3 )
*                 ( u_1*v_2 - u_2*v_1 )
*-- Arguments -- 
* NDIMi  dimension du vecteur i
* TYPi  type reel ou complexe du vecteur no i 
* MCi   adresse du vecteur i dans le tableau du bon type RSTi ou CSTi
* RSTi  tableau contenant le vecteur i s'il est reel
* CSTi  tableau contenant le vecteur i s'il est complexe
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER*(*) TYP1,TYP2,TYP3
      INTEGER       NDIM1,MC1,NDIM2,MC2,MC3
      REAL          RST1(*),RST2(*),RST3(*)
      COMPLEX       CST1(*),CST2(*),CST3(*)  
*  
      CHARACTER ERRCAR*120 
      COMMON/FORMAH/ERRCAR 
*-----------------------------------------------------------------------
      IF (NDIM1.EQ.2.AND.NDIM2.EQ.2) THEN
        IF (TYP3(1:1).EQ.'R') THEN
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN
             RST3(MC3)=RST1(MC1)*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2) 
            ELSE
             GOTO 10001
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             GOTO 10002
            ELSE
             GOTO 10003
            ENDIF
          ENDIF
        ELSE
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN
             CST3(MC3)=CST1(MC1)*CST2(MC2+1)-CST1(MC1+1)*CST2(MC2) 
            ELSE
             CST3(MC3)=RST1(MC1)*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2) 
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             CST3(MC3)=RST1(MC1)*CST2(MC2+1)-RST1(MC1+1)*CST2(MC2) 
            ELSE
             CST3(MC3)=CST1(MC1)*RST2(MC2+1)-CST1(MC1+1)*RST2(MC2) 
            ENDIF
          ENDIF
        ENDIF
*-----------------------------------------------------------------------
      ELSEIF (NDIM1.EQ.3.AND.NDIM2.EQ.3) THEN
        IF (TYP3(1:1).EQ.'R') THEN
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN
             RST3(MC3  )=RST1(MC1+1)*RST2(MC2+2)-RST1(MC1+2)*RST2(MC2+1) 
             RST3(MC3+1)=RST1(MC1+2)*RST2(MC2  )-RST1(MC1  )*RST2(MC2+2) 
             RST3(MC3+2)=RST1(MC1  )*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2  ) 
            ELSE
             GOTO 10001
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             GOTO 10002
            ELSE
             GOTO 10003
            ENDIF
          ENDIF
        ELSE
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN
             CST3(MC3  )=CST1(MC1+1)*CST2(MC2+2)-CST1(MC1+2)*CST2(MC2+1) 
             CST3(MC3+1)=CST1(MC1+2)*CST2(MC2  )-CST1(MC1  )*CST2(MC2+2) 
             CST3(MC3+2)=CST1(MC1  )*CST2(MC2+1)-CST1(MC1+1)*CST2(MC2  )    
            ELSE
             CST3(MC3  )=RST1(MC1+1)*RST2(MC2+2)-RST1(MC1+2)*RST2(MC2+1) 
             CST3(MC3+1)=RST1(MC1+2)*RST2(MC2  )-RST1(MC1  )*RST2(MC2+2) 
             CST3(MC3+2)=RST1(MC1  )*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2  )
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             CST3(MC3  )=RST1(MC1+1)*CST2(MC2+2)-RST1(MC1+2)*CST2(MC2+1) 
             CST3(MC3+1)=RST1(MC1+2)*CST2(MC2  )-RST1(MC1  )*CST2(MC2+2) 
             CST3(MC3+2)=RST1(MC1  )*CST2(MC2+1)-RST1(MC1+1)*CST2(MC2  )
            ELSE
             CST3(MC3  )=CST1(MC1+1)*RST2(MC2+2)-CST1(MC1+2)*RST2(MC2+1) 
             CST3(MC3+1)=CST1(MC1+2)*RST2(MC2  )-CST1(MC1  )*RST2(MC2+2) 
             CST3(MC3+2)=CST1(MC1  )*RST2(MC2+1)-CST1(MC1+1)*RST2(MC2  )
            ENDIF
          ENDIF
        ENDIF
*-----------------------------------------------------------------------
      ELSEIF (NDIM1.EQ.2.AND.NDIM2.EQ.3) THEN
        IF (TYP3(1:1).EQ.'R') THEN
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN
             RST3(MC3  )=RST1(MC1+1)*RST2(MC2+2) 
             RST3(MC3+1)=                       -RST1(MC1  )*RST2(MC2+2) 
             RST3(MC3+2)=RST1(MC1  )*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2) 
            ELSE
             GOTO 10001
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             GOTO 10002
            ELSE
             GOTO 10003
            ENDIF
          ENDIF
        ELSE
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN
             CST3(MC3  )=CST1(MC1+1)*CST2(MC2+2) 
             CST3(MC3+1)=                       -CST1(MC1  )*CST2(MC2+2) 
             CST3(MC3+2)=CST1(MC1  )*CST2(MC2+1)-CST1(MC1+1)*CST2(MC2)    
            ELSE
             CST3(MC3  )=RST1(MC1+1)*RST2(MC2+2) 
             CST3(MC3+1)=                       -RST1(MC1  )*RST2(MC2+2) 
             CST3(MC3+2)=RST1(MC1  )*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2)
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             CST3(MC3  )=RST1(MC1+1)*CST2(MC2+2) 
             CST3(MC3+1)=                       -RST1(MC1  )*CST2(MC2+2) 
             CST3(MC3+2)=RST1(MC1  )*CST2(MC2+1)-RST1(MC1+1)*CST2(MC2)
            ELSE
             CST3(MC3  )=CST1(MC1+1)*RST2(MC2+2) 
             CST3(MC3+1)=                       -CST1(MC1  )*RST2(MC2+2) 
             CST3(MC3+2)=CST1(MC1  )*RST2(MC2+1)-CST1(MC1+1)*RST2(MC2)
            ENDIF
          ENDIF
        ENDIF
*-----------------------------------------------------------------------
      ELSEIF (NDIM1.EQ.3.AND.NDIM2.EQ.2) THEN
        IF (TYP3(1:1).EQ.'R') THEN
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'R') THEN
             RST3(MC3  )=                     -RST1(MC1+2)*RST2(MC2+1) 
             RST3(MC3+1)=RST1(MC1+2)*RST2(MC2) 
             RST3(MC3+2)=RST1(MC1)*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2) 
            ELSE
             GOTO 10001
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             GOTO 10002
            ELSE
             GOTO 10003
            ENDIF
          ENDIF
        ELSE
          IF (TYP1(1:1).EQ.TYP2(1:1)) THEN
            IF (TYP1(1:1).EQ.'C') THEN
             CST3(MC3  )=                     -CST1(MC1+2)*CST2(MC2+1) 
             CST3(MC3+1)=CST1(MC1+2)*CST2(MC2) 
             CST3(MC3+2)=CST1(MC1)*CST2(MC2+1)-CST1(MC1+1)*CST2(MC2)    
            ELSE
             CST3(MC3  )=                     -RST1(MC1+2)*RST2(MC2+1) 
             CST3(MC3+1)=RST1(MC1+2)*RST2(MC2) 
             CST3(MC3+2)=RST1(MC1)*RST2(MC2+1)-RST1(MC1+1)*RST2(MC2)
            ENDIF
          ELSE
            IF (TYP1(1:1).EQ.'R') THEN
             CST3(MC3  )=                     -RST1(MC1+2)*CST2(MC2+1) 
             CST3(MC3+1)=RST1(MC1+2)*CST2(MC2) 
             CST3(MC3+2)=RST1(MC1)*CST2(MC2+1)-RST1(MC1+1)*CST2(MC2)
            ELSE
             CST3(MC3  )=                     -CST1(MC1+2)*RST2(MC2+1) 
             CST3(MC3+1)=CST1(MC1+2)*RST2(MC2) 
             CST3(MC3+2)=CST1(MC1)*RST2(MC2+1)-CST1(MC1+1)*RST2(MC2)
            ENDIF
          ENDIF
        ENDIF
*-----------------------------------------------------------------------
      ELSE 
         GOTO 10000
      ENDIF
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
10000 CALL ENCLER (NDIM1,ERRCAR(1:3))
      CALL ENCLER (NDIM2,ERRCAR(4:6))
      CALL BAISE('*TVectT* (Lib-Utiliter) : Calcul de produit exterieur'
     &//' non prevu pour NDIM1 ='//ERRCAR(1:3)//', NDIM2='//ERRCAR(4:6)
     &//' !')
10001 CALL BAISE('*TVectT* (Lib-Utiliter) : Incompatibilite entre types'
     &//' Vecteur resultat reel / Vecteur 1 complexe et Vecteur 2 reel')
10002 CALL BAISE('*TVectT* (Lib-Utiliter) : Incompatibilite entre types'
     &//' Vecteur resultat reel / Vecteur 1 reel et Vecteur 2 complexe')
10003 CALL BAISE('*TVectT* (Lib-Utiliter) : Incompatibilite entre types'
     &//' Vecteur resultat reel / Vecteur 1 et Vecteur 2 complexes')

                                                                    END !TVectT
