*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE WATERM (ERRNUM,NMTERM,NVTERM)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mai 2000)
* Derniere modification : D.Martin (26 mar.2010)
* Version 2
*  
* Warnings pour un terme
*  
*-- Arguments d'entree --
* ERRNUM code d'erreur
* NMTERM nom du terme
* NVTERM niveau du terme
*-- Messages d'erreurs --
*- 1 Terme repete dans une structure d'assemblage
*- 2 Terme non reconnu comme symetrique, on le considere comme tel
*    en ignorant sa partie trinagulaire superieure
*- 3 Type de stockage non prevu dans la procedure
*-- Procedures utilisees --
* PRNTRA, ENCLER, WARNNG (Utilite)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMTERM
      INTEGER       ERRNUM,NVTERM
*
      INTEGER       DIXN,NBCARE,NCATRM
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRNTRA (NMTERM,NVTERM,ERCODE,NCATRM)
      DIXN=10
      DO 3 NBCARE=1,9
         IF (ABS(ERRNUM).LT.DIXN) GOTO 4
         DIXN=10*DIXN
3     CONTINUE
4     IF (ERRNUM.LT.0) NBCARE=NBCARE+1
      CALL ENCLER (ERRNUM,ERCODE(NCATRM+1:NCATRM+NBCARE))
*
      IF (ERRNUM.EQ.1) THEN
         CALL WARNNG  ('<Waterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' ne peut etre repete dans une structure d''assemblage.'
     &   //' La repetition est ignoree !')
      ELSEIF (ERRNUM.EQ.2) THEN
         CALL WARNNG  ('<Waterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' n''est pas reconnu comme SYMETRIQUE.'
     &   //' Aux risques et perils de l''utilisateur,'
     &   //' on le considere comme tel et on ignore sa partie'
     &   //' triangulaire superieure!')
      ELSEIF (ERRNUM.EQ.3) THEN
         CALL WARNNG  ('<Waterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' a un type de stockage non prevu dans la procedure.')
      ELSEIF (ERRNUM.EQ.4) THEN
         CALL WARNNG  ('<Waterm> Code '//ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //'- Le terme '//ERCODE(1:NCATRM)
     &   //' est de type complexe, non prevu dans la procedure. Pour'
     &   //'representer la partie reelle, imaginaire, le module...'
     &   //', l''extraire au prealable, e.g. a l''aide de T1TERM.')
      ELSE
         CALL WARNNG ('<Waterm> Appele avec le code '
     &   //ERCODE(NCATRM+1:NCATRM+NBCARE)
     &   //' non prevu - Terme '//ERCODE(1:NCATRM))
      ENDIF
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (26 mar.2010)
* - ajout d'un message dans le cas d'une sortie complexe pour un terme complexe
* Version 1 : D.Martin (22 aou.2000)
* Version 1 : D.Martin (avr.2000)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !WaTerm
