*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VPINIT (NMMATA,NVMATA,NMVALP,NVVALP
     &                  ,NMVECP,NVVECP,NMESVP,NVESVP
     &                  ,NBVPDS,NVECAC,DIMEST,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : F.Mahe, D.Martin (Novembre 1996)
* Derniere modification : D.Martin (7 Janvier 2004)
* Version 1.1
*  
* Creation des tableaux de valeurs et vecteurs propres (generalises) 
* et initialisation aleatoire des vecteurs propres d'un probleme aux 
* valeurs propres :
*                        A X = lambda [B] X.
* Si les tableaux existent mais pas de la bonne dimension, ils sont mis
* a jour sans modification des NVECAC 1eres valeurs deja calculees.
*  
*-- Arguments d'entree -- 
* NMMATA nom du tableau contenant la matrice A
* NVMATA son niveau
* NMVALP nom du tableau contenant les valeurs propres lambda. 
*        Si certaines d'entre elles ont deja ete calculees et que l'on en veut
*        d'autres le tableau contient les valeurs propres deja calculees
*        suivies des erreurs sur les valeurs propres suivantes non calculees
* NVVALP son niveau
* NMVECP nom du tableau contenant les vecteurs propres x (ranges par colonnes)
*        En entree les premiers peuvent etre deja calcules (NVECAC > 0) , ils
*        sont completes par initialisation aleatoire.
* NVVECP son niveau
* NMESVP nom du tableau contenant les "bornes d'erreur residuelle" sur 
*        les premieres val. prop. deja calculees (NVECAC) en entree et 
*        completees en sortie. Ce tableau est cree ou mis a jour.
* NVESVP son niveau
* NBVPDS nombre de valeurs propres desirees ( <= DIMEST )
* NVECAC nombre de valeurs propres deja calculees en entree (>= 0)
* DIMEST dimension du sous-espace de travail ( NBVPDS <= DIMEST <= NBLIGN )
* NIVIMP niveau d'impression des calculs
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMMATA,NMVALP,NMVECP,NMESVP
      INTEGER       NVMATA,NVVALP,NVVECP,NBVPDS,NVECAC,NIVIMP,NVESVP
     &             ,DIMEST
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER       INTTYP
      INTEGER       ITREEL,NBCOLO,NBLIGN,LGVALP,ITVALP,ITVECP
     &             ,LGVECP,MCVALP,MCVECP,IRND,I,MCCOLI
     &             ,MCDTRM,LGETRM,INCTRM,NBTERM,NCHTRM,NCATR1
      CHARACTER     TYPINT*8
      CHARACTER     ERCODE*120,SYMATA*14,STMATA*7
      CHARACTER*8   TYMATA,TYVECP
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*VpInit*')
*
      ITREEL=INTTYP ('REEL')                                            !utilite
*
      CALL ATTERM (NMMATA,NVMATA,TYMATA,SYMATA,NBCOLO,NBLIGN,STMATA)    !sdexplo
      IF (NBCOLO.NE.NBLIGN) CALL ERTERM (11,NMMATA,NVMATA)              !utilite
*
*     On cree ou on ajuste la taille du tableau des valeurs, vecteurs propres
*     et erreurs residuelles.
*
      IF (DIMEST.LT.NBVPDS) GOTO 99990
      IF (NBVPDS.GE.NBLIGN) GOTO 99991
      IF (DIMEST.GT.NBLIGN) GOTO 99992
*
      LGVALP=DIMEST
      ITVALP=ITREEL
      ITVECP=INTTYP (TYMATA)
      TYVECP=TYPINT (ITVECP)
      LGVECP=LGVALP*NBLIGN
      CALL TBCREE (NMVALP,NVVALP,ITVALP,LGVALP,'c')
*
      CALL TBCREE (NMVECP,NVVECP,ITVECP,LGVECP,'c')
      IF (NMESVP(1:1).NE.' ')
     &CALL TBCREE (NMESVP,NVESVP,ITREEL,LGVALP,'c')
      CALL TBAR2  (ERCODE,NMVALP,NVVALP,MCVALP,NMVECP,NVVECP,MCVECP)
      MCCOLI=MCVECP+NVECAC*NBLIGN
      IRND=0
*
*     Generation aleatoire des vecteurs supplementaires
*
      DO 10 I=NVECAC+1,LGVALP
         CALL TBRAND (IRND,NBLIGN,TYVECP,MCCOLI,IST,RST,CST)            !utilite
         MCCOLI=MCCOLI+NBLIGN
10    CONTINUE
*
      CALL TBSAVE (NMVALP,NVVALP)
      CALL TBSAVE (NMVECP,NVVECP)
      IF (NMESVP(1:1).NE.' ') CALL TBSAVE (NMESVP,NVESVP)
*
      IF (NIVIMP.GE.0) THEN
         CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
         CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)          !sdexplo
         CALL PRNTRM (NMVECP,NVVECP,ERCODE,NCATR1)
         IF (LGVALP.EQ.1) THEN
            WRITE (IMPPAL,10001) '*VpInit*',ERCODE(1:NCATR1)
         ELSE
            IF (NVECAC.EQ.0) THEN
               WRITE (IMPPAL,10002) '*VpInit*',LGVALP,ERCODE(1:NCATR1)
            ELSE
               WRITE (IMPPAL,10003) '*VpInit*',LGVALP-NVECAC
     &                                               ,ERCODE(1:NCATR1)
            ENDIF
         ENDIF
         IF (NIVIMP.GE.5) CALL PRTERM (NMVECP,NVVECP,NIVIMP,IMPSDR)
      ENDIF
      CALL PRFXMJ (-1,'*VpInit*')
      RETURN
*-----------------------------------------------------------------------
10001 FORMAT(/T2,A8,' Generation du vecteur aleatoire ',A)
10002 FORMAT(/T2,A8,' Generation des ',I3
     &,' vecteurs aleatoires du tableau ',A)
10003 FORMAT(/T2,A8,' Generation des ',I3
     &,' derniers vecteurs aleatoires du tableau ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99990 CALL ENCLER (DIMEST,ERCODE(1:3))
      CALL ENCLER (NBVPDS,ERCODE(4:6))
      CALL BAISE  ('La dimension du sous-espace de travail DIMEST='
     &//ERCODE(1:3)//' doit etre superieure au nombre de'
     &//' valeurs propres desire NBVPDS='//ERCODE(4:6)//'.')
99991 CALL PRNTRM (NMMATA,NVMATA,ERCODE,NCATR1)
      CALL BAISE ('Nombre de valeurs propres desirees > a la dimension'
     & //' de la matrice '//ERCODE(1:NCATR1))
99992 CALL ENCLER (DIMEST,ERCODE(1:3))
      CALL ENCLER (NBLIGN,ERCODE(4:9))
      CALL BAISE  ('La dimension du sous-espace de travail DIMEST='
     &//ERCODE(1:3)//' doit etre inferieure au nombre de'
     &//' lignes de la matrice NBLIGN='//ERCODE(4:9)//'.')
                                                                    END !VpInit
