*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VPOPTI (CHAINE,EPSIL,SAUT,ITMAX,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Avril 1999)
* Derniere modification : D.Martin (3 Mai 1999)
*
* Valeurs des donneees optionnelles des procedure VpMise & IteInv
*
*-- Argument d'entree --
* CHAINE chaine de caracteres pour decrire les options
*        La chaine est structuree sous la forme d'articles de
*        la forme <ITEM=ITEMVA> separes par des virgules ou ITEM vaut l'une
*        des chaines :
*           'Epsilon', 'Saut', 'Maximum_Iterations', ' Impression'
*        et ITEMVA est le nom d'une donnee declaree.
*-- Arguments de sortie --
* EPSIL  valeur (reelle) de seuil d'arret des iterations Epsilon
* SAUT   valeur (reelle) du parametre Saut
* ITMAX  nombre maximum d'iterations
* NIVIMP niveau d'impression
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) CHAINE
      INTEGER       ITMAX,NIVIMP
      REAL          EPSIL,SAUT
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     NMITEM*72,CHARAC*1
      INTEGER       INTDON,INTTYP,KELCHN
      INTEGER       NTIERE,MCMDON,MCDONN,LGEDON,NBDONN,INCDON,NCHDON
     &             ,NUDONN,ITYDON,NIVDON,ITYPDO,INTCON,INTENT,INTREL
     &             ,LGCHAI,NBLEFT,ARTICH,ARTIDB,ITEMCH,NBLIGN,NDEB,NFIN
      REAL          REELLE
      COMPLEX       COMPLE
      CHARACTER     ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*VpOpti*')
*
      INTCON=INTDON ('CONSTANTE')
      INTENT=INTTYP ('ENTIER')
      INTREL=INTTYP ('REEL')
*
      CALL TBAR2  (ERCODE,'#OMDON',1,MCMDON,'$DONNE',1,MCDONN)
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
      LGCHAI = LEN (CHAINE)
      NBLEFT = LGCHAI
*
*     Valeur de Epsilon
*
      CALL DCOCHN (CHAINE,LGCHAI,'Epsilon'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NUDONN = KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)   !utilite
         IF (NUDONN.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))              !utilite
*        Caracteristiques de la donnee
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.NE.INTCON) CALL ERDONN (2,NMITEM(1:ITEMCH))         !utilite
         IF (ITYPDO.NE.INTREL) CALL ERDONN (13,NMITEM(1:ITEMCH))        !utilite
*        Valeur de la donnee
         CALL OUTCST (NIVDON,ITYPDO,NTIERE,EPSIL,COMPLE,CHARAC)         !sdexplo
      ENDIF
*
*     Valeur de Saut
*
      CALL DCOCHN (CHAINE,LGCHAI,'Saut'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NUDONN = KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)   !utilite
         IF (NUDONN.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))              !utilite
*        Caracteristiques de la donnee
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.NE.INTCON) CALL ERDONN (2,NMITEM(1:ITEMCH))         !utilite
         IF (ITYPDO.NE.INTREL) CALL ERDONN (13,NMITEM(1:ITEMCH))        !utilite
*        Valeur de la donnee
         CALL OUTCST (NIVDON,ITYPDO,NTIERE,SAUT,COMPLE,CHARAC)          !sdexplo
      ENDIF
*
*     Valeur de Maximum_Iterations
*
      CALL DCOCHN (CHAINE,LGCHAI,'Maximum_Iterations'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NUDONN = KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)   !utilite
         IF (NUDONN.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))              !utilite
*        Caracteristiques de la donnee
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.NE.INTCON) CALL ERDONN (2,NMITEM(1:ITEMCH))         !utilite
         IF (ITYPDO.NE.INTENT) CALL ERDONN (13,NMITEM(1:ITEMCH))        !utilite
*        Valeur de la donnee
         CALL OUTCST (NIVDON,ITYPDO,ITMAX,REELLE,COMPLE,CHARAC)         !sdexplo
      ENDIF
*
*     Valeur de Impression
*
      CALL DCOCHN (CHAINE,LGCHAI,'Impression'
     &            ,ARTICH,ARTIDB,NMITEM,ITEMCH)                         !utilite
      NBLEFT = NBLEFT-ARTICH
      IF (ITEMCH.GT.0) THEN
         NUDONN = KELCHN (NMITEM(1:ITEMCH),AST(MCMDON),NBDONN,NCHDON)   !utilite
         IF (NUDONN.LE.0) CALL ERDONN (1,NMITEM(1:ITEMCH))              !utilite
*        Caracteristiques de la donnee
         CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)          !utilite
         IF (ITYDON.NE.INTCON) CALL ERDONN (2,NMITEM(1:ITEMCH))         !utilite
         IF (ITYPDO.NE.INTENT) CALL ERDONN (13,NMITEM(1:ITEMCH))        !utilite
*        Valeur de la donnee
         CALL OUTCST (NIVDON,ITYPDO,NIVIMP,REELLE,COMPLE,CHARAC)        !sdexplo
      ENDIF
*
21    IF (NBLEFT.GT.0) THEN
         NBLIGN=1+(LGCHAI-1)/80
         NDEB = 1
         WRITE (IMPPAL,90001) 'VpOpti',NBLEFT
         DO 90000 ITEMCH=1,NBLIGN
            NFIN  = MIN (NDEB+79,LGCHAI)
            WRITE (IMPPAL,90002) CHAINE(NDEB:NFIN)
            NDEB = NDEB +80
90000    CONTINUE
      ENDIF
*
      CALL PRFXMJ (-1,'*VpOpti*')
*-----------------------------------------------------------------------
90001 FORMAT (/T2,A8,' La chaine suivante n''a pu etre (totalement)'
     &,' dechiffree (reste',I3,' caracteres)')
90002 FORMAT ((T5,A))
      END
