*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE VPPREP (NMMATA,NVMATA,NMMATB,NVMATB,NMVALP,NVVALP
     &                  ,NMVECP,NVVECP,LGVALP
     &                  ,TYMATA,NMSTOA,NVSTOA,NMSYMA,NMTYKA,NMFACA
     &                  ,TYMATB,NMSTOB,NVSTOB,NMSYMB,NMTYKB,NMFACB
     &                  ,TYVALP,TYVECP,NBLIGN,NIVIMP)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & F.Mahe (Mars 1997)
* Derniere modification : D.Martin (3 novembre 2008)
* Version 3
*  
* Recherche des caracteristiques des matrices prealablement au calcul
* des valeurs propres par la methode d'iteration des sous-espaces pour
* le probleme: A x = lambda [B] x.
*  
*-- Arguments d'entree -- 
* NMMATA nom du tableau contenant la matrice A
* NVMATA son niveau
* NMMATB nom du tableau contenant la matrice B
*        (NMMATB=' ' pour le probleme non generalise: A x = lambda x)
* NVMATB son niveau
* NMVALP nom du tableau contenant les valeurs propres lambda calculees
*         suivies des erreurs sur les valeurs propres suivantes non calculees
* NVVALP son niveau
* NMVECP nom du tableau contenant les vecteurs propres x (ranges par colonnes)
*         -> en entree ils sont soit deja calcules (NVECAC.gt.0) 
*        soit initialises a l'aide de VpInit par exemple (NVECAC=0).
*        -> en sortie les vecteurs propres calcules.
* NVVECP son niveau
* LGVALP longueur du tableau recepteur des valeurs propres
*-- Arguments de sortie --
* TYMATA type (reel ou complexe) de la matrice A
* NMSTOA nom du tableau de stockage de la matrice A
* NVSTOA niveau du tableau de stockage de la matrice A
* NMSYMA nom de type de symetrie de la matrice A
* NMTYKA nom de type de calcul de la matrice A
* NMFACA nom de type (de factorisation) de la matrice A
* TYMATB type (reel ou complexe) de la matrice B
* NMSTOB nom du tableau de stockage de la matrice B
* NVSTOB niveau du tableau de stockage de la matrice B
* NMSYMB nom de type de symetrie de la matrice B
* NMTYKB nom de type de calcul de la matrice B
* NMFACB nom de type (de factorisation) de la matrice B
* TYVALP type (reel ou complexe) du tableau contenant les valeurs propres
* TYVECP type (reel ou complexe) du tableau contenant les vecteurs propres
* NBLIGN nombre de lignes de la matrice
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      CHARACTER*(*) NMMATA,NMMATB,NMVALP,NMVECP,TYVALP,TYVECP
     &             ,TYMATA,NMSTOA,NMSYMA,NMTYKA,NMFACA
     &             ,TYMATB,NMSTOB,NMSYMB,NMTYKB,NMFACB
      INTEGER       NVMATA,NVVALP,NVVECP,LGVALP,NVMATB,NVSTOA,NVSTOB
     &             ,NBLIGN,NIVIMP
*  
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      CHARACTER     STODLN*6,TYPINT*8,SYMIND*14,YKLINT*6,FACIND*6
      LOGICAL       CRETRM
      INTEGER       INDSTO,KLNIVE,KLTERM,INDSYM,INTTYP,INTYKL
      INTEGER       ITMATA,NUDONN,ITYSYA,NVDSMA,NUINCC,NVDUCA,NBNECA
     &             ,NVNUCA,NUINCL,NVDULA,NBNELA,NVNULA,INSTOA,NVCOOR
     &             ,IATRDO,NIVIMA,ITFACA,NUFACA
     &             ,ITMATB,ITYSYB,NVDSMB,NVDUCB,NBNECB,NVNUCB,NVDULB
     &             ,NBNELB,NVNULB,INSTOB,NIVIMB,ITFACB,NUFACB
     &             ,MCMTRM,MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,NUTERM
     &             ,IADTRM,NCPICA,NCPILA,INTERP,NBTNEU,ITVALP,NVVMAT
     &             ,KVVECP,ITVECP,ITYCAL,KUKALE,KUDONN,KTYSYM,NVDSSO
     &             ,KUINCC,KVDUMC,KBNECC,KVNUMC,KUINCL,KVDUML,KBNELL
     &             ,KVNUMV,KNDSTK,KVSTOK,KVCOOR,KATRDO,KIVIMP
     &             ,NCPICB,NCPILB,MCSTOK,MCLENV,MCUENV
     &             ,NBL,LGL,NBC,LGU,LONTRM,MCSTOD,NBLIDL,NBCODL,MCUVDL
     &             ,MCLVDL,INDSBI,INDSPR,ITYSNO,MCINCO
      CHARACTER     ERCODE*120,YADLCA,YADLLA,MULTIM
      COMMON/FORMAH/ERCODE 
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*VpPrep*')
*
      INDSBI=INDSTO ('BIMORSE')                                         !utilite
      INDSPR=INDSTO ('PROFIL')                                          !utilite
      ITYSNO=INDSYM (' ')                                               !utilite
*  
*     Recherche des adresses des structures de description des termes :
*     tableaux #OMTRM et $SDTRM
      CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'$SDTRM',1,MCDTRM
     &                   ,'#NCONU',1,MCINCO)                     
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !sdexplo
*
*--   Recherche des attributs de la matrice NMMATA 
* 
      NUTERM=KLTERM (NMMATA,NVMATA,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.LE.0) CALL ERTERM (1,NMMATA,NVMATA)                    !utilite
      IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
      CALL GETTRM (IST(IADTRM),NVVMAT
     &            ,ITMATA,ITFACA,NUFACA,NUDONN,ITYSYA,NVDSMA
     &            ,NUINCC,NVDUCA,NBNECA,NVNUCA
     &            ,NUINCL,NVDULA,NBNELA,NVNULA
     &            ,INSTOA,NVSTOA,NVCOOR,IATRDO,NIVIMA)                  !sdexplo
      TYMATA=TYPINT (ITMATA)                                            !utilite
      NMTYKA=YKLINT (ITFACA)                                            !utilite
      NMFACA=' '
      IF (NMTYKA.EQ.'FACTOR') NMFACA=FACIND (NUFACA)                    !utilite
      NCPICA=1
      NCPILA=1
      IF (NUINCC.NE.NDFINC)
     &CALL SDEXCO (NUINCC,IST(MCINCO),NCPICA,INTERP,NBTNEU)             !sdexplo
      IF (NUINCL.NE.NDFINC)
     &CALL SDEXCO (NUINCL,IST(MCINCO),NCPILA,INTERP,NBTNEU)             !sdexplo
      IF (NBNECA.NE.NBNELA) CALL ERTERM (11,NMMATA,NVMATA)              !utilite
      IF (NCPICA.NE.NCPILA) CALL ERTERM (16,NMMATA,NVMATA)              !utilite
      NMSYMA=SYMIND (ITYSYA)                                            !utilite
      NMSTOA=STODLN (INSTOA, NCPICA, NCPILA)                            !utilite
      NBLIGN=NBNELA*NCPILA
*
      MULTIM='N'
      IF (NVDSMA.NE.NDFDSM.AND.NUINCC.EQ.NDFINC.AND.NUINCL.EQ.NDFINC)
     &   MULTIM='Y'
*     Faut-il les numerotations en d.l.
      CALL FONUDL (NCPICA,NCPILA,NVNUCA,NVNULA,0,0,0,0,NVDUCA,NVDULA
     &            ,YADLCA,YADLLA)                                       !sdexplo
      IF (YADLCA.EQ.'C') 
     &   CALL PUTTRM (IST(IADTRM),NVVMAT
     &               ,ITMATA,ITFACA,NUFACA,NUDONN,ITYSYA,NVDSMA
     &               ,NUINCC,NVDUCA,NBNECA,NVNUCA
     &               ,NUINCL,NVDUCA,NBNELA,NVNULA
     &               ,INSTOA,NVSTOA,NVCOOR,IATRDO,NIVIMA)               !sdexplo
*  
*--   Recherche des attributs de la matrice NMMATB
*
      INSTOB=0
      ITMATB=INTTYP ('REEL')                                            !utilite
      NVSTOB=NVSTOA
      NCPICB=1
      NCPILB=1
      NMSTOB=' '
      TYMATB=' '
      NMSYMB=' '
      NMTYKB=' '
      NMFACB=' '
      IF (NMMATB(1:1).NE.' ') THEN
         NUTERM=KLTERM (NMMATB,NVMATB,AST(MCMTRM),IST(MCDTRM))          !sdexplo
         IF (NUTERM.LE.0) CALL ERTERM (1,NMMATB,NVMATB)                 !utilite
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM)  ,NVVMAT
     &               ,ITMATB,ITFACB,NUFACB,NUDONN,ITYSYB,NVDSMB 
     &               ,NUINCC,NVDUCB,NBNECB,NVNUCB
     &               ,NUINCL,NVDULB,NBNELB,NVNULB
     &               ,INSTOB,NVSTOB,NVCOOR,IATRDO,NIVIMB)               !sdexplo
         TYMATB=TYPINT (ITMATB)                                         !utilite
         NMTYKB=YKLINT (ITFACB)                                         !utilite
         NMFACB=' '
         IF (NMTYKB.EQ.'FACTOR') NMFACB=FACIND (NUFACB)                 !utilite
         IF (NBNECB.NE.NBNELB) CALL ERTERM (11,NMMATB,NVMATB)           !utilite
         IF (NBNECA.NE.NBNECB) GOTO 99993
         IF (NUINCC.NE.NDFINC)
     &   CALL SDEXCO (NUINCC,IST(MCINCO),NCPICB,INTERP,NBTNEU)          !sdexplo
         IF (NUINCL.NE.NDFINC)
     &   CALL SDEXCO (NUINCL,IST(MCINCO),NCPILB,INTERP,NBTNEU)          !sdexplo
         IF (NCPICB.NE.NCPICA.OR.NCPILB.NE.NCPILA) GOTO 99991
         NMSYMB=SYMIND (ITYSYB)                                         !utilite
         NMSTOB = STODLN (INSTOB, NCPICB, NCPILB)                       !utilite
*        On prend pour B les memes numerotations en d.l. que celles de A
         IF (YADLCA.NE.'N')
     &      CALL PUTTRM (IST(IADTRM),NVVMAT
     &                  ,ITMATB,ITFACB,NUFACB,NUDONN,ITYSYB,NVDSMB
     &                  ,NUINCC,NVDUCA,NBNECB,NVNUCB
     &                  ,NUINCL,NVDUCA,NBNELB,NVNULB
     &                  ,INSTOB,NVSTOB,NVCOOR,IATRDO,NIVIMB)            !sdexplo
      ENDIF
      TYMATB=TYPINT (ITMATB)                                            !utilite
*
*--   Recherche des attributs du terme 'Vecteurs Propres' s'il existe
*
      NVALNE=NCPICA
      NUTERM=KLTERM (NMVECP,NVVECP,AST(MCMTRM),IST(MCDTRM))             !sdexplo
      IF (NUTERM.GT.0) THEN
         IADTRM=MCDTRM+LGETRM+INCTRM*(NUTERM-1)
         CALL GETTRM (IST(IADTRM),KVVECP
     &               ,ITVECP,ITYCAL,KUKALE,KUDONN,NVALNE,NVDSSO
     &               ,KUINCC,KVDUMC,KBNECC,KVNUMC
     &               ,KUINCL,KVDUML,KBNELL,KVNUMV
     &               ,KNDSTK,KVSTOK,KVCOOR,KATRDO,KIVIMP)               !sdexplo
      ENDIF
*
      IF (YADLCA.EQ.'C') THEN
*
*--      Creation des numerotations en d.l. de la matrice NMMATA
*
         CALL NUM2DL (NCPICA,NVNUCA,NVDUCA,NBLIGN,NIVIMA)
*     Rajout le 29/04/2008
      ENDIF
*
*     Rajout le 29/04/2008 et modifie le 08/10/2008
      IF (NMSTOA(5:6).NE.'RS'.AND.NMSTOA(5:6).NE.'11') THEN
*        Creation du stockage en d.l. de la matrice NMMATA
         IF (INSTOA.EQ.INDSBI) THEN
*
*--      Compactage bimorse en d.l. de la matrice NMMATA
*
            CALL BMO2DL (NVSTOA,NCPICA,NCPICA,ITYSYA,NMMATA,NVMATA
     &                  ,NIVIMA)                                        !sdexplo
*
         ELSEIF (INSTOA.EQ.INDSPR) THEN
*
*--      Compactage profil en d.l. de la matrice NMMATA
*
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOA,NVSTOA,MCSTOK)
            IF (ERCODE(1:1).NE.' ') THEN
               CALL TBRR1  (ERCODE,'&PROFL',NVSTOA,MCSTOK)
               CALL TBAR1  (ERCODE,'&PROFL',NVSTOA,MCSTOK)
               CALL EXPROF  (MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                         ,NBC,MCUENV,LGU)         !sdexplo
               LONTRM=2+NBL*NCPILA
               IF (ITYSYA.EQ.ITYSNO) LONTRM=LONTRM+NBC*NCPICA+1
               CALL TBCREE (NMSTOA,NVSTOA,1,LONTRM,'c')
               CALL TBAR2  (ERCODE,'&PROFL',NVSTOA,MCSTOK
     &                            ,NMSTOA,NVSTOA,MCSTOD)
               CALL EXPROF (MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                        ,NBC,MCUENV,LGU)          !sdexplo
               MCLVDL=MCSTOD+2 
               CALL N2DLPR (NCPICA,NCPILA,NBL,NBC,IST(MCLENV),NBLIDL
     &                     ,IST(MCLVDL))                                !sdexplo
               IST(MCSTOD)=2
               IST(MCLVDL-1)=NBLIDL
               IF (ITYSYA.EQ.ITYSNO) THEN
                  IST(MCSTOD)=3+NBLIDL
                  MCUVDL=MCLVDL+NBLIDL+1
                  CALL N2DLPR (NCPILA,NCPICA,NBC,NBL,IST(MCUENV),NBCODL
     &                        ,IST(MCUVDL))                             !morse
                  IST(MCUVDL-1)=NBCODL
               ENDIF
               IF (NIVIMA.GE.5) 
     &         CALL PRPROF (IST(MCSTOD),'*VpPrep* Tables Profil en d.l.'
     &                     ,NMMATA,NVMATA,NIVIMA,IMPSDR)                !prsdd
               CALL TBSAVE ('&PROFL',NVSTOA)                     
            ENDIF
         ELSE
            GOTO 99994
         ENDIF
      ENDIF
*
*     Rajout le 29/04/2008, modifie le 08/10/2008
      IF (NMMATB(1:1).NE.' '.AND.
     &    NMSTOB(5:6).NE.'RS'.AND.NMSTOB.NE.'11') THEN
*        Creation du stockage en d.l. de la matrice B si neccessaire
         IF (INSTOB.EQ.INDSBI) THEN
*
*--         Compactage bimorse en d.l. de la matrice B si neccessaire
*
            CALL BMO2DL (NVSTOB,NCPICA,NCPICA,ITYSYB,NMMATB,NVMATB
     &                  ,NIVIMB)                                        !sdexplo
*
         ELSEIF (INSTOB.EQ.INDSPR) THEN
*
*--         Compactage profil en d.l. de la matrice B si neccessaire
*
            ERCODE(1:1)='!'
            CALL TBRR1  (ERCODE,NMSTOB,NVSTOB,MCSTOK)
            IF (ERCODE(1:1).NE.' ') THEN
               CALL TBRR1  (ERCODE,'&PROFL',NVSTOB,MCSTOK)
               CALL TBAR1  (ERCODE,'&PROFL',NVSTOB,MCSTOK)
               CALL EXPROF (MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                        ,NBC,MCUENV,LGU)          !sdexplo
               LONTRM=2+NBL*NCPILB
               IF (ITYSYB.EQ.ITYSNO) LONTRM=LONTRM+NBC*NCPICB+1
               CALL TBCREE (NMSTOB,NVSTOB,1,LONTRM,'c')
               CALL TBAR2  (ERCODE,'&PROFL',NVSTOB,MCSTOK
     &                            ,NMSTOB,NVSTOB,MCSTOD)
               CALL EXPROF(MCSTOK,IST(MCSTOK),NBL,MCLENV,LGL
     &                                       ,NBC,MCUENV,LGU)           !sdexplo
               MCLVDL=MCSTOD+2
               CALL N2DLPR (NCPICB,NCPILB,NBL,NBC,IST(MCLENV),NBLIDL
     &                     ,IST(MCLVDL))                                !sdexplo
               IST(MCSTOD)=2
               IST(MCLVDL-1)=NBLIDL
               IF (ITYSYB.EQ.ITYSNO) THEN
                  IST(MCSTOD)=3+NBLIDL
                  MCUVDL=MCLVDL+NBLIDL+1
                  CALL N2DLPR (NCPILB,NCPICB,NBC,NBL,IST(MCUENV),NBCODL
     &                        ,IST(MCUVDL))                             !morse
                  IST(MCUVDL-1)=NBCODL
               ENDIF
               IF (NIVIMB.GE.5) 
     &         CALL PRPROF (IST(MCSTOD),'*Vpprep* Table Profil en d.l.' 
     &                     ,NMMATB,NVMATB,NIVIMB,IMPSDR)                !prsd
            ENDIF
            CALL TBSAVE ('&PROFL',NVSTOB)
         ELSE
            GOTO 99994
         ENDIF
      ENDIF
*  
*--   Recherche du type du tableau des valeurs propres NMVALP
*
      CALL TBTYPE (NMVALP,NVVALP,ITVALP)
      TYVALP=TYPINT (ITVALP)                                            !utilite
*  
*--   Recherche du type du tableau des vecteurs propres NMVECP
*
      CALL TBTYPE (NMVECP,NVVECP,ITVECP)
      TYVECP=TYPINT (ITVECP)                                            !utilite
*
*--   Creation ou mise a jour du terme contenant les vecteurs propres
*
      IF (MULTIM.EQ.'Y'.AND.NVDSSO.EQ.NDFDSM.AND.NVDSMA.NE.NDFDSM) THEN
          NVDSSO=KLNIVE ()                                              !sdexplo
      ENDIF
*
      ITYCAL=INTYKL('SOLUTI')
      CALL CRTERM (NMVECP,NVVECP,NBLIGN*LGVALP,ITVECP,ITYCAL,-1
     &            ,NDFDON,NVALNE,NVDSSO,NDFINC,NDFDUM,LGVALP,NDFNUM
     &            ,NUINCL,NVDULA,NBNELA,NVNULA,INDSTO('PLEIN-C')
     &            ,NDFSTO,NDFCOR,0,NIVIMP,.FALSE.,CRETRM)               !sdexplo
*
      IF (MULTIM.EQ.'Y'.AND.NVDSSO.NE.NDFDSM) THEN
*
*        Creation de la structure $DSMBL pour le resultat.
*        On recopie les attributs liee aux colonnes de la matrice
*
         CALL MKSDDS (NVDSMA,'C',0,0,0,0,0,0,NVDSSO)                    !sdexplo
         CALL TBSAVE ('$DSMBL',NVDSMA)
         CALL TBSAVE ('$DSMBL',NVDSSO)
*
      ENDIF
*
      CALL PRFXMJ (-1,'*VpPrep*')
      RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99991 ERCODE=NMMATA
      CALL ENCLER (NVMATA,ERCODE(1+NCHTRM:2*NCHTRM))
      ERCODE(1+2*NCHTRM:3*NCHTRM)=NMMATB
      CALL ENCLER (NVMATB,ERCODE(1+3*NCHTRM:4*NCHTRM))
      CALL BAISE  (' Incompatibilite entre les inconnues de la matrice ' 
     &//' : '//ERCODE(1:NCHTRM)//' ,niveau '//ERCODE(1+NCHTRM:2*NCHTRM)
     &//' et la matrice : '//ERCODE(1+2*NCHTRM:3*NCHTRM)//' ,niveau '
     &//ERCODE(1+3*NCHTRM:4*NCHTRM))
99993 ERCODE=NMMATA
      CALL ENCLER (NVMATA,ERCODE(1+NCHTRM:2*NCHTRM))
      ERCODE(1+2*NCHTRM:3*NCHTRM)=NMMATB
      CALL ENCLER (NVMATB,ERCODE(1+3*NCHTRM:4*NCHTRM))
      CALL BAISE  (' Incompatibilite entre les tailles des matrices : '
     &//ERCODE(1:NCHTRM)//' ,niveau '//ERCODE(1+NCHTRM:2*NCHTRM)
     &//' et '//ERCODE(1+2*NCHTRM:3*NCHTRM)//' ,niveau '
     &//ERCODE(1+3*NCHTRM:4*NCHTRM))
99994 CALL BAISE  ('Cas d''une inconnue vectorielle, stockage de la '
     &//'matrice du autre que BIMORSE ou PROFIL non prevu')
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 3 : D.Martin (08 octobre/03 novembre 2008)
*  Changement de nom des structures en DL (appel de STODLN)
* Version 2 : D.Martin (29 avril 2008)
*  Bug : oubli de creation en D.L. de la matrice 'B' lorsque la matrice 'A' en 
*        possede deja un
* Version 1.0.5 : D.Martin (18 Juin 2002)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

                                                                    END !VpPrep
