      SUBROUTINE DEFCHO (CLIC,NBCOL,NUMREP,MAILLA,ZMIN,ZMAX,PASCOL,
     &                   NBFEN,VALPRJ,AXES)

C- Fonction : Modifications lies au choix de la souris
C-
C- Entree :
C-    CLIC : Valeur du clic du mulot
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    
C- Sortie : -
C-    NUMREP : Type de representation
C-    MAILLA :  : Maillage ou non
C-    ZMIN,ZMAX : Min et max des Z
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    NBFEN : Nombre de fenetres
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-    AXES : Traces ou non des axes
C-
C- Derniere modif : 24 FEV 2003

      INTEGER CLIC,NBCOL,NUMREP,NBFEN
      LOGICAL MAILLA,AXES
      REAL ZMIN,ZMAX,PASCOL,VALPRJ(*)

      GOTO (10,20,30,40,50,60,70,80,90,100,110,120,130,140,150,160,170)
     &      CLIC

C- Maillage
10    NUMREP=1
      RETURN

C- Iso.lignes
20    NUMREP=2
      RETURN

C- Iso.planes
30    NUMREP=3
      RETURN

C- Iso.en elevation
40    NUMREP=4
      RETURN

C- Maillage ou pas
50    MAILLA=.NOT.MAILLA
      RETURN

C- Mono/Multi-fenetrage
60    CALL PGSAVE ()
      IF (NBFEN.EQ.1) THEN
         NBFEN=4
         CALL PGSUBP (2,2)
      ELSE
         NBFEN=1
         NUMREP=1
         CALL PGSUBP (1,1)
         CALL PGUNSA ()
      ENDIF
      RETURN

C- Changement de ZMIN
70    CALL MENUZ (ZMIN,1)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

C- Changement de ZMAX
80    CALL MENUZ (ZMAX,2)
      PASCOL=(ZMAX-ZMIN)/NBCOL
      RETURN

C- Zoom -
90    VALPRJ(3) = VALPRJ(3) * 0.9
      RETURN

C- Zoom +
100   VALPRJ(3) = VALPRJ(3) / 0.9
      RETURN

C- PHI - 
110   VALPRJ(1) = VALPRJ(1) - 10.0
      RETURN

C- PHI +
120   VALPRJ(1) = VALPRJ(1) + 10.0
      RETURN

C- THETA - 
130   VALPRJ(2) = VALPRJ(2) - 10.0
      RETURN

C- THETA +
140   VALPRJ(2) = VALPRJ(2) + 10.0
      RETURN

C- AXES (O/N)
150   AXES=.NOT.AXES
      RETURN
      
C- Sortie Fichier
160   RETURN

C- Quitter
170   RETURN

      END
