      SUBROUTINE DESFIC (NBLMAX,NUMREP,MAILLA,ARETES,X,Y,Z,ZMIN,N,NBEL,
     &                   NBCOL,PASCOL,VALPRJ)

C- Fonction : Dessin du fichier en representation NUMREP
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    ZMIN   : Min des Z
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Local :
C-    XP,YP,ZP : Coordonnees des triangles
C-    NBARET   : Nombre d'aretes
C-    TRIARE   : Tableau contenant les 3 aretes d'un triangle
C-
C- Derniere modif : 17 JAN 2003

      INTEGER NBLMAX,NUMREP,N(NBLMAX,*),NBEL,NBCOL,ARETES(*),NBARET
      INTEGER TRIARE(6),I,J,K,L
      REAL X(*),Y(*),Z(*),ZMIN,PASCOL,VALPRJ(*),XP(3),YP(3),ZP(3)
      LOGICAL MAILLA

C- Initialisation du nombre d'aretes
      NBARET=0

C- Ouverture du buffer 
      CALL PGBBUF ()      
      
C- Creation des triangles. 
      DO 50 I=1,NBEL
         DO 10 J=1,3
            XP(J) = X(N(I,J))
            YP(J) = Y(N(I,J))
            ZP(J) = Z(N(I,J))
10       CONTINUE

C- On dessine les triangles en couleur en NUMREP>1
         IF (NUMREP.GT.1) 
     &      CALL TRINIV (NUMREP,XP,YP,ZP,ZMIN,PASCOL,VALPRJ)

C- On trace le maillage ou les bords des isovaleurs planes        
C- en blanc pour NUMREP=1 et 2, en noir pour NUMREP 3 e t 4
C- On trace toujours en NUMREP=1 sinon ya rien a voir 
         IF (MAILLA.OR.NUMREP.EQ.1) THEN
            IF (NUMREP.LT.3) THEN
               CALL PGSCI (NBCOL+1)
            ELSE
               CALL PGSCI (0)
            ENDIF
C- On passe en pointille en NUMREP>1
            IF (NUMREP.GT.1) CALL PGSLS (4)
            CALL PGSFS (2)
            CALL DESCAS (NUMREP,3,XP,YP,ZP,VALPRJ)
            IF (NUMREP.GT.1) CALL PGSLS (1) 
         ENDIF

C- On cherche les aretes 
         IF (.NOT.MAILLA.AND.NUMREP.EQ.2) THEN
            CALL CREARE (NBLMAX,N,I,TRIARE)
            DO 40 J=1,3
C- On teste chaque nouvelle arete. 
               DO 30 K=1,NBARET/2
                  IF (TRIARE(2*J-1).EQ.ARETES(2*K-1) .AND.
     &                TRIARE(2*J).EQ.ARETES(2*K)) THEN
C- L'arete ARETES(2*K-1,2*K) existe deja. On la supprime puisque
C- une arete ne peut etre utilisee que 1 ou 2 fois.
                     DO 20 L=K,NBARET/2
                        ARETES(2*L-1)=ARETES(2*L+1)
                        ARETES(2*L)=ARETES(2*L+2)
20                   CONTINUE
                     NBARET=NBARET-2             
                     GOTO 40
                  ENDIF
30             CONTINUE
C- Si on est arrive la, l'arete est nouvelle. Donc on l'ajoute
               ARETES(NBARET+1)=TRIARE(2*J-1)
               ARETES(NBARET+2)=TRIARE(2*J)
               NBARET=NBARET+2
40          CONTINUE
         ENDIF
50    CONTINUE

C- On trace les arete
      IF (.NOT.MAILLA.AND.NUMREP.EQ.2) THEN
         CALL PGSCI (NBCOL+1)
         DO 60 I=1,NBARET/2
            J=ARETES(2*I-1)
            K=ARETES(2*I)
            CALL PGMOVE (X(J),Y(J))
            CALL PGDRAW (X(K),Y(K))
60       CONTINUE
      ENDIF

C- Fermeture du buffer (i.e affichage)
      CALL PGEBUF ()

      END
