      SUBROUTINE DESPOL (NUMREP,KOLOR,X,Y,Z,NBPTS,VALPRJ)

C- Fonction : Remplissage d'un polygone a 3, 4 ou 5 cotes
C-
C- Entree :
C-    NUMREP : Type de representation
C-    KOLOR : Couleur de trace du polygone
C-    X,Y,Z : Coordonnees des sommets du polygone
C-    NBPTS : Nombre de sommets du polygone
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Local :
C-    ANGLE : Calcul des angles en ccoordonnees polaires
C-    XT,YT,ZT : Sert au calcul du barycentre et au tri des angles
C-    AT : Sert au tri des angles
C-    PI : Constante Pi
C-
C- Derniere modif : 20 JAN 2003

      INTEGER NUMREP,KOLOR,NBPTS,I
      REAL X(*),Y(*),Z(*),VALPRJ(*),ANGLE(5),XT,YT,ZT,AT,PI
      PARAMETER (PI=3.14159)
      
      IF (NBPTS.LT.3.OR.NBPTS.GT.5) CALL BLEME (9)

      CALL PGSCI (KOLOR)
      CALL PGSFS (1)
C- Triangle
      IF (NBPTS.EQ.3) THEN
         CALL DESCAS (NUMREP,3,X,Y,Z,VALPRJ)
         RETURN
      ENDIF

C- Quad/Pentangle : On calcule le barycentre et les angles des 4/5 points
C- Calcul du barycentre
      XT=0.0
      YT=0.0
      DO 50 I=1,NBPTS
         XT=XT+X(I)
         YT=YT+Y(I)
50    CONTINUE     
      XT=XT/NBPTS
      YT=YT/NBPTS
      DO 60 I=1,NBPTS
         ANGLE(I)=ATAN((Y(I)-YT)/(X(I)-XT))
         IF (X(I).LT.XT) ANGLE(I)=ANGLE(I)+PI
60    CONTINUE

C-   On trie les angles
70    CONTINUE
      DO 80 I=1,NBPTS-1
         IF (ANGLE(I+1).LT.ANGLE(I)) THEN
            AT=ANGLE(I)
            XT=X(I)
            YT=Y(I)
            ZT=Z(I)
            ANGLE(I)=ANGLE(I+1)
            X(I)=X(I+1)
            Y(I)=Y(I+1)
            Z(I)=Z(I+1)
            ANGLE(I+1)=AT
            X(I+1)=XT
            Y(I+1)=YT
            Z(I+1)=ZT
            GOTO 70
         ENDIF
80    CONTINUE   

      CALL DESCAS (NUMREP,NBPTS,X,Y,Z,VALPRJ)

      END
