      SUBROUTINE DESSIN (NBLMAX,NBFEN,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,
     &                   YMIN,ZMIN,XMAX,YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,
     &                   TABCOL,AXES,LABEL,VALPRJ)

C- Fonction : Dessin du ou des NBFICH fichiers en fonction des differentes
C-            variables (NUMREP,NBFEN,...)
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    NBFEN  : Nombre de fenetres
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    XMIN,YMIN,ZMIN : Min des X,Y,Z
C-    XMAX,YMAX,ZMAX : Max des X,Y,Z
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-    AXES   : Traces ou non des axes
C-    LABEL  : Labels i.e commentaires des dessins
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Derniere modif : 17 JAN 2002

      INTEGER NBLMAX,NBFEN,NUMREP,ARETES(*),N(NBLMAX,*),NBEL,NBCOL
      LOGICAL MAILLA,AXES
      REAL X(*),Y(*),Z(*),XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,PASCOL,TABCOL
      REAL VALPRJ(*)
      CHARACTER*80 LABEL

C- On "nettoie" la fenetre
      CALL PGPAGE ()

C- Cas simple, on a une fenetre
      IF (NBFEN.EQ.1) THEN
         CALL  REPFIC (NBLMAX,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,YMIN,ZMIN,
     &                 XMAX,YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &                 LABEL,VALPRJ)
      ELSE
         DO 10 NUMREP=1,4
            CALL  REPFIC (NBLMAX,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,YMIN,
     &                    ZMIN,XMAX,YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,
     &                    TABCOL,AXES,LABEL,VALPRJ)
C- On passe a la sous-fenetre suivante sauf le dernier sinon on passe a une 
C- autre fenetre. Capito ?
            IF (NUMREP.LT.4) CALL PGPAGE ()
10       CONTINUE
      ENDIF

      END 
 
