      SUBROUTINE ENTDON (NBFIMX,NBFICH,FICHGE,FICHRE,NOMFIC,ENTREE,
     &                   LABEL)

C- Fonction : Entree des donnees
C-
C- Entree :
C-    NBFIMX : Nombre maximum de fichiers
C-
C- Sortie :
C-    NBFICH : Nombre de fichiers
C-    FICHGE : Nom du(es) fichier(s) de geometrie 
C-    FICHRE : Nom du(es) fichier(s) de resultats
C-    NOMFIC : Nom du fichier, lu dans le fichier FICHRE
C-    ENTREE : Repertoire contenant les fichiers de donnees
C-    LABEL  : Label i.e commentaires des dessins
C-
C- Local :
C-    CHOIX  : Choix de l'utilisateur
C-    FICHEX : Teste la presence des fichiers
C-    IFICH  : Indice de fichiers
C-    LONGCH : Fonction calculant la longueur reelle d'une chaine
C-    LONNOM : Longueur des noms pour ecriture sans blancs
C-    NOMLU  : Nom entree au clavier ou lu dans un fichier. A nettoyer 
C-
C- Derniere modif : 16 JAN 2003

      INTEGER NBFIMX,NBFICH,IFICH,LONGCH,LONNOM
      CHARACTER*(*) FICHGE(NBFIMX),FICHRE(NBFIMX),NOMFIC(NBFIMX)
      CHARACTER*(*) LABEL
      CHARACTER CHOIX,NOMLU*80,ENTREE*80
      LOGICAL FICHEX

C- Nombre de fichiers
10    WRITE (*,1001) ' Nombre de fichiers a traiter : '
      READ(*,1003,ERR=10) NBFICH
      IF (NBFICH.GT.NBFIMX) THEN
         WRITE (*,1002) ' ==> Nombre de fichiers > NBFIMX'
         GOTO 10
      ENDIF
      WRITE (*,*)

      DO 30 IFICH=1,NBFICH
C- Fichier(s) de resultats
20       IF (NBFICH.EQ.1) THEN
            WRITE (*,1001) ' Nom du fichier de resultats : '
         ELSE
            WRITE (*,1004) ' Nom du fichier de resultats ',IFICH,' : '
         ENDIF
         READ (*,1002,ERR=20) NOMLU
         CALL NETNOM (NOMLU)
         IF (.NOT.FICHEX (1,NOMLU,ENTREE,FICHRE(IFICH))) GOTO 20

C- Fichier(s) de geometrie
         OPEN (21,FILE=FICHRE(IFICH),STATUS='OLD')
         CALL LIRNOM (NOMFIC(IFICH),NOMLU)
         CALL NETNOM (NOMLU)
         LONNOM=LONGCH(NOMLU)
         CLOSE (21)
         IF (NBFICH.EQ.1) THEN
            WRITE (*,1005) ' Nom du fichier de geometrie : ',
     &                       NOMLU(1:LONNOM)
         ELSE
            WRITE (*,1006) ' Nom du fichier de geometrie ',IFICH,' : ',
     &                       NOMLU(1:LONNOM)
         ENDIF
         IF (.NOT.FICHEX (1,NOMLU,ENTREE,FICHGE(IFICH))) STOP
         WRITE (*,*)
30    CONTINUE

C- Label des fenetres standard i.e par nom du premier fichier
C- On initialise le(s) label(s)
      LABEL=NOMFIC(1)
      LONNOM=LONGCH(LABEL)
      WRITE (*,1007) ' Label du fichier : "',LABEL(1:LONNOM),
     &                  '" (o/n) : '
      READ (*,1002) CHOIX
      IF (CHOIX.EQ.'n'.OR.CHOIX.EQ.'N') THEN
C- Entree du label
40       WRITE (*,1001) ' Entrez le label du fichier : '
         READ (*,1002,ERR=40) LABEL
      ENDIF   

1001  FORMAT (A,$)
1002  FORMAT (A)
1003  FORMAT (I1)
1004  FORMAT (A,I1,A,$)
1005  FORMAT (A,A)
1006  FORMAT (A,I1,A,A)
1007  FORMAT (A,A,A,$)

      END 


