      PROGRAM GRAME

C- Representation GRAphique de fichiers de sorties MElina
C-
C- Auteur : Pascal GENTIL
C-
C- Derniere modif : 26 FEV 2003
C-
C- Constantes
C-    NBBUTN Nombre de boutons du menu
      INTEGER NBBUTN
      PARAMETER (NBBUTN = 17)
C-    NBFIMX : Nombre maximum de fichiers           
      INTEGER NBFIMX
      PARAMETER (NBFIMX = 4)
C-    NBLMAX : Nombre maximum d'elements
      INTEGER NBLMAX 
      PARAMETER (NBLMAX = 100000)
C-
C- Variables
C-    ACTIFS : Choix actifs ou non
      LOGICAL ACTIFS(NBBUTN)
C-    ARETES : Tableau contenant le debut et la fin des aretes.
      INTEGER ARETES (NBLMAX)
C-    AXES : Traces ou non des axes
      LOGICAL AXES
C-    CHOSOU : Fonction renvoyant X et Y du mulot
      INTEGER CHOSOU
C-    CLIC : Valeur du clic du mulot
      INTEGER CLIC
C-    DELTAX, DELTAY : LArgeur (XMAX-XMIN) et hauteur (YMAX-YMIN) reels
      REAL DELTAX,DELTAY
C-    ENTREE : Repertoire contenant les fichiers de donnees
      CHARACTER*80 ENTREE
C-    FENDES : Unite PGPLOT associe a la fenetre de dessins
      INTEGER FENDES
C-    FENMEN : Unite PGPLOT associe a la fenetre de menu
      INTEGER FENMEN
C-    FICHGE : Nom du(es) fichier(s) de geometrie 
      CHARACTER*80 FICHGE(NBFIMX)
C-    FICHRE : Nom du(es) fichier(s) de resultats
      CHARACTER*80 FICHRE(NBFIMX)
C-    HAUMAX,LARMAX : Hauteur et largeur max d'une fenetre. Depend de l'ecran
      REAL HAUMAX,LARMAX
C-    LABEL : Labels i.e commentaires des dessins
      CHARACTER*80 LABEL
C-    MAILLA : Maillage ou non
      LOGICAL MAILLA
C-    N : Tableau contenant les noeuds
      INTEGER N(NBLMAX,3)
C-    NBCOL : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
      INTEGER NBCOL
C-    NBEL : Nombre d'elements
      INTEGER NBEL
C-    NBFEN : Nombre de fenetres
      INTEGER NBFEN
C-    NBFICH : Nombre de fichiers
      INTEGER NBFICH
C-    NBPTS : Nombre de points total
      INTEGER NBPTS
C-    NOMFIC : Nom du(es) fichier(s)
      CHARACTER*80 NOMFIC(NBFIMX)
C-    NUMREP : Type de representation
C-       1 : Maillage
C-       2 : Isovaleurs en lignes en couleurs moyennes 
C-       3 : Isovaleurs planes en couleurs reelles.
C-       4 : Isovaleurs en elevations
      INTEGER NUMREP
C-    PASCOL : DeltaZ correspondant a un changement de couleur
      REAL PASCOL
C-    PGOPEN : Fonction PGPLOT d'ouverture
      INTEGER PGOPEN  
C-    SORTIE : Repertoire contenant les fichiers de sorties
      CHARACTER*80 SORTIE
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
      REAL TABCOL
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
      REAL VALPRJ(9)
C-    X,Y,Z : Tableaux des coordonnees des noeuds 
      REAL X(NBLMAX),Y(NBLMAX),Z(NBLMAX)
C-    XBUTON,YBUTON :  Coordonnees X et Y des boutons
      REAL XBUTON(NBBUTN),YBUTON(NBBUTN)
C-    XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y,Z
      REAL XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX

C- Initialisations 
      DATA AXES   / .TRUE. /
      DATA HAUMAX / 10.5 /
      DATA LARMAX / 14.5 /
      DATA MAILLA / .TRUE. /
      DATA NBCOL  / 254 /
      DATA NBEL   / 0 /
      DATA NBFEN  / 1/
      DATA NBPTS  / 0 /
      DATA NUMREP / 1 /
      DATA VALPRJ / 50.0, 470.0, 0.666, 6 * 0.0 /
      DATA XBUTON / 7*0.5,7.5,0.5,7.5,0.5,7.5,0.5,7.5,3*0.5 /
      DATA YBUTON / 21.0,20.0,19.0,18.0,15.0,14.0,11.0,11.0,8.0,
     &              8.0,7.0,7.0,6.0,6.0,5.0,3.0,1.0 /
      DATA XMIN,YMIN,ZMIN / 3*1.E30 /
      DATA XMAX,YMAX,ZMAX / 3*-1.E30 /

C------------------------------------------------------------------------------

C- NB : TOUS les fichiers sont ouverts avec l'unite logique 21 puisque
C- il n'y en a jamais plus de 1 ouvert a la fois

C- Presentation
      CALL TITRE ()

C- ENTREE et SORTIE sont-ils biens definis ?
      CALL DEFES (ENTREE,SORTIE)

C- Entree des donnees (nom des fichiers,couleurs,label et nombre de fenetres)
      CALL ENTDON (NBFIMX,NBFICH,FICHGE,FICHRE,NOMFIC,ENTREE,LABEL)

C- Lecture des donnees (nombre de points, nombre d'elements, X,Y,Z et N)
      CALL LIRDON (NBFIMX,NBLMAX,FICHGE,FICHRE,NBFICH,NBPTS,NBEL,X,Y,Z,
     &             XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,N)

C- Ouverture de l'ecran, taille et forme de la fenetre ecran
      FENDES=PGOPEN('/xwin')
*      FENDES=PGOPEN('/AQT')
      IF (FENDES.LT.0) CALL BLEME (10)
      CALL PGASK (.FALSE.)
      CALL PGPAP (LARMAX,HAUMAX/LARMAX)
   
C- On pose la bande de couleur a droite du dessin
      DELTAX=XMAX-XMIN
      DELTAY=YMAX-YMIN

C- On augmente en X et en Y de 1/100 du deltaX/deltaY pour bien tracer 
C- les triangles qui sont sur la limite. On "elargit" de TABCOL
C- pour representer la barre de couleurs a droite
      TABCOL=(XMAX-XMIN)/10
      CALL PGENV (XMIN-0.01*DELTAX,XMAX+0.01*DELTAX+TABCOL,
     &            YMIN-0.01*DELTAY,YMAX+0.01*DELTAX,1,-2)

C- On charge le tableau de couleurs
      CALL INICOL ()

C- On calcule le pas d'avance d'une couleur
      PASCOL=(ZMAX-ZMIN)/NBCOL

C- On prepare le multifenetrage eventuel
C- Par defaut, mono-fenetrage

C- Valeurs des variables de projection spherique
      CALL INIPRJ (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,VALPRJ)

C- Definition des boutons actifs 
      CALL DEFACT (NBBUTN,NUMREP,NBFEN,ACTIFS)

C- Ouverture de la fenetre de menu
      CALL INIMEN (FENMEN)
      CALL MENU (NBBUTN,YBUTON,NBFEN,NUMREP,ACTIFS,FENMEN,FENDES)

C- On represente ce qu'on a par defaut i.e un maillage
      GOTO 30

C- Ya ka cliquer sur le mulot ((c) J.Ch)
20    CLIC = CHOSOU (NBBUTN,XBUTON,YBUTON,NUMREP,NBFEN,ACTIFS,FENMEN)

C- On reaffiche le dessin
      CALL PGSLCT (FENDES)
      
C- Si "Fichier"
      IF (CLIC.EQ.16) THEN
         CALL FICSOR (NBLMAX,NBFEN,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,YMIN,
     &	              ZMIN,XMAX,YMAX,ZMAX,DELTAX,DELTAY,N,NBEL,NBCOL,
     &                PASCOL,TABCOL,AXES,FICHRE(1),ENTREE,SORTIE,LABEL,
     &                VALPRJ)
C- Si "Quitter"
      ELSEIF (CLIC.EQ.17) THEN
         GOTO 999    
      ELSE
C- Sinon, on redefinit un certain nombre de variables en fonction du choix
         CALL DEFCHO (CLIC,NBCOL,NUMREP,MAILLA,ZMIN,ZMAX,PASCOL,NBFEN,
     &                VALPRJ,AXES)
      ENDIF

C- On recalcule les actifs et les valeurs des variables de projection,
C- on regenere le menu
30    CALL DEFACT (NBBUTN,NUMREP,NBFEN,ACTIFS)
      CALL MENU (NBBUTN,YBUTON,NBFEN,NUMREP,ACTIFS,FENMEN,FENDES)
      CALL INIPRJ (XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,VALPRJ)

C- Enfin, on represente le tout
      CALL  DESSIN (NBLMAX,NBFEN,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,YMIN,
     &              ZMIN,XMAX,YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,AXES,
     &              LABEL,VALPRJ)

C- Et on repart pour un tour
      GOTO 20
  
C- Fin 
999   CALL PGCLOS ()

      END 

