      SUBROUTINE LIRDON (NBFIMX,NBLMAX,FICHGE,FICHRE,NBFICH,NBPTS,NBEL,
     &                   X,Y,Z,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,N)

C- Fonction : Lecture des donnees
C-
C- Entrees :
C-    NBFIMX : Nombre maximum de fichiers
C-    NBLMAX : Nombre maximum d'elements
C-    FICHGE : Nom du(es) fichier(s) de geometrie 
C-    FICHRE : Nom du(es) fichier(s) de resultats
C-    NBFICH : Nombre de fichiers
C-
C- Sortie :
C-    NBPTS : Nombre de points total
C-    NBEL : Nombre d'elements
C-    X,Y,Z : Tableaux des coordonnees des noeuds 
C-    XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX : Min et max des X,Y,Z
C-    N : Tableau contenant les noeuds
C-
C- Local :
C-    IFICH  : Indice de fichiers
C-    PTS : Nombre de points du fichier considere
C-
C- Derniere modif : 17 JAN 2003

      INTEGER NBFIMX,NBLMAX,IFICH,PTS
      CHARACTER*(*) FICHGE(NBFIMX),FICHRE(NBFIMX)
      INTEGER NBFICH,NBPTS,NBEL,N(NBLMAX,*)
      REAL X(*),Y(*),Z(*),XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX
      
C- On lit le nombre de points, le nombre d'elements, les X,Y et les noeuds
C- dans le(s) fichier(s) de geometrie puis les Z dans le(s) fichier(s) de 
C- resultats et on additionne  chaque nouveau fichier

      DO 10 IFICH=1,NBFICH 
         OPEN (21,FILE=FICHGE(IFICH),STATUS='OLD')
         CALL LIRGEO (NBLMAX,NBPTS,NBEL,PTS,X,Y,XMIN,XMAX,YMIN,YMAX,N)
         CLOSE (21) 
         OPEN (21,FILE=FICHRE(IFICH),STATUS='OLD')
         CALL LIRRES (PTS,NBPTS,Z,ZMIN,ZMAX)
         CLOSE (21)
10    CONTINUE

      END
      
