      SUBROUTINE LIRGEO (NBLMAX,NBPTS,NBEL,PTS,X,Y,XMIN,XMAX,YMIN,YMAX,
     &                   N)


C- Fonction : Lecture du fichier de geometrie FICHGE(IFICH) 
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    NBPTS : Nombre de points *total*
C-
C- Sortie :
C-    NBEL : Nombre d'elements
C-    PTS : Nombre de points du fichier considere
C-    X,Y : Sommets du maillage
C-    XMIN,XMAX,YMIN,YMAX : Min et max des X,Y
C-    N : Tableau contenant les noeuds
C-
C- Local :
C-    ELE    : Nombre d'elements du fichier considere
C-    LIGNE  : Ligne lue contenant NBPTS et NBEL du fichier considere
C-    ELELU  : Numero des elements lus dans le fichier considere
C-
C- Derniere modif : 21 JAN 2003

      INTEGER NBLMAX,NBPTS,NBEL,N(NBLMAX,*),PTS,ELE,ELELU(3),I,J
      REAL X(*),Y(*),XMIN,XMAX,YMIN,YMAX
      CHARACTER*80 LIGNE

C- On saute les 3 premieres lignes
      DO 10 I=1,3
10    READ (21,1001)

C- 4eme ligne : PTS et ELE
      READ (21,1001) LIGNE
      CALL DECLIG (LIGNE,PTS,ELE)
      IF (ELE.GT.NBLMAX) CALL BLEME (8)
      READ (21,1001) 

C- On lit les X et Y et on calcule X et Y min et max pour *l'ensemble* 
C- des fichiers
      DO 20 I=NBPTS+1,NBPTS+PTS
         READ (21,*) X(I), Y(I)
         XMIN = MIN(XMIN,X(I))
         XMAX = MAX(XMAX,X(I))
         YMIN = MIN(YMIN,Y(I))
         YMAX = MAX(YMAX,Y(I))
20    CONTINUE

C- On saute la ligne NUMEL
      READ (21,1001)

C- On lit les numeros des noeuds
      DO 40 I=NBEL+1,NBEL+ELE
         READ (21,*) (ELELU(J),J=1,3)
C- C'est bien le nombre de *points* deja lu ie de noeuds qu'on ajoute         
         DO 30 J=1,3
30       N(I,J)=ELELU(J)+NBPTS
40    CONTINUE

C- On somme les elements
      NBEL = NBEL + ELE
      
1001  FORMAT (A)

      END
