      SUBROUTINE REPFIC (NBLMAX,NUMREP,MAILLA,ARETES,X,Y,Z,XMIN,YMIN,
     &                   ZMIN,XMAX,YMAX,ZMAX,N,NBEL,NBCOL,PASCOL,TABCOL,
     &                   AXES,LABEL,VALPRJ)

C- Fonction : Representation complete du fichier dans le type NUMREP
C-            plus le tableau couleur, le label et [eventuellment] les axes
C-
C- Entree :
C-    NBLMAX : Nombre maximum d'elements
C-    NUMREP : Type de representation
C-    MAILLA : Maillage ou non
C-    ARETES : Tableau contenant le debut et la fin des aretes.
C-    X,Y,Z  : Tableaux des coordonnees des sommets
C-    XMIN,YMIN,ZMIN : Min des X,Y,Z
C-    XMAX,YMAX,ZMAX : Max des X,Y,Z
C-    N      : Tableau contenant les noeuds
C-    NBEL   : Nombre d'elements
C-    NBCOL  : Nombre de couleurs possibles. 0:noir, NBCOL+1:blanc
C-    PASCOL : DeltaZ correspondant a un changement de couleur
C-    TABCOL : Bande laterale droite servant a la representation des couleurs
C-    AXES   : Traces ou non des axes
C-    LABEL  : Labels i.e commentaires des dessins
C-    VALPRJ : Tableau contenant les parametres de projection 3D en 2D
C-
C- Sortie : -
C-
C- Derniere modif : 17 JAN 2003
C-
      INTEGER NBLMAX,NUMREP,ARETES(*),N(NBLMAX,*),NBEL,NBCOL
      REAL X(*),Y(*),Z(*),XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,PASCOL,TABCOL
      REAL VALPRJ(*)
      LOGICAL MAILLA,AXES
      CHARACTER*80 LABEL

C- Axes en 3D avant le dessin sinon c'est pas beau 
      IF (NUMREP.EQ.4 .AND. AXES) 
     &   CALL TRAXES (XMIN,YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,VALPRJ)

C- On dessine
      CALL DESFIC (NBLMAX,NUMREP,MAILLA,ARETES,X,Y,Z,ZMIN,N,NBEL,NBCOL,
     &             PASCOL,VALPRJ)

C- Tableau de couleurs
      IF (NUMREP.GT.1) CALL REPCOL (YMIN,ZMIN,XMAX,YMAX,ZMAX,NBCOL,
     &                              TABCOL)
     
C- Ecriture du label
C- NB : PGLAB n'est pas suffisant. On utilise PGMTXT
      CALL PGSCF (1)
      CALL PGSCH (1.0)
C- 2.0 : hauteur du texte au-dessus du viewport en unite hauteur de caractere
      CALL PGMTXT ('T',1.5,0.5,0.5,LABEL)

      END 
