function COOR=mailcoor(omega,Rext,Rmil,Rint,n,p,k,test)
% maille 	Maillage d'une couronne.
% 
% Appel : maille (omega,Rext,Rmil,Rint,n,p,k,test)
% 
% omega = demi-angle au sommet
% Rext  = rayon exterieur
% Rmil  = rayon median
% Rint  = rayon interieur
% n     = nombre de couche d'elements en direction angulaire
% p     = nombre de couche d'elements en direction radiale
% k     = degre d'interpolation
% test  = 'avec' si on veut la petite couronne (donc un angle)
%         'sans' si on ne veut que la couronne exterieure

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% CALCUL DES COORDONNES DES POINTS DU MAILLAGE %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

COOR=[];
theta=0;
R=Rext;
for j=1:p*k+1,
for i=1:2*n*k+1,
	X=R*cos(theta);
	Y=R*sin(theta);
	COOR=[COOR,[X;Y]];
	theta=theta+omega/(n*k);
end
R=R-1/(p*k)*(Rext-Rmil);
theta=0;
end

if test=='avec'

R=Rmil-1/(p*k)*(Rmil-Rint);
theta=omega;
for j=1:p*k,
for i=1:n*k+1,
	X=R*cos(theta);
	Y=R*sin(theta);
	COOR=[COOR,[X;Y]];
	theta=theta+omega/(n*k);
end
R=R-1/(p*k)*(Rmil-Rint);
	theta=omega;
end
end



