function a=Me2Sparse(file)
% Lecture d'un fichier issu de Melina, contenant la definition d'une matrice sparse
%
% Auteur D. Martin (7 avril 1999)
% Derniere modification : D.Martin, Y. Lafranche, E. Darrigrand-Lacarrieu (12 february 2009)
%
% Argument 
%    file : nom du fichier contenant la structure sparse de la matrice

fid=fopen(file,'r');
if fid == -1 
  error([':>( Fichier ' file ' non trouve.']);
end
% Lecture de l''entete du fichier (prremiere ligne)
% Read file header (first line)
line=fgets(fid);
ttype=[];
tsymm=[];
if findstr(line,'REEL') > 0 ttype='REEL    '; end
if isempty(ttype)
  if findstr(line,'COMPLEXE') > 0 ttype='COMPLEXE'; end
end
if findstr(line,'ANTISYMETRIQUE') > 0 tsymm='ANTISYMETRIQUE'; end
if isempty(tsymm)
  if findstr(line,'SYMETRIQUE') > 0 tsymm='SYMETRIQUE    '; end
end
%
disp(['Lecture sur le fichier ' file ' d''une matrice de type ' ttype ' ' tsymm]);
%
% Nombre de lignes, colonnes, coefficients non nuls
% Number of rows, columns, non-zero entries
%
indices(1:4)=fscanf(fid,'%i',4);
m=indices(1);
n=indices(2);
nzmax=indices(3);
type=indices(4);
tab_i(1:nzmax)=fscanf(fid,'%f',nzmax);
tab_j(1:nzmax)=fscanf(fid,'%f',nzmax);
%
% Read matrix entries
%
if ttype == 'COMPLEXE'
%  Matrix is complex : read matrices of real and imaginary parts
   mat=fscanf(fid,'%f',[2 nzmax]);
%    then build complex valued matrix
   s=mat(1,:) + i*mat(2,:);
else
%  Matrix is real valued : read matrix
   s=fscanf(fid,'%f',nzmax);
end
a=sparse(tab_i,tab_j,s,m,n);
%
%%%%% if tsymm == 'ANTISYMETRIQUE'
if strcmp(tsymm, 'ANTISYMETRIQUE')
   a=a-tril(a-diag(diag(a)))';
%%%%% elseif tsymm == 'SYMETRIQUE'
elseif strcmp(tsymm,'SYMETRIQUE    ')
   a=a+tril(a-diag(diag(a)))';
end
fclose(fid);

%
% File history
% D.Martin, Y. Lafranche, E. Darrigrand-Lacarrieu (12 feb 2009) bug fixed when reading a complex matrix
%
