%
% Matlab5 M-file pour les sorties graphiques 2d de melina/me2uni
%
% Auteur : J.Perez (Decembre 1997)
% Version actuelle : Y.Lafranche, D.Martin (Mars 2000)
% Derniere modification : D.Martin (6 Avril 2000)
% Version 1.1.0
%
VerNo=version;
if (VerNo(1) < '5');
   disp(':>(')
   disp(':>( Ce script ne fonctionne qu''avec une version de Matlab posterieure a 5.0 .')
   disp([':>( Vous utilisez la version ' VerNo ' .'])
   disp(':>(')
   return
end
%
clear all
quote=zeros(1,2);
titleres=[];
%
% Resultats reel ou complexe dans le fichier (on n'utilise seulement la partie reelle)
%
tyresu =-1;
while tyresu == -1
  tyresuc = input(':) Resultat reel ou complexe ? [1,r/2,c] > ','s');
  switch lower(tyresuc)
    case {'1','r'}, tyresu=1;
    case {'2','c'}, tyresu=2;
    otherwise, tyresu=-1;
  end
end
%
% Nombre de resultats a tracer :
% permet de tracer des resultats discontinus
%
nbresu = input(':) Nombre de resultats a tracer sur la meme figure ? > ');
%
for d=1:nbresu
  fid=-1;
  trials=0;
  while fid == -1
     nmresu{d} = input([':) Nom du fichier de resultats #',num2str(d),' ? > '],'s');
     nomfich=nmresu{d};
     fid=fopen(nomfich,'r');
     if fid == -1
	   disp([':(']); 
       disp([':( Fichier ' nomfich ' non trouve.']);
	   trials=trials+1;
	   if trials > 2 error([':( Fichier ' nomfich ' non trouve (3 essais on arrete).']);end
       if isunix
	      unix(['ls -F | grep -v "\.m" | grep -v "\.f" | grep -v "\.o" '...
                '| grep -v "fort\." | grep -v "/" | grep -v "\*" | grep -v "@"' ...
                '| grep -v akefile | grep -v "^GE"']);
	   end
     end
  end
%
% Lecture dans le fichier de resultats
%
% 5 premieres lignes
  line=fgets(fid);
  line=fgets(fid);
  quote=findstr(line,'''');
  titleres=[titleres,line(quote(1)+1:quote(2)-1)];
  if nbresu > 1 & d < nbresu 
     titleres=[titleres,' / '];
  end
  line=fgets(fid);
% 4eme ligne : Nom de fichier contenant le maillage
  line=fgets(fid);
  quote=findstr(line,'''');
  nomgeo{d}=line(quote(1)+1:quote(2)-1);
  line=fgets(fid);
  fclose(fid);
%
% Lecture dans le fichier de maillage
%
  nomfich=nomgeo{d};
  fid=fopen(nomfich,'r');
  if fid == -1 error([':>( Fichier ' nomfich ' non trouve.']);end
  line=fgets(fid);
  line=fgets(fid);
  line=fgets(fid);
  a=findstr(line,'D');
  dim=str2num(line(a-1:a-1));
  if dim ~= 2 
     error (':>( matme fonctionne seulement en dimension 2.');
  end
  a=findstr(line,'P');
  if isempty(a)
     a=findstr(line,'Q');
  end
  if isempty(a)
     error ([':>( matme : erreur dans le fichier ',nomfich])
  end
  PouQ(d)=line(a:a);
  degre(d)=str2num(line(a+1:a+1));
%
% nbneel(d) : nombre de noeud de l'element decoupe en triangle P1
% multel(d) : nombre de triangles P1 apres decoupe de l'element
%
  nbneel(d)=0;
  if PouQ(d) == 'P'
    nbneel(d)=(degre(d)+1)*(degre(d)+2)/2;
    multel(d)=degre(d)^2;
  elseif PouQ(d) == 'Q'
    nbneel(d)=(degre(d)+1)^2;
    multel(d)=2*degre(d)^2;
    end
  end
  if nbneel(d) == 0
    error (':>( matme prevu seulement pour les cas (P/Q)_k, k=1,2,3');
  end
%
  line=fgets(fid);
  line=strrep(line,' ','');
  a=findstr(line,'NBPTS');
  b=findstr(line,'NBEL');
  c=size(line,2);
% Nombre de noeuds du maillage
  nbne(d)=str2num(line(a+5:b-1));
% Nombre d'elements du maillage
  nbel(d)=str2num(line(b+4:c));
  line=fgets(fid);
  fclose(fid);
  disp ([':>) Maillage #',num2str(d),' lu sur fichier : ',nomgeo{d}])
% ...
%       ,'(',PouQ(d),num2str(degre(d),' ,',num2str(nbel(d)),' elements ,'])
%        ...
%       ,num2str(nbne(d),' noeuds)'])
%
% Creation des tableaux
%
coord=zeros(dim,max(nbne),nbresu);
numeg=zeros(max(nbneel),max(nbel),nbresu);
nwmeg=zeros(3,max(nbel.*multel),nbresu);
valeurs=zeros(tyresu,max(nbne),nbresu);
%
% Traces effectifs
%
for d=1:nbresu
%
% Lecture du fichier du maillage
%
  nomfich=nomgeo{d};
  fid = fopen(nomfich,'r');
% Lecture a vide des 5 premieres lignes (deja lues)
  for i = 1:5
     line=fgets(fid);
  end
  %
% Coordonnees des noeuds du maillage
%
  coord(1:dim,1:nbne(d),d) = fscanf(fid,'%f',[dim,nbne(d)]);
%
% Numero globaux des noeuds du maillage
%
% Lecture a vide de la ligne contenant 'NUMEL'
  line=fgets(fid);
  line=fgets(fid);
%
  numeg(1:nbneel(d),1:nbel(d),d) = fscanf(fid,'%f',[nbneel(d),nbel(d)]);
%
  multeld=multel(d);
  nbwel=multeld*nbel(d);
  nwnu=multeld;
  if PouQ(d) == 'P'
    if degre(d) == 1
      nwmeg(1:3,1:nbel(d),d) = numeg(1:3,1:nbel(d),d);
    elseif degre(d) == 2
%     Cas P2
%     Tableau de correspondance pour decouper un triangle P2 en 4 triangle P1
      corrnu=[1 4 6 ; 2 5 4 ; 4 5 6 ; 3 6 5 ];
      for nu = 1:multeld
         nwnu=nwnu-1;
         nwmeg(1:3,[nu:multeld:nbwel-nwnu],d) = numeg(corrnu(nu,:),1:nbel(d),d);
      end
    elseif degre(d) == 3
%     Cas P3
%     Tableau de correspondance pour decouper un triangle P3 en 9 triangle P1
      corrnu=[1 4 9 ; 4 7 10 ; 7 2 5 ; 9 4 10 ; 10 7 5 ; 9 10 6 ; 10 5 8 ; 6 10 8 ; 6 8 3];
      for nu = 1:multeld
         nwnu=nwnu-1;
         nwmeg(1:3,[nu:multeld:nbwel-nwnu],d) = numeg(corrnu(nu,:),1:nbel(d),d);
       end
    end
  elseif PouQ(d) == 'Q'
    if degre(d) == 1
%     Cas Q1
      nwmeg(1:3,[1:2:nbwel-1],d) = numeg([1 2 3],1:nbel(d),d);
      nwmeg(1:3,[2:2:nbwel],d)   = numeg([1 3 4],1:nbel(d),d);
    elseif degre(d) == 2
%     Cas Q2
%     Tableau de correspondance pour decouper un quadrangle Q2 en 8 triangle P1
      corrnu=[1 5 8 ; 2 9 5 ; 5 9 8 ; 4 8 9 ; 2 6 9 ; 6 7 9 ; 4 7 9 ; 3 6 7 ];
      for nu = 1:multeld
         nwnu=nwnu-1;
         nwmeg(1:3,[nu:multeld:nbwel-nwnu],d) = numeg(corrnu(nu,:),1:nbel(d),d);
      end
    elseif degre(d) == 3
%     Cas Q3
%     Tableau de correspondance pour decouper un quadrangle Q3 en 18 triangle P1
      corrnu=[ 1  5 12 ;  5 13 12 ;  5  9 13 ;  9 14 13 ;  9  2 14 ;  2  6 14 ; ...
              12 13  8 ; 13 16  8 ; 13 14 16 ; 14 15 16 ; 14  6 15 ;  6 10 15 ;...
               8 16  4 ; 16 11  4 ; 16 15 11 ; 15  7 11 ; 15 10  7 ; 10  3  7 ];
      for nu = 1:multeld
         nwnu=nwnu-1;
         nwmeg(1:3,[nu:multeld:nbwel-nwnu],d) = numeg(corrnu(nu,:),1:nbel(d),d);
      end
    end
  end
  fclose(fid);
  nwel(d) = nbwel;
%
% Lecture des valeurs nodales
%
  nomfich=nmresu{d};
  fid = fopen(nomfich,'r');
% Lecture a vide des 5 premieres lignes (deja lues)
  for i = 1:5
     line=fgets(fid);
  end
  valeurs(1:tyresu,1:nbne(d),d) = fscanf(fid,'%f',[tyresu,nbne(d)]);
  fclose(fid);
end
%
coefhauteur=0;
%
% Choix de la representation graphique
%
trace=input ([':) Tracer les isovaleurs pleines en elevation ? (E) (defaut) \n'...
              '   Tracer les isovaleurs pleines planes ?       (p) \n'...
              '   Tracer les isovaleurs planes en contour ?    (c) > '],'s');
switch lower(trace)
 case {'e','p','c'}
 otherwise
 trace='e';
end
%
% Trace preoprement dit
%
switch lower(trace)
 case {'e','p'}
%
%  Trace des isovaleurs pleines en elevation 
%
   for d=1:nbresu  
%    LineStyle: [ {-} | -- | : | -. | none ]
     trime=trisurf((nwmeg(:,1:nwel(d),d))',coord(1,1:nbne(d),d),coord(2,1:nbne(d),d) ...
            ,valeurs(1,1:nbne(d),d),valeurs(1,1:nbne(d),d),'Linestyle','none');
      hold on	
   end
   switch lower(trace)
    case {'e'}
     view([30 40]);
     trace_isop=input ([':-> Le trace des isovaleurs planes est faux pour les domaines non convexes.\n' ...
                        '    Tracer les isovaleurs sur le maillage en projection ? (o/n) > '],'s');
     trace_maip=input ([':>) Tracer le maillage en projection ? (o/n) > '],'s');			  
     coefhauteur=1;
   case {'p'}
	 view([0 90]);
	 coefhauteur=0;
	 trace_isop='n';
	 trace_maip=input ([':>) Tracer le maillage ? (o/n) > '],'s');
   end
%  shading [faceted | flat | interp]
   shading interp;
 otherwise
   trace_isop='o';
   disp ([':>) Le trace des isovaleurs planes est faux pour les domaines non convexes.']);
   trace_maip=input ([':>) Tracer le maillage ? (o/n) > '],'s');
end
%
% Trace des lignes de niveau en 2d ou dans le plan z=vmin-(vmax-vmin) ?
%
xmin=+1e6;ymin=xmin;vmin=xmin;
xmax=-1e6;ymax=xmax;vmax=xmax;
for d = 1:nbresu
  vmin=min(vmin,min(valeurs(1,:,d)));vmax=max(vmax,max(valeurs(1,:,d)));
end
caxis([vmin vmax]);
hauteur=coefhauteur*(vmin-(vmax-vmin));
for d = 1:nbresu
  switch lower(trace_maip)
   case {'o','y'}
%    LineStyle: [ {-} | -- | : | -. | none ]
%    EdgeColor [ y | m | c | r | g | b | w | b ]
     trimesh((nwmeg(:,1:nwel(d),d))',coord(1,1:nbne(d),d),coord(2,1:nbne(d),d) ...
                  ,hauteur*ones(1,nbne(d)),'LineStyle','--','EdgeColor','k');
     hold on
  end
  switch lower(trace_isop)
  case {'o','y'}
     N=round(sqrt(2*nbne(d)))+1;
     xmin=min(coord(1,1:nbne(d),d));xmax=max(coord(1,1:nbne(d),d));
     ymin=min(coord(2,1:nbne(d),d));ymax=max(coord(2,1:nbne(d),d));
     [xi,yi]=meshgrid(linspace(xmin,xmax,N),linspace(ymin,ymax,N));
     zi=griddata(coord(1,1:nbne(d),d),coord(2,1:nbne(d),d) ...
                  ,valeurs(1,1:nbne(d),d),xi,yi,'cubic');
%
	 switch lower(trace)
      case ('e')
	    [con,hd]=contour(xi,yi,zi,20);
        for i=1:length(hd)
           m=length(get(hd(i),'Xdata'));
           set(hd(i),'Zdata',hauteur*ones(1,m),'LineWidth',[1])
        end
	  otherwise
	    [con,hd]=contour(xi,yi,zi,50);
%	     for i=1:length(hd)
%           m=length(get(hd(i),'Xdata'));
%           set(hd(i),'LineWidth',[1.5])
%        end
	 end
  end
end
hidden off
%
switch lower(trace)
 case ('e')
% Suppression des valeurs sur l'axes des Z
  set(gca,'ZTickLabel',[])
end
colorbar;
title(titleres);
% modif
%axis('equal')
disp(' ')	
switch lower(trace)
  case ('e')
  disp(':-> Pour faire pivoter la figure a l''aide de la souris, taper ''rotate3d'',')
  disp(':-> Pour ''aplatir'' la figure , taper ''view([0 90])'' ou ''view(2)'',')
end
disp(':-> Pour faire un zoom taper ''zoom on/off''...')

