*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE LECTSD (IST,RST,CST,MAXIST,AST,MAXAST,NUFIN)   
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin & G.Vial  
* Derniere modification : D.Martin & G.Vial (13 Juin 2003)
* Version 1.0.4
*   
* Lecture des donnees geometriques du maillage
*   
*-- Arguments d'entree -- 
* M      super-tableau version entiere de l'allocation dynamique Modulef
* RM     super-tableau version reelle Modulef
* LM     lomgueur du super-tableau de Modulef
* IST    super-tableau version entiere de l'allocation dynamique Melina
* RST    super-tableau version reelle Melina
* CST    super-tableau version complexe Melina
* MAXIST longueur du super-tableau scalaire Melina (IST,RST,CST)
* AST    super-tableau de caracteres de Melina
* MAXAST longueur du super-tableau caractere de Melina
* NUFIN  numero d'unite logique du fichier de maillage Melina
* NUFOUT numero d'unite logique du fichier contenant la S.D.E. NOPO
* NOFOUT nom du fichier de la NOPO Modulef
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      CHARACTER        AST(*)
      INTEGER          IST(*),MAXIST,MAXAST,NUFIN
      REAL             RST(*)
      COMPLEX          CST(*)
*
      INCLUDE 'CONTEX'
*
      INTEGER          ISOR,NIVIMP
      INTEGER          BECANE,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &                ,ISEUIL,NBBUF,NBUTMX,NBUNIT,USYSIN,USYSPR
     &                ,NUM,NUMOLD,LECOLD,LCANTE,LECACT,LASAPL
      INTEGER          NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDCA1/   NUM,NRAN,LEC,IMP,IECR,KNUM,IRWD,NOCO,IRET,NAVANT
      COMMON/REDLST/   LECOLD,LCANTE,NUMOLD /LASAPL/LASAPL
*     Nombre initial maximum d'inconnues, de donnees, de domaines, de termes
*     de constantes entieres, reelles, complexes, chaines de caracteres
      INTEGER NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI,NBTRMI,NCTRMI
     &       ,NBCSEI,NBCSRI,NBCSCI,NBCSDI,NBCSAI,NCCSAI
      DATA NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI,NBTRMI,NCTRMI
     &    /0     ,0     ,0     ,0     ,10    ,6     ,0     ,0/
     &    ,NBCSEI,NBCSRI,NBCSCI,NBCSDI,NBCSAI,NCCSAI/5*0,0/
*-----------------------------------------------------------------------
*
*--   Initialisation et Valeurs par defaut
      CALL INITIA (MAXIST,LGBUF,NBENRX,IMPALO,IMPERR,NBTBMX
     &            ,ISEUIL,NBBUF,NBUTMX,NBUNIT,USYSIN,USYSPR
     &            ,NUM,NUMOLD,LECACT,LECOLD,LCANTE,LASAPL)              !initial
*
*--   Date et heure du debut de l'execution
      CALL HORODA (IMPPAL,'M E V I S U',OSARCH,NAMEMA)                  !utilite
*
*--   Initialisation de la gestion des tables de l'allocation dynamique
      BECANE=1
      CALL STINIT (MAXAST,MAXIST,NBTBMX,ISEUIL,LGBUF,NBENRX,NBBUF,NBUTMX 
     &            ,NBUNIT,INTMAX,IMPALO,IMPERR)
*
*--   Initialisation du systeme d'unites logiques 
      CALL INIFIC (LASNUF,USYSPR,IMPPAL,IMPSDR,IMPMES,ABS(IMPALO)
     &            ,IMPERR)                                              !initial
*--   Creation de tableaux recepteurs des structures d'entree
      CALL CREESD (NBINCI,NCINCI,NBDONI,NCDONI,NBDOMI,NCDOMI
     &            ,NBTRMI,NCTRMI,NBCSEI,NBCSRI,NBCSCI,NBCSDI
     &            ,NBCSAI,NCCSAI)                                       !initial
      ISOR=0
      CALL REDINI (NUFIN,ISOR)                                          !redlec
      CALL REDLE                                                        !redlec
*
*--   Lecture du fichier de maillage Melina 
      NIVIMP=0
      CALL LCGMAI (NIVIMP)                                              !lecgeom
*
                                                                    END !M2Nopo
