      SUBROUTINE TRADOM (NCOL,NOMDOM,NCHDOM,IST,RST,ADRLIS,ADRBLK
     &,ADRCOR,NBBBLK,NU1BLK,NDIM,NBPTEX)
*-----------------------------------------------------------------------     
* TRACE D'UN DOMAINE
* Arguments d'entree :
*  NCOL (integer)         :  couleur de trace
*  NOMDOM (character)     :  nom du domaine
*  NCHDOM (integer)       :  nombre de caracteres reserves pour les noms
*  RST (real)             :  super-tableau version reelle
*  IST (integer)          :  super-tableau version entiere
*  ADRLIS (integer)       :  adresse de la structure #ISTEL du domaine
*  ADRBLK (integer)       :  adresse de la structure #LOKEL
*  ADRCOR (integer)       :  adresse de la structure #ORPTS
*  NBBBLK (integer)       :  nombre de blocs d'elements de meme type
*  NU1BLK (integer)       :  numero de type du premier bloc
*  NDIM (integer)         :  dimension d'espace (=2 ici)
*  NBPTEX (integer)       :  nombre de points maximum par element
*-----------------------------------------------------------------------
 
      
      CHARACTER NOMDOM(*)
      INTEGER NCHDOM,ADRCOR,ADRBLK,ADRLIS,NBBBLK,NU1BLK
     &,NDIM,NBPTEX,NCOL,IST(*) 
      REAL RST(*)
* Variables locales
      INTEGER NDMDOM,NDMDOE,NBELDO,TYP,NUMELT,NBBARY,LONG
     &,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE 
     &,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX
     &,ARETE,NUMART,KLTYPE,ELT,NUM,I,POINT,NUMPT,ADR
      REAL X(4),Y(4),SX,SY
      CHARACTER*15 CHNOM
* Lecture de l'entete de la structure #ISTEL
      NDMDOM=IST(ADRLIS+1)
      NDMDOE=IST(ADRLIS+2)
      NBELDO=IST(ADRLIS+3)  
*-----------------------------------------------------------------------          
* SI LE DOMAINE EST VOLUMIQUE
*-----------------------------------------------------------------------  
      CALL PGSFS(1)
      CALL PGSCI (NCOL)
      NBBARY=0
      SX=0
      SY=0
      IF (NDMDOM.EQ.NDMDOE) THEN
*       Boucle sur les elements du domaine
        DO 1 ELT=1,NBELDO
*           Determination du type de l'element
            NUMELT=IST(5+ADRLIS+ELT)
          IF (NBBBLK.EQ.1) THEN
            TYP=NU1BLK
          ELSE  
              TYP=KLTYPE (NUM,IST,ADRBLK)  
          ENDIF
*           Caracteristiques de l'element
            CALL ELEMNB (TYP,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE  
     &                  ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
            DO 2 I=1,NBSOMT
            NBBARY=NBBARY+1
            X(I)=RST(2*I-1+ADRCOR+(NDMDOE*NBPTEX+1)*(NUMELT-1))
            Y(I)=RST(2*I+ADRCOR+(NDMDOE*NBPTEX+1)*(NUMELT-1))
            SX=SX+X(I)
            SY=SY+Y(I)
2          CONTINUE
            IF (NBNEAX.EQ.2) THEN
* Si l'interpolation est de degre 1, on remplit simplement le polygone
              CALL PGPOLY (NBSOMT,X,Y)
          ELSE
* Sinon, il faut interpoler les bords
              CALL FILELT (NUMELT,NBPTEX,NBSOMT,NBNEAX,NBARET,
     &RST(1+ADRCOR+(NDIM*NBPTEX+1)*(NUMELT-1)))              
            ENDIF
1       CONTINUE  
* Ecriture du nom de domaine a l'isobarycentre du domaine
        SX=SX/NBBARY
        SY=SY/NBBARY    
      CALL PGSTBG(4)
      CALL PGSCH (1.5)
      CALL PGSCF (1)
      CALL NOMGRC (NOMDOM,NCHDOM,CHNOM,LONG)  
      CALL PGPTXT (SX+.01,SY+.01,0.,0.5,CHNOM(1:LONG))
        CALL PGSTBG(-1)
     
*-----------------------------------------------------------------------          
* SI LE DOMAINE EST PONCTUEL
*-----------------------------------------------------------------------                
      ELSEIF (NDMDOM.EQ.0) THEN
      CALL PGSCI(NCOL)
        DO 22 POINT=1,NBELDO
          CALL NOMGRC (NOMDOM,NCHDOM,CHNOM,LONG)
        NUMELT = IST(8+ADRLIS+2*(POINT-1))
        NUMPT =  IST(8+ADRLIS+2*(POINT-1)+1)
          ADR=ADRCOR+(NDIM*NBPTEX+1)*(NUMELT-1)+NDIM*NUMPT-1
        CALL AFFPT (NCOL,CHNOM,LONG,RST(ADR))
22      CONTINUE     
*-----------------------------------------------------------------------          
* SI LE DOMAINE EST SURFACIQUE
*----------------------------------------------------------------------- 
      ELSE
        CALL PGSCI(NCOL)
      DO 33 ARETE=1,NBELDO
        NUMELT = IST(8+ADRLIS+2*(ARETE-1))
        NUMART = IST(9+ADRLIS+2*(ARETE-1))
*         NUMERO DE TYPE DE L'ELEMENT        
          IF (NBBBLK.EQ.1) THEN
            TYP=NU1BLK
          ELSE  
              TYP=KLTYPE (NUM,IST,ADRBLK)  
          ENDIF
*           Caracteristiques de l'element
            CALL ELEMNB (TYP,LAGHER,CLASSE,NBSOMT,NBARET,NBFACE  
     &                  ,NBNEEL,NBDLEL,NBNEAX,NBDLAX,NBNEFX,NBDLFX)
          ADR=1+ADRCOR+(NDIM*NBPTEX+1)*(NUMELT-1)
            CALL TRAART (RST(ADR),NUMART,NBSOMT,NBNEAX)          
33      CONTINUE
      CALL NOMGRC (NOMDOM,NCHDOM,CHNOM,LONG) 
* Ecriture du nom de domaine      
      CALL TXTART (NCOL,RST(ADR),NUMART,NDIM,NBSOMT,CHNOM,LONG)
*      
      ENDIF
      END
