      SUBROUTINE TRAELT (NGNEEL,NUMELT,NBNEEX,NBSOMT,NBNEAX,
     &NBARET,CORPTS,NBNEEL,ACTIFS)
*-----------------------------------------------------------------------
* TRACE D'UN ELEMENT DU MAILLAGE
* Arguments d'entree :
*  NGNEEL (integer)      :  numerotation globale des points de l'element
*  NUMELT (integer)      :  numero de l'element
*  NBNEEX (integer)      :  nombre de points maximum par element
*  NBSOMT (integer)      :  nombre de sommets de l'element
*  NBNEAX (integer)      :  nombre maximum de points par arete
*  NBARET (integer)      :  nombre d'aretes de l'element
*  CORPTS (real)         :  coordonnees des points de l'element
*  NBNEEL (integer)      :  nombre de points de l'element
*  ACTIFS (logical)      :  booleen pour l'affichage des numeros
*-----------------------------------------------------------------------      
      INTEGER NBNEEL,NGNEEL(*),NUMELT,NBNEEX,NBNEAX,NBSOMT,ARETE
     &,NUM ,NC,I,J,NBARET
      REAL CORPTS(2,*),X(11),Y(11)
      LOGICAL ACTIFS(*)
      CHARACTER*5 STRING
*-----------------------------------------------------------------------  
* TRACE DU MAILLAGE SI ACTIFS(1) est VRAI
*-----------------------------------------------------------------------  

       IF (ACTIFS(1)) THEN
* TRACE DES ARETES
        CALL PGSLW(1)
        DO 1 ARETE=1,NBARET
          DO 2 I=0,NBNEAX-2
	    X(I+1)=CORPTS(1,ARETE+NBSOMT*I)
	    Y(I+1)=CORPTS(2,ARETE+NBSOMT*I)
2         CONTINUE
          X(NBNEAX)=CORPTS(1,MOD(ARETE,NBSOMT)+1)
	  Y(NBNEAX)=CORPTS(2,MOD(ARETE,NBSOMT)+1) 
	  CALL PGSCI(5)
* Si l'interpolation est de degre 1, on relie les sommets
	  IF (NBNEAX.EQ.2) THEN
	     CALL PGMOVE (X(1),Y(1))
	     CALL PGDRAW (X(2),Y(2))
	  ELSE   
* Sinon il faut interpoler	  
            CALL TRAPOL (X,Y,NBNEAX,20)
	  ENDIF
1       CONTINUE
* TRACE DES POINTS
        DO 3 I=1,NBNEEL
          CALL PGPT1 (CORPTS(1,I),CORPTS(2,I),20)
*         Ecriture des numeros des points si ACTIFS(2) est VRAI
	  IF (ACTIFS(2)) THEN
*           Attributs du texte	
            CALL PGSCI(3)  
       	    CALL PGSCF(1)
            CALL PGSCH(.8)
	    CALL PGSTBG(0)
*           Ecriture du texte au point (decalage .01 en x 0.007 en y)	    
	    NUM=NGNEEL(NBNEEX*(NUMELT-1)+I)
	    CALL PGNUMB(NUM,0,1,STRING,NC)
	    CALL PGPTXT (CORPTS(1,I)+.01,CORPTS(2,I)+.007,0.,0.5
     &     ,STRING(1:NC))
	  ENDIF  
3       CONTINUE       
      ENDIF
*         Ecriture des numeros des elements si ACTIFS(3) est VRAI	  
          IF (ACTIFS(3)) THEN
*           Attributs du texte	
            CALL PGSCI(5)
	    CALL PGSCF(4)
            CALL PGSCH(.8)
	    CALL PGSTBG(3)
*           Calcul de l'isobarycentre de l'element	    
	    X(1)=0.
	    Y(1)=0.
	    DO 4 J=1,NBSOMT
	      X(1)=X(1)+CORPTS(1,J)
	      Y(1)=Y(1)+CORPTS(2,J)
4           CONTINUE	  
            X(1)=X(1)/NBSOMT
	    Y(1)=Y(1)/NBSOMT-0.005
*           Ecriture du texte au centre de l'element
	    CALL PGNUMB(NUMELT,0,1,STRING,NC)
	    CALL PGPTXT (X,Y,0.,0.5,STRING(1:NC))
	    CALL PGSTBG(-1)
	  ENDIF  
      END
