      SUBROUTINE TXTART (NCOL,CORPTS,NUMART,NDIM,NBSOMT,CHNOM,LONG)
*-----------------------------------------------------------------------
*  AFFICHAGE DU TEXTE SUR UNE ARETE (a l'exterieur de l'element
* Arguments d'entree
*  NCOL (integer)      :  couleur d'affichage
*  CORPTS (real)       :  coordonnes des points de l'element
*  NUMART (integer)    :  numero de l'arete
*  NDIM (integer)      :  dimension d'espace
*  NBSOMT (integer)    :  nombre de sommets de l'element
*  CHNOM (character)   :  texte a afficher
*  LONG (integer)      :  longueur de CHNOM
*-----------------------------------------------------------------------
      REAL CORPTS(2,*),X(4),Y(4),LX,LY
      INTEGER NUMART,NDIM,LONG,NCOL,NBSOMT
      CHARACTER*(*) CHNOM   
* Calcul des coordonnes ou afficher       
      CALL PGSTBG (NCOL)
      CALL PGSCI(5) 
* X(1),Y(1) sont les coordonnees de l'extremite de l'arete      
      X(1)=CORPTS(1,MOD(NUMART,NBSOMT)+1)
      Y(1)=CORPTS(2,MOD(NUMART,NBSOMT)+1)
* X(1),Y(1) sont les coordonnees de l'origine de l'arete       
      X(2)=CORPTS(1,NUMART)
      Y(2)=CORPTS(2,NUMART)
* X(3),Y(3) est un vecteur retrogradement orthogonal a l'arete      
      X(3)=Y(1)-Y(2)
      Y(3)=X(2)-X(1)
* X(4),Y(4) sont les coordonnees ou on va afficher      
      X(4)=.5*(X(1)+X(2))
      Y(4)=.5*(Y(1)+Y(2))-0.015      
* Determination de la taille (en unites graphique) de CHNOM      
      CALL PGLEN (4,CHNOM(1:LONG),LX,LY)
* Affichage en decalant selon LX et LY      
      CALL PGPTXT (X(4)+.52*LX*X(3)/(sqrt(X(3)**2+Y(3)**2)),
     &Y(4)+.52*LY*Y(3)/(sqrt(Y(3)**2+X(3)**2)),0.,0.5,CHNOM(1:LONG))
      CALL PGSTBG (-1) 	     
      CALL PGSCI(NCOL)
*
      END
      
