*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PROGRAM  MOME
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (1990)
* Derniere modification : D.Martin (24 Aout 2000)
* Version 1.0.2
*
* INTERFACE entre Melina et Modulef. Permet de creer
*   
* 1) un maillage 'Melina' sur unite sequentielle formattee 
*    a partir d'une Structure de Donnees 'NOPO'
*   
* 2) un maillage 'Melina' sur unite sequentielle formattee 
*    a partir des Structures de Donnees 'MAIL' & 'COOR'
*   
* 3) une Structure de Donnees 'NOPO' a partir d'un maillage
*    'Melina' lue sur unite sequentielle formattee
*
* 4) creer des Structures de Donnees 'MAIL' & 'COOR' a partir
*    d'un maillage 'Melina' lue sur unite sequentielle formattee 
*
* 5) une Structure de Donnees 'B' a partir de valeurs nodales  
*    calculees par Melina et lues sur unite sequentielle formattee
*   
* 6) un fichier de trace de courbes (par TRACXX) a partir de
*    donnees calculees par Melina et lues sur fichier
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PARAMETER    (LM=4000000, MAXAST=80000, MAXIST=4000000)
      CHARACTER     AST  
      COMMON/      /IST(MAXIST) /STCHAR/AST(MAXAST) /MODULF/M(LM) 
      REAL          RM(1),RST(1)
      COMPLEX       CST(1)
      EQUIVALENCE  (RM(1),M(1)),(IST(1),RST(1),CST(1))
*
      INCLUDE 'CONTEX'
*
      CHARACTER*80  NOMELI,NOMODU
*------------------------------------------------------------------------
      NIVESP=0
      CALL PRFXMJ (1,'$mome$')
      NUMELI=46
      NUNOPO=47
      NUCOOR=NUNOPO
      NUMAIL=48
      WRITE (*,*) '        Transfert Melina <==> Modulef ?'
1     WRITE (*,*) 
      WRITE (*,*) '  0 - Quitter'
      WRITE (*,*) '  1 - Nopo Modulef        ==> Maillage Melina' 
      WRITE (*,*) '  2 - MAIL & COOR Modulef ==> Maillage Melina'
      WRITE (*,*) '      (a revoir pour les elements courbes)'
      WRITE (*,*) '  3 - Maillage Melina     ==> SD Nopo Modulef'  
      WRITE (*,*) '  4 - Maillage Melina     ==> SD MAIL & COOR Modulef'
      WRITE (*,*) '      (non prevu actuellement)'
      WRITE (*,*) '  5 - Resultat Melina     ==> SD B Modulef'
      WRITE (*,*) '  6 - Fichier de trace de courbe pour tracxx' 
      WRITE (*,*) '      (non disponible actuellement)'
      WRITE (*,*)
*
      READ (*,*,ERR=1) ITEST  
      GOTO (10,20,30,40,50,60) ITEST
      CALL PRFXMJ (-1,'$mome$')
      CALL BYE   ('Fin de l''execution')
*
10    CALL RDFICH (NUNOPO,'la S.D. NOPO en entree','OLD'
     &,'UNFORMATTED',NOMODU)
      CALL RDFICH (NUMELI,'le maillage Melina en sortie','NEW'
     &,'FORMATTED',NOMELI)
      CALL NOPO2M (M,RM,LM,IST,RST,CST,MAXIST,AST,MAXAST
     &,NUNOPO,NUMELI,NOMELI)
      WRITE (*,*)
      WRITE (*,*) '--> *MoMe* Creation du maillage Melina'
      GOTO 1 
*
20    CALL RDFICH (NUMAIL,'la S.D. MAIL en entree','OLD'
     &,'UNFORMATTED',NOMODU)
      CALL RDFICH (NUCOOR,'la S.D. COOR en entree','OLD'
     &,'UNFORMATTED',NOMODU)
      CALL RDFICH (NUMELI,'le maillage Melina en sortie','NEW'
     &,'FORMATTED',NOMELI)
      CALL MACO2M (M,RM,LM,IST,RST,CST,MAXIST,AST,MAXAST
     &,NUCOOR,NUMAIL,NUMELI,NOMELI)
      WRITE (*,*)
      WRITE (*,*) '--> *MoMe* Creation du maillage Melina'
      GOTO 1
*   
30    CALL RDFICH (NUMELI,'le maillage Melina en entree','OLD'
     &,'FORMATTED',NOMELI)
      CALL RDFICH (NUNOPO,'la S.D. NOPO en sortie','NEW'
     &,'UNFORMATTED',NOMODU)
      CALL M2NOPO (M,RM,LM,IST,RST,CST,MAXIST,AST,MAXAST
     &,NUMELI,NUNOPO,NOMODU)
      WRITE (*,*)
      WRITE (*,*) '--> *MoMe* Creation de la S.D.S. NOPO'
       GOTO 1
*
40    CALL RDFICH (NUMELI,'le maillage Melina en entree','OLD'
     &,'FORMATTED',NOMELI)
      CALL RDFICH (NUMAIL,'la S.D. MAIL en sortie','NEW'
     &,'UNFORMATTED',NOMODU)
      CALL RDFICH (NUCOOR,'la S.D. COOR en sortie','NEW'
     &,'UNFORMATTED',NOMODU)
      CALL BAISE  (' A prevoir')
*     CALL M2MACO ()
      WRITE (*,*)
      GOTO 1
*   
50    CALL RDFICH (NUMELI,'le resultat Melina en entree','OLD'
     &,'FORMATTED',NOMELI)
      CALL RDFICH (NUNOPO,'la S.D. B en sortie','NEW'
     &,'UNFORMATTED',NOMODU)
      CALL MELI2B (M,RM,LM,NUMELI,NUNOPO)
      WRITE (*,*)
      WRITE (*,*) '--> *MoMe* Creation de la S.D.S.  B'
      GOTO 1
*   
60    CONTINUE
*     CALL CRTRAC (M,RM)
      WRITE (*,*)
      WRITE (*,*) '--> *MoMe* Creation du fichier de trace de courbes'
      GOTO 1
                                                                    END !MoMe

