*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      PROGRAM DELTAU
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Juin 2001)
* Derniere modification : D.Martin (14 Juin 2001)
*
* Resolution de \Delta U = F avec conditions de Dirichlet et de Neumann
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*
*     Declarations globales des super-tableaux
*
      CHARACTER     AST
      INTEGER       MOTMXR,NBCHMX
      REAL          RST
      PARAMETER    (MOTMXR=100000000,NBCHMX=1000000)
      COMMON/      /RST(MOTMXR) /STCHAR/AST(NBCHMX)
*
*     Variables locales
      INTEGER    EBID,IMPASS,IMPSYS,IMPSOL,IMPTIM
      REAL       RBID
      COMPLEX    CBID
      CHARACTER  ABID
      CHARACTER  TYPE*1, S2MEMB*11
*
*-----------------------------------------------------------------------
      IMPTIM=6
*     Initialisation de l'allocation dynamique et
*     creation des structures de donnees.
      CALL INITIE (NBCHMX,MOTMXR)
*
*     Lecture du fichier de geometrie (maillage)
      CALL LCGEOM
*
*     Lecture des directives de definition des inconnues variationnelles
*     et de construction des termes elements-finis
      CALL LCDIRE
*
*     Lecture des donnees scalaires
      CALL LCDONN
*
*     Numerotations globales en noeuds
      CALL NUMNEU
*
*     Distribution des coordonnees sur les domaines
      CALL CPTDOM
*
*
*     Constantes pour impression
      CALL GETCST ('Imp_ass',TYPE,IMPASS,RBID,CBID,ABID)
      CALL GETCST ('Imp_sys',TYPE,IMPSYS,RBID,CBID,ABID)
      CALL GETCST ('Imp_sol',TYPE,IMPSOL,RBID,CBID,ABID)
*
*     Calcul des termes elements-finis sur les domaines
      CALL CALKEF
      CALL GETCST ('Calcul_2membre',TYPE,EBID,RBID,CBID,S2MEMB)
*     Second Membre issu de conditions de Neuman calcule par interpolation
      IF (S2MEMB(1:6).EQ.'Interp') THEN
        CALL MATVEC ('Masse',1,'dudn',1,'SecmbN',1,IMPASS)
      ENDIF
      CALL CHRONO (' Calculs Elements Finis',IMPTIM)
*
*     Assemblage du second membre
*     Second membre de -Delta u = f + condition de Neuman bord 1
      CALL ASVTRM ('Secmbr',0,IMPASS)
*
*     Condition de Dirichlet sur le bord 2
      CALL CDESSE ('Dirich',2,'Matris',0,'Secmbr',0)
      CALL CHRONO (' Constitution du Systeme',IMPTIM)
*
*     Resolution par factorisation LLt
*
      CALL FALLT  ('Matris',0,'Matfac',0,IMPSYS)
      CALL FASV   ('Matfac',0,'Secmbr',0,'Soluti',0,IMPSYS)
      CALL CHRONO (' Resolution Systeme',IMPTIM)
*
*     Comparaison avec une solution exacte
*
      CALL DFTERM ('SOLEXA',0,'Soluti',0,IMPSOL)
*
*     Fichiers de resultats pour exploitation graphique
*
      CALL GBEGIN ('Dessin','2D','mesh&bb')
      CALL GHEADR ('Dessin','Solution','1')
      CALL GBODYR ('Dessin','Soluti',0,'Omega')
      CALL GEND ()
      CALL BYE (' That''s all Folks')
      END

