*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CPTDOM
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.deBayser (Janvier 1989) 
* Derniere modification : D.Martin (30 Novembre 1999)
* Version 1.0.0
*  
* Distribution des coordonnees des points sur les 'elements' des domaines 
* de calculs 
* 
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
*
      INCLUDE 'CONTEX' 
      INCLUDE 'ALLOC' 
*
      INTEGER   IMPRIM,IBID,MCTRDO,LGERDO,NBDOMK,LGCANO,NCHDOM,NXDODO
     &         ,NUDOG,NUDOK,IGEOME,INDMIX,NUSCHQ,INDEXC,IDLHRC,INTRPC
     &         ,NBNECX,NBNEEX,NBDLEX,NBNEFX,NBDLFX,NVNUMC,INDEXL,IDLHRL
     &         ,INTRPL,NBNELX,NBNEEY,NBDLEY,NBNEFY,NBDLFY,NVNUML,NVCOOR
     &         ,INUTIL,NBTRDO,NIVDOM,IDOK,IDTRDO,MCNOMD,MCLIST
     &         ,NXLIST,NDMDOM,NDMDOE,NBELDO,NBNEEZ,NBDLEZ,NBNEFZ,NBDLFZ
     &         ,LGPTEX,MCBLOK,MCVARE,MCCORL,MCPTEL,MCDLFA,LGPTEL,I
      CHARACTER ERCODE*120,PRFXAF*8
      COMMON/FORMAH/ERCODE
      LOGICAL   ELEQFA
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Cptdom*')
      IMPRIM=0
*
*     Recherche du tableau des points (d.l. definissant la geometrie)  
      CALL TBRR1  (ERCODE,'#ORPTL',0,IBID)
*  
      CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)                     
      CALL SDEXDB (IST(MCTRDO),LGERDO,NBDOMK,LGCANO,NCHDOM)             !sdexplo
*
*     Adresse relative de la structure de description des termes dans #TERDO
*
      NXDODO=LGERDO
*
*     Boucle sur les domaines de calcul 
* 
      DO 100 IDOK=1,NBDOMK
*
         CALL TBAR1  (ERCODE,'#TERDO',1,MCTRDO)
*  
*        Exploitation du contenu de la structure de donnees #TERDO pour
*        le domaine de calcul NUDOK
*  
*        Adresse absolue des caracteristiques du domaine de calcul dans #TERDO
         IDTRDO=MCTRDO+NXDODO 
         CALL GETDOM (IST(IDTRDO),NUDOG,NUDOK,IGEOME,INDMIX,NUSCHQ
     &               ,INDEXC,IDLHRC,INTRPC,NBNECX,NBNEEX,NBDLEX,NBNEFX
     &               ,NBDLFX,NVNUMC,INDEXL,IDLHRL,INTRPL,NBNELX,NBNEEY
     &               ,NBDLEY,NBNEFY,NBDLFY,NVNUML,NVCOOR,INUTIL,NBTRDO
     &               ,NIVDOM)                                           !sdexplo
         IF (IMPSDR.LE.0) NIVDOM=0
*  
*        Dans la description des domaines de calculs on saute par dessus  
*        les descriptions des termes sur le domaine de calcul 
         NXDODO=NXDODO+LGCANO+NBTRDO  
*  
*        Exploitation de la structure de donnees #ISTEL (1ere partie) 
*        (Renseignements globaux sur les elements constituant le domaine) 
*  
         CALL TBRR1 (ERCODE,'#ISTEL',NUDOG,MCLIST)
         CALL TBAR2 (ERCODE,'#ISTEL',NUDOG,MCLIST,'#OMDOM',1,MCNOMD)
*  
         IF (NIVDOM.GT.1) THEN
            IF (IMPRIM.LE.0) THEN
               IMPRIM=1
               WRITE (IMPSDR,10000) PRFXAF ( )
            ENDIF
            WRITE (IMPSDR,10001) NUDOK,(AST(I)
     &                ,I=MCNOMD+(NUDOG-1)*NCHDOM,MCNOMD+NUDOG*NCHDOM-1)
         ENDIF
*
         CALL EXLIST (IST(MCLIST),NXLIST,NDMDOM,NDMDOE,NBELDO
     &               ,NBNEEZ,NBDLEZ,NBNEFZ,NBDLFZ)                      !sdexplo
*  
*        Creation du tableau des coordonnees des points du domaine par element
*  
         LGPTEX=NBELDO*(NBDLFZ*NDIM+2)
         IF (INDEXC+INDEXL.GE.1) LGPTEX=NBELDO*(NBDLEZ*NDIM+2) 
         CALL TBCREE ('#ORPTL',NUDOK,2,LGPTEX,'c')
         MCBLOK=1
         IF (NBBBLK.GE.2) CALL TBAR1(ERCODE,'#LOKEL',1,MCBLOK)
         CALL TBAR4  (ERCODE,'#ARIAB',1    ,MCVARE
     &                      ,'#ORPTL',0    ,MCCORL 
     &                      ,'#ORPTL',NUDOK,MCPTEL
     &                      ,'#ISTEL',NUDOG,MCLIST)
*
*        Le tableau de travail NUDLFA (cf. CoDoVo et Sacha) est subtilement
*        cache dans les dernieres memoires du tableau #ORPTL !!
*
         MCDLFA=MCPTEL+LGPTEX-NBDLFZ
         LGPTEL=0
*
*        Cas ou les elements sont eux-memes de dimension inferieure a NDIM 
         ELEQFA=NBNEEZ.EQ.NBNEFZ.AND.NBDLEZ.EQ.NBDLFZ
*
         IF (NDMDOM.EQ.NDMDOE.OR.INDEXC+INDEXL.GE.1.OR.ELEQFA) THEN
*
*           Cas d'un domaine de la meme dimension que l'espace
*
            CALL CODOVO (NDIM,NDMDOM,NDMDOE,NBELDO,NBCNVE,AST(MCVARE)
     &                  ,IST(MCBLOK),IST(MCLIST+NXLIST),NBPTEX 
     &                  ,IST(MCCORL),RST(MCCORL),IST(MCPTEL),RST(MCPTEL)
     &                  ,LGPTEL,NIVDOM,IMPSDR)                          !cordom
*
         ELSEIF (NDMDOM.GE.0) THEN
*
*           Cas d'un domaine de bord (face ou arete)
*
            CALL CODOFA (NDIM,NDMDOM,NBELDO,NBCNVE,AST(MCVARE)
     &                  ,IST(MCBLOK),IST(MCLIST+NXLIST),NBPTEX
     &                  ,IST(MCCORL),RST(MCCORL),IST(MCPTEL),RST(MCPTEL)
     &                  ,LGPTEL,IST(MCDLFA),IST(MCDLFA),NIVDOM,IMPSDR)  !cordom
*
         ENDIF
*
         IF (LGPTEL.NE.LGPTEX) CALL TBAJST ('#ORPTL',NUDOK,LGPTEL)
         CALL TBSAVE ('#ORPTL',NUDOK)
         CALL TBSAVE ('#ISTEL',NUDOG)
*
100   CONTINUE 
*
      CALL TBSAVE ('#ORPTL',0)
      IF (IMPSDR.GT.0.AND.IMPRIM.EQ.1) WRITE(IMPSDR,10002) PRFXAF()
      CALL PRFXMJ (-1,'*Cptdom*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,'* ',A8,' ',98('*'))
10001 FORMAT(/T3,'Coordonnees des points sur le domaine de calcul #',I3
     &,', Domaine geometrique ',50A1)
10002 FORMAT(' ',96('*'),'  ',A8,'  *')
                                                                    END !Cptdom
