*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE CALKSP
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : C.Chambeyron (Decembre 2002)
* Derniere modification : D.Martin (16 octobre 2006)
* Version 2
*
* Calcul des coefficients des matrices spectrales :
*  matrices des produits scalaires des fonctions propres de la base spectrale
*  (non necessairement orthogonale).
*
* Dans le cas orthogonal, le terme spectral doit etre entre par l'utilisateur
* comme un vecteur :
*      DO X I=1,NBLIGN
*         S(I) = ... ( coefficient S_{ii}
* X    CONTINUE
*
* Dans le cas non orthogonal la matrice spectrale DOIT etre entree dans une 
* matrice stockee PLEIN-C ('a la fortran') :
*      DO X I=1,NBLIGN    (boucle sur les lignes)
*         DO Y J=1,NBCOLO (boucle sur les colonnes)
*            K=K+1
*            S(K) = ... ( coefficient S_{ij} )
* Y       CONTINUE
* X    CONTINUE
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      LOGICAL   CRETRM
      CHARACTER DONINT*10,STOIND*7,TYPINT*9,YKLINT*6
      CHARACTER NMTERM*6,NOMFCT*16,NODONA*16,TYPRAS*9,TYDONA*9
     &         ,PRFXAS*8,THETRM*16,STOSTK*7,TYTERM*9
      INTEGER   INTTYP,INTYKL
      INTEGER   MCDTRM,LGETRM,NBTERM,INCTRM,NCHTRM,MCMTRM
     &         ,MCDONN,LGEDON,NBDONN,INCDON,NCHDON,MCMDON
     &         ,ADTERM,MCTERM,NUTERM
     &         ,NVTERM,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &         ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &         ,NUINCL,NVDUML,NBLIGN,NVNUML,NBTRSP,MCAUXI
     &         ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP,INTYSP,NCATRM,I
     &         ,ITYDON,NIVDON,ITYPDO,ITYRAS,NIVASS,ITYPRA,MCCSTE,MCASSO
      REAL      POINT(3)
      CHARACTER ERCODE*120
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*CalkSp*')

      INTYSP=INTYKL('SPECTR')
      CRETRM=.FALSE.
*
      CALL TBAR2  (ERCODE,'$SDTRM',1,MCDTRM,'$DONNE',1,MCDONN)
*     Caracteristiques du tableau des termes
      CALL SDEXDB (IST(MCDTRM),LGETRM,NBTERM,INCTRM,NCHTRM)             !utilite
*     Caracteristiques du tableau des donnees
      CALL SDEXDB (IST(MCDONN),LGEDON,NBDONN,INCDON,NCHDON)             !utilite
*
*     ADTERM adresse relative du terme courant dans $SDTRM  
      ADTERM=LGETRM
      NBTRSP=0
*
*                     +++++++++++++++++++++++++++++
*                     ++  BOUCLE SUR LES TERMES  ++
*                     +++++++++++++++++++++++++++++
*
      DO 1000 NUTERM=1,NBTERM
*
         IF (CRETRM) CALL TBAR1  (ERCODE,'$SDTRM',1,MCDTRM)
         CRETRM=.FALSE.

*        Exploitation du contenu de la structure de donnees $SDTRM
*        Recherche des parametres de description du terme courant
*
         CALL GETTRM (IST(MCDTRM+ADTERM),NVTERM
     &               ,ITYPTR,ITYCAL,NUKALE,NUDONN,ITYSYM,NVDSMB
     &               ,NUINCC,NVDUMC,NBCOLO,NVNUMC
     &               ,NUINCL,NVDUML,NBLIGN,NVNUML
     &               ,INDSTK,NVSTOK,NVCORC,IATRDO,NIVIMP)               !sdexplo
*
*        On ne s'occupe ici que des termes spectraux
*
         IF (ITYCAL.EQ.INTYSP) THEN
*
*           Recherche du nom du terme (#OMTRM)
*           MCMTRM = adresse en memoire centrale
            CALL TBAR3  (ERCODE,'#OMTRM',1,MCMTRM,'#OMDON',1,MCMDON
     &                         ,'$DONNE',1,MCDONN)
            CALL GETCHN (AST(MCMTRM),NCHTRM,NUTERM,NMTERM)
*           IF (NBLIGN.NE.NBCOLO) CALL ERTERM (11,NMTERM,NVTERM)        !utilite
            CRETRM=.TRUE.
            TYTERM=TYPINT (ITYPTR)                                      !utilite
            STOSTK=STOIND (INDSTK)                                      !utilite
*
            ITYPDO=INTTYP ('REEL')
            NOMFCT='Pas de fonction!'
            MCASSO=0
            ITYRAS=0
            TYPRAS=' '
            TYDONA=' '
*
            IF (NUDONN.GT.0) THEN
*              Nom et attributs de la fonction associee a la donnee
               CALL GETCHN (AST(MCMDON),NCHDON,NUDONN,NOMFCT)           !utilite
               CALL SDEXCO (NUDONN,IST(MCDONN),ITYDON,NIVDON,ITYPDO)    !utilite
*
*
               IF (NIVDON.GT.0) THEN
*
*                 Caracteristiques de la donnee associee a la fonction
*
                  CALL SDEXCO (NIVDON,IST(MCDONN),ITYRAS,NIVASS,ITYPRA) !utilite
                  CALL GETCHN (AST(MCMDON),NCHDON,NIVDON,NODONA)
                  TYDONA=DONINT(ITYRAS)
                  TYPRAS=TYPINT(ITYPRA)
               ENDIF
            ENDIF
*
*
*           Creation du terme et le cas echeant du tableau auxiliaire
*
            CALL TBCREE (NMTERM,NVTERM,ITYPTR,NBLIGN*NBCOLO,'c')
*
            IF (STOSTK.EQ.'BIMORSE') THEN
*              Creation d'un tableau de travail auxiliaire
               CALL TBCREE ('$Calks',0,ITYPTR,NBLIGN*NBCOLO,'c')
            ENDIF
*
*           Adresse de la donnee associee a la fonction
*
            IF (TYDONA(1:9).EQ.'CONSTANTE') THEN
*              La fonction a une donnee associee CONSTANTE
*              Adresse de la constante associee a la fonction
               IF (TYPRAS(1:2).EQ.'EN') THEN
                  CALL TBAR1 (ERCODE,'$ECSTE',1,MCCSTE)  
               ELSEIF (TYPRAS(1:2).EQ.'RE') THEN
                  CALL TBAR1 (ERCODE,'$RCSTE',1,MCCSTE)  
               ELSEIF (TYPRAS(1:2).EQ.'CO') THEN
                  CALL TBAR1 (ERCODE,'$CCSTE',1,MCCSTE) 
               ENDIF
               MCASSO=MCCSTE+NIVASS
*     
            ELSEIF (TYDONA(1:7).EQ.'TABLEAU') THEN
*              La fonction a une donnee associee TABLEAU
*              Adresse du tableau associe a la fonction
               CALL TBRR1 (ERCODE,NODONA(1:6),NIVASS,MCASSO)
               CALL TBAR1 (ERCODE,NODONA(1:6),NIVASS,MCASSO)
*
            ENDIF
*
*           Remplissage du terme spectral
*
            CALL TBAR1  (ERCODE,NMTERM,NVTERM,MCTERM)
            MCAUXI=MCTERM
            IF (STOSTK.EQ.'BIMORSE') 
     &         CALL TBAR1  (ERCODE,'$Calks',0,MCAUXI)
            DO 10 I=1,NDIM
               POINT(I)=0.
10          CONTINUE
*
*           Procedure 'utilisateur' pour calculer les coefficients spectraux
*
            CALL FCTPRO (NDIM,POINT,NBLIGN,NOMFCT,TYPINT(ITYPDO)        !user's
     &                  ,NODONA,TYPRAS,MCASSO,IST,RST,CST
     &                  ,RST(MCAUXI),CST(MCAUXI))
*
*           Rangement du terme initialement PLEIN-C sous forme BIMORSE
*
            IF (STOSTK.EQ.'BIMORSE') THEN
*              Remarque : Le tableau de stockage &BMORS est cree dans LckSpe
*              Mise a zero (accumulation dans MPL2BM)
               CALL TAZERO (NBLIGN*NBLIGN,TYTERM,MCTERM,AST,IST,RST,CST)!utilite
               CALL MPL2BM (TYTERM,NBLIGN,NBLIGN,'PLEIN-C',MCAUXI
     &                     ,MCTERM,RST,CST)                             !morse
               CALL TBTUER ('$Calks',0)
*
            ELSEIF (STOSTK.EQ.'PLEIN-L') THEN
*
*              Transposition du terme rentre PLEIN-C
*
               CALL BAISE  ('Transformation PLEIN-C a PLEIN-L a voir')  !utilite
               CALL TBTUER ('$Calks',0)
            ENDIF       
*
            IF (TYDONA(1:7).EQ.'TABLEAU')
     &         CALL TBSAVE (NODONA(1:6),NIVASS)
            CALL TBSAVE (NMTERM,NVTERM)
*
            IF (NIVIMP.GT.0) CALL PRTERM (NMTERM,NVTERM,NIVIMP,IMPSDR)  !sdexplo
            IF (NIVIMP.GE.0.AND.IMPPAL.GT.0) THEN
               IF (NBTRSP.EQ.0) WRITE (IMPPAL,10000) PRFXAS (0)
               NBTRSP=NBTRSP+1
               CALL PRNTRM (NMTERM(:NCHTRM),NVTERM,THETRM,NCATRM)       !utilite
               WRITE (IMPPAL,10001) PRFXAS (0),THETRM(1:NCATRM)
     &                             ,YKLINT(ITYCAL),TYTERM,STOSTK
            ENDIF
         ENDIF
*
1000  ADTERM=ADTERM+INCTRM
      CALL PRFXMJ (-1,'*CalkSp*')
*-----------------------------------------------------------------------
10000 FORMAT(/T2,A8,' Calcul des termes spectraux')
10001 FORMAT(T5,A8,' Terme ',A,' de type ',A,', ',A,:,', ',A,:,', ',A)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
*-- File history
* Version 2 : D.Martin (16 octobre 2006)
* - stockage de la matrice spectrale sous forme BIMORSE
* Version 1 : D.Martin (1er Juillet 2003)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !CalkSp
