*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE RMOTOR (IDEB,ISTART,MLEVEL,ITREE,NBTPTG,NELEVL,NTREE
     &                  ,MXDEG,ADVOIS,NEVOIS,NEMARK,NIVIMP,IMPFCH)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs: E.Masson (Juin 1993)  
* Derniere modification : D.Martin (30 juin 2002)
* Version 2.0.0
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
      INTEGER   IDEB,ISTART,MLEVEL,ITREE,NBTPTG,MXDEG,NELEVL(*),NTREE(*)
     &         ,ADVOIS(*),NEVOIS(*),NEMARK(*),NIVIMP,IMPFCH
*
      CHARACTER PRFXAS*8
      INTEGER   NGI,ADRVOI,JTREE,INELOC,NGJ,MDEG,IDEG
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'*Rmotor*')
*     Classer les noeuds de la composante connexe courante par ordre
*     de voisinagepar rapport a IDEB et par degre croissant et 
*     les ranger dans NTREE/ITREE
*     Parmi les noeuds de plus haut niveau celui de plus petit degre
*     est ISTART
*
*     Initialisation
      DO 1 NGI=1,NBTPTG
         NELEVL(NGI)=0
1     CONTINUE
*
*     Nombre de noeuds deja ranges dans NTREE
      ITREE   =1
      NTREE(1)=IDEB
*
*     Curseur des noeuds non exploites
*     si JTREE .le. ITREE NTREE(JTREE) est a exploiter sinon fin
      JTREE=1
*
*     Liste des noeuds deja ranges dans NTREE
      NELEVL(IDEB)=1
*
*     Exploiter les noeuds de NTREE :
*     chercher tous les voisins non marques
2     IF (JTREE.LE.ITREE) THEN
*
*         Depiler
          NGI=NTREE(JTREE)
          JTREE=JTREE+1
*
*         Empiler et marquer tous voisins non marques
          ADRVOI=ADVOIS(NGI)
          DO 3 INELOC=1,NEVOIS(ADRVOI)
             ADRVOI=ADRVOI+1
             NGJ=NEVOIS(ADRVOI)
             IF (NELEVL(NGJ).EQ.0) THEN
                NELEVL(NGJ)=NELEVL(NGI)+1
                MLEVEL=NELEVL(NGJ)
                ITREE=ITREE+1
                NTREE(ITREE)=NGJ
              ENDIF
3        CONTINUE 
         GOTO 2
      ENDIF     
*
*     Parmi les noeuds de plus grande profondeur
*     chercher le plus petit degre
      MDEG=MXDEG
      DO 4 NGI=1,NBTPTG
         IF (NELEVL(NGI).EQ.MLEVEL) THEN
            IDEG=NEVOIS(ADVOIS(NGI))
            IF (IDEG.LT.MDEG) THEN
               MDEG  =IDEG
               ISTART=NGI
            ENDIF
         ENDIF
4     CONTINUE
*
*     Marquer tous les noeuds de la composante connnexe courante
*
      DO 5 NGI=1,NBTPTG
        IF (NELEVL(NGI).NE.0) NEMARK(NGI)=1
5     CONTINUE
      CALL PRFXMJ (-1,'*Rmotor*')
      IF (IMPFCH.LE.0.OR.NIVIMP.LE.9) RETURN
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      WRITE (IMPFCH,10001) PRFXAS(0),NBTPTG
      WRITE (IMPFCH,10002) (NEMARK(NGI),NGI=1,NBTPTG)
10001 FORMAT(/A8,'>*RMotor* Impression de NEMARK : Nombre de DL ',I5)
10002 FORMAT(80I1)
                                                                    END !RMotor
