*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE GEND
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (29.juin.2001)
* Derniere modification : D.Martin (5.mai.2010)
* Version 4
*
* Ecriture des donnees geometriques sous forme d'elements P1 pour traitement
* graphique et selon les formats
*    'unighn' = 'grame' (2D)
*    'mesh&bb' = 'medit' exploite par medit (2D ou 3D)
*    'paraview' exploite par paraview
*
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      IMPLICIT NONE
*
      INCLUDE 'ALLOC'
      INCLUDE 'CONTEX'
*
      INTEGER  UN,LAGDM2,LAGDM3
      PARAMETER ( LAGDM2 = 10, LAGDM3 = 2, UN=1 )
      INTEGER  KLUNIT   
      INTEGER  LNOUTP,LNPRFX,LNSUFX,LNMEXT
     &        ,NUNITG,NUNITR,ADNDOM,AD1DOM,ADNOMD,ADNUMD,ADNEDO
     &        ,LGENDS,NBDESS,LGCHAR,NBCARD,INCNDS,INCNDO,ADRDOM
     &        ,MCINDS,MCNMDS,NBDODS,NBELDS,NBNEDS,NUDOMG,INTERP
     &        ,NDMDOM,NDMDOE,NUDOMD,MCORNO,NDOMCO,NUMDES,NUMREF
     &        ,NVNUMD,MCNUME,NBNE,NUDOMK,NBELDO,NBNEDO,LGGNDO
     &        ,MCGNDO,MCLIST,NXLIST,LGSTEL,MCBLOK,NUTYAV,NUTGEO
     &        ,NUEL,NUTYLE,LAGHER,KCLASS,NBNEEL,NBDLEL,NUF,NUFAAV
     &        ,NUTYFA,NBNEFA,NBDLFA,NDIMCO,NBSOP1,NBLMP1
      INTEGER  I,L,K,NBELP1,NUNEFA (20),MCPOTR,ADPOTR
      REAL     RBID
      COMPLEX  CBID
      CHARACTER LEYTUN*5,MEDITN*10
      CHARACTER OUTPUT*8,OUTPWT*8,PRFX*8,SUFX*8,NOMEXT*72,ERCODE*120
     &         ,MFORMA*11,NWTYPE*2,TYPE*4,ELTDIF*5,NOMINT*20,CHDIM*3
      COMMON/FORMAH/ERCODE
*-----------------------------------------------------------------------
      CALL PRFXMJ (1,'< GEnd >')
      CHDIM =' '
      NWTYPE=' '
      NOMEXT=' '
      ELTDIF =' '
*
*     Le tableau $WORK$',0 est le recepteur du resultat de la decoupe
*     en triangles P1 en 2D, en tetraedres P1 en 3D. Sa longueur est
*     superieur ou egale au nombre de points des elements P1, multipliee
*     par le nombre d'elements issus de la decoupe
*
      IF (NDIM.EQ.2) THEN
*        Pour des triangles   NBPLM1=(2^2)^(k-1)
*        Pour des quadrangles NBPLM1=2*(2^2)^(k-1)
*        Le max est atteint en decoupant un quadrangle Qk en 2k^2 triangles
         NBLMP1=2*LAGDM2**2
         NBSOP1=3
         MEDITN='Triangles'
      ELSEIF (NDIM.EQ.3) THEN
*        Actuellement on decoupe au plus un tetradedre P2 en 8 P1
*        Pour des tetraedres NBPLM1=(2^3)^(k-1)
*        Pour des prismes    NBPLM1=3*(2^3)^(k-1)
*        Pour des hexaedres  NBPLM1=5*(2^3)^(k-1) ou 6*(2^3)^(k-1)
*        MAIS est-il necessaire de decouper les prismes et hexaedres
         NBLMP1=8
         NBSOP1=4
         MEDITN='Tetrahedra'
      ELSE
         CALL M2UGEO ()
         CALL PRFXMJ (-1,'< GEnd >')
         RETURN
      ENDIF
*
      CALL TBCREE ('$WORK$',0,1,NBSOP1*NBLMP1,'c')
      CALL TBAR1  (ERCODE,'$InfDS',UN,MCINDS)
*
      LGENDS=IST(MCINDS)
      NBDESS=IST(MCINDS+1)
      LGCHAR=IST(MCINDS+2)
      NBCARD=IST(MCINDS+3)
      INCNDS=IST(MCINDS+4)
      INCNDO=IST(MCINDS+5)
      ADNDOM=LGENDS
      AD1DOM=LGENDS+INCNDS*NBDESS
      ADNOMD=1
*
      NUNITG=KLUNIT ( )                                                 !sdexplo
*
*     Boucle sur les dessins
*
      DO 100 NUMDES=1,NBDESS
*
         CALL TBAR3  (ERCODE,'$NomDS',UN,MCNMDS,'$InfDS',UN,MCINDS
     &                      ,'$WORK$',0,MCPOTR)
*
*--      Calcul du nombre d'elements et de degres de liberte du dessin
*
         NBDODS =IST(ADNDOM+MCINDS)
         ADNUMD=MCINDS+AD1DOM
         NUDOMG=IST(ADNUMD)
         NXLIST=IST(ADNUMD+2)
         INTERP=IST(ADNUMD+6)
         NDMDOM=IST(ADNUMD+7)
         NDMDOE=NDIM
         ADRDOM=AD1DOM
*
*        Les elements sont-ils tous de meme type?
*
         CALL GELTYP (NBDODS,ADRDOM,INCNDO,ELTDIF,NBNEDS,NBELDS
     &               ,NBELP1,IST(MCPOTR))
*
*--      Determination du nom interne, ouverture du fichier de geometrie
*
         NOMINT=' '
         CALL GETCHN (AST(MCNMDS),LGCHAR,ADNOMD,NOMINT)                 !utilite
         CALL GETCHN (AST(MCNMDS),LGCHAR,ADNOMD+1,CHDIM)                !utilite
         CALL GETCHN (AST(MCNMDS),LGCHAR,ADNOMD+2,OUTPUT)               !utilite     
         OUTPWT=OUTPUT
         IF (OUTPUT(1:8).EQ.'paraview') OUTPWT='mesh&bb'
         ADNOMD=ADNOMD+NBCARD
*
*--      Determination du nom externe
*
         CALL GCHARS (OUTPUT,'g',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
         CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
*
         OPEN (UNIT=NUNITG,FILE=NOMEXT(1:LNMEXT),STATUS='UNKNOWN'
     &        ,ACCESS='SEQUENTIAL',FORM='FORMATTED',ERR=90000)
*
*--      Fichier de geometrie, ecriture de l'entete
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         IF (OUTPWT(1:6).EQ.'unighn') THEN
*
*           Fichier au format 'unighn' = 'grame'
*
            WRITE (NUNITG,*) 'GEO'
            WRITE (NUNITG,*) 'NOM',' '''//NOMEXT(1:LNMEXT)//''' '
            WRITE (NUNITG,*) CHDIM,' P1'
            WRITE (NUNITG,*) 'NBPTS ',NBNEDS,' NBEL ',NBELP1
            WRITE (NUNITG,*) 'POINTS'
*
         ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
*
*           Fichier au format 'mesh' de medit
*
            WRITE (NUNITG,*) 'MeshVersionFormatted 1'
            WRITE (NUNITG,*) 'Dimension ',NDIM
            WRITE (NUNITG,*) 'Vertices ',NBNEDS
         ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*
*--      Ecriture des coordonnees des noeuds pour tous les domaines
*
         CALL TBRR1  (ERCODE,'#ORNOE',INTERP,MCORNO)
*
         NDIMCO=NDIM
         IF (CHDIM(3:3).EQ.'5') THEN
            CALL RELCNE (CHDIM(1:1),NDIMCO)
            NDIMCO=NDIMCO+1
         ENDIF
         ADNEDO=AD1DOM+5
         DO 9 NUDOMD=1,NBDODS
            CALL TBAR1  (ERCODE,'$InfDS',UN,MCINDS)
            NUMREF=IST(ADNEDO-5+MCINDS)
            NVNUMD=IST(ADNEDO-2+MCINDS)
            CALL TBRR1 (ERCODE,'#GNEDO',NVNUMD,MCNUME)
            CALL TBAR3 (ERCODE,'#GNEDO',NVNUMD,MCNUME
     &                        ,'#ORNOE',INTERP,MCORNO
     &                        ,'$InfDS',UN,MCINDS)
*           Boucle sur les noeuds
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
            IF (OUTPWT(1:6).EQ.'unighn') THEN
               DO 2 I=1,IST(ADNEDO+MCINDS)
                  L=MCORNO+NDIM*(IST(MCNUME+1+I)-1)
                  WRITE (NUNITG,10000) (RST(K),K=L,L+NDIM-1)
     &                                ,(0.,K=NDIM,NDIMCO-1)
2              CONTINUE
            ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
*              Numero de reference : NUMREF = NUDOMG
               MFORMA='(3E14.5,I3)'
               IF (NDIMCO.NE.3) CALL ENCLER (NDIMCO,MFORMA(2:2))        !utilite
               DO 3 I=1,IST(ADNEDO+MCINDS)
                  L=MCORNO+NDIM*(IST(MCNUME+1+I)-1)
                  WRITE (NUNITG,MFORMA) (RST(K),K=L,L+NDIM-1),NUMREF
3              CONTINUE
            ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
            ADNEDO=ADNEDO+INCNDO
            CALL TBSAVE ('#GNEDO',NVNUMD)
9        CONTINUE
         CALL TBSAVE ('#ORNOE',INTERP)
*
*--      Ecriture de la numerotation des noeuds pour tous les domaines
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         IF (OUTPWT(1:6).EQ.'unighn') THEN
*
*           Fichier au format 'unighn' = 'grame'
*
            WRITE (NUNITG,*) 'NUMEL'
*
         ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
*
*           Fichier au format 'mesh' de 'medit'
*
            WRITE (NUNITG,*) MEDITN,' ',NBELP1
*
         ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

         NBNE=0
         DO 80 NUDOMD=1,NBDODS
            NUDOMG=IST(AD1DOM  +MCINDS)
            NUMREF=NUDOMG
            NUDOMK=IST(AD1DOM+1+MCINDS)
            NXLIST=IST(AD1DOM+2+MCINDS)
            NBELDO=IST(AD1DOM+4+MCINDS)
            NBNEDO=IST(AD1DOM+5+MCINDS)
            NDMDOM=IST(AD1DOM+7+MCINDS)
            CALL TBRR2  (ERCODE,'#RGNDO',NUDOMK,LGGNDO
     &                         ,'#ISTEL',NUDOMG,LGSTEL)
            CALL TBAR3  (ERCODE,'#RGNDO',NUDOMK,MCGNDO
     &                         ,'#ISTEL',NUDOMG,MCLIST
     &                         ,'$WORK$',0,MCPOTR)
            MCBLOK=MCLIST
            IF (NBBBLK.GE.2) CALL TBAR1(ERCODE,'#LOKEL',1,MCBLOK)
*
*           Type des elements
*
            NUTYAV=0
            NUFAAV=0
            CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MCLIST),IST(MCBLOK)
     &                  ,NUTGEO,INTERP,NUEL,NUTYAV,NUTYLE,LAGHER,KCLASS
     &                  ,NBNEEL,NBDLEL,NUF,NUFAAV,NUTYFA,NBNEFA,NBDLFA
     &                  ,NUNEFA,NUNEFA,0,IMPSDR)                        !sdexplo
            IF (NDMDOM.LT.NDIM) NUTYLE=NUTYFA
*
            IF (ELTDIF.EQ.' ') THEN
*
*              Tous les elements sont du meme type geometrique
*              Decoupage des elements en elements P1
               CALL ELEMP1 (NUTYLE,NBELP1,IST(MCPOTR))
*
*              Boucle sur les elements du domaine
               DO 58 I=1,NBELDO
                  ADPOTR=MCPOTR-1
*
*                 Ecriture de la numerotation globale des noeuds
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                  IF (OUTPWT(1:6).EQ.'unighn') THEN
*
*                    Fichier au format 'unighn' = 'grame'
*
                     DO 50 L=1,NBELP1
                        WRITE (NUNITG,10001) 
     &                  (NBNE+IST(MCGNDO+1+IST(ADPOTR+K)),K=1,NBSOP1)
                       ADPOTR=ADPOTR+NBSOP1
50                   CONTINUE
*
                  ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
*
*                    Fichier au format 'mesh' de 'medit'
*
*                    Numero de reference : NUMREF = NUDOMG  
                     DO 52 L=1,NBELP1
                        WRITE(NUNITG,10001)
     &                  (NBNE+IST(MCGNDO+1+IST(ADPOTR+K)),K=1,NBSOP1)
     &                 ,NUMREF 
                        ADPOTR=ADPOTR+NBSOP1
52                   CONTINUE
                  ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  MCGNDO=MCGNDO+NBNEEL+1
58             CONTINUE
*
            ELSE
*
*              Elements non tous du meme type
*
               NUTYAV=0
               NUFAAV=0
               DO 78 I=1,NBELDO
                  CALL EXSTEL (NDMDOM,NDMDOE,NXLIST,IST(MCLIST)
     &                        ,IST(MCBLOK),NUTGEO,INTERP,NUEL,NUTYAV
     &                        ,NUTYLE,LAGHER,KCLASS
     &                        ,NBNEEL,NBDLEL,NUF,NUFAAV,NUTYFA
     &                        ,NBNEFA,NBDLFA,NUNEFA,NUNEFA,0,IMPSDR)    !sdexplo
                  IF (NDMDOM.LT.NDIM) NUTYLE=NUTYFA
*
*                 Decoupage des elements en elements P1
                  CALL ELEMP1 (NUTYLE,NBELP1,IST(MCPOTR))
*
*                 Ecriture de la numerotation globale des noeuds
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
                  IF (OUTPWT(1:6).EQ.'unighn') THEN
*
                     ADPOTR=MCPOTR-1
                     DO 70 L=1,NBELP1
                        WRITE (NUNITG,10001) 
     &                  (NBNE+IST(MCGNDO+1+IST(ADPOTR+K)),K=1,NBSOP1)
                        ADPOTR=ADPOTR+NBSOP1
70                   CONTINUE
*
                  ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
*
*                    Numero de reference : NUREF = NUDOMG
                     ADPOTR=MCPOTR-1
                     DO 72 L=1,NBELP1
                        WRITE (NUNITG,10001) 
     &                  (NBNE+IST(MCGNDO+1+IST(ADPOTR+K)),K=1,NBSOP1)
     &                 ,NUMREF
                        ADPOTR=ADPOTR+NBSOP1
72                   CONTINUE
                  ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
                  MCGNDO=MCGNDO+NBNEEL+1
78             CONTINUE
               CALL TBSAVE ('#ISTEL',NUDOMG)
            ENDIF
*
            NBNE  =NBNE+NBNEDO
            AD1DOM=AD1DOM+INCNDO
            CALL TBSAVE ('#RGNDO',NUDOMK)
80       CONTINUE
*
*--      Fermeture des fichiers de geometrie et de resultats
*
         CALL GCHARS (OUTPUT,'r',OUTPUT,LNOUTP,PRFX,LNPRFX,SUFX,LNSUFX)
         CALL GFILEN (NOMINT,PRFX,LNPRFX,SUFX,LNSUFX,NOMEXT,LNMEXT)
         INQUIRE (FILE=NOMEXT(1:LNMEXT),NUMBER=NUNITR)
*
*>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
         IF (OUTPWT(1:6).EQ.'unighn') THEN
            WRITE  (NUNITG,*) 'FIN'
            WRITE  (NUNITR,*) 'FIN'
         ELSEIF (OUTPWT(1:7).EQ.'mesh&bb') THEN
            WRITE  (NUNITG,*) 'End'
         ENDIF
*<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
*
*        IF (NBDODS.GT.1) CALL G23DOM (NOMEXT(1:LNMEXT),NBDODS) 
*
         IF (OUTPUT(1:8).EQ.'paraview') THEN
*        Creation du fichier NOMEXT.vtk a partir des fichiers au format mesh&bb
*        NOMEXT_t.mesh et NOMEXT_t.bb
*
            CALL MB2VTK (OUTPUT,NOMINT) 
            CLOSE (UNIT=NUNITR,STATUS='DELETE')
            CLOSE (UNIT=NUNITG,STATUS='DELETE')
         ELSE
            CLOSE (UNIT=NUNITG,STATUS='KEEP')
            CLOSE (UNIT=NUNITR,STATUS='KEEP')
         ENDIF
*
*        Destruction de la structure $DimRS pour le dessin
         CALL TBTUER ('$DimRS',NUMDES)
*        et passage au dessin suivant
         ADNDOM=ADNDOM+INCNDS
100   CONTINUE
*
*     Destruction des structures $InfDS et $NomDs
*
      CALL TBTUER ('$WORK$',0)
      CALL TBTUER ('$InfDS',UN)
      CALL TBTUER ('$NomDS',UN)
*
      CALL PRFXMJ (-1,'< GEnd >')
      RETURN
*-----------------------------------------------------------------------
10000 FORMAT(5E14.5)
10001 FORMAT(10I8)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
90000 CALL BAISE  ('Erreur sur l''ouverture du fichier de geometrie '
     &//NOMEXT(1:LNMEXT))
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Version 5 : D.Martin (5.mai.2010)
* variable OUTPWT initialisee avant OUTPUT(par GETCHN)s ! 
* Version 4 : D.Martin (23.mars.2010)
* rajout du cas de sortie graphique pour Paraview
* Version 3 : D.Martin (4.nov.2008)
* rajout d'un CALL PRFXMJ (-1,'< GEnd >') manquant avant un RETURN (Cas 1d)
* Version 2 : D.Martin (4.juil.2005)
* Version 1.9 : G.Legendre et C.Chambeyron (11.fev.2004)
* Version 0 : D.Martin (29.juin.2001)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                                                                    END !GEnd
