*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXLIST (LISTEL,NXLIST,NDMDOM,NDMDOE,NBELDO
     &                  ,NBNEEX,NBDLEX,NBNEFX,NBDLFX)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteurs : D.Martin & O.de Bayser (Juillet 1988)
* Derniere modification : D.Martin (29 Novembre 1999)
*  
* Exploitation de la structure de donnees #ISTEL pour un domaine geometrique
*  
*-- Arguments --
* LISTEL tableau #ISTEL a son adresse initiale ( 'IST(MCLIST)' )
* NXLIST adresse dans LISTEL du numero du premier constituant -1
* NDMDOM dimension (des constituants) du domaine
* NDMDOE dimension des elements supports des constituants du domaine
* NBELDO nombre de constituants du domaine
* NBNEEX nombre maximum de noeuds par element
* NBDLEX nombre maximum de d.l. par element
*        (cas Hermite, = NBNEEX sinon)
* NBNEFX nombre maximum de noeuds par face/arete d'element si NDMDOM < NDMDOE
* NBDLFX nombre maximum de d.l. par face/arete d'element si NDMDOM < NDMDOE
*        (cas Hermite, = NBNEFX sinon)
*
*-- Definition de LISTEL
* LISTEL(1) longueur du tableau LISTEL
* LISTEL(2) = NDMDOM dimension (des constituants) du domaine, par exemple
*             0 pour des points
*             1 pour des elements 1d, des aretes d'elements 2d ou 3d
*             2 pour des elements 2d, des faces d'elements 3d
*             3 pour des elements 3d
* LISTEL(3) = NDMDOE dimension des elements supports des constituants du domaine
*             1 pour des elements 1d, des points d'elements 1d
*             2 pour des elements 2d, des aretes/points d'elements 2d
*             3 pour des elements 3d, des faces/aretes/points d'elements 3d
* LISTEL(4) = NBELDO nombre d'elements supports des constituants du domaine
* LISTEL(5) = NBNEEX nombre maximum de noeuds par element
* LISTEL(6) = NBDLEX nombre maximum de d.l. par element (Hermite)
* si NDMDOM = NDMDOE > 0 :
*  LISTEL(7  a  6 + NBELDO) liste des numeros des elements
* si NDMDOM < NDMDOE et NDMDOM > 0 :
*  LISTEL(7) = NBNEFX nombre maximum de noeuds par face/arete d'element
*  LISTEL(8) = NBDLFX nombre maximum de d.l. par face/arete d'element (Hermite)
*  LISTEL(9 a 8+2*NBELDO) couples de (no d'element,no de face/arete )
* si NDMDOM=0 :
*  LISTEL(7) = NBCPDO nombre de couples (no d'element,no de point)
*  LISTEL(8) inutilise
*  LISTEL(9 a 8+2*NBCPDO) liste des couples (no d'element,no de point)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER LISTEL(*),NXLIST,NDMDOM,NDMDOE,NBELDO
     &       ,NBNEEX,NBDLEX,NBNEFX,NBDLFX
*-----------------------------------------------------------------------
      NDMDOM=LISTEL(2)
      NDMDOE=LISTEL(3)
      NBELDO=LISTEL(4)
      NBNEEX=LISTEL(5)
      NBDLEX=LISTEL(6)
      NXLIST=6
      NBNEFX=NBNEEX
      NBDLFX=NBDLEX
      IF (NDMDOM.LT.NDMDOE) THEN
         NXLIST=8
         IF (NDMDOM.GT.0) THEN
            NBNEFX=LISTEL(7)
            NBDLFX=LISTEL(8)
         ELSE
            NBELDO=LISTEL(7)
         ENDIF
      ENDIF
                                                                    END !Exlist
