*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXMORS (MCINIT,MORSE
     &                  ,NBLIGN,NBCOLO,NBPLAG,MCPLAG,MCPLIG,LGMORS)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : O.DeBayser (Fevrier 1992)
* Derniere modification : O.DeBayser (10 Fevrier 1992)
*  
* Exploitation d'une structure &PLAGE : Cette procedure fournit
* les nombre de lignes, de plages , la longueur du tableau compactee
* les adresses relatives ou absolues des pointeurs de compactage morse
*  
*-- Argument d'entree --  
* MCINIT adresse de la structure &PLAGE (absolue si on cherche
*          des adresses absolues , egale a 1 pour des adresses relatives.
* MORSE  structure &PLAGE a son adresse initiale.
*
*-- Arguments de sortie --
* NBLIGN nombre de lignes
* NBCOLO nombre de colonnes
* NBPLAG nombre de plages 
* MCPLAG adresse absolue ou relative du tab. des numeros de derniere plage
*         de chaque ligne.
* MCPLIG idem pour les tableaux des numeros de debut de plage et adresses 
*         des coeff. de fin de plage
* LGMORS nombre de coefficients
*
*-- Structure &PLAGE -- 
*  
* Adresse  -> Contenu 
*  
* 1        -> NBLIGN nombre de lignes 
* 2        -> NBCOLO nombre de colonnes
* 3        -> NBPLAG nombre de plages
* 4        -> LGMORS nombre de coefficients
* 5        -> MCPLAG adrs. du tab. des numeros de dernieres plages
* 3+NBLIGN -> NBPLAG nombre de plages
* 4+NBLIGN -> MCPLIG adrs. du tab. des numeros de debut de plage et des
*                    adresses des coeff. de fin des plages
* 4+NBLIGN+2*NBPLAL-1 -> LGMORS longueur du tableau compacte =
*                               adresse du dernier coeff. de la derniere plage
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MCINIT,MORSE(*),NBLIGN,NBCOLO,NBPLAG,MCPLAG,MCPLIG,LGMORS
*-----------------------------------------------------------------------
      NBLIGN=MORSE(1) 
      NBCOLO=MORSE(2) 
*     NBPLAG=MORSE(3) 
*     LGMORS=MORSE(4) 
      NBPLAG=MORSE(4+NBLIGN)
      MCPLAG=4+MCINIT
      MCPLIG=MCPLAG+NBLIGN
      LGMORS=MORSE(4+NBLIGN+2*NBPLAG)
                                                                    END !Exmors
