*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXNEDO (NGNEDO,HERMIT,NBNEDO,NBDLDO,ADNEDO,ADDLDO)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Mars 1989)
* Derniere modification : D.Martin (6 Juillet 1999)
*
* Exploitation du tableau #GNEDO
*
*-- Argument d'entree --
* NGNEDO tableau de numerotation sur un domaine
*-- Arguments de sortie --
* HERMIT indice de presence d'interpolation de Hermite
* NBNEDO nombre de noeuds du domaine pour l'interpolation
* NBDLDO nombre de d.l.         -
* ADNEDO adresse relative dans NGNEDO de la numerotation des noeuds
* ADDLDO adresse relative dans NGNEDO des numeros de 1er d.l. de chaque noeud
*
*-- Structure NGNEDO -- 
*  
* Adresse:   -> Interpretation :
*  
*   1        -> HERMIT         (indicateur d'interpolation d'Hermite)
*   2        -> NBNEDO         (nombre de noeuds)
*   3=ADNEDO -> NGNECO(1)      (numero du 1er noeud)
*   ........    ...... 
*   NBNEDO+2 -> NGNECO(NBNEDO) (numero du dernier)
*  
*               Puis en cas d'interpolation d'Hermite :
*   NBNEDO+3 -> NBDLDO         (nombre de d.l. de l'interpolation) 
*   NBNEDO+4 -> NUCONE(1)      (numero du 1er d.l. du 1er noeud)
*   ........    ...... 
* 2*NBNEDO+3 -> NUCONE(NBNEDO) (numero du 1er d.l. du dernier noeud)  
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER NGNEDO(*),HERMIT,NBNEDO,NBDLDO,ADNEDO,ADDLDO
*
      INTEGER NEXTAD
*-----------------------------------------------------------------------
      HERMIT=NGNEDO(1) 
      ADNEDO=3 
      NBNEDO=NGNEDO(ADNEDO-1)  
      NEXTAD=ADNEDO+NBNEDO 
      NBDLDO=NBNEDO
      IF (NGNEDO(1).NE.0) THEN  
         NBDLDO=NGNEDO(NEXTAD) 
         ADDLDO=NEXTAD+1
      ENDIF
                                                                    END !Exnedo
