*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      SUBROUTINE EXPROF (MCINIT,PROFIL
     &                  ,NBLIGN,MCLENV,LGPROL,NBCOLO,MCUENV,LGPROU)
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
* Auteur : D.Martin (Octobre 1989)
* Derniere modification : D.Martin (14 Octobre 1991)
* Version # 1.0.0
*  
* Exploitation d'une structure &PROFL : Cette procedure fournit
* les nombre de lignes, la longueur de la partie triangulaire profil
* inferieur et l'adresse relative ou absolue des pointeurs profil ligne
* et les memes parametres pour la partie triangulaire profil superieur
* partie triangulaire Morse par colonne superieure
*  
*-- Argument d'entree --  
* MCINIT: adresse de la structure &PROFL (absolue si on cherche
*          des adresses absolues , egale a 1 pour des adresses relatives.
* PROFIL: structure &PROFL a son adresse initiale.
*-- Arguments de sortie --
* NBLIGN: nombre de lignes
* MCLENV: adresse absolue ou relative du tab. des pointeurs de la partie 
*         triangulaire inferieure
* LGPROL: nombre de coefficients de la partie triangulaire inferieure
* NBCOLO,MCUENV,LGPROU: idem pour la part. triang. superieure
*
*-- Structure &PROFL -- 
*  
* Adresse  -> Contenu
*  
* 1        -> Adresse de NBCOLO (nombre de colonne) dans PROFIL
* 2        -> NBLIGN nombre de lignes 
* 3        -> MCLENV adrs. du tab. des pointeurs du profil inferieur
*                      pour les lignes 2 a NBLIGN
* 2+NBLIGN -> LGPROL longueur de la partie triangulaire inferieure +1
*                    = adresse du dernier coeff. du profil inf. +1
* Puis en cas de structure non symetrique (PROFIL(1) > 2)
* 3+NBLIGN -> NBCOLO nombre de colonnes
* 4+NBLIGN -> MCUENV adrs. du tab. des pointeurs du profil superieur
*                    pour les colones 2 a NBCOLO
* 3+NBLIGN+NBCOLO -> LGPROU longueur de la partie triangulaire superieure +1
*                           = adresse du dernier coeff. du profil sup. +1
*+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      INTEGER MCINIT,PROFIL(*),NBLIGN,MCLENV,LGPROL,NBCOLO,MCUENV,LGPROU
*
      INTEGER IANEXT
*-----------------------------------------------------------------------
      NBLIGN=PROFIL(2) 
      MCLENV=MCINIT+2  
      IANEXT=NBLIGN+1
      LGPROL=PROFIL(IANEXT+1)-1
      IF(PROFIL(1).EQ.2) IANEXT=0
      NBCOLO=PROFIL(IANEXT+2) 
      MCUENV=IANEXT+MCINIT+2  
      IANEXT=IANEXT+NBCOLO+1
      LGPROU=PROFIL(IANEXT+1)-1
                                                                    END !ExProf
